/* functional C style */

/* trace flag */
extern int graph_trace;

/* exported routines from graphops.c */

extern Graph insert1_graph
             FL3( Graph, g, Node, n, Node, n1 );
       /* insert arc from n to n1 into g      */


extern Labeled_graph insert1_labeled_graph
             FL4( Labeled_graph, lg, Node, n, Node, n1, Currency, c); 
       /* insert arc from n to n1 with cost c */
       /* into the labeled graph lg           */

extern Labeled_graph insert_labeled_graph
             FL3( Labeled_graph, lg, Node, n, Nodes, succ );
       /* insert all successors of node n     */
       /* into the labeled graph lg           */
             
extern Goal generate_labeled_graph
             FL2( Labeled_graph, lg, Nodes, succ );
       /* extend the graph lg at nodes        */
       /* contained in the set succ           */

extern Goal solve_labeled_graph
             FL1( Labeled_graph, initlg );
       /* this function calls generate with   */
       /* the initial labeled graph           */       

extern Currency min_currency
             FL2(Currency, x1, Currency, x2);
       /* minimum function for Currency       */
       
extern Cost min_cost FL2( Cost, x1, Cost, x2 );
       /* compute the minimum cost            */
       
extern Bool is_better_cost FL2( Cost, x1, Cost, x2 );
       /* compare costs                       */

extern Node select_best_node
             FL3( Nodes, succ, Labels, cm, Node, n0);
       /* select the best node from succ      */
       /* cm contains the costs of the nodes  */
                                       
       
/* problem specific routines                  */
 
extern Currency cost1_node
             FL2( Node, n, Node, n1 );
       /* compute the cost form n to n1       */

extern Bool is_solution_node FL1( Node, n );
       /* is n an element of the final states */
       
extern Nodes generate_succ_nodes
             FL1( Node, n );
       /* the problem specific production     */
       /* system                              */

extern Currency heuristic
             FL1( Node, n );
       /* heuristic function to guess the     */
       /* quality of node n                   */
