#include <stdio.h>
 
/* routines for manipulating directed graphs */

#include "func.mcr"
#include "Graph.h"
#include "Graph-ops.h"
#include "Graph-gen.h"
                        
Succ sel1_node_succ PL2(Node,x1,Succ,x2)
{  
   return mk_one_succ(x1);
}                           

Succ sel1_node_costs PL2(Node,x1,Costs,x2)
{ 
   return mk_one_succ(x1);
}   

Succ new_nodes PL2(Gw,gw1,Attr,at1)
{  Succ s1,s2;

   LET s1 = dom_attr(at1) IN
   LET s2 = dom_graph(s_gr(gw1)) IN 
   return diff_succ(s1,s2);
}
                                                        
Gw gen_all_gw PL2(Gw,gw,Succ,nset)
{  
   Node n;
   Attr a;
   Succ ns1,ns2,ns3; 
                        
   printf("gen_all_gw: gw = \n");pr_gw(gw);pr_succ(nset);
   if (is_empty_succ(nset))
      return gw ;
   LET n = sel_succ(nset)    IN  pr_node(n);
   LET a = generate_attr(n)  IN  pr_attr(a); 
   LET ns1 = new_nodes(gw,a) IN 
   LET ns2 = union_succ(nset,ns1) IN 
   LET ns3 = sub1_succ(ns2,n)     IN 
   IN  
      return gen_all_gw(insert_costs_gw(gw,n,a),ns3);
}                                              

Graph insert1_graph PL3(Graph,g,Node,n,Node,n1)
{ 
   Graph g0,g1;
   Succ  nf;  

   LET g0 = IF is_in_graph(n,g)
            THEN g
            ELSE union1_graph(g,n,mk_empty_succ()) IN
   LET g1 = IF is_in_graph(n1,g0) 
            THEN g0
            ELSE union1_graph(g0,n1,mk_empty_succ()) IN
   LET nf = sel_graph(g1,n)                         IN
       return ovwrt1_graph(g1,n,union1_succ(nf,n1));
}             
 
Graph insert_graph PL3(Graph,g,Node,n,Succ,nset)
{  
   Succ s1;

   return
      IF is_in_dom_graph(n,g,&s1)
      THEN ovwrt1_graph(g,n,union_succ(s1,nset))
      ELSE union1_graph(g,n,nset); 
}

Gw insert1_costs_gw PL4(Gw,gw,Node,n,Node,n1,Costs,c)
{  Graph g,g1;
   Attr w,w1;
   Costs c1,c2;

   LET g  = s_gr(gw)                                IN
   LET w  = s_co(gw)                                IN 
   LET g1 = insert1_graph(g,n,n1)                   IN
   LET c1 = sel_attr(w,n) + c                       IN
   LET w1 = IF ! is_in_dom_attr(n1,w,&c2)
            THEN union1_attr(w,n1,c1)
            ELSE ovwrt1_attr(w,n1,min_costs(c2,c1)) IN 
   return mk_gw(g1,w1);
}                 

Gw insert_costs_gw PL3(Gw,gw,Node,n,Attr,succ)
{  Gw gw1;
   Node n1; 
       
   if (is_empty_attr(succ))
      return gw;                      
          
   LET n1  = sel_dom_attr(succ)                          IN       
   LET gw1 = insert1_costs_gw(gw,n,n1,sel_attr(succ,n1)) IN
      return
        insert_costs_gw(gw1,n,sub1_attr(succ,n1));

}
