
/* Map test program */
/* Map1 = Nat0 -m-> Nat0 */
/* Map2 = Map1 -m-> Map1 */
/* Map3 = Map3 -m-> Map3 */

#include <stdio.h>
#include "proto.h"
#include "Map.h"

static Bool is_odd PL1( Nat0, x1 )
 {return (x1 & 1);}   

static Bool is_two PL1( Nat0, x1 )
 {return (x1 == 2);}   

Map1 mki_map1 PL1( Nat0, x1 )
   {Map1 lx1 = mk_empty_map1();
    while (x1) {lx1 = union1_map1(lx1,x1,x1);x1--;}
    return lx1;
   } 

void map1_test PL0()
   {Map1  t1 = mk_empty_map1();
    Map1  t2 = mk_one_map1(1,2);
    Map1  t0 = union1_map1(mk_one_map1(2,4),3,6);
    Map1  t3 = union1_map1(mk_one_map1(1,2),2,4);
    Map1  t5 = mk_one_map1(1,0);
    Map1  t4;
    Nat0  i1 = 0;

    printf("\n  []                   == ");pr_map1(t1);
    printf("\n  [1:->2]              == ");pr_map1(t2);
    printf("\n  [2:->4,3:->6]        == ");pr_map1(t0);
    printf("\n  [1:->2,2:->4         == ");pr_map1(t3);

    printf("\n  card([])                       == %d",card_map1(t1));
    printf("\n  card([1:->2])                  == %d",card_map1(t2));
    printf("\n  card([1:->2,2:->4])            == %d",card_map1(t3));
    printf("\n  card([2:->3,3:->6])            == %d",card_map1(t0));

    printf("\n  is_empty([])         == ");pr_bool(is_empty_map1(t1));
    printf("\n  is_empty([1:->2])    == ");pr_bool(is_empty_map1(t2));

    printf("\n  is_eq([1:->2],[1:->2])               == ");pr_bool(is_eq_map1(t2,t2));
    printf("\n  is_eq([1:->2],[1:->0])               == ");pr_bool(is_eq_map1(t2,t5));
    printf("\n  is_eq([1:->2,2:->4],[1:->2])         == ");pr_bool(is_eq_map1(t3,t2));
    printf("\n  is_eq([1:->2],[1:->2,2:->4])         == ");pr_bool(is_eq_map1(t2,t3));
    printf("\n  is_eq([1:->2,2:->4],[1:->2,2:->4])   == ");pr_bool(is_eq_map1(t3,t3));
    printf("\n  is_eq([],[1:->2])                    == ");pr_bool(is_eq_map1(t1,t2));

    printf("\n  is_in(1,[1:->2])         == ");pr_bool(is_in_map1(1,t2));
    printf("\n  is_in(0,[1:->2])         == ");pr_bool(is_in_map1(0,t2));
    printf("\n  is_in(2,[1:->2,2:->4])   == ");pr_bool(is_in_map1(2,t3));
    printf("\n  is_in(3,[1:->2,2:->4])   == ");pr_bool(is_in_map1(3,t3));
    printf("\n  is_in(0,[])              == ");pr_bool(is_in_map1(0,t1));

    printf("\n  is_in_dom(0,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_dom_map1(0,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_dom(1,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_dom_map1(1,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_dom(2,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_dom_map1(2,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_dom(3,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_dom_map1(3,t3,&i1));printf(" %d",i1);

    printf("\n  is_in_rng(0,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_rng_map1(0,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_rng(1,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_rng_map1(1,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_rng(2,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_rng_map1(2,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_rng(4,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_rng_map1(4,t3,&i1));printf(" %d",i1);

    printf("\n  is_in_min(0,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_min_map1(0,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_min(1,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_min_map1(1,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_min(2,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_min_map1(2,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_min(3,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_min_map1(3,t3,&i1));printf(" %d",i1);

    printf("\n  is_in_max(0,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_max_map1(0,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_max(1,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_max_map1(1,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_max(2,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_max_map1(2,t3,&i1));printf(" %d",i1);
    printf("\n  is_in_max(3,[1:->2,2:->4],&i1)   == ");pr_bool(is_in_max_map1(3,t3,&i1));printf(" %d",i1);

    printf("\n  is_submap([],[1:->2])          == ");pr_bool(is_submap_map1(t1,t2));
    printf("\n  is_submap([1:->2],[1:->2])     == ");pr_bool(is_submap_map1(t2,t2));
    printf("\n  is_submap([1:->2],[1:->0])     == ");pr_bool(is_submap_map1(t2,t5));
    printf("\n  is_submap([1:->2],[])          == ");pr_bool(is_submap_map1(t2,t1));
    printf("\n  is_submap([2:->4],[1:->2])     == ");pr_bool(is_submap_map1(t0,t2));

    t4 = copy_map1(t2);
    printf("\n  copy([1:->2])                  == ");pr_map1(t4);
    printf("\n  sel([1:->2],1)                 == %d",sel_map1(t4,1));

    t4 = union1_map1(t4,0,0);
    printf("\n  union1([1:->2],0,0)                     == ");pr_map1(t4);

    t4 = union1_map1(t4,0,0);
    printf("\n  union1([1:->2],0,0)                     == ");pr_map1(t4);

    t4 = union_map1(t4,copy1_map1(t3));
    printf("\n  union1([0:->0,1:->2],[1:->2,2:->4])     == ");pr_map1(t4);

    t4 = sub1_map1(t4,1);
    printf("\n  sub1([0:->0,1:->2,2:->4],1)             == ");pr_map1(t4);

    t4 = sub1_map1(t4,3);
    printf("\n  sub1([0:->0,1:->2,2:->4],3)             == ");pr_map1(t4);

    t4 = inters_map1(t4,mk_one_map1(0,0));
    printf("\n  inters([0:->0,1:->2,2:->4],[0:->0])  == ");pr_map1(t4);

    t4 = inters_map1(t4,mk_empty_map1());
    printf("\n  inters([0:->0],[])                   == ");pr_map1(t4);

    printf("\n  hash([1:->2,2:->4])                == %d",hash_map1(t3));

    del1_map1(t4);

    del1_map1(t0);
    del1_map1(t1);
    del1_map1(t2);
    del1_map1(t3);
    del1_map1(t5);
   }

Map2 mk_triangle PL1( Nat0, x1 )
   {Map2 lx1 = mk_empty_map2();
    while (x1) {lx1 = union1_map2(lx1,mki_map1(x1),mk_one_map1(x1,x1*x1));x1--;}
    return lx1;
   }

void map2_test PL0()
 {Map2 tt1 = mk_triangle(1);
  Map2 tt2 = mk_triangle(2);
  Map2 tt3 = mk_triangle(3);
  Map2 tt4 = mk_triangle(4);
  Map2 tt0 = mk_triangle(0);
  Map1  t3;
  printf("\n  mk_triangle(0) == ");pr_map2(tt0);
  printf("\n  mk_triangle(1) == ");pr_map2(tt1);
  printf("\n  mk_triangle(2) == ");pr_map2(tt2);
  printf("\n  mk_triangle(3) == ");pr_map2(tt3);
  printf("\n  mk_triangle(4) == ");pr_map2(tt4);

  printf("\n  is_empty(mk_triangle(0))  == ");pr_bool(is_empty_map2(tt0));
  printf("\n  is_empty(mk_triangle(1))  == ");pr_bool(is_empty_map2(tt1));

  printf("\n  is_eq(mk_triangle(4),mk_triangle(4)) == ");pr_bool(is_eq_map2(tt4,tt4)); 
  printf("\n  is_eq(mk_triangle(4),mk_triangle(3)) == ");pr_bool(is_eq_map2(tt4,tt3)); 
  printf("\n  is_submap(mk_triangle(3),mk_triangle(4)) == ");pr_bool(is_submap_map2(tt3,tt4)); 
  printf("\n  is_submap(mk_triangle(4),mk_triangle(4)) == ");pr_bool(is_submap_map2(tt4,tt4)); 
  printf("\n  is_submap(mk_triangle(4),mk_triangle(3)) == ");pr_bool(is_submap_map2(tt4,tt3)); 

  del_map2(tt3);
  
  del_map2(tt0);
  del_map2(tt1);
  del_map2(tt2);
  del_map2(tt4);
 }

Map3 mk_list_map3 PL1( Nat0, x1 )
   {if (x1) return mk_one_map3(mk_list_map3(x1-1),mk_list_map3(x1-1));
    return mk_empty_map3();
   } 

Map3 mk_tri_map3 PL1( Nat0, x1 )
   {Map3 lx1 = mk_empty_map3();   
    while (x1) {lx1 = union1_map3(lx1,mk_list_map3(x1),mk_list_map3(x1-1));x1--;}
    return lx1;
   } 

void map3_test PL0()
 {Map3 s0 = mk_list_map3(0);
  Map3 s1 = mk_list_map3(1);
  Map3 s2 = mk_list_map3(2);
  Map3 s3 = mk_list_map3(3);
  Map3 s4 = mk_list_map3(4);
 
  printf("\n  mk_list(0)        == ");pr_map3(s0);
  printf("\n  mk_list(1)        == ");pr_map3(s1);
  printf("\n  mk_list(2)        == ");pr_map3(s2);
  printf("\n  mk_list(3)        == ");pr_map3(s3);
  printf("\n  mk_list(4)        == ");pr_map3(s4);

  {Map3 s123 = union1_map3(union1_map3(mk_list_map3(1)
                                      ,mk_list_map3(2)
                                      ,mk_list_map3(3))
                          ,mk_list_map3(4)
                          ,mk_list_map3(5));
   printf("\n  [[],[[]:->[]],[...] ]       == ");pr_map3(s123);
   del_map3(s123);
  }

  del_map3(s0);
  del_map3(s1);
  del_map3(s2);
  del_map3(s3);
  del_map3(s4);
 }

main()
   {
    printf("\nMap test");
    map1_test();
    map2_test();
    map3_test();
    printf("\n\n");
    fflush(stdout);
    profile_map1();
    profile_map2();
    profile_map3();
    return 0;
   }
