/* Map test program */
/* Map1 = Token -m-> Nat0 */

#include "Map.h"

#ifndef MACROS
Nat0 mk_zero_nat0() {return 0;}
Nat0 add_nat0(x1,x2) Nat0 x1,x2; {return x1+x2;}
Nat0 projr_token_nat0(x1,x2) Token x1; Nat0 x2; {return x2;}
#endif

void map1_test()
   {Map1  m1 = mk_empty_map1();
    Token t2 = ext_map1(&m1,2);
    Token t3 = ext_map1(&m1,9);

    fprintf(stdout,"  is_empty(m1)    == ");pr_bool(is_empty_map1(m1));
    fprintf(stdout,"  t2              == ");pr_token(t2);
    fprintf(stdout,"  t3              == ");pr_token(t3);
    fprintf(stdout,"  sel_map1(m1,t2) == ");pr_nat0(sel_map1(m1,t2));
    fprintf(stdout,"  sel_map1(m1,t3) == ");pr_nat0(sel_map1(m1,t3));    

    m1 = union1_map1(m1,t2,2);
    m1 = ovwrt1_map1(m1,t2,4);
    m1 = ovwrt1d_map1(m1,t2,5);

    fprintf(stdout,"  sel_map1(m1,t2) == ");pr_nat0(sel_map1(m1,t2));
    fprintf(stdout,"  sel_map1(m1,t3) == ");pr_nat0(sel_map1(m1,t3));    
    fprintf(stdout,"  m1              == ");pr_map1(m1);

#ifdef heapmap
    fprintf(stdout,"  is_empty(m1)    == ");pr_bool(is_empty_map1(m1));
    fprintf(stdout,"  card(m1)        == ");pr_nat0(card_map1(m1));
    fprintf(stdout,"  sum(m1)         == ");pr_nat0(sum_map1(m1));
#endif

    m1 = sub1_map1(m1,t2);
    fprintf(stdout,"  m1              == ");pr_map1(m1);
    m1 = sub1d_map1(m1,t3);
    fprintf(stdout,"  m1              == ");pr_map1(m1);

#ifdef heapmap
    fprintf(stdout,"  is_empty(m1)    == ");pr_bool(is_empty_map1(m1));
    fprintf(stdout,"  card(m1)        == ");pr_nat0(card_map1(m1));
#endif

    del1_map1(m1);
   }

main()
   {
    fprintf(stdout,"\nMap test program for a map domain of type");
    fprintf(stdout,"\n  Map  =  TOKEN -m-> Nat0");
    fprintf(stdout,"\nwith TOKEN implemented as a pointer\n");

    map1_test();
    fflush(stdout);

    /* output of profiling data */
    profile_token();
    fprintf(stderr,"\n");
    fflush(stderr);

    return 0;
   }
