/* Option test program */
/*  Union1      == s_u1 : Nat0 | s_u2 : Nat1    */
/*  Opti2       =  [ Union1 ] */

#include <stdio.h>
#include "Opti.h"

void Opti1_test()
   {Opti2  t1 = mk_opt_opti2(mk_u1(0));
    Opti2  t2 = mk_opt_opti2(mk_u2(1));
    Opti2  t0 = mk_nil_opti2();
    Opti2  t3;

    printf("  t1 = mk_u1(0)      == ");pr_opti2(t1);
    printf("  t2 = mk_u2(5)      == ");pr_opti2(t2);
    printf("  t0 = NIL           == ");pr_opti2(t0);

    printf("  s_union1(t1)       == ");pr_union1(s_union1_opti2(t1));
    printf("  s_union1(t2)       == ");pr_union1(s_union1_opti2(t2));

    printf("  is_nil(t1)         == ");pr_bool(is_nil_opti2(t1));
    printf("  is_nil(t2)         == ");pr_bool(is_nil_opti2(t2));
    printf("  is_nil(t0)         == ");pr_bool(is_nil_opti2(t0));

    printf("  is_union1(t1)      == ");pr_bool(is_union1_opti2(t1));
    printf("  is_union1(t2)      == ");pr_bool(is_union1_opti2(t2));
    printf("  is_union1(t0)      == ");pr_bool(is_union1_opti2(t0));

    printf("  is_eq(t1,t1)       == ");pr_bool(is_eq_opti2(t1,t1));
    printf("  is_eq(t1,t2)       == ");pr_bool(is_eq_opti2(t1,t2));
    printf("  is_ge(t1,t1)       == ");pr_bool(is_ge_opti2(t1,t1));
    printf("  is_ge(t1,t0)       == ");pr_bool(is_ge_opti2(t1,t0));
    printf("  is_ge(t0,t1)       == ");pr_bool(is_ge_opti2(t0,t1));
    printf("  is_ge(t1,t2)       == ");pr_bool(is_ge_opti2(t1,t2));
    printf("  is_ge(t2,t1)       == ");pr_bool(is_ge_opti2(t2,t1));
    printf("  is_gr(t1,t1)       == ");pr_bool(is_gr_opti2(t1,t1));
    printf("  is_gr(t1,t0)       == ");pr_bool(is_gr_opti2(t1,t0));
    printf("  is_gr(t0,t1)       == ");pr_bool(is_gr_opti2(t0,t1));
    printf("  is_gr(t1,t2)       == ");pr_bool(is_gr_opti2(t1,t2));
    printf("  is_gr(t2,t1)       == ");pr_bool(is_gr_opti2(t2,t1));

    printf("  hash(t1)           == ");pr_nat0(hash_opti2(t1));
    printf("  hash(t2)           == ");pr_nat0(hash_opti2(t2));
    printf("  hash(t0)           == ");pr_nat0(hash_opti2(t0));

    {Union1 u1;
    printf("  is_opt(t1,&u1)     == ");pr_bool(is_opt_opti2(t1,&u1));
    printf("                        ");pr_union1(u1);
    printf("  is_opt(t2,&u1)     == ");pr_bool(is_opt_opti2(t2,&u1));
    printf("                        ");pr_union1(u1);
    printf("  is_opt(t0,&u1)     == ");pr_bool(is_opt_opti2(t0,&u1));
    }

    del_opti2(copy_opti2(t1));

    del_opti2(t0);
    del_opti2(t1);
    del_opti2(t2);
   }


void alloc_test(x1)
   Nat0 x1;
  {if (x1)
   {Opti2 x2 = mk_opt_opti2(mk_u2(4));
    alloc_test(x1-1);
    del_opti2(x2);
  }}

main()
   {
    printf("\nTest program for optional and union domains");
    printf("\n  Opti2  =  [ Union1 ]");
    printf("\n  Union1 =  s_u1 : Nat0  |  s_u2 : Nat1\n");

    Opti1_test();
    alloc_test(50);
    printf("\n");
    fflush(stdout);

    /* output of profiling data */
    profile_union1();
    
    return 0;
   }
