/* Set test program */
/* Set1 = Nat0 -set */
/* Set2 = Set1 -set */

#include <stdio.h>
#include "proto.h"
#include "Set.h"

static Bool is_odd PL1(Nat0,x1)
 {return (x1 & 1);}   

static Bool is_two PL1(Nat0,x1)
 {return (x1 == 2);}   

Set1 mki_set1 PL1(Nat0,x1)
   {Set1 lx1 = mk_empty_set1();
    while (x1) lx1 = union1_set1(lx1,x1--);
    return lx1;
   } 

void set1_test PL0()
   {Set1  t1 = mk_empty_set1();
    Set1  t2 = mk_one_set1(1);
    Set1  t0 = union1_set1(mk_one_set1(2),3);
    Set1  t3 = union1_set1(mk_one_set1(1),2);
    Set1  t4;

    printf("\n  {}                   == ");pr_set1(t1);
    printf("\n  {1}                  == ");pr_set1(t2);
    printf("\n  {2,3}                == ");pr_set1(t0);
    printf("\n  {1,2}                == ");pr_set1(t3);

    printf("\n  is_empty({})         == ");pr_bool(is_empty_set1(t1));
    printf("\n  is_empty({1})        == ");pr_bool(is_empty_set1(t2));

    printf("\n  is_eq({1},{1})       == ");pr_bool(is_eq_set1(t2,t2));
    printf("\n  is_eq({1,2},{1})     == ");pr_bool(is_eq_set1(t3,t2));
    printf("\n  is_eq({1},{1,2})     == ");pr_bool(is_eq_set1(t2,t3));
    printf("\n  is_eq({1,2},{1,2})   == ");pr_bool(is_eq_set1(t3,t3));
    printf("\n  is_eq({},{1})        == ");pr_bool(is_eq_set1(t1,t2));

    printf("\n  is_in(1,{1})         == ");pr_bool(is_in_set1(1,t2));
    printf("\n  is_in(0,{1})         == ");pr_bool(is_in_set1(0,t2));
    printf("\n  is_in(2,{1,2})       == ");pr_bool(is_in_set1(2,t3));
    printf("\n  is_in(3,{1,2})       == ");pr_bool(is_in_set1(3,t3));
    printf("\n  is_in(0,{})          == ");pr_bool(is_in_set1(0,t1));

    printf("\n  is_subset({},{1})    == ");pr_bool(is_subset_set1(t1,t2));
    printf("\n  is_subset({1},{1})   == ");pr_bool(is_subset_set1(t2,t2));
    printf("\n  is_subset({1},{})    == ");pr_bool(is_subset_set1(t2,t1));
    printf("\n  is_subset({2},{1})   == ");pr_bool(is_subset_set1(t0,t2));

    printf("\n  card({})             == %d",card_set1(t1));
    printf("\n  card({1})            == %d",card_set1(t2));
    printf("\n  card({1,2})          == %d",card_set1(t3));
    printf("\n  card({2,3})          == %d",card_set1(t0));

    t4 = copy_set1(t2);
    printf("\n  copy({1})            == ");pr_set1(t4);
    printf("\n  sel({1}))            == %d",sel_set1(t4));

    t4 = union1_set1(t4,0);
    printf("\n  union1({1},0)        == ");pr_set1(t4);

    t4 = union1_set1(t4,0);       
    printf("\n  union1({0,1},0)      == ");pr_set1(t4);

    t4 = union_set1(t4,copy1_set1(t3));
    printf("\n  union1({0,1},{1,2})  == ");pr_set1(t4);

    t4 = sub1_set1(t4,1);
    printf("\n  sub1({0,1,2},1)      == ");pr_set1(t4);

    t4 = sub1_set1(t4,3);
    printf("\n  sub1({0,2},3)        == ");pr_set1(t4);

    t4 = diff_set1(t4,t3);
    printf("\n  diff({0,2},{1,2})    == ");pr_set1(t4);

    t4 = inters_set1(t4,mk_one_set1(0));
    printf("\n  inters({0},{0})   == ");pr_set1(t4);

    t4 = inters_set1(t4,mk_empty_set1());
    printf("\n  inters({0},{})    == ");pr_set1(t4);

    printf("\n  hash({1,2})     == %d",hash_set1(t3));

    del1_set1(t4);

    del1_set1(t0);
    del1_set1(t1);
    del1_set1(t2);
    del1_set1(t3);
   }

Set2 mk_triangle PL1(Nat0,x1)
   {Set2 lx1 = mk_empty_set2();
    while (x1) lx1 = union1_set2(lx1,mki_set1(x1--));
    return lx1;
   }

void set2_test PL0()
 {Set2 tt1 = mk_triangle(1);
  Set2 tt2 = mk_triangle(2);
  Set2 tt3 = mk_triangle(3);
  Set2 tt4 = mk_triangle(4);
  Set2 tt0 = mk_triangle(0);
  Set1  t3;
  printf("\n  mk_triangle(0) == ");pr_set2(tt0);
  printf("\n  mk_triangle(1) == ");pr_set2(tt1);
  printf("\n  mk_triangle(2) == ");pr_set2(tt2);
  printf("\n  mk_triangle(3) == ");pr_set2(tt3);
  printf("\n  mk_triangle(4) == ");pr_set2(tt4);

  printf("\n  is_empty(mk_triangle(0))  == ");pr_bool(is_empty_set2(tt0));
  printf("\n  is_empty(mk_triangle(1))  == ");pr_bool(is_empty_set2(tt1));

  printf("\n  is_eq(mk_triangle(4),mk_triangle(4)) == ");pr_bool(is_eq_set2(tt4,tt4)); 
  printf("\n  is_eq(mk_triangle(4),mk_triangle(3)) == ");pr_bool(is_eq_set2(tt4,tt3)); 
  printf("\n  is_subset(mk_triangle(3),mk_triangle(4)) == ");pr_bool(is_subset_set2(tt3,tt4)); 
  printf("\n  is_subset(mk_triangle(4),mk_triangle(4)) == ");pr_bool(is_subset_set2(tt4,tt4)); 
  printf("\n  is_subset(mk_triangle(4),mk_triangle(3)) == ");pr_bool(is_subset_set2(tt4,tt3)); 

  t3 = distr_union_set2(tt3);
  printf("\n  distr_union(mk_triangle(3)) == ");pr_set1(t3);
  del_set1(t3);
  del1_set2(tt3);
  
  del_set2(tt0);
  del_set2(tt1);
  del_set2(tt2);
  del_set2(tt4);
 }

Set3 mk_list_set3 PL1(Nat0,x1)
   {if (x1) return mk_one_set3(mk_list_set3(x1-1));
    return mk_empty_set3();
   } 

Set3 mk_tri_set3 PL1(Nat0,x1)
   {Set3 lx1 = mk_empty_set3();   
    while (x1) lx1 = union1_set3(lx1,mk_list_set3(x1--));
    return lx1;
   } 

Set3 distr_union_test PL1(Set3,x1)
   {while (! is_empty_set3(x1))
     {printf("\n  distr_union(");pr_set3(x1);printf(") = ");
      {Set3 x2 =  distr_union_set3(x1);
       pr_set3(x2);
       del1_set3(x1);x1=x2;
     }} 
    return x1;
   }  

void set3_test PL0()
 {Set3 s0 = mk_list_set3(0);
  Set3 s1 = mk_list_set3(1);
  Set3 s2 = mk_list_set3(2);
  Set3 s3 = mk_list_set3(3);
  Set3 s4 = mk_list_set3(4);
 
  printf("\n  mk_list(0)        == ");pr_set3(s0);
  printf("\n  mk_list(1)        == ");pr_set3(s1);
  printf("\n  mk_list(2)        == ");pr_set3(s2);
  printf("\n  mk_list(3)        == ");pr_set3(s3);
  printf("\n  mk_list(4)        == ");pr_set3(s4);

  {Set3 s123 = union1_set3(union1_set3(mk_list_set3(1),mk_list_set3(1)),mk_list_set3(4));
   printf("\n  {{},{{}},{{{{{}}}}}       == ");pr_set3(s123);
   del_set3(s123);
  }

  del_set3(distr_union_test(mk_tri_set3(7)));

  del_set3(s0);
  del_set3(s1);
  del_set3(s2);
  del_set3(s3);
  del_set3(s4);
 }

main()
   {
    printf("\nSet test");
    set1_test();
    set2_test();
    set3_test();
    printf("\n\n");
    fflush(stdout);
    profile_set1();
    profile_set2();
    profile_set3();
    return 0;
   }
