
/* einfacher make Prototyp */
/* FILESYSTEM Klasse       */

#include <sys/types.h>
#include <sys/stat.h>

#include "make.hpp"

BOOL minus_n = TRUE;

void FILESYSTEM::shell(const KOMMANDO & c) {
   char * cmd = new char[c.len() + 1];
     c.cpc(cmd);
     cerr << "        " << cmd << endl;
     if ( ! minus_n )
        system(cmd);
   delete cmd;
}

BOOL FILESYSTEM::is_in(const FILENAME & f) const {
//             cerr << "is_in: " << f;
   char * fn = new char[f.len() + 1];
   f.cpc(fn);
   struct stat sbuf;
   int status = stat(fn,&sbuf);
//             cerr << fn << ":" << status << endl;
   delete fn;
   return BOOL(status==0);
}

ZEITMARKE FILESYSTEM::operator[](const FILENAME & f) const {
//             cerr << "sel: " << f;
   char * fn = new char[f.len() + 1];
   f.cpc(fn);
   struct stat sbuf;
   stat(fn,&sbuf);
   delete fn;
   return ZEITMARKE(sbuf.st_mtime);
}

void FILESYSTEM::make(const ZIEL   & z,
                      const REGELN & rm) {
//              cerr << "make: " << z << rm;
  if ( ! is_in(z) && ! rm.is_in(z) ) {
        cerr << "don't know how to make " << z;
  }
  if ( rm.is_in(z) ) {
    QUELLEN qm = rm[z].abhaengig();
//           cerr << "quellen " << qm;
      makeall(qm,rm);
      if ( ! uptodate(z,qm) )
         shell(rm[z].aktion());
  }
}

void FILESYSTEM::makeall(const QUELLEN & qm,
                         const REGELN  & rm) {
//           cerr << "makeall: " << qm << rm;
  QUELLEN qs = qm.copy1();
  while ( ! qs.is_empty() ) {
    FILENAME quelle = qs.sel();
      make(quelle,rm);
      qs = qs - quelle;
  }
  qs.del1();
}

BOOL FILESYSTEM::uptodate(const ZIEL & z, const QUELLEN & qm) const {
//            cerr << "uptodate: " << z << qm;
  QUELLEN qs           = qm.copy1();
  BOOL    ist_uptodate = is_in(z);
    if ( ist_uptodate ) {
      ZEITMARKE zm = (*this)[z];
        while (ist_uptodate && ! qs.is_empty()) {
          FILENAME  quelle = qs.sel();
            ist_uptodate = is_in(quelle);
            if ( ist_uptodate ) {
              ZEITMARKE qm     = (*this)[quelle];
//                    cerr << "quelle " << quelle;
//                    cerr << "zeit   " << qm;
                ist_uptodate = zm > qm;
            }
            qs = qs - quelle;
        }
    }
    qs.del1();
//            cerr << ist_uptodate;
    return ist_uptodate;
}
