
/* einfacher make Prototyp */
/* FILESYSTEM Klasse       */

#include <sys/types.h>
#include <sys/stat.h>

#include "make.hpp"

BOOL minus_n = TRUE;	// -n is default, sonst etwas gefhrlich
BOOL minus_t = FALSE;

FILESYSTEM & FILESYSTEM::shell(const KOMMANDO & c) {
		// Konversion in OS Schnittstelle
    char * cmd = new char[c.len().data + 1];
    c.cpc(cmd);
    cerr << "        " << cmd << endl;
    if ( ! minus_n )
        system(cmd);
    delete cmd;
    return *this;
}

BOOL FILESYSTEM::is_in(const FILENAME & f) const {
    if ( minus_t )
        cerr << "is_in: f = " << f;
    char * fn = new char[f.len().data + 1];
    f.cpc(fn);
    struct stat sbuf;
    int status = stat(fn,&sbuf);
    if ( minus_t )
        cerr << "is_in: fn=  " << fn << " status = " << status << endl;
    delete fn;
    return BOOL(status==0);
}

ZEITMARKE FILESYSTEM::operator[](const FILENAME & f) const {
    if ( minus_t )
        cerr << "sel  : f = " << f;
    char * fn = new char[f.len().data + 1];
    f.cpc(fn);
    struct stat sbuf;
    stat(fn,&sbuf);
    delete fn;
    return ZEITMARKE(sbuf.st_mtime);
}

BOOL FILESYSTEM::make(const ZIEL   & z,
                      const REGELN & rm) {
    if ( minus_t )
        cerr << "make: z = " << z
             << "     rm = " << rm;

    BOOL something_todo = FALSE;

    if ( ! is_in(z) && ! rm.is_in(z) ) {
        cerr << "don't know how to make " << z;
    }
    if ( rm.is_in(z) ) {
        QUELLEN qm = rm[z].abhaengig();
        if ( minus_t )
            cerr << "quellen = " << qm;
        BOOL something_done = makeall(qm,rm);
        if ( ! uptodate(z,qm)
           || ( minus_n && something_done )
           ) {
            something_todo = TRUE;
            shell(rm[z].aktion());
        }
    }
    return something_todo;
}

BOOL FILESYSTEM::makeall(const QUELLEN & qm,
                         const REGELN  & rm) {
    if ( minus_t )
        cerr << "makeall: qm = " << qm << rm;

    BOOL something_todo = FALSE;
    ITER_QUELLEN qs(qm);
    while ( ! qs ) {
        FILENAME quelle = qs.sel();
        something_todo |= make(quelle,rm);
        qs++;
    }
    return something_todo;
}

BOOL FILESYSTEM::uptodate(const ZIEL & z, const QUELLEN & qm) const {
    if ( minus_t )
        cerr << "uptodate: z = " << z
             << "         qm = " << qm;
    ITER_QUELLEN qs(qm);
    BOOL    ist_uptodate = is_in(z);
    if ( ist_uptodate ) {
        ZEITMARKE zm = (*this)[z];
        while ( ist_uptodate && ! qs ) {
            FILENAME  quelle = qs.sel();
            ist_uptodate = is_in(quelle);
            if ( ist_uptodate ) {
                ZEITMARKE qm     = (*this)[quelle];
                if ( minus_t )
                    cerr << "quelle " << quelle
                         << "zeit   " << qm;
                ist_uptodate = zm > qm;
            }
            qs++;
        }
    }
    if ( minus_t )
        cerr << "ist uptodate = " << ist_uptodate;
    return ist_uptodate;
}
