/* Tree test program */
/*  Tree1      :: s_t1 : Nat0 s_t2 : Nat1    */
/*  Tree2      :: s_t21 : Nat0 s_t22 : Nat1 s_t23 : Tree1 */

#include <stdio.h>
#include "Tree.h"

void tree1_test()
   {Tree1  t0,t1,t2,t3;
    t1 = mk_tree1(0,1);
    t2 = mk_tree1(5,5);
    t0 = mk_tree1(0,2);

    printf("  t1 = mk_tree1(0,1)        == ");pr_tree1(t1);
    printf("  t2 = mk_tree1(5,5)        == ");pr_tree1(t2);
    printf("  t0 = mk_tree1(0,2)        == ");pr_tree1(t0);

    printf("  s_t1(t1)                  == ");pr_nat0(s_t1(t1));
    printf("  s_t2(t1)                  == ");pr_nat1(s_t2(t1));
    printf("  s_t1(t2)                  == ");pr_nat0(s_t1(t2));
    printf("  s_t2(t2)                  == ");pr_nat1(s_t2(t2));

    printf("  is_eq(t1,t1)               == ");pr_bool(is_eq_tree1(t1,t1));
    printf("  is_eq(t1,t2)               == ");pr_bool(is_eq_tree1(t1,t2));
    printf("  is_ge(t1,t1)               == ");pr_bool(is_ge_tree1(t1,t1));
    printf("  is_ge(t1,t0)               == ");pr_bool(is_ge_tree1(t1,t0));
    printf("  is_ge(t0,t1)               == ");pr_bool(is_ge_tree1(t0,t1));
    printf("  is_ge(t1,t2)               == ");pr_bool(is_ge_tree1(t1,t2));
    printf("  is_ge(t2,t1)               == ");pr_bool(is_ge_tree1(t2,t1));
    printf("  is_gr(t1,t1)               == ");pr_bool(is_gr_tree1(t1,t1));
    printf("  is_gr(t1,t0)               == ");pr_bool(is_gr_tree1(t1,t0));
    printf("  is_gr(t0,t1)               == ");pr_bool(is_gr_tree1(t0,t1));
    printf("  is_gr(t1,t2)               == ");pr_bool(is_gr_tree1(t1,t2));
    printf("  is_gr(t2,t1)               == ");pr_bool(is_gr_tree1(t2,t1));

    t1 = chg_t1(t1,2);
    printf("  t1 = chg_t1(t1,2)         == ");pr_tree1(t1);
    t1 = chg_t2(t1,2);
    printf("  t1 = chg_t2(t1,2)         == ");pr_tree1(t1);

    t3 = subst_t1(t1,5);
    printf("  subst_t1(t1,5)            == ");pr_tree1(t3);
    del1_tree1(t3);
    t3 = subst_t2(t1,8);
    printf("  subst_t2(t1,8)            == ");pr_tree1(t3);
    del1_tree1(t3);

    del1_tree1(t0);
    del1_tree1(t1);
    del1_tree1(t2);
   }

void tree2_test()
   {Tree2  t1 = mk_tree2(0,1,mk_tree1(2,3));
    Tree2  t2 = mk_tree2(5,5,mk_tree1(5,5));
    Tree2  t0 = mk_tree2(0,1,mk_tree1(2,4));
    Tree2  t3;

    printf("  t1 = mk_tree2(0,1,mk_tree1(2,3))        == ");pr_tree2(t1);
    printf("  t2 = mk_tree2(5,5,mk_tree1(5,5))        == ");pr_tree2(t2);
    printf("  t0 = mk_tree2(0,1,mk_tree1(2,4))        == ");pr_tree2(t0);

    printf("  s_t21(t1)                  == ");pr_nat0(s_t21(t1));
    printf("  s_t22(t1)                  == ");pr_nat1(s_t22(t1));
    printf("  s_t23(t1)                  == ");pr_tree1(s_t23(t1));

    printf("  s_t21(t2)                  == ");pr_nat0(s_t21(t2));
    printf("  s_t22(t2)                  == ");pr_nat1(s_t22(t2));
    printf("  s_t23(t2)                  == ");pr_tree1(s_t23(t2));

    printf("  is_eq(t1,t1)               == ");pr_bool(is_eq_tree2(t1,t1));
    printf("  is_eq(t1,t2)               == ");pr_bool(is_eq_tree2(t1,t2));
    printf("  is_ge(t1,t1)               == ");pr_bool(is_ge_tree2(t1,t1));
    printf("  is_ge(t1,t0)               == ");pr_bool(is_ge_tree2(t1,t0));
    printf("  is_ge(t0,t1)               == ");pr_bool(is_ge_tree2(t0,t1));
    printf("  is_ge(t1,t2)               == ");pr_bool(is_ge_tree2(t1,t2));
    printf("  is_ge(t2,t1)               == ");pr_bool(is_ge_tree2(t2,t1));
    printf("  is_gr(t1,t1)               == ");pr_bool(is_gr_tree2(t1,t1));
    printf("  is_gr(t1,t0)               == ");pr_bool(is_gr_tree2(t1,t0));
    printf("  is_gr(t0,t1)               == ");pr_bool(is_gr_tree2(t0,t1));
    printf("  is_gr(t1,t2)               == ");pr_bool(is_gr_tree2(t1,t2));
    printf("  is_gr(t2,t1)               == ");pr_bool(is_gr_tree2(t2,t1));

    t1 = chg_t21(t1,2);
    printf("  t1 = chg_t21(t1,2)            == ");pr_tree2(t1);
    t1 = chg_t22(t1,2);
    printf("  t1 = chg_t22(t1,2)            == ");pr_tree2(t1);
    t1 = chg_t23(t1,mk_tree1(0,1));
    printf("  t1 = chg_t22(t1,mk_tree1(0,1) == ");pr_tree2(t1);

    t3 = subst_t21(t1,5);
    printf("  subst_t1(t1,5)             == ");pr_tree2(t3);
    del1_tree2(t3);
    t3 = subst_t21(t1,2);
    printf("  subst_t2(t1,8)             == ");pr_tree2(t3);
    del1_tree2(t3);
    t3 = subst_t23(t1,mk_tree1(0,1));
    printf("  subst_t23(t1,mk_tree1(0,1) == ");pr_tree2(t1);
    del1_tree2(t3);

    del1_tree2(t0);
    del1_tree2(t1);
    del1_tree2(t2);
    {Nat0 i = 50;
     while (i--) del_tree2(mk_tree2(1,2,mk_tree1(3,4)));
    }
   }

main()
   {
    printf("\nTree domain test");
    tree1_test();
    tree2_test();
    printf("\n");
    fflush(stdout);

    profile_tree2();
    return 0;
   }
