/* tupl test program */
/* Tupl = Nat0 *     */
/* Tupl2 = Tupl *    */

#include "Tupl.h"

static Tupl t3,t4;

static Bool is_odd(x1)
   Nat0 x1;
 {return (x1 & 1);}   

static Bool is_two(x1)
      Nat0 x1;
 {return (x1 == 2);}   

static void loc_reverse(y1)
      Nat0 y1;
  {t4 = appl_tupl(y1,t4);}

Tupl reverse(x1)
      Tupl x1;
  {t4 = mk_empty_tupl();
   forall_tupl(x1,loc_reverse);
   return t4;
  } 

static void loc_filter(y1)
      Nat0 y1;
   {t4 = appr_tupl(t4,y1);}

Tupl filter(x1,x2)
      Tupl x1;
      Bool (*x2)();
 {t4 = mk_empty_tupl();  
  forsome_tupl(x1,x2,loc_filter);
  return t4;
 }

str_test()
   {Str  s1 = mkc_str("Emil");
    Str  s2 = mkc_str("Egon");
    Str  s3 = conc_str(conc_str(copy_str(s1),mkc_str(" & ")),copy_str(s2));
    char cs1[20];
    printf("\n  \"Emil\" = ");pr_str(s1);
    cpc_str(s3,cs1);
    printf("\n  \"%s\" = ",cs1);pr_str(s3);
    del_str(s1);
    del_str(s2);
    del_str(s3);
   }

tupl_test()
   {Tupl t1 = mk_empty_tupl();
   {Tupl t2 = mk_one_tupl(1);
   {Tupl t0 = mk_one_tupl(2);

    printf("\n  <> == ");pr_tupl(t1);
    printf("\n  <1>== ");pr_tupl(t2);
    printf("\n  <2>== ");pr_tupl(t0);

    printf("\n  is_empty(<>)     == ");pr_bool(is_empty_tupl(t1));
    printf("\n  is_empty(<1>)    == ");pr_bool(is_empty_tupl(t2));

    printf("\n  is_eq(<1>,<1>)   == ");pr_bool(is_eq_tupl(t2,t2));
    printf("\n  is_eq(<>,<1>)    == ");pr_bool(is_eq_tupl(t1,t2));

    printf("\n  is_ge(<>,<1>)    == ");pr_bool(is_ge_tupl(t1,t2));
    printf("\n  is_ge(<1>,<1>)   == ");pr_bool(is_ge_tupl(t2,t2));
    printf("\n  is_ge(<1>,<>)    == ");pr_bool(is_ge_tupl(t2,t1));
    printf("\n  is_ge(<2>,<1>)   == ");pr_bool(is_ge_tupl(t0,t2));

    printf("\n  is_gr(<>,<1>)    == ");pr_bool(is_gr_tupl(t1,t2));
    printf("\n  is_gr(<1>,<1>)   == ");pr_bool(is_gr_tupl(t2,t2));
    printf("\n  is_gr(<1>,<>)    == ");pr_bool(is_gr_tupl(t2,t1));
    printf("\n  is_gr(<2>,<1>)   == ");pr_bool(is_gr_tupl(t0,t2));

    printf("\n  len(<>)          == %d",len_tupl(t1));
    printf("\n  len(<1>)         == %d",len_tupl(t2));

    t3 = copy_tupl(t2);
    printf("\n  copy(<1>)        == ");pr_tupl(t3);
    del_tupl(t3);
    printf("\n  del(copy(<1>))");
    del1_tupl(t2);
    printf("\n  del1(<1>)           ");

    t2 = mk_one_tupl(1);
    t3 = copy_tupl(t2);


    printf("\n  hd(<1>))         == %d",hd_tupl(t3));
    t3 = tl_tupl(t3);
    printf("\n  tl(<1>))         == ");pr_tupl(t3);
    printf("\n  sel(<1>,1)       == %d",sel_tupl(t2,1));

    t1 = appl_tupl(0,t1);
    printf("\n  appl(0,<>)       == ");pr_tupl(t1);

    t1 = appr_tupl(t1,2);       
    printf("\n  appr(<0>,2)      == ");pr_tupl(t1);

    t1 = conc_tupl(t1,copy_tupl(t1));
    printf("\n  conc(<0,2>,<0,2>)       == ");pr_tupl(t1);

    t1 = conc_tupl(t1,mk_empty_tupl());
    printf("\n  conc(<0,2,0,2>,<>)      == ");pr_tupl(t1);

    t1 = conc_tupl(mk_empty_tupl(),t1);
    printf("\n  conc(<>,<0,2,0,2>)      == ");pr_tupl(t1);

    t1 = rmv1_tupl(t1,4);
    printf("\n  rmv1(<0,2,0,2>,4)       == ");pr_tupl(t1);

    printf("\n  hash(<0,2,0>)      == %d",hash_tupl(t1));
    t1 = ovwrt1_tupl(t1,3,4);
    printf("\n  ovwrt1(<0,2,0>,3,4)     == ");pr_tupl(t1);

    printf("\n  index(<0,2,4>,2)        == %d",index_tupl(t1,2));
    printf("\n  index(<0,2,4>,1)        == %d",index_tupl(t1,1));
    printf("\n  search(<0,2,4>,is_odd)  == %d",search_tupl(t1,is_odd));
    printf("\n  search(<0,2,4>,is_two)  == %d",search_tupl(t1,is_two));

    t4 = reverse(t1);
    printf("\n  reverse(<0,2,4>)        == ");pr_tupl(t4);
    del1_tupl(t4);

    printf("\n  filter(x1,x2) = <x1(i) | 1 <= i <= len x1 & x2(x1(i))>");
    t4 = filter(t1,is_two);
    printf("\n  filter(<0,2,4>,is_two)     == ");pr_tupl(t4);
    del1_tupl(t4);

    t4 = filter(t1,is_odd);
    printf("\n  filter(<0,2,4>,is_odd)     == ");pr_tupl(t4);

    del1_tupl(t4);
    printf("\n  del1(t4)");

    del1_tupl(t0);
    printf("\n  del1(t0)");
    del1_tupl(t1);
    printf("\n  del1(t1)");
    del1_tupl(t2);
    printf("\n  del1(t2)");
    del1_tupl(t3);
    printf("\n  del1(t3)");
   }}}

Tupl mki_tupl(x1)
   Nat0 x1;
   {Tupl lx1 = mk_empty_tupl();
    while (x1) lx1 = appl_tupl(x1--,lx1);
    return lx1;
   } 

Tupl2 mk_triangle(x1)
   Nat0 x1;
   {Tupl2 lx1 = mk_empty_tupl2();
    while (x1) lx1 = appr_tupl2(lx1,mki_tupl(x1--));
    return lx1;
   }

tupl2_test()
 {Tupl2 tt1 = mk_triangle(1);
  Tupl2 tt2 = mk_triangle(2);
  Tupl2 tt3 = mk_triangle(3);
  Tupl2 tt4 = mk_triangle(4);
  Tupl2 tt0 = mk_triangle(0);
  Tupl  t3;
  printf("\n  mk_triangle(0) == ");pr_tupl2(tt0);
  printf("\n  mk_triangle(1) == ");pr_tupl2(tt1);
  printf("\n  mk_triangle(2) == ");pr_tupl2(tt2);
  printf("\n  mk_triangle(3) == ");pr_tupl2(tt3);
  printf("\n  mk_triangle(4) == ");pr_tupl2(tt4);

  printf("\n  is_empty(mk_triangle(0))  == ");pr_bool(is_empty_tupl2(tt0));
  printf("\n  is_empty(mk_triangle(1))  == ");pr_bool(is_empty_tupl2(tt1));

  printf("\n  is_eq(mk_triangle(4),mk_triangle(4)) == ");pr_bool(is_eq_tupl2(tt4,tt4)); 
  printf("\n  is_eq(mk_triangle(4),mk_triangle(3)) == ");pr_bool(is_eq_tupl2(tt4,tt3)); 
  printf("\n  is_ge(mk_triangle(3),mk_triangle(4)) == ");pr_bool(is_ge_tupl2(tt3,tt4)); 
  printf("\n  is_ge(mk_triangle(4),mk_triangle(4)) == ");pr_bool(is_ge_tupl2(tt4,tt4)); 
  printf("\n  is_ge(mk_triangle(4),mk_triangle(3)) == ");pr_bool(is_ge_tupl2(tt4,tt3)); 
  printf("\n  is_gr(mk_triangle(3),mk_triangle(4)) == ");pr_bool(is_gr_tupl2(tt3,tt4)); 
  printf("\n  is_gr(mk_triangle(4),mk_triangle(4)) == ");pr_bool(is_gr_tupl2(tt4,tt4)); 
  printf("\n  is_gr(mk_triangle(4),mk_triangle(3)) == ");pr_bool(is_gr_tupl2(tt4,tt3)); 

  t3 = concatenate_tupl2(tt3);
  printf("\n  concatenate(mk_triangle(3)) == ");pr_tupl(t3);
  del_tupl(t3);
  del1_tupl2(tt3);
  
  del_tupl2(tt0);
  del_tupl2(tt1);
  del_tupl2(tt2);
  del_tupl2(tt4);
 }

main()
   {
    printf("\nTupl test\n");
    tupl_test();
    printf("\n");
    printf("\nStr test\n");
    str_test();
    printf("\n");
    printf("\nTupl2 test\n");
    tupl2_test();
    printf("\n");
    fflush(stdout);

    profile_str();
    profile_tupl();
    profile_tupl2();
    return 0;

   }
