/* Union test program */
/*  Union1      :: s_u1 : Nat0 s_u2 : Nat1    */
/*  Union2      :: s_u21 : Nat0 s_u22 : Nat1 s_u23 : Union1 */

#include <stdio.h>
#include "Unio.h"

Nat0 e_nat0(x1,x2) Nat0 x1; Nat1 x2;{return x1 + x2;}
Nat0 e_nat1(x1,x2) Nat1 x1; Nat1 x2;{return x1 * x2;}

void Union1_test()
   {Union1  t1,t2,t0,t3;
    t1 = mk_u1(0);
    t2 = mk_u2(5);
    t0 = mk_u2(2);

    printf("t1 = mk_u1(0)        == ");pr_union1(t1);
    printf("t2 = mk_u2(5)        == ");pr_union1(t2);
    printf("t0 = mk_u2(2)        == ");pr_union1(t0);

    printf("s_u1(t1)                  == ");pr_nat0(s_u1(t1));
    printf("s_u2(t2)                  == ");pr_nat0(s_u2(t2));

    printf("is_eq(t1,t1)               == ");pr_bool(is_eq_union1(t1,t1));
    printf("is_eq(t1,t2)               == ");pr_bool(is_eq_union1(t1,t2));
    printf("is_ge(t1,t1)               == ");pr_bool(is_ge_union1(t1,t1));
    printf("is_ge(t1,t0)               == ");pr_bool(is_ge_union1(t1,t0));
    printf("is_ge(t0,t1)               == ");pr_bool(is_ge_union1(t0,t1));
    printf("is_ge(t1,t2)               == ");pr_bool(is_ge_union1(t1,t2));
    printf("is_ge(t2,t1)               == ");pr_bool(is_ge_union1(t2,t1));
    printf("is_gr(t1,t1)               == ");pr_bool(is_gr_union1(t1,t1));
    printf("is_gr(t1,t0)               == ");pr_bool(is_gr_union1(t1,t0));
    printf("is_gr(t0,t1)               == ");pr_bool(is_gr_union1(t0,t1));
    printf("is_gr(t1,t2)               == ");pr_bool(is_gr_union1(t1,t2));
    printf("is_gr(t2,t1)               == ");pr_bool(is_gr_union1(t2,t1));

    printf("e_union1(t1,5) ==  5       == ");pr_nat0(e_union1(t1,5));
    printf("e_union1(t2,5) == 25       == ");pr_nat0(e_union1(t2,5));

    t1 = chg_u1(t1,2);
    printf("t1 = chg_u1(t1,2)         == ");pr_union1(t1);

    t3 = subst_u1(t1,5);
    printf("subst_u1(t1,5)            == ");pr_union1(t3);
    del1_union1(t3);

    t3 = subst_u2(t2,8);
    printf("subst_u2(t2,8)            == ");pr_union1(t3);
    del1_union1(t3);

    del1_union1(t0);
    del1_union1(t1);
    del1_union1(t2);
   }

void Union2_test()
   {Union2  t1,t2,t0,t3;
    t1 = mk_u21(0);
    t2 = mk_u22(5);
    t0 = mk_u23(mk_u1(2));

    printf("t1 = mk_u21(0)        == ");pr_union2(t1);
    printf("t2 = mk_u22(5)        == ");pr_union2(t2);
    printf("t0 = mk_u23(mk_u1(2)) == ");pr_union2(t0);

    printf("s_u21(t1)             == ");pr_nat0(s_u21(t1));
    printf("s_u22(t2)             == ");pr_nat1(s_u22(t2));
    printf("s_u23(t0)             == ");pr_union1(s_u23(t0));

    printf("is_eq(t1,t1)          == ");pr_bool(is_eq_union2(t1,t1));
    printf("is_eq(t1,t2)          == ");pr_bool(is_eq_union2(t1,t2));
    printf("is_ge(t1,t1)          == ");pr_bool(is_ge_union2(t1,t1));
    printf("is_ge(t1,t0)          == ");pr_bool(is_ge_union2(t1,t0));
    printf("is_ge(t0,t1)          == ");pr_bool(is_ge_union2(t0,t1));
    printf("is_ge(t1,t2)          == ");pr_bool(is_ge_union2(t1,t2));
    printf("is_ge(t2,t1)          == ");pr_bool(is_ge_union2(t2,t1));
    printf("is_gr(t1,t1)          == ");pr_bool(is_gr_union2(t1,t1));
    printf("is_gr(t1,t0)          == ");pr_bool(is_gr_union2(t1,t0));
    printf("is_gr(t0,t1)          == ");pr_bool(is_gr_union2(t0,t1));
    printf("is_gr(t1,t2)          == ");pr_bool(is_gr_union2(t1,t2));
    printf("is_gr(t2,t1)          == ");pr_bool(is_gr_union2(t2,t1));

    printf("e_union2(t1,5) ==  5  == ");pr_nat0(e_union2(t1,5));
    printf("e_union2(t2,5) == 25  == ");pr_nat0(e_union2(t2,5));
    printf("e_union2(t0,5) ==  7  == ");pr_nat0(e_union2(t0,5));

    t1 = chg_u21(t1,2);
    printf("t1 = chg_u21(t1,2)        == ");pr_union2(t1);
    t2 = chg_u22(t2,2);
    printf("t1 = chg_u22(t2,2)        == ");pr_union2(t2);
    t0 = chg_u23(t0,mk_u1(0));
    printf("t1 = chg_u23(t1,mk_u1(0)) == ");pr_union2(t0);

    t3 = subst_u21(t1,5);
    printf("subst_u11(t1,5)           == ");pr_union2(t3);
    del1_union2(t3);

    t3 = subst_u22(t2,2);
    printf("subst_u22(t1,8)           == ");pr_union2(t3);
    del1_union2(t3);

    t3 = subst_u23(t0,mk_u2(1));
    printf("subst_u23(t0,mk_u2(1)     == ");pr_union2(t3);
    del1_union2(t3);

    del1_union2(t0);
    del1_union2(t1);
    del1_union2(t2);
   }

void alloc_test(x1)
   Nat0 x1;
  {if (x1)
   {Union2 x2;
    x2 = mk_u23(mk_u2(4));
    alloc_test(x1-1);
    del_union2(x2);
  }}

main()
   {
    printf("\nUnion test\n\n");
    Union1_test();
    printf("\n");
    Union2_test();
    alloc_test(50);
    printf("\n");
    fflush(stdout);

    profile_union2();
    return 0;
   }
