/* ackermann function */
/* with cache of intermediate results */

#include "map2.h"

#define LET
#define IN ;

static Nat0 hits=0,calls=0;

Nat0 f0(x,y) Nat0 x,y;
  { calls++; return (x==0) ? y+1 : f0(x-1 ,(y==0) ? 1 : f0(x,y-1) ); }

Nat0 f1();

Nat0 f(x,y) Nat0 x,y;
  { return (x==0) ? y+1 : f1(x-1 ,(y==0) ? 1 : f1(x,y-1) ); }

Map2 cache;
extern Bool is_in_cache();
extern Map2 extend_cache();

Nat0 f1(x,y) Nat0 x,y;
   {Nat0 z;
    if (is_in_cache(x,y,cache,&z))
       {hits++;}
    else
       {calls++;    
        z = f(x,y);
        cache = extend_cache(x,y,z,cache);}
    return z;
    }

main(argc,argv) unsigned argc; char * argv[];
  {Nat0 x,y,z;
   char c;
   cache = mk_empty_map2();

   printf("ackermann function: terminate with x,y = 0,0");
   while (1) {
   printf("\nx,y = ");
   scanf(" %u , %u",&x,&y);
   if (x == 0 && y == 0) break;
    {hits=0;
     calls=0;
     z = f1(x,y);
     printf("\nackermann(%u,%u) = %u\n",x,y,z);
     printf("\n %d calls of ackermann",calls);
     printf("\n %d cache hits\n",hits);

     printf("display cache (y/n) ? ");
     scanf(" %c",&c);
     if (c=='Y' || c== 'y') pr_map2(cache);

     printf("\ncall without cache (y/n) ? ");
     scanf(" %c",&c);
     if (c=='Y' || c== 'y')
       {calls=0;
        z = f0(x,y);
        printf("\nackermann(%u,%u) = %u\n",x,y,z);
        printf("\n %d calls of ackermann\n",calls);
       }

    }}

    del_map2(cache);
    printf("\n");
    return 0;
  }
