/* $Id: acker_auto.cc,v 1.2 1994/06/12 16:35:38 vdm Exp $
* Testprogramm zur Performance-Analyse:
*   - Berechnung der Ackermann-Funktion unter Verwendung eines Werte-Caches
*   - automatische Speicherverwaltung
*
* Version 1.0 - 25/11/93
* ========================================================================= 
*/

#include "acker_vdm.hpp"
#include <time.h>

class TCache 
{
   private:
      MAP2 map2;
   public:
      TCache();
      ~TCache();
      Bool lookup(NAT0 x, NAT0 y, NAT0& result);
      void extend(NAT0 x, NAT0 y, NAT0 z);
};

TCache::TCache() : map2(empty)
{}

TCache::~TCache()
{}

inline Bool TCache::lookup(NAT0 x, NAT0 y, NAT0& result)
{
   MAP1 map1;
   return map2.is_in_dom(x,map1) && map1.is_in_dom(y,result);
}

inline void TCache::extend(NAT0 x, NAT0 y, NAT0 z)
{
   MAP1 map1;
   if (map2.is_in_dom(x,map1))
      map2.ovwrt1(x,map1.ovwrt1(y,z));
   else
      map2.plus1(x,MAP1(y,z));
}

// --- Globale Variablen: -----------------------------------------------------

   TCache cache;
   unsigned long acker_calls = 0; 
   unsigned long hits        = 0; 

   extern unsigned long cnt_copy_map1;
// ---------------------------------------------------------------------------

NAT0 acker(NAT0,NAT0);

NAT0 acker_help(NAT0 x, NAT0 y)
{
   return (x==0) ? y+1 : acker(x-1 ,(y==0) ? NAT0(1) : acker(x,y-1));
}

NAT0 acker(NAT0 x, NAT0 y)
{
   NAT0 res;
   if (!cache.lookup(x,y,res))
   {
      acker_calls++;
      res = acker_help(x,y);
      cache.extend(x,y,res);
   }       
   else
      hits++;
   return res;      
}

// ---------------------------------------------------------------------------

main()
{
/*    cout << "\n\n=== Berechnung der Ackermann-Funktion (automem) ===\n\n";
    unsigned long x,y;
    cout << " Please enter x and y value: ";
    cin  >> x >> y;
    cout << " the result is " << (unsigned long)acker(x,y) << "\n";
    cout << " Ackermann calls : " << acker_calls;
    cout << " Cache hits      : " << hits << "\n";
    cout << " Kopien map1     : " << cnt_copy_map1 << "\n";
    cout << cache.map2;  
*/
   
   clock_t start_clock, end_clock; 
   start_clock=clock();
   acker(3,8);
   end_clock = clock();
   cout << end_clock - start_clock << " ";
   
   return 0;
}
