/* $Id: cp_auto2.cc,v 1.1 1994/02/24 11:37:40 vdm Exp $
* Testprogramm zur Performance-Analyse:
*   - Berechnung der Coursest Partioning einer Menge von Mengen 
*     (tail-recursion durch Schleife ersetzt)
*
* Version 1.0 - 24/11/93
* ========================================================================= 
*/

#include "cp_vdm.hpp"
#include <time.h>

ASET find_partner(BSET b, ASET a)
{
   while (!b.is_empty())
   {
      ASET ret_val = b.sel();
      b -= ret_val;
      if (!(ret_val & a).is_empty()) return ret_val;
   }
   return  ASET(empty);
}

// --------------------------------------

BSET coursest_part(BSET S)
{
   ASET x,y;
   
   while (1)
   {
      Bool found = FALSE;
      BSET tmp = S;
      while (!found && !tmp.is_empty())
      {
         x = tmp.sel();
         tmp -= x;
         y = find_partner(tmp,x);
         found = !y.is_empty();
      }
      if (!found) break;
      
      S -= x;
      S -= y;
      S |= (x & y); 
      ASET tmp_aset = x-y; 
      if (!tmp_aset.is_empty())  S |= tmp_aset; 
      tmp_aset = y-x;
      if (!tmp_aset.is_empty())  S |= tmp_aset;
   }
   return S;
}

void run_cp(void)
{
    ASET a = NAT0(1); a |= NAT0(3);
    a |= NAT0(5); a |= NAT0(7);
    a |= NAT0(9); a |= NAT0(11);
    a |= NAT0(13);a |= NAT0(15);
    BSET b = BSET(a);
    
    a  = NAT0(2);  a |= NAT0(4);
    a |= NAT0(6);  a |= NAT0(8);
    a |= NAT0(10); a |= NAT0(12);
    a |= NAT0(14); a |= NAT0(16);
    b |= a;
    
    a  = NAT0(1); a |= NAT0(2);
    a |= NAT0(3); a |= NAT0(4);
    a |= NAT0(5); a |= NAT0(6);
    a |= NAT0(7); a |= NAT0(8);
    b |= (a);
    
    a  = NAT0(2); a |= NAT0(11);
    a |= NAT0(3); a |= NAT0(13);
    a |= NAT0(5); a |= NAT0(17);
    a |= NAT0(7); a |= NAT0(19);
    b |= a;    
    
//    cout << "Ergebnis : " << coursest_part(b);
    b = coursest_part(b);
}

// ---------------------------------------------------------------------------

main()
{
//   cout << "\n\n=== Berechnung der Coursest Partioning II (automem) ===\n\n";

   clock_t start_clocks, end_clocks;
   
   start_clocks = clock();
   for (int i=0; i<1500; i++) 
      run_cp();
   end_clocks = clock();
   cout << " " << end_clocks - start_clocks << " ";

//  profile_aset();
//  profile_rep_aset();
//  profile_bset();
//  profile_rep_bset();   
}
