// Testprogramm TYPGEN=Optional, IMPL=automem
//
// Version 1.0, 09/11/93, Thorsten Tews
// ===========================================================================

#include "opti_vdm.hpp"
#include "opti_test.def"

// Beschreibung des Testmakros TEST:
//    - Parameter e : Ausdruck, der, falls Anweisungen ok, TRUE ergeben muss
//    - Parameter ce: Variable ve darf (YES) bzw. darf nicht (NO) durch den
//                    Ausdruck e veraendert werden
//    - Parameter c1: Variable v1 darf (YES) bzw. darf nicht (NO) durch den
//                    Ausdruck e veraendert werden
//    - Parameter c2: Variable v2 darf (YES) bzw. darf nicht (NO) durch den
//                    Ausdruck e veraendert werden

#define YES FALSE
#define NO  TRUE
#define TEST(e,ce,c1,c2) {\
   OPTI vn = OPTI(nil), v1 = OPTI(ELEM1), v2 = OPTI(ELEM2), vtmp;\
   unsigned long err_code = 0;\
   if ((e) != TRUE) err_code |= 1;\
   if (ce && !(vn.is_eq(OPTI(nil)))) err_code |= 2;\
   if (c1 && !(v1.is_eq(OPTI(ELEM1)))) err_code |= 4;\
   if (c2 && !(v2.is_eq(OPTI(ELEM2)))) err_code |= 8;\
   if (err_code != 0)\
      cout << " ### TEST FAILED: " #e ", error code = " << err_code << " ###\n";\
   else\
      cout << " Test passed : " #e "\n";\
}

// ---------------------------------------------------------------------------

void perform_test(void)
{
   cout << "Used objects in tests:\n" ;
   cout << "   vn ... the optional mk_nil()\n"; 
   cout << "   v1 ... the optional mk_opt(ELEM1)\n";
   cout << "   v2 ... the optional mk_opt(ELEM2) (v2>v1)\n\n";
   
   TEST(v1 == v1,NO,NO,NO)
   TEST(v1 != v2,NO,NO,NO)
   TEST(vn == vn,NO,NO,NO)
#if !defined(NO_GREATER)   
   TEST(v2.is_gr(v1),NO,NO,NO)
   TEST(!v1.is_gr(v2),NO,NO,NO)
   TEST(v2.is_ge(v1),NO,NO,NO)
   TEST(!v1.is_ge(v2),NO,NO,NO)
#endif   
   TEST(v1.IS_ELEM(),NO,NO,NO)
   TEST(!vn.IS_ELEM(),NO,NO,NO)
   TEST(vn.is_nil(),NO,NO,NO)
   TEST(!v1.is_nil(),NO,NO,NO)
   TEST(v1.s() == ELEM1,NO,NO,NO)
   TEST(v2.s() == ELEM2,NO,NO,NO)

   TEST(OPTI(ELEM1) == vtmp.cvfromtupl(v1.cvtotupl()),NO,NO,NO) // cv(from|to)tupl 

   
   OPTI vn = OPTI(nil), v1 = OPTI(ELEM1), v2 = OPTI(ELEM2);
   cout << "\n--- Please check the following test results: ---\n\n"; 
   cout << " fpr       :\n   vn = " << vn << "   v1 = " << v1 << "   v2 = " << v2;
   cout << " v1.hash() : " << v1.hash() << "\n";
   cout << " finput    : \n   Please enter a value  v1 = ";
   cin  >> v1;
   cout << "   Value read by finput  v1 = " << v1; 
}

// ---------------------------------------------------------------------------
 
main()
{
   cout << "\n\n=== Test for TYPGEN: Optional, IMPL: Automem (09/11/93) ===\n\n";
   
   perform_test();
   profile_nset();
   return 0;
}   
