// Testprogramm TYPGEN=Tuple, IMPL= readfile/writefile (automem)
//
// Version 1.0, 01/12/93, Thorsten Tews
// ===========================================================================

#include "rw_vdm.hpp"

#define TESTFILE STR("/tmp/rw_testfile")

void dummy_prog(QUELLE q)
{
   int i = 100;
}

// ---------------------------------------------------------------------------

void perform_test(void)
{
   // Create a test object, which will be written to disk and read back
   SET test_set = SET(empty);
   for (Nat0 i=1; i<=10; i++) test_set |= NAT0(i);

   cout << "Der Set vorher: " << test_set;
   
   // Convert object to a tuple and write into a file; you can't assign the 
   // temporary created to any variable, so send the message  writef directly
   (test_set.cvtotupl()).fwrite(TESTFILE); 

   // Read the object back into the memory; after this operations 'quelle'
   // will be destroyed and can not be accessed !
   QUELLE quelle;
   quelle.fread(TESTFILE);
   SET test_set2;
   test_set2.cvfromtupl(quelle);
   
   cout << "Der Set nacher: " << test_set2;
   
   if (test_set == test_set2)
      cout << "Test passed !\n";
   else
      cout << "TEST FAILED !\n";   
      
   // the following statements are not valid and should provoke an error
   // message from the compiler:
   // quelle = quelle;     // assigment operator is private
   // dummy_prog(quelle);  // copy constructor is private
   
      
}

// ---------------------------------------------------------------------------
 
main()
{
   cout << "\n\n=== Test for TYPGEN: Tuple, IMPL: read/writefile (Automem) ===\n\n";
   
   perform_test();

   return 0;
}   
