/* $Id: main.cc,v 1.1 1996/01/24 14:46:01 vdm Exp $ */
/* the example main program */

#include "example.hpp"

void maptest() {
    MAP m = empty;

    cout << endl << "an empty map" << endl;
    cout << "m = " << m;

    // extending map using operator functions
    m |= PAIR_MAP(1,STRPTR("a 1. string"));
    m |= PAIR_MAP(2,STRPTR("a 2. string"));

    // equivalent non operator function
    m.plus1(3,STRPTR("a 3. string"));


    cout << endl << "a map with 3 elements" << endl;
    cout << "m = " << m;

    MAP m2 = m;

    cout << endl << "a copy of the map" << endl;
    cout << "m2 = " << m;

    // overwrite or extend map
    m += PAIR_MAP(2,STRPTR("a new 2. string"));
    m += PAIR_MAP(4,STRPTR("a new 4. string"));

    // equivalent statements not using operators
    m.ovwrt1(2,STRPTR("a new 2. string"));
    m.ovwrt1(4,STRPTR("a new 4. string"));
    
    cout << endl << "1 element changed and 1 new element" << endl;
    cout << "m = " << m;

    // remove entries with key 3 and 4
    m -= 3;
    m -= 4;

    // equivalent non operator functions
    m.sub1(3);
    m.sub1(4);

    cout << endl << "2 elements deleted" << endl;
    cout << "m = " << m;


    // acces non VDM type with conversion operator Strptr
    // allways defined in STRPTR

    STRPTR s = m[2];
    cout << endl << "accessing non VDM type : " << Strptr(s) << endl;
    
    cout << endl << "test finished" << endl;
}

int main(int argc, char* argv[]) {
   maptest();

   return 0;
}
