// $Id: is_a_ex.cc,v 1.3 1996/09/18 13:13:19 vdm Exp $
// test program for is-a constructor

#include "is_a.hpp"

//------------------------------------------------------------------------------
//
// the user supported member functions

BOOL
NUM::odd() const
{
  return mod(2) == 1;
}

NUM &
NUM::plus2()
{
  operator +=(2);
  return *this;
}

BOOL
BAG1::is_good() const
{
  return ! is_empty();
}

STR
TUP::attr() const
{
  return STR("TUP");
}

STR
TUP1::attr() const
{
  return STR("TUP1");
}

STR
TUP2::attr() const
{
  return STR("TUP2");
}

BOOL
MYSTR::is_longer(const MYSTR & s2) const
{
  return BOOL(len() > s2.len());
}
//------------------------------------------------------------------------------
//
// the toy application

int
main(int argc, char * argv[])
{
  cout << "is-a test program" << endl;

  NUM n1(5);

  cout << "n1 = "
       << n1
       << endl
       << "n1.odd() == "
       << n1.odd()
       << endl;

  n1.plus2();

  cout << "n1.plus2(); n1 == " 
       << n1
       << endl;

  BAG1 b1(5);
  cout << "b1 = "
       << b1
       << endl
       << "b1.is_good() == "
       << b1.is_good()
       << endl;

  TUP  t0(NAT0(42));
  TUP1 t1(t0);
  TUP2 t2(t1);

  cout << "t0.attr() == " << t0.attr() << endl
       << "t1.attr() == " << t1.attr() << endl
       << "t2.attr() == " << t2.attr() << endl;

  STR
    s0("abc");
  MYSTR
    m1(s0),
    m2("1234");

  cout << "m1.is_longer(m2) == " << m1.is_longer(m2) << endl;

  return 0;
}
