%{

#include "parse.hpp"

#define yywrap() 1

void yyerror(char * s)
    {
    }

STRLIST yyparse_result;

// forward declaration needed because of call of yylex
// from yyparse
extern int yylex(void);

%}

%union {
    int     vnull;
    Str     vstr;
    Strlist vlist;
}

%token <vstr> TID
%type  <vlist> prog idlist

%%

prog :  idlist
        {
	    $$ = $1;
	    yyparse_result = STRLIST($1);
        }
     ;

idlist : /* empty */
        { 
	    $$ = STRLIST(empty).cv_strlist();
	}
       | idlist TID
        {
	    STRLIST l1 = STRLIST($1);
	    l1 += STR($2);
	    $$ = l1.cv_strlist();
	}

%%

#include "scan.c"

int
main()
{

    // profiling statistics at progam start
    // profiling is enabled by calling VDM with "-SPROFILE" option

    profile_str();
    profile_rep_str();
    profile_strlist();
    profile_rep_strlist();

    {
	cout << endl << "start parsing" << endl;

	yyparse();

	cout << endl << "the following identifiers are detected in the input text" << endl;
	cout << endl << yyparse_result << endl;

	// forget parse tree to test storage management
	yyparse_result = empty;
    }

    // profiling statistics at program end
    profile_str();
    profile_rep_str();
    // for strlist one object remains allocated
    profile_strlist();
    profile_rep_strlist();


    return 0;
}
