/*----------------------------------------------------------------------

 $Id: header.h,v 1.7 1996/01/15 10:02:12 vdm Exp $

   Aufgabe:   "header.h" stellt Makros fuer Bool'sche Funktionen 
              und VDM-aehnliche Syntax zur Verfuegung 
              enthaelt die includes fuer die Systemheader

----------------------------------------------------------------------

 Changes:
 ========

   $Log: header.h,v $
   Revision 1.7  1996/01/15 10:02:12  vdm
   cvs backup

 * Revision 1.6  1994/03/07  13:43:36  vdm
 * extensions for changing Vdmdb implementation,
 * such that the database is read completely at program startup
 *
 * Revision 1.5  1993/11/03  14:17:09  vdm
 * Hans-Martins Aenderungen eingemischt
 *
 * Revision 1.3  1993/07/25  08:51:27  hmh
 * minor changes
 *
 * 'stdlib.h' included for '__STDC__' only

 * Revision 1.2  1993/07/10  07:29:54  hmh
 * Handling of 'VDMROOT' environment variable corrected:
 *   - removed reading from domaincomp ('vdmmain') completely
 *   - in Dm: if VDMROOT is undefined, set to default path ('/usr').
 *

----------------------------------------------------------------------*/

#ifndef HEADER
#define HEADER
/* Definitionen zur besseren Lesbarkeit: BOOLESCHE Operationen */

#define NOT !
#define AND &&
#define OR ||

/* Definitionen zur besseren Lesbarkeit: VDM-aehnliche Syntax */

#define IF (
#define THEN )?(
#define ELSE ):

#define LET
#define IN ;

#ifndef TRACE /* default: TRACE on */
#define TRACE 1
#endif

#define OUT_str(x) puts_str(x,stderr),fprintf(stderr,"\n")
#define OUT2_str(x1,x2) OUT_str(x1),OUT_str(x2)
#define OUT3_str(x1,x2,x3) OUT2_str(x1,x2),OUT_str(x3)
#define OUT4_str(x1,x2,x3,x4) OUT3_str(x1,x2,x3),OUT_str(x4)
#define OUT5_str(x1,x2,x3,x4,x5) OUT4_str(x1,x2,x3,x4),OUT_str(x5)

#define bool2str(x) IF x THEN "TRUE" ELSE "FASLE"
#define OUT_bool(x) fprintf(stdout,"%s\n",bool2str(x))

                                       /* environment variable */
#define VDMROOT "VDMROOT"
#define DEFAULT_VDMDB_NAME	"lib/vdmdb-c"
#define DEFAULT_VDMROOT		"/usr"
#define DEFAULT_FLAT_EXTENSION  ".s"

#if TRACE
#define HALLO(x) if (gptrace>0) fprintf(stderr,x)
#define TRACE1(x) if (gptrace>1) x
#define TRACE2(x) if (gptrace>2) x
#else
#define HALLO(x)
#define TRACE1(x)
#define TRACE2(x)
#endif

#endif

