/*----------------------------------------------------------------------*/

/* Modul:                  @(#)info.c */
/* Version:                2.1 */
/* Ersteller:              Gerrit Petrich, WI 8215, WS 93 */
/* Datum der letzten */
/* Aenderung:              93/03/29 */

/*----------------------------------------------------------------------*/

/* Aufgabe:   "info.c" stellt die Funktionen fuer das VDM-Info- */
/*            system bereit. */

/*----------------------------------------------------------------------*/

/* Aenderungen: */
/* wann:                 warum: */
/*----------------------------------------------------------------------*/
/* 16.02.1993                 include der Systemheader entfernt */
/*                       Sie werden jetzt in header.h eingebunden */
/*                          geaendert von: G. Petrich */
/*----------------------------------------------------------------------*/

#include "header.h"          /* allgemeines Headerfile */
#include "info.h"            /* eigenes Headerfile */
#include "genext.h"          /* Headerfile fuer fold-Funktionen */
#include "dbs.h"             /* Header fuer exists_... */

/*----------------------------------------------------------------------*/

Adtnameset contents_Vdmdb F1(Vdmdb,vdmdb)
                             /* contents_Vdmdb ermittelt die Namen */
                             /* aller ADTs einer Datenbank und */
                             /* gibt diese als Menge zurueck */
{
  return
    (IF exist_vdmdb(vdmdb)
     THEN dom_vdmdb(vdmdb)
     ELSE mk_empty_strset());
}

/*----------------------------------------------------------------------*/

Implnameset contents_Adt F2(Vdmdb,vdmdb,Adtname,adtname)
                             /* contents_Adt ermittelt die Namen */
                             /* aller Implementationen unter einem */
                             /* ADT einer Datenbank und */
                             /* gibt diese als Menge zurueck */
{
  return
    (IF exist_Adt(vdmdb,adtname)
     THEN dom_adt(sel_vdmdb(vdmdb,adtname))
     ELSE mk_empty_strset());
}

/*----------------------------------------------------------------------*/

Opnameset contents_Impl F3(Vdmdb,vdmdb,Adtname,adtname,Implname,implname)
                             /* contents_Impl ermittelt die Namen */
                             /* der Operationen einer Implement. */
                             /* eines ADTs aus einer Datenbank und */
                             /* gibt diese als Menge zurueck */
{
  return
    (IF exist_Implementation(vdmdb,adtname,implname)
     THEN dom_impl(sel_adt(sel_vdmdb(vdmdb,adtname),implname))
     ELSE mk_empty_strset());
}

/*----------------------------------------------------------------------*/

Opnameset ext_contents_Impl F3(Vdmdb,vdmdb,Adtname,adtname,Implname,implname)
                             /* ext_contents_Impl ermittelt die Namen */
                             /* der Operationen einer Implement. */
                             /* eines ADTs, der gemeinsamen Operationen*/
                             /* eines ADTs (adt/com), und der fuer */
                             /* alle ADTs gemeinsamen Operationen */
                             /* (com/com) einer DB und */
                             /* gibt diese als Menge zurueck */
{
Impl comimpl,
     comcomimpl;

  return
    (IF exist_Implementation(vdmdb,adtname,implname)
     THEN
       comimpl=sel_adt(sel_vdmdb(vdmdb,adtname),dmCOM),     /* adt/com */
       comcomimpl=sel_adt(sel_vdmdb(vdmdb,dmCOM),dmCOM),      /* com/com */
       uniond_strset(uniond_strset(dom_impl(comimpl),
                                 dom_impl(comcomimpl)),
                    dom_impl(sel_adt(sel_vdmdb(vdmdb,adtname),implname)))
     ELSE mk_empty_strset());
}

/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/
