/*----------------------------------------------------------------------*/

/* Modul:                  @(#)invar.c */
/* Version:                2.1 */
/* Ersteller:              Gerrit Petrich, WI 8215, WS 93 */
/* Datum der letzten */
/* Aenderung:              93/03/29 */

/*----------------------------------------------------------------------*/

/* Aufgabe:   "invar.c" enthaelt die Funktionen, die die Such- */
/*            algorithmen realisieren. */

/*----------------------------------------------------------------------*/

/* Aenderungen: */
/* wann:                 warum: */
/*----------------------------------------------------------------------*/
/* 16.02.1993                 include der Systemheader entfernt */
/*                       Sie werden jetzt in header.h eingebunden */
/*                          geaendert von: G. Petrich */
/*----------------------------------------------------------------------*/

#include "header.h"              /* Standard-header-file */
#include "dbs.h"                 /* globale Konstanten   */
#include "invar.h"               /* eigenes header-file */

/*----------------------------------------------------------------------*/

Bool exist_wf_Operation F7(
        Vdmdb,vdmdb,            /* Datenbank, in der gesucht werden soll */
        Adtname,adt_name,       /* Name des ADTs, in dem die Operation gesucht werden soll */
        Implname,impl_name,     /* Name der Implementation, in der die Operation gesucht werden soll */
        Opname,op_name,         /* Name der Operation, nach der gesucht werden soll */
        Adtname *,found_in_adt, /* Name des ADTs, in dem die Operation gefunden wurde */
        Implname *,found_in_impl, /* Name der Implementation, in der die Operation gefunden wurde */
        Operation *,found_operation)  /* gefundene Komponente */

/* ueberprueft, ob eine Operation in der Datenbank enthalten ist, */

/* Es wird folgende Suchstrategie angewendet:
           1. adtname implname opname compname
           2. adtname com      opname compname
           3. com     com      opname compname */
{
    Adt adt;
    Impl impl;

    HALLO("wf Op:\n");
    TRACE1( { OUT3_str(adt_name,impl_name,op_name); } )

    return
	IF is_in_dom_vdmdb(adt_name,vdmdb,&adt)
	AND is_in_dom_adt(impl_name,adt,&impl)
	AND is_in_dom_impl(op_name,impl,found_operation)
	THEN (*found_in_adt=adt_name,
	      *found_in_impl = impl_name,
	      TRUE)
	ELSE
	IF NOT is_eq_str(impl_name,dmCOM)  /* unter com impl suchen */
	THEN exist_wf_Operation(vdmdb,adt_name,dmCOM,op_name,
				found_in_adt,found_in_impl,found_operation)
	ELSE
	IF NOT is_eq_str(adt_name,dmCOM)   /* unter com adt suchen */
	THEN exist_wf_Operation(vdmdb,dmCOM,impl_name,op_name,
				found_in_adt,found_in_impl,found_operation)
	ELSE FALSE;
}

Bool exist_wf_Signature F5(
        Vdmdb,vdmdb,            /* Datenbank, in der gesucht werden soll */
        Adtname,adt_name,       /* Name des ADTs, in dem die Signatur gesucht werden soll */
        Opname,op_name,         /* Name der Operation, fuer die die Signatur gesucht werden soll */
        Adtname *,found_in_adt, /* Name des ADTs, in dem die Signatur gefunden wurde */
        Operation *,found_operation)   /* alle SIGN Komponenten */

     /* ueberprueft, ob eine Signatur in der Datenbank enthalten ist, */

     /* Es wird folgende Suchstrategie angewendet:
           1. adtname sign opname compname
           2. com     sign opname compname */

{
    Adt adt;
    Impl impl;

    HALLO("wf Sign:\n");
    TRACE1( { OUT2_str(adt_name,op_name); } )

    return
	IF is_in_dom_vdmdb(adt_name,vdmdb,&adt)
	AND is_in_dom_adt(dmSIGN,adt,&impl)
	AND is_in_dom_impl(op_name,impl,found_operation)
	THEN (*found_in_adt=adt_name,
	      TRUE)
	ELSE
	IF NOT is_eq_str(adt_name,dmCOM)   /* unter com adt suchen */
	THEN exist_wf_Signature(vdmdb,dmCOM,op_name,
				found_in_adt,found_operation)
	ELSE FALSE;
}
