/*----------------------------------------------------------------------*/

/* Modul:                  @(#)tl.c */
/* Version:                2.1 */
/* Ersteller:              Gerrit Petrich, WI 8215, WS 93 */
/* Datum der letzten */
/* Aenderung:              93/03/29 */

/*----------------------------------------------------------------------*/

/* Aufgabe:   "tl.c" ist die Programmschnittstelle fuer die */
/*            Einfuege- und Loeschoperationen der VDM-Klassen- */
/*            bibliothek aus "tool.c". */

/*----------------------------------------------------------------------*/

/* Aenderungen: */
/* wann:                 warum: */
/*----------------------------------------------------------------------*/
/* 16.02.1993                 include der Systemheader entfernt */
/*                       Sie werden jetzt in header.h eingebunden */
/*                          geaendert von: G. Petrich */
/*----------------------------------------------------------------------*/

#include "header.h"          /* allgemeiner Header */
#include "genext.h"
#include "gen.h"             /* aus gen.vdm generierter Header */
#include "dbs.h"             /* init und finish und globale Konstanten */
#include "tool.h"            /* enthaelt aufzurufende Funktionen */


void Usage()                 /* Usage gibt die moeglichen Programm- */
                             /* parameter aus, wenn das Programm */
                             /* fehlerhaft aufgerufen wird */
{
  fprintf(stderr,"usage: tl -|+ v|a|i|o|c params\n");
  fprintf(stderr,"options:\n");
  fprintf(stderr,"  +v : create new database\n");
  fprintf(stderr,"       params: <Vdmdbname>\n");
  fprintf(stderr,"  +a : create new adt in database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname>\n");
  fprintf(stderr,"  +i : create new implementation in database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname> <Implname>\n");
  fprintf(stderr,"  +o : create new operation in database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname> <Implname> <Opname>\n");
  fprintf(stderr,"  +c : insert new component in database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname> <Implname> <Opname> <Compname> <Filename>\n");
  fprintf(stderr,"  -v : remove database\n");
  fprintf(stderr,"       params: <Vdmdbname>\n");
  fprintf(stderr,"  -a : remove adt from database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname>\n");
  fprintf(stderr,"  -i : remove implementation from database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname> <Implname>\n");
  fprintf(stderr,"  -o : remove operation from database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname> <Implname> <Opname>\n");
  fprintf(stderr,"  -c : remove component from database\n");
  fprintf(stderr,"       params: <Vdmdbname> <Adtname> <Implname> <Opname> <Compname>\n");
}


/*----------------------------------------------------------------------*/

void pre_create_Vdmdb F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_create_Vdmdb wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* create_Vdmdb */
{
Vdmdbname vdmdb_name;
Vdmdb vdmdb;

  HALLO("pre create Vdmdbs\n");
  if (argc<i+1)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      vdmdb=mk_vdmdb_from_str(vdmdb_name);   /* Datenbank erzeugen */
      write_Vdmdb(vdmdb_name,vdmdb);         /* Datenbank schreiben */
      del_vdmdb(vdmdb);                      /* Speicher freigeben */
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_create_Adt F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_create_Adt wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* create_Adt */
{
Vdmdbname vdmdb_name;
Adtname adt_name;
Vdmdb vdmdb;

  HALLO("pre create Adt   \n");
  if (argc<i+2)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      vdmdb=create_Adt(vdmdb_name,adt_name); /* ADT erzeugen */
      write_Vdmdb(vdmdb_name,vdmdb);         /* Datenbank schreiben */
      del_vdmdb(vdmdb);                      /* Speicher freigeben */
      del_str(adt_name);
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_create_Impl F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_create_Impl wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* create_Impl */
{
Vdmdbname vdmdb_name;
Adtname adt_name;
Implname impl_name;
Vdmdb vdmdb;

  HALLO("pre create Impl  \n");
  if (argc<i+3)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no implname given\n");
      if (argc<i+2)
        fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      impl_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      vdmdb=create_Impl(vdmdb_name,adt_name,impl_name); /* Impl erzeugen */
      write_Vdmdb(vdmdb_name,vdmdb);         /* Datenbank schreiben */
      del_vdmdb(vdmdb);                      /* Speicher freigeben */
      del_str(impl_name);
      del_str(adt_name);
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_create_Operation F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_create_Operation wertet die Programm-*/
                             /* parameter aus, und startet die Funktion */
                             /* create_Operation */
{
Vdmdbname vdmdb_name;
Adtname adt_name;
Implname impl_name;
Opname op_name;
Vdmdb vdmdb;

  HALLO("pre create Op    \n");
  if (argc<i+4)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no opname given\n");
      if (argc<i+3)
        fprintf(stderr,"missing functionparameter: no implname given\n");
      if (argc<i+2)
        fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      impl_name=mkc_str(argv[i++]);
      op_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      vdmdb=create_Operation(vdmdb_name,adt_name,impl_name,op_name);
                                             /* Operation erzeugen */
      write_Vdmdb(vdmdb_name,vdmdb);         /* Datenbank schreiben */
      del_vdmdb(vdmdb);                      /* Speicher freigeben */
      del_str(op_name);
      del_str(impl_name);
      del_str(adt_name);
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_insert_Comp F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_insert_Comp wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* insert_Comp */
{
Vdmdbname vdmdb_name;
Adtname adt_name;
Implname impl_name;
Opname op_name;
Compname comp_name;
Str file;
Component comp;
Vdmdb vdmdb;

  HALLO("pre insert Comp  \n");
  if (argc<i+6)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no filename given\n");
      if (argc<i+5)
        fprintf(stderr,"missing functionparameter: no compname given\n");
      if (argc<i+4)
        fprintf(stderr,"missing functionparameter: no opname given\n");
      if (argc<i+3)
        fprintf(stderr,"missing functionparameter: no implname given\n");
      if (argc<i+2)
        fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      impl_name=mkc_str(argv[i++]);
      op_name=mkc_str(argv[i++]);
      comp_name=mkc_str(argv[i++]);
      file=mkc_str(argv[i++]);
      comp=fread_str(file);                 /* Datei lesen */
      if (is_empty_str(comp))               /* Falls Datei leer: Warnung */
        {
          fprintf(stderr,"Warning: file which includes Component is empty: \n");
          OUT_str(file);
          fprintf(stderr,"the following Component is empty: \n");
          OUT_str(comp_name);
        }
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      vdmdb=insert_Component(vdmdb_name,adt_name,impl_name,
                             op_name,comp_name,comp);
                                            /* Komponente erzeugen */
      write_Vdmdb(vdmdb_name,vdmdb);        /* Datenbank schreiben */
      del_vdmdb(vdmdb);                     /* Speicher freigeben */
      del_str(file);
      del_str(comp_name);
      del_str(op_name);
      del_str(impl_name);
      del_str(adt_name);
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_rm_Vdmdb F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_rm_Vdmdb wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* rm_Vdmdb */
{
Vdmdbname vdmdb_name;

  HALLO("pre rm Adt       \n");
  if (argc<i+1)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no adtname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      if (rm_Vdmdb(vdmdb_name))              /* Datenbank loeschen */
        fprintf(stderr,"vdm-database successfully removed: ");
      else fprintf(stderr,"error: could not remove vdm-database: ");
      OUT_str(vdmdb_name);
      del_str(vdmdb_name);                   /* Speicher freigeben */
    }
}

/*----------------------------------------------------------------------*/

void pre_rm_Adt F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_rm_Adt wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* rm_Adt */
{
Vdmdbname vdmdb_name;
Adtname adt_name;

  HALLO("pre rm Adt       \n");
  if (argc<i+2)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      if (rm_Adt(vdmdb_name,adt_name))       /* ADT       loeschen */
        fprintf(stderr,"ADT successfully removed: ");
      else fprintf(stderr,"error: could not remove ADT: ");
      OUT_str(adt_name);
      fprintf(stderr,"from database: ");
      OUT_str(vdmdb_name);
      del_str(vdmdb_name);                   /* Speicher freigeben */
      del_str(adt_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_rm_Impl F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_rm_Impl wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* rm_Impl */
{
Vdmdbname vdmdb_name;
Adtname adt_name;
Implname impl_name;

  HALLO("pre rm Impl      \n");
  if (argc<i+3)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no implname given\n");
      if (argc<i+2)
        fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      impl_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      if (rm_Impl(vdmdb_name,adt_name,impl_name))
                                            /* Implementation loeschen */
        fprintf(stderr,"implementation  successfully removed: ");
      else fprintf(stderr,"error: could not remove implementation: ");
      OUT_str(impl_name);
      fprintf(stderr,"from ADT: ");
      OUT_str(adt_name);
      fprintf(stderr,"from database: ");
      OUT_str(vdmdb_name);
      del_str(impl_name);                    /* Speicher freigeben */
      del_str(adt_name);
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_rm_Operation F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_rm_Operation wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* rm_Operation */
{
Vdmdbname vdmdb_name;
Adtname adt_name;
Implname impl_name;
Opname op_name;

  HALLO("pre rm Operation \n");
  if (argc<i+4)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no opname given\n");
      if (argc<i+3)
        fprintf(stderr,"missing functionparameter: no implname given\n");
      if (argc<i+2)
        fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      impl_name=mkc_str(argv[i++]);
      op_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      if (rm_Operation(vdmdb_name,adt_name,impl_name,op_name))
                                            /* Operation      loeschen */
        fprintf(stderr,"operation successfully removed: ");
      else fprintf(stderr,"error: could not remove operation: ");
      OUT_str(op_name);
      fprintf(stderr,"from implementation: ");
      OUT_str(impl_name);
      fprintf(stderr,"from ADT: ");
      OUT_str(adt_name);
      fprintf(stderr,"from database: ");
      OUT_str(vdmdb_name);
      del_str(op_name);                      /* Speicher freigeben */
      del_str(impl_name);
      del_str(adt_name);
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

void pre_rm_Comp F3(
        int,i,             /* Zaehler fuer uebergebene Parameter */
        int,argc,          /* Anzahl der uebergebenen Parameter */
        char **,argv)      /* Tupel der uebergebenen Parameter */
                             /* pre_rm_Comp wertet die Programm- */
                             /* parameter aus, und startet die Funktion */
                             /* rm_Comp */
{
Vdmdbname vdmdb_name;
Adtname adt_name;
Implname impl_name;
Opname op_name;
Compname comp_name;

  HALLO("pre rm Comp      \n");
  if (argc<i+5)                        /* zu wenig Parameter: */
    {
      fprintf(stderr,"missing functionparameter: no compname given\n");
      if (argc<i+4)
        fprintf(stderr,"missing functionparameter: no opname given\n");
      if (argc<i+3)
        fprintf(stderr,"missing functionparameter: no implname given\n");
      if (argc<i+2)
        fprintf(stderr,"missing functionparameter: no adtname given\n");
      if (argc<i+1)
        fprintf(stderr,"missing functionparameter: no vdmdbname given\n");
      Usage();
    }
  else
    {                                  /* Parameter auswerten */
      vdmdb_name=mkc_str(argv[i++]);
      adt_name=mkc_str(argv[i++]);
      impl_name=mkc_str(argv[i++]);
      op_name=mkc_str(argv[i++]);
      comp_name=mkc_str(argv[i++]);
      while (argc > i)
        {                              /* zu viele Parameter: */
          fprintf(stderr,"superfluos parameter %s ignored\n",argv[i++]);
        }
      if (rm_Component(vdmdb_name,adt_name,impl_name,op_name,comp_name))
                                            /* Komponente     loeschen */
        fprintf(stderr,"Component successfully removed: ");
      else fprintf(stderr,"error: could not remove Component: ");
      OUT_str(comp_name);
      fprintf(stderr,"from operation: ");
      OUT_str(op_name);
      fprintf(stderr,"from implementation: ");
      OUT_str(impl_name);
      fprintf(stderr,"from ADT: ");
      OUT_str(adt_name);
      fprintf(stderr,"from database: ");
      OUT_str(vdmdb_name);
      del_str(comp_name);                    /* Speicher freigeben */
      del_str(op_name);
      del_str(impl_name);
      del_str(adt_name);
      del_str(vdmdb_name);
    }
}

/*----------------------------------------------------------------------*/

int main F2(
        int,argc,
        char **,argv)
                             /* Das Hauptprogramm liest die Programm- */
                             /* parameter ein und startet die Funktionen */
{
char *p;
int i=1;
Str tracestring;

  init_vdmdm();

  if (argc==1)                         /* keine Programmparameter */
    Usage();                           /* => usage ausgeben */
  else
     {
       while (argc>i)
         {
           p=argv[i++];
           if (*p=='+')
             switch(*(++p))                /* create-Funktionen starten */
               {
                 case 'v' : pre_create_Vdmdb(i,argc,argv);i=argc;break;
                 case 'a' : pre_create_Adt(i,argc,argv);i=argc;break;
                 case 'i' : pre_create_Impl(i,argc,argv);i=argc;break;
                 case 'o' : pre_create_Operation(i,argc,argv);i=argc;break;
                 case 'c' : pre_insert_Comp(i,argc,argv);i=argc;break;
                 default  : fprintf(stderr,"wrong function parameter\n");
                            Usage();
               }
           else
             if (*p=='-')
               switch(*(++p))                /* rm-Funktionen starten */
                 {
                   case 'T' : /* Trace-variable setzen */
                              tracestring=mkc_str(argv[i-1]);
                              gptrace=len_str(tracestring)-1;
                              del_str(tracestring);
                              break;
                   case 'v' : pre_rm_Vdmdb(i,argc,argv);i=argc;break;
                   case 'a' : pre_rm_Adt(i,argc,argv);i=argc;break;
                   case 'i' : pre_rm_Impl(i,argc,argv);i=argc;break;
                   case 'o' : pre_rm_Operation(i,argc,argv);i=argc;break;
                   case 'c' : pre_rm_Comp(i,argc,argv);i=argc;break;
                   default  : fprintf(stderr,"wrong function parameter\n");
                              Usage();
                 }
             else
              {
                fprintf(stderr,"function parameter has to start with + for create or - for rm\n");
                Usage();
              }
         }
     }
   TRACE1( { profile_vdmdbs(); profile_str(); } )

  finish_vdmdm();

  return 0;
 }
