
#ifndef CPP_TYPES

#include <stdio.h>
#include <sys/types.h>                 /* 'time_t'                         */
#include <time.h>                      /* 'ctime','time'                   */
/* #include <process.h> */             /* 'exit','abort'                   */
#include <string.h>                    /* 'strlen','strcpy','strchr','str- */
				       /* cmp','strcat','strncpy'          */
/* #include <alloc.h> */               /* 'malloc','realloc','free'        */

#if __STDC__
#ifndef apollo
#define __ANSI__ 1
#endif
#endif

#if __ANSI__

#define S0(t1   )                         (t1   )
#define S1(t1,p1)                         (t1 p1)
#define S2(t1,p1,t2,p2)                   (t1 p1,t2 p2)
#define S3(t1,p1,t2,p2,t3,p3)             (t1 p1,t2 p2,t3 p3)
#define S4(t1,p1,t2,p2,t3,p3,t4,p4)       (t1 p1,t2 p2,t3 p3,t4 p4)
#define S5(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5) (t1 p1,t2 p2,t3 p3,t4 p4,t5 p5)
#define S6(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6) (t1 p1,t2 p2,t3 p3,t4 p4,t5 p5,t6 p6)
#define E1(t1)                (t1)
#define E2(t1,t2)             (t1,t2)
#define E3(t1,t2,t3)          (t1,t2,t3)
#define E4(t1,t2,t3,t4)       (t1,t2,t3,t4)
#define E5(t1,t2,t3,t4,t5)    (t1,t2,t3,t4,t5)
#define E6(t1,t2,t3,t4,t5,t6) (t1,t2,t3,t4,t5,t6)

#else

#define S0(t1) (  )
#define S1(t1,p1) (p1) t1 p1;
#define S2(t1,p1,t2,p2) (p1,p2) t1 p1; t2 p2;
#define S3(t1,p1,t2,p2,t3,p3) (p1,p2,p3) t1 p1; t2 p2; t3 p3;
#define S4(t1,p1,t2,p2,t3,p3,t4,p4) (p1,p2,p3,p4) t1 p1; t2 p2; t3 p3; t4 p4;
#define S5(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5) (p1,p2,p3,p4,p5) t1 p1; t2 p2; t3 p3; t4 p4; t5 p5;
#define S6(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6) (p1,p2,p3,p4,p5,p6) t1 p1; t2 p2; t3 p3; t4 p4; t5 p5; t6 p6;

#define E1(t1) (  )
#define E2(t1,t2) (  )
#define E3(t1,t2,t3) (  )
#define E4(t1,t2,t3,t4) (  )
#define E5(t1,t2,t3,t4,t5) (  )
#define E6(t1,t2,t3,t4,t5,t6) (  )

#endif

typedef struct         { FILE            *fp;
			 char            *name;
			 time_t          time;
			 unsigned long   line;  }                    stream;

typedef enum           { OP_SEP,IDENT,FCONST,CCONST,STRING,ICONST,
			 PPCMD,PPCOTHER,last_stype                    } stype;

	struct sym_str { struct sym_str  *nxt;
			 struct mac_str  *mcr;
			 stype           type;
			 char            *text; };

	struct mac_str { struct sym_str  **rpl,
					 **par;
			 char            lock,
					 syst;
			 size_t          pc;    };

typedef struct sym_str                                               *symbol;
typedef struct mac_str                                               *macro;

enum exp_mode          { NO_EXP,LINE_EXP,ALL_EXP };

#define SLASH     fsymbols[ 0]
#define WHITESP   fsymbols[ 1]
#define NEWLINE   fsymbols[ 2]
#define NOT       fsymbols[ 3]
#define MODULO    fsymbols[ 4]
#define BIN_XOR   fsymbols[ 5]
#define BIN_AND   fsymbols[ 6]
#define MULTIPL   fsymbols[ 7]
#define MINUS     fsymbols[ 8]
#define PLUS      fsymbols[ 9]
#define COMPLM    fsymbols[10]
#define BIN_OR    fsymbols[11]
#define LESS      fsymbols[12]
#define GREATER   fsymbols[13]
#define QUESTM    fsymbols[14]
#define MAKE_STR  fsymbols[15]
#define INCREMENT fsymbols[16]
#define DECREMENT fsymbols[17]
#define L_SHIFT   fsymbols[18]
#define R_SHIFT   fsymbols[19]
#define LSOREQUAL fsymbols[20]
#define GROREQUAL fsymbols[21]
#define EQUAL     fsymbols[22]
#define NOT_EQUAL fsymbols[23]
#define LOG_AND   fsymbols[24]
#define LOG_OR    fsymbols[25]
#define L_PARENTH fsymbols[26]
#define R_PARENTH fsymbols[27]
#define COMMA     fsymbols[28]
#define COLON     fsymbols[29]
#define ENDOFFILE fsymbols[30]
#define QUOTES_   fsymbols[31]
#define UNLOCK    fsymbols[32]
#define DEFINE    fsymbols[33]
#define IF        fsymbols[34]
#define IFDEF     fsymbols[35]
#define IFNDEF    fsymbols[36]
#define ELIF      fsymbols[37]
#define ELSE      fsymbols[38]
#define ENDIF     fsymbols[39]
#define ERROR     fsymbols[40]
#define INCLUDE   fsymbols[41]
#define LINE      fsymbols[42]
#define PRAGMA    fsymbols[43]
#define UNDEF     fsymbols[44]
#define NULLDIR   fsymbols[45]
#define DEFINED   fsymbols[46]
#define STDC_MCR  fsymbols[47]
#define DATE_MCR  fsymbols[48]
#define TIME_MCR  fsymbols[49]
#define FILE_MCR  fsymbols[50]
#define LINE_MCR  fsymbols[51]
#define ZERO      fsymbols[52]
#define ONE       fsymbols[53]

extern symbol fsymbols[];
#define FSYMB_N   54

#define ESC       '\1'
#define QUOTES    '\2'
#define APOSTR    '\3'
#define PARAM     '\4'
#define HASHM     '\5'

#endif
#define CPP_TYPES

