/*----------------------------------------------------------------------

 $Id: domdsl.c,v 1.4 1996/01/15 10:01:55 vdm Exp $

 Aufgabe  : Aufruf des Parsers 

----------------------------------------------------------------------
 Parameter 

 Eingabe  : VDM-String mit zu verarbeitender DSL-Syntax 

 Ausgabe  : Parse-Baum 

----------------------------------------------------------------------

 Ersteller: Kai Steinau 

----------------------------------------------------------------------

 Aenderungen: 

 $Log: domdsl.c,v $
 Revision 1.4  1996/01/15 10:01:55  vdm
 cvs backup

 * Revision 1.3  1993/11/03  14:16:50  vdm
 * Hans-Martins Aenderungen eingemischt
 *
 * Revision 1.3  1993/10/29  21:21:40  hmh
 * Several corrections dealing with storage allocation:
 *
 * - In 'parsevdm' the input string will be deleted.

 * Revision 1.2  1993/10/24  21:58:05  hmh
 * Changes built in to handle the '-r' option used to check
 * if a given enrichment file can be used as starting point of
 * enrichment process.
 *
 * - trace messages generated using 'trace*'.

----------------------------------------------------------------------*/

#include "domadt.h"
#include "domfct.h"
#include "domdsl.h"

/*----------------------------------------------------------------------*/
/* globale Variablen */

int           parse_count;     /* Anzahl der Parse-Durchgaenge */


/*----------------------------------------------------------------------
 Modulname: parsevdm 
 Aufgabe  : Ermitteln des Parse-Baum fur eine gegebene Spezifikation 
	    Der Eingabestring wird zerstoert!
----------------------------------------------------------------------
 Parameter 
 Eingabe  : VDM-String der Spezifikation in DSL-Syntax 's' 
 Ausgabe  : Parse-Baum 
----------------------------------------------------------------------*/

Dominfo parsevdm F1(
Str, s)                /* VDM-String */
{
 extern int yyparse H0();
 extern void yyrestart H1(FILE *);
 extern char *infile;
 extern char *rootfile;
 extern Dominfo yyparse_result;
 extern FILE *yyin;
 Str fn;                           /* Name der Eingabe-Datei */
 static Bool restart_parser = FALSE;

 parse_count++;
 if (domtrace>0)
  printstr(mkc_str("Parsing..."),gen_str(EMPTY,parse_count),Empty),
  printstr(copy_str(NEWLINE),Empty,Empty);

 if (((infile=(char *)tmpmalloc(Parsefilenamelen))!=NULL)
  AND ((rootfile=(char *)tmpmalloc(Parsefilenamelen))!=NULL))
 {
    yyparse_result=mk_empty_dominfo();
    fn=create_tmpfile();
    /* ablegen des VDM-Strings in einer Datei */
    if (NOT is_empty_str(fn))
       if (fwrite_str(s,fn)==FALSE)
          error(mkc_str("Cant't write source for parser into tmpfile "),fn);
       else
          /* verarbeiten des Strings mit dem Parser (yyparse) */
          if ((yyin=open_file(fn,"r"))!=NULL)
          {
             /* Dateinamen zur Angabe von Fehlerpositionen */
             cpc_str(fn,rootfile);
             cpc_str(fn,infile);
             if ( restart_parser )
                yyrestart(yyin);
             restart_parser = TRUE;
             yyparse();
             close_file(yyin);
             if (domtrace<3)
                remove_file(fn);
             del_str(fn);
             if (domtrace>2)
             {
                puts_str(mkc_str("\n\nParse result :\n"),stdout);
                pr_dominfo(yyparse_result);fflush(stdout);
             }
          }

 }
 if (infile!=NULL) free(infile);
 if (rootfile!=NULL) free(rootfile);
 del_rootvals(rootvalues);
 rootvalues=mk_empty_rootvals();

 del_str(s);

 return yyparse_result;
}
