/*----------------------------------------------------------------------

 Modulname: $Id: domfct.c,v 1.19 1996/09/08 11:45:12 vdm Exp $ 

 Aufgabe  : Bereitstellen von Hilfsfunktionen 

----------------------------------------------------------------------
 Parameter 

 Eingabe  : 

 Ausgabe  :

----------------------------------------------------------------------

 Ersteller: Kai Steinau 

----------------------------------------------------------------------

Aenderungen:

$Log: domfct.c,v $
Revision 1.19  1996/09/08 11:45:12  vdm
error in param_defined removed:
Implid was not checked against NIL, before accessing the database
this case occurs for PREDEF domain ids
"s_str_implid(...)" was not called in parameter expression for "get_params"
"Str" and "Implid" are in C the same type, so no compiler error was
issued ( :-( ).

Revision 1.18  1996/04/30 20:24:26  vdm
extensions for implementing alias as inheritance in C++
solution: a new constructor -isa with external syntax
Subtype is-a Basetype
Semantics for C like "=", but for C++ class SUBTYPE
becomes a subclass of class BASETYPE
Problem: constructors are not inherited, so the
constructors are passed from Basetype to Subtype
in the generator, therefore a special operation
constructor.mk??? introduced, wich is copied in the generator
to the Subtype domain.
The generation order computation did not work save,
therefore an explicit dependency graph is constructed, with this
graph the generation order is computed, old code still there
function "old_gen_order"

Revision 1.17  1996/01/15 10:01:56  vdm
cvs backup

 * Revision 1.16  1995/11/25  14:17:29  vdm
 * minor writing errors
 *
 * Revision 1.15  1995/11/25  13:50:37  vdm
 * minor warning correction from sun cc and g++ 2.7.0
 *
 * Revision 1.14  1995/01/31  18:13:45  vdm
 * SIGNATURE --> SIGNATURESTRING
 * for -X all domains in .enr file written, not only defined domains'
 *
 * Revision 1.13  1994/12/29  16:52:31  vdm
 * new option -X for collecting comments
 * during parsing and writing these comments into the .enr and .pre files
 * for parsing and importing .vdm files into vdmedit
 *
 * Revision 1.12  1994/12/27  20:13:15  vdm
 * union domains extended:
 * a union domain can now be defined step by step with the following syntax
 * Uni = D1 | D2
 * ...
 * Uni = ... | D3 | D4
 * ...
 * Uni = ... | D5
 *
 * Revision 1.11  1994/11/27  19:05:10  vdm
 * new keywords set bag nat nat0 int char bool real rat
 * for ISO syntax
 *
 * Revision 1.10  1994/08/13  19:44:01  vdm
 * TDEPEND --> TFCT,
 * new function arrow => for transformation functions
 *
 * Revision 1.9  1994/08/13  11:48:40  vdm
 * syntax of VDM-DSL extended:
 * a FUNCTIONS part added to specify the signature of user defined functions
 * DOMAINS, IMPLEMENTATIONS and FUNCTIONS parts may be mixed arbitrarily
 * the keyword FUNCTIONS may also be writtes as Functions
 * the syntax of a signature is
 *   fct1,...,fctn : D1 x ... x Dm -> R1 x ... x Ro
 * these signatures are implemeted by the com.com.signature operation
 * x is a new keyword
 * lexical syntax of selectors changed: numbers are not longer allowed as the first char
 * in identifiers
 * the --> symbol (TFCT) did not longer work because of the -- comment
 * therfore the symbol substituted by -> (TDEPEND)
 *
 * Revision 1.8  1994/02/10  10:36:31  vdm
 * option -J for adding C++ default operations
 *
 * Revision 1.7  1993/11/21  20:03:50  vdm
 * Torsten Tews 1.Version eingemischt
 * Dabei interne Domain Gleichungen in C++ ausgeblendet
 * mit einem internen Implementierungsparameter INTERALDOMAIN
 *
 * Revision 1.6  1993/11/03  14:16:51  vdm
 * Hans-Martins Aenderungen eingemischt
 *
 * Revision 1.5.2.1  1993/11/20  17:20:28  vdm
 * 1.Version von Torsten Tews
 *
 * Revision 1.7  1993/10/29  21:21:42  hmh
 * Several corrections dealing with storage allocation:
 *
 * Revision 1.6  1993/10/24  21:58:09  hmh
 * Changes built in to handle the '-r' option used to check
 * if a given enrichment file can be used as starting point of
 * enrichment process.
 * Revision 1.5.2.1  1993/11/17  21:03:39  uvdm
 *
 * Aenderungen fuer automatische Speicherverwaltung eingebaut; der
 * eingelesene Parsebaum wird in domgen.c transformiert. Aenderungen sind mir
 * / * TT * / markiert. Auswahl der Transformation ueber neuen Kommandozeilen-
 * parameter -M
 *
 * Revision 1.5  1993/09/01  18:11:08  vdm
 * Hans-Martins Version vom 1.9.93 als neue Hauptversion
 *
 * - new procedure 'trace' for message output depending on 'domtrace'
 * - trace messages generated using 'trace*'.
 * Revision 1.4  1993/07/01  14:10:19  vdm
 * Uwes changes for C++ inserted
 * Naming conventions for selector names
 * "for" routine interfaces removed
 *
 * Revision 1.5  1993/07/25  08:50:53  hmh
 * Several changes
 *
 * Revision 1.4  1993/07/05  21:34:00  hmh
 * Merging Uwes changes into mine.
 *
 * Revision 1.4  1993/07/01  14:10:19  vdm
 * Uwes changes for C++ inserted
 * Naming conventions for selector names
 * "for" routine interfaces removed
 *
 * Revision 1.3  1993/05/28  11:03:24  hmh
 * Compiler extended to accept the ISO VDM-SL ASCII syntax. These
 * extensions are activated through the '-N' switch.
 *
 * New function 'tolower_str'

 * Revision 1.2  1993/05/22  14:22:17  hmh
 * Handling of filenames containing '.' (i.e. '../e.vdm') corrected.
 * For this, the function 'gen_file_name' was changed to scan
 * backwards for '.' and stop at '/'.
 *

  93/02/11: System-Includes (#include <...>) nach domfct.h
            'get_globalimpl_params': keine Beruecksichtigung,
            ob Parameter fuer Implementation erlaubt --> 
            generieren von 'GEN_ANSIC'

----------------------------------------------------------------------*/

#include "domadt.h"
#include "domfct.h"

/*----------------------------------------------------------------------*/
/* globale Variablen */

int           domtrace=0;      /* Wert von 0 bis 3, steuert Ausgabe der */
                                  /* Informationsmenge, bei der Bearbeitung */

Params        global_params;   /* globale Parameter (definiert bei */
                                  /* Aufruf des VDM-Generators) */

Rootvals      rootvalues;      /* Dateiliste zur Fehlerbehandlung */

Crossref      crossref;        /* Abbildung (Map) ADT auf Definition*/
                                  /* (Datei+Position) */

extern Str    curr_domid;      /* aktueller ADT beim Parsen */
                                  /* (definiert in domparse) */


/* VDM-Strings zur Verarbeitung von Parametern und Datenbank-Komponenten */

/* Konstruktoren */
Str PREDEF,
    USERDEF,
    ALLDEF,
    NUMERIC,
    ISA,
    TREE,
    TOKEN,
    TUPLE,
    UNION,
    MAP,
    SET,
    BAG,
    TOKUNI,
    OPTI,
    ALIAS,
    ISA,
    FCT,
    DEPND;

/* ADT-Parameter */
Str FCTNAME,
    RESULT,
    DOMAINNAME,
    ELEM0;

#ifdef OLDVDM
Str ELEM,
    ELEM1,
    ELEM2;
#endif

Str SEL,
    COMP,
    VAR,
    ENUM,
    CPP_PARAM;

/* Aufrufparameter */
Str CPP_NAME,
    CPP_NODEBUG,
    PARAM_[Paramtabsize];

/* Datenbank-Komponenten */
Str STDLIB,
    STDADT,
    SETUP,
    COM,
    BASIC,
    SIGN,
    PARAM,
    POST,
    ADTTYPE;

/* Datei-Endung fuer DSL-Spezifikationen */
Str VDM,
    ENR,
    PRE;

/* Parameter zur Suche nach Komponenten und Steuerung der Code-Erzeugung */
Str NOSTD,
    DEF,
    DUMMY,
    FORWARD_ALLOWED,
    CCOD,GEN_C,
    GCOD,
    MACROS,
    CMCR,
    GMCR,
    GSIG,
    GPTR,
    GTYP,
    GEN_PASCAL,
    CONSTS,
    PCST,
    GEN_MODULA,
    GCST,
    GEN_IMPORT,
    IMPORTS,
    GIMP,
    CPP,
    CPPCLASS,
    CPLUSPLUS,
    DECL,
    GEN_CPLUS,
    MEMBERS,
    OPERATOR,
    UPPER,
    INTERNALDOMAIN,
    BASEIMPL,
    AUTOMEM,
    DEFAULT;

Str VDMDOMAIN,
    CROUTINES,
    PTRTYPES,
    TYPES,
    SIGNATURE,
    SIGNATUREOP,
    SIGNATURESTRING,
    CMACROS;

Str GEN_ANSIC,
    RENAME,
    CONSTRUCTOR;

Str AUTOMEM_OK,
    AUTOMEM_NOT_ALLOWED; /* TT */

/* VDM-Strings zur Ausgabe-Aufbereitung */
Str NEWLINE,
    EMPTY;


/*----------------------------------------------------------------------*/

/* Modulname: mk_init_str; */

/* Aufgabe  : Initialisierung der VDM-Strings zur Verarbeitung von */
/*            Parametern und Datenbank-Komponenten */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
mk_init_str()
{
    int i;
    PREDEF=         mkc_str("PREDEF");
    USERDEF=        mkc_str("USERDEF");
    ALLDEF=         mkc_str("ALLDEF");
    NUMERIC=        mkc_str("numeric");
    ISA=            mkc_str("isa");
    TREE=           mkc_str("tree");
    TOKEN=          mkc_str("token");
    TUPLE=          mkc_str("tupl");
    UNION=          mkc_str("unio");
    MAP=            mkc_str("map");
    SET=		mkc_str("set");
    BAG=		mkc_str("bag");
    TOKUNI=         mkc_str("enum");
    OPTI=           mkc_str("opti");
    ALIAS=          mkc_str("alias");
    ISA=            mkc_str("isa");
    FCT=            mkc_str("fct");
    DEPND=          mkc_str("depend");
    
    FCTNAME=        mkc_str("FCTNAME");
    RESULT =        mkc_str("RESULT");
    DOMAINNAME=     mkc_str("DOMAIN");
    ELEM0=          mkc_str("ELEM0");
#ifdef OLDVDM
    ELEM=           mkc_str("ELEM");
    ELEM1=          mkc_str("ELEM1");
    ELEM2=          mkc_str("ELEM2");
#endif
    SEL=            mkc_str("SEL");
    COMP=           mkc_str("COMP");
    VAR=            mkc_str("VAR");
    ENUM=           mkc_str("ENUM");
    CPP_PARAM=      mkc_str("Cpp_");
    
    CPP_NAME=       mkc_str("cpp");     /* Praeprozessor-Name */
    CPP_NODEBUG=    mkc_str("-E0");
    
    for (i=0;
	 i<Paramtabsize;
	 i++)
	{
	    Char x[2];
	    x[0]=(Char)i;
	    x[1]=(Char)('\0');
	    PARAM_[i]=conc_str(mkc_str("-"),mkc_str(x));
	}

    STDLIB=         mkc_str("stdlib");
    STDADT=         mkc_str("Stdlib");
    SETUP=          mkc_str("setup");
    COM=            mkc_str("com");
    BASIC=          mkc_str("basic");
    SIGN=           mk_opt_implid(mkc_str("sign"));
    PARAM=          mkc_str("param");
    POST=           mkc_str("post");
    ADTTYPE=        mkc_str("adttype");

    VDM=            mkc_str("vdm");
    ENR=            mkc_str("enr");
    PRE=            mkc_str("pre");

    NOSTD=          mkc_str("NOSTD");
    DEF=            mkc_str("1");
    DUMMY=          mkc_str("DUMMY_DEFINE");
    FORWARD_ALLOWED=mkc_str("FORWARD_ALLOWED");
    CCOD=           mkc_str("ccod");
    GEN_C=          mkc_str("GEN_C");
    GCOD=           mkc_str("gcod");
    MACROS=         mkc_str("MACROS");
    CMCR=           mkc_str("cmcr");
    GMCR=           mkc_str("gmcr");
    GSIG=           mkc_str("gsig");
    GPTR=           mkc_str("gptr");
    GTYP=           mkc_str("gtyp");
    GEN_PASCAL=     mkc_str("GEN_PASCAL");
    CONSTS=         mkc_str("CONSTS");
    PCST=           mkc_str("pcst");
    GEN_MODULA=     mkc_str("GEN_MODULA");
    GCST=           mkc_str("gcst");
    GEN_IMPORT=     mkc_str("GEN_IMPORT");
    IMPORTS=        mkc_str("IMPORTS");
    GIMP=           mkc_str("gimp");
    CPP=            mkc_str("cpp");
    CPPCLASS=       mkc_str("cppclass");
    CPLUSPLUS=      mkc_str("CPLUSPLUS");
    DECL=           mkc_str("DECL");
    GEN_CPLUS=      mkc_str("GEN_CPLUS");
    MEMBERS=        mkc_str("MEMBERS");
    OPERATOR=       mkc_str("OPERATOR");
    UPPER=          mkc_str("UPPER");
    INTERNALDOMAIN= mkc_str(INTERNALDOMAINstr);
    BASEIMPL=       mkc_str("BASEIMPL");
    AUTOMEM=        mkc_str("automem");
    DEFAULT=        mkc_str("default");

    VDMDOMAIN=      mkc_str("VDMDOMAIN");
    CROUTINES=      mkc_str("CROUTINES");
    PTRTYPES=       mkc_str("PTRTYPES");
    TYPES=          mkc_str("TYPES");
    SIGNATURE=      mkc_str("SIGNATURE");
    SIGNATUREOP=    mkc_str("signature");
    SIGNATURESTRING=mkc_str("SIGNATURESTRING");
    CMACROS=        mkc_str("CMACROS");
    RENAME=         mkc_str("rename.");
    CONSTRUCTOR=    mkc_str("constructor.");
    GEN_ANSIC=      mkc_str("GEN_ANSIC");

    AUTOMEM_OK          = mkc_str("AUTOMEM");     /* TT */
    AUTOMEM_NOT_ALLOWED = mkc_str("NO_AUTOMEM");

    NEWLINE=        mkc_str("\n");
    EMPTY=          Empty;
}

/*----------------------------------------------------------------------*/

/* Modulname: del_init_str */

/* Aufgabe  : Loeschen der VDM-Strings zur Verarbeitung von */
/*            Parametern und Datenbank-Komponenten */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
del_init_str()
{
    register int i;
    del_str(PREDEF);
    del_str(USERDEF);
    del_str(ALLDEF);
    del_str(NUMERIC);
    del_str(ISA);
    del_str(TREE);
    del_str(TOKEN);
    del_str(TUPLE);
    del_str(UNION);
    del_str(MAP);
    del_str(TOKUNI);
    del_str(OPTI);
    del_str(ALIAS);
    del_str(ISA);
    del_str(FCT);
    del_str(DEPND);
    
    del_str(FCTNAME);
    del_str(RESULT);
    del_str(DOMAINNAME);
    del_str(ELEM0);
#ifdef OLDVDM
    del_str(ELEM);
    del_str(ELEM1);
    del_str(ELEM2);
#endif
    del_str(SEL);
    del_str(COMP);
    del_str(VAR);
    del_str(ENUM);
    del_str(CPP_PARAM);

    del_str(CPP_NAME);
    del_str(CPP_NODEBUG);
    for (i=0;
	 i<Paramtabsize;
	 i++)
	del_str(PARAM_[i]);

    del_str(STDLIB);
    del_str(STDADT);
    del_str(SETUP);
    del_str(COM);
    del_str(BASIC);
    del_str(SIGN);
    del_str(PARAM);
    del_str(POST);
    del_str(ADTTYPE);

    del_str(VDM);
    del_str(ENR);
    del_str(PRE);

    del_str(NOSTD);
    del_str(DEF);
    del_str(DUMMY);
    del_str(FORWARD_ALLOWED);
    del_str(CCOD);
    del_str(GEN_C);
    del_str(GCOD);
    del_str(MACROS);
    del_str(CMCR);
    del_str(GMCR);
    del_str(GSIG);
    del_str(GPTR);
    del_str(GTYP);
    del_str(GEN_PASCAL);
    del_str(CONSTS);
    del_str(PCST);
    del_str(GEN_MODULA);
    del_str(GCST);
    del_str(GEN_IMPORT);
    del_str(IMPORTS);
    del_str(GIMP);
    del_str(CPP);
    del_str(CPPCLASS);
    del_str(CPLUSPLUS);
    del_str(DECL);
    del_str(GEN_CPLUS);
    del_str(MEMBERS);
    del_str(OPERATOR);
    del_str(UPPER);
    del_str(INTERNALDOMAIN);
    del_str(BASEIMPL);
    del_str(AUTOMEM);
    del_str(DEFAULT);

    del_str(VDMDOMAIN);
    del_str(CROUTINES);
    del_str(PTRTYPES);
    del_str(TYPES);
    del_str(SIGNATURE);
    del_str(SIGNATUREOP);
    del_str(SIGNATURESTRING);
    del_str(CMACROS);
    del_str(RENAME);
    del_str(CONSTRUCTOR);
    del_str(GEN_ANSIC);

    del_str(AUTOMEM_OK);             /* TT */
    del_str(AUTOMEM_NOT_ALLOWED);

    del_str(NEWLINE);
    del_str(EMPTY);
}


/*----------------------------------------------------------------------*/

/* Modulname: tmpmalloc */

/* Aufgabe  : belegen von dynamischem Speicher */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Groesse des Speicherbereichs 'size' */

/* Ausgabe  : Zeiger auf Speicherbereich oder 'NULL' */

/*----------------------------------------------------------------------*/

void *
tmpmalloc F1(
	     Nat0, size)
{
    void *mem;

    if ((mem=(void *)malloc(size))==NULL)
	error(mkc_str("Not enough memory"));
    return mem;
}

/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/

/* Modulname: printstr */

/* Aufgabe  : Ausgabe von VDM-Strings */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : VDM-Strings 's1', 's2', 's3' */

/* Ausgabe  : 's1' und 's2', zusaetzlich 's3' in "'" ,  wenn nicht leer */

/*----------------------------------------------------------------------*/

void
printstr F3(
	    Str, s1,              /* Ausgabe-String */
	    Str, s2,              /* Ausgabe-String */
	    Str, s3)              /* Ausgabe-String */
{
    Str ostr=conc_str(s1,s2);

    if (NOT is_empty_str(s3))    /* 's3' ist nicht leer */
	ostr=conc_str(ostr,mk_quot(s3));

    puts_str(ostr,stderr);
    del_str(ostr);
}


/*----------------------------------------------------------------------*/

/* Modulname: message */

/* Aufgabe  : Ausgabe einer Meldung */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : VDM-String der Meldung 'msgstr' */
/*            VDM-String des Wertes, auf den sich die Meldung bezieht 's' */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
message F2(
	   Str, msgstr,            /* Text der Meldung */
	   Str, s)                 /* Wert auf den sich die Meldung bezieht */
{
    printstr(Empty,msgstr,s);  /* Ausgabe der Meldung */
    puts_str(NEWLINE,stderr);  /* Zeilenvorschunb */
    fflush(stderr);
}

void
trace F3(
	 Str, msgstr,            /* Text der Meldung */
	 Str, s,                 /* Wert auf den sich die Meldung bezieht */
	 int, lev)
{
    if (domtrace >= lev)
	{
	    message(msgstr,s);
	}
}

/*----------------------------------------------------------------------*/

/* Modulname: warning */

/* Aufgabe  : Ausgabe einer Warnung */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : VDM-String der Warnung 'wrnstr' */
/*            VDM-String des Wertes, auf den sich die Warnung bezieht 's' */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
warning F2(
	   Str, wrnstr,       /* VDM-String der Warnung */
	   Str, s)            /* Wert, auf den sich die Warnung bezieht */
{
    printstr(mkc_str("warning :  "),wrnstr,s);  /* Ausgabe der Meldung */
    puts_str(NEWLINE,stderr);                   /* Zeilenvorschub */
}


/*----------------------------------------------------------------------*/

/* Modulname: error */

/* Aufgabe  : Ausgabe einer Fehlermeldung */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : VDM-String der Fehlermeldung 'errstr' */
/*            VDM-String des Wertes, auf den sich die Meldung bezieht 's' */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
error F2(
	 Str, errstr,         /* VDM-String der Fehlermeldung */
	 Str, s)              /* Wert, auf den sich die Meldung bezieht */
{
    printstr(mkc_str("error :  "),errstr,s);  /* Ausgabe der Meldung */
    puts_str(NEWLINE,stderr);                 /* Zeilenvorschub */
    fflush(stderr);
    yyexitcode=TRUE;                   /* bei Auftreten eines Fehlers, wird */
                                       /* der Fehlercode gesezt */
}


/*----------------------------------------------------------------------*/

/* Modulname: errorfile */

/* Aufgabe  : Ausgabe des Dateinamens, in dem ein vorgegebener ADT */
/*            definiert ist als Angabe der Fehlerstelle */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : ADT-Name 's' */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
errorfile F1(
	     Str,s)  /* ADT-Name */
{
    Str rn=get_root_name(s);  /* Eintrag aus 'rootvalues' (Definitions-Stelle) */

    rn=sub_tupd_str(rn,1,index_str(rn,' ')-1); /* keine Angabe der Zeilennummer */

    error(mkc_str("file "),rn);  /* Ausgabe der Fehlermeldung */
}


/*----------------------------------------------------------------------*/

/* Modulname: gen_str */

/* Aufgabe  : Erzeugen eines VDM-Strings aus Str und Nat0 */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : VDM-String 's' */
/*            ganze Zahl (Nat0), die an 's' angehaengt wird 'i' */

/* Ausgabe  : VDM-String, enthaelt 's' und 'i' als String */

/*----------------------------------------------------------------------*/

Str
gen_str F2(
	   Str, s,              /* VDM-String */
	   Nat0, i)             /* Zahl, wird an VDM-String angehaengt */
{
    return conc_str(copy_str(s),
		    cvstr_nat0(i));
}

/*----------------------------------------------------------------------*/

Str
gen_quote_str F1(Str,s)
{ 
    return conc3_str(mkc_str("\""),
		     s,
		     mkc_str("\""));
}

Str
gen_quote2_str F1(
		  Str, p )
{
    Nat1 i;

    for (i = len_str(p);
	 i >= 1;
	 i--)
     {
	 if (sel_str(p,i) == '\"')
	     {
		 p = insert_str(p,i,'\\');
	     }
     }

    return gen_quote_str(p);
}

/*----------------------------------------------------------------------*/

/* Modulname: gen_file_name */

/* Aufgabe  : Erzeugen eines Dateinamens aus Basisnamen und Endung */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Basisname 'file_name' (VDM-String) */
/*            Endung 'ext' (VDM-String) */

/* Ausgabe  : Dateiname als VDM-String */

/*----------------------------------------------------------------------*/

Str
gen_file_name F2(
		 Str, file_name,         /* Basisname */
		 Str, ext)               /* Endung */
{
    Nat0 ei=rindex_str(file_name,'.');
    Nat0 si=rindex_str(file_name,'/');

    if (ei > si)
	{
	    return
		conc_str(mk_sub_tup_str(file_name,1,ei),
			 copy_str(ext));
	}
    else
	{
	    /* no extension found ==> append desired extension. */
	    return
		conc3_str(copy_str(file_name),
			  mkc_str("."),
			  copy_str(ext));
	}
}


/*----------------------------------------------------------------------*/

/* Modulname: exists_file */

/* Aufgabe  : Ueberpruefung ob eine angegebene Datei existiert */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Dateiname 'file_name' */

/* Ausgabe  : Datei existiert Ja/Nein (Bool: Ja=TRUE, Nein=FALSE) */

/*----------------------------------------------------------------------*/

Bool
exists_file F1(
	       Str, file_name)      /* Dateiname */
{
    /* Rueckgabewert der Funktion, gibt an, ob die Datei existiert */
    Bool exists=FALSE;

    /* Speicheranforderung zur Umwandlung des vdm-strings 'file_name' in einen */
    /* C-String (char *) */
    char *c_file_name=(char *)tmpmalloc(len_str(file_name)+1);

    /* genug Speicher vorhanden */
    if (c_file_name != NULL)
	{
	    /* Umwandlung des vdm_strings in einen C-string */
	    cpc_str(file_name,c_file_name);
	    LET exists =
		IF NOT access(c_file_name,4)
		THEN TRUE
		ELSE FALSE IN
		free(c_file_name);
	}
    return exists;
}


/*----------------------------------------------------------------------*/

/* Modulname: open_file */

/* Aufgabe  : Oeffnen einer angegebenen Datei */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Dateiname 'file_name' */
/*            Modus, in dem die Datei geoeffnet werden soll */
/*            (=mode Parameter der C-Funktion 'fopen') 'mode' */

/* Ausgabe  : Zeiger auf 'C-stream' der Datei */

/*----------------------------------------------------------------------*/

FILE *
open_file F2(
	     Str, file_name,            /* Dateiname */
	     char*, mode)               /* Oeffnungs-Modus */
{
    /* Speicheranforderung zur Umwandlung des vdm-strings 'file_name' in einen */
    /* C-string (char *) */
    char *c_file_name=(char *)tmpmalloc(len_str(file_name)+1);

    /* 'Datei-Zeiger' definiert in <stdio.h> */
    FILE *file_pointer=NULL;

    /* genug Speicher vorhanden */
    if (c_file_name != NULL)
	{
	    /* Umwandlung des vdm-strings in einen C-string */
	    cpc_str(file_name,c_file_name);

	    file_pointer=fopen(c_file_name,mode);
	    if (file_pointer==NULL)
		error(mkc_str("Can't open "),copy_str(file_name));
	    free(c_file_name);
	}

    return file_pointer;
}


/*----------------------------------------------------------------------*/

/* Modulname: close_file */

/* Aufgabe  : Schliessen einer Datei */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Zeiger auf 'C-stream' der Datei (FILE*) 'file_pointer' */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
close_file F1(
	      FILE *, file_pointer)
{
    fclose(file_pointer);
}


/*----------------------------------------------------------------------*/

/* Modulname: remove_file */

/* Aufgabe  : Loeschen einer Datei */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Dateiname 'file_name' */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
remove_file F1(
	       Str, file_name)
{
    /* Speicheranforderung zur Umwandlung des vdm-strings 'file_name' in einen */
    /* C-string (char *) */
    char *c_file_name=(char *)tmpmalloc(len_str(file_name)+1);

    /* genug Speicher vorhanden */
    if (c_file_name != NULL)
	{
	    /* Umwandlung des VDM-strings in einen C-string */
	    cpc_str(file_name,c_file_name);
	    if (unlink(c_file_name))
		error(mkc_str("Can't remove "),copy_str(file_name));
	    free(c_file_name);
	}
}


/*----------------------------------------------------------------------*/

/* Modulname: create_tmpfile */

/* Aufgabe  : Erzeugen einer Datei mit noch nicht vorhandenem Dateinamen */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : */

/* Ausgabe  : Dateiname */

/*----------------------------------------------------------------------*/

Str
create_tmpfile F0()
{
    /* Angabe, ob ein Dateiname gefunden wurde */
    Bool found=FALSE;

    /* 'Datei-Zeiger' definiert in <stdio.h> */
    FILE *file_pointer;

    /* Zaehler fuer Dateinamen */
    static Nat0 file_count=0;

    /* Dateiname der erzeugten Datei (vdm-string) (Rueckgabewert der Funktion) */
    Str file_name;

    /* Dateiname der zu erzeugenden temporaeren Datei */
    char *c_file_name=(char *)tmpmalloc(Filenamelen+1);

    if (domtrace<3)
	file_count=0;

    if (c_file_name!=NULL)
	{
	    while ((file_count <= 32767) AND (NOT found))
		{
		    if (domtrace > 2)
			{
			    sprintf(c_file_name,
				    "vdm%d-%d.%s",
				    (int)getpid(),
				    (int)(file_count++),
				    "tmp");
			}
		    else
			{
			    sprintf(c_file_name,
				    "/tmp/vdm%d-%d",
				    (int)getpid(),
				    (int)(file_count++));
			}

		    file_name=mkc_str(c_file_name);

		    /* Die Datei existiert noch nicht */
		    if (NOT exists_file(file_name))
			{
			    file_pointer=open_file(file_name,"w");

			    /* Die Datei konnte angelegt werden */
			    if (file_pointer!=NULL)
				{
				    close_file(file_pointer);
				    found=TRUE;
				}
			}
		}
	    free(c_file_name);
	}

    /* keine Datei angelegt */
    if (NOT found)
	error(mkc_str("Can't create tmpfile"),Empty);
    else
	/* Datei angelegt */
	trace2(mkc_str("creating tmpfile "),copy_str(file_name));

    return 
	IF found 
	THEN file_name
	ELSE Empty;
}

/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/

/* Modulname: mk_empty_domain */

/* Aufgabe  : Erzeugen einer 'leeren' Domain-Gleichung */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : */

/* Ausgabe  : Domain-Gleichung */

/*----------------------------------------------------------------------*/

Domain mk_empty_domain()
{
 return mk_domain(copy_str(PREDEF),mk_empty_elems(),mk_empty_depend());
}


/*----------------------------------------------------------------------*/

/* Modulname: mk_empty_implementation */

/* Aufgabe  : Erzeugen einer 'leeren' Implementations-Beschreibung */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : */

/* Ausgabe  : Implementations-Beschreibung */

/*----------------------------------------------------------------------*/

Implementation
mk_empty_implementation(void)
{
    return 
	mk_implementation(mk_nil_implid(),
			  mk_empty_params(),
			  mk_empty_operations());
}


/*----------------------------------------------------------------------*/

/* Modulname: merge_params */

/* Aufgabe  : Zusammenfassen der Parameter einer Operation */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parameter 'p1' */
/*            Parameter 'p2' */

/* Ausgabe  : Summe der Parameter */

/*----------------------------------------------------------------------*/

/* Params merge_params(Params p1, Params p2) */
/* Foldfunktion, definiert in domadt */


/*----------------------------------------------------------------------*/

/* Modulname: merge1_params */

/* Aufgabe  : Ergaenzen der Parameter einer Operation um einen Parameter */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parameter 'p1' der Operation */
/*            Zusaetzlicher Parameter, bestehend aus: */
/*            Parameter-Name 'pn2' und Parameter-Wert 'pv2' */

/* Ausgabe  : Ergaenzte Abbildung der Parameter 'p1' */

/*----------------------------------------------------------------------*/

Params
merge1_params F3(
		 Params, p1,                             /* Parameter */
		 Str, pn2,                               /* Parameter-Name */
		 Str, pv2)                               /* Parameter-Wert */
{
    /* Wert des Parameters p1 */
    Str pv1;

    /* der Paramtername pn2 ist nicht in den Paramtern p1 enthalten */
    if (NOT(is_in_dom_params(pn2,p1,&pv1)))
	p1=union1d_params(p1,pn2,pv2);
    else
	{
	    /* p1 enthaelt Paramtername pn2 -> Test auf gleichen Parameterwert */
	    if (NOT(is_eq_str(pv1,pv2)))
		{
		    yyerror("semantic error");
		    message(mkc_str(" Inconsistent parameter for domain "),copy_str(curr_domid));
		    message(mkc_str(" parametername is "),copy_str(pn2));
		    message(mkc_str(" Domain is first defined in  "),get_root_name(curr_domid));
		}
	    del_str(pn2);
	    del_str(pv2);
	}
    return p1;
}


/*----------------------------------------------------------------------*/

/* Modulname: merge_operations */

/* Aufgabe  : Zusammenfassen der Operationen eines ADT */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Operationen 'o1' */
/*            Operationen 'o2' */

/* Ausgabe  : Summe der Operationen */

/*----------------------------------------------------------------------*/

/* Operations merge_operations(Operations o1, Operations o2) */
/* Foldfunktion, definiert in domadt */


/*----------------------------------------------------------------------*/

/* Modulname: merge1_operations */

/* Aufgabe  : Ergaenzen der Operationen eines ADT um eine Operation */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Operationen des ADT 'o1' */
/*            Zusaetzliche Operation, bestehend aus: */
/*            Operationsname 'on2' und Parametern der Operation 'ov2' */

/* Ausgabe  : Ergaenzte Operationen des ADT */

/*----------------------------------------------------------------------*/

Operations 
merge1_operations F3(
		     Operations, o1,                         /* Operation */
		     Str, on2,                               /* Operation-Name */
		     Params, ov2)                            /* Operation-Wert (=Parameter) */
{
    /* Fuer die Operation o1 definierte Parameter */
    Params ov1;

    return
	IF NOT(is_in_dom_operations(on2,o1,&ov1)) 
	THEN
	union1d_operations(o1,on2,ov2)
        ELSE
	ovwrt1d_operations(o1,on2,merge_params(copy_params(ov1),ov2));
}


/*----------------------------------------------------------------------*/

/* Modulname: merge_dominfo */

/* Aufgabe  : Zusammenfassen zweier Parse-Baeume zu einem */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parse-Baum 'd1' */
/*            Parse-Baum 'd2' */

/* Ausgabe  : Parse-Baum mit Informationen aus 'd1' und 'd2' */

/*----------------------------------------------------------------------*/

/* Dominfo merge_dominfo(Dominfo d1, Dominfo d2) */
/* Foldfunktion, definiert in domadt */


/*----------------------------------------------------------------------*/

/* Modulname: merge1_dominfo */

/* Aufgabe  : Ergaenzen der Informationen eines Parse-Baum um einen ADT */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parse-Baum 'd1' */
/*            Name des ADT 'dn2' */
/*            Beschreibung des ADT 'desc2' */

/* Ausgabe  : Ergaenzter Parse-Baum */

/*----------------------------------------------------------------------*/

Elems
merge_union F3(
	       Elems,	e1,
	       Elems,	e2,
	       Str,	domainname)
{
    Nat0 i,l;

    for (i = 1, l = len_elems(e2);
	 i < l;
	 i+=2 )
	{
	    Str sel,cmp,sel1,cmp1;
	    Nat0 ix;

	    sel = sel_elems(e2,i);
	    cmp = sel_elems(e2,i+1);
	    ix = index_elems(e1,sel);
	    if (ix != 0)
		{
		    sel1 = sel_elems(e1,ix);
		    cmp1 = sel_elems(e1,ix+1);
		    if (NOT (is_eq_str(sel,sel1)
			     AND is_eq_str(cmp,cmp1)))
			{
			    ix = 0;
			    if (is_eq_str(sel,sel1))
				{
				    yyerror("semantic error: merging union domains");
				    message(mkc_str("equal selectors "),copy_str(sel));
				    message(mkc_str("but different types "),copy_str(cmp));
				    message(mkc_str("and "),copy_str(cmp1));
				    message(mkc_str("for domain "),copy_str(domainname));
				}
			}
		}

	    if (ix == 0)
		{
		    e1 = appr_elems(e1,copy_str(sel));
		    e1 = appr_elems(e1,copy_str(cmp));
		}
	}

    return e1;
}

/*----------------------------------------------------------------------*/

Dominfo
merge1_dominfo F3(
		  Dominfo,	d1,                  /* Parse-Baum */
		  Str,		dn2,                   /* ADT-Name */
		  Description,	desc2)         /* ADT-Beschreibung */
{
    /* Beschreibung des ADT's 'dn2' im Parse-Baum 'd1' */
    Description desc1;

    /* 'dn2' ist nicht im Parse-Baum 'd1' enthalten */
    if (NOT(is_in_dom_dominfo(dn2,d1,&desc1)))
	{
	    d1=union1d_dominfo(d1,dn2,desc2);
	    trace2(mkc_str("merging dominfo :  "),copy_str(dn2));
	}
    /* 'dn2' ist im Parse-Baum 'd1' enthalten */
    else
	{
	    /* Elemente der Beschreibungen des ADT's 'dn2' in 'desc1' und 'desc2' */
	    Domain domain1,domain2;
	    Implementation implem1,implem2;
	    Str constr1,constr2;
	    Elems elems1,elems2;
	    Depend depend1,depend2;
	    Implid implid1,implid2;
	    Params params1,params2;
	    Operations operations1,operations2;

	    /* Zerlegung der Beschreibungen des ADT's in ihre Bestandteile */
	    domain1=s_domain(desc1), domain2=s_domain(desc2);
	    implem1=s_implem(desc1), implem2=s_implem(desc2);
	    constr1=s_constr(domain1) ,constr2=s_constr(domain2);
	    elems1=s_elems(domain1) ,elems2=s_elems(domain2);
	    depend1=s_depend(domain1) ,depend2=s_depend(domain2);
	    implid1=s_implid(implem1) ,implid2=s_implid(implem2);
	    params1=s_iparams(implem1) ,params2=s_iparams(implem2);
	    operations1=s_operations(implem1) ,operations2=s_operations(implem2);

	    /* Es ist keine Definition fuer den Konstruktor des ADT im Parse_Baum */
	    /* gegeben */
	    if (is_eq_str(constr1,PREDEF))
		{
		    /* Die Definition fuer Konstruktor und Elemente wird aus 'desc2' */
		    /* entnommen */
		    constr1=constr2;
		    elems1=elems2;
		}
	    /* Es ist eine Definition des Konstruktors fuer den ADT gegeben */
	    else
		/* Der Kunstruktor des ADT ist in 'desc2' definiert */
		if (NOT(is_eq_str(constr2,PREDEF)))
		    
		    if (is_eq_str(constr1,UNION) AND is_eq_str(constr2,UNION)) {
			elems1=merge_union(elems1,elems2,dn2);
		    }
		    else
			/* Die Definitionen (Konstruktor oder Elemente) im Parse-Baum */
			/* und in 'desc2' sind verschieden */
			if(NOT((is_eq_str(constr1,constr2)) AND (is_eq_elems(elems1,elems2))))
			    {
				yyerror("semantic error");
				message(mkc_str(" Duplicate definition for "),copy_str(dn2));
				message(mkc_str(" Domain is first defined in  "),get_root_name(dn2));
			    }

	    /* Es ist keine Implementation des ADT im Parse-Baum vorhanden */
	    if (is_nil_implid(implid1))
		/* Die Implementation des ADT wird aus 'desc2' entnommen */
		implid1=implid2;
	    /* Eine Implementation des ADT ist vorhanden */
	    else
		/* Die Implementation in 'desc2' unterscheidet sich von der im */
		/* im Parse-Baum gegebenen */
		if ((NOT is_nil_implid(implid2))
		    AND (NOT(is_eq_implid(implid1,implid2))))
		    {
			yyerror("semantic error");
			message(mkc_str(" Duplicate implementation for "),copy_str(dn2));
			message(mkc_str(" Domain is first defined in  "),get_root_name(dn2));
		    }

	    if (NOT yyexitcode)
		{
		    /* 'curr_domid' enthaelt den Namen des bearbeiteten ADT's, */
		    /* die Variable wird bei einer Fehlermeldung innerhalb der Funktion */
		    /* 'merge1_params' ausgegeben. Bei Aufruf von 'merge1_dominfo', */
		    /* 'merge1_operations' oder 'merge1_params' aus dem Parser wird */
		    /* 'curr_domid' dort entsprechend gesetzt. */
		    /* Bei Aufruf von 'merge1_dominfo' aus 'domgen' (Zusammenfuegen der */
		    /* Parse-Baeume mehrerer Dateien, ist 'curr_domid' nicht definiert, */
		    /* deshalb wird die Variable hier mit dem Namen des gerade */
		    /* bearbeiteten ADT's belegt */
		    curr_domid=dn2;

		    /* Gesammtmenge der Abhaengigkeiten des ADT von anderen ADT's */
		    depend1=uniond_depend(copy_depend(depend1),
					  copy_depend(depend2));

		    /* Menge der Paramter */
		    params1=merge_params(copy_params(params1),
					 copy_params(params2));

		    /* in 'desc2' sind Operationen fuer den ADT definiert */
		    operations1=merge_operations(copy_operations(operations1),
						 copy_operations(operations2));

		    /* Zusammensetzen der einzelnen Komponenten */
		    domain1=mk_domain(copy_str(constr1),
				      copy_elems(elems1),
				      depend1);
		    implem1=mk_implementation(copy_implid(implid1),
					      params1,
					      operations1);
		    desc1=mk_description(domain1,implem1);

		    /* Ersetzen der Beschreibung des ADT im Parse-Baum durch die neue, */
		    /* erweiterte Beschreibung */
		    d1=ovwrt1d_dominfo(d1,
				       copy_str(dn2),
				       desc1);
		}

	    del_str(dn2);
	    del_description(desc2);
	}
    return d1;
}


/*----------------------------------------------------------------------*/

/* Modulname: diff_dominfo */

/* Aufgabe  : Berechnen der Differenz zweier Parse-Baeume */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parse-Baum 'd1' */
/*            Parse-Baum 'd2' */

/* Ausgabe  : Um Elemente aus 'd2' reduzierter Parse-Baum 'd1' */

/*----------------------------------------------------------------------*/

/* Dominfo diff_dominfo(Dominfo d1, Dominfo d2) */
/* Foldfunktion, definiert in domadt */


/*----------------------------------------------------------------------*/

/* Modulname: diff1_dominfo */

/* Aufgabe  : Entfernen der Elemente der Beschreibung eines ADT aus einem */
/*            Parse-Baum */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parse-Baum 'd1' */
/*            Name des ADT 'dn2' */
/*            Beschreibung des ADT 'desc2' */

/* Ausgabe  : Reduzierter Parse-Baum 'd1' */

/*----------------------------------------------------------------------*/

Dominfo
diff1_dominfo F3(
		 Dominfo, d1,                 /* Parse-Baum */
		 Str, dn2,                    /* ADT-Name */
		 Description, desc2)          /* ADT-Beschreibung */
{
    Description desc1;
    
    if (is_in_dom_dominfo(dn2,d1,&desc1))
	if ((NOT is_eq_str(s_constr(s_domain(desc2)),PREDEF))
	    AND (NOT is_nil_implid(s_implid(s_implem(desc2)))))
	    {
		/* Elemente der Beschreibungen des ADT's 'dn2' in 'desc1' und 'desc2' */
		Implementation implem1;
		Operations operations1, operations2;

		implem1=s_implem(desc1);

		/* Auswahl der Operationen der ADT's */
		operations1=s_operations(implem1);
		operations2=s_operations(s_implem(desc2));

		/* entfernen der in 'desc2' definierten Operationen aus 'd1' */
		operations1=subd_operations(copy_operations(operations1),operations2);

		/* Zusammensetzten der einzelnen Komponenten */
		implem1=mk_implementation(copy_implid(s_implid(implem1)),
					  copy_params(s_iparams(implem1)),
					  (operations1));

		/* ersetzen der alten Operationen des ADT durch die neue Differenz */
		if (NOT is_empty_operations(operations1))
		    d1=ovwrt1d_dominfo(d1,
				       copy_str(dn2),
				       mk_description(copy_domain(s_domain(desc1)),
						      implem1));
		else
		    {
			del_implementation(implem1);
			d1=sub1d_dominfo(d1,dn2);
		    }
	    }

    del_str(dn2);
    del_description(desc2);
    
    return d1;
}


/*----------------------------------------------------------------------*/

/* Modulname: del_predef_dominfo */

/* Aufgabe  : Entfernen aller ADT's aus einem Parse-Baum, die mit 'PREDEF' */
/*            definiert sind oder keine Implementations-Beschreibung haben */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parse-Baum 'd1' */
/*            Parse-Baum 'd2' (='d1') */

/* Ausgabe  : Reduzierter Parse-Baum */

/*----------------------------------------------------------------------*/

/* Dominfo del_predef_dominfo(Dominfo d1, Dominfo d2) */
/* Foldfunktion, definiert in domadt */


/*----------------------------------------------------------------------*/

/* Modulname: del_predef1_dominfo */

/* Aufgabe  : Entfernen der Beschreibung eines ADT aus einem Parse-Baum, */
/*            wenn der ADT mit 'PREDEF' definiert ist oder keine */
/*            Implementations-Beschreibung hat */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parse-Baum 'd1' */
/*            ADT-Name 'dn2' */
/*            ADT-Beschreibung 'desc2' */

/* Ausgabe  : Reduzierter Parse-Baum */

/*----------------------------------------------------------------------*/

Dominfo 
del_predef1_dominfo F3(
		       Dominfo, d1,            /* Parse-Baum */
		       Str, dn2,               /* ADT-Name */
		       Description, desc2)     /* ADT-Beschreibung */
{
    if ((is_eq_str(s_constr(s_domain(desc2)),PREDEF))
	OR (is_nil_implid(s_implid(s_implem(desc2)))))
	d1=sub1d_dominfo(d1,dn2);

    del_str(dn2);
    del_description(desc2);
    return d1;
}


/*----------------------------------------------------------------------*/

/* Modulname: update_alias_operations */

/* Aufgabe  : Voranstellen von 'rename.' vor die Operationsnamen der */
/*            Operationen eines ADT mit Alias-Konstruktor */

/* Eingabe  : Menge aller Operationen des ADT 'o1' */
/*            Operationen 'o2' (='o1') */

/* Ausgabe  : Menge der aktualisierten Operationen 'o1' */

/* Operations update_alias_operations(Operations o1, Operations o2) */
/* Foldfunktion, definiert in domadt */


/*----------------------------------------------------------------------*/

/* Modulname: update_alias_operations1 */

/* Aufgabe  : Voranstellen von 'rename.' vor den Operationsnamen einer */
/*            Operation eines ADT mit Alias-Konstruktor */

/* Eingabe  : Menge aller Operationen des ADT 'o1' */
/*            Name der aktuell bearbeiteten Operation 'on2' */
/*            Parameter der aktuell bearbeiteten Operation 'ov2' */

/* Ausgabe  : Menge mit aktualisierter Operation 'on2' */

/*----------------------------------------------------------------------*/

Operations 
update_alias1_operations F3(
			    Operations, o1,               /* Operationen */
			    Str, on2,                     /* Name einer Operation */
			    Params, ov2)                  /* Parameter der Operation */
{
    if (NOT index_str(on2,'.'))
	{
	    Str on1;
	    Params ov1;

	    o1=sub1d_operations(o1,on2);
	    ov1=merge1_params(copy_params(ov2),
			      copy_str(FCTNAME),
			      copy_str(on2));
	    on1=conc_str(copy_str(RENAME),
			 copy_str(on2));
	    o1=merge1_operations(o1,on1,ov1);
	}

    del_str(on2);
    del_params(ov2);

    return o1;
}


/*----------------------------------------------------------------------*/

/* Modulname: update_alias1_dominfo */

/* Aufgabe  : Aktualisierung vom Implementationen und Operationen */
/*            eines ADT mit Alias-Konstruktor */

/* Eingabe  : Parse-Baum           'd1'    */
/*            Name des ADT         'dn2'   */
/*            Beschreibung des ADT 'desc2' */

/* Ausgabe  : Aktualiesierter Parse-Baum 'd1' */

/*----------------------------------------------------------------------*/

extern                             /* Foldfunktion, definiert in domadt */
Dominfo
update_alias_dominfo H2(Dominfo, Dominfo);


Dominfo
update_alias1_dominfo F3(
			 Dominfo, d1,
			 Str, dn2,
			 Description, desc2)
{
    if ( is_eq_str(s_constr(s_domain(desc2)),ALIAS)
	 OR is_eq_str(s_constr(s_domain(desc2)),ISA) )
	{
	    Description desc1;
	    Domain domain1;
	    Implementation implem1;
	    Str constr1;
	    Elems elems1;
	    Depend depend1;
	    Implid implid1;
	    Params params1;
	    Operations op1;

	    if (is_nil_implid(s_implid(s_implem(desc2))))
		d1=merge1_dominfo(d1,
				  copy_str(dn2),
				  mk_description(mk_domain(copy_str(PREDEF),
							   mk_empty_elems(),
							   mk_empty_depend()),
						 mk_implementation(mk_opt_implid(copy_str(COM)),
								   mk_empty_params(),
								   mk_empty_operations())));
	    desc1=sel_dominfo(d1,dn2);
	    domain1=s_domain(desc1);
	    implem1=s_implem(desc1);
	    constr1=s_constr(domain1);
	    elems1=s_elems(domain1);
	    depend1=s_depend(domain1);
	    implid1=s_implid(implem1);
	    params1=s_iparams(implem1);
	    op1=s_operations(implem1);
	    op1=update_alias_operations(copy_operations(op1),
					copy_operations(op1));
	    domain1=mk_domain(copy_str(constr1),
			      copy_elems(elems1),
			      copy_depend(depend1));
	    implem1=mk_implementation(copy_implid(implid1),
				      copy_params(params1),
				      op1);
	    desc1=mk_description(domain1,implem1);
	    d1=ovwrt1d_dominfo(d1,copy_str(dn2),desc1);
	}
    del_str(dn2);del_description(desc2);
    return d1;
}

/*----------------------------------------------------------------------*/

/* Modulname: add_constructor1_for_isa_dominfo */

/* Aufgabe  : Umsetzen einer Signatur in eine signature-Operation */

/* Parameter: Funktionsname  fn
              Parametertypen pl
              Resultattypen  rl
              Funktionsart   fc
*/

/*----------------------------------------------------------------------*/

extern                                                 /* fold function */
Operations
select_constructors_operations H2(Operations,Operations);

Operations
select_constructor1_operations F3(Operations, ops,
				  Str,        op,
				  Params,     params)
{
    if ( is_prefix_str(CONSTRUCTOR,op) )
	{
	    ops = ovwrt1d_operations(ops,copy_str(op),copy_params(params));
	}

    return ops;
}

extern                                                 /* fold function */
Dominfo
add_constructors_for_isa_dominfo H2(Dominfo,Dominfo);

Bool
sel_non_isa_constr_dominfo F3(Str,dn,
			      Dominfo,di,
			      Description *, descr)
{
    Bool found = is_in_dom_dominfo(dn,di,descr);
    if ( found )
	{
	    Domain d
		= s_domain((*descr));
	    Str d_constr
		= s_constr(d);

	    if ( is_eq_str(d_constr,ISA) )
		{
		    return sel_non_isa_constr_dominfo(hd_elems(s_elems(d)),
						      di,
						      descr);
		}
	}

    return found;
}

Dominfo
add_constructor1_for_isa_dominfo F3(
				    Dominfo, d1,
				    Str, dn2,
				    Description, desc2)
{
    Domain d2_domain = s_domain(desc2);
    Str    d2_constr = s_constr(d2_domain);

    if ( is_eq_str(d2_constr,ISA) )
	{
	    /* copy all constructor.* operations from ELEM1 to DOMAIN */

	    /* compute name and description of ELEM1 domain */
	    Str elem1_domain_name
		= hd_elems(s_elems(d2_domain));

	    Description elem1_domain_descr;

	    if ( sel_non_isa_constr_dominfo(elem1_domain_name,d1,&elem1_domain_descr) )
		{
		    Operations elem1_domain_operations
			= s_operations(s_implem(elem1_domain_descr));

		    Operations elem1_constructors
			= select_constructors_operations(mk_empty_operations(),
							 elem1_domain_operations);

		    Implementation add_constr_impl
			= mk_implementation(mk_nil_implid(),
					    mk_empty_params(),
					    elem1_constructors);

		    Description add_constr_descr
			= mk_description(copy_domain(d2_domain),
					 add_constr_impl);

		    d1 = merge1_dominfo(d1,copy_str(dn2),add_constr_descr);
		}
	}

    del_str(dn2);
    del_description(desc2);

    return d1;
}

/*----------------------------------------------------------------------*/

/* Modulname: mk_sig_dominfo_str */

/* Aufgabe  : Umsetzen einer Signatur in eine signature-Operation */

/* Parameter: Funktionsname  fn
              Parametertypen pl
              Resultattypen  rl
              Funktionsart   fc
*/

/*----------------------------------------------------------------------*/

Str
concat_str F2(Elems,strl,
	      Str,del)
{
    Str res;
    res = mk_empty_str();

    if ( ! is_empty_elems(strl) )
	res = conc_str(res,copy_str(hd_elems(strl)));

    {
        Nat0 i,l;

        for (i = 2, l = len_elems(strl);
             i <= l;
             i++ )
            {
                res = conc_str(res,copy_str(del));
                res = conc_str(res,copy_str(sel_elems(strl,i)));
            } 
    }

    del_str(del);

    return res;
}

Str 
mk_sig_option_str F4(Str,fn,
		     Elems,pl,
		     Elems,rl,
		     Str,fc) {
    Str pl1,rl1,res;

    pl1 = concat_str(pl,mkc_str(" x "));
    rl1 = concat_str(rl,mkc_str(" x "));
  
    res = conc_str(copy_str(fn),mkc_str(" : "));
    res = conc_str(res,pl1);
    res = conc_str(res,mkc_str(" "));
    res = conc_str(res,copy_str(fc));
    res = conc_str(res,mkc_str(" "));
    res = conc_str(res,rl1);

    return res;
}

/*----------------------------------------------------------------------*/

Dominfo
mk_sig_dominfo_str F4(Str,fn,
		      Elems,pl,
		      Elems,rl,
		      Str,fc)
{
    Str    domname;
    Str    opname;
    Params ps;

    domname = copy_str(hd_elems(pl));
    
    opname = conc_str(copy_str(SIGNATUREOP),mkc_str("."));
    opname = conc_str(opname,copy_str(fn));

					/* to extend these limits */
					/* modifiy com.sign.signature.gsig and cpp */
					/* and     com.com.signature.param and docu */
    if (len_elems(pl) > 10)
	{
	    yyerror("semantic error");
	    message(mkc_str(" to many parameters (max 10) for function "),
                    copy_str(fn));
	}

    if (len_elems(rl) > 5)
	{
	    yyerror("semantic error");
	    message(mkc_str(" to many result types (max 5) for function "),
                    copy_str(fn));
	}

    ps = mk1_params(copy_str(FCTNAME),
		    copy_str(fn));

					/* the signature string as parameter */
    ps = union1_params(ps,
		       copy_str(SIGNATURESTRING),
		       mk_sig_option_str(fn,pl,rl,fc));

    if (is_empty_elems(rl))
	{
	    /* void function */
	    /* not yet used: concrete syntax ??? */
	}
    else
	if (hd_str(fc)=='=')
	    {	/* manipulator */
		if (!is_eq_str(domname,hd_elems(rl)))
		    {
			yyerror("semantic error");
			message(mkc_str(" in transformation functions 1. result must be equal 1. argument for function "),
				copy_str(fn));
		    }
		ps = union1_params(ps,
				   mkc_str("NOTCONST"),
				   mkc_str("1"));

		/* no further result values */
		if (len_elems(rl) == 1)
		    {
			ps = union1_params(ps,
					   mkc_str("MANIPULATOR"),
					   mkc_str("1"));
			ps = union1_params(ps,
					   copy_str(RESULT),
					   copy_str(hd_elems(rl)));
		    }
		else 
		    {
			/* other result values */
			/* 1. becomes function result */
			ps = union1_params(ps,
					   copy_str(RESULT),
					   copy_str(sel_elems(rl,2)));

			/* others extra & parameters */
			{ Nat0 i,l;

			for (i=3,l=len_elems(rl);
			     i<=l;
			     i++) 
			    ps  = union1_params(ps,
						gen_str(RESULT,i-1),
						copy_str(sel_elems(rl,i)));
			}
		    }
	    }
	else 
	    {
		/* const function */
		ps = union1_params(ps,
				   copy_str(RESULT),
				   copy_str(hd_elems(rl)));
		{ Nat0 i,l;

		for (i=2,l=len_elems(rl);
		     i<=l;
		     i++)
		    ps  = union1_params(ps,
					gen_str(RESULT,i),
					copy_str(sel_elems(rl,i)));
		}
	    }

    { 
	/* parameter list processing */
	Nat0 i,l;

	for (i=1,l=len_elems(pl);
	     i<=l;
	     i++)
	    {
		ps  = union1_params(ps,
				    mknc_str('X',i),
				    copy_str(sel_elems(pl,i)));
	    }
    }

    return
	mk1_dominfo(domname,
		    mk_description(mk_empty_domain(),
				   mk_implementation(mk_nil_implid(),
						     mk_empty_params(),
						     mk1_operations(opname,
								    ps)
						     )
				   )
		    );
}

/*----------------------------------------------------------------------*/

/* Modulname: get_file_val */

/* Aufgabe  : Ermitteln des Dateinamens, der zu einer Zeile der mit dem */
/*            Parser verarbeiteten Liste mehrerer Dateien gehoert */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Zeilennummer der Zeile 'lineno' */

/* Ausgabe  : Dateiname */

/*----------------------------------------------------------------------*/

Fileval
get_file_val F1(
		Nat1, lineno)           /* Zeilennummer */
{
    Nat1 p;
    for ( p=len_rootvals(rootvalues);
	  (p>1) AND (lineno<s_lines(sel_rootvals(rootvalues,p)));
	  p--);
    return
	sel_rootvals(rootvalues,p);
}


/*----------------------------------------------------------------------*/

/* Modulname: get_root_name */

/* Aufgabe  : Ermitteln der ersten Definitions-Stelle eines ADT */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Name des ADT 'domainid' */

/* Ausgabe  : Dateiname der ersten Definitions-Stelle */

/*----------------------------------------------------------------------*/

Str
get_root_name F1(
		 Str, domainid)         /* ADT-Name */
{
    Str s;
    Info info;
    LET s=mk_empty_str() IN
    if (is_in_dom_crossref(domainid,crossref,&info))
	{
	    s=conc_str(s,copy_str(s_defined(info)));
	    s=conc_str(s,mkc_str(" ("));
	    s=conc_str(s,gen_str(mkc_str("line :  "),s_line(info)));
	    s=conc_str(s,mkc_str(")"));
	}
    return s;
}


/*----------------------------------------------------------------------*/

/* Modulname: make_root_name */

/* Aufgabe  : Erstellen eines VDM-Strings aus den Informationen eines */
/*            Eintrags der Liste zur Fehlerbehandlung */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Element aus der Liste zur Fehlerbehandlung 'f' */

/* Ausgabe  : VDM-String */

/*----------------------------------------------------------------------*/

Str
make_root_name F1(
		  Fileval, f)
{
    Str s=mk_empty_str();
    if (is_empty_str(s_fconstr(f)))
	s=conc_str(s,copy_str(s_fdomain(f)));
    else
	{
	    s=conc_str(s,mkc_str("<"));
	    s=conc_str(s,copy_str(s_fconstr(f)));
	    s=conc_path_str(s,copy_str(s_fimplid(f)));
	    s=conc_path_str(s,copy_str(s_foperationid(f)));
	    s=conc_path_str(s,copy_str(VDM));
	    s=conc_str(s,mkc_str(">"));
	    s=conc4_str(s,mkc_str(" (used by :  "),copy_str(s_fdomain(f)),
			mkc_str(")"));
	}
    return s;
}


/*----------------------------------------------------------------------*/

/* Modulname: update_crossref */

/* Aufgabe  : Aktualisierung der Abbildung der Stellen der ersten */
/*            Definitionen der ADT's */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : ADT-Name 'dn' */
/*            aktuell verarbeitete DSL-Spezifikation 'infile' */
/*            Parser uebergebene DSL-Spezifikation 'rootfile' */
/*            Zeilennummer, in der der ADT definiert wird 'lineno' */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

void
update_crossref F4(
		   Str, dn,                    /* ADT-Name */
		   char*, infile,              /* aktuelle Datei */
		   char*, rootfile,            /* DSL-Spezifikation */
		   Nat0, lineno)               /* Zeilennummer */
{
    char *ms=(char *)tmpmalloc(strlen(infile)+1);
    if (ms!=NULL)
	{
	    strcpy(ms,infile);
	    if (NOT is_in_crossref(dn,crossref))
		crossref=union1_crossref(crossref,copy_str(dn),mk_info(mkc_str(ms),lineno));
	    free(ms);
	}
}


/*----------------------------------------------------------------------*/

/* Modulname: get_globalimpl_params */

/* Aufgabe  : Erzeugen einer Abbildung (Map), mit den Parameter- */
/*            Definitionen der beim Aufruf mit -S angegebenen globalen */
/*            Parameter */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : Parameter einer Implementation 'oldparams' */
/*            Gueltige Parameter 'vdmparams' */

/* Ausgabe  : Parameter-Definitionen */

/*----------------------------------------------------------------------*/

Params
get_globalimpl_params F0()
{
    Str pv;
    Params params=mk_empty_params();

    /* mit -S beim Aufruf definierte Parameter */
    if (is_in_dom_params(PARAM_['S'],global_params,&pv))
	{
	    Str pname,
		pval,
		v=copy_str(pv);
	    Nat0 i,
		g;

	    while (NOT is_empty_str(v))
		{
		    /* einzelne Parameter-Definitionen durch '\n' getrennt */
		    i=index_str(v,'\n');
		    if (NOT i)
			i=len_str(v)+1;
		    pname=mk_sub_tup_str(v,1,i-1);

		    /* Parameter-Wert gegeben */
		    if ((g=index_str(pname,'='))!=0)
			{
			    pval=mk_sub_tup_str(pname,g+1,len_str(pname));
			    pname=sub_tupd_str(pname,1,g-1);
			}
		    else
			pval=copy_str(DEF);

		    /* Parameter noch nicht definiert und gueltig */
		    params=ovwrtd_params(params,mk1_params(pname,pval));
		    v=sub_tupd_str(v,i+1,len_str(v));
		}
	    del_str(v);
	}

    return params;
}


/*----------------------------------------------------------------------*/

/* Modulname: tolower_str */

/* Aufgabe  : Transformiere string nach lower case */

/*----------------------------------------------------------------------*/

Str
lowercase_str F1(
		 Str,s)
{
    Str r = mk_empty_str();
    Nat0 i;

    for (i = 1;
	 i <= len_str(s);
	 i++)
	{
	    r = appr_str(r,tolower(sel_str(s,i)));
	}
    return r;
}

/*----------------------------------------------------------------------
 Modulname: profile_all 
 Aufgabe  : Generate profiling information (if enabled during generation)
----------------------------------------------------------------------
 Parameter 
 Eingabe  : 
 Ausgabe  : 
----------------------------------------------------------------------*/

void
profile_all F0()
{
    profile_str();
    profile_depend();
}


