/*----------------------------------------------------------------------

 Modulname: $Id: domfct.h,v 1.18 1996/04/30 20:24:27 vdm Exp $ 

 Aufgabe  : Deklarationsdatei fuer domfct.c 

----------------------------------------------------------------------
 Parameter 

 Eingabe  :

 Ausgabe  :

----------------------------------------------------------------------

 Ersteller: Kai Steinau 

----------------------------------------------------------------------

Aenderungen:

$Log: domfct.h,v $
Revision 1.18  1996/04/30 20:24:27  vdm
extensions for implementing alias as inheritance in C++
solution: a new constructor -isa with external syntax
Subtype is-a Basetype
Semantics for C like "=", but for C++ class SUBTYPE
becomes a subclass of class BASETYPE
Problem: constructors are not inherited, so the
constructors are passed from Basetype to Subtype
in the generator, therefore a special operation
constructor.mk??? introduced, wich is copied in the generator
to the Subtype domain.
The generation order computation did not work save,
therefore an explicit dependency graph is constructed, with this
graph the generation order is computed, old code still there
function "old_gen_order"

Revision 1.17  1996/01/15 10:01:57  vdm
cvs backup

 * Revision 1.16  1995/11/25  13:50:38  vdm
 * minor warning correction from sun cc and g++ 2.7.0
 *
 * Revision 1.15  1995/01/31  18:13:47  vdm
 * SIGNATURE --> SIGNATURESTRING
 * for -X all domains in .enr file written, not only defined domains'
 *
 * Revision 1.14  1994/12/29  16:52:34  vdm
 * new option -X for collecting comments
 * during parsing and writing these comments into the .enr and .pre files
 * for parsing and importing .vdm files into vdmedit
 *
 * Revision 1.13  1994/11/27  19:05:11  vdm
 * new keywords set bag nat nat0 int char bool real rat
 * for ISO syntax
 *
 * Revision 1.12  1994/08/13  19:44:02  vdm
 * TDEPEND --> TFCT,
 * new function arrow => for transformation functions
 *
 * Revision 1.11  1994/08/13  11:48:41  vdm
 * syntax of VDM-DSL extended:
 * a FUNCTIONS part added to specify the signature of user defined functions
 * DOMAINS, IMPLEMENTATIONS and FUNCTIONS parts may be mixed arbitrarily
 * the keyword FUNCTIONS may also be writtes as Functions
 * the syntax of a signature is
 *   fct1,...,fctn : D1 x ... x Dm -> R1 x ... x Ro
 * these signatures are implemeted by the com.com.signature operation
 * x is a new keyword
 * lexical syntax of selectors changed: numbers are not longer allowed as the first char
 * in identifiers
 * the --> symbol (TFCT) did not longer work because of the -- comment
 * therfore the symbol substituted by -> (TDEPEND)
 *
 * Revision 1.10  1994/05/10  15:06:31  vdm
 * flat version
 *
 * Revision 1.9  1994/02/10  10:36:37  vdm
 * option -J for adding C++ default operations
 *
 * Revision 1.8  1993/11/28  09:54:31  vdm
 * Options sortiert
 *
 * Revision 1.7  1993/11/21  20:03:51  vdm
 * Torsten Tews 1.Version eingemischt
 * Dabei interne Domain Gleichungen in C++ ausgeblendet
 * mit einem internen Implementierungsparameter INTERALDOMAIN
 *
 * Revision 1.6  1993/11/03  14:16:53  vdm
 * Hans-Martins Aenderungen eingemischt
 *
 * Revision 1.5.2.1  1993/11/20  17:20:30  vdm
 * 1.Version von Torsten Tews
 *
 * Revision 1.8  1993/10/29  21:21:44  hmh
 * Several corrections dealing with storage allocation:
 *
 * Revision 1.7  1993/10/24  21:58:18  hmh
 * Changes built in to handle the '-r' option used to check
 * if a given enrichment file can be used as starting point of
 * enrichment process.
 *
 * Revision 1.5.2.1  1993/11/17  21:03:42  uvdm
 * Aenderungen fuer automatische Speicherverwaltung eingebaut; der
 * eingelesene Parsebaum wird in domgen.c transformiert. Aenderungen sind mir
 * / * TT * / markiert. Auswahl der Transformation ueber neuen Kommandozeilen-
 * parameter -M
 *
 * Revision 1.5  1993/09/01  18:11:10  vdm
 * Hans-Martins Version vom 1.9.93 als neue Hauptversion
 * - new macros 'trace[1-3]' for message output depending on 'domtrace'
 * Revision 1.4  1993/07/01  14:10:21  vdm
 * Uwes changes for C++ inserted
 * Naming conventions for selector names
 * "for" routine interfaces removed
 *
 * Revision 1.6  1993/07/25  08:50:56  hmh
 * Several changes
 *
 * 'stdlib.h' included for '__STDC__' only.

 * Revision 1.5  1993/07/10  07:29:24  hmh
 * Handling of 'VDMROOT' environment variable corrected:
 *   - removed reading from domaincomp ('vdmmain') completely
 *   - in Dm: if VDMROOT is undefined, set to default path ('/usr/local').
 *
 * Revision 1.4  1993/07/05  21:34:03  hmh
 * Merging Uwes changes into mine.
 *
 * Revision 1.4  1993/07/01  14:10:21  vdm
 * Uwes changes for C++ inserted
 * Naming conventions for selector names
 * "for" routine interfaces removed
 *
 * Revision 1.3  1993/05/28  11:03:26  hmh
 * Compiler extended to accept the ISO VDM-SL ASCII syntax. These
 * extensions are activated through the '-N' switch.
 *
 * Revision 1.2  1993/05/22  14:22:19  hmh
 * Handling of filenames containing '.' (i.e. '../e.vdm') corrected.
 * For this, the function 'gen_file_name' was changed to scan
 * backwards for '.' and stop at '/'.
 *

  93/02/11: Zusammenfassen aller System-Includes 
            (#include <...>) 
  93/02/23: proto.h include anstatt domdekl.h 

----------------------------------------------------------------------*/

#define OLDVDM   /* Signatur-Komponenten wie 'csig' und 'psig' werden */
                 /* unterstuetzt, Elemente 'ELEM' ,'ELEM1', 'ELEM2' werden */
                 /* definiert --> nach Anpassung der Datenbank */
                 /* #define OLDVDM loeschen */

#define NOPOS    /* keine Ausgabe von Positionen innerhalb einer Zeile bei */
                 /* Fehlermeldungen (der verwendete Praeprozessor loescht */
                 /* Lerrzeichen am Zeilenanfang --> Positionsangaben stimmen */
                 /* nicht ) --> nach Austausch/Anpassung des Praeprozessors */
                 /* #define NOPOS loeschen */

#ifndef DOMFCT
#define DOMFCT

#include <stdio.h>
#ifdef __STDC__
#include <stdlib.h>
#endif
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include "proto.h"
#include "domadt.h"

#define Progname "vdm"
#define Basename mkc_str("vdm-mod")
#define VDMROOT "VDMROOT"

#ifndef Database
#define Database "/lib/vdmdb-c"
#endif

#ifndef Vdmroot
#define Vdmroot "/usr/local"
#endif

#define INTERNALDOMAINstr "INTERNALDOMAIN"

/*----------------------------------------------------------------------*/

/* Definitionen der moeglichen Konstruktoren */

extern Str PREDEF;
extern Str USERDEF;
extern Str ALLDEF;
extern Str NUMERIC;
extern Str ISA;
extern Str TREE;
extern Str TOKEN;
extern Str TUPLE;
extern Str UNION;
extern Str MAP;
extern Str SET;
extern Str BAG;
extern Str TOKUNI;
extern Str OPTI;
extern Str ALIAS;
extern Str ISA;
extern Str FCT;
extern Str DEPND;

/*----------------------------------------------------------------------*/

/* Definitionen fuer ADT-Parameter */

extern Str FCTNAME;
extern Str RESULT;
extern Str DOMAINNAME;
extern Str ELEM0;
#ifdef OLDVDM
extern Str ELEM;
extern Str ELEM1;
extern Str ELEM2;
#endif
extern Str SEL;
extern Str COMP;
extern Str VAR;
extern Str ENUM;
extern Str CPP_PARAM;

/*----------------------------------------------------------------------*/

/* Definitionen fuer Aufrufparameter fuer VDM-Generator und Praeprozessor */

extern Str CPP_NAME;
extern Str CPP_NODEBUG;
#define Paramtabsize 256
extern Str PARAM_[Paramtabsize];

/*----------------------------------------------------------------------*/

/* Definitionen zur Suche nach VDM-Datenbank-Komponenten */

extern Str STDLIB;
extern Str STDADT;
extern Str SETUP;
extern Str COM;
extern Str BASIC;
extern Str SIGN;
extern Str PARAM;
extern Str POST;
extern Str VDM;
extern Str ENR;
extern Str PRE;
extern Str ADTTYPE;

extern Str NOSTD;
extern Str DEF;
extern Str DUMMY;
extern Str FORWARD_ALLOWED;
extern Str CCOD;
extern Str GEN_C;
extern Str GCOD;
extern Str MACROS;
extern Str CMCR;
extern Str GMCR;
extern Str GSIG;
extern Str GPTR;
extern Str GTYP;
extern Str GEN_PASCAL;
extern Str CONSTS;
extern Str PCST;
extern Str GEN_MODULA;
extern Str GCST;
extern Str GEN_IMPORT;
extern Str IMPORTS;
extern Str GIMP;
extern Str CPP;
extern Str CPPCLASS;
extern Str CPLUSPLUS;
extern Str DECL;
extern Str GEN_CPLUS;
extern Str MEMBERS;
extern Str OPERATOR;
extern Str UPPER;
extern Str INTERNALDOMAIN;
extern Str BASEIMPL;
extern Str AUTOMEM;
extern Str DEFAULT;

extern Str VDMDOMAIN;
extern Str CROUTINES;
extern Str PTRTYPES;
extern Str TYPES;
extern Str SIGNATURE;
extern Str SIGNATUREOP;
extern Str SIGNATURESTRING;
extern Str CMACROS;

extern Str GEN_ANSIC;
extern Str RENAME;
extern Str CONSTRUCTOR;
extern Str NEWLINE;
extern Str EMPTY;

extern Str AUTOMEM_OK;            /* TT */
extern Str AUTOMEM_NOT_ALLOWED;

#define Empty   mk_empty_str()

#ifdef OLDVDM
#define Sign_components mkc_str("vsig,csig,psig,gsig,cpp,cppclass")
#else
#define Sign_components mkc_str("gsig,cpp,cppclass")
#endif
#define Order_components mkc_str("gptr,gtyp,gsig,ccod,cpp,cppclass")

/*----------------------------------------------------------------------*/

#define Parsefilenamelen 1024          /* max. Laenge der Dateinamen, der */
                                       /* Dateien, die vom Parser */
                                       /* verarbeitet werden */

/* Definitionen fuer temporaere Dateien */

#define Filenamelen 256              /* Max. Laenge fuer temporaere Dateien */

/*----------------------------------------------------------------------*/
/* Funktionsdeklarationen */

typedef void(*fctptr)();

void           mk_init_str();
void           del_init_str();
void          *tmpmalloc H1(Nat0);

/* Ausgabe-Funktionen fuer Meldungen und Fehler */

void           printstr H3(Str, Str, Str);
void           message H2(Str, Str);
void           warning H2(Str, Str);
void           trace H3(Str, Str, int);
void           error H2 (Str, Str);
void           errorfile H1(Str);
Str            gen_str H2(Str, Nat0);
Str            gen_quote_str H1(Str);
Str            gen_quote2_str H1(Str);

void           yyerror H1(char *);

#define trace1(m,s)	trace(m,s,1)
#define trace2(m,s)	trace(m,s,2)
#define trace3(m,s)	trace(m,s,3)

/*----------------------------------------------------------------------*/

/* Funktionen zur Dateiverarbeitung */

                 /* ersetzt Endung '.xxx' durch '.ext' */
Str            gen_file_name H2(Str, Str);

                 /* prueft ob Datei 'file_name' existiert */
Bool           exists_file H1(Str);

                 /* oeffnet Datei 'file_name' im Modus mode */
FILE          *open_file H2(Str ,char *);

                 /* schlieM-at die durch 'file_pointer' referenzierte Datei */
void           close_file H1(FILE *);

                 /* loescht Datei 'file_name' */
void           remove_file H1(Str);

                 /* erstellt temporaere Datei, gibt Dateinamen zurueck */
Str            create_tmpfile ();

/*----------------------------------------------------------------------*/

/* Makros zur Stringverarbeitung */

#define line_str(s) appr_str(s,'\n')
#define prefix_underline_str(s) appl_str('_',s)
#define define_str(m,v) \
   line_str(conc4_str(mkc_str("#define "),m,mkc_str(" "),v))
#define undef_str(m) \
   line_str(conc_str(mkc_str("#undef "),m))
#define app_str(d,s) d=conc_str(d,s)
#define mk_quot(s) appl_str('\'',appr_str(copy_str(s),'\''))
#define outstr(s) message(s,Empty);

Str lowercase_str H1(Str);

/*----------------------------------------------------------------------*/
/* Makros fuer Optionstest */

#define extent_selector_names is_in_params(PARAM_['a'],global_params)
#define upper_case_class_names is_in_params(PARAM_['U'],global_params)
#define friend_functions is_in_params(PARAM_['F'],global_params)
#define operator_functions is_in_params(PARAM_['O'],global_params)
#define include_standard_domains ( NOT is_in_params(PARAM_['k'],global_params) )
#define incomplete_set_of_operations is_in_params(PARAM_['u'],global_params)
#define automem_impl_with_macros is_in_params(PARAM_['K'],global_params)
#define automem_impl_with_defaults is_in_params(PARAM_['J'],global_params)
#define ISO_standard is_in_params(PARAM_['N'],global_params)

/*----------------------------------------------------------------------*/

/* Funktionen zu Bearbeitung des Parse Baum's */

Domain         mk_empty_domain         H0();
Implementation mk_empty_implementation H0();

Dominfo        merge1_dominfo    H3(Dominfo,    Str, Description);
Operations     merge1_operations H3(Operations, Str, Params     );

Dominfo        mk_sig_dominfo_str H4(Str,Elems,Elems,Str);

/*----------------------------------------------------------------------*/

/* Bearbeitung der Dateiliste/Crossref-Liste zur Fehlerbehandlung */

Str            make_root_name  H1(Fileval);
Fileval        get_file_val    H1(Nat1);
Str            get_root_name   H0();
void           update_crossref H4(Str, char*, char*, Nat1);

/*----------------------------------------------------------------------*/

Params         get_globalimpl_params H0();

/*----------------------------------------------------------------------*/

/* globale Variablen */

extern Bool          yyexitcode;    /* TRUE fuer Fehler, FALSE sonnst */

extern int domtrace;                /* Wert von 0 bis 3, steuert Ausgabe der */
                                    /* Informationsmenge, bei der Bearbeitung */

extern Params        global_params; /* globale Parameter (definiert bei */
                                    /* Aufruf des VDM-Generators) */

extern Rootvals      rootvalues;    /* Dateiliste zur Fehlerbehandlung */

extern Crossref      crossref;      /* Abbildung (Map) ADT auf Definition*/
                                    /* (Datei+Position) */

/*----------------------------------------------------------------------*/

/* Definitionen fuer VDM-aehnliche Notation */

#define IF (
#define THEN )?(
#define ELSE ):
#define LET
#define IN ;
#define AND &&
#define OR ||
#define NOT !

/*----------------------------------------------------------------------*/
extern void profile_all();

/*----------------------------------------------------------------------*/

#endif
