/*----------------------------------------------------------------------*/

/* Modul:                  @(#)proto.h */
/* Version:                2.1 */
/* Ersteller:              Gerrit Petrich, WI 8215, WS 93 */
/* Datum der letzten */
/* Aenderung:              93/03/29 */

/*----------------------------------------------------------------------*/

/* Aufgabe:   "proto.h" erlaubt die Benutzung von ALIAS-Namen und */
/*            die wahlweise Generation von ANSI-C oder K&R-C */
/*            Funktionskoepfen. */

/*----------------------------------------------------------------------*/

/* Aenderungen: */
/* wann:                 warum: */
/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/

#ifndef PROTO
#define PROTO

/* Definitionen zur Simulation von Aliasnamen */

#ifndef __ALIAS__
#define __ALIAS__ 1               /*  hier ist der Schalter */
#endif

#if __ALIAS__

#define Vdmdbname Str
#define Adtname Str
#define Implname Str
#define Opname Str
#define Signname Str
#define Signature Str
#define Compname Str
#define Component Str
#define SignCompname Str

#define Adtnameset Strset
#define Implnameset Strset
#define Opnameset Strset
#define Compnameset Strset

#endif

/* Funktionskoepfe fuer ANSI-C (= STDC) oder K&R-C */

#if __STDC__
#ifndef __ANSI__
#define _ANSI__ 1
#endif
#endif

#if __ANSI__

#define F0()                                          (void)
#define F1(t1,p1)                                            (t1 p1)
#define F2(t1,p1,t2,p2)                                   (t1 p1,t2 p2)
#define F3(t1,p1,t2,p2,t3,p3)                             (t1 p1,t2 p2,t3 p3)
#define F4(t1,p1,t2,p2,t3,p3,t4,p4)                   (t1 p1,t2 p2,t3 p3,t4 p4)
#define F5(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5)             (t1 p1,t2 p2,t3 p3,t4 p4,t5 p5)
#define F6(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6)       (t1 p1,t2 p2,t3 p3,t4 p4,t5 p5,t6 p6)
#define F7(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6,t7,p7) (t1 p1,t2 p2,t3 p3,t4 p4,t5 p5,t6 p6,t7 p7)
#define F8(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6,t7,p7,t8,p8) (t1 p1,t2 p2,t3 p3,t4 p4,t5 p5,t6 p6,t7 p7,t8 p8)
#define F9(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6,t7,p7,t8,p8,t9,p9) (t1 p1,t2 p2,t3 p3,t4 p4,t5 p5,t6 p6,t7 p7,t8 p8,t9 p9)
#define H0()                     (void)
#define H1(t1)                   (t1)
#define H2(t1,t2)                (t1,t2)
#define H3(t1,t2,t3)             (t1,t2,t3)
#define H4(t1,t2,t3,t4)          (t1,t2,t3,t4)
#define H5(t1,t2,t3,t4,t5)       (t1,t2,t3,t4,t5)
#define H6(t1,t2,t3,t4,t5,t6)    (t1,t2,t3,t4,t5,t6)
#define H7(t1,t2,t3,t4,t5,t6,t7) (t1,t2,t3,t4,t5,t6,t7)
#define H8(t1,t2,t3,t4,t5,t6,t7,t8) (t1,t2,t3,t4,t5,t6,t7,t8)
#define H9(t1,t2,t3,t4,t5,t6,t7,t8,t9) (t1,t2,t3,t4,t5,t6,t7,t8,t9)

#else

#define F0()                                          ()
#define F1(t1,p1)                                     (p1)                   t1 p1;
#define F2(t1,p1,t2,p2)                               (p1,p2)                t1 p1; t2 p2;
#define F3(t1,p1,t2,p2,t3,p3)                         (p1,p2,p3)             t1 p1; t2 p2; t3 p3;
#define F4(t1,p1,t2,p2,t3,p3,t4,p4)                   (p1,p2,p3,p4)          t1 p1; t2 p2; t3 p3; t4 p4;
#define F5(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5)             (p1,p2,p3,p4,p5)       t1 p1; t2 p2; t3 p3; t4 p4; t5 p5;
#define F6(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6)       (p1,p2,p3,p4,p5,p6)    t1 p1; t2 p2; t3 p3; t4 p4; t5 p5; t6 p6;
#define F7(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6,t7,p7) (p1,p2,p3,p4,p5,p6,p7) t1 p1; t2 p2; t3 p3; t4 p4; t5 p5; t6 p6;t7 p7;
#define F8(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6,t7,p7,t8,p8) (p1,p2,p3,p4,p5,p6,p7,p8) t1 p1; t2 p2; t3 p3; t4 p4; t5 p5; t6 p6;t7 p7;t8 p8;
#define F9(t1,p1,t2,p2,t3,p3,t4,p4,t5,p5,t6,p6,t7,p7,t8,p8,t9,p9) (p1,p2,p3,p4,p5,p6,p7,p8,p9) t1 p1; t2 p2; t3 p3; t4 p4; t5 p5; t6 p6;t7 p7;t8 p8;t9 p9;
#define H0()                     ()
#define H1(t1)                   ()
#define H2(t1,t2)                ()
#define H3(t1,t2,t3)             ()
#define H4(t1,t2,t3,t4)          ()
#define H5(t1,t2,t3,t4,t5)       ()
#define H6(t1,t2,t3,t4,t5,t6)    ()
#define H7(t1,t2,t3,t4,t5,t6,t7) ()
#define H8(t1,t2,t3,t4,t5,t6,t7,t8) ()
#define H9(t1,t2,t3,t4,t5,t6,t7,t8,t9) ()

#endif
#endif

