  /* ----------------------------------------------------

   $Id: bbgen.c,v 1.6 1994/07/14 22:33:48 vdm Exp $

   last programmer who changed file: Uwe

   VDM Class Library Test Program Generator
   ========================================

   ------------------------------------------------------

   last changes:

   Apr-26-92  : 'testdb' in preprocessor options replaced by 
   .		'test_dbdir'

   ---------------------------------------------------- */


static
    char version[] = "VDM Class Library Test Case Generator ($Id: bbgen.c,v 1.6 1994/07/14 22:33:48 vdm Exp $)";

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef AIX
#define _AIX
#endif

#ifdef _AIX
#ifdef TRUE
#undef TRUE
#endif
#ifdef FALSE
#undef FALSE
#endif
#endif

typedef enum {FALSE,TRUE} boolean;

char progname[]="bbgen";              /* program name      */

#define MAX_STR 200

/*--------------------------------------------------------------------*/

boolean user_trace     = FALSE;         /* verbose flag      */

/*--- directory and file names ---------------------------------------*/

#define PRES "E"

#define vdmsourcefilename  "BB_adt.vdm"
#define csourcefilename    "BB.c"
#define BBtempfilename0    "tmp0"
#define BBtempfilename1    "tmp1"
#define BBtempfilename2    "tmp2"
#define BBtempfilename3    "tmp3"

#define BBmakefilename     "bbmake"
#define Makefilename       "Makefile"

#define ROOTVAR "VDMROOT"
#define DEFROOT "/usr"
#define default_dir_str     "lib/vdmdb-c"
#define default_vdmpp       "lib/vdmpp"
#define CPPopt " -E0 -i -I"

char home[]=".";                      /* working directory */
char testdb[]="testdb-c";
char aux[]="aux";
char common[]="com";
char basic[] ="basic";
char testcschema[]="bbc";
char testvdmadt1[]="bb1";
char testvdmadt2[]="bb2";
char testdata1[]="bbd1";
char testdata2[]="bbd2";

char * rootdir;                       /* default vdm system root */
char * dbdir;                         /* database dir            */
char * test_dbdir;                    /* test database dir       */
char * basicADT;

char testsourcedir[MAX_STR];
char testsourcedir2[MAX_STR];
char defdbdir[MAX_STR];               /* default database dir    */

char * cbeauty     = " | cb";
char * cbeauty_cmd = "";

#ifndef __STDC__
extern		char *getenv(); /* contained in 'stdlib.h' for ANSI C */
#endif

/*--- ADT's supported ------------------------------------------------*/

/* special case: predefined Str ADT implemented as array */

#define Str_adt    "Str"
#define Nat0_adt   "Nat0"
#define Char_adt   "Char"

#define Str_constr    "tupl"
#define Token_constr  "token"
#define Nat0_constr   "numeric"

#define Str_impl   "array"

/*--- elementary ADT's ---*/

char *EADT[] = { "numeric", "bool", Token_constr, "enum"
               };

/*--- ADT's with a total ordering ---*/

char *OADT[] = { "numeric", "bool",
                 "opti", "tree", "tupl", "unio" };

struct Prestruct {char * name;
                  char * constr;}
      PreADT[] = { { Nat0_adt, Nat0_constr},
                   { "Nat1","numeric"},
                   { "Intg","numeric"},
                   { Char_adt,"numeric"},
                   { "Bool","bool"},
                   { Str_adt ,"tupl"}
                 };

#define NPreADT (sizeof(PreADT)/sizeof(struct Prestruct))

char * is_predef_adt( char * name )
{
  int i;
  if (name == 0) return 0;
  for (i=0; i<NPreADT; i++)
    if (strcmp(name,PreADT[i].name)==0) {
       return PreADT[i].constr;
    }
  return 0;
}

#define NEADT (sizeof(EADT)/sizeof(char *))

#define NOADT (sizeof(OADT)/sizeof(char *))

boolean is_elem_adt( char * name )
{ int i;
  for (i=0; i<NEADT; i++)
    if (strcmp(name,EADT[i])==0) return TRUE;
  return FALSE;
}

boolean is_token_adt( char * name )
{ return (name != 0) && strcmp(name,Token_constr)==0; }

boolean is_str_adt( char * name )
{ return (name != 0) && strcmp(name,Str_adt)==0; }

boolean is_ordered_adt( char * name )
{ int i;
  for (i=0; i<NOADT; i++)
    if (strcmp(name,OADT[i])==0) return TRUE;
  return FALSE;
}

/******************************************************************************/

struct txtptr { char          *NAME;
                struct txtptr *NEXT; };

#define STP struct txtptr *
#define STM sizeof(struct txtptr)

#define the_sky_is_blue 1

struct txtptr *XTEXT=NULL;

int NXTEXT;

char YTEXT[MAX_STR],
     ZTEXT[MAX_STR];

FILE *fr=NULL,
     *fw=NULL,
     *pr=NULL;

/*--- error messages -------------------------------------------------*/

int err( int nr, char * msg );

char *ERRMSG[] = { "output written to directory: ",
                   "please check file: ",
                   "can't allocate memory",
                   "can't open stream: ",
                   "can't execute: ",
                   "can't read from file: ",
                   "can't write to file: ",
                   "can't remove file: ",
                   "can't get no implementation!",
                   "missing '@' in file: ",
                   "can't create directory: ",
                   "can't find a test program for ADT ",
                   "can't find an implementation "
                 };

enum errornr { END , CASE , MEM , PIPE ,
               EXEC , READ , WRITE , DEL ,
               NIX ,
               SYN ,
               DIR ,
               NOEXADT ,
               NOIMP } ;

/*--- string handling ------------------------------------------------*/

void strcpy2( char * d, char * s1, char * s2 )
{
   strcpy(d,s1);
   strcat(d,s2);
}

void strcpy4( char * d, char * s1, char * s2, char * s3, char * s4 )
{
   strcpy(d,s1);
   strcat(d,s2);
   strcat(d,s3);
   strcat(d,s4);
}

void strdcat( char * d, char * s )
{
   strcat(d,"/");
   strcat(d,s);
}

void strdcpy2( char * d, char * s1, char * s2 )
{
   strcpy (d,s1);
   strdcat(d,s2);
}

void mksubdir( char * d, char * s )
{
   strdcat(d,s);
   (user_trace) && fprintf(stderr,"mkdir %s\n",d);
   mkdir(d,0755);
}

int check_input( char * fn )
{  
   extern int access();
   (user_trace) && fprintf(stderr,"checking file existence for %s\n",fn);
   return (access(fn,4) == 0);
}

void open_input( char * fn )
{
   (user_trace) && fprintf(stderr,"reading from %s\n",fn);
   ( (fr=fopen(fn,"r")) == NULL ) && err(READ,fn);
}

void open_output( char * fn )
{
   (user_trace) && fprintf(stderr,"writing to   %s\n",fn);
   ( (fw=fopen(fn,"w")) == NULL ) && err(WRITE,fn);
}

void close_input( void )
{
  if(fr!=NULL)
    fclose(fr);
  fr=NULL;
}

void close_output( void )
{
  if(fw!=NULL)
    fclose(fw);
  fw=NULL;
}

void copy_file( void )
{  int c1;
   while ( (c1=fgetc(fr)) != EOF ) {
         fputc(c1,fw);
   }
}

void c_adtdir( char * dir, char * adt, char * impl )
{  char tmp[MAX_STR];

  strdcpy2(dir,test_dbdir,adt);
  strdcat(dir,common);
  strdcat(dir,basic);

#if ! flat
  /* check test source file */
  strdcpy2(tmp,dir,testcschema);
  (check_input(tmp)) || err(NOEXADT,adt);

  /* check implementation */
  strdcpy2(tmp,dbdir+2,adt);
  strdcat(tmp,impl);
  (check_input(tmp)) || err(NOIMP,impl);
#endif

}

/*--- error handling -------------------------------------------------*/

int err( int nr, char * msg )

{
  fprintf(stderr,"\n%s: %s%s\n",progname,ERRMSG[nr],msg);

  close_input();
  close_output();

  (user_trace) && fprintf(stderr,"\ntest case generation finished\n");
  exit(nr);
}

void err_syn( char * fn )
{ err(SYN,fn); }

/*--------------------------------------------------------------------*/

void executecmd(char * cmd)
{
  int err;
  (user_trace) && fprintf(stderr,"executing %s\n",cmd);
  err=system(cmd);
  (user_trace) && fprintf(stderr,"cmd executed: rc = %d\n",err);
}

void deletefile(char * file)
{
  user_trace || (unlink(file) == 0) || err(DEL,file);
}

/*--------------------------------------------------------------------*/

char prepropar[4*MAX_STR];

void clearprepropar( void )
{ prepropar[0]=0; }

void defprepropar( char * name, char * val )
{ strcat(prepropar," -D");
  strcat(prepropar,name);
  if (val != 0 && val[0] != 0) {
     strcat(prepropar,"=");
     strcat(prepropar,val);
  }
}

void preprocess( char * s, char * d, char * cbeauty )
{ char cmd[5*MAX_STR];
  strdcpy2(cmd,rootdir,default_vdmpp);
  strcat(cmd,CPPopt);
#if ! flat
  strcat(cmd,test_dbdir);
#else
  strcat(cmd,".");
#endif
  strcat(cmd,prepropar);
  strcat(cmd," ");strcat(cmd,s);
  strcat(cmd,cbeauty);
  strcat(cmd,">");
  strcat(cmd,d);
  executecmd(cmd);
}

/*--------------------------------------------------------------------*/

boolean is_implementation(name,ilist)
  char * name;
  STP ilist;
{ while (ilist) {
    if (strcmp(ilist->NAME,name)==0) return TRUE;
    ilist=ilist->NEXT;
  }
  return FALSE;
}

/*--------------------------------------------------------------------*/

char *steuer(instr,outstr)

  char instr[], outstr[];

{ char *pin = instr, *pout = outstr;

  do
  { if((*pin=='\'')||(*pin=='\"')||(*pin=='\\'))
      *pout++ = '\\';
  }
  while( *pout++ = *pin++ );
  return(outstr);
}

/*--------------------------------------------------------------------*/

int usage()
{
   fprintf(stderr,"usage: %s [<options>]  <domain>  [ <element> ]\n",progname);
   fprintf(stderr,"domain :   <ADT> <Implementation> | <predefined-ADT>\n");
   fprintf(stderr,"element:   <ADT> <Implementation> | <predefined-ADT>\n");
   fprintf(stderr,"options:\n");
   fprintf(stderr,"   -v              : print trace output\n");
   fprintf(stderr,"   -D<impl.param>  : implementation parameter for <domain>\n");
   fprintf(stderr,"   -E<impl.param>  : implementation parameter for <element>\n");
   fprintf(stderr,"   -P<basic-ADT>   : predefined basic ADT (default Nat0)\n");
   fprintf(stderr,"   -B<vdmdb>       : VDM database (default: %s)\n",dbdir);
   fprintf(stderr,"   -T<vdmdb>       : VDM test source database (default: VDM database)\n");
   fprintf(stderr,"   -b              : calls cb for generated test prog\n"); 
   fprintf(stderr,"predefined ADT's:\n");
   { int i;
     for (i=0; i<NPreADT;i++)
         fprintf(stderr,"   %s",PreADT[i].name);
     fprintf(stderr,"\n");
   }
   exit(1);
   return 0;
}

/* database access via vdmdbm ----------------------------------------*/

static char str[MAX_STR], str2[MAX_STR];		/* file names */
static char testdir[MAX_STR];				/* test dir   */


static
char selcomp[] = "(echo \"loaddb %s\""
                 ";echo \"puts [searchcomp %s %s %s %s]\""
                 ";echo \"exit\""
                 ") | %s/lib/vdm/dbm > %s";

static
char includ[] = "(echo \"loaddb %s\""
                ";echo \"puts [solveincludes %s]\""
                ";echo \"exit\""
                 ") | %s/lib/vdm/dbm > %s";

void solveincludes( char * db, char * file, char * output )
{ char cmd[5*MAX_STR];

  sprintf(cmd,includ,db,file,rootdir,output);
  executecmd(cmd);
}

void writecomponent(char * str, char * db,
                    char * adt, char * impl, char * oper, char * comp,
                    char * outfile)
#if ! flat
{ strdcpy2(str,db,adt);
  strdcat(str,impl);
  strdcat(str,oper);
  strdcat(str,comp);
}
#else
{ char cmd[5*MAX_STR];

  strdcpy2(str,testdir,outfile);
  sprintf(cmd,selcomp,db,adt,impl,oper,comp,rootdir,str);
  executecmd(cmd);
}
#endif

/*--- main program ---------------------------------------------------*/

int main( int argc, char * argv[] )

{ long fpos;

  char * imp1str  = 0 , * imp2str  = 0,
       * dir1str  = 0 , * dir2str  = 0,
       * adt1str  = 0 , * adt2str  = 0,
       * implpar1 = "", * implpar2 = "",
       * preadt1  = 0 , * preadt2  = 0,
       tmp[MAX_STR];

  boolean is_elem=FALSE,
          is_grge=FALSE,
          is_str1=FALSE,
          is_str2=FALSE,
          is_token2=FALSE,
          is_predef1=FALSE,
          is_predef2=FALSE,
          up,
          print;


  struct txtptr *ptr;

  int xvaluecount ;

  int testcasecount,subcasecount,
      c1, c2;

/*--- compute default database directory -----------------------------*/

   rootdir = (char *)getenv(ROOTVAR);
   if (rootdir == 0) rootdir = DEFROOT;

   strcpy2 (defdbdir,"-B",rootdir);
   strdcat (defdbdir,default_dir_str);
   dbdir=defdbdir;
   test_dbdir=0;

/*--- process options and program parameters -------------------------*/

  { /* options */
    int i;
    char * tmp;
    i = 1;
    while ((argc > i) && (*(tmp=argv[i])=='-')) {
      switch (*(tmp+1)) {
      case 'B' : dbdir = tmp;
                 break;
      case 'v' : user_trace = 1;
                 break;
      case 'b' : cbeauty_cmd = cbeauty;
                 break;
      case 'D' : implpar1 = tmp + 2;
                 break;
      case 'E' : implpar2 = tmp + 2;
                 break;
      case 'T' : test_dbdir = tmp + 2;
                 break;
      case 'P' : basicADT = tmp + 2;
                 break;
      default  : fprintf(stderr,"%s : unknown option %s\n",progname,tmp);
                 usage();
      }
      i++;
    } /*while*/

    (test_dbdir != 0) || (test_dbdir = dbdir + 2);

    (argc > i) && (adt1str = argv[i++]);
    (argc > i) && (imp1str = argv[i++]);
    (argc > i) && (adt2str = argv[i++]);
    (argc > i) && (imp2str = argv[i  ]);
  } /* options */

/*--- initialisation -------------------------------------------------*/

  (user_trace) && fprintf(stderr,"%s\n",version);

/*--- reading implementations ----------------------------------------*/

  (adt1str) || usage();
  { char * p;
    if (is_predef1 = ((p = is_predef_adt(adt1str)) != 0)) {
       preadt1=adt1str;
       adt1str=p;
    }
  }

  if ( is_str1=is_str_adt(preadt1) ) {
     imp1str = Str_impl;
     adt2str = Char_adt;
  }

  is_elem = is_elem_adt(adt1str);

  is_elem && (adt2str = Nat0_adt);
  is_elem && is_predef1 && (imp1str = common, dir1str = preadt1);

  { char * p;
    if (is_predef2 = ((p = is_predef_adt(adt2str)) != 0)) {
       dir2str = preadt2 = adt2str;
       adt2str = p;
       imp2str = common;
    }
  }

  is_str2 = is_str_adt(adt2str);
  is_token2 = is_token_adt(adt2str);

  is_predef2    &&   is_str2 && (basicADT = Char_adt);
  is_predef2    && ! is_str2 && (basicADT = preadt2);
  is_predef1    && ! is_str1 && (basicADT = preadt1);
  basicADT == 0              && (basicADT = Nat0_adt);
  
/*--------------------------------------------------------------------*/

  (imp1str) || usage();
  (adt2str) || usage();
  (imp2str) || usage();

  (dir1str == 0) && (dir1str = imp1str);
  (dir2str == 0) && (dir2str = imp2str);

  is_grge=is_ordered_adt(adt2str);

  clearprepropar();
  defprepropar("ADT1",adt1str);
  if (is_predef1) {
     defprepropar("ADT1predef",0);
     defprepropar("Domain",preadt1);
     { char str2[MAX_STR];
       strcpy(str2,"_");
       strcat(str2,preadt1);
       str2[1] += 'a' - 'A';
       defprepropar("_domain",str2);
     }
  }
  defprepropar("IMPL1",imp1str);
  defprepropar("IMPLPAR1",implpar1);
  defprepropar("ADT2",adt2str);
  if (is_predef2) {
     defprepropar("ADT2predef",0);
     defprepropar("IMPL2","predefined");
     defprepropar("Elem",preadt2);
     { char str2[MAX_STR];
       strcpy(str2,"_");
       strcat(str2,preadt2);
       str2[1] += 'a' - 'A';
       defprepropar("_elem",str2);
     }
  }
  else {
     defprepropar("IMPL2",imp2str);
     defprepropar("IMPLPAR2",implpar2);
  }
  { char str[MAX_STR];
    strcpy2(str,"is",basicADT);
    defprepropar(str,"1");
  }

  if (is_grge)   { defprepropar("ISORDERED",0); }
  if (is_token2) { defprepropar("ISTOKEN2",0); }
  if (is_str1)   { defprepropar("ISSTR1",0); }
  if (is_str2)   { defprepropar("ISSTR2",0); }

/*--- compute test source dir ---------------------------------------*/

  c_adtdir(testsourcedir ,adt1str,imp1str);
  c_adtdir(testsourcedir2,adt2str,imp2str);

/*--- create test directory -----------------------------------------*/

  strcpy(testdir,home);
  mksubdir(testdir,PRES);
  mksubdir(testdir,adt1str);
  mksubdir(testdir,dir1str);
  mksubdir(testdir,adt2str);
  mksubdir(testdir,dir2str);

/*--- open temp .vdm file --------------------------------------------*/

  strdcpy2(tmp,testdir,BBtempfilename0);
  open_output(tmp);

/*--- open .vdm schema file ------------------------------------------*/

  { char schemafile[MAX_STR];

    writecomponent(schemafile,test_dbdir,
                   adt1str,common,basic,testvdmadt1,testvdmadt1);
    open_input(schemafile);
    copy_file();
    close_input();
  }

/*--- open schema file for Element ADT -------------------------------*/

  if (!is_elem) {
    char schemafile[MAX_STR];
    writecomponent(schemafile,test_dbdir,
                   adt2str,common,basic,testvdmadt2,testvdmadt2);
    open_input(schemafile);
    copy_file();
    close_input();
  }
  close_output();

/*--- preprocess .vdmfile --------------------------------------------*/

  { char vdmfile[MAX_STR];
    strdcpy2(vdmfile,testdir,vdmsourcefilename);
    preprocess(tmp,vdmfile,"");
  }
  deletefile(tmp);

/*--- read test values -----------------------------------------------*/

{ char datafile[MAX_STR];
  char tmp3[MAX_STR];

  writecomponent(datafile,test_dbdir,
                 is_elem ? adt1str : adt2str,
                 common,
                 basic,
                 is_elem ? testdata2 : testdata1,
                 testdata1);
  strdcpy2(tmp3,testdir,BBtempfilename3);
  preprocess(datafile,tmp3,"");

  open_input(tmp3);

  strdcpy2(tmp,testdir,BBtempfilename1);
  open_output(tmp);

  while ( (c1=fgetc(fr)) != EOF ) {
     if ( c1=='@' ) {
        c2=fgetc(fr);
        switch(c2) {
        case 'X':
        case 'Y':
        case 'Z': fprintf(fw,"@%c@",c2);
                  if( fgetc(fr) != '@' )
                    err_syn(datafile);
                  break;
        default:  fprintf(stderr,"\n*** illegal character '%c' detected!",c2);
                  err(CASE,datafile);
        }
     }
     else
        fputc(c1,fw);
  }
  close_input();
  close_output();
  deletefile(tmp3);
}

  open_input(tmp);
  user_trace && fprintf(stderr,"reading test values\n");
  if( (ptr=XTEXT=(STP)malloc(STM)) == NULL )
    err(MEM,"");
  ptr->NEXT=NULL;
  ptr->NAME=NULL;
  NXTEXT=0;
  fscanf(fr,"@X@=");
  while(the_sky_is_blue)
  { fscanf(fr,"%s",str);
    if(strcmp(str,"@Y@=")==0)
      break;
    user_trace && fprintf(stderr,"@X@ = %s\n",str);
    if( (ptr->NAME=malloc(strlen(str)+1)) == NULL )
      err(MEM,"");
    strcpy(ptr->NAME,str);
    if( (ptr->NEXT=(STP)malloc(STM)) == NULL )
      err(MEM,"");
    ptr=ptr->NEXT;
    ptr->NEXT=NULL;
    ptr->NAME=NULL;
    ++NXTEXT;
  }
  fscanf(fr,"%s",str);
  user_trace && fprintf(stderr,"@Y@ = %s\n",str);
  strcpy(YTEXT,str);
  do {
    fscanf(fr,"%s",str);
  }
  while(strcmp(str,"@Z@=")!=0);
  fscanf(fr,"%s",str);
  user_trace && fprintf(stderr,"@Z@ = %s\n",str);
  strcpy(ZTEXT,str);

  close_input();

  /****************************************************************************/
/*--- create test source file .c -------------------------------------*/

{ char testprog[MAX_STR];
  char tmp2[MAX_STR];

  writecomponent(tmp2,test_dbdir,
                 adt1str,common,basic,testcschema,testcschema);
  preprocess(tmp2,tmp,"");
  open_input(tmp);

  strdcpy2(tmp2,testdir,BBtempfilename2);
  open_output(tmp2);

  testcasecount=0;
  subcasecount=0;

  while( (c1=fgetc(fr)) != EOF )
  { if(c1=='\n')
      print=FALSE;
    if(c1=='@')
    { c2=fgetc(fr);
      if(up=(c2=='@'))
        c2=fgetc(fr);
      switch(c2)
      {
        case 'X': fprintf(fw,"%s",print?steuer(ptr->NAME,str):ptr->NAME);
                  if( fgetc(fr) != '@' )
                    err_syn(tmp);
                  break;
        case 'Y': fprintf(fw,"%s",print?steuer(YTEXT,str):YTEXT);
                  if( fgetc(fr) != '@' )
                    err_syn(tmp);
                  break;
        case 'Z': fprintf(fw,"%s",print?steuer(ZTEXT,str):ZTEXT);
                  if( fgetc(fr) != '@' )
                    err_syn(tmp);
                  break;
        case '(':
                  fprintf(fw,"  ");
                  xvaluecount=0;
                  ptr=XTEXT;
                  fpos=ftell(fr);
                  break;
        case ')': fprintf(fw,"  ");
                  xvaluecount++;
                  if(xvaluecount < NXTEXT)
                  { ptr=ptr->NEXT;
                    fseek(fr,fpos,0);
                  }
                  break;
        case 'N': testcasecount++;
                  subcasecount=0;
                  fprintf(fw,"%d%d%d%d",
                          testcasecount/1000,
                          (testcasecount%1000)/100,
                          (testcasecount%100)/10,
                          testcasecount%10);
                  if( fgetc(fr) != '@' )
                    err_syn(tmp);
                  break;
        case 'n': print=TRUE;
                  fprintf(fw,"%d,%d", testcasecount,++subcasecount);
                  if( fgetc(fr) != '@' )
                    err_syn(tmp);
                  break;
        case '!': { int h;
                    for(h=1; h<=testcasecount; ++h)
                      fprintf(fw,"        case %4d: p_%d%d%d%d(); break;\n",
                              h, h/1000, (h%1000)/100, (h%100)/10, h%10);
                  }
                  break;
        default:  fprintf(stderr,"\n*** illegal character '%c' detected!",c2);
                  err(CASE,tmp);
      }
    }
    else
      fputc(c1,fw);
  }
  close_input();
  deletefile(tmp);
  close_output();

#if ! flat
#else
  { char tmp3[MAX_STR];
  strdcpy2(tmp3,testdir,BBtempfilename3);
  solveincludes(test_dbdir,tmp2,tmp3);
  deletefile(tmp2);
  strcpy(tmp2,tmp3);
  }
#endif

  strdcpy2(testprog,testdir,csourcefilename);
  preprocess(tmp2,testprog,cbeauty_cmd);
  deletefile(tmp2);
}

/******************************************************************************/

  writecomponent(str,test_dbdir,aux,common,basic,BBmakefilename,BBmakefilename);
  open_input(str);

  strdcpy2(str2,testdir,Makefilename);
  open_output(str2);
  copy_file();
  close_input();
  close_output();

/******************************************************************************/

  err(END,testdir);
  return 0;
}
