// $Id: cmd.cc,v 1.1 1994/03/17 23:21:58 vdm Exp $

#include "cmd.hpp"

char * prompt = 0;

//--------------------------------------------------------------------

int exitcmd(int argc, char * argv[]) {
  return exit_executed; 
}

int noopcmd(int argc, char * argv[]) {
  return 0; 
}

int helpcmd(int argc, char * argv[]) {
  int i = 0;

  while ( commands[i].cn != 0 ) {
    cerr << commands[i].cn << "\t" << commands[i].params << endl;
    i++;
  }
  return 0;
}

//--------------------------------------------------------------------

cmdfct searchcmd(char * cn) {
  int i = 0;

  while ( commands[i].cn != 0 && strcmp(commands[i].cn,cn) != 0 ) 
    i++;

  return
    commands[i].cf;
}

//--------------------------------------------------------------------

int interpretcmd(int argc, char * argv[]) {
  if ( argc == 0 )
    return 0;

  cmdfct fct = searchcmd(argv[0]);
 
  return
    fct == 0 ? not_found : (*fct)(argc-1,argv+1);
}

//--------------------------------------------------------------------

int breakargs(char * str, char * args[]) {
  int ac;
  char * p;

  p = str, ac = 0, args[ac] = 0;

  while ( *p != 0 ) {
    if ( ! isspace(*p) ) {
      if (args[ac] == 0 )
        args[ac] = p;
    }
    else {
      if ( args[ac] != 0 ) {
        ac++, args[ac] = 0, *p = 0;
      }
    }
    p++;
  }

  if ( args[ac] != 0 ) {
    ac++, args[ac] = 0;
  }

  return ac;
}

//--------------------------------------------------------------------

int interpreterloop(void) {

  char		line[maxline];
  char *	args[maxargs];

  while ( 1 ) {
    if ( prompt )
      cout << prompt << flush;

    cin.getline(line,maxline);
    if ( cin.eof() )
      return 0;

    int ac = breakargs(line,args);

#ifndef NDEBUG
    for (int i = 0; i< ac; i++) {
      cerr << "args[" << i << "] = " << args[i] << endl;
    }
#endif

    int rc = interpretcmd(ac,args);

#ifndef NDEBUG
    cerr << "rc = " << rc << endl;
#endif

    if ( rc == exit_executed )
      return 0;
    if ( rc != 0 )
      return rc;
  }

  return 0;
}

//--------------------------------------------------------------------

