#include "cmds.h"
#include "proto.h"
#include "support.h"

int cmds_IgnoreCmd(ClientData clientData,Tcl_Interp *interp,int argc,char *argv[])
{
    sprintf(interp->result,"command ignored due to tcl version less than 7.5");
    return TCL_ERROR;
}

#ifdef TCL_CHANNEL_SUPPORT
#define TCL_CREATE_CMD(interp,cmdName,proc,clientData,deleteProc) \
	Tcl_CreateCommand(interp,cmdName,proc,clientData,deleteProc)
#else 
#define TCL_CREATE_CMD(interp,cmdName,proc,clientData,deleteProc) \
	Tcl_CreateCommand(interp,cmdName,cmds_IgnoreCmd,NULL,NULL)
#endif

void cmds_Init()
{
    Tcl_signalCmdInit();
    Tcl_killCmdInit();
}

void cmds_Done()
{
    Tcl_signalCmdDone();
}

int cmds_Register(Tcl_Interp *interp)
{
#ifdef TCL_CHANNEL_SUPPORT
    cmds_Init();
#endif
    TCL_CREATE_CMD(interp, "daemon", Tcl_daemonCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "reopen", Tcl_reopenCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "fork", Tcl_forkCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "reap", Tcl_reapCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "dup", Tcl_dupCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "pipe", Tcl_pipeCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "kill", Tcl_killCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "signal", Tcl_signalCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "setpgrp", Tcl_setpgrpCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "wait", Tcl_waitCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "waitpid", Tcl_waitpidCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "vt", Tcl_vtCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "ppid", Tcl_ppidCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "debug", Tcl_debugCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "getuid", Tcl_getuidCmd, NULL, NULL);
    TCL_CREATE_CMD(interp, "getgid", Tcl_getgidCmd, NULL, NULL);
    return 1;
}

int cmds_Unregister(Tcl_Interp *interp)
{
#ifdef TCL_CHANNEL_SUPPORT
    cmds_Done();
#endif
    return 1;
}
