#include <unistd.h>
#include <stdio.h>
#include <tcl.h>
#include "proto.h"
#include "support.h"

#ifdef TCL_CHANNEL_SUPPORT

int Tcl_forkCmd(ClientData clientData,Tcl_Interp * interp,int argc,char *argv[])
{
    int pid;
    
    if (argc != 1) {
	interp->result = "wrong # args";
	return TCL_ERROR;
    }
	
    switch (pid = fork()) {
    case -1:
	Tcl_PosixError(interp); 
	return TCL_ERROR;
    case  0:
	break;
    default: 
	Tcl_DetachPids(1, &pid); 
    } 
    
    sprintf(interp->result, "%d", pid);
    return TCL_OK;
}

int Tcl_reapCmd(ClientData clientData,Tcl_Interp * interp,int argc,char *argv[]) 
{
    if (argc != 1) {
	interp->result = "wrong # args";
	return TCL_ERROR;
    }
    Tcl_ReapDetachedProcs();
    return TCL_OK;
}

#endif /* TCL_CHANNEL_SUPPORT */
