#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include "proto.h"
#include "compat.h"

#include "support.h"

#ifdef TCL_CHANNEL_SUPPORT


int Tcl_pipeCmd(ClientData clientData,Tcl_Interp * interp,int argc,char *argv[])
{
    FILE *infile,*outfile;
    char *tmps;
    int fd[2];
    int rc;
	
    if (argc != 1) {
	interp->result = 
	    "wrong # args";
	return TCL_ERROR;
    }

    if ( (rc=pipe(fd)) < 0) {
	Tcl_PosixError(interp);
	return TCL_ERROR;
    }
	
    if (!(infile=fdopen(fd[0],"r"))) {
	Tcl_PosixError(interp);
	return TCL_ERROR;
    }
	
	
    if (!(outfile=fdopen(fd[1],"a"))) {
	fclose(infile);
	Tcl_PosixError(interp);
	return TCL_ERROR;
    }
	
    setvbuf(infile, NULL, _IONBF, 0);
    setvbuf(outfile, NULL, _IONBF, 0);
	
    if (Tcl_EnterFile(interp,outfile,TCL_FILE_WRITABLE) != TCL_OK) {
	sprintf(interp->result,"failed to enter file");
	return TCL_ERROR;
    } 
	
    if ( (tmps=strdup(interp->result)) == (char*)0) {
	fclose(infile); 
	fclose(outfile);
	sprintf(interp->result,"failed memory allocation");
	return TCL_ERROR;
    }

    if (Tcl_EnterFile(interp,infile,TCL_FILE_READABLE) != TCL_OK) {
	sprintf(interp->result,"failed to enter file");
	return TCL_ERROR;
    }

    strcat(interp->result," ");
    strcat(interp->result,tmps);
    free(tmps);
    
    return TCL_OK;
}

#endif /* TCL_CHANNEL_SUPPORT */
