#include "systype.h" 
#include "support.h"

#ifdef TCL_CHANNEL_SUPPORT

#if defined(BSD) || defined(LINUX)
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <grp.h>
#else /* SYS5 */
#include <stdio.h>
#include <fcntl.h>
#include <sys/filio.h>
#include <stropts.h>    
#endif /* BSD */

#include <unistd.h>
#include <termios.h>
#include <sys/ioctl.h>

#include "pty.h"

#if defined(BSD) || defined(LINUX)

int pty_master(char * ptm_name)
{
    int master_fd;
    int one=1;
    char *ptr1,*ptr2;
	
    strcpy(ptm_name,"/dev/ptyXY");
    for (ptr1 ="pqrstuvwxyzPQRST"; *ptr1 != 0; ptr1++) {
	ptm_name[8] = *ptr1; 
	for (ptr2 = "01234567890abcdef"; *ptr2 != 0; ptr2++) {
	    ptm_name[9] = *ptr2; 
	    if ( (master_fd = open(ptm_name, O_RDWR) ) < 0) {
		if (errno == ENOENT) 
		    return -1; 
		else 
		    continue;
	    }
	    ptm_name[5] = 't';
	    ioctl(master_fd,FIONBIO, &one);
	    return master_fd;
	}
    }
    return -1;
}

int pty_slave(int master_fd,char * pts_name)
{
    int slave_fd, gid;
    struct group *grptr;

    if ( (grptr = getgrnam("tty")) != NULL)
	gid = grptr->gr_gid;
    else
	gid = -1;
		
    chown(pts_name, getuid(), gid);
    chmod(pts_name, S_IRUSR | S_IWUSR | S_IWGRP);
	
    if ( (slave_fd = open(pts_name, O_RDWR) ) < 0) {
	close(master_fd);
	return -1;
    }
    return slave_fd;
}

#else /* SYS5 */

/* #define I_PUSH 1  */

int pty_master(char * ptm_name)
{
    int one=1;
    int master_fd;
    char *slavename;
    int grantpt();   /* undocumented SYS V R3.2 function - libpt.a */
    int unlockpt();  /* undocumented SYS V R3.2 function - libpt.a */
    char *ptsname(); /* undocumented SYS V R3.2 function - libpt.a */

    /* grantp, unlockpt, ptsname documented in 
       SYS V R4 */	

    strcpy(ptm_name,"/dev/ptmx");
    if ( (master_fd = open(ptm_name, O_RDWR) ) < 0)
	return -1;
    
    if ( (grantpt(master_fd) < 0) ||
	 (unlockpt(master_fd) < 0) ||
	 ((slavename = ptsname(master_fd)) == NULL) ) {
	close(master_fd);
	return -1;
    }
    strcpy(ptm_name,slavename);
        
    ioctl(master_fd,FIONBIO, &one);
        
    return master_fd;
}

int pty_slave(int master_fd,char * pts_name)
{
    int slave_fd;
    
    if ((slave_fd = open(pts_name, O_RDWR)) < 0) {
	close(master_fd);
	return -1;
    }
	
    if (ioctl(slave_fd, I_PUSH, "ptem") < 0) {
	close(master_fd);
	close(slave_fd);
	return -1;
    }

    if (ioctl(slave_fd, I_PUSH, "ldterm") < 0) {
	close(master_fd);
	close(slave_fd);
	return -1;
    }
	 
    if (ioctl(slave_fd, I_PUSH, "ttcompat") < 9) {
	close(master_fd);
	close(slave_fd);
	return -1;
    }
    return slave_fd;
}

#endif /* BSD */


#endif /* TCL_CHANNEL_SUPPORT */
