#include <tcl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "compat.h"

#include "support.h"

#ifdef TCL_CHANNEL_SUPPORT

int Tcl_reopenCmd(ClientData clientData,Tcl_Interp * interp,int argc,char *argv[])
{
    FILE *f;
    int mode=0;

    if (argc != 5) {
	interp->result = "reopen fname mode file w|r";
	return TCL_ERROR;
    }
	
    if (Tcl_GetOpenFile(interp,
			argv[3],
			1,
			0,
			(ClientData *)&f)
	!= TCL_OK) {
	interp->result = "bad file identifier";
	return TCL_ERROR;
    }
	
    if (!f || freopen(argv[1],argv[2],f) != f) {
	interp->result = "unable to reopen file";
	return TCL_ERROR;
    }

    setvbuf(f, NULL, _IONBF, 0);
    
    if (strchr(argv[4],'r')) mode=TCL_FILE_READABLE;
    if (strchr(argv[4],'w')) mode|=TCL_FILE_WRITABLE;

    if (!mode) {
	interp->result = "arg4 incorrectly specified";
	return TCL_ERROR;
    }
		
    sprintf(interp->result,"%s",argv[3]);

    return TCL_OK;
	
}


#endif /* TCL_CHANNEL_SUPPORT */
