#include <sys/param.h>
#include <string.h>
#include <unistd.h>
#include <tcl.h>
#include <limits.h>
#include "proto.h"
#include "pty.h"
#include "compat.h"

#include "support.h"

#ifdef TCL_CHANNEL_SUPPORT

int Tcl_vtCmd(ClientData clientData,Tcl_Interp *interp,int argc,char *argv[])
{
    int master_fd,slave_fd;
    FILE *mf,*sf;
    char pty_name[PATH_MAX];
    char s1[80];
	
    if (argc != 1) {
	interp->result = "wrong # args";
	return TCL_ERROR;
    }
	
    master_fd = pty_master(pty_name);
    slave_fd = pty_slave(master_fd,pty_name);
    mf = fdopen(master_fd,"a+");
    sf = fdopen(slave_fd,"a+");
    Tcl_EnterFile(interp,sf,TCL_FILE_READABLE|TCL_FILE_WRITABLE);
    strcpy(s1,interp->result);
    Tcl_EnterFile(interp,mf,TCL_FILE_READABLE|TCL_FILE_WRITABLE);
    strcat(interp->result," ");
    strcat(interp->result,s1);
    return TCL_OK;
}


#endif /* TCL_CHANNEL_SUPPORT */

