#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "dp.h"


void communicate(int fd)
{
  char in[100],*res;

  if (rpc_MakeClient(fd) < 0) {
  	fprintf(stderr,"connection rejected\n");
  	return;
  }  
  fprintf(stderr,"connection accepted\n");
  
  for (;;) {
 	 if (gets(in) == NULL) {
 	 	 if (rpc_Close(fd) < 0) 
 	 	 	fprintf(stderr,"connection aborted\n");
 	 	 else
 	 	 	fprintf(stderr,"connection closed\n"); 
 	 	 return;
 	 }
 	 switch (rpc_Exec(fd,in,&res)) {
		case -1: fprintf(stderr,"connection error\n"); return;
		case  1: fprintf(stderr,"[error] ");
			 printf("%s\n",res); break;
		case  0: fprintf(stderr,"[ok] ",res); 
			 printf("%s\n",res); break;
  	}
  	free(res);
  }
}

main(argc,argv)
int argc;
char *argv[];
{
    int sockfd,port;
    struct sockaddr_in serv_addr;
    struct hostent *hp;
    struct servent *sp;
  
    if (argc < 3) {
	fprintf(stderr,"%s host port\n",argv[0]);
	exit(1);
    }
   
    if ( (hp = gethostbyname(argv[1]) ) == NULL) {
	char str[255];
	sprintf(str,"unknown host %s", argv[1]);
	perror(str);
	exit(1);
    }
  
    bzero( (char*) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = hp->h_addrtype;
    bcopy(hp->h_addr_list[0], (caddr_t)&serv_addr.sin_addr,hp->h_length);

    if ((port=atoi(argv[2])) == 0) {
	if ((sp = getservbyname(argv[2],"tcp")) == NULL) {
	    char str[255];
	    sprintf(str,"service %s/tcp unknown\n",argv[2]);
	    perror(str);
	    exit(1);
	} else port = sp->s_port;
    }
    serv_addr.sin_port = htons(port);
  
    if ( (sockfd = socket(AF_INET,SOCK_STREAM, 0)) < 0) {
  	perror("cannot open stream socket");
  	exit(1);
    }  
    
    if (connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
	perror("cannot connect to server");
	exit(1);
    }

    communicate(sockfd);
  
    close(sockfd);
    exit(0);
}
  
