#include "dp.h"

size_t writen(fd,ptr,nbytes)
int fd;
char *ptr;
size_t nbytes;
{
  size_t nleft, nwritten;
  
  nleft=nbytes;
  while (nleft > 0) {
  	nwritten = write(fd,ptr,nleft);
  	if (nwritten <= 0)
  		return nwritten;
  	
  	nleft -= nwritten;
  	ptr += nwritten;
  }
  return (nbytes - nleft);
}

size_t readn(fd,ptr,nbytes)
int fd;
char *ptr;
size_t nbytes;
{
	size_t nleft, nread;
	
	nleft = nbytes;
	while (nleft > 0) {
		nread = read(fd,ptr,nleft);
		if (nread < 0)
			return nread;
		else if (nread==0)
			break;
		
		nleft -= nread;
		ptr += nread;
	}
	return (nbytes - nleft);
}

char *readcr(fd)
int fd;
{
	size_t sz=MEMDIMSTEP,n,rc;
	char *ptr=malloc(sz+1),c;

	for (n=0;;) {
		if (n == sz) {
			char *p;
			sz+=MEMDIMSTEP;
			p=malloc(sz+1);
			strcpy(p,ptr);
			free(ptr);
			ptr=p;	
		}
		if ( (rc = readn(fd, &c, 1) ) == 1) {
			if (c == '\n') 
				break;
			ptr[n++] = c;
		} else {
  			free(ptr); 
  			return NULL;
		}		
	} 
	ptr[n]=0; 
	return ptr;
}

char *readdata(fd,size)
int fd;
size_t size;
{
	char *ptr=malloc(size+1);
	*ptr=0;
	if (readn(fd,ptr,size) != size) {
		free(ptr);
		return NULL;
	} else {
		ptr[size]=0;
		return ptr;
	}
}

int writedata(fd,ptr)
int fd;
char *ptr;
{
  return (writen(fd,ptr,strlen(ptr)) == strlen(ptr));   
}

int rpc_MakeClient(fd)
int fd;
{
  char *s;
  if ((s=readcr(fd) ) == NULL) return 0;
  if (!strstr(s,"accepted")) { free(s); return -1; }
  free(s);
  return 0;
}

int rpc_Close(fd)
int fd;
{
  char *s;
  int rc;
  
  if (!writedata(fd,"release.request\n")) return -1;
  if ( (s=readcr(fd)) == NULL) return -1;
  rc=(strstr(s,"release.response") == NULL)?-1:0;
  free(s);
  return rc; 
}

int rpc_Exec(fd,cmd,res)
int fd;
char *cmd;
char **res;
{
  char *s,len[10],status[10];
  size_t n;
  if (!writedata(fd,"data.request\n")) return -1;
  sprintf(len,"%ld",strlen(cmd));
  if (!writedata(fd,len) || !writedata(fd,"\n") || !writedata(fd,cmd)) return -1; 
  if ((s=readcr(fd) ) == NULL) return -1;
  if (sscanf(s,"%ld %s",&n,status) != 2) { free(s); return -1; }
  free(s);
  if ((*res=s=readdata(fd,n)) == NULL) return -1;
  if (!strcmp(status,"ok")) return 0;
  else return 1;
}
