# $Id: protocol.tcl,v 1.1 1996/09/05 07:03:29 vdm Exp $

# protcol_sendmsg
# 
# writes message to a channel with a specified type

proc protocol_sendmsg { channel msg {type ""} } {
    puts $channel "[string length "$msg"] $type"
    puts -nonewline $channel "$msg"
    flush $channel
}

# protocol_recvtypemsg
#
# read type of message and message from channel

proc protocol_recvtypemsg { channel typevar } { 
    upvar $typevar type

    gets $channel header
    if [eof $channel] {
	close $channel
	error "protocol: unexpected eof"
    }
    if [string length $header]==0 {
	error "protocol: length failure"
    }
    set type [lindex $header 1]
    return [set msg [read $channel [lindex $header 0]]]
}

# protocol_recvmsg
#
# read message, ignore type of message from channel

proc protocol_recvmsg { channel } {
    return [protocol_recvtypemsg $channel type]
}

