
/*
 * bg - A utility for putting an NT program into the background.
 *
 * Compile with -DHIDDEN to prevent the creation of a new console 
 * 
 * Intended to be compiled with a makefile like this:
 *
 * !include <ntwin32.mak>
 *
 * bg.exe:	bg.obj
 * 		$(link) $(conflags) -out:bg.exe bg.obj $(conlibs)
 * 
 * .c.obj:
 * 		$(cc) $(cflags) $(cvars) $*.c
 *
 *  
 */


#include <stdio.h>
#include <fcntl.h>
#include <winsock.h> 
#include <memory.h>
#include <string.h>
#include <io.h>
#include <stdlib.h> 

int Verbose = 0;

#define RCVSIZE 512


#ifdef HIDDEN
#define creation 0 
#else
#define creation (CREATE_NEW_CONSOLE|CREATE_NEW_PROCESS_GROUP)
#endif


main(int argc,char **argv) 
{
	char cmd[1024],*s;
	SECURITY_ATTRIBUTES saPipe; 
	PROCESS_INFORMATION pi;
	STARTUPINFO si;  /* for CreateProcess call */
	int r, n;
	
	cmd[0] = '\0';
	for ( n=1; n<argc; n++ ) {
		strcat(cmd,argv[n]);
		strcat(cmd," ");
	}

	saPipe.nLength = sizeof(SECURITY_ATTRIBUTES);
	saPipe.lpSecurityDescriptor = NULL;
	saPipe.bInheritHandle = FALSE;

	memset(&si, 0, sizeof(si));		
	if ((s=strrchr(argv[0],'.'))!=NULL) *s='\0';
	if ((s=strrchr(argv[0],'\\'))==NULL) s=argv[0];
	else s++;
	if (stricmp(s,"bgh")==0) { 
	  si.dwFlags = STARTF_USESHOWWINDOW;
	  si.wShowWindow = SW_HIDE;
	}
	 
	si.cb = sizeof(si);
	r = CreateProcess(NULL,  /* filename */
		cmd,  /* full command line for child */
		NULL,  /* process security descriptor */
		NULL,  /* thread security descriptor */
		FALSE,  /* inherit handles? */
		creation, /* creation flags */
		NULL,  /* inherited environment address */
		NULL,  /* startup dir; NULL = start in current */
		&si,  /* pointer to startup info (input) */
		&pi);  /* pointer to process info (output) */
	if (!r) {
		fprintf(stderr,"CreateProcess() failed");
		return 1;
	}
	if ( Verbose )
		fprintf(stderr,"CreateProcess for (%s) succeeded\n",cmd);
	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);
	return 0;
}
