# $Id: console.tcl,v 1.1 1996/09/05 07:03:38 vdm Exp $

set console_prompt1 "puts -nonewline \"vdmd > \""
set console_prompt2 "puts -nonewline \" > \""
set console_cmd ""

proc console_prompt {{no "1"}} {
    global console_prompt1 console_prompt2 event_done
    if $no==1 {
	puts -nonewline [eval $console_prompt1]
    } else {
	puts -nonewline [eval $console_prompt2]
    }
    set event_done 1
    flush stdout
}

proc console_event {} {
    global console_cmd

    set line [gets stdin]
    if [eof stdin] {
	puts ""
	exit 0
    }
    if { [string length $line] == 0 } {
	console_prompt
	return
    }
    set last [expr [string length $line]-1]
    if {[string last \\ $line]==$last} {
	set console_cmd "$console_cmd [string range $line 0 [expr $last-1]]"
	console_prompt 2
	return
    } else {
	set console_cmd "$console_cmd $line"
    }
    if [string length $console_cmd] {
	if [catch { set res [uplevel \#0 $console_cmd] } err] { 
	    puts "$err"
	} else { 
	    if [string length $res] { puts "$res" }
	}
	set console_cmd ""
    }
    console_prompt
    return
}

proc console {} {
    global tcl_prompt1 tcl_prompt2 console_prompt1 console_prompt2
    fconfigure stdin -buffering none
    fconfigure stdout -buffering none
    fconfigure stderr -buffering none
    set console_prompt1 "puts -nonewline console: ;$tcl_prompt1"
    set console_prompt2 "puts -nonewline console: ;$tcl_prompt2"
    console_prompt 
    fileevent stdin readable console_event
    event_loopforever
}
