# $Id: database.tcl,v 1.2 1996/09/18 12:23:55 vdm Exp $
# loaddb command with argument check
# if flat database implemetation file <db>.s is searched
# otherwise directory <db> is used

# Special server commands. The database name is ignored.

proc database_exit {} {
  global databaseloaded
  if {[string length [currdb]] && [databasechanged]} {
     puts stderr "WARNING: The database state is changed !\n"
     while {1} {
       puts -nonewline stderr "Save \[y/n\] ? "
       set answer [gets stdin]
       switch [string toupper $answer] {
          Y { break }
	  N { puts "";exit }
	  {} { puts "" }
       }
     
     } 
     storedb "$databaseloaded"
  }
}

proc database_init {} {
    atexit appendUnique "database_exit"
}

proc reloaddb { { db "" }} {
    global databaseloaded defaultdatabase

    server_Alert "database" "Reload request"

    if [string compare $db ""]==0 { set db $databaseloaded }
    if [string compare $db ""]==0 { set db $defaultdatabase }

    if [string compare [databaseimplementation] flat]==0 {
	if [file readable $db.s]==0 { error "VDM database file \"$db.s\" not found" }
	loaddatabase "$db.s"
    } else {
	if [file isdirectory $db]==0 { error "VDM database directory \"$db\" not found" }
	loaddatabase $db
    }

    return [set databaseloaded $db]
}

proc loaddb { { db "" }} {
    global env databaseloaded 

    set db ""
    if {$databaseloaded != {}} {
	return $databaseloaded
    }
    return [reloaddb $db]
}

proc currdb {} {
    global databaseloaded

    if [catch { set host "[exec hostname]:" }]==1 {
	set host ""
    }
    if {$databaseloaded == {}} {
	return ""
    }
    return "$host$databaseloaded"
}

# storedb command with argument check
# save current loaded database

proc storedb {{db ""}} {
    global databaseloaded

    server_Alert "database" "Store request"

    set db ""
    if [string compare $db ""]==0 { set db $databaseloaded }

    if [string compare $db ""]==0 { error "no VDM database loaded" }

    if [string compare [databaseimplementation] flat]==0 {
	storedatabase "$db.s"
    } else {
	storedatabase $db
    }
    set databaseloaded $db
}

# removedb is hardcoded and ignored in init.tcl

