# $Id: docu.tcl,v 1.2 1996/09/06 10:52:13 vdm Exp $

#-------------------------------------------------------------------------------

proc docu_predefined {} {
    return "\
<H3>predefined datatypes</H3>
<P>
[preprocessHyper predefined]
"
}

#-------------------------------------------------------------------------------

proc docu_general { adt } {
    return "\
<H3>general information about ADT $adt</H3>
<P>
[preprocessHyper getVsigDocu $adt com basic]
"
}

#-------------------------------------------------------------------------------


proc docu_feature { adt imp } {
    return "\
<H3>features of implementation $imp for ADT $adt</H3>
<P>
[preprocessHyper getVsigDocu $adt $imp basic]
"
}

#-------------------------------------------------------------------------------

proc docu_header {adt imp opr} {
    set type [opertype $adt $imp $opr]

    if {"$type" == "SPECIAL"} {
	return "<H3>operation $opr of implementation $imp for ADT $adt</H3><P>\n"
    } 
    if {"$type" == "COMMON"} {
	return "<H3>general operation $opr for ADT $adt</H3><P>\n"
    } 
    return "<H3>common operation $opr for all ADTs</H3><P>\n"
}

proc docu_body { adt imp opr } {
    global language

    set docu1 [preprocessHyper getVsigDocu $adt $imp $opr]
    set html "<P><H4>Description</H4><P>\n"
    if [string length $docu1]==0 {
	append html "no general description available"
    } else {
	append html "$docu1"
    }
    append html "<P>\n"

    if {"$language"=="C"} {
        set docu2 [preprocessHyper getCsigDocu $adt $opr]
        if [string length $docu2]!=0 {
	    append html "<P><H4>C protoype</H4><P>\n"
  	    append html "$docu2<P>"
        }
    }

    if {"$language"!="C"} {
        set docu3 [preprocessHyper getCppDocu $adt $opr]
        if {[string length $docu3] != 0} {
	    append html "<P><H4>C++ member function</H4><P>\n"
            if [string length $docu3]!=0 {
                append html "$docu3"
            } else {
                append html "not supported!"
            }
	    append html "<P>\n"
        }
    }
    return $html 
}

proc docu_collect {adt imp opr} {
    return "[docu_header $adt $imp $opr] [docu_body $adt $imp $opr]"
}
