# $Id: init.tcl,v 1.1 1996/09/05 07:03:40 vdm Exp $

proc init_Source {} {
    rename removedb ""
    proc removedb {} {}
}

proc init_RootDir {} {
    if {[config_getstr ServerRoot] != {}} {
	cd [config_getstr ServerRoot]
    }
}

proc init_Server {} {
    if [config_getbool ServerRPC] { 
	server_RPCInit [config_getstr PortRPC] 
    }
    if [config_getbool ServerTELNET] { 
	server_TELNETInit [config_getstr PortTELNET] 
    }
}

proc init_Daemon {} {
    set daemonpid [daemon]

    if [config_getbool ConsoleLogStderr] {
	if [catch {set f [open [config_getstr ConsoleLogRoot]/stderr.log w]} err]==1 {
	    error "Unable to create logfile: $err"
	}
	puts $f "** Daemon has unexpectedly terminated **"
	puts $f "Note: This message is overwritten if logging is started."
	close $f
    }

    if {$daemonpid} {
	puts "daemon running at pid $daemonpid"
	exit
    }

    if {[signal SIGCLD]} {
	signal SIGCLD SIG_DFL
    }
 
    if [config_getbool ConsoleLogStderr] {
	reopen "[config_getstr ConsoleLogRoot]/stderr.log" w stderr w
    }

    if [config_getbool ConsoleLogStdout] {
	reopen "[config_getstr ConsoleLogRoot]/stdout.log" w stdout w
    } 
}

