# $Id: preprocess.tcl,v 1.2 1996/09/18 12:23:55 vdm Exp $
#
# preprocess text for documentation

set baseimpl U
set cplus U

proc preprocess_init {} {
    global baseimpl cplus
    set baseimpl U
    set cplus U
}

proc operationtype1 lang {
    global baseimpl cplus

    operationtype $lang
    if {"$lang"=="C"}   {set cplus U   } else {set cplus D   }
    if {"$lang"=="A++"} {set baseimpl D} else {set baseimpl U}
    return
}

proc preprocessDocu {ishyper text} {
    global Vdmpp baseimpl cplus

    set docu ""
    if [string length $text]!=0 {
        if [catch {
	    if $ishyper {             
              set docu [exec $Vdmpp -E0 -L -R \
                      -DGEN_DOCU -DGEN_HYPER -DGEN_C -DGEN_ANSIC \
                      -${cplus}GEN_CPP -${baseimpl}BASEIMPL << $text]
	    } else {
	       set docu [exec $Vdmpp -E0 -L -R \
                      -DGEN_DOCU -DGEN_C -DGEN_ANSIC \
                      -${cplus}GEN_CPP -${baseimpl}BASEIMPL << $text]
	    } 
       } msg] {
	    # server_Alert "external $Vdmpp" "WARNING: Preprocessing failed"
	    # error "$Vdmpp failed: $msg"
	    # preprocessor errors are ignored
	    set docu "
WARNING:
an error occured during preprocessing the documentation
the documentation may be incomplete, the error message was:

$msg
"
	}
    }
    return $docu
}

# preprocess the result of a command

proc preprocessResult args {
    preprocessDocu 0 "[eval $args]"
}

proc preprocessHyper args {
    preprocessDocu 1 "[eval $args]"
}