# $Id: search.tcl,v 1.1 1996/09/05 07:03:40 vdm Exp $
#
# searching topics and fulltext
#


proc search_alltopics { adts impls opers {lang ""} } {
    upvar $adts alist
    upvar $impls ilist
    upvar $opers olist
    global language

    set oldlanguage $language
    if {$lang != {}} {setlanguage "$lang"}
    set alist [adts]
    foreach a $alist {
	foreach i [implementations $a] {
	    if [lsearch -exact $ilist $i]==-1 {lappend ilist $i}
	    foreach o [operations $a $i] {
		if [lsearch -exact $olist $o]==-1 {lappend olist $o}
	    }  
	}
    }
    setlanguage $oldlanguage
    set alist [lsort $alist]
    set ilist [lsort $ilist]
    set olist [lsort $olist]
}

proc search_topic { {adt ""} {impl ""} {oper ""} {lang ""}} {
    if {$adt == "" && $impl == "" && $oper == ""} { return ""}

    global language
    set oldlanguage $language
    if {$lang != {}} {setlanguage "lang"}
    set res ""
    foreach a [adts] {
	foreach i [implementations $a] {
	    foreach o [operations $a $i] {
		if {$adt != {} && [lsearch -exact $adt $a]==-1} continue
		if {$impl != {} && [lsearch -exact $impl $i]==-1} continue
		if {$oper != {} && [lsearch -exact $oper $o]==-1} continue
		lappend res [join "$a $i $o" .]
	    }
	}
    }
    setlanguage $oldlanguage
    return $res
}

proc search_full { key {adt ""} {impl ""} {oper ""} {lang ""} } {
    global language

    set oldlanguage $language 
    if {$lang != {}} {setlanguage "lang"}
    set res ""
    set topics "[search_topic $adt $impl $oper $lang]"
    foreach t $topics {
	set t [split $t .]
	set a [lindex $t 0]
	set i [lindex $t 1]
	set o [lindex $t 2]
	server_Alert "search machine" "searching in: $a.$i.$o"
	catch {
	    set docu [preprocessResult getVsigDocu $a $i $o]
	    if {$language == "C"} {
		append docu [preprocessResult getCsigDocu $a $o]
	    }
	    if {$language != "C"} {
		append docu [preprocessResult getCppDocu $a $o]
	    }
	    if [catch { set found [regexp "$key" "$docu"]} err]!=1 {  
		if {$found} {lappend res [join $t .]}
	    }     
	}
    }
    setlanguage $oldlanguage
    return $res
}


