# $Id: security.tcl,v 1.1 1996/09/05 07:03:40 vdm Exp $
#
# global security_Commands

proc security_Init {} {
    global security_Commands
    upvar security_Commands cmds

    set cmds ""
    #	lappend cmds "rw,session"
    lappend cmds "rw,databasechanged"
    lappend cmds "rw,specialops"
    lappend cmds "rw,operationtype1"
    lappend cmds "rw,preprocessDocu"
    lappend cmds "rw,preprocessResult"
    lappend cmds "rw,databaseimplementation"
    lappend cmds "rw,help"
    lappend cmds "rw,loaddb \[db\]"
    lappend cmds "rw,storedb \[db\]"
    lappend cmds "rw,currdb"
    lappend cmds "rw,existadt adt"
    lappend cmds "rw,existimp adt implementation"
    lappend cmds "rw,existoper adt implementation oper"
    lappend cmds "rw,existcomp adt implementation oper comp"
    lappend cmds "rw,adts"
    lappend cmds "rw,implementations adt"
    lappend cmds "rw,operations adt implementation"
    lappend cmds "rw,components adt implementation operation"
    lappend cmds "rw,implparams adt implementation"
    lappend cmds "rw,operparams adt implementation operation"
    lappend cmds "rw,selcomp adt implementation operation component"
    lappend cmds "rw,searchcomp adt implementation operation component"
    lappend cmds "rw,searchsign adt implementation operation component"
    lappend cmds "rw,predefined"
    lappend cmds "rw,adtdocu"
    lappend cmds "rw,docu"
    lappend cmds "rw,opertype"
    lappend cmds "rw,select filter \[...\]"
    lappend cmds "rw,solveincludes file"
    lappend cmds "rw,import file"
    lappend cmds "rw,export"
    lappend cmds "rw,partialexport"
    lappend cmds "rw,newcomponent adt implementation operation component file"
    lappend cmds "rw,removedb"
    lappend cmds "rw,removeadt adt"
    lappend cmds "rw,removeimpl adt implementation"
    lappend cmds "rw,removeoper adt implementation operation"
    lappend cmds "rw,removecomp adt implementation operation component"
    lappend cmds "rw,newadt adt"
    lappend cmds "rw,newimpl adt implementation"
    lappend cmds "rw,newoper adt implementation operation"
    lappend cmds "rw,newcomp adt implementation operation component" 
}

proc security_Show {} {
    global security_Commands
    puts "$security_Commands"
}

proc security_Rights cmd {
    global security_Commands
    set i [lsearch -regexp $security_Commands ".*\,$cmd\( .*|$)"]
    if {$i == -1} {
	return ""
    } 
    if {[regexp "(.*),$cmd\( .*|$)" [lindex $security_Commands $i] x m]} {
	return $m
    } else {
	return ""
    }
}

proc security_Allowed cmd {
    if {[security_Rights $cmd] != {}} {
	return 1
    } else {
	return 0
    }
}


security_Init

