# $Id: vdmdhelp.tcl,v 1.1 1996/09/05 07:03:41 vdm Exp $
#
# help routine for vdmd daemon

proc help args {
  global argv0 defaultdatabase
  return "$argv0: commands:
database access:                # All database names are ignored
  loaddb	\[ database \]	# load database  (default:defined in vdmd.conf)
  storedb	\[ database \]	# store database (default:database loaded)
  currdb			# list current database name
tests:
  existadt		adt
  existimpl		adt implementation
  existoper		adt implementation operation
  existcomp		adt implementation operation component
list database content:
  adts
  implementations	adt
  operations		adt implementation
  components		adt implementation operation
  implparams		adt implementation
  operparams            adt implementation operation
select components:
  selcomp		adt implementation operation component	# select component
  searchcomp		adt implementation operation component	# search component
  searchsign		adt implementation operation component	# search signature
select documentation:
  predefined						# predefined domains
  adtdocu						# docu about all ADTs
  docu			adt implementation operation	# docu about one operation
  opertype		adt implementation operation	# SPECIAL COMMON GENERAL
filter components:
  select		filter \[name ... \]
				# legal filter sets :
				# adttypes specialimpl specialops signcomps
				# filteradts filterimpl filteroper filtercomp
				# filterparams
  solveincludes		file	# solves includes in file with database components
				# and write result to stdout
database modification:
  import		file	# import components from file
  export			# export database as shell script
  partialexport			# export selected parts
  newcomponent		adt implementation operation component file
  removedb
  removeadt		adt
  removeimpl		adt implementation
  removeoper		adt implementation operation
  removecomp		adt implementation operation component
  newadt		adt
  newimpl		adt implementation
  newoper		adt implementation operation
  newcomp		adt implementation operation component
new server commands:
  control
  session 			# type session help for info
  directimport		text    # text in importformat
  exportformat		adt implementation operation component
  
misc:
  help				this message
  exit"
}

