# $Id: busy.tcl,v 1.1 1994/09/26 20:23:51 vdm Exp $
# changes curser to watch during execution of a command
# if window is a top level window all slaves are reconfigured
# to hinder building the whole window every time busy is called

proc busy args {
    setopt window	.
    setopt cursor	"watch"

    set windows $window
    if {"[winfo toplevel $window]" == "$window"} {
        set windows [pack slaves $window]
    }
    foreach w $windows {
        lappend old [lindex [$w configure -cursor] 4]
        $w configure -cursor $cursor
    }
    update
    set result [eval $args]
    foreach w $windows {
        $w configure -cursor [lindex $old 0]
        set old [lrange $old 1 end]
    }
    update
    return $result
}

proc busyCallDbm args { eval busy callDbm $args }

proc busyCallDbmToFile {cmd file} {busy callDbmToFile $cmd $file}
