
# $Id: communicate.tcl,v 1.2 1996/09/05 07:03:42 vdm Exp $
#
# openServer	: initialize server
# closeServer	: terminate server
# sendMessage	: let server evaluate a command
# getAnswer	: receive answer form sendMessage command
# callServer	: combine sendMessage and getAnswer
# sendCmd	: send a command to client to be evaluated without answer

# the server gets the same auto_path as the client

proc openServer servername {
  global auto_path

  if [file executable [lindex $servername 0]]==0 {
     error "can't find \"$servername\""
  }

  set fd [ open "| $servername" w+ ]
  puts   $fd "set auto_path \"$auto_path\""
  flush  $fd
  return $fd
}

proc closeServer fd {
  sendCmd $fd exit
  catch {close $fd}
}

proc sendMessage {fd cmd {cmdtype evalMessage}} {
  puts $fd "$cmdtype $cmd"
  flush $fd
}

proc sendCmd {fd cmd} {
  sendMessage $fd $cmd "evalCmd"
}

proc sendMessageToFile {fd cmd file} {
  sendMessage $fd [concat $file $cmd] evalMessageToFile 
}

proc getAnswer fd {
  gets $fd type
  gets $fd len
  set msg [read $fd $len]
  gets $fd 
  if [string compare $type "error"]==0 {
    error $msg
  }
  return $msg
}

proc callServer {fd cmd} {
  sendMessage $fd $cmd
  getAnswer $fd 
}

proc callServerToFile {fd cmd file} {
  sendMessageToFile $fd $cmd $file
  getAnswer $fd
}

# server commands
# sendAnswer	: send a result message or an error report back to client
# evalCmd	: evaluate command and ignore result
# evalMessage	: evaluate command and send result back to client

proc sendAnswer {type mes} {
  puts $type
  puts [string length $mes]
  puts $mes
  flush stdout
}

proc evalCmd args {
  catch {uplevel #0 $args}
  flush stdout
}

proc evalMessage args {
  if [catch {
    sendAnswer "ok" [ uplevel #0 $args ]
  } msg]==1 {
    sendAnswer "error" $msg
  }
}

proc evalMessageToFile {file args} {
  if [catch {
    set fid [open $file w]
    puts  -nonewline $fid [uplevel #0 $args]
    close $fid
    sendAnswer "ok" ""
  } msg]==1 {
    sendAnswer "error" $msg
  }
}

