# $Id: createmenu.tcl,v 1.3 1995/02/21 19:25:10 vdm Exp $

# -------------------------------------------------------------------------------

# createMenu creates one menu button and via addMenuEntries
# a pull down menue
# the button name is taken as a default for the menue name
# it can be overwritten by -text <text> option
# args act as option list
# this list is also passed to addMenuEnties

proc createMenu {menu button args} {
	set args1 $args
	set name [string tolower $button]
	setopt side left
	setopt text $button
	setopt underline 0
	setopt borderwidth 1
	setopt entries ""

	menubutton $menu.$name		\
		-text $text		\
		-menu $menu.$name.m	\
		-underline $underline	\
		-borderwidth $borderwidth

        menu $menu.$name.m -borderwidth $borderwidth
	pack $menu $menu.$name -side $side

	addMenuEntries $menu.$name.m $entries $args1
}

# -------------------------------------------------------------------------------

# createMenuBar creates a whole menue bar
# by calling createMenu for all entries in the buttons parameter
# args act as global option list for all menues
# -focus <window>	: option for any focus in
# -menubar yes		: option for call of tk_menuBar

proc createMenuBar {menu buttons args} {
	set args1 $args
	setopt relief raised
	setopt borderwidth 1
	setopt focus ""
	setopt menubar no

	frame $menu -relief $relief -borderwidth $borderwidth

	set menubuttons ""

	foreach i $buttons {
		eval createMenu $menu $i $args1
		lappend menubuttons "$menu.[string tolower [lindex $i 0]]"
	}

	if [string compare $focus ""]!=0 {
		bind $focus <Any-FocusIn> "
			if {(\"%d\" == \"NotifyVirtual\") && (\"%m\" == \"NotifyNormal\")} {
				focus $menu
			}
		"
	}

	if [string compare $menubar yes]==0 {
		eval tk_menuBar $menu $menubuttons
	}
}

# -------------------------------------------------------------------------------

# addMenuEntry creates one entry in a pull down menue
# args acts as option list

proc addMenuEntry {menubutton label command args} {
	setopt underline 0
	setopt type command
	setopt value ""

	if {"$type"=="command"} {
		$menubutton add command -label $label -command $command -underline $underline
	} elseif {"$type"=="radio"} {
		$menubutton add radio -label $label -variable $command -value $value
	}
}

# -------------------------------------------------------------------------------

# addMenuEntries creates alle entries in a pull down menue
# args my contain common options for all entries

proc addMenuEntries {menubutton entries args} {
	foreach i $entries {
		eval addMenuEntry $menubutton $i $args
	}
}

# -------------------------------------------------------------------------------

