# $Id: createtoplevel.tcl,v 1.3 1996/09/05 07:03:43 vdm Exp $

# topLevelWindow creates a top level window
# the name can be given by -window <windowname> (staring with a .)
# calls a routine given by -proc <routine> for setting window content
# and waits for input to a global variable given by -answer <global variable>
# the -proc option must be given
# default name is "a<windowname>
# result evaluation is done with a routine given by -evalresult <routine>
# 

proc topLevelWindow args {
    setopt window .toplevelwindow
    setopt answer "a$window"
    global $answer

    setopt title "Top Level Window"
    setopt iconname $title
    setopt proc none
    setopt evalresult none

    if [string compare $proc none]==0 return

    catch {destroy $window}

    toplevel $window
    wm title $window $title
    wm iconname $window $iconname

    eval $proc $window -answer $answer $args

    tkwait visibility $window
    grab set $window

    tkwait variable $answer

    # optionally call result evaluation routine
    if [string compare $evalresult none]!=0 {
        eval $evalresult $window -answer $answer $args
    }

    destroy $window
    update
    return [set $answer]
}

# test routine -----------------
#
#proc okButton {window args} {
#    setopt answer "a$window"
#    setopt text ok
#
#    button $window.ok -text $text -command "set $answer ok"
#    pack $window.ok
#}
#
#proc putsargs {window args} {
#   setopt answer "a$window"
#   global $answer
#
#   puts "$args"
#   set $answer "modyfied"
#}
# test call: topLevelWindow -proc okButton -evalresult putsargs

