# flatfname
#
# For portability. It its a bad idea to create files names aux.x.y.z or
# prn.a.b.c in a windows environment because aux and prn are treated as 
# devices. An ex. for export is prepended to the filenames.

proc flatfname_shorten path {
  regsub -all "./" $path "" path
  return $path
}

proc flatfname_make path {
  global platform_type
  if {$platform_type == "windows"} {
  	set dir [file dirname $path]
  	set fname [file tail $path]
 	if {[string index $fname 0] != "-"} { set fname "-$fname" }
	return [flatfname_shorten $dir/$fname]
  }
  return $path
}

proc flatfname_unmake path {
  global platform_type
  if {$platform_type == "windows"} {
  	set dir [file dirname $path]	
	set fname [file tail $path]
	if {[string index $fname 0] == "-"} { 
	  set fname [string range $fname 1 end]
        }
	return [flatfname_shorten $dir/$fname]
  }
  return $path
}
