#!/usr/bin/tclsh

# giftrans  - make images transparent

set giftrans_EXTERNAL ""

proc giftrans_init { external } {
  global giftrans_EXTERNAL 
  set giftrans_EXTERNAL "$external"
}

proc giftrans_supported {} {
  global giftrans_EXTERNAL
  return [string length "$giftrans_EXTERNAL"]
}

proc giftrans_errorcheck errfile {
  set err ""
  if [catch {
    set f [open $errfile]
    set msg [string trim [read $f [file size $errfile]]]
    close $f
  } err ]==1 {
    error "Error handling giftrans error files: $err"
  } 
  unlink $errfile
  if {$err != {}} {  error "Error from giftrans: $msg" }
}

proc giftrans_exec {fname tmpfile} {
  global giftrans_EXTERNAL platform_type
  if {$platform_type == "windows"} {
    catch { exec $giftrans_EXTERNAL -o$tmpfile -e$tmpfile.err -t #ffffff $fname}
    giftrans_errorcheck $tmpfile.err
    catch { exec $giftrans_EXTERNAL -o$fname   -e$tmpfile.err -B #bfbfbf $tmpfile}     
    giftrans_errorcheck $tmpfile.err
  } else {
    exec $giftrans_EXTERNAL -t #ffffff $fname > $tmpfile
    exec $giftrans_EXTERNAL -B #bfbfbf $tmpfile > $fname
  }
  catch { unlink $tmpfile }
}



