
# listboxwlsb.tcl,v 1.4 1995/03/08 12:08:29 vdm Exp
# create a new widget $w for a listbox with scrollbar and label
# args act as option list

proc listboxWithLabelAndScrollbar {w labeltext selectvar args} {
    setopt relief raised
    setopt labelrelief flat
    setopt geometry 20x12
    setopt borderwidth 1

    frame     $w
    label     $w.label  -text	$labeltext			\
			-relief	$labelrelief			\
			-borderwidth	$borderwidth
    label     $w.select -textvariable	$selectvar		\
			-relief		$relief			\
			-borderwidth	$borderwidth
    scrollbar $w.scroll -command	"$w.list yview"		\
			-borderwidth	$borderwidth
    listbox   $w.list   -yscroll	"$w.scroll set"		\
			-relief		$relief			\
			-borderwidth	$borderwidth		\
			-setgrid	yes

    global tk_version
    if {$tk_version >= 4.0} {
	set wh		[split $geometry x]
	set width	[lindex $wh 0]
	set height	[lindex $wh 1]
        $w.list configure -width $width -height $height
    } else {
        $w.list configure -geometry $geometry
    }

    pack      $w.label  -side top  -fill both
    pack      $w.select -side top  -fill both
    pack      $w.list   -side left -fill both
    pack      $w.scroll -side left -fill y
}

