
# messagebox.tcl,v 1.4 1994/08/28 12:02:14 vdm Exp
# error messages for VDM Tk applications

# top level message box ---------------
# use topLevelWindow to built a top level message bos

proc MessageBox {Message ButtonNames args} {
   eval topLevelWindow	-window		.message		\
			-title		Message			\
			-proc		createMessageBox	\
			-text		[list $Message]		\
			-buttons	[list $ButtonNames]	\
			-answer		MessageBoxAns		\
			$args
}

proc createMessageBox {window args} {
    setopt text		""
    setopt aspect	120
    setopt borderwidth	1
    setopt buttons	""
    setopt answer	""

    global $answer

    message $window.mess -text $text -aspect $aspect
    pack append $window $window.mess bottom

    foreach buttonname $buttons {
        button $window.x$buttonname           \
                -borderwidth    $borderwidth    \
                -text           $buttonname     \
                -command        "set $answer [lsearch $buttons $buttonname]"
        pack append $window $window.x$buttonname left
    }
}

proc ErrorMessage {msg args} {
    eval MessageBox [list $msg] ok -title error -aspect 500 $args
}

proc DoesNotExist {something args} {
       eval MessageBox [list "$something not found, \
please check VDM Class Library installation and \
enviroment variable \"VDMROOT\""] quit -title "installation error" -aspect 400 $args
       exit 1
}

proc CommunicationError {msg args} {
    global VdmDbManager

    eval MessageBox [list "Communication error with Vdm database manager \
\"$VdmDbManager\"

$msg
"] quit -title error -aspect 400 $args
    exit 1
}

