proc platform_init {} {  
  global tcl_platform platform_exeext platform_tclshell platform_type 
  global platform_os argv0
  set platform_exeext ""
  set platform_type ""
  set platform_os ""
  if {[info exists tcl_platform]} {
    set platform_type "$tcl_platform(platform)"
    set platform_os "$tcl_platform(os)"
    switch $tcl_platform(platform) {
      unix {}
      windows { set platform_exeext ".exe" }
    }
  }  
}

proc platform_path path {
  global platform_type
  if {$platform_type == "windows"} {
    regsub -all / $path \\ path
  }
  return $path 
}

proc unlink { file } {
  global platform_type platform_os
  switch "$platform_type" {
    windows { 
      set file [platform_path $file]
      switch $platform_os {
	Win95 { exec command /c del $file }
        "Windows NT" { exec cmd /c del $file }
	default { exec command /c del $file } 
      }      
    } 
    default { exec /bin/rm -f $file} 
  }
}


