
# $Id: supervise.tcl,v 1.2 1996/09/05 07:03:45 vdm Exp $
# execute a command and report an error message
# input : "cmd"			to be evaluated
#	: "msg"			error message
#	: "errorhandler"	error handler routine
# output:			command result
#       :			or empty argument in case of an error
#	:			and the error handler does not abort the program

proc supervise {cmd {msg ""} {errorroutine "error"}} {
  if [catch { set r [ uplevel #0 $cmd ] } emsg ] {
    if [string compare $msg ""]!=0 { set msg "$msg:\n" }
    $errorroutine "$msg$emsg"
    return ""
  }
  return $r
}

