
# sysinit.tcl,v 1.7 1995/02/11 14:20:19 vdm Exp
# system initialisation routine
# define system wide variables
# and test existence of programs and files

set SystemInitialized 0

proc SystemInit { { manager "" } } {
  global	env	argc	argv
  global	VdmSystemRoot	VdmSystemLibrary	VdmSystemDatabase
  global	Vdmpp		VdmTmpFile		VdmPid
  global	VdmDbManager	VdmFd			VdmEditor
  global	TraceSource	SystemInitialized	VdmTclDir
  global	VdmSystemBinary
  global	VdmDbmBitmap	VdmHelpBitmap		VdmDocuBitmap

  if $SystemInitialized return

  set SystemInitialized 1
  if [info exists env(VDMROOT)] {
    set VdmSystemRoot $env(VDMROOT)
  } else {
    set VdmSystemRoot /usr/local
  }
  set VdmSystemBinary	$VdmSystemRoot/bin
  set VdmSystemLibrary	$VdmSystemRoot/lib
  set VdmSystemDatabase	$VdmSystemLibrary/vdmdb-c
  set Vdmpp		$VdmSystemLibrary/vdmpp
  set VdmTclDir		$VdmSystemLibrary/vdm
  if {$manager == {}} {
     set VdmDbManager $VdmTclDir/dbm
  } else {
     set VdmDbManager $manager
  }

  set VdmDbmBitmap ""
  set VdmHelpBitmap ""
  set VdmDocuBitmap ""
  if [file exists $VdmTclDir/vdmdbm.xbm ] { set VdmDbmBitmap  @$VdmTclDir/vdmdbm.xbm  }
  if [file exists $VdmTclDir/vdmhelp.xbm] { set VdmHelpBitmap @$VdmTclDir/vdmhelp.xbm }
  if [file exists $VdmTclDir/vdmdocu.xbm] { set VdmDocuBitmap @$VdmTclDir/vdmdocu.xbm }

  set TraceSource	$VdmTclDir/communicate.trc
  set VdmFd		""
  set VdmPid		[ pid ]
  set VdmTmpFile	/tmp/vdm-$VdmPid
  if [info exists env(EDITOR)] {set VdmEditor $env(EDITOR)} else {set VdmEditor xedit}

  return
}

proc VdmSystemInit {} {SystemInit}
