# $Id: watchprocess.tcl,v 1.3 1996/09/05 07:03:46 vdm Exp $
# procedure for watching, whether a background process is still working
# first argument is process id
# optional arguments 
#    -interval	: time in msec
#    -command	: action to be executed after process died
#
#example call
#    set pid [exec xedit file &]
#    watchprocess $pid -interval 5000 -command {set newtext [exec cat file]}

proc waitforprocess {process args} {

    setopt interval	200

    while [catch {exec ps $process}] {
        after 500
    }
}

proc watchprocess {process args} {

   setopt interval	1000
   setopt command	""

   if [catch {exec ps $process}] {
      eval $command
   } else {
      after $interval watchprocess $process	\
		-interval $interval		\
		-command [list $command] $args
   }
}
