: Bourne Shell

#---------------------------------------------------------------
#-  $Id: vdminfo.sh,v 1.2 1994/05/07 13:06:54 vdm Exp $
#---------------------------------------------------------------

headline()
 { echo ""
   echo "$1"
   echo `echo "$1" | sed 's|.|=|g'`
   echo ""
 }

#main program
ROOT=$VDMROOT
[ "$ROOT" = "" ] && ROOT=/usr/local
vdmdir="$ROOT/lib"
vdmbin="$ROOT/bin"

vdmdb="$vdmdir/vdmdb-c"
defvdmdb=$vdmdb
cpp="$ROOT/lib/vdmpp -E0 -L -R -DGEN_DOCU -DGEN_C -DGEN_ANSIC"
vdmdbm="$vdmbin/vdmdbm -c"
pr="pr -4 -b -t"
post="$pr"

dbtype=XXXX

constr=""
impln=""
opname=""

adttypes=REAL
sigs=""
command=""
detailed=0

parseopt=1
while [ $# -ne 0 ] && [ $parseopt -eq 1 ]
do
   case $1 in
      -B*) vdmdb=`echo $1 | sed 's/-B//'`
           shift
      ;;
      -l*) vdmdb=$vdmdir/vdmdb-`echo $1 | sed 's/-l//'`
           shift
      ;;
      -c)    sigs="$sigs csig"
             shift
      ;;
      -c++)  sigs="$sigs cpp"
             shift
      ;;
      -m | -p) shift
      ;;
      -d)  detailed=1
           post=$cpp
           shift
      ;;
      -a)  adttypes="$adttypes INTERNAL"
           shift
       ;;
      -e)  command="predefined"
           shift
       ;;
      -*)  echo "$0: unknown option $1 ignored"
           shift
      ;;   
      *) parseopt=0
      ;;
   esac
done

if [ "$dbtype" = "FLAT" ] && [ ! -f "$vdmdb.s" ]
   then
     echo "$0: flat database \"$vdmdb.s\" not found"
     exit 1
fi

if [ "$dbtype" != "FLAT" ] && [ ! -d "$vdmdb" ]
   then
     echo "$0: directory \"$vdmdb\" not found"
     exit 1 
fi

if [ "$command" = "" ]
then
  if [ $# -eq 0 ]
  then
    if [ "$detailed" -eq 1 ]
    then
      command="adtdocu"
    else
      command="adts"
    fi
  else
    constr=$1
    shift
    if [ $# -eq 0 ]
    then
      if [ "$detailed" -eq 1 ]
      then
        command="impdocu"
      else
        command="implementations"
      fi
    else
      impln=$1
      shift
      if [ $# -eq 0 ]
      then
        if [ "$detailed" -eq 1 ]
        then
          command="oprdocu"
        else
          command="operations"
        fi
      else
        opname=$1
        command="op1docu"
      fi
   fi
fi   
fi   

#list predefined domains
#=======================

if [ "$command" = "predefined" ]
then
  (echo loaddb $vdmdb
   echo newlines
   echo $command
   echo exit
  ) | $vdmdbm | $cpp
  exit
fi


#list available constructors
#===========================

if [ "$command" = "adts" ] || [ "$command" = "adtdocu" ]
then
  if [ $vdmdb = $defvdmdb ]
  then
    echo "Usage: $0 [<option>...] [<constr> [<impl> [<opr>]]]"
    echo "Options:"
    echo " -e        : give predefined elementary domains "
    echo " -a        : list internal ADTs also"
    echo " -d        : detailed documentation "
    echo " -c        : additional ANSI-C prototypes"
    echo " -c++      : additional C++ member function declarations"
    echo " -B<vdmdb> : selects vdm database (default: $defvdmdb )"
    echo " -l<d>     : selects vdm database '$vdmdir/vdmdb-<d>'"
  fi

  headline "constructors in VDM ADT database \"$vdmdb\""

  (echo loaddb $vdmdb
   echo newlines
   echo adttypes $adttypes
   echo $command
   echo exit
  ) | $vdmdbm | $post 

  echo ""
  exit
fi

#list available implementations
#==============================

if [ "$command" = "impdocu" ] || [ "$command" = "implementations" ]
then

  headline "implementations for constructor \"$constr\""
  (echo loaddb $vdmdb
   echo newlines
   echo specialimpl com aux sign
   echo $command $constr
   echo exit
  ) | $vdmdbm | $post

  echo ""
  exit
fi

#list available operations
#=========================

if [ "$command" = "oprdocu" ] || [ "$command" = "operations" ]
then
   [ "$command" = "operations" ] && \
   headline "operations of implementation \"$impln\" for constructor \"$constr\""

  (echo loaddb $vdmdb
   echo newlines
   echo specialoper basic rename signature gcinfo cvfromtup1 cvtotup1 mk_one mkn_empty
   echo signcomps $sigs
   echo $command $constr $impln
   echo exit
  ) | $vdmdbm | $post

  echo ""
  exit
fi

#list one operation
#==================

if [ "$command" = "op1docu" ]
then
  echo ""

  (echo loaddb $vdmdb
   echo newlines
   echo signcomps $sigs
   echo $command $constr $impln $opname
   echo exit
  ) | $vdmdbm | $cpp

  echo ""
  exit
fi
 
