
/* $Id: vdmtcl.cc,v 1.2 1996/09/05 07:03:22 vdm Exp $ */

/*----------------------------------------------------------------------------*/

#ifndef MYTCL_C
#define MYTCL_C

#include <tcl.h>


/*----------------------------------------------------------------------------*/

#ifndef ApplicationName
#define ApplicationName "vdmtcl"
#endif

/*--- macros for simplifying tcl calls ---------------------------------------*/

#define CreateCmd(name)\
  Tcl_CreateCommand(interp,#name,Tcl_##name##Cmd,(ClientData *)0,(Tcl_CmdDeleteProc *)0)

#define CmdProc(name)\
  int Tcl_##name##Cmd(ClientData clientdata, Tcl_Interp * interp, int argc, char * argv[])

#define Return(r)\
  Tcl_SetResult(interp,(r),TCL_STATIC);return TCL_OK

#define ReturnSTR(s)\
  Tcl_SetResult(interp,STR2char(s),freeSTRchar);return TCL_OK

#define ReturnBOOL(b)\
  Return((b) ? "1" : "0")

#define Error(r)\
  Tcl_SetResult(interp,(r),TCL_STATIC);return TCL_ERROR

#define ArgEq(i)\
  if (argc == (i)) ; else {Error("wrong # args");}

#define ArgGe(i)\
  if (argc >= (i)) ; else {Error("wrong # args");}

#define ArgLe(i)\
  if (argc <= (i)) ; else {Error("wrong # args");}

#define Assign(var,val)\
  Tcl_SetVar(interp,#var,val,0)

#define AssignGlobal(var,val)\
  Tcl_SetVar(interp,#var,val,TCL_GLOBAL_ONLY)

#define Read(var)\
  Tcl_GetVar(interp,#var,0)

#define ReadGlobal(var)\
  Tcl_GetVar(interp,#var,TCL_GLOBAL_ONLY)

#define ReadArray(var,index)\
  Tcl_GetVar2(interp,#var,#index,0)

#define ReadGlobalArray(var,index)\
  Tcl_GetVar2(interp,#var,#index,TCL_GLOBAL_ONLY)

#define Eval(cmd)\
  Tcl_GlobalEval(interp,cmd)

#define SetApplicationRcFile()\
  tcl_RcFileName =  "~/." ApplicationName "rc"

#define Prompt1()\
  AssignGlobal(tcl_prompt1,"puts -nonewline \"" ApplicationName " > \"")

#define Prompt2()\
  AssignGlobal(tcl_prompt2,"puts -nonewline \"> \"")

/*--- conversion between VDM strings and Tcl strings -------------------------*/

char * STR2char (const STR & s) {
  char * str = new char [(s.len()+1).data];
  s.cpc(str);
        t("STR2char");
  return str;
}

void freeSTRchar (char * s) {
        t("freeSTRchar");
  delete [] s;
}

/*----------------------------------------------------------------------------*/

#endif

