
% global state handling ------------------------------------------------------------------

:- retractall(global_state(_, _)).
:- assert(global_state(dummy, undefined)).

set_variable(Variable, Value) :-
	(
	  retract(global_state(Variable, _OldValue))	% overwrite variable
		-> assert(global_state(Variable, Value))
	;
	  assert(global_state(Variable, Value))		% new variable
	).

read_variable(Variable, Value) :-
	global_state(Variable, Value).

change_variable(Variable, Value, Oldvalue) :-
	(
	    read_variable(Variable, Oldvalue) -> true
	;
	    Oldvalue = Value
	),
	set_variable(Variable, Value).


global_state :-						% failure driven loop
	repeat,
	( global_state(Var,Val),
	  writelist([Var,'	= ',Val]),
	  fail
	;
	  !
	).

% ----------------------------------------------------------------------------------------

new_value(Token) :-
	(
	    read_variable(tokenCnt, Value) ->
	    Token is Value + 1,
	    set_variable(tokenCnt, Token)
	;
	    set_variable(tokenCnt, 0),
	    Token = 0
	).

new_name(Prefix, Name) :-
	new_value(Token),
	name(Token, List2),
	name(Prefix,List1),
	append(List1, List2, List),
	name(Name, List).
