
% global state handling ------------------------------------------------------------------

:- retractall(global_state(_,_)).

new_variable(Variable,Value) :-
	(
	  global_state(Variable,_)
		-> writelist(['new_variable/2: global variable "'
			     ,Variable,'" already exists']),
		   fail
	;
	  assert(global_state(Variable,Value))
	).

set_variable(Variable,Value) :-
	(
	  retract(global_state(Variable,_OldValue))	% overwrite variable
		-> assert(global_state(Variable,Value))
	;
	  writelist(['set_variable/2: global variable "',Variable,'" does not exist']),
	  fail
	).

read_variable(Variable,Value) :-
	(
	  global_state(Variable,Value)
		-> true
	;
	  writelist(['read_variable/2: global variable "',Variable,'" does not exist']),
	  fail
	).


% generation and translation of names ----------------------------------------------------

:- new_variable(name_count,0).

new_name(N) :-
	read_variable(name_count,N),
	!,
	N1 is N + 1,
	set_variable(name_count,N1).

% ----------------------------------------------------------------------------------------
% new_name(+Prefix,-Name).
% generate a new identifier

new_name(Prefix,Name) :-
	name(Prefix,L0),
	new_name(N),
	name(N,L1),
	append(L0,[0'_|L1],L),
	name(Name,L).

% ----------------------------------------------------------------------------------------

