% $Id: input.pl,v 1.3 1995/08/11 17:28:36 vdm Exp $

% check filename type and compute output filename

texFileName(Filename, TeXFilename) :-
	once(texFileName1(Filename, TeXFilename)).

texFileName1(Filename, TeXFilename) :-
	name(Filename, List),
	append(Basename, ".vdm", List),
	append(Basename, ".tex", List1),
	name(TeXFilename, List1).

texFileName1(Filename, _) :-
	set_variable(errors,true),
	writelist(['wrong file extension in filename "', Filename, '" .vdm required']),
	fail.

% read a file   --------------------------------------------------------------------------
% read(+Filename,-CharList).

read_file(Filename,Chars) :-
	fileerrors(OnOff,off),		% switch errors off
	see(Filename),			% and read file
	read_chars(Chars),
	seen,
	fileerrors(_,OnOff),
	!.

read_file(Filename,[-1]) :-		% else return empty sequence
	set_variable(errors,true),
	writelist(['error in reading file "',Filename,'"']),
	fileerrors(_,on).		% and restore fileerrors flag

read_chars(Chars) :-
	get0(C),
	read_chars(C,Chars).

read_chars(-1,[-1]) :- !.
read_chars(X,[X|Xs]) :-
	get0(C),
	read_chars(C,Xs).

% ----------------------------------------------------------------------------------------

