
:- ensure_loaded(global_state).
:- ensure_loaded(input).
:- ensure_loaded(scanner).
:- ensure_loaded(message).
:- ensure_loaded(parser).
:- ensure_loaded(transform).
:- ensure_loaded(is_wellformed).
:- ensure_loaded(expression).
:- ensure_loaded(totex).
%:- ensure_loaded(ident).  % not yet needed

% ----------------------------------------------------------------------------------------

process(Filename) :-
	set_variable(filename,Filename),
	set_variable(errors,false),
	texFileName(Filename,TeXFilename),
	read_file(Filename,Chars),
	scan_chars(Chars,Symbols),
	parse_symbols(Symbols,SyntaxTree),
	is_wellformed(SyntaxTree),
	compile_tree(SyntaxTree,_Program),
	outTeX(SyntaxTree,TeXFilename).

process(_).

scan_chars(Chars,Symbols) :-
	read_variable(errors,false),
	phrase(symbols(Symbols),Chars),
	write_symbols(Symbols),
	errors_issued('lexical').

parse_symbols(Symbols,SyntaxTree) :-
	read_variable(errors,false),
	phrase(specification(SyntaxTree),Symbols,Rest),
	write_tree(SyntaxTree),
	write(Rest),nl,
	errors_issued('syntax').

is_wellformed(SyntaxTree) :-
	read_variable(errors,false),
	is_wf_specification(SyntaxTree),
	errors_issued('static semantics').

compile_tree(_,_).

