// String1 Klassse fuer Strings
// die sich wie unstrukturiete Werte
// verhalten
#ifndef BASICSTRING_H
 #define BASICSTRING_H

 #include <stdlib.h>
 #include <string.h>
 #include "types.hpp"

 typedef char * string;
 typedef unsigned int zahl;

 class Basicstring {
  protected:
   string s;
   zahl length;

  public:
   void indexcheck(zahl i){
    zahl sl = strlen(s);
    if (i >= length){
     cout << "// Basicstring1: Index error !(" << i << "<" << sl <<")\n";
     exit(1);
    }
   }

  public:
   Basicstring(){
    s = new char [1];
    s[0] = 0;
    length = 0;
   }

   Basicstring(string const x){
    length = strlen(x);
    s = new char [length + 1];
    strcpy(s,x);
   }

   Basicstring(const Basicstring & x){
    length = x.len();
    s = new char [length + 1];
    strcpy(s,x.s);
   }

   zahl len() const{
    return length;
   }

   friend bool operator == (const Basicstring & x1, const Basicstring & x2);

   friend bool operator != (const Basicstring & x1, const Basicstring & x2);

   friend bool operator < (const Basicstring & x1, const Basicstring & x2);

   friend bool operator > (const Basicstring & x1, const Basicstring & x2);

   Basicstring & operator = (const Basicstring & x){
    if (x.s != s){
     delete s;
     length = x.len();
     s = new char[length + 1];
     strcpy(s,x.s);
    }
    return *this;
   }

   Basicstring & operator = (string const x){
    delete s;
    length = strlen(x);
    s = new char[length + 1];
    strcpy(s,x);
    return *this;
   }

   operator string() const{
    return s;
   }

   char & operator [] (zahl i){
    indexcheck(i);
    return s[i];
   }

   Basicstring substr(nat0 apos, nat0 epos) const
   {
    if (apos <= len())
    {
     Basicstring temp(s + apos - 1);
     if (epos <= len()) temp[epos - apos + 1] = 0;
     return Basicstring(&temp[0]);
    }
    return Basicstring("");
   }

   ~Basicstring(){
    delete s;
   }

 };

extern bool operator == (const Basicstring & x1, const Basicstring & x2);
extern bool operator != (const Basicstring & x1, const Basicstring & x2);
extern bool operator < (const Basicstring & x1, const Basicstring & x2);
extern bool operator > (const Basicstring & x1, const Basicstring & x2);

#endif

