#include "node.hpp"
extern bool VDM_TRACE;

node::node()
{
  rule = (rulept)NULL;
  typ = UNKNOWN;
  prec = (node*)NULL;
  new_lay = bool(0);
  linenr = yylino;     // aus parse.hpp
}

node::node(const node & n)
{
  operator = (n);
}

node::node(rulept r,
	   const nodeseq & ns,
	   const parse_typ & t,
	   node * p)
{
  rule = r;
  terms = ns;
  typ = t;
  prec = p;
  new_lay = bool(0);
  linenr = yylino;     // aus parse.hpp
}

node::node(rulept r,
	   const parse_typ & t,
	   node * elem,
	   ...) // variable Argumentliste und ihr Name
{
  new_lay = bool(0);
  if (VDM_TRACE)
    cout << "\nKnoten:" << this << "  Terme:";
  va_list argp;
  va_start(argp, elem);

  while (elem != (node*)NULL)
    {
      if (VDM_TRACE)
	cout << elem << ", ";

      elem->prec = this;
      terms.add(elem);
      elem = va_arg(argp, node *);
    }

  if (VDM_TRACE) {
    cout << "\nRule = ";
    cout << (void *)r;
    cout << "; Typ = ";
    cout << t;
  }

  linenr = yylino;     // aus parse.hpp
  rule = r;
  node * tmp = this;

  if(( t == UNKNOWN ) && ( rule != (rulept)NULL ))
    typ = (parse_typ)rule(terms, tmp, UNKNOWN);  // erster Typ-Ermittlungsversuch

  else if(t == FIRST)
    typ = UNKNOWN;   // erster Durchgang nur globale Typen

  else if(t == NEW_LAYER)
    {
      typ = UNKNOWN;
      new_lay = bool(1);
    }

  else if(t == NEW_LAYER_ACT)
    {
      typ = (parse_typ)rule(terms, tmp, NEW_LAYER_ACT);  // erster Typ-Ermittlungsversuch
      new_lay = bool(1);
    }

  else
    typ = t;

  prec = (node*)0;
}

node::~node()
{
  for(nat0 i = 1; i <= terms.len(); i++)
    delete terms.get(i);
}

void node::parse(bool newtypes)
{
  nat0 l = terms.len();

  if (VDM_TRACE)
    cout << "Parse-Knoten:" << this << "\n";

  if(new_lay)
    {
      if (VDM_TRACE)
	cout << "\nAdresse = " << this << "\n";
      make_layer();
    }

  for(nat0 i = 1; i <= l; i++)
    {
      if (VDM_TRACE)
	cout << "\nparse " << i;
      terms.get(i)->parse(newtypes);
      if (VDM_TRACE)
	cout << "\nsubtyp: " << terms.get(i)->typ;
    }

  if (VDM_TRACE)
    {
      cout << "\nRule = ";
      cout << (void *)rule;
      cout << "; Typ = ";
      cout << typ;
    }

  node * tmp = this;
  if (rule != (rulept)NULL)
    typ = (parse_typ)rule(terms, tmp, (newtypes ? UNKNOWN : typ));

  if (VDM_TRACE)
    cout << "\nErg-Typ = " << typ;

  //if(new_lay)   Killen mu Regel besorgen, da sie ueber mehrere
  // kill_layer();Knoten verteilt sein kann
}

node & node::operator = (const node & n)
{
  rule = n.rule;
  terms = n.terms;
  typ = n.typ;
  prec = n.prec;
  linenr = n.linenr;     // aus parse.hpp
  return *this;
}

bool node::operator == (const node & n)
{
  return bool((rule == n.rule) &&
	      (terms == n.terms) &&
	      (typ == n.typ) && 
	      (prec == n.prec) &&
	      (linenr == n.linenr)
	      );
}

bool node::operator != (const node & n)
{
  return bool(!(operator == (n)));
}

