#include "nodesba.hpp"

 /***************************************************************************
  ****** IMPLEMENTIERUNG: ***************************************************
  ***************************************************************************/


 node ** Basicarray_node::getmem(nat0 size)
 { TRACE("T ** Basicarray<T>::getmem "
	  << "(nat0 size = " << size << ");")
  node ** tf = new node *[size];
  assert(tf != NULL, 40);
  OUT( "new Basicarray<T>::feld: " << ADR(tf) << "; Gre: " << (size * (sizeof(node*))) )
  return tf;
 }

 void Basicarray_node::releasemem(node ** tf)
 { TRACE("void Basicarray<T>::releasemem "
	  << "(T ** tf = " << ADR(tf) << ");")
  if (tf != NULL)
  {
/*   for (nat0 i = 0; i < feldcount; i++)  // Eintrge mssen hier
   {                                       // selbst gelscht werden
    delete tf[i];
    OUT( "delete Basicarray<T>::feld[" << i << "]: " << ADR(tf[i]) )
   }   */
   delete tf;                          // Feld selbst lschen
   OUT( "delete Basicarray<T>::feld: " << ADR(tf) )
  }
 }

 nat0 Basicarray_node::indexcheck(nat0 i) const
 { OUT("nat0 Basicarray<T>::indexcheck "
	  << "(nat0 i = " << i << ");")
  assert(i < feldcount, 44);
  return i;
 }

 void Basicarray_node::copyliste(const Basicarray_node & a)
 { TRACE("void Basicarray<T>::copyliste "
	<< "(const Basicarray<T> & a); // Adresse a: " << ADR(a))
  for (nat0 i = 0; i < a.len(); i++)
  feld[i] = a.get(i + 1);
 }

 Basicarray_node::Basicarray_node (nat0 l,
		  nat0 d)
 { TRACE("Basicarray<T>(nat0 l = " << l
	     << ", nat0 d = " << d << ");")
  feldsize = l;
  delta = d;
  feldcount = 0;
  feld = getmem(l);
 }

 Basicarray_node::Basicarray_node (const Basicarray_node &a)
 { TRACE("Basicarray<T>(const Basicarray<T> &a); //Adresse a: " << ADR(a))
  feld = NULL;
  operator = (a);
 }

 Basicarray_node::~Basicarray_node ()
 { TRACE("~Basicarray<T>();")
  releasemem(feld);
 }

 nat0 Basicarray_node::add (node * Daten)
 { TRACE("nat0 Basicarray<T>::add "
	<< "(const T & Daten); // Adresse Daten: " << ADR(Daten))
  if (feldcount >= feldsize)             // Feldgrenze erreicht? (Dynamik)
  {
   assert(delta > 0, 8);                 // Fehler, wenn kein Zuwachs erlaubt
   node ** temp = getmem(feldsize + delta); // neues Feld anlegen
   for (nat0 i = 0; i < feldcount; i++)  // alte Eintrags-Adressen kopieren
    temp[i] = feld[i];
   releasemem(feld);                         // altes Feld lschen
   OUT( "delete Basicarray<T>::feld: " << ADR(feld) )
   feld = temp;                          // neues Feld nach feld
   feldsize = feldsize + delta;          // neue Gesamt-Gre ermitteln
  }
  feld[feldcount] = Daten;               // neuer Eintrag
  OUT( "new Basicarray<T>::feld[" << feldcount << "]: " << ADR(feld[feldcount]) )
  feldcount = feldcount + 1;             // aktuelle Belegung hochzhlen
  return (feldcount);                    // Rckgabe des entspr. Index-Werts
 }

 nat0 Basicarray_node::del (const node * Daten, int deltype)
 { TRACE("nat0 Basicarray<T>::del "
	<< "(const T & Daten); // Adresse Daten: " << ADR(Daten))
  deltype = 0;     // noch nicht belegt, dient der Unterscheidung, s.o.
  nat0 pos = 0;    // steuert Aktivitt in folg. Schleife: Ist Eintrag
		   // noch nicht gefunden, dann weitersuchen, sonst
		   // wird pos mit i belegt und ab jetzt umgespeichert, um das
		   // entstandene "Loch" im Feld zu fllen
  for (nat0 i = 1; i <= feldcount; i++)
  {
   if (!pos)       // Eintrag noch nicht gefunden: Vergleichen
   {
    if (get(i) == Daten)
    {              // gefundenen Eintrag lschen
     feldcount -= 1;
     // delete feld[i - 1];
     pos = i;      // pos belegen, damit ab jetzt umgespeichert wird
     if (i < (feldcount + 1)) feld[i - 1] = feld[i];
    }              // entstandene Lcke fllen; feldcount + 1 ntig, da vorher
   }               // feldcount schon aktualisiert wurde ( -1 )
   else            // Eintrag gefunden: Umspeichern der Adressen
   {               // Lcke wird nach hinten durchgereicht
    if (i < (feldcount + 1)) feld[i - 1] = feld[i];
   }
  }
  return pos;
 }

 nat0 Basicarray_node::del (nat0 i)
 { TRACE("nat0 Basicarray<T>::del "
	<< "(nat0 i = " << i << ");")
  feldcount -= 1;
  for (nat0 z = i; z <= feldcount; z++)
  {                               // Umspeichern: Durchreichen der Lcke
   if (z < (feldcount + 1)) feld[z - 1] = feld[z];
  }
  return i;
 }

 void Basicarray_node::put (nat0 i, node * Daten)
 { TRACE("void Basicarray<T>::put "
	<< "(nat0 i = " << i
	<< ", const T & Daten); // Adresse Daten: " << ADR(Daten))
  feld[indexcheck(i - 1)] = Daten;
 }

 node * Basicarray_node::get (nat0 i) const
 { OUT("T Basicarray<T>::get "
	  << "(nat0 i = " << i << ") const;")
  return feld[indexcheck(i - 1)];
 }

 void Basicarray_node::insert (nat0 j, node * Daten)
 { TRACE("void Basicarray<T>::insert "
	<< "(nat0 j = " << j
	<< ", const T & Daten); // Adresse Daten: " << ADR(Daten))
  add(get(len()));               // Anhngen des letzten Wertes
  for (nat0 i = len() - 1; i > j; i--)
  {
   put(i, get(i - 1));           // Umspeichern der Vorgnger
  }
  put(j, Daten);                 // Ersetzen am "freigewordenen" Platz
 }

 node * Basicarray_node::operator[] (nat0 i)
 { TRACE("T & Basicarray<T>::operator[] "
	  << "(nat0 i = " << i << ");")
  return feld[indexcheck(i)];         // Indexbeginn wie fr Arrays: 0
 }

 void Basicarray_node::foreach(fpointer f, argtype arg)
 { TRACE("void Basicarray<T>::foreach "
	<< "(fpointer f, argtype arg);"
	<< " // Adressen: " << ADR(f) << "; " << ADR(arg))
  for (nat0 i = 0; i < feldcount; i++)
   f(feld[i], arg); // fr jeden Eintrag Funktion mit Argumenten aufrufen
 }

 nat0 Basicarray_node::len() const
 { OUT("nat0 Basicarray<T>::len() const;")
  return feldcount;
 }

 bool Basicarray_node::isin(const node * e) const
 { OUT("bool Basicarray<T>::isin(const T &e) const;")
  for (nat0 i = 1; i <= feldcount; i++)
  {            // jeden Eintrag auf Gleichheit testen, bis bereinstimmung
   if (e == get(i)) return bool(1);
  }
  return bool(0);
 }

 nat0 Basicarray_node::getsize() const
 { OUT("nat0 Basicarray<T>::getsize() const;")
  return feldsize;
 }

 nat0 Basicarray_node::getdelta() const
 { OUT("nat0 Basicarray<T>::getdelta() const;")
  return delta;
 }

 void Basicarray_node::setdelta(nat0 d)
 { TRACE("T & Basicarray<T>::setdelta "
	  << "(nat0 d = " << d << ");")
  delta = d;
 }

 void Basicarray_node::setsize(nat0 l)
 { TRACE("T & Basicarray<T>::setsize "
	  << "(nat0 l = " << l << ");")
  releasemem(feld);  // Achtung, Arrayinhalt geht verloren!
  feldsize = l;
  feldcount = 0;
  feld = getmem(l);
 }

 Basicarray_node & Basicarray_node:: operator = (const Basicarray_node & a)
 { TRACE("Basicarray<T> & Basicarray<T>::operator = "
	<< "(const Basicarray<T> & a); // Adresse a: " << ADR(a))
  if (&a != this)    // Keine Aktion, wenn Feld schon mit a bereinstimmt
  {
   releasemem(feld);        // Lschen des alten Feldes
   feldsize = a.getsize();  // neue Gre holen
   feld = getmem(feldsize); // Feld mit neuer Gre anlegen
   feldcount = 0;
   delta = a.getdelta();
   nat0 l = a.len();
   for (nat0 i = 0; i < l; i++)
    add(a.get(i + 1));      // neue Eintrge anlegen
  }
  return *this;
 }

 bool operator == (const Basicarray_node & a1, // Vergleich ( l1 = l2 )
			  const Basicarray_node & a2) // a1, a2: zu vergleichen
						    // return: gleich / ungl.
 { OUT("friend bool Basicarray::operator == "
		    << "(const Basicarray<T> & a1,"
		    << " const Basicarray<T> & a2);"
		    << " // Adressen : "
		    << ADR(a1) << "; " << ADR(a2))
  nat0 l1 = a1.len();
  nat0 l2 = a2.len();
  if (l1 == l2)                       // Lngenvergleich
  {
   for (nat0 i = 1; i <= l1; i++)
   {
    if (a1.get(i) != a2.get(i))       // einzelner Element-Vergleich
     return bool(0);                  // false bei erster Ungleichheit
   }
   return bool(1);                    // true nach Test aller Elemente
  }
  return bool(0);                     // false bei ungleicher Lnge
 }

 bool operator != (const Basicarray_node & a1, // Ungleich ( l1 /= l2 )
			  const Basicarray_node & a2) // s.o.
 { OUT("friend bool Basicarray::operator != "
		    << "(const Basicarray<T> & a1,"
		    << " const Basicarray<T> & a2);"
		    << " // Adressen : "
		    << ADR(a1) << "; " << ADR(a2))
  return bool(!(a1 == a2));
 }