#ifndef SEMAUX_H
#define SEMAUX_H
#include "semantic.hpp"

const NOWARN = 0,
      INCOMP = 1,
      DIFFTYP = 2;
typedef short warn_typ;
extern bool TRUEvalue; // zur Vermeidung von Initialisierungs-Fehler:
		  // "non-const & parameter init with rvalue"

extern void check_types(void);

//extern bool match_parameters(const t_typ & pre_t1, t_typ & t2, bool & output);

extern void eval_union(t_typ expression,
		const t_typ & filter,
		nat0seq & anzahl,
		bool & warning);

extern bool unary_ops(const t_typ & expression,
	       const t_typ & filter,
	       const String & error_message,
	       const nat0 & linenr,
	       nat0seq & anzahl,
	       const bool & output = bool(1),
	       bool & warn = TRUEvalue);

extern bool eval_equal(t_typ t1,
		t_typ t2,
		warn_typ & warning);

extern void make_layer(void);
extern void kill_layer(bool nur_id = 1);

extern nat0 make_text(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 make_quote(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

#endif