#include "sembin.hpp"

nat0 binary_expression1(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//ITERATE
 // if (t_akt== UNKNOWN)
 {
  nat0 expression1     = GET(1);
  nat0 expression2     = GET(2);
  nat0seq anzahl1, anzahl2;
  String op;
    op = "'**'";
    nat0seq tmp, tmp_2;
    bool warning1 = bool(0), warning2 = bool(0);
    unary_ops(expression1, T_REAL, "", adr->linenr, anzahl1, bool(0), warning1);
    unary_ops(expression2, T_NAT, "", adr->linenr, anzahl2, bool(0), warning2);
    if(anzahl2.len() == 0)
     VDM_ERROR(24, adr->linenr, "binary operator " + op + ", 2. operand");
    tmp.append(anzahl1);
    anzahl1 = nat0seq();
    warning1 = bool(0);
    unary_ops(expression1, T_MAP, "", adr->linenr, anzahl1, bool(0), warning1);
    warning1 = bool(0);
    unary_ops(expression1, T_FUNC, "", adr->linenr, tmp_2, bool(0), warning1);
    anzahl1.append(tmp_2);
    if(anzahl1.len() + tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "binary operator " + op + ", 1. operand");
    if(warning2 && (anzahl1.len() > 0))
     VDM_WARNING(1, adr->linenr, "binary operator " + op + ", 2. operand");
    nat0 i;
    bool isin = bool(0);
    warn_typ warn = NOWARN;
    bool incomp = bool(0);
    bool oldmath = MATH;
    MATH = bool(0);
    for(i = 1; i <= anzahl1.len(); i++)
    {
     if(eval_equal(TC.get_subtype(anzahl1.get(i), 1),
		   TC.get_subtype(anzahl1.get(i), 2), warn))
     {
      tmp.add(anzahl1.get(i));
      isin = bool(1);
      if(warn == INCOMP)
       incomp = bool(1);
     }
    }
    MATH = oldmath;
    if(!isin && (tmp.len() < 1))
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(incomp)
     VDM_WARNING(1, adr->linenr, "binary operator " + op);
    if(tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
 }
 // else return t_akt;
}

nat0 binary_expression2(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//COMP
 // if (t_akt== UNKNOWN)
 {
  nat0 expression1     = GET(1);
  nat0 expression2     = GET(2);
  nat0seq anzahl1, anzahl2;
  String op;
    op = "'comp'";
    nat0seq tmp;
    bool warning1 = bool(0), warning2 = bool(0);
    unary_ops(expression1, T_MAP, "", adr->linenr, anzahl1, bool(0), warning1);
    unary_ops(expression1, T_FUNC, "", adr->linenr, tmp, bool(0), warning2);
    anzahl1.append(tmp);
    if(anzahl1.len() == 0)
     VDM_ERROR(24, adr->linenr, "binary operator " + op + ", 1. operand");
    warning1 = bool(0);
    warning2 = bool(0);
    unary_ops(expression2, T_MAP, "", adr->linenr, anzahl2, bool(0), warning1);
    tmp = nat0seq();
    unary_ops(expression2, T_FUNC, "", adr->linenr, tmp, bool(0), warning2);
    anzahl2.append(tmp);
    if(anzahl2.len() == 0)
     VDM_ERROR(24, adr->linenr, "binary operator " + op + ", 2. operand");
    tmp = nat0seq();
    nat0 i,j;
    bool isin = bool(0);
    warn_typ warn = NOWARN;
    bool incomp = bool(0);
    bool oldmath = MATH;
    MATH = bool(0);
    for(i = 1; i <= anzahl1.len(); i++)
     for(j = 1; j <= anzahl2.len(); j++)
     {
      if((TC.get_type(anzahl1.get(i)) == TC.get_type(anzahl2.get(j))) &&
	 eval_equal(TC.get_subtype(anzahl1.get(i), 1),
		    TC.get_subtype(anzahl2.get(j), 2), warn))
      {
       nat0seq tmp2;
       tmp2.add(TC.get_subtype(anzahl2.get(j), 1));
       tmp2.add(TC.get_subtype(anzahl1.get(j), 2));
       tmp.add(TC.add_type(tmp2, T_MAP, T_MAP, adr, KNOWN));
       isin = bool(1);
       if(warn == INCOMP)
	incomp = bool(1);
      }
     }
    MATH = oldmath;
    if(!isin)
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(incomp)
     VDM_WARNING(1, adr->linenr, "binary operator " + op);
    if(tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
 }
 // else return t_akt;
}

nat0 binary_expression3(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//IMPLY
 // if (t_akt== UNKNOWN)
 {
  nat0 expression1     = GET(1);
  nat0 expression2     = GET(2);
  nat0seq anzahl1, anzahl2;
  String op;
    op = "=>";
    unary_ops(expression1, T_BOOL, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_BOOL, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
     return T_BOOL;
 }
 // else return t_akt;
}

nat0 binary_expression4(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//LOGIC_EQUAL, wie IMPLY
 return binary_expression3(terms, adr, t_akt);
}

nat0 binary_expression5(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//restrict_operator
 // if (t_akt== UNKNOWN)
 {
  nat0 expression1     = GET(1);
  nat0 binary_operator  = GET(2);
  nat0 expression2     = GET(3);
  nat0seq anzahl1, anzahl2;
  String op;
  switch(binary_operator)
  {
   case DOM_RSTR_TO: if(op == "") op = "'<:'";
   case DOM_RSTR_BY: if(op == "") op = "'<-:'";
   case RNG_RSTR_TO: if(op == "") op = "':>'";
   case RNG_RSTR_BY:
   {
    if(op == "") op = "':->'";
    t_typ zw;
    bool rng = bool(0);
    if((binary_operator == RNG_RSTR_TO) || (binary_operator == RNG_RSTR_BY))
    {
     zw = expression2;
     expression2 = expression1;
     expression1 = zw;
     rng = bool(1);
    }
    unary_ops(expression1, T_SET, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_MAP, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
    nat0 i,j;
    nat0seq tmp;
    bool isin = bool(0);
    warn_typ warn = NOWARN;
    bool incomp = bool(0);
    bool difftyp = bool(0);
    for(i = 1; i <= anzahl1.len(); i++)
     for(j = 1; j <= anzahl2.len(); j++)
     {
      nat0seq tmp2;
      tmp2.add(TC.get_subtype(anzahl2.get(j), (rng?2:1)));
      t_typ del = TC.add_type(tmp2, T_SET, T_SET, adr, KNOWN);
      if(eval_equal(anzahl1.get(i), del, warn))
      {
       tmp.add(anzahl2.get(j));
       isin = bool(1);
       if(warn == INCOMP)
	incomp = bool(1);
       if(warn == DIFFTYP)
	difftyp = bool(1);
      }
      TC.del_type(del);
     }
    if(!isin)
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(difftyp) // Set ist anderer Typ
     VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be the empty or the whole map");
    if(incomp)
     VDM_WARNING(1, adr->linenr, "binary operator " + op);
    if(tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
  }
 }
 return t_akt;
}

nat0 binary_expression6(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//multi_operator
 // if (t_akt== UNKNOWN)
 {
  nat0 expression1     = GET(1);
  nat0 binary_operator  = GET(2);
  nat0 expression2     = GET(3);
  nat0seq anzahl1, anzahl2;
  String op;
  switch(binary_operator)
  {
   case '*': if(op == "") op = "*";
   case '/':
   {
    if(op == "") op = "/";
    nat0seq tmp;          // pruefen
    unary_ops(expression1, T_REAL, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_REAL, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
    tmp.append(anzahl1);
    tmp.append(anzahl2);
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
   case DIV: if(op == "") op = "div";
   case REM: if(op == "") op = "rem";
   case MOD:
   {
    if(op == "") op = "mod";
    nat0seq tmp;          // pruefen
    unary_ops(expression1, T_INT, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_INT, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
    tmp.append(anzahl1);
    tmp.append(anzahl2);
    if(tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
   case AND:
   {
    op = "'and'";
    unary_ops(expression1, T_BOOL, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_BOOL, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
     return T_BOOL;
    break;
   }
   case INTER:
   {
    op = "'inter'";
    t_typ etyp = T_SET;
    nat0 ebez = T_SET;
    String styp = "set";
    unary_ops(expression1, etyp,
	      "binary operator " + op + ", 1. operand", adr->linenr, anzahl1);
    unary_ops(expression2, etyp,
	      "binary operator " + op + ", 2. operand", adr->linenr, anzahl2);
    nat0 i,j;
    warn_typ warn = NOWARN;
    bool difftyp = bool(0), incomp = bool(0);
    nat0seq tmp;
    for(i = 1; i <= anzahl1.len(); i++)
     for(j = 1; j <= anzahl2.len(); j++)
     {
      if(eval_equal(anzahl1.get(i), anzahl2.get(j), warn))
      {
       nat0seq tmp2, tmp3;
       if(warn == INCOMP)
	incomp = bool(1);
       if(warn == DIFFTYP)
	difftyp = bool(1);
       if((warn == INCOMP) || (warn == DIFFTYP))
       {
	tmp2.add(TC.get_subtype(anzahl1.get(i), 1));
	tmp2.add(TC.get_subtype(anzahl2.get(j), 1));
	tmp3.add(TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN));
	if(etyp == T_MAP)
	{
	 tmp2 = nat0seq();
	 tmp2.add(TC.get_subtype(anzahl1.get(i), 2));
	 tmp2.add(TC.get_subtype(anzahl2.get(j), 2));
	 tmp3.add(TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN));
	}
       }
       else
       {
	tmp3.add(TC.get_subtype(anzahl1.get(i), 1));
	if(etyp == T_MAP)
	 tmp3.add(TC.get_subtype(anzahl1.get(i), 2));
       }
       tmp.add(TC.add_type(tmp3, etyp, ebez, adr, KNOWN));
      }
     }
    if((tmp.len() == 0) && !MATH)
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(difftyp) // Set ist anderer Typ
     VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be\n a "
		 + styp + " of the union of those types");
    if(incomp)  // Set enthaelt noch andere Union-Typen
    {
     if(!MATH)
      VDM_WARNING(1, adr->linenr, "binary operator " + op);
     else
      VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be\n a "
		  + styp + " of the union of those types");
    }
    if(tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
  }
 }
 return t_akt;
}

nat0 binary_expression7(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//addi_operator
 // if (t_akt== UNKNOWN)
 {
  nat0 expression1     = GET(1);
  nat0 binary_operator  = GET(2);
  nat0 expression2     = GET(3);
  nat0seq anzahl1, anzahl2;
  String op;
  switch(binary_operator)
  {
   case '+': if(op == "") op = "+";
   case '-':
   {
    if(op == "") op = "-";
    nat0seq tmp;          // pruefen
    unary_ops(expression1, T_REAL, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_REAL, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
    tmp.append(anzahl1);
    tmp.append(anzahl2);
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
   case OR:
   {
    op = "'or'";
    unary_ops(expression1, T_BOOL, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_BOOL, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
     return T_BOOL;
    break;
   }
   case UNION: if(op == "") op = "'union'";
   case '\\': if(op == "") op = "'\\'";
   case '^': if(op == "") op = "'^'";
   case MUNION:
   {
    if (VDM_TRACE) cout << "\nin munion";
    if(op == "") op = "'munion'";
    t_typ etyp = T_SET;
    nat0 ebez = T_SET;
    String styp = "set";
    if(binary_operator == '^')
    {
     etyp = T_SEQ;
     ebez = T_SEQ;
     styp = "seq";
    }
    else if(binary_operator == MUNION)
    {
     etyp = T_MAP;
     ebez = T_MAP;
     styp = "map";
    }
    unary_ops(expression1, etyp,
	      "binary operator " + op + ", 1. operand", adr->linenr, anzahl1);
    unary_ops(expression2, etyp,
	      "binary operator " + op + ", 2. operand", adr->linenr, anzahl2);
    nat0 i,j;
    warn_typ warn = NOWARN;
    bool difftyp = bool(0), incomp = bool(0);
    nat0seq tmp;
    for(i = 1; i <= anzahl1.len(); i++)
     for(j = 1; j <= anzahl2.len(); j++)
     {
      if(eval_equal(anzahl1.get(i), anzahl2.get(j), warn))
      {
       nat0seq tmp2, tmp3;
       if(warn == INCOMP)
	incomp = bool(1);
       if(warn == DIFFTYP)
	difftyp = bool(1);
       if((warn == INCOMP) || (warn == DIFFTYP))
       {
	tmp2.add(TC.get_subtype(anzahl1.get(i), 1));
	tmp2.add(TC.get_subtype(anzahl2.get(j), 1));
	tmp3.add(TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN));
	if(etyp == T_MAP)
	{
	 tmp2 = nat0seq();
	 tmp2.add(TC.get_subtype(anzahl1.get(i), 2));
	 tmp2.add(TC.get_subtype(anzahl2.get(j), 2));
	 tmp3.add(TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN));
	}
       }
       else
       {
	tmp3.add(TC.get_subtype(anzahl1.get(i), 1));
	if(etyp == T_MAP)
	 tmp3.add(TC.get_subtype(anzahl1.get(i), 2));
       }
       tmp.add(TC.add_type(tmp3, etyp, ebez, adr, KNOWN));
      }
     }
    if((tmp.len() == 0) && !MATH)
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(difftyp) // Set ist anderer Typ
     VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be\n a "
		 + styp + " of the union of those types");
    if(incomp)  // Set enthaelt noch andere Union-Typen
    {
     if(!MATH)
      VDM_WARNING(1, adr->linenr, "binary operator " + op);
     else
      VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be\n a "
		  + styp + " of the union of those types");
    }
    if(tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
   case UPDATE:
   {
    op = "'++'";
    bool warning1 = bool(0), warning2 = bool(0);
    unary_ops(expression1, T_SEQ, "", adr->linenr, anzahl1, bool(0), warning1);
    unary_ops(expression2, T_MAP,
	      "binary operator " + op + ", 2. operand", adr->linenr, anzahl2);
    nat0seq tmp;
    warn_typ warn = NOWARN, warn2 = NOWARN;
    bool difftyp = bool(0), incomp = bool(0);
    nat0 i,j;
    for(i = 1; i <= anzahl1.len(); i++)
     for(j = 1; j <= anzahl2.len(); j++)
     {
      if(eval_equal(TC.get_subtype(anzahl2.get(j), 1), T_NAT1, warn))
      {
       if(eval_equal(TC.get_subtype(anzahl1.get(i), 1),
		     TC.get_subtype(anzahl2.get(j), 2), warn2))
       {
	if((warn2 == INCOMP) || (warn2 == DIFFTYP))
	{
	 nat0seq tmp2, tmp3;
	 tmp2.add(TC.get_subtype(anzahl1.get(i), 1));
	 tmp2.add(TC.get_subtype(anzahl2.get(j), 1));
	 tmp3.add(TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN));
	 tmp.add(TC.add_type(tmp3, T_SEQ, T_SEQ, adr, KNOWN));
	}
	else tmp.add(anzahl1.get(i));
       }
      }
     }
    anzahl1 = nat0seq();
    unary_ops(expression1, T_MAP, "", adr->linenr, anzahl1, bool(0), warning2);
    if((anzahl1.len() + tmp.len()) == 0)
     VDM_ERROR(24, adr->linenr, "binary operator " + op + ", 1. operand");
    warn = NOWARN;
    difftyp = bool(0);
    incomp = bool(0);
    for(i = 1; i <= anzahl1.len(); i++)
     for(j = 1; j <= anzahl2.len(); j++)
     {
      if(eval_equal(anzahl1.get(i), anzahl2.get(j), warn))
      {
       nat0seq tmp2, tmp3;
       if(warn == INCOMP)
	incomp = bool(1);
       if(warn == DIFFTYP)
	difftyp = bool(1);
       if((warn == INCOMP) || (warn == DIFFTYP))
       {
	tmp2.add(TC.get_subtype(anzahl1.get(i), 1));
	tmp2.add(TC.get_subtype(anzahl2.get(j), 1));
	tmp3.add(TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN));
	tmp2 = nat0seq();
	tmp2.add(TC.get_subtype(anzahl1.get(i), 2));
	tmp2.add(TC.get_subtype(anzahl2.get(j), 2));
	tmp3.add(TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN));
	tmp.add(TC.add_type(tmp3, T_MAP, T_MAP, adr, KNOWN));
       }
       else tmp.add(anzahl1.get(i));
      }
     }
    if((tmp.len() == 0) && !MATH)
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(difftyp) // Set ist anderer Typ
     VDM_WARNING(7, adr->linenr, "operator " + op +
		 ", result will be\n a seq or map of the union of those types");
    if(incomp)  // Set enthaelt noch andere Union-Typen
    {
     if(!MATH)
      VDM_WARNING(1, adr->linenr, "binary operator " + op);
     else
      VDM_WARNING(7, adr->linenr, "operator " + op +
		  ", result will be\n a seq or map of the union of those types");
    }
    if(tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
  }
 }
 return t_akt;
}

nat0 binary_expression8(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{//rel_operator
 // if (t_akt== UNKNOWN)
 {
  nat0 expression1     = GET(1);
  nat0 binary_operator  = GET(2);
  nat0 expression2     = GET(3);
  nat0seq anzahl1, anzahl2;
  String op;
  switch(binary_operator)
  {
   case '<': if(op == "") op = "<";
   case LESS_EQUAL: if(op == "") op = "<=";
   case '>': if(op == "") op = ">";
   case GREATER_EQUAL:
   {
    if(op == "") op = ">=";
    unary_ops(expression1, T_REAL, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_REAL, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
     return T_BOOL;
    break;
   }
   case '=':  if(op == "") op = "'='";
   case NOT_EQUAL:
   {
    if(op == "") op = "'<>'";
    if (VDM_TRACE) cout << "in =";
    warn_typ warn = NOWARN;
    if(!eval_equal(expression1, expression2, warn))
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(warn == DIFFTYP)
      VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be 'false'");
    if(warn == INCOMP)
     VDM_WARNING(1, adr->linenr, "binary operator " + op);
    return T_BOOL;
    break;
   }
   case IN_SET: if(op == "") op = "'in set'";
   case NOT_IN_SET:
   {
    if(op == "") op = "'not in set'";
    unary_ops(expression2, T_SET, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
    bool isin = bool(0);
    warn_typ warn = NOWARN;
    bool incomp = bool(0);
    bool difftyp = bool(0);
    for(nat0 i = 1; i <= anzahl2.len(); i++)
    {
     if (VDM_TRACE) cout << "\nanzahl2.get(i) = " << anzahl2.get(i) << " len " << TC.len_subtypes(anzahl2.get(i));
     if(eval_equal(TC.get_subtype(anzahl2.get(i), 1), expression1, warn))
      isin = bool(1);
     if(warn == INCOMP)
      incomp = bool(1);
     if(warn == DIFFTYP)
      difftyp = bool(1);
    }
    if(!isin)   // Element ist anderer Typ als zu testender
    {
     if(MATH)
      VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be 'false'");
     else
      VDM_ERROR(24, adr->linenr, "binary operator " + op);
    }
    if(difftyp) // Element ist anderer Compound-Typ als zu testender
     VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be 'false'");
    if(incomp)
     VDM_WARNING(1, adr->linenr, "binary operator " + op);
    return T_BOOL;
    break;
   }
   case SUBSET: if(op == "") op = "'subset'";
   case PSUBSET:
   {
    if(op == "") op = "'psubset'";
    unary_ops(expression1, T_SET, "binary operator " + op + ", 1. operand",
	      adr->linenr, anzahl1);
    unary_ops(expression2, T_SET, "binary operator " + op + ", 2. operand",
	      adr->linenr, anzahl2);
    nat0 i,j;
    bool isin = bool(0);
    warn_typ warn = NOWARN;
    bool incomp = bool(0);
    bool difftyp = bool(0);
    for(i = 1; i <= anzahl1.len(); i++)
     for(j = 1; j <= anzahl2.len(); j++)
     {
      if(eval_equal(anzahl1.get(i), anzahl2.get(j), warn))
       isin = bool(1);
      if(warn == INCOMP)
       incomp = bool(1);
      if(warn == DIFFTYP)
       difftyp = bool(1);
     }
    if(!isin)
     VDM_ERROR(24, adr->linenr, "binary operator " + op);
    if(difftyp) // Set ist anderer Typ
     VDM_WARNING(7, adr->linenr, "operator " + op + ", result will be 'false'");
    if(incomp)
     VDM_WARNING(1, adr->linenr, "binary operator " + op);
    return T_BOOL;
    break;
   }
  }
 }
 return t_akt;
}