#include "sempatt.hpp"

/*nat0 pattern_list_opt(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 if (t_akt == UNKNOWN)
 {
  return TC.add_value(nat0seq(), NOPAT, "NO_PATTERN", adr, KNOWN);
 }
 else return t_akt;
} */

nat0 pattern_identifier1(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 if (t_akt== UNKNOWN)
 {
  nat0 identifier = GET(1);
  t_typ typ = TC.layer_seek_type(LEXEMS.get(identifier));
  if(typ == UNKNOWN)
  {
   nat0seq tmp; //        noch nicht deklariert
   tmp.add(UNKNOWN);
   return TC.add_id(nat0seq(), VAR, identifier, adr, UNKNOWN);
  }
  else return typ;
 }
 else return t_akt;
}

nat0 pattern_identifier2(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  return TC.add_id(nat0seq(), DONTCARE, DONTCARE, adr, UNKNOWN);
 }
 // else return t_akt;
}

nat0 match_value1(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
// if (t_akt == UNKNOWN)
 {
  nat0 expression = GET(1);
//  nat0seq tmp(nat0(1), nat0(0));         /*noch nicht deklariert*/
//  tmp.add(expression);
  return TC.add_value(nat0seq(), expression, expression, adr, TC.get_state(expression));
 }
// else return t_akt;
}

nat0 match_value2(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 symbolic_literal = GET(1);
  if (TC.get_type(symbolic_literal) != T_SEQ)  // kein Text-Literal
  {
/*   nat0seq tmp(nat0(1), nat0(0));
   tmp.add(symbolic_literal);*/
   return TC.add_value(nat0seq(), symbolic_literal,
		      symbolic_literal, adr, CONST);
  }
  else return symbolic_literal;
 }
 // else return t_akt;
}

nat0 set_enum_pattern(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern_list_opt = GET(1);
  t_typ t = pattern_list_opt;
  if(TC.get_type(pattern_list_opt) == NOPAT)
   t = T_EMPTYSET;
  else
  {
   if(TC.len_subtypes(pattern_list_opt) > 1)
   {
    TC.put_type(pattern_list_opt, MULTI_PAT);
    TC.put_typename(pattern_list_opt, MULTI_PAT);
    nat0seq tmp(nat0(1), nat0(0));
    tmp.add(pattern_list_opt);
    t = TC.add_type(tmp, T_SET, T_SET, adr, CONST);
   }
   else
   {
    TC.put_type(pattern_list_opt, T_SET);
    TC.put_typename(pattern_list_opt, T_SET);
   }
  }
  return t;
 }
 // else return t_akt;
}

nat0 set_union_pattern(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern1 = GET(1);
  nat0 pattern2 = GET(2);
  t_typ t = pattern1;
  t_typ t1 = TC.get_type(pattern1);
  t_typ t2 = TC.get_type(pattern2);
  t_typ t3;
  if((t1 == VAR) || (t1 == DONTCARE) || (t1 == T_SET) || (t1 == T_EMPTYSET))
  {
   if(t1 == VAR)
    TC.put_type(pattern1, T_VARSET); // spaeter nur Sets binden
   if((t2 == VAR) || (t2 == DONTCARE) || (t2 == T_SET) || (t2 == T_EMPTYSET))
   {
    if(t2 == VAR)
     TC.put_type(pattern2, T_VARSET); //spaeter nur Sets binden
    nat0seq tmp;
    tmp.add(pattern1);
    tmp.add(pattern2);
    t = TC.add_type(tmp, MULTI_PAT, MULTI_PAT, adr);
   }
   else
   {
    if(t2 == MULTI_PAT)
    {
     if(((t3 = TC.get_type(TC.get_subtype(pattern2, 1))) == T_SET) ||
	       (t3 == T_VARSET))
     {
      TC.insert_subtype(pattern2, 1, pattern1);
      t = pattern2;
     }
     else
      VDM_ERROR(21, adr->linenr, TC.get_typename(TC.get_subtype(pattern2, 1)));
    }
    else
     VDM_ERROR(21, adr->linenr, TC.get_typename(t2));
   }
  }
  else
  {
   if((t1 == MULTI_PAT) && (((t3 = TC.get_type(TC.get_subtype(pattern1, 1))) ==
			     T_SET) || (t3 == T_VARSET)))
   {
    if((t2 == VAR) || (t2 == DONTCARE) || (t2 == T_SET))
    {
     TC.add_subtype(pattern1, pattern2);
     TC.put_type(pattern2, T_VARSET);
    }
    else
    {
     if(t2 == MULTI_PAT)
     {
      if(((t3 = TC.get_type(TC.get_subtype(pattern2, 1))) == T_SET) ||
	       (t3 == T_VARSET))
       TC.add_subtypes(pattern1, TC.get_subtypes(pattern2));
      else
       VDM_ERROR(21, adr->linenr, TC.get_typename(TC.get_subtype(pattern2, 1)));
     }
     else
      VDM_ERROR(21, adr->linenr, TC.get_typename(t2));
    }
   }
   else
    VDM_ERROR(21, adr->linenr, TC.get_typename(t1));
  }
  return t;
 }
 // else return t_akt;
}

nat0 seq_enum_pattern(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern_list_opt = GET(1);
  t_typ t = pattern_list_opt;
  if(TC.get_type(pattern_list_opt) == NOPAT)
   t = T_EMPTYSEQ;
  else
  {
   if(TC.len_subtypes(pattern_list_opt) > 1)
   {
    TC.put_type(pattern_list_opt, MULTI_PAT);
    TC.put_typename(pattern_list_opt, MULTI_PAT);
    nat0seq tmp(nat0(1), nat0(0));
    tmp.add(pattern_list_opt);
    t = TC.add_type(tmp, T_SEQ, T_SEQ, adr, CONST);
   }
   else
   {
    TC.put_type(pattern_list_opt, T_SEQ);
    TC.put_typename(pattern_list_opt, T_SEQ);
   }
  }
  return t;
 }
 // else return t_akt;
}

nat0 seq_conc_pattern(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern1 = GET(1);
  nat0 pattern2 = GET(2);
  t_typ t = pattern1;
  t_typ t1 = TC.get_type(pattern1);
  t_typ t2 = TC.get_type(pattern2);
  t_typ t3;
  if((t1 == VAR) || (t1 == DONTCARE) || (t1 == T_SEQ) || (t1 == T_EMPTYSEQ))
  {
   if(t1 == VAR)
    TC.put_type(pattern1, T_VARSEQ); // spaeter nur Seqs binden
   if((t2 == VAR) || (t2 == DONTCARE) || (t2 == T_SEQ) || (t2 == T_EMPTYSEQ))
   {
    if(t2 == VAR)
     TC.put_type(pattern2, T_VARSEQ); //spaeter nur Seqs binden
    nat0seq tmp;
    tmp.add(pattern1);
    tmp.add(pattern2);
    t = TC.add_type(tmp, MULTI_PAT, MULTI_PAT, adr);
   }
   else
   {
    if(t2 == MULTI_PAT)
    {
     if(((t3 = TC.get_type(TC.get_subtype(pattern2, 1))) == T_SEQ) ||
	       (t3 == T_VARSEQ))
     {
      TC.insert_subtype(pattern2, 1, pattern1);
      t = pattern2;
     }
     else
      VDM_ERROR(22, adr->linenr, TC.get_typename(TC.get_subtype(pattern2, 1)));
    }
    else
     VDM_ERROR(22, adr->linenr, TC.get_typename(t2));
   }
  }
  else
  {
   if((t1 == MULTI_PAT) && (((t3 = TC.get_type(TC.get_subtype(pattern1, 1))) ==
			     T_SEQ) || (t3 == T_VARSEQ)))
   {
    if((t2 == VAR) || (t2 == DONTCARE) || (t2 == T_SEQ))
    {
     TC.add_subtype(pattern1, pattern2);
     TC.put_type(pattern2, T_VARSEQ);
    }
    else
    {
     if(t2 == MULTI_PAT)
     {
      if(((t3 = TC.get_type(TC.get_subtype(pattern2, 1))) == T_SEQ) ||
	       (t3 == T_VARSEQ))
       TC.add_subtypes(pattern1, TC.get_subtypes(pattern2));
      else
       VDM_ERROR(22, adr->linenr, TC.get_typename(TC.get_subtype(pattern2, 1)));
     }
     else
      VDM_ERROR(22, adr->linenr, TC.get_typename(t2));
    }
   }
   else
    VDM_ERROR(22, adr->linenr, TC.get_typename(t1));
  }
  return t;
 }
 // else return t_akt;
}

nat0 tuple_pattern(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern_list = GET(1);
  if (TC.len_subtypes(pattern_list) < 2) // nur ein Pattern angegeben
   VDM_ERROR(23, TC.get_adress(pattern_list)->linenr, "mk-tuple");
  TC.put_type(pattern_list, T_PROD);
  TC.put_typename(pattern_list, T_PROD);
  return pattern_list;
 }
 // else return t_akt;
}

nat0 record_pattern(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 name             = GET(1);
  nat0 pattern_list_opt = GET(2);
  if (TC.get_type(TC.seek_tagfield(LEXEMS.get(name))) != T_COMP)
   VDM_ERROR(17, adr->linenr, LEXEMS.get(name));
  TC.put_type(pattern_list_opt, T_COMP);
  TC.put_typename(pattern_list_opt, name);
  return pattern_list_opt;
 }
 // else return t_akt;
}

nat0 pattern_list1(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern_list = GET(1);
  nat0 pattern      = GET(2);
  if (VDM_TRACE) cout << "\nweiteres Pattern: " << pattern << ":" << (char*)TC.get_typename(pattern);
  TC.add_subtype(pattern_list, pattern);
  if (VDM_TRACE) cout << "\nnach pattern";
  return pattern_list;
 }
 // else return t_akt;
}

nat0 pattern_list2(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern      = GET(1);
  nat0seq tmp(nat0(5), nat0(3));
  tmp.add(pattern);
  char * debug = (char*)TC.get_typename(pattern);
  if (VDM_TRACE) cout << "\nerstes Pattern = " << pattern << ":" << (char*)TC.get_typename(pattern);
  return TC.add_value(tmp, PAT_LIST, PAT_LIST, adr); // erstes Pattern einspeichern
 }
 // else return t_akt;
}

nat0 set_bind(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern = GET(1);
  nat0 expression = GET(2);
  nat0seq anzahl;
  unary_ops(expression, T_SET,"binary operator 'in set', 2. operand",adr->linenr,
		anzahl);
  bool isin = bool(0);
  warn_typ warn = NOWARN;
  bool incomp = bool(0);
  bool difftyp = bool(0);
  nat0seq tmp;
  for(nat0 i = 1; i <= anzahl.len(); i++)
  {
   if (VDM_TRACE) cout << "\nanzahl.get(i) = " << anzahl.get(i) << " len " << TC.len_subtypes(anzahl.get(i));
   if(eval_equal(pattern, TC.get_subtype(anzahl.get(i), 1), warn))
   {
    tmp.add(anzahl.get(i));
    isin = bool(1);
    if(warn == INCOMP)
     incomp = bool(1);
    if(warn == DIFFTYP)
     difftyp = bool(1);
   }
  }
  if(!isin)   // Element ist anderer Typ als zu testender
   VDM_ERROR(24, TC.get_adress(pattern)->linenr, "binary operator 'in set'");
  if(difftyp) // Element ist anderer Compound-Typ als zu testender
   VDM_WARNING(7, TC.get_adress(pattern)->linenr, "operator 'in set', result will be 'false'");
  if(incomp)
   VDM_WARNING(1, TC.get_adress(pattern)->linenr, "binary operator 'in set'");
  if(tmp.len() == 1)
   return tmp.get(1);
  else
   return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
 }
 // else return t_akt;
}

nat0 type_bind(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern = GET(1);
  nat0 type = GET(2);
  warn_typ warn = NOWARN;
  if(!eval_equal(pattern, type, warn))
   VDM_ERROR(24, TC.get_adress(pattern)->linenr, "type-bind");
  if(warn == INCOMP)
   VDM_WARNING(1, TC.get_adress(pattern)->linenr, "type-bind");
  return type;
 }
 // else return t_akt;
}

nat0 bind_list(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt)
{
 return 0;
}

nat0 multi_set_bind(const nodeseq & terms,
		    node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern_list = GET(1);
  nat0 expression   = GET(2);
  nat0seq anzahl;
  unary_ops(expression, T_SET,"binary operator 'in set', 2. operand",adr->linenr,
		anzahl);
  for(nat0 j = 1; j <= TC.len_subtypes(pattern_list); j++)
  {
   bool isin = bool(0);
   warn_typ warn = NOWARN;
   bool incomp = bool(0);
   bool difftyp = bool(0);
   for(nat0 i = 1; i <= anzahl.len(); i++)
   {
    if (VDM_TRACE) cout << "\nanzahl.get(i) = " << anzahl.get(i) << " len " << TC.len_subtypes(anzahl.get(i));
    if(eval_equal(TC.get_subtype(pattern_list, j),
		  TC.get_subtype(anzahl.get(i), 1), warn))
     isin = bool(1);
    if(warn == INCOMP)
     incomp = bool(1);
    if(warn == DIFFTYP)
     difftyp = bool(1);
   }
   if(!isin)   // Element ist anderer Typ als zu testender
    VDM_ERROR(24, TC.get_adress(pattern_list)->linenr, "binary operator 'in set'");
   if(difftyp) // Element ist anderer Compound-Typ als zu testender
    VDM_WARNING(7, TC.get_adress(pattern_list)->linenr, "operator 'in set', result will be 'false'");
   if(incomp)
    VDM_WARNING(1, TC.get_adress(pattern_list)->linenr, "binary operator 'in set'");
  }
  return T_BOOL;
 }
 // else return t_akt;
}

nat0 multi_type_bind(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 pattern_list = GET(1);
  nat0 type = GET(2);
  for(nat0 j = 1; j <= TC.len_subtypes(pattern_list); j++)
  {
   warn_typ warn = NOWARN;
   if(!eval_equal(TC.get_subtype(pattern_list, j), type, warn))
    VDM_ERROR(24, TC.get_adress(pattern_list)->linenr, "type-bind");
   if(warn == INCOMP)
    VDM_WARNING(1, TC.get_adress(pattern_list)->linenr, "type-bind");
  }
  return T_BOOL;
 }
 // else return t_akt;
}

nat0 type_bind_list(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt)
{
 return 0;
}