#include "semun.hpp"

nat0 unary_expression(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{ // inverse
 // if (t_akt== UNKNOWN)
 {
  nat0 expression = GET(1);
  nat0seq tmp,tmp2,tmp3;          // pruefen
  unary_ops(expression, T_INMAP,"operator inverse", adr->linenr, tmp);
  bool isin = bool(0);
  if(tmp.len() == 0)
   VDM_ERROR(24, adr->linenr, "operator inverse");
  for(nat0 i = 1; i <= tmp.len(); i++)
  {
   tmp3 = nat0seq();
   //if(TC.get_type(TC.get_subtype(tmp.get(i), 1)) != UNKNOWN)
   if(tmp.get(i) != T_EMPTYMAP)
   {
    tmp3.add(TC.get_subtype(tmp.get(i), 2));
    tmp3.add(TC.get_subtype(tmp.get(i), 1));
    tmp2.add(TC.add_type(tmp3, T_INMAP, T_INMAP, adr, KNOWN));
   }
   else if(!isin)
   {
    //tmp3.add(UNKNOWN);
    //tmp2.add(TC.add_type(tmp3, T_INMAP, "INMAP", adr, KNOWN));
    tmp2.add(T_EMPTYMAP);
    isin = bool(1);
   }
  }
  if(tmp2.len() == 1)
   return tmp2.get(1);
  else
   return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
 }
 // else return t_akt;
}

nat0 prefix_expression2(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 { // unary +, s. 4.4.1.1
  nat0 expression = GET(1);
  nat0seq tmp;

  // s. 4.4.1.1.1
  unary_ops(expression, T_REAL,"unary operator +",adr->linenr, tmp);

  // s. make_typ() in 4.4.1.1
  switch(tmp.len())
  {
   case 0 :{VDM_ERROR(24, adr->linenr, "unary operator +");
	    break;}
   case 1 :{return tmp.get(1);
	    break;}
   default:{return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
	    break;}
  }
 }
 return t_akt;
}

nat0 prefix_expression3(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 { // unary -, s.4.4.1.1
  nat0 expression = GET(1);
  nat0seq tmp;

  // s. make_typ() in 4.4.1.1
  unary_ops(expression, T_REAL,"unary operator -",adr->linenr, tmp);
  switch(tmp.len())
  {
   case 0 :{VDM_ERROR(24, adr->linenr, "unary operator -");
	   break;}
   case 1 :{if(TC.get_type(tmp.get(1)) == T_NAT1)	// s. 4.4.1.1.2
	    return TC.add_type(nat0seq(), T_INT, T_INT, adr, KNOWN);
	   return tmp.get(1);
	   break;}
   default:{for(nat0 i = 1; i <= tmp.len(); i++)
	    if(TC.get_type(tmp.get(i)) == T_NAT1)
	     tmp.put(i, TC.add_type(nat0seq(), T_INT, T_INT, adr, KNOWN));
	   return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
	   break;}
  }
 }
 return t_akt;
}

nat0 prefix_expression4(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{ // merge
 // if (t_akt== UNKNOWN)
 {
  nat0 h;
  nat0 expression = GET(1);
  nat0seq tmp;          // pruefen
  nat0seq anzahl;
  unary_ops(expression, T_SET,"operator merge",adr->linenr, tmp);
  nat0seq tmp2;          // pruefen
  bool isin = bool(0);
  for(h = 1; h <= tmp.len(); h++)
  {
   //if(TC.get_type(TC.get_subtype(tmp.get(h), 1)) != UNKNOWN)
   if(tmp.get(h) != T_EMPTYSET)
   {
    anzahl = nat0seq();
    unary_ops(TC.get_subtype(tmp.get(h), 1), T_MAP,
	 "operator merge", adr->linenr, anzahl);
    tmp2.append(anzahl);
   }
   else if(!isin)
   {
    //tmp3 = nat0seq();
    //tmp3.add(UNKNOWN);
    //tmp2.add(TC.add_type(tmp3, T_MAP, "MAP", adr, KNOWN));
    tmp2.add(T_EMPTYMAP);
    isin = bool(1);
   }
  }
  if(tmp2.len() == 0)
   VDM_ERROR(24, adr->linenr, "operator merge");
  if (tmp2.len() == 1)
   return tmp2.get(1);
  else
   return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
 }
 // else return t_akt;
}

nat0 prefix_expression1(const nodeseq & terms, node * adr, const parse_typ & t_akt)
{
 // if (t_akt== UNKNOWN)
 {
  nat0 unary_operator = GET(1);
  nat0 expression     = GET(2);
  nat0seq anzahl;
  switch(unary_operator)
  {

   case ABS    :	// s. 4.4.1.2
   {
    nat0seq tmp;
    unary_ops(expression, T_REAL,"operator abs",adr->linenr, tmp);
    switch(tmp.len())
    {
     case 0 :{VDM_ERROR(24, adr->linenr, "operator abs");
	      break;}
     case 1 :{if(TC.get_type(tmp.get(1)) == T_INT)	// s. 4.4.1.2.2
	       return TC.add_type(nat0seq(), T_NAT, T_NAT, adr, KNOWN);
	      return tmp.get(1);
	      break;}
     default:{for(nat0 i = 1; i <= tmp.len(); i++)
	       if(TC.get_type(tmp.get(i)) == T_INT)
		tmp.put(i, TC.add_type(nat0seq(), T_NAT, T_NAT, adr, KNOWN));
	      return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
	      break;}
    }
    break;
   }

   case FLOOR  :	// s. 4.4.1.2
   {
    nat0seq tmp;
    unary_ops(expression, T_REAL,"operator floor",adr->linenr, tmp);
    switch(tmp.len())
    {
     case 0 :{VDM_ERROR(24, adr->linenr, "operator floor");
	      break;}
     case 1 :{if(TC.get_type(tmp.get(1)) > T_INT)	// s. 4.4.1.2.3
	       return TC.add_type(nat0seq(), T_INT, T_INT, adr, KNOWN);
	      return tmp.get(1);
	      break;}
     default:{for(nat0 i = 1; i <= tmp.len(); i++)
	       if(TC.get_type(tmp.get(i)) > T_INT)
		tmp.put(i, TC.add_type(nat0seq(), T_INT, T_INT, adr, KNOWN));
	      return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
	      break;}
    }
    break;
   }

   case NOT    :	// s. 4.4.1.3
   {

    // s. 4.4.1.3.1
    unary_ops(expression, T_BOOL,"operator not",adr->linenr, anzahl);
    if(anzahl.len() == 1)
     return anzahl.get(1);
    else
     return TC.add_type(anzahl, T_UNION, T_UNION, adr, KNOWN);
    break;
   }

   case CARD   :   	// s. 4.4.1.4
   {

    // s. 4.4.1.4.1
    unary_ops(expression, T_SET,"operator card",adr->linenr, anzahl);

    // s. 4.4.1.4.2
    return TC.add_type(nat0seq(), T_NAT, T_NAT, adr, KNOWN);
    break;
   }

   case POWER  :   	// s. 4.4.1.5
   {

    // s. 4.4.1.5.1
    unary_ops(expression, T_SET,"operator power",adr->linenr, anzahl);
    nat0seq tmp;

    // s. 4.4.1.5.2
    for(nat0 i = 1; i <= anzahl.len(); i++)
    {
     if (VDM_TRACE) cout << "\nanzahl.get(i) = " << anzahl.get(i);
     nat0seq tmp2(nat0(1), nat0(0));
     tmp2.add(anzahl.get(i));
     tmp.add(TC.add_type(tmp2, T_SET, T_SET, adr, KNOWN));
    }
    if (VDM_TRACE) cout << "\ntmp.len = " << tmp.len();

    // s. 4.4.1.1 make_typ()
    if (tmp.len() == 1)
    {
     if (VDM_TRACE) cout << "\nsubtypes tmp = " << TC.get_subtype(tmp.get(1), 1);
     return tmp.get(1);
    }
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }

   case DUNION :	// s. 4.4.1.6
   {

    // s. 4.4.1.6.1
    unary_ops(expression, T_SET,"operator dunion",adr->linenr, anzahl);
    nat0seq tmp;
    nat0seq tmp2;

    // s. 4.4.1.6.2
    for(nat0 i = 1; i <= anzahl.len(); i++)
    {
     //if(TC.get_type(TC.get_subtype(anzahl.get(i), 1)) != UNKNOWN)
     if(anzahl.get(i) != T_EMPTYSET)
     {
      if(unary_ops(TC.get_subtype(anzahl.get(i), 1), T_SET,
		   "operator dunion", adr->linenr, tmp2, bool(0)))
       tmp.append(tmp2);
     }
     else if(!tmp.isin(anzahl.get(i))) tmp.add(anzahl.get(i));
    }

    // s. 4.4.1.1 make_typ()
    if(tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator dunion");
    if (tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }

   case DINTER :	// s. 4.4.1.6 und s.o.
   {
    unary_ops(expression, T_SET,"operator dinter", adr->linenr, anzahl);
    nat0seq tmp;          // pruefen
    nat0seq tmp2;          // pruefen
    for(nat0 i = 1; i <= anzahl.len(); i++)
    {
     //if(TC.get_type(TC.get_subtype(anzahl.get(i), 1)) != UNKNOWN)
     if(anzahl.get(i) != T_EMPTYSET)
     {
      if(unary_ops(TC.get_subtype(anzahl.get(i), 1), T_SET,
		   "operator dinter", adr->linenr, tmp2, bool(0)))
       tmp.append(tmp2);
     }
     else if(!tmp.isin(anzahl.get(i))) tmp.add(anzahl.get(i));
    }
    if(tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator dinter");
    if (tmp.len() == 1)
     return tmp.get(1);
    else
     return TC.add_type(tmp, T_UNION, T_UNION, adr, KNOWN);
    break;
   }

   case HD     :
   {
    nat0seq tmp;          // pruefen
    unary_ops(expression, T_SEQ, "operator hd", adr->linenr, tmp);
    switch(tmp.len())
    {
     case 0 :{VDM_ERROR(24, adr->linenr, "operator hd");
	      break;}
     case 1 :{//if(TC.get_type(TC.get_subtype(tmp.get(1), 1)) == UNKNOWN)
	      if(tmp.get(1) == T_EMPTYSEQ)
	       VDM_ERROR(27, adr->linenr, "");
	      else
	       return TC.get_subtype(tmp.get(1), 1);
	      break;}
     default:{nat0seq tmp2;
	      for(nat0 i = 1; i <= tmp.len(); i++)
	      {
	       //if(TC.get_type(TC.get_subtype(tmp.get(1), 1)) == UNKNOWN)
	       if(tmp.get(1) == T_EMPTYSEQ)
		VDM_WARNING(5, adr->linenr, "");
	       else
		tmp2.add(TC.get_subtype(tmp.get(i), 1));
	      }
	      if(tmp2.len() == 0)
	       VDM_ERROR(27, adr->linenr, "");
	      else if (tmp2.len() == 1)
	       return(tmp2.get(1));
	      else
	       return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
	      break;}
    }
    break;
   }
   case TL     :
   {
    nat0seq tmp;          // pruefen
    unary_ops(expression, T_SEQ,"operator tl",adr->linenr, tmp);
    switch(tmp.len())
    {
     case 0 :{VDM_ERROR(24, adr->linenr, "operator tl");
	      break;}
     case 1 :{//if(TC.get_type(TC.get_subtype(tmp.get(1), 1)) == UNKNOWN)
	      if(tmp.get(1) == T_EMPTYSEQ)
	       VDM_ERROR(28, adr->linenr, "");
	      else return tmp.get(1);
	      break;}
     default:{nat0seq tmp2;
	      for(nat0 i = 1; i <= tmp.len(); i++)
	      {
	       //if(TC.get_type(TC.get_subtype(tmp.get(1), 1)) == UNKNOWN)
	       if(tmp.get(1) == T_EMPTYSEQ)
		VDM_WARNING(6, adr->linenr, "");
	       else
		tmp2.add(tmp.get(i));
	      }
	      if(tmp2.len() == 0)
	       VDM_ERROR(28, adr->linenr, "");
	      else if (tmp2.len() == 1)
	       return(tmp2.get(1));
	      else
	       return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
	      break;}
    }
    break;
   }
   case LEN    :
   {
    nat0seq tmp;          // pruefen
    unary_ops(expression, T_SEQ,"operator len",adr->linenr, tmp);
    if(tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator len");
    return TC.add_type(nat0seq(), T_NAT, T_NAT, adr, KNOWN);
    break;
   }
   case ELEMS  :
   {
    nat0seq tmp;          // pruefen
    nat0 i;
    unary_ops(expression, T_SEQ,"operator elems",adr->linenr, tmp);
    if(tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator elems");
    nat0seq tmp2;
    for(i = 1; i <= tmp.len(); i++)
    {
     nat0seq tmp3(nat0(1), nat0(0));
     tmp3.add(TC.get_subtype(tmp.get(i), 1));
     tmp2.add(TC.add_type(tmp3, T_SET, T_SET, adr, KNOWN));
    }
    if(tmp2.len() == 1)
     return tmp2.get(1);
    else
     return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
   case INDS   :
   {
    nat0seq tmp;          // pruefen
    unary_ops(expression, T_SEQ,"operator inds",adr->linenr, tmp);
    if(tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator inds");
    tmp = nat0seq();
    tmp.add(TC.add_type(nat0seq(), T_NAT, T_NAT, adr, KNOWN));
    return TC.add_type(tmp, T_SET, T_SET, adr, KNOWN);
    break;
   }
   case CONC   :
   {
    nat0 h;
    nat0seq tmp;          // pruefen
    unary_ops(expression, T_SEQ,"operator conc",adr->linenr, tmp);
    nat0seq tmp2;          // pruefen
    for(h = 1; h <= tmp.len(); h++)
    {
     //if(TC.get_type(TC.get_subtype(tmp.get(h), 1)) != UNKNOWN)
     if(tmp.get(h) != T_EMPTYSEQ)
     {
      anzahl = nat0seq();
      unary_ops(TC.get_subtype(tmp.get(h), 1), T_SEQ,
	   "operator conc", adr->linenr, anzahl);
      tmp2.append(anzahl);
     }
     else if(!tmp2.isin(tmp.get(h))) tmp2.add(tmp.get(h));
    }
    if(tmp2.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator conc");
    if (tmp2.len() == 1)
     return tmp2.get(1);
    else
     return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
   case DOM    :
   {
    nat0seq tmp;
    nat0 i;
    unary_ops(expression, T_MAP,"operator dom",adr->linenr, tmp);
    if(tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator dom");
    nat0seq tmp2;
    for(i = 1; i <= tmp.len(); i++)
    {
     nat0seq tmp3(nat0(1), nat0(0));
     tmp3.add(TC.get_subtype(tmp.get(i), 1));
     tmp2.add(TC.add_type(tmp3, T_SET, T_SET, adr, KNOWN));
    }
    if(tmp2.len() == 1)
     return tmp2.get(1);
    else
     return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
   case RNG    :
   {
    nat0seq tmp;
    nat0 i;
    unary_ops(expression, T_MAP,"operator rng",adr->linenr, tmp);
    if(tmp.len() == 0)
     VDM_ERROR(24, adr->linenr, "operator rng");
    nat0seq tmp2;
    for(i = 1; i <= tmp.len(); i++)
    {
     nat0seq tmp3(nat0(1), nat0(0));
     tmp3.add(TC.get_subtype(tmp.get(i), 2));
     tmp2.add(TC.add_type(tmp3, T_SET, T_SET, adr, KNOWN));
    }
    if(tmp2.len() == 1)
     return tmp2.get(1);
    else
     return TC.add_type(tmp2, T_UNION, T_UNION, adr, KNOWN);
    break;
   }
  }
 }
 return t_akt;
}