#include "typcheck.hpp"
#include "y.tab.h"

extern int yydebug;
extern FILE * yyin;
extern int yyparse();

nat0 yylino = 1;

Basicarray_String LEXEMS(nat0(500), nat0(250));

nat0seq LINENR(nat0(100), nat0(25));

Basicarray_String ERRORS(nat0(100));

Basicarray_String WARNINGS(nat0(100));

String DATNAM;

int PARSE = FIRST;

String POLY = ""; // Zum Kennzeichnen der polymorphen Typvariablen

typCheck TC;

bool MATH = 0;  // Ist MATH gesetzt, sind Operationen auf Mengen und Listen
		// mit beliebigen Typen erlaubt (wie im math. Mengen-Modell)
		// sonst wird bei unterschiedlichen Typen nicht nur eine
		// Warnung sondern ein Fehler ausgegeben. Option -m

bool WUNION = 1;// Ist WUNION 0, wird bei fr eine Operation incompatiblen
		// Union-Komponente keine Warnung ausgegeben. Option -w

bool VDM_TRACE = 0;// ohne Trace

void usage(char * progname)
{
  cerr
    << "usage: " << progname << " [ -m | -w | -t ] <file>.vdm" << endl
    << "options:"                                              << endl
    << "     -m  : mathematical type check"                    << endl
    << "     -w  : no warnings for different union type"       << endl
    << "     -t  : trace output"                               << endl
    << "     -h  : this message"                               << endl
    ;
}
int main(int parcount, char ** params)
{
  yyin = (FILE*)0;
  if (parcount == 0)
    {
      cerr << "No input file given" << endl;
      usage(params[0]);
      return 1;
    }

  for(int i = 1; i < parcount; i++)
    {
      if(params[i][0] == '-')     // Optionen abfragen
	{
	  switch(params[i][1])
	    {
	    case 'h':
	      {
		usage(params[0]);
		exit(0);
	      }
	    case 'm':
	      {
		MATH = bool(1);
		break;
	      }
	    case 'w':
	      {
		WUNION = bool(0);
		break;
	      }
	    case 't':
	      {
		VDM_TRACE = bool(1);
		break;
	      }
	    default:
	      {
		cerr
		  << "unknown option -" << params[i][1] << endl;
		usage(params[0]);
		exit(1);
	      }
	    }
	}
      else
	{
	  DATNAM = params[i];
	  yyin = fopen(params[i], "r");
	  if(yyin == (FILE*)0)
	    {
	      cerr
		<< "Can't read input file " << params[i] << endl;
	      return 1;
	    }

	  if (VDM_TRACE)
	    yydebug = 1;
	  else
	    yydebug = 0;

	  yyparse();

	  TC.output();
	  fclose(yyin);
	  yylino = 1;
	}
    }

  if(yyin == (FILE*)0)
    {
      cerr
	<< "No input file given" << endl;
      usage(params[0]);
      return 1;
    }

  return 0;
}

