%{
#include <stdio.h>

#define YYSTYPE node *  //Stack-Typ, zur Erzeugung des Parse-Baums
#define YYERROR_VERBOSE

extern int yylex();
int yyparse();
int yyerror(char * error);

long int FIELD_MARK;     // kein guter, aber annaehernder Merker fuer
		     // Zeile des letzten Compose-Feldes (fuer Fehlermeldung)
long int ID_MARK;        // dito fuer Id's. Genauer waere ein Stack.

//#include "semaux.hpp"
#include "semtypes.hpp"
#include "semfunc.hpp"
#include "semun.hpp"
#include "sembin.hpp"
#include "sempatt.hpp"
#include "semoth.hpp"

%}

/* Schlsselwrter: */
%token AS
%token ALWAYS
%token BE
%token BOOL
%token BY
%token CASES
%token CHAR
%token COMPOSE
%token DCL
%token DEF
%token DEFINITIONS
%token DO
%token ELSEIF
%token END_VDM
%token ERROR
%token ERRS
%token ETC
%token EXISTS
%token EXISTS1
%token EXIT
%token EXPORTS
%token EXT
%token FALSE
%token FOR
%token FORALL
%token FROM
%token FUNCTIONS
%token GET_VALUE
%token IF
%token IMPORTS
/*%token IN*/
%token INIT
%token INSTANTIATION
%token INT_VDM
%token INV
%token IS_
%token IS_NOT_YET_DEFINED
%token IOTA
%token LAMBDA
%token LET
%token MK_
%token MODULE
%token MU
%token NAME
%token NAT
%token NAT1
%token NIL
%token OF
%token OPERATIONS
%token OTHERS
%token PARAMETERS
%token POST
%token PRE
%token PUT_VALUE
%token RAT
%token RD
%token REAL
%token RETURN_VDM
%token REVERSE
%token SEQ
%token SEQ1
%token SET
%token SKIP
%token ST
%token STATE
%token TAG
%token THEN
%token TIXE
%token TOKEN
%token TRAP
%token TRUE
%token TYPES
%token TYPEVARID
%token UNDEFINED
%token USING
%token VALUES
%token WHILE
%token WR
%token RESULT

/* Operatoren mit mehr als ein Zeichen:*/
%token OPERATION
%token NONDET_STATE
%token MAPS
%token FUNCTION

/* spezielle is_id's */
%token IS_BOOL
%token IS_CHAR
%token IS_NAT
%token IS_NAT1
%token IS_INT
%token IS_RAT
%token IS_REAL
%token IS_TOKEN

/* reservierte Namen:*/
%token INIT_
%token INV_
%token IS_NAME
%token MK_NAME
%token POST_
%token PRE_

/*sonstige:*/
%token ID
%token QUOTELIT
%token CHARLIT
%token TEXTLIT
%token NAT_LIT
%token NAT1_LIT
%token DEC_LIT
%token OPERATOR


/* Aufloesung von Mehrdeutigkeiten: */
/*expressionlist und Komma gegen subsequence*/
%left ','
/*Functionbegin und ':' gegen pattern_identifier*/
%left ANY
%left ':'

%right PART_FUNC TOTAL_FUNC
%left '|'
%right MAP INMAP TO
%left SEQ_OF SEQ1_OF SET_OF

%left CONSTRUCTOR

/*Schieben der bin. Operat. bei folgenden Konstrukten:*/
%right IN ELSE '&'

%nonassoc LESS_EQUAL '<' GREATER_EQUAL '>' '=' NOT_EQUAL SUBSET PSUBSET IN_SET NOT_IN_SET TWO
%left  LOGIC_EQUAL TWOL

%left IMPLY THREE

%left OR '+' '-' UNION '^' MUNION UPDATE '\\' FOUR

%left AND '*' '/' REM MOD DIV INTER FIVE
%right COMP FIVER

%nonassoc DOM_RSTR_TO DOM_RSTR_BY RNG_RSTR_TO RNG_RSTR_BY SIX

%right ITERATE SEVEN

/*Schieben der bin. Operat. bei folgenden Konstrukten:
%right IN ELSE '&' '('*/

%left INDS CONC TL HD ELEMS LEN MERGE RNG DOM DUNION DINTER POWER CARD FLOOR ABS NOT INVERSE UNARY EIGHT
/* unaeres +,- per %prec EIGHT */

%left APPLICATOR '.' NINE

/*Schieben der bin. Operat. bei folgenden Konstrukten:*/
%right '('

/* Auflsung von Mehrdeutigkeiten:
/*expressionlist und Komma gegen subsequence
%left ','
/*Functionbegin und ':' gegen pattern_identifier
%left ANY
%left ':'

%right PART_FUNC TOTAL_FUNC
%left '|'
%right MAP INMAP TO
%left SEQ_OF SEQ1_OF SET_OF

%left CONSTRUCTOR

%left  LOGIC_EQUAL
%right IMPLY
%left  OR
%left  AND
%left  NOT

%left LESS_EQUAL '<' GREATER_EQUAL '>' '=' NOT_EQUAL SUBSET PSUBSET IN_SET NOT_IN_SET

%left '+' '-' UNION '^' MUNION UPDATE '\\'
%left '*' '/' REM MOD DIV INTER
%right DOM_RSTR_TO DOM_RSTR_BY
%left RNG_RSTR_TO RNG_RSTR_BY
%right BINARY

/*Schieben der bin. Operat. bei folgenden Konstrukten:
%right IN ELSE '&' '('

%left INDS CONC TL HD ELEMS LEN MERGE RNG DOM DUNION DINTER POWER CARD FLOOR ABS INVERSE
%right UNARY

%left APPLICATOR '.'

%right ITERATE
%right COMP */

/* #define YYSTYPE double */

%%

/* definitions */
start : document    {if($1 != (node*)0)
		     {               /* nach erstem Durchlauf: */
		      check_types(); /* Typen nacharbeiten */
		      PARSE = SECOND;
		      $1->parse();   /* Expressions auswerten */
		      delete $1;
		     }
		    }
      ;

document : document definition_block
	   {$$ = new node((rulept)0, UNKNOWN, $1, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
	 | definition_block
	   {$$ = $1;}
	 ;

definition_block : type_definitions
		   {$$ = $1;}
/*		 | state_definition*/
		 | value_definitions
		   {$$ = $1;}
		 | function_definitions
		   {$$ = $1;}
/*		 | operation_definitions*/
		 ;


/* type definitions */
type_definitions : TYPES type_definition_list
		   {$$ = $2;}
		 ;

type_definition_list : type_definition_list ';' type_definition
		       {$$ = new node((rulept)0, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		     | type_definition
		       {$$ = $1;}
		     ;

type_definition : identifier '=' type invariant_opt
		  {$$ = new node((rulept)type_definition1, UNKNOWN, $1, $3, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		| identifier TAG field_list invariant_opt
		  {$$ = new node((rulept)type_definition2, UNKNOWN, $1, $3, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		;

type : bracketet_type  {$$ = $1;}
     | basic_type      {$$ = $1;}
     | quote_type      {$$ = $1;}
     | composite_type  {$$ = $1;}
     | union_type      %prec ANY {$$ = $1;}
     | product_type    %prec ANY {$$ = $1;}
     | optional_type   {$$ = $1;}
     | set_type        {$$ = $1;}
     | seq_type        {$$ = $1;}
     | map_type        {$$ = $1;}
     | function_type   {$$ = $1;}
     | type_name       {$$ = $1;}
     | type_variable   {$$ = $1;}
     ;

bracketet_type : '(' type ')'  {$$ = $2;}
	       ;

basic_type : BOOL      {$$ = new node((rulept)0, T_BOOL ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | NAT       {$$ = new node((rulept)0, T_NAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | NAT1      {$$ = new node((rulept)0, T_NAT1 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | INT_VDM   {$$ = new node((rulept)0, T_INT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | RAT       {$$ = new node((rulept)0, T_RAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | REAL      {$$ = new node((rulept)0, T_REAL ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | CHAR      {$$ = new node((rulept)0, T_CHAR ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | TOKEN     {$$ = new node((rulept)0, T_TOKEN ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   ;


quote_type : QUOTELIT  {$$ = new node((rulept)quote_type, UNKNOWN, $1 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   ;

composite_type : COMPOSE identifier OF field_list END_VDM
		 {$$ = new node((rulept)composite_type, UNKNOWN, $2, $4 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	       ;

field_list : field_list field        {$$ = new node((rulept)field_list1, UNKNOWN, $1, $2 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | field_list type         {$$ = new node((rulept)field_list2, UNKNOWN, $1, $2 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | /* e */                 {$$ = new node((rulept)field_list3, UNKNOWN, (node*)0);
				assert($$ > (node*)NULL, 99);}
	   ;

field : identifier ':' type          {$$ = new node((rulept)field, UNKNOWN, $1, $3 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
      ;

union_type : type '|' type           {$$ = new node((rulept)union_type1, UNKNOWN, $1, $3 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   | union_type '|' type     {$$ = new node((rulept)union_type2, UNKNOWN, $1, $3 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	   ;

product_type : type '*' type         {$$ = new node((rulept)product_type1, UNKNOWN, $1, $3 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	     | product_type '*' type {$$ = new node((rulept)product_type2, UNKNOWN, $1, $3 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	     ;

optional_type : '[' type ']'         {$$ = new node((rulept)optional_type, UNKNOWN, $2 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      ;

set_type : SET_OF type %prec UNARY   {$$ = new node((rulept)set_type, UNKNOWN, $2 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	 ;

seq_type : SEQ_OF type %prec UNARY   {$$ = new node((rulept)seq_type1, UNKNOWN, $2 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	 | SEQ1_OF type %prec UNARY  {$$ = new node((rulept)seq_type2, UNKNOWN, $2 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	 ;

map_type : general_map_type             {$$ = $1;}
	 | injective_map_type           {$$ = $1;}
	 ;

general_map_type : MAP type TO type     {$$ = new node((rulept)general_map_type, UNKNOWN, $2, $4 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

injective_map_type : INMAP type TO type {$$ = new node((rulept)injective_map_type, UNKNOWN, $2, $4 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		   ;

function_type : partial_function_type   {$$ = $1;}
	      |	total_function_type     {$$ = $1;}
	      ;

partial_function_type : type PART_FUNC type
			{$$ = new node((rulept)partial_function_type1, UNKNOWN, $1, $3 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		      | '(' ')' PART_FUNC type
			{$$ = new node((rulept)partial_function_type2, UNKNOWN, $4 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		      ;

total_function_type : type TOTAL_FUNC type
		      {$$ = new node((rulept)total_function_type1, UNKNOWN, $1, $3 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		    | '(' ')' TOTAL_FUNC type
		      {$$ = new node((rulept)total_function_type2, UNKNOWN, $4 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		    ;

type_name : name      {$$ = new node((rulept)type_name, UNKNOWN, $1 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	  ;

type_variable : type_variable_identifier
		{$$ = new node((rulept)type_variable, UNKNOWN, $1 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      ;


/* state definition */
/*state_definition : STATE identifier OF field_list
		   invariant_opt initialisation_opt END_VDM
		 ;*/

invariant_opt: invariant {$$ = $1;}
	     | /* e */
	       {$$ = new node((rulept)0, NOPAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	     ;

invariant : INV invariant_initial_function {$$ = $2;}
	  ;

/*initialisation_opt : initialisation
		   |  e
		   ;

initialisation : INIT invariant_initial_function
	       ;    */

invariant_initial_function : inv_pattern FUNCTION expression
			     {$$ = new node((rulept)inv_init, NEW_LAYER, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
			   ;

inv_pattern : pattern
	      {$$ = new node((rulept)inv_pattern, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    ;


/* value definitions */
value_definitions : VALUES value_definition_list {$$ = $2;}
		  ;

value_definition_list : value_definition_list ';' value_definition
			{$$ = new node((rulept)0, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		      | value_definition  {$$ = $1;}
		      ;

value_definition : pattern type_opt '=' expression
		   {$$ = new node((rulept)val_def, FIRST, $1, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

type_opt : ':' type {$$ = $2;}
	 | /* e */
	   {$$ = new node((rulept)0, NOPAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	 ;


/* function definitions */
function_definitions : FUNCTIONS function_definition_list
		       {$$ = $2;}
		     ;

function_definition_list : function_definition_list ';' function_definition
			   {$$ = new node((rulept)0, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
			 | function_definition
			   {$$ = $1;}
			 ;

function_definition : explicit_function_definition
		      {$$ = $1;}
		    | implicit_function_definition
		      {$$ = $1;}
		    ;

/* explicit_function_definition : identifier type_variable_list_opt
			       ':' function_type identifier
			       parameters_list FUNCTION expression
			       pre_expression_opt post_expression_opt
			     ;*/

explicit_function_definition : function_begin FUNCTION func_expression
			       pre_expression_opt post_expression_opt
			       {$$ = new node((rulept)explicit_function_definition, UNKNOWN, $1, $3, $4, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
			     ;
/* mehrdeutig zu pattern_identifier mit ':' */
function_begin : type_variable_list ':' function_type identifier
		 parameters /* Standard: parameters_list; warum? */
		 {if (VDM_TRACE) cout << "\nfunction-open\n";
		  $$ = new node((rulept)function_begin1, NEW_LAYER_ACT, $1, $3, $4, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | identifier ':' function_type identifier
		 parameters /* Standard: parameters_list; warum? */
		 {if (VDM_TRACE) cout << "\nfunction-open\n";
		  $$ = new node((rulept)function_begin2, NEW_LAYER_ACT, $1, $3, $4, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       ;

implicit_function_definition : identifier parameter_types identifier_type_pair
			       pre_expression_opt POST func_expression
			       {if (VDM_TRACE) cout << "\nimplicit-function-open\n";
				$$ = new node((rulept)impl_func, NEW_LAYER_ACT, $1, $2, $3, $4, $6, (node*)0);
				assert($$ > (node*)NULL, 99);}
			     ;

func_expression : expression {$$ = $1;}
		| IS_NOT_YET_DEFINED
		  {$$ = new node((rulept)0, NOPAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		;

pre_expression_opt : PRE expression {$$ = $2;}
		   | /* e */
		     {$$ = new node((rulept)0, NOPAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		   ;

post_expression_opt : POST expression {$$ = $2;}
		    | /* e */
		     {$$ = new node((rulept)0, NOPAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		    ;

/*type_variable_list_opt : type_variable_list {$$ = $1}
		       |  e
			 {$$ = new node((rulept)0, NOPAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		       ;*/

type_variable_list : poly_identifier '[' type_variable_identifier_list ']'
		     {$$ = new node((rulept)type_variable_list, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		   ;

poly_identifier : identifier
		  {$$ = new node((rulept)poly_identifier, UNKNOWN, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
                ;

type_variable_identifier_list : type_variable_identifier_list ','
				type_variable_identifier
				{$$ = new node((rulept)type_variable_identifier_list1, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
			      | type_variable_identifier
				{$$ = new node((rulept)type_variable_identifier_list2, UNKNOWN, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
			      ;

/*new_layer : e
	    {$$ = new node((rulept)new_layer, FIRST, (node*)0);
				assert($$ > (node*)NULL, 99);}
	  ;
		*/
identifier_type_pair : identifier ':' type
		       {$$ = new node((rulept)id_type_pair, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		     ;

parameter_types : '(' pattern_type_pair_list_opt ')' {$$ = $2;}
		;

pattern_type_pair_list_opt : pattern_type_pair_list  {$$ = $1;}
			   | /* e */
			     {$$ = new node((rulept)0, NOPAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
			   ;

pattern_type_pair_list : pattern_type_pair_list ',' pattern_list ':' type
			 {$$ = new node((rulept)p_type_pair_l1, UNKNOWN, $1, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		       | pattern_list ':' type
			 {$$ = new node((rulept)p_type_pair_l2, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		       ;

/*parameters_list : parameters_list parameters
		| parameters
		;
*/
parameters : '(' pattern_list_opt ')'
	     {$$ = new node((rulept)parameters, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
	   ;

pattern_list_opt : pattern_list {$$ = $1;}
		 | /* e */
		   {$$ = new node((rulept)0, NOPAT, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;


/* operation definitions */
/*operation_definitions : OPERATIONS op_temp operation_definition_list
		      ;

op_temp :  e  {VDM_ERROR(8, yylino, "");}

	;

operation_definition_list : operation_definition_list ';' operation_definition
			  | operation_definition
			  ;

operation_definition : explicit_operation_definition
		     | implicit_operation_definition
		     ;

explicit_operation_definition : identifier ':' operation_type identifier
				parameters FUNCTION statement
				pre_expression_opt post_expression_opt
			      ;

implicit_operation_definition : identifier parameter_types
				identifier_type_pair_opt externals_opt
				pre_expression_opt POST expression exceptions_opt
			      ;

identifier_type_pair_opt : identifier_type_pair
			 |  e
			 ;

externals_opt : externals
	      |  e
	      ;

exceptions_opt : exceptions
	       |  e
	       ;

operation_type : discretionary_type OPERATION discretionary_type
	       ;

discretionary_type : type
		   | '(' ')'
		   ;

externals : EXT var_information_list
	  ;

var_information_list : var_information_list var_information
		     | var_information
		     ;

var_information : mode name_list type_opt
		;

mode : RD
     | WR
     ;

exceptions : ERRS error_list
	   ;

error_list : error_list error
	   | vdmerror
	   ;

vdmerror : identifier ':' expression PART_FUNC expression
	 ;          */


/* expressions */
expression_list : expression_list ',' expression
		  {$$ = new node((rulept)expression_list1, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		| expression %prec ANY
		  {$$ = new node((rulept)expression_list2, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
		;

expression : bracketet_expression   {$$ = $1;}
	   | let_expression         {$$ = $1;}
	   | let_be_expression      {$$ = $1;}
/*	   | def_expression         {$$ = $1;}*/
	   | if_expression          {$$ = $1;}
	   | cases_expression       {$$ = $1;}
	   | unary_expression       {$$ = $1;}
	   | binary_expression      {$$ = $1;}
	   | quantified_expression  {$$ = $1;}
	   | iota_expression        {$$ = $1;}
	   | set_enumeration        {$$ = $1;}
	   | set_comprehension      {$$ = $1;}
	   | set_range_expression   {$$ = $1;}
	   | sequence_enumeration   {$$ = $1;}
	   | sequence_comprehension {$$ = $1;}
	   | subsequence            {$$ = $1;}
	   | map_enumeration        {$$ = $1;}
	   | map_comprehension      {$$ = $1;}
	   | tuple_constructor      {$$ = $1;}
	   | record_constructor          {$$ = $1;}
	   | record_modifier             {$$ = $1;}
	   | apply                       {$$ = $1;}
	   | field_select                {$$ = $1;}
	   | function_type_instantiation {$$ = $1;}
	   | lambda_expression           {$$ = $1;}
	   | is_expression               {$$ = $1;}
	   | undefined_expression        {$$ = $1;}
	   | name
	     {$$ = new node((rulept)expression, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
/*	   | old_name*/
	   | symbolic_literal            {$$ = $1;}
	   ;

bracketet_expression : '(' expression ')' {$$ = $2;}
		     ;

let_expression : LET local_definition_list IN expression
		 {if (VDM_TRACE) cout << "\nlet-open\n";
		  $$ = new node((rulept)let_expression, NEW_LAYER, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       ;

local_definition_list : local_definition_list ',' local_definition
			{$$ = new node((rulept)0, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		      | local_definition  {$$ = $1;}
		      ;

let_be_expression : LET bind be_opt IN expression
		    {if (VDM_TRACE) cout << "\nlet-be-open\n";
                     $$ = new node((rulept)let_be_expression, NEW_LAYER, $2, $3, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

be_opt : BE ST expression {$$ = $3;}
       | /* e */
	 {$$ = new node((rulept)0, NOPAT, (node*)0);
				assert($$ > (node*)NULL, 99);}
       ;

/*def_expression : DEF pattern_bind_list IN expression
	       ;*/


/*pattern_bind_list : pattern_bind_list ';' pattern_bind '=' expression
		  | pattern_bind '=' expression
		  ;*/

if_expression : IF expression THEN expression elseif_list ELSE expression
		{$$ = new node((rulept)if_expression, FIRST, $2, $4, $5, $7, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      ;

elseif_list : /* e */
	      {$$ = new node((rulept)0, NOPAT, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    | elseif_list elseif_expression
	      {$$ = new node((rulept)elseif_list, FIRST, $1, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    ;

elseif_expression : ELSEIF expression THEN expression
		    {$$ = new node((rulept)elseif_expression, FIRST, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

cases_expression : CASES expression ':' alternatives other_opt END_VDM
		   {$$ = new node((rulept)cases_expression, FIRST, $2, $4, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

alternatives : alternatives ',' alternative
	       {$$ = new node((rulept)pattern_list1, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | alternative
	       {$$ = new node((rulept)pattern_list2, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     ;

alternative : pattern_list PART_FUNC expression
	      {$$ = new node((rulept)alternative, NEW_LAYER, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    ;

other_opt : others_expression
	    {$$ = $1;}
	  | /* e */
	    {$$ = new node((rulept)0, NOPAT, (node*)0);
				assert($$ > (node*)NULL, 99);}
	  ;

others_expression : ',' OTHERS PART_FUNC expression
		    {$$ = $4;}
		  ;

unary_expression : prefix_expression  {$$ = $1;}
		 | INVERSE expression %prec UNARY
		   {$$ = new node((rulept)unary_expression, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

prefix_expression : unary_operator expression %prec EIGHT
		    {$$ = new node((rulept)prefix_expression1, FIRST, $1, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | '+' expression            %prec EIGHT
		    {$$ = new node((rulept)prefix_expression2, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}

		  | '-' expression            %prec EIGHT
		    {$$ = new node((rulept)prefix_expression3, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | MERGE expression          /*%prec EIGHT*/
		    {$$ = new node((rulept)prefix_expression4, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

unary_operator : /* '+'
	       | '-'
	       | */ ABS {$$ = new node((rulept)0, ABS, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | FLOOR  {$$ = new node((rulept)0, FLOOR, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | NOT    {$$ = new node((rulept)0, NOT, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | CARD   {$$ = new node((rulept)0, CARD, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | POWER  {$$ = new node((rulept)0, POWER, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | DUNION {$$ = new node((rulept)0, DUNION, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | DINTER {$$ = new node((rulept)0, DINTER, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | HD     {$$ = new node((rulept)0, HD, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | TL     {$$ = new node((rulept)0, TL, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | LEN    {$$ = new node((rulept)0, LEN, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | ELEMS  {$$ = new node((rulept)0, ELEMS, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | INDS   {$$ = new node((rulept)0, INDS, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | CONC   {$$ = new node((rulept)0, CONC, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | DOM    {$$ = new node((rulept)0, DOM, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | RNG    {$$ = new node((rulept)0, RNG, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    /*   | MERGE */
	       ;

/* unary_plus : '+'
	   ;

unary_minus : '-'
	    ;

distributet_map_merge : MERGE
		      ;
*/
binary_expression : expression ITERATE expression
		    {$$ = new node((rulept)binary_expression1, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | expression COMP expression
		    {$$ = new node((rulept)binary_expression2, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | expression IMPLY expression
		    {$$ = new node((rulept)binary_expression3, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | expression LOGIC_EQUAL expression
		    {$$ = new node((rulept)binary_expression4, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | expression restrict_operator expression %prec SIX
		    {$$ = new node((rulept)binary_expression5, FIRST, $1, $2, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | expression multi_operator expression    %prec FIVE
		    {$$ = new node((rulept)binary_expression6, FIRST, $1, $2, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | expression addi_operator expression     %prec FOUR
		    {$$ = new node((rulept)binary_expression7, FIRST, $1, $2, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | expression rel_operator expression      %prec TWO
		    {$$ = new node((rulept)binary_expression8, FIRST, $1, $2, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

addi_operator : '+'           {$$ = new node((rulept)0, (long int)'+', (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | '-'           {$$ = new node((rulept)0, (long int)'-', (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | OR            {$$ = new node((rulept)0, OR, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | UNION         {$$ = new node((rulept)0, UNION, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | '\\'          {$$ = new node((rulept)0, (long int)'\\', (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | UPDATE        {$$ = new node((rulept)0, UPDATE, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | MUNION        {$$ = new node((rulept)0, MUNION, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | '^'           {$$ = new node((rulept)0, (long int)'^', (node*)0);
				assert($$ > (node*)NULL, 99);}
	      ;

multi_operator : '*'           {$$ = new node((rulept)0, (long int)'*', (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | '/'           {$$ = new node((rulept)0, (long int)'/', (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | DIV           {$$ = new node((rulept)0, DIV, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | REM           {$$ = new node((rulept)0, REM, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | MOD           {$$ = new node((rulept)0, MOD, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | AND           {$$ = new node((rulept)0, AND, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | INTER         {$$ = new node((rulept)0, INTER, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       ;

rel_operator : '<'           {$$ = new node((rulept)0, (long int)'<', (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | LESS_EQUAL    {$$ = new node((rulept)0, LESS_EQUAL, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | '>'           {$$ = new node((rulept)0, (long int)'>', (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | GREATER_EQUAL {$$ = new node((rulept)0, GREATER_EQUAL, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | '='           {$$ = new node((rulept)0, (long int)'=', (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | NOT_EQUAL     {$$ = new node((rulept)0, NOT_EQUAL, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | IN_SET        {$$ = new node((rulept)0, IN_SET, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | NOT_IN_SET    {$$ = new node((rulept)0, NOT_IN_SET, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | SUBSET        {$$ = new node((rulept)0, SUBSET, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | PSUBSET       {$$ = new node((rulept)0, PSUBSET, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     ;

restrict_operator : DOM_RSTR_TO   {$$ = new node((rulept)0, DOM_RSTR_TO, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | DOM_RSTR_BY   {$$ = new node((rulept)0, DOM_RSTR_BY, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | RNG_RSTR_TO   {$$ = new node((rulept)0, RNG_RSTR_TO, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  | RNG_RSTR_BY   {$$ = new node((rulept)0, RNG_RSTR_BY, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

/* arithmetic_plus : '+'
		;

arithmetic_minus : '-'
		 ;

map_merge : MERGE
	  ;
*/
quantified_expression : all_expression           {$$ = $1;}
		      | exists_expression        {$$ = $1;}
		      | exists_unique_expression {$$ = $1;}
		      ;

all_expression : FORALL bind_list '&' expression
		 {if (VDM_TRACE) cout << "\nall-open\n";
                  $$ = new node((rulept)all_expression, NEW_LAYER, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       ;

exists_expression : EXISTS bind_list '&' expression
		    {if (VDM_TRACE) cout << "\nexists-open\n";
                     $$ = new node((rulept)all_expression, NEW_LAYER, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

exists_unique_expression : EXISTS1 bind '&' expression
			   {if (VDM_TRACE) cout << "\nexists1-open\n";
                            $$ = new node((rulept)all_expression, NEW_LAYER, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
			 ;

iota_expression : IOTA bind '&' expression
		  {if (VDM_TRACE) cout << "\niota-open\n";
                   $$ = new node((rulept)iota_expression, NEW_LAYER, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		;

set_enumeration : '{' expression_list_opt '}'
		  {$$ = new node((rulept)set_enum, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		;

expression_list_opt : expression_list  {$$ = $1;}
		    | /* e */
		      {$$ = new node((rulept)0, NOPAT, (node*)0);
				assert($$ > (node*)NULL, 99);}
		    ;

set_comprehension : '{' expression '|' bind_list bind_expression_opt '}' /*veraenderte Reihenfolge*/
		    {if (VDM_TRACE) cout << "\nset-comp-open\n";
                     $$ = new node((rulept)set_comp, NEW_LAYER, $4, $2, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

bind_expression_opt : '&' expression {$$ = $2;}
		    | /* e */
		      {$$ = new node((rulept)0, NOPAT, (node*)0);
				assert($$ > (node*)NULL, 99);}
		    ;

set_range_expression : '{' expression ETC expression '}'
		       {$$ = new node((rulept)set_range, FIRST, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		     ;

sequence_enumeration : '[' expression_list_opt ']'
		       {$$ = new node((rulept)seq_enum, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		     ;

sequence_comprehension : '[' expression '|' set_bind bind_expression_opt ']' /*veraenderte Reihenfolge*/
			 {if (VDM_TRACE) cout << "\nseq-comp-open\n";
                          $$ = new node((rulept)seq_comp, NEW_LAYER, $4, $2, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
		       ;

subsequence : expression '(' expression ETC expression ')' %prec APPLICATOR
	      {$$ = new node((rulept)subseq, FIRST, $1, $3, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    ;

map_enumeration : '{' maplet_list '}'
		  {$$ = new node((rulept)map_enum, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		| '{' MAPS '}'
		  {$$ = new node((rulept)0, T_EMPTYMAP, (node*)0);
				assert($$ > (node*)NULL, 99);}
		;

maplet_list : maplet_list ',' maplet
	      {$$ = new node((rulept)pattern_list1, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    | maplet
	      {$$ = new node((rulept)pattern_list2, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
	    ;

maplet : expression MAPS expression
	 {$$ = new node((rulept)maplet, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
       ;

map_comprehension : '{' maplet '|' bind_list bind_expression_opt '}' /*veraenderte Reihenfolge*/
		    {if (VDM_TRACE) cout << "\nmap-comp-open\n";
                     $$ = new node((rulept)map_comp, NEW_LAYER, $4, $2, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

tuple_constructor : MK_ '(' expression_list ')'
		    {$$ = new node((rulept)tuple_pattern, FIRST, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

record_constructor : MK_NAME name '(' expression_list_opt ')'
		    {$$ = new node((rulept)record, FIRST, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		   ;

record_modifier : MU '(' expression ',' record_modification_list ')'
		  {$$ = new node((rulept)record_mod, FIRST, $3, $5, (node*)0);
				assert($$ > (node*)NULL, 99);}
		;

record_modification_list : record_modification_list ',' record_modification
			   {$$ = new node((rulept)pattern_list1, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
			 | record_modification
			   {$$ = new node((rulept)pattern_list2, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
			 ;

record_modification : identifier MAPS expression
		      {$$ = new node((rulept)rec_mod, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		    ;

apply : expression '(' expression_list_opt ')' %prec APPLICATOR
	{$$ = new node((rulept)apply, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
      ;

field_select : expression '.' identifier %prec APPLICATOR
	       {$$ = new node((rulept)field_sel, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     ;

function_type_instantiation : name '[' type_list ']' %prec APPLICATOR
			      {$$ = new node((rulept)type_inst, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
			    ;

type_list : type_list ',' type
	    {$$ = new node((rulept)pattern_list1, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	  | type
	    {$$ = new node((rulept)pattern_list2, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
	  ;

lambda_expression : LAMBDA type_bind_list '&' expression
		    {if (VDM_TRACE) cout << "\nlambda-open\n";
                     $$ = new node((rulept)lambda_expression, NEW_LAYER, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

is_expression : IS_NAME name '(' expression ')'
		{$$ = new node((rulept)is_expression1, T_BOOL, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      | is_basic_type '(' expression ')'
		{$$ = new node((rulept)is_expression2, T_BOOL, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      ;

undefined_expression : UNDEFINED
		       {$$ = new node((rulept)0, T_UNDEFINED, (node*)0);
				assert($$ > (node*)NULL, 99);}
		     ;

name : identifier /*identifiers_opt*/  {$$ = $1;} /*spaeter Module beruecksichtigen*/
     ;

/*identifiers_opt : identifiers_list
		|  e
		;

identifiers_list : identifiers_list '`' identifier
		 | '`' identifier
		 ;*/

/*name_list : name_list ',' name
	  | name
	  ;*/

/*old_name : identifier '~'
	 ;*/

symbolic_literal : num_lit      {$$ = $1;}
		 | bool_literal {$$ = $1;}
		 | NIL      {$$ = new node((rulept)0, T_NIL ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		 | CHARLIT  {$$ = new node((rulept)0, T_CHAR ,(node*)0);
				assert($$ > (node*)NULL, 99);}
		 | TEXTLIT  {$$ = new node((rulept)make_text, FIRST, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 | QUOTELIT {$$ = new node((rulept)make_quote, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

num_lit : NAT1_LIT {$$ = new node((rulept)0, T_NAT1 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	| NAT_LIT  {$$ = new node((rulept)0, T_NAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	| DEC_LIT  {$$ = new node((rulept)0, T_RAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	;

bool_literal : TRUE  {$$ = new node((rulept)0, T_BOOL ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	     | FALSE {$$ = new node((rulept)0, T_BOOL ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	     ;


/* pattern and bindings */
pattern : pattern_identifier {$$ = $1;}
	| match_value        {$$ = $1;}
	| set_enum_pattern   {$$ = $1;}
	| set_union_pattern  {$$ = $1;}
	| seq_enum_pattern   {$$ = $1;}
	| seq_conc_pattern   {$$ = $1;}
	| tuple_pattern      {$$ = $1;}
	| record_pattern     {$$ = $1;}
	;

pattern_identifier : identifier %prec ANY
		     {$$ = new node((rulept)pattern_identifier1, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
		   | '-'
		     {$$ = new node((rulept)0, DONTCARE, (node*)0);
				assert($$ > (node*)NULL, 99);}
		   ;

match_value : '(' expression ')' {$$ = $2;}
	      /*{$$ = new node((rulept)match_value1, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}*/
	    | symbolic_literal   {$$ = $1;}
	      /*{$$ = new node((rulept)match_value2, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}*/
	    ;

set_enum_pattern : '{' pattern_list_opt '}'
		   {$$ = new node((rulept)set_enum_pattern, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

set_union_pattern : pattern UNION pattern
		    {$$ = new node((rulept)set_union_pattern, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

seq_enum_pattern : '[' pattern_list_opt ']'
		   {$$ = new node((rulept)seq_enum_pattern, FIRST, $2, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

seq_conc_pattern : pattern '^' pattern
		   {$$ = new node((rulept)seq_conc_pattern, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		 ;

tuple_pattern : MK_ '(' pattern_list ')'
		{$$ = new node((rulept)tuple_pattern, FIRST, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	      ;

record_pattern : MK_NAME name '(' pattern_list_opt ')'
		 {$$ = new node((rulept)record_pattern, FIRST, $2, $4, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       ;

pattern_list : pattern_list ',' pattern
	       {$$ = new node((rulept)pattern_list1, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     | pattern
	       {$$ = new node((rulept)pattern_list2, FIRST, $1, (node*)0);
				assert($$ > (node*)NULL, 99);}
	     ;

/*pattern_bind : pattern  {$$ = $1;}
	     | bind     {$$ = $1;}
	     ;*/

bind : set_bind         {$$ = $1;}
     | type_bind        {$$ = $1;}
     ;

set_bind : pattern IN_SET expression
	   {$$ = new node((rulept)set_bind, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	 ;

type_bind : pattern ':' type %prec CONSTRUCTOR
	   {$$ = new node((rulept)type_bind, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	  ;

bind_list : bind_list ',' multiple_bind
	   {$$ = new node((rulept)0, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	  | multiple_bind           {$$ = $1;}
	  ;

multiple_bind : multiple_set_bind   {$$ = $1;}
	      | multiple_type_bind  {$$ = $1;}
	      ;

multiple_set_bind : pattern_list IN_SET expression
		    {$$ = new node((rulept)multi_set_bind, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		  ;

multiple_type_bind : pattern_list ':' type %prec CONSTRUCTOR
		     {$$ = new node((rulept)multi_type_bind, FIRST, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
		   ;

type_bind_list : type_bind_list ',' type_bind
		 {$$ = new node((rulept)0, UNKNOWN, $1, $3, (node*)0);
				assert($$ > (node*)NULL, 99);}
	       | type_bind          {$$ = $1;}
	       ;


/* statements */
/*statement :  e
	  ;      */

local_definition : value_definition    {$$ = $1;}
		 | function_definition {$$ = $1;}
		 ;



/* Literale */
is_basic_type : IS_BOOL  {$$ = new node((rulept)0, T_BOOL ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      | IS_NAT   {$$ = new node((rulept)0, T_NAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      | IS_NAT1  {$$ = new node((rulept)0, T_NAT1 ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      | IS_INT   {$$ = new node((rulept)0, T_INT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      | IS_RAT   {$$ = new node((rulept)0, T_RAT ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      | IS_REAL  {$$ = new node((rulept)0, T_REAL ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      | IS_CHAR  {$$ = new node((rulept)0, T_CHAR ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      | IS_TOKEN {$$ = new node((rulept)0, T_TOKEN ,(node*)0);
				assert($$ > (node*)NULL, 99);}
	      ;

identifier : ID   {$$ = $1;}   /* Knoten wird im Lexer erstellt */
	   ;


type_variable_identifier : TYPEVARID
			   {$$ = $1;}   /* Knoten wird im Lexer erstellt */
			 ;


%%

int yyerror(char * error)
  { 

    // Syntax-error, kein VDM_ERROR; kein exit();

    cerr << (char*)DATNAM << ":" << yylino << ": " << error << endl;
    
    //fprintf(stderr,"\n%s:%lu: %s", (char*)DATNAM, (unsigned long)yylino, error);

    return(1);
  }
