#!/bin/sh
#
# $Id: vdminfo.sh,v 1.5 1994/03/06 20:05:24 vdm Exp $
#
# interface zu vdminfo.tcl

getadt(){
########
#
# listet die ADT-Liste einer Datenbasis
#        ohne die internen ADTs
#
#  $1: vdmdb - Datenbasis

inf  -B$1 -DREAL -v|sort
}


getintadt(){
########
#
# listet die ADT-Liste einer Datenbasis
#        mit den  internen ADTs
#
#  $1: vdmdb - Datenbasis

inf  -B$1 -DREAL -DAUXILIARY -DINTERNAL -v|sort
}


getdocus(){
#########
#
#  $1: vdmdb - Datenbasis
#  $2: adtname 
#  $3: implname 
#  $4: opname 
# [$5: signature]
#

case $2 in
   -*-) getpredeldom $1
        exit
        ;;
   -*)
        ;;
esac

case $3 in
   -*-) implname=com
        ;;
   *)   implname=$3
        ;;
esac

case $4 in
   -*-) opname=basic
        ;;
   *)   opname=$4
        ;;
esac

if [ $# -ge 4 ]  
   then
   echo >$TMPfile
   {
   echo "Description"
   echo "==========="
   echo ""

   db -B$1 -x stdlib sign setup docu
   db -B$1 -X $2 $opname vsig
   echo

   if [ `db -B$1 -c $2 $implname $opname docu` = "TRUE" ]
      then
      db -B$1 -d $2 $implname $opname
   else
   if [ `db -B$1 -c $2 com $opname docu` = "TRUE" ]
      then
      db -B$1 -d $2 com $opname
   else
      db -B$1 -d com com $opname
   fi
   fi
   echo
   } >>$TMPfile

   if [ "$5" != "" ] && [ "$opname" != "basic" ]
      then
      db -B$1 -X $2 $opname $5 >$TMPfile.2
      if [ -s $TMPfile.2 ]
      then
         {
         echo ""
         echo "C Interface"
         echo "==========="
         echo ""
         } >>$TMPfile
      fi
      cat $TMPfile.2 >> $TMPfile
      rm -f $TMPfile.2
      db -B$1 -X $2 $opname cpp >$TMPfile.2
      if [ -s $TMPfile.2 ]
      then
         {
         echo ""
         echo "C++ Interface"
         echo "============="
         echo ""
         echo "#define GEN_CPLUS"
         db -B$1 -x stdlib sign setup docu
         } >>$TMPfile
      fi
      cat $TMPfile.2 >> $TMPfile
      rm -f $TMPfile.2
   fi

   $cpreprog -DGEN_DOCU -DGEN_C -DGEN_ANSIC -I$1 $TMPfile
   rm -f $TMPfile
fi
}

getimpl(){
########
#
# liest alle Implementationen fuer einen ADT
#
#  $1: vdmdb
#  $2: adtname


inf -B$1 -a $2 | grep -v '^com$' | grep -v '^aux$' | sort -u
}




getop(){
#######
#
# liest alle Operationen fuer eine Implementation eines ADTs
# und sortiert diese
#
#  $1: vdmdb
#  $2: adtname
#  $3: implname


inf -B$1 -e $2 $3 | grep -v '^basic$' | sort
}

getoptype() {
###########
#
# gibt die Art der Implementierung zurueck
#

case $4 in
   -*-) echo $4
        ;;
   *)
        if [ -d $1/$2/$3/$4 ]
        then
            echo "SPECIAL"
        else
        if [ -d $1/$2/com/$4 ]
        then
            echo "COMMON"
        else
            echo "GENERAL"
        fi
        fi
        ;;
esac
}

getpredeldom(){
#############
# liest die predefined elementary domains
#
#   $1: vdmdb

db -B$1 -g  stdlib com basic vdm | $cpreprog

}




#  Hauptprogramm
#
#  setzt Dirs und verzweigt in Prozeduren!
#
#  parameters:
#
#  $1: Name der Prozedur
#  $2-$n: Parameterliste, wird an Prozedur uebergeben
#

cpreprog="$VDMROOT/lib/vdmpp -E0 -L"

TMPDIR=/tmp
TMPfile=$TMPDIR/xvdminfo-$$

prog=$1
shift
$prog $*

#ignore error codes
exit 0
