#!/bin/sh
OUT_DIR=$VDMROOT/lib/vdmdb-c;[ "$1" != "" ] && OUT_DIR=$1
[ -d $OUT_DIR ] || mkdir $OUT_DIR
[ -d $OUT_DIR/alias ] || mkdir $OUT_DIR/alias
[ -d $OUT_DIR/alias/com ] || mkdir $OUT_DIR/alias/com
[ -d $OUT_DIR/alias/com/basic ] || mkdir $OUT_DIR/alias/com/basic
cat >$OUT_DIR/alias/com/basic/adttype <<'-----'
REAL


-----
cat >$OUT_DIR/alias/com/basic/docu <<'-----'
Syntax:

  Domain1 = Domain2

Description:
 
  Definition of alias names for domains. Domain1 stands for
  the same data type as Domain2.

Example:

  Mystring = Str

  defines a new data type Mystring. Mystring is implemented
  via Str. No implementation must be given for alias domains.
  Operations can be added in the usual way.

  adding operation "hd" for domain Mystring can be specified
  as

  IMPLEMENTATIONS
     Mystring = + hd

-----
cat >$OUT_DIR/alias/com/basic/gtyp <<'-----'
_DEFINE DOMAIN ELEM1
-----
cat >$OUT_DIR/alias/com/basic/vdm <<'-----'
#if ALIAS_AS_INHERIT

DOMAINS
  DOMAIN -> ELEM1
IMPLEMENTATIONS

#endif
-----
[ -d $OUT_DIR/alias/com/rename ] || mkdir $OUT_DIR/alias/com/rename
cat >$OUT_DIR/alias/com/rename/param <<'-----'
FCTNAME
TUPLDOMAIN
NAME
NOADD
-----
cat >$OUT_DIR/alias/com/rename/vdm <<'-----'
#ifndef NOADD

#ifdef TUPLDOMAIN
#define ARG ("TUPLDOMAIN"=TUPLDOMAIN)
#else
#define ARG
#endif

_ADD_OP(ELEM1,FCTNAME ARG)

#undef ARG
#endif
-----
[ -d $OUT_DIR/alias/sign ] || mkdir $OUT_DIR/alias/sign
[ -d $OUT_DIR/alias/sign/basic ] || mkdir $OUT_DIR/alias/sign/basic
cat >$OUT_DIR/alias/sign/basic/cpp <<'-----'
#if ALIAS_AS_INHERIT
class  Cpp_DOMAIN : public Cpp_ELEM1 {
  Cpp_DOMAIN() : Cpp_ELEM1() {}

#endif

-----
cat >$OUT_DIR/alias/sign/basic/cppclass <<'-----'
#ifdef ALIAS_AS_INHERIT

class Cpp_DOMAIN;

#else

_DEFINE Cpp_DOMAIN Cpp_ELEM1

#endif
-----
[ -d $OUT_DIR/alias/sign/post ] || mkdir $OUT_DIR/alias/sign/post
cat >$OUT_DIR/alias/sign/post/cpp <<'-----'
#if ALIAS_AS_INHERIT
};
#endif
-----
[ -d $OUT_DIR/alias/sign/rename ] || mkdir $OUT_DIR/alias/sign/rename
cat >$OUT_DIR/alias/sign/rename/gsig <<'-----'
#ifndef NAME
#define NAME FCTNAME
#endif
_DEFINE MERGE(NAME,_DOMAIN) MERGE(FCTNAME,_ELEM1)
#undef NAME
-----
[ -d $OUT_DIR/aux ] || mkdir $OUT_DIR/aux
[ -d $OUT_DIR/aux/array ] || mkdir $OUT_DIR/aux/array
[ -d $OUT_DIR/aux/array/basic ] || mkdir $OUT_DIR/aux/array/basic
cat >$OUT_DIR/aux/array/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/aux/array/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/aux/array/basic/gtyp <<'-----'
  START_RECORD_TYP(Struct##_DOMAIN)
#ifdef GEN_C
 			Nat0 f_max;
			Nat0 f_len;
#else
                      RECFIELD(f_max,SUB_RANGE(0,MAXINT));
                      RECFIELD(f_len,SUB_RANGE(0,MAXINT));
                      RECFIELD(f_str,ARRAY[1..10000]OF ELEM1);
#endif
  END_RECORD_TYP(Struct##_DOMAIN) 
-----
[ -d $OUT_DIR/aux/array/conc ] || mkdir $OUT_DIR/aux/array/conc
cat >$OUT_DIR/aux/array/conc/ccod <<'-----'
#ifndef fct
#define fct conc
#endif
#ifndef del
#define del MERGE(del1,_DOMAIN(x2));
#endif

  DOMAIN fct##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {Nat0 ll1 = ref##_DOMAIN(x1)->f_len;
    Nat0 ll = ll1 + ref##_DOMAIN(x2)->f_len;
    if (ll > x1->f_max)
      {DOMAIN lx3 = alloc##_DOMAIN(ll);
       register Nat0 i = ll1;
       register ELEM1 * px3 = (ELEM1 *)(lx3 + 1);
       register ELEM1 * px1 = (ELEM1 *)( x1 + 1);
       while (i--) *(px3++) = *(px1++);
       del1##_DOMAIN(x1);
       x1 = lx3;
      }
    else x1->f_len = ll;
    {register Nat0 i = x2->f_len;
     register ELEM1 * px1 = ((ELEM1 *)( x1 + 1)) + ll1;
     register ELEM1 * px2 =  (ELEM1 *)( x2 + 1);
     while (i--) *(px1++) = *(px2++);
     del
    }
    return x1;
   }

#undef del
#undef fct
-----
[ -d $OUT_DIR/aux/array/copy1 ] || mkdir $OUT_DIR/aux/array/copy1
cat >$OUT_DIR/aux/array/copy1/ccod <<'-----'
#ifndef fct
#define fct copy1
#endif

#ifndef elem
#define elem ELEM1
#endif

#ifndef copyelem
#define copyelem(z1) z1
#endif

  DOMAIN fct##_DOMAIN _FPH1(DOMAIN)
   {Nat0    l1 = ref##_DOMAIN(x1)->f_len;
    DOMAIN  x2 = alloc##_DOMAIN(l1);
    register elem * px1 = (elem *)(x1+1);
    register elem * px2 = (elem *)(x2+1);
    register Nat0 i = 0;
    while (i++ != l1) *(px2++) = copyelem(*(px1++));
    return x2;
   }

#undef elem
#undef copyelem
#undef fct
-----
[ -d $OUT_DIR/aux/array/del1 ] || mkdir $OUT_DIR/aux/array/del1
cat >$OUT_DIR/aux/array/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(x1);}
-----
cat >$OUT_DIR/aux/array/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(z1) free##_DOMAIN(z1)
-----
[ -d $OUT_DIR/aux/array/forall ] || mkdir $OUT_DIR/aux/array/forall
cat >$OUT_DIR/aux/array/forall/ccod <<'-----'
  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    ELEM1 * px1 = (ELEM1 * )(x1+1);
    while (lx1--) (*x2)(*(px1++));
   } 
-----
[ -d $OUT_DIR/aux/array/is_empty ] || mkdir $OUT_DIR/aux/array/is_empty
cat >$OUT_DIR/aux/array/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN)
   {return (ref##_DOMAIN(x1)->f_len == 0);}
-----
cat >$OUT_DIR/aux/array/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (! (ref##_DOMAIN((x1))->f_len) )
-----
cat >$OUT_DIR/aux/array/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (x1^.f_len = 0)
-----
[ -d $OUT_DIR/aux/array/len ] || mkdir $OUT_DIR/aux/array/len
cat >$OUT_DIR/aux/array/len/ccod <<'-----'
#ifndef fct
#define fct len
#endif

  Nat0 fct##_DOMAIN _FPH1(DOMAIN) {return (ref##_DOMAIN(x1)->f_len);}
#undef fct
-----
cat >$OUT_DIR/aux/array/len/cmcr <<'-----'
#ifndef fct
#define fct len
#endif

_DEFINE fct##_DOMAIN(x1) (ref##_DOMAIN((x1))->f_len)
#undef fct
-----
cat >$OUT_DIR/aux/array/len/docu <<'-----'
  selecting the number of elements in a structured value
  parameters :
   fct   function name (len, card, ...)
-----
cat >$OUT_DIR/aux/array/len/pmcr <<'-----'
#ifndef fct
#define fct len
#endif

_DEFINE fct##_DOMAIN(x1) x1^.f_len
#undef fct
-----
[ -d $OUT_DIR/aux/array/mk1 ] || mkdir $OUT_DIR/aux/array/mk1
cat >$OUT_DIR/aux/array/mk1/ccod <<'-----'
#ifndef params
#define params _FP(x1,ELEM1)
#endif
#ifndef paramdec
#define paramdec _EP(x1,ELEM1)
#endif
#ifndef assign
#define assign(z1) *((ELEM1 *)(z1+1)) = x1
#endif

  DOMAIN mk1##_DOMAIN(params) paramdec
  {DOMAIN lx1 = alloc##_DOMAIN((Nat0)1);
   assign(lx1);
   return lx1;
  } 

#undef params
#undef paramdec
#undef assign
-----
[ -d $OUT_DIR/aux/array/mk_empty ] || mkdir $OUT_DIR/aux/array/mk_empty
cat >$OUT_DIR/aux/array/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0()
  {return alloc##_DOMAIN((Nat0)0);}
-----
cat >$OUT_DIR/aux/array/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() alloc##_DOMAIN((Nat0)0)
-----
[ -d $OUT_DIR/aux/array/mkn_empty ] || mkdir $OUT_DIR/aux/array/mkn_empty
cat >$OUT_DIR/aux/array/mkn_empty/ccod <<'-----'
  _FDEC1(mkn_empty,DOMAIN,Nat0,DOMAIN lx1 = alloc##_DOMAIN(x1); lx1->f_len = 0; return lx1;)
-----
[ -d $OUT_DIR/aux/automem ] || mkdir $OUT_DIR/aux/automem
[ -d $OUT_DIR/aux/automem/attribute ] || mkdir $OUT_DIR/aux/automem/attribute
cat >$OUT_DIR/aux/automem/attribute/ccod <<'-----'
#if !defined(PTYPE1)
#define PTYPE1 DOMAIN
#endif
#if !defined(RESULT)
#define RESULT Bool
#endif

#if defined(PTYPE3)
#define PARLIST1 _FPH3(PTYPE1,PTYPE2,PTYPE3)
#else
#if defined(PTYPE2)
#define PARLIST1 _FPH2(PTYPE1,PTYPE2)
#else
#define PARLIST1 _FPH1(PTYPE1)
#endif
#endif

#if !defined(P1_IS_ELEM)
#define AP1 x1->f_rep
#else
#define AP1 x1
#endif

#if defined(PTYPE2)
#if !defined(P2_IS_ELEM)
#define AP2 , x2->f_rep
#else
#define AP2 , x2
#endif
#else
#define AP2
#endif

#if defined(PTYPE3)
#if !defined(P3_IS_ELEM)
#define AP3 , x3->f_rep
#else
#define AP3 , x3
#endif
#else
#define AP3
#endif

#define PARLIST2 (AP1 AP2 AP3)

RESULT NAME##_DOMAIN PARLIST1
{
#if !defined(P1_IS_ELEM)
   check_handle##_DOMAIN(x1);
#endif
#if defined(PTYPE2) && !defined(P2_IS_ELEM)
   check_handle##_DOMAIN(x2);
#endif
#if defined(PTYPE3) && !defined(P3_IS_ELEM)
   check_handle##_DOMAIN(x3);
#endif
   return NAME##_rep##_DOMAIN PARLIST2 ;
}

#undef RESULT
#undef PTYPE1
#undef PTYPE2
#undef PTYPE3
#undef NAME
#undef P1_IS_ELEM
#undef P2_IS_ELEM
#undef P3_IS_ELEM
#undef PARLIST1
#undef PARLIST2
#undef AP1
#undef AP2
#undef AP3
-----
cat >$OUT_DIR/aux/automem/attribute/cmcr <<'-----'
#if defined(THREE_PARAM)
#define MPARLIST x1,x2,x3
#else
#if defined(TWO_PARAM)
#define MPARLIST x1,x2
#else
#define MPARLIST x1
#endif
#endif

#if !defined(P1_IS_ELEM)
#define AP1 (x1)->f_rep
#else
#define AP1 (x1)
#endif

#if defined(TWO_PARAM) || defined(THREE_PARAM)
#if !defined(P2_IS_ELEM)
#define AP2 , (x2)->f_rep
#else
#define AP2 , (x2)
#endif
#else
#define AP2
#endif

#if defined(THREE_PARAM)
#if !defined(P3_IS_ELEM)
#define AP3 , (x3)->f_rep
#else
#define AP3 , (x3)
#endif
#else
#define AP3
#endif

#define PARLIST AP1 AP2 AP3

_DEFINE NAME##_DOMAIN(MPARLIST) NAME##_rep##_DOMAIN(PARLIST)

#undef TWO_PARAM
#undef THREE_PARAM
#undef NAME
#undef P1_IS_ELEM
#undef P2_IS_ELEM
#undef P3_IS_ELEM
#undef PARLIST
#undef MPARLIST
#undef AP1
#undef AP2
-----
cat >$OUT_DIR/aux/automem/attribute/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + NAME
#undef NAME
-----
[ -d $OUT_DIR/aux/automem/autoresult ] || mkdir $OUT_DIR/aux/automem/autoresult
cat >$OUT_DIR/aux/automem/autoresult/ccod <<'-----'
#ifndef RESULT
#define RESULT Str
#define _RESULT _str
#endif

  RESULT FCTNAME##_DOMAIN _FPH1(DOMAIN)
   { RESULT lx;
     lx = alloc##_RESULT();
     lx->f_rc  = 1;
     lx->f_rep = REPFCTNAME##_DOMAIN(x1);
     return lx;
   }

#undef RESULT
#undef _RESULT
#undef FCTNAME
#undef REPFCTNAME
-----
[ -d $OUT_DIR/aux/automem/basic ] || mkdir $OUT_DIR/aux/automem/basic
cat >$OUT_DIR/aux/automem/basic/ccod <<'-----'
void cond_clone##_DOMAIN _FPH1(DOMAIN *)
{
   if ((*x1)->f_rc > 1)
   {
      DOMAIN clone = alloc##_DOMAIN();
      clone->f_rc = 1;
      (*x1)->f_rc--;
      clone->f_rep = copy_rep##_DOMAIN((*x1)->f_rep);
      *x1 = clone;
   }
}
-----
cat >$OUT_DIR/aux/automem/basic/docu <<'-----'
  'automem' is an implementation of a TYPGEN with automatic memory management.
  It will be much easier to write your C++ programs with this implementation,
  because you do not have to worry about copying or deleting objects,
  but you should expect some performance penalties.

  All operations which delete elements (ending with -d, e.g. union1d) and all
  copy- and del-operations are not needed and therefore are not avaiable.

  The memory management is done by building a wrapper around the "base"
  implementation, in the wrapper reference counting is done, as well as
  automatic duplication and deletion of objects.

  An __HYPEREXAMPLE(example for automem implementations,REF,/automem/README.html) is in the
  Test __HYPEREXAMPLE(examples directory, REF,/README.html)

  __HYPERBIG(All automem members are written in __IMAGELINKALIGN(c,mime:mimelib.aux.pics.cpp,middle) )


  Warning:
  ========

     - This implementation can only be used with C++ as target language !

     - Most error checking will be done by BASEIMPL, so error messages may 
       contain the name of an auxialiary domain 'Rep_DOMAIN' instead of the 
       expected 'DOMAIN'.

     - Elements of "automem" domains should also be implemented
       by an automem implementation or by elementary types
       (Nat0,Nat1,Char,Bool) to achieve optimal performance

#ifdef MAP
     - The implementation 'heap' can not be used as BASEIMPL  (this will
       cause runtime errors) !
#endif

#ifdef OPTI
     - The implementation 'ptelem' can not be used as BASEIMPL, because
       the used NIL value has already another meaning in all automem
       implementations. Use 'elemonil' with NILVAL<>0 instead !
#endif


  If the ".vdm" file is processed with the A++ option instead
  of the C++ option, the wrapper is built automatically around
  the "base" implementation, and no parameters need to be supported

  Parameters:

  'BASEIMPL' :
               Choose the 'real' TYPGEN implementation. The automem
               implementation is only a wrapper around BASEIMPL that
               provides the automatic memory management.
               You must always specify BASEIMPL !

  'NOCHECK' :
               No check for uninitialised objects (created by the
               default constructor DOMAIN::DOMAIN()) will be done
               Use this option with care.

  Space requirements:

      Space(BASEIMPL) + sizeof(unsigned long) [ + sizeof(void *) ]
#undef TYPGEN
#undef OPTI
#undef MAP
-----
cat >$OUT_DIR/aux/automem/basic/docucopydel <<'-----'

  For the C++ interface with automatic memory management
  this function is not required, there copying and deleting
  values is performed implicitly by constructors, assignments
  and destrutors.

-----
cat >$OUT_DIR/aux/automem/basic/gimp <<'-----'
/* THIS IS THE GIMP-FILE */
-----
cat >$OUT_DIR/aux/automem/basic/gptr <<'-----'
TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Handle##_DOMAIN))
-----
cat >$OUT_DIR/aux/automem/basic/gtyp <<'-----'
	 
START_RECORD_TYP(Handle##_DOMAIN)
	RECFIELD(f_rep,Rep##_DOMAIN);
	RECFIELD(f_rc,Nat0);
END_RECORD_TYP(Handle##_DOMAIN) 

_DEFINE AUTOMEM##_DOMAIN

#ifdef GEN_C
void cond_clone##_DOMAIN P_OP DOMAIN * P_CL ;
#endif

#ifndef NOCHECK
_DEFINE check_handle##_DOMAIN(h)  if ((h) == 0) err_nv_hdl_vdmlib(MKSTRING(DOMAIN));
#else
_DEFINE check_handle##_DOMAIN(h)
#endif
#undef NOCHECK
-----
cat >$OUT_DIR/aux/automem/basic/vdm <<'-----'
#ifndef BASEIMPL
#error === Parameter 'BASEIMPL' must be specified ===
#endif

DOMAINS

  Rep##_DOMAIN  = REP_DOMAIN
  Heap##_DOMAIN	= DOMAIN -heap

  DOMAIN -> Heap##_DOMAIN
  DOMAIN -> Rep##_DOMAIN
	
IMPLEMENTATIONS

  Rep##_DOMAIN  = BASEIMPL 
                + copy ! allways needed by function cond_clone() !

  Heap##_DOMAIN = freelist ("INTERNALDOMAIN", "MAXLEN"="100", "PROFILE")
		+ alloc("STRUCT"="struct Handle" #_DOMAIN)

  DOMAIN        = + del ! always needed for destrutor !

#ifdef ELEM1
  ELEM1         = + copy + del
#endif

#ifdef ELEM2
  ELEM2         = + copy + del
#endif

#ifndef NOCHECK
  Vdmlib        = + err_nv_hdl
#endif
  
#undef BASEIMPL
#undef NOCHECK
#undef REP_DOMAIN
-----
[ -d $OUT_DIR/aux/automem/copy ] || mkdir $OUT_DIR/aux/automem/copy
cat >$OUT_DIR/aux/automem/copy/ccod <<'-----'
DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
{
   check_handle##_DOMAIN(x1);
   x1->f_rc++;
   return x1;
}
-----
[ -d $OUT_DIR/aux/automem/cvfromtup1 ] || mkdir $OUT_DIR/aux/automem/cvfromtup1
cat >$OUT_DIR/aux/automem/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
{
   DOMAIN lx = alloc##_DOMAIN();
   lx->f_rc  = 1;
   lx->f_rep = cvfromtup1_rep##_DOMAIN(x1);
   return lx;
}

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/aux/automem/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/aux/automem/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/aux/automem/cvfromtupl ] || mkdir $OUT_DIR/aux/automem/cvfromtupl
cat >$OUT_DIR/aux/automem/cvfromtupl/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAIN cvfromtupl##_DOMAIN _FPH1(TUPLDOMAIN)
{
   DOMAIN lx = alloc##_DOMAIN();
   lx->f_rc  = 1;  /* =1, if C++ constructor, otherwise = 0 */
_IFDEF AUTOMEM##_TUPLDOMAIN
   check_handle##_TUPLDOMAIN(x1);
   cond_clone##_TUPLDOMAIN(&x1);
_ENDIF
   lx->f_rep = cvfromtup1_rep##_DOMAIN(&x1);  /* destroys the tuple with tld ! */ 
   del##_TUPLDOMAIN(x1);
   return lx;
}

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/aux/automem/cvfromtupl/param <<'-----'
TUPLDOMAIN
NOCPP
-----
cat >$OUT_DIR/aux/automem/cvfromtupl/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
   DOMAIN -> TUPLDOMAIN  
IMPLEMENTATIONS
   Rep##_DOMAIN = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
   TUPLDOMAIN   = + del 

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/aux/automem/cvtotup1 ] || mkdir $OUT_DIR/aux/automem/cvtotup1
cat >$OUT_DIR/aux/automem/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN, DOMAIN)
{
   check_handle##_DOMAIN(x2);
   return cvtotup1_rep##_DOMAIN(x1, x2->f_rep); 
}

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/aux/automem/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/aux/automem/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/aux/automem/cvtotupl ] || mkdir $OUT_DIR/aux/automem/cvtotupl
cat >$OUT_DIR/aux/automem/cvtotupl/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

TUPLDOMAIN cvtotupl##_DOMAIN _FPH1(DOMAIN)
{
   TUPLDOMAIN lx;
   check_handle##_DOMAIN(x1);
   lx = cvtotup1_rep##_DOMAIN(mk_empty##_TUPLDOMAIN(),x1->f_rep);
   return lx;
}

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/aux/automem/cvtotupl/param <<'-----'
TUPLDOMAIN
NOCPP
-----
cat >$OUT_DIR/aux/automem/cvtotupl/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
   TUPLDOMAIN   = + mk_empty

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/aux/automem/del ] || mkdir $OUT_DIR/aux/automem/del
cat >$OUT_DIR/aux/automem/del/ccod <<'-----'
void del##_DOMAIN _FPH1(DOMAIN)
{
   if ((x1 != 0) && (--x1->f_rc == 0))
   {
      del_rep##_DOMAIN(x1->f_rep);
      free##_DOMAIN(x1);
   }
}
-----
cat >$OUT_DIR/aux/automem/del/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + del
-----
[ -d $OUT_DIR/aux/automem/forall ] || mkdir $OUT_DIR/aux/automem/forall
cat >$OUT_DIR/aux/automem/forall/ccod <<'-----'
void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
{
   check_handle##_DOMAIN(x1);
   forall_rep##_DOMAIN(x1->f_rep,x2);
}
-----
cat >$OUT_DIR/aux/automem/forall/cmcr <<'-----'
_DEFINE forall##_DOMAIN(x1,x2)   forall_rep##_DOMAIN(x1->f_rep,x2)
-----
cat >$OUT_DIR/aux/automem/forall/vdm <<'-----'

DOMAINS
IMPLEMENTATIONS
  Rep##_DOMAIN = + forall
-----
[ -d $OUT_DIR/aux/automem/gcinfo ] || mkdir $OUT_DIR/aux/automem/gcinfo
cat >$OUT_DIR/aux/automem/gcinfo/ccod <<'-----'
#define Handle Nat0

/* The functions get_gc_info1 returns the handle to the passed ADT if the
   DOMAIN is an automem implementation, otherwise 0 will be returned !
*/

static Adts * ptr_adts##_DOMAIN;
static Handles handles##_DOMAIN;

#if defined(ELEM2)
void get_gc_info2##_DOMAIN(ELEM1 x1, ELEM2 x2)
#else
void get_gc_info2##_DOMAIN(ELEM1 x1)
#endif
{
   Handle a_handle;
   a_handle = get_gc_info1##_ELEM1(x1, ptr_adts##_DOMAIN);
   if (a_handle != 0)
      handles##_DOMAIN = union1_handles(handles##_DOMAIN, a_handle);
#if defined(ELEM2)
   a_handle = get_gc_info1##_ELEM1(x2, ptr_adts##_DOMAIN);
   if (a_handle != 0)
      handles##_DOMAIN = union1_handles(handles##_DOMAIN, a_handle);
#endif
}

Handle get_gc_info1##_DOMAIN(DOMAIN x1, Adts * x2)
{
   check_handle##_DOMAIN(x1);
   ptr_adts##_DOMAIN = x2;

   if (!is_in_adts((Handle) x1, *ptr_adts##_DOMAIN))
   {
      Handles temp_save = handles##_DOMAIN;   /* required for recursive types */
      Adt my_adt;

      handles##_DOMAIN = mk_empty_handles();

      forall_rep##_DOMAIN(x1->f_rep, get_gc_info2##_DOMAIN);
      /* We have to manipulate the reference counter of handles##_DOMAIN and
         my_adt manually, because the called operations were designed to be
         called	from C++ and not from C ! */
_IFDEF AUTOMEM_handles
     handles##_DOMAIN->f_rc = 0;    
_ENDIF 
      my_adt = mk_adt(x1->f_rc, handles##_DOMAIN);
_IFDEF AUTOMEM_adt
     my_adt->f_rc = 0;    
_ENDIF 
      *ptr_adts##_DOMAIN = union1_adts(*ptr_adts##_DOMAIN, (Handle) x1, my_adt);

      handles##_DOMAIN = temp_save;
   }
	
   return (Handle) x1;
}

Adts get_gc_info##_DOMAIN(DOMAIN x1)
{
   check_handle##_DOMAIN(x1);

   Adts lx = mk_empty_adts();
   (void) get_gc_info1##_DOMAIN(x1, &lx);
   return lx;
}

#undef Handle
-----
cat >$OUT_DIR/aux/automem/gcinfo/docu <<'-----'
The operation 'gcinfo' is only avaiable for testing the automem implementation 
and can not be used for other purposes !
==============================================================================

These operations create the data structure

        Adts     = Handle -m-> Adt
        Adt      = ref-cnt : Nat0   elems : Elements
        Elements = Handle -bag,

used in the specification of the automatic memory management, from the actual
data used in a program. To create this data, call the member function
get_gc_info in your C++ program for any data type with an automem
implementation. To find out what handle is used for an ADT, use the member
function get_handle (these operations must be explicitly selected by adding the
operation 'gcinfo' to your ADT!).

ATTENTION: 

a) Not all ADT used in your program will be included in the created
   Adts; only ADT which can be reached by a sequence of the selector operations
   from the ADT, for whom you called get_gc_info, will be included !

b) You must include the file <aux/automem/gcinfo/gcinfo.inc> into your own DSL 
   specification to use this test facility.

c) The DSL specification must be compiled with the '-M' command line option
   set 

d) To test the optional, you must explicitly select the automem
   implementation with "automem(BASEIMPL=...)"

=============================================================================

Example:

1) test.vdm

   include "gcinfo.inc"
   DOMAINS
      Mymap = Nset -m-> Nset
      Nset  = Nat -set
   IMPLEMENTIONS
      Mymap = automem("BASEIMPL"="linklist") + ... + gcinfo
      Nset  = automem("BASEIMPL"="linklist") + ...
  
2) test_prog.cc

   include "test.hpp"
   main()
   {
      NSET n1 = NSET(100), n2 = NSET(200);
      MYMAP m1 = MYMAP(n1,n2);
      m1.plus1(n2,n1);
      cout << n1.get_handle() << n2.get_handle() << m1.get_handle();
      cout << s1.get_gc_info();
   }	
   
-----
cat >$OUT_DIR/aux/automem/gcinfo/gcinfo.inc <<'-----'
#define Handle Nat0
#define Var    Nat0

DOMAINS

#if defined(FULL_DEBUG)
   Variables = Var -set   
   Daten     = Var -m-> Handle
#endif
   Adts      = Handle -m-> Adt
   Adt      :: s_rc : Nat0 s_elems : Handles
   Handles   = Handle -bag

IMPLEMENTATIONS

#if defined(FULL_DEBUG)
   Variables = linklist
             + mk_empty + union1 + sub1 + sel + is_empty
   Daten     = linklist  ! dont use scaldom here, or you need *MUCH* memory !
             + mk_empty + union1 + fpr
#endif
  Adts    = linklist     ! dont use scaldom here, or you need *MUCH* memory !
          + mk_empty + union1 + is_in + union + fpr
  Adt     = ptstruct
          + mk
  Handles = linklist
          + mk_empty + union1
-----
cat >$OUT_DIR/aux/automem/gcinfo/test_template <<'-----'
// Template fr Programme die den State 'Program' (siehe Spezifikation)
// ermitteln wollen
//
// Vorgehensweise:
//
//      1. In der DSL-Spezifikation mu das Flag FULL_DEBUG definiert und 
//         die Datei "gcinfo.inc" includiert werden ! Fr alle Adt mu
//         die Operation "gcinfo" in den Enrichments angefordert werden.
//         bersetzen mit Parameter "-M" in der Kommandozeile des 
//         VDM-Compilers.
//
// 	2. fr jeden ADT mu eine Kopie von CHECKED_DOMAIN erzeugt
//         werden, DOMAIN mu dabei durch den Namen des ADT ersetzt werden
//         Im Programm werden dann nur noch die Klassen CHECKED_DOMAIN
//         anstelle von DOMAIN verwendet ! Alle definierten Operationen
//         stehen auch hier zur Verfgung.
//
//      3. In dieser Klasse mu fr *jeden* vorhandenen Konstruktor des
//         ADT ein Konstuktor entsprechend den vorhandenen Beispielen
//         erzeugt werden (d.h Aufruf des Konstruktors von ADT und Eintragen
//         von this in die Menge the_variables)
//
//      4. Testprogramm in Funktion test_proc eintragen
//
//      5. Warnungen bezglich virtueller Destruktoren beim Compilieren
//         ignorieren !
//    
//      6. Zur Ausgabe des Zustandes "Program" die Funktion 
//                      show_state_program() 
//         aufrufen. Um herauszufinden welcher Token Var fr ein Objekt 
//         verwendet wird, folgende Anweisung verwenden
//
//              VAR my_var = ((Var)my_domain.get_the_var()) % 10000 
// 
//         (Nicht sehr komfortabel, o.k. !)
//     
//    Als Beispiel kann das Programm spec2_test.cc,spec2.vdm verwendet werden !   
//
//
// Hinweise: 
//            - Fr den Token Var wird der Wert *this des entsprechenden
//              Objektes verwendet; zur besseren Lesbarkeit wird 
//              *this mod 10000 ausgegeben ! Dies funktioniert unter Linux 
//              V0.99.9/g++ 2.3.3 hervorragend (sonst alle Objekte im 3 oder 
//              4 Gigabyte), mu fr andere Systeme aber evtl. gendert werden !
//
//            - Fr den Token Handle wird die Adresse des Handle_Struct im 
//              Heap verwendet
//
// Version : 1.0/26-01-94
// ===========================================================================


#include "INSERT YOUR HEADERFILE HERE"

// --- globale Variablen/Konstanten: ------ DO NOT CHANGE ! ------------------

#define Var    Nat0
#define Handle Nat0
#define VAR    NAT0
#define HANDLE NAT0

VARIABLES the_variables = empty;

// ----------------------------------------- DO NOT CHANGE ! ------------------
 
class CHECKED_ADT {
public: 
   virtual VAR get_the_var(void)         = 0;
   virtual HANDLE get_the_handle(void)   = 0;
   virtual ADTS get_the_local_adts(void) = 0;
};

// ----------------------------------------- DO NOT CHANGE ! -----------------

void show_state_program(void)
{
   DATEN     data = DATEN(empty);
   ADTS      adts = ADTS(empty);
   VARIABLES temp = the_variables;

	while (!temp.is_empty())
	{
	   NAT0 a_var = temp.sel();
	   CHECKED_ADT * ptr_var = (CHECKED_ADT *) Nat0(a_var);
	   data.plus1( Nat0(a_var) % 10000, ptr_var->get_the_handle());
	   if (ptr_var->get_the_handle() != 0 /* nil */ )
	      adts |= ptr_var->get_the_local_adts();
	      
	   temp -= a_var;
	}   
	cout << "State 'program' is : \n";
	cout << "\tdata = " << data << "\tadts = " << adts;
	cout << "\n";
}

// --- TEMPLATE --------------- fr jeden ADT kopieren und Namen anpassen ----
//                              (d.h. DOMAIN durch Namen des ADT ersetzen)

class CHECKED_DOMAIN : public CHECKED_ADT, public DOMAIN{
public:
   CHECKED_DOMAIN()  // constructor DOMAIN called implicitly 
      { the_variables.plus1(VAR( (Var)this ));}
   ~CHECKED_DOMAIN()
      { the_variables.sub1(VAR( (Var)this ) );}
   CHECKED_DOMAIN(const CHECKED_DOMAIN& x) : DOMAIN(x)
      { the_variables.plus1(VAR( (Var)this ));}   

   // Dieser Zuweisungsoperator wird bentigt, da sonst das Resultat eines
   // Selektors nicht zugewiesen kann !
   CHECKED_DOMAIN& operator=(const DOMAIN& x1)
   { 
      check_handle_domain(x1.data);   // hier Name des ADT in Kleinbuchstaben!
      (x1.data)->f_rc++;
      if (data!=0) del_domain(data);  // hier Name des ADT in Kleinbuchstaben!
      data = x1.data;
      return *this;
   }
   
   // --- fr jeden Konstruktor des ADT mu entsprechender Konstruktor
   // --- fr diese Klasse definiert werden
   //
   // CHECKED_DOMAIN(NILETC& x) : DOMAIN(x)          Beispiel: mk_empty
   //    { the_variables.plus1(VAR( (Var)this ));}
   // CHECKED_DOMAIN(CHECKED_DOMAIN& x) : DOMAIN(x)    Beispiel: mk1
   //    { the_variables.plus1(VAR( (Var)this ));}
   

   // --- DO NOT CHANGE: ----
   virtual VAR get_the_var(void) { return VAR( (Var)this );}   
   virtual HANDLE get_the_handle(void) { return HANDLE(get_handle());}
   virtual ADTS get_the_local_adts(void) { return get_gc_info(); }
};

// --- Testfunktionen: -----------------------------------------------------

void test_prog(void)
{
     // HIER DAS EIGENE TESTPROGRAMM EINFGEN
}

// -------------------------------------------------------------------------

main()
{
   cout << "(Init) "; show_state_program();

	test_prog();

   cout << "(End) "; show_state_program();
   return 0;
}
-----
cat >$OUT_DIR/aux/automem/gcinfo/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + forall
   ELEM1        = + gcinfo
#if defined(ELEM2)
   ELEM2        = + gcinfo
#endif
-----
[ -d $OUT_DIR/aux/automem/iterator ] || mkdir $OUT_DIR/aux/automem/iterator
cat >$OUT_DIR/aux/automem/iterator/vdm <<'-----'
/* value of BASEIMPL does not matter here */
#define PARAM "BASEIMPL"="unknown"
#define IMPL automem
#include <aux/com/iterator/vdm>

-----
[ -d $OUT_DIR/aux/automem/map_is_in_xxx ] || mkdir $OUT_DIR/aux/automem/map_is_in_xxx
cat >$OUT_DIR/aux/automem/map_is_in_xxx/ccod <<'-----'
#if !defined(P1_IS_ELEM2)
#define PTYPE1  ELEM1
#else
#define PTYPE1  ELEM2
#endif
#if !defined(P3_IS_ELEM2)
#define PTYPE3  ELEM1
#define _PTYPE3 _ELEM1
#else
#define PTYPE3  ELEM2
#define _PTYPE3 _ELEM2
#endif
Bool NAME##_DOMAIN _FPH3(PTYPE1 , DOMAIN, PTYPE3 *)
{
   PTYPE3 lx;
   Bool   res;
   check_handle##_DOMAIN(x2);
   del##_PTYPE3(*x3);  /* delete any old value for x3 */
   res = NAME##_rep##_DOMAIN(x1,x2->f_rep,&lx);
   if (res==TRUE)
      *x3 = copy##_PTYPE3(lx);
   else
      *x3 = 0;        /* mark element as 'not valid' */
   return res;
}
#undef NAME
#undef PTYPE1
#undef PTYPE3
#undef _PTYPE3
#undef P1_IS_ELEM2
#undef P3_IS_ELEM2
-----
cat >$OUT_DIR/aux/automem/map_is_in_xxx/vdm <<'-----'
#if !defined(P3_IS_ELEM2)
#define PTYPE3 ELEM1
#else
#define PTYPE3 ELEM2
#endif
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + NAME
   PTYPE3       = + copy + del
#undef NAME
#undef P1_IS_ELEM2
#undef P3_IS_ELEM2
#undef PTYPE3
-----
[ -d $OUT_DIR/aux/automem/mk ] || mkdir $OUT_DIR/aux/automem/mk
cat >$OUT_DIR/aux/automem/mk/ccod <<'-----'
#if defined(P1_INSERTED) && !defined(PTYPE1)
#define PTYPE1 ELEM1
#define _PTYPE1 _ELEM1
#endif
#if defined(P2_INSERTED) && !defined(PTYPE2)
#define PTYPE2 ELEM2
#define _PTYPE2 _ELEM2
#endif

#if defined(PTYPE1) && defined(PTYPE2) && defined(PTYPE3)
#define PARLIST1 _FPH3(PTYPE1,PTYPE2,PTYPE3)
#define PARLIST2 (x1,x2,x3)
#elif defined(PTYPE1) && defined(PTYPE2)
#define PARLIST1 _FPH2(PTYPE1,PTYPE2)
#define PARLIST2 (x1,x2)
#elif defined(PTYPE1)
#define PARLIST1 _FPH1(PTYPE1)
#define PARLIST2 (x1)
#else
#define PARLIST1 _FPH0()
#define PARLIST2 ()
#endif
DOMAIN NAME##_DOMAIN PARLIST1
{ 
   DOMAIN l = alloc##_DOMAIN();
   l->f_rc  = 1;
#if defined(P1_INSERTED)
   x1 = copy##_PTYPE1(x1);
#endif
#if defined(P2_INSERTED)
   x2 = copy##_PTYPE2(x2);
#endif
#if defined(P3_INSERTED)
   x3 = copy##_PTYPE2(x3);
#endif
   l->f_rep = NAME##_rep##_DOMAIN PARLIST2;
   return l;
}
#undef NAME
#undef PTYPE1
#undef _PTYPE1
#undef PTYPE2
#undef _PTYPE2
#undef PTYPE3
#undef _PTYPE3
#undef P1_INSERTED
#undef P2_INSERTED
#undef P3_INSERTED
#undef PARLIST1
#undef PARLIST2
-----
cat >$OUT_DIR/aux/automem/mk/vdm <<'-----'
#if defined(P1_INSERTED) && !defined(PTYPE1)
#define PTYPE1 ELEM1
#endif
#if defined(P2_INSERTED) && !defined(PTYPE2)
#define PTYPE2 ELEM2
#endif
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + NAME
#if defined(PTYPE1) && defined(P1_INSERTED)
    PTYPE1       = + copy
#endif
#if defined(PTYPE2) && defined(P2_INSERTED)
    PTYPE2       = + copy
#endif
#if defined(PTYPE3) && defined(P3_INSERTED)
    PTYPE3       = + copy
#endif
#undef NAME
#undef PTYPE1
#undef P1_INSERTED
#undef PTYPE2
#undef P2_INSERTED
#undef PTYPE3
#undef P3_INSERTED
-----
[ -d $OUT_DIR/aux/automem/mk_special ] || mkdir $OUT_DIR/aux/automem/mk_special
cat >$OUT_DIR/aux/automem/mk_special/ccod <<'-----'
#if !defined(REP_NAME)
#define REP_NAME NAME
#endif
#if !defined(PTYPE2)
DOMAIN NAME##_DOMAIN _FPH1(PTYPE1)
#else
DOMAIN NAME##_DOMAIN _FPH2(PTYPE1,PTYPE2)
#endif
{ 
   DOMAIN l = alloc##_DOMAIN();
   l->f_rc  = 1;
#if !defined(PTYPE2)
   l->f_rep = REP_NAME##_rep##_DOMAIN(x1);
#else
   l->f_rep = REP_NAME##_rep##_DOMAIN(x1,x2);
#endif
   return l;
}
#undef PTYPE2
#undef PTYPE1
#undef REP_NAME
#undef NAME
-----
cat >$OUT_DIR/aux/automem/mk_special/vdm <<'-----'
#if !defined(REP_NAME)
#error automem/mk_special/vdm: NAME must be defined 
#endif
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + REP_NAME
#undef REP_NAME
-----
[ -d $OUT_DIR/aux/automem/parse ] || mkdir $OUT_DIR/aux/automem/parse
cat >$OUT_DIR/aux/automem/parse/ccod <<'-----'
DOMAIN parse##_DOMAIN _FPH0()
{
   DOMAIN lx = alloc##_DOMAIN();
   lx->f_rc  = 1;
   lx->f_rep = parse_rep##_DOMAIN();
   return lx;
}
-----
cat >$OUT_DIR/aux/automem/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + parse
-----
[ -d $OUT_DIR/aux/automem/selector ] || mkdir $OUT_DIR/aux/automem/selector
cat >$OUT_DIR/aux/automem/selector/ccod <<'-----'
#if !defined(RESULT)
#define RESULT ELEM1
#define _RESULT _ELEM1
#endif

#if !defined(P2_TYPE)
#define PARLIST1 _FPH1(DOMAIN)
#define PARLIST2 (x1->f_rep)
#else
#define PARLIST1 _FPH2(DOMAIN,P2_TYPE)
#define PARLIST2 (x1->f_rep,x2)
#endif

RESULT NAME##_DOMAIN PARLIST1
{
   check_handle##_DOMAIN(x1);
   return copy##_RESULT(NAME##_rep##_DOMAIN PARLIST2);
}
#undef NAME
#undef RESULT
#undef _RESULT
#undef P2_TYPE
#undef PARLIST1
#undef PARLIST2
-----
cat >$OUT_DIR/aux/automem/selector/cmcr <<'-----'
#if !defined(RESULT)
#define RESULT ELEM1
#define _RESULT _ELEM1
#endif

#if !defined(P2_TYPE)
#define PARLIST1 x1
#define PARLIST2 (x1)->f_rep
#else
#define PARLIST1 x1,x2
#define PARLIST2 (x1)->f_rep,x2
#endif

_DEFINE NAME##_DOMAIN(PARLIST1) copy##_RESULT(NAME##_rep##_DOMAIN(PARLIST2))

#undef NAME
#undef RESULT
#undef _RESULT
#undef P2_TYPE
#undef PARLIST1
#undef PARLIST2
-----
cat >$OUT_DIR/aux/automem/selector/vdm <<'-----'
#if !defined(RESULT)
#define RESULT ELEM1
#endif
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + NAME
   RESULT       = + copy
#undef NAME
#undef RESULT
-----
[ -d $OUT_DIR/aux/automem/sort ] || mkdir $OUT_DIR/aux/automem/sort
cat >$OUT_DIR/aux/automem/sort/ccod <<'-----'
#define NAME sort
#include <aux/automem/structselector/ccod>
-----
cat >$OUT_DIR/aux/automem/sort/param <<'-----'
RESULT
COPY
-----
cat >$OUT_DIR/aux/automem/sort/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + sort("RESULT"=Rep##_RESULT,"COPY")
-----
[ -d $OUT_DIR/aux/automem/structselector ] || mkdir $OUT_DIR/aux/automem/structselector
cat >$OUT_DIR/aux/automem/structselector/ccod <<'-----'
#ifdef PAR2
#define PARLIST1 _FPH2(DOMAIN,PAR2)
#else
#define PARLIST1 _FPH1(DOMAIN)
#endif

RESULT NAME##_DOMAIN PARLIST1
{
   RESULT lx;

   check_handle##_DOMAIN(x1);
#ifdef PAR2
   check_handle##_PAR2(x2);
#endif
   lx = alloc##_RESULT();
   lx->f_rc  = 1;
   lx->f_rep = NAME##_rep##_DOMAIN(x1->f_rep
#ifdef PAR2
                                  ,x2->f_rep
#endif
                                  );
   return lx;
}

#undef NAME
#undef RESULT
#undef _RESULT
#undef PARLIST1
#undef PAR2
#undef _PAR2

-----
[ -d $OUT_DIR/aux/automem/update_D ] || mkdir $OUT_DIR/aux/automem/update_D
cat >$OUT_DIR/aux/automem/update_D/ccod <<'-----'
#if !defined(PTYPE2)
#define PTYPE2  ELEM1
#endif
#if !defined(_PTYPE2)
#define _PTYPE2 _ELEM1
#endif
#if !defined(PTYPE3)
#define PARLIST1 _FPH2(DOMAIN, PTYPE2)
#define PARLIST2 (x1->f_rep,x2)
#else
#define PARLIST1 _FPH3(DOMAIN, PTYPE2, PTYPE3)
#define PARLIST2 (x1->f_rep,x2,x3)
#endif
#if !defined(REP_NAME)
#define REP_NAME MERGE(NAME,d)
#endif

DOMAIN NAME##_DOMAIN PARLIST1
{
   check_handle##_DOMAIN(x1);
   cond_clone##_DOMAIN(&x1);
#if defined(P2_INSERTED)
   x2 = copy##_PTYPE2(x2);
#endif
#if defined(P3_INSERTED)
   x3 = copy##_PTYPE3(x3);
#endif
   x1->f_rep = REP_NAME##_rep##_DOMAIN PARLIST2 ;
   return x1;
}
#undef NAME
#undef REP_NAME
#undef PTYPE2
#undef _PTYPE2
#undef PTYPE3
#undef _PTYPE3
#undef P2_INSERTED
#undef P3_INSERTED
#undef PARLIST1
#undef PARLIST2
-----
cat >$OUT_DIR/aux/automem/update_D/vdm <<'-----'
#if !defined(PTYPE2)
#define PTYPE2 ELEM1
#endif
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = 
#if defined(REP_NAME)
   + REP_NAME
#else
   + MERGE(NAME,d)
#endif
#if defined(P2_INSERTED)
   PTYPE2 = + copy
#endif
#if defined(PTYPE3) && defined(P3_INSERTED)
   PTYPE3 = + copy
#endif
#undef NAME
#undef REP_NAME
#undef PTYPE2
#undef PTYPE3
#undef P2_INSERTED
#undef P3_INSERTED
-----
[ -d $OUT_DIR/aux/automem/update_DD ] || mkdir $OUT_DIR/aux/automem/update_DD
cat >$OUT_DIR/aux/automem/update_DD/ccod <<'-----'
#if defined(P2_DESTROYED)
#define LOCAL_COPY_P2  MERGE(Rep,_DOMAIN) lrep2 = MERGE(copy_rep,_DOMAIN)(x2->f_rep);
#define P2 lrep2
#else
#define LOCAL_COPY_P2
#define P2 x2->f_rep
#endif
#if !defined(REP_NAME)
#define REP_NAME MERGE(NAME,d)
#endif
DOMAIN NAME##_DOMAIN _FPH2(DOMAIN,DOMAIN)
{
   check_handle##_DOMAIN(x1);
   check_handle##_DOMAIN(x2);
   {
     LOCAL_COPY_P2
     cond_clone##_DOMAIN(&x1);
     x1->f_rep = REP_NAME##_rep##_DOMAIN(x1->f_rep,P2);
   }
   return x1;
}
#undef NAME
#undef REP_NAME
#undef P2_DESTROYED
#undef LOCAL_COPY_P2
#undef P2
-----
cat >$OUT_DIR/aux/automem/update_DD/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = 
#if defined(REP_NAME)
   + REP_NAME
#else
   + MERGE(NAME,d)
#endif
#if defined(P2_DESTROYED)
   + copy
#endif
#undef NAME
#undef REP_NAME
#undef P2_DESTROYED
-----
[ -d $OUT_DIR/aux/com ] || mkdir $OUT_DIR/aux/com
[ -d $OUT_DIR/aux/com/all ] || mkdir $OUT_DIR/aux/com/all
cat >$OUT_DIR/aux/com/all/docu <<'-----'
  General implementation based on 'fold'. Note that performance
  may change heavily depending if the implementaion of DOMAIN
  supports the 'ABORTVAL' parameter or not.

  See __SA(fold) for details.
-----
cat >$OUT_DIR/aux/com/all/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + fold.all("RESULT"=Bool
                       ,"FOLDFCT"=and
                       ,"NULLFCT"=true
                       ,"CVFCTVAR"
                       ,"ABORTVAL" = FALSE)
    Bool = + and + true
-----
[ -d $OUT_DIR/aux/com/basic ] || mkdir $OUT_DIR/aux/com/basic
cat >$OUT_DIR/aux/com/basic/adttype <<'-----'
AUXILIARY
-----
cat >$OUT_DIR/aux/com/basic/bbc1 <<'-----'
#include <stdlib/com/setup/ccod>
#define MERGE(SSS,TTT)SSS##TTT

_INCLUDE <aux/com/basic/bbpre>

int errors = 0;

void myerr( NR, SUB, FUNC, OPS )

  int NR;
  int SUB;
  char *FUNC;
  char *OPS;

{ fprintf(stderr,"\n"
                 "*** error in test case %4d subcase %4d\n",
                 NR,SUB);
  fprintf(stderr,"*** operation%s: %s\n",
                 (strchr(FUNC,',')!=NULL)?("s"):(" "), FUNC);
  if(*OPS)
  fprintf(stderr,"*** operand%s  : %s",
                 (strchr(OPS,',')!=NULL)?("s"):(" "), OPS);
  fprintf(stderr,"\n\n");
  errors = 1;
}

jmp_buf env;

static int vdmerrcode;

void vdmerr(x1) int x1;
{ if (x1 != VDM_ERR_NOTIMPL) { errors = 1;}
  vdmerrcode = x1;
  longjmp( env, -1 );
}

-----
cat >$OUT_DIR/aux/com/basic/bbc2 <<'-----'
main()

{ int i=1;

  fprintf(stderr,"<start test>\n");

  do
    if( setjmp(env) )
    { if (vdmerrcode != VDM_ERR_NOTIMPL)
         { fprintf(stderr,"\n*** error in executing operation in test case %d\n\n", i); }
    }
    else
    { fprintf(stderr,"<test case> %4d ",i);fflush(stderr);
      switch(i)
      {
@!
      }
      fprintf(stderr,"<finished>\n");fflush(stderr);
    }
  while( i++ < (1@N@ - 10000));
  fprintf(stderr,"<end test>\n");
  errors && fprintf(stderr,"<errors detected>\n");
  exit(errors);
}

-----
cat >$OUT_DIR/aux/com/basic/bbdef <<'-----'
#ifndef REPEAT
#define OP
#define CL
#else
#define OP @(
#define CL @)
#endif
#ifndef NO
#define NO
#endif
#ifndef ARG
#define ARG @X@
#endif
#ifndef TEXT
#ifndef ARG2
#define TEXT ARG
#else
#define TEXT ARG,ARG2
#endif
#endif
#ifndef ARG2
#define ARG2 ARG
#endif
#ifndef NEG
#define NEG !
#endif
#define mkSTR(x) #x
-----
cat >$OUT_DIR/aux/com/basic/bbdel.inc <<'-----'
#define MAX_ARRAY 1000
#define STR(s) #s

#ifdef ELEMENTS
#define TYPE Elem
#define DELFUNC MERGE(del,_elem)
#define E_ (*(MERGE(Elem,_save)()))=
#define EE MERGE(Elem,_delete)();
#else
#define TYPE Domain
#define DELFUNC MERGE(del,_domain)
#define D_ (*(MERGE(Domain,_save)()))=
#define DD MERGE(Domain,_delete)();
#endif

static TYPE MERGE(TYPE,_array)[MAX_ARRAY];
static unsigned int MERGE(TYPE,_index) = 0;


static void MERGE(TYPE,_delete)()
{
 while( MERGE(TYPE,_index) > 0 )
   { --MERGE(TYPE,_index); DELFUNC(MERGE(TYPE,_array)[MERGE(TYPE,_index)]); }
}

static TYPE *MERGE(TYPE,_save)()
{
 if( MERGE(TYPE,_index) >= MAX_ARRAY )
   {
    fprintf( stderr, "\t%s-array-overflow!\n", STR(TYPE) );
    MERGE(TYPE,_delete)();
    vdmerr(1);             /* => longjmp nach main + Meldung! */
   }

 return &(MERGE(TYPE,_array)[ MERGE(TYPE,_index)++ ]);
}

#undef MAX_ARRAY
#undef STR
#undef TYPE
#undef DELFUNC
#undef ELEMENTS
-----
cat >$OUT_DIR/aux/com/basic/bbdeld <<'-----'
#undef ELEMENTS
#include <aux/com/basic/bbdel.inc>
-----
cat >$OUT_DIR/aux/com/basic/bbdele <<'-----'
#define ELEMENTS
#include <aux/com/basic/bbdel.inc>
-----
cat >$OUT_DIR/aux/com/basic/bbid1 <<'-----'
   void p_@N@()
   { fprintf(stderr,"\nVDM Test Case Library    Version %s  Last modified %s\n","92/05/04","2.8");
     fprintf(stderr,
             "test of elementary ADT : " #ADT1  "\n"
             "implementation         : " #IMPL1 "\n\n");
     fprintf(stderr,"<start>\n\n");
   }
-----
cat >$OUT_DIR/aux/com/basic/bbid2 <<'-----'
   void p_@N@()
   { fprintf(stderr,"\nVDM Test Case Generator 1.9 92/03/23\n");
     fprintf(stderr,
            "test of ADT    : " #ADT1  "\n"
            "implementation : " #IMPL1 "\n"
            "with sub-ADT   : " #ADT2  "\n"
            "implementation : " #IMPL2 "\n\n");
   }

-----
cat >$OUT_DIR/aux/com/basic/bbmake <<'-----'
# ---------------------------------------------------
#          makefile for VDM Class Library
#              Test Case Generator
# ---------------------------------------------------

VDMGEN= VDMGEN
VDM   = VDM
VCMD  = -KR

# ANSIC C compiler
ACC   = gcc

DB    =
VOPT  =
VOPT1 =
COPT  =
SHELL = /bin/sh

CCC   = $(CC) $(COPT)
VV    = $(VDM) $(VCMD) $(DB) $(VOPT) $(VOPT1)
VDG   = $(VDMGEN) $(VCMD) -v $(DB) $(VOPT) $(VOPT1) -CC "$(CCC)"

#- default target: prepare simple (K&R-C) test

BB         : BB.o BB_adt.o \
           ; $(CCC) -o BB BB.o BB_adt.o

BB.o       : BB_adt.h BB.c \
           ; $(CCC) -c BB.c

BB_adt.o   : BB_adt.h BB_adt.c \
           ; $(CCC) -c BB_adt.c

BB_adt.h BB_adt.c : BB_adt.vdm \
           ; $(VV) BB_adt.vdm

#- targets for using VDMGEN command

BB_lib.a   : 
	     $(VDG) -o BB_lib BB_adt.vdm
	     cp BB_lib.h BB_adt.h

BBl	   : BB_lib.a BB.o
	     $(CCC) -o BBl BB.o BB_lib.a 

#- Cleanup -----------------------------------------

CLEAN : ; rm -rf tmp[0-3] BB_lib* BBl BB.o BB_adt.[och] BB_adt.opt BB_adt.enr BB_adt.hpp

#- Test Program generation -------------------------

KR    : 
	@echo "----- K&R test generation"
	$(MAKE) VCMD=-KR DB=$(DB) VOPT="$(VOPT)" VOPT1="$(VOPT1)" VDM="$(VDM)" BB
ANSI  : 
	@echo "----- ANSI test generation"
	$(MAKE) VCMD=-C  DB=$(DB) VOPT="$(VOPT)" VOPT1="$(VOPT1)" CC=$(ACC) COPT='-O' VDM="$(VDM)" BB
SAVE  : 
	@echo "----- SAVE test generation"
	$(MAKE) VCMD=-C  DB=$(DB) VOPT="-SSAVE $(VOPT)" VOPT1="$(VOPT1)" CC=$(ACC) COPT='-O' VDM="$(VDM)" BB
MCR   : 
	@echo "----- MACRO test generation"
	$(MAKE) VCMD=-C  DB=$(DB) VOPT="-SMACROS $(VOPT)" VOPT1="$(VOPT1)" CC=$(ACC) COPT='-O' VDM="$(VDM)" BB
VDMG  : 
	@echo "----- Using 'VDMGEN' command"
	$(MAKE) VCMD=-C  DB=$(DB) VDMGEN="$(VDMGEN)" VOPT="$(VOPT)" VOPT1="$(VOPT1)" CC=$(ACC) COPT='-O' VDM="$(VDM)" BBl

#- Test execution ----------------------------------

RUNKR	  : KR ; time BB; $(MAKE) CLEAN
RUNANSI	  : ANSI ; time BB; $(MAKE) CLEAN
RUNSAVE	  : SAVE ; time BB; $(MAKE) CLEAN
GENSAVE	  : SAVE ; $(MAKE) CLEAN
RUNMCR	  : MCR ; time BB; $(MAKE) CLEAN
RUNVDMG	  : VDMG ; time BBl; $(MAKE) CLEAN

RUNALL	  : RUNANSI RUNKR RUNSAVE RUNMCR # RUNVDMG
	    @echo "=== test passed"

#- special target for those where 'SAVE' cannot be run
RUNALL1	  : RUNANSI RUNKR GENSAVE RUNMCR # RUNVDMG
	    @echo "=== test passed"

-----
cat >$OUT_DIR/aux/com/basic/bbpre <<'-----'
#include <stdlib/com/setup/bb>

_INCLUDE <stdio.h>
_INCLUDE <setjmp.h>
_INCLUDE <string.h>
_INCLUDE "BB_adt.h"

-----
cat >$OUT_DIR/aux/com/basic/bbundef <<'-----'
#undef OP
#undef CL
#undef REPEAT
#undef ARG
#undef ARG2
#undef NO
#undef TEXT
#undef NEG
#undef mkSTR
-----
cat >$OUT_DIR/aux/com/basic/gimp <<'-----'
  IDF_(DOMAIN) IMP_SEP
-----
[ -d $OUT_DIR/aux/com/binary ] || mkdir $OUT_DIR/aux/com/binary
cat >$OUT_DIR/aux/com/binary/ccod <<'-----'
#include <aux/com/binary/defp>

#define _NAME(xx) MERGE(MERGE(MERGE(MERGE(_,xx),_),FCTNAME),_DOMAIN)
#define r1 _NAME(rr1)
#define f1 _NAME(rf1)


#ifndef ELEM2
#define xxpars ELEM1 x2
#define yypars _EP(y1,ELEM1)
#define yy y1
#define yyp _FP(y1,ELEM1)
#else
#define xxpars ELEM1 x2, ELEM2 x3
#define yypars _EP(y1,ELEM1) _EP(y2,ELEM2)
#define yy y1,y2
#define yyp _FP(y1,ELEM1), _FP(y2,ELEM2)
#endif

_IFNDEF FOLDFCT##_FOLDEXT
  extern RESULT_ FOLDFCT##_FOLDEXT P_OP RESULT_ x1, xxpars P_CL;
_ENDIF

  static RESULT_ r1;
  static void f1(yyp) yypars {r1 = FOLDFCT##_FOLDEXT(r1,yy);}
  
  RESULT_ FCTNAME##_DOMAIN _FPH2(RESULT_,DOMAIN)
   {RESULT_ lr1 = r1;
    r1 = x1;
    forall##_DOMAIN(x2,f1);
#if DELETE
    del1##_DOMAIN(x2);
#endif
    {RESULT_ lr2 = r1; r1 = lr1; return lr2;}
   }

#undef r1
#undef f1
#undef _NAME

#undef xxpars
#undef yypars
#undef yy
#undef yyp
#undef RESULT_
#undef FOLDEXT
#undef _FOLDEXT
-----
cat >$OUT_DIR/aux/com/binary/defp <<'-----'
#ifndef FOLDFCT
  DOMAIN: the implementation parameter FOLDFCT must be specified
#endif

#ifdef RESULT
#define RESULT_ RESULT
#else
#define RESULT_ DOMAIN
#endif

#ifndef FOLDEXT
#define FOLDEXT DOMAIN
#define _FOLDEXT _DOMAIN
#endif
-----
cat >$OUT_DIR/aux/com/binary/docu <<'-----'
  The functional binary is implemented with the help of the forall routine

  parameters :
   'RESULT' : Optional Parameter, default value is DOMAIN. This will 
	      give the binary extensions as shown in the examples. For
	      generating conversion functions it will be necessary
	      to have RESULT <> DOMAIN. Then a function of the type

		   RESULT DOMAIN  -->  RESULT 

              will be generated using an appropriate FOLDFCT.

   'FOLFFCT': The name of a binary function with 1. parameter of type RESULT
              an 2. parameter of type ELEM1
#ifdef map 
              the 3. parameter is of type ELEM2
#endif
   'DELETE' : if set, a call of del1  for the 2. argument 
              (the object, over that the loop is performed)
              is inserted at the end of the
              body of the generated binary Operation

   'FOLDEXT': Optional Parameter, default value is DOMAIN. It changes
	      the naming convention of the Fold function which normally
	      is extended by DOMAIN.
              
	      So 
		   binary.foo(FOLDFCT="foo1")
              
	      will require a function foo1##_DOMAIN while defineng

		   binary.foo(FOLDFCT="foo1",FOLDEXT="foo2")

	      will expect a function 'foo1_foo2' as foldfct.	  

 'NOFOLDENR': By default, the fold operation (supplied by 'FOLDFCT')
	      will be assumed to be part of the 'FOLDEXT' domain and
	      the statement 'FOLDEXT = + FOLDFCT' will be executed
	      to generate this operation automaticcally. If 'FOLDFCT'
	      is a self written operation, set the parameter 'NOFOLDENR'
	      to suppress this enrichment operation.


   examples :
#ifdef tupl
   1. conc

   DOMAIN = ..... + binary.conc(FOLDFCT="appr")
#endif
#ifdef bag
   1. union

   DOMAIN = ..... + binary.union(FOLDFCT="union1")
#endif
#ifdef set
   1. union

   DOMAIN = ..... + binary.union(FOLDFCT="union1")
#endif
#ifdef map
   1. ovwrt

   DOMAIN = ..... + binary.ovwrt(FOLDFCT="ovwrt1")
#endif

#undef tupl
#undef set
#undef bag
#undef map
-----
cat >$OUT_DIR/aux/com/binary/vdm <<'-----'
#include <aux/com/binary/defp>

DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall 
#if DELETE
   DOMAIN   = + del1
#endif
#ifndef NOFOLDENR
   FOLDEXT  = + FOLDFCT
#endif
#undef RESULT_
#undef FOLDEXT
#undef _FOLDEXT
-----
[ -d $OUT_DIR/aux/com/constructor ] || mkdir $OUT_DIR/aux/com/constructor
cat >$OUT_DIR/aux/com/constructor/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + MERGE(constructor.,CONSTRNAME)(
	ADTNAME
#ifdef ELEM1
        ,"COMP_ELEM1"=MKSTRING(ELEM1)
#endif
#ifdef ELEM2
        ,"COMP_ELEM2"=MKSTRING(ELEM2)
#endif
#ifdef ELEM3
        ,"COMP_ELEM3"=MKSTRING(ELEM3)
#endif
	)

#undef CONSTRNAME
#undef ADTNAME
-----
[ -d $OUT_DIR/aux/com/copy ] || mkdir $OUT_DIR/aux/com/copy
cat >$OUT_DIR/aux/com/copy/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   {
OP   if(! is_eq##_domain##NO( D_ copy##_domain##NO(D_ ARG), D_ ARG ) )
       myerr(@n@,"copy()",mkSTR(TEXT));
CL DD 
   }

#include <aux/com/basic/bbundef>
-----
[ -d $OUT_DIR/aux/com/copy1 ] || mkdir $OUT_DIR/aux/com/copy1
cat >$OUT_DIR/aux/com/copy1/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   {
OP   if(! is_eq##_domain##NO( D_ copy1##_domain##NO(ARG), D_ ARG ) )
       myerr(@n@,"copy1()",mkSTR(TEXT));
CL DD 
   }

#include <aux/com/basic/bbundef>
-----
[ -d $OUT_DIR/aux/com/cvfromtup1 ] || mkdir $OUT_DIR/aux/com/cvfromtup1
cat >$OUT_DIR/aux/com/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

#ifndef MK_EMPTY
#define MK_EMPTY(x1) MERGE(mk_empty,_DOMAIN)()
#endif

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { Nat0 lx1 = cvfromtup1_nat0(x1);
    DOMAIN lx2;

    lx2 = MK_EMPTY(lx1);
    for (; lx1 >= 1; lx1--)
#ifdef ELEM2
	{ /* ADDELEM may be macro, evaluating arguments more than once */
	  ELEM1 lx3; ELEM2 lx4;
	  lx3 =  cvfromtup1##_ELEM1(x1);
	  lx4 =  cvfromtup1##_ELEM2(x1);
          lx2 = __ADDELEM##_DOMAIN(lx2,lx3,lx4);
	}
#else
	{ /* ADDELEM may be macro, evaluating arguments more than once */
#ifdef ISCHAR
          /* optimization for character tuples: read characters directly */
	  lx2 = __ADDELEM##_DOMAIN(lx2,hd##_TUPLDOMAIN(*x1));
	  *x1  = tld##_TUPLDOMAIN(*x1);
#else
	  ELEM1 lx3;
	  lx3 =  cvfromtup1##_ELEM1(x1);
	  lx2 = __ADDELEM##_DOMAIN(lx2,lx3);
#endif
	}
#endif
    return lx2;
  }

#include <aux/com/cvtotupl/undefp>
#undef __ADDELEM
#undef MK_EMPTY
-----
cat >$OUT_DIR/aux/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/aux/com/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>
#ifndef MK_EMPTY
#define MK_EMPTY mk_empty
#else
#undef MK_EMPTY
#define MK_EMPTY mkn_empty
#endif

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Nat0		= + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
  DOMAIN	= + __ADDELEM + MK_EMPTY
#ifdef ISCHAR
  TUPLDOMAIN	= + hd + tld
#else
  ELEM1		= + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#ifdef ELEM2
  ELEM2		= + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#endif
#endif

#include <aux/com/cvtotupl/undefp>
#undef MK_EMPTY
#undef __ADDELEM
#undef __NOELEMS
-----
[ -d $OUT_DIR/aux/com/cvlines ] || mkdir $OUT_DIR/aux/com/cvlines
cat >$OUT_DIR/aux/com/cvlines/ccod <<'-----'

  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   {
#ifdef SUPRESS
      if (supress_cvlines_vdmlib)
	 { return mk1_cvtext_vdmlib(mkc_str(MKSTRING(< DOMAIN > ))); }
#endif
    { Nat0 lx1   = curr_linelen_vdmlib;
      char *lx2  = start_structure_vdmlib;
      char *lx3  = end_structure_vdmlib;
      Cvtext_vdmlib lx4;
      Nat0 lx5;

      start_structure_vdmlib = START_STR;
      end_structure_vdmlib = END_STR;
      lx5 = (Nat0)strlen(start_structure_vdmlib);
      adj_linelen_vdmlib(lx5);

      if (IS_EMPTY(x1))
         lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
                                            , mkc_str(end_structure_vdmlib)));
      else 
         lx4 = close_struct_vdmlib( cvlines1##_DOMAIN(x1)
                                  , mkc_str(end_structure_vdmlib)
                                  , lx5
                                  );

      curr_linelen_vdmlib = lx1;
      start_structure_vdmlib = lx2;
      end_structure_vdmlib = lx3;
      return lx4;
    }
   }
-----
cat >$OUT_DIR/aux/com/cvlines/docu <<'-----'
   General implementation of cvlines. Parameters:

     SUPRESS: Optional. If defined, the output of this value will
	      be supressed depending of the setting of the variable
	      'supress_cvlines_vdmlib'. The string "< DOMAIN >" is
	      generated instead. This can be used to implement some
	      'zooming' through complicated structure where sometimes
	      only the top level structure is of interest.
-----
[ -d $OUT_DIR/aux/com/cvstr ] || mkdir $OUT_DIR/aux/com/cvstr
cat >$OUT_DIR/aux/com/cvstr/defp <<'-----'
#ifdef AUTOMEMRESULT

#define FCTN cvrep_str
#define MKC mkc_rep_str
#define RST Rep_str

#define RESULT Str
#define _RESULT _str
#define FCTNAME cvstr
#define REPFCTNAME FCTN

#else

#define FCTN cvstr
#define MKC mkc_str
#define RST Str

#endif
-----
cat >$OUT_DIR/aux/com/cvstr/undef <<'-----'
#ifdef AUTOMEMRESULT
#include <aux/automem/autoresult/ccod>
#endif

#undef FCTN
#undef MKC
#undef RST
-----
[ -d $OUT_DIR/aux/com/cvtotup1 ] || mkdir $OUT_DIR/aux/com/cvtotup1
cat >$OUT_DIR/aux/com/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
  { return cvtotupelems##_DOMAIN(cvtotup1_nat0(x1,__NOELEMS##_DOMAIN(x2)),x2); }

#include <aux/com/cvtotupl/undefp>
#undef __ADDELEM
#undef __NOELEMS
-----
cat >$OUT_DIR/aux/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/aux/com/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Nat0		= + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
  DOMAIN	= + __NOELEMS
		  + binary.cvtotupelems("RESULT"=TUPLDOMAIN
#ifdef ELEM2
				       , "NOFOLDENR"
				       , "FOLDFCT"=cvtotuppair
				       , "FOLDEXT"=DOMAIN
#else
#ifdef ISCHAR
		! optimization for char tuples: append chars directly !
				       , "FOLDFCT"=appr
				       , "FOLDEXT"=TUPLDOMAIN
#else
				       , "FOLDFCT"=cvtotup1
				       , "FOLDEXT"=ELEM1
#endif
#endif
				       )
#ifndef ISCHAR
  ELEM1		= + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
#ifdef ELEM2
  ELEM2		= + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
#endif
#else
  TUPLDOMAIN    = + appr
#endif

#include <aux/com/cvtotupl/undefp>
#undef __ADDELEM
#undef __NOELEMS
-----
[ -d $OUT_DIR/aux/com/cvtotupl ] || mkdir $OUT_DIR/aux/com/cvtotupl
cat >$OUT_DIR/aux/com/cvtotupl/bbc2 <<'-----'
#include <aux/com/basic/bbdef>
#ifndef DOMAIN_
#define DOMAIN_ Domain
#endif

   void p_@N@()
   { Str tmp1;
     DOMAIN_ tmp2;
OP
     tmp2 = ARG;
     tmp1 = cvtotupl##_domain##NO(tmp2);
     tmp2 = D_ cvfromtupl##_domain##NO(tmp1);
     if(! is_eq##_domain##NO( tmp2, D_ ARG ) )
       myerr(@n@,"cvfromtupl(),cvtotupl()",mkSTR(TEXT));
CL DD
   }

#undef DOMAIN_
#include <aux/com/basic/bbundef>
-----
cat >$OUT_DIR/aux/com/cvtotupl/defp <<'-----'
#ifndef TUPLDOMAIN
#define TUPLDOMAIN Str
#define _TUPLDOMAIN _str
#define Cpp_TUPLDOMAIN Cpp_STR
#endif
-----
cat >$OUT_DIR/aux/com/cvtotupl/undefp <<'-----'
#undef TUPLDOMAIN
#undef _TUPLDOMAIN
#undef Cpp_TUPLDOMAIN

-----
[ -d $OUT_DIR/aux/com/default ] || mkdir $OUT_DIR/aux/com/default
cat >$OUT_DIR/aux/com/default/docu <<'-----'
  'default' is not an operation, but defines a set of operations
  which will be included, if the 'default operation' is selected.

  This will shorten the implementation part of the .vdm file

-----
cat >$OUT_DIR/aux/com/default/docunoop <<'-----'
#include <aux/com/default/docu>

  For this special purpose implementation
  no operations are added by default
-----
[ -d $OUT_DIR/aux/com/del ] || mkdir $OUT_DIR/aux/com/del
cat >$OUT_DIR/aux/com/del/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   {
OP   del##_domain##NO( ARG );
CL 
   }

#include <aux/com/basic/bbundef>
-----
cat >$OUT_DIR/aux/com/del/ccod <<'-----'
#if SIMPLEELEMS
  void del##_DOMAIN _FPH1(DOMAIN) {del1##_DOMAIN(x1);}
#else
#define fct del

#ifdef ELEM2
#define ty2 ELEM2
#define incr MERGE(del,_ELEM1)(y1);MERGE(del,_ELEM2)(y2);
#else
#define incr MERGE(del,_ELEM1)(y1);
#endif

#define resfin MERGE(del1,_DOMAIN)(x1);
#include <aux/com/for/ccod>
#endif
-----
cat >$OUT_DIR/aux/com/del/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if SIMPLEELEMS
   DOMAIN   =  + del1
#else
   DOMAIN   =  + del1 + forall
   ELEM1    =  + del
#ifdef ELEM2
   ELEM2    =  + del
#endif
#endif
-----
[ -d $OUT_DIR/aux/com/del1 ] || mkdir $OUT_DIR/aux/com/del1
cat >$OUT_DIR/aux/com/del1/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   {
OP   del1##_domain##NO( ARG );
CL  
   }

#include <aux/com/basic/bbundef>
-----
[ -d $OUT_DIR/aux/com/dheap ] || mkdir $OUT_DIR/aux/com/dheap
cat >$OUT_DIR/aux/com/dheap/ccod <<'-----'

  DOMAIN alloc##_DOMAIN _FPH1(Nat0)
   {
    Nat0 len = sizeof(Struct##_DOMAIN) + x1 * sizeof(ELEM1);
    Nat0 len2 = 4;
    DOMAIN lx1;
    while (len2 < len) len2 += len2;
    lx1 = (DOMAIN) malloc(len2);
    if (! lx1) heap_oflw_vdmlib(MKSTRING(DOMAIN));
    lx1->f_max = (len2 - sizeof(Struct##_DOMAIN))/sizeof(ELEM1);
    lx1->f_len = x1;
    return lx1;
   } 

  void free##_DOMAIN _FPH1(DOMAIN)
   {
    extern void free P_OP char * x1 P_CL;
    free((char *)(x1));
   }

-----
cat >$OUT_DIR/aux/com/dheap/docu <<'-----'
  common routines for heap storage management for variable length items
  space is allocated in units of powers of 2. So the number of required
  element units is rounded up. In field f_max the maximum number of elements
  is stored; in f_len the actually required number is stored

    alloc##_DOMAIN allocates space for one element of type DOMAIN
    free##_DOMAIN gives the space back to the heap store
    
-----
cat >$OUT_DIR/aux/com/dheap/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + heap_oflw
-----
[ -d $OUT_DIR/aux/com/elemfromtup1 ] || mkdir $OUT_DIR/aux/com/elemfromtup1
cat >$OUT_DIR/aux/com/elemfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { register int lx1;
    register unsigned int lx2 = 0;
      
    for (lx1 = 1; lx1 <= sizeof(DOMAIN); lx1++)
      { lx2 = lx2 | (hd##_TUPLDOMAIN(*x1) << ((lx1 - 1)*8));
	*x1 = tld##_TUPLDOMAIN(*x1);
      }
    return (DOMAIN)lx2;
  }
#undef TUPLDOMAIN
#undef _TUPLDOMAIN
-----
cat >$OUT_DIR/aux/com/elemfromtup1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  TUPLDOMAIN	= + hd + tld
-----
[ -d $OUT_DIR/aux/com/elemtotup1 ] || mkdir $OUT_DIR/aux/com/elemtotup1
cat >$OUT_DIR/aux/com/elemtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
  { register int i;
      
    for (i = 1; i <= sizeof(DOMAIN); i++)
      { x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2) & 255));
        x2 = (DOMAIN)(((unsigned int) x2) >> 8);
      }
    return x1;
  }
#undef TUPLDOMAIN
#undef _TUPLDOMAIN
-----
cat >$OUT_DIR/aux/com/elemtotup1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  TUPLDOMAIN	= + appr
-----
[ -d $OUT_DIR/aux/com/exist ] || mkdir $OUT_DIR/aux/com/exist
cat >$OUT_DIR/aux/com/exist/docu <<'-----'
  General implementation based on 'fold'. Note that performance
  may change heavily depending if the implementaion of DOMAIN
  supports the 'ABORTVAL' parameter or not.
  See __SA(fold) for details.
-----
cat >$OUT_DIR/aux/com/exist/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + fold.exist(RESULT=Bool, FOLDFCT=or, NULLFCT=false, CVFCTVAR, ABORTVAL = TRUE)
    Bool = + or + false
-----
[ -d $OUT_DIR/aux/com/exist1 ] || mkdir $OUT_DIR/aux/com/exist1
cat >$OUT_DIR/aux/com/exist1/ctyp <<'-----'
#ifdef GEN_C
  /* works for C only */
#ifdef ELEM2
  typedef Bool (*T2_ex1##_DOMAIN)(ELEM1,ELEM2);
  #define cvex1##_DOMAIN(x1,x2,x3) ( ((*x3)(x1,x2)) ? 1 : 0 )
#else
  typedef Bool (*T2_ex1##_DOMAIN)(ELEM1);
  #define cvex1##_DOMAIN(x1,x2) ( ((*x2)(x1)) ? 1 : 0 )
#endif
#endif
-----
cat >$OUT_DIR/aux/com/exist1/docu <<'-----'
  General implementation based on 'fold'. Note that performance
  may change heavily depending if the implementaion of DOMAIN
  supports the 'ABORTVAL' parameter or not.
  See __SA(fold) for details.
-----
cat >$OUT_DIR/aux/com/exist1/gcod <<'-----'
  _FDEC2(exist1,Bool,DOMAIN,T2_ex1##_DOMAIN,_RET(is_eq_nat0(exist1_help##_DOMAIN(x1,x2),1)))
-----
cat >$OUT_DIR/aux/com/exist1/gtyp <<'-----'
#ifdef GEN_C
  /* works for C only */
#ifdef ELEM2
  typedef Bool (*T2_ex1##_DOMAIN)P_OP ELEM1,ELEM2 P_CL;
_DEFINE cvex1##_ELEM1##_ELEM2(x1,x2,x3) ( ((*x3)(x1,x2)) ? 1 : 0 )
#else
  typedef Bool (*T2_ex1##_DOMAIN) P_OP ELEM1 P_CL;
_DEFINE cvex1##_ELEM1(x1,x2) ( ((*x2)(x1)) ? 1 : 0 )
#endif
#endif
-----
cat >$OUT_DIR/aux/com/exist1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + fold.exist1_help("RESULT"=Nat0
			       ,"FOLDFCT"=plus
			       ,"NULLFCT"=null
			       ,"CVFCT"=cvex1
			       ,"ABORTVAL"= 2
			       ,"X"= T2_ex1##_DOMAIN
			       )
    Nat0 = + plus + null + is_eq
-----
[ -d $OUT_DIR/aux/com/fold ] || mkdir $OUT_DIR/aux/com/fold
cat >$OUT_DIR/aux/com/fold/ccod <<'-----'
#define CV vcv
#include <aux/com/folda/ccod>
#include <aux/com/folda/gtyp>
#define MACRO1(T,N)    static T _NAME(N);
#include <aux/com/folda/mcrxyz>

  static RESULT r1;
  static void f1(fyy)
      tyy
   {r1 = FOLDFCT##_RESULT(r1,cvfct__(yy gPX gPY) gPY gPZ);}
  
  RESULT FCTNAME##_DOMAIN(_FP(x1,DOMAIN) Pnull Pcvfct PX PY PZ)
      _EP(x1,DOMAIN) tPnull tPcvfct tPX tPY tPZ
   {RESULT lr1;
#define MACRO1(T,N)    T MERGE(l_,N);
#include <aux/com/folda/mcrxyz>
    lr1 = r1;
#define MACRO1(T,N)    MERGE(l_,N) = _NAME(N); _NAME(N) = N;
#include <aux/com/folda/mcrxyz>
    r1 = _NULL;
    _FORALL##_DOMAIN(x1,f1);
#define MACRO1(T,N)    _NAME(N) = MERGE(l_,N);
#include <aux/com/folda/mcrxyz>
    {RESULT lr2 = r1; r1 = lr1; return lr2;}
   }
#include <aux/com/folde/ccod>
-----
cat >$OUT_DIR/aux/com/fold/docu <<'-----'
#ifdef Bag
#undef bag
#define Set bag
#endif
  Parameters :
   "RESULT"   : Domain name of the result type (optional). Default value
                is ELEM1
   "NULLFCT"  : Name of a constant function which determines the value of
                an empty structure.
                The name of the function must be given without suffix. It
                will be extended by the name of the result domain.
                See description of "NULLPARAM" how to initialize with
                a nonconstant value.
   "FOLDFCT"  : Name of a binary function defined on the domain "RESULT"
                The function name will be extended with the name of the
                result domain
#ifdef Map
   "CVFCT"    : Name of a conversion function from ELEM1 and ELEM2 to
                "RESULT". This name will be suffixed with the names of
                of the domain- and the range domain of the map.
#else
#ifdef Rel
   "CVFCT"    : Name of a conversion function from ELEM1, ELEM2,... to
                "RESULT". This name will be suffixed with the names of
                of the domains ELEM1 and ELEM2. This convention is not
                extended if the relation consists of more than two
                components.
#else
   "CVFCT"    : Name of a conversion function from ELEM1 to "RESULT"
                (optional). Default is the identity function (In this
                case, the parameter "CVFCTRES" must be used if
                "RESULT" <> "ELEM1"). The name given here will be
                extended with ELEM1.
#endif
#endif
                See description of "CVFCTVAR" parameter about how
                to supply this function as a parameter.

  These were the most important parameters needed to generate
  fold functions. Further parameters are described at the end after
  some examples for standard use of fold functions.

  The following examples will illustrate the naming conventions.

   Examples :
#ifdef Map
   1. construction of the inverse map (only defined for bijective maps)

   DOMAINS
   Map    =  Elem1 -m-> Elem2
   Imap   =  Elem2 -m-> Elem1

   IMPLEMENTATIONS
   Map    = ..... + fold.inverse(RESULT="Imap",
                                 NULLFCT="mk_empty",
                                 FOLDFCT="union",
                                 CVFCT="swap")

   Here it is assumed that the following functions are declared as
     Map1 mk_empty_imap()
     Map1 union_imap(Imap x1, Imap x2)
     Map1 swap_Elem1_Elem2(Elem1 x1, Elem2 x2) {return mk_one_imap(x2,x1);}
   or are available as macros with the same semantics. 

   The function inverse is then generated as

     Map1 inverse_Map(Map x1)

#else
#ifdef Tupl
   1. len

   DOMAIN = ..... + fold.len(RESULT="Nat0",
                             NULLFCT="zero",
                             FOLDFCT="plus",
                             CVFCT="one")
#endif
#ifdef Set
   1. card

   DOMAIN = ..... + fold.card(RESULT="Nat0",
                              NULLFCT="zero",
                              FOLDFCT="plus",
                              CVFCT="one")
#endif

   here it is assumed that the following functions are declared as
     Nat0 zero_nat0() {return 0;}
     Nat0 plus_nat0(x1,x2);Nat0 x1,x2;{return x1 + x2;}
     Nat0 one##_ELEM1(ELEM1 x1);{return 1;}
   or are available as macros with the same semantics
#endif     

#ifdef Tupl
   2. distributed concatenation
    
   DOMAIN   = .... + fold.concatenate(NULLFCT="mk_empty",
                                      FOLDFCT="conc")
                                      
   here it is assumed that DOMAIN is defined as a tuple of ELEM1
   and ELEM1 is again a tuple, RESULT == ELEM1 and mk_empty and conc
   are the typle functions for ELEM1. The conversion function from ELEM1
   to RESULT is the identity. The resulting function is
   
   concatenate(x1) = if x1 = <> 
                     then <>
                     else hd x1 & concatenate(tl x1)
   TYPE :  DOMAIN  -->  ELEM1                  
   
   in C syntax
   ELEM1 concatenate##_DOMAIN(DOMAIN x1)
#endif

#ifdef Set
   2. distributed union
    
   DOMAIN   = .... + fold.distr_union(NULLFCT="mk_empty",
                                      FOLDFCT="conc")
                                      
   here it is assumed that DOMAIN is defined as a set of ELEM1
   and ELEM1 is again a set, RESULT == ELEM1 and mk_empty and union
   are the set functions for ELEM1. The conversion function from ELEM1
   to RESULT is the identity. The resulting function is
   
   distr_union(x1) = {z1 | y1 e x1 & z1 e y1}
   TYPE :  DOMAIN  -->  ELEM1                  
   
   in C syntax
   ELEM1 distr_union##_DOMAIN(DOMAIN x1)
#endif

 Additional Parameter Types:

   The additional parameters for the FOLDFCT and the CVFCT are generated
   due to the following conventions: Their types are given by the parameters
   X,XX,XXX,XXXX,XXXXX,Y,YY,YYY,Z,ZZ,ZZZ. The parameters described
   by X,XX,... and Y,YY,YYY are passed to the conversion function
   (CVFCT) and the parameters Y,YY,YYY and Z,ZZ,ZZZ will be passed 
   to the FOLDFCT.
   
   So for example writing (for a tupl domain)
   
         DOMAIN =  ... + fold.f1( RESULT  = "Nat0"
                                , NULLFCT = "zero"
                                , FOLDFCT = "ff1"
                                , CVFCT   = "cvv"
                                , X       = "Str"
                                , XX      = "Nat0"
                                , Y       = "Intg"
                                )
   
   will generate a function
   
       Nat0 f1(DOMAIN x1, Str x2, Nat0 x3, Intg x4)
   
   assuming the existence of the functions
   
       Nat0  zero_nat0()
       Nat0  ff1_nat0(Nat0 x1, Nat0 x2, Intg x3)
       Nat0  cvv##_ELEM1(ELEM1 x1, Str x2, Nat0 x3, Intg x4)

Further Parameters supported:

   "NULLPARAM":	This parameter can be defined alternatively to
                "NULLFCT". In this case, the initial value is not
                determined through a function but must be supplied
                as parameter instead, which in this case will be the
                second parameter to the function generated, immediately
                after the DOMAIN parameter.

                Using this feature allows to accumulate results through
                successive calls of the same 'fold' function.
   "CVFCTVAR" :	This parameter can be set instead of "CVFCT". In this
                case, the fold function will be supplied as parameter
                instead of being hardcoded into the function generated.
                This is very useful if you will need many fold functions
                of the same type within your application, where using
                the "CVFCT" parameter, you would have to generate
                one fold function for each.

                Example: The general 'All' quantifyer would be generated
                         through:
		
                   fold.all(RESULT  = Bool
                           ,NULLFCT = true
                           ,FOLDFCT = and
                           ,CVFCTPAR
                           ,ABORTVAL = FALSE)
		   
                   leading to a function

                      all_Domain(DOMAIN x1, Bool (*f)(ELEM1));

   "CVFCTRES" : If this parameter is defined the CVFCT is expected
                to return "CVFCTRES" instead of "RESULT". Therefore,
                the "FOLDFCT" must have the type 

                  RESULT CVFCTRES  -->  RESULT
	
                instead of the default type
		  
                  RESULT RESULT  --> RESULT.

                This parameter allows 
                  - to avoid slide overhead if otherwise additional
                    conversion to the RESULT type would become necessary
                  - greater flexibility in functionality.

                See also the operation __SA(binary), especially if using
                the parameter 'NULLPARAM', if the desired functionality
                will be covered better by this.

#ifdef Abortval
   "ABORTVAL" : This parameter allows the generation of nonstrict
                'fold' functions. This is done by defining 'ABORTVAL'
                with some special value of type 'RESULT'. If the
                result becomes this value, iteration will be aborted
                for the rest of the map (set,tuple,bag).

                Example: 
                  Assume the following map domain:
		   
                    Amap = Str -m-> Nat0

                  Defining
		   
                    Amap = ... + fold.forall( RESULT = Bool
                                            , NULLFCT = true
                                            , FOLDFCT = and
                                            , CVFCT = check
                                            , ABORTVAL = FALSE)
		
                generates a function forall_amap testing, if
                the predicate 'check' is true for all elements of
                a map. As soon as 'check' returns 'FALSE', iteration
                is aborted and 'FALSE' will be returned.
#else
   "ABORTVAL" : This parameter is supplied for compatibility reasons
                to other implementations that supply the possibility
                of nonstrict functionals. See __SA(fold) operation
                for 'linklist'- or 'scanfile' implementation for
                further details.
#endif
#undef Rel
#undef Tupl
#undef Set
#undef Map
-----
cat >$OUT_DIR/aux/com/fold/vdm <<'-----'
#include <aux/com/folda/ccod>
DOMAINS
   DOMAIN   -> RESULT
   DOMAIN   -> CVFCTRES
IMPLEMENTATIONS
   DOMAIN   = + _FORALL

#ifdef _COMMENT
   RESULT   = + FOLDFCT + NULLFCT
#ifdef CVFCT
   ELEM1    = + CVFCT
#endif
#endif
#include <aux/com/folde/ccod>
-----
[ -d $OUT_DIR/aux/com/folda ] || mkdir $OUT_DIR/aux/com/folda
cat >$OUT_DIR/aux/com/folda/ccod <<'-----'

#ifndef X

#define PX 
#define pPX
#define tPX
#define ppPX
#define gppPX
#define gPX
#define lPX

#else
#ifndef XX

#define PX ,_FP(px1,X)
#define tPX _EP(px1,X)
#define pPX ,X px1
#define ppPX ;px1 : X
#define gppPX P_SEP PARAM(px1,X)
#define gPX ,_NAME(px1)
#define lPX ,px1

#else
#ifndef XXX

#define PX ,_FP(px1,X), _FP(px2,XX)
#define tPX _EP(px1,X) _EP(px2,XX)
#define pPX ,X px1, XX px2
#define ppPX ;px1 : X; px2 : XX
#define gppPX P_SEP PARAM(px1,X) P_SEP PARAM(px2,XX)
#define gPX ,_NAME(px1),_NAME(px2)
#define lPX ,px1,px2

#else
#ifndef XXXX

#define PX ,_FP(px1,X), _FP(px2,XX), _FP(px3,XXX)
#define tPX _EP(px1,X) _EP(px2,XX) _EP(px3,XXX)
#define pPX ,X px1, XX px2, XXX px3
#define ppPX ;px1 : X; px2 : XX; px3 : XXX
#define gppPX P_SEP PARAM(px1,X) P_SEP PARAM(px2,XX) P_SEP PARAM(px3,XXX)
#define gPX ,_NAME(px1),_NAME(px2),_NAME(px3)
#define lPX ,px1,px2,px3

#else
#ifndef XXXXX

#define PX ,_FP(px1,X), _FP(px2,XX), _FP(px3,XXX), _FP(px4,XXXX)
#define tPX _EP(px1,X) _EP(px2,XX) _EP(px3,XXX) _EP(px4,XXXX)
#define pPX ,X px1, XX px2, XXX px3, XXXX px4
#define ppPX ;px1 : X; px2 : XX; px3 : XXX; px4 : XXXX
#define gppPX P_SEP PARAM(px1,X) P_SEP PARAM(px2,XX) P_SEP PARAM(px3,XXX) P_SEP PARAM(px4,XXXX)
#define gPX ,_NAME(px1),_NAME(px2),_NAME(px3),_NAME(px4)
#define lPX ,px1,px2,px3,px4

#else

#define PX ,_FP(px1,X), _FP(px2,XX), _FP(px3,XXX), _FP(px4,XXXX), _FP(px5,XXXXX)
#define tPX _EP(px1,X) _EP(px2,XX) _EP(px3,XXX) _EP(px4,XXXX) _EP(px5,XXXXX)
#define pPX ,X px1, XX px2, XXX px3, XXX px4, XXXXX px5
#define ppPX ;px1 : X; px2 : XX; px3 : XXX; px4 : XXXX; px5 : XXXXX
#define gppPX P_SEP PARAM(px1,X) P_SEP PARAM(px2,XX) P_SEP PARAM(px3,XXX) P_SEP PARAM(px4,XXXX) P_SEP PARAM(px5,XXXXX)
#define gPX ,_NAME(px1),_NAME(px2),_NAME(px3),_NAME(px4),_NAME(px5)
#define lPX ,px1,px2,px3,px4,px5



#endif
#endif
#endif
#endif
#endif


#ifndef Y

#define PY 
#define pPY
#define tPY
#define ppPY
#define gppPY
#define gPY
#define lPY

#else
#ifndef YY

#define PY ,_FP(py1,Y)
#define tPY _EP(py1,Y)
#define pPY ,Y py1
#define ppPY ;py1 : Y
#define gppPY P_SEP PARAM(py1,Y)
#define gPY ,_NAME(py1)
#define lPY ,py1

#else
#ifndef YYY

#define PY ,_FP(py1,Y), _FP(py2,YY)
#define tPY _EP(py1,Y) _EP(py2,YY)
#define pPY ,Y py1, YY py2
#define ppPY ;py1 : Y; py2 : YY
#define gppPY P_SEP PARAM(py1,Y) P_SEP PARAM(py2,YY)
#define gPY ,_NAME(py1),_NAME(py2)
#define lPY ,py1,py2

#else

#define PY ,_FP(py1,Y), _FP(py2,YY), _FP(py3,YYY)
#define tPY _EP(py1,Y) _EP(py2,YY) _EP(py3,YYY)
#define pPY ,Y py1, YY py2, YYY py3
#define ppPY ;py1 : Y; py2 : YY; py3 : YYY
#define gppPY P_SEP PARAM(py1,Y) P_SEP PARAM(py2,YY) P_SEP PARAM(py3,YYY)
#define gPY ,_NAME(py1),_NAME(py2),_NAME(py3)
#define lPY ,py1,py2,py3

#endif
#endif
#endif


#ifndef Z

#define PZ 
#define pPZ
#define tPZ
#define ppPZ
#define gppPZ
#define gPZ
#define lPZ 

#else
#ifndef ZZ

#define PZ ,_FP(pz1,Z)
#define tPZ _EP(pz1,Z)
#define pPZ ,Z pz1
#define ppPZ ;pz1 : Z
#define gppPZ P_SEP PARAM(pz1,Z) 
#define gPZ ,_NAME(pz1)
#define lPZ ,pz1

#else
#ifndef ZZZ

#define PZ ,_FP(pz1,Z), _FP(pz2,ZZ)
#define tPZ _EP(pz1,Z) _EP(pz2,ZZ)
#define pPZ ,Z pz1, ZZ pz2
#define ppPZ ;pz1 : Z; pz2 : ZZ
#define gppPZ P_SEP PARAM(pz1,Z) P_SEP PARAM(pz2,ZZ)
#define gPZ ,_NAME(pz1),_NAME(pz2)
#define lPZ ,pz1,pz2

#else

#define PZ ,_FP(pz1,Z), _FP(pz2,ZZ), _FP(pz3,ZZZ)
#define tPZ _EP(pz1,Z) _EP(pz2,ZZ) _EP(pz3,ZZZ)
#define pPZ ,Z pz1, ZZ pz2, ZZZ pz3
#define ppPZ ;pz1 : Z; pz2 : ZZ; pz3 : ZZZ
#define gppPZ P_SEP PARAM(pz1,Z) P_SEP PARAM(pz2,ZZ) P_SEP PARAM(pz3,ZZZ)
#define gPZ ,_NAME(pz1),_NAME(pz2),_NAME(pz3)
#define lPZ ,pz1,pz2,pz3

#endif
#endif
#endif


#ifndef _FORALL
#define _FORALL forall
#define ii
#define tii
#define pii
#define iipp
#define iinp
#define vii
#endif

#ifndef RESULT
#define RESULT ELEM1
#define _RESULT _ELEM1
#endif

#ifndef CVFCTRES
#define CVFCTRES RESULT
#define _CVFCTRES _RESULT
#endif


#define _NAME(xx) MERGE(MERGE(MERGE(MERGE(_,xx),_),FCTNAME),_DOMAIN)
#define r1 _NAME(rr1)
#define f1 _NAME(rf1)
#define tcv _NAME(T2cv)
#define vcv _NAME(Pvcvfct)

/* Handling of CVFCT/CVFCTVAR */
#if defined(CVFCT) && defined(CVFCTVAR)
  DOMAIN: only one of 'CVFCT' and 'CVFCTVAR' may be defined.
#error DOMAIN: only one of 'CVFCT' and 'CVFCTVAR' may be defined.
#endif

#if ! defined(CVFCT) && ! defined(CVFCTVAR)
#if defined(X) || defined(Y)
  DOMAIN: the implementation parameter CVFCT or CVFCTVAR must be specified
          if additional parameters are specified (X,XX,XXX,Y,YY,YYY)
#error DOMAIN: CVFCT must be specified if add. params (X,XX,XXX,Y,YY,YYY) are used
#endif
#endif

#ifndef CVFCT
#define cvfct__(xx) xx
#else
#ifndef ELEM2
#define CVFCTNAME MERGE(CVFCT,_ELEM1)
#define cvfct__(xx) MERGE(CVFCT,_ELEM1)(xx)
#else
#define CVFCTNAME MERGE(MERGE(CVFCT,_ELEM1),_ELEM2)
#define cvfct__(xx) MERGE(MERGE(CVFCT,_ELEM1),_ELEM2)(xx)
#endif
#endif
#ifdef CVFCTVAR
#define Pcvfct , _FP(Pvcvfct,tcv)
#define tPcvfct _EP(Pvcvfct,tcv)
#define gppPcvfct P_SEP PARAM(Pvcvfct,tcv)
#undef cvfct__
#define cvfct__(xx) (*CV)(xx)
#else
#define Pcvfct
#define tPcvfct
#define gppPcvfct 
#endif

/* Element parameter evaluation */
#ifndef ELEM2
#define yy y1 iinp
#define fyy _FP(y1,ELEM1) ii
#define tyy _EP(y1,ELEM1) tii
#define pyy ELEM1 y1 pii
#else
#ifndef ELEM3
#define yy y1,y2 iinp
#define fyy _FP(y1,ELEM1),_FP(y2,ELEM2) ii
#define tyy _EP(y1,ELEM1) _EP(y2,ELEM2) tii
#define pyy ELEM1 y1, ELEM2 y2 pii
#else
#ifndef ELEM4
#define yy y1,y2,y3 iinp
#define fyy _FP(y1,ELEM1),_FP(y2,ELEM2),_FP(y3,ELEM3) ii
#define tyy _EP(y1,ELEM1) _EP(y2,ELEM2) _EP(y3,ELEM3) tii
#define pyy ELEM1 y1, ELEM2 y2, ELEM3 y3 pii
#else
#ifndef ELEM5
#define yy y1,y2,y3,y4 iinp
#define fyy _FP(y1,ELEM1),_FP(y2,ELEM2),_FP(y3,ELEM3),_FP(y4,ELEM4) ii
#define tyy _EP(y1,ELEM1) _EP(y2,ELEM2) _EP(y3,ELEM3) _EP(y4,ELEM4) tii
#define pyy ELEM1 y1, ELEM2 y2, ELEM3 y3, ELEM4 y4 pii
#else
#ifndef ELEM6
#define yy y1,y2,y3,y4,y5 iinp
#define fyy _FP(y1,ELEM1),_FP(y2,ELEM2),_FP(y3,ELEM3),_FP(y4,ELEM4),_FP(y5,ELEM5) ii
#define tyy _EP(y1,ELEM1) _EP(y2,ELEM2) _EP(y3,ELEM3) _EP(y4,ELEM4) _EP(y5,ELEM5) tii
#define pyy ELEM1 y1, ELEM2 y2, ELEM3 y3, ELEM4 y4, ELEM5 y5 pii
#else
#error DOMAIN: Not more than 5 components allowed for fold functions
#endif
#endif
#endif
#endif
#endif

/* Handling of NULLFCT/NULLPARAM */
#ifdef NULLFCT
#define _NULL MERGE(NULLFCT,_RESULT)()
#define Pnull 
#define tPnull
#define gppPnull
#else
#ifdef NULLPARAM
#define _NULL Pvnull
#define Pnull ,_FP(Pvnull,RESULT)
#define tPnull _EP(Pvnull,RESULT)
#define gppPnull P_SEP PARAM(Pvnull,RESULT)
#else
#error DOMAIN: either NULLFCT or NULLPARAM must be defined
#endif
#endif

#if defined(NULLFCT) && defined(NULLPARAM)
#error DOMAIN: only one of 'NULLFCT' and 'NULLPARAM' may be defined
#endif


-----
cat >$OUT_DIR/aux/com/folda/gtyp <<'-----'
#ifdef GEN_C

#ifdef NULLFCT
_IFNDEF NULLFCT##_RESULT
  extern RESULT NULLFCT##_RESULT P_OP void P_CL ;
_ENDIF
#endif

_IFNDEF FOLDFCT##_RESULT
  extern RESULT FOLDFCT##_RESULT P_OP RESULT x1, CVFCTRES x2 pPY pPZ P_CL ;
_ENDIF

#ifdef ELEM1
/* does not apply for trees where CVFCTNAME is not valid since 
   multiple cvfcts do exist */

#ifdef CVFCT
_IFNDEF CVFCTNAME
  extern CVFCTRES CVFCTNAME P_OP pyy pPX pPY P_CL ;
_ENDIF
#endif

#endif

#endif
-----
cat >$OUT_DIR/aux/com/folda/mcrcv <<'-----'
#ifdef CVFCTVAR
MACRO1(tcv,Pvcvfct)
#endif
-----
cat >$OUT_DIR/aux/com/folda/mcrx <<'-----'
#ifdef X
MACRO1(X,px1)
#endif
#ifdef XX
MACRO1(XX,px2)
#endif
#ifdef XXX
MACRO1(XXX,px3)
#endif
#ifdef XXXX
MACRO1(XXXX,px4)
#endif
#ifdef XXXXX
MACRO1(XXXXX,px5)
#endif
-----
cat >$OUT_DIR/aux/com/folda/mcrxy <<'-----'
#include <aux/com/folda/mcrx>
#include <aux/com/folda/mcry>
#undef MACRO1
-----
cat >$OUT_DIR/aux/com/folda/mcrxyz <<'-----'
#include <aux/com/folda/mcrx>
#include <aux/com/folda/mcry>
#include <aux/com/folda/mcrz>
#include <aux/com/folda/mcrcv>
#undef MACRO1
-----
cat >$OUT_DIR/aux/com/folda/mcry <<'-----'
#ifdef Y
MACRO1(Y,py1)
#endif
#ifdef YY
MACRO1(YY,py2)
#endif
#ifdef YYY
MACRO1(YYY,py3)
#endif
-----
cat >$OUT_DIR/aux/com/folda/mcryz <<'-----'
#include <aux/com/folda/mcry>
#include <aux/com/folda/mcrz>
#undef MACRO1
-----
cat >$OUT_DIR/aux/com/folda/mcrz <<'-----'
#ifdef Z
MACRO1(Z,pz1)
#endif
#ifdef ZZ
MACRO1(ZZ,pz2)
#endif
#ifdef ZZZ
MACRO1(ZZZ,pz3)
#endif
-----
[ -d $OUT_DIR/aux/com/folde ] || mkdir $OUT_DIR/aux/com/folde
cat >$OUT_DIR/aux/com/folde/ccod <<'-----'
#undef PX 
#undef pPX
#undef tPX
#undef ppPX
#undef gppPX
#undef gPX
#undef lPX
#undef PY 
#undef pPY
#undef tPY
#undef ppPY
#undef gppPY
#undef gPY
#undef lPY
#undef PZ 
#undef pPZ
#undef tPZ
#undef ppPZ
#undef gppPZ
#undef gPZ
#undef lPZ

#undef _FORALL
#undef ii
#undef tii
#undef pii
#undef iipp
#undef iinp
#undef vii

#undef CVFCTNAME
#undef cvfct__
#undef r1
#undef f1
#undef tcv
#undef vcv
#undef CV
#undef Pcvfct
#undef tPcvfct
#undef gppPcvfct 
#undef _NAME
#undef yy
#undef fyy
#undef tyy
#undef pyy
#undef RESULT
#undef _RESULT
#undef CVFCTRES
#undef _CVFCTRES

#undef _NULL
#undef gppPnull
#undef Pnull
#undef tPnull
-----
[ -d $OUT_DIR/aux/com/for ] || mkdir $OUT_DIR/aux/com/for
cat >$OUT_DIR/aux/com/for/ccod <<'-----'
#define _NAME(xx) MERGE(MERGE(MERGE(MERGE(_,xx),_),fct),_DOMAIN)
#define r1 _NAME(rr1)
#define t1 _NAME(tt1)
#define t2 _NAME(tt2)
#define t3 _NAME(tt3)
#define t4 _NAME(tt4)
#define l1 _NAME(ll1)
#define f1 _NAME(ff1)

#ifdef result
#define result_rr1 static result r1;
#define result_lt1 result lr1; lr1 = r1;

#ifdef inires
#define result_ini r1 = inires;
#else
#define result_ini
#endif

#define result_ret {result lr2; lr2 = r1; r1 = lr1; return lr2;}
#else
#define result_rr1
#define result_lt1
#define result_ini
#define result_ret
#define result void
#endif

#ifndef resfin
#define resfin
#endif

#ifndef tx1
#define tx1 DOMAIN
#endif

#ifndef tx2
#define xl _FP(x1,tx1)
#define txl _EP(x1,tx1)
#define dxl static tx1 t1;
#define sxl tx1 lt1; lt1 = t1;
#define ixl t1 = x1;
#define rxl t1 = lt1;
#else
#ifndef tx3
#define xl _FP(x1,tx1),_FP(x2,tx2)
#define txl _EP(x1,tx1) _EP(x2,tx2)
#define dxl static tx1 t1; static tx2 t2;
#define sxl tx1 lt1; tx2 lt2; lt1 = t1; lt2 = t2;
#define ixl t1 = x1; t2 = x2;
#define rxl t1 = lt1; t2 = lt2;
#else
#ifndef tx4
#define xl _FP(x1,tx1),_FP(x2,tx2),_FP(x3,tx3)
#define txl _EP(x1,tx1) _EP(x2,tx2) _EP(x3,tx3)
#define dxl static tx1 t1; static tx2 t2; static tx3 t3;
#define sxl tx1 lt1; tx2 lt2; tx3 lt3; lt1 = t1; lt2 = t2; lt3 = t3;
#define ixl t1 = x1; t2 = x2; t3 = x3;
#define rxl t1 = lt1; t2 = lt2; t3 = lt3;
#else
#define xl _FP(x1,tx1),_FP(x2,tx2),_FP(x3,tx3),_FP(x4,tx4)
#define txl _EP(x1,tx1) _EP(x2,tx2) _EP(x3,tx3) _EP(x4,tx4)
#define dxl static tx1 t1; static tx2 t2; static tx3 t3; static tx4 t4;
#define sxl tx1 lt1; tx2 lt2; tx3 lt3; tx4 lt4; lt1 = t1; lt2 = t2; lt3 = t3; lt4 = t4;
#define ixl t1 = x1; t2 = x2; t3 = x3; t4 = x4;
#define rxl t1 = lt1; t2 = lt2; t3 = lt3; t4 = lt4;
#endif
#endif
#endif

#ifndef ty1
#define ty1 ELEM1
#endif

#ifndef ty2
#define yl _FP(y1,ty1)
#define tyl _EP(y1,ty1)
#else
#define yl _FP(y1,ty1),_FP(y2,ty2)
#define tyl _EP(y1,ty1) _EP(y2,ty2)
#endif

#ifdef tl1
#define dll static tl1 l1;
#define sll tl1 ll1; ll1 = l1;
#define rll l1 = ll1;

#ifdef inil1
#define ill l1 = inil1;
#else
#define ill
#endif

#else
#define dll
#define ill
#define rll
#define sll
#endif

#ifndef forloop
#define forloop MERGE(forall,_DOMAIN)
#endif

#ifndef forx
#define forx x1
#endif

  result_rr1
  dxl dll
  
  static void f1(yl)
      tyl
   {incr}   

  result fct##_DOMAIN(xl)
      txl
  {result_lt1
  {sxl
  {sll
  {ixl
   ill
  {result_ini
   forloop(forx,f1);
   resfin
   rxl rll
   result_ret
  }}}}}

#undef fct
#undef result
#undef tx1
#undef tx2
#undef tx3
#undef tx4

#undef ty1
#undef ty2

#undef tl1
#undef inil1

#undef inires
#undef incr
#undef forloop
#undef forx

#undef xl
#undef txl
#undef dxl
#undef sxl
#undef rxl
#undef ixl

#undef yl
#undef tyl

#undef dll
#undef sll
#undef rll
#undef ill

#undef result_rr1
#undef result_lt1
#undef result_ini
#undef result_ret
#undef resfin

#undef _NAME
#undef r1
#undef t1
#undef t2
#undef t3
#undef t4
#undef l1
#undef f1
-----
cat >$OUT_DIR/aux/com/for/docu <<'-----'
  general macro for generating routines with the forall construct
  the routine may be called recursively, all global data is saved
  and restored on procedure entry and exit

  parameters
   fct      : name of the function to be defined
   inires   : result initialization
   incr     : body of local routine
   result   : function result type (optional, default void)
   tx1      : type of parameter x1 (optional, default DOMAIN)
   tx2      : type of parameter x2 (optional)
   ty1      : type of parameter y1 (optional, default ELEM1)
   ty2      : type of parameter y2 (optional)
   tl1      : type of a local variable l1 (optional)
   inil1    : initialization of l1 (optional, tl1 must be defined)
   for      : call of for routine (optional, default forall)
   resfin   : action to be taken after call of for (optional)

  example:
   
   static result r1;
   static tx1 t1;
   static tx2 x2;
   static tl1 l1;

   void f1(y1,y2)
      ty1 y1;
      ty2 y2;
   {incr} 

   result fct(x1,x2)
      tx1 x1;
      tx2 x2;
   {result lr1 = r1;   
    tx1 lx1 = t1; tx2 lx2 = t2;
    tl1 ll1 = l1;
    t1 = x1; t2 = x2;
    r1 = inires
    l1 = inil1
    for(x1,f1)
    finres
    t1 = lx1; t2 = lx2;
    {result lr2 = r1; r1 = lr1; return lr2;}
   }

 variables :
   r1    : acumulates result
   x1,x2 : parameters
   y1,y2 : parameters of local procedure
   t1,t2 : parameter values x1,x2 as global variables
   l1    : temporary variable

  example application :
   len implemented with forall

#define fct len
#define result Nat0
#define inires 0
#define incr r1++;
#include <aux/com/for/ccod>
-----
[ -d $OUT_DIR/aux/com/fpr ] || mkdir $OUT_DIR/aux/com/fpr
cat >$OUT_DIR/aux/com/fpr/bbc1 <<'-----'
   void p_@N@()
   { /* fprintf(stderr,"testing function fpr():\n"); */
   }
-----
cat >$OUT_DIR/aux/com/fpr/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   { FILE * f;
OP
     f = fopen("Emil","w");
     fpr##_domain##NO( f, D_ ARG );
     fclose(f);
     f = fopen("Emil","r");
     if (! is_eq##_domain##NO(D_ finput##_domain##NO(f), D_ ARG))
       { myerr(@n@,"fpr/finput",#ARG); }
     fclose(f);
CL DD
   }

#include <aux/com/basic/bbundef>
-----
[ -d $OUT_DIR/aux/com/hash ] || mkdir $OUT_DIR/aux/com/hash
cat >$OUT_DIR/aux/com/hash/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   {
OP   if( ! is_eq_nat0(hash##_domain##NO( D_ ARG ),
                      hash##_domain##NO( D_ ARG )) )
       myerr(@n@,"hash()",mkSTR(TEXT));
CL DD }

#include <aux/com/basic/bbundef>
-----
[ -d $OUT_DIR/aux/com/heap ] || mkdir $OUT_DIR/aux/com/heap
cat >$OUT_DIR/aux/com/heap/vdm <<'-----'

#ifndef ALLOC
#define ALLOC malloc("INTERNALDOMAIN")
#endif

DOMAINS
   Heap##_DOMAIN  = DOMAIN -heap
   DOMAIN	  -> Heap##_DOMAIN

IMPLEMENTATIONS
   Heap##_DOMAIN  = ALLOC
                  + alloc("STRUCT"="struct Struct" #_DOMAIN)

#undef ALLOC
-----
[ -d $OUT_DIR/aux/com/is_eq ] || mkdir $OUT_DIR/aux/com/is_eq
cat >$OUT_DIR/aux/com/is_eq/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   {
OP   if( NEG is_eq##_domain##NO( D_ ARG, D_ ARG2 ) )
       myerr(@n@,"is_eq()",mkSTR(TEXT));
CL DD
   }

#include <aux/com/basic/bbundef>
-----
[ -d $OUT_DIR/aux/com/iterator ] || mkdir $OUT_DIR/aux/com/iterator
cat >$OUT_DIR/aux/com/iterator/docu <<'-----'
  "iterator" is an operation for defining iterator
  functions for a collection datatype (like set, bag, map, tupl, ..)
  Including this operation leads to the definition of an auxiliay
  ADT "Iter_collection" (or C++ class "ITER_COLLECTION") for a given
  structured type "COLLECTION".

#ifndef MAP
  "COLLECTION" stands for the name of the collection,
  "ELEMENT" for the element type in the collection.

#ifdef SET
#define CONSTR -set
#else
#ifdef BAG
#define CONSTR -bag
#else
#ifdef TUPL
#define CONSTR *
#else 
#define CONSTR -error
#endif
#endif
#endif

  i.e. the structured value has the following definition:

    Collection = Element CONSTR

#else
  "COLLECTION" stands for the name of the map type,
  "KEY" for the name of the keys in the map,
  "ATTR" for the type of the associated attributes,

  i.e. the structured value has the following definition:

    Collection = Key -m-> Attr

#endif

C++ Interface
-------------

  The C++ interface of the class has the following structure:

  class ITER_COLLECTION {
  public:
        ITER_COLLECTION(const COLLECTION &);
        BOOL operator ! ();
#ifndef MAP
        ELEMENT sel();
#else
        KEY sel(ATTR &);
#endif
        void operator ++ ();
        ~ITER_COLLECTION ();
  };

  The constructor initializes the iterator variable

  The "operator !" is used for testing whether there are elements left
  for processing

  The "sel" function selects the next element. Precondition is,
  that predicate "operator !" holds.
#ifdef MAP
  The associated attribute value is given back via a reference parameter
#endif

  The "operator ++" (post increment) moves the iterator to the
  next element. Precondition is again,
  that predicate "operator !" holds.

  A typical while loop has the following structure

#ifndef MAP
  COLLECTION c=...;     // an initialized collection c

  ITER_COLLECTION ic(c);  // init of iterator

  while ( ! ic ) {
     ELEMENT e = ic.sel(); // selection of the current element
             ..... // further processing of e
             ic++; // moving to the next element
  }

  The equivalent for loop has the following form

  for (ITER_COLLECTION ic = c; ! ic; ic++) {
     ELEMENT e = ic.sel();
             ....
  }
#else
  MAP m = ... ;     // an initialized map m

  ITER_MAP im(m);  // init of iterator

  while ( ! im ) {
     ATTR a;
     KEY k = im.sel(a); // selection of the current element
             ..... // further processing of k and a
             im++; // moving to the next element
  }

  The equivalent for loop has the following form

  for (ITER_MAP im = m; ! im; im++) {
     ATTR a;
     KEY k = im.sel(a);
             ..... 
  }

#endif

C Interface:
------------

  From C, the iterators will be used through the following constructs:

  FOR_iter_collection(Collection v,i);	/* Starts the loop */

    ... loop body, iterating over all elements of 'v'.
        'i' gives the name of the variable used to access the elements
        of 'v' within the loop body..
#ifdef MAP
        Each pair within the map can be accessed by the two variables
        'Key i; Attr i_e;'
#else
        Each element can be accessed through the variable 'Element i'
#endif

  ENDFOR_iter_collection(i);
 

WARNING:
  Iterators are not yet supported by all implementations
#undef MAP
-----
cat >$OUT_DIR/aux/com/iterator/vdm <<'-----'
#ifdef PARAM
#define PARAM1 PARAM,
#else
#define PARAM1
#endif

#ifndef ELEM1
#define ELEM1a
#else 
#define ELEM1a ELEM1
#endif

#ifndef ELEM2
#define ELEM2a
#else 
#define ELEM2a ELEM2
#endif

#ifdef INTERNALFCT
#define PARAMS PARAM1 "INTERNALDOMAIN","MACROS"
#else
#define PARAMS PARAM1 "MACROS"
#endif

/* Iter##_DOMAIN is supported with the DOMAIN and the ELEMi
   normally (for sets, bags and tuples) only ELEM1 is used 
   but for maps ELEM2 is used in sel_-functions
   and for generic binary trees both ELEM1 and ELEM2 are undefined
*/

DOMAINS
   Iter##_DOMAIN = (DOMAIN ELEM1a ELEM2a) -iterator
IMPLEMENTATIONS
   Iter##_DOMAIN = IMPL ( PARAMS )

#undef IMPL
#undef PARAM
#undef PARAM1
#undef PARAMS
#undef ELEM1a
#undef ELEM2a
-----
[ -d $OUT_DIR/aux/com/macro1 ] || mkdir $OUT_DIR/aux/com/macro1
cat >$OUT_DIR/aux/com/macro1/ccod <<'-----'
#ifndef MACRO0
#define MACRO0
#endif

#ifdef COMP1
MACRO1(COMP1,_COMP1,SEL1,_SEL1)
#endif
#ifdef COMP2
MACRO0
MACRO1(COMP2,_COMP2,SEL2,_SEL2)
#endif
#ifdef COMP3
MACRO0
MACRO1(COMP3,_COMP3,SEL3,_SEL3)
#endif
#ifdef COMP4
MACRO0
MACRO1(COMP4,_COMP4,SEL4,_SEL4)
#endif
#ifdef COMP5
MACRO0
MACRO1(COMP5,_COMP5,SEL5,_SEL5)
#endif
#ifdef COMP6
MACRO0
MACRO1(COMP6,_COMP6,SEL6,_SEL6)
#endif
#ifdef COMP7
MACRO0
MACRO1(COMP7,_COMP7,SEL7,_SEL7)
#endif
#ifdef COMP8
MACRO0
MACRO1(COMP8,_COMP8,SEL8,_SEL8)
#endif
#ifdef COMP9
MACRO0
MACRO1(COMP9,_COMP9,SEL9,_SEL9)
#endif

#ifdef COMP10
#include <aux/com/macro2/ccod>
#endif

#undef MACRO0
#undef MACRO1
#undef TUPLDOMAIN
#undef _TUPLDOMAIN
-----
[ -d $OUT_DIR/aux/com/macro2 ] || mkdir $OUT_DIR/aux/com/macro2
cat >$OUT_DIR/aux/com/macro2/ccod <<'-----'
#ifdef COMP10
MACRO0
MACRO1(COMP10,_COMP10,SEL10,_SEL10)
#endif
#ifdef COMP11
MACRO0
MACRO1(COMP11,_COMP11,SEL11,_SEL11)
#endif
#ifdef COMP12
MACRO0
MACRO1(COMP12,_COMP12,SEL12,_SEL12)
#endif
#ifdef COMP13
MACRO0
MACRO1(COMP13,_COMP13,SEL13,_SEL13)
#endif
#ifdef COMP14
MACRO0
MACRO1(COMP14,_COMP14,SEL14,_SEL14)
#endif
#ifdef COMP15
MACRO0
MACRO1(COMP15,_COMP15,SEL15,_SEL15)
#endif
#ifdef COMP16
MACRO0
MACRO1(COMP16,_COMP16,SEL16,_SEL16)
#endif
#ifdef COMP17
MACRO0
MACRO1(COMP17,_COMP17,SEL17,_SEL17)
#endif
#ifdef COMP18
MACRO0
MACRO1(COMP18,_COMP18,SEL18,_SEL18)
#endif
#ifdef COMP19
MACRO0
MACRO1(COMP19,_COMP19,SEL19,_SEL19)
#endif

#ifdef COMP20
MACRO0
MACRO1(COMP20,_COMP20,SEL20,_SEL20)
#endif
#ifdef COMP21
MACRO0
MACRO1(COMP21,_COMP21,SEL21,_SEL21)
#endif
#ifdef COMP22
MACRO0
MACRO1(COMP22,_COMP22,SEL22,_SEL22)
#endif
#ifdef COMP23
MACRO0
MACRO1(COMP23,_COMP23,SEL23,_SEL23)
#endif
#ifdef COMP24
MACRO0
MACRO1(COMP24,_COMP24,SEL24,_SEL24)
#endif
#ifdef COMP25
MACRO0
MACRO1(COMP25,_COMP25,SEL25,_SEL25)
#endif
#ifdef COMP26
MACRO0
MACRO1(COMP26,_COMP26,SEL26,_SEL26)
#endif
#ifdef COMP27
MACRO0
MACRO1(COMP27,_COMP27,SEL27,_SEL27)
#endif
#ifdef COMP28
MACRO0
MACRO1(COMP28,_COMP28,SEL28,_SEL28)
#endif
#ifdef COMP29
MACRO0
MACRO1(COMP29,_COMP29,SEL29,_SEL29)
#endif

#ifdef COMP30
#include <aux/com/macro3/ccod>
#endif

-----
[ -d $OUT_DIR/aux/com/macro3 ] || mkdir $OUT_DIR/aux/com/macro3
cat >$OUT_DIR/aux/com/macro3/ccod <<'-----'
#ifdef COMP30
MACRO0
MACRO1(COMP30,_COMP30,SEL30,_SEL30)
#endif
#ifdef COMP31
MACRO0
MACRO1(COMP31,_COMP31,SEL31,_SEL31)
#endif
#ifdef COMP32
MACRO0
MACRO1(COMP32,_COMP32,SEL32,_SEL32)
#endif
#ifdef COMP33
MACRO0
MACRO1(COMP33,_COMP33,SEL33,_SEL33)
#endif
#ifdef COMP34
MACRO0
MACRO1(COMP34,_COMP34,SEL34,_SEL34)
#endif
#ifdef COMP35
MACRO0
MACRO1(COMP35,_COMP35,SEL35,_SEL35)
#endif
#ifdef COMP36
MACRO0
MACRO1(COMP36,_COMP36,SEL36,_SEL36)
#endif
#ifdef COMP37
MACRO0
MACRO1(COMP37,_COMP37,SEL37,_SEL37)
#endif
#ifdef COMP38
MACRO0
MACRO1(COMP38,_COMP38,SEL38,_SEL38)
#endif
#ifdef COMP39
MACRO0
MACRO1(COMP39,_COMP39,SEL39,_SEL39)
#endif
#ifdef COMP40
MACRO0
MACRO1(COMP40,_COMP40,SEL40,_SEL40)
#endif
#ifdef COMP41
MACRO0
MACRO1(COMP41,_COMP41,SEL41,_SEL41)
#endif
#ifdef COMP42
MACRO0
MACRO1(COMP42,_COMP42,SEL42,_SEL42)
#endif
#ifdef COMP43
MACRO0
MACRO1(COMP43,_COMP43,SEL43,_SEL43)
#endif
#ifdef COMP44
MACRO0
MACRO1(COMP44,_COMP44,SEL44,_SEL44)
#endif
#ifdef COMP45
MACRO0
MACRO1(COMP45,_COMP45,SEL45,_SEL45)
#endif
#ifdef COMP46
MACRO0
MACRO1(COMP46,_COMP46,SEL46,_SEL46)
#endif
#ifdef COMP47
MACRO0
MACRO1(COMP47,_COMP47,SEL47,_SEL47)
#endif
#ifdef COMP48
MACRO0
MACRO1(COMP48,_COMP48,SEL48,_SEL48)
#endif
#ifdef COMP49
MACRO0
MACRO1(COMP49,_COMP49,SEL49,_SEL49)
#endif
#ifdef COMP50
MACRO0
MACRO1(COMP50,_COMP50,SEL50,_SEL50)
#endif
#ifdef COMP51
MACRO0
MACRO1(COMP51,_COMP51,SEL51,_SEL51)
#endif
#ifdef COMP52
MACRO0
MACRO1(COMP52,_COMP52,SEL52,_SEL52)
#endif
#ifdef COMP53
MACRO0
MACRO1(COMP53,_COMP53,SEL53,_SEL53)
#endif
#ifdef COMP54
MACRO0
MACRO1(COMP54,_COMP54,SEL54,_SEL54)
#endif
#ifdef COMP55
MACRO0
MACRO1(COMP55,_COMP55,SEL55,_SEL55)
#endif
#ifdef COMP56
MACRO0
MACRO1(COMP56,_COMP56,SEL56,_SEL56)
#endif
#ifdef COMP57
MACRO0
MACRO1(COMP57,_COMP57,SEL57,_SEL57)
#endif
#ifdef COMP58
MACRO0
MACRO1(COMP58,_COMP58,SEL58,_SEL58)
#endif
#ifdef COMP59
MACRO0
MACRO1(COMP59,_COMP59,SEL59,_SEL59)
#endif
#ifdef COMP60
MACRO0
MACRO1(COMP60,_COMP60,SEL60,_SEL60)
#endif
#ifdef COMP61
MACRO0
MACRO1(COMP61,_COMP61,SEL61,_SEL61)
#endif
#ifdef COMP62
MACRO0
MACRO1(COMP62,_COMP62,SEL62,_SEL62)
#endif
#ifdef COMP63
MACRO0
MACRO1(COMP63,_COMP63,SEL63,_SEL63)
#endif
#ifdef COMP64
MACRO0
MACRO1(COMP64,_COMP64,SEL64,_SEL64)
#endif
#ifdef COMP65
MACRO0
MACRO1(COMP65,_COMP65,SEL65,_SEL65)
#endif
#ifdef COMP66
MACRO0
MACRO1(COMP66,_COMP66,SEL66,_SEL66)
#endif
#ifdef COMP67
MACRO0
MACRO1(COMP67,_COMP67,SEL67,_SEL67)
#endif
#ifdef COMP68
MACRO0
MACRO1(COMP68,_COMP68,SEL68,_SEL68)
#endif
#ifdef COMP69
MACRO0
MACRO1(COMP69,_COMP69,SEL69,_SEL69)
#endif
#ifdef COMP70
MACRO0
MACRO1(COMP70,_COMP70,SEL70,_SEL70)
#endif
#ifdef COMP71
MACRO0
MACRO1(COMP71,_COMP71,SEL71,_SEL71)
#endif
#ifdef COMP72
MACRO0
MACRO1(COMP72,_COMP72,SEL72,_SEL72)
#endif
#ifdef COMP73
MACRO0
MACRO1(COMP73,_COMP73,SEL73,_SEL73)
#endif
#ifdef COMP74
MACRO0
MACRO1(COMP74,_COMP74,SEL74,_SEL74)
#endif
#ifdef COMP75
MACRO0
MACRO1(COMP75,_COMP75,SEL75,_SEL75)
#endif
#ifdef COMP76
MACRO0
MACRO1(COMP76,_COMP76,SEL76,_SEL76)
#endif
#ifdef COMP77
MACRO0
MACRO1(COMP77,_COMP77,SEL77,_SEL77)
#endif
#ifdef COMP78
MACRO0
MACRO1(COMP78,_COMP78,SEL78,_SEL78)
#endif
#ifdef COMP79
MACRO0
MACRO1(COMP79,_COMP79,SEL79,_SEL79)
#endif
#ifdef COMP80
MACRO0
MACRO1(COMP80,_COMP80,SEL80,_SEL80)
#endif
#ifdef COMP81
MACRO0
MACRO1(COMP81,_COMP81,SEL81,_SEL81)
#endif
#ifdef COMP82
MACRO0
MACRO1(COMP82,_COMP82,SEL82,_SEL82)
#endif
#ifdef COMP83
MACRO0
MACRO1(COMP83,_COMP83,SEL83,_SEL83)
#endif
#ifdef COMP84
MACRO0
MACRO1(COMP84,_COMP84,SEL84,_SEL84)
#endif
#ifdef COMP85
MACRO0
MACRO1(COMP85,_COMP85,SEL85,_SEL85)
#endif
#ifdef COMP86
MACRO0
MACRO1(COMP86,_COMP86,SEL86,_SEL86)
#endif
#ifdef COMP87
MACRO0
MACRO1(COMP87,_COMP87,SEL87,_SEL87)
#endif
#ifdef COMP88
MACRO0
MACRO1(COMP88,_COMP88,SEL88,_SEL88)
#endif
#ifdef COMP89
MACRO0
MACRO1(COMP89,_COMP89,SEL89,_SEL89)
#endif
#ifdef COMP89
  DOMAIN: only 89 components are supported 
#endif

-----
[ -d $OUT_DIR/aux/com/mecro1 ] || mkdir $OUT_DIR/aux/com/mecro1
cat >$OUT_DIR/aux/com/mecro1/ccod <<'-----'

#ifndef MACRO1
#define MACRO1
#endif

#ifndef MACRO2
#define MACRO2
#endif

#ifndef MACRO3
#define MACRO3
#endif

#ifdef COMP1
MACRO1(COMP1,_COMP1,SEL1,_SEL1)
MACRO2(COMP1,_COMP1,SEL1,_SEL1)
MACRO3(COMP1,_COMP1,SEL1,_SEL1)
#endif
#ifdef COMP2
MACRO1(COMP2,_COMP2,SEL2,_SEL2)
MACRO2(COMP2,_COMP2,SEL2,_SEL2)
MACRO3(COMP2,_COMP2,SEL2,_SEL2)
#endif
#ifdef COMP3
MACRO1(COMP3,_COMP3,SEL3,_SEL3)
MACRO2(COMP3,_COMP3,SEL3,_SEL3)
MACRO3(COMP3,_COMP3,SEL3,_SEL3)
#endif
#ifdef COMP4
MACRO1(COMP4,_COMP4,SEL4,_SEL4)
MACRO2(COMP4,_COMP4,SEL4,_SEL4)
MACRO3(COMP4,_COMP4,SEL4,_SEL4)
#endif
#ifdef COMP5
MACRO1(COMP5,_COMP5,SEL5,_SEL5)
MACRO2(COMP5,_COMP5,SEL5,_SEL5)
MACRO3(COMP5,_COMP5,SEL5,_SEL5)
#endif
#ifdef COMP6
MACRO1(COMP6,_COMP6,SEL6,_SEL6)
MACRO2(COMP6,_COMP6,SEL6,_SEL6)
MACRO3(COMP6,_COMP6,SEL6,_SEL6)
#endif
#ifdef COMP7
MACRO1(COMP7,_COMP7,SEL7,_SEL7)
MACRO2(COMP7,_COMP7,SEL7,_SEL7)
MACRO3(COMP7,_COMP7,SEL7,_SEL7)
#endif
#ifdef COMP8
MACRO1(COMP8,_COMP8,SEL8,_SEL8)
MACRO2(COMP8,_COMP8,SEL8,_SEL8)
MACRO3(COMP8,_COMP8,SEL8,_SEL8)
#endif
#ifdef COMP9
MACRO1(COMP9,_COMP9,SEL9,_SEL9)
MACRO2(COMP9,_COMP9,SEL9,_SEL9)
MACRO3(COMP9,_COMP9,SEL9,_SEL9)
#endif

#ifdef COMP10
#include <aux/com/mecro2/ccod>
#endif

#undef MACRO1
#undef MACRO2
#undef MACRO3
-----
[ -d $OUT_DIR/aux/com/mecro2 ] || mkdir $OUT_DIR/aux/com/mecro2
cat >$OUT_DIR/aux/com/mecro2/ccod <<'-----'
#ifdef COMP10
MACRO1(COMP10,_COMP10,SEL10,_SEL10)
MACRO2(COMP10,_COMP10,SEL10,_SEL10)
MACRO3(COMP10,_COMP10,SEL10,_SEL10)
#endif
#ifdef COMP11
MACRO1(COMP11,_COMP11,SEL11,_SEL11)
MACRO2(COMP11,_COMP11,SEL11,_SEL11)
MACRO3(COMP11,_COMP11,SEL11,_SEL11)
#endif
#ifdef COMP12
MACRO1(COMP12,_COMP12,SEL12,_SEL12)
MACRO2(COMP12,_COMP12,SEL12,_SEL12)
MACRO3(COMP12,_COMP12,SEL12,_SEL12)
#endif
#ifdef COMP13
MACRO1(COMP13,_COMP13,SEL13,_SEL13)
MACRO2(COMP13,_COMP13,SEL13,_SEL13)
MACRO3(COMP13,_COMP13,SEL13,_SEL13)
#endif
#ifdef COMP14
MACRO1(COMP14,_COMP14,SEL14,_SEL14)
MACRO2(COMP14,_COMP14,SEL14,_SEL14)
MACRO3(COMP14,_COMP14,SEL14,_SEL14)
#endif
#ifdef COMP15
MACRO1(COMP15,_COMP15,SEL15,_SEL15)
MACRO2(COMP15,_COMP15,SEL15,_SEL15)
MACRO3(COMP15,_COMP15,SEL15,_SEL15)
#endif
#ifdef COMP16
MACRO1(COMP16,_COMP16,SEL16,_SEL16)
MACRO2(COMP16,_COMP16,SEL16,_SEL16)
MACRO3(COMP16,_COMP16,SEL16,_SEL16)
#endif
#ifdef COMP17
MACRO1(COMP17,_COMP17,SEL17,_SEL17)
MACRO2(COMP17,_COMP17,SEL17,_SEL17)
MACRO3(COMP17,_COMP17,SEL17,_SEL17)
#endif
#ifdef COMP18
MACRO1(COMP18,_COMP18,SEL18,_SEL18)
MACRO2(COMP18,_COMP18,SEL18,_SEL18)
MACRO3(COMP18,_COMP18,SEL18,_SEL18)
#endif
#ifdef COMP19
MACRO1(COMP19,_COMP19,SEL19,_SEL19)
MACRO2(COMP19,_COMP19,SEL19,_SEL19)
MACRO3(COMP19,_COMP19,SEL19,_SEL19)
#endif
#ifdef COMP20
MACRO1(COMP20,_COMP20,SEL20,_SEL20)
MACRO2(COMP20,_COMP20,SEL20,_SEL20)
MACRO3(COMP20,_COMP20,SEL20,_SEL20)
#endif
#ifdef COMP21
MACRO1(COMP21,_COMP21,SEL21,_SEL21)
MACRO2(COMP21,_COMP21,SEL21,_SEL21)
MACRO3(COMP21,_COMP21,SEL21,_SEL21)
#endif
#ifdef COMP22
MACRO1(COMP22,_COMP22,SEL22,_SEL22)
MACRO2(COMP22,_COMP22,SEL22,_SEL22)
MACRO3(COMP22,_COMP22,SEL22,_SEL22)
#endif
#ifdef COMP23
MACRO1(COMP23,_COMP23,SEL23,_SEL23)
MACRO2(COMP23,_COMP23,SEL23,_SEL23)
MACRO3(COMP23,_COMP23,SEL23,_SEL23)
#endif
#ifdef COMP24
MACRO1(COMP24,_COMP24,SEL24,_SEL24)
MACRO2(COMP24,_COMP24,SEL24,_SEL24)
MACRO3(COMP24,_COMP24,SEL24,_SEL24)
#endif
#ifdef COMP25
MACRO1(COMP25,_COMP25,SEL25,_SEL25)
MACRO2(COMP25,_COMP25,SEL25,_SEL25)
MACRO3(COMP25,_COMP25,SEL25,_SEL25)
#endif
#ifdef COMP26
MACRO1(COMP26,_COMP26,SEL26,_SEL26)
MACRO2(COMP26,_COMP26,SEL26,_SEL26)
MACRO3(COMP26,_COMP26,SEL26,_SEL26)
#endif
#ifdef COMP27
MACRO1(COMP27,_COMP27,SEL27,_SEL27)
MACRO2(COMP27,_COMP27,SEL27,_SEL27)
MACRO3(COMP27,_COMP27,SEL27,_SEL27)
#endif
#ifdef COMP28
MACRO1(COMP28,_COMP28,SEL28,_SEL28)
MACRO2(COMP28,_COMP28,SEL28,_SEL28)
MACRO3(COMP28,_COMP28,SEL28,_SEL28)
#endif
#ifdef COMP29
MACRO1(COMP29,_COMP29,SEL29,_SEL29)
MACRO2(COMP29,_COMP29,SEL29,_SEL29)
MACRO3(COMP29,_COMP29,SEL29,_SEL29)
#endif

#ifdef COMP30
#include <aux/com/mecro3/ccod>
#endif

-----
[ -d $OUT_DIR/aux/com/mecro3 ] || mkdir $OUT_DIR/aux/com/mecro3
cat >$OUT_DIR/aux/com/mecro3/ccod <<'-----'
#ifdef COMP30
MACRO1(COMP30,_COMP30,SEL30,_SEL30)
MACRO2(COMP30,_COMP30,SEL30,_SEL30)
MACRO3(COMP30,_COMP30,SEL30,_SEL30)
#endif
#ifdef COMP31
MACRO1(COMP31,_COMP31,SEL31,_SEL31)
MACRO2(COMP31,_COMP31,SEL31,_SEL31)
MACRO3(COMP31,_COMP31,SEL31,_SEL31)
#endif
#ifdef COMP32
MACRO1(COMP32,_COMP32,SEL32,_SEL32)
MACRO2(COMP32,_COMP32,SEL32,_SEL32)
MACRO3(COMP32,_COMP32,SEL32,_SEL32)
#endif
#ifdef COMP33
MACRO1(COMP33,_COMP33,SEL33,_SEL33)
MACRO2(COMP33,_COMP33,SEL33,_SEL33)
MACRO3(COMP33,_COMP33,SEL33,_SEL33)
#endif
#ifdef COMP34
MACRO1(COMP34,_COMP34,SEL34,_SEL34)
MACRO2(COMP34,_COMP34,SEL34,_SEL34)
MACRO3(COMP34,_COMP34,SEL34,_SEL34)
#endif
#ifdef COMP35
MACRO1(COMP35,_COMP35,SEL35,_SEL35)
MACRO2(COMP35,_COMP35,SEL35,_SEL35)
MACRO3(COMP35,_COMP35,SEL35,_SEL35)
#endif
#ifdef COMP36
MACRO1(COMP36,_COMP36,SEL36,_SEL36)
MACRO2(COMP36,_COMP36,SEL36,_SEL36)
MACRO3(COMP36,_COMP36,SEL36,_SEL36)
#endif
#ifdef COMP37
MACRO1(COMP37,_COMP37,SEL37,_SEL37)
MACRO2(COMP37,_COMP37,SEL37,_SEL37)
MACRO3(COMP37,_COMP37,SEL37,_SEL37)
#endif
#ifdef COMP38
MACRO1(COMP38,_COMP38,SEL38,_SEL38)
MACRO2(COMP38,_COMP38,SEL38,_SEL38)
MACRO3(COMP38,_COMP38,SEL38,_SEL38)
#endif
#ifdef COMP39
MACRO1(COMP39,_COMP39,SEL39,_SEL39)
MACRO2(COMP39,_COMP39,SEL39,_SEL39)
MACRO3(COMP39,_COMP39,SEL39,_SEL39)
#endif
#ifdef COMP40
MACRO1(COMP40,_COMP40,SEL40,_SEL40)
MACRO2(COMP40,_COMP40,SEL40,_SEL40)
MACRO3(COMP40,_COMP40,SEL40,_SEL40)
#endif
#ifdef COMP41
MACRO1(COMP41,_COMP41,SEL41,_SEL41)
MACRO2(COMP41,_COMP41,SEL41,_SEL41)
MACRO3(COMP41,_COMP41,SEL41,_SEL41)
#endif
#ifdef COMP42
MACRO1(COMP42,_COMP42,SEL42,_SEL42)
MACRO2(COMP42,_COMP42,SEL42,_SEL42)
MACRO3(COMP42,_COMP42,SEL42,_SEL42)
#endif
#ifdef COMP43
MACRO1(COMP43,_COMP43,SEL43,_SEL43)
MACRO2(COMP43,_COMP43,SEL43,_SEL43)
MACRO3(COMP43,_COMP43,SEL43,_SEL43)
#endif
#ifdef COMP44
MACRO1(COMP44,_COMP44,SEL44,_SEL44)
MACRO2(COMP44,_COMP44,SEL44,_SEL44)
MACRO3(COMP44,_COMP44,SEL44,_SEL44)
#endif
#ifdef COMP45
MACRO1(COMP45,_COMP45,SEL45,_SEL45)
MACRO2(COMP45,_COMP45,SEL45,_SEL45)
MACRO3(COMP45,_COMP45,SEL45,_SEL45)
#endif
#ifdef COMP46
MACRO1(COMP46,_COMP46,SEL46,_SEL46)
MACRO2(COMP46,_COMP46,SEL46,_SEL46)
MACRO3(COMP46,_COMP46,SEL46,_SEL46)
#endif
#ifdef COMP47
MACRO1(COMP47,_COMP47,SEL47,_SEL47)
MACRO2(COMP47,_COMP47,SEL47,_SEL47)
MACRO3(COMP47,_COMP47,SEL47,_SEL47)
#endif
#ifdef COMP48
MACRO1(COMP48,_COMP48,SEL48,_SEL48)
MACRO2(COMP48,_COMP48,SEL48,_SEL48)
MACRO3(COMP48,_COMP48,SEL48,_SEL48)
#endif
#ifdef COMP49
MACRO1(COMP49,_COMP49,SEL49,_SEL49)
MACRO2(COMP49,_COMP49,SEL49,_SEL49)
MACRO3(COMP49,_COMP49,SEL49,_SEL49)
#endif

#ifdef COMP50
!! only 49 components are supported !!
#endif

-----
[ -d $OUT_DIR/aux/com/mfolddom ] || mkdir $OUT_DIR/aux/com/mfolddom
cat >$OUT_DIR/aux/com/mfolddom/ccod <<'-----'
#include <aux/com/mfolddom/macroa>

#ifdef _Tupl
#define __PH _FPH2(Nat0,ELEM1)
static Nat0 __gx1;
static ELEM1 __gx2;
#define __save __gx1 = x1; __gx2 = x2;
#else
#ifdef ELEM2
#define __PH _FPH2(ELEM1,ELEM2)
static ELEM1 __gx1;
static ELEM2 __gx2;
#define __save __gx1 = x1; __gx2 = x2;
#else
#define __PH _FPH1(ELEM1)
static ELEM1 __gx1;
#define __save __gx1 = x1;
#endif
#endif

static void mfoldfct##_FCTNAME##_DOMAIN __PH
    { __save
#ifdef NEXTDOM
      _pforall##_NEXTDOM(XN,mfoldfct##_FCTNAME##_NEXTDOM);
#else
      MERGE(MERGE(callcv,_FCTNAME),_CALLDOM)();
#endif
    }

#undef __PH
#undef __save
#include <aux/com/mfolddom/macroa>
-----
cat >$OUT_DIR/aux/com/mfolddom/gtyp <<'-----'
#include <aux/com/mfolddom/macroa>

#ifdef GEN_C
#ifdef ELEM2
_DEFINE MERGE(MERGE(_fp,_FCTNAME),_DOMAIN) ELEM1 __x1, ELEM2 __x2
_DEFINE MERGE(MERGE(_ap,_FCTNAME),_DOMAIN) __gx1, __gx2
_DEFINE MERGE(_pforall,_DOMAIN) MERGE(forall,_DOMAIN)
static void mfoldfct##_FCTNAME##_DOMAIN(CA ELEM1 x1,ELEM2 x2 CE);
static ELEM1 __gx1;
static ELEM2 __gx2;
#else
#ifdef _Tupl
_DEFINE MERGE(MERGE(_fp,_FCTNAME),_DOMAIN) Nat0 __x1, ELEM1 __x2
_DEFINE MERGE(MERGE(_ap,_FCTNAME),_DOMAIN) __gx1, __gx2
_DEFINE MERGE(_pforall,_DOMAIN) MERGE(forindex,_DOMAIN)
static void mfoldfct##_FCTNAME##_DOMAIN(CA Nat0 x1,ELEM1 x2 CE);
static Nat0 __gx1;
static ELEM1 __gx2;
#else
_DEFINE MERGE(MERGE(_fp,_FCTNAME),_DOMAIN) ELEM1 __gx1
_DEFINE MERGE(MERGE(_ap,_FCTNAME),_DOMAIN) __gx1
_DEFINE MERGE(_pforall,_DOMAIN) MERGE(forall,_DOMAIN)
static void mfoldfct##_FCTNAME##_DOMAIN(CA ELEM1 x1 CE);
static ELEM1 __gx1;
#endif
#endif
#endif

#include <aux/com/mfolddom/macroe>
-----
cat >$OUT_DIR/aux/com/mfolddom/macroa <<'-----'
#define __x1 MERGE(MERGE(x1,_FCTNAME),_DOMAIN)
#define __x2 MERGE(MERGE(x2,_FCTNAME),_DOMAIN)
#define __gx1 MERGE(MERGE(gx1,_FCTNAME),_DOMAIN)
#define __gx2 MERGE(MERGE(gx2,_FCTNAME),_DOMAIN)
-----
cat >$OUT_DIR/aux/com/mfolddom/macroe <<'-----'
#undef __x1 
#undef __x2
#undef __gx1 
#undef __gx2
-----
cat >$OUT_DIR/aux/com/mfolddom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifdef _Tupl
  DOMAIN = + forindex
#else
  DOMAIN = + forall
#endif
-----
[ -d $OUT_DIR/aux/com/micro1 ] || mkdir $OUT_DIR/aux/com/micro1
cat >$OUT_DIR/aux/com/micro1/ccod <<'-----'

#ifndef COMP2
    MACRO1(COMP1,_COMP1,SEL1,_SEL1)
#else
    MACRO2(COMP1,_COMP1,SEL1,_SEL1)
#ifndef COMP3
    MACRO1(COMP2,_COMP2,SEL2,_SEL2)
#else
    MACRO2(COMP2,_COMP2,SEL2,_SEL2)
#ifndef COMP4
    MACRO1(COMP3,_COMP3,SEL3,_SEL3)
#else
    MACRO2(COMP3,_COMP3,SEL3,_SEL3)
#ifndef COMP5
    MACRO1(COMP4,_COMP4,SEL4,_SEL4)
#else
    MACRO2(COMP4,_COMP4,SEL4,_SEL4)
#ifndef COMP6
    MACRO1(COMP5,_COMP5,SEL5,_SEL5)
#else
    MACRO2(COMP5,_COMP5,SEL5,_SEL5)
#ifndef COMP7
    MACRO1(COMP6,_COMP6,SEL6,_SEL6)
#else
    MACRO2(COMP6,_COMP6,SEL6,_SEL6)
#ifndef COMP8
    MACRO1(COMP7,_COMP7,SEL7,_SEL7)
#else
    MACRO2(COMP7,_COMP7,SEL7,_SEL7)
#ifndef COMP9
    MACRO1(COMP8,_COMP8,SEL8,_SEL8)
#else
    MACRO2(COMP8,_COMP8,SEL8,_SEL8)

#include <aux/com/micro2/ccod>

    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif

#undef MACRO1
#undef MACRO2
#undef MACRO3
-----
[ -d $OUT_DIR/aux/com/micro2 ] || mkdir $OUT_DIR/aux/com/micro2
cat >$OUT_DIR/aux/com/micro2/ccod <<'-----'
#ifndef COMP10
    MACRO1(COMP9,_COMP9,SEL9,_SEL9)
#else
    MACRO2(COMP9,_COMP9,SEL9,_SEL9)
#ifndef COMP11
    MACRO1(COMP10,_COMP10,SEL10,_SEL10)
#else
    MACRO2(COMP10,_COMP10,SEL10,_SEL10)
#ifndef COMP12
    MACRO1(COMP11,_COMP11,SEL11,_SEL11)
#else
    MACRO2(COMP11,_COMP11,SEL11,_SEL11)
#ifndef COMP13
    MACRO1(COMP12,_COMP12,SEL12,_SEL12)
#else
    MACRO2(COMP12,_COMP12,SEL12,_SEL12)
#ifndef COMP14
    MACRO1(COMP13,_COMP13,SEL13,_SEL13)
#else
    MACRO2(COMP13,_COMP13,SEL13,_SEL13)
#ifndef COMP15
    MACRO1(COMP14,_COMP14,SEL14,_SEL14)
#else
    MACRO2(COMP14,_COMP14,SEL14,_SEL14)
#ifndef COMP16
    MACRO1(COMP15,_COMP15,SEL15,_SEL15)
#else
    MACRO2(COMP15,_COMP15,SEL15,_SEL15)
#ifndef COMP17
    MACRO1(COMP16,_COMP16,SEL16,_SEL16)
#else
    MACRO2(COMP16,_COMP16,SEL16,_SEL16)
#ifndef COMP18
    MACRO1(COMP17,_COMP17,SEL17,_SEL17)
#else
    MACRO2(COMP17,_COMP17,SEL17,_SEL17)
#ifndef COMP19
    MACRO1(COMP18,_COMP18,SEL18,_SEL18)
#else
    MACRO2(COMP18,_COMP18,SEL18,_SEL18)
#ifndef COMP20
    MACRO1(COMP19,_COMP19,SEL19,_SEL19)
#else
    MACRO2(COMP19,_COMP19,SEL19,_SEL19)
#ifndef COMP21
    MACRO1(COMP20,_COMP20,SEL20,_SEL20)
#else
    MACRO2(COMP20,_COMP20,SEL20,_SEL20)
#ifndef COMP22
    MACRO1(COMP21,_COMP21,SEL21,_SEL21)
#else
    MACRO2(COMP21,_COMP21,SEL21,_SEL21)
#ifndef COMP23
    MACRO1(COMP22,_COMP22,SEL22,_SEL22)
#else
    MACRO2(COMP22,_COMP22,SEL22,_SEL22)
#ifndef COMP24
    MACRO1(COMP23,_COMP23,SEL23,_SEL23)
#else
    MACRO2(COMP23,_COMP23,SEL23,_SEL23)
#ifndef COMP25
    MACRO1(COMP24,_COMP24,SEL24,_SEL24)
#else
    MACRO2(COMP24,_COMP24,SEL24,_SEL24)
#ifndef COMP26
    MACRO1(COMP25,_COMP25,SEL25,_SEL25)
#else
    MACRO2(COMP25,_COMP25,SEL25,_SEL25)
#ifndef COMP27
    MACRO1(COMP26,_COMP26,SEL26,_SEL26)
#else
    MACRO2(COMP26,_COMP26,SEL26,_SEL26)
#ifndef COMP28
    MACRO1(COMP27,_COMP27,SEL27,_SEL27)
#else
    MACRO2(COMP27,_COMP27,SEL27,_SEL27)
#ifndef COMP29
    MACRO1(COMP28,_COMP28,SEL28,_SEL28)
#else
    MACRO2(COMP28,_COMP28,SEL28,_SEL28)

#ifndef COMP30
    MACRO1(COMP29,_COMP29,SEL29,_SEL29)
#else
    !! only 29 components are supported !!
#endif

    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
    MACRO3
#endif
-----
[ -d $OUT_DIR/aux/com/mk_empty ] || mkdir $OUT_DIR/aux/com/mk_empty
cat >$OUT_DIR/aux/com/mk_empty/docu <<'-----'
#ifdef GEN_CPP

  In C++ initialization with an empty value is done
  in the form

    DOMAIN v = empty;

  or

    DOMAIN v(empty);

  'empty' is a special predefined object of an auxiliary class 'NILETC'

#endif
-----
[ -d $OUT_DIR/aux/com/mkn_empty ] || mkdir $OUT_DIR/aux/com/mkn_empty
cat >$OUT_DIR/aux/com/mkn_empty/gcod <<'-----'
  _FDEC1(mkn_empty,DOMAIN,Nat0,_RET(mk_empty##_DOMAIN()))
-----
cat >$OUT_DIR/aux/com/mkn_empty/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS 
    DOMAIN = + mk_empty
-----
[ -d $OUT_DIR/aux/com/parse ] || mkdir $OUT_DIR/aux/com/parse
cat >$OUT_DIR/aux/com/parse/vdm <<'-----'
#ifndef params
#define params
#endif

DOMAINS
IMPLEMENTATIONS
  Vdmlib = + parseio + parsesup(params)

#undef params
-----
[ -d $OUT_DIR/aux/com/parsem ] || mkdir $OUT_DIR/aux/com/parsem
cat >$OUT_DIR/aux/com/parsem/ccod <<'-----'
#ifndef START_SYM
#define START_SYM '{'
#define STOP_SYM '}'
#define ADD_TO union1
#endif

  DOMAIN parse##_DOMAIN _FPH0()
    { DOMAIN lx1 = mk_empty##_DOMAIN();
      char lx2;
      ELEM1 lx3;
#ifdef ELEM2
      ELEM2 lx4;
#endif
      char  lls2[5];

      strcpy(lls2," /,");lls2[0] = STOP_SYM;
      expect_vdmlib(char2str_vdmlib(START_SYM),#DOMAIN);
      if ((lx2 = next_char_vdmlib()) == STOP_SYM)
	 { return lx1; }
      else
	 { unputchar_vdmlib(lx2); }

      do
	 { lx3 = parse##_ELEM1();
#ifdef ELEM2
#ifdef GEN_ISO
      	   expect_vdmlib("|->",#DOMAIN);
#else
      	   expect_vdmlib(":->",#DOMAIN);
#endif
	   lx4 = parse##_ELEM2();
	   lx1 = ADD_TO##_DOMAIN(lx1,lx3,lx4);
#else
	   lx1 = ADD_TO##_DOMAIN(lx1,lx3);
#endif
	 }
      while ((lx2 = next_char_vdmlib()) == ',');

      if (lx2 != STOP_SYM)
	 { unputchar_vdmlib(lx2);
	   expected_vdmlib(#DOMAIN,lls2,char2str_vdmlib(lx2));
	 }

      return lx1;
   }
      
#undef START_SYM
#undef STOP_SYM
#undef ADD_TO
-----
cat >$OUT_DIR/aux/com/parsem/vdm <<'-----'
#ifndef ADD_TO
#define ADD_TO union1
#endif

DOMAINS
IMPLEMENTATIONS
 Vdmlib	= + parsesup
 DOMAIN	= + mk_empty + ADD_TO
 ELEM1	= + parse
#ifdef ELEM2
 ELEM2	= + parse
#endif

#undef ADD_TO
-----
[ -d $OUT_DIR/aux/com/pr ] || mkdir $OUT_DIR/aux/com/pr
cat >$OUT_DIR/aux/com/pr/bbc1 <<'-----'
/* ----------
   --- 'pr' is covered by 'fpr' ----------
   void p_@N@()
   { fprintf(stderr,"\n\ntesting function pr():\n");
   }
------------*/
-----
cat >$OUT_DIR/aux/com/pr/bbc2 <<'-----'
/* ----------
   --- 'pr' is covered by 'fpr' ----------
#include <aux/com/basic/bbdef>

   void p_@N@()
   {
OP   pr##_domain##NO( D_ ARG );
     fflush(stderr);
CL DD
   }

#undef ARG
#include <aux/com/basic/bbundef>
------------*/
#undef ARG
-----
[ -d $OUT_DIR/aux/com/print ] || mkdir $OUT_DIR/aux/com/print
cat >$OUT_DIR/aux/com/print/bbc1 <<'-----'
   void p_@N@()
   { /*- fprintf(stderr,"testing function fprint():\n"); -*/
   }
-----
cat >$OUT_DIR/aux/com/print/bbc2 <<'-----'
#include <aux/com/basic/bbdef>

   void p_@N@()
   { FILE * f;
OP
     f = fopen("Emil_print","w");
     fprint##_domain##NO( f, D_ ARG );
     fclose(f);
     f = fopen("Emil_print","r");
     if (! is_eq##_domain##NO(D_ finput##_domain##NO(f), D_ ARG))
       { myerr(@n@,"fpr/finput",#ARG); }
     fclose(f);
CL DD
   }

#include <aux/com/basic/bbundef>
-----
cat >$OUT_DIR/aux/com/print/ccod <<'-----'
#ifndef start
#define start "<"
#define step  ","
#define stop  ">"
#define stup  ""
#endif

_IFDEF __cplusplus
#ifndef ELEM2
#define printelem MERGE(print,_ELEM1)(y1); print_FD_vdmlib << "\n";
#else
#define printelem MERGE(print,_ELEM1)(y1); print_FD_vdmlib << stup; MERGE(print,_ELEM2)(y2); print_FD_vdmlib << "\n";
#define ty2 ELEM2
#endif

#define fct print
#define tl1 char *
#define inil1 start
#define incr print_FD_vdmlib << l1; printelem l1 = step;
#define forloop if (MERGE(is_empty,_DOMAIN)(x1)) print_FD_vdmlib << start; else MERGE(forall,_DOMAIN)
#define resfin print_FD_vdmlib << stop;
#include <aux/com/for/ccod>

#undef printelem

_ELSE

#ifndef ELEM2
#define printelem MERGE(print,_ELEM1)(y1);fprintf(print_FD_vdmlib,"\n");
#else
#define printelem MERGE(print,_ELEM1)(y1);fprintf(print_FD_vdmlib,stup);MERGE(print,_ELEM2)(y2);fprintf(print_FD_vdmlib,"\n");
#define ty2 ELEM2
#endif

#define fct print
#define tl1 char *
#define inil1 start
#define incr fprintf(print_FD_vdmlib,l1); printelem l1 = step;
#define forloop if (MERGE(is_empty,_DOMAIN)(x1)) fprintf(print_FD_vdmlib,start); else MERGE(forall,_DOMAIN)
#define resfin fprintf(print_FD_vdmlib,stop);
#include <aux/com/for/ccod>

#undef printelem

_ENDIF

#undef start
#undef step
#undef stop
#undef stup
-----
cat >$OUT_DIR/aux/com/print/docu <<'-----'
  printing of a structured value with forall

  parameters:
   start : starting sequence
   step  : delimiter between elements
   stop  : finishing sequence
   stup  : delimiter between pairs
-----
[ -d $OUT_DIR/aux/com/sort ] || mkdir $OUT_DIR/aux/com/sort
cat >$OUT_DIR/aux/com/sort/ccod <<'-----'
#include <aux/com/sort/defs>

#ifdef COPY
#define Y1 MERGE(copy,_ELEM1)(y1)
#else
#define Y1 y1
#endif

#define fct sort
#define result RESULT
#define inires MERGE(mk_empty,_RESULT)()

#ifdef SORTEDSET
#define incr r1 = MERGE(appr,_RESULT)(r1,Y1);
#else
#ifdef LINEARINSERT
#define tl1 Nat0
#define inil1 0
#define incr \
 { \
   Nat1 i = 1; \
   while ( i <= l1 && MERGE(is_gr,_ELEM1)(y1,MERGE(sel,_RESULT)(r1,i)) ) i++; \
   r1 = MERGE(insert,_RESULT)(r1,i,Y1); \
   l1++; \
 }
#else
#error BINARYINSERT not yet implemented
#endif
#endif

#include <aux/com/for/ccod>

#undef Y1

#undef SORTEDSET
#undef LINEARINSERT
#undef BINARYINSERT

-----
cat >$OUT_DIR/aux/com/sort/defs <<'-----'
#ifndef GEN_DOCU
#ifndef RESULT
#error DOMAIN: Parameter 'RESULT' must be defined for operation 'sort'!
#endif
#endif

#if ! defined(SORTEDSET) && ! defined(LINEARINSERT) && ! defined(BINARYINSERT)
#define LINEARINSERT
#endif

-----
cat >$OUT_DIR/aux/com/sort/docu <<'-----'
  General implementation of converting a COLL into
  a sorted list

  Parameters:

   'RESULT':
             Supplies the name of the resulting tuple domain.
             This parameter must be supplied.

#ifndef BASEIMPL
   'COPY':
             if this parameter is given, a complete copy
             of the elements is performed during the computation
             such that the result and the argument do not share
             any data (not neccesary for C++ automem)
#endif
             
#undef COLL
-----
cat >$OUT_DIR/aux/com/sort/param <<'-----'
RESULT
COPY
SORTEDSET
LINEARINSERT
BINARYINSERT
-----
cat >$OUT_DIR/aux/com/sort/vdm <<'-----'
#include <aux/com/sort/defs>

 DOMAINS
   DOMAIN -> RESULT
 IMPLEMENTATIONS
   DOMAIN = + forall
   RESULT = + mk_empty
   ELEM1  = + is_gr

#ifdef COPY
   ELEM1  = + copy
#endif

#ifdef SORTEDSET
   RESULT = + appr
#else
   RESULT = + insert + sel
#endif

#undef SORTEDSET
#undef LINEARINSERT
#undef BINARYINSERT
-----
[ -d $OUT_DIR/aux/com/switch ] || mkdir $OUT_DIR/aux/com/switch
cat >$OUT_DIR/aux/com/switch/ccod <<'-----'
#ifndef RESULT
#define RESULT void
#define xxproc PROCEDURE MERGE(FCTNAME,_DOMAIN) (x1 : DOMAIN xxppl)
#define gxxproc PROCDEC(MERGE(FCTNAME,_DOMAIN),P_OP PARAM(x1,DOMAIN) gxxpl P_CL)
#else
#define xxproc FUNCTION MERGE(FCTNAME,_DOMAIN) (x1 : DOMAIN xxppl) : RESULT
#define gxxproc FUNCDEC(MERGE(FCTNAME,_DOMAIN),P_OP PARAM(x1,DOMAIN) gxxpl P_CL,RESULT)
#endif

#ifndef XX
#define xxpl
#define Cpp_xxpl
#define xxl
#define xxpars
#define xxfpars
#define xxppl
#define gxxpl
#define Cpp_xxpl
#else
#ifndef XXX
#define xxpl ,x2
#define Cpp_xxpl x2
#define xxl ,_FP(x2,XX)
#define xxpars _EP(x2,XX)
#define xxfpars ,XX x2
#define xxppl  ;x2 : XX
#define gxxpl P_SEP PARAM(x2,XX)
#else
#ifndef XXXX
#define xxpl ,x2,x3
#define Cpp_xxpl x2,x3
#define xxl ,_FP(x2,XX),_FP(x3,XXX)
#define xxpars _EP(x2,XX) _EP(x3,XXX)
#define xxfpars ,XX x2 ,XXX x3
#define xxppl  ;x2 : XX; x3 : XXX
#define gxxpl P_SEP PARAM(x2,XX) P_SEP PARAM(x3,XXX)
#else
#define xxpl ,x2,x3,x4
#define Cpp_xxpl x2,x3,x4
#define xxl ,_FP(x2,XX),_FP(x3,XXX),_FP(x4,XXXX)
#define xxpars _EP(x2,XX) _EP(x3,XXX) _EP(x4,XXXX)
#define xxfpars ,XX x2, XXX x3, XXXX x4
#define xxppl  ;x2 : XX; x3 : XXX; x4 : XXXX
#define gxxpl P_SEP PARAM(x2,XX) P_SEP PARAM(x3,XXX) P_SEP PARAM(x4,XXXX)
#endif
#endif
#endif
-----
cat >$OUT_DIR/aux/com/switch/docu <<'-----'
  With the functionals sswitch and cswitch
  switch routines for union types can be generated
  the switch routines contain a switch statement that
  selects a routine for each variant of the union type

  parameters :
   "XX","XXX","XXXX"
                : optional parameters for the domain names 
                  of extra parameters passed through the switch
                  a maximum 3 extra parameters are supported
   "RESULT"     : the domain name of the result type of
                  the generated routine
                  if not specified a procedure
                  (a routine of result type void routine) is generated

   examples :

   DOMAINS
   Union    =  s_u1 : Nat0  | s_u2 : Id
   Env      =  ...

   IMPLEMENTATIONS
   Union    = .... + cswitch.eval("RESULT"="Intg",XX="Env")

   generates a switch function

   eval_union(x1,x2) =
    (is_u1(x1) -> eval_nat0(s_u1(x1),x2)
    ,is_u2(x1) -> eval_id  (s_u2(x1),x2)
    )
   TYPE :  Union  Env  -->  Intg

   it is assumed that eval_nat0 and eval_id
   are defined with appropriate types

   TYPE eval_nat0 :  Nat0 Env  -->  Intg
   TYPE eval_id   :  Id   Env  -->  Intg

   for the sswitch functional the various "eval_"-functions are
   identified via the selector name instead of the component type

   IMPLEMENTATIONS
   Union    = .... + sswitch.eval("RESULT"="Intg",XX="Env")

   generates a switch function

   eval_union(x1,x2) =
    (is_u1(x1) -> eval_u1(s_u1(x1),x2)
    ,is_u2(x1) -> eval_u2(s_u2(x1),x2)
    )
   TYPE :  Union  Env  -->  Intg

   it is assumed that eval_u1 and eval_u2
   are defined with appropriate types

   TYPE eval_u1 :  Nat0 Env  -->  Intg
   TYPE eval_u2 :  Id   Env  -->  Intg

   for C++ switch functions are automatically generated
   when a function signature for a union type is specified
   in the .vdm file

-----
cat >$OUT_DIR/aux/com/switch/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + discr + s
   Vdmlib   = + err_uuni
-----
cat >$OUT_DIR/aux/com/switch/vparam <<'-----'

#ifndef vparamsDEFINED
/* construct parameter list */

#ifdef RESULT
#define PARAM1 "RESULT"=RESULT
#else
#define PARAM1 "DUMMY"
#endif

#ifdef NOTCONST
#define PARAM1a PARAM1,"NOTCONST"
#else
#define PARAM1a PARAM1
#endif

#ifdef MANIPULATOR
#define PARAM1b PARAM1a,"MANIPULATOR"
#else
#define PARAM1b PARAM1a
#endif

#ifdef XX
#define PARAM2 PARAM1b,"XX"=XX
#else
#define PARAM2 PARAM1b
#endif

#ifdef XXX
#define PARAM3 PARAM2,"XXX"=XXX
#else
#define PARAM3 PARAM2
#endif

#ifdef XXXX
#define PARAM4 PARAM3,"XXXX"=XXXX
#else
#define PARAM4 PARAM3
#endif

#ifdef XXXXX
#define PARAM5 PARAM4,"XXXXX"=XXXXX
#else
#define PARAM5 PARAM4
#endif

#ifdef XXXXXX
#define PARAM6 PARAM5,"XXXXXX"=XXXXXX
#else
#define PARAM6 PARAM5
#endif

#ifdef XXXXXXX
#define PARAM7 PARAM6,"XXXXXXX"=XXXXXXX
#else
#define PARAM7 PARAM6
#endif

#ifdef XXXXXXXX
#define PARAM8 PARAM7,"XXXXXXXX"=XXXXXXXX
#else
#define PARAM8 PARAM7
#endif

#ifdef XXXXXXXXX
#define PARAM9 PARAM8,"XXXXXXXXX"=XXXXXXXXX
#else
#define PARAM9 PARAM8
#endif

#ifdef XXXXXXXXXX
#define PARAMr1 PARAM9,"XXXXXXXXXX"=XXXXXXXXXX
#else
#define PARAMr1 PARAM9
#endif

#ifdef RESULT2
#define PARAMr2 PARAMr1,"RESUT2"=RESUT2
#else
#define PARAMr2 PARAMr1
#endif

#ifdef RESULT3
#define PARAMr3 PARAMr2,"RESUT3"=RESUT3
#else
#define PARAMr3 PARAMr2
#endif

#ifdef RESULT4
#define PARAMr4 PARAMr3,"RESUT4"=RESUT4
#else
#define PARAMr4 PARAMr3
#endif

#ifdef RESULT5
#define PARAMr5 PARAMr4,"RESUT5"=RESUT5
#else
#define PARAMr5 PARAMr4
#endif

#define PARAMS PARAMr5
#define vparamsDEFINED

#else
/* undefine parameterlist macros */

#undef PARAM1
#undef PARAM1a
#undef PARAM1b
#undef PARAM2
#undef PARAM3
#undef PARAM4
#undef PARAM5
#undef PARAM6
#undef PARAM7
#undef PARAM8
#undef PARAM9
#undef PARAM10
#undef PARAMr1
#undef PARAMr2
#undef PARAMr3
#undef PARAMr4
#undef PARAMr5
#undef PARAMS
#undef vparamsDEFINED

#endif
-----
[ -d $OUT_DIR/aux/com/switche ] || mkdir $OUT_DIR/aux/com/switche
cat >$OUT_DIR/aux/com/switche/ccod <<'-----'
#undef xxpars
#undef xxfpars
#undef xxppl
#undef xxproc
#undef gxxproc
#undef xxl
#undef xxpl
#undef Cpp_xxpl
#undef gxxpl
#undef RESULT
-----
[ -d $OUT_DIR/aux/com/vheap ] || mkdir $OUT_DIR/aux/com/vheap
cat >$OUT_DIR/aux/com/vheap/vdm <<'-----'
#ifndef ALLOC
#define ALLOC vmalloc("INTERNALDOMAIN")
#endif

DOMAINS
   Heap##_DOMAIN  = ( DOMAIN ELEM1 ) -heap
   DOMAIN	  -> Heap##_DOMAIN

IMPLEMENTATIONS
   Heap##_DOMAIN  = ALLOC + valloc("STRUCT"="struct Struct" #_DOMAIN)
#undef ALLOC
-----
[ -d $OUT_DIR/aux/hashlist ] || mkdir $OUT_DIR/aux/hashlist
[ -d $OUT_DIR/aux/hashlist/basic ] || mkdir $OUT_DIR/aux/hashlist/basic
cat >$OUT_DIR/aux/hashlist/basic/gptr <<'-----'
_DEFINE DOMAIN Tupl##_DOMAIN
-----
cat >$OUT_DIR/aux/hashlist/basic/gtyp <<'-----'
/*   TYPE_DEF(DOMAIN,Tupl##_DOMAIN) */
-----
cat >$OUT_DIR/aux/hashlist/basic/setup <<'-----'
#ifndef LISTLOG
#define LISTLEN		(1 << 8)
#else
#define LISTLEN		(1 << LISTLOG)
#endif

#define _HIND(e)	((MERGE(hash,_ELEM1)(e) & (LISTLEN - 1)) + 1)
#define _HGET(t,e)	MERGE(sel_tupl,_DOMAIN)(t,_HIND(e))
-----
cat >$OUT_DIR/aux/hashlist/basic/vdm <<'-----'
#ifndef TUPLIMPL
#define TUPLIMPL array("INTERNALDOMAIN")
#endif

#ifndef ELEM2
#define AUXDOM ELEM1 -set
#else
#define AUXDOM ELEM1 -m-> ELEM2
#endif

DOMAINS
  Tupl##_DOMAIN	= Aux##_DOMAIN*
  Aux##_DOMAIN	= AUXDOM

  DOMAIN       -> Tupl##_DOMAIN

IMPLEMENTATIONS
  Tupl##_DOMAIN  = TUPLIMPL
                 + sel + ovwrt1
#ifdef SETIMPL
  Aux##_DOMAIN   = SETIMPL
#else
#ifdef MAPIMPL
  Aux##_DOMAIN   = MAPIMPL
#else
! if changing default implementation, check if 'mk_empty' still can  !
! use 'mkn' instead of 'mknc' since an empty linked list does not    !
! have to be copied						     !
! do not change linklist(...) into a macro !

  Aux##_DOMAIN   = linklist("SAVE"=0
                           ,"INTERNALDOMAIN"
                           ,"ALLOC"="freelist(\"SAVE\"=0,\"MAXLEN\"=20)")
#endif
#endif

  ELEM1		=		+ hash


#undef TUPLIMPL
#undef AUXDOM
-----
[ -d $OUT_DIR/aux/hashlist/combine ] || mkdir $OUT_DIR/aux/hashlist/combine
cat >$OUT_DIR/aux/hashlist/combine/ccod <<'-----'
#ifndef OPER
#define OPER ovwrt1
#endif

#include <aux/hashlist/basic/setup>

  DOMAIN OPER##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
    { Nat0	lx1 = _HIND(x2);
      Aux##_DOMAIN lx2 = sel_tupl##_DOMAIN(x1,lx1);

      return ovwrt1_tupl##_DOMAIN(x1,lx1,OPER##_aux##_DOMAIN(lx2,x2,x3));
    }

#undef OPER
#undef LISTLEN
#undef _HGET
#undef _HIND
-----
cat >$OUT_DIR/aux/hashlist/combine/vdm <<'-----'
#ifndef OPER
#define OPER ovwrt1
#endif
_ADD_OP(Aux##_DOMAIN,OPER)

#undef OPER
-----
[ -d $OUT_DIR/aux/hashlist/combine1 ] || mkdir $OUT_DIR/aux/hashlist/combine1
cat >$OUT_DIR/aux/hashlist/combine1/ccod <<'-----'
#ifndef OPER
#define OPER sub1
#endif

#include <aux/hashlist/basic/setup>

  DOMAIN OPER##_DOMAIN _FPH2(DOMAIN,ELEM1)
    { Nat0	lx1 = _HIND(x2);
      Aux##_DOMAIN lx2 = sel_tupl##_DOMAIN(x1,lx1);

      return ovwrt1_tupl##_DOMAIN(x1,lx1,OPER##_aux##_DOMAIN(lx2,x2));
    }

#undef OPER
#undef LISTLEN
#undef _HGET
#undef _HIND
-----
cat >$OUT_DIR/aux/hashlist/combine1/vdm <<'-----'
#ifndef OPER
#define OPER sub1
#endif
_ADD_OP(Aux##_DOMAIN,OPER)

#undef OPER
-----
[ -d $OUT_DIR/aux/hashlist/forall ] || mkdir $OUT_DIR/aux/hashlist/forall
cat >$OUT_DIR/aux/hashlist/forall/ccod <<'-----'
static T2_forall##_DOMAIN TMP_forall##_DOMAIN;

static void p1_forall##_DOMAIN _FPH1(Aux##_DOMAIN)
  { forall_aux##_DOMAIN(x1,TMP_forall##_DOMAIN); }

void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
  { T2_forall##_DOMAIN lx1 = TMP_forall##_DOMAIN;
    TMP_forall##_DOMAIN = x2;
    forall_tupl##_DOMAIN(x1,p1_forall##_DOMAIN);
    TMP_forall##_DOMAIN = lx1;
  }

-----
cat >$OUT_DIR/aux/hashlist/forall/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Aux##_DOMAIN		= + forall
    Tupl##_DOMAIN	= + forall
-----
[ -d $OUT_DIR/aux/hashlist/iterator ] || mkdir $OUT_DIR/aux/hashlist/iterator
cat >$OUT_DIR/aux/hashlist/iterator/vdm <<'-----'

#define PARAM "INTERNALFCT"
#define IMPL hashlist
#include <aux/com/iterator/vdm>

DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN = + iterator("INTERNALFCT")
  Aux##_DOMAIN  = + iterator("INTERNALFCT")
-----
[ -d $OUT_DIR/aux/hashlist/mk_empty ] || mkdir $OUT_DIR/aux/hashlist/mk_empty
cat >$OUT_DIR/aux/hashlist/mk_empty/ccod <<'-----'
#include <aux/hashlist/basic/setup>
  DOMAIN mk_empty##_DOMAIN _FPH0()
#ifdef SIMPLE_AUX
    { return mkn_tupl##_DOMAIN(mk_empty_aux##_DOMAIN(),LISTLEN); }
#else
    { Aux##_DOMAIN	lx1 = mk_empty_aux##_DOMAIN();
      DOMAIN		lx2 = mknc_tupl##_DOMAIN(lx1,LISTLEN);
      del_aux##_DOMAIN(lx1);
      return lx2;
    }
#endif

#undef SIMPLE_AUX
-----
cat >$OUT_DIR/aux/hashlist/mk_empty/vdm <<'-----'
#ifdef SIMPLE_AUX
_ADD_OP(Tupl##_DOMAIN,mkn)
#else
_ADD_OP(Tupl##_DOMAIN,mknc)
#endif

_ADD_OP(Aux##_DOMAIN,mk_empty)

#undef SIMPLE_AUX
-----
[ -d $OUT_DIR/aux/heap ] || mkdir $OUT_DIR/aux/heap
[ -d $OUT_DIR/aux/heap/sub1 ] || mkdir $OUT_DIR/aux/heap/sub1
cat >$OUT_DIR/aux/heap/sub1/ccod <<'-----'
#ifndef fct
#define fct sub1
#endif

#ifndef delelem
#define delelem
#endif

  DOMAIN fct##_DOMAIN _FPH2(DOMAIN,ELEM1)
   {delelem
    free##_ELEM1(x2);
    return 0;
   }

#undef fct
#undef delelem
-----
[ -d $OUT_DIR/aux/heap/undef ] || mkdir $OUT_DIR/aux/heap/undef
cat >$OUT_DIR/aux/heap/undef/ccod <<'-----'
#ifndef RES
#define RES DOMAIN
#endif
#ifndef X1
#define X1 DOMAIN
#endif

  RES FCT##_DOMAIN(_FP(x1,X1)
#ifdef X2
                  ,_FP(x2,X2)
#endif
#ifdef X3
                  ,_FP(x3,X3)
#endif
                  )
      _EP(x1,X1)
#ifdef X2
      _EP(x2,X2)
#endif      
#ifdef X3
      _EP(x3,X3)
#endif
   {err_uop_vdmlib(MKSTRING(FCT),MKSTRING(DOMAIN));}

#undef RES
#undef FCT
#undef X1
#undef X2
#undef X3
-----
cat >$OUT_DIR/aux/heap/undef/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib = + err_uop
-----
[ -d $OUT_DIR/aux/heapmap ] || mkdir $OUT_DIR/aux/heapmap
[ -d $OUT_DIR/aux/heapmap/basic ] || mkdir $OUT_DIR/aux/heapmap/basic
cat >$OUT_DIR/aux/heapmap/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  H1##_DOMAIN  = + fct
#undef fct
-----
[ -d $OUT_DIR/aux/heapmap/ovwrt1 ] || mkdir $OUT_DIR/aux/heapmap/ovwrt1
cat >$OUT_DIR/aux/heapmap/ovwrt1/ccod <<'-----'
#ifndef fct
#define fct ovwrt1
#endif
#ifndef delelem
#define delelem
#endif

   DOMAIN fct##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
      {x1 = union1_##h1##_DOMAIN(x1,x2);
       delelem
       store##_ELEM1(x2,x3);
       return x1;
      } 

#undef fct
#undef delelem
-----
[ -d $OUT_DIR/aux/heapmap/sub1 ] || mkdir $OUT_DIR/aux/heapmap/sub1
cat >$OUT_DIR/aux/heapmap/sub1/ccod <<'-----'
#ifndef fct
#define fct sub1
#endif

#ifndef delelem
#define delelem
#endif

  DOMAIN fct##_DOMAIN _FPH2(DOMAIN,ELEM1)
   {x1 = sub1_##h1##_DOMAIN(x1,x2);
    delelem
    free##_ELEM1(x2);
    return x1;
   }

#undef fct
#undef delelem
-----
[ -d $OUT_DIR/aux/linklist ] || mkdir $OUT_DIR/aux/linklist
[ -d $OUT_DIR/aux/linklist/basic ] || mkdir $OUT_DIR/aux/linklist/basic
cat >$OUT_DIR/aux/linklist/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/aux/linklist/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/aux/linklist/basic/gtyp <<'-----'

#define attr1 RECFIELD(f_info,ELEM1);

#ifndef ELEM2
#define attr2
#else
#define attr2 RECFIELD(f_attr,ELEM2);
#endif

  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_next,DOMAIN);
                      attr1
                      attr2
  END_RECORD_TYP(Struct##_DOMAIN) 

#undef attr1
#undef attr2
#undef info
-----
[ -d $OUT_DIR/aux/linklist/conc ] || mkdir $OUT_DIR/aux/linklist/conc
cat >$OUT_DIR/aux/linklist/conc/ccod <<'-----'
#ifndef fct
#define fct conc
#endif

  DOMAIN fct##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {DOMAIN * px1 = & x1;
    while (*px1)
     { DOMAIN lx1 = ref##_DOMAIN(*px1);
       px1 = &(lx1->f_next);
     }
    *px1 = x2;
    return x1;
   }

#undef fct
-----
[ -d $OUT_DIR/aux/linklist/copy ] || mkdir $OUT_DIR/aux/linklist/copy
cat >$OUT_DIR/aux/linklist/copy/ccod <<'-----'
#define fct copy
#ifndef ELEM2
#define copyelem (*px2)->f_info = MERGE(copy,_ELEM1)((*px2)->f_info);
#else
#define copyelem (*px2)->f_info = MERGE(copy,_ELEM1)((*px2)->f_info); (*px2)->f_attr = MERGE(copy,_ELEM2)((*px2)->f_attr);
#endif

#include <aux/linklist/copy1/ccod>
-----
cat >$OUT_DIR/aux/linklist/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + copy
#ifdef ELEM2
   ELEM2  = + copy
#endif
-----
[ -d $OUT_DIR/aux/linklist/copy1 ] || mkdir $OUT_DIR/aux/linklist/copy1
cat >$OUT_DIR/aux/linklist/copy1/ccod <<'-----'
#ifndef fct
#define fct copy1
#endif

#ifndef copyelem
#define copyelem
#endif

  DOMAIN fct##_DOMAIN _FPH1(DOMAIN)
   {DOMAIN x2 = (DOMAIN)0;
    register DOMAIN * px2 = & x2;
    while (x1)
    {*px2 = alloc##_DOMAIN();
     *(*px2) = *(ref##_DOMAIN(x1));
     copyelem
     px2 = &((*px2)->f_next);
     x1=x1->f_next;
    }
    return x2;
   }

#undef fct
#undef copyelem
-----
[ -d $OUT_DIR/aux/linklist/del1 ] || mkdir $OUT_DIR/aux/linklist/del1
cat >$OUT_DIR/aux/linklist/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN)
   {while (x1)
    {DOMAIN lx1=x1;
     x1=ref##_DOMAIN(x1)->f_next;
     free##_DOMAIN(lx1);
    }
   }
-----
cat >$OUT_DIR/aux/linklist/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) {DOMAIN _y1=x1;while (_y1!=(DOMAIN)0) {DOMAIN _x1=_y1;_y1=ref##_DOMAIN(_y1)->f_next;free##_DOMAIN(_x1);}}
-----
[ -d $OUT_DIR/aux/linklist/fold ] || mkdir $OUT_DIR/aux/linklist/fold
cat >$OUT_DIR/aux/linklist/fold/ccod <<'-----'
#define CV Pvcvfct
#include <aux/com/folda/ccod>
#include <aux/com/folda/gtyp>

#ifdef ELEM2
#define params MERGE(ref,_DOMAIN)(x1)->f_info,x1->f_attr
#else
#define params MERGE(ref,_DOMAIN)(x1)->f_info
#endif
#ifdef ABORTVAL
#define _abort && !MERGE(is_eq,_RESULT)(ABORTVAL,lx1)
#else
#define _abort
#endif

  RESULT FCTNAME##_DOMAIN(_FP(x1,DOMAIN) Pnull Pcvfct PX PY PZ)
      _EP(x1,DOMAIN) tPnull tPcvfct tPX tPY tPZ
   { vii   /* index counter for foldix, corresponds to iipp below */
     RESULT lx1;
     lx1 = _NULL;
     for(;x1 _abort; x1=ref##_DOMAIN(x1)->f_next)
        {lx1 = FOLDFCT##_RESULT(lx1,cvfct__(params iipp lPX lPY) lPY lPZ);}
     return lx1;
   }

#undef _abort
#undef params
#include <aux/com/folde/ccod>
-----
cat >$OUT_DIR/aux/linklist/fold/vdm <<'-----'
#include <aux/com/folda/ccod>
DOMAINS
   DOMAIN   -> RESULT
   DOMAIN   -> CVFCTRES
IMPLEMENTATIONS
#ifdef ABORTVAL
  RESULT = + is_eq
#endif
#include <aux/com/folde/ccod>
-----
[ -d $OUT_DIR/aux/linklist/forall ] || mkdir $OUT_DIR/aux/linklist/forall
cat >$OUT_DIR/aux/linklist/forall/ccod <<'-----'

#ifdef ELEM2
#define params MERGE(ref,_DOMAIN)(x1)->f_info,x1->f_attr
#else
#define params MERGE(ref,_DOMAIN)(x1)->f_info
#endif

  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
   {for(;x1; x1=ref##_DOMAIN(x1)->f_next)(*x2)(params);}

#undef params
-----
cat >$OUT_DIR/aux/linklist/forall/cmcr <<'-----'
#ifdef ELEM2
#define params MERGE(ref,_DOMAIN)(_x1)->f_info,_x1->f_attr
#else
#define params MERGE(ref,_DOMAIN)(_x1)->f_info
#endif

_DEFINE forall##_DOMAIN(x1,x2){DOMAIN _x1=x1;for(;_x1!=(DOMAIN)0;_x1=_x1->f_next) x2(params);}
#undef params
-----
[ -d $OUT_DIR/aux/linklist/is_empty ] || mkdir $OUT_DIR/aux/linklist/is_empty
cat >$OUT_DIR/aux/linklist/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) {return (! x1);}
-----
cat >$OUT_DIR/aux/linklist/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (! (x1))
-----
cat >$OUT_DIR/aux/linklist/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((x1) = NIL)
-----
[ -d $OUT_DIR/aux/linklist/is_in ] || mkdir $OUT_DIR/aux/linklist/is_in
cat >$OUT_DIR/aux/linklist/is_in/ccod <<'-----'

#ifndef fct
#define fct is_in
#endif

#ifndef params
#define params _FP(x1,ELEM1), _FP(x2,DOMAIN)
#endif

#ifndef xx
#define xx x2
#endif

#ifndef paramdec
#define paramdec _EP(x1,ELEM1) _EP(x2,DOMAIN)
#endif

#ifndef search
#define search if MERGE(is_eq,_ELEM1)(MERGE(ref,_DOMAIN)(x2)->f_info,x1) return 1;
#endif

  Bool fct##_DOMAIN(params)
      paramdec
  {while (xx)
   {search
    xx = xx->f_next;
   } 
   return 0;
  } 

#undef params
#undef paramdec
#undef search
#undef fct
#undef xx
-----
[ -d $OUT_DIR/aux/linklist/len ] || mkdir $OUT_DIR/aux/linklist/len
cat >$OUT_DIR/aux/linklist/len/ccod <<'-----'
#ifndef fct
#define fct len
#endif

  Nat0 fct##_DOMAIN _FPH1(DOMAIN)
   {Nat0 lx1 = 0;
    while (x1) {lx1++; x1=ref##_DOMAIN(x1)->f_next;}
    return lx1;
   }
#undef fct
-----
cat >$OUT_DIR/aux/linklist/len/docu <<'-----'
  counting of elements in a structured value

  parameters :
   fct   function name (len, card, ...)
-----
[ -d $OUT_DIR/aux/linklist/mk1 ] || mkdir $OUT_DIR/aux/linklist/mk1
cat >$OUT_DIR/aux/linklist/mk1/ccod <<'-----'

#ifndef ELEM2
#define params _FP(x1,ELEM1)
#define paramdec _EP(x1,ELEM1)
#define assign lx1->f_info = x1;
#else
#define params _FP(x1,ELEM1), _FP(x2,ELEM2)
#define paramdec _EP(x1,ELEM1) _EP(x2,ELEM2)
#define assign lx1->f_info = x1; lx1->f_attr = x2;
#endif

  DOMAIN mk1##_DOMAIN(params)
      paramdec
  {DOMAIN lx1 = alloc##_DOMAIN();
   lx1->f_next = (DOMAIN)0;
   assign
   return lx1;
  } 

#undef params
#undef paramdec
#undef assign
-----
[ -d $OUT_DIR/aux/linklist/mk_empty ] || mkdir $OUT_DIR/aux/linklist/mk_empty
cat >$OUT_DIR/aux/linklist/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() {return (DOMAIN)0;}
-----
cat >$OUT_DIR/aux/linklist/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() ((DOMAIN)0)
-----
[ -d $OUT_DIR/aux/linklist/sub1 ] || mkdir $OUT_DIR/aux/linklist/sub1
cat >$OUT_DIR/aux/linklist/sub1/ccod <<'-----'

#ifndef fct
#define fct sub1
#endif

#ifndef params
#define params _FP(x1,DOMAIN), _FP(x2,ELEM1)
#endif

#ifndef paramdec
#define paramdec _EP(x1,DOMAIN) _EP(x2,ELEM1)
#endif

#ifndef delelem
#define delelem
#endif

#ifndef found
#define found MERGE(is_eq,_ELEM1)((MERGE(ref,_DOMAIN)(*lx1))->f_info,x2)
#endif

  DOMAIN fct##_DOMAIN(params)
      paramdec
   {register DOMAIN * lx1 = &x1;
    while (*lx1)
     {if (found)
      {DOMAIN lx2 = *lx1;
       *lx1 = lx2->f_next;
       delelem
       free##_DOMAIN(lx2);
       break;
      }
      lx1 = &((*lx1)->f_next);
     }
    return x1;
   }

#undef fct
#undef found
#undef delelem
#undef params
#undef paramdec
-----
[ -d $OUT_DIR/aux/linklist/union1 ] || mkdir $OUT_DIR/aux/linklist/union1
cat >$OUT_DIR/aux/linklist/union1/ccod <<'-----'

#ifndef fct
#define fct union1
#endif

#ifndef params
#define params _FP(x1,DOMAIN), _FP(x2,ELEM1)
#endif

#ifndef paramdec
#define paramdec _EP(x1,DOMAIN) _EP(x2,ELEM1)
#endif

#ifndef retst
#define retst return x1;
#endif

#ifndef found
#define found if (MERGE(is_eq,_ELEM1)(MERGE(ref,_DOMAIN)(lx1)->f_info,x2)) retst
#endif

#ifndef notfound
#define notfound lx1 = MERGE(mk1,_DOMAIN)(x2);
#endif

  DOMAIN fct##_DOMAIN(params)
      paramdec
   {register DOMAIN lx1 = x1;
    while (lx1)
     {found
      lx1 = lx1->f_next;
     }
    notfound
    lx1->f_next = x1;
    return lx1;
   }

#undef fct
#undef found
#undef notfound
#undef retst
#undef params
#undef paramdec
-----
[ -d $OUT_DIR/aux/scanfile ] || mkdir $OUT_DIR/aux/scanfile
[ -d $OUT_DIR/aux/scanfile/basic ] || mkdir $OUT_DIR/aux/scanfile/basic
cat >$OUT_DIR/aux/scanfile/basic/docu <<'-----'
  'scanfile' is a special implementation used to iterate
  through the serialized form of a structured value
  (usually within a file) generated using the
  'cvtotupl' operation. It is a 'read-only' implementation
  supplying mainly the following operations:

    - cvfromtupl
    - forall
    - card (or len)
    - all operations based on 'forall' (like 'fold', 'forrange',...)
    - del1

  but no further operations, especially no constructor
  operations. The intended use is to optimize the following
  sequence

    Tupldom t = fread_tupledom(<file>);
    DOMAIN d = cvfromtupl_domain(t);

    forall_domain(d,<elemfct>);
    /* or call of a fold function at this place */

    del1_domain(d);

  The optimization is done by not reading and constructing
  the whole structure but reading each map element if it
  is needed during iteration. <elemfct> has to take care
  that elements will be deleted if they are not needed
  any longer.
  
  If the domain value is intended to be
  iterated a second time it has to be read from file
  again (This is because 'forall' destroys the tuple
  during conversion like 'cvfromtupl' usually will
  do also). An error like 'Taking hd of an empty tuple'
  will occur if 'forall' is used without reading the
  tuple again.

  Only 'del1' is available because the elements cannot be
  accessed after iteration has happened.

  Parameters:

  'MACROS' :
               Generate macros if possible

  'TUPLEDOMAIN' :
               Name of the tupledomain.
               For 'scanfile' this parameter must be supplied
               as implementation parameter instead of
               supplying it for 'cvfromtupl' only.
               Default value is 'Str'.

-----
cat >$OUT_DIR/aux/scanfile/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/aux/scanfile/basic/gtyp <<'-----'
#include <aux/scanfile/basic/defp>

#ifdef GEN_C
  typedef struct 
     { Nat0       f_len;
       TUPLDOMAIN f_tpl;
     } DOMAIN;
#else
  !!!! error: define for other languages than C
#endif
-----
cat >$OUT_DIR/aux/scanfile/basic/param <<'-----'
INTERNALDOMAIN
MACROS
TUPLDOMAIN
-----
[ -d $OUT_DIR/aux/scanfile/cvfromtupl ] || mkdir $OUT_DIR/aux/scanfile/cvfromtupl
cat >$OUT_DIR/aux/scanfile/cvfromtupl/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtupl##_DOMAIN _FPH1(TUPLDOMAIN)
   {DOMAIN lx1;
    
    lx1.f_len = cvfromtup1_nat0(&x1);
    lx1.f_tpl = x1;

    return lx1;
   }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/aux/scanfile/cvfromtupl/docu <<'-----'
#include <aux/scanfile/cvfromtupl/docu>
-----
cat >$OUT_DIR/aux/scanfile/cvfromtupl/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Nat0 = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/aux/scanfile/del1 ] || mkdir $OUT_DIR/aux/scanfile/del1
cat >$OUT_DIR/aux/scanfile/del1/ccod <<'-----'

  _FDEC1(del1,void,DOMAIN,)
-----
cat >$OUT_DIR/aux/scanfile/del1/param <<'-----'
MACROS
-----
[ -d $OUT_DIR/aux/scanfile/fold ] || mkdir $OUT_DIR/aux/scanfile/fold
cat >$OUT_DIR/aux/scanfile/fold/ccod <<'-----'
#include <aux/scanfile/basic/defp>
#define CV Pvcvfct
#include <aux/com/folda/ccod>
#include <aux/com/folda/gtyp>

#ifdef ELEM2
#define params lx2, lx3
#define Lvars  ELEM1 lx2 = MERGE(cvfromtup1,_ELEM1)(&x1.f_tpl); ELEM2 lx3 = MERGE(cvfromtup1,_ELEM2)(&x1.f_tpl);
#else
#define params lx2
#define Lvars  ELEM1 lx2 = cvfromtup1##_ELEM1(&x1.ftpl);
#endif
#ifdef ABORTVAL
#define _abort && !MERGE(is_eq,_RESULT)(ABORTVAL,lx1)
#else
#define _abort
#endif

  RESULT FCTNAME##_DOMAIN(_FP(x1,DOMAIN) Pnull Pcvfct PX PY PZ)
      _EP(x1,DOMAIN) tPnull tPcvfct tPX tPY tPZ
   { vii   /* index counter for foldix, corresponds to iipp below */
     RESULT lx1;
     lx1 = _NULL;
     for(;x1.f_len _abort; x1.f_len--)
        {Lvars lx1 = FOLDFCT##_RESULT(lx1,cvfct__(params iipp lPX lPY) lPY lPZ);}
     return lx1;
   }

#undef _abort
#undef params
#undef Lvars
#include <aux/com/folde/ccod>
-----
cat >$OUT_DIR/aux/scanfile/fold/vdm <<'-----'
#include <aux/scanfile/forall/vdm>
#include <aux/com/folda/ccod>
DOMAINS
   DOMAIN   -> RESULT
   DOMAIN   -> CVFCTRES
IMPLEMENTATIONS
#ifdef ABORTVAL
  RESULT = + is_eq
#endif
#include <aux/com/folde/ccod>
-----
[ -d $OUT_DIR/aux/scanfile/forall ] || mkdir $OUT_DIR/aux/scanfile/forall
cat >$OUT_DIR/aux/scanfile/forall/ccod <<'-----'
#include <aux/scanfile/basic/defp>

#ifdef ELEM2
#define params , lx2
#define tmpvar ELEM2 lx2 = MERGE(cvfromtup1,_ELEM2)(&x1.f_tpl);
#else
#define params
#define tmpvar
#endif

  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
   { for(;x1.f_len; x1.f_len--)
      { ELEM1 lx1 = cvfromtup1##_ELEM1(&x1.f_tpl); tmpvar (*x2)(lx1 params);}
   }

#undef tmpvar
#undef params
-----
cat >$OUT_DIR/aux/scanfile/forall/cmcr <<'-----'
#include <aux/scanfile/basic/defp>

#ifdef ELEM2
#define params , lx2
#define tmpvar ELEM2 lx2 = MERGE(cvfromtup1,_ELEM2)(&x1.f_tpl);
#else
#define params
#define tmpvar
#endif

_DEFINE forall##_DOMAIN(x1,x2) { for(;x1.f_len; x1.f_len--) { ELEM1 lx1 = cvfromtup1##_ELEM1(&x1.f_tpl); tmpvar (*x2)(lx1 params);} }

#undef tmpvar
#undef params

-----
cat >$OUT_DIR/aux/scanfile/forall/param <<'-----'
MACROS
-----
cat >$OUT_DIR/aux/scanfile/forall/vdm <<'-----'
#include <aux/scanfile/basic/defp>
DOMAINS
IMPLEMENTATIONS
  ELEM1 = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#ifdef ELEM2
  ELEM2 = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#endif
-----
[ -d $OUT_DIR/aux/scanfile/len ] || mkdir $OUT_DIR/aux/scanfile/len
cat >$OUT_DIR/aux/scanfile/len/ccod <<'-----'
#ifndef fct
#define fct len
#endif

  _FDEC1(fct,Nat0,DOMAIN,_RET(_DCOMPSEL(x1,f_len)))

#undef fct
-----
cat >$OUT_DIR/aux/scanfile/len/cmcr <<'-----'
#include <aux/scanfile/len/ccod>
-----
cat >$OUT_DIR/aux/scanfile/len/param <<'-----'
MACROS
-----
[ -d $OUT_DIR/aux/sign ] || mkdir $OUT_DIR/aux/sign
[ -d $OUT_DIR/aux/sign/all ] || mkdir $OUT_DIR/aux/sign/all
cat >$OUT_DIR/aux/sign/all/vsig <<'-----'
#ifdef ELEM2
  all(x1,x2) = A [x :-> y] e x1: x2(x,y)
  TYPE: DOMAIN (ELEM1 ELEM2 --> Bool) --> Bool
#else
  all(x1,x2) = A x e x1: x2(x)
  TYPE: DOMAIN (ELEM1 --> Bool) --> Bool
#endif

  All quantifyer over DOMAIN. The predicate x2 is checked for every
  entry of the DOMAIN value x1.

  If you need special parameter combinations for x2 generate
  an own __EM(all) function using __SA(fold).

-----
[ -d $OUT_DIR/aux/sign/binary ] || mkdir $OUT_DIR/aux/sign/binary
cat >$OUT_DIR/aux/sign/binary/gsig <<'-----'
#include <aux/com/binary/defp>

#if ! NOSIGNATURE
  FUNCDEC(FCTNAME##_DOMAIN,PL_2(RESULT_,DOMAIN),RESULT_)
#endif
#undef RESULT_
#undef FOLDEXT
#undef _FOLDEXT
-----
[ -d $OUT_DIR/aux/sign/exist ] || mkdir $OUT_DIR/aux/sign/exist
cat >$OUT_DIR/aux/sign/exist/vsig <<'-----'
#ifdef ELEM2
  exist(x1,x2) = E [x :-> y] e x1: x2(x,y)
  TYPE: DOMAIN (ELEM1 ELEM2 --> Bool) --> Bool
#else
  exist(x1,x2) = E x e x1: x2(x)
  TYPE: DOMAIN (ELEM1 --> Bool) --> Bool
#endif
Existential quantifyer over DOMAIN. Check if there exists at least
one entry within x1 fulfilling the predicate x2.

If you need special parameter combinations for x2, generate
an own __EM(exist) function using _SA(fold).
-----
[ -d $OUT_DIR/aux/sign/exist1 ] || mkdir $OUT_DIR/aux/sign/exist1
cat >$OUT_DIR/aux/sign/exist1/gsig <<'-----'
#ifdef GEN_C
  extern Bool exist1##_DOMAIN P_OP DOMAIN,T2_ex1##_DOMAIN P_CL;
#endif
-----
cat >$OUT_DIR/aux/sign/exist1/vsig <<'-----'
#ifdef ELEM2
  exist1(x1,x2) = E! [x :-> y] e x1: x2(x,y)
  TYPE: DOMAIN (ELEM1 ELEM2 --> Bool) --> Bool
#else
  exist1(x1,x2) = E! x e x1: x2(x)
  TYPE: DOMAIN (ELEM1 --> Bool) --> Bool
#endif

  Existential quantifyer over DOMAIN. Check if there exists exactly
  one entry within x1 fulfilling the predicate x2.

  If you need special parameter combinations for x2 generate
  an own __EM(exist) function using __SA(fold).

-----
[ -d $OUT_DIR/aux/sign/fold ] || mkdir $OUT_DIR/aux/sign/fold
cat >$OUT_DIR/aux/sign/fold/gsig <<'-----'
#include <aux/com/folda/ccod>
#if defined(GEN_C) && defined(CVFCTVAR)
  /* works for C only */
  typedef CVFCTRES (*tcv) P_OP pyy pPX pPY P_CL;
#endif
#if ! NOSIGNATURE
  FUNCDEC(FCTNAME##_DOMAIN,P_OP PARAM(x1,DOMAIN) gppPnull gppPcvfct gppPX gppPY gppPZ P_CL,RESULT)
#endif
#include <aux/com/folde/ccod>
-----
[ -d $OUT_DIR/aux/sign/iterator ] || mkdir $OUT_DIR/aux/sign/iterator
cat >$OUT_DIR/aux/sign/iterator/docu <<'-----'
#ifdef GEN_DOCU
  see iterator class definition above
#endif
-----
[ -d $OUT_DIR/aux/sign/macro1 ] || mkdir $OUT_DIR/aux/sign/macro1
cat >$OUT_DIR/aux/sign/macro1/cpp <<'-----'
#ifndef MACRO0
#define MACRO0
#endif

#ifdef Cpp_COMP1
MACRO1(Cpp_COMP1,_COMP1,Cpp_SEL1,_SEL1)
#endif
#ifdef Cpp_COMP2
MACRO0
MACRO1(Cpp_COMP2,_COMP2,Cpp_SEL2,_SEL2)
#endif
#ifdef Cpp_COMP3
MACRO0
MACRO1(Cpp_COMP3,_COMP3,Cpp_SEL3,_SEL3)
#endif
#ifdef Cpp_COMP4
MACRO0
MACRO1(Cpp_COMP4,_COMP4,Cpp_SEL4,_SEL4)
#endif
#ifdef Cpp_COMP5
MACRO0
MACRO1(Cpp_COMP5,_COMP5,Cpp_SEL5,_SEL5)
#endif
#ifdef Cpp_COMP6
MACRO0
MACRO1(Cpp_COMP6,_COMP6,Cpp_SEL6,_SEL6)
#endif
#ifdef Cpp_COMP7
MACRO0
MACRO1(Cpp_COMP7,_COMP7,Cpp_SEL7,_SEL7)
#endif
#ifdef Cpp_COMP8
MACRO0
MACRO1(Cpp_COMP8,_COMP8,Cpp_SEL8,_SEL8)
#endif
#ifdef Cpp_COMP9
MACRO0
MACRO1(Cpp_COMP9,_COMP9,Cpp_SEL9,_SEL9)
#endif

#ifdef Cpp_COMP10
#include <aux/sign/macro2/cpp>
#endif

#undef MACRO0
#undef MACRO1
-----
[ -d $OUT_DIR/aux/sign/macro2 ] || mkdir $OUT_DIR/aux/sign/macro2
cat >$OUT_DIR/aux/sign/macro2/cpp <<'-----'
#ifdef Cpp_COMP10
MACRO0
MACRO1(Cpp_COMP10,_COMP10,Cpp_SEL10,_SEL10)
#endif
#ifdef Cpp_COMP11
MACRO0
MACRO1(Cpp_COMP11,_COMP11,Cpp_SEL11,_SEL11)
#endif
#ifdef Cpp_COMP12
MACRO0
MACRO1(Cpp_COMP12,_COMP12,Cpp_SEL12,_SEL12)
#endif
#ifdef Cpp_COMP13
MACRO0
MACRO1(Cpp_COMP13,_COMP13,Cpp_SEL13,_SEL13)
#endif
#ifdef Cpp_COMP14
MACRO0
MACRO1(Cpp_COMP14,_COMP14,Cpp_SEL14,_SEL14)
#endif
#ifdef Cpp_COMP15
MACRO0
MACRO1(Cpp_COMP15,_COMP15,Cpp_SEL15,_SEL15)
#endif
#ifdef Cpp_COMP16
MACRO0
MACRO1(Cpp_COMP16,_COMP16,Cpp_SEL16,_SEL16)
#endif
#ifdef Cpp_COMP17
MACRO0
MACRO1(Cpp_COMP17,_COMP17,Cpp_SEL17,_SEL17)
#endif
#ifdef Cpp_COMP18
MACRO0
MACRO1(Cpp_COMP18,_COMP18,Cpp_SEL18,_SEL18)
#endif
#ifdef Cpp_COMP19
MACRO0
MACRO1(Cpp_COMP19,_COMP19,Cpp_SEL19,_SEL19)
#endif

#ifdef Cpp_COMP20
MACRO0
MACRO1(Cpp_COMP20,_COMP20,Cpp_SEL20,_SEL20)
#endif
#ifdef Cpp_COMP21
MACRO0
MACRO1(Cpp_COMP21,_COMP21,Cpp_SEL21,_SEL21)
#endif
#ifdef Cpp_COMP22
MACRO0
MACRO1(Cpp_COMP22,_COMP22,Cpp_SEL22,_SEL22)
#endif
#ifdef Cpp_COMP23
MACRO0
MACRO1(Cpp_COMP23,_COMP23,Cpp_SEL23,_SEL23)
#endif
#ifdef Cpp_COMP24
MACRO0
MACRO1(Cpp_COMP24,_COMP24,Cpp_SEL24,_SEL24)
#endif
#ifdef Cpp_COMP25
MACRO0
MACRO1(Cpp_COMP25,_COMP25,Cpp_SEL25,_SEL25)
#endif
#ifdef Cpp_COMP26
MACRO0
MACRO1(Cpp_COMP26,_COMP26,Cpp_SEL26,_SEL26)
#endif
#ifdef Cpp_COMP27
MACRO0
MACRO1(Cpp_COMP27,_COMP27,Cpp_SEL27,_SEL27)
#endif
#ifdef Cpp_COMP28
MACRO0
MACRO1(Cpp_COMP28,_COMP28,Cpp_SEL28,_SEL28)
#endif
#ifdef Cpp_COMP29
MACRO0
MACRO1(Cpp_COMP29,_COMP29,Cpp_SEL29,_SEL29)
#endif

#ifdef Cpp_COMP30
#include <aux/sign/macro3/cpp>
#endif

-----
[ -d $OUT_DIR/aux/sign/macro3 ] || mkdir $OUT_DIR/aux/sign/macro3
cat >$OUT_DIR/aux/sign/macro3/cpp <<'-----'
#ifdef Cpp_COMP30
MACRO0
MACRO1(Cpp_COMP30,_COMP30,Cpp_SEL30,_SEL30)
#endif
#ifdef Cpp_COMP31
MACRO0
MACRO1(Cpp_COMP31,_COMP31,Cpp_SEL31,_SEL31)
#endif
#ifdef Cpp_COMP32
MACRO0
MACRO1(Cpp_COMP32,_COMP32,Cpp_SEL32,_SEL32)
#endif
#ifdef Cpp_COMP33
MACRO0
MACRO1(Cpp_COMP33,_COMP33,Cpp_SEL33,_SEL33)
#endif
#ifdef Cpp_COMP34
MACRO0
MACRO1(Cpp_COMP34,_COMP34,Cpp_SEL34,_SEL34)
#endif
#ifdef Cpp_COMP35
MACRO0
MACRO1(Cpp_COMP35,_COMP35,Cpp_SEL35,_SEL35)
#endif
#ifdef Cpp_COMP36
MACRO0
MACRO1(Cpp_COMP36,_COMP36,Cpp_SEL36,_SEL36)
#endif
#ifdef Cpp_COMP37
MACRO0
MACRO1(Cpp_COMP37,_COMP37,Cpp_SEL37,_SEL37)
#endif
#ifdef Cpp_COMP38
MACRO0
MACRO1(Cpp_COMP38,_COMP38,Cpp_SEL38,_SEL38)
#endif
#ifdef Cpp_COMP39
MACRO0
MACRO1(Cpp_COMP39,_COMP39,Cpp_SEL39,_SEL39)
#endif

#ifdef Cpp_COMP40
MACRO0
MACRO1(Cpp_COMP40,_COMP40,Cpp_SEL40,_SEL40)
#endif
#ifdef Cpp_COMP41
MACRO0
MACRO1(Cpp_COMP41,_COMP41,Cpp_SEL41,_SEL41)
#endif
#ifdef Cpp_COMP42
MACRO0
MACRO1(Cpp_COMP42,_COMP42,Cpp_SEL42,_SEL42)
#endif
#ifdef Cpp_COMP43
MACRO0
MACRO1(Cpp_COMP43,_COMP43,Cpp_SEL43,_SEL43)
#endif
#ifdef Cpp_COMP44
MACRO0
MACRO1(Cpp_COMP44,_COMP44,Cpp_SEL44,_SEL44)
#endif
#ifdef Cpp_COMP45
MACRO0
MACRO1(Cpp_COMP45,_COMP45,Cpp_SEL45,_SEL45)
#endif
#ifdef Cpp_COMP46
MACRO0
MACRO1(Cpp_COMP46,_COMP46,Cpp_SEL46,_SEL46)
#endif
#ifdef Cpp_COMP47
MACRO0
MACRO1(Cpp_COMP47,_COMP47,Cpp_SEL47,_SEL47)
#endif
#ifdef Cpp_COMP48
MACRO0
MACRO1(Cpp_COMP48,_COMP48,Cpp_SEL48,_SEL48)
#endif
#ifdef Cpp_COMP49
MACRO0
MACRO1(Cpp_COMP49,_COMP49,Cpp_SEL49,_SEL49)
#endif

#ifdef Cpp_COMP50
MACRO0
MACRO1(Cpp_COMP50,_COMP50,Cpp_SEL50,_SEL50)
#endif
#ifdef Cpp_COMP51
MACRO0
MACRO1(Cpp_COMP51,_COMP51,Cpp_SEL51,_SEL51)
#endif
#ifdef Cpp_COMP52
MACRO0
MACRO1(Cpp_COMP52,_COMP52,Cpp_SEL52,_SEL52)
#endif
#ifdef Cpp_COMP53
MACRO0
MACRO1(Cpp_COMP53,_COMP53,Cpp_SEL53,_SEL53)
#endif
#ifdef Cpp_COMP54
MACRO0
MACRO1(Cpp_COMP54,_COMP54,Cpp_SEL54,_SEL54)
#endif
#ifdef Cpp_COMP55
MACRO0
MACRO1(Cpp_COMP55,_COMP55,Cpp_SEL55,_SEL55)
#endif
#ifdef Cpp_COMP56
MACRO0
MACRO1(Cpp_COMP56,_COMP56,Cpp_SEL56,_SEL56)
#endif
#ifdef Cpp_COMP57
MACRO0
MACRO1(Cpp_COMP57,_COMP57,Cpp_SEL57,_SEL57)
#endif
#ifdef Cpp_COMP58
MACRO0
MACRO1(Cpp_COMP58,_COMP58,Cpp_SEL58,_SEL58)
#endif
#ifdef Cpp_COMP59
MACRO0
MACRO1(Cpp_COMP59,_COMP59,Cpp_SEL59,_SEL59)
#endif

#ifdef Cpp_COMP60
MACRO0
MACRO1(Cpp_COMP60,_COMP60,Cpp_SEL60,_SEL60)
#endif
#ifdef Cpp_COMP61
MACRO0
MACRO1(Cpp_COMP61,_COMP61,Cpp_SEL61,_SEL61)
#endif
#ifdef Cpp_COMP62
MACRO0
MACRO1(Cpp_COMP62,_COMP62,Cpp_SEL62,_SEL62)
#endif
#ifdef Cpp_COMP63
MACRO0
MACRO1(Cpp_COMP63,_COMP63,Cpp_SEL63,_SEL63)
#endif
#ifdef Cpp_COMP64
MACRO0
MACRO1(Cpp_COMP64,_COMP64,Cpp_SEL64,_SEL64)
#endif
#ifdef Cpp_COMP65
MACRO0
MACRO1(Cpp_COMP65,_COMP65,Cpp_SEL65,_SEL65)
#endif
#ifdef Cpp_COMP66
MACRO0
MACRO1(Cpp_COMP66,_COMP66,Cpp_SEL66,_SEL66)
#endif
#ifdef Cpp_COMP67
MACRO0
MACRO1(Cpp_COMP67,_COMP67,Cpp_SEL67,_SEL67)
#endif
#ifdef Cpp_COMP68
MACRO0
MACRO1(Cpp_COMP68,_COMP68,Cpp_SEL68,_SEL68)
#endif
#ifdef Cpp_COMP69
MACRO0
MACRO1(Cpp_COMP69,_COMP69,Cpp_SEL69,_SEL69)
#endif

#ifdef Cpp_COMP70
MACRO0
MACRO1(Cpp_COMP70,_COMP70,Cpp_SEL70,_SEL70)
#endif
#ifdef Cpp_COMP71
MACRO0
MACRO1(Cpp_COMP71,_COMP71,Cpp_SEL71,_SEL71)
#endif
#ifdef Cpp_COMP72
MACRO0
MACRO1(Cpp_COMP72,_COMP72,Cpp_SEL72,_SEL72)
#endif
#ifdef Cpp_COMP73
MACRO0
MACRO1(Cpp_COMP73,_COMP73,Cpp_SEL73,_SEL73)
#endif
#ifdef Cpp_COMP74
MACRO0
MACRO1(Cpp_COMP74,_COMP74,Cpp_SEL74,_SEL74)
#endif
#ifdef Cpp_COMP75
MACRO0
MACRO1(Cpp_COMP75,_COMP75,Cpp_SEL75,_SEL75)
#endif
#ifdef Cpp_COMP76
MACRO0
MACRO1(Cpp_COMP76,_COMP76,Cpp_SEL76,_SEL76)
#endif
#ifdef Cpp_COMP77
MACRO0
MACRO1(Cpp_COMP77,_COMP77,Cpp_SEL77,_SEL77)
#endif
#ifdef Cpp_COMP78
MACRO0
MACRO1(Cpp_COMP78,_COMP78,Cpp_SEL78,_SEL78)
#endif
#ifdef Cpp_COMP79
MACRO0
MACRO1(Cpp_COMP79,_COMP79,Cpp_SEL79,_SEL79)
#endif

#ifdef Cpp_COMP80
MACRO0
MACRO1(Cpp_COMP80,_COMP80,Cpp_SEL80,_SEL80)
#endif
#ifdef Cpp_COMP81
MACRO0
MACRO1(Cpp_COMP81,_COMP81,Cpp_SEL81,_SEL81)
#endif
#ifdef Cpp_COMP82
MACRO0
MACRO1(Cpp_COMP82,_COMP82,Cpp_SEL82,_SEL82)
#endif
#ifdef Cpp_COMP83
MACRO0
MACRO1(Cpp_COMP83,_COMP83,Cpp_SEL83,_SEL83)
#endif
#ifdef Cpp_COMP84
MACRO0
MACRO1(Cpp_COMP84,_COMP84,Cpp_SEL84,_SEL84)
#endif
#ifdef Cpp_COMP85
MACRO0
MACRO1(Cpp_COMP85,_COMP85,Cpp_SEL85,_SEL85)
#endif
#ifdef Cpp_COMP86
MACRO0
MACRO1(Cpp_COMP86,_COMP86,Cpp_SEL86,_SEL86)
#endif
#ifdef Cpp_COMP87
MACRO0
MACRO1(Cpp_COMP87,_COMP87,Cpp_SEL87,_SEL87)
#endif
#ifdef Cpp_COMP88
MACRO0
MACRO1(Cpp_COMP88,_COMP88,Cpp_SEL88,_SEL88)
#endif
#ifdef Cpp_COMP89
MACRO0
MACRO1(Cpp_COMP89,_COMP89,Cpp_SEL89,_SEL89)
#endif

#ifdef Cpp_COMP89
  DOMAIN: only 89 components are supported
#endif

-----
[ -d $OUT_DIR/aux/sign/mecro1 ] || mkdir $OUT_DIR/aux/sign/mecro1
cat >$OUT_DIR/aux/sign/mecro1/cpp <<'-----'

#ifndef MACRO1
#define MACRO1
#endif

#ifndef MACRO2
#define MACRO2
#endif

#ifndef MACRO3
#define MACRO3
#endif

#ifdef Cpp_COMP1
MACRO1(Cpp_COMP1,_COMP1,Cpp_SEL1,_SEL1,SEL1)
MACRO2(Cpp_COMP1,_COMP1,Cpp_SEL1,_SEL1,SEL1)
MACRO3(Cpp_COMP1,_COMP1,Cpp_SEL1,_SEL1,SEL1)
#endif
#ifdef Cpp_COMP2
MACRO1(Cpp_COMP2,_COMP2,Cpp_SEL2,_SEL2,SEL2)
MACRO2(Cpp_COMP2,_COMP2,Cpp_SEL2,_SEL2,SEL2)
MACRO3(Cpp_COMP2,_COMP2,Cpp_SEL2,_SEL2,SEL2)
#endif
#ifdef Cpp_COMP3
MACRO1(Cpp_COMP3,_COMP3,Cpp_SEL3,_SEL3,SEL3)
MACRO2(Cpp_COMP3,_COMP3,Cpp_SEL3,_SEL3,SEL3)
MACRO3(Cpp_COMP3,_COMP3,Cpp_SEL3,_SEL3,SEL3)
#endif
#ifdef Cpp_COMP4
MACRO1(Cpp_COMP4,_COMP4,Cpp_SEL4,_SEL4,SEL4)
MACRO2(Cpp_COMP4,_COMP4,Cpp_SEL4,_SEL4,SEL4)
MACRO3(Cpp_COMP4,_COMP4,Cpp_SEL4,_SEL4,SEL4)
#endif
#ifdef Cpp_COMP5
MACRO1(Cpp_COMP5,_COMP5,Cpp_SEL5,_SEL5,SEL5)
MACRO2(Cpp_COMP5,_COMP5,Cpp_SEL5,_SEL5,SEL5)
MACRO3(Cpp_COMP5,_COMP5,Cpp_SEL5,_SEL5,SEL5)
#endif
#ifdef Cpp_COMP6
MACRO1(Cpp_COMP6,_COMP6,Cpp_SEL6,_SEL6,SEL6)
MACRO2(Cpp_COMP6,_COMP6,Cpp_SEL6,_SEL6,SEL6)
MACRO3(Cpp_COMP6,_COMP6,Cpp_SEL6,_SEL6,SEL6)
#endif
#ifdef Cpp_COMP7
MACRO1(Cpp_COMP7,_COMP7,Cpp_SEL7,_SEL7,SEL7)
MACRO2(Cpp_COMP7,_COMP7,Cpp_SEL7,_SEL7,SEL7)
MACRO3(Cpp_COMP7,_COMP7,Cpp_SEL7,_SEL7,SEL7)
#endif
#ifdef Cpp_COMP8
MACRO1(Cpp_COMP8,_COMP8,Cpp_SEL8,_SEL8,SEL8)
MACRO2(Cpp_COMP8,_COMP8,Cpp_SEL8,_SEL8,SEL8)
MACRO3(Cpp_COMP8,_COMP8,Cpp_SEL8,_SEL8,SEL8)
#endif
#ifdef Cpp_COMP9
MACRO1(Cpp_COMP9,_COMP9,Cpp_SEL9,_SEL9,SEL9)
MACRO2(Cpp_COMP9,_COMP9,Cpp_SEL9,_SEL9,SEL9)
MACRO3(Cpp_COMP9,_COMP9,Cpp_SEL9,_SEL9,SEL9)
#endif

#ifdef Cpp_COMP10
#include <aux/sign/mecro2/cpp>
#endif

#undef MACRO1
#undef MACRO2
#undef MACRO3
-----
[ -d $OUT_DIR/aux/sign/mecro2 ] || mkdir $OUT_DIR/aux/sign/mecro2
cat >$OUT_DIR/aux/sign/mecro2/cpp <<'-----'
#ifdef Cpp_COMP10
MACRO1(Cpp_COMP10,_COMP10,Cpp_SEL10,_SEL10,SEL10)
MACRO2(Cpp_COMP10,_COMP10,Cpp_SEL10,_SEL10,SEL10)
MACRO3(Cpp_COMP10,_COMP10,Cpp_SEL10,_SEL10,SEL10)
#endif
#ifdef Cpp_COMP11
MACRO1(Cpp_COMP11,_COMP11,Cpp_SEL11,_SEL11,SEL11)
MACRO2(Cpp_COMP11,_COMP11,Cpp_SEL11,_SEL11,SEL11)
MACRO3(Cpp_COMP11,_COMP11,Cpp_SEL11,_SEL11,SEL11)
#endif
#ifdef Cpp_COMP12
MACRO1(Cpp_COMP12,_COMP12,Cpp_SEL12,_SEL12,SEL12)
MACRO2(Cpp_COMP12,_COMP12,Cpp_SEL12,_SEL12,SEL12)
MACRO3(Cpp_COMP12,_COMP12,Cpp_SEL12,_SEL12,SEL12)
#endif
#ifdef Cpp_COMP13
MACRO1(Cpp_COMP13,_COMP13,Cpp_SEL13,_SEL13,SEL13)
MACRO2(Cpp_COMP13,_COMP13,Cpp_SEL13,_SEL13,SEL13)
MACRO3(Cpp_COMP13,_COMP13,Cpp_SEL13,_SEL13,SEL13)
#endif
#ifdef Cpp_COMP14
MACRO1(Cpp_COMP14,_COMP14,Cpp_SEL14,_SEL14,SEL14)
MACRO2(Cpp_COMP14,_COMP14,Cpp_SEL14,_SEL14,SEL14)
MACRO3(Cpp_COMP14,_COMP14,Cpp_SEL14,_SEL14,SEL14)
#endif
#ifdef Cpp_COMP15
MACRO1(Cpp_COMP15,_COMP15,Cpp_SEL15,_SEL15,SEL15)
MACRO2(Cpp_COMP15,_COMP15,Cpp_SEL15,_SEL15,SEL15)
MACRO3(Cpp_COMP15,_COMP15,Cpp_SEL15,_SEL15,SEL15)
#endif
#ifdef Cpp_COMP16
MACRO1(Cpp_COMP16,_COMP16,Cpp_SEL16,_SEL16,SEL16)
MACRO2(Cpp_COMP16,_COMP16,Cpp_SEL16,_SEL16,SEL16)
MACRO3(Cpp_COMP16,_COMP16,Cpp_SEL16,_SEL16,SEL16)
#endif
#ifdef Cpp_COMP17
MACRO1(Cpp_COMP17,_COMP17,Cpp_SEL17,_SEL17,SEL17)
MACRO2(Cpp_COMP17,_COMP17,Cpp_SEL17,_SEL17,SEL17)
MACRO3(Cpp_COMP17,_COMP17,Cpp_SEL17,_SEL17,SEL17)
#endif
#ifdef Cpp_COMP18
MACRO1(Cpp_COMP18,_COMP18,Cpp_SEL18,_SEL18,SEL18)
MACRO2(Cpp_COMP18,_COMP18,Cpp_SEL18,_SEL18,SEL18)
MACRO3(Cpp_COMP18,_COMP18,Cpp_SEL18,_SEL18,SEL18)
#endif
#ifdef Cpp_COMP19
MACRO1(Cpp_COMP19,_COMP19,Cpp_SEL19,_SEL19,SEL19)
MACRO2(Cpp_COMP19,_COMP19,Cpp_SEL19,_SEL19,SEL19)
MACRO3(Cpp_COMP19,_COMP19,Cpp_SEL19,_SEL19,SEL19)
#endif
#ifdef Cpp_COMP20
MACRO1(Cpp_COMP20,_COMP20,Cpp_SEL20,_SEL20,SEL20)
MACRO2(Cpp_COMP20,_COMP20,Cpp_SEL20,_SEL20,SEL20)
MACRO3(Cpp_COMP20,_COMP20,Cpp_SEL20,_SEL20,SEL20)
#endif
#ifdef Cpp_COMP21
MACRO1(Cpp_COMP21,_COMP21,Cpp_SEL21,_SEL21,SEL21)
MACRO2(Cpp_COMP21,_COMP21,Cpp_SEL21,_SEL21,SEL21)
MACRO3(Cpp_COMP21,_COMP21,Cpp_SEL21,_SEL21,SEL21)
#endif
#ifdef Cpp_COMP22
MACRO1(Cpp_COMP22,_COMP22,Cpp_SEL22,_SEL22,SEL22)
MACRO2(Cpp_COMP22,_COMP22,Cpp_SEL22,_SEL22,SEL22)
MACRO3(Cpp_COMP22,_COMP22,Cpp_SEL22,_SEL22,SEL22)
#endif
#ifdef Cpp_COMP23
MACRO1(Cpp_COMP23,_COMP23,Cpp_SEL23,_SEL23,SEL23)
MACRO2(Cpp_COMP23,_COMP23,Cpp_SEL23,_SEL23,SEL23)
MACRO3(Cpp_COMP23,_COMP23,Cpp_SEL23,_SEL23,SEL23)
#endif
#ifdef Cpp_COMP24
MACRO1(Cpp_COMP24,_COMP24,Cpp_SEL24,_SEL24,SEL24)
MACRO2(Cpp_COMP24,_COMP24,Cpp_SEL24,_SEL24,SEL24)
MACRO3(Cpp_COMP24,_COMP24,Cpp_SEL24,_SEL24,SEL24)
#endif
#ifdef Cpp_COMP25
MACRO1(Cpp_COMP25,_COMP25,Cpp_SEL25,_SEL25,SEL25)
MACRO2(Cpp_COMP25,_COMP25,Cpp_SEL25,_SEL25,SEL25)
MACRO3(Cpp_COMP25,_COMP25,Cpp_SEL25,_SEL25,SEL25)
#endif
#ifdef Cpp_COMP26
MACRO1(Cpp_COMP26,_COMP26,Cpp_SEL26,_SEL26,SEL26)
MACRO2(Cpp_COMP26,_COMP26,Cpp_SEL26,_SEL26,SEL26)
MACRO3(Cpp_COMP26,_COMP26,Cpp_SEL26,_SEL26,SEL26)
#endif
#ifdef Cpp_COMP27
MACRO1(Cpp_COMP27,_COMP27,Cpp_SEL27,_SEL27,SEL27)
MACRO2(Cpp_COMP27,_COMP27,Cpp_SEL27,_SEL27,SEL27)
MACRO3(Cpp_COMP27,_COMP27,Cpp_SEL27,_SEL27,SEL27)
#endif
#ifdef Cpp_COMP28
MACRO1(Cpp_COMP28,_COMP28,Cpp_SEL28,_SEL28,SEL28)
MACRO2(Cpp_COMP28,_COMP28,Cpp_SEL28,_SEL28,SEL28)
MACRO3(Cpp_COMP28,_COMP28,Cpp_SEL28,_SEL28,SEL28)
#endif
#ifdef Cpp_COMP29
MACRO1(Cpp_COMP29,_COMP29,Cpp_SEL29,_SEL29,SEL29)
MACRO2(Cpp_COMP29,_COMP29,Cpp_SEL29,_SEL29,SEL29)
MACRO3(Cpp_COMP29,_COMP29,Cpp_SEL29,_SEL29,SEL29)
#endif

#ifdef Cpp_COMP30
#include <aux/sign/mecro3/cpp>
#endif

-----
[ -d $OUT_DIR/aux/sign/mecro3 ] || mkdir $OUT_DIR/aux/sign/mecro3
cat >$OUT_DIR/aux/sign/mecro3/cpp <<'-----'
#ifdef Cpp_COMP30
MACRO1(Cpp_COMP30,_COMP30,Cpp_SEL30,_SEL30,SEL30)
MACRO2(Cpp_COMP30,_COMP30,Cpp_SEL30,_SEL30,SEL30)
MACRO3(Cpp_COMP30,_COMP30,Cpp_SEL30,_SEL30,SEL30)
#endif
#ifdef Cpp_COMP31
MACRO1(Cpp_COMP31,_COMP31,Cpp_SEL31,_SEL31,SEL31)
MACRO2(Cpp_COMP31,_COMP31,Cpp_SEL31,_SEL31,SEL31)
MACRO3(Cpp_COMP31,_COMP31,Cpp_SEL31,_SEL31,SEL31)
#endif
#ifdef Cpp_COMP32
MACRO1(Cpp_COMP32,_COMP32,Cpp_SEL32,_SEL32,SEL32)
MACRO2(Cpp_COMP32,_COMP32,Cpp_SEL32,_SEL32,SEL32)
MACRO3(Cpp_COMP32,_COMP32,Cpp_SEL32,_SEL32,SEL32)
#endif
#ifdef Cpp_COMP33
MACRO1(Cpp_COMP33,_COMP33,Cpp_SEL33,_SEL33,SEL33)
MACRO2(Cpp_COMP33,_COMP33,Cpp_SEL33,_SEL33,SEL33)
MACRO3(Cpp_COMP33,_COMP33,Cpp_SEL33,_SEL33,SEL33)
#endif
#ifdef Cpp_COMP34
MACRO1(Cpp_COMP34,_COMP34,Cpp_SEL34,_SEL34,SEL34)
MACRO2(Cpp_COMP34,_COMP34,Cpp_SEL34,_SEL34,SEL34)
MACRO3(Cpp_COMP34,_COMP34,Cpp_SEL34,_SEL34,SEL34)
#endif
#ifdef Cpp_COMP35
MACRO1(Cpp_COMP35,_COMP35,Cpp_SEL35,_SEL35,SEL35)
MACRO2(Cpp_COMP35,_COMP35,Cpp_SEL35,_SEL35,SEL35)
MACRO3(Cpp_COMP35,_COMP35,Cpp_SEL35,_SEL35,SEL35)
#endif
#ifdef Cpp_COMP36
MACRO1(Cpp_COMP36,_COMP36,Cpp_SEL36,_SEL36,SEL36)
MACRO2(Cpp_COMP36,_COMP36,Cpp_SEL36,_SEL36,SEL36)
MACRO3(Cpp_COMP36,_COMP36,Cpp_SEL36,_SEL36,SEL36)
#endif
#ifdef Cpp_COMP37
MACRO1(Cpp_COMP37,_COMP37,Cpp_SEL37,_SEL37,SEL37)
MACRO2(Cpp_COMP37,_COMP37,Cpp_SEL37,_SEL37,SEL37)
MACRO3(Cpp_COMP37,_COMP37,Cpp_SEL37,_SEL37,SEL37)
#endif
#ifdef Cpp_COMP38
MACRO1(Cpp_COMP38,_COMP38,Cpp_SEL38,_SEL38,SEL38)
MACRO2(Cpp_COMP38,_COMP38,Cpp_SEL38,_SEL38,SEL38)
MACRO3(Cpp_COMP38,_COMP38,Cpp_SEL38,_SEL38,SEL38)
#endif
#ifdef Cpp_COMP39
MACRO1(Cpp_COMP39,_COMP39,Cpp_SEL39,_SEL39,SEL39)
MACRO2(Cpp_COMP39,_COMP39,Cpp_SEL39,_SEL39,SEL39)
MACRO3(Cpp_COMP39,_COMP39,Cpp_SEL39,_SEL39,SEL39)
#endif
#ifdef Cpp_COMP40
MACRO1(Cpp_COMP40,_COMP40,Cpp_SEL40,_SEL40,SEL40)
MACRO2(Cpp_COMP40,_COMP40,Cpp_SEL40,_SEL40,SEL40)
MACRO3(Cpp_COMP40,_COMP40,Cpp_SEL40,_SEL40,SEL40)
#endif
#ifdef Cpp_COMP41
MACRO1(Cpp_COMP41,_COMP41,Cpp_SEL41,_SEL41,SEL41)
MACRO2(Cpp_COMP41,_COMP41,Cpp_SEL41,_SEL41,SEL41)
MACRO3(Cpp_COMP41,_COMP41,Cpp_SEL41,_SEL41,SEL41)
#endif
#ifdef Cpp_COMP42
MACRO1(Cpp_COMP42,_COMP42,Cpp_SEL42,_SEL42,SEL42)
MACRO2(Cpp_COMP42,_COMP42,Cpp_SEL42,_SEL42,SEL42)
MACRO3(Cpp_COMP42,_COMP42,Cpp_SEL42,_SEL42,SEL42)
#endif
#ifdef Cpp_COMP43
MACRO1(Cpp_COMP43,_COMP43,Cpp_SEL43,_SEL43,SEL43)
MACRO2(Cpp_COMP43,_COMP43,Cpp_SEL43,_SEL43,SEL43)
MACRO3(Cpp_COMP43,_COMP43,Cpp_SEL43,_SEL43,SEL43)
#endif
#ifdef Cpp_COMP44
MACRO1(Cpp_COMP44,_COMP44,Cpp_SEL44,_SEL44,SEL44)
MACRO2(Cpp_COMP44,_COMP44,Cpp_SEL44,_SEL44,SEL44)
MACRO3(Cpp_COMP44,_COMP44,Cpp_SEL44,_SEL44,SEL44)
#endif
#ifdef Cpp_COMP45
MACRO1(Cpp_COMP45,_COMP45,Cpp_SEL45,_SEL45,SEL45)
MACRO2(Cpp_COMP45,_COMP45,Cpp_SEL45,_SEL45,SEL45)
MACRO3(Cpp_COMP45,_COMP45,Cpp_SEL45,_SEL45,SEL45)
#endif
#ifdef Cpp_COMP46
MACRO1(Cpp_COMP46,_COMP46,Cpp_SEL46,_SEL46,SEL46)
MACRO2(Cpp_COMP46,_COMP46,Cpp_SEL46,_SEL46,SEL46)
MACRO3(Cpp_COMP46,_COMP46,Cpp_SEL46,_SEL46,SEL46)
#endif
#ifdef Cpp_COMP47
MACRO1(Cpp_COMP47,_COMP47,Cpp_SEL47,_SEL47,SEL47)
MACRO2(Cpp_COMP47,_COMP47,Cpp_SEL47,_SEL47,SEL47)
MACRO3(Cpp_COMP47,_COMP47,Cpp_SEL47,_SEL47,SEL47)
#endif
#ifdef Cpp_COMP48
MACRO1(Cpp_COMP48,_COMP48,Cpp_SEL48,_SEL48,SEL48)
MACRO2(Cpp_COMP48,_COMP48,Cpp_SEL48,_SEL48,SEL48)
MACRO3(Cpp_COMP48,_COMP48,Cpp_SEL48,_SEL48,SEL48)
#endif
#ifdef Cpp_COMP49
MACRO1(Cpp_COMP49,_COMP49,Cpp_SEL49,_SEL49,SEL49)
MACRO2(Cpp_COMP49,_COMP49,Cpp_SEL49,_SEL49,SEL49)
MACRO3(Cpp_COMP49,_COMP49,Cpp_SEL49,_SEL49,SEL49)
#endif

#ifdef Cpp_COMP50
  DOMAIN: only 49 components are supported 
#endif

-----
[ -d $OUT_DIR/aux/sign/signature ] || mkdir $OUT_DIR/aux/sign/signature
cat >$OUT_DIR/aux/sign/signature/cppdef <<'-----'
#ifndef UNDEFMAC
#define UNDEFMAC

#ifdef MANIPULATOR
#undef Cpp_RESULT
#define Cpp_RESULT Cpp_DOMAIN &
#undef NOTCONST
#define NOTCONST
#endif

#ifdef NOTCONST
#define Cpp_Const
#else
#define Cpp_Const const
#endif

#ifdef CPPIMPL
#define FCTNAME1 Cpp_DOMAIN::FCTNAME
#define X2 x2
#define X3 x3
#define X4 x4
#define X5 x5
#define X6 x6
#define X7 x7
#define X8 x8
#define X9 x9
#define X10 x10
#define R2 r2
#define R3 r3
#define R4 r4
#define R5 r5
#define Cpp_Body
#else
#define FCTNAME1 FCTNAME
#define X2 x2                       
#define X3 x3                       
#define X4 x4
#define X5 x5   
#define X6 x6   
#define X7 x7           
#define X8 x8           
#define X9 x9           
#define X10 x10         
#define R2 r2           
#define R3 r3           
#define R4 r4
#define R5 r5           
#define Cpp_Body ;
#endif

#ifndef Cpp_RESULT
#define Cpp_RESULT void
#endif

#ifdef Cpp_XX
#define Cpp_Param2 const Cpp_XX & X2
#define Cpp_Aaram2 X2
#define Cpp_Paramsep ,
#else
#define Cpp_Param2
#define Cpp_Aaram2
#define Cpp_Paramsep
#endif

#ifdef Cpp_XXX
#define Cpp_Param3 Cpp_Param2, const Cpp_XXX & X3
#define Cpp_Aaram3 Cpp_Aaram2, X3
#else
#define Cpp_Param3 Cpp_Param2
#define Cpp_Aaram3 Cpp_Aaram2
#endif

#ifdef Cpp_XXXX
#define Cpp_Param4 Cpp_Param3, const Cpp_XXXX & X4
#define Cpp_Aaram4 Cpp_Aaram3, X4
#else
#define Cpp_Param4 Cpp_Param3
#define Cpp_Aaram4 Cpp_Aaram3
#endif

#ifdef Cpp_XXXXX
#define Cpp_Param5 Cpp_Param4, const Cpp_XXXXX & X5
#define Cpp_Aaram5 Cpp_Aaram4, X5
#else
#define Cpp_Param5 Cpp_Param4
#define Cpp_Aaram5 Cpp_Aaram4
#endif

#ifdef Cpp_XXXXXX
#define Cpp_Param6 Cpp_Param5, const Cpp_XXXXXX & X6
#define Cpp_Aaram6 Cpp_Aaram5, X6
#else
#define Cpp_Param6 Cpp_Param5
#define Cpp_Aaram6 Cpp_Aaram5
#endif

#ifdef Cpp_XXXXXXX
#define Cpp_Param7 Cpp_Param6, const Cpp_XXXXXXX & X7
#define Cpp_Aaram7 Cpp_Aaram6, X7
#else
#define Cpp_Param7 Cpp_Param6
#define Cpp_Aaram7 Cpp_Aaram6
#endif

#ifdef Cpp_XXXXXXXX
#define Cpp_Param8 Cpp_Param7, const Cpp_XXXXXXXX & X8
#define Cpp_Aaram8 Cpp_Aaram7, X8
#else
#define Cpp_Param8 Cpp_Param7
#define Cpp_Aaram8 Cpp_Aaram7
#endif

#ifdef Cpp_XXXXXXXXX
#define Cpp_Param9 Cpp_Param8, const Cpp_XXXXXXXXX & X9
#define Cpp_Aaram9 Cpp_Aaram8, X9
#else
#define Cpp_Param9 Cpp_Param8
#define Cpp_Aaram9 Cpp_Aaram8
#endif

#ifdef Cpp_XXXXXXXXXX
#define Cpp_Param10 Cpp_Param9, const Cpp_XXXXXXXXXX & X10
#define Cpp_Aaram10 Cpp_Aaram9, X10
#else
#define Cpp_Param10 Cpp_Param9
#define Cpp_Aaram10 Cpp_Aaram9
#endif

#ifdef Cpp_RESULT2
#define Cpp_Paramr2 Cpp_Param10 Cpp_Paramsep Cpp_RESULT2 & R2
#define Cpp_Aaramr2 Cpp_Aaram10 Cpp_Paramsep R2
#else
#define Cpp_Paramr2 Cpp_Param10
#define Cpp_Aaramr2 Cpp_Aaram10
#endif

#ifdef Cpp_RESULT3
#define Cpp_Paramr3 Cpp_Paramr2, Cpp_RESULT3 & R3
#define Cpp_Aaramr3 Cpp_Aaramr2, R3
#else
#define Cpp_Paramr3 Cpp_Paramr2
#define Cpp_Aaramr3 Cpp_Aaramr2
#endif

#ifdef Cpp_RESULT4
#define Cpp_Paramr4 Cpp_Paramr3, Cpp_RESULT4 & R4
#define Cpp_Aaramr4 Cpp_Aaramr3, R4
#else
#define Cpp_Paramr4 Cpp_Paramr3
#define Cpp_Aaramr4 Cpp_Aaramr3
#endif

#ifdef Cpp_RESULT5
#define Cpp_Paramr5 Cpp_Paramr4 , Cpp_RESULT5 & R5
#define Cpp_Aaramr5 Cpp_Aaramr4 , R5
#else
#define Cpp_Paramr5 Cpp_Paramr4
#define Cpp_Aaramr5 Cpp_Aaramr4
#endif

#define Cpp_ParamS Cpp_Paramr5
#define Cpp_AaramS Cpp_Aaramr5

#else

#undef Cpp_Param2
#undef Cpp_Param3
#undef Cpp_Param4
#undef Cpp_Param5
#undef Cpp_Param6
#undef Cpp_Param7
#undef Cpp_Param8
#undef Cpp_Param9
#undef Cpp_Param10
#undef Cpp_Paramr2
#undef Cpp_Paramr3
#undef Cpp_Paramr4
#undef Cpp_Paramr5
#undef Cpp_ParamS

#undef Cpp_Aaram2
#undef Cpp_Aaram3
#undef Cpp_Aaram4
#undef Cpp_Aaram5
#undef Cpp_Aaram6
#undef Cpp_Aaram7
#undef Cpp_Aaram8
#undef Cpp_Aaram9
#undef Cpp_Aaram10
#undef Cpp_Aaramr2
#undef Cpp_Aaramr3
#undef Cpp_Aaramr4
#undef Cpp_Aaramr5
#undef Cpp_AaramS

#undef Cpp_Const
#undef Cpp_RESULT
#undef Cpp_Body
#undef Cpp_Paramsep

#undef X2
#undef X3
#undef X4
#undef X5
#undef X6
#undef X7
#undef X8
#undef X9
#undef X10
#undef R2
#undef R3
#undef R4
#undef R5

#undef FCTNAME1

#undef NOTCONST
#undef RESULT
#undef UNDEFMAC
#endif

-----
[ -d $OUT_DIR/aux/sign/sort ] || mkdir $OUT_DIR/aux/sign/sort
cat >$OUT_DIR/aux/sign/sort/cpp <<'-----'
#include <aux/com/sort/defs>
InlineFriendConstFct(sort,FPAR1(const Cpp_DOMAIN &),Cpp_RESULT)
RUMPF(BODY1(Cpp_RESULT,sort,FPARLIST1))

-----
cat >$OUT_DIR/aux/sign/sort/gsig <<'-----'
#include <aux/com/sort/defs>

  FUNCDEC(sort##_DOMAIN,PL_1(DOMAIN),RESULT)

-----
cat >$OUT_DIR/aux/sign/sort/vsig <<'-----'
  sort(x1) = 
    let r e RESULT be s.t.
        len r = card x1 &
        elems r = x1    &
        A i e ind r : i != len r => r(i) <= r(i+1)
    in r
                
  TYPE : DOMAIN  -->  RESULT

  The elements occuring in the COLL x1 are sorted in a tuple

  Supposed ELEM1 is the element domain,
  then RESULT must be an ELEM1 *.
#undef COLL
-----
[ -d $OUT_DIR/aux/sign/switch ] || mkdir $OUT_DIR/aux/sign/switch
cat >$OUT_DIR/aux/sign/switch/cpp <<'-----'
#ifndef Cpp_RESULT
#define Cpp_RESULT void
#endif
#ifndef Cpp_XX
#define Cpp_PX
#define _pPX
#else
#ifndef Cpp_XXX
#define Cpp_PX const Cpp_XX &px1
#define _pPX ,px1.data
#else
#ifndef Cpp_XXXX
#define Cpp_PX const Cpp_XX &px1, const Cpp_XXX &px2
#define _pPX ,px1.data, px2.data
#else
#define Cpp_PX const Cpp_XX &px1, const Cpp_XXX &px2, const Cpp_XXXX &px3
#define _pPX ,px1.data, px2.data, px3.data
#endif
#endif
#endif
#ifdef Cpp_XX
#define KOMMA ,
#else
#define KOMMA
#endif
#ifdef MEMBERS
#define PARAMS (Cpp_PX)
#else
#define PARAMS (const Cpp_DOMAIN &xx KOMMA Cpp_PX)
#endif
InlineFriendFct(FCTNAME,PARAMS,Cpp_RESULT)
RUMPF(BODY1(Cpp_RESULT,FCTNAME,(DATA _pPX)))
#undef PARAMS
#undef Cpp_PX
#undef _pPX
#undef KOMMA
#undef Cpp_RESULT
-----
cat >$OUT_DIR/aux/sign/switch/gsig <<'-----'
#if ! NOSIGNATURE
#include <aux/com/switch/ccod>
 gxxproc
#include <aux/com/switche/ccod>
#endif
#undef RESULT
-----
cat >$OUT_DIR/aux/sign/switch/vsig <<'-----'
#if ! NOSIGNATURE
  switch(e1,,,,en)(x1,...,xm) =
   let e = (is_e1(x1)  -> e1(x1,...,xm)
                :
                :
           ,is_en(x1)  -> en(x1,...,xm)
           )
   in e
  TYPE : ( Comp1 D2 ... Dm  -->  Res
                  :
                  :
           Compn D2 ... Dm  -->  Res ) 

         -->

         DOMAIN  D2 ... Dm  -->  Res

  with this functional switch functions can be generated
#endif
-----
[ -d $OUT_DIR/bag ] || mkdir $OUT_DIR/bag
[ -d $OUT_DIR/bag/automem ] || mkdir $OUT_DIR/bag/automem
[ -d $OUT_DIR/bag/automem/all ] || mkdir $OUT_DIR/bag/automem/all
cat >$OUT_DIR/bag/automem/all/vdm <<'-----'
! === automem: Operation bag/all not supported === !
-----
[ -d $OUT_DIR/bag/automem/basic ] || mkdir $OUT_DIR/bag/automem/basic
cat >$OUT_DIR/bag/automem/basic/ccod <<'-----'
#include <aux/automem/basic/ccod>
-----
cat >$OUT_DIR/bag/automem/basic/docu <<'-----'
#define TYPGEN bag
#include <aux/automem/basic/docu>
-----
cat >$OUT_DIR/bag/automem/basic/gptr <<'-----'
#include <aux/automem/basic/gptr>
-----
cat >$OUT_DIR/bag/automem/basic/gtyp <<'-----'
#include <aux/automem/basic/gtyp>
-----
cat >$OUT_DIR/bag/automem/basic/param <<'-----'
BASEIMPL
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
NOCHECK
-----
cat >$OUT_DIR/bag/automem/basic/vdm <<'-----'
#define REP_DOMAIN  ELEM1 -bag
#include <aux/automem/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/automem/card ] || mkdir $OUT_DIR/bag/automem/card
cat >$OUT_DIR/bag/automem/card/ccod <<'-----'
#define NAME   card
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/card/cmcr <<'-----'
#define NAME  card
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/card/vdm <<'-----'
#define NAME card
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/copy ] || mkdir $OUT_DIR/bag/automem/copy
cat >$OUT_DIR/bag/automem/copy/ccod <<'-----'
#include <aux/automem/copy/ccod>
-----
[ -d $OUT_DIR/bag/automem/copy1 ] || mkdir $OUT_DIR/bag/automem/copy1
cat >$OUT_DIR/bag/automem/copy1/vdm <<'-----'
! === automem: Operation bag/copy1 not supported === !
-----
[ -d $OUT_DIR/bag/automem/cvfromtup1 ] || mkdir $OUT_DIR/bag/automem/cvfromtup1
cat >$OUT_DIR/bag/automem/cvfromtup1/ccod <<'-----'
#include <aux/automem/cvfromtup1/ccod>
-----
cat >$OUT_DIR/bag/automem/cvfromtup1/param <<'-----'
#include <aux/automem/cvfromtup1/param>
-----
cat >$OUT_DIR/bag/automem/cvfromtup1/vdm <<'-----'
#include <aux/automem/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/bag/automem/cvfromtupl ] || mkdir $OUT_DIR/bag/automem/cvfromtupl
cat >$OUT_DIR/bag/automem/cvfromtupl/ccod <<'-----'
#include <aux/automem/cvfromtupl/ccod>
-----
cat >$OUT_DIR/bag/automem/cvfromtupl/param <<'-----'
#include <aux/automem/cvfromtupl/param>
-----
cat >$OUT_DIR/bag/automem/cvfromtupl/vdm <<'-----'
#include <aux/automem/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/bag/automem/cvlines ] || mkdir $OUT_DIR/bag/automem/cvlines
cat >$OUT_DIR/bag/automem/cvlines/ccod <<'-----'
#define NAME cvlines
#define RESULT Cvtext_vdmlib
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/cvlines/cmcr <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/cvlines/vdm <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/cvtotup1 ] || mkdir $OUT_DIR/bag/automem/cvtotup1
cat >$OUT_DIR/bag/automem/cvtotup1/ccod <<'-----'
#include <aux/automem/cvtotup1/ccod>
-----
cat >$OUT_DIR/bag/automem/cvtotup1/param <<'-----'
#include <aux/automem/cvtotup1/param>
-----
cat >$OUT_DIR/bag/automem/cvtotup1/vdm <<'-----'
#include <aux/automem/cvtotup1/vdm>
-----
[ -d $OUT_DIR/bag/automem/cvtotupl ] || mkdir $OUT_DIR/bag/automem/cvtotupl
cat >$OUT_DIR/bag/automem/cvtotupl/ccod <<'-----'
#include <aux/automem/cvtotupl/ccod>
-----
cat >$OUT_DIR/bag/automem/cvtotupl/param <<'-----'
#include <aux/automem/cvtotupl/param>
-----
cat >$OUT_DIR/bag/automem/cvtotupl/vdm <<'-----'
#include <aux/automem/cvtotupl/vdm>
-----
[ -d $OUT_DIR/bag/automem/del ] || mkdir $OUT_DIR/bag/automem/del
cat >$OUT_DIR/bag/automem/del/ccod <<'-----'
#include <aux/automem/del/ccod>
-----
cat >$OUT_DIR/bag/automem/del/vdm <<'-----'
#include <aux/automem/del/vdm>
-----
[ -d $OUT_DIR/bag/automem/del1 ] || mkdir $OUT_DIR/bag/automem/del1
cat >$OUT_DIR/bag/automem/del1/vdm <<'-----'
! === automem: Operation bag/del1 not required === !
-----
[ -d $OUT_DIR/bag/automem/diff ] || mkdir $OUT_DIR/bag/automem/diff
cat >$OUT_DIR/bag/automem/diff/ccod <<'-----'
#define NAME diff
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/bag/automem/diff/vdm <<'-----'
#define NAME diff
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/bag/automem/diffd ] || mkdir $OUT_DIR/bag/automem/diffd
cat >$OUT_DIR/bag/automem/diffd/vdm <<'-----'
! === automem: Operation bag/diffd not supported === !
-----
[ -d $OUT_DIR/bag/automem/exist ] || mkdir $OUT_DIR/bag/automem/exist
cat >$OUT_DIR/bag/automem/exist/vdm <<'-----'
! === automem: Operation bag/exist not supported === !
-----
[ -d $OUT_DIR/bag/automem/exist1 ] || mkdir $OUT_DIR/bag/automem/exist1
cat >$OUT_DIR/bag/automem/exist1/vdm <<'-----'
! === automem: Operation bag/exist1 not supported === !
-----
[ -d $OUT_DIR/bag/automem/fold ] || mkdir $OUT_DIR/bag/automem/fold
cat >$OUT_DIR/bag/automem/fold/vdm <<'-----'
! === automem: Operation bag/fold not supported === !
-----
[ -d $OUT_DIR/bag/automem/forall ] || mkdir $OUT_DIR/bag/automem/forall
cat >$OUT_DIR/bag/automem/forall/ccod <<'-----'
#include <aux/automem/forall/ccod>
-----
cat >$OUT_DIR/bag/automem/forall/cmcr <<'-----'
#include <aux/automem/forall/cmcr>
-----
cat >$OUT_DIR/bag/automem/forall/vdm <<'-----'
#include <aux/automem/forall/vdm>
-----
[ -d $OUT_DIR/bag/automem/forsome ] || mkdir $OUT_DIR/bag/automem/forsome
cat >$OUT_DIR/bag/automem/forsome/vdm <<'-----'
! === automem: Operation bag/forsome not supported === !
-----
[ -d $OUT_DIR/bag/automem/gcinfo ] || mkdir $OUT_DIR/bag/automem/gcinfo
cat >$OUT_DIR/bag/automem/gcinfo/ccod <<'-----'
#include <aux/automem/gcinfo/ccod>
-----
cat >$OUT_DIR/bag/automem/gcinfo/docu <<'-----'
#include <aux/automem/gcinfo/docu>
-----
cat >$OUT_DIR/bag/automem/gcinfo/vdm <<'-----'
#include <aux/automem/gcinfo/vdm>
-----
[ -d $OUT_DIR/bag/automem/hash ] || mkdir $OUT_DIR/bag/automem/hash
cat >$OUT_DIR/bag/automem/hash/ccod <<'-----'
#define NAME hash
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/hash/cmcr <<'-----'
#define NAME hash
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/hash/vdm <<'-----'
#define NAME hash
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/input ] || mkdir $OUT_DIR/bag/automem/input
cat >$OUT_DIR/bag/automem/input/vdm <<'-----'
! === automem: Operation bag/input not supported === !
-----
[ -d $OUT_DIR/bag/automem/inters ] || mkdir $OUT_DIR/bag/automem/inters
cat >$OUT_DIR/bag/automem/inters/ccod <<'-----'
#define NAME inters
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/bag/automem/inters/vdm <<'-----'
#define NAME inters
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/bag/automem/intersd ] || mkdir $OUT_DIR/bag/automem/intersd
cat >$OUT_DIR/bag/automem/intersd/vdm <<'-----'
! === automem: Operation bag/intersd not supported === !
-----
[ -d $OUT_DIR/bag/automem/is_empty ] || mkdir $OUT_DIR/bag/automem/is_empty
cat >$OUT_DIR/bag/automem/is_empty/ccod <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/is_empty/cmcr <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/is_empty/vdm <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/is_eq ] || mkdir $OUT_DIR/bag/automem/is_eq
cat >$OUT_DIR/bag/automem/is_eq/ccod <<'-----'
#define NAME is_eq
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/is_eq/cmcr <<'-----'
#define NAME is_eq
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/is_eq/vdm <<'-----'
#define NAME is_eq
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/is_ge ] || mkdir $OUT_DIR/bag/automem/is_ge
cat >$OUT_DIR/bag/automem/is_ge/vdm <<'-----'
! === automem: Operation bag/is_ge not supported === !
-----
[ -d $OUT_DIR/bag/automem/is_gr ] || mkdir $OUT_DIR/bag/automem/is_gr
cat >$OUT_DIR/bag/automem/is_gr/vdm <<'-----'
! === automem: Operation bag/is_gr not supported === !
-----
[ -d $OUT_DIR/bag/automem/is_in ] || mkdir $OUT_DIR/bag/automem/is_in
cat >$OUT_DIR/bag/automem/is_in/ccod <<'-----'
#define NAME is_in
#define PTYPE1 ELEM1
#define P1_IS_ELEM
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/is_in/cmcr <<'-----'
#define NAME is_in
#define TWO_PARAM
#define P1_IS_ELEM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/is_in/vdm <<'-----'
#define NAME is_in
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/is_subbag ] || mkdir $OUT_DIR/bag/automem/is_subbag
cat >$OUT_DIR/bag/automem/is_subbag/ccod <<'-----'
#define NAME is_subbag
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/is_subbag/cmcr <<'-----'
#define NAME is_subbag
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/is_subbag/vdm <<'-----'
#define NAME is_subbag
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/iterator ] || mkdir $OUT_DIR/bag/automem/iterator
cat >$OUT_DIR/bag/automem/iterator/vdm <<'-----'
#include <aux/automem/iterator/vdm>
DOMAINS
IMPLEMENTATIONS
  Rep##_DOMAIN = + iterator("INTERNALFCT")
-----
[ -d $OUT_DIR/bag/automem/mk1 ] || mkdir $OUT_DIR/bag/automem/mk1
cat >$OUT_DIR/bag/automem/mk1/ccod <<'-----'
#define NAME mk1
#define PTYPE1 ELEM1
#define _PTYPE1 _ELEM1
#define P1_INSERTED
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/bag/automem/mk1/vdm <<'-----'
#define NAME mk1
#define PTYPE1 ELEM1
#define P1_INSERTED
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk1
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/automem/mk1n ] || mkdir $OUT_DIR/bag/automem/mk1n
cat >$OUT_DIR/bag/automem/mk1n/ccod <<'-----'
#define NAME    mk1n
#define P1_INSERTED
#define PTYPE2  Nat0
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/bag/automem/mk1n/vdm <<'-----'
#define NAME   mk1n
#define P1_INSERTED
#define PTYPE2 Nat0
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk1n
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/automem/mk_empty ] || mkdir $OUT_DIR/bag/automem/mk_empty
cat >$OUT_DIR/bag/automem/mk_empty/ccod <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/bag/automem/mk_empty/vdm <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/vdm>
#define CONSTRNAME mk_empty
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/automem/occurs ] || mkdir $OUT_DIR/bag/automem/occurs
cat >$OUT_DIR/bag/automem/occurs/ccod <<'-----'
#define NAME occurs
#define RESULT Nat0
#define PTYPE1 ELEM1
#define P1_IS_ELEM
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/bag/automem/occurs/cmcr <<'-----'
#define NAME occurs
#define TWO_PARAM
#define P1_IS_ELEM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/bag/automem/occurs/vdm <<'-----'
#define NAME occurs
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/bag/automem/parse ] || mkdir $OUT_DIR/bag/automem/parse
cat >$OUT_DIR/bag/automem/parse/ccod <<'-----'
#include <aux/automem/parse/ccod>
-----
cat >$OUT_DIR/bag/automem/parse/vdm <<'-----'
#include <aux/automem/parse/vdm>
-----
[ -d $OUT_DIR/bag/automem/pr ] || mkdir $OUT_DIR/bag/automem/pr
cat >$OUT_DIR/bag/automem/pr/vdm <<'-----'
! === automem: Operation bag/pr not supported === !
-----
[ -d $OUT_DIR/bag/automem/sel ] || mkdir $OUT_DIR/bag/automem/sel
cat >$OUT_DIR/bag/automem/sel/ccod <<'-----'
#define NAME sel
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/bag/automem/sel/cmcr <<'-----'
#define NAME sel
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/bag/automem/sel/vdm <<'-----'
#define NAME sel
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/bag/automem/sort ] || mkdir $OUT_DIR/bag/automem/sort
cat >$OUT_DIR/bag/automem/sort/ccod <<'-----'
#include <aux/automem/sort/ccod>
-----
cat >$OUT_DIR/bag/automem/sort/param <<'-----'
#include <aux/automem/sort/param>
-----
cat >$OUT_DIR/bag/automem/sort/vdm <<'-----'
#include <aux/automem/sort/vdm>
-----
[ -d $OUT_DIR/bag/automem/sub1 ] || mkdir $OUT_DIR/bag/automem/sub1
cat >$OUT_DIR/bag/automem/sub1/ccod <<'-----'
#define NAME sub1
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/bag/automem/sub1/vdm <<'-----'
#define NAME sub1
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/bag/automem/sub1all ] || mkdir $OUT_DIR/bag/automem/sub1all
cat >$OUT_DIR/bag/automem/sub1all/ccod <<'-----'
#define NAME sub1all
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/bag/automem/sub1all/vdm <<'-----'
#define NAME sub1all
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/bag/automem/sub1alld ] || mkdir $OUT_DIR/bag/automem/sub1alld
cat >$OUT_DIR/bag/automem/sub1alld/vdm <<'-----'
! === automem: Operation bag/sub1alld not supported === !
-----
[ -d $OUT_DIR/bag/automem/sub1d ] || mkdir $OUT_DIR/bag/automem/sub1d
cat >$OUT_DIR/bag/automem/sub1d/vdm <<'-----'
! === automem: Operation bag/sub1alld not supported === !
-----
[ -d $OUT_DIR/bag/automem/sub1n ] || mkdir $OUT_DIR/bag/automem/sub1n
cat >$OUT_DIR/bag/automem/sub1n/ccod <<'-----'
#define NAME    sub1n
#define PTYPE3  Nat0
#define _PTYPE3 nat0
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/bag/automem/sub1n/vdm <<'-----'
#define NAME   sub1n
#define PTYPE3 Nat0
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/bag/automem/sub1nd ] || mkdir $OUT_DIR/bag/automem/sub1nd
cat >$OUT_DIR/bag/automem/sub1nd/vdm <<'-----'
! === automem: Operation bag/sub1nd not supported === !
-----
[ -d $OUT_DIR/bag/automem/union ] || mkdir $OUT_DIR/bag/automem/union
cat >$OUT_DIR/bag/automem/union/ccod <<'-----'
#define NAME union
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/bag/automem/union/vdm <<'-----'
#define NAME union
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/bag/automem/union1 ] || mkdir $OUT_DIR/bag/automem/union1
cat >$OUT_DIR/bag/automem/union1/ccod <<'-----'
#define NAME union1
#define P2_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/bag/automem/union1/vdm <<'-----'
#define NAME union1
#define P2_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/bag/automem/union1d ] || mkdir $OUT_DIR/bag/automem/union1d
cat >$OUT_DIR/bag/automem/union1d/vdm <<'-----'
! === automem: Operation bag/union1d not supported === !
-----
[ -d $OUT_DIR/bag/automem/union1n ] || mkdir $OUT_DIR/bag/automem/union1n
cat >$OUT_DIR/bag/automem/union1n/ccod <<'-----'
#define NAME    union1n
#define PTYPE3  Nat0
#define _PTYPE3 nat0
#define P2_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/bag/automem/union1n/vdm <<'-----'
#define NAME   union1n
#define PTYPE3 Nat0
#define P2_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/bag/automem/union1nd ] || mkdir $OUT_DIR/bag/automem/union1nd
cat >$OUT_DIR/bag/automem/union1nd/vdm <<'-----'
! === automem: Operation bag/union1nd not supported === !
-----
[ -d $OUT_DIR/bag/automem/uniond ] || mkdir $OUT_DIR/bag/automem/uniond
cat >$OUT_DIR/bag/automem/uniond/vdm <<'-----'
! === automem: Operation set/uniond not supported === !
-----
[ -d $OUT_DIR/bag/com ] || mkdir $OUT_DIR/bag/com
[ -d $OUT_DIR/bag/com/all ] || mkdir $OUT_DIR/bag/com/all
cat >$OUT_DIR/bag/com/all/docu <<'-----'
#include <aux/com/all/docu>
-----
cat >$OUT_DIR/bag/com/all/vdm <<'-----'
#include <aux/com/all/vdm>
-----
[ -d $OUT_DIR/bag/com/basic ] || mkdir $OUT_DIR/bag/com/basic
cat >$OUT_DIR/bag/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/bag/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = Elem -bag

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + mk_empty
   + mk1
   + mk1n

   + card

   + copy1
   + copy
   + union1
   + union1d
   + union1n
   + union1nd 
   + sub1
   + sub1n
   + sub1all
   + sub1d
   + sub1nd
   + sub1alld
   + union
   + uniond 
   + diff
   + diffd
   + inters
   + intersd
   + sel

   + is_eq
   + is_empty
   + is_in
   + is_subbag
   + occurs

   + forall
   + forsome

   + binary.bf(RESULT=Bool,FOLDFCT="bfoldf",NOFOLDENR)
   + fold.ff(RESULT=Bool,NULLFCT="fnullf",CVFCT="fcvf",FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)
   + fold.ff1(RESULT=Bool,NULLPARAM,CVFCTVAR,FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)
   /* 'ff2' is generated only but not called, to check XXXX and XXXXX */
   + fold.ff2(RESULT=Bool,NULLPARAM,CVFCTVAR,FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,XXXX=Bool,XXXXX=Str,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput
   + all + exist + exist1

-----
cat >$OUT_DIR/bag/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Elem = BASIC -bag

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + mk_empty
   + mk1
   + mk1n

   + union1d 
   + union1nd

   + is_eq
-----
cat >$OUT_DIR/bag/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbdele>

#define nilbag MERGE(mk_empty,_domain)()

#define onebag(elem) MERGE(mk1,_domain)(elem)
#define onenbag(elem,n) MERGE(mk1n,_domain)(elem,n)

/* global table using for union1n(d), sub1n(d), mk1n and onenbag */
#define len_ntab 5
Nat0 ntab[ len_ntab ] = { 0, 1, 2, 3, 10 }; 

#define MAXARGTEXT 1000
#define MAXNUMSTR 100
static char arg_text_buf[MAXARGTEXT+MAXNUMSTR+1];
static char *arg_text(s,n)
/**********************************************************************
 returns "s string(n)"
 s: char * = any string (max. MAXARGTEXT characters used)
 n: long   = any number (max. MAXNUMSSTR digits (+ sign)
 global var.: arg_text_buf (stores the string)
***********************************************************************/
char *s;
long  n;
{
 char nstr[MAXNUMSTR+1];
 
 sprintf(nstr," %ld",n);
 
 strncpy(arg_text_buf,s,MAXARGTEXT);
 arg_text_buf[MAXARGTEXT] = '\0';
 
 strncat(arg_text_buf,nstr,MAXNUMSTR);
 arg_text_buf[MAXARGTEXT+MAXNUMSTR] = '\0';
   
 return arg_text_buf;
}
#undef MAXARGTEXT
#undef MAXNUMSTR



Domain bigbag()
{
  Nat0 n = 0;
  
  Domain bighelp =
   @( union1d##_domain( 
   @)  nilbag 
   @( ,@X@) 
   @)
  ;

  /* for testing the implementation linklist the @X@-elements should not to
     be sorted in the bigbag -> another union-operations! 
     occurs( "first"  @X@, bigbag() ) == 1; 
     occurs( "second" @X@, bigbag() ) == 2;
     occurs( "third"  @X@, bigbag() ) == 3;
     etc.
  */

   @( bighelp = union1nd##_domain( bighelp, @X@, n++ );
   @)

 return bighelp;
}

/*------------------------------------------------------------------------------------------------*/

int bignum()
{
   int i = 0;
   int n = 0;
@( i += ++n;  /* == occurs(@X@,BIGBAG) */
@) 
   return( i );
}

/*================================================================================================*/

int glob = -1;
Domain glob_bag;

/*------------------------------------------------------------------------------------------------*/

void clear_glob ()

{ if (glob != -1) del1##_domain(glob_bag);
  glob = 0;
  glob_bag = nilbag;
}

/*------------------------------------------------------------------------------------------------*/

void for_test (_FP(elem,Elem)) _EP(elem,Elem)
{ ++glob;
  glob_bag = union1##_domain( glob_bag, elem );
}

/*------------------------------------------------------------------------------------------------*/

Bool forsome_test (_FP(elem,Elem)) _EP(elem,Elem)
{ Elem e; /* Nur lokales Element lschen */ 
 
  Bool r = is_eq##_elem( elem, e = @Y@ );
 
  del##_elem(e);
  return r;
}

/*================================================================================================*/

Bool bfoldf##_domain ( _FP(result,Bool), _FP(elem,Elem) ) _EP(result,Bool) _EP(elem,Elem)
{ Domain bighelp;
  Bool r;
  bighelp = bigbag();

  r = result && is_in##_domain( elem, bighelp );
  
  del##_domain(bighelp);
  return r;
}

/*================================================================================================*/

Bool fnullf_bool ()

{ return TRUE;
}

/*------------------------------------------------------------------------------------------------*/

Bool fcvf##_elem ( elem, vx, vxx, vxxx, vy, vyy, vyyy )

  Elem elem;
  Elem vx,vy; BASIC vxx,vyy; Bool vxxx,vyyy;

{ Domain dbig = bigbag(); /* nur lokale DOMAIN-Instanz lschen */
  Elem   eZe  = @Z@,      /* dito fr lokale Elemente          */
         eYe  = @Y@;
  
  Bool r = is_in##_domain( elem, dbig ) &&
           is_eq##_elem( vx, eZe ) &&
           vxx == ccc &&
           vxxx &&
           is_eq##_elem( vy, eYe ) &&
           vyy == bbb &&
           ! vyyy ;
  
  del##_domain(dbig);
  del##_elem(eZe);
  del##_elem(eYe);
  return r;
}

/*------------------------------------------------------------------------------------------------*/

Bool ffoldf_bool ( result1, result2, vy, vyy, vyyy, vz, vzz, vzzz )

  Bool result1, result2;
  Elem vy,vz; BASIC vyy,vzz; Bool vyyy,vzzz;

{ 
  Domain dbig = bigbag(); /* Zum Lschen lokaler Variable! */
  Elem   eYe  = @Y@; 	  /* dito */

  Bool r = result1 && 
           result2 && 
           is_in##_domain( vz, dbig ) &&
           vzz == aaa  &&
           vzzz &&
           is_eq##_elem( vy, eYe ) &&
           vyy == bbb && 
           !vyyy;

  del##_elem(eYe);
  del##_domain(dbig);
  return r;
}

#include <aux/com/basic/bbid2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ nilbag ) )
       myerr(@n@,"mk_empty()","");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ onebag(@X@) ), E_ @X@ ) )
       myerr(@n@,"mk1()","@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if( card##_domain( D_ nilbag ) != 0 )
       myerr(@n@,"card()","{}");
   DD }

   void p_@N@()
   {
@(   if( card##_domain( D_ onebag(@X@) ) != 1 )
       myerr(@n@,"card()","{@X@}");
@) DD }

   void p_@N@()
   { if( card##_domain( D_ bigbag() ) != bignum() )
       myerr(@n@,"card()","BIGBAG");
   DD }

/*================================================================================================*/

#define CHECK(x,n,occbig) (MERGE(is_empty,_domain)(D_ onenbag((x),(n)) ) == ((n)==0))
#define OPTEXT is_empty,mk1n
#define ARGTEXT @X@
#include <bag/com/basic/forxn.inc>

#define CHECK(x,n,occbig) (MERGE(occurs,_domain)(E_ (x), D_ onenbag((x),(n)) ) == (n))
#define OPTEXT occurs,mk1n
#define ARGTEXT @X@
#include <bag/com/basic/forxn.inc>

#define CHECK(x,n,occbig) (MERGE(card,_domain)( D_ onenbag((x),(n)) ) == (n))
#define OPTEXT card,mk1n
#define ARGTEXT @X@
#include <bag/com/basic/forxn.inc>

/*================================================================================================*/

#define ARG_ELEM @X@
#define ARG_BAG bigbag()
#define ARG_TXT @X@,BIGBAG
#define REPEAT
#include <bag/com/basic/occ.inc>

#define ARG_ELEM @Y@
#define ARG_BAG bigbag()
#define ARG_TXT @Y@,BIGBAG
#include <bag/com/basic/occ.inc>

#define ARG_ELEM @X@
#define ARG_BAG nilbag
#define ARG_TXT @X@,{}
#define REPEAT
#define OCC_RES 0
#include <bag/com/basic/occ.inc>

#define ARG_ELEM @X@
#define ARG_BAG onebag(@X@)
#define ARG_TXT @X@,{@X@}
#define REPEAT
#define OCC_RES 1
#include <bag/com/basic/occ.inc>

#define ARG_ELEM @Y@
#define ARG_BAG onebag(@Y@)
#define ARG_TXT @Y@,{@Y@}
#define OCC_RES 1
#include <bag/com/basic/occ.inc>

#define ARG_ELEM @Y@
#define ARG_BAG onebag(@X@)
#define ARG_TXT @Y@,{@X@}
#define REPEAT
#define OCC_RES 0
#include <bag/com/basic/occ.inc>

#define ARG_ELEM @X@
#define ARG_BAG onebag(@Y@)
#define ARG_TXT @X@,{@Y@}
#define REPEAT
#define OCC_RES 0
#include <bag/com/basic/occ.inc>

/* the combination onenbag/occurs is already tested (see last paragraph)! */

/*================================================================================================*/

#define ARG nilbag
#define TEXT {}
#include <aux/com/copy1/bbc2>

#define ARG onebag(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG bigbag()
#include <aux/com/copy1/bbc2>

#define ARG nilbag
#define TEXT {}
#include <aux/com/copy/bbc2>

#define ARG onebag(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/copy/bbc2>

#define ARG bigbag()
#include <aux/com/copy/bbc2>


/*================================================================================================*/

#ifndef WITHOUT_NO_DEL

#undef NUMBER
#undef DELETE
#include <bag/com/basic/union1.inc>

#define NUMBER
#undef DELETE
#include <bag/com/basic/union1.inc>

#endif

#ifndef WITHOUT_DEL

#undef NUMBER
#define DELETE
#include <bag/com/basic/union1.inc>

#define NUMBER
#define DELETE
#include <bag/com/basic/union1.inc>

#endif

/*================================================================================================*/

#ifndef WITHOUT_NO_DEL

#undef NUMBER
#undef DELETE
#undef ALL
#include <bag/com/basic/sub1.inc>

#define NUMBER
#undef DELETE
#undef ALL
#include <bag/com/basic/sub1.inc>

#undef NUMBER
#undef DELETE
#define ALL
#include <bag/com/basic/sub1.inc>

#endif

#ifndef WITHOUT_DEL

#undef NUMBER
#define DELETE
#undef ALL
#include <bag/com/basic/sub1.inc>

#define NUMBER
#define DELETE
#undef ALL
#include <bag/com/basic/sub1.inc>

#undef NUMBER
#define DELETE
#define ALL
#include <bag/com/basic/sub1.inc>

#endif

/*================================================================================================*/

#ifndef WITHOUT_NO_DEL

#undef DELETE
#include <bag/com/basic/union.inc>

#endif

#ifndef WITHOUT_DEL

#define DELETE
#include <bag/com/basic/union.inc>

#endif

/*================================================================================================*/

#ifndef WITHOUT_NO_DEL

#undef DELETE
#include <bag/com/basic/diff.inc>

#endif

#ifndef WITHOUT_DEL

#define DELETE
#include <bag/com/basic/diff.inc>

#endif

/*================================================================================================*/

#ifndef WITHOUT_NO_DEL

#undef DELETE
#include <bag/com/basic/inters.inc>

#endif

#ifndef WITHOUT_DEL

#define DELETE
#include <bag/com/basic/inters.inc>

#endif

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ onebag(@X@) ), E_ @X@ ) )
       myerr(@n@,"sel()","{@X@}");
@) DD EE }

   void p_@N@()
   { Domain bighelp = bigbag();
     Elem elem;
     int i = bignum();
     while(i--)
     { if(! is_in##_domain( ( elem = sel##_domain( bighelp ) ), bighelp ) )
         myerr(@n@,"sel() /1","BIGBAG");
       bighelp = sub1d##_domain( bighelp, elem );
     }
     if(! is_empty##_domain( bighelp ) )
       myerr(@n@,"sel() /2","BIGBAG");
 
    del##_domain(bighelp);
   }

/*================================================================================================*/

#define ARG nilbag
#define TEXT {},{}
#include <aux/com/is_eq/bbc2>

#define ARG nilbag
#define ARG2 onebag(@X@)
#define TEXT {},{@X@}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG nilbag
#define ARG2 bigbag()
#define NEG
#define TEXT {},ARG2
#include <aux/com/is_eq/bbc2>

#define ARG onebag(@X@)
#define ARG2 nilbag
#define TEXT {@X@},{}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onebag(@Y@)
#define ARG2 onebag(@X@)
#define TEXT {@Y@},{@X@}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onebag(@X@)
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onebag(@X@)
#define ARG2 bigbag()
#define TEXT {@X@},ARG2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigbag()
#define ARG2 nilbag
#define TEXT ARG,{}
#define NEG
#include <aux/com/is_eq/bbc2>

#define ARG bigbag()
#define ARG2 onebag(@X@)
#define TEXT ARG,{@X@}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigbag()
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ nilbag ) )
       myerr(@n@,"is_empty()","{}");
   DD }

   void p_@N@()
   {
@(   if( is_empty##_domain( D_ onebag(@X@) ) )
       myerr(@n@,"is_empty()","{@X@}");
@) DD }

   void p_@N@()
   { if( is_empty##_domain( D_ bigbag() ) )
       myerr(@n@,"is_empty()","BIGBAG");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ nilbag ) )
       myerr(@n@,"is_in()","@X@,{}");
@( DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ onebag(@Y@) ) )
       myerr(@n@,"is_in()","@X@,{@Y@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ onebag(@X@) ) )
       myerr(@n@,"is_in()","@X@,{@X@}");
@) DD EE }

   void p_@N@()
   { if( is_in##_domain( E_ @Y@, D_ bigbag() ) )
       myerr(@n@,"is_in()","@Y@,BIGBAG");
   DD EE }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ bigbag() ) )
       myerr(@n@,"is_in()","@X@,BIGBAG");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if(! is_subbag##_domain( D_ nilbag, D_ nilbag ) )
       myerr(@n@,"is_subbag()","{},{}");
   DD }

   void p_@N@()
   {
@(   if( is_subbag##_domain( D_ onebag(@X@), D_ nilbag ) )
       myerr(@n@,"is_subbag()","{@X@},{}");
@) DD }

   void p_@N@()
   { if( is_subbag##_domain( D_ bigbag(), D_ nilbag ) )
       myerr(@n@,"is_subbag()","BIGBAG,{}");
   DD }

   void p_@N@()
   {
@(   if(! is_subbag##_domain( D_ nilbag, D_ onebag(@X@) ) )
       myerr(@n@,"is_subbag()","{},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if( is_subbag##_domain( D_ onebag(@X@), D_ onebag(@Y@) ) )
       myerr(@n@,"is_subbag()","{@X@},{@Y@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_subbag##_domain( D_ onebag(@X@), D_ onebag(@X@) ) )
       myerr(@n@,"is_subbag()","{@X@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if( is_subbag##_domain( D_ bigbag(), D_ onebag(@X@) ) )
       myerr(@n@,"is_subbag()","BIGBAG,{@X@}");
@) DD }

   void p_@N@()
   { if(! is_subbag##_domain( D_ nilbag, D_ bigbag() ) )
       myerr(@n@,"is_subbag()","{},BIGBAG");
   DD }

   void p_@N@()
   { if( is_subbag##_domain( D_ onebag(@Y@), D_ bigbag() ) )
       myerr(@n@,"is_subbag()","{@Y@},BIGBAG");
   DD }

   void p_@N@()
   {
@(   if(! is_subbag##_domain( D_ onebag(@X@), D_ bigbag() ) )
       myerr(@n@,"is_subbag()","{@X@},BIGBAG");
@) DD }

   void p_@N@()
   { if(! is_subbag##_domain( D_ bigbag(), D_ bigbag() ) )
       myerr(@n@,"is_subbag()","BIGBAG,BIGBAG");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ nilbag, for_test );
     if( glob != 0 )
       myerr(@n@,"forall()","{}");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forall##_domain( D_ onebag(@X@), for_test );
     if( glob != 1 ) 
       myerr(@n@,"forall() /1","{@X@}");
     if(! is_eq##_domain( glob_bag, D_ onebag(@X@) ) )
       myerr(@n@,"forall() /2","{@X@}");
@) DD }

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ bigbag(), for_test );
       if( glob != bignum() )
         myerr(@n@,"forall() /1","BIGBAG");
       if(! is_eq##_domain( glob_bag, D_ bigbag() ) )
         myerr(@n@,"forall() /2","BIGBAG");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ nilbag, forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","{}");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forsome##_domain( D_ onebag(@X@), forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","{@X@}");
@) DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ onebag(@Y@), forsome_test, for_test );
     if( glob != 1 )
       myerr(@n@,"forsome() /1","{@Y@}");
     if(! is_eq##_domain( glob_bag, D_ onebag(@Y@) ) )
       myerr(@n@,"forsome() /2","{@Y@}");
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ bigbag(), forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","BIGBAG");
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ union1d##_domain( bigbag(), @Y@ ), forsome_test, for_test );
     if( glob != 1 )
       myerr(@n@,"forsome() /1","BIGBAG+@Y@");
     if(! is_eq##_domain( glob_bag, D_ onebag(@Y@) ) )
       myerr(@n@,"forsome() /2","BIGBAG+@Y@");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if( bf##_domain( TRUE, D_ nilbag ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","{}");
   DD }

   void p_@N@()
   {
@(   if( bf##_domain( TRUE, D_ onebag( @X@) ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","{@X@}");
@) DD }

   void p_@N@()
   { if( bf##_domain( TRUE, D_ bigbag() ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","BIGBAG");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( ff##_domain( D_ nilbag, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","{},@X@,aaa,@Y@,bbb,@Z@,ccc");
     if( ff1##_domain( D_ nilbag, TRUE, fcvf##_elem, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"fold-Funktional ff1()","{},@X@,aaa,@Y@,bbb,@Z@,ccc");
@) DD EE }

   void p_@N@()
   {
@(   if( ff##_domain( D_ onebag(@X@), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE )
         != TRUE )
       myerr(@n@,"fold-Funktional ff()","{@X@},@Z@,ccc,@Y@,bbb,@X@,aaa");
     if( ff1##_domain( D_ onebag(@X@),TRUE,fcvf##_elem, E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE )
         != TRUE )
       myerr(@n@,"fold-Funktional ff1()","{@X@},@Z@,ccc,@Y@,bbb,@X@,aaa");
@) DD EE }

   void p_@N@()
   {
@(   if( ff##_domain( D_ bigbag(), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","BIGBAG,@Z@,ccc,@Y@,bbb,@X@,aaa");
     if( ff1##_domain( D_ bigbag(),TRUE, fcvf##_elem, E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"fold-Funktional ff1()","BIGBAG,@Z@,ccc,@Y@,bbb,@X@,aaa");
@) DD EE }

/*================================================================================================*/

#define ARG nilbag
#define TEXT {}
#include <aux/com/cvtotupl/bbc2>

#define ARG onebag(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/cvtotupl/bbc2>

#define ARG bigbag()
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG nilbag
#define TEXT {}
#include <aux/com/hash/bbc2>

#define ARG onebag(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/hash/bbc2>

#define ARG bigbag()
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG nilbag
#include <aux/com/del1/bbc2>

#define ARG onebag(@X@)
#define REPEAT
#include <aux/com/del1/bbc2>

#define ARG bigbag()
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG nilbag
#include <aux/com/del/bbc2>

#define ARG onebag(@X@)
#define REPEAT
#include <aux/com/del/bbc2>

#define ARG bigbag()
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG nilbag
#include <aux/com/print/bbc2>

#define ARG onebag(@X@)
#define REPEAT
#include <aux/com/print/bbc2>

#define ARG bigbag()
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG nilbag
#include <aux/com/pr/bbc2>

#define ARG onebag(@X@)
#define REPEAT
#include <aux/com/pr/bbc2>

#define ARG bigbag()
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG nilbag
#include <aux/com/fpr/bbc2>

#define ARG onebag(@X@)
#define REPEAT
#include <aux/com/fpr/bbc2>

#define ARG bigbag()
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/bag/com/basic/bbd1 <<'-----'
@X@=
mk_empty##_elem()
mk1##_elem(xxx)
mk1##_elem(yyy)
mk1##_elem(zzz)
mk1n##_elem(xxx,(Nat0)10)
union1d##_elem(union1d##_elem(mk1##_elem(xxx),yyy),zzz)
union1nd##_elem(union1nd##_elem(mk1n##_elem(xxx,(Nat0)5),yyy,(Nat0)5),zzz,(Nat0)5)

@Y@=
mk1##_elem(ppp)

@Z@=
mk1##_elem(qqq)
-----
cat >$OUT_DIR/bag/com/basic/diff.inc <<'-----'
#include <bag/com/basic/mkstr.inc>
#include <bag/com/basic/testxbig.inc>

#ifdef DELETE
#define DEL d
#define DE_
#else
#define DEL
#define DE_ E_
#endif

#define DIFF MERGE(diff,DEL) 
#define DIFFTEXT MERGE(DIFF,())

#define RESTX(occx1,occx2) ( (occx1) > (occx2) ? (occx1) - (occx2) : 0 )


   void p_@N@()
   { if(! is_empty##_domain( D_ DIFF##_domain( nilbag, D_ nilbag ) ) )
       myerr(@n@,MKSTR2(DIFF,()),"{},{}");
   DD }


#define CHECK1(x,n,DF) ( MERGE(is_empty,_domain)( D_ MERGE(DF,_domain)( nilbag,\
D_ onenbag(x,n) ) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT {},{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


   void p_@N@()
   { if(! is_empty##_domain( D_ DIFF##_domain( nilbag, D_ bigbag() ) ) )
       myerr(@n@,MKSTR2(DIFF,()),"{},BIGBAG");
   DD }


#define CHECK1(x,n,DF) ( MERGE(is_eq,_domain)( D_ MERGE(DF,_domain)( onenbag(x,n),\
D_ nilbag ), D_ onenbag(x,n) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT {@X@..@X@},{}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


#define CHECK1(x,n,DF) ( MERGE(is_eq,_domain)( D_ MERGE(DF,_domain)( onebag(@Y@),\
D_ onenbag(x,n) ), D_ onebag(@Y@) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT {@Y@},{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


#define CHECK1(x,n,DF) ( MERGE(is_eq,_domain)( D_ MERGE(DF,_domain)( onenbag(@Y@,n),\
D_ onebag(x) ), D_ onenbag(@Y@,n) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT {@Y@..@Y@},{@X@}; card({@Y@..@Y@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "onenbag(x,n)" bleiben Reste brig!)                                  */
#define CHECK1(x,n,DF) ( MERGE(is_empty,_domain)( D_ MERGE(DF,_domain)( onenbag(x,n),\
D_ onenbag(x,n) ) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT {@X@..@X@},{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "onenbag(x,n)" bleiben Reste brig!)                                  */
#define CHECK1(x,n,occbig,DF) ( MERGE(occurs,_domain)( E_ x, D_ MERGE(DF,_domain)(\
onenbag(x,n), D_ bigbag() ) ) == RESTX(n,occbig) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT {@X@..@X@},BIGBAG; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1

/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "bigbag()" bleiben Reste brig!)                                      */
#define CHECK1(x,n,occbig,DF) ( MERGE(occurs,_domain)( E_ x, D_ MERGE(DF,_domain)(\
bigbag(), D_ onenbag(x,n) ) ) == RESTX(occbig,n) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT BIGBAG,{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "onenbag(x,n)" bleiben Reste brig!)                                  */
#define CHECK1(x,n,occbig,DF) ( MERGE(card,_domain)( D_ MERGE(DF,_domain)(\
onenbag(x,n), D_ bigbag() ) ) == RESTX(n,occbig) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT {@X@..@X@},BIGBAG; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "bigbag()" bleiben Reste brig!)                                      */
#define CHECK1(x,n,occbig,DF) ( MERGE(card,_domain)( D_ MERGE(DF,_domain)(\
bigbag(), D_ onenbag(x,n) ) ) == bignum() - (occbig) + RESTX(occbig,n) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT BIGBAG,{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "bigbag()" bleiben Reste brig!)                                      */
#define CHECK1(x,n,DF) ( MERGE(is_subbag,_domain)( D_ MERGE(DF,_domain)( bigbag(),\
D_ onenbag(x,n) ), D_ bigbag() ) )
#define CHECK(x,n,occbig) CHECK1(x,n,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT BIGBAG,{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "bigbag()" bleiben Reste brig!)                                      */
#define CHECK1(x,n,occbig,DF) ( test_x_bigbag( D_ MERGE(DF,_domain)( bigbag(),\
D_ onenbag(x,n) ), E_ x, RESTX(occbig,n) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,DIFF)
#define OPTEXT DIFFTEXT
#define ARGTEXT BIGBAG,{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


   void p_@N@()
   { if(! is_eq##_domain( D_ DIFF##_domain( bigbag(), D_ nilbag ), 
                          D_ bigbag() ) )
       myerr(@n@,MKSTR2(DIFF,()),"BIGBAG,{}");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ DIFF##_domain( bigbag(), D_ onebag(@Y@) ), 
                          D_ bigbag() ) )
       myerr(@n@,MKSTR2(DIFF,()),"BIGBAG,{@Y@}");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ DIFF##_domain( bigbag(), D_ bigbag() ) ) )
       myerr(@n@,MKSTR2(DIFF,()),"BIGBAG,BIGBAG");
   DD }


#undef RESTX
#undef DIFF
#undef DIFFTEXT
#undef DELETE
#undef DEL
#undef DE_
-----
cat >$OUT_DIR/bag/com/basic/docu <<'-----'
Syntax:

   Abag = Element -bag

ISO like Syntax ( -N option ):

   Abag = bag of Element

Description:

  '-bag' (ISO: bag of <type> )
  defines the domain of all finite subsets of a given datatype,
  in contrast to the '-set' datatype elements may occur more than
  once in a set, this data type is sometimes also called multiset.

  For all set operations are there are similar bag operations,
  but there is an extra operation occurs for finding out how often
  an element is in a bag.

Example :

  Let Nat0 be the data type for natural numbers, then

      NumberBag = Nat0 -set

  or in ISO like syntax

      NumberBag = bag of Nat0

  is a datatype for mulisets over the natural numbers.
  One application of bags is the simulation of maps with
  natural numbers as attributes:

      AMap = map SomeKey to Nat1

  can be implemented with

      AMap1 = bag of SomeKey

  this model is often more elegant than the map model, e.g. for the
  bills of materal example.
  



-----
cat >$OUT_DIR/bag/com/basic/forxn.inc <<'-----'
#include <bag/com/basic/mkstr.inc>

  void p_@N@()
   {
    int  __for_i;
    int  __occ_big;

    for( __for_i = 0; __for_i < len_ntab; __for_i++ )
      {
       __occ_big = 0;
@(    
       __occ_big++; /* == occurs(x,BIGBAG) */ 
       if( !( CHECK(@X@,ntab[__for_i],__occ_big) ) )
         myerr(@n@,MKSTR1(OPTEXT),arg_text(MKSTR1(ARGTEXT),
               (long) ntab[__for_i]));
@)
       DD EE /* innerhalb der Schleife loeschen, sonst zu viele! */
      }
   }
#undef CHECK
#undef OPTEXT
#undef ARGTEXT
-----
cat >$OUT_DIR/bag/com/basic/inters.inc <<'-----'
#include <bag/com/basic/mkstr.inc>

#ifdef DELETE
#define DEL d
#define DE_
#else
#define DEL
#define DE_ E_
#endif

#define INTERS MERGE(inters,DEL) 
#define INTERSTEXT MERGE(INTERS,())

#define RESTX(occx1,occx2) ( (occx1) > (occx2) ? (occx2) : (occx1) )


   void p_@N@()
   { if(! is_empty##_domain( D_ INTERS##_domain( nilbag, nilbag ) ) )
       myerr(@n@,MKSTR2(INTERS,()),"{},{}");
   DD }


#define CHECK1(x,n,IN) ( MERGE(is_empty,_domain)( D_ MERGE(IN,_domain)( nilbag,\
onenbag(x,n) ) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT {},{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


   void p_@N@()
   { if(! is_empty##_domain( D_ INTERS##_domain( nilbag, bigbag() ) ) )
       myerr(@n@,MKSTR2(INTERS,()),"{},BIGBAG");
   DD }


#define CHECK1(x,n,IN) ( MERGE(is_empty,_domain)( D_ MERGE(IN,_domain)( onenbag(x,n),\
nilbag ) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT {@X@..@X@},{}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


#define CHECK1(x,n,IN) ( MERGE(is_empty,_domain)( D_ MERGE(IN,_domain)( onebag(@Y@),\
onenbag(x,n) ) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT {@Y@},{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


#define CHECK1(x,n,IN) ( MERGE(is_empty,_domain)( D_ MERGE(IN,_domain)( onenbag(@Y@,n),\
onebag(x) ) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT {@Y@..@Y@},{@X@}; card({@Y@..@Y@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


#define CHECK1(x,n,IN) ( MERGE(is_eq,_domain)( D_ MERGE(IN,_domain)( onenbag(x,n),\
onenbag(x,n) ), D_ onenbag(x,n) ) )
#define CHECK(x,n,occbig) CHECK1(x,n,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT {@X@..@X@},{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "onenbag(x,n)" bleiben Reste brig!)                                  */
#define CHECK1(x,n,occbig,IN) ( MERGE(occurs,_domain)( E_ x, D_ MERGE(IN,_domain)(\
onenbag(x,n), bigbag() ) ) == RESTX(n,occbig) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT {@X@..@X@},BIGBAG; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1

/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "bigbag()" bleiben Reste brig!)                                      */
#define CHECK1(x,n,occbig,IN) ( MERGE(occurs,_domain)( E_ x, D_ MERGE(IN,_domain)(\
bigbag(), onenbag(x,n) ) ) == RESTX(occbig,n) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT BIGBAG,{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "onenbag(x,n)" bleiben Reste brig!)                                  */
#define CHECK1(x,n,occbig,IN) ( MERGE(card,_domain)( D_ MERGE(IN,_domain)(\
onenbag(x,n), bigbag() ) ) == RESTX(n,occbig) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT {@X@..@X@},BIGBAG; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "bigbag()" bleiben Reste brig!)                                      */
#define CHECK1(x,n,occbig,IN) ( MERGE(card,_domain)( D_ MERGE(IN,_domain)(\
bigbag(), onenbag(x,n) ) ) == RESTX(occbig,n) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT BIGBAG,{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


/* Hier werden Heapleichen entstehen, da nicht alle Elemente gelscht werden! */
/* (Vom "bigbag()" bleiben Reste brig!)                                      */
#define CHECK1(x,n,IN) ( MERGE(is_subbag,_domain)( D_ MERGE(IN,_domain)( bigbag(),\
onenbag(x,n) ), D_ bigbag() ) )
#define CHECK(x,n,occbig) CHECK1(x,n,INTERS)
#define OPTEXT INTERSTEXT
#define ARGTEXT BIGBAG,{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1


   void p_@N@()
   { if(! is_empty##_domain( D_ INTERS##_domain( bigbag(), nilbag ) ) )
       myerr(@n@,MKSTR2(INTERS,()),"BIGBAG,{}");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ INTERS##_domain( bigbag(), bigbag() ), 
                          D_ bigbag() ) )
       myerr(@n@,MKSTR2(INTERS,()),"BIGBAG,BIGBAG");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ INTERS##_domain( bigbag(), onebag(@Y@) ) ) )
       myerr(@n@,MKSTR2(INTERS,()),"BIGBAG,{@Y@}");
   DD }


#undef RESTX
#undef INTERS
#undef INTERSTEXT
#undef DELETE
#undef DEL
#undef DE_
-----
cat >$OUT_DIR/bag/com/basic/mkstr.inc <<'-----'
#ifndef _MKSTR_
#define _MKSTR_

#define MKSTR1(s1) #s1
#define MKSTR2(s1,s2) MKSTR1(MERGE(s1,s2))
#define MKONE(s1,s2) s1,s2

#endif
-----
cat >$OUT_DIR/bag/com/basic/occ.inc <<'-----'
#include <bag/com/basic/mkstr.inc>

#ifndef OCC_RES
#define OCC_RES __occ_big
#endif

  void p_@N@()
   {
    Nat0 __occ_big = 0;

#ifdef REPEAT
    @(
      __occ_big++; /* == occurs(@X@,BIGBAG) */
#endif

      if( occurs##_domain( E_ ARG_ELEM, D_ ARG_BAG ) != OCC_RES )
        myerr( @n@, "occurs", MKSTR1(ARG_TXT) );

#ifdef REPEAT
    @)
#endif

    DD EE
   }
#undef OCC_RES
#undef REPEAT
#undef ARG_ELEM
#undef ARG_BAG
#undef ARG_TXT
-----
cat >$OUT_DIR/bag/com/basic/sub1.inc <<'-----'
#include <bag/com/basic/mkstr.inc>
#include <bag/com/basic/testxbig.inc>

#ifdef NUMBER
#define NUMALL n
#define OCC ntab[__for_i]
#define NUM_ARG , OCC
#define ARG_STR(s1,s2) arg_text(MKSTR1(MKONE(s1,s2)),(long) OCC)
#define FOR int __for_i; for( __for_i = 0; __for_i < len_ntab; __for_i++ ) 
#define ONENUMBAG(x) onenbag(x,OCC)
#else
#define NUMALL
#define OCC 1
#define NUM_ARG
#define ARG_STR(s1,s2) MKSTR1(MKONE(s1,s2))
#define FOR 
#define ONENUMBAG(x) onebag(x)
#endif

#ifdef ALL
#undef NUMALL
#define NUMALL all
#endif

#ifdef DELETE
#define DEL d
#else
#define DEL
#endif

#define SUB1 MERGE(MERGE(sub1,NUMALL),DEL)


#define BAG nilbag
#define COMPBAG BAG
#define REPEAT
#define ELEM @X@
#define ARGSTR ARG_STR({},@X@)
#include <bag/com/basic/sub1_eq.inc>
 

#define BAG onebag(@Y@)
#define COMPBAG BAG
#define REPEAT
#define ELEM @X@
#define ARGSTR ARG_STR({@Y@},@X@)
#include <bag/com/basic/sub1_eq.inc>


#define BAG onebag(@X@)
#define COMPBAG BAG
#define REPEAT
#define ELEM @Y@
#define ARGSTR ARG_STR({@X@},@Y@)
#include <bag/com/basic/sub1_eq.inc>


#define BAG bigbag()
#define COMPBAG BAG
#undef  REPEAT
#define ELEM @Y@
#define ARGSTR ARG_STR(BIGBAG,@Y@)
#include <bag/com/basic/sub1_eq.inc>




#define BAG onebag(@X@)
#define ELEM @X@
#define OCCBAG 1
#define CARDBAG 1
#define ARGSTR ARG_STR({@X@},@X@)
#define REPEAT
#include <bag/com/basic/sub1_occ.inc>


#define BAG bigbag()
#define ELEM @X@
#define OCCBIGBAG 
#define CARDBAG bignum()
#define ARGSTR ARG_STR(BIGBAG,@X@)
#define REPEAT 
#include <bag/com/basic/sub1_occ.inc>


#ifdef NUMBER

#define CHECK1(x,n,occbig,S1) ( test_x_bigbag( D_ MERGE(S1,_domain)( bigbag(),x,n ),\
E_ x, (n > occbig) ? 0 : occbig - n ) )
#define CHECK(x,n,occbig) CHECK1(x,n,occbig,SUB1)
/* direkter Aufruf in CHECK lt SUB1_domain stehen! */
#define OPTEXT MERGE(SUB1,())
#define ARGTEXT BIGBAG,{@X@}
#include <bag/com/basic/forxn.inc>
#undef CHECK1

#else

#ifdef ALL
#define SOLL 0
#else
#define SOLL ( __occ_big - 1 )
#endif

   void p_@N@()
   { 
    int __occ_big = 0;
@(  
    __occ_big++;
    if( ! test_x_bigbag( D_ SUB1##_domain( bigbag(), @X@ ), E_ @X@, SOLL ) )
      myerr(@n@,MKSTR2(SUB1,()),"BIGBAG,{}");
@)
   DD EE }

#undef SOLL

#endif


#undef NUMBER
#undef ALL
#undef NUMALL
#undef NUM_ARG
#undef ARG_STR
#undef UNION1
#undef OCC
#undef FOR
#undef STR
#undef DELETE
#undef DEL
#undef ONENUMBAG
-----
cat >$OUT_DIR/bag/com/basic/sub1_eq.inc <<'-----'
#include <bag/com/basic/mkstr.inc>

   void p_@N@()
   {
    FOR
      {
#ifdef REPEAT 
@(     
#endif
       if(! is_eq##_domain( D_ SUB1##_domain( BAG, ELEM NUM_ARG ),
			    D_ COMPBAG ) )
         myerr(@n@,MKSTR2(SUB1,()),ARGSTR);
#ifdef REPEAT
@)
#endif
       DD EE /* Innerhalb der FOR-Schleife lschen, da sonst zu viel! */
      }
   }

#undef BAG
#undef COMPBAG
#undef ELEM
#undef ARGSTR
#undef REPEAT
-----
cat >$OUT_DIR/bag/com/basic/sub1_occ.inc <<'-----'
#ifdef OCCBIGBAG
#undef OCCBAG
#define OCCBAG __occ_big
#endif

#ifdef ALL
#define REST 0
#else
#define REST ( ( OCC < OCCBAG ) ? OCCBAG - OCC : 0 )
#endif


   void p_@N@()
   {
#ifdef OCCBIGBAG
    int __occ_big;
#endif

    FOR
      {
#ifdef OCCBIGBAG
       __occ_big = 0;
#endif
#ifdef REPEAT 
@(    
#ifdef OCCBIGBAG
       __occ_big++;
#endif 
#endif
       if( occurs##_domain( E_ ELEM, D_ SUB1##_domain( BAG, ELEM NUM_ARG ) )
           != REST )
         myerr(@n@,MKSTR2(SUB1,() /1),ARGSTR );
       if( !is_subbag##_domain( D_ SUB1##_domain( BAG, ELEM NUM_ARG ), 
				D_ BAG ) )
         myerr(@n@,MKSTR2(SUB1,() /2),ARGSTR );
       if( card##_domain( D_ SUB1##_domain( BAG, ELEM NUM_ARG ) ) != 
           CARDBAG - OCCBAG + REST )
         myerr(@n@,MKSTR2(SUB1,() /3),ARGSTR );
#ifdef REPEAT
@)
#endif
       DD EE /* Innerhalb der FOR-Schleife lschen, da sonst zu viele! */
      }
   }

#undef BAG
#undef ELEM
#undef OCCBAG
#undef OCCBIGBAG
#undef CARDBAG
#undef ARGSTR 
#undef REPEAT
#undef REST
-----
cat >$OUT_DIR/bag/com/basic/testxbig.inc <<'-----'
#ifndef _TESTXBIG_
#define _TESTXBIG_

static Bool test_x_bigbag(t_bag,x_elem,occ_x_soll)
Domain	t_bag;		/* zu testende bag-Instanz, siehe    */
			/* Prfungsfunktion bei "returns"!   */
Elem	x_elem;		/* Element aus "@X@" 	   	     */
Nat0	occ_x_soll;	/* Sollwert fr occurs(x_elem,t_bag) */
/* returns: BOOL; TRUE, wenn gilt: 
     (ALL x e "@X@") (if x==x_elem 
		    	then occurs(x,t_bag)==occ_x_soll
		  	else occurs(x,t_bag)==occurs(x,bigbag()))
   
   Definiere PRINT_TEST_X_BIGBAG fr Testausgaben (z.Z. undefiniert!)
*/
#undef PRINT_TEST_X_BIGBAG
{
  Elem 	e1, e2;		   /* zum Lschen von lokal erzeugten Elementen! */
  int 	__occ_big   = 0;
  Bool 	test_result = TRUE;
@(  
  __occ_big++; /* == occurs(@X@,BIGBAG) */
#ifdef PRINT_TEST_X_BIGBAG
{
 Elem pe1, pe2; /* Zum Lschen der beim Testausdruck erzeugten Elemente */

 fprintf(stderr,
  "\n###\tocc-bigbag=%d ist=%lu soll=%lu test-res.=%lu",
  __occ_big,
  (unsigned long) occurs##_domain( pe1 = @X@, t_bag ),
  (unsigned long) (is_eq##_elem( pe2 = @X@, x_elem ) ? occ_x_soll : __occ_big),
  (unsigned long) test_result );
 del##_elem(pe1);
 del##_elem(pe2);
}
#endif
  test_result = ( occurs##_domain( e1 = @X@, t_bag ) ==
                ( is_eq##_elem(x_elem, e2 = @X@) ? occ_x_soll : __occ_big ) )
		          && test_result;
  del##_elem(e1);
  del##_elem(e2);
@)
#ifdef PRINT_TEST_X_BIGBAG
fprintf(stderr, "\n### end! test-res.=%lu ###\n", 
                (unsigned long) test_result );
#endif

  return test_result;
}

#endif
-----
cat >$OUT_DIR/bag/com/basic/union.inc <<'-----'
#include <bag/com/basic/mkstr.inc>
#include <bag/com/basic/testxbig.inc>

#ifdef DELETE
#define DEL d
#else
#define DEL
#endif

#define UNION MERGE(union,DEL)



   void p_@N@()
   { if(! is_empty##_domain( D_ UNION##_domain( nilbag, nilbag ) ) )
       myerr(@n@,MKSTR2(UNION,()),"{},{}");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ UNION##_domain( nilbag, onebag(@X@) ), D_ onebag(@X@) ) )
       myerr(@n@,MKSTR2(UNION,()),"{},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ UNION##_domain( nilbag, bigbag() ), D_ bigbag() ) )
       myerr(@n@,MKSTR2(UNION,()),"{},BIGBAG");
   DD }

#define CHECK(x,n,occbig) CHECK1(x,n,UNION)
#define CHECK1(x,n,UN) ( MERGE(is_eq,_domain)( D_ MERGE(UN,_domain)( nilbag,\
onenbag(x,n) ), D_ onenbag(x,n) ) )
/* direkter Aufruf bei CHECK lt UNION_domain stehen! */
#define OPTEXT UNION,()
#define ARGTEXT {},{@X@..@X@}; card({@X@..@X@}) ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ UNION##_domain( onebag(@X@), nilbag ), D_ onebag(@X@) ) )
       myerr(@n@,MKSTR2(UNION,()),"{@X@},{}");
@) DD }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @Y@, D_ UNION##_domain( onebag(@Y@), onebag(@X@) ) ) )
       myerr(@n@,MKSTR2(UNION,() /1),"{@Y@},{@X@}");
     if(! is_in##_domain( E_ @X@, D_ UNION##_domain( onebag(@Y@), onebag(@X@) ) ) )
       myerr(@n@,MKSTR2(UNION,() /2),"{@Y@},{@X@}");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ UNION##_domain( onebag(@X@), onebag(@X@) ),
                          D_ onenbag(@X@,(Nat0)2) ) )
       myerr(@n@,MKSTR2(UNION,()),"{@X@},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_in##_domain( E_ @Y@, D_ UNION##_domain( onebag(@Y@), bigbag() ) ) )
       myerr(@n@,MKSTR2(UNION,() /1),"{@Y@},BIGBAG");
     if(! is_subbag##_domain( D_ bigbag(), 
			      D_ UNION##_domain( onebag(@Y@), bigbag() ) ) )
       myerr(@n@,MKSTR2(UNION,() /2),"{@Y@},BIGBAG");
   DD EE }

#define ARG_STR "{@X@},BIGBAG"
#define BAG1 onebag(@X@)
#define BAG2 bigbag()
#define CARD1 1
#define CARD2 bignum()
#define OCCX1 1
#define OCCX2 OCCXBIG
#undef FOR
#include <bag/com/basic/unionbb.inc>

#define ARG_STR "BIGBAG,{@X@}"
#define BAG2 onebag(@X@)
#define BAG1 bigbag()
#define CARD2 1
#define CARD1 bignum()
#define OCCX2 1
#define OCCX1 OCCXBIG
#undef FOR
#include <bag/com/basic/unionbb.inc>

#define ARG_STR arg_text("{@X@,..,@X@},BIGBAG, card{@X@..}==",(long)OCCXFOR)
#define BAG1 onenbag(@X@,OCCXFOR)
#define BAG2 bigbag()
#define CARD1 OCCXFOR
#define CARD2 bignum()
#define OCCX1 OCCXFOR
#define OCCX2 OCCXBIG
#define FOR
#include <bag/com/basic/unionbb.inc>

#define ARG_STR arg_text("BIGBAG,{@X@,..,@X@}, card{@X@..}==",(long)OCCXFOR)
#define BAG2 onenbag(@X@,OCCXFOR)
#define BAG1 bigbag()
#define CARD2 OCCXFOR
#define CARD1 bignum()
#define OCCX2 OCCXFOR
#define OCCX1 OCCXBIG
#define FOR
#include <bag/com/basic/unionbb.inc>

#define CHECK(x,n,occbig) CHECK1(x,n,occbig,UNION)
#define CHECK1(x,n,occbig,UN) ( test_x_bigbag( D_ MERGE(UN,_domain)( bigbag(),\
onenbag(x,n) ), E_ x, occbig + n ) )
/* direkter Aufruf bei CHECK lt UNION_domain stehen! */
#define OPTEXT UNION,()
#define ARGTEXT BIGBAG,{@X@,..,@X@}, card{@X@..} ==
#include <bag/com/basic/forxn.inc>
#undef CHECK1

  
#define ARG_STR "BIGBAG,BIGBAG"
#define BAG2 bigbag()
#define BAG1 bigbag()
#define CARD2 bignum()
#define CARD1 bignum()
#define OCCX2 OCCXBIG
#define OCCX1 OCCXBIG
#undef FOR
#include <bag/com/basic/unionbb.inc>

   void p_@N@()
   { if(! is_eq##_domain( D_ UNION##_domain( bigbag(), nilbag ), D_ bigbag() ) )
       myerr(@n@,MKSTR2(UNION,()),"BIGBAG,{}");
   DD }

   void p_@N@()
   { if(! is_subbag##_domain( D_ bigbag(), D_ UNION##_domain( bigbag(), onebag(@Y@) ) ) )
       myerr(@n@,MKSTR2(UNION,() /1),"BIGBAG,{@Y@}");
     if(! is_in##_domain( E_ @Y@, D_ UNION##_domain( bigbag(), onebag(@Y@) ) ) )
       myerr(@n@,MKSTR2(UNION,() /2),"BIGBAG,{@Y@}");
   DD EE }


#undef UNION
#undef DELETE
#undef DEL
-----
cat >$OUT_DIR/bag/com/basic/union1.inc <<'-----'
#include <bag/com/basic/mkstr.inc>
#include <bag/com/basic/testxbig.inc>

#ifdef NUMBER
#define NUM n
#define OCC ntab[__for_i]
#define NUM_ARG , OCC
#define ARG_TEXT(s1,s2) arg_text(MKSTR1(MKONE(s1,s2)),(long)OCC)
#define FOR int __for_i; for( __for_i = 0; __for_i < len_ntab; __for_i++ ) 
#define ONENUMBAG(x) onenbag(x,OCC)
#else
#define NUM
#define OCC 1
#define NUM_ARG
#define ARG_TEXT(s1,s2) MKSTR1(MKONE(s1,s2))
#define FOR 
#define ONENUMBAG(x) onebag(x)
#endif

#ifdef DELETE
#define DEL d
#else
#define DEL
#endif

#define UNION1 MERGE(MERGE(union1,NUM),DEL)


   void p_@N@()
   {
    FOR
      {
@(     if(! is_eq##_domain( D_ UNION1##_domain( nilbag, @X@ NUM_ARG ), 
                            D_ ONENUMBAG(@X@) ) )
         myerr(@n@,MKSTR2(UNION1,()),ARG_TEXT({},@X@) );
@)
       DD /* Innerhalb der FOR-Schleife lschen, da sonst zu viele! */
      }
   } 


   void p_@N@()
   {
    FOR  
      { 
@(     
       if(! is_in##_domain( E_ @X@, D_ UNION1##_domain( onebag(@Y@), 
							@X@ NUM_ARG ) ) != 
	  (OCC == 0) )
         myerr(@n@,MKSTR2(UNION1,() /1),ARG_TEXT({@Y@},@X@) );
       if(! is_in##_domain( E_ @Y@, D_ UNION1##_domain( onebag(@Y@), 
							@X@ NUM_ARG ) ) )
         myerr(@n@,MKSTR2(UNION1,() /2),ARG_TEXT({@Y@},@X@) );
       if( card##_domain( D_ UNION1##_domain( onebag(@Y@), @X@ NUM_ARG ) ) != 
	   OCC + 1 )
         myerr(@n@,MKSTR2(UNION1,() /3),ARG_TEXT({@Y@},@X@) );
@)
       DD EE
      }   
   }

 
   void p_@N@()
   {
    FOR
      {
@(     
       if( card##_domain( D_ UNION1##_domain( onebag(@X@), @X@ NUM_ARG ) ) !=  
	   OCC + 1 )
         myerr(@n@,MKSTR2(UNION1,() /1),ARG_TEXT({@X@},@X@) );
       if( occurs##_domain( E_ @X@, D_ UNION1##_domain( onebag(@X@), 
							@X@ NUM_ARG ) ) !=  
	   OCC + 1 )
         myerr(@n@,MKSTR2(UNION1,() /2),ARG_TEXT({@X@},@X@) );
@)
       DD EE
      }
   }

 
   void p_@N@()
   {
    FOR
      {
       if(! is_in##_domain( E_ @Y@, 
			    D_ UNION1##_domain( bigbag(), E_ @Y@ NUM_ARG ) ) != 
	  (OCC == 0) )
         myerr(@n@,MKSTR2(UNION1,() /1),ARG_TEXT(BIGBAG,@Y@) );
       if(! is_subbag##_domain( D_ bigbag(), 
				D_ UNION1##_domain( bigbag(), @Y@ NUM_ARG ) ) )
         myerr(@n@,MKSTR2(UNION1,() /2),ARG_TEXT(BIGBAG,@Y@) );
       if( card##_domain( D_ UNION1##_domain( bigbag(), @Y@ NUM_ARG ) ) != 
	   OCC + bignum() )
         myerr(@n@,MKSTR2(UNION1,() /3),ARG_TEXT(BIGBAG,@Y@) );
       if( occurs##_domain( E_ @Y@, 
			    D_ UNION1##_domain( bigbag(), @Y@ NUM_ARG ) ) != 
	   OCC )
         myerr(@n@,MKSTR2(UNION1,() /4),ARG_TEXT(BIGBAG,@Y@) );
       DD EE
      }
   }


   void p_@N@()
   {
    int __occ_big;
    FOR
      {
       __occ_big = 0;

@(     __occ_big++;   /* == occurs(@X@,BIGBAG) */
       if( card##_domain( D_ UNION1##_domain( bigbag(), @X@ NUM_ARG ) ) != 
	   OCC + bignum() )
         myerr(@n@,MKSTR2(UNION1,() /1),ARG_TEXT(BIGBAG,@X@) );
       if( occurs##_domain( E_ @X@, 
			    D_ UNION1##_domain( bigbag(), 
						@X@ NUM_ARG ) ) != 
	   OCC + __occ_big )
         myerr(@n@,MKSTR2(UNION1,() /2),ARG_TEXT(BIGBAG,@X@) );
       if( ! test_x_bigbag( D_ UNION1##_domain( bigbag(), @X@ NUM_ARG ),
	   		    E_ @X@, OCC + __occ_big ) )
 	 myerr(@n@,MKSTR2(UNION1,() /3),ARG_TEXT(BIGBAG,@X@) );
@)
       DD EE 
      }
   }

#undef NUMBER
#undef NUM
#undef NUM_ARG
#undef ARG_TEXT
#undef UNION1
#undef OCC
#undef FOR
#undef DELETE
#undef DEL
#undef ONENUMBAG
-----
cat >$OUT_DIR/bag/com/basic/unionbb.inc <<'-----'
#include <bag/com/basic/mkstr.inc>

#define OCCXBIG __occ_big
#ifdef FOR
#define OCCXFOR ntab[__for_i]
#endif


   void p_@N@()
   {
    int __occ_big;
#ifdef FOR
    int __for_i;

    for( __for_i = 0; __for_i < len_ntab; __for_i++ )
#endif
      {
       __occ_big = 0;
@(     
       __occ_big++; /* == occurs(@X@,BIGBAG) */
       if( is_eq##_domain( D_ UNION##_domain( BAG1, BAG2 ), D_ BAG1 ) &&
           CARD2 > 0 )
         myerr(@n@,MKSTR2(UNION,() /1),ARG_STR);
       if( is_eq##_domain( D_ UNION##_domain( BAG1, BAG2 ), D_ BAG2 ) &&
           CARD1 > 0 )
         myerr(@n@,MKSTR2(UNION,() /2),ARG_STR);
       if( card##_domain( D_ UNION##_domain( BAG1, BAG2 ) ) != 
           CARD1 + CARD2 )
         myerr(@n@,MKSTR2(UNION,() /3),ARG_STR);
       if( occurs##_domain( E_ @X@, D_ UNION##_domain( BAG1, BAG2 ) )
           != OCCX1 + OCCX2 )
         myerr(@n@,MKSTR2(UNION,() /4),ARG_STR);
       if( ! is_subbag##_domain( D_ BAG1, 
				 D_ UNION##_domain( BAG1, BAG2 ) ) )
         myerr(@n@,MKSTR2(UNION,() /5),ARG_STR); 
       if( ! is_subbag##_domain( D_ BAG2, 
				 D_ UNION##_domain( BAG1, BAG2 ) ) )
         myerr(@n@,MKSTR2(UNION,() /6),ARG_STR);

       DD EE  /* innerhalb der for-Schleife und der "@X@-Schleife",    */ 
              /* da sonst zu viele Eintrge gespeichert werden mssen! */
@)
      }
   }



#undef ARG_STR
#undef BAG1
#undef BAG2
#undef CARD1
#undef CARD2
#undef OCCX1
#undef OCCX2
#undef FOR
#undef OCCXBIG
#undef OCCXFOR
-----
[ -d $OUT_DIR/bag/com/binary ] || mkdir $OUT_DIR/bag/com/binary
cat >$OUT_DIR/bag/com/binary/ccod <<'-----'
#include <aux/com/binary/ccod>
-----
cat >$OUT_DIR/bag/com/binary/docu <<'-----'
#define bag
#include <aux/com/binary/docu>
-----
cat >$OUT_DIR/bag/com/binary/param <<'-----'
DELETE
FCTNAME
FOLDEXT
FOLDFCT
NOFOLDENR
NOSIGNATURE
RESULT
-----
cat >$OUT_DIR/bag/com/binary/vdm <<'-----'
#include <aux/com/binary/vdm>
-----
[ -d $OUT_DIR/bag/com/card ] || mkdir $OUT_DIR/bag/com/card
cat >$OUT_DIR/bag/com/card/docu <<'-----'
  Common implementation of 'card' built upon 'fold'.
-----
cat >$OUT_DIR/bag/com/card/gtyp <<'-----'
_DEFINE one##_ELEM1(x1) 1
-----
cat >$OUT_DIR/bag/com/card/vdm <<'-----'
#ifndef GEN_CPLUS
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + fold.card( "RESULT" = "Nat0"
			, "NULLFCT" = "null"
			, "CVFCT" = "one"
			, "FOLDFCT" = "plus"
			, "NOSIGNATURE"
			)
    Nat0   = + null + plus
#endif
-----
[ -d $OUT_DIR/bag/com/copy ] || mkdir $OUT_DIR/bag/com/copy
cat >$OUT_DIR/bag/com/copy/ccod <<'-----'
#if SIMPLEELEMS
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
   {return copy1##_DOMAIN(x1);}
#else
#define fct copy
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define incr r1 = MERGE(union1d,_DOMAIN)(r1,MERGE(copy,_ELEM1)(y1));
#include <aux/com/for/ccod>
#endif
-----
cat >$OUT_DIR/bag/com/copy/docu <<'-----'
  general implementation of copy
  copy(x1) = {copy(i) | i e x1}

  time complexity : O(n) * O(copy(ELEM1))
-----
cat >$OUT_DIR/bag/com/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if SIMPLEELEMS
   DOMAIN   =  + copy1
#else
   DOMAIN   =  + forall + mk_empty + union1d
   ELEM1    =  + copy
#endif
-----
[ -d $OUT_DIR/bag/com/copy1 ] || mkdir $OUT_DIR/bag/com/copy1
cat >$OUT_DIR/bag/com/copy1/ccod <<'-----'
#define fct copy1
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define incr r1 = MERGE(union1,_DOMAIN)(r1,y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/com/copy1/docu <<'-----'
  general implementation of copy1 by constructing a new bag
  copy1(x1) = { i | i e x1 }

  time complexity : O(n) * O(union1)
-----
cat >$OUT_DIR/bag/com/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall + mk_empty + union1
-----
[ -d $OUT_DIR/bag/com/cvfromtup1 ] || mkdir $OUT_DIR/bag/com/cvfromtup1
cat >$OUT_DIR/bag/com/cvfromtup1/ccod <<'-----'
#define __ADDELEM union1d
#include <aux/com/cvfromtup1/ccod>
-----
cat >$OUT_DIR/bag/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/bag/com/cvfromtup1/vdm <<'-----'
#define __ADDELEM union1
#include <aux/com/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/bag/com/cvlines ] || mkdir $OUT_DIR/bag/com/cvlines
cat >$OUT_DIR/bag/com/cvlines/ccod <<'-----'
#define IS_EMPTY(x1) MERGE(is_empty,_DOMAIN)(x1)
#define START_STR "{"
#define END_STR "}"
#include <aux/com/cvlines/ccod>
#undef IS_EMPTY
#undef START_STR
#undef END_STR
-----
cat >$OUT_DIR/bag/com/cvlines/docu <<'-----'
#include <aux/com/cvlines/docu>
-----
cat >$OUT_DIR/bag/com/cvlines/gtyp <<'-----'
#ifdef GEN_C
_DEFINE cvlines2##_DOMAIN(x1,x2) cvlines2_vdmlib(x1,x2)
#endif
-----
cat >$OUT_DIR/bag/com/cvlines/param <<'-----'
SUPRESS
-----
cat >$OUT_DIR/bag/com/cvlines/vdm <<'-----'
DOMAINS  
IMPLEMENTATIONS
  Str            =  + mkc
  DOMAIN         =  + is_empty
                    + fold.cvlines1( "NULLFCT" = "mk_empty"
                                   , "CVFCT"   = "cvlines"
                                   , "FOLDFCT" = "cvlines2"
                                   , "RESULT"  = "Cvtext_vdmlib")
  ELEM1          =  + cvlines
  Vdmlib         =  + cvtext + header("STRING")
-----
[ -d $OUT_DIR/bag/com/cvtotup1 ] || mkdir $OUT_DIR/bag/com/cvtotup1
cat >$OUT_DIR/bag/com/cvtotup1/ccod <<'-----'
#define __NOELEMS card
#include <aux/com/cvtotup1/ccod>
-----
cat >$OUT_DIR/bag/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/bag/com/cvtotup1/vdm <<'-----'
#define __NOELEMS card
#include <aux/com/cvtotup1/vdm>
-----
[ -d $OUT_DIR/bag/com/default ] || mkdir $OUT_DIR/bag/com/default
cat >$OUT_DIR/bag/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the bag data type the following set of operations is
  added

#include <bag/com/default/vdm>
-----
cat >$OUT_DIR/bag/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + mk1
                                       ! constructors !
             + is_empty + is_in
                                       ! predicates !
             + card + occurs
                                       ! attributes !
             + union1 + sub1
                                       ! combinators with elements !
             + union + diff + inters 
                                       ! combinators with bags !
             + iterator
                                       ! iterator functions !
             + copy1 + del1
                                       ! duplicate and destroy values !
-----
[ -d $OUT_DIR/bag/com/del ] || mkdir $OUT_DIR/bag/com/del
cat >$OUT_DIR/bag/com/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN)
   {
#if SIMPLEELEMS
#else
    while(!is_empty##_DOMAIN(x1))
      x1 = sub1alld##_DOMAIN(x1,sel##_DOMAIN(x1))
#endif
    del1##_DOMAIN(x1);
   }
-----
cat >$OUT_DIR/bag/com/del/docu <<'-----'

   general implementation of del via is_empty, sel, sub1alld and del1

   time-complexity: 
      O( O(n) * (O(is_empty)+O(sub1alld)+O(sel)) ) +O(del1(empty DOMAIN)) )
-----
cat >$OUT_DIR/bag/com/del/vdm <<'-----'
   DOMAINS
   IMPLEMENTATIONS
#if SIMPLEELEMS
      DOMAIN = + del1
#else
      DOMAIN = + is_empty + sub1alld + sel + del1
#endif
-----
[ -d $OUT_DIR/bag/com/diff ] || mkdir $OUT_DIR/bag/com/diff
cat >$OUT_DIR/bag/com/diff/ccod <<'-----'
DOMAIN l_diff##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
   /* umfassende Funktion, falls fuer sub1 ein MACRO verwendet wird! */
   return sub1##_DOMAIN( x1, x2 ); 
}
-----
cat >$OUT_DIR/bag/com/diff/docu <<'-----'
  general implementation of diff with sub1

  time complexity : O(n) * O(sub1)
-----
cat >$OUT_DIR/bag/com/diff/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.diff("FOLDFCT"="l_diff",NOFOLDENR)
   DOMAIN   = + sub1
#endif
-----
[ -d $OUT_DIR/bag/com/diffd ] || mkdir $OUT_DIR/bag/com/diffd
cat >$OUT_DIR/bag/com/diffd/ccod <<'-----'
DOMAIN l_diffd##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
   /* umfassende Funktion, falls fuer sub1 ein MACRO verwendet wird! */
   return sub1d##_DOMAIN( x1, x2 ); 
}
-----
cat >$OUT_DIR/bag/com/diffd/docu <<'-----'
  general implementation of diffd with sub1d

  time complexity : O(n) * O(sub1d)
-----
cat >$OUT_DIR/bag/com/diffd/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.diffd("FOLDFCT"="l_diffd",NOFOLDENR)
   DOMAIN   = + sub1d
#endif
-----
[ -d $OUT_DIR/bag/com/exist ] || mkdir $OUT_DIR/bag/com/exist
cat >$OUT_DIR/bag/com/exist/docu <<'-----'
#include <aux/com/exist/docu>
-----
cat >$OUT_DIR/bag/com/exist/vdm <<'-----'
#include <aux/com/exist/vdm>
-----
[ -d $OUT_DIR/bag/com/exist1 ] || mkdir $OUT_DIR/bag/com/exist1
cat >$OUT_DIR/bag/com/exist1/docu <<'-----'
#include <aux/com/exist1/docu>
-----
cat >$OUT_DIR/bag/com/exist1/gcod <<'-----'
#include <aux/com/exist1/gcod>
-----
cat >$OUT_DIR/bag/com/exist1/gtyp <<'-----'
#include <aux/com/exist1/gtyp>
-----
cat >$OUT_DIR/bag/com/exist1/vdm <<'-----'
#include <aux/com/exist1/vdm>
-----
[ -d $OUT_DIR/bag/com/fold ] || mkdir $OUT_DIR/bag/com/fold
cat >$OUT_DIR/bag/com/fold/ccod <<'-----'
#include <aux/com/fold/ccod>
-----
cat >$OUT_DIR/bag/com/fold/docu <<'-----'
#define Bag 
  Implementation of the 'fold' functional using the 'forall' routine
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/bag/com/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/bag/com/fold/vdm <<'-----'
#include <aux/com/fold/vdm>
-----
[ -d $OUT_DIR/bag/com/forsome ] || mkdir $OUT_DIR/bag/com/forsome
cat >$OUT_DIR/bag/com/forsome/ccod <<'-----'
#define fct forsome
#define tx2 MERGE(T2_forsome,_DOMAIN)
#define tx3 MERGE(T3_forsome,_DOMAIN)
#define incr if ((*t2)(y1)) (*t3)(y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/com/forsome/docu <<'-----'
  general implementation of forsome by forall

  time complexity : max( O(forall), O(filter) )
-----
cat >$OUT_DIR/bag/com/forsome/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
-----
[ -d $OUT_DIR/bag/com/hash ] || mkdir $OUT_DIR/bag/com/hash
cat >$OUT_DIR/bag/com/hash/ccod <<'-----'
#define fct hash
#define result Nat0
#define inires 0
#define incr r1 += MERGE(hash,_ELEM1)(y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/com/hash/docu <<'-----'
  general implementation of hash for bags
  as hash the sum of the hashvalues of the elements is taken

  time complexity : O(n) * O(hash(ELEM1))
-----
cat >$OUT_DIR/bag/com/hash/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall
   ELEM1    =  + hash
-----
[ -d $OUT_DIR/bag/com/inters ] || mkdir $OUT_DIR/bag/com/inters
cat >$OUT_DIR/bag/com/inters/ccod <<'-----'
#define fct inters
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 DOMAIN
#define incr if (MERGE(is_in,_DOMAIN)(y1,t2)) { r1 = MERGE(union1,_DOMAIN)(r1,y1); t2 = MERGE(sub1,_DOMAIN)(t2,y1); }
#define resfin MERGE(del1,_DOMAIN)(x1);MERGE(del1,_DOMAIN)(t2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/com/inters/docu <<'-----'
  general implementation of inters with is_in, union1 and sub1

  time complexity : O(n) * max{ O(is_in), O(union1), O(sub1) }
-----
cat >$OUT_DIR/bag/com/inters/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + is_in + union1 + sub1 + forall + del1
-----
[ -d $OUT_DIR/bag/com/intersd ] || mkdir $OUT_DIR/bag/com/intersd
cat >$OUT_DIR/bag/com/intersd/ccod <<'-----'
DOMAIN intersd##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {
    DOMAIN lx3 = mk_empty##_DOMAIN();
    ELEM1  lx4;
   
    while(!is_empty##_DOMAIN(x2))
      {
       register Nat0 lx5 = occurs##_DOMAIN((lx4=copy##_ELEM1(sel_DOMAIN(x2))),x2);
       register Nat0 lx6 = occurs##_DOMAIN(lx4,x1);
       x2  = sub1alld##_DOMAIN(x2,lx4);
       lx3 = union1nd##_DOMAIN(lx3,lx4, ((lx5 > lx6) ? lx6 : lx5) );
      }
    del##_DOMAIN(x1);   
    return lx3;
   }
-----
cat >$OUT_DIR/bag/com/intersd/docu <<'-----'

   general implementation of intersd via is_empty, occurs, sel, copy(ELEM1),
   sub1alld, union1nd and del

   time complexity: 
     O(O(del) + 
       n*(O(is_empty)+O(occurs)+O(sub1alld)+O(sel)+O(copy(ELEM))+O(union1nd)))
-----
cat >$OUT_DIR/bag/com/intersd/vdm <<'-----'
   DOMAINS
   IMPLEMENTATIONS
      DOMAIN = + is_empty + occurs + sel + sub1alld + union1nd + del
      ELEM   = + copy
-----
[ -d $OUT_DIR/bag/com/is_empty ] || mkdir $OUT_DIR/bag/com/is_empty
cat >$OUT_DIR/bag/com/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) 
   { return (card##_DOMAIN(x1) == (Nat0)0); }
-----
cat >$OUT_DIR/bag/com/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (card##_DOMAIN((x1)) == (Nat0)0)
-----
cat >$OUT_DIR/bag/com/is_empty/param <<'-----'
MACROS
-----
cat >$OUT_DIR/bag/com/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (card##_DOMAIN((x1)) = 0)
-----
cat >$OUT_DIR/bag/com/is_empty/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN  = + card
-----
[ -d $OUT_DIR/bag/com/is_eq ] || mkdir $OUT_DIR/bag/com/is_eq
cat >$OUT_DIR/bag/com/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return (card##_DOMAIN(x1) == card##_DOMAIN(x2))   
           && is_subbag##_DOMAIN(x1,x2);
   }        
-----
cat >$OUT_DIR/bag/com/is_eq/cmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) (card##_DOMAIN((x1))==card##_DOMAIN((x2)) && is_subbag##_DOMAIN((x1),(x2)))
-----
cat >$OUT_DIR/bag/com/is_eq/docu <<'-----'
  general implementation of is_eq:

  is_eq(x1,x2) =
      (card x1 = card x2)
      & is_subbag(x1,x2)

  time complexity : max(O(card),O(is_subbag))
-----
cat >$OUT_DIR/bag/com/is_eq/pmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) ((card##_DOMAIN((x1))=card##_DOMAIN((x2))) AND (is_subbag##_DOMAIN((x1),(x2))))
-----
cat >$OUT_DIR/bag/com/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + card + is_subbag
-----
[ -d $OUT_DIR/bag/com/is_in ] || mkdir $OUT_DIR/bag/com/is_in
cat >$OUT_DIR/bag/com/is_in/ccod <<'-----'
#define fct is_in
#define tx1 ELEM1
#define tx2 DOMAIN
#define result Bool
#define inires FALSE
#define incr r1 = r1 || MERGE(is_eq,_ELEM1)(y1,t1);
#define forx x2
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/com/is_in/docu <<'-----'
  
  general implemention of is_in via forall and the element-operation is_eq.

  time complexity: O(n)*O(is_eq(ELEM1))
-----
cat >$OUT_DIR/bag/com/is_in/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq 
   DOMAIN = + forall
-----
[ -d $OUT_DIR/bag/com/is_subbag ] || mkdir $OUT_DIR/bag/com/is_subbag
cat >$OUT_DIR/bag/com/is_subbag/ccod <<'-----'

#define fct is_subbag
#define result Bool
#define tx1 DOMAIN
#define tx2 DOMAIN
#define inires TRUE 
#define incr r1 = r1 && (MERGE(occurs,_DOMAIN)(y1,t1) <= MERGE(occurs,_DOMAIN)(y1,t2));
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/com/is_subbag/docu <<'-----'
  general implementation of is_subbag :

  is_subbag(x1,x2) = (All i e x1)(occurs(i,x1) <= occurs(i,x2)) 
  time complexity : O(n) * O(occurs)
-----
cat >$OUT_DIR/bag/com/is_subbag/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + occurs + forall
-----
[ -d $OUT_DIR/bag/com/iterator ] || mkdir $OUT_DIR/bag/com/iterator
cat >$OUT_DIR/bag/com/iterator/docu <<'-----'
#define BAG
#include <aux/com/iterator/docu>
-----
[ -d $OUT_DIR/bag/com/mfolddom ] || mkdir $OUT_DIR/bag/com/mfolddom
cat >$OUT_DIR/bag/com/mfolddom/ccod <<'-----'
#include <aux/com/mfolddom/ccod>
-----
cat >$OUT_DIR/bag/com/mfolddom/gtyp <<'-----'
#include <aux/com/mfolddom/gtyp>
-----
cat >$OUT_DIR/bag/com/mfolddom/param <<'-----'
FCTNAME
NEXTDOM
CALLDOM
XN
-----
cat >$OUT_DIR/bag/com/mfolddom/vdm <<'-----'
#include <aux/com/mfolddom/vdm>
-----
[ -d $OUT_DIR/bag/com/mk1 ] || mkdir $OUT_DIR/bag/com/mk1
cat >$OUT_DIR/bag/com/mk1/ccod <<'-----'
  DOMAIN mk1##_DOMAIN _FPH1(ELEM1)
    { return union1##_DOMAIN(mk_empty##_DOMAIN(),x1); }
-----
cat >$OUT_DIR/bag/com/mk1/cmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) union1##_DOMAIN(mk_empty##_DOMAIN(),(x1))
-----
cat >$OUT_DIR/bag/com/mk1/pmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) union1##_DOMAIN(mk_empty##_DOMAIN(),(x1))
-----
cat >$OUT_DIR/bag/com/mk1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + union1

#define CONSTRNAME mk1
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/com/mk1n ] || mkdir $OUT_DIR/bag/com/mk1n
cat >$OUT_DIR/bag/com/mk1n/ccod <<'-----'
  DOMAIN mk1n##_DOMAIN _FPH2(ELEM1,Nat0) 
    { return union1n##_DOMAIN(mk_empty##_DOMAIN(),x1,x2); }
-----
cat >$OUT_DIR/bag/com/mk1n/cmcr <<'-----'
_DEFINE mk1n##_DOMAIN(x1,x2) union1n##_DOMAIN(mk_empty##_DOMAIN(),(x1),(x2))
-----
cat >$OUT_DIR/bag/com/mk1n/docu <<'-----'
  general implementation of mk1n via union1n :

  mk1n(x1,n) = union1n(mk_empty(),x1,n)

  time complexity : O(union1n) * O(mk_empty)
-----
cat >$OUT_DIR/bag/com/mk1n/pmcr <<'-----'
_DEFINE mk1n##_DOMAIN(x1,x2) union1n##_DOMAIN(mk_empty##_DOMAIN(),(x1),(x2))
-----
cat >$OUT_DIR/bag/com/mk1n/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + union1n

#define CONSTRNAME mk1n
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/com/occurs ] || mkdir $OUT_DIR/bag/com/occurs
cat >$OUT_DIR/bag/com/occurs/ccod <<'-----'
#define fct occurs
#define tx1 ELEM1
#define tx2 DOMAIN
#define result Nat0
#define inires (Nat0)0
#define incr if( MERGE(is_eq,_ELEM1)(y1,t1) ) r1++;
#define forx x2
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/com/occurs/docu <<'-----'
  
  general implemention of occurs via forall and the element-operation is_eq.

  time complexity: O(n)*O(is_eq(ELEM1))
-----
cat >$OUT_DIR/bag/com/occurs/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq 
   DOMAIN = + forall
-----
[ -d $OUT_DIR/bag/com/parse ] || mkdir $OUT_DIR/bag/com/parse
cat >$OUT_DIR/bag/com/parse/ccod <<'-----'
#define START_SYM '{'
#define STOP_SYM '}'
#define ADD_TO union1d
#include <aux/com/parsem/ccod>
-----
cat >$OUT_DIR/bag/com/parse/docu <<'-----'

  Syntax:  '{' [<ELEM1> (',' <ELEM1>)* ] '}'

-----
cat >$OUT_DIR/bag/com/parse/vdm <<'-----'
#define ADD_TO union1d
#include <aux/com/parsem/vdm>
-----
[ -d $OUT_DIR/bag/com/print ] || mkdir $OUT_DIR/bag/com/print
cat >$OUT_DIR/bag/com/print/ccod <<'-----'
#define start "{"
#define stop "}"
#define step ","
#include <aux/com/print/ccod>
-----
cat >$OUT_DIR/bag/com/print/docu <<'-----'
  prints a bag in the format "{e1,...,en}"
-----
cat >$OUT_DIR/bag/com/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall + is_empty
   ELEM1    = + print
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/bag/com/sort ] || mkdir $OUT_DIR/bag/com/sort
cat >$OUT_DIR/bag/com/sort/ccod <<'-----'
#include <aux/com/sort/ccod>
-----
cat >$OUT_DIR/bag/com/sort/defs <<'-----'
#include <aux/com/sort/defs>
-----
cat >$OUT_DIR/bag/com/sort/docu <<'-----'
#define COLL bag
#include <aux/com/sort/docu>
-----
cat >$OUT_DIR/bag/com/sort/param <<'-----'
#include <aux/com/sort/param>
-----
cat >$OUT_DIR/bag/com/sort/vdm <<'-----'
#include <aux/com/sort/vdm>
-----
[ -d $OUT_DIR/bag/com/sub1all ] || mkdir $OUT_DIR/bag/com/sub1all
cat >$OUT_DIR/bag/com/sub1all/ccod <<'-----'
DOMAIN sub1all##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
 return sub1n##_DOMAIN( x1, x2, occurs##_DOMAIN( x2, x1 ) );
/*
 veraltet:
   
 while(is_in##_DOMAIN(x2,x1) ) 
   x1 = sub1##_DOMAIN(x1,x2);

 return x1;
*/ 
}
-----
cat >$OUT_DIR/bag/com/sub1all/cmcr <<'-----'
_DEFINE sub1all##_DOMAIN(x1,x2) sub1n##_DOMAIN((x1),(x2),occurs##_DOMAIN((x2),(x1)))
-----
cat >$OUT_DIR/bag/com/sub1all/docu <<'-----'
  general implementation of sub1all via sub1n and occurs :

  sub1all(x1,x2) = sub1n(x1,x2,occurs(x2,x1))

  time complexity : O(O(occurs),O(sub1n))
-----
cat >$OUT_DIR/bag/com/sub1all/pmcr <<'-----'
_DEFINE sub1all##_DOMAIN(x1,x2) sub1n##_DOMAIN((x1),(x2),occurs##_DOMAIN((x2),(x1)))
-----
cat >$OUT_DIR/bag/com/sub1all/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + occurs + sub1n 
-----
[ -d $OUT_DIR/bag/com/sub1alld ] || mkdir $OUT_DIR/bag/com/sub1alld
cat >$OUT_DIR/bag/com/sub1alld/ccod <<'-----'
DOMAIN sub1alld##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
 return sub1nd##_DOMAIN( x1, x2, occurs##_DOMAIN( x2, x1 ) );
/*
 veraltet:
   
 while(is_in##_DOMAIN(x2,x1) ) 
   x1 = sub1d##_DOMAIN(x1,x2);

 return x1;
*/ 
}
-----
cat >$OUT_DIR/bag/com/sub1alld/cmcr <<'-----'
_DEFINE sub1alld##_DOMAIN(x1,x2) sub1nd##_DOMAIN((x1),(x2),occurs##_DOMAIN((x2),(x1)))
-----
cat >$OUT_DIR/bag/com/sub1alld/docu <<'-----'
  general implementation of sub1alld via sub1nd and occurs :

  sub1alld(x1,x2) = sub1nd(x1,x2,occurs(x2,x1))

  time complexity : O(O(occurs),O(sub1nd))
-----
cat >$OUT_DIR/bag/com/sub1alld/pmcr <<'-----'
_DEFINE sub1alld##_DOMAIN(x1,x2) sub1nd##_DOMAIN((x1),(x2),occurs##_DOMAIN((x2),(x1)))
-----
cat >$OUT_DIR/bag/com/sub1alld/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + occurs + sub1nd 
-----
[ -d $OUT_DIR/bag/com/sub1n ] || mkdir $OUT_DIR/bag/com/sub1n
cat >$OUT_DIR/bag/com/sub1n/ccod <<'-----'
DOMAIN sub1n##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0) 
{
 register Nat0 i;

 for( i = x3; i > (Nat0)0; i-- )
   x1 = sub1##_DOMAIN(x1,x2);

 return x1;
}
-----
cat >$OUT_DIR/bag/com/sub1n/docu <<'-----'
  general implementation of sub1n via sub1 :

  sub1n(x1,x2,n) = x1 - { x2 | i elem Nat1 : 1 <= i <= n }

  time complexity : O(n) * O(sub1)
-----
cat >$OUT_DIR/bag/com/sub1n/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + sub1 
-----
[ -d $OUT_DIR/bag/com/sub1nd ] || mkdir $OUT_DIR/bag/com/sub1nd
cat >$OUT_DIR/bag/com/sub1nd/ccod <<'-----'
DOMAIN sub1nd##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0)
{
 register Nat0 i;

 for( i = x3; i > (Nat0)0; i-- )
   x1 = sub1d##_DOMAIN(x1,x2);

 return x1;
}
-----
cat >$OUT_DIR/bag/com/sub1nd/docu <<'-----'
  general implementation of sub1nd via sub1d :

  sub1n(x1,x2,n) = x1 - { x2 | i elem Nat1 : 1 <= i <= n }

  time complexity : O(n) * O(sub1d)
-----
cat >$OUT_DIR/bag/com/sub1nd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + sub1d 
-----
[ -d $OUT_DIR/bag/com/union ] || mkdir $OUT_DIR/bag/com/union
cat >$OUT_DIR/bag/com/union/ccod <<'-----'
static DOMAIN l_union##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
   /* umfassende Funktion, falls fr union1 ein MACRO verwendet wird! */
   return union1##_DOMAIN( x1, x2 ); 
}
-----
cat >$OUT_DIR/bag/com/union/docu <<'-----'
  general implementation of union with union1

  time complexity : O(n) * O(union1)
-----
cat >$OUT_DIR/bag/com/union/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.union("FOLDFCT"="l_union",DELETE,NOFOLDENR)
   DOMAIN   = + union1
#endif
-----
[ -d $OUT_DIR/bag/com/union1n ] || mkdir $OUT_DIR/bag/com/union1n
cat >$OUT_DIR/bag/com/union1n/ccod <<'-----'
DOMAIN union1n##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0)
{
 if( x3 > (Nat0)0 )
   { 
    register Nat0 i;

    for( i = x3 - (Nat0)1; i > (Nat0)0; i-- )
      x1 = union1d##_DOMAIN(x1,copy##_ELEM1(x2));
    x1 = union1##_DOMAIN(x1,x2);
   }

 return x1;
}
-----
cat >$OUT_DIR/bag/com/union1n/docu <<'-----'
  general implementation of union1n via union1 :

  union1n(x1,x2,n) = x1 U { x2 | i elem Nat1 : 1 <= i <= n } 

  time complexity : O(n) * O(union1)
-----
cat >$OUT_DIR/bag/com/union1n/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + union1 + union1d
   ELEM1    = + copy	
-----
[ -d $OUT_DIR/bag/com/union1nd ] || mkdir $OUT_DIR/bag/com/union1nd
cat >$OUT_DIR/bag/com/union1nd/ccod <<'-----'
DOMAIN union1nd##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0)
{
 if( x3 > (Nat0)0 )
   {
    register Nat0 i;

    for( i = x3 - (Nat0)1; i > (Nat0)0; i-- )
      x1 = union1d##_DOMAIN(x1,copy##_ELEM1(x2));
    x1 = union1d##_DOMAIN(x1,x2);
   }
 else
   del##_ELEM1(x2);

 return x1;
}
-----
cat >$OUT_DIR/bag/com/union1nd/docu <<'-----'
  general implementation of union1nd via union1 and union1d:

  union1nd(x1,x2,n) = x1 U { x2 | i elem Nat1 : 1 <= i <= n } 

  if x2 is not needed in x1 (or n is zero), a implicit call of del(x2) is 
  performed

  time complexity : ( O(n) * O(union1) ) + O(union1d)
-----
cat >$OUT_DIR/bag/com/union1nd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + union1d
   ELEM1    = + del + copy	
-----
[ -d $OUT_DIR/bag/com/uniond ] || mkdir $OUT_DIR/bag/com/uniond
cat >$OUT_DIR/bag/com/uniond/ccod <<'-----'
DOMAIN uniond##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {
    ELEM1 lx3;
    Nat0  lx4;

    while(!is_empty##_DOMAIN(x2))
      {
       lx4 = occurs##_DOMAIN( (lx3=copy##_ELEM1(sel_DOMAIN(x2))) ,x2);
       x2  = sub1alld##_DOMAIN(x2,lx3);
       x1  = union1nd##_DOMAIN(x1,lx3,lx4);
      }
    return x1;
   }
-----
cat >$OUT_DIR/bag/com/uniond/docu <<'-----'

   general implementation of uniond via is_empty, occurs, sel, copy(ELEM1),
   sub1alld and union1nd

   time complexity: 
     O(n*(O(is_empty)+O(occurs)+O(sub1alld)+O(sel)+O(copy(ELEM))+O(union1nd)))
-----
cat >$OUT_DIR/bag/com/uniond/vdm <<'-----'
   DOMAINS
   IMPLEMENTATIONS
      DOMAIN = + is_empty + occurs + sel + sub1alld + union1nd
      ELEM1  = + copy
-----
[ -d $OUT_DIR/bag/linklist ] || mkdir $OUT_DIR/bag/linklist
[ -d $OUT_DIR/bag/linklist/basic ] || mkdir $OUT_DIR/bag/linklist/basic
cat >$OUT_DIR/bag/linklist/basic/docu <<'-----'
  Implementation of bags as linked lists

  space : O(n) * (sizeof(pointer) + sizeof(ELEM1))
-----
cat >$OUT_DIR/bag/linklist/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/bag/linklist/basic/gptr <<'-----'
#include <aux/linklist/basic/gptr>
-----
cat >$OUT_DIR/bag/linklist/basic/gtyp <<'-----'
#include <aux/linklist/basic/gtyp>
-----
cat >$OUT_DIR/bag/linklist/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
SAVE
-----
cat >$OUT_DIR/bag/linklist/basic/vdm <<'-----'
#include <aux/com/heap/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/linklist/card ] || mkdir $OUT_DIR/bag/linklist/card
cat >$OUT_DIR/bag/linklist/card/ccod <<'-----'
#define fct card
#include <aux/linklist/len/ccod>
-----
cat >$OUT_DIR/bag/linklist/card/docu <<'-----'
  time complexity : O(n)
-----
[ -d $OUT_DIR/bag/linklist/copy ] || mkdir $OUT_DIR/bag/linklist/copy
cat >$OUT_DIR/bag/linklist/copy/ccod <<'-----'
#include <aux/linklist/copy/ccod>
-----
cat >$OUT_DIR/bag/linklist/copy/vdm <<'-----'
#include <aux/linklist/copy/vdm>
-----
[ -d $OUT_DIR/bag/linklist/copy1 ] || mkdir $OUT_DIR/bag/linklist/copy1
cat >$OUT_DIR/bag/linklist/copy1/ccod <<'-----'
#include <aux/linklist/copy1/ccod>
-----
[ -d $OUT_DIR/bag/linklist/del ] || mkdir $OUT_DIR/bag/linklist/del
cat >$OUT_DIR/bag/linklist/del/ccod <<'-----'
#include <aux/com/del/ccod>
-----
cat >$OUT_DIR/bag/linklist/del/docu <<'-----'
  implementation of del via forall, del(ELEM1) and del1(DOMAIN)

  time complexity : O(O(n) * O(del(ELEM1)),O(del1(DOMAIN)))
-----
cat >$OUT_DIR/bag/linklist/del/vdm <<'-----'
#include <aux/com/del/vdm>
-----
[ -d $OUT_DIR/bag/linklist/del1 ] || mkdir $OUT_DIR/bag/linklist/del1
cat >$OUT_DIR/bag/linklist/del1/ccod <<'-----'
#include <aux/linklist/del1/ccod>
-----
cat >$OUT_DIR/bag/linklist/del1/cmcr <<'-----'
#include <aux/linklist/del1/cmcr>
-----
[ -d $OUT_DIR/bag/linklist/fold ] || mkdir $OUT_DIR/bag/linklist/fold
cat >$OUT_DIR/bag/linklist/fold/ccod <<'-----'
#include <aux/linklist/fold/ccod>
-----
cat >$OUT_DIR/bag/linklist/fold/docu <<'-----'
#define Abortval
#define Bag
  Special linklist implementation for 'fold'
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/bag/linklist/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/bag/linklist/fold/vdm <<'-----'
#include <aux/linklist/fold/vdm>
-----
[ -d $OUT_DIR/bag/linklist/forall ] || mkdir $OUT_DIR/bag/linklist/forall
cat >$OUT_DIR/bag/linklist/forall/ccod <<'-----'
#include <aux/linklist/forall/ccod>
-----
cat >$OUT_DIR/bag/linklist/forall/cmcr <<'-----'
#include <aux/linklist/forall/cmcr>
-----
[ -d $OUT_DIR/bag/linklist/intersd ] || mkdir $OUT_DIR/bag/linklist/intersd
cat >$OUT_DIR/bag/linklist/intersd/ccod <<'-----'
#define fct intersd
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 DOMAIN
#define incr if(MERGE(is_in,_DOMAIN)(y1,t2)) { r1 = MERGE(union1,_DOMAIN)(r1,y1); t2 = MERGE(sub1d,_DOMAIN)(t2,y1); } else MERGE(del,_ELEM1)(y1);
#define resfin MERGE(del1,_DOMAIN)(x1);MERGE(del,_DOMAIN)(t2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/linklist/intersd/docu <<'-----'
  general implementation of intersd with is_in, union1 and sub1d

  time complexity : O(n) * max{ O(is_in), O(union1), O(sub1d) }
-----
cat >$OUT_DIR/bag/linklist/intersd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + is_in + union1 + sub1d + forall + del1 + del
   ELEM1    = + del
-----
[ -d $OUT_DIR/bag/linklist/is_empty ] || mkdir $OUT_DIR/bag/linklist/is_empty
cat >$OUT_DIR/bag/linklist/is_empty/ccod <<'-----'
#include <aux/linklist/is_empty/ccod>
-----
cat >$OUT_DIR/bag/linklist/is_empty/cmcr <<'-----'
#include <aux/linklist/is_empty/cmcr>
-----
cat >$OUT_DIR/bag/linklist/is_empty/docu <<'-----'
  time complexity : constant (1 pointer test)
-----
cat >$OUT_DIR/bag/linklist/is_empty/pmcr <<'-----'
#include <aux/linklist/is_empty/pmcr>
-----
[ -d $OUT_DIR/bag/linklist/is_in ] || mkdir $OUT_DIR/bag/linklist/is_in
cat >$OUT_DIR/bag/linklist/is_in/ccod <<'-----'

#define fct is_in
#define params _FP(x1,ELEM1), _FP(x2,DOMAIN)
#define paramdec _EP(x1,ELEM1) _EP(x2,DOMAIN)
#define search if (MERGE(is_eq,_ELEM1)(MERGE(ref,_DOMAIN)(x2)->f_info,x1)) return 1;
#include <aux/linklist/is_in/ccod>
-----
cat >$OUT_DIR/bag/linklist/is_in/docu <<'-----'
  time complexity : O(n)
-----
cat >$OUT_DIR/bag/linklist/is_in/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq
-----
[ -d $OUT_DIR/bag/linklist/iterator ] || mkdir $OUT_DIR/bag/linklist/iterator
cat >$OUT_DIR/bag/linklist/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/bag/linklist/iterator/vdm <<'-----'
#define IMPL linklist
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/bag/linklist/mk1 ] || mkdir $OUT_DIR/bag/linklist/mk1
cat >$OUT_DIR/bag/linklist/mk1/ccod <<'-----'
#include <aux/linklist/mk1/ccod>
-----
cat >$OUT_DIR/bag/linklist/mk1/vdm <<'-----'

#define CONSTRNAME mk1
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/linklist/mk_empty ] || mkdir $OUT_DIR/bag/linklist/mk_empty
cat >$OUT_DIR/bag/linklist/mk_empty/ccod <<'-----'
#include <aux/linklist/mk_empty/ccod>
-----
cat >$OUT_DIR/bag/linklist/mk_empty/cmcr <<'-----'
#include <aux/linklist/mk_empty/cmcr>
-----
cat >$OUT_DIR/bag/linklist/mk_empty/vdm <<'-----'
#define CONSTRNAME mk_empty
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/linklist/occurs ] || mkdir $OUT_DIR/bag/linklist/occurs
cat >$OUT_DIR/bag/linklist/occurs/ccod <<'-----'
Nat0 occurs##_DOMAIN _FPH2(ELEM1,DOMAIN)
{
 register Nat0   r1  = (Nat0)0;
 register DOMAIN lx2 = x2;
 
 while(lx2)
   {
    if( is_eq##_ELEM1(ref##_DOMAIN(lx2) -> f_info, x1 ) )
      r1++;
    
    lx2 = lx2 -> f_next;
   }

 return r1;
}
-----
cat >$OUT_DIR/bag/linklist/occurs/docu <<'-----'
  
  time complexity: O(n)
-----
cat >$OUT_DIR/bag/linklist/occurs/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1 = + is_eq 
-----
[ -d $OUT_DIR/bag/linklist/sel ] || mkdir $OUT_DIR/bag/linklist/sel
cat >$OUT_DIR/bag/linklist/sel/ccod <<'-----'
  ELEM1 sel##_DOMAIN _FPH1(DOMAIN)
   {if ( !x1 )
       err_elem_vdmlib(MKSTRING(DOMAIN));
    return ref##_DOMAIN(x1)->f_info;
   }
-----
cat >$OUT_DIR/bag/linklist/sel/docu <<'-----'
  time complexity : constant
-----
cat >$OUT_DIR/bag/linklist/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_elem
-----
[ -d $OUT_DIR/bag/linklist/sub1 ] || mkdir $OUT_DIR/bag/linklist/sub1
cat >$OUT_DIR/bag/linklist/sub1/ccod <<'-----'
#include <aux/linklist/sub1/ccod>
-----
cat >$OUT_DIR/bag/linklist/sub1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq
-----
[ -d $OUT_DIR/bag/linklist/sub1d ] || mkdir $OUT_DIR/bag/linklist/sub1d
cat >$OUT_DIR/bag/linklist/sub1d/ccod <<'-----'

#define fct sub1d
#define delelem MERGE(del,_ELEM1)(lx2->f_info);
#include <aux/linklist/sub1/ccod>
-----
cat >$OUT_DIR/bag/linklist/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq + del
-----
[ -d $OUT_DIR/bag/linklist/union ] || mkdir $OUT_DIR/bag/linklist/union
cat >$OUT_DIR/bag/linklist/union/ccod <<'-----'
#define fct union
#include <aux/linklist/conc/ccod>
-----
[ -d $OUT_DIR/bag/linklist/union1 ] || mkdir $OUT_DIR/bag/linklist/union1
cat >$OUT_DIR/bag/linklist/union1/ccod <<'-----'
DOMAIN union1##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
 register DOMAIN lx1 = mk1##_DOMAIN(x2);
 lx1 -> f_next = x1;
 return lx1;
}
-----
cat >$OUT_DIR/bag/linklist/union1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk1
-----
[ -d $OUT_DIR/bag/linklist/union1d ] || mkdir $OUT_DIR/bag/linklist/union1d
cat >$OUT_DIR/bag/linklist/union1d/ccod <<'-----'
  DOMAIN union1d##_DOMAIN _FPH2(DOMAIN,ELEM1) 
    { return union1##_DOMAIN(x1,x2); }
-----
cat >$OUT_DIR/bag/linklist/union1d/cmcr <<'-----'
_DEFINE union1d##_DOMAIN(x1,x2) union1##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/linklist/union1d/docu <<'-----'

  implementation: union1d = union1

  time complexity: as union1
-----
cat >$OUT_DIR/bag/linklist/union1d/pmcr <<'-----'
_DEFINE union1d##_DOMAIN(x1,x2) union1##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/linklist/union1d/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + union1
-----
[ -d $OUT_DIR/bag/linklist/union1nd ] || mkdir $OUT_DIR/bag/linklist/union1nd
cat >$OUT_DIR/bag/linklist/union1nd/ccod <<'-----'
  DOMAIN union1nd##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0) 
    { return union1n##_DOMAIN(x1,x2,x3); }
-----
cat >$OUT_DIR/bag/linklist/union1nd/cmcr <<'-----'
_DEFINE union1nd##_DOMAIN(x1,x2,x3) union1n##_DOMAIN((x1),(x2),(x3))
-----
cat >$OUT_DIR/bag/linklist/union1nd/docu <<'-----'

  implementation: union1nd = union1n

  time complexity: as union1n
-----
cat >$OUT_DIR/bag/linklist/union1nd/pmcr <<'-----'
_DEFINE union1nd##_DOMAIN(x1,x2,x3) union1n##_DOMAIN((x1),(x2),(x3))
-----
cat >$OUT_DIR/bag/linklist/union1nd/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + union1n
-----
[ -d $OUT_DIR/bag/linklist/uniond ] || mkdir $OUT_DIR/bag/linklist/uniond
cat >$OUT_DIR/bag/linklist/uniond/ccod <<'-----'
  DOMAIN uniond##_DOMAIN _FPH2(DOMAIN,DOMAIN) 
    { return union##_DOMAIN(x1,x2); }
-----
cat >$OUT_DIR/bag/linklist/uniond/cmcr <<'-----'
_DEFINE uniond##_DOMAIN(x1,x2) union##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/linklist/uniond/docu <<'-----'

  implementation: uniond = union

  time complexity: as union
-----
cat >$OUT_DIR/bag/linklist/uniond/pmcr <<'-----'
_DEFINE uniond##_DOMAIN(x1,x2) union##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/linklist/uniond/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + union
-----
[ -d $OUT_DIR/bag/mapdom ] || mkdir $OUT_DIR/bag/mapdom
[ -d $OUT_DIR/bag/mapdom/basic ] || mkdir $OUT_DIR/bag/mapdom/basic
cat >$OUT_DIR/bag/mapdom/basic/defp <<'-----'
#ifndef MAPIMPL
#define MAPIMPL linklist("INTERNALDOMAIN")
#endif
-----
cat >$OUT_DIR/bag/mapdom/basic/docu <<'-----'
#ifdef MAPIMPL
#undef MAPIMPL
#endif
  Implementation of a bag as a map: Bag = Elem -m-> Nat1 
  
  Parameter:

  "MAPIMPL" : name of the underlying map implementation
              recommented are "linklist" for small bags,
              "array" if indexing on Elem is possible,
              "hashtab" for a hash table or
              "genbt" for a binary tree implementation
              the default is linklist

  Do not use the following map-implementations
  "heap", "heapmap" and "dir" they are special purpose
  map implementations

  Example:

  DOMAINS

  Bag1 = Nat1 -bag
  Bag2 = Bag1 -bag

  IMPLEMENTATIONS

  Bag1 = mapdom(MAPIMPL="scaldom(LOWB=00)")
  Bag2 = mapdom  ! or: Bag2 = mapdom(MAPIMPL="linklist") !

  (LOWB: see map, implementation __A('scaldom',map.scaldom.basic))
  (Bag2: __A('linklist',map.linklist.basic)-implementation of the map)

  space : space requirements of the underlying map implementation
-----
cat >$OUT_DIR/bag/mapdom/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/bag/mapdom/basic/gtyp <<'-----'
TYPE_DEF(DOMAIN,Map##_DOMAIN)
-----
cat >$OUT_DIR/bag/mapdom/basic/param <<'-----'
AUTOMEM
INTERNALDOMAIN
MACROS
MAPIMPL
-----
cat >$OUT_DIR/bag/mapdom/basic/vdm <<'-----'
#include <bag/mapdom/basic/defp>
DOMAINS
  Map##_DOMAIN = ELEM1 -m-> Nat1

  DOMAIN       -> Map##_DOMAIN

IMPLEMENTATIONS
  Map##_DOMAIN = MAPIMPL
#undef MAPIMPL

#define CONSTRNAME mk_basic
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/mapdom/card ] || mkdir $OUT_DIR/bag/mapdom/card
cat >$OUT_DIR/bag/mapdom/card/ccod <<'-----'
#define fct card
#define result Nat0
#define inires (Nat0)0
#define ty2 Nat1
#define incr r1 += (Nat0)y2;
#define forloop MERGE(forall_map,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/card/docu <<'-----'
 
  Implementation with map-operation forall.
-----
cat >$OUT_DIR/bag/mapdom/card/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
-----
[ -d $OUT_DIR/bag/mapdom/copy ] || mkdir $OUT_DIR/bag/mapdom/copy
cat >$OUT_DIR/bag/mapdom/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN) 
    { return copy_map##_DOMAIN(x1); }
-----
cat >$OUT_DIR/bag/mapdom/copy/cmcr <<'-----'
_DEFINE copy##_DOMAIN(x1) copy_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/copy/docu <<'-----'

   implementation of copy via copy(map)
-----
cat >$OUT_DIR/bag/mapdom/copy/pmcr <<'-----'
_DEFINE copy##_DOMAIN(x1) copy_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/copy/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + copy
-----
[ -d $OUT_DIR/bag/mapdom/copy1 ] || mkdir $OUT_DIR/bag/mapdom/copy1
cat >$OUT_DIR/bag/mapdom/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN) 
    { return copy1_map##_DOMAIN(x1); }
-----
cat >$OUT_DIR/bag/mapdom/copy1/cmcr <<'-----'
_DEFINE copy1##_DOMAIN(x1) copy1_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/copy1/docu <<'-----'

   implementation of copy1 via copy1(map)
-----
cat >$OUT_DIR/bag/mapdom/copy1/pmcr <<'-----'
_DEFINE copy1##_DOMAIN(x1) copy1_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/copy1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + copy1
-----
[ -d $OUT_DIR/bag/mapdom/del ] || mkdir $OUT_DIR/bag/mapdom/del
cat >$OUT_DIR/bag/mapdom/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN) 
    { del_map##_DOMAIN(x1); }
-----
cat >$OUT_DIR/bag/mapdom/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1) del_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/del/docu <<'-----'

   implementation of del via del(map)
-----
cat >$OUT_DIR/bag/mapdom/del/pmcr <<'-----'
_DEFINE del##_DOMAIN(x1) del_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/del/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + del
-----
[ -d $OUT_DIR/bag/mapdom/del1 ] || mkdir $OUT_DIR/bag/mapdom/del1
cat >$OUT_DIR/bag/mapdom/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) 
    { del1_map##_DOMAIN(x1); }
-----
cat >$OUT_DIR/bag/mapdom/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) del1_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/del1/docu <<'-----'

   implementation of del1 via del1(map)
-----
cat >$OUT_DIR/bag/mapdom/del1/pmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) del1_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/del1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + del1
-----
[ -d $OUT_DIR/bag/mapdom/diff ] || mkdir $OUT_DIR/bag/mapdom/diff
cat >$OUT_DIR/bag/mapdom/diff/ccod <<'-----'
#define fct diff
#define result DOMAIN
#define tx2 DOMAIN
#define inires x1
#define ty2 Nat1
#define incr r1 = MERGE(sub1n,_DOMAIN)( r1, y1, (Nat0)y2 );
#define forx x2
#define forloop MERGE(forall_map,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/diff/docu <<'-----'
 
  Implementation with map-operation forall and sub1n.
-----
cat >$OUT_DIR/bag/mapdom/diff/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
  DOMAIN      = + sub1n
-----
[ -d $OUT_DIR/bag/mapdom/diffd ] || mkdir $OUT_DIR/bag/mapdom/diffd
cat >$OUT_DIR/bag/mapdom/diffd/ccod <<'-----'
#define fct diffd
#define result DOMAIN
#define tx2 DOMAIN
#define inires x1
#define ty2 Nat1
#define incr r1 = MERGE(sub1nd,_DOMAIN)( r1, y1, (Nat0)y2 );
#define forx x2
#define forloop MERGE(forall_map,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/diffd/docu <<'-----'
 
  Implementation with map-operation forall and sub1nd.
-----
cat >$OUT_DIR/bag/mapdom/diffd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
  DOMAIN      = + sub1nd
-----
[ -d $OUT_DIR/bag/mapdom/forall ] || mkdir $OUT_DIR/bag/mapdom/forall
cat >$OUT_DIR/bag/mapdom/forall/ccod <<'-----'
#define fct forall
#define tx2 MERGE(T2_forall,_DOMAIN)
#define ty2 Nat1
#define incr register Nat0 i = (Nat0)y2; while( (i--) > (Nat0)0 ) (*t2)(y1);
#define forloop MERGE(forall_map,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/forall/docu <<'-----'
 
  Implementation with map-operation forall and a static help-function.
  Don't change or delete the element (1. parameter) in your function!
-----
cat >$OUT_DIR/bag/mapdom/forall/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
-----
[ -d $OUT_DIR/bag/mapdom/inters ] || mkdir $OUT_DIR/bag/mapdom/inters
cat >$OUT_DIR/bag/mapdom/inters/ccod <<'-----'
#define fct inters
#define result DOMAIN
#define tx2 DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define ty2 Nat1
#define incr register Nat0 n = MERGE(occurs,_DOMAIN)( y1, t2 ); r1 = MERGE(union1n,_DOMAIN)( r1, y1, (n > (Nat0)y2 ? (Nat0)y2 : n) );
#define forloop MERGE(forall_map,_DOMAIN)
#define resfin MERGE(del1,_DOMAIN)( t2 ); MERGE(del1,_DOMAIN)( x1 ); 
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/inters/docu <<'-----'
 
  Implementation with map-operation forall, mk_empty, occurs, union1n and del1.
-----
cat >$OUT_DIR/bag/mapdom/inters/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
  DOMAIN      = + mk_empty + occurs + union1n + del1
-----
[ -d $OUT_DIR/bag/mapdom/intersd ] || mkdir $OUT_DIR/bag/mapdom/intersd
cat >$OUT_DIR/bag/mapdom/intersd/ccod <<'-----'
#define fct intersd
#define result DOMAIN
#define tx2 DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define ty2 Nat1
#define incr register Nat0 n = MERGE(occurs,_DOMAIN)( y1, t2 ); r1 = MERGE(union1nd,_DOMAIN)( r1, y1, (n > (Nat0)y2 ? (Nat0)y2 : n) );
#define forloop MERGE(forall_map,_DOMAIN)
#define resfin MERGE(del,_DOMAIN)( t2 ); MERGE(del1,_DOMAIN)( x1 );
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/intersd/docu <<'-----'
 
  Implementation with map-operation forall, mk_empty, occurs, union1nd,
  del and del1.
-----
cat >$OUT_DIR/bag/mapdom/intersd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
  DOMAIN      = + mk_empty + occurs + union1nd + del + del1
-----
[ -d $OUT_DIR/bag/mapdom/is_empty ] || mkdir $OUT_DIR/bag/mapdom/is_empty
cat >$OUT_DIR/bag/mapdom/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) 
    { return is_empty_map##_DOMAIN(x1); }
-----
cat >$OUT_DIR/bag/mapdom/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/is_empty/docu <<'-----'

   implementation of is_empty via is_empty(map)
-----
cat >$OUT_DIR/bag/mapdom/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/is_empty/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + is_empty
-----
[ -d $OUT_DIR/bag/mapdom/is_eq ] || mkdir $OUT_DIR/bag/mapdom/is_eq
cat >$OUT_DIR/bag/mapdom/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN) 
    { return is_eq_map##_DOMAIN(x1,x2); }
-----
cat >$OUT_DIR/bag/mapdom/is_eq/cmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) is_eq_map##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/is_eq/docu <<'-----'

   implementation of is_eq via is_eq(map1,map2)
-----
cat >$OUT_DIR/bag/mapdom/is_eq/pmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) is_eq_map##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/is_eq/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + is_eq
-----
[ -d $OUT_DIR/bag/mapdom/is_in ] || mkdir $OUT_DIR/bag/mapdom/is_in
cat >$OUT_DIR/bag/mapdom/is_in/ccod <<'-----'
Bool is_in##_DOMAIN _FPH2(ELEM1,DOMAIN)
{ return is_in_map##_DOMAIN(x1,x2); }
-----
cat >$OUT_DIR/bag/mapdom/is_in/cmcr <<'-----'
_DEFINE is_in##_DOMAIN(x1,x2) is_in_map##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/is_in/docu <<'-----'

   implementation of is_in via is_in_dom(elem,map)
-----
cat >$OUT_DIR/bag/mapdom/is_in/pmcr <<'-----'
_DEFINE is_in##_DOMAIN(x1,x2) is_in_map##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/is_in/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + is_in 
-----
[ -d $OUT_DIR/bag/mapdom/is_subbag ] || mkdir $OUT_DIR/bag/mapdom/is_subbag
cat >$OUT_DIR/bag/mapdom/is_subbag/ccod <<'-----'
#define fct is_subbag
#define result Bool
#define tx2 DOMAIN
#define inires TRUE
#define ty2 Nat1
#define incr r1 = r1 && (Nat0)y2 <= MERGE(occurs,_DOMAIN)( y1, t2 );
#define forloop MERGE(forall_map,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/is_subbag/docu <<'-----'
 
  Implementation with map-operation forall and bag-function occurs
-----
cat >$OUT_DIR/bag/mapdom/is_subbag/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
  DOMAIN      = + occurs
-----
[ -d $OUT_DIR/bag/mapdom/iterator ] || mkdir $OUT_DIR/bag/mapdom/iterator
cat >$OUT_DIR/bag/mapdom/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/bag/mapdom/iterator/vdm <<'-----'
#include <bag/mapdom/basic/defp>

#define PARAM "INTERNALFCT"
#define IMPL mapdom
#include <aux/com/iterator/vdm>

DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + iterator("INTERNALFCT")

#undef MAPIMPL
-----
[ -d $OUT_DIR/bag/mapdom/mk1 ] || mkdir $OUT_DIR/bag/mapdom/mk1
cat >$OUT_DIR/bag/mapdom/mk1/ccod <<'-----'
  DOMAIN mk1##_DOMAIN _FPH1(ELEM1) 
    { return mk1_map##_DOMAIN(x1,(Nat0)1); }
-----
cat >$OUT_DIR/bag/mapdom/mk1/cmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) mk1_map##_DOMAIN((x1),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/mk1/docu <<'-----'

   Implementation of mk1 via map-mk1(elem,1)
-----
cat >$OUT_DIR/bag/mapdom/mk1/pmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) mk1_map##_DOMAIN((x1),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/mk1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + mk1

#define CONSTRNAME mk1
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/mapdom/mk1n ] || mkdir $OUT_DIR/bag/mapdom/mk1n
cat >$OUT_DIR/bag/mapdom/mk1n/ccod <<'-----'
  DOMAIN mk1n##_DOMAIN _FPH2(ELEM1,Nat0) 
    { return (( x2 > (Nat0)0 ) ? 
         mk1_map##_DOMAIN(x1,(Nat1)x2) : 
         mk_empty_map##_DOMAIN());    }
-----
cat >$OUT_DIR/bag/mapdom/mk1n/cmcr <<'-----'
_DEFINE mk1n##_DOMAIN(x1,x2) ((x2) > (Nat0)0 ? mk1_map##_DOMAIN((x1),((Nat0)(x2))) : mk_empty_map##_DOMAIN())
-----
cat >$OUT_DIR/bag/mapdom/mk1n/docu <<'-----'

   Implementation of mk1n via map-mk1(elem,n)
-----
cat >$OUT_DIR/bag/mapdom/mk1n/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + mk1 + mk_empty

#define CONSTRNAME mk1n
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/mapdom/mk_empty ] || mkdir $OUT_DIR/bag/mapdom/mk_empty
cat >$OUT_DIR/bag/mapdom/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() 
    { return mk_empty_map##_DOMAIN(); }
-----
cat >$OUT_DIR/bag/mapdom/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() mk_empty_map##_DOMAIN()
-----
cat >$OUT_DIR/bag/mapdom/mk_empty/docu <<'-----'

   Implementation of mk_empty via map-mk_empty
-----
cat >$OUT_DIR/bag/mapdom/mk_empty/pmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() mk_empty_map##_DOMAIN()
-----
cat >$OUT_DIR/bag/mapdom/mk_empty/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + mk_empty

#define CONSTRNAME mk_empty
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bag/mapdom/occurs ] || mkdir $OUT_DIR/bag/mapdom/occurs
cat >$OUT_DIR/bag/mapdom/occurs/ccod <<'-----'
Nat0 occurs##_DOMAIN _FPH2(ELEM1,DOMAIN)
{ Nat1	r1;
  return ( is_in_dom_map##_DOMAIN(x1,x2,&r1) ? (Nat0) r1 : (Nat0)0 );
}
-----
cat >$OUT_DIR/bag/mapdom/occurs/docu <<'-----'
 
  Implementation with map-operation is_in_dom 
-----
cat >$OUT_DIR/bag/mapdom/occurs/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + is_in_dom 
-----
[ -d $OUT_DIR/bag/mapdom/sel ] || mkdir $OUT_DIR/bag/mapdom/sel
cat >$OUT_DIR/bag/mapdom/sel/ccod <<'-----'
  ELEM1 sel##_DOMAIN _FPH1(DOMAIN) 
    { return sel_dom_map##_DOMAIN(x1); }
-----
cat >$OUT_DIR/bag/mapdom/sel/cmcr <<'-----'
_DEFINE sel##_DOMAIN(x1) sel_dom_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/sel/docu <<'-----'

   Implementation with map-operation sel_dom.
-----
cat >$OUT_DIR/bag/mapdom/sel/pmcr <<'-----'
_DEFINE sel##_DOMAIN(x1) sel_dom_map##_DOMAIN((x1))
-----
cat >$OUT_DIR/bag/mapdom/sel/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + sel_dom
-----
[ -d $OUT_DIR/bag/mapdom/sub1 ] || mkdir $OUT_DIR/bag/mapdom/sub1
cat >$OUT_DIR/bag/mapdom/sub1/ccod <<'-----'
  DOMAIN sub1##_DOMAIN _FPH2(DOMAIN,ELEM1) 
    { return sub1n##_DOMAIN(x1,x2,(Nat0)1); }
-----
cat >$OUT_DIR/bag/mapdom/sub1/cmcr <<'-----'
_DEFINE sub1##_DOMAIN(x1,x2) sub1n##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/sub1/docu <<'-----'

  implementation: sub1(bag,elem) = sub1n(bag,elem,1)
  time complexity: as sub1n with parameter x3=1
-----
cat >$OUT_DIR/bag/mapdom/sub1/pmcr <<'-----'
_DEFINE sub1##_DOMAIN(x1,x2) sub1n##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/sub1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + sub1n
-----
[ -d $OUT_DIR/bag/mapdom/sub1all ] || mkdir $OUT_DIR/bag/mapdom/sub1all
cat >$OUT_DIR/bag/mapdom/sub1all/ccod <<'-----'
  DOMAIN sub1all##_DOMAIN _FPH2(DOMAIN,ELEM1) 
    { return sub1_map##_DOMAIN(x1,x2); }
-----
cat >$OUT_DIR/bag/mapdom/sub1all/cmcr <<'-----'
_DEFINE sub1all##_DOMAIN(x1,x2) sub1_map##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/sub1all/docu <<'-----'

  implementation: sub1all(bag,elem) = map-sub1(bag,elem)
-----
cat >$OUT_DIR/bag/mapdom/sub1all/pmcr <<'-----'
_DEFINE sub1all##_DOMAIN(x1,x2) sub1##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/sub1all/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + sub1
-----
[ -d $OUT_DIR/bag/mapdom/sub1alld ] || mkdir $OUT_DIR/bag/mapdom/sub1alld
cat >$OUT_DIR/bag/mapdom/sub1alld/ccod <<'-----'
  DOMAIN sub1alld##_DOMAIN _FPH2(DOMAIN,ELEM1) 
    { return sub1d_map##_DOMAIN(x1,x2); }
-----
cat >$OUT_DIR/bag/mapdom/sub1alld/cmcr <<'-----'
_DEFINE sub1alld##_DOMAIN(x1,x2) sub1d_map##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/sub1alld/docu <<'-----'


  implementation: sub1alld(bag,elem) = map-sub1d(bag,elem)
-----
cat >$OUT_DIR/bag/mapdom/sub1alld/pmcr <<'-----'
_DEFINE sub1alld##_DOMAIN(x1,x2) sub1d_map##_DOMAIN((x1),(x2))
-----
cat >$OUT_DIR/bag/mapdom/sub1alld/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Map##_DOMAIN = + sub1d
-----
[ -d $OUT_DIR/bag/mapdom/sub1d ] || mkdir $OUT_DIR/bag/mapdom/sub1d
cat >$OUT_DIR/bag/mapdom/sub1d/ccod <<'-----'
  DOMAIN sub1d##_DOMAIN _FPH2(DOMAIN,ELEM1) 
    { return sub1nd##_DOMAIN(x1,x2,(Nat0)1); }
-----
cat >$OUT_DIR/bag/mapdom/sub1d/cmcr <<'-----'
_DEFINE sub1d##_DOMAIN(x1,x2) sub1nd##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/sub1d/docu <<'-----'

  implementation: sub1d(bag,elem) = sub1nd(bag,elem,1)
  time complexity: as sub1nd with parameter x3=1
-----
cat >$OUT_DIR/bag/mapdom/sub1d/pmcr <<'-----'
_DEFINE sub1d##_DOMAIN(x1,x2) sub1nd##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/sub1d/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + sub1nd
-----
[ -d $OUT_DIR/bag/mapdom/sub1n ] || mkdir $OUT_DIR/bag/mapdom/sub1n
cat >$OUT_DIR/bag/mapdom/sub1n/ccod <<'-----'
DOMAIN sub1n##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0)
{ 
 register Nat0 n0;
 
 return ( x3 > (Nat0)0 ? ( (n0 = occurs##_DOMAIN( x2, x1 )) > x3 ?
		     ovwrt1_map##_DOMAIN( x1, x2, (Nat1)(n0 - x3) ) :
		     sub1_map##_DOMAIN( x1, x2 ) ) 
	: x1 );
}
-----
cat >$OUT_DIR/bag/mapdom/sub1n/docu <<'-----'
 
  Implementation with bag-function occurs and map-operations ovwrt1 or sub1.
-----
cat >$OUT_DIR/bag/mapdom/sub1n/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + ovwrt1 + sub1
  DOMAIN      = + occurs 
-----
[ -d $OUT_DIR/bag/mapdom/sub1nd ] || mkdir $OUT_DIR/bag/mapdom/sub1nd
cat >$OUT_DIR/bag/mapdom/sub1nd/ccod <<'-----'
DOMAIN sub1nd##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0)
{ 
 register Nat0 n0;
 
 return ( x3 > (Nat0)0 ? ( (n0 = occurs##_DOMAIN( x2, x1 )) > x3 ?
	 	     ovwrt1_map##_DOMAIN( x1, x2, (Nat1)(n0 - x3) ) : 
		     sub1d_map##_DOMAIN( x1, x2 ) ) 
        : x1 );
}
-----
cat >$OUT_DIR/bag/mapdom/sub1nd/docu <<'-----'
 
  Implementation with bag-function and map-operations ovwrt1 or sub1d. 
-----
cat >$OUT_DIR/bag/mapdom/sub1nd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + ovwrt1 + sub1d
  DOMAIN      = + occurs
-----
[ -d $OUT_DIR/bag/mapdom/union ] || mkdir $OUT_DIR/bag/mapdom/union
cat >$OUT_DIR/bag/mapdom/union/ccod <<'-----'
#define fct union
#define result DOMAIN
#define tx2 DOMAIN
#define inires x1
#define ty2 Nat1
#define incr r1 = MERGE(union1n,_DOMAIN)( r1, y1, (Nat0)y2 );
#define forx x2
#define forloop MERGE(forall_map,_DOMAIN)
#define resfin MERGE(del1,_DOMAIN)(x2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/union/docu <<'-----'
 
  Implementation with map-operation forall, union1n and del1.
-----
cat >$OUT_DIR/bag/mapdom/union/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
  DOMAIN      = + union1n + del1
-----
[ -d $OUT_DIR/bag/mapdom/union1 ] || mkdir $OUT_DIR/bag/mapdom/union1
cat >$OUT_DIR/bag/mapdom/union1/ccod <<'-----'
  DOMAIN union1##_DOMAIN _FPH2(DOMAIN,ELEM1) 
    { return union1n##_DOMAIN(x1,x2,(Nat0)1); }
-----
cat >$OUT_DIR/bag/mapdom/union1/cmcr <<'-----'
_DEFINE union1##_DOMAIN(x1,x2) union1n##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/union1/docu <<'-----'

  implementation: union1(bag,elem) = union1n(bag,elem,1)
  time complexity: as union1n with parameter x3=1
-----
cat >$OUT_DIR/bag/mapdom/union1/pmcr <<'-----'
_DEFINE union1##_DOMAIN(x1,x2) union1n##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/union1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + union1n
-----
[ -d $OUT_DIR/bag/mapdom/union1d ] || mkdir $OUT_DIR/bag/mapdom/union1d
cat >$OUT_DIR/bag/mapdom/union1d/ccod <<'-----'
  DOMAIN union1d##_DOMAIN _FPH2(DOMAIN,ELEM1) 
    { return union1nd##_DOMAIN(x1,x2,(Nat0)1); }
-----
cat >$OUT_DIR/bag/mapdom/union1d/cmcr <<'-----'
_DEFINE union1d##_DOMAIN(x1,x2) union1nd##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/union1d/docu <<'-----'

  implementation: union1d(bag,elem) = union1nd(bag,elem,1)

  time complexity: as union1nd with parameter x3=1
-----
cat >$OUT_DIR/bag/mapdom/union1d/pmcr <<'-----'
_DEFINE union1d##_DOMAIN(x1,x2) union1nd##_DOMAIN((x1),(x2),(Nat0)1)
-----
cat >$OUT_DIR/bag/mapdom/union1d/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + union1nd
-----
[ -d $OUT_DIR/bag/mapdom/union1n ] || mkdir $OUT_DIR/bag/mapdom/union1n
cat >$OUT_DIR/bag/mapdom/union1n/ccod <<'-----'
DOMAIN union1n##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0)
{
 return ( x3 > (Nat0)0 ?
          ovwrt1_map##_DOMAIN( x1, x2, (Nat1)(x3 + occurs##_DOMAIN( x2, x1 )) ) :
          x1 );
}
-----
cat >$OUT_DIR/bag/mapdom/union1n/cmcr <<'-----'
_DEFINE union1n##_DOMAIN(x1,x2,x3) ( (x3) > (Nat0)0 ? ovwrt1_map##_DOMAIN( (x1), (x2), (Nat1)((x3) + occurs##_DOMAIN( (x2), (x1) )) ) : x1 )
-----
cat >$OUT_DIR/bag/mapdom/union1n/docu <<'-----'
 
  Implementation with bag-function occurs and map-operation ovwrt1.
-----
cat >$OUT_DIR/bag/mapdom/union1n/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + ovwrt1
  DOMAIN      = + occurs
-----
[ -d $OUT_DIR/bag/mapdom/union1nd ] || mkdir $OUT_DIR/bag/mapdom/union1nd
cat >$OUT_DIR/bag/mapdom/union1nd/ccod <<'-----'
DOMAIN union1nd##_DOMAIN _FPH3(DOMAIN,ELEM1,Nat0)
{
 if( x3 > (Nat0)0 )
   x1 = ovwrt1d_map##_DOMAIN( x1, x2, (Nat1)(x3 + occurs##_DOMAIN( x2, x1 )) );
 else
   del##_ELEM1( x2 );

 return x1;
}
-----
cat >$OUT_DIR/bag/mapdom/union1nd/docu <<'-----'
 
  Implementation with bag-function occurs and map-operations ovwrt1d, or 
  element-operation del.
-----
cat >$OUT_DIR/bag/mapdom/union1nd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + ovwrt1d
  DOMAIN      = + occurs
  ELEM1	     = + del	
-----
[ -d $OUT_DIR/bag/mapdom/uniond ] || mkdir $OUT_DIR/bag/mapdom/uniond
cat >$OUT_DIR/bag/mapdom/uniond/ccod <<'-----'
#define fct uniond
#define result DOMAIN
#define tx2 DOMAIN
#define inires x1
#define ty2 Nat1
#define incr r1 = MERGE(union1nd,_DOMAIN)( r1, y1, (Nat0)y2 );
#define forx x2
#define forloop MERGE(forall_map,_DOMAIN)
#define resfin MERGE(del1,_DOMAIN)(x2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/bag/mapdom/uniond/docu <<'-----'
 
  Implementation with map-operation forall, union1nd and del1.
-----
cat >$OUT_DIR/bag/mapdom/uniond/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Map##_DOMAIN = + forall
  DOMAIN      = + union1nd + del1
-----
[ -d $OUT_DIR/bag/sign ] || mkdir $OUT_DIR/bag/sign
[ -d $OUT_DIR/bag/sign/all ] || mkdir $OUT_DIR/bag/sign/all
cat >$OUT_DIR/bag/sign/all/vsig <<'-----'
#include <aux/sign/all/vsig>
-----
[ -d $OUT_DIR/bag/sign/binary ] || mkdir $OUT_DIR/bag/sign/binary
cat >$OUT_DIR/bag/sign/binary/gsig <<'-----'
#include <aux/sign/binary/gsig>
-----
cat >$OUT_DIR/bag/sign/binary/vsig <<'-----'
  binary(x1) =
   let fct(y1,y2) = if y2 = {}
                    then y1
                    else let elem e y2 in
                      fct(x1(y1,elem),y2 - {elem})
   in fct
  TYPE : (Result  ELEM1 --> Result)
         -->
         (Result  DOMAIN --> Result)

  binary is a functional (a function returning another function as result).
  With help of this functional binary functions on Result and ELEM1 can be
  generalized to functions of DOMAIN to Result. 
  An important case is Result = DOMAIN. This leads to the examples
  described below. The general case is usefull for inventing conversions.

  binary is evaluated at module generation time.

  Example : union of 2 bags

  given the function :

     union1(y1,y2) = y1 u {y2}
     TYPE : DOMAIN ELEM1  -->  DOMAIN

  the union function can be constructed by:

     union(x1,x2) = binary(union1)(x1,x2)
     TYPE : DOMAIN  DOMAIN -->  DOMAIN

-----
[ -d $OUT_DIR/bag/sign/card ] || mkdir $OUT_DIR/bag/sign/card
cat >$OUT_DIR/bag/sign/card/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(card,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,card,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/bag/sign/card/gsig <<'-----'
  FUNCDEC(card##_DOMAIN,PL_1(DOMAIN),Nat0)
-----
cat >$OUT_DIR/bag/sign/card/vsig <<'-----'
  card(x1) = card x1
  TYPE : DOMAIN --> Nat0

  cardinality of bag x1
-----
[ -d $OUT_DIR/bag/sign/diff ] || mkdir $OUT_DIR/bag/sign/diff
cat >$OUT_DIR/bag/sign/diff/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN & 
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(diff,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diff,FPARLIST2))

#ifdef OPERATOR

#if defined(BASEIMPL)

InlineFriendFct(operator -=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diff,FPARLIST2))

InlineFriendConstFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(diff))

#else

InlineFriendFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diff,FPARLIST2))

#endif

#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/diff/gsig <<'-----'
  FUNCDEC(diff##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/diff/vsig <<'-----'
  diff(x1,x2) = x1 - x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  bag difference of x1 and x2
  only x1 is destroyed
-----
[ -d $OUT_DIR/bag/sign/diffd ] || mkdir $OUT_DIR/bag/sign/diffd
cat >$OUT_DIR/bag/sign/diffd/cpp <<'-----'
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(diffd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diffd,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/diffd/gsig <<'-----'
  FUNCDEC(diffd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/diffd/vsig <<'-----'
  diffd(x1,x2) = x1 - x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  bag difference of x1 and x2
  for elements of x1 not contained x2 implicit calls of del are performed
  only x1 are destroyed
-----
[ -d $OUT_DIR/bag/sign/exist ] || mkdir $OUT_DIR/bag/sign/exist
cat >$OUT_DIR/bag/sign/exist/vsig <<'-----'
#include <aux/sign/exist/vsig>
-----
[ -d $OUT_DIR/bag/sign/exist1 ] || mkdir $OUT_DIR/bag/sign/exist1
cat >$OUT_DIR/bag/sign/exist1/gsig <<'-----'
#include <aux/sign/exist1/gsig>
-----
cat >$OUT_DIR/bag/sign/exist1/vsig <<'-----'
#include <aux/sign/exist1/vsig>
-----
[ -d $OUT_DIR/bag/sign/fold ] || mkdir $OUT_DIR/bag/sign/fold
cat >$OUT_DIR/bag/sign/fold/gsig <<'-----'
#include <aux/sign/fold/gsig>
-----
cat >$OUT_DIR/bag/sign/fold/vsig <<'-----'
  fold(x1,x2,x3)(y1,a1,...,an) =
   let fct(z1) = if z1 = {}
                 then x2
                 else let i e z1 in
                      x3(x1 (i,a1,..,ak)
                        ,fct(z1 - {i})
                        ,al,...,an
                        )
   in fct(y1)
  TYPE : (ELEM1         T1 ... Tk --> RESULT)
         (                        --> RESULT)
         (RESULT RESULT Tl ... Tn --> RESULT)
         -->
         (DOMAIN        T1 ... Tn --> RESULT)

  Fold is a functional (a function returning another function as result).
  With help of this functional functions on the type DOMAIN can be defined
  by means of functions defined on the element type ELEM1.
  Fold returns a function from DOMAIN to RESULT.
  Usually, fold is partly evaluated at module generation time.
  The parameters a1 .. an are usefull to pass global information
  into the fold- or conversion functions. They are optional and
  can be generated in any combination.

  Example : computation of the cardinality of a bag

  Given the functions :

     one(y1) = 1
     TYPE : ELEM1  -->  Nat0
     zero()  = 0
     TYPE :  --> Nat0
     plus(y1,y2) = y1 + y2
     TYPE : Nat0  Nat0  -->  Nat0

  the card function can be constructed by:

     card(x1) = fold(one,zero,plus)(x1)
     TYPE : DOMAIN  -->  Nat0

-----
[ -d $OUT_DIR/bag/sign/forall ] || mkdir $OUT_DIR/bag/sign/forall
cat >$OUT_DIR/bag/sign/forall/cpp.old <<'-----'
#ifndef DECL
class cv_forall##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
public:
  cv_forall##_DOMAIN(void (*x1) (Cpp_ELEM1))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
};
void (*cv_forall##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1)
InlineFriendFct(forall,PPAR2(T1,X2),void)
#ifndef DECL
{ cv_forall##_DOMAIN tmp(x2);
  forall##_DOMAIN(DATA, cv_forall##_DOMAIN::cv_1);
  tmp.reset();}
#else
;
#endif
#undef T1
#undef X2
-----
cat >$OUT_DIR/bag/sign/forall/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forall##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern void forall##_DOMAIN P_OP DOMAIN x1, T2_forall##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/bag/sign/forall/vsig <<'-----'
  forall(x1,x2) = for i in x1 do x2(i)
  TYPE : DOMAIN  (ELEM1  -->  )  --> 

  for all elements in bag x1 procedure x2 is executed
  if the bag is ordered the elements are processed in this order
-----
[ -d $OUT_DIR/bag/sign/forsome ] || mkdir $OUT_DIR/bag/sign/forsome
cat >$OUT_DIR/bag/sign/forsome/cpp.old <<'-----'
#ifndef DECL
class cv_forsome##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  Cpp_BOOL (*data2) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
  static Cpp_BOOL (*ptr2) (Cpp_ELEM1);
public:
  cv_forsome##_DOMAIN(void (*x1) (Cpp_ELEM1), Cpp_BOOL (*x2) (Cpp_ELEM1))
   { data1 = ptr1; data2 = ptr2; ptr1 = x1; ptr2 = x2; }
  void reset()
   { ptr1 = data1; ptr2 = data2;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
  static Bool cv_2(ELEM1 x1)
   { return ((*ptr2) (x1)).data;}
};
void (*cv_forsome##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
Cpp_BOOL (*cv_forsome##_DOMAIN::ptr2) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 Cpp_BOOL (*x2) (Cpp_ELEM1)
#define X3 void (*x3) (Cpp_ELEM1)
InlineFriendFct(forsome,PPAR3(T1,X2,X3),void)
#ifndef DECL
{ cv_forsome##_DOMAIN tmp(x3,x2);
  forsome##_DOMAIN(DATA,cv_forsome##_DOMAIN::cv_2, cv_forsome##_DOMAIN::cv_1);
  tmp.reset();}
#else
;
#endif
#undef T1
#undef X2
#undef X3
-----
cat >$OUT_DIR/bag/sign/forsome/gsig <<'-----'
#ifdef GEN_C
  typedef Bool (* T2_forsome##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  typedef void (* T3_forsome##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern void forsome##_DOMAIN P_OP DOMAIN x1, T2_forsome##_DOMAIN x2, T3_forsome##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/bag/sign/forsome/vsig <<'-----'
  forsome(x1,x2,x3) = let y1 = <x1(i) | i e ind x1 & x2(x1(i))>
                      in forall(y1,x3)
  TYPE : DOMAIN  ( ELEM1  -->  Bool )  ( ELEM1  -->  )  -->

  for those elements in bag x1
  for which the predicate x2 holds 
  procedure x3 is executed
-----
[ -d $OUT_DIR/bag/sign/inters ] || mkdir $OUT_DIR/bag/sign/inters
cat >$OUT_DIR/bag/sign/inters/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN & 
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(inters,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

#ifdef OPERATOR

#if defined(BASEIMPL)

InlineFriendFct(operator &=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

InlineFriendConstFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(inters))

#else

InlineFriendFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

#endif
#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/inters/gsig <<'-----'
  FUNCDEC(inters##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/inters/vsig <<'-----'
  inters(x1,x2) = x1 n x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  intersect of x1 and x2
  x1 and x2 are destroyed
-----
[ -d $OUT_DIR/bag/sign/intersd ] || mkdir $OUT_DIR/bag/sign/intersd
cat >$OUT_DIR/bag/sign/intersd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'intersd' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(intersd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(intersd,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/bag/sign/intersd/gsig <<'-----'
  FUNCDEC(intersd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/intersd/vsig <<'-----'
  intersd(x1,x2) = x1 n x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  intersection of x1 and x2
  for elements not contained in the result bag implicit calls of del
  are preformed
  x1 and x2 are destroyed
-----
[ -d $OUT_DIR/bag/sign/is_empty ] || mkdir $OUT_DIR/bag/sign/is_empty
cat >$OUT_DIR/bag/sign/is_empty/cpp <<'-----'
#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(is_empty,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_empty,FPARLIST1))

#ifdef OPERATOR
InlineFriendConstFct(operator !,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,! is_empty,FPARLIST1))
#endif

#undef T1
-----
cat >$OUT_DIR/bag/sign/is_empty/gsig <<'-----'
  FUNCDEC(is_empty##_DOMAIN,PL_1(DOMAIN),Bool)
-----
cat >$OUT_DIR/bag/sign/is_empty/vsig <<'-----'
  is_empty(x1) = ( x1 = {} )
  TYPE : DOMAIN  -->  Bool

  test on empty bag
-----
[ -d $OUT_DIR/bag/sign/is_in ] || mkdir $OUT_DIR/bag/sign/is_in
cat >$OUT_DIR/bag/sign/is_in/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(is_in,SPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in,SPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/is_in/gsig <<'-----'
  FUNCDEC(is_in##_DOMAIN,PL_2(ELEM1,DOMAIN),Bool)
-----
cat >$OUT_DIR/bag/sign/is_in/vsig <<'-----'
  is_in(x1,x2) = ( x1 e x2 )
  TYPE : ELEM1  DOMAIN  -->  Bool

  test whether element x1 is in bag x2
-----
[ -d $OUT_DIR/bag/sign/is_subbag ] || mkdir $OUT_DIR/bag/sign/is_subbag
cat >$OUT_DIR/bag/sign/is_subbag/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(is_subbag,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_subbag,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/is_subbag/gsig <<'-----'
  FUNCDEC(is_subbag##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/bag/sign/is_subbag/vsig <<'-----'
  is_subbag(x1,x2) = ( x1 <= x2 )
  TYPE : ELEM1  DOMAIN  -->  Bool

  test whether bag x1 is contained in bag x2
-----
[ -d $OUT_DIR/bag/sign/iterator ] || mkdir $OUT_DIR/bag/sign/iterator
cat >$OUT_DIR/bag/sign/iterator/cpp <<'-----'
#include <aux/sign/iterator/docu>
-----
[ -d $OUT_DIR/bag/sign/mk1 ] || mkdir $OUT_DIR/bag/sign/mk1
cat >$OUT_DIR/bag/sign/mk1/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk1,KPARLIST1))
#undef T1
-----
cat >$OUT_DIR/bag/sign/mk1/gsig <<'-----'
  FUNCDEC(mk1##_DOMAIN,PL_1(ELEM1),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/mk1/vsig <<'-----'
  mk1(x1) = {x1}
  TYPE : ELEM1  -->  DOMAIN

  construction of a bag with one element x1
-----
[ -d $OUT_DIR/bag/sign/mk1n ] || mkdir $OUT_DIR/bag/sign/mk1n
cat >$OUT_DIR/bag/sign/mk1n/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_NAT0 &
  InlineNoFriendFct(Cpp_DOMAIN,KPAR2(T1,T2),)
  RUMPF(BODY4(mk1n,KPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/mk1n/gsig <<'-----'
  FUNCDEC(mk1n##_DOMAIN,PL_2(ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/mk1n/vsig <<'-----'
  mk1n(x1,x2) = U(1..x2) {x1}
  TYPE : ELEM1  Nat0  -->  DOMAIN

  construction of a bag with x2 elements x1.
  If x2 is zero, the bag x1 is empty.
-----
[ -d $OUT_DIR/bag/sign/mk_empty ] || mkdir $OUT_DIR/bag/sign/mk_empty
cat >$OUT_DIR/bag/sign/mk_empty/cpp <<'-----'
#define T1 const Cpp_EMPTY &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk_empty,KPARLIST0))
#undef T1 
-----
cat >$OUT_DIR/bag/sign/mk_empty/gsig <<'-----'
  FUNCDEC(mk_empty##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/mk_empty/vsig <<'-----'
  mk_empty() = {}
  TYPE :  -->  DOMAIN

  construction of the empty bag

#include <aux/com/mk_empty/docu>
-----
[ -d $OUT_DIR/bag/sign/occurs ] || mkdir $OUT_DIR/bag/sign/occurs
cat >$OUT_DIR/bag/sign/occurs/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(occurs,SPAR2(T1,T2),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,occurs,SPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/occurs/gsig <<'-----'
  FUNCDEC(occurs##_DOMAIN,PL_2(ELEM1,DOMAIN),Nat0)
-----
cat >$OUT_DIR/bag/sign/occurs/vsig <<'-----'
  occurs(x1,x2) = card { y | y e x2 : y = x1 }
  TYPE : ELEM1  DOMAIN --> Nat0

  Occurance of x1 in bag x2
-----
[ -d $OUT_DIR/bag/sign/sel ] || mkdir $OUT_DIR/bag/sign/sel
cat >$OUT_DIR/bag/sign/sel/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(sel,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,sel,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/bag/sign/sel/gsig <<'-----'
  FUNCDEC(sel##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/bag/sign/sel/vsig <<'-----'
  sel(x1) = let y1 e x1 in y1
  TYPE : DOMAIN  -->  ELEM1
  PRE  : ~ (x1 = {})

  selects an arbitrary element of bag x1
  x1 must be non empty
-----
[ -d $OUT_DIR/bag/sign/sort ] || mkdir $OUT_DIR/bag/sign/sort
cat >$OUT_DIR/bag/sign/sort/cpp <<'-----'
#include <aux/sign/sort/cpp>

-----
cat >$OUT_DIR/bag/sign/sort/gsig <<'-----'
#include <aux/sign/sort/gsig>
-----
cat >$OUT_DIR/bag/sign/sort/vsig <<'-----'
#define COLL bag
#include <aux/sign/sort/vsig>
-----
[ -d $OUT_DIR/bag/sign/sub1 ] || mkdir $OUT_DIR/bag/sign/sub1
cat >$OUT_DIR/bag/sign/sub1/cpp <<'-----'
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &

InlineFriendFct(sub1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator -=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))

#if defined(BASEIMPL)
InlineFriendConstFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(sub1))
#else
InlineFriendFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))
#endif 

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/sub1/gsig <<'-----'
  FUNCDEC(sub1##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/sub1/vsig <<'-----'
  sub1(x1,x2) = x1 - {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is removed from x1
  x1 is destroyed
-----
[ -d $OUT_DIR/bag/sign/sub1all ] || mkdir $OUT_DIR/bag/sign/sub1all
cat >$OUT_DIR/bag/sign/sub1all/cpp <<'-----'
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1all,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1all,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/sub1all/gsig <<'-----'
  FUNCDEC(sub1all##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/sub1all/vsig <<'-----'
  sub1all(x1,x2) = x1 - { x2 | 1 <= i <= occurs(x2,x1) }
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  All x2 elements are removed from x1
  x1 is destroyed
-----
[ -d $OUT_DIR/bag/sign/sub1alld ] || mkdir $OUT_DIR/bag/sign/sub1alld
cat >$OUT_DIR/bag/sign/sub1alld/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'sub1alld' not supported for automem)
#else

#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1alld,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1alld,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/bag/sign/sub1alld/gsig <<'-----'
  FUNCDEC(sub1alld##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/sub1alld/vsig <<'-----'
  sub1alld(x1,x2) = x1 - U(1..occurs(x2,x1) {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  All x2 are removed from x1
  if a value y1 equal to x2 is x1 an implicit call of del(y1) is performed
  x1 is destroyed
-----
[ -d $OUT_DIR/bag/sign/sub1d ] || mkdir $OUT_DIR/bag/sign/sub1d
cat >$OUT_DIR/bag/sign/sub1d/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'sub1d' not supported for automem)
#else

#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1d,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/bag/sign/sub1d/gsig <<'-----'
  FUNCDEC(sub1d##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/sub1d/vsig <<'-----'
  sub1d(x1,x2) = x1 - {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is removed from x1
  if a value y1 equal to x2 is x1 an implicit call of del(y1) is performed
  x1 is destroyed
-----
[ -d $OUT_DIR/bag/sign/sub1n ] || mkdir $OUT_DIR/bag/sign/sub1n
cat >$OUT_DIR/bag/sign/sub1n/cpp <<'-----'
#define T3 const Cpp_NAT0 &
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1n,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(sub1n,FPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/bag/sign/sub1n/gsig <<'-----'
  FUNCDEC(sub1n##_DOMAIN,PL_3(DOMAIN,ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/sub1n/vsig <<'-----'
  sub1n(x1,x2,x3) = x1 - { x2 | 1 <= i <= x3 }
  TYPE : DOMAIN  ELEM1  Nat0  -->  DOMAIN

  element x2 is removed from x1 x3 times
  x1 is destroyed
-----
[ -d $OUT_DIR/bag/sign/sub1nd ] || mkdir $OUT_DIR/bag/sign/sub1nd
cat >$OUT_DIR/bag/sign/sub1nd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'sub1nd' not supported for automem)
#else

#define T3 const Cpp_NAT0 &
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1nd,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(sub1nd,FPARLIST3))
#undef T1
#undef T2
#undef T3
#endif
-----
cat >$OUT_DIR/bag/sign/sub1nd/gsig <<'-----'
  FUNCDEC(sub1nd##_DOMAIN,PL_3(DOMAIN,ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/sub1nd/vsig <<'-----'
  sub1nd(x1,x2,x3) = x1 - U(1..x3) {x2}
  TYPE : DOMAIN  ELEM1  Nat0  -->  DOMAIN

  if x3 is not zero, x2 is x3 times removed from x1
  if a value y1 equal to x2 is x1 an implicit call of del(y1) is performed
  x1 is destroyed
-----
[ -d $OUT_DIR/bag/sign/union ] || mkdir $OUT_DIR/bag/sign/union
cat >$OUT_DIR/bag/sign/union/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN & 
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(plus,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

#ifdef OPERATOR

InlineFriendFct(operator |=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

#if defined(BASEIMPL)

InlineFriendConstFct(operator |,FPAR2(T1,T2), Cpp_DOMAIN)
RUMPF(BODY6(union))

#else

InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/union/gsig <<'-----'
  FUNCDEC(union##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/union/vsig <<'-----'
  union(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  union of x1 and x2
  x1 and x2 are destroyed

  in C++ union is called plus, to avoid conflicts
  with C keyword union
-----
[ -d $OUT_DIR/bag/sign/union1 ] || mkdir $OUT_DIR/bag/sign/union1
cat >$OUT_DIR/bag/sign/union1/cpp <<'-----'
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &

InlineFriendFct(plus1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST2))

#ifdef OPERATOR
 InlineFriendFct(operator |=,FPAR2(T1,T2),Cpp_DOMAIN &) 
 RUMPF(BODY2(union1,FPARLIST2))

#if defined(BASEIMPL)
 InlineFriendConstFct(operator |,FPAR2(T1,T2), Cpp_DOMAIN)
 RUMPF(BODY6(union1))
#else
 InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN &)
 RUMPF(BODY2(union1,FPARLIST2))
#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/bag/sign/union1/gsig <<'-----'
  FUNCDEC(union1##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/union1/vsig <<'-----'
  union1(x1,x2) = x1 u {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is inserted in x1
  x1 is destroyed

  in C++ union1 is called plus1, to avoid conflicts
  with C keyword union (see operation union)
-----
[ -d $OUT_DIR/bag/sign/union1d ] || mkdir $OUT_DIR/bag/sign/union1d
cat >$OUT_DIR/bag/sign/union1d/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'union1d' not supported for automem)
#else

#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
InlineFriendFct(plus1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1d,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/bag/sign/union1d/gsig <<'-----'
  FUNCDEC(union1d##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/union1d/vsig <<'-----'
  union1d(x1,x2) = x1 u {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is inserted in x1
  if x2 is not needed in x1 an implicit call of del(x2) is performed
  x1 is destroyed

  in C++ union1d is called plus1d, to avoid conflicts
  with C keyword union (see operation union)
-----
[ -d $OUT_DIR/bag/sign/union1n ] || mkdir $OUT_DIR/bag/sign/union1n
cat >$OUT_DIR/bag/sign/union1n/cpp <<'-----'
#define T3 const Cpp_NAT0 &
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN & 
InlineFriendFct(plus1n,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(union1n,FPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/bag/sign/union1n/gsig <<'-----'
  FUNCDEC(union1n##_DOMAIN,PL_3(DOMAIN,ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/union1n/vsig <<'-----'
  union1n(x1,x2,x3) = x1 u U(1..x3) {x2}
  TYPE : DOMAIN  ELEM1  Nat0  -->  DOMAIN

  if x3 is not zero, x2 is x3 times inserted in x1
  x1 is destroyed

  in C++ union1n is called plus1n, to avoid conflicts
  with C keyword union (see operation union)
-----
[ -d $OUT_DIR/bag/sign/union1nd ] || mkdir $OUT_DIR/bag/sign/union1nd
cat >$OUT_DIR/bag/sign/union1nd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'union1nd' not supported for automem)
#else

#define T3 const Cpp_NAT0 &
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN & 
InlineFriendFct(plus1nd,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(union1nd,FPARLIST3))
#undef T1
#undef T2
#undef T3
#endif
-----
cat >$OUT_DIR/bag/sign/union1nd/gsig <<'-----'
  FUNCDEC(union1nd##_DOMAIN,PL_3(DOMAIN,ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/union1nd/vsig <<'-----'
  union1nd(x1,x2,x3) = x1 u U(1..x3) {x2}
  TYPE : DOMAIN  ELEM1  Nat0  -->  DOMAIN

  if x3 is not zero, x2 is x3 times inserted in x1
  if x2 is not needed in x1 or x3 is zero, an implicit call of del(x2) is 
  performed
  x1 is destroyed

  in C++ union1nd is called plus1nd, to avoid conflicts
  with C keyword union (see operation union)
-----
[ -d $OUT_DIR/bag/sign/uniond ] || mkdir $OUT_DIR/bag/sign/uniond
cat >$OUT_DIR/bag/sign/uniond/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'uniond' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(plusd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(uniond,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/bag/sign/uniond/gsig <<'-----'
  FUNCDEC(uniond##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bag/sign/uniond/vsig <<'-----'
  uniond(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  union of x1 and x2

  for elements contained in both bags but not contained in the result,
  implicit calls of del are performed

  x1 and x2 are destroyed
-----
[ -d $OUT_DIR/bool ] || mkdir $OUT_DIR/bool
[ -d $OUT_DIR/bool/bool ] || mkdir $OUT_DIR/bool/bool
[ -d $OUT_DIR/bool/bool/and ] || mkdir $OUT_DIR/bool/bool/and
cat >$OUT_DIR/bool/bool/and/ccod <<'-----'
  DOMAIN and##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return x1 & x2;}
-----
cat >$OUT_DIR/bool/bool/and/cmcr <<'-----'
_DEFINE and##_DOMAIN(x1,x2) ((x1) & (x2))
-----
cat >$OUT_DIR/bool/bool/and/docu <<'-----'
  and function 
  the function is strict, both arguments are evaluated
-----
[ -d $OUT_DIR/bool/bool/basic ] || mkdir $OUT_DIR/bool/bool/basic
cat >$OUT_DIR/bool/bool/basic/docu <<'-----'
  Special implementation for boolean values.
  This implementation is used only for the predefined type __EM(Bool).
  The default implementation works with the C __EM(unsigned char) type
  and requires one byte. If another C type is prefered, the implementation
  parameter __EM(CSTRUCT) may be defined, see example below.

  The constants __EM(TRUE) and __EM(FALSE) are defined with this type

  __EM(TRUE)  is represented as 1
  __EM(FALSE) is represented as 0

  For C, there are 2 variants defined for __EM(TRUE) and __EM(FALSE),
  the default is the definition as macros for the constants 1 and 0,
  if an enum type is prefered, at compile time of the C source, the
  preprocessor macro __EM(BoolAsEnum) must be defined, e.g. with
  a compiler option __EM(-DBoolAsEnum=1).

  For C++ the corresponding values of class BOOL
  __EM(true) and __EM(false) are defined by macros,
  so the naming should not lead to name clashes.
  
  The ISO C++ standard defines a bool datatype with
  __EM(true) and __EM(false) as constants, if this raises
  problems the names of the VDM Class Library __EM(true) and __EM(false)
  may be changed by adding parameters to the implementation of the
  __EM(Bool) datatype:

  Example:

  IMPLEMENTATIONS

    Bool = bool(TRUENAME="yes",FALSENAME="no",CSTRUCT="int")

  changes __EM(true) to __EM(yes) and __EM(false) to __EM(no)
  and uses __EM(int) C data type.

  This renaming does not change any i/o routines, e.g. __SA(fpr),
  __SA(cvstr), __SA(parse).

  see also the Bool example in the Test directory
-----
cat >$OUT_DIR/bool/bool/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/bool/bool/basic/gptr <<'-----'
#ifdef GEN_C

#ifndef CSTRUCT
#define CSTRUCT unsigned char
#endif

#ifdef ISBOOLTYPE
COMMENT_(some systems define TRUE and FALSE in system header files)
_IFNDEF FALSE
_IFNDEF TRUE

COMMENT_(Bool as enum requires conversion between enum and int)
_IFDEF BoolAsEnum
  enum {FALSE,TRUE};
_ELSE
_DEFINE FALSE ((CSTRUCT)0)
_DEFINE TRUE ((CSTRUCT)1)
_ENDIF

#ifndef TRUENAME
#define TRUENAME true
#endif

#ifndef FALSENAME
#define FALSENAME false
#endif

_IFDEF __cplusplus
_DEFINE FALSENAME BOOL(FALSE)
_DEFINE TRUENAME BOOL(TRUE)
_ENDIF

#undef TRUENAME
#undef FALSENAME

_ENDIF
_ENDIF
#endif

  typedef CSTRUCT DOMAIN;

#else

#ifndef STRUCT
#define STRUCT BOOLTYPE
#endif
  TYPE_DEF(DOMAIN,STRUCT)

#endif
#undef CSTRUCT
#undef STRUCT
-----
cat >$OUT_DIR/bool/bool/basic/param <<'-----'
CSTRUCT
FORWARD_ALLOWED
INTERNALDOMAIN
ISBOOLTYPE
MACROS
STRUCT
TRUENAME
FALSENAME
-----
cat >$OUT_DIR/bool/bool/basic/vdm <<'-----'

#define CONSTRNAME mk_basic
#define ADTNAME ADT_BOOL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/bool/bool/cvfromtup1 ] || mkdir $OUT_DIR/bool/bool/cvfromtup1
cat >$OUT_DIR/bool/bool/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { register DOMAIN lx2;
      
    lx2 = (DOMAIN)hd##_TUPLDOMAIN(*x1);
    *x1 = tld##_TUPLDOMAIN(*x1);
    return lx2;
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/bool/bool/cvfromtup1/docu <<'-----'
  for boolean values the values TRUE or FALSE are read from
  the tuple
-----
cat >$OUT_DIR/bool/bool/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/bool/bool/cvfromtup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + hd + tld
-----
[ -d $OUT_DIR/bool/bool/cvlines ] || mkdir $OUT_DIR/bool/bool/cvlines
cat >$OUT_DIR/bool/bool/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
#ifdef GEN_ISO
   {return mk1_cvtext_vdmlib(mkc_str(((x1) ? "true" : "false")));}
#else
   {return mk1_cvtext_vdmlib(mkc_str(((x1) ? "TRUE" : "FALSE")));}
#endif
-----
cat >$OUT_DIR/bool/bool/cvlines/docu <<'-----'
#ifdef GEN_ISO
  <"true"> or <"false"> is returned
#else
  <"TRUE"> or <"FALSE"> is returned
#endif
-----
cat >$OUT_DIR/bool/bool/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  Cvtext_vdmlib   = + mk1
  Vdmlib          = + cvtext
  Str             = + mkc
-----
[ -d $OUT_DIR/bool/bool/cvstr ] || mkdir $OUT_DIR/bool/bool/cvstr
cat >$OUT_DIR/bool/bool/cvstr/ccod <<'-----'
#include <aux/com/cvstr/defp>

  RST FCTN##_DOMAIN _FPH1(DOMAIN)
   {static char * ft[2] = {"FALSE","TRUE"};
    return MKC(ft[x1]);
   }

#include <aux/com/cvstr/undef>
-----
cat >$OUT_DIR/bool/bool/cvstr/docu <<'-----'
  the boolean value is converted to the string representations
  "TRUE" or "FALSE"
-----
cat >$OUT_DIR/bool/bool/cvstr/param <<'-----'
AUTOMEMRESULT
-----
cat >$OUT_DIR/bool/bool/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)
              /* computes flag AUTOMEMRESULT */
-----
[ -d $OUT_DIR/bool/bool/cvtotup1 ] || mkdir $OUT_DIR/bool/bool/cvtotup1
cat >$OUT_DIR/bool/bool/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
    { return appr##_TUPLDOMAIN(x1,(unsigned int)x2); }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/bool/bool/cvtotup1/docu <<'-----'
   for boolean values TRUE (=1) or FALSE (=0) are appended
-----
cat >$OUT_DIR/bool/bool/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/bool/bool/cvtotup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + appr
-----
[ -d $OUT_DIR/bool/bool/false ] || mkdir $OUT_DIR/bool/bool/false
cat >$OUT_DIR/bool/bool/false/ccod <<'-----'
  DOMAIN false##_DOMAIN _FPH0() {return (DOMAIN)0;}
-----
cat >$OUT_DIR/bool/bool/false/cmcr <<'-----'
_DEFINE false##_DOMAIN() ((DOMAIN)0)
-----
cat >$OUT_DIR/bool/bool/false/docu <<'-----'
  the constant function false returns the constant FALSE (= 0)
  this function can be used as __EM(NULLFCT) in the __A("fold",tupl.com.fold) functional
  for building predicates over structured values
-----
cat >$OUT_DIR/bool/bool/false/pmcr <<'-----'
_DEFINE false##_DOMAIN DOMAIN(false)
-----
[ -d $OUT_DIR/bool/bool/hash ] || mkdir $OUT_DIR/bool/bool/hash
cat >$OUT_DIR/bool/bool/hash/ccod <<'-----'
  Nat0 hash##_DOMAIN _FPH1(DOMAIN)
   {return ((Nat0)x1);}
-----
cat >$OUT_DIR/bool/bool/hash/cmcr <<'-----'
_DEFINE hash##_DOMAIN(x1) ((Nat0)(x1))
-----
cat >$OUT_DIR/bool/bool/hash/docu <<'-----'
  hash function on boolean types :
  __EM(TRUE)  is mapped to 1
  __EM(FALSE) is mapped to 0
-----
cat >$OUT_DIR/bool/bool/hash/pmcr <<'-----'
_DEFINE hash##_DOMAIN(x1) Nat0(x1)
-----
[ -d $OUT_DIR/bool/bool/iff ] || mkdir $OUT_DIR/bool/bool/iff
cat >$OUT_DIR/bool/bool/iff/docu <<'-----'
  The function is strict, both arguments are evaluated
-----
cat >$OUT_DIR/bool/bool/iff/gcod <<'-----'
  _FDEC2(iff,Bool,DOMAIN,DOMAIN,_RET(is_eq##_DOMAIN(x1,x2)))
-----
cat >$OUT_DIR/bool/bool/iff/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + is_eq + or
-----
[ -d $OUT_DIR/bool/bool/implies ] || mkdir $OUT_DIR/bool/bool/implies
cat >$OUT_DIR/bool/bool/implies/docu <<'-----'
  The function is strict, both arguments are evaluated
-----
cat >$OUT_DIR/bool/bool/implies/gcod <<'-----'
  _FDEC2(implies,Bool,DOMAIN,DOMAIN,_RET(or##_DOMAIN(not##_DOMAIN(x1),x2)))
-----
cat >$OUT_DIR/bool/bool/implies/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + not + or
-----
[ -d $OUT_DIR/bool/bool/is_gr ] || mkdir $OUT_DIR/bool/bool/is_gr
cat >$OUT_DIR/bool/bool/is_gr/ccod <<'-----'
#include <numeric/com/is_gr/ccod>
-----
cat >$OUT_DIR/bool/bool/is_gr/cmcr <<'-----'
#include <numeric/com/is_gr/cmcr>
-----
cat >$OUT_DIR/bool/bool/is_gr/pmcr <<'-----'
#include <numeric/com/is_gr/pmcr>
-----
[ -d $OUT_DIR/bool/bool/not ] || mkdir $OUT_DIR/bool/bool/not
cat >$OUT_DIR/bool/bool/not/ccod <<'-----'
  DOMAIN not##_DOMAIN _FPH1(DOMAIN) {return !x1;}
-----
cat >$OUT_DIR/bool/bool/not/cmcr <<'-----'
_DEFINE not##_DOMAIN(x1) (!(x1))
-----
cat >$OUT_DIR/bool/bool/not/docu <<'-----'
  not function on Bool data type
-----
[ -d $OUT_DIR/bool/bool/or ] || mkdir $OUT_DIR/bool/bool/or
cat >$OUT_DIR/bool/bool/or/ccod <<'-----'
  DOMAIN or##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return x1 | x2;}
-----
cat >$OUT_DIR/bool/bool/or/cmcr <<'-----'
_DEFINE or##_DOMAIN(x1,x2) ((x1) | (x2))
-----
cat >$OUT_DIR/bool/bool/or/docu <<'-----'
  or function 
  the function is strict, both arguments are evaluated
-----
[ -d $OUT_DIR/bool/bool/print ] || mkdir $OUT_DIR/bool/bool/print
cat >$OUT_DIR/bool/bool/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
#ifdef GEN_ISO
   { print_FD_vdmlib << ((x1) ? "true" : "false");}
#else
   { print_FD_vdmlib << ((x1) ? "TRUE" : "FALSE");}
#endif
_ELSE
#ifdef GEN_ISO
   {fprintf(print_FD_vdmlib,(x1) ? "true" : "false");}
#else
   {fprintf(print_FD_vdmlib,(x1) ? "TRUE" : "FALSE");}
#endif
_ENDIF
-----
cat >$OUT_DIR/bool/bool/print/docu <<'-----'
#ifdef GEN_ISO
  "true" or "false" is printed
#else
  "TRUE" or "FALSE" is printed
#endif
-----
cat >$OUT_DIR/bool/bool/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/bool/bool/true ] || mkdir $OUT_DIR/bool/bool/true
cat >$OUT_DIR/bool/bool/true/ccod <<'-----'
  DOMAIN true##_DOMAIN _FPH0() {return (DOMAIN)1;}
-----
cat >$OUT_DIR/bool/bool/true/cmcr <<'-----'
_DEFINE true##_DOMAIN() ((DOMAIN)1)
-----
cat >$OUT_DIR/bool/bool/true/docu <<'-----'
  the constant function true returns the constant TRUE (= 1)
  this function can be used as 'NULLFCT' in the fold functional
  for building predicates over structured values
-----
cat >$OUT_DIR/bool/bool/true/pmcr <<'-----'
_DEFINE true##_DOMAIN DOMAIN(true)
-----
[ -d $OUT_DIR/bool/bool/xor ] || mkdir $OUT_DIR/bool/bool/xor
cat >$OUT_DIR/bool/bool/xor/ccod <<'-----'
  DOMAIN xor##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return x1 ^ x2;}
-----
cat >$OUT_DIR/bool/bool/xor/cmcr <<'-----'
_DEFINE xor##_DOMAIN(x1,x2) ((x1) ^ (x2))
-----
cat >$OUT_DIR/bool/bool/xor/docu <<'-----'
  exclusive or function 
-----
[ -d $OUT_DIR/bool/com ] || mkdir $OUT_DIR/bool/com
[ -d $OUT_DIR/bool/com/basic ] || mkdir $OUT_DIR/bool/com/basic
cat >$OUT_DIR/bool/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/bool/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = () -bool

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + true
   + false

   + copy1
   + copy
   + not
   + and
   + or
   + xor

   + is_eq
   + is_gr
   + is_ge

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

-----
cat >$OUT_DIR/bool/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

DOMAINEQ2

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + true
   + false

   + is_eq
   + is_gr
   + is_ge

-----
cat >$OUT_DIR/bool/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbid1>

/*================================================================================================*/

   void p_@N@()
   { if(! is_eq##_domain( D_ true##_domain(), TRUE ) )
       myerr(@n@,"true()","");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_eq##_domain( D_ false##_domain(), FALSE ) )
       myerr(@n@,"false()","");
   DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/copy1/bbc2>

#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_eq##_domain( D_ not##_domain( D_ false##_domain() ), D_ true##_domain() ) )
       myerr(@n@,"not()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ not##_domain( D_ true##_domain() ), D_ false##_domain() ) )
       myerr(@n@,"not()","");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_eq##_domain( D_ and##_domain( D_ false##_domain(), D_ false##_domain() ), D_ false##_domain() ) )
       myerr(@n@,"and()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ and##_domain( D_ false##_domain(), D_ true##_domain() ), D_ false##_domain() ) )
       myerr(@n@,"and()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ and##_domain( D_ true##_domain(), D_ false##_domain() ), D_ false##_domain() ) )
       myerr(@n@,"and()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ and##_domain( D_ true##_domain(), D_ true##_domain() ), D_ true##_domain() ) )
       myerr(@n@,"and()","");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_eq##_domain( D_ or##_domain( D_ false##_domain(), D_ false##_domain() ), D_ false##_domain() ) )
       myerr(@n@,"or()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ or##_domain( D_ false##_domain(), D_ true##_domain() ), D_ true##_domain() ) )
       myerr(@n@,"or()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ or##_domain( D_ true##_domain(), D_ false##_domain() ), D_ true##_domain() ) )
       myerr(@n@,"or()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ or##_domain( D_ true##_domain(), D_ true##_domain() ), D_ true##_domain() ) )
       myerr(@n@,"or()","");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_eq##_domain( D_ xor##_domain( D_ false##_domain(), D_ false##_domain() ), D_ false##_domain() ) )
       myerr(@n@,"xor()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ xor##_domain( D_ false##_domain(), D_ true##_domain() ), D_ true##_domain() ) )
       myerr(@n@,"xor()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ xor##_domain( D_ true##_domain(), D_ false##_domain() ), D_ true##_domain() ) )
       myerr(@n@,"xor()","");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ xor##_domain( D_ true##_domain(), D_ true##_domain() ), D_ false##_domain() ) )
       myerr(@n@,"xor()","");
   DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if( is_gr##_domain( D_ @X@, D_ @X@ ) )
       myerr(@n@,"is_gr()","@X@,@X@");
@) DD }

   void p_@N@()
   { if( is_gr##_domain( D_ @Y@, D_ @Z@ ) )
       myerr(@n@,"is_gr()","@Y@,@Z@");
   DD }

   void p_@N@()
   { if(! is_gr##_domain( D_ @Z@, D_ @Y@ ) )
       myerr(@n@,"is_gr()","@Z@,@Y@");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(  if(! is_ge##_domain( D_ @X@, D_ @X@ ) )
       myerr(@n@,"is_ge()","@X@,@X@");
@) DD }

   void p_@N@()
   { if( is_ge##_domain( D_ @Y@, D_ @Z@ ) )
       myerr(@n@,"is_ge()","@Y@,@Z@");
   DD }

   void p_@N@()
   { if(! is_ge##_domain( D_ @Z@, D_ @Y@ ) )
       myerr(@n@,"is_ge()","@Z@,@Y@");
   DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define REPEAT
#include <aux/com/del1/bbc2>

#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define REPEAT
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define REPEAT
#include <aux/com/fpr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/bool/com/basic/bbd1 <<'-----'
@X@=
false##_elem()
true##_elem()

@Y@=
false##_elem()

@Z@=
true##_elem()
-----
cat >$OUT_DIR/bool/com/basic/bbd2 <<'-----'
@X@=
false##_domain()
true##_domain()

@Y@=
false##_domain()

@Z@=
true##_domain()
-----
cat >$OUT_DIR/bool/com/basic/docu <<'-----'
Syntax:
  
  Bool = () -bool

Description:

  'Bool' is an elementary abstract data type for logical values.
  The predefined data type 'Bool' supplies its functionality
  and normally no further instanciations will be needed.

  Additional operations can be added, when required,
  in the IMPLEMENTATIONS section by

    Bool = + <additional op>
-----
[ -d $OUT_DIR/bool/com/default ] || mkdir $OUT_DIR/bool/com/default
cat >$OUT_DIR/bool/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the boolean datatype the following set of operations is
  added

#include <bool/com/default/vdm>
-----
cat >$OUT_DIR/bool/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + and + or + xor + not
             + is_eq + is_ge + is_gr
-----
[ -d $OUT_DIR/bool/com/parse ] || mkdir $OUT_DIR/bool/com/parse
cat >$OUT_DIR/bool/com/parse/ccod <<'-----'
DOMAIN parse##_DOMAIN _FPH0()
  { char *lx1 = readtoken_vdmlib(#DOMAIN);

#ifdef GEN_ISO
    if (strcmp(lx1,"true") == 0) { return TRUE; }
    if (strcmp(lx1,"false") != 0) { expected_vdmlib(#DOMAIN,"true or false",lx1); }
#else
    if (strcmp(lx1,"TRUE") == 0) { return TRUE; }
    if (strcmp(lx1,"FALSE") != 0) { expected_vdmlib(#DOMAIN,"TRUE or FALSE",lx1); }
#endif
    return FALSE;
  }
-----
cat >$OUT_DIR/bool/com/parse/docu <<'-----'

#ifdef GEN_ISO
  Syntax:  __EM(true) | __EM(false)
#else
  Syntax:  __EM(TRUE) | __EM(FALSE)
#endif

-----
cat >$OUT_DIR/bool/com/parse/vdm <<'-----'
#include <aux/com/parse/vdm>
-----
[ -d $OUT_DIR/bool/sign ] || mkdir $OUT_DIR/bool/sign
[ -d $OUT_DIR/bool/sign/and ] || mkdir $OUT_DIR/bool/sign/and
cat >$OUT_DIR/bool/sign/and/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendFct(and,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,and,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator &=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(and,FPARLIST2))

InlineFriendFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,and,FPARLIST2))
#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/bool/sign/and/gsig <<'-----'
  FUNCDEC(and##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/bool/sign/and/vsig <<'-----'
  and(x1,x2) =  x1 and x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/bool/sign/basic ] || mkdir $OUT_DIR/bool/sign/basic
cat >$OUT_DIR/bool/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
public:
  DOMAIN data;
  Cpp_DOMAIN()                                  {}
  Cpp_DOMAIN            (int x1)                { data = (DOMAIN)x1;               }
  Cpp_DOMAIN & operator=(int x1)                { data = (DOMAIN)x1; return *this; }
  Cpp_DOMAIN            (const Cpp_DOMAIN & x1) { data = x1.data;                  }
  Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1) { data = x1.data;    return *this; }

  operator int() const             {                return (int)data; }

  /* access function for data field for conversion between C++ and C */
  /* for consistency reasons, else oprtator int is sufficient */

  DOMAIN       cv##_DOMAIN() const              { return data;                  }
#endif

-----
cat >$OUT_DIR/bool/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/bool/sign/false ] || mkdir $OUT_DIR/bool/sign/false
cat >$OUT_DIR/bool/sign/false/gsig <<'-----'
  FUNCDEC(false##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/bool/sign/false/vsig <<'-----'
  false() =  FALSE
  TYPE :  -->  DOMAIN
-----
[ -d $OUT_DIR/bool/sign/iff ] || mkdir $OUT_DIR/bool/sign/iff
cat >$OUT_DIR/bool/sign/iff/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &
InlineFriendFct(iff,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,iff,FPARLIST2))

#if 0
#ifdef OPERATOR
InlineFriendFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,iff,FPARLIST2))
#endif
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/bool/sign/iff/gsig <<'-----'
  FUNCDEC(iff##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/bool/sign/iff/vsig <<'-----'
  iff(x1,x2) =  x1 <=> x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/bool/sign/implies ] || mkdir $OUT_DIR/bool/sign/implies
cat >$OUT_DIR/bool/sign/implies/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &
InlineFriendFct(implies,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,implies,FPARLIST2))

#if 0
#ifdef OPERATOR
InlineFriendFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,implies,FPARLIST2))
#endif
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/bool/sign/implies/gsig <<'-----'
  FUNCDEC(implies##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/bool/sign/implies/vsig <<'-----'
  implies(x1,x2) =  x1 ==> x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/bool/sign/not ] || mkdir $OUT_DIR/bool/sign/not
cat >$OUT_DIR/bool/sign/not/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(not,FPAR1(T1),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,not,FPARLIST1))

#ifdef OPERATOR
InlineFriendConstFct(operator !,FPAR1(T1),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,not,FPARLIST1))
#endif

#undef T1
-----
cat >$OUT_DIR/bool/sign/not/gsig <<'-----'
  FUNCDEC(not##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bool/sign/not/vsig <<'-----'
  not(x1,x2) =  not x1
  TYPE : DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/bool/sign/or ] || mkdir $OUT_DIR/bool/sign/or
cat >$OUT_DIR/bool/sign/or/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendFct(or,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,or,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator |=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(or,FPARLIST2))

InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,or,FPARLIST2))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/bool/sign/or/gsig <<'-----'
  FUNCDEC(or##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bool/sign/or/vsig <<'-----'
  or(x1,x2) =  x1 or x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/bool/sign/true ] || mkdir $OUT_DIR/bool/sign/true
cat >$OUT_DIR/bool/sign/true/gsig <<'-----'
  FUNCDEC(true##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/bool/sign/true/vsig <<'-----'
  true() =  TRUE
  TYPE :  -->  DOMAIN
-----
[ -d $OUT_DIR/bool/sign/xor ] || mkdir $OUT_DIR/bool/sign/xor
cat >$OUT_DIR/bool/sign/xor/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendFct(xor,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,xor,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator ^=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(xor,FPARLIST2))

InlineFriendFct(operator ^,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,xor,FPARLIST2))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/bool/sign/xor/gsig <<'-----'
  FUNCDEC(xor##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/bool/sign/xor/vsig <<'-----'
  xor(x1,x2) =  x1 != x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/com ] || mkdir $OUT_DIR/com
[ -d $OUT_DIR/com/aux ] || mkdir $OUT_DIR/com/aux
[ -d $OUT_DIR/com/aux/is_ge ] || mkdir $OUT_DIR/com/aux/is_ge
cat >$OUT_DIR/com/aux/is_ge/ccod <<'-----'
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN) 
   { err_uop_vdmlib(MKSTRING(DOMAIN),"is_ge"); }
-----
cat >$OUT_DIR/com/aux/is_ge/docu <<'-----'
  this predicate is not available in a general form
  for this DOMAIN
-----
cat >$OUT_DIR/com/aux/is_ge/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib = + err_uop
-----
[ -d $OUT_DIR/com/com ] || mkdir $OUT_DIR/com/com
[ -d $OUT_DIR/com/com/automemresult ] || mkdir $OUT_DIR/com/com/automemresult
cat >$OUT_DIR/com/com/automemresult/param <<'-----'
FCTNAME
ARGUMENT
OPERATION
-----
[ -d $OUT_DIR/com/com/basic ] || mkdir $OUT_DIR/com/com/basic
cat >$OUT_DIR/com/com/basic/adttype <<'-----'
AUXILIARY
-----
[ -d $OUT_DIR/com/com/constructor ] || mkdir $OUT_DIR/com/com/constructor
cat >$OUT_DIR/com/com/constructor/param <<'-----'
FCTNAME
ADT_BAG
ADT_BOOL
ADT_ENUM
ADT_MAP
ADT_NUMERIC
ADT_OPTI
ADT_REL
ADT_SET
ADT_TOKEN
ADT_TREE
ADT_TUPL
ADT_UNIO
IMPL_REAL
IMPL_SCALAR
IMPL_UNSIGNED
IMPL_EXTERN
IMPL_NAT0
IMPL_PTR
COMP_ELEM1
COMP_ELEM2
COMP_ELEM3
-----
[ -d $OUT_DIR/com/com/copy ] || mkdir $OUT_DIR/com/com/copy
cat >$OUT_DIR/com/com/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN) {return x1;}
-----
cat >$OUT_DIR/com/com/copy/cmcr <<'-----'
_DEFINE copy##_DOMAIN(x1) x1
-----
cat >$OUT_DIR/com/com/copy/pmcr <<'-----'
_DEFINE copy##_DOMAIN(x1) x1
-----
[ -d $OUT_DIR/com/com/copy1 ] || mkdir $OUT_DIR/com/com/copy1
cat >$OUT_DIR/com/com/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN) {return x1;}
-----
cat >$OUT_DIR/com/com/copy1/cmcr <<'-----'
_DEFINE copy1##_DOMAIN(x1) x1
-----
cat >$OUT_DIR/com/com/copy1/pmcr <<'-----'
#include <com/com/copy1/cmcr>
-----
[ -d $OUT_DIR/com/com/cvfromtupl ] || mkdir $OUT_DIR/com/com/cvfromtupl
cat >$OUT_DIR/com/com/cvfromtupl/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtupl##_DOMAIN _FPH1(TUPLDOMAIN)
  { DOMAIN lx1;
    lx1 = cvfromtup1##_DOMAIN(&x1);
    del##_TUPLDOMAIN(x1);
    return lx1;
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/com/cvfromtupl/cmcr <<'-----'
#include <aux/com/cvtotupl/defp>

_DEFINE cvfromtupl##_DOMAIN(x1) cvfromtup1##_DOMAIN(&x1)

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/com/cvfromtupl/docu <<'-----'
  The parameter is converted into a structured value using 'hd' and
  'tl' operations.

  The name of the result domain must be given through
  the parameter 'TUPLEDOMAIN'.
  Default value for 'TUPLEDOMAIN' is Str
-----
cat >$OUT_DIR/com/com/cvfromtupl/param <<'-----'
TUPLDOMAIN
NOCPP
-----
cat >$OUT_DIR/com/com/cvfromtupl/pmcr <<'-----'
#include <aux/com/cvtotupl/defp>

_DEFINE cvfromtupl##_DOMAIN(x1) cvfromtup1##_DOMAIN(x1)

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/com/cvfromtupl/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  DOMAIN	= + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
  TUPLDOMAIN	= + del

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/com/com/cvtotupl ] || mkdir $OUT_DIR/com/com/cvtotupl
cat >$OUT_DIR/com/com/cvtotupl/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotupl##_DOMAIN _FPH1(DOMAIN)
    { TUPLDOMAIN lx1;
      lx1 = cvtotup1##_DOMAIN(mk_empty##_TUPLDOMAIN(),x1);
      del##_DOMAIN(x1);
      return lx1;
    }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/com/cvtotupl/docu <<'-----'
  The parameter is converted into a tuple value using 'mk_empty' and 'appr'.

  The name of the result domain must be given through the parameter 'TUPLDOMAIN'.
  Default value for 'TUPLEDOMAIN' is 'Str'

  The byte string representation is usually machine independent,
  It does not matter wether the machine has little endian or big endian
  integer. An exeption are real number, here the internal byte representation
  is stored directly in the byte string.
-----
cat >$OUT_DIR/com/com/cvtotupl/param <<'-----'
TUPLDOMAIN
NOCPP
-----
cat >$OUT_DIR/com/com/cvtotupl/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  DOMAIN	= + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN) + del
  TUPLDOMAIN	= + mk_empty

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/com/com/default ] || mkdir $OUT_DIR/com/com/default
cat >$OUT_DIR/com/com/default/docu <<'-----'
#include <aux/com/default/docu>

  Example:

  DOMAINS
    Anydomain = Anyelement -anyconstructor

  IMPLEMENTATIONS
    Anydomain = anyimpl + default

-----
cat >$OUT_DIR/com/com/default/vdm <<'-----'
! default set of operations for any adt !
! = empty                               !

-----
[ -d $OUT_DIR/com/com/del ] || mkdir $OUT_DIR/com/com/del
cat >$OUT_DIR/com/com/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN) {}
-----
cat >$OUT_DIR/com/com/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1)
-----
cat >$OUT_DIR/com/com/del/pmcr <<'-----'
_DEFINE del##_DOMAIN(x1)
-----
[ -d $OUT_DIR/com/com/del1 ] || mkdir $OUT_DIR/com/com/del1
cat >$OUT_DIR/com/com/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) {}
-----
cat >$OUT_DIR/com/com/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(x1)
-----
cat >$OUT_DIR/com/com/del1/pmcr <<'-----'
#include <com/com/del1/cmcr>
-----
[ -d $OUT_DIR/com/com/finput ] || mkdir $OUT_DIR/com/com/finput
cat >$OUT_DIR/com/com/finput/ccod <<'-----'
_IFDEF __cplusplus
_FDEC1(finput,DOMAIN,istream&,
       _SEQ(parseinput_vdmlib = &x1,_RET(parse##_DOMAIN())))
_ELSE
_FDEC1(finput,DOMAIN,FILE *,
       _SEQ(parseinput_vdmlib = x1,_RET(parse##_DOMAIN())))
_ENDIF
-----
cat >$OUT_DIR/com/com/finput/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + parse
  Vdmlib = + parseio
-----
[ -d $OUT_DIR/com/com/format ] || mkdir $OUT_DIR/com/com/format
cat >$OUT_DIR/com/com/format/ccod <<'-----'
#ifndef MAXLINELEN
#define MAXLINELEN 80
#endif

  Str format##_DOMAIN _FPH1(DOMAIN)
    { Cvtext_vdmlib lx1;
      Str res;
      curr_linelen_vdmlib = MAXLINELEN;
      lx1 = cvlines##_DOMAIN(x1);

      { Nat0 i,l;
        i = 1;
        l = len_cvtext_vdmlib(lx1);
        res = mk_empty_str();
        while (i <= l) {
          res = conc_str(res,sel_cvtext_vdmlib(lx1,i));
          if (i != l)
            res = appr_str(res,'\n');
          ++i;
        } 
      }
      del1_cvtext_vdmlib(lx1);
      return res;
    }
#undef MAXLINELEN
-----
cat >$OUT_DIR/com/com/format/param <<'-----'
MAXLINELEN
-----
cat >$OUT_DIR/com/com/format/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
  DOMAIN  = + cvlines
  Str     = + mk_empty + appr + conc
  Cvtext_vdmlib = + len + sel + del1
-----
[ -d $OUT_DIR/com/com/fpr ] || mkdir $OUT_DIR/com/com/fpr
cat >$OUT_DIR/com/com/fpr/ccod <<'-----'
#ifndef MAXLINELEN
#define MAXLINELEN 80
#endif

_IFDEF __cplusplus
  void fpr##_DOMAIN _FPH2(ostream &,DOMAIN)
_ELSE
  void fpr##_DOMAIN _FPH2(FILE *,DOMAIN)
_ENDIF
    { Cvtext_vdmlib lx1;
      curr_linelen_vdmlib = MAXLINELEN;
      lx1 = cvlines##_DOMAIN(x2);
      fprint_lines_vdmlib(x1,lx1);
      del_cvtext_vdmlib(lx1);
    }
#undef MAXLINELEN
-----
cat >$OUT_DIR/com/com/fpr/param <<'-----'
MAXLINELEN
-----
cat >$OUT_DIR/com/com/fpr/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
  DOMAIN  = + cvlines
  Vdmlib  = + header("IOSTREAM")
  Str     = + sel
-----
[ -d $OUT_DIR/com/com/fprint ] || mkdir $OUT_DIR/com/com/fprint
cat >$OUT_DIR/com/com/fprint/ccod <<'-----'
_IFDEF __cplusplus
  void fprint##_DOMAIN _FPH2(ostream &,DOMAIN)
    { 
      ostream * lx1 = ptr_print_FD_vdmlib;
      ptr_print_FD_vdmlib = & x1;
      print##_DOMAIN(x2);
      ptr_print_FD_vdmlib = lx1;
    }
_ELSE
  void fprint##_DOMAIN _FPH2(FILE *,DOMAIN)
    { 
      FILE *lx1 = print_FD_vdmlib;
      print_FD_vdmlib = x1;
      print##_DOMAIN(x2);
      print_FD_vdmlib = lx1;
    }
_ENDIF
-----
cat >$OUT_DIR/com/com/fprint/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + print
  Vdmlib  = + header("IOSTREAM")
            + printsup
-----
[ -d $OUT_DIR/com/com/gcinfo ] || mkdir $OUT_DIR/com/com/gcinfo
cat >$OUT_DIR/com/com/gcinfo/ccod <<'-----'
#define Handle Nat0

/* the function gc_info1 returns the handle 0, to signal that DOMAIN is not
  implemented by an automem implementation and therefore no real handle 
  is available ! 
*/
Handle get_gc_info1##_DOMAIN(DOMAIN x1, Adts * x2)
{
   return (Handle) 0; 
}

/* only dummy operation, do not call ! */
Adts get_gc_info##_DOMAIN(DOMAIN x1)
{
   return (Adts) 0;
}

#undef Handle

-----
[ -d $OUT_DIR/com/com/input ] || mkdir $OUT_DIR/com/com/input
cat >$OUT_DIR/com/com/input/ccod <<'-----'
#include <com/com/input/gcod>
-----
cat >$OUT_DIR/com/com/input/cmcr <<'-----'
#include <com/com/input/gcod>
-----
cat >$OUT_DIR/com/com/input/gcod <<'-----'
_FDEC0(input,DOMAIN,_RET(finput##_DOMAIN(stdin)))
-----
cat >$OUT_DIR/com/com/input/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + finput
-----
[ -d $OUT_DIR/com/com/is_eq ] || mkdir $OUT_DIR/com/com/is_eq
cat >$OUT_DIR/com/com/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return (x1==x2);}   
-----
cat >$OUT_DIR/com/com/is_eq/cmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) ((x1) == (x2))
-----
cat >$OUT_DIR/com/com/is_eq/docu <<'-----'
  the equivalence predicate
-----
cat >$OUT_DIR/com/com/is_eq/pmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) ((x1) = (x2))
-----
[ -d $OUT_DIR/com/com/is_ge ] || mkdir $OUT_DIR/com/com/is_ge
cat >$OUT_DIR/com/com/is_ge/ccod <<'-----'
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return (x1>=x2);}   
-----
cat >$OUT_DIR/com/com/is_ge/cmcr <<'-----'
_DEFINE is_ge##_DOMAIN(x1,x2) ((x1) >= (x2))
-----
cat >$OUT_DIR/com/com/is_ge/pmcr <<'-----'
_DEFINE is_ge##_DOMAIN(x1,x2) ((x1) >= (x2))
-----
[ -d $OUT_DIR/com/com/is_gr ] || mkdir $OUT_DIR/com/com/is_gr
cat >$OUT_DIR/com/com/is_gr/ccod <<'-----'
  Bool is_gr##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return (is_ge##_DOMAIN(x1,x2) && ! is_eq##_DOMAIN(x1,x2));}
-----
cat >$OUT_DIR/com/com/is_gr/docu <<'-----'
  general implementation of is_gr ( > )
  as  is_ge(x1,x2) & ~ is_eq(x1,x2) 
  ( x1 >= x2 && x1 != x2 )
-----
cat >$OUT_DIR/com/com/is_gr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + is_gr + is_eq
-----
[ -d $OUT_DIR/com/com/is_le ] || mkdir $OUT_DIR/com/com/is_le
cat >$OUT_DIR/com/com/is_le/docu <<'-----'
  General implementation of is_le ( <= ) using is_ge.
-----
cat >$OUT_DIR/com/com/is_le/gcod <<'-----'
  _FDEC2(is_le,Bool,DOMAIN,DOMAIN,_RET(is_ge##_DOMAIN((x2),(x1))))
-----
cat >$OUT_DIR/com/com/is_le/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + is_ge
-----
[ -d $OUT_DIR/com/com/is_lt ] || mkdir $OUT_DIR/com/com/is_lt
cat >$OUT_DIR/com/com/is_lt/docu <<'-----'
  General implementation of is_lt ( < ) using is_gr.
-----
cat >$OUT_DIR/com/com/is_lt/gcod <<'-----'
  _FDEC2(is_lt,Bool,DOMAIN,DOMAIN,_RET(is_gr##_DOMAIN((x2),(x1))))
-----
cat >$OUT_DIR/com/com/is_lt/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + is_gr
-----
[ -d $OUT_DIR/com/com/load ] || mkdir $OUT_DIR/com/com/load
cat >$OUT_DIR/com/com/load/ccod <<'-----'
  Bool load##_DOMAIN _FPH2(Str,DOMAIN *)
    { 
      Vdmlib_inbytes lx1;
      lx1 = fread_vdmlib_inbytes(x1);
      if (is_empty_vdmlib_inbytes(lx1))
        return 0;

      *x2 = cvfromtupl##_DOMAIN(lx1);
      return 1;
    }
-----
cat >$OUT_DIR/com/com/load/vdm <<'-----'
DOMAINS
  Vdmlib_inbytes = Char *

IMPLEMENTATIONS
  Vdmlib_inbytes  = readfile("MACROS","INTERNALDOMAIN")
                  + fread
                  + is_empty
  DOMAIN          =
                  + cvfromtupl("TUPLDOMAIN"=Vdmlib_inbytes,"NOCPP")
                  + del

-----
[ -d $OUT_DIR/com/com/mfold ] || mkdir $OUT_DIR/com/com/mfold
cat >$OUT_DIR/com/com/mfold/ccod <<'-----'
#include <com/com/mfold/macroa>

#define MACRO1(yn,x) static x MERGE(__fctname,yn);
#include <com/com/mfold/macroX>
#define MACRO1(xn,d) static d MERGE(__fctname,xn);
#include <com/com/mfold/macroD>
static DOMAIN __resvar;

static void __cvfctcall _FPH0()
  { __resvar = __foldfct(__resvar,__cvfct(_cPLCV _cPLX)); }

 DOMAIN __fctname (_aPL1 _aPLX1) _aPL2 _aPLX2
   {
#define MACRO1(yn,x) MERGE(__fctname,yn) = yn;
#include <com/com/mfold/macroX>
#define MACRO1(xn,d) MERGE(__fctname,xn) = xn;
#include <com/com/mfold/macroD>

    __resvar = __nullfct();
    forall##_DOMAIN1(MERGE(__fctname,x1),mfoldfct##_FCTNAME##_DOMAIN1);
    return __resvar;

   }
#include <com/com/mfold/macroe>
-----
cat >$OUT_DIR/com/com/mfold/ctyp <<'-----'
#ifdef GEN_C
#include <com/com/mfold/macroa>
#define MACRO1(xn,d) static d MERGE(__fctname,xn);
#include <com/com/mfold/macroD>
#include <com/com/mfold/macroe>
#endif
-----
cat >$OUT_DIR/com/com/mfold/macroD <<'-----'
#ifdef DOMAIN1
MACRO1(x1,DOMAIN1)
#endif
#ifdef DOMAIN2
MACRO1(x2,DOMAIN2)
#endif
#ifdef DOMAIN3
MACRO1(x3,DOMAIN3)
#endif
#ifdef DOMAIN4
MACRO1(x4,DOMAIN4)
#endif
#ifdef DOMAIN5
MACRO1(x5,DOMAIN5)
#endif

#undef MACRO1
-----
cat >$OUT_DIR/com/com/mfold/macroX <<'-----'
#ifdef X
MACRO1(y1,X)
#endif
#ifdef XX
MACRO1(y2,XX)
#endif
#ifdef XXX
MACRO1(y3,XXX)
#endif
#ifdef XXXX
MACRO1(y4,XXXX)
#endif
#ifdef XXXXX
MACRO1(y5,XXXXX)
#endif

#undef MACRO1
-----
cat >$OUT_DIR/com/com/mfold/macroa <<'-----'

#ifndef DOMAIN1
#error DOMAIN: At least one DOMAIN<n> parameter must be set for 'mfold'
#else
#ifndef DOMAIN2
#define _fPL	DOMAIN1 x1
#define _fPLCV	MERGE(MERGE(_fp,_FCTNAME),_DOMAIN1)
#define _aPL1	_FP(x1,DOMAIN1)
#define _aPL2	_EP(x1,DOMAIN1)
#define _cPLCV	MERGE(MERGE(_ap,_FCTNAME),_DOMAIN1)
#else
#ifndef DOMAIN3
#define _fPL	DOMAIN1 x1, DOMAIN2 x2
#define _fPLCV	MERGE(MERGE(_fp,_FCTNAME),_DOMAIN1), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN2) 
#define _aPL1	_FP(x1,DOMAIN1), _FP(x2,DOMAIN2)
#define _aPL2	_EP(x1,DOMAIN1) _EP(x2,DOMAIN2)
#define _cPLCV	MERGE(MERGE(_ap,_FCTNAME),_DOMAIN1), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN2)
#else
#ifndef DOMAIN4
#define _fPL	DOMAIN1 x1, DOMAIN2 x2, DOMAIN3 x3
#define _fPLCV	MERGE(MERGE(_fp,_FCTNAME),_DOMAIN1), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN2), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN3)
#define _aPL1	_FP(x1,DOMAIN1), _FP(x2,DOMAIN2), _FP(x3,DOMAIN3)
#define _aPL2	_EP(x1,DOMAIN1) _EP(x2,DOMAIN2) _EP(x3,DOMAIN3)
#define _cPLCV	MERGE(MERGE(_ap,_FCTNAME),_DOMAIN1), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN2), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN3)
#else
#ifndef DOMAIN5
#define _fPL	DOMAIN1 x1, DOMAIN2 x2, DOMAIN3 x3, DOMAIN4 x4
#define _fPLCV	MERGE(MERGE(_fp,_FCTNAME),_DOMAIN1), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN2), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN3), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN4)
#define _aPL1	_FP(x1,DOMAIN1), _FP(x2,DOMAIN2), _FP(x3,DOMAIN3), _FP(x4,DOMAIN4)
#define _aPL2	_EP(x1,DOMAIN1) _EP(x2,DOMAIN2) _EP(x3,DOMAIN3) _EP(x4,DOMAIN4)
#define _cPLCV	MERGE(MERGE(_ap,_FCTNAME),_DOMAIN1), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN2), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN3), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN4)
#else
#define _fPL	DOMAIN1 x1, DOMAIN2 x2, DOMAIN3 x3, DOMAIN4 x4, DOMAIN5 x5
#define _fPLCV	MERGE(MERGE(_fp,_FCTNAME),_DOMAIN1), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN2), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN3), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN4), MERGE(MERGE(_fp,_FCTNAME),_DOMAIN5)
#define _aPL1	_FP(x1,DOMAIN1), _FP(x2,DOMAIN2), _FP(x3,DOMAIN3), _FP(x4,DOMAIN4), _FP(x5,DOMAIN5)
#define _aPL2	_EP(x1,DOMAIN1) _EP(x2,DOMAIN2) _EP(x3,DOMAIN3) _EP(x4,DOMAIN4) _EP(x5,DOMAIN5)
#define _cPLCV	MERGE(MERGE(_ap,_FCTNAME),_DOMAIN1), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN2), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN3), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN4), MERGE(MERGE(_ap,_FCTNAME),_DOMAIN5)
#endif
#endif
#endif
#endif
#endif

#ifdef CVFCTRES
#define __CVFCTRES CVFCTRES
#else
#define __CVFCTRES DOMAIN
#endif

#define __fctname MERGE(FCTNAME,_DOMAIN)
#define __cvfct MERGE(CVFCT,_DOMAIN)
#define __cvfctcall MERGE(callcv_,__fctname)
#define __foldfct MERGE(FOLDFCT,_DOMAIN)
#define __nullfct MERGE(NULLFCT,_DOMAIN)

#define __resvar MERGE(__fctname,_res)

#ifndef X
#define _fPLX
#else
#ifndef XX
#define _fPLX	,X y1
#define _aPLX1	, _FP(y1,X)
#define _aPLX2	_EP(y1,X)
#define _cPLX	,MERGE(__fctname,y1)
#else
#ifndef XXX
#define _fPLX	,X y1, XX y2
#define _aPLX1	, _FP(y1,X), _FP(y2,XX)
#define _aPLX2	_EP(y1,X) _EP(y2,XX)
#define _cPLX	,MERGE(__fctname,y1), MERGE(__fctname,y2)
#else
#ifndef XXXX
#define _fPLX	,X y1, XX y2, XXX y3
#define _aPLX1	, _FP(y1,X), _FP(y2,XX), _FP(y3,XXX)
#define _aPLX2	_EP(y1,X) _EP(y2,XX) _EP(y3,XXX) 
#define _cPLX	,MERGE(__fctname,y1), MERGE(__fctname,y2), MERGE(__fctname,y3)
#else
#ifndef XXXXX
#define _fPLX	,X y1, XX y2, XXX y3, XXXX y4
#define _aPLX1	, _FP(y1,X), _FP(y2,XX), _FP(y3,XXX), _FP(y4,XXXX)
#define _aPLX2	_EP(y1,X) _EP(y2,XX) _EP(y3,XXX) _EP(y4,XXXX)
#define _cPLX	,MERGE(__fctname,y1), MERGE(__fctname,y2), MERGE(__fctname,y3), MERGE(__fctname,y4)
#else
#define _fPLX	,X y1, XX y2, XXX y3, XXXX y4, XXXXX y5
#define _aPLX1	, _FP(y1,X), _FP(y2,XX), _FP(y3,XXX), _FP(y4,XXXX), _FP(y5,XXXXX)
#define _aPLX2	_EP(y1,X) _EP(y2,XX) _EP(y3,XXX) _EP(y4,XXXX) _EP(y5,XXXXX)
#define _cPLX	,MERGE(__fctname,y1), MERGE(__fctname,y2), MERGE(__fctname,y3), MERGE(__fctname,y4), MERGE(__fctname,y5)
#endif
#endif
#endif
#endif
#endif

-----
cat >$OUT_DIR/com/com/mfold/macroe <<'-----'
#undef _fPL
#undef _fPLX
#undef _aPL1
#undef _aPL2
#undef _aPLX1
#undef _aPLX2
#undef _cPLX
#undef __CVFCTNAME
#undef __fctname
#undef __cvfct
#undef __cvfctcall
#undef __foldfct
#undef __nullfct
#undef __resvar
-----
cat >$OUT_DIR/com/com/mfold/param <<'-----'
FOLDFCT
CVFCT
NULLFCT
DOMAIN1
DOMAIN2
DOMAIN3
DOMAIN4
DOMAIN5
FCTNAME
X
XX
XXX
XXXX
XXXXX
-----
cat >$OUT_DIR/com/com/mfold/vdm <<'-----'
#include <com/com/mfold/macroa>

DOMAINS
IMPLEMENTATIONS
#ifndef DOMAIN2
  DOMAIN1 = + mfolddom.FCTNAME(CALLDOM=DOMAIN)
#else
  DOMAIN1 = + mfolddom.FCTNAME(NEXTDOM=DOMAIN2,XN=__fctname##x2)
#ifndef DOMAIN3
  DOMAIN2 = + mfolddom.FCTNAME(CALLDOM=DOMAIN)
#else
  DOMAIN2 = + mfolddom.FCTNAME(NEXTDOM=DOMAIN3,XN=__fctname##x3)
#ifndef DOMAIN4
  DOMAIN3 = + mfolddom.FCTNAME(CALLDOM=DOMAIN)
#else
  DOMAIN3 = + mfolddom.FCTNAME(NEXTDOM=DOMAIN4,XN=__fctname##x4)
#ifndef DOMAIN5
  DOMAIN4 = + mfolddom.FCTNAME(CALLDOM=DOMAIN)
#else
  DOMAIN4 = + mfolddom.FCTNAME(NEXTDOM=DOMAIN5,XN=__fctname##x5)
#endif
  DOMAIN5 = + mfolddom.FCTNAME(CALLDOM=DOMAIN)
#endif
#endif
#endif

#include <com/com/mfold/macroe>
-----
[ -d $OUT_DIR/com/com/mk_one ] || mkdir $OUT_DIR/com/com/mk_one
cat >$OUT_DIR/com/com/mk_one/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN = + mk1
-----
[ -d $OUT_DIR/com/com/pr ] || mkdir $OUT_DIR/com/com/pr
cat >$OUT_DIR/com/com/pr/ccod <<'-----'
_IFDEF __cplusplus
  void pr##_DOMAIN _FPH1(DOMAIN) { fpr##_DOMAIN(cout,x1); }
_ELSE
  void pr##_DOMAIN _FPH1(DOMAIN) { fpr##_DOMAIN(stdout,x1); }
_ENDIF
-----
cat >$OUT_DIR/com/com/pr/cmcr <<'-----'
_IFDEF __cplusplus
_DEFINE pr##_DOMAIN(x1) fpr##_DOMAIN(cout,x1)
_ELSE
_DEFINE pr##_DOMAIN(x1) fpr##_DOMAIN(stdout,x1)
_ENDIF
-----
cat >$OUT_DIR/com/com/pr/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
  DOMAIN  = + fpr
  Vdmlib  = + header("IOSTREAM")
-----
[ -d $OUT_DIR/com/com/rename ] || mkdir $OUT_DIR/com/com/rename
cat >$OUT_DIR/com/com/rename/param <<'-----'
ADT
FCTNAME
NAME
NOADD
-----
cat >$OUT_DIR/com/com/rename/vdm <<'-----'
#ifndef NOADD
_ADD_OP(DOMAIN,FCTNAME)
#endif
-----
[ -d $OUT_DIR/com/com/signature ] || mkdir $OUT_DIR/com/com/signature
cat >$OUT_DIR/com/com/signature/docu <<'-----'
  auxiliary operation for generating signatures (prototypes,
  member function declarations, procedure headings, ...)

  Parameters:

  "RESULT"
            result type of operation (default: void)
  "X"
            1. Parameter type (default: DOMAIN)
  "XX"
            2. Parameter type (optional)
  "XXX"
            3. Parameter type (optional)
  "XXXX"
            4. Parameter type (optional)
  "XXXXX"
            5. Parameter type (optional)   
  "XXXXXX"
            6. Parameter type (optional)
  "XXXXXXX"
            7. Parameter type (optional)
  "XXXXXXXX"
            8. Parameter type (optional)
  "XXXXXXXXX"
            9. Parameter type (optional)
  "XXXXXXXXXX"
            10. Parameter type (optional)
  "RESULT<i>"
            optional additional result values implemented as reference parameter
            <i> may range from 2 to 5


  "NOTCONST"
            for C++ only: member function is not const
  "MANIPULATOR"
            for C++ only: result is of type "DOMAIN &"
-----
cat >$OUT_DIR/com/com/signature/param <<'-----'
DUMMY
FCTNAME
NOTCONST
MANIPULATOR
SIGNATURESTRING
RESULT
RESULT2
RESULT3
RESULT4
RESULT5
X
XX
XXX
XXXX
XXXXX
XXXXXX
XXXXXXX
XXXXXXXX
XXXXXXXXX
XXXXXXXXXX
-----
[ -d $OUT_DIR/com/com/store ] || mkdir $OUT_DIR/com/com/store
cat >$OUT_DIR/com/com/store/ccod <<'-----'
  Bool store##_DOMAIN _FPH2(DOMAIN,Str)
    { 
      Vdmlib_outbytes lx1;
      Bool wr;

      lx1 = cvtotupl##_DOMAIN(x1);
      wr  = fwrite_vdmlib_outbytes(lx1,x2);
      del1_vdmlib_outbytes(lx1);

      return
        wr;
    }
-----
cat >$OUT_DIR/com/com/store/vdm <<'-----'
DOMAINS
  Vdmlib_outbytes = Char *

IMPLEMENTATIONS
  Vdmlib_outbytes = writefile("MACROS","INTERNALDOMAIN")
                  + fwrite
                  + del1
  DOMAIN          =
                  + cvtotupl("TUPLDOMAIN"=Vdmlib_outbytes,"NOCPP")

-----
[ -d $OUT_DIR/com/sign ] || mkdir $OUT_DIR/com/sign
[ -d $OUT_DIR/com/sign/basic ] || mkdir $OUT_DIR/com/sign/basic
cat >$OUT_DIR/com/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN { 
public:
  DOMAIN data;
  /* 
     === the macro BASEIMPL is defined only if the actual domain ===
     === is realised by an automem implementation                === 
     */
#ifdef BASEIMPL
  Cpp_DOMAIN()
  {
    data = 0; 
    CA == non valid handle CE
  }

  ~Cpp_DOMAIN()
  {
    del##_DOMAIN(data);
  }

  Cpp_DOMAIN(const Cpp_DOMAIN & x1)
  {
    check_handle##_DOMAIN(x1.data);
    data = x1.data;
    data->f_rc++;
  }

  Cpp_DOMAIN(const DOMAIN &x1)
  {
    check_handle##_DOMAIN(x1);
    data = x1;
  }

  Cpp_DOMAIN & operator = (const Cpp_DOMAIN & x1)
  { 
    check_handle##_DOMAIN(x1.data);
    (x1.data)->f_rc++;
    if (data!=0) del##_DOMAIN(data);
    data = x1.data;
    return *this;
  }

  /* for moving a C++ object into a C data structure, e.g. a union */
  /* conversion back to C++ is done implicitly by Constuctor Cpp_DOMAIN(const DOMAIN & x1) */
  /* use count is incremented to prevent deletion by destructors */

  DOMAIN cv##_DOMAIN() const
  {
    check_handle##_DOMAIN(data);
    data->f_rc++;
    return data;
  }

#else
  Cpp_DOMAIN            ()                      {                               }
  Cpp_DOMAIN            (const     DOMAIN & x1) { data = x1;                    }
  Cpp_DOMAIN            (const Cpp_DOMAIN & x1) { data = x1.data;               }
  Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1) { data = x1.data; return *this; }

  /* access function for data field for conversion between C++ and C */
  DOMAIN       cv##_DOMAIN() const              { return data;                  }
#endif
#endif
-----
cat >$OUT_DIR/com/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/com/sign/copy ] || mkdir $OUT_DIR/com/sign/copy
cat >$OUT_DIR/com/sign/copy/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#if defined(BASEIMPL)
CA === Member function 'copy' not required for automem implementations === CE
#else
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(copy,FPAR1(T1),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,copy,FPARLIST1))
#undef T1
#endif
#endif
-----
cat >$OUT_DIR/com/sign/copy/gsig <<'-----'
  FUNCDEC(copy##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/com/sign/copy/vsig <<'-----'
  copy(x1) = x1
  TYPE : DOMAIN  -->  DOMAIN

  generates a physical copy of a value inclusiv all subvalues
  if the value x1 or any substructure of x1 uses heap
  memory, this heap space is duplicated

  if x1 does not contain any dynamically allocated heap space
  copy becomes a dummy routine

#include <aux/automem/basic/docucopydel>

-----
[ -d $OUT_DIR/com/sign/copy1 ] || mkdir $OUT_DIR/com/sign/copy1
cat >$OUT_DIR/com/sign/copy1/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#ifdef BASEIMPL
COMMENT_(Member function 'copy1' not required for automem implementations) 
#else
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(copy1,FPAR1(T1),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,copy1,FPARLIST1))
#undef T1
#endif

#endif
-----
cat >$OUT_DIR/com/sign/copy1/gsig <<'-----'
  FUNCDEC(copy1##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/com/sign/copy1/vsig <<'-----'
  copy1(x1) = x1
  TYPE : DOMAIN  -->  DOMAIN

  the value x1 is duplicated
  if x1 is a dynamically allocated heap value a new
  copy is generated on the heap
  if x1 is not represented by a heap value,
  copy1  returns just its parameter x1

#include <aux/automem/basic/docucopydel>

  See also:
    __SA(copy), __SA(del1) 
-----
[ -d $OUT_DIR/com/sign/copy2 ] || mkdir $OUT_DIR/com/sign/copy2
cat >$OUT_DIR/com/sign/copy2/gsig <<'-----'
  FUNCDEC(copy2##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/com/sign/copy2/vsig <<'-----'
  copy2(x1) = < copy1(x1[i]) | i e ind x1 >
  TYPE : DOMAIN  -->  DOMAIN

  Take a copy of the argument. __EM(copy2) works similar to __SA(copy1)
  but takes copies of the substructures down to level 1.

  This operation mainly is supplied for internal use for implementation
  of domains based hierarchically upone other domains. It is implemented
  for tuples only at the moment.

#include <aux/automem/basic/docucopydel>

  See also: copy, copy1
-----
[ -d $OUT_DIR/com/sign/cvfromtup1 ] || mkdir $OUT_DIR/com/sign/cvfromtup1
cat >$OUT_DIR/com/sign/cvfromtup1/gsig <<'-----'
#include <aux/com/cvtotupl/defp>

  FUNCDEC(cvfromtup1##_DOMAIN,PL_R(TUPLDOMAIN),DOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/sign/cvfromtup1/vsig <<'-----'
  cvfromtup1(x1) =
  TYPE : Byte*  -->  (DOMAIN Byte*)
  
  Function to convert a bytestring into a structured value of type 
  DOMAIN. The new bytestring is the old one with the byte representation
  of the DOMAIN element removed from its head. It is passed by using
  x1 as reference parameter.  This function is usually called via 
  the function __SA(cvfromtupl).
-----
[ -d $OUT_DIR/com/sign/cvfromtupl ] || mkdir $OUT_DIR/com/sign/cvfromtupl
cat >$OUT_DIR/com/sign/cvfromtupl/cpp <<'-----'
#ifndef NOCPP
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#include <aux/com/cvtotupl/defp>

InlineNoFriendFct(cvfromtupl,KPAR1(Cpp_TUPLDOMAIN &),Cpp_DOMAIN &)
#if !defined(BASEIMPL)
RUMPF(BODY2(cvfromtupl,(x1.data)))
#else
RUMPF({MERGE(del,_DOMAIN)(data);
       BODY2(cvfromtupl,(x1.data);x1.data=0 /* tupl destroyed !*/)})
#endif

#include <aux/com/cvtotupl/undefp>

#endif
#endif
-----
cat >$OUT_DIR/com/sign/cvfromtupl/gsig <<'-----'
#include <aux/com/cvtotupl/defp>

  FUNCDEC(cvfromtupl##_DOMAIN,PL_1(TUPLDOMAIN),DOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/sign/cvfromtupl/vsig <<'-----'
  cvfromtupl(x1) =
  TYPE : Byte *  -->  DOMAIN
  
  Function to convert a structured value that has been converted
  into a bytestring using the function __SA(cvtotupl) back into a value
  of type DOMAIN.

  The Bytestring is destroyed.

  The name of the tuple Domain "Byte *" must be supplied by a parameter
  of the cvfromtupl in the implementation description

  See also: 
    __SA(cvtotupl) (operation), __A("readfile",tupl.readfile.basic) (tuple implementation)
-----
[ -d $OUT_DIR/com/sign/cvlines ] || mkdir $OUT_DIR/com/sign/cvlines
cat >$OUT_DIR/com/sign/cvlines/gsig <<'-----'
  FUNCDEC(cvlines##_DOMAIN,PL_1(DOMAIN),Cvtext_vdmlib)
  COMMENT_(global variable 'curr_linelen_vdmlib' determines line length)
-----
cat >$OUT_DIR/com/sign/cvlines/vsig <<'-----'
  cvlines(x1) =
  TYPE : DOMAIN  -->  Str *
  
  auxiliary function for building a formated text representation
  of the value x1.

  This routine is used by the "pr" and "fpr" routines

  The line length of the formated output can be controlled by
  the global predefined variable "curr_linelen_vdmlib".
  The default value is 80 characters.

  The result type of the formated output, a list of strings,
  is named __EM(Cvtext_vdmlib).
  This internal domain is automatically added, when the
  formated output functions are used.

-----
[ -d $OUT_DIR/com/sign/cvstr ] || mkdir $OUT_DIR/com/sign/cvstr
cat >$OUT_DIR/com/sign/cvstr/cpp <<'-----'
InlineFriendFct(cvstr,FPAR1(const Cpp_DOMAIN &),Cpp_STR)
RUMPF(BODY1(Cpp_STR,cvstr,FPARLIST1))
-----
cat >$OUT_DIR/com/sign/cvstr/gsig <<'-----'
  FUNCDEC(cvstr##_DOMAIN,PL_1(DOMAIN),Str)
-----
cat >$OUT_DIR/com/sign/cvstr/vsig <<'-----'
  cvstr(x1) =
  TYPE : DOMAIN  -->  Str

  converts a value of type DOMAIN into a single line string representation
-----
[ -d $OUT_DIR/com/sign/cvtotup1 ] || mkdir $OUT_DIR/com/sign/cvtotup1
cat >$OUT_DIR/com/sign/cvtotup1/gsig <<'-----'
#include <aux/com/cvtotupl/defp>

  FUNCDEC(cvtotup1##_DOMAIN,PL_2(TUPLDOMAIN,DOMAIN),TUPLDOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/sign/cvtotup1/vsig <<'-----'
  cvtotup1(x1,x2) =
    x1 ^ ! byte representation of x2 !
  TYPE : Byte*  DOMAIN  -->  Byte*
  
  Function to convert a structured value of type DOMAIN
  into a tuple of bytes. The byte representation is appended 
  to the first argument. This function is usually called via 
  the function __SA(cvtotupl).
-----
[ -d $OUT_DIR/com/sign/cvtotupl ] || mkdir $OUT_DIR/com/sign/cvtotupl
cat >$OUT_DIR/com/sign/cvtotupl/cpp <<'-----'
#ifndef NOCPP
#include <aux/com/cvtotupl/defp>

InlineFriendFct(cvtotupl,FPAR1(const Cpp_DOMAIN &),Cpp_TUPLDOMAIN)
RUMPF(BODY1(Cpp_TUPLDOMAIN,cvtotupl,FPARLIST1))

#include <aux/com/cvtotupl/undefp>
#endif
-----
cat >$OUT_DIR/com/sign/cvtotupl/gsig <<'-----'
#include <aux/com/cvtotupl/defp>

  FUNCDEC(cvtotupl##_DOMAIN,PL_1(DOMAIN),TUPLDOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/com/sign/cvtotupl/vsig <<'-----'
  cvtotupl(x1) =
  TYPE : DOMAIN  -->  Byte *
  
  Function to convert a structured value of type DOMAIN
  into a tuple of bytes.

  The function __SA(cvfromtupl) can be used to transform the byte sequence
  back into a structured value. 
  __EM(cvtotupl) and __SA(cvfromtupl) can be used for I/O of structured values
  to implement persistent objects.

  The DOMAIN argument will be destroyed after conversion into a tuple
  and must be copied explicitly if still needed after conversion.

  The name of the tuple Domain "Byte *" must be supplied by a parameter
  of __EM(cvtotupl) in the implementation description

  See also:
     __SA(cvfromtupl) (operation), __A("writefile",tupl.writefile.basic) (tuple implementation)
-----
[ -d $OUT_DIR/com/sign/del ] || mkdir $OUT_DIR/com/sign/del
cat >$OUT_DIR/com/sign/del/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#ifdef BASEIMPL
CA === Member function 'del' not required for automem implementations === CE
#else
#define T1 Cpp_DOMAIN &
InlineFriendFct(del,FPAR1(T1),void)
RUMPF(BODY3(del,FPARLIST1))
#undef T1
#endif

#endif
-----
cat >$OUT_DIR/com/sign/del/gsig <<'-----'
  PROCDEC(del##_DOMAIN,PL_1(DOMAIN))
-----
cat >$OUT_DIR/com/sign/del/vsig <<'-----'
  del(x1) =
  TYPE : DOMAIN  -->

  __EM(del) releases the memory allocated on the heap for the value x1
  and all dynamically allocated substructures.

  If the value is not allocated on the heap and if it does not contain
  any dynamically allocated substructures, the function is a noop

#include <aux/automem/basic/docucopydel>

  See also:
    __SA(del1) (Operation)
-----
[ -d $OUT_DIR/com/sign/del1 ] || mkdir $OUT_DIR/com/sign/del1
cat >$OUT_DIR/com/sign/del1/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#ifdef BASEIMPL
COMMENT_(Member function 'del1' not required for automem implementations) 
#else
#define T1 const Cpp_DOMAIN &
InlineFriendFct(del1,FPAR1(T1),void)
RUMPF(BODY3(del1,FPARLIST1))
#undef T1
#endif

#endif
-----
cat >$OUT_DIR/com/sign/del1/gsig <<'-----'
  PROCDEC(del1##_DOMAIN,PL_1(DOMAIN))
-----
cat >$OUT_DIR/com/sign/del1/vsig <<'-----'
  del1(x1) =
  TYPE : DOMAIN   -->

  the value x1 is deleted like with del
  but if x1 is a structured value only x1 is deleted
  but no subvalues

#include <aux/automem/basic/docucopydel>

-----
[ -d $OUT_DIR/com/sign/del2 ] || mkdir $OUT_DIR/com/sign/del2
cat >$OUT_DIR/com/sign/del2/gsig <<'-----'
  PROCDEC(del2##_DOMAIN,PL_1(DOMAIN))
-----
cat >$OUT_DIR/com/sign/del2/vsig <<'-----'
  del2(x1) =
  TYPE : DOMAIN   -->

  The value x1 is deleted like with del1, i.e. only the structure itself
  will be deleted. But but if x1 is a structured value, all subvalues
  will be deleted using __SA(del1). 

  This operation is mainly intended for internal use to implement
  'del1' within implementations based on other implementations.

  At the moment, this will only be supplied for tuple domains.

#include <aux/automem/basic/docucopydel>

  See also: 
    __SA(del1), __SA(copy2) (Operations)
-----
[ -d $OUT_DIR/com/sign/finput ] || mkdir $OUT_DIR/com/sign/finput
cat >$OUT_DIR/com/sign/finput/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#define T1 istream &
#define T2 Cpp_DOMAIN &

#if defined(BASEIMPL) || defined(AUTOMEM_SEL)
InlineFriendFct(finput,SPAR2(T1,T2),void)
RUMPF({ del##_DOMAIN(DATA); DATA = finput##_DOMAIN(x1); })
#else
InlineFriendFct(finput,SPAR2(T1,T2),void)
RUMPF({ DATA = finput##_DOMAIN(x1); })
#endif

#ifdef OPERATOR
#if defined (BASEIMPL) || defined(AUTOMEM_SEL)
InlineAllwaysFriendFct(operator >>,KPAR2(T1,T2),istream &)
RUMPF({ del##_DOMAIN(x2.data); x2.data=finput##_DOMAIN(x1); return x1;})
#else
InlineAllwaysFriendFct(operator >>,KPAR2(T1,T2),istream &)
RUMPF({ x2.data=finput##_DOMAIN(x1); return x1;})
#endif
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/com/sign/finput/gsig <<'-----'
_IFDEF __cplusplus
  FUNCDEC(finput##_DOMAIN,PL_1(istream &),DOMAIN)
_ELSE
  FUNCDEC(finput##_DOMAIN,PL_1(FILE *),DOMAIN)
_ENDIF
-----
cat >$OUT_DIR/com/sign/finput/vsig <<'-----'
  finput(fd) = "read value from textual representation"
  TYPE: FILE *  -->  DOMAIN ( or istream& --> DOMAIN for C++)

  A value is read from the textual file determined by __EM(fd) using
  __SA(parse).

  See also:
    __SA(parse), __SA(input)
-----
[ -d $OUT_DIR/com/sign/format ] || mkdir $OUT_DIR/com/sign/format
cat >$OUT_DIR/com/sign/format/cpp <<'-----'
InlineFriendFct(format,FPAR1(const Cpp_DOMAIN &),Cpp_STR)
RUMPF(BODY1(Cpp_STR,format,FPARLIST1))
-----
cat >$OUT_DIR/com/sign/format/gsig <<'-----'
  FUNCDEC(format##_DOMAIN,PL_1(DOMAIN),Str)
-----
cat >$OUT_DIR/com/sign/format/vsig <<'-----'
  format(x1) 
  TYPE : DOMAIN  --> Str

  converts the value x1 of type DOMAIN into
  a formated string, formating is done like in __SA(fpr) and __SA(pr)
  but the formated string does not end with a newline
-----
[ -d $OUT_DIR/com/sign/fpr ] || mkdir $OUT_DIR/com/sign/fpr
cat >$OUT_DIR/com/sign/fpr/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 ostream &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(fpr,SPAR2(T1,T2),void)
RUMPF(BODY3(fpr,SPARLIST21))
#ifdef OPERATOR
InlineAllwaysFriendFct(operator <<,KPAR2(T1,T2),ostream &)
RUMPF({ fpr##_DOMAIN (x1,x2.data); return x1; })
#endif
#undef T1
#undef T2
#endif

COMMENT_(NOTE: Do not generate 'fpr' together with 'fprint' for C++)
COMMENT_(      since both will be mapped to the operator '<<'   !!!)

-----
cat >$OUT_DIR/com/sign/fpr/gsig <<'-----'
#ifdef GEN_C
#ifdef GEN_DOCU
  PROCDEC(fpr##_DOMAIN,PL_RV(FILE,DOMAIN))
#else
_IFDEF __cplusplus
  PROCDEC(fpr##_DOMAIN,PL_2(ostream &,DOMAIN))
_ELSE
  PROCDEC(fpr##_DOMAIN,PL_RV(FILE,DOMAIN))
_ENDIF
#endif
#endif
-----
cat >$OUT_DIR/com/sign/fpr/vsig <<'-----'
  fpr(x1,x2) =
  TYPE : File  DOMAIN  -->

  prints the value x2 of type DOMAIN on the stream x1 
  of type FILE * (defined in stdio.h)
  ( for C++ on stream defined in iostream.h)
-----
[ -d $OUT_DIR/com/sign/fprint ] || mkdir $OUT_DIR/com/sign/fprint
cat >$OUT_DIR/com/sign/fprint/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 ostream &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(fprint,SPAR2(T1,T2),void)
RUMPF(BODY3(fprint,SPARLIST21))
#ifdef OPERATOR
InlineAllwaysFriendFct(operator <<,KPAR2(T1,T2),ostream &)
RUMPF({ fprint##_DOMAIN (x1,x2.data); return x1; })
#endif
#undef T1
#undef T2
#endif

COMMENT_(NOTE: Do not generate 'fpr' together with 'fprint' for C++)
COMMENT_(      since both will be mapped to the operator '<<'   !!!)

-----
cat >$OUT_DIR/com/sign/fprint/gsig <<'-----'
#ifdef GEN_C
#ifdef GEN_DOCU
  PROCDEC(fprint##_DOMAIN,PL_RV(FILE,DOMAIN))
#else
_IFDEF __cplusplus
  PROCDEC(fprint##_DOMAIN,PL_2(ostream &,DOMAIN))
_ELSE
  PROCDEC(fprint##_DOMAIN,PL_RV(FILE,DOMAIN))
_ENDIF
#endif
#endif
-----
cat >$OUT_DIR/com/sign/fprint/vsig <<'-----'
  fprint(x1,x2) =
  TYPE : File DOMAIN  --> 

  Output routine, prints structured value of type DOMAIN
  to the stream x1 which is of type __EM(FILE *) as defined
  in __EM(stdio.h) (or __EM(streamio.h) for C++). In contrast
  to using __SA(fpr), this output is completely unformatted
  and therefore much more efficient. The output format of
  __SA(fpr) and __EM(fprint) is identical and can be parsed by __SA(finput).

  See also:
    _SA(pr), __SA(print), __SA(fprint), __SA(input), __SA(finput)

-----
[ -d $OUT_DIR/com/sign/gcinfo ] || mkdir $OUT_DIR/com/sign/gcinfo
cat >$OUT_DIR/com/sign/gcinfo/cpp <<'-----'
#if defined(ELEM1) || defined(COMP1)
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
InlineNoFriendConstFct(get_gc_info,FPAR1(T1),ADTS)
RUMPF(BODY1(ADTS,get_gc_info,FPARLIST1))
InlineNoFriendConstFct(get_handle,FPAR1(T1),Nat0)
RUMPF({return (Nat0) DATA;})
#undef T1
#endif
#endif
-----
cat >$OUT_DIR/com/sign/gcinfo/gsig <<'-----'
#define Handle Nat0  
  extern Handle get_gc_info1##_DOMAIN(DOMAIN x1, Adts * x2);
  extern Adts get_gc_info##_DOMAIN(DOMAIN x1);
#undef Handle
-----
cat >$OUT_DIR/com/sign/gcinfo/vsig <<'-----'
  This operation is used for testing the C++ automatic memory management.
  It is of no interest for a normal application.

  The following usable operations will be created by selecting operation
  __EM(gcinfo) (as member functions in C++ only !)

        TYPE get_gc_info : DOMAIN -> Adts
        TYPE get_handle  : DOMAIN -> Handle
-----
[ -d $OUT_DIR/com/sign/hash ] || mkdir $OUT_DIR/com/sign/hash
cat >$OUT_DIR/com/sign/hash/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(hash,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,hash,FPARLIST1))
#undef T1
#endif
-----
cat >$OUT_DIR/com/sign/hash/gsig <<'-----'
  FUNCDEC(hash##_DOMAIN,PL_1(DOMAIN),Nat0)
-----
cat >$OUT_DIR/com/sign/hash/vsig <<'-----'
  hash(x1) =
  TYPE : DOMAIN  -->  Nat0

  auxiliary function for computing a hash value for the value x1
  of DOMAIN. This function is required by some implementations
  of maps and sets as hash tables
-----
[ -d $OUT_DIR/com/sign/input ] || mkdir $OUT_DIR/com/sign/input
cat >$OUT_DIR/com/sign/input/gsig <<'-----'
  FUNCDEC(input##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/com/sign/input/vsig <<'-----'
  input() = "read value from textual representation through 'stdin'"
  TYPE:  -->  DOMAIN

  A value is read from __EM(stdin) using __SA(finput) and __SA(parse).

  See also:
    __SA(parse), __SA(finput)
-----
[ -d $OUT_DIR/com/sign/is_eq ] || mkdir $OUT_DIR/com/sign/is_eq
cat >$OUT_DIR/com/sign/is_eq/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_eq,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_eq,FPARLIST2))

#ifdef OPERATOR
InlineFriendConstFct(operator ==,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_eq,FPARLIST2))

InlineFriendConstFct(operator !=,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,(Bool)! is_eq,FPARLIST2))
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/com/sign/is_eq/gsig <<'-----'
  FUNCDEC(is_eq##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/com/sign/is_eq/vsig <<'-----'
  is_eq(x1,x2) = ( x1 = x2 )
  TYPE : DOMAIN  DOMAIN  -->  Bool

  equality test (for Bool: equivalence test)
-----
[ -d $OUT_DIR/com/sign/is_ge ] || mkdir $OUT_DIR/com/sign/is_ge
cat >$OUT_DIR/com/sign/is_ge/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_ge,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_ge,FPARLIST2))

#ifdef OPERATOR
InlineFriendConstFct(operator >=,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_ge,FPARLIST2))
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/com/sign/is_ge/gsig <<'-----'
  FUNCDEC(is_ge##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/com/sign/is_ge/vsig <<'-----'
  is_ge(x1,x2) = x1 >= x2
  TYPE : DOMAIN  DOMAIN  -->  Bool

  comparison of values x1 and x2
  __EM(is_ge) defines allways a total order on the values of DOMAIN
-----
[ -d $OUT_DIR/com/sign/is_gr ] || mkdir $OUT_DIR/com/sign/is_gr
cat >$OUT_DIR/com/sign/is_gr/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_gr,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_gr,FPARLIST2))

#ifdef OPERATOR
InlineFriendConstFct(operator >,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_gr,FPARLIST2))
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/com/sign/is_gr/gsig <<'-----'
  FUNCDEC(is_gr##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/com/sign/is_gr/vsig <<'-----'
  is_gr(x1,x2) = (x1 >= x2) & ~ (x1 = x2)
  TYPE : DOMAIN  DOMAIN  -->  Bool

  comparison of values x1 and x2
-----
[ -d $OUT_DIR/com/sign/is_le ] || mkdir $OUT_DIR/com/sign/is_le
cat >$OUT_DIR/com/sign/is_le/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_le,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_le,FPARLIST2))

#ifdef OPERATOR
InlineFriendConstFct(operator <=,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_le,FPARLIST2))
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/com/sign/is_le/gsig <<'-----'
  FUNCDEC(is_le##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/com/sign/is_le/vsig <<'-----'
  is_le(x1,x2) = (x1 <= x2)
  TYPE : DOMAIN  DOMAIN  -->  Bool

  comparison of values x1 and x2
-----
[ -d $OUT_DIR/com/sign/is_lt ] || mkdir $OUT_DIR/com/sign/is_lt
cat >$OUT_DIR/com/sign/is_lt/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_lt,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_lt,FPARLIST2))

#ifdef OPERATOR
InlineFriendConstFct(operator <,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_lt,FPARLIST2))
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/com/sign/is_lt/gsig <<'-----'
  FUNCDEC(is_lt##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/com/sign/is_lt/vsig <<'-----'
  is_lt(x1,x2) = (x1 < x2)
  TYPE : DOMAIN  DOMAIN  -->  Bool

  comparison of values x1 and x2
-----
[ -d $OUT_DIR/com/sign/load ] || mkdir $OUT_DIR/com/sign/load
cat >$OUT_DIR/com/sign/load/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_STR &

InlineNoFriendFct(load,FPAR2(T1,T2),Cpp_BOOL)
RUMPF({del##_DOMAIN(data);return Cpp_BOOL(MERGE(load,_DOMAIN)(x2.data,&data));})

#undef T1
#undef T2
-----
cat >$OUT_DIR/com/sign/load/gsig <<'-----'
  FUNCDEC(load##_DOMAIN,PL_2(Str,DOMAIN *),Bool)
-----
cat >$OUT_DIR/com/sign/load/vsig <<'-----'
  load(x1) =
  TYPE : Str --> ( Bool [ DOMAIN ] )

  Input routine for implementing persistent objects.
  The parameter x1 is a file name for an external
  file, from this file a value of type DOMAIN is read
  this value is given back in a 2. reference parameter
  the success of the operation is indicated by the
  boolean function result. 
  ( C interface like __SA(is_in_dom) for maps )

  This is the inverse operation to __SA(store)

  The operation is implemented with the __SA(cvfromtupl) operation
  and an internal tuple domain __EM(Vdmlib_inbytes).
  This internal domain is implemented with the __A("readfile",tupl.readfile.basic) tuple
  implementation, an efficient implementation for reading from
  a byte stream.

  If an error occurs when reading the file x1
  false is the result of the operation, else true is given back

  For tuning the input operations the __EM(Vdmlib_inbytes) implementation
  can be parameterized in the .vdm file by including the following
  lines

    IMPLEMENTATIONS
      Vdmlib_inbytes = readfile(PARAMETER="myvalue",...)

  where PARAMETER stands for an implementation parameter for the
  __A("readfile",tupl.readfile.basic) implementation

  See also:
    __SA(cvfromtupl), __SA(fread) (for tuples),
    __A("readfile",tupl.readfile.basic) (tuple implementation)

-----
[ -d $OUT_DIR/com/sign/mfold ] || mkdir $OUT_DIR/com/sign/mfold
cat >$OUT_DIR/com/sign/mfold/gsig <<'-----'
#include <com/com/mfold/macroa>
#ifdef GEN_C
 extern DOMAIN __fctname P_OP _fPL _fPLX P_CL;
_IFNDEF __cvfct
 extern __CVFCTRES __cvfct P_OP _fPLCV _fPLX P_CL;
_ENDIF
_IFNDEF __foldfct
 extern DOMAIN __foldfct P_OP DOMAIN x1, __CVFCTRES x2 P_CL;
_ENDIF
 static void __cvfctcall P_OP void P_CL;
#endif
#include <com/com/mfold/macroe>
-----
[ -d $OUT_DIR/com/sign/mk_one ] || mkdir $OUT_DIR/com/sign/mk_one
cat >$OUT_DIR/com/sign/mk_one/gsig <<'-----'
_DEFINE mk_one##_DOMAIN mk1##_DOMAIN
-----
cat >$OUT_DIR/com/sign/mk_one/vsig <<'-----'
  old name for __SA(mk1),
  only for compatibility reasons in the database
  please use __SA(mk1) of the apropriate adt.

  See also:
     __SA(mk1)
-----
[ -d $OUT_DIR/com/sign/new ] || mkdir $OUT_DIR/com/sign/new
cat >$OUT_DIR/com/sign/new/gsig <<'-----'
  FUNCDEC(new##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/com/sign/new/vsig <<'-----'
  DCL elems := {} TYPE DOMAIN -set

  new() =
   LET e BE S.T. e ~ IN C elems IN
    (elems := C elems U {e};
     RETURN e
    ) 
  TYPE :   ==>  DOMAIN

  creation of a new value of DOMAIN that is never used before
-----
[ -d $OUT_DIR/com/sign/parse ] || mkdir $OUT_DIR/com/sign/parse
cat >$OUT_DIR/com/sign/parse/gsig <<'-----'
  FUNCDEC(parse##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/com/sign/parse/vsig <<'-----'
  parse() = read value from textual representation
  TYPE: --> DOMAIN

  A value of type DOMAIN is parsed from a textual representation.
  This function can be used to read values from an ASCII file.
  The syntax for structured values is compatible to the one used
  by __SA(fpr), __SA(pr) or __SA(cvlines) for textual output of structured values.
  
  To make the use of this function as flexible as possible,
  __EM(parse) expects three routines to handle character input 
  and error handling:

    char getchar_vdmlib(void)	to supply one character from input
				stream.

    void unputchar_vdmlib(char)	to put one character back into the
				input stream. The character buffer
				needs to contain one characrer only.

    void parseerror_vdmlib(char *dom, char *id, char *mess)
				to generate the error message __EM(mess)
				for domain __EM(dom) and parameter __EM(id).

  This interface makes it possible to use __EM(parse) together with
  __EM(lex) input schema as well as Unix/C stream I/O. Standard routines
  for C file I/O will be supplied together with __SA(input).

  See also:
     __SA(input), __SA(finput), __SA(cvlines), __SA(fpr), __SA(pr)
-----
[ -d $OUT_DIR/com/sign/post ] || mkdir $OUT_DIR/com/sign/post
cat >$OUT_DIR/com/sign/post/cpp <<'-----'
#ifdef DECL
};
#endif
-----
[ -d $OUT_DIR/com/sign/pr ] || mkdir $OUT_DIR/com/sign/pr
cat >$OUT_DIR/com/sign/pr/gsig <<'-----'
  PROCDEC(pr##_DOMAIN,PL_1(DOMAIN))
-----
cat >$OUT_DIR/com/sign/pr/vsig <<'-----'
  pr(x1) =
  TYPE : DOMAIN  -->

  prints a value of type DOMAIN
  on standard output stream stdio (C++: cout)
-----
[ -d $OUT_DIR/com/sign/print ] || mkdir $OUT_DIR/com/sign/print
cat >$OUT_DIR/com/sign/print/gsig <<'-----'
  PROCDEC(print##_DOMAIN,PL_1(DOMAIN))
-----
cat >$OUT_DIR/com/sign/print/vsig <<'-----'
  print(x1) =
  TYPE : DOMAIN --> 

  test output
  prints a value of type DOMAIN to file __EM(print_FD_vdmlib).
  Default value for this file descriptor is __EM(stderr). To redirect
  output to another file, use __SA(fprint).

  See also:
    __SA(fprint), __SA(fpr)
-----
[ -d $OUT_DIR/com/sign/rename ] || mkdir $OUT_DIR/com/sign/rename
cat >$OUT_DIR/com/sign/rename/gsig <<'-----'
#ifndef NAME
#define NAME FCTNAME
#endif
#ifndef ADT
#define ADT DOMAIN
#define _ADT _DOMAIN
#endif
_DEFINE MERGE(NAME,_ADT) MERGE(FCTNAME,_DOMAIN)
#undef ADT
#undef _ADT
#undef NAME
-----
[ -d $OUT_DIR/com/sign/signature ] || mkdir $OUT_DIR/com/sign/signature
cat >$OUT_DIR/com/sign/signature/cpp <<'-----'
#if defined(DECL) || defined(CPPIMPL)

#include <aux/sign/signature/cppdef>

Cpp_RESULT FCTNAME1 (Cpp_ParamS) Cpp_Const Cpp_Body

#include <aux/sign/signature/cppdef>

#endif
-----
cat >$OUT_DIR/com/sign/signature/gsig <<'-----'
#ifdef GEN_C

#ifndef RESULT
#define RESULT1 void
#else
#define RESULT1 RESULT
#endif

#ifdef X
#define PARAM1 X x1
#else
#define PARAM1 DOMAIN x1
#endif

#ifdef XX
#define PARAM2 PARAM1, XX x2
#else
#define PARAM2 PARAM1
#endif

#ifdef XXX
#define PARAM3 PARAM2, XXX x3
#else
#define PARAM3 PARAM2
#endif

#ifdef XXXX
#define PARAM4 PARAM3, XXXX x4
#else
#define PARAM4 PARAM3
#endif

#ifdef XXXXX
#define PARAM5 PARAM4, XXXXX x5
#else
#define PARAM5 PARAM4
#endif

#ifdef XXXXX
#define PARAM6 PARAM5, XXXXX x6
#else
#define PARAM6 PARAM5
#endif

#ifdef XXXXXX
#define PARAM7 PARAM6, XXXXXX x7
#else
#define PARAM7 PARAM6
#endif

#ifdef XXXXXXX
#define PARAM8 PARAM7, XXXXXXX x8
#else
#define PARAM8 PARAM7
#endif

#ifdef XXXXXXXX
#define PARAM9 PARAM8, XXXXXXXX x9
#else
#define PARAM9 PARAM8
#endif

#ifdef XXXXXXXXX
#define PARAM10 PARAM9, XXXXXXXXX x10
#else
#define PARAM10 PARAM9
#endif

#ifdef RESULT2
#define PARAMr2 PARAM10, RESULT2 * r2
#else
#define PARAMr2 PARAM10
#endif

#ifdef RESULT3
#define PARAMr3 PARAMr2, RESULT3 * r3
#else
#define PARAMr3 PARAMr2
#endif

#ifdef RESULT4
#define PARAMr4 PARAMr3, RESULT3 * r4
#else
#define PARAMr4 PARAMr3
#endif

#ifdef RESULT5
#define PARAMr5 PARAMr4, RESULT3 * r5
#else
#define PARAMr5 PARAMr4
#endif

#define PARAMS PARAMr5

  extern RESULT1 MERGE(FCTNAME,_DOMAIN) P_OP PARAMS P_CL;

#undef PARAM1
#undef PARAM2
#undef PARAM3
#undef PARAM4
#undef PARAM5
#undef PARAM6
#undef PARAM7
#undef PARAM8
#undef PARAM9
#undef PARAM10
#undef PARAMr2
#undef PARAMr3
#undef PARAMr4
#undef PARAMr5
#undef PARAMS
#undef RESULT1

#endif
-----
[ -d $OUT_DIR/com/sign/store ] || mkdir $OUT_DIR/com/sign/store
cat >$OUT_DIR/com/sign/store/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_STR &

InlineFriendConstFct(store,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,store,FPARLIST2))

#undef T1
#undef T2
-----
cat >$OUT_DIR/com/sign/store/gsig <<'-----'
  FUNCDEC(store##_DOMAIN,PL_2(DOMAIN,Str),Bool)
-----
cat >$OUT_DIR/com/sign/store/vsig <<'-----'
  store(x1,x2) =
  TYPE : DOMAIN  Str --> Bool 

  Output routine for implementing persistent objects.
  The value x1 is written to an external file with name x2.

  The value can be retrieved with the inverse operation __SA(load)

  The operation is implemented with the __SA(cvtotupl) operation
  this operation uses an internal tuple domain __EM(Vdmlib_outbytes)
  for coding the value x1 into a sequence of bytes,
  as implementation for this internal stream the __A("writefile",tupl.writefile.basic)
  tuple implementation is used,
  an efficient implementation for writing to a byte stream.

  If an error occurs when writing to the file x2 false is
  the result, else true is given back

  For tuning the output operations the __EM(Vdmlib_outbytes) implementation
  can be parameterized in the .vdm file by including the following
  lines

    IMPLEMENTATIONS
      Vdmlib_outbytes = writefile(PARAMETER="myvalue",...)

  where PARAMETER stands for an implementation parameter for the
  __A("writefile",tupl.writefile.basic) implementation

  See also:
    __SA(cvtotupl), __SA(fwrite) (for tuples),
    __A("writefile",tupl.writefile.basic) (tuple implementation)

-----
[ -d $OUT_DIR/enum ] || mkdir $OUT_DIR/enum
[ -d $OUT_DIR/enum/aux ] || mkdir $OUT_DIR/enum/aux
[ -d $OUT_DIR/enum/aux/elems ] || mkdir $OUT_DIR/enum/aux/elems
cat >$OUT_DIR/enum/aux/elems/ccod <<'-----'
#ifndef MACRO1
#define MACRO1(E) E
#endif

#ifdef ELEM1
       MACRO1(ELEM1)
#endif
#ifdef ELEM2
     , MACRO1(ELEM2)
#endif
#ifdef ELEM3
     , MACRO1(ELEM3)
#endif
#ifdef ELEM4
     , MACRO1(ELEM4)
#endif
#ifdef ELEM5
     , MACRO1(ELEM5)
#endif
#ifdef ELEM6
     , MACRO1(ELEM6)
#endif
#ifdef ELEM7
     , MACRO1(ELEM7)
#endif
#ifdef ELEM8
     , MACRO1(ELEM8)
#endif
#ifdef ELEM9
     , MACRO1(ELEM9)
#endif

#ifdef ELEM10
     , MACRO1(ELEM10)
#endif
#ifdef ELEM11
     , MACRO1(ELEM11)
#endif
#ifdef ELEM12
     , MACRO1(ELEM12)
#endif
#ifdef ELEM13
     , MACRO1(ELEM13)
#endif
#ifdef ELEM14
     , MACRO1(ELEM14)
#endif
#ifdef ELEM15
     , MACRO1(ELEM15)
#endif
#ifdef ELEM16
     , MACRO1(ELEM16)
#endif
#ifdef ELEM17
     , MACRO1(ELEM17)
#endif
#ifdef ELEM18
     , MACRO1(ELEM18)
#endif
#ifdef ELEM19
     , MACRO1(ELEM19)
#endif

#ifdef ELEM20
     , MACRO1(ELEM20)
#endif
#ifdef ELEM21
     , MACRO1(ELEM21)
#endif
#ifdef ELEM22
     , MACRO1(ELEM22)
#endif
#ifdef ELEM23
     , MACRO1(ELEM23)
#endif
#ifdef ELEM24
     , MACRO1(ELEM24)
#endif
#ifdef ELEM25
     , MACRO1(ELEM25)
#endif
#ifdef ELEM26
     , MACRO1(ELEM26)
#endif
#ifdef ELEM27
     , MACRO1(ELEM27)
#endif
#ifdef ELEM28
     , MACRO1(ELEM28)
#endif
#ifdef ELEM29
     , MACRO1(ELEM29)
#endif
#ifdef ELEM30
     , MACRO1(ELEM30)
#endif
#ifdef ELEM31
     , MACRO1(ELEM31)
#endif
#ifdef ELEM32
     , MACRO1(ELEM32)
#endif
#ifdef ELEM33
     , MACRO1(ELEM33)
#endif
#ifdef ELEM34
     , MACRO1(ELEM34)
#endif
#ifdef ELEM35
     , MACRO1(ELEM35)
#endif
#ifdef ELEM36
     , MACRO1(ELEM36)
#endif
#ifdef ELEM37
     , MACRO1(ELEM37)
#endif
#ifdef ELEM38
     , MACRO1(ELEM38)
#endif
#ifdef ELEM39
     , MACRO1(ELEM39)
#endif

#ifdef ELEM40
     , MACRO1(ELEM40)
#endif
#ifdef ELEM41
     , MACRO1(ELEM41)
#endif
#ifdef ELEM42
     , MACRO1(ELEM42)
#endif
#ifdef ELEM43
     , MACRO1(ELEM43)
#endif
#ifdef ELEM44
     , MACRO1(ELEM44)
#endif
#ifdef ELEM45
     , MACRO1(ELEM45)
#endif
#ifdef ELEM46
     , MACRO1(ELEM46)
#endif
#ifdef ELEM47
     , MACRO1(ELEM47)
#endif
#ifdef ELEM48
     , MACRO1(ELEM48)
#endif
#ifdef ELEM49
     , MACRO1(ELEM49)
#endif

#ifdef ELEM50
#include <enum/aux/elems/ccod1>
#endif

#undef MACRO1
-----
cat >$OUT_DIR/enum/aux/elems/ccod1 <<'-----'
#ifdef ELEM50
     , MACRO1(ELEM50)
#endif
#ifdef ELEM51
     , MACRO1(ELEM51)
#endif
#ifdef ELEM52
     , MACRO1(ELEM52)
#endif
#ifdef ELEM53
     , MACRO1(ELEM53)
#endif
#ifdef ELEM54
     , MACRO1(ELEM54)
#endif
#ifdef ELEM55
     , MACRO1(ELEM55)
#endif
#ifdef ELEM56
     , MACRO1(ELEM56)
#endif
#ifdef ELEM57
     , MACRO1(ELEM57)
#endif
#ifdef ELEM58
     , MACRO1(ELEM58)
#endif
#ifdef ELEM59
     , MACRO1(ELEM59)
#endif

#ifdef ELEM60
     , MACRO1(ELEM60)
#endif
#ifdef ELEM61
     , MACRO1(ELEM61)
#endif
#ifdef ELEM62
     , MACRO1(ELEM62)
#endif
#ifdef ELEM63
     , MACRO1(ELEM63)
#endif
#ifdef ELEM64
     , MACRO1(ELEM64)
#endif
#ifdef ELEM65
     , MACRO1(ELEM65)
#endif
#ifdef ELEM66
     , MACRO1(ELEM66)
#endif
#ifdef ELEM67
     , MACRO1(ELEM67)
#endif
#ifdef ELEM68
     , MACRO1(ELEM68)
#endif
#ifdef ELEM69
     , MACRO1(ELEM69)
#endif

#ifdef ELEM70
     , MACRO1(ELEM70)
#endif
#ifdef ELEM71
     , MACRO1(ELEM71)
#endif
#ifdef ELEM72
     , MACRO1(ELEM72)
#endif
#ifdef ELEM73
     , MACRO1(ELEM73)
#endif
#ifdef ELEM74
     , MACRO1(ELEM74)
#endif
#ifdef ELEM75
     , MACRO1(ELEM75)
#endif
#ifdef ELEM76
     , MACRO1(ELEM76)
#endif
#ifdef ELEM77
     , MACRO1(ELEM77)
#endif
#ifdef ELEM78
     , MACRO1(ELEM78)
#endif
#ifdef ELEM79
     , MACRO1(ELEM79)
#endif
#ifdef ELEM80
     , MACRO1(ELEM80)
#endif
#ifdef ELEM81
     , MACRO1(ELEM81)
#endif
#ifdef ELEM82
     , MACRO1(ELEM82)
#endif
#ifdef ELEM83
     , MACRO1(ELEM83)
#endif
#ifdef ELEM84
     , MACRO1(ELEM84)
#endif
#ifdef ELEM85
     , MACRO1(ELEM85)
#endif
#ifdef ELEM86
     , MACRO1(ELEM86)
#endif
#ifdef ELEM87
     , MACRO1(ELEM87)
#endif
#ifdef ELEM88
     , MACRO1(ELEM88)
#endif
#ifdef ELEM89
     , MACRO1(ELEM89)
#endif

#ifdef ELEM90
     , MACRO1(ELEM90)
#endif
#ifdef ELEM91
     , MACRO1(ELEM91)
#endif
#ifdef ELEM92
     , MACRO1(ELEM92)
#endif
#ifdef ELEM93
     , MACRO1(ELEM93)
#endif
#ifdef ELEM94
     , MACRO1(ELEM94)
#endif
#ifdef ELEM95
     , MACRO1(ELEM95)
#endif
#ifdef ELEM96
     , MACRO1(ELEM96)
#endif
#ifdef ELEM97
     , MACRO1(ELEM97)
#endif
#ifdef ELEM98
     , MACRO1(ELEM98)
#endif
#ifdef ELEM99
     , MACRO1(ELEM99)
#endif

#ifdef ELEM100
     , MACRO1(ELEM100)
#endif
#ifdef ELEM101
     , MACRO1(ELEM101)
#endif
#ifdef ELEM102
     , MACRO1(ELEM102)
#endif
#ifdef ELEM103
     , MACRO1(ELEM103)
#endif
#ifdef ELEM104
     , MACRO1(ELEM104)
#endif
#ifdef ELEM105
     , MACRO1(ELEM105)
#endif
#ifdef ELEM106
     , MACRO1(ELEM106)
#endif
#ifdef ELEM107
     , MACRO1(ELEM107)
#endif
#ifdef ELEM108
     , MACRO1(ELEM108)
#endif
#ifdef ELEM109
     , MACRO1(ELEM109)
#endif
#ifdef ELEM110
     , MACRO1(ELEM110)
#endif
#ifdef ELEM111
     , MACRO1(ELEM111)
#endif
#ifdef ELEM112
     , MACRO1(ELEM112)
#endif
#ifdef ELEM113
     , MACRO1(ELEM113)
#endif
#ifdef ELEM114
     , MACRO1(ELEM114)
#endif
#ifdef ELEM115
     , MACRO1(ELEM115)
#endif
#ifdef ELEM116
     , MACRO1(ELEM116)
#endif
#ifdef ELEM117
     , MACRO1(ELEM117)
#endif
#ifdef ELEM118
     , MACRO1(ELEM118)
#endif
#ifdef ELEM119
     , MACRO1(ELEM119)
#endif
#ifdef ELEM120
     , MACRO1(ELEM120)
#endif
#ifdef ELEM121
     , MACRO1(ELEM121)
#endif
#ifdef ELEM122
     , MACRO1(ELEM122)
#endif
#ifdef ELEM123
     , MACRO1(ELEM123)
#endif
#ifdef ELEM124
     , MACRO1(ELEM124)
#endif
#ifdef ELEM125
     , MACRO1(ELEM125)
#endif
#ifdef ELEM126
     , MACRO1(ELEM126)
#endif
#ifdef ELEM127
     , MACRO1(ELEM127)
#endif
#ifdef ELEM128
     , MACRO1(ELEM128)
#endif
#ifdef ELEM129
     , MACRO1(ELEM129)
#endif
#ifdef ELEM130
     , MACRO1(ELEM130)
#endif
#ifdef ELEM131
     , MACRO1(ELEM131)
#endif
#ifdef ELEM132
     , MACRO1(ELEM132)
#endif
#ifdef ELEM133
     , MACRO1(ELEM133)
#endif
#ifdef ELEM134
     , MACRO1(ELEM134)
#endif
#ifdef ELEM135
     , MACRO1(ELEM135)
#endif
#ifdef ELEM136
     , MACRO1(ELEM136)
#endif
#ifdef ELEM137
     , MACRO1(ELEM137)
#endif
#ifdef ELEM138
     , MACRO1(ELEM138)
#endif
#ifdef ELEM139
     , MACRO1(ELEM139)
#endif

#ifdef ELEM140
     , MACRO1(ELEM140)
#endif
#ifdef ELEM141
     , MACRO1(ELEM141)
#endif
#ifdef ELEM142
     , MACRO1(ELEM142)
#endif
#ifdef ELEM143
     , MACRO1(ELEM143)
#endif
#ifdef ELEM144
     , MACRO1(ELEM144)
#endif
#ifdef ELEM145
     , MACRO1(ELEM145)
#endif
#ifdef ELEM146
     , MACRO1(ELEM146)
#endif
#ifdef ELEM147
     , MACRO1(ELEM147)
#endif
#ifdef ELEM148
     , MACRO1(ELEM148)
#endif
#ifdef ELEM149
     , MACRO1(ELEM149)
#endif

#ifdef ELEM150
     , MACRO1(ELEM150)
#endif
#ifdef ELEM151
     , MACRO1(ELEM151)
#endif
#ifdef ELEM152
     , MACRO1(ELEM152)
#endif
#ifdef ELEM153
     , MACRO1(ELEM153)
#endif
#ifdef ELEM154
     , MACRO1(ELEM154)
#endif
#ifdef ELEM155
     , MACRO1(ELEM155)
#endif
#ifdef ELEM156
     , MACRO1(ELEM156)
#endif
#ifdef ELEM157
     , MACRO1(ELEM157)
#endif
#ifdef ELEM158
     , MACRO1(ELEM158)
#endif
#ifdef ELEM159
     , MACRO1(ELEM159)
#endif

#ifdef ELEM160
     , MACRO1(ELEM160)
#endif
#ifdef ELEM161
     , MACRO1(ELEM161)
#endif
#ifdef ELEM162
     , MACRO1(ELEM162)
#endif
#ifdef ELEM163
     , MACRO1(ELEM163)
#endif
#ifdef ELEM164
     , MACRO1(ELEM164)
#endif
#ifdef ELEM165
     , MACRO1(ELEM165)
#endif
#ifdef ELEM166
     , MACRO1(ELEM166)
#endif
#ifdef ELEM167
     , MACRO1(ELEM167)
#endif
#ifdef ELEM168
     , MACRO1(ELEM168)
#endif
#ifdef ELEM169
     , MACRO1(ELEM169)
#endif

#ifdef ELEM170
     , MACRO1(ELEM170)
#endif
#ifdef ELEM171
     , MACRO1(ELEM171)
#endif
#ifdef ELEM172
     , MACRO1(ELEM172)
#endif
#ifdef ELEM173
     , MACRO1(ELEM173)
#endif
#ifdef ELEM174
     , MACRO1(ELEM174)
#endif
#ifdef ELEM175
     , MACRO1(ELEM175)
#endif
#ifdef ELEM176
     , MACRO1(ELEM176)
#endif
#ifdef ELEM177
     , MACRO1(ELEM177)
#endif
#ifdef ELEM178
     , MACRO1(ELEM178)
#endif
#ifdef ELEM179
     , MACRO1(ELEM179)
#endif
#ifdef ELEM180
     , MACRO1(ELEM180)
#endif
#ifdef ELEM181
     , MACRO1(ELEM181)
#endif
#ifdef ELEM182
     , MACRO1(ELEM182)
#endif
#ifdef ELEM183
     , MACRO1(ELEM183)
#endif
#ifdef ELEM184
     , MACRO1(ELEM184)
#endif
#ifdef ELEM185
     , MACRO1(ELEM185)
#endif
#ifdef ELEM186
     , MACRO1(ELEM186)
#endif
#ifdef ELEM187
     , MACRO1(ELEM187)
#endif
#ifdef ELEM188
     , MACRO1(ELEM188)
#endif
#ifdef ELEM189
     , MACRO1(ELEM189)
#endif

#ifdef ELEM190
     , MACRO1(ELEM190)
#endif
#ifdef ELEM191
     , MACRO1(ELEM191)
#endif
#ifdef ELEM192
     , MACRO1(ELEM192)
#endif
#ifdef ELEM193
     , MACRO1(ELEM193)
#endif
#ifdef ELEM194
     , MACRO1(ELEM194)
#endif
#ifdef ELEM195
     , MACRO1(ELEM195)
#endif
#ifdef ELEM196
     , MACRO1(ELEM196)
#endif
#ifdef ELEM197
     , MACRO1(ELEM197)
#endif
#ifdef ELEM198
     , MACRO1(ELEM198)
#endif
#ifdef ELEM199
     , MACRO1(ELEM199)
#endif

#ifdef ELEM200
       MACRO1(ELEM200)
#endif
#ifdef ELEM201
       MACRO1(ELEM201)
#endif
#ifdef ELEM202
     , MACRO1(ELEM202)
#endif
#ifdef ELEM203
     , MACRO1(ELEM203)
#endif
#ifdef ELEM204
     , MACRO1(ELEM204)
#endif
#ifdef ELEM205
     , MACRO1(ELEM205)
#endif
#ifdef ELEM206
     , MACRO1(ELEM206)
#endif
#ifdef ELEM207
     , MACRO1(ELEM207)
#endif
#ifdef ELEM208
     , MACRO1(ELEM208)
#endif
#ifdef ELEM209
     , MACRO1(ELEM209)
#endif

#ifdef ELEM210
     , MACRO1(ELEM210)
#endif
#ifdef ELEM211
     , MACRO1(ELEM211)
#endif
#ifdef ELEM212
     , MACRO1(ELEM212)
#endif
#ifdef ELEM213
     , MACRO1(ELEM213)
#endif
#ifdef ELEM214
     , MACRO1(ELEM214)
#endif
#ifdef ELEM215
     , MACRO1(ELEM215)
#endif
#ifdef ELEM216
     , MACRO1(ELEM216)
#endif
#ifdef ELEM217
     , MACRO1(ELEM217)
#endif
#ifdef ELEM218
     , MACRO1(ELEM218)
#endif
#ifdef ELEM219
     , MACRO1(ELEM219)
#endif

#ifdef ELEM220
     , MACRO1(ELEM220)
#endif
#ifdef ELEM221
     , MACRO1(ELEM221)
#endif
#ifdef ELEM222
     , MACRO1(ELEM222)
#endif
#ifdef ELEM223
     , MACRO1(ELEM223)
#endif
#ifdef ELEM224
     , MACRO1(ELEM224)
#endif
#ifdef ELEM225
     , MACRO1(ELEM225)
#endif
#ifdef ELEM226
     , MACRO1(ELEM226)
#endif
#ifdef ELEM227
     , MACRO1(ELEM227)
#endif
#ifdef ELEM228
     , MACRO1(ELEM228)
#endif
#ifdef ELEM229
     , MACRO1(ELEM229)
#endif
#ifdef ELEM230
     , MACRO1(ELEM230)
#endif
#ifdef ELEM231
     , MACRO1(ELEM231)
#endif
#ifdef ELEM232
     , MACRO1(ELEM232)
#endif
#ifdef ELEM233
     , MACRO1(ELEM233)
#endif
#ifdef ELEM234
     , MACRO1(ELEM234)
#endif
#ifdef ELEM235
     , MACRO1(ELEM235)
#endif
#ifdef ELEM236
     , MACRO1(ELEM236)
#endif
#ifdef ELEM237
     , MACRO1(ELEM237)
#endif
#ifdef ELEM238
     , MACRO1(ELEM238)
#endif
#ifdef ELEM239
     , MACRO1(ELEM239)
#endif

#ifdef ELEM240
     , MACRO1(ELEM240)
#endif
#ifdef ELEM241
     , MACRO1(ELEM241)
#endif
#ifdef ELEM242
     , MACRO1(ELEM242)
#endif
#ifdef ELEM243
     , MACRO1(ELEM243)
#endif
#ifdef ELEM244
     , MACRO1(ELEM244)
#endif
#ifdef ELEM245
     , MACRO1(ELEM245)
#endif
#ifdef ELEM246
     , MACRO1(ELEM246)
#endif
#ifdef ELEM247
     , MACRO1(ELEM247)
#endif
#ifdef ELEM248
     , MACRO1(ELEM248)
#endif
#ifdef ELEM249
     , MACRO1(ELEM249)
#endif

#ifdef ELEM250
     , MACRO1(ELEM250)
#endif
#ifdef ELEM251
     , MACRO1(ELEM251)
#endif
#ifdef ELEM252
     , MACRO1(ELEM252)
#endif
#ifdef ELEM253
     , MACRO1(ELEM253)
#endif
#ifdef ELEM254
     , MACRO1(ELEM254)
#endif
#ifdef ELEM255
     , MACRO1(ELEM255)
#endif
#ifdef ELEM256
     , MACRO1(ELEM256)
#endif
#ifdef ELEM257
     , MACRO1(ELEM257)
#endif
#ifdef ELEM258
     , MACRO1(ELEM258)
#endif
#ifdef ELEM259
     , MACRO1(ELEM259)
#endif

#ifdef ELEM260
     , MACRO1(ELEM260)
#endif
#ifdef ELEM261
     , MACRO1(ELEM261)
#endif
#ifdef ELEM262
     , MACRO1(ELEM262)
#endif
#ifdef ELEM263
     , MACRO1(ELEM263)
#endif
#ifdef ELEM264
     , MACRO1(ELEM264)
#endif
#ifdef ELEM265
     , MACRO1(ELEM265)
#endif
#ifdef ELEM266
     , MACRO1(ELEM266)
#endif
#ifdef ELEM267
     , MACRO1(ELEM267)
#endif
#ifdef ELEM268
     , MACRO1(ELEM268)
#endif
#ifdef ELEM269
     , MACRO1(ELEM269)
#endif

#ifdef ELEM270
     , MACRO1(ELEM270)
#endif
#ifdef ELEM271
     , MACRO1(ELEM271)
#endif
#ifdef ELEM272
     , MACRO1(ELEM272)
#endif
#ifdef ELEM273
     , MACRO1(ELEM273)
#endif
#ifdef ELEM274
     , MACRO1(ELEM274)
#endif
#ifdef ELEM275
     , MACRO1(ELEM275)
#endif
#ifdef ELEM276
     , MACRO1(ELEM276)
#endif
#ifdef ELEM277
     , MACRO1(ELEM277)
#endif
#ifdef ELEM278
     , MACRO1(ELEM278)
#endif
#ifdef ELEM279
     , MACRO1(ELEM279)
#endif
#ifdef ELEM280
     , MACRO1(ELEM280)
#endif
#ifdef ELEM281
     , MACRO1(ELEM281)
#endif
#ifdef ELEM282
     , MACRO1(ELEM282)
#endif
#ifdef ELEM283
     , MACRO1(ELEM283)
#endif
#ifdef ELEM284
     , MACRO1(ELEM284)
#endif
#ifdef ELEM285
     , MACRO1(ELEM285)
#endif
#ifdef ELEM286
     , MACRO1(ELEM286)
#endif
#ifdef ELEM287
     , MACRO1(ELEM287)
#endif
#ifdef ELEM288
     , MACRO1(ELEM288)
#endif
#ifdef ELEM289
     , MACRO1(ELEM289)
#endif

#ifdef ELEM290
     , MACRO1(ELEM290)
#endif
#ifdef ELEM291
     , MACRO1(ELEM291)
#endif
#ifdef ELEM292
     , MACRO1(ELEM292)
#endif
#ifdef ELEM293
     , MACRO1(ELEM293)
#endif
#ifdef ELEM294
     , MACRO1(ELEM294)
#endif
#ifdef ELEM295
     , MACRO1(ELEM295)
#endif
#ifdef ELEM296
     , MACRO1(ELEM296)
#endif
#ifdef ELEM297
     , MACRO1(ELEM297)
#endif
#ifdef ELEM298
     , MACRO1(ELEM298)
#endif
#ifdef ELEM299
     , MACRO1(ELEM299)
#endif

#ifdef ELEM300
       MACRO1(ELEM300)
#endif
#ifdef ELEM301
       MACRO1(ELEM301)
#endif
#ifdef ELEM302
     , MACRO1(ELEM302)
#endif
#ifdef ELEM303
     , MACRO1(ELEM303)
#endif
#ifdef ELEM304
     , MACRO1(ELEM304)
#endif
#ifdef ELEM305
     , MACRO1(ELEM305)
#endif
#ifdef ELEM306
     , MACRO1(ELEM306)
#endif
#ifdef ELEM307
     , MACRO1(ELEM307)
#endif
#ifdef ELEM308
     , MACRO1(ELEM308)
#endif
#ifdef ELEM309
     , MACRO1(ELEM309)
#endif

#ifdef ELEM310
     , MACRO1(ELEM310)
#endif
#ifdef ELEM311
     , MACRO1(ELEM311)
#endif
#ifdef ELEM312
     , MACRO1(ELEM312)
#endif
#ifdef ELEM313
     , MACRO1(ELEM313)
#endif
#ifdef ELEM314
     , MACRO1(ELEM314)
#endif
#ifdef ELEM315
     , MACRO1(ELEM315)
#endif
#ifdef ELEM316
     , MACRO1(ELEM316)
#endif
#ifdef ELEM317
     , MACRO1(ELEM317)
#endif
#ifdef ELEM318
     , MACRO1(ELEM318)
#endif
#ifdef ELEM319
     , MACRO1(ELEM319)
#endif

#ifdef ELEM320
     , MACRO1(ELEM320)
#endif
#ifdef ELEM321
     , MACRO1(ELEM321)
#endif
#ifdef ELEM322
     , MACRO1(ELEM322)
#endif
#ifdef ELEM323
     , MACRO1(ELEM323)
#endif
#ifdef ELEM324
     , MACRO1(ELEM324)
#endif
#ifdef ELEM325
     , MACRO1(ELEM325)
#endif
#ifdef ELEM326
     , MACRO1(ELEM326)
#endif
#ifdef ELEM327
     , MACRO1(ELEM327)
#endif
#ifdef ELEM328
     , MACRO1(ELEM328)
#endif
#ifdef ELEM329
     , MACRO1(ELEM329)
#endif
#ifdef ELEM330
     , MACRO1(ELEM330)
#endif
#ifdef ELEM331
     , MACRO1(ELEM331)
#endif
#ifdef ELEM332
     , MACRO1(ELEM332)
#endif
#ifdef ELEM333
     , MACRO1(ELEM333)
#endif
#ifdef ELEM334
     , MACRO1(ELEM334)
#endif
#ifdef ELEM335
     , MACRO1(ELEM335)
#endif
#ifdef ELEM336
     , MACRO1(ELEM336)
#endif
#ifdef ELEM337
     , MACRO1(ELEM337)
#endif
#ifdef ELEM338
     , MACRO1(ELEM338)
#endif
#ifdef ELEM339
     , MACRO1(ELEM339)
#endif

#ifdef ELEM340
     , MACRO1(ELEM340)
#endif
#ifdef ELEM341
     , MACRO1(ELEM341)
#endif
#ifdef ELEM342
     , MACRO1(ELEM342)
#endif
#ifdef ELEM343
     , MACRO1(ELEM343)
#endif
#ifdef ELEM344
     , MACRO1(ELEM344)
#endif
#ifdef ELEM345
     , MACRO1(ELEM345)
#endif
#ifdef ELEM346
     , MACRO1(ELEM346)
#endif
#ifdef ELEM347
     , MACRO1(ELEM347)
#endif
#ifdef ELEM348
     , MACRO1(ELEM348)
#endif
#ifdef ELEM349
     , MACRO1(ELEM349)
#endif

#ifdef ELEM350
     , MACRO1(ELEM350)
#endif
#ifdef ELEM351
     , MACRO1(ELEM351)
#endif
#ifdef ELEM352
     , MACRO1(ELEM352)
#endif
#ifdef ELEM353
     , MACRO1(ELEM353)
#endif
#ifdef ELEM354
     , MACRO1(ELEM354)
#endif
#ifdef ELEM355
     , MACRO1(ELEM355)
#endif
#ifdef ELEM356
     , MACRO1(ELEM356)
#endif
#ifdef ELEM357
     , MACRO1(ELEM357)
#endif
#ifdef ELEM358
     , MACRO1(ELEM358)
#endif
#ifdef ELEM359
     , MACRO1(ELEM359)
#endif

#ifdef ELEM360
     , MACRO1(ELEM360)
#endif
#ifdef ELEM361
     , MACRO1(ELEM361)
#endif
#ifdef ELEM362
     , MACRO1(ELEM362)
#endif
#ifdef ELEM363
     , MACRO1(ELEM363)
#endif
#ifdef ELEM364
     , MACRO1(ELEM364)
#endif
#ifdef ELEM365
     , MACRO1(ELEM365)
#endif
#ifdef ELEM366
     , MACRO1(ELEM366)
#endif
#ifdef ELEM367
     , MACRO1(ELEM367)
#endif
#ifdef ELEM368
     , MACRO1(ELEM368)
#endif
#ifdef ELEM369
     , MACRO1(ELEM369)
#endif

#ifdef ELEM370
     , MACRO1(ELEM370)
#endif
#ifdef ELEM371
     , MACRO1(ELEM371)
#endif
#ifdef ELEM372
     , MACRO1(ELEM372)
#endif
#ifdef ELEM373
     , MACRO1(ELEM373)
#endif
#ifdef ELEM374
     , MACRO1(ELEM374)
#endif
#ifdef ELEM375
     , MACRO1(ELEM375)
#endif
#ifdef ELEM376
     , MACRO1(ELEM376)
#endif
#ifdef ELEM377
     , MACRO1(ELEM377)
#endif
#ifdef ELEM378
     , MACRO1(ELEM378)
#endif
#ifdef ELEM379
     , MACRO1(ELEM379)
#endif
#ifdef ELEM380
     , MACRO1(ELEM380)
#endif
#ifdef ELEM381
     , MACRO1(ELEM381)
#endif
#ifdef ELEM382
     , MACRO1(ELEM382)
#endif
#ifdef ELEM383
     , MACRO1(ELEM383)
#endif
#ifdef ELEM384
     , MACRO1(ELEM384)
#endif
#ifdef ELEM385
     , MACRO1(ELEM385)
#endif
#ifdef ELEM386
     , MACRO1(ELEM386)
#endif
#ifdef ELEM387
     , MACRO1(ELEM387)
#endif
#ifdef ELEM388
     , MACRO1(ELEM388)
#endif
#ifdef ELEM389
     , MACRO1(ELEM389)
#endif

#ifdef ELEM390
     , MACRO1(ELEM390)
#endif
#ifdef ELEM391
     , MACRO1(ELEM391)
#endif
#ifdef ELEM392
     , MACRO1(ELEM392)
#endif
#ifdef ELEM393
     , MACRO1(ELEM393)
#endif
#ifdef ELEM394
     , MACRO1(ELEM394)
#endif
#ifdef ELEM395
     , MACRO1(ELEM395)
#endif
#ifdef ELEM396
     , MACRO1(ELEM396)
#endif
#ifdef ELEM397
     , MACRO1(ELEM397)
#endif
#ifdef ELEM398
     , MACRO1(ELEM398)
#endif
#ifdef ELEM399
     , MACRO1(ELEM399)
#endif

#ifdef ELEM400
  DOMAIN: only 399 elements supported 
#endif
-----
[ -d $OUT_DIR/enum/com ] || mkdir $OUT_DIR/enum/com
[ -d $OUT_DIR/enum/com/basic ] || mkdir $OUT_DIR/enum/com/basic
cat >$OUT_DIR/enum/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/enum/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = EMIL | EGON | ELLIE | LEO | THEO

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + copy1
   + copy

   + is_eq
   + is_gr
   + is_ge

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

-----
cat >$OUT_DIR/enum/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Elem = EMIL | EGON | ELLIE | LEO | THEO

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

-----
cat >$OUT_DIR/enum/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbid1>

/*================================================================================================*/

#define REPEAT
#include <aux/com/copy1/bbc2>

#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG2 @Y@
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if( is_gr##_domain( D_ @X@, D_ @X@ ) )
       myerr(@n@,"is_gr()","@X@,@X@");
@) DD }

   void p_@N@()
   { if( is_gr##_domain( D_ @Y@, D_ @Z@ ) )
       myerr(@n@,"is_gr()","@Y@,@Z@");
   DD }

   void p_@N@()
   { if(! is_gr##_domain( D_ @Z@, D_ @Y@ ) )
       myerr(@n@,"is_gr()","@Z@,@Y@");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(  if(! is_ge##_domain( D_ @X@, D_ @X@ ) )
       myerr(@n@,"is_ge()","@X@,@X@");
@) DD }

   void p_@N@()
   { if( is_ge##_domain( D_ @Y@, D_ @Z@ ) )
       myerr(@n@,"is_ge()","@Y@,@Z@");
   DD }

   void p_@N@()
   { if(! is_ge##_domain( D_ @Z@, D_ @Y@ ) )
       myerr(@n@,"is_ge()","@Z@,@Y@");
   DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define REPEAT
#include <aux/com/del1/bbc2>

#define REPEAT
#include <aux/com/del/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/print/bbc1>

#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define REPEAT
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define REPEAT
#include <aux/com/fpr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/enum/com/basic/bbd1 <<'-----'
@X@=
EMIL
EGON
ELLIE

@Y@=
LEO

@Z@=
THEO
-----
cat >$OUT_DIR/enum/com/basic/bbd2 <<'-----'
@X@=
EMIL
EGON
ELLIE

@Y@=
LEO

@Z@=
THEO
-----
cat >$OUT_DIR/enum/com/basic/docu <<'-----'
Syntax:

  Constants = TOKEN1 | TOKEN2 | TOKEN3 | ... | TOKENn

Description:

  This elementary domain constructor describes a set of named
  objects (constants). This will be mapped to a C enumeration type
  which explains the somewhat strange constructor name.

  In contrast to the 'token' constructor which supples anonymous
  objects the element of this ADT can be identyfied through their
  name within the program. No generator operations exist.

Example:

  Operators within a programming language can be described by

  Operator = PLUS | MINUS | TIMES | DIVIDE

-----
[ -d $OUT_DIR/enum/com/default ] || mkdir $OUT_DIR/enum/com/default
cat >$OUT_DIR/enum/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the enum datatype the following set of operations is
  added

#include <enum/com/default/vdm>
-----
cat >$OUT_DIR/enum/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + is_eq + is_ge + is_gr
-----
[ -d $OUT_DIR/enum/enum ] || mkdir $OUT_DIR/enum/enum
[ -d $OUT_DIR/enum/enum/basic ] || mkdir $OUT_DIR/enum/enum/basic
cat >$OUT_DIR/enum/enum/basic/ccod <<'-----'
#ifdef ELEMTAB
 static char * elemtab##_DOMAIN[] = {
#define MACRO1(E) MKSTRING(E)
#include <enum/aux/elems/ccod>
				    ,NULL
                                    };
#endif
-----
cat >$OUT_DIR/enum/enum/basic/docu <<'-----'
  Implementation of enumerations of token values

  Example:
    Op  =  ADDOP | SUBOP | MULTOP | DIVOP
  
  It can be choosen between integer- or subrange implementation
  (See description of "SMALLTYPE")

  Parameters:

    "SMALLTYPE":
               An enumeration in C is represented by an unsigned
               integer type with additional constant definitions.

               In languages like Pascal or Modula2 usually subrange
               types of the form (0 .. #elements) are used to
               implement enumerations.
               These normally only occupy as less storage as possible
               (i.e. one byte for less than 256 elements,...).
               If "SMALLTYPE" is set this allocation strategy will be
               followed up.
               By default normal C enumerations are generated.
               Check which strategy will be the one needed for you
               when using these C implementations from Pascal, Modula,
               etc.
               This option can also be used to reduce space used by
               DOMAIN.
-----
cat >$OUT_DIR/enum/enum/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/enum/enum/basic/gptr <<'-----'
#ifdef GEN_C
#define _ENUMNAME MERGE(Enum,_DOMAIN)
#else
#define _ENUMNAME DOMAIN
#endif


  START_ENUM_TYP(_ENUMNAME)
#define MACRO1(E) E
#include <enum/aux/elems/ccod>
	   END_ENUM_TYP(_ENUMNAME)


#ifdef GEN_C
#ifdef SMALLTYPE
/* determine the actual type fitting to the number of elems   */
#ifdef ELEM65536
  typedef unsigned long DOMAIN;
#else
#ifdef ELEM256
  typedef unsigned short DOMAIN;
#else
  typedef unsigned char DOMAIN;
#endif
#endif

#else
  typedef _ENUMNAME DOMAIN;
#endif
#endif

#undef _ENUMNAME
-----
cat >$OUT_DIR/enum/enum/basic/param <<'-----'
INTERNALDOMAIN
MACROS
SMALLTYPE
-----
cat >$OUT_DIR/enum/enum/basic/vdm <<'-----'
DOMAINS
 DOMAIN	-> Bool
IMPLEMENTATIONS

#define CONSTRNAME mk_basic
#define ADTNAME ADT_ENUM
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/enum/enum/cvfromtup1 ] || mkdir $OUT_DIR/enum/enum/cvfromtup1
cat >$OUT_DIR/enum/enum/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { register DOMAIN lx2;
    lx2  = (DOMAIN)hd##_TUPLDOMAIN(*x1);
    *x1  = tld##_TUPLDOMAIN(*x1);
#ifdef ELEM256
    lx2 |= (DOMAIN)hd##_TUPLDOMAIN(*x1) << 8;
    *x1  = tld##_TUPLDOMAIN(*x1);
#endif
#ifdef ELEM65536
    lx2 |= (DOMAIN)hd##_TUPLDOMAIN(*x1) << 16;
    *x1  = tld##_TUPLDOMAIN(*x1);
    lx2 |= (DOMAIN)hd##_TUPLDOMAIN(*x1) << 24;
    *x1  = tld##_TUPLDOMAIN(*x1);
#endif
    return (DOMAIN)lx2;
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/enum/enum/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/enum/enum/cvfromtup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + hd + tld
-----
[ -d $OUT_DIR/enum/enum/cvlines ] || mkdir $OUT_DIR/enum/enum/cvlines
cat >$OUT_DIR/enum/enum/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   { return mk1_cvtext_vdmlib(cvstr##_DOMAIN(x1)); }
-----
cat >$OUT_DIR/enum/enum/cvlines/docu <<'-----'
  The name of the current value is returned
-----
cat >$OUT_DIR/enum/enum/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  Cvtext_vdmlib   = + mk1
  DOMAIN          = + cvstr
  Vdmlib          = + cvtext
-----
[ -d $OUT_DIR/enum/enum/cvstr ] || mkdir $OUT_DIR/enum/enum/cvstr
cat >$OUT_DIR/enum/enum/cvstr/ccod <<'-----'
#include <aux/com/cvstr/defp>

  RST FCTN##_DOMAIN _FPH1(DOMAIN)
   { return MKC(elemtab##_DOMAIN[(Nat0)x1]); }

#include <aux/com/cvstr/undef>
-----
cat >$OUT_DIR/enum/enum/cvstr/docu <<'-----'
  The string representation of the current value
  (the token) is returned
-----
cat >$OUT_DIR/enum/enum/cvstr/param <<'-----'
AUTOMEMRESULT
-----
cat >$OUT_DIR/enum/enum/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + elemtab
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)

-----
[ -d $OUT_DIR/enum/enum/cvtotup1 ] || mkdir $OUT_DIR/enum/enum/cvtotup1
cat >$OUT_DIR/enum/enum/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
  {
#ifdef ELEM65536
    x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2) & 255));
    x2 = x2 >> 8;
    x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2) & 255));
    x2 = x2 >> 8;
    x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2) & 255));
    x2 = x2 >> 8;
    x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2)      ));
#else
#ifdef ELEM256
    x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2) & 255));
    x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2) >>  8));
#else
    x1 = appr##_TUPLDOMAIN(x1,(unsigned int) x2);
#endif
#endif
    return x1;
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/enum/enum/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/enum/enum/cvtotup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + appr
-----
[ -d $OUT_DIR/enum/enum/elemtab ] || mkdir $OUT_DIR/enum/enum/elemtab
cat >$OUT_DIR/enum/enum/elemtab/ccod <<'-----'
 char * elemtab##_DOMAIN[] = {
#ifdef GEN_ISO
#define MACRO1(E) "<"#E">"
#else
#define MACRO1(E) MKSTRING(E)
#endif
#include <enum/aux/elems/ccod>
				    ,NULL
                                    };
-----
cat >$OUT_DIR/enum/enum/elemtab/gtyp <<'-----'
 extern char * elemtab##_DOMAIN[];
-----
[ -d $OUT_DIR/enum/enum/hash ] || mkdir $OUT_DIR/enum/enum/hash
cat >$OUT_DIR/enum/enum/hash/ccod <<'-----'
  Nat0 hash##_DOMAIN _FPH1(DOMAIN) {return ((Nat0)x1);}
-----
cat >$OUT_DIR/enum/enum/hash/cmcr <<'-----'
_DEFINE hash##_DOMAIN(x1) ((Nat0)(x1))
-----
cat >$OUT_DIR/enum/enum/hash/docu <<'-----'
  hash function on enumeration types : 
  the value (the internal representation) is converted to a Nat0 value.
-----
cat >$OUT_DIR/enum/enum/hash/pmcr <<'-----'
_DEFINE hash##_DOMAIN(x1) (Nat0(x1))
-----
[ -d $OUT_DIR/enum/enum/is_gr ] || mkdir $OUT_DIR/enum/enum/is_gr
cat >$OUT_DIR/enum/enum/is_gr/ccod <<'-----'
#include <numeric/com/is_gr/ccod>
-----
cat >$OUT_DIR/enum/enum/is_gr/cmcr <<'-----'
#include <numeric/com/is_gr/cmcr>
-----
cat >$OUT_DIR/enum/enum/is_gr/pmcr <<'-----'
#include <numeric/com/is_gr/pmcr>
-----
[ -d $OUT_DIR/enum/enum/parse ] || mkdir $OUT_DIR/enum/enum/parse
cat >$OUT_DIR/enum/enum/parse/ccod <<'-----'
DOMAIN parse##_DOMAIN _FPH0()
  { Nat0 lx1 = 0;
    Char *lx21;
    Char lx2[300];

#ifdef GEN_ISO
    expect_vdmlib("<",#DOMAIN);
    lx21 = readtoken_vdmlib(#DOMAIN);
    expect_vdmlib(">",#DOMAIN);
    sprintf(lx2,"<%s>",lx21);	/* elemtab contains surrounding braces (output!) */
#else
    lx21 = readtoken_vdmlib(#DOMAIN);
    sprintf(lx2,"%s",lx21);
#endif

    while (elemtab##_DOMAIN[lx1])
      { if (strcmp(lx2,elemtab##_DOMAIN[lx1]) == 0) { return (DOMAIN)lx1; }
	lx1++;
      }

    expected_vdmlib(#DOMAIN,"token element ",lx2);
    return (DOMAIN)0;
  }
-----
cat >$OUT_DIR/enum/enum/parse/docu <<'-----'

  Syntax: <ELEMi>

-----
cat >$OUT_DIR/enum/enum/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
 DOMAIN = + elemtab
 Vdmlib = + parsesup
-----
[ -d $OUT_DIR/enum/enum/print ] || mkdir $OUT_DIR/enum/enum/print
cat >$OUT_DIR/enum/enum/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
   { print_FD_vdmlib << elemtab##_DOMAIN[(Nat0)x1]; }
_ELSE
   { fprintf(print_FD_vdmlib,elemtab##_DOMAIN[(Nat0)x1]); }
_ENDIF
-----
cat >$OUT_DIR/enum/enum/print/docu <<'-----'
  the name (external representation) of x1 is printed
-----
cat >$OUT_DIR/enum/enum/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + elemtab
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/enum/sign ] || mkdir $OUT_DIR/enum/sign
[ -d $OUT_DIR/enum/sign/basic ] || mkdir $OUT_DIR/enum/sign/basic
cat >$OUT_DIR/enum/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
public:
  DOMAIN data;
  Cpp_DOMAIN            ()                      {}
  Cpp_DOMAIN            (DOMAIN x1)             { data = x1;                    }
  Cpp_DOMAIN & operator=(DOMAIN x1)             { data = x1;      return *this; }
  Cpp_DOMAIN            (const Cpp_DOMAIN & x1) { data = x1.data;               }
  Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1) { data = x1.data; return *this; }

  operator DOMAIN() const          { return data;                  }

  /* access function for data field for conversion between C++ and C */
  /* for consistency reasons, else oprtator int is sufficient */

  DOMAIN       cv##_DOMAIN() const              { return data;                  }

#endif

-----
cat >$OUT_DIR/enum/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/genbt ] || mkdir $OUT_DIR/genbt
[ -d $OUT_DIR/genbt/bintree ] || mkdir $OUT_DIR/genbt/bintree
[ -d $OUT_DIR/genbt/bintree/basic ] || mkdir $OUT_DIR/genbt/bintree/basic
cat >$OUT_DIR/genbt/bintree/basic/ccod <<'-----'

#ifdef AVL

static DOMAIN li_shift##_DOMAIN _FPH1 (DOMAIN)
{
 DOMAIN x;

 x=x1;
 x1=x->f_right;
 if (x1->f_left)
  x->f_right=x1->f_left;
 else
  x->f_right=0;
 x1->f_left=x;
 return x1;
}
 
static DOMAIN re_shift##_DOMAIN _FPH1 (DOMAIN)
{
 DOMAIN x;

 x=x1;
 x1=x->f_left;
 if (x1->f_right)
  x->f_left=x1->f_right;
 else
  x->f_left=0;
 x1->f_right=x;
 return x1;
}

static DOMAIN li_reduce##_DOMAIN _FPH1 (DOMAIN)
{
 int tb,subdb,subdmdb;

 tb=x1->bal;
 subdb=(x1->f_left)->bal;

 if ((tb+subdb)!=0)                          
  {
   x1=re_shift##_DOMAIN (x1);
   x1->bal=subdb-tb;  
   ((x1->f_right)->bal)=-(x1->bal); 
  }
 else
  {
   subdmdb=((x1->f_left)->f_right)->bal;
   x1->f_left=li_shift##_DOMAIN (x1->f_left);
   x1=re_shift##_DOMAIN (x1);
   if (subdmdb==-tb)
    subdb=tb;
   else
    subdb=0;
   x1->bal=0;
   (x1->f_left)->bal=subdb;
   (x1->f_right)->bal= -(subdb+subdmdb);
  }
 return x1;
 }


static DOMAIN re_reduce##_DOMAIN _FPH1 (DOMAIN)
{
 int tb,subdb,subdmdb;

 tb=x1->bal;
 subdb=(x1->f_right)->bal;

 if ((tb+subdb)!=0)                          
  {
   x1=li_shift##_DOMAIN (x1);
   x1->bal=subdb-tb;  
   ((x1->f_left)->bal)=-(x1->bal);   
  }
 else
  {
   subdmdb=((x1->f_right)->f_left)->bal;
   x1->f_right=re_shift##_DOMAIN (x1->f_right);
   x1=li_shift##_DOMAIN (x1);
   if (subdmdb==-tb)
    subdb=tb;
   else
    subdb=0;
   x1->bal=0;
     (x1->f_right)->bal=subdb;
     (x1->f_left)->bal= -(subdb+subdmdb);
  }
 return x1;
 }

#endif
-----
cat >$OUT_DIR/genbt/bintree/basic/docu <<'-----'
   ADT generic binary tree
   for implementing maps, sets, etc. with a binary tree
   the code for the binary tree is generic
   so all implementaions based on this implementation
   will share the same code for the tree operations 

   Implementation Parameters

  "AVL" : the tree is organized as a balanced tree

-----
cat >$OUT_DIR/genbt/bintree/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/genbt/bintree/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))

#ifdef GEN_C
  typedef void * Genptr;
#endif
-----
cat >$OUT_DIR/genbt/bintree/basic/gtyp <<'-----'
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_left ,DOMAIN);
                      RECFIELD(f_right,DOMAIN); 
#ifdef AVL
                      RECFIELD(bal,int);    
#endif
                      COMMENT_(RECFIELD(f_info,ELEM1))
  END_RECORD_TYP(Struct##_DOMAIN)

#ifdef GEN_C
  typedef void (* Perf##_DOMAIN) P_OP Genptr y1 P_CL ;
  typedef int  (* Cmp##_DOMAIN)  P_OP Genptr y1, Genptr y2 P_CL ;
#endif
-----
cat >$OUT_DIR/genbt/bintree/basic/param <<'-----'
ALLOC
AVL
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
NORMAL
-----
cat >$OUT_DIR/genbt/bintree/basic/vdm <<'-----'
#ifndef ALLOC
#define ALLOC osalloc("INTERNALDOMAIN")
#endif

! a heap allocation strategie can be define by ALLOC parameter !
! C memcopy prototypes are included via  + header(MEMORY)      !
! a global generic pointer type is declared via + genptr       !

DOMAINS
   Heap##_DOMAIN  = DOMAIN     -heap
   DOMAIN	  -> Heap##_DOMAIN

IMPLEMENTATIONS
   Heap##_DOMAIN  = ALLOC + memalloc
   Vdmlib        = + header("MEMORY")
                   + genptr

#undef ALLOC
-----
[ -d $OUT_DIR/genbt/bintree/card ] || mkdir $OUT_DIR/genbt/bintree/card
cat >$OUT_DIR/genbt/bintree/card/ccod <<'-----'
  Nat0 card##_DOMAIN _FPH1(DOMAIN)
    /* Knoten zaehlen (rekursiv) */
   {
    return
      (! x1)
      ? 0
      : 1 + card##_DOMAIN(x1->f_left) + card##_DOMAIN(x1->f_right);
   }


-----
[ -d $OUT_DIR/genbt/bintree/copy1 ] || mkdir $OUT_DIR/genbt/bintree/copy1
cat >$OUT_DIR/genbt/bintree/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH3(DOMAIN,Nat0,Perf##_DOMAIN)
    /* duplizieren von x1 (rekursv) und mit x4 Operation
       auf den Elementen ausfuehren
    */
    { DOMAIN neu;
      if ( ! x1 ) return x1;
      else            { neu=alloc##_DOMAIN(sizeof(*neu)+x2);
                            /* (DOMAIN)malloc(sizeof(*neu)+x2); */
		        neu->f_left = copy1##_DOMAIN(x1->f_left , x2, x3);
		        neu->f_right= copy1##_DOMAIN(x1->f_right, x2, x3);
#ifdef AVL
                        neu->bal    = x1->bal;
#endif
		        memcpy( (Genptr) (neu+1), (Genptr) (x1+1), x2);
	                (*x3)( (Genptr) (neu+1) );
                        return neu;
		      }

    }


-----
[ -d $OUT_DIR/genbt/bintree/del1 ] || mkdir $OUT_DIR/genbt/bintree/del1
cat >$OUT_DIR/genbt/bintree/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH3(DOMAIN,Nat0,Perf##_DOMAIN)
   { if (x1) {
        del1##_DOMAIN(x1->f_left ,x2,x3);
        del1##_DOMAIN(x1->f_right,x2,x3);
        (*x3)((Genptr)(x1+1));
        free##_DOMAIN(x1,sizeof(*x1) + x2);
     }
   }
-----
[ -d $OUT_DIR/genbt/bintree/find ] || mkdir $OUT_DIR/genbt/bintree/find
cat >$OUT_DIR/genbt/bintree/find/ccod <<'-----'
Genptr find##_DOMAIN _FPH3(DOMAIN,Genptr,Cmp##_DOMAIN)
    /* Suche in x1                                */
    /* x1 = NIL           --> return NIL          */
    /* x3((x1+1),x2) = 0  --> return (x1+1)       */
    /*               = 1  --> rechts weitersuchen */
    /*               = -1 --> links weitersuchen  */
    /*               = -2 --> return NIL          */
{  if ( x1 ) {
      switch ( (*x3) ( (Genptr)(x1+1), x2) ) {
         case  0 : return (Genptr)(x1+1);
         case  1 : return find##_DOMAIN(x1->f_right, x2, x3);
         case -1 : return find##_DOMAIN(x1->f_left , x2, x3);
         default :;
      }
   }
   return (Genptr)0;
 }
-----
[ -d $OUT_DIR/genbt/bintree/forall ] || mkdir $OUT_DIR/genbt/bintree/forall
cat >$OUT_DIR/genbt/bintree/forall/ccod <<'-----'
void forall##_DOMAIN _FPH2(DOMAIN,Perf##_DOMAIN)
    /* fuer alle Elemente aus x1 (rekursiv) x2 ausfuehren */
{  if (x1) {
      forall##_DOMAIN (x1->f_left,x2);
      (*x2) ((Genptr)(x1+1));
      forall##_DOMAIN (x1->f_right,x2);
   }
 }
-----
[ -d $OUT_DIR/genbt/bintree/insert1 ] || mkdir $OUT_DIR/genbt/bintree/insert1
cat >$OUT_DIR/genbt/bintree/insert1/ccod <<'-----'

#ifdef AVL                     

static Bool        bal##_DOMAIN;
static Genptr      gx1##_DOMAIN;
static Nat0        gx2##_DOMAIN;
static Cmp##_DOMAIN gx4##_DOMAIN;

static DOMAIN insert0##_DOMAIN _FPH1(DOMAIN)
{
   if (x1) {
      switch ( (*gx4##_DOMAIN)((Genptr)(x1+1),gx1##_DOMAIN) ) {
         case  1 : x1->f_right = insert0##_DOMAIN(x1->f_right);
                   if ( bal##_DOMAIN )
                      if ( ((x1->bal)+1) > 1 ) {
                         x1 = re_reduce##_DOMAIN(x1);
                         bal##_DOMAIN = FALSE;
	              }
                      else {
	                 (x1->bal)++;
	                 if ((x1->bal) == 0)
	                    bal##_DOMAIN = FALSE;
	              }
                   break;
         case -1 : x1->f_left = insert0##_DOMAIN(x1->f_left);
                   if ( bal##_DOMAIN )
                      if ( ((x1->bal)-1) < -1 ) {
	                 x1 = li_reduce##_DOMAIN(x1);
                         bal##_DOMAIN = FALSE;
                      }
                      else {
	                 (x1->bal)--;
	                 if ( (x1->bal) == 0 )
	                    bal##_DOMAIN = FALSE;
	              }
                   break;
         default : bal##_DOMAIN = FALSE;
      }
      return x1;
   }
   return mk1##_DOMAIN (gx1##_DOMAIN,gx2##_DOMAIN);
}
 
DOMAIN insert1##_DOMAIN _FPH4(Genptr,Nat0,DOMAIN,Cmp##_DOMAIN)
{
   bal##_DOMAIN = TRUE;
   gx1##_DOMAIN = x1;
   gx2##_DOMAIN = x2;
   gx4##_DOMAIN = x4;
   return insert0##_DOMAIN(x3);
}

#else
                             
DOMAIN insert1##_DOMAIN _FPH4(Genptr,Nat0,DOMAIN,Cmp##_DOMAIN)
    /* parameter x1 wird in x3 mit Hilfe der
       Vergleichsfunktion x4 eingefuegt,
       x4 =  0 --> gefunden (???)
       x4 = -1 --> links
       x4 = +1 --> rechts
    */
{  if ( x3 ) { 
      switch ( (*x4)((Genptr)(x3+1),x1 )) {
         case  1 : x3->f_right = insert1##_DOMAIN (x1,x2,(x3->f_right),x4);
                   break;
         case -1 : x3->f_left  = insert1##_DOMAIN (x1,x2,(x3->f_left ),x4);
                   break;
         default : ;
      }
      return x3;
   }
   return mk1##_DOMAIN (x1,x2);
}

#endif
-----
cat >$OUT_DIR/genbt/bintree/insert1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  
   DOMAIN = + mk1
-----
[ -d $OUT_DIR/genbt/bintree/is_empty ] || mkdir $OUT_DIR/genbt/bintree/is_empty
cat >$OUT_DIR/genbt/bintree/is_empty/ccod <<'-----'
Bool is_empty##_DOMAIN _FPH1(DOMAIN)
  { return (! x1); }
-----
[ -d $OUT_DIR/genbt/bintree/is_eq ] || mkdir $OUT_DIR/genbt/bintree/is_eq
cat >$OUT_DIR/genbt/bintree/is_eq/ccod <<'-----'

static Bool is_eq_hilf##_DOMAIN _FPH3(DOMAIN,DOMAIN,Cmp##_DOMAIN)
{  return ( !x1 )
       || ( (find##_DOMAIN(x2, (Genptr)(x1+1), x3)) &&
            (is_eq_hilf##_DOMAIN(x1->f_left , x2, x3)) && 
            (is_eq_hilf##_DOMAIN(x1->f_right, x2, x3))
          );
}

Bool is_eq##_DOMAIN _FPH3(DOMAIN,DOMAIN,Cmp##_DOMAIN)
    /* cardinalitaeten muessen gleich sein
       und alle Elemente aus x1 muessen in x2 gefunden werden
       (zurueckfuehren auf card und find)
    */
   
{  return ( card##_DOMAIN(x1) == card##_DOMAIN(x2) )  
      &&  ( is_eq_hilf##_DOMAIN(x1,x2,x3) );
}
-----
cat >$OUT_DIR/genbt/bintree/is_eq/vdm <<'-----'
DOMAINS     
IMPLEMENTATIONS
 DOMAIN = + card
          + find
-----
[ -d $OUT_DIR/genbt/bintree/is_ge ] || mkdir $OUT_DIR/genbt/bintree/is_ge
cat >$OUT_DIR/genbt/bintree/is_ge/ccod <<'-----'
#include <com/aux/is_ge/ccod>
-----
cat >$OUT_DIR/genbt/bintree/is_ge/docu <<'-----'
#include <com/aux/is_ge/docu>
-----
cat >$OUT_DIR/genbt/bintree/is_ge/vdm <<'-----'
#include <com/aux/is_ge/vdm>
-----
[ -d $OUT_DIR/genbt/bintree/iterator ] || mkdir $OUT_DIR/genbt/bintree/iterator
cat >$OUT_DIR/genbt/bintree/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/genbt/bintree/iterator/vdm <<'-----'
#define PARAM "INTERNALFCT"
#define IMPL bintree
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/genbt/bintree/mk1 ] || mkdir $OUT_DIR/genbt/bintree/mk1
cat >$OUT_DIR/genbt/bintree/mk1/ccod <<'-----'
DOMAIN mk1##_DOMAIN _FPH2(Genptr,Nat0)
{  DOMAIN lx1;
   lx1 = alloc##_DOMAIN(sizeof(*lx1) + x2);
   lx1->f_left = lx1->f_right = 0;
#ifdef AVL
   lx1->bal=0;
#endif
   memcpy((Genptr)(lx1+1),x1,x2);
   return lx1;
}
-----
[ -d $OUT_DIR/genbt/bintree/mk_empty ] || mkdir $OUT_DIR/genbt/bintree/mk_empty
cat >$OUT_DIR/genbt/bintree/mk_empty/ccod <<'-----'
DOMAIN mk_empty##_DOMAIN _FPH0()
{ return (DOMAIN)0; }
-----
[ -d $OUT_DIR/genbt/bintree/remove1 ] || mkdir $OUT_DIR/genbt/bintree/remove1
cat >$OUT_DIR/genbt/bintree/remove1/ccod <<'-----'
#ifdef AVL

static Bool         rbl##_DOMAIN;
static Nat1         rx2##_DOMAIN;
static Genptr       rx3##_DOMAIN;
static Cmp##_DOMAIN  rx4##_DOMAIN;
static Perf##_DOMAIN rx5##_DOMAIN;

static DOMAIN bal_plus##_DOMAIN _FPH1(DOMAIN)
{  if ( rbl##_DOMAIN ) 
      if ( ((x1->bal)+1) > 1 ) {
         x1 = re_reduce##_DOMAIN(x1);
	 if ( (x1->bal) !=0 ) 
            rbl##_DOMAIN = FALSE;
      }
      else {
	 (x1->bal)++;
	 if ((x1->bal)!=0)
            rbl##_DOMAIN=FALSE;
      } 
   return x1;
}

static DOMAIN bal_minus##_DOMAIN _FPH1(DOMAIN)
{  if ( rbl##_DOMAIN ) 
      if ( ((x1->bal)-1) < -1) {
	 x1 = li_reduce##_DOMAIN(x1);
	 if ( (x1->bal) != 0 )
            rbl##_DOMAIN = FALSE;
      }
      else {
	 (x1->bal)--;
	 if ( (x1->bal) != 0 )
            rbl##_DOMAIN = FALSE;
      }
   return x1;
}

static DOMAIN new_root##_DOMAIN _FPH1(DOMAIN *)
{  DOMAIN new_root;
   if ( (*x1)->f_left ) { 
      (*x1)->f_left = new_root##_DOMAIN(&((*x1)->f_left));
       *x1          = bal_plus##_DOMAIN(*x1);
   }
   else {
      new_root = *x1;
      *x1 = new_root->f_right;
   }
   return new_root;
 }

static DOMAIN remove_root##_DOMAIN _FPH1(DOMAIN)
{
   DOMAIN oldroot = x1;
   if ( !( x1->f_right) ) 
      x1 = x1->f_left;
   else
   if ( !( x1->f_left ) )
      x1 = x1->f_right;
   else {
      x1 = new_root##_DOMAIN(&(x1->f_right));
      x1->f_right = oldroot->f_right;
      x1->f_left  = oldroot->f_left ;
      x1 = bal_minus##_DOMAIN(x1);
   }
   free##_DOMAIN (oldroot,sizeof(*oldroot)+rx2##_DOMAIN);
   return x1;
}

static DOMAIN remove2##_DOMAIN _FPH1(DOMAIN)
{  if ( !x1 ) {
      rbl##_DOMAIN = FALSE;
      return x1;
   }
   switch ( (*rx4##_DOMAIN)((Genptr)(x1+1),rx3##_DOMAIN ) ) {
      case  1: x1->f_right = remove2##_DOMAIN(x1->f_right);
               return bal_minus##_DOMAIN (x1);
      case -1: x1->f_left  = remove2##_DOMAIN(x1->f_left);
               return bal_plus##_DOMAIN (x1);        
      case  0: (*rx5##_DOMAIN)((Genptr)(x1+1));
               return remove_root##_DOMAIN(x1);
   }
}

DOMAIN remove1##_DOMAIN _FPH5(DOMAIN, Nat0, Genptr, Cmp##_DOMAIN, Perf##_DOMAIN)
    /* ein Element e wird in x1 gesucht, fuer das x4(e,x3) = 0
       ist, dieses Element wird geloescht, vorher wird x5(e)
       ausgefuehrt
       liefert x4(e,x3) = -1 wird links weiter gesucht
                        =  1 wird rechts weiter gesucht 
       loeschen von Blaettern und Knoten mit einem Nachfolger
       ist einfach
       loeschen von inneren Knoten: Suche des rechtesten
       Knotens im linken Teilbaum (ist kein innerer Knoten)
       diesen zur neuen Wurzel machen
     */
 { 
    rbl##_DOMAIN = TRUE;
    rx2##_DOMAIN = x2;
    rx3##_DOMAIN = x3;
    rx4##_DOMAIN = x4;
    rx5##_DOMAIN = x5;
    return remove2##_DOMAIN(x1); 
 }


#else

static DOMAIN new_root##_DOMAIN _FPH1(DOMAIN *)
{  DOMAIN new_root;
   while ( (*x1)->f_right ) x1 = &( (*x1)->f_right );
   new_root = *x1;
   *x1 = new_root->f_left;
   return new_root;
}

static DOMAIN remove_root##_DOMAIN _FPH2 (DOMAIN, Nat0)
{ 
   DOMAIN oldroot = x1;
   if ( !( x1->f_right) ) 
      x1 = x1->f_left;
   else
   if ( !( x1->f_left ) )
      x1 = x1->f_right;
   else {
      x1 = new_root##_DOMAIN(&(x1->f_left));
      x1->f_right = oldroot->f_right;
      x1->f_left  = oldroot->f_left ;
   }
   free##_DOMAIN (oldroot,sizeof(*oldroot)+x2);
   return x1;
}

DOMAIN remove1##_DOMAIN _FPH5(DOMAIN, Nat0, Genptr, Cmp##_DOMAIN, Perf##_DOMAIN)
    /* ein Element e wird in x1 gesucht, fuer das x4(e,x3) = 0
       ist, dieses Element wird geloescht, vorher wird x5(e)
       ausgefuehrt
       liefert x4(e,x3) = -1 wird links weiter gesucht
                        =  1 wird rechts weiter gesucht 
       loeschen von blattern und knoten mit einem Nachfolger
       ist einfach
       loeschen von inneren Knoten: Suche des rechtesten
       Knotens im linken Teilbaum (ist kein innerer Knoten)
       diesen zur neuen Wurzel machen
     */
{ if (x1) {
     switch ((*x4)((Genptr)(x1+1),x3)) {
        case  1 : x1->f_right=remove1##_DOMAIN (x1->f_right,x2,x3,x4,x5);
                  return x1;
        case -1 : x1->f_left =remove1##_DOMAIN (x1->f_left ,x2,x3,x4,x5);
                  return x1;
        case  0 : (*x5)((Genptr)(x1+1));
                  return remove_root##_DOMAIN(x1,x2);
     }
  }
  return x1; 
}

#endif


-----
cat >$OUT_DIR/genbt/bintree/remove1/vdm <<'-----'
DOMAINS                
IMPLEMENTATIONS   
#ifdef AVL
 DOMAIN = + insert1
          + mk_empty
          + find
          + del1
#endif
-----
[ -d $OUT_DIR/genbt/com ] || mkdir $OUT_DIR/genbt/com
[ -d $OUT_DIR/genbt/com/basic ] || mkdir $OUT_DIR/genbt/com/basic
cat >$OUT_DIR/genbt/com/basic/adttype <<'-----'
INTERNAL
-----
[ -d $OUT_DIR/genbt/sign ] || mkdir $OUT_DIR/genbt/sign
[ -d $OUT_DIR/genbt/sign/card ] || mkdir $OUT_DIR/genbt/sign/card
cat >$OUT_DIR/genbt/sign/card/gsig <<'-----'
  FUNCDEC(card##_DOMAIN,PL_1(DOMAIN),Nat0)
-----
cat >$OUT_DIR/genbt/sign/card/vsig <<'-----'
  card(x1) = card x1
  TYPE : DOMAIN  -->  Nat0

  length of list x1
-----
[ -d $OUT_DIR/genbt/sign/copy1 ] || mkdir $OUT_DIR/genbt/sign/copy1
cat >$OUT_DIR/genbt/sign/copy1/gsig <<'-----'
#ifdef GEN_C
  extern DOMAIN copy1##_DOMAIN P_OP DOMAIN x1, Nat0 x2, Perf##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/genbt/sign/copy1/vsig <<'-----'
  copy1(x1,x2,x3)
  TYPE : DOMAIN  Nat0  (Genptr  --> ) --> DOMAIN

  copy1 copies a whole tree x1
  the length of the elements is given by x2
  after an element is copied procedure x3 is called
  to perform possible modifications of the copied
  instance

  __SA(copy) and __EM(copy1) of other datatypes can be implemented with this function
-----
[ -d $OUT_DIR/genbt/sign/del1 ] || mkdir $OUT_DIR/genbt/sign/del1
cat >$OUT_DIR/genbt/sign/del1/gsig <<'-----'
#ifdef GEN_C
  extern void del1##_DOMAIN P_OP DOMAIN x1, Nat0 x2, Perf##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/genbt/sign/del1/vsig <<'-----'
  del1(x1,x2,x3)
  TYPE : DOMAIN  Nat0  (Genptr  --> ) --> 

  __EM(del1) deletes a whole tree x1
  the length of the elements is given by x2
  before deleting an element
  procedure x3 is called with a generic parameter
  pointing to the element for performing
  cleanup operations
-----
[ -d $OUT_DIR/genbt/sign/find ] || mkdir $OUT_DIR/genbt/sign/find
cat >$OUT_DIR/genbt/sign/find/gsig <<'-----'
#ifdef GEN_C
  extern Genptr find##_DOMAIN P_OP DOMAIN x1, Genptr x2, Cmp##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/genbt/sign/find/vsig <<'-----'
  find(x1,x2,x3) =
    ( x1 = NIL          -> NIL
    , x3(x1.info,x2) = 0  -> pointer to x1.info
    , x3(x1.info,x2) = -1 -> find(x1.left,x2,x3)
    , x3(x1.info,x2) = +1 -> find(x1.right,x2,x3)
    )
  TYPE : DOMAIN  Genptr (Genptr Genptr --> -1..1)  -->  Genptr

  search of an element in x1 for that the predicate x3
  holds (normally an equallity test with x2)
  if found a pointer to that element is returned 
  else NIL is returned
-----
[ -d $OUT_DIR/genbt/sign/forall ] || mkdir $OUT_DIR/genbt/sign/forall
cat >$OUT_DIR/genbt/sign/forall/gsig <<'-----'
#ifdef GEN_C
  extern void forall##_DOMAIN P_OP DOMAIN x1, Perf##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/genbt/sign/forall/vsig <<'-----'
  forall(x1,x2) = for i in x1 do x2(i)
  TYPE : DOMAIN  ( Genptr  -->  )  --> 

  in left to right order for all elements in the tree x1
  procedure x2 is executed
  x2 has one parameter: a generic pointer to the element
-----
[ -d $OUT_DIR/genbt/sign/insert1 ] || mkdir $OUT_DIR/genbt/sign/insert1
cat >$OUT_DIR/genbt/sign/insert1/gsig <<'-----'
#ifdef GEN_C
  extern DOMAIN insert1##_DOMAIN P_OP Genptr x1, Nat0 x2, DOMAIN x3, Cmp##_DOMAIN x4  P_CL ;
#endif

-----
[ -d $OUT_DIR/genbt/sign/is_empty ] || mkdir $OUT_DIR/genbt/sign/is_empty
cat >$OUT_DIR/genbt/sign/is_empty/gsig <<'-----'
  FUNCDEC(is_empty##_DOMAIN,PL_1(DOMAIN),Bool)
-----
cat >$OUT_DIR/genbt/sign/is_empty/vsig <<'-----'
  is_empty(x1) = ( x1 = NIL )
  TYPE : DOMAIN  -->  Bool

  test on empty list
-----
[ -d $OUT_DIR/genbt/sign/is_eq ] || mkdir $OUT_DIR/genbt/sign/is_eq
cat >$OUT_DIR/genbt/sign/is_eq/gsig <<'-----'
#ifdef GEN_C
  extern Bool is_eq##_DOMAIN P_OP DOMAIN x1, DOMAIN x2, Cmp##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/genbt/sign/is_eq/vsig <<'-----'
  is_eq(x1,x2,x3) = 
    (card x1 = card x2) &
    (V e1 e elems x1)(E e2 e x2)(x3(e1,e2)) & 
    (V e2 e elems x2)(E e1 e x1)(x3(e1,e2)) 
  TYPE : DOMAIN  DOMAIN (Genptr Genptr --> -1..1) --> Bool

  test on equal elements in both trees
  all coresponding elements must fullfill predicate x3
-----
[ -d $OUT_DIR/genbt/sign/mk1 ] || mkdir $OUT_DIR/genbt/sign/mk1
cat >$OUT_DIR/genbt/sign/mk1/gsig <<'-----'
  FUNCDEC(mk1##_DOMAIN,PL_2(Genptr,Nat0),DOMAIN)
-----
cat >$OUT_DIR/genbt/sign/mk1/vsig <<'-----'
  mk1(x1,x2) = (NIL,x1,NIL) 
  TYPE : Genptr Nat0  -->  DOMAIN

  construction of a tree with one element x1
  described by a generic pointer x1 and a size x2
-----
[ -d $OUT_DIR/genbt/sign/mk_empty ] || mkdir $OUT_DIR/genbt/sign/mk_empty
cat >$OUT_DIR/genbt/sign/mk_empty/gsig <<'-----'
  FUNCDEC(mk_empty##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/genbt/sign/mk_empty/vsig <<'-----'
  mk_empty() = NIL
  TYPE :  -->  DOMAIN

  construction of the empty tree
-----
[ -d $OUT_DIR/genbt/sign/remove1 ] || mkdir $OUT_DIR/genbt/sign/remove1
cat >$OUT_DIR/genbt/sign/remove1/gsig <<'-----'
#ifdef GEN_C
  extern DOMAIN remove1##_DOMAIN P_OP DOMAIN x1, Nat0 x2, Genptr x3, Cmp##_DOMAIN x4, Perf##_DOMAIN x5 P_CL ;
#endif
-----
cat >$OUT_DIR/genbt/sign/remove1/vsig <<'-----'
  remove(x1,x2,x3,x4,x5) =
  TYPE : DOMAIN  Nat0  Genptr
         (Genptr Genptr --> -1..1) (Genptr --> ) --> DOMAIN

  the first Element e in the tree x1, for that x4(e,x3) = 0,
  is removed from the tree,
  
  before removing e the cleanup routine x5
  is called with that element
  x2 determines the size of the element
-----
[ -d $OUT_DIR/heap ] || mkdir $OUT_DIR/heap
[ -d $OUT_DIR/heap/aux ] || mkdir $OUT_DIR/heap/aux
[ -d $OUT_DIR/heap/aux/prof ] || mkdir $OUT_DIR/heap/aux/prof
cat >$OUT_DIR/heap/aux/prof/gsig <<'-----'
#ifdef GEN_C

#if PROFILE
    PROCDEC(profile##_ELEM1,PL_0())
#else
_DEFINE profile##_ELEM1()
#endif

#endif
-----
cat >$OUT_DIR/heap/aux/prof/vdm <<'-----'
#if PROFILE
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + header("STDIO")
#endif
-----
cat >$OUT_DIR/heap/aux/prof/vsig <<'-----'
  profile()
  TYPE :  -->

  allocation statistics
  statistics are gathered when flag PROFILE is set
-----
[ -d $OUT_DIR/heap/aux/ref ] || mkdir $OUT_DIR/heap/aux/ref
cat >$OUT_DIR/heap/aux/ref/ccod <<'-----'
#ifdef PASS1

#if SAVE
  Valid##_DOMAIN legal_ptrs_valid##_DOMAIN = mk_empty_valid##_DOMAIN();

  ELEM1 ref##_ELEM1 _FPH1(ELEM1)
   {
    if (! x1) err_nil_vdmlib(MKSTRING(ELEM1));
    if (! is_in_valid##_DOMAIN((Token##_DOMAIN)x1,legal_ptrs_valid##_DOMAIN)) err_ref_vdmlib(MKSTRING(ELEM1));
    return x1;
   }

#define add_ptr(x1) MERGE(legal_ptrs_valid,_DOMAIN) = MERGE(union1_valid,_DOMAIN)(MERGE(legal_ptrs_valid,_DOMAIN),(MERGE(Token,_DOMAIN))(x1))
#define sub_ptr(x1) MERGE(legal_ptrs_valid,_DOMAIN) =   MERGE(sub1_valid,_DOMAIN)(MERGE(legal_ptrs_valid,_DOMAIN),(MERGE(Token,_DOMAIN))(x1))
#define fre_ptr(x1,x2) sub_ptr(MERGE(ref,_ELEM1)(x1))
#else
#define add_ptr(x1)
#define sub_ptr(x1)
#define fre_ptr(x1,x2) FREEMEM_vdmlib((VOIDptr)x1,x2)
#endif

#undef PASS1
#endif

#ifdef PASS2
#undef add_ptr
#undef sub_ptr
#undef fre_ptr
#undef OFFSET
#undef PASS2
#endif
-----
cat >$OUT_DIR/heap/aux/ref/docu <<'-----'
  if the implementation parameter SAVE is set, ref check whether
  the pointer is currently legal, errormessages are given for NIL
  value pointers and for dangling pointers
  if SAVE is not given ref becomes a dummy function
-----
cat >$OUT_DIR/heap/aux/ref/gsig <<'-----'
#ifdef GEN_C

#if SAVE
    FUNCDEC(ref##_ELEM1,PL_1(ELEM1),ELEM1)
#else
_DEFINE ref##_ELEM1(x1) (x1)
#endif

#endif
-----
cat >$OUT_DIR/heap/aux/ref/gtyp <<'-----'
#ifdef GEN_C

#if SAVE
  extern Valid##_DOMAIN legal_ptrs_valid##_DOMAIN;
#endif

#endif
-----
cat >$OUT_DIR/heap/aux/ref/vdm <<'-----'
#if SAVE
DOMAINS
   Valid##_DOMAIN  = Token##_DOMAIN -set
   Token##_DOMAIN  = TOKEN

   DOMAIN         -> Valid##_DOMAIN

IMPLEMENTATIONS
   Valid##_DOMAIN  = linklist("INTERNALDOMAIN"
                             ,"SAVE"="0","MACROS"
                             ,"ALLOC"="freelist(\"SAVE\"=0)")
                     + mk_empty + is_in + union1 + sub1
   Token##_DOMAIN  = ptr("INTERNALDOMAIN")
   Vdmlib          = + err_ref + err_nil
#endif
-----
cat >$OUT_DIR/heap/aux/ref/vsig <<'-----'
  ref(x1)
  TYPE : ELEM1  -->  ELEM1

  checks whether x1 is a legal value that is created with alloc
  and not deleted with free
  ref will only be effective when flag SAVE is set
-----
[ -d $OUT_DIR/heap/com ] || mkdir $OUT_DIR/heap/com
[ -d $OUT_DIR/heap/com/basic ] || mkdir $OUT_DIR/heap/com/basic
cat >$OUT_DIR/heap/com/basic/adttype <<'-----'
INTERNAL
-----
[ -d $OUT_DIR/heap/com/cont ] || mkdir $OUT_DIR/heap/com/cont
cat >$OUT_DIR/heap/com/cont/ccod <<'-----'
  RESULT cont##_ELEM1 _FPH1(ELEM1) {return *((RESULT *)(x1));}
  void store##_ELEM1 _FPH2(ELEM1,RESULT) {*((RESULT *)(x1)) = x2;}
-----
cat >$OUT_DIR/heap/com/cont/cmcr <<'-----'
_DEFINE cont##_ELEM1(x1) (*((RESULT *)(x1)))
_DEFINE store##_ELEM1(x1,x2) (*((RESULT *)(x1)) = x2)
-----
cat >$OUT_DIR/heap/com/cont/param <<'-----'
MACROS
RESULT
-----
[ -d $OUT_DIR/heap/freelist ] || mkdir $OUT_DIR/heap/freelist
[ -d $OUT_DIR/heap/freelist/alloc ] || mkdir $OUT_DIR/heap/freelist/alloc
cat >$OUT_DIR/heap/freelist/alloc/ccod <<'-----'
#ifndef STRUCT
#define STRUCT struct MERGE(Struct,_ELEM1)
#endif

  static Nat0 len_mfree##_ELEM1 = 0;

#if PROFILE
  static Nat0 cnt_alloc##_ELEM1 = 0;
  static Nat0 cnt_free##_ELEM1  = 0;
  static Nat0 cnt_mallc##_ELEM1 = 0;
  static Nat0 cnt_mfree##_ELEM1 = 0;

  void profile##_ELEM1 _FPH0()
   {fprintf(stderr,"\n  profiling allocation of domain %s",MKSTRING(ELEM1));
#ifdef MAXLEN
    fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)MAXLEN);
#else
    fprintf(stderr,"\n  strategie : freelist with unbounded length");
#endif
    fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc##_ELEM1);
    fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free##_ELEM1);
    fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc##_ELEM1);
    fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree##_ELEM1);
    fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree##_ELEM1);
    fprintf(stderr,"\n");     
   }

#define incr_alloc() MERGE(cnt_alloc,_ELEM1) ++  
#define incr_free()  MERGE(cnt_free,_ELEM1)  ++  
#define incr_mallc() MERGE(cnt_mallc,_ELEM1) ++  
#define incr_mfr()   MERGE(cnt_mfree,_ELEM1) ++
#else
#define incr_alloc()
#define incr_free()
#define incr_mallc()
#define incr_mfr()
#endif

/* 
   TT, 10-19-93: These macros are used always, not only when PROFILE is
   selected ! 
*/
#define incr_len()   MERGE(len_mfree,_ELEM1) ++
#define decr_len()   MERGE(len_mfree,_ELEM1) --  

  static VOIDptr freelist##_ELEM1 = (VOIDptr)0;

  ELEM1 alloc##_ELEM1 _FPH0()
   {ELEM1 x1;
    incr_alloc();
    if (! freelist##_ELEM1)
      {while (! (x1 = (ELEM1)ALLOCMEM_vdmlib(sizeof(STRUCT)))) heap_oflw_vdmlib(MKSTRING(DOMAIN));
       incr_mallc();
       return x1;
      }
    freelist##_ELEM1 = *((VOIDptr *)(x1 = (ELEM1) freelist##_ELEM1));
    decr_len();
    return x1;
   } 

  void free##_ELEM1 _FPH1(ELEM1)
   {incr_len();
    incr_free();
    *((VOIDptr *)x1) = freelist##_ELEM1;
    freelist##_ELEM1 = (VOIDptr)x1;
#ifdef MAXLEN
    if (len_mfree##_ELEM1 > MAXLEN)
      {while (len_mfree##_ELEM1 > MAXLEN / 2)
         {VOIDptr lx1 = *((VOIDptr *) freelist##_ELEM1);
          FREEMEM_vdmlib(freelist##_ELEM1,sizeof(STRUCT));
          freelist##_ELEM1 = lx1;
          decr_len();
          incr_mfr();
         }
      }
#endif
   }   

#if SAVE
  ELEM1 ref##_ELEM1 _FPH1(ELEM1)
   { return x1; }
#endif

#undef incr_alloc
#undef incr_free
#undef incr_mallc
#undef incr_len
#undef decr_len
#undef incr_mfr

#undef STRUCT
-----
cat >$OUT_DIR/heap/freelist/alloc/param <<'-----'
SAVE
STRUCT
-----
[ -d $OUT_DIR/heap/freelist/basic ] || mkdir $OUT_DIR/heap/freelist/basic
cat >$OUT_DIR/heap/freelist/basic/docu <<'-----'
  memory allocation module
  for memory allocation implemented by a freelist
  if the freelist is empty, space is allocated with the C routine
  malloc
  parameters

   MAXLEN  : can be used to limit the length of the freelist
             if the freelist exceeds this value it is shortened to half
             the length and the space is given back to the C runtime system
             with the routine free

   PROFILE : if set info of # of calls of alloc routines is gathered
             and an extra routine profile##_ELEM1() for statistics output
             is added
-----
cat >$OUT_DIR/heap/freelist/basic/param <<'-----'
FORWARD_ALLOWED
INTERNALDOMAIN
MAXLEN
PROFILE
SAVE
-----
cat >$OUT_DIR/heap/freelist/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + heap_oflw + mallfree

#include <heap/aux/prof/vdm>
-----
[ -d $OUT_DIR/heap/malloc ] || mkdir $OUT_DIR/heap/malloc
[ -d $OUT_DIR/heap/malloc/alloc ] || mkdir $OUT_DIR/heap/malloc/alloc
cat >$OUT_DIR/heap/malloc/alloc/ccod <<'-----'
#if PROFILE
  static Nat0 cnt_alloc##_ELEM1 = 0;
  static Nat0 cnt_free##_ELEM1  = 0;

  void profile##_ELEM1 _FPH0()
   {fprintf(stderr,"\n  profiling allocation of domain %s",MKSTRING(ELEM1));
    fprintf(stderr,"\n  strategie : C malloc and free routines");
    fprintf(stderr,"\n     calls of alloc : %10ld",(long)cnt_alloc##_ELEM1);
    fprintf(stderr,"\n     calls of free  : %10ld",(long)cnt_free##_ELEM1);
    fprintf(stderr,"\n");     
   }

#define incr_alloc() MERGE(cnt_alloc,_ELEM1) ++  
#define incr_free()  MERGE(cnt_free,_ELEM1) ++  
#else
#define incr_alloc()
#define incr_free()
#endif

#define PASS1
#include <heap/aux/ref/ccod>

  ELEM1 alloc##_ELEM1 _FPH0()
   {ELEM1 x1; x1 = (ELEM1)0;  /* prevent warning: x1 may be used before set */
    while (! (x1 = (ELEM1)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib(MKSTRING(DOMAIN));
    add_ptr(x1);
    incr_alloc();
    return x1;
   } 

  void free##_ELEM1 _FPH1(ELEM1)
   {
    fre_ptr(x1,sizeof(*x1));
    incr_free();
   }   

#undef incr_alloc
#undef incr_free

#define PASS2
#include <heap/aux/ref/ccod>
-----
cat >$OUT_DIR/heap/malloc/alloc/param <<'-----'
SAVE
STRUCT
-----
[ -d $OUT_DIR/heap/malloc/basic ] || mkdir $OUT_DIR/heap/malloc/basic
cat >$OUT_DIR/heap/malloc/basic/docu <<'-----'
  memory allocation based on C malloc and free

  parameters:

   PROFILE :   optional for counting  calls of alloc and free
               statistics can be reported by the call of profile##_DOMAIN
   SAVE    :   test implementation for checking on legal pointers
               no space is given back via calls of free
               to detect as much dangling references as possible
               all legal pointers are collected in a set
-----
cat >$OUT_DIR/heap/malloc/basic/gtyp <<'-----'
#include <heap/aux/ref/gtyp>
-----
cat >$OUT_DIR/heap/malloc/basic/param <<'-----'
FORWARD_ALLOWED
INTERNALDOMAIN
PROFILE
SAVE
-----
cat >$OUT_DIR/heap/malloc/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + heap_oflw + mallfree

#include <heap/aux/ref/vdm>

#include <heap/aux/prof/vdm>
-----
[ -d $OUT_DIR/heap/osalloc ] || mkdir $OUT_DIR/heap/osalloc
[ -d $OUT_DIR/heap/osalloc/basic ] || mkdir $OUT_DIR/heap/osalloc/basic
cat >$OUT_DIR/heap/osalloc/basic/docu <<'-----'
  common routines for heap storage management for variable length items.
  space is allocated with baisc operating system functions
  via the functions in the vdmlib under mallfree
  (default C-library functions malloc and free)
  A test is done whether space is available
  otherwise the heap overflow routine is called

-----
cat >$OUT_DIR/heap/osalloc/basic/param <<'-----'
FORWARD_ALLOWED
INTERNALDOMAIN
PROFILE
SAVE
-----
cat >$OUT_DIR/heap/osalloc/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + heap_oflw + mallfree

#include <heap/aux/prof/vdm>
-----
[ -d $OUT_DIR/heap/osalloc/memalloc ] || mkdir $OUT_DIR/heap/osalloc/memalloc
cat >$OUT_DIR/heap/osalloc/memalloc/ccod <<'-----'
#if PROFILE
  static Nat0 cnt_malloc##_ELEM1 = 0;
  static Nat0 cnt_free##_ELEM1   = 0;
  static Nat0 cnt_as##_ELEM1     = 0;
  static Nat0 cnt_fs##_ELEM1     = 0;

  void profile##_ELEM1 _FPH0()
   {fprintf(stderr,"\n  profiling allocation of domain %s",MKSTRING(ELEM1));
    fprintf(stderr,"\n  strategie : OS calls of malloc and free");
    fprintf(stderr,"\n     calls of C fct malloc  : %10ld",(long)cnt_malloc##_ELEM1);
    fprintf(stderr,"\n     calls of C fct free    : %10ld",(long)cnt_free##_ELEM1);
    fprintf(stderr,"\n     total space allocated  : %10ld",(long)cnt_as##_ELEM1);
    fprintf(stderr,"\n     total space given back : %10ld",(long)cnt_fs##_ELEM1);
    fprintf(stderr,"\n     currently allocated    : %10ld",(long)cnt_as##_ELEM1 - (long)cnt_fs##_ELEM1);
    fprintf(stderr,"\n");     
   }

#define incr_malloc(x) MERGE(cnt_malloc,_ELEM1) ++; MERGE(cnt_as,_ELEM1) += x;
#define incr_free(x)   MERGE(cnt_free,_ELEM1)  ++;  MERGE(cnt_fs,_ELEM1) += x;
#else
#define incr_malloc(x)
#define incr_free(x)
#endif

  ELEM1 alloc##_ELEM1 _FPH1(Nat0)
   {
    ELEM1 lx1;
    while (! (lx1 = (ELEM1) ALLOCMEM_vdmlib(x1)))
       heap_oflw_vdmlib(MKSTRING(ELEM1));
    incr_malloc(x1)
    return lx1;
   } 

  void free##_ELEM1 _FPH2(ELEM1,Nat0)
   {
      FREEMEM_vdmlib(x1,x2);
#if PROFILE
      incr_free(x2)
#endif
   }

#undef incr_free
#undef incr_malloc
-----
[ -d $OUT_DIR/heap/sign ] || mkdir $OUT_DIR/heap/sign
[ -d $OUT_DIR/heap/sign/alloc ] || mkdir $OUT_DIR/heap/sign/alloc
cat >$OUT_DIR/heap/sign/alloc/gsig <<'-----'
#ifdef GEN_C
  FUNCDEC(alloc##_ELEM1,PL_0(),ELEM1)
  PROCDEC(free##_ELEM1,PL_1(ELEM1))

#include <heap/aux/ref/gsig>
#include <heap/aux/prof/gsig>
#endif
-----
cat >$OUT_DIR/heap/sign/alloc/vsig <<'-----'
  alloc()
  TYPE :  -->  ELEM1
  memory allocation for one element

  free(x1)
  TYPE :  ELEM1  -->

  memory deallocation for one element

#include <heap/aux/ref/vsig>

#include <heap/aux/prof/vsig>
-----
[ -d $OUT_DIR/heap/sign/basic ] || mkdir $OUT_DIR/heap/sign/basic
cat >$OUT_DIR/heap/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN { 
#endif

-----
cat >$OUT_DIR/heap/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/heap/sign/cont ] || mkdir $OUT_DIR/heap/sign/cont
cat >$OUT_DIR/heap/sign/cont/gsig <<'-----'
  FUNCDEC(cont##_ELEM1,PL_1(ELEM1),ELEM2)
  PROCDEC(store##_ELEM1,PL_2(ELEM1,RESULT))
-----
cat >$OUT_DIR/heap/sign/cont/vsig <<'-----'
  cont(x1)
  TYPE :  ELEM1  -->  RESULT

  store(x1,x2)
  TYPE :  ELEM1  RESULT  ==>

  memory access function

  for reading a value x1 from the heap and for storing a value x2
  under address x1 in the heap
-----
[ -d $OUT_DIR/heap/sign/memalloc ] || mkdir $OUT_DIR/heap/sign/memalloc
cat >$OUT_DIR/heap/sign/memalloc/gsig <<'-----'
#ifdef GEN_C
  FUNCDEC(alloc##_ELEM1,PL_1(Nat0),ELEM1)
  PROCDEC(free##_ELEM1,PL_2(ELEM1,Nat0))

#include <heap/aux/prof/gsig>
#endif
-----
cat >$OUT_DIR/heap/sign/memalloc/vsig <<'-----'
  alloc(x1)
  TYPE :  Nat0  -->  ELEM1

  memory allocation for a block of bytes
  x1 determines the number of bytes to be allocated

  free(x1,x2)
  TYPE :  ELEM1  Nat0  -->

  memory deallocation for a block of bytes
  x1 determines the block
  x2 the lengh of the block 

#include <heap/aux/prof/vsig>
-----
[ -d $OUT_DIR/heap/sign/valloc ] || mkdir $OUT_DIR/heap/sign/valloc
cat >$OUT_DIR/heap/sign/valloc/gsig <<'-----'
#ifdef GEN_C
  FUNCDEC(alloc##_ELEM1,PL_1(Nat0),ELEM1)
  PROCDEC(free##_ELEM1,PL_1(ELEM1))

#include <heap/aux/ref/gsig>
#include <heap/aux/prof/gsig>
#endif
-----
cat >$OUT_DIR/heap/sign/valloc/vsig <<'-----'
  alloc(x1)
  TYPE :  Nat0  -->  ELEM1

  memory allocation for a block of elements
  x1 determines the number of elements

  free(x1)
  TYPE :  ELEM1  -->

  memory deallocation for a block of elements

#include <heap/aux/ref/vsig>

#include <heap/aux/prof/vsig>
-----
[ -d $OUT_DIR/heap/vmalloc ] || mkdir $OUT_DIR/heap/vmalloc
[ -d $OUT_DIR/heap/vmalloc/basic ] || mkdir $OUT_DIR/heap/vmalloc/basic
cat >$OUT_DIR/heap/vmalloc/basic/docu <<'-----'
  common routines for heap storage management for variable length items.
  space is allocated in units of powers of 2. So the number of required
  element units is rounded up. In field 'f_max' the maximum number of elements
  is stored in 'f_len' the actually required number is stored
  allocation is done with C malloc and free

  parameters:

   "PROFILE" : optional for counting  calls of alloc and free
               statistics can be reported by the call of profile##_DOMAIN
   "SAVE"    : test implementation for checking on legal pointers
               no space is given back via calls of free
               to detect as much dangling references as possible
               all legal pointers are collected in a set
#ifdef OFFSET
   "OFFSET"  : defines an default offset for data allocation within
	       a freshly defined object. This value is entered into
	       the field 'f_offs'. This is an optional parameter; the
	       default setting will be '0'.
#endif
#undef OFFSET
-----
cat >$OUT_DIR/heap/vmalloc/basic/gtyp <<'-----'
#include <heap/aux/ref/gtyp>
-----
cat >$OUT_DIR/heap/vmalloc/basic/param <<'-----'
FORWARD_ALLOWED
INTERNALDOMAIN
PROFILE
SAVE
-----
cat >$OUT_DIR/heap/vmalloc/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + heap_oflw + mallfree

#include <heap/aux/ref/vdm>

#include <heap/aux/prof/vdm>
-----
[ -d $OUT_DIR/heap/vmalloc/valloc ] || mkdir $OUT_DIR/heap/vmalloc/valloc
cat >$OUT_DIR/heap/vmalloc/valloc/ccod <<'-----'
#ifndef STRUCT
#define STRUCT struct MERGE(Struct,_ELEM1)
#endif

#if PROFILE
  static Nat0 cnt_alloc##_ELEM1 = 0;
  static Nat0 cnt_free##_ELEM1  = 0;
  static Nat0 cne_alloc##_ELEM1 = 0;
  static Nat0 cne_free##_ELEM1  = 0;

  void profile##_ELEM1 _FPH0()
   {fprintf(stderr,"\n  profiling allocation of domain %s",MKSTRING(ELEM1));
    fprintf(stderr,"\n  strategie : 2**n elems are allocated at once with C malloc and free routines");
    fprintf(stderr,"\n     calls of alloc    : %10ld",(long)cnt_alloc##_ELEM1);
    fprintf(stderr,"\n     calls of free     : %10ld",(long)cnt_free##_ELEM1);
    fprintf(stderr,"\n     # elems allocated : %10ld",(long)cne_alloc##_ELEM1);
    fprintf(stderr,"\n     # elems freed     : %10ld",(long)cne_free##_ELEM1);
    fprintf(stderr,"\n");     
   }

#define incr_alloc() MERGE(cnt_alloc,_ELEM1) ++; MERGE(cne_alloc,_ELEM1) += lx1->f_max 
#define incr_free()  MERGE(cnt_free,_ELEM1) ++ ; MERGE(cne_free,_ELEM1) += x1->f_max 
#else
#define incr_alloc()
#define incr_free()
#endif

#ifdef OFFSET
#define __OFFSET OFFSET
#else
#define __OFFSET 0
#endif

#define PASS1
#include <heap/aux/ref/ccod>

  ELEM1 alloc##_ELEM1 _FPH1(Nat0)
   {
    Nat0 len = sizeof(STRUCT) + (x1 + __OFFSET) * sizeof(ELEM2);
    Nat0 len2 = 4;
    ELEM1 lx1;
    while (len2 < len) len2 += len2;
    while (! (lx1 = (ELEM1) ALLOCMEM_vdmlib(len2)))
       heap_oflw_vdmlib(MKSTRING(ELEM1));
    lx1->f_max = ((len2 - sizeof(STRUCT))/sizeof(ELEM2));
    lx1->f_len = x1;
#ifdef OFFSET
    lx1->f_offs = OFFSET;
#endif
    add_ptr(lx1);
    incr_alloc();
    return lx1;
   } 

  void free##_ELEM1 _FPH1(ELEM1)
   {
    incr_free();
	       /* WARNING: This length computation will fail if   */
	       /*          the computation of 'f_max' in 'valloc' */
	       /*          leaves a remainder (found nothing      */
	       /*	   better yet)!				  */
    fre_ptr(x1,sizeof(STRUCT) + x1->f_max*sizeof(ELEM2));
   }   

#undef __OFFSET
#undef incr_alloc
#undef incr_free
#undef STRUCT

#define PASS2
#include <heap/aux/ref/ccod>
-----
cat >$OUT_DIR/heap/vmalloc/valloc/param <<'-----'
SAVE
STRUCT
-----
[ -d $OUT_DIR/heap/vomalloc ] || mkdir $OUT_DIR/heap/vomalloc
[ -d $OUT_DIR/heap/vomalloc/basic ] || mkdir $OUT_DIR/heap/vomalloc/basic
cat >$OUT_DIR/heap/vomalloc/basic/defp <<'-----'
#ifndef OFFSET
#define OFFSET 0
#endif
-----
cat >$OUT_DIR/heap/vomalloc/basic/docu <<'-----'
#include <heap/vomalloc/basic/defp>
#include <heap/vmalloc/basic/docu>
-----
cat >$OUT_DIR/heap/vomalloc/basic/gtyp <<'-----'
#include <heap/aux/ref/gtyp>
-----
cat >$OUT_DIR/heap/vomalloc/basic/param <<'-----'
FORWARD_ALLOWED
INTERNALDOMAIN
OFFSET
PROFILE
SAVE
-----
cat >$OUT_DIR/heap/vomalloc/basic/vdm <<'-----'
#include <heap/vmalloc/basic/vdm>
-----
[ -d $OUT_DIR/heap/vomalloc/valloc ] || mkdir $OUT_DIR/heap/vomalloc/valloc
cat >$OUT_DIR/heap/vomalloc/valloc/ccod <<'-----'
#include <heap/vomalloc/basic/defp>
#include <heap/vmalloc/valloc/ccod>
-----
cat >$OUT_DIR/heap/vomalloc/valloc/param <<'-----'
SAVE
STRUCT
-----
[ -d $OUT_DIR/isa ] || mkdir $OUT_DIR/isa
[ -d $OUT_DIR/isa/com ] || mkdir $OUT_DIR/isa/com
[ -d $OUT_DIR/isa/com/basic ] || mkdir $OUT_DIR/isa/com/basic
cat >$OUT_DIR/isa/com/basic/adttype <<'-----'
REAL

-----
cat >$OUT_DIR/isa/com/basic/docu <<'-----'
Syntax:

    Domain1 is-a Domain2 

Description:
 
  Definition of alias names for domains.
  Domain1 stands for the same data type as Domain2.

  for pure C, this is exactly the same as

    Domain1 = Domain2

  that means, Domain1 is another name for the type Domain2

  for C++ this does not longer hold, here Domain1,
  or the C++ class DOMAIN1, becomes a derived class of
  class DOMAIN2.

  No implementation must be given for is-a domains,
  operations and signature specs can be specified
  in the ususal way.

  The is-a construct allows for redefining functions, especially
  user defined function, in class DOMAIN1 for modifying the general
  functionality specified in class DOMAIN2.

Example:

  For C++ only:

  DOMAINS

    Mystring is-a Str

  IMPLEMENTATIONS

    Mystring = + hd

  FUNCTIONS
    scan : Mystring -> Bool

  defines a new class MYSTRING, the hd operation becomes part
  of the STR class, the function scan becomes a member function
  of class Mystring, the implementation of scan must be supported
  in an extra C++ file

    class MYSTRING : public STR
    {
      ...
      BOOL scan() const;
      ...
    };



  
-----
cat >$OUT_DIR/isa/com/basic/gtyp <<'-----'
/* in C -isa acts like -alias */
_DEFINE DOMAIN ELEM1
-----
cat >$OUT_DIR/isa/com/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> ELEM1
IMPLEMENTATIONS
-----
[ -d $OUT_DIR/isa/com/constructor ] || mkdir $OUT_DIR/isa/com/constructor
cat >$OUT_DIR/isa/com/constructor/param <<'-----'
FCTNAME
ADT_BAG
ADT_BOOL
ADT_ENUM
ADT_MAP
ADT_NUMERIC
ADT_OPTI
ADT_REL
ADT_SET
ADT_TOKEN
ADT_TREE
ADT_TUPL
ADT_UNIO
IMPL_REAL
IMPL_SCALAR
IMPL_UNSIGNED
IMPL_EXTERN
IMPL_NAT0
IMPL_PTR
COMP_ELEM1
COMP_ELEM2
COMP_ELEM3
-----
[ -d $OUT_DIR/isa/com/rename ] || mkdir $OUT_DIR/isa/com/rename
cat >$OUT_DIR/isa/com/rename/param <<'-----'
FCTNAME
TUPLDOMAIN
NAME
NOADD
-----
cat >$OUT_DIR/isa/com/rename/vdm <<'-----'
/* operations are propagated to ELEM1 domain, like in -alias */
#ifndef NOADD

#ifdef TUPLDOMAIN
#define ARG ("TUPLDOMAIN"=TUPLDOMAIN)
#else
#define ARG
#endif

_ADD_OP(ELEM1,FCTNAME ARG)

#undef ARG
#endif
-----
[ -d $OUT_DIR/isa/sign ] || mkdir $OUT_DIR/isa/sign
[ -d $OUT_DIR/isa/sign/basic ] || mkdir $OUT_DIR/isa/sign/basic
cat >$OUT_DIR/isa/sign/basic/cpp <<'-----'
#ifdef DECL

class Cpp_DOMAIN : public Cpp_ELEM1
{
public :
inline
Cpp_DOMAIN();

inline
Cpp_DOMAIN(const Cpp_DOMAIN & x1);

inline
Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1);

inline
Cpp_DOMAIN(const Cpp_ELEM1 & x1);

inline
Cpp_DOMAIN & operator=(const Cpp_ELEM1 & x1);

#else

inline
Cpp_DOMAIN::Cpp_DOMAIN()
  : Cpp_ELEM1()
{}

inline
Cpp_DOMAIN::Cpp_DOMAIN(const Cpp_DOMAIN & x1)
  : Cpp_ELEM1(x1)
{}

inline
Cpp_DOMAIN & 
Cpp_DOMAIN::operator=(const Cpp_DOMAIN & x1)
{
  (Cpp_ELEM1 &)(*this) = (Cpp_ELEM1 &)x1;
  return *this;
}

inline
Cpp_DOMAIN::Cpp_DOMAIN(const Cpp_ELEM1 & x1)
  : Cpp_ELEM1(x1)
{}

inline
Cpp_DOMAIN & 
Cpp_DOMAIN::operator=(const Cpp_ELEM1 & x1)
{
  (Cpp_ELEM1 &)(*this) = x1;
  return *this;
}

#endif
-----
cat >$OUT_DIR/isa/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/isa/sign/constructor ] || mkdir $OUT_DIR/isa/sign/constructor
cat >$OUT_DIR/isa/sign/constructor/cpp <<'-----'

#define mk_basic 1
#define mk_empty 2
#define mk1      3
#define mk1n     4
#define mk2      5
#define mk3      6
#define mkc      7
#define mk_nil   8
#define mk_opt   9
#define mk       10

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mk_basic) && ( defined(ADT_NUMERIC) )
  InlineNoFriendFct(Cpp_DOMAIN,KPAR1(DOMAIN),)
  RUMPF(: Cpp_ELEM1(x1) {})
#endif

/* -------------------------------------------------------------------------- */

#if FCTNAME == mk_empty
  InlineNoFriendFct(Cpp_DOMAIN,KPAR1(const Cpp_EMPTY &),)
  RUMPF(: Cpp_ELEM1(x1) {})
#endif

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mk1) && ( defined(ADT_MAP) || defined(ADT_REL) )
  InlineNoFriendFct(Cpp_DOMAIN,KPAR2(const Cpp_COMP_ELEM1 &, const Cpp_COMP_ELEM2 &),)
  RUMPF(: Cpp_ELEM1(x1,x2) {})
#endif

#if (FCTNAME == mk1) && ( defined(ADT_BAG) || defined(ADT_SET) || defined(ADT_TUPL) )
  InlineNoFriendFct(Cpp_DOMAIN,KPAR1(const Cpp_COMP_ELEM1 &),)
  RUMPF(: Cpp_ELEM1(x1) {})
#endif

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mk2) && ( defined(ADT_BAG) || defined(ADT_SET) || defined(ADT_TUPL) )
  InlineNoFriendFct(Cpp_DOMAIN,KPAR2(const Cpp_COMP_ELEM1 &, const Cpp_COMP_ELEM1 &),)
  RUMPF(: Cpp_ELEM1(x1,x2) {})
#endif

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mk3) && ( defined(ADT_BAG) || defined(ADT_SET) || defined(ADT_TUPL) )
  InlineNoFriendFct(Cpp_DOMAIN,KPAR3(const Cpp_COMP_ELEM1 &, const Cpp_COMP_ELEM1 &, const COMP_ELEM1 &),)
  RUMPF(: Cpp_ELEM1(x1,x2,3) {})
#endif

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mk1n) && defined(ADT_BAG)
  InlineNoFriendFct(Cpp_DOMAIN,KPAR2(const Cpp_COMP_ELEM1 &, const Cpp_NAT0 &),)
  RUMPF(: Cpp_ELEM1(x1,x2) {})
#endif

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mkc) && defined(ADT_TUPL)
  InlineNoFriendFct(Cpp_DOMAIN,KPAR1(char *),)
  RUMPF(: Cpp_ELEM1(x1) {})
#endif

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mk_nil) && defined(ADT_OPTI)
  InlineNoFriendFct(Cpp_DOMAIN,KPAR1(const Cpp_NIL),)
  RUMPF(: Cpp_ELEM1(x1) {})
#endif

/* -------------------------------------------------------------------------- */

#if (FCTNAME == mk_opt) && defined(ADT_OPTI)
  InlineNoFriendFct(Cpp_DOMAIN,KPAR1(const Cpp_COMP_ELEM1 &),)
  RUMPF(: Cpp_ELEM1(x1) {})
#endif

/* -------------------------------------------------------------------------- */

#if 0
  this constructor is generated for all classes, not only trees and unions

#if (FCTNAME == mk) && (defined(ADT_TREE) || defined(ADT_UNIO))
  InlineNoFriendFct(Cpp_DOMAIN,KPAR1(const Cpp_ELEM1 &),)
  RUMPF(: Cpp_ELEM1(x1) {})
#endif

#endif

/* -------------------------------------------------------------------------- */

#undef mk_basic
#undef mk_empty
#undef mk1
#undef mk1n
#undef mk2
#undef mk3
#undef mkc
#undef mk_nil
#undef mk_opt
#undef mk
-----
[ -d $OUT_DIR/isa/sign/post ] || mkdir $OUT_DIR/isa/sign/post
cat >$OUT_DIR/isa/sign/post/cpp <<'-----'
#ifdef DECL
};
#endif
-----
[ -d $OUT_DIR/isa/sign/rename ] || mkdir $OUT_DIR/isa/sign/rename
cat >$OUT_DIR/isa/sign/rename/gsig <<'-----'
/* in C: -isa acts like -alias : just #define's for alias names */
#ifndef NAME
#define NAME FCTNAME
#endif
_DEFINE MERGE(NAME,_DOMAIN) MERGE(FCTNAME,_ELEM1)
#undef NAME
-----
[ -d $OUT_DIR/iterator ] || mkdir $OUT_DIR/iterator
[ -d $OUT_DIR/iterator/array ] || mkdir $OUT_DIR/iterator/array
[ -d $OUT_DIR/iterator/array/basic ] || mkdir $OUT_DIR/iterator/array/basic
cat >$OUT_DIR/iterator/array/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_array,ELEM1);
                      RECFIELD(f_curser,unsigned);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/array/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/array/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/array/is_empty ] || mkdir $OUT_DIR/iterator/array/is_empty
cat >$OUT_DIR/iterator/array/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((x1)->f_curser == (x1)->f_array->f_len)
-----
[ -d $OUT_DIR/iterator/array/mk ] || mkdir $OUT_DIR/iterator/array/mk
cat >$OUT_DIR/iterator/array/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_array = x1;
    lx.f_curser = 0;
    return lx;
}
-----
[ -d $OUT_DIR/iterator/array/next ] || mkdir $OUT_DIR/iterator/array/next
cat >$OUT_DIR/iterator/array/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if (x1->f_curser == x1->f_array->f_len)
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    x1->f_curser++;
}
-----
[ -d $OUT_DIR/iterator/array/sel ] || mkdir $OUT_DIR/iterator/array/sel
cat >$OUT_DIR/iterator/array/sel/ccod <<'-----'
#ifndef ELEM3
#define selPL _FPH1(DOMAIN *)
#define copyATTR
#else
#error not yet implemented
#define selPL _FPH2(DOMAIN *,ELEM3 *)
#define copyATTR *x2 = x1->f_curser->f_attr;
#endif

ELEM2 sel##_DOMAIN selPL {
    if (x1->f_curser == x1->f_array->f_len)
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    copyATTR
    return
        *(((ELEM2 *)(x1->f_array +1)) + x1->f_curser);
}

#undef selPL
#undef copyATTR
-----
[ -d $OUT_DIR/iterator/automem ] || mkdir $OUT_DIR/iterator/automem
[ -d $OUT_DIR/iterator/automem/basic ] || mkdir $OUT_DIR/iterator/automem/basic
cat >$OUT_DIR/iterator/automem/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_ir,Iter_rep##_ELEM1);
                      RECFIELD(f_vl,ELEM1);
  END_RECORD_TYP(Struct##_DOMAIN) 

  TYPE_DEF(DOMAIN,struct Struct##_DOMAIN)
#endif
-----
cat >$OUT_DIR/iterator/automem/basic/param <<'-----'
BASEIMPL
INTERNALDOMAIN
MACROS
-----
cat >$OUT_DIR/iterator/automem/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Iter_rep##_ELEM1
IMPLEMENTATIONS
  DOMAIN   = + mk + is_empty + sel + next + del
  ELEM2    = + copy
-----
[ -d $OUT_DIR/iterator/automem/del ] || mkdir $OUT_DIR/iterator/automem/del
cat >$OUT_DIR/iterator/automem/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1) del##_ELEM1((x1).f_vl)
-----
[ -d $OUT_DIR/iterator/automem/is_empty ] || mkdir $OUT_DIR/iterator/automem/is_empty
cat >$OUT_DIR/iterator/automem/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_iter_rep##_ELEM1(&((x1)->f_ir))
-----
[ -d $OUT_DIR/iterator/automem/mk ] || mkdir $OUT_DIR/iterator/automem/mk
cat >$OUT_DIR/iterator/automem/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx1;
    check_handle##_ELEM1(x1);
    x1->f_rc++;
    lx1.f_vl = x1;
    lx1.f_ir = mk_iter_rep##_ELEM1(x1->f_rep);
    return lx1;
}
-----
[ -d $OUT_DIR/iterator/automem/next ] || mkdir $OUT_DIR/iterator/automem/next
cat >$OUT_DIR/iterator/automem/next/cmcr <<'-----'
_DEFINE next##_DOMAIN(x1) next_iter_rep##_ELEM1(&((x1)->f_ir))
-----
[ -d $OUT_DIR/iterator/automem/sel ] || mkdir $OUT_DIR/iterator/automem/sel
cat >$OUT_DIR/iterator/automem/sel/cmcr <<'-----'
#ifndef ELEM3
_DEFINE sel##_DOMAIN(x1) copy##_ELEM2(sel##_iter_rep##_ELEM1(&((x1)->f_ir)))
#else
_DEFINE sel##_DOMAIN(x1,x2) copy##_ELEM2(sel##_iter_rep##_ELEM1(&((x1)->f_ir),x2))
#endif
-----
[ -d $OUT_DIR/iterator/bintree ] || mkdir $OUT_DIR/iterator/bintree
[ -d $OUT_DIR/iterator/bintree/basic ] || mkdir $OUT_DIR/iterator/bintree/basic
cat >$OUT_DIR/iterator/bintree/basic/ccod <<'-----'
static I1##_DOMAIN leftmost##_DOMAIN _FPH2(I1##_DOMAIN,ELEM1) {
    while ( x2 ) {
       if ( x1->f_free == 0 ) { /* allocate a new element in iterator list */
           I1##_DOMAIN lx1;
           lx1 = alloc_i1##_DOMAIN();
           lx1->f_free = 0;
           lx1->f_prev = x1;
           x1->f_free = lx1;
       }
       x1 = x1->f_free;                    /* extend iterator list by one element */
       x1->f_nextelem = x2;                /* insert node */
       x2 = x2->f_left;                    /* move to the left subnode */
    }
    return x1;
}
-----
cat >$OUT_DIR/iterator/bintree/basic/gptr <<'-----'
#ifdef GEN_C
  TYPE_DEF(I1##_DOMAIN,POINTER_TO_STRUCT(Struct1##_DOMAIN))
#endif
-----
cat >$OUT_DIR/iterator/bintree/basic/gtyp <<'-----'
#ifdef GEN_C
/* the iterator is realized as a double linked list
   the iterator allocates elements on demand, such that
   the list becomes during processing as long as the longest path
   no of calls of alloc are limited by the length of the path (tree depth)
*/
  START_RECORD_TYP(Struct1##_DOMAIN)
                      RECFIELD(f_nextelem,ELEM1);
                      RECFIELD(f_prev    ,I1##_DOMAIN);
                      RECFIELD(f_free    ,I1##_DOMAIN);
  END_RECORD_TYP(Struct1##_DOMAIN) 

  START_RECORD_TYP(Struct2##_DOMAIN)
                      RECFIELD(f_iter    ,I1##_DOMAIN);
                      RECFIELD(f_free    ,I1##_DOMAIN);
  END_RECORD_TYP(Struct2##_DOMAIN) 

  TYPE_DEF(DOMAIN,struct Struct2##_DOMAIN)
#endif
-----
cat >$OUT_DIR/iterator/bintree/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/bintree/basic/vdm <<'-----'
DOMAINS
   I1##_DOMAIN        = PREDEF
   Heap##_i1##_DOMAIN = I1##_DOMAIN -heap

   I1##_DOMAIN        -> Heap##_i1##_DOMAIN

IMPLEMENTATIONS
   Vdmlib             = + err_empty_iterator + genptr
   DOMAIN             = + mk + is_empty + sel + next + del
   Heap##_i1##_DOMAIN =   malloc("INTERNALDOMAIN")
                        + alloc("STRUCT"="struct Struct1" #_DOMAIN)
-----
[ -d $OUT_DIR/iterator/bintree/del ] || mkdir $OUT_DIR/iterator/bintree/del
cat >$OUT_DIR/iterator/bintree/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN) {
   I1##_DOMAIN lx1;
   lx1 = x1.f_free;
   while ( lx1 ) {
      I1##_DOMAIN lx2;
      lx2 = lx1;
      lx1 = lx1->f_free; 
      free_i1##_DOMAIN(lx2);
   }
}
-----
[ -d $OUT_DIR/iterator/bintree/is_empty ] || mkdir $OUT_DIR/iterator/bintree/is_empty
cat >$OUT_DIR/iterator/bintree/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((x1)->f_iter == (x1)->f_free)
-----
[ -d $OUT_DIR/iterator/bintree/mk ] || mkdir $OUT_DIR/iterator/bintree/mk
cat >$OUT_DIR/iterator/bintree/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx1;

    lx1.f_free = alloc_i1##_DOMAIN();
    lx1.f_free->f_nextelem = 0;
    lx1.f_free->f_prev     = 0;
    lx1.f_free->f_free     = 0;
    lx1.f_iter = leftmost##_DOMAIN(lx1.f_free,x1);

    return lx1;
}
-----
[ -d $OUT_DIR/iterator/bintree/next ] || mkdir $OUT_DIR/iterator/bintree/next
cat >$OUT_DIR/iterator/bintree/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    register I1##_DOMAIN lx1;
    if ( is_empty##_DOMAIN(x1) )
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    lx1 = x1->f_iter;
    x1->f_iter = leftmost##_DOMAIN(lx1->f_prev,lx1->f_nextelem->f_right);
}
-----
[ -d $OUT_DIR/iterator/bintree/sel ] || mkdir $OUT_DIR/iterator/bintree/sel
cat >$OUT_DIR/iterator/bintree/sel/ccod <<'-----'
#ifdef ELEM2
#error not yet implemented
#endif

Genptr sel##_DOMAIN _FPH1(DOMAIN *) {
    if ( is_empty##_DOMAIN(x1) )
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    return
        (Genptr)((x1->f_iter->f_nextelem) + 1);
}
-----
[ -d $OUT_DIR/iterator/bitmap ] || mkdir $OUT_DIR/iterator/bitmap
[ -d $OUT_DIR/iterator/bitmap/basic ] || mkdir $OUT_DIR/iterator/bitmap/basic
cat >$OUT_DIR/iterator/bitmap/basic/gtyp <<'-----'
#ifdef GEN_C
#include <set/bitmap/basic/setup>
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_bits,ELEM1);
                      RECFIELD(f_curser,ELEM2);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/bitmap/basic/param <<'-----'
BASESIZE
INTERNALDOMAIN
INTERNALFCT
LB
MACROS
NOELEMS
-----
cat >$OUT_DIR/iterator/bitmap/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
   ELEM1    = + is_in
-----
[ -d $OUT_DIR/iterator/bitmap/is_empty ] || mkdir $OUT_DIR/iterator/bitmap/is_empty
cat >$OUT_DIR/iterator/bitmap/is_empty/cmcr <<'-----'
#include <set/bitmap/basic/defp>
_DEFINE is_empty##_DOMAIN(x1) ((x1)->f_curser == UB)
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB

-----
[ -d $OUT_DIR/iterator/bitmap/mk ] || mkdir $OUT_DIR/iterator/bitmap/mk
cat >$OUT_DIR/iterator/bitmap/mk/ccod <<'-----'
#include <set/bitmap/basic/defp>
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_bits = x1;
    lx.f_curser = LB1;
    while ( lx.f_curser != UB && (! is_in##_ELEM1(lx.f_curser,x1) ) ) {
       lx.f_curser++;
    }
    return lx;
}
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB

-----
[ -d $OUT_DIR/iterator/bitmap/next ] || mkdir $OUT_DIR/iterator/bitmap/next
cat >$OUT_DIR/iterator/bitmap/next/ccod <<'-----'
#include <set/bitmap/basic/defp>
void next##_DOMAIN _FPH1(DOMAIN *) {
    if (x1->f_curser == UB)
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    x1->f_curser++;
    while ( x1->f_curser != UB && (! is_in##_ELEM1(x1->f_curser,x1->f_bits) ) ) {
        x1->f_curser++;
    }
}
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB

-----
[ -d $OUT_DIR/iterator/bitmap/sel ] || mkdir $OUT_DIR/iterator/bitmap/sel
cat >$OUT_DIR/iterator/bitmap/sel/ccod <<'-----'
#include <set/bitmap/basic/defp>

ELEM2 sel##_DOMAIN _FPH1(DOMAIN *) {
    if (x1->f_curser == UB)
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    return
        (ELEM2)(x1->f_curser);
}
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB

-----
[ -d $OUT_DIR/iterator/bitset ] || mkdir $OUT_DIR/iterator/bitset
[ -d $OUT_DIR/iterator/bitset/basic ] || mkdir $OUT_DIR/iterator/bitset/basic
cat >$OUT_DIR/iterator/bitset/basic/gtyp <<'-----'
#ifdef GEN_C
  typedef Nat0 DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/bitset/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/bitset/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/bitset/is_empty ] || mkdir $OUT_DIR/iterator/bitset/is_empty
cat >$OUT_DIR/iterator/bitset/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((*x1) == (Nat0)1)
-----
[ -d $OUT_DIR/iterator/bitset/mk ] || mkdir $OUT_DIR/iterator/bitset/mk
cat >$OUT_DIR/iterator/bitset/mk/cmcr <<'-----'
_DEFINE mk##_DOMAIN(x1) (x1)
-----
[ -d $OUT_DIR/iterator/bitset/next ] || mkdir $OUT_DIR/iterator/bitset/next
cat >$OUT_DIR/iterator/bitset/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if ((*x1) == (Nat0)1)
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    (*x1) >>= 1;
}
-----
[ -d $OUT_DIR/iterator/bitset/sel ] || mkdir $OUT_DIR/iterator/bitset/sel
cat >$OUT_DIR/iterator/bitset/sel/ccod <<'-----'
#ifndef ELEM3
#define selPL _FPH1(DOMAIN *)
#define copyATTR
#else
#error not yet implemented
#define selPL _FPH2(DOMAIN *,ELEM3 *)
#define copyATTR *x2 = x1->f_curser->f_attr;
#endif

ELEM2 sel##_DOMAIN selPL {
    if ((*x1) == (Nat0)1)
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    copyATTR
    return
        (ELEM2)((*x1) & 1);
}

#undef selPL
#undef copyATTR
-----
[ -d $OUT_DIR/iterator/com ] || mkdir $OUT_DIR/iterator/com
[ -d $OUT_DIR/iterator/com/basic ] || mkdir $OUT_DIR/iterator/com/basic
cat >$OUT_DIR/iterator/com/basic/adttype <<'-----'
INTERNAL
-----
cat >$OUT_DIR/iterator/com/basic/docu <<'-----'
Iterator is an internal ADT for implementing
C++ iterators for collection datatypes like sets, map
and bags. It is used only from within the C++ interface.

The forall and fold functions are not supported for the
C++ interface, because this functional programming style
conflicts with the imperative and object oriented
style from C++, and because it is clumsy to deal with
function pointers to member functions.

For each class COLLECTION of a collection datatype there is
an iterator class ITER_COLLECTION with 4 
4 elementary Operations: a constructor for initializing
the iterator variable, a test function for checking whether
there are elements left for processing, the "!" operator
can be used for this operation, a select function "sel"
for selecting the element to be processed, the interface
is simlar to the "SET" select function "sel" and an
increment function for moving to the next element in
the collection. The post increment operator is used for
this operation. Error checking is done, the collection
is comletely processed and "sel" or "++" operation is
performed.

Example: all elements of a set are to be processed 

SET s;

                   // the construtor for initialisation
ITER_SET s1(s);

                   // test whether s1 is not yet processed completely
while ( ! s1 ) {
                   // selection of the current element
    ELEMENT e = s1.sel();
                   // moving to the next element
    s1++;
}

WARNING:

Iterators are not yet supported for all implementations.
-----
[ -d $OUT_DIR/iterator/dir ] || mkdir $OUT_DIR/iterator/dir
[ -d $OUT_DIR/iterator/dir/basic ] || mkdir $OUT_DIR/iterator/dir/basic
cat >$OUT_DIR/iterator/dir/basic/gtyp <<'-----'
TYPE_DEF(DOMAIN,Iter_r1##_ELEM1)

-----
cat >$OUT_DIR/iterator/dir/basic/param <<'-----'
INTERNALDOMAIN
MACROS
-----
cat >$OUT_DIR/iterator/dir/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Iter_r1##_ELEM1
IMPLEMENTATIONS
  DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/dir/is_empty ] || mkdir $OUT_DIR/iterator/dir/is_empty
cat >$OUT_DIR/iterator/dir/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_iter_r1##_ELEM1(x1)
-----
[ -d $OUT_DIR/iterator/dir/mk ] || mkdir $OUT_DIR/iterator/dir/mk
cat >$OUT_DIR/iterator/dir/mk/cmcr <<'-----'
_DEFINE mk##_DOMAIN(x1) mk_iter_r1##_ELEM1(x1)
-----
[ -d $OUT_DIR/iterator/dir/next ] || mkdir $OUT_DIR/iterator/dir/next
cat >$OUT_DIR/iterator/dir/next/cmcr <<'-----'
_DEFINE next##_DOMAIN(x1) next_iter_r1##_ELEM1(x1)
-----
[ -d $OUT_DIR/iterator/dir/sel ] || mkdir $OUT_DIR/iterator/dir/sel
cat >$OUT_DIR/iterator/dir/sel/ccod <<'-----'
ELEM2 sel##_DOMAIN _FPH2(DOMAIN *,ELEM3 *) {
    R2##_ELEM1 lx2;
    ELEM2 r = sel_iter_r1##_ELEM1(x1,&lx2);
    *x2 = checkread##_ELEM1(lx2);
    return r;
}
-----
[ -d $OUT_DIR/iterator/genbt ] || mkdir $OUT_DIR/iterator/genbt
[ -d $OUT_DIR/iterator/genbt/basic ] || mkdir $OUT_DIR/iterator/genbt/basic
cat >$OUT_DIR/iterator/genbt/basic/gtyp <<'-----'
#ifdef GEN_C
#include <map/genbt/basic/defp>

  typedef Iter##_GENBT DOMAIN;

#include <map/genbt/basic/undefp>
#endif
-----
cat >$OUT_DIR/iterator/genbt/basic/param <<'-----'
AVLTREE
INTERNALDOMAIN
INTERNALFCT
MACROS
NORMAL
-----
cat >$OUT_DIR/iterator/genbt/basic/vdm <<'-----'
#include <map/genbt/basic/defp>

DOMAINS
   DOMAIN  -> Iter##_GENBT
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator + genptr
   DOMAIN   = + mk + is_empty + sel + next + del
   GENBT    = + iterator

#include <map/genbt/basic/undefp>
-----
[ -d $OUT_DIR/iterator/genbt/del ] || mkdir $OUT_DIR/iterator/genbt/del
cat >$OUT_DIR/iterator/genbt/del/cmcr <<'-----'
#include <map/genbt/basic/defp>

_DEFINE del##_DOMAIN(x1) del_iter##_GENBT(x1)

#include <map/genbt/basic/undefp>
-----
[ -d $OUT_DIR/iterator/genbt/is_empty ] || mkdir $OUT_DIR/iterator/genbt/is_empty
cat >$OUT_DIR/iterator/genbt/is_empty/cmcr <<'-----'
#include <map/genbt/basic/defp>

_DEFINE is_empty##_DOMAIN(x1) is_empty_iter##_GENBT(x1)

#include <map/genbt/basic/undefp>
-----
[ -d $OUT_DIR/iterator/genbt/mk ] || mkdir $OUT_DIR/iterator/genbt/mk
cat >$OUT_DIR/iterator/genbt/mk/cmcr <<'-----'
#include <map/genbt/basic/defp>

_DEFINE mk##_DOMAIN(x1) mk_iter##_GENBT(x1)

#include <map/genbt/basic/undefp>
-----
[ -d $OUT_DIR/iterator/genbt/next ] || mkdir $OUT_DIR/iterator/genbt/next
cat >$OUT_DIR/iterator/genbt/next/cmcr <<'-----'
#include <map/genbt/basic/defp>

/* error checking is done in genbt */

_DEFINE next##_DOMAIN(x1) next_iter##_GENBT(x1)

#include <map/genbt/basic/undefp>
-----
[ -d $OUT_DIR/iterator/genbt/sel ] || mkdir $OUT_DIR/iterator/genbt/sel
cat >$OUT_DIR/iterator/genbt/sel/ccod <<'-----'
#ifndef ELEM3
#error not yet implemented
#endif

#include <map/genbt/basic/defp>

ELEM2 sel##_DOMAIN _FPH2(DOMAIN *,ELEM3 *) {
    H1##_ELEM1 lx1;
    lx1 = (H1##_ELEM1)sel_iter##_GENBT(x1);
    *x2 = lx1->f_attr;
    return
        lx1->f_info;
}

#include <map/genbt/basic/undefp>
-----
[ -d $OUT_DIR/iterator/hashlist ] || mkdir $OUT_DIR/iterator/hashlist
[ -d $OUT_DIR/iterator/hashlist/basic ] || mkdir $OUT_DIR/iterator/hashlist/basic
cat >$OUT_DIR/iterator/hashlist/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_iter1,Iter_tupl##_ELEM1);
                      RECFIELD(f_iter2,Iter_aux##_ELEM1);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/hashlist/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/hashlist/basic/vdm <<'-----'
DOMAINS
   DOMAIN  -> Iter_tupl##_ELEM1
   DOMAIN  -> Iter_aux##_ELEM1
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/hashlist/del ] || mkdir $OUT_DIR/iterator/hashlist/del
cat >$OUT_DIR/iterator/hashlist/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1) del_iter_tupl##_ELEM1((x1).f_iter1)
-----
[ -d $OUT_DIR/iterator/hashlist/is_empty ] || mkdir $OUT_DIR/iterator/hashlist/is_empty
cat >$OUT_DIR/iterator/hashlist/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_iter_tupl##_ELEM1(&((x1)->f_iter1))
-----
[ -d $OUT_DIR/iterator/hashlist/mk ] || mkdir $OUT_DIR/iterator/hashlist/mk
cat >$OUT_DIR/iterator/hashlist/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_iter1 = mk_iter_tupl##_ELEM1(x1);

    while ( ! is_empty_iter_tupl##_ELEM1(&(lx.f_iter1)) ) {
        lx.f_iter2 = mk_iter_aux##_ELEM1(sel_iter_tupl##_ELEM1(&(lx.f_iter1)));
        if ( ! is_empty_iter_aux##_ELEM1(&(lx.f_iter2)) )
            break;
        del_iter_aux##_ELEM1(lx.f_iter2);
        next_iter_tupl##_ELEM1(&(lx.f_iter1));
    }

    return lx;
}
-----
[ -d $OUT_DIR/iterator/hashlist/next ] || mkdir $OUT_DIR/iterator/hashlist/next
cat >$OUT_DIR/iterator/hashlist/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if ( is_empty_iter_tupl##_ELEM1(&(x1->f_iter1)) )
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));

    next_iter_aux##_ELEM1(&(x1->f_iter2));

    while ( is_empty_iter_aux##_ELEM1(&(x1->f_iter2)) ) {
        del_iter_aux##_ELEM1(x1->f_iter2);
        next_iter_tupl##_ELEM1(&(x1->f_iter1));
        if ( is_empty_iter_tupl##_ELEM1(&(x1->f_iter1)) )
            break;
        x1->f_iter2 = mk_iter_aux##_ELEM1(sel_iter_tupl##_ELEM1(&(x1->f_iter1)));
    }
}
-----
[ -d $OUT_DIR/iterator/hashlist/sel ] || mkdir $OUT_DIR/iterator/hashlist/sel
cat >$OUT_DIR/iterator/hashlist/sel/ccod <<'-----'
#ifndef ELEM3
#define selPL _FPH1(DOMAIN *)
#define copyATTR
#else
#define selPL _FPH2(DOMAIN *,ELEM3 *)
#define copyATTR , x2
#endif


ELEM2 sel##_DOMAIN selPL {
    if ( is_empty_iter_tupl##_ELEM1(&(x1->f_iter1)) )
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    return
        sel_iter_aux##_ELEM1(&(x1->f_iter2) copyATTR);
}

#undef selPL
#undef copyATTR
-----
[ -d $OUT_DIR/iterator/hashtab ] || mkdir $OUT_DIR/iterator/hashtab
[ -d $OUT_DIR/iterator/hashtab/basic ] || mkdir $OUT_DIR/iterator/hashtab/basic
cat >$OUT_DIR/iterator/hashtab/basic/ccod <<'-----'

-----
cat >$OUT_DIR/iterator/hashtab/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_arraycurser,H1##_ELEM1);
                      RECFIELD(f_listcurser ,H1##_ELEM1);
                      RECFIELD(f_end        ,H1##_ELEM1);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/hashtab/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/hashtab/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/hashtab/is_empty ] || mkdir $OUT_DIR/iterator/hashtab/is_empty
cat >$OUT_DIR/iterator/hashtab/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((x1)->f_arraycurser == (x1)->f_end)
-----
[ -d $OUT_DIR/iterator/hashtab/mk ] || mkdir $OUT_DIR/iterator/hashtab/mk
cat >$OUT_DIR/iterator/hashtab/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_arraycurser = (H1##_ELEM1)(x1+1);
    lx.f_end         = lx.f_arraycurser + x1->f_len;

    while ( ( lx.f_arraycurser != lx.f_end )
         && ( lx.f_arraycurser->f_next == & _tmp_free##_ELEM1 )
          ) lx.f_arraycurser++;
    lx.f_listcurser  = lx.f_arraycurser;

    return lx;
}
-----
[ -d $OUT_DIR/iterator/hashtab/next ] || mkdir $OUT_DIR/iterator/hashtab/next
cat >$OUT_DIR/iterator/hashtab/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if ( is_empty##_DOMAIN(x1) )
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    x1->f_listcurser = x1->f_listcurser->f_next;
    if ( x1->f_listcurser == 0 ) {
       x1->f_arraycurser++;
       while ( ( x1->f_arraycurser != x1->f_end )
            && ( x1->f_arraycurser->f_next == & _tmp_free##_ELEM1 )
             ) x1->f_arraycurser++;
       x1->f_listcurser = x1->f_arraycurser;
    }
}
-----
[ -d $OUT_DIR/iterator/hashtab/sel ] || mkdir $OUT_DIR/iterator/hashtab/sel
cat >$OUT_DIR/iterator/hashtab/sel/ccod <<'-----'
#ifndef ELEM3
#error not yet implemented
#endif

ELEM2 sel##_DOMAIN _FPH2(DOMAIN *,ELEM3 *) {
    if ( is_empty##_DOMAIN(x1) )
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    *x2 = x1->f_listcurser->f_attr; 
    return
        x1->f_listcurser->f_info;
}
-----
[ -d $OUT_DIR/iterator/heapmap ] || mkdir $OUT_DIR/iterator/heapmap
[ -d $OUT_DIR/iterator/heapmap/basic ] || mkdir $OUT_DIR/iterator/heapmap/basic
cat >$OUT_DIR/iterator/heapmap/basic/gtyp <<'-----'
#ifdef GEN_C
  typedef Iter_##h1##_ELEM1 DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/heapmap/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/heapmap/basic/vdm <<'-----'
DOMAINS
   DOMAIN  -> Iter_##h1##_ELEM1
IMPLEMENTATIONS
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/heapmap/is_empty ] || mkdir $OUT_DIR/iterator/heapmap/is_empty
cat >$OUT_DIR/iterator/heapmap/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_iter_##h1##_ELEM1(x1)
-----
[ -d $OUT_DIR/iterator/heapmap/mk ] || mkdir $OUT_DIR/iterator/heapmap/mk
cat >$OUT_DIR/iterator/heapmap/mk/cmcr <<'-----'
_DEFINE mk##_DOMAIN(x1) mk_iter_##h1##_ELEM1(x1)
-----
[ -d $OUT_DIR/iterator/heapmap/next ] || mkdir $OUT_DIR/iterator/heapmap/next
cat >$OUT_DIR/iterator/heapmap/next/cmcr <<'-----'
_DEFINE next##_DOMAIN(x1) next_iter_##h1##_ELEM1(x1)
-----
[ -d $OUT_DIR/iterator/heapmap/sel ] || mkdir $OUT_DIR/iterator/heapmap/sel
cat >$OUT_DIR/iterator/heapmap/sel/ccod <<'-----'
#ifndef ELEM3
#error not implemented
#endif

ELEM2 sel##_DOMAIN _FPH2(DOMAIN *,ELEM3 *) {
    ELEM2 lx;
    lx = sel_iter_##h1##_ELEM1(x1);
    *x2 = cont##_ELEM2(lx);
    return lx;
}
-----
[ -d $OUT_DIR/iterator/larray ] || mkdir $OUT_DIR/iterator/larray
[ -d $OUT_DIR/iterator/larray/basic ] || mkdir $OUT_DIR/iterator/larray/basic
cat >$OUT_DIR/iterator/larray/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_larray,ELEM1);
                      RECFIELD(f_curser,Nat0);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/larray/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/larray/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/larray/is_empty ] || mkdir $OUT_DIR/iterator/larray/is_empty
cat >$OUT_DIR/iterator/larray/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((x1)->f_curser == (x1)->f_larray->f_len)
-----
[ -d $OUT_DIR/iterator/larray/mk ] || mkdir $OUT_DIR/iterator/larray/mk
cat >$OUT_DIR/iterator/larray/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_larray = x1;
    lx.f_curser = 0;
    return lx;
}
-----
[ -d $OUT_DIR/iterator/larray/next ] || mkdir $OUT_DIR/iterator/larray/next
cat >$OUT_DIR/iterator/larray/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if (x1->f_curser == x1->f_larray->f_len)
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    x1->f_curser++;
}
-----
[ -d $OUT_DIR/iterator/larray/sel ] || mkdir $OUT_DIR/iterator/larray/sel
cat >$OUT_DIR/iterator/larray/sel/ccod <<'-----'
#ifndef ELEM3
#define selPL _FPH1(DOMAIN *)
#define copyATTR
#else
#error not yet implemented
#define selPL _FPH2(DOMAIN *,ELEM3 *)
#define copyATTR *x2 = x1->f_curser->f_attr;
#endif

ELEM2 sel##_DOMAIN selPL {
    if (x1->f_curser == x1->f_larray->f_len)
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    copyATTR
    return
        *(((ELEM2 *)(x1->f_larray +1)) + (x1->f_curser + x1->f_larray->f_offs));
}

#undef selPL
#undef copyATTR
-----
[ -d $OUT_DIR/iterator/linklist ] || mkdir $OUT_DIR/iterator/linklist
[ -d $OUT_DIR/iterator/linklist/basic ] || mkdir $OUT_DIR/iterator/linklist/basic
cat >$OUT_DIR/iterator/linklist/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_list,ELEM1);
                      RECFIELD(f_curser,ELEM1);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/linklist/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/linklist/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/linklist/is_empty ] || mkdir $OUT_DIR/iterator/linklist/is_empty
cat >$OUT_DIR/iterator/linklist/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (! (x1)->f_curser)
-----
[ -d $OUT_DIR/iterator/linklist/mk ] || mkdir $OUT_DIR/iterator/linklist/mk
cat >$OUT_DIR/iterator/linklist/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_curser = x1;
    lx.f_list   = x1;
    return lx;
}
-----
[ -d $OUT_DIR/iterator/linklist/next ] || mkdir $OUT_DIR/iterator/linklist/next
cat >$OUT_DIR/iterator/linklist/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if (! x1->f_curser)
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    x1->f_curser = x1->f_curser->f_next;
}
-----
[ -d $OUT_DIR/iterator/linklist/sel ] || mkdir $OUT_DIR/iterator/linklist/sel
cat >$OUT_DIR/iterator/linklist/sel/ccod <<'-----'
#ifndef ELEM3
#define selPL _FPH1(DOMAIN *)
#define copyATTR
#else
#define selPL _FPH2(DOMAIN *,ELEM3 *)
#define copyATTR *x2 = x1->f_curser->f_attr;
#endif

ELEM2 sel##_DOMAIN selPL {
    if (! x1->f_curser)
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    copyATTR
    return
        x1->f_curser->f_info;
}

#undef selPL
#undef copyATTR
-----
[ -d $OUT_DIR/iterator/mapdom ] || mkdir $OUT_DIR/iterator/mapdom
[ -d $OUT_DIR/iterator/mapdom/basic ] || mkdir $OUT_DIR/iterator/mapdom/basic
cat >$OUT_DIR/iterator/mapdom/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_iter,Iter_map##_ELEM1);
                      RECFIELD(f_info,ELEM2);
                      RECFIELD(f_attr,Nat1);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/mapdom/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
MACROS
-----
cat >$OUT_DIR/iterator/mapdom/basic/vdm <<'-----'
DOMAINS
   DOMAIN  -> Iter_map##_ELEM1
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
-----
[ -d $OUT_DIR/iterator/mapdom/del ] || mkdir $OUT_DIR/iterator/mapdom/del
cat >$OUT_DIR/iterator/mapdom/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1)
-----
[ -d $OUT_DIR/iterator/mapdom/is_empty ] || mkdir $OUT_DIR/iterator/mapdom/is_empty
cat >$OUT_DIR/iterator/mapdom/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_iter_map##_ELEM1(&((x1)->f_iter))
-----
[ -d $OUT_DIR/iterator/mapdom/mk ] || mkdir $OUT_DIR/iterator/mapdom/mk
cat >$OUT_DIR/iterator/mapdom/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_iter = mk_iter_map##_ELEM1(x1);
    if ( ! is_empty_iter_map##_ELEM1(&(lx.f_iter)) ) {
        lx.f_info = sel_iter_map##_ELEM1(&(lx.f_iter),&(lx.f_attr));
    }
    return lx;
}
-----
[ -d $OUT_DIR/iterator/mapdom/next ] || mkdir $OUT_DIR/iterator/mapdom/next
cat >$OUT_DIR/iterator/mapdom/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if ( is_empty_iter_map##_ELEM1(&(x1->f_iter)) )
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    if ( x1->f_attr == 1) {
        next_iter_map##_ELEM1(&(x1->f_iter));
	if ( ! is_empty_iter_map##_ELEM1(&(x1->f_iter)) ) {
            x1->f_info = sel_iter_map##_ELEM1(&(x1->f_iter),&(x1->f_attr));
        }
    } else {
        x1->f_attr--;
    }
}
-----
[ -d $OUT_DIR/iterator/mapdom/sel ] || mkdir $OUT_DIR/iterator/mapdom/sel
cat >$OUT_DIR/iterator/mapdom/sel/ccod <<'-----'
#ifdef ELEM3
#error not yet implemented
#endif

ELEM2 sel##_DOMAIN _FPH1(DOMAIN *) {
    if ( is_empty_iter_map##_ELEM1(&(x1->f_iter)) )
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    return
        x1->f_info;
}

-----
[ -d $OUT_DIR/iterator/scaldom ] || mkdir $OUT_DIR/iterator/scaldom
[ -d $OUT_DIR/iterator/scaldom/basic ] || mkdir $OUT_DIR/iterator/scaldom/basic
cat >$OUT_DIR/iterator/scaldom/basic/gtyp <<'-----'
#ifdef GEN_C
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_iter,Iter_tupl##_ELEM1);
                      RECFIELD(f_curser,Nat0);
  END_RECORD_TYP(Struct##_DOMAIN) 

  typedef struct Struct##_DOMAIN DOMAIN;
#endif
-----
cat >$OUT_DIR/iterator/scaldom/basic/param <<'-----'
INTERNALDOMAIN
INTERNALFCT
LOWB
MACROS
-----
cat >$OUT_DIR/iterator/scaldom/basic/vdm <<'-----'
DOMAINS
   DOMAIN  -> Iter_tupl##_ELEM1
IMPLEMENTATIONS
   Vdmlib   = + err_empty_iterator
   DOMAIN   = + mk + is_empty + sel + next + del
   Tupl##_ELEM1 = + sel
   Opti##_ELEM1 = + s + is_nil
-----
[ -d $OUT_DIR/iterator/scaldom/is_empty ] || mkdir $OUT_DIR/iterator/scaldom/is_empty
cat >$OUT_DIR/iterator/scaldom/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_iter_tupl##_ELEM1(&((x1)->f_iter))
-----
[ -d $OUT_DIR/iterator/scaldom/mk ] || mkdir $OUT_DIR/iterator/scaldom/mk
cat >$OUT_DIR/iterator/scaldom/mk/ccod <<'-----'
DOMAIN mk##_DOMAIN _FPH1(ELEM1) {
    DOMAIN lx;
    lx.f_iter = mk_iter_tupl##_ELEM1(x1);
    lx.f_curser  = 0;
    while ( ! is_empty_iter_tupl##_ELEM1(&(lx.f_iter)) ) {
        if ( ! is_nil_opti##_ELEM1(sel_iter_tupl##_ELEM1(&(lx.f_iter))) )
           break;
        next_iter_tupl##_ELEM1(&(lx.f_iter));
        lx.f_curser++;
    }
    return lx;
}
-----
[ -d $OUT_DIR/iterator/scaldom/next ] || mkdir $OUT_DIR/iterator/scaldom/next
cat >$OUT_DIR/iterator/scaldom/next/ccod <<'-----'
void next##_DOMAIN _FPH1(DOMAIN *) {
    if ( is_empty_iter_tupl##_ELEM1(&(x1->f_iter)) )
        err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    do {
       next_iter_tupl##_ELEM1(&(x1->f_iter));
       x1->f_curser++;
    } while ( ! is_empty_iter_tupl##_ELEM1(&(x1->f_iter)) 
             && is_nil_opti##_ELEM1(sel_iter_tupl##_ELEM1(&(x1->f_iter)))
            );
}
-----
[ -d $OUT_DIR/iterator/scaldom/sel ] || mkdir $OUT_DIR/iterator/scaldom/sel
cat >$OUT_DIR/iterator/scaldom/sel/ccod <<'-----'
#ifndef ELEM3
#error not yet implemented
#endif

ELEM2 sel##_DOMAIN _FPH2(DOMAIN *,ELEM3 *) {
    if ( is_empty_iter_tupl##_ELEM1(&(x1->f_iter)) )
         err_empty_iterator_vdmlib(MKSTRING(DOMAIN));
    *x2 = s##_ELEM3##_opti##_ELEM1(sel_iter_tupl##_ELEM1(&(x1->f_iter)));
    return
        (ELEM2)(x1->f_curser + LOWB);
}

-----
[ -d $OUT_DIR/iterator/sign ] || mkdir $OUT_DIR/iterator/sign
[ -d $OUT_DIR/iterator/sign/basic ] || mkdir $OUT_DIR/iterator/sign/basic
cat >$OUT_DIR/iterator/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
public:
  DOMAIN data;
  ~Cpp_DOMAIN() { del##_DOMAIN(data); }
#else
#endif
-----
cat >$OUT_DIR/iterator/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
cat >$OUT_DIR/iterator/sign/basic/gsig <<'-----'

#ifdef GEN_C

#ifndef ELEM3
_DEFINE FOR##_DOMAIN(x1,x2) { DOMAIN x2\#\#_it = mk##_DOMAIN(x1); while (!is_empty##_DOMAIN(& x2\#\#_it)) { ELEM2 x2 = sel##_DOMAIN(& x2\#\#_it);
#else
_DEFINE FOR##_DOMAIN(x1,x2) { DOMAIN x2\#\#_it = mk##_DOMAIN(x1); while (!is_empty##_DOMAIN(& x2\#\#_it)) { ELEM3 x2\#\#_e; ELEM2 x2 = sel##_DOMAIN(& x2\#\#_it,&x2\#\#_e);
#endif
_DEFINE ENDFOR##_DOMAIN(x2) next##_DOMAIN(& x2\#\#_it); } del##_DOMAIN(x2\#\#_it); }

#else
#error DOMAIN: iterator functions supportd for C only!!!
#endif

-----
[ -d $OUT_DIR/iterator/sign/is_empty ] || mkdir $OUT_DIR/iterator/sign/is_empty
cat >$OUT_DIR/iterator/sign/is_empty/cpp <<'-----'
InlineFriendFct(is_empty,FPAR1(const Cpp_DOMAIN &),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_empty,FPARLIST1a))

#ifdef OPERATOR
InlineFriendFct(operator !,FPAR1(const Cpp_DOMAIN &),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,! is_empty,FPARLIST1a))
#endif
-----
cat >$OUT_DIR/iterator/sign/is_empty/gsig <<'-----'
 FUNCDEC(is_empty##_DOMAIN,PL_1(DOMAIN *),Bool)
-----
[ -d $OUT_DIR/iterator/sign/mk ] || mkdir $OUT_DIR/iterator/sign/mk
cat >$OUT_DIR/iterator/sign/mk/cpp <<'-----'
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(Cpp_ELEM1),)
RUMPF(BODY4(mk,KPARLIST1))
-----
cat >$OUT_DIR/iterator/sign/mk/gsig <<'-----'
 FUNCDEC(mk##_DOMAIN,PL_1(ELEM1),DOMAIN)
-----
[ -d $OUT_DIR/iterator/sign/next ] || mkdir $OUT_DIR/iterator/sign/next
cat >$OUT_DIR/iterator/sign/next/cpp <<'-----'
InlineFriendFct(next,FPAR1(Cpp_DOMAIN &),void)
RUMPF(BODY3(next,FPARLIST1a))

#ifdef OPERATOR
InlineNoFriendFct(operator ++,FPAR1(Cpp_DOMAIN &),void)
RUMPF(BODY3(next,FPARLIST1a))

InlineNoFriendFct(operator ++,FPAR2a(Cpp_DOMAIN &,int),void)
RUMPF(BODY3(next,FPARLIST1a))
#endif
-----
cat >$OUT_DIR/iterator/sign/next/gsig <<'-----'
 PROCDEC(next##_DOMAIN,PL_1(DOMAIN *))
-----
[ -d $OUT_DIR/iterator/sign/sel ] || mkdir $OUT_DIR/iterator/sign/sel
cat >$OUT_DIR/iterator/sign/sel/cpp <<'-----'
#ifndef ELEM3
InlineFriendFct(sel,FPAR1(const Cpp_DOMAIN &),Cpp_ELEM2)
RUMPF(BODY1(Cpp_ELEM2,sel,FPARLIST1a))
#else
InlineFriendFct(sel,FPAR2(const Cpp_DOMAIN &,Cpp_ELEM3 &),Cpp_ELEM2)
#ifdef BASEIMPL
RUMPF({ELEM3 lx3; \
       ELEM2 lx2; \
       del##_ELEM3(x2.data); \
       lx2 = sel##_DOMAIN(&DATA,&lx3); \
       x2.data = copy##_ELEM3(lx3); \
       return lx2; \
      })
#else
RUMPF(BODY1(Cpp_ELEM2,sel,(&DATA,&(x2.data))))
#endif
#endif
-----
cat >$OUT_DIR/iterator/sign/sel/gsig <<'-----'
#ifndef ELEM2
 FUNCDEC(sel##_DOMAIN,PL_1(DOMAIN *),Genptr)
#else
#ifndef ELEM3
 FUNCDEC(sel##_DOMAIN,PL_1(DOMAIN *),ELEM2)
#else
 FUNCDEC(sel##_DOMAIN,PL_2(DOMAIN *,ELEM3 *),ELEM2)
#endif
#endif
-----
[ -d $OUT_DIR/map ] || mkdir $OUT_DIR/map
[ -d $OUT_DIR/map/automem ] || mkdir $OUT_DIR/map/automem
[ -d $OUT_DIR/map/automem/all ] || mkdir $OUT_DIR/map/automem/all
cat >$OUT_DIR/map/automem/all/vdm <<'-----'
! === automem: Operation map/all not supported === !
-----
[ -d $OUT_DIR/map/automem/basic ] || mkdir $OUT_DIR/map/automem/basic
cat >$OUT_DIR/map/automem/basic/ccod <<'-----'
#include <aux/automem/basic/ccod>
-----
cat >$OUT_DIR/map/automem/basic/docu <<'-----'
#define TYPGEN map
#define MAP
#include <aux/automem/basic/docu>
-----
cat >$OUT_DIR/map/automem/basic/gptr <<'-----'
#include <aux/automem/basic/gptr>
-----
cat >$OUT_DIR/map/automem/basic/gtyp <<'-----'
#include <aux/automem/basic/gtyp>
-----
cat >$OUT_DIR/map/automem/basic/param <<'-----'
BASEIMPL
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
NOCHECK
-----
cat >$OUT_DIR/map/automem/basic/vdm <<'-----'
#define REP_DOMAIN  ELEM1 -m-> ELEM2
#include <aux/automem/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/automem/card ] || mkdir $OUT_DIR/map/automem/card
cat >$OUT_DIR/map/automem/card/ccod <<'-----'
#define NAME   card
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/card/cmcr <<'-----'
#define NAME  card
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/map/automem/card/vdm <<'-----'
#define NAME card
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/copy ] || mkdir $OUT_DIR/map/automem/copy
cat >$OUT_DIR/map/automem/copy/ccod <<'-----'
#include <aux/automem/copy/ccod>
-----
[ -d $OUT_DIR/map/automem/copy1 ] || mkdir $OUT_DIR/map/automem/copy1
cat >$OUT_DIR/map/automem/copy1/vdm <<'-----'
! === automem: Operation map/copy1 not supported === !
-----
[ -d $OUT_DIR/map/automem/cvfromtup1 ] || mkdir $OUT_DIR/map/automem/cvfromtup1
cat >$OUT_DIR/map/automem/cvfromtup1/ccod <<'-----'
#include <aux/automem/cvfromtup1/ccod>
-----
cat >$OUT_DIR/map/automem/cvfromtup1/param <<'-----'
#include <aux/automem/cvfromtup1/param>
-----
cat >$OUT_DIR/map/automem/cvfromtup1/vdm <<'-----'
#include <aux/automem/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/map/automem/cvfromtupl ] || mkdir $OUT_DIR/map/automem/cvfromtupl
cat >$OUT_DIR/map/automem/cvfromtupl/ccod <<'-----'
#include <aux/automem/cvfromtupl/ccod>
-----
cat >$OUT_DIR/map/automem/cvfromtupl/param <<'-----'
#include <aux/automem/cvfromtupl/param>
-----
cat >$OUT_DIR/map/automem/cvfromtupl/vdm <<'-----'
#include <aux/automem/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/map/automem/cvlines ] || mkdir $OUT_DIR/map/automem/cvlines
cat >$OUT_DIR/map/automem/cvlines/ccod <<'-----'
#define NAME cvlines
#define RESULT Cvtext_vdmlib
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/cvlines/cmcr <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/map/automem/cvlines/vdm <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/cvtotup1 ] || mkdir $OUT_DIR/map/automem/cvtotup1
cat >$OUT_DIR/map/automem/cvtotup1/ccod <<'-----'
#include <aux/automem/cvtotup1/ccod>
-----
cat >$OUT_DIR/map/automem/cvtotup1/param <<'-----'
#include <aux/automem/cvtotup1/param>
-----
cat >$OUT_DIR/map/automem/cvtotup1/vdm <<'-----'
#include <aux/automem/cvtotup1/vdm>
-----
[ -d $OUT_DIR/map/automem/cvtotupl ] || mkdir $OUT_DIR/map/automem/cvtotupl
cat >$OUT_DIR/map/automem/cvtotupl/ccod <<'-----'
#include <aux/automem/cvtotupl/ccod>
-----
cat >$OUT_DIR/map/automem/cvtotupl/param <<'-----'
#include <aux/automem/cvtotupl/param>
-----
cat >$OUT_DIR/map/automem/cvtotupl/vdm <<'-----'
#include <aux/automem/cvtotupl/vdm>
-----
[ -d $OUT_DIR/map/automem/del ] || mkdir $OUT_DIR/map/automem/del
cat >$OUT_DIR/map/automem/del/ccod <<'-----'
#include <aux/automem/del/ccod>
-----
cat >$OUT_DIR/map/automem/del/vdm <<'-----'
#include <aux/automem/del/vdm>
-----
[ -d $OUT_DIR/map/automem/del1 ] || mkdir $OUT_DIR/map/automem/del1
cat >$OUT_DIR/map/automem/del1/vdm <<'-----'
! === automem: Operation map/del1 not required === !
-----
[ -d $OUT_DIR/map/automem/dom ] || mkdir $OUT_DIR/map/automem/dom
cat >$OUT_DIR/map/automem/dom/ccod <<'-----'
#define NAME dom
#include <aux/automem/structselector/ccod>
-----
cat >$OUT_DIR/map/automem/dom/param <<'-----'
RESULT
COPY
-----
cat >$OUT_DIR/map/automem/dom/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + dom("RESULT"=Rep##_RESULT,"COPY")
-----
[ -d $OUT_DIR/map/automem/exist ] || mkdir $OUT_DIR/map/automem/exist
cat >$OUT_DIR/map/automem/exist/vdm <<'-----'
! === automem: Operation map/exist not supported === !
-----
[ -d $OUT_DIR/map/automem/exist1 ] || mkdir $OUT_DIR/map/automem/exist1
cat >$OUT_DIR/map/automem/exist1/vdm <<'-----'
! === automem: Operation map/exist1 not supported === !
-----
[ -d $OUT_DIR/map/automem/ext ] || mkdir $OUT_DIR/map/automem/ext
cat >$OUT_DIR/map/automem/ext/ccod <<'-----'
ELEM1 ext##_DOMAIN _FPH2(DOMAIN *, ELEM2)
{
   check_handle##_DOMAIN(*x1);
   cond_clone(x1);
   return ext_rep##_DOMAIN(&(x1->f_rep),x2);
}
-----
cat >$OUT_DIR/map/automem/ext/vdm <<'-----'
DOMAIN
IMPLEMENTATION
   Rep##_DOMAIN = + ext
-----
[ -d $OUT_DIR/map/automem/fold ] || mkdir $OUT_DIR/map/automem/fold
cat >$OUT_DIR/map/automem/fold/vdm <<'-----'
! === automem: Operation map/fold not supported === !
-----
[ -d $OUT_DIR/map/automem/forall ] || mkdir $OUT_DIR/map/automem/forall
cat >$OUT_DIR/map/automem/forall/ccod <<'-----'
#include <aux/automem/forall/ccod>
-----
cat >$OUT_DIR/map/automem/forall/cmcr <<'-----'
#include <aux/automem/forall/cmcr>
-----
cat >$OUT_DIR/map/automem/forall/vdm <<'-----'
#include <aux/automem/forall/vdm>
-----
[ -d $OUT_DIR/map/automem/forrange ] || mkdir $OUT_DIR/map/automem/forrange
cat >$OUT_DIR/map/automem/forrange/vdm <<'-----'
! === automem: Operation map/forrange not supported === !
-----
[ -d $OUT_DIR/map/automem/forsome ] || mkdir $OUT_DIR/map/automem/forsome
cat >$OUT_DIR/map/automem/forsome/vdm <<'-----'
! === automem: Operation map/forsome not supported === !
-----
[ -d $OUT_DIR/map/automem/fread ] || mkdir $OUT_DIR/map/automem/fread
cat >$OUT_DIR/map/automem/fread/ccod <<'-----'
#define NAME   fread
#define PTYPE1 Str
#include <aux/automem/mk_special/ccod>
-----
cat >$OUT_DIR/map/automem/fread/vdm <<'-----'
#define REP_NAME fread
#include <aux/automem/mk_special/vdm>
-----
[ -d $OUT_DIR/map/automem/fwrite ] || mkdir $OUT_DIR/map/automem/fwrite
cat >$OUT_DIR/map/automem/fwrite/ccod <<'-----'
#define NAME   fwrite
#define PTYPE1 DOMAIN
#define PTYPE2 Str
#define P2_IS_ELEM
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/fwrite/vdm <<'-----'
#define NAME fwrite
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/gcinfo ] || mkdir $OUT_DIR/map/automem/gcinfo
cat >$OUT_DIR/map/automem/gcinfo/ccod <<'-----'
#include <aux/automem/gcinfo/ccod>
-----
cat >$OUT_DIR/map/automem/gcinfo/docu <<'-----'
#include <aux/automem/gcinfo/docu>
-----
cat >$OUT_DIR/map/automem/gcinfo/vdm <<'-----'
#include <aux/automem/gcinfo/vdm>
-----
[ -d $OUT_DIR/map/automem/hash ] || mkdir $OUT_DIR/map/automem/hash
cat >$OUT_DIR/map/automem/hash/ccod <<'-----'
#define NAME hash
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/hash/cmcr <<'-----'
#define NAME hash
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/map/automem/hash/vdm <<'-----'
#define NAME hash
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/input ] || mkdir $OUT_DIR/map/automem/input
cat >$OUT_DIR/map/automem/input/vdm <<'-----'
! === automem: Operation map/input not supported === !
-----
[ -d $OUT_DIR/map/automem/inters ] || mkdir $OUT_DIR/map/automem/inters
cat >$OUT_DIR/map/automem/inters/ccod <<'-----'
#define NAME inters
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/map/automem/inters/vdm <<'-----'
#define NAME inters
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/map/automem/intersd ] || mkdir $OUT_DIR/map/automem/intersd
cat >$OUT_DIR/map/automem/intersd/vdm <<'-----'
! === automem: Operation map/intersd not supported === !
-----
[ -d $OUT_DIR/map/automem/is_empty ] || mkdir $OUT_DIR/map/automem/is_empty
cat >$OUT_DIR/map/automem/is_empty/ccod <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/is_empty/cmcr <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/map/automem/is_empty/vdm <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/is_eq ] || mkdir $OUT_DIR/map/automem/is_eq
cat >$OUT_DIR/map/automem/is_eq/ccod <<'-----'
#define NAME is_eq
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/is_eq/cmcr <<'-----'
#define NAME is_eq
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/map/automem/is_eq/vdm <<'-----'
#define NAME is_eq
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/is_ge ] || mkdir $OUT_DIR/map/automem/is_ge
cat >$OUT_DIR/map/automem/is_ge/vdm <<'-----'
! === automem: Operation map/is_ge not supported === !
-----
[ -d $OUT_DIR/map/automem/is_gr ] || mkdir $OUT_DIR/map/automem/is_gr
cat >$OUT_DIR/map/automem/is_gr/vdm <<'-----'
! === automem: Operation map/is_gr not supported === !
-----
[ -d $OUT_DIR/map/automem/is_in ] || mkdir $OUT_DIR/map/automem/is_in
cat >$OUT_DIR/map/automem/is_in/ccod <<'-----'
#define NAME is_in
#define PTYPE1 ELEM1
#define P1_IS_ELEM
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/is_in/cmcr <<'-----'
#define NAME is_in
#define TWO_PARAM
#define P1_IS_ELEM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/map/automem/is_in/vdm <<'-----'
#define NAME is_in
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/is_in_dom ] || mkdir $OUT_DIR/map/automem/is_in_dom
cat >$OUT_DIR/map/automem/is_in_dom/ccod <<'-----'
#define NAME is_in_dom
#define P3_IS_ELEM2
#include <aux/automem/map_is_in_xxx/ccod>
-----
cat >$OUT_DIR/map/automem/is_in_dom/vdm <<'-----'
#define NAME is_in_dom
#define P3_IS_ELEM2
#include <aux/automem/map_is_in_xxx/vdm>
-----
[ -d $OUT_DIR/map/automem/is_in_max ] || mkdir $OUT_DIR/map/automem/is_in_max
cat >$OUT_DIR/map/automem/is_in_max/ccod <<'-----'
#define NAME is_in_max
#include <aux/automem/map_is_in_xxx/ccod>
-----
cat >$OUT_DIR/map/automem/is_in_max/vdm <<'-----'
#define NAME is_in_max
#include <aux/automem/map_is_in_xxx/vdm>
-----
[ -d $OUT_DIR/map/automem/is_in_min ] || mkdir $OUT_DIR/map/automem/is_in_min
cat >$OUT_DIR/map/automem/is_in_min/ccod <<'-----'
#define NAME is_in_min
#include <aux/automem/map_is_in_xxx/ccod>
-----
cat >$OUT_DIR/map/automem/is_in_min/vdm <<'-----'
#define NAME is_in_min
#include <aux/automem/map_is_in_xxx/vdm>
-----
[ -d $OUT_DIR/map/automem/is_in_rng ] || mkdir $OUT_DIR/map/automem/is_in_rng
cat >$OUT_DIR/map/automem/is_in_rng/ccod <<'-----'
#define NAME is_in_rng
#define P1_IS_ELEM2
#include <aux/automem/map_is_in_xxx/ccod>
-----
cat >$OUT_DIR/map/automem/is_in_rng/vdm <<'-----'
#define NAME is_in_rng
#define P1_IS_ELEM2
#include <aux/automem/map_is_in_xxx/vdm>
-----
[ -d $OUT_DIR/map/automem/is_submap ] || mkdir $OUT_DIR/map/automem/is_submap
cat >$OUT_DIR/map/automem/is_submap/ccod <<'-----'
#define NAME is_submap
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/map/automem/is_submap/cmcr <<'-----'
#define NAME is_submap
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/map/automem/is_submap/vdm <<'-----'
#define NAME is_submap
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/map/automem/iterator ] || mkdir $OUT_DIR/map/automem/iterator
cat >$OUT_DIR/map/automem/iterator/vdm <<'-----'
#include <aux/automem/iterator/vdm>
DOMAINS
IMPLEMENTATIONS
  Rep##_DOMAIN = + iterator("INTERNALFCT")
-----
[ -d $OUT_DIR/map/automem/max_dom ] || mkdir $OUT_DIR/map/automem/max_dom
cat >$OUT_DIR/map/automem/max_dom/ccod <<'-----'
#define NAME   max_dom
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/map/automem/max_dom/cmcr <<'-----'
#define NAME max_dom
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/map/automem/max_dom/vdm <<'-----'
#define NAME max_dom
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/map/automem/min_dom ] || mkdir $OUT_DIR/map/automem/min_dom
cat >$OUT_DIR/map/automem/min_dom/ccod <<'-----'
#define NAME   min_dom
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/map/automem/min_dom/cmcr <<'-----'
#define NAME min_dom
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/map/automem/min_dom/vdm <<'-----'
#define NAME min_dom
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/map/automem/mk1 ] || mkdir $OUT_DIR/map/automem/mk1
cat >$OUT_DIR/map/automem/mk1/ccod <<'-----'
#define NAME mk1
#define P1_INSERTED
#define P2_INSERTED
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/map/automem/mk1/vdm <<'-----'
#define NAME mk1
#define P1_INSERTED
#define P2_INSERTED
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk1
#define ADTNAME ADT_BAG
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/automem/mk_empty ] || mkdir $OUT_DIR/map/automem/mk_empty
cat >$OUT_DIR/map/automem/mk_empty/ccod <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/map/automem/mk_empty/vdm <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/automem/ovwrt ] || mkdir $OUT_DIR/map/automem/ovwrt
cat >$OUT_DIR/map/automem/ovwrt/ccod <<'-----'
#define NAME ovwrt
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/map/automem/ovwrt/vdm <<'-----'
#define NAME ovwrt
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/map/automem/ovwrt1 ] || mkdir $OUT_DIR/map/automem/ovwrt1
cat >$OUT_DIR/map/automem/ovwrt1/ccod <<'-----'
#define NAME ovwrt1
#define PTYPE3  ELEM2
#define _PTYPE3 _ELEM2
#define P2_INSERTED
#define P3_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/map/automem/ovwrt1/vdm <<'-----'
#define NAME ovwrt1
#define PTYPE3 ELEM2
#define P2_INSERTED
#define P3_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/map/automem/ovwrtd ] || mkdir $OUT_DIR/map/automem/ovwrtd
cat >$OUT_DIR/map/automem/ovwrtd/vdm <<'-----'
! === automem: Operation map/ovwrtd not supported === !
-----
[ -d $OUT_DIR/map/automem/parse ] || mkdir $OUT_DIR/map/automem/parse
cat >$OUT_DIR/map/automem/parse/ccod <<'-----'
#include <aux/automem/parse/ccod>
-----
cat >$OUT_DIR/map/automem/parse/vdm <<'-----'
#include <aux/automem/parse/vdm>
-----
[ -d $OUT_DIR/map/automem/pr ] || mkdir $OUT_DIR/map/automem/pr
cat >$OUT_DIR/map/automem/pr/vdm <<'-----'
! === automem: Operation map/pr not supported === !
-----
[ -d $OUT_DIR/map/automem/ran ] || mkdir $OUT_DIR/map/automem/ran
cat >$OUT_DIR/map/automem/ran/ccod <<'-----'
#define NAME ran
#include <aux/automem/structselector/ccod>
-----
cat >$OUT_DIR/map/automem/ran/param <<'-----'
RESULT
COPY
-----
cat >$OUT_DIR/map/automem/ran/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + ran("RESULT"=Rep##_RESULT,"COPY")
-----
[ -d $OUT_DIR/map/automem/sel ] || mkdir $OUT_DIR/map/automem/sel
cat >$OUT_DIR/map/automem/sel/ccod <<'-----'
#define NAME sel
#define P2_TYPE ELEM1
#define RESULT ELEM2
#define _RESULT _ELEM2
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/map/automem/sel/cmcr <<'-----'
#define NAME sel
#define RESULT ELEM2
#define _RESULT _ELEM2
#define P2_TYPE ELEM1
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/map/automem/sel/vdm <<'-----'
#define NAME sel
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/map/automem/sel_dom ] || mkdir $OUT_DIR/map/automem/sel_dom
cat >$OUT_DIR/map/automem/sel_dom/ccod <<'-----'
#define NAME sel_dom
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/map/automem/sel_dom/cmcr <<'-----'
#define NAME sel_dom
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/map/automem/sel_dom/vdm <<'-----'
#define NAME sel_dom
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/map/automem/sub ] || mkdir $OUT_DIR/map/automem/sub
cat >$OUT_DIR/map/automem/sub/ccod <<'-----'
#define NAME sub
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/map/automem/sub/vdm <<'-----'
#define NAME sub
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/map/automem/sub1 ] || mkdir $OUT_DIR/map/automem/sub1
cat >$OUT_DIR/map/automem/sub1/ccod <<'-----'
#define NAME sub1
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/map/automem/sub1/vdm <<'-----'
#define NAME sub1
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/map/automem/sub1d ] || mkdir $OUT_DIR/map/automem/sub1d
cat >$OUT_DIR/map/automem/sub1d/vdm <<'-----'
! === automem: Operation map/sub1d not supported === !
-----
[ -d $OUT_DIR/map/automem/subd ] || mkdir $OUT_DIR/map/automem/subd
cat >$OUT_DIR/map/automem/subd/vdm <<'-----'
! === automem: Operation map/subd not supported === !
-----
[ -d $OUT_DIR/map/automem/union ] || mkdir $OUT_DIR/map/automem/union
cat >$OUT_DIR/map/automem/union/ccod <<'-----'
#define NAME union
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/map/automem/union/vdm <<'-----'
#define NAME union
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/map/automem/union1 ] || mkdir $OUT_DIR/map/automem/union1
cat >$OUT_DIR/map/automem/union1/ccod <<'-----'
#define NAME union1
#define PTYPE3  ELEM2
#define _PTYPE3 _ELEM2
#define P2_INSERTED
#define P3_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/map/automem/union1/vdm <<'-----'
#define NAME union1
#define PTYPE3 ELEM2
#define P2_INSERTED
#define P3_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/map/automem/union1d ] || mkdir $OUT_DIR/map/automem/union1d
cat >$OUT_DIR/map/automem/union1d/vdm <<'-----'
! === automem: Operation map/union1d not supported === !
-----
[ -d $OUT_DIR/map/automem/uniond ] || mkdir $OUT_DIR/map/automem/uniond
cat >$OUT_DIR/map/automem/uniond/vdm <<'-----'
! === automem: Operation map/uniond not supported === !
-----
[ -d $OUT_DIR/map/com ] || mkdir $OUT_DIR/map/com
[ -d $OUT_DIR/map/com/all ] || mkdir $OUT_DIR/map/com/all
cat >$OUT_DIR/map/com/all/docu <<'-----'
#include <aux/com/all/docu>
-----
cat >$OUT_DIR/map/com/all/vdm <<'-----'
#include <aux/com/all/vdm>
-----
[ -d $OUT_DIR/map/com/basic ] || mkdir $OUT_DIR/map/com/basic
cat >$OUT_DIR/map/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/map/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = Elem -m-> Elem

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + mk_empty
   + mk1
#ifdef ISTOKEN2
   + ext
#endif

   + card

   + copy1
   + copy
   + union1
   + union1d
   + ovwrt1
   + ovwrt1d
   + sub1
   + sub1d
   + union
   + uniond
   + ovwrt
   + ovwrtd
   + sub
   + subd
   + inters
   + intersd
   + sel
   + sel_dom
#ifdef ISORDERED
   + min_dom
   + max_dom
#endif

   + is_eq
   + is_empty
   + is_in
   + is_submap
   + is_in_dom
   + is_in_rng
#ifdef ISORDERED
   + is_in_min
   + is_in_max
#endif

   + forall
   + forsome
#ifdef ISORDERED
   + forrange
#endif

   + binary.bf(RESULT=Bool,FOLDFCT="bfoldf",NOFOLDENR)
   + fold.ff(RESULT=Bool,NULLFCT="fnullf",CVFCT="fcvf",FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)
   + fold.ff1(RESULT=Bool,NULLPARAM,CVFCTVAR,FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)
   /* 'ff2' is just generated to check XXXX and XXXXX. It is not called. */
   + fold.ff2(RESULT=Bool,NULLPARAM,CVFCTVAR,FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,XXXX=Str,XXXXX=Elem,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)

#ifdef ISSTR2
   + fread
   + fwrite
#endif

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput
   + all + exist + exist1

-----
cat >$OUT_DIR/map/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Elem = BASIC -m-> BASIC

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + mk_empty
   + mk1

   + ovwrt1d

   + is_eq

-----
cat >$OUT_DIR/map/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbdele>

/*================================================================================================*/

#define nilmap MERGE(mk_empty,_domain)()

#define onemap(elem1,elem2) MERGE(mk1,_domain)(elem1,elem2)

Domain bigmap()
{ return
     @( ovwrt1d##_domain( 
     @)  nilmap 
     @( ,@X@,@Y@) 
     @)
  ;
}

/*------------------------------------------------------------------------------------------------*/

int bignum()

{  Elem e_array[99];
   int Ei = 0;
   Domain bighelp;
   int i = 0;
   bighelp = bigmap();
@( if( is_in##_domain( E_ @X@, bighelp ) )
   { ++i;
     bighelp = sub1d##_domain( bighelp, E_ @X@ );
   }
@) /* HMH EE */
   del##_domain(bighelp);
   return( i );
}

/*================================================================================================*/

int glob = -1;
Domain glob_map;

/*------------------------------------------------------------------------------------------------*/

void clear_glob ()

{ if (glob != -1) del1##_domain(glob_map);
  glob = 0;
  glob_map = nilmap;
}

/*------------------------------------------------------------------------------------------------*/

void for_test _FPH2(Elem,Elem)
{ ++glob;
  glob_map = ovwrt1d##_domain( glob_map, x1, x2 );
}

/*------------------------------------------------------------------------------------------------*/

Bool forsome_test _FPH2(Elem,Elem)
{ return( is_eq##_elem( x1, @Y@ ) );
}

/*================================================================================================*/

Bool bfoldf##_domain ( result, elem1, elem2 )

  Bool result;
  Elem elem1, elem2;

{ Domain bighelp;
  Bool r;
  bighelp = bigmap();
  r =  result && is_eq##_elem( sel##_domain( bighelp, elem1 ), elem2 );
  del##_domain(bighelp); 
  return r;
}

/*================================================================================================*/

Bool fnullf_bool ()

{ return(TRUE);
}

/*------------------------------------------------------------------------------------------------*/

Bool fcvf##_elem##_elem ( elem1, elem2, vx, vxx, vxxx, vy, vyy, vyyy )

  Elem elem1, elem2;
  Elem vx,vy; BASIC vxx,vyy; Bool vxxx,vyyy;

{ 
  Domain d_array[9];
  int Di = 0;
  Elem e_array[9];
  int Ei = 0;
  Bool r =  is_eq##_elem( sel##_domain( D_ bigmap(), elem1 ), elem2 ) &&
            is_eq##_elem( vx, E_ @Z@ ) &&
            vxx == ccc  &&
            vxxx &&
            is_eq##_elem( vy, E_ @Y@ ) &&
            vyy == bbb  &&
            ! vyyy ;
/* HMH  DD EE  */
  return r;
}

/*------------------------------------------------------------------------------------------------*/

Bool ffoldf_bool ( result1, result2, vy, vyy, vyyy, vz, vzz, vzzz )

  Bool result1, result2;
  Elem vy,vz; BASIC vyy,vzz; Bool vyyy,vzzz;

{ 
  Domain d_array[9];
  int Di = 0;
  Elem e_array[9];
  int Ei = 0;
  Bool r =  result1 &&
            result2 && 
            is_in##_domain( vz, D_ bigmap() ) && 
            vzz == aaa &&
            vzzz &&
            is_eq##_elem( vy, E_ @Y@ ) && 
            vyy == bbb &&
            ! vyyy;
/* HMH  DD EE */
  return r;
}

#include <aux/com/basic/bbid2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ nilmap ) )
       myerr(@n@,"mk_empty()","");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ onemap(@X@,@Y@), E_ @X@ ), E_ @Y@ ) )
       myerr(@n@,"mk1()","@X@,@Y@");
@) DD EE }

/*================================================================================================*/

#ifdef ISTOKEN2
     void p_@N@()
     { Domain bighelp = D_ nilmap;
       Elem elem1;
       if( is_in##_domain( ( elem1 = ext##_domain( &bighelp, @Z@ ) ), D_ nilmap ) )
         myerr(@n@,"ext() /1","[]");
       if(! is_eq##_domain( bighelp, D_ onemap( elem1, @Z@ ) ) )
         myerr(@n@,"ext() /2","[]");
     DD }
  
  @( void p_@N@()
     { Domain bighelp = D_ onemap(@X@,@Y@);
       Elem elem1;
       if( is_in##_domain( ( elem1 = ext##_domain( &bighelp, @Z@ ) ),
                           D_ onemap(@X@,@Y@) ) )
         myerr(@n@,"ext() /1","[@X@:->@Y@]");
       if(! is_submap##_domain( D_ onemap(@X@,@Y@), bighelp ) )
         myerr(@n@,"ext() /2","[@X@:->@Y@]");
       if(! is_submap##_domain( D_ onemap(elem1,@Z@), bighelp ) )
         myerr(@n@,"ext() /3","[@X@:->@Y@]");
     DD }
  @)
     void p_@N@()
     { Domain bighelp = D_ bigmap();
       Elem elem1;
       if( is_in##_domain( ( elem1 = ext##_domain( &bighelp, @Z@ ) ), D_ bigmap() ) )
         myerr(@n@,"ext() /1","BIGMAP");
       if(! is_submap##_domain( D_ bigmap(), bighelp ) )
         myerr(@n@,"ext() /2","BIGMAP");
       if(! is_submap##_domain( D_ onemap(elem1,@Z@), bighelp ) )
         myerr(@n@,"ext() /3","BIGMAP");
     DD }
#endif

/*================================================================================================*/

   void p_@N@()
   { if( card##_domain( D_ nilmap ) != 0 )
       myerr(@n@,"card()","[]");
   DD }

   void p_@N@()
   { 
@(   if( card##_domain( D_ onemap(@X@,@Y@) ) != 1 )
       myerr(@n@,"card()","[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   { if( card##_domain( D_ bigmap() ) != bignum() )
       myerr(@n@,"card()","BIGMAP");
   DD }

/*================================================================================================*/

#define ARG nilmap
#define TEXT []
#include <aux/com/copy1/bbc2>

#define ARG onemap(@X@,@Y@)
#define TEXT [@X@:->@Y@]
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG bigmap()
#include <aux/com/copy1/bbc2>

#define ARG nilmap
#define TEXT []
#include <aux/com/copy/bbc2>

#define ARG onemap(@X@,@Y@)
#define TEXT [@X@:->@Y@]
#define REPEAT
#include <aux/com/copy/bbc2>

#define ARG bigmap()
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1##_domain( nilmap,@X@,@Y@ ), D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"union1()","[],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ union1##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"union1() /1","[@Y@:->@Z@],@X@,@Y@");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ union1##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"union1() /2","[@Y@:->@Z@],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1##_domain( onemap(@X@,@Y@), @X@,@Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"union1()","[@X@:->@Y@],@X@,@Y@");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ bigmap(), D_ union1##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"union1() /1","BIGMAP,@Y@,@Z@");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ union1##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"union1() /2","BIGMAP,@Y@,@Z@");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1##_domain( bigmap(), E_ @X@,E_ @Y@ ), D_ bigmap() ) )
       myerr(@n@,"union1()","BIGMAP,E_ @X@,E_ @Y@");
@) DD EE }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1d##_domain( nilmap, @X@,@Y@ ), D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"union1d()","[],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ union1d##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"union1d() /1","[@Y@:->@Z@],@X@,@Y@");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ union1d##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"union1d() /2","[@Y@:->@Z@],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1d##_domain( onemap(@X@,@Y@), @X@,@Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"union1d()","[@X@:->@Y@],@X@,@Y@");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ bigmap(), D_ union1d##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"union1d() /1","BIGMAP,@Y@,@Z@");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ union1d##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"union1d() /2","BIGMAP,@Y@,@Z@");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1d##_domain( bigmap(), @X@,@Y@ ), D_ bigmap() ) )
       myerr(@n@,"union1d()","BIGMAP,@X@, @Y@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1##_domain( nilmap, @X@,@Y@ ), D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt1()","[],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrt1##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"ovwrt1() /1","[@Y@:->@Z@],@X@,@Y@");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ ovwrt1##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"ovwrt1() /2","[@Y@:->@Z@],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1##_domain( onemap(@X@,@Z@), @X@,@Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt1()","[@X@:->@Z@],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1##_domain( onemap(@X@,@Y@), @X@,@Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt1()","[@X@:->@Y@],@X@,@Y@");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ bigmap(), D_ ovwrt1##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"ovwrt1() /1","BIGMAP,@Y@,@Z@");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrt1##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"ovwrt1() /2","BIGMAP,@Y@,@Z@");
   DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@X@,@Z@),
                              D_ ovwrt1##_domain( bigmap(), @X@,@Z@ ) ) )
       myerr(@n@,"ovwrt1()","BIGMAP,@X@,@Z@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1##_domain( bigmap(), @X@,@Y@ ), D_ bigmap() ) )
       myerr(@n@,"ovwrt1()","BIGMAP,@X@,@Y@");
@) DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1d##_domain( nilmap, @X@,@Y@ ), D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt1d()","[],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrt1d##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"ovwrt1d() /1","[@Y@:->@Z@],@X@,@Y@");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ ovwrt1d##_domain( onemap(@Y@,@Z@), @X@,@Y@ ) ) )
       myerr(@n@,"ovwrt1d() /2","[@Y@:->@Z@],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1d##_domain( onemap(@X@,@Z@), @X@,@Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt1d()","[@X@:->@Z@],@X@,@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1d##_domain( onemap(@X@,@Y@), @X@,@Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt1d()","[@X@:->@Y@],@X@,@Y@");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ bigmap(), D_ ovwrt1d##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"ovwrt1d() /1","BIGMAP,@Y@,@Z@");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrt1d##_domain( bigmap(), @Y@,@Z@ ) ) )
       myerr(@n@,"ovwrt1d() /2","BIGMAP,@Y@,@Z@");
   DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@X@,@Z@),
                              D_ ovwrt1d##_domain( bigmap(), @X@,@Z@ ) ) )
       myerr(@n@,"ovwrt1d()","BIGMAP,@X@,@Z@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1d##_domain( bigmap(), @X@,@Y@ ), D_ bigmap() ) )
       myerr(@n@,"ovwrt1d()","BIGMAP,@X@,@Y@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1##_domain( nilmap, E_ @X@ ) ) )
       myerr(@n@,"sub1()","[],@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub1##_domain( onemap(@X@,@Y@), E_ @Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"sub1()","[@X@:->@Y@],@Y@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1##_domain( onemap(@X@,@Y@), E_ @X@ ) ) )
       myerr(@n@,"sub1()","[@X@:->@Y@],@X@");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub1##_domain( bigmap(), E_ @Y@ ), D_ bigmap() ) )
       myerr(@n@,"sub1()","BIGMAP,@Y@");
   DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ sub1##_domain( bigmap(), E_ @X@ ) ) )
       myerr(@n@,"sub1()","BIGMAP,@X@");
@) DD EE }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1d##_domain( nilmap, E_ @X@ ) ) )
       myerr(@n@,"sub1d()","[],@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub1d##_domain( onemap(@X@,@Y@), @Y@ ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"sub1d()","[@X@:->@Y@],@Y@");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1d##_domain( onemap(@X@,@Y@), E_ @X@ ) ) )
       myerr(@n@,"sub1d()","[@X@:->@Y@],@X@");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub1d##_domain( bigmap(), E_ @Y@ ), D_ bigmap() ) )
       myerr(@n@,"sub1d()","BIGMAP,@Y@");
   DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ sub1d##_domain( bigmap(), E_ @X@ ) ) )
       myerr(@n@,"sub1d()","BIGMAP,@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ union##_domain( nilmap, nilmap ) ) )
       myerr(@n@,"union()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( nilmap, onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"union()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ union##_domain( nilmap, bigmap() ), D_ bigmap() ) )
       myerr(@n@,"union()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( onemap(@X@,@Y@), nilmap ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"union()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ union##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"union() /1","[@Y@:->@Z@],[@X@:->@Y@]");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ union##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"union() /2","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( onemap(@X@,@Y@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"union()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ union##_domain( onemap(@Y@,@Z@), bigmap() ) ) )  
       myerr(@n@,"union() /1","[@Y@:->@Z@],BIGMAP");
     if(! is_submap##_domain( D_ bigmap(), D_ union##_domain( onemap(@Y@,@Z@), bigmap() ) ) )
       myerr(@n@,"union() /2","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( onemap(@X@,@Y@), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"union()","[@X@:->@Y@],BIGMAP");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ union##_domain( bigmap(), nilmap ), D_ bigmap() ) )
       myerr(@n@,"union()","BIGMAP,[]");
   DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ bigmap(), D_ union##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )
       myerr(@n@,"union() /1","BIGMAP,[@Y@:->@Z@]");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ union##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )  
       myerr(@n@,"union() /2","BIGMAP,[@Y@:->@Z@]");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( bigmap(), onemap(@X@,@Y@) ), D_ bigmap() ) )
       myerr(@n@,"union()","BIGMAP,[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ union##_domain( bigmap(), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"union()","BIGMAP,BIGMAP");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_empty##_domain( D_ uniond##_domain( nilmap, nilmap ) ) )
       myerr(@n@,"uniond()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( nilmap, onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"uniond()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ uniond##_domain( nilmap, bigmap() ), D_ bigmap() ) )
       myerr(@n@,"uniond()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( onemap(@X@,@Y@), nilmap ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"uniond()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ uniond##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"uniond() /1","[@Y@:->@Z@],[@X@:->@Y@]");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ uniond##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"uniond() /2","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( onemap(@X@,@Y@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"uniond()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ uniond##_domain( onemap(@Y@,@Z@), bigmap() ) ) )  
       myerr(@n@,"uniond() /1","[@Y@:->@Z@],BIGMAP");
     if(! is_submap##_domain( D_ bigmap(), D_ uniond##_domain( onemap(@Y@,@Z@), bigmap() ) ) )
       myerr(@n@,"uniond() /2","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( onemap(@X@,@Y@), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"uniond()","[@X@:->@Y@],BIGMAP");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ uniond##_domain( bigmap(), nilmap ), D_ bigmap() ) )
       myerr(@n@,"uniond()","BIGMAP,[]");
   DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ bigmap(), D_ uniond##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )
       myerr(@n@,"uniond() /1","BIGMAP,[@Y@:->@Z@]");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ uniond##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )  
       myerr(@n@,"uniond() /2","BIGMAP,[@Y@:->@Z@]");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( bigmap(), onemap(@X@,@Y@) ), D_ bigmap() ) )
       myerr(@n@,"uniond()","BIGMAP,[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ uniond##_domain( bigmap(), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"uniond()","BIGMAP,BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ ovwrt##_domain( nilmap, nilmap ) ) )
       myerr(@n@,"ovwrt()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt##_domain( nilmap, onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ ovwrt##_domain( nilmap, bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrt()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt##_domain( onemap(@X@,@Y@), nilmap ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrt##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"ovwrt() /1","[@Y@:->@Z@],[@X@:->@Y@]");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ ovwrt##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"ovwrt() /2","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt##_domain( onemap(@X@,@Z@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt()","[@X@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt##_domain( onemap(@X@,@Y@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrt()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrt##_domain( onemap(@Y@,@Z@), bigmap() ) ) )  
       myerr(@n@,"ovwrt() /1","[@Y@:->@Z@],BIGMAP");
     if(! is_submap##_domain( D_ bigmap(), D_ ovwrt##_domain( onemap(@Y@,@Z@), bigmap() ) ) )
       myerr(@n@,"ovwrt() /2","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt##_domain( onemap(@X@,@Z@), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrt()","[@X@:->@Z@],BIGMAP");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt##_domain( onemap(@X@,@Y@), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrt()","[@X@:->@Y@],BIGMAP");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ ovwrt##_domain( bigmap(), nilmap ), D_ bigmap() ) )
       myerr(@n@,"ovwrt()","BIGMAP,[]");
   DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ bigmap(), D_ ovwrt##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )
       myerr(@n@,"ovwrt() /1","BIGMAP,[@Y@:->@Z@]");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrt##_domain( bigmap(), onemap(@Y@,@Z@ ) ) ) )  
       myerr(@n@,"ovwrt() /2","BIGMAP,[@Y@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@X@,@Z@),
                              D_ ovwrt##_domain( bigmap(), onemap(@X@,@Z@) ) ) )
       myerr(@n@,"ovwrt()","BIGMAP,[@X@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt##_domain( bigmap(), onemap(@X@,@Y@) ), D_ bigmap() ) )
       myerr(@n@,"ovwrt()","BIGMAP,[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ ovwrt##_domain( bigmap(), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrt()","BIGMAP,BIGMAP");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_empty##_domain( D_ ovwrtd##_domain( nilmap, nilmap ) ) )
       myerr(@n@,"ovwrtd()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrtd##_domain( nilmap, onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrtd()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ ovwrtd##_domain( nilmap, bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrtd()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrtd##_domain( onemap(@X@,@Y@), nilmap ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrtd()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrtd##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"ovwrtd() /1","[@Y@:->@Z@],[@X@:->@Y@]");
     if(! is_submap##_domain( D_ onemap(@X@,@Y@),
                              D_ ovwrtd##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"ovwrtd() /2","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrtd##_domain( onemap(@X@,@Z@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrtd()","[@X@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrtd##_domain( onemap(@X@,@Y@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"ovwrtd()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrtd##_domain( onemap(@Y@,@Z@), bigmap() ) ) )  
       myerr(@n@,"ovwrtd() /1","[@Y@:->@Z@],BIGMAP");
     if(! is_submap##_domain( D_ bigmap(), D_ ovwrtd##_domain( onemap(@Y@,@Z@), bigmap() ) ) )
       myerr(@n@,"ovwrtd() /2","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrtd##_domain( onemap(@X@,@Z@), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrtd()","[@X@:->@Z@],BIGMAP");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrtd##_domain( onemap(@X@,@Y@), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrtd()","[@X@:->@Y@],BIGMAP");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ ovwrtd##_domain( bigmap(), nilmap ), D_ bigmap() ) )
       myerr(@n@,"ovwrtd()","BIGMAP,[]");
   DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ bigmap(), D_ ovwrtd##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )
       myerr(@n@,"ovwrtd() /1","BIGMAP,[@Y@:->@Z@]");
     if(! is_submap##_domain( D_ onemap(@Y@,@Z@),
                              D_ ovwrtd##_domain( bigmap(), onemap(@Y@,@Z@ ) ) ) ) 
       myerr(@n@,"ovwrtd() /2","BIGMAP,[@Y@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@X@,@Z@),
                              D_ ovwrtd##_domain( bigmap(), onemap(@X@,@Z@) ) ) )
       myerr(@n@,"ovwrtd()","BIGMAP,[@X@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrtd##_domain( bigmap(), onemap(@X@,@Y@) ), D_ bigmap() ) )
       myerr(@n@,"ovwrtd()","BIGMAP,[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ ovwrtd##_domain( bigmap(), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"ovwrtd()","BIGMAP,BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ sub##_domain( nilmap, D_ nilmap ) ) )
       myerr(@n@,"sub()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub##_domain( nilmap, D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"sub()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub##_domain( nilmap, D_ bigmap() ) ) )
       myerr(@n@,"sub()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub##_domain( onemap(@X@,@Y@), D_ nilmap ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"sub()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub##_domain( onemap(@Y@,@Z@), D_ onemap(@X@,@Y@) ),
                          D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"sub()","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub##_domain( onemap(@X@,@Z@), D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"sub()","[@X@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub##_domain( onemap(@X@,@Y@), D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"sub()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub##_domain( onemap(@Y@,@Z@), D_ bigmap() ),
                          D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"sub()","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub##_domain( onemap(@X@,@Z@), D_ bigmap() ) ) )
       myerr(@n@,"sub()","[@X@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub##_domain( onemap(@X@,@Y@), D_ bigmap() ) ) )
       myerr(@n@,"sub()","[@X@:->@Y@],BIGMAP");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub##_domain( bigmap(), D_ nilmap ), D_ bigmap() ) )
       myerr(@n@,"sub()","BIGMAP,[]");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub##_domain( bigmap(), D_ onemap(@Y@,@Z@) ), D_ bigmap() ) )
       myerr(@n@,"sub()","BIGMAP,[@Y@:->@Z@]");
   DD }

   void p_@N@()
   {
@(   if( is_in##_domain( @X@, D_ sub##_domain( bigmap(), D_ onemap(@X@,@Z@) ) ) )
       myerr(@n@,"sub()","BIGMAP,[@X@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ sub##_domain( bigmap(), D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"sub()","BIGMAP,[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub##_domain( bigmap(), D_ bigmap() ) ) )
       myerr(@n@,"sub()","BIGMAP,BIGMAP");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_empty##_domain( D_ subd##_domain( nilmap, D_ nilmap ) ) )
       myerr(@n@,"subd()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ subd##_domain( nilmap, D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"subd()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ subd##_domain( nilmap, D_ bigmap() ) ) )
       myerr(@n@,"subd()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ subd##_domain( onemap(@X@,@Y@), D_ nilmap ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"subd()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ subd##_domain( onemap(@Y@,@Z@), D_ onemap(@X@,@Y@) ),
                          D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"subd()","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ subd##_domain( onemap(@X@,@Z@), D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"subd()","[@X@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ subd##_domain( onemap(@X@,@Y@), D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"subd()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ subd##_domain( onemap(@Y@,@Z@), D_ bigmap() ),
                          D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"subd()","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ subd##_domain( onemap(@X@,@Z@), D_ bigmap() ) ) )
       myerr(@n@,"subd()","[@X@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ subd##_domain( onemap(@X@,@Y@), D_ bigmap() ) ) )
       myerr(@n@,"subd()","[@X@:->@Y@],BIGMAP");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ subd##_domain( bigmap(), D_ nilmap ), D_ bigmap() ) )
       myerr(@n@,"subd()","BIGMAP,[]");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ subd##_domain( bigmap(), D_ onemap(@Y@,@Z@) ), D_ bigmap() ) )
       myerr(@n@,"subd()","BIGMAP,[@Y@:->@Z@]");
   DD }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ subd##_domain( bigmap(), D_ onemap(@X@,@Z@) ) ) )
       myerr(@n@,"subd()","BIGMAP,[@X@:->@Z@]");
@) DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ subd##_domain( bigmap(), D_ onemap(@X@,@Y@) ) ) )
       myerr(@n@,"subd()","BIGMAP,[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   { if(! is_empty##_domain( D_ subd##_domain( bigmap(), D_ bigmap() ) ) )
       myerr(@n@,"subd()","BIGMAP,BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( nilmap, nilmap ) ) )
       myerr(@n@,"inters()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( nilmap, onemap(@X@,@Y@) ) ) )
       myerr(@n@,"inters()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( nilmap, bigmap() ) ) )
       myerr(@n@,"inters()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( onemap(@X@,@Y@), nilmap ) ) )
       myerr(@n@,"inters()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"inters()","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( onemap(@X@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"inters()","[@X@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ inters##_domain( onemap(@X@,@Y@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"inters()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( onemap(@Y@,@Z@), bigmap() ) ) )
       myerr(@n@,"inters()","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( onemap(@X@,@Z@), bigmap() ) ) )
       myerr(@n@,"inters()","[@X@:->@Z@],BIGMAP");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ inters##_domain( onemap(@X@,@Y@), bigmap() ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"inters()","[@X@:->@Y@],BIGMAP");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( bigmap(), nilmap ) ) )
       myerr(@n@,"inters()","BIGMAP,[]");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )
       myerr(@n@,"inters()","BIGMAP,[@Y@:->@Z@]");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( bigmap(), onemap(@X@,@Z@) ) ) )
       myerr(@n@,"inters()","BIGMAP,[@X@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ inters##_domain( bigmap(), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"inters()","BIGMAP,[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ inters##_domain( bigmap(), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"inters()","BIGMAP,BIGMAP");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( nilmap, nilmap ) ) )
       myerr(@n@,"intersd()","[],[]");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( nilmap, onemap(@X@,@Y@) ) ) )
       myerr(@n@,"intersd()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( nilmap, bigmap() ) ) )
       myerr(@n@,"intersd()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( onemap(@X@,@Y@), nilmap ) ) )
       myerr(@n@,"intersd()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( onemap(@Y@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"intersd()","[@Y@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( onemap(@X@,@Z@), onemap(@X@,@Y@) ) ) )
       myerr(@n@,"intersd()","[@X@:->@Z@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ intersd##_domain( onemap(@X@,@Y@), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"intersd()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( onemap(@Y@,@Z@), bigmap() ) ) )
       myerr(@n@,"intersd()","[@Y@:->@Z@],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( onemap(@X@,@Z@), bigmap() ) ) )
       myerr(@n@,"intersd()","[@X@:->@Z@],BIGMAP");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ intersd##_domain( onemap(@X@,@Y@), bigmap() ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"intersd()","[@X@:->@Y@],BIGMAP");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( bigmap(), nilmap ) ) )
       myerr(@n@,"intersd()","BIGMAP,[]");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( bigmap(), onemap(@Y@,@Z@) ) ) )
       myerr(@n@,"intersd()","BIGMAP,[@Y@:->@Z@]");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( bigmap(), onemap(@X@,@Z@) ) ) )
       myerr(@n@,"intersd()","BIGMAP,[@X@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ intersd##_domain( bigmap(), onemap(@X@,@Y@) ),
                          D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"intersd()","BIGMAP,[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ intersd##_domain( bigmap(), bigmap() ), D_ bigmap() ) )
       myerr(@n@,"intersd()","BIGMAP,BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ onemap(@X@,@Y@), E_ @X@ ), E_ @Y@ ) )
       myerr(@n@,"sel()","[@X@:->@Y@],@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ bigmap(), E_ @X@ ), E_ @Y@ ) )
       myerr(@n@,"sel()","BIGMAP,@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel_dom##_domain( D_ onemap(@X@,@Y@) ), E_ @X@ ) )
       myerr(@n@,"sel_dom()","[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   { Domain bighelp = bigmap();
     Elem elem1;
     int i = bignum();
     while(i--)
     { if(! is_in##_domain( ( elem1 = sel_dom##_domain( bighelp ) ), bighelp ) )
         myerr(@n@,"sel_dom() /1","BIGMAP");
       bighelp = sub1d##_domain( bighelp, elem1 );
     }
     if(! is_empty##_domain( bighelp ) )
       myerr(@n@,"sel_dom() /2","BIGMAP");
     del##_domain(bighelp);
   }

/*================================================================================================*/

#ifdef ISORDERED
      void p_@N@()
      {
   @(   if(! is_eq##_elem( min_dom##_domain( D_ onemap(@X@,@Y@) ), @X@ ) )
          myerr(@n@,"min_dom()","[@X@:->@Y@]");
   @) DD }
  
      void p_@N@()
      { Elem elem1;
        if(! is_in##_domain( ( elem1 = min_dom##_domain( D_ bigmap() ) ), D_ bigmap() ) )
          myerr(@n@,"min_dom() /1","BIGMAP");
   @(   if(! is_ge##_elem( E_ @X@, elem1 ) )
          myerr(@n@,"min_dom() /2","BIGMAP");
   @) DD EE }
  

      void p_@N@()
      {
   @(   if(! is_eq##_elem( max_dom##_domain( D_ onemap(@X@,@Y@) ), E_ @X@ ) )
          myerr(@n@,"max_dom()","[@X@:->@Y@]");
   @) DD EE }
  
      void p_@N@()
      { Elem elem1;
        if(! is_in##_domain( ( elem1 = max_dom##_domain( D_ bigmap() ) ), D_ bigmap() ) )
          myerr(@n@,"max_dom() /1","BIGMAP");
   @(   if( is_gr##_elem( E_ @X@, elem1 ) )
          myerr(@n@,"max_dom() /2","BIGMAP");
   @) DD EE }
  
#endif
/*================================================================================================*/

#define ARG nilmap
#define TEXT [],[]
#include <aux/com/is_eq/bbc2>

#define ARG nilmap
#define ARG2 onemap(@X@,@Z@)
#define TEXT [],[@X@:->@Z@]
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG nilmap
#define ARG2 bigmap()
#define NEG
#define TEXT [],ARG2
#include <aux/com/is_eq/bbc2>

#define ARG onemap(@X@,@Z@)
#define ARG2 nilmap
#define TEXT [@X@:->@Z@],[]
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onemap(@Y@,@Z@)
#define ARG2 onemap(@X@,@Y@)
#define TEXT [@Y@:->@Z@],[@X@:->@Y@]
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onemap(@X@,@Z@)
#define ARG2 onemap(@X@,@Y@)
#define TEXT [@X@:->@Z@],[@X@:->@Y@]
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onemap(@X@,@Y@)
#define ARG2 onemap(@X@,@Y@)
#define TEXT [@X@:->@Y@],[@X@:->@Y@]
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onemap(@X@,@Y@)
#define ARG2 bigmap()
#define TEXT [@X@:->@Y@],ARG2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigmap()
#define ARG2 nilmap
#define TEXT ARG,[]
#define NEG
#include <aux/com/is_eq/bbc2>

#define ARG bigmap()
#define ARG2 onemap(@X@,@Y@)
#define TEXT ARG,[@X@:->@Y@]
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigmap()
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ nilmap ) )
       myerr(@n@,"is_empty()","[]");
   DD }

   void p_@N@()
   {
@(   if( is_empty##_domain( D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"is_empty()","[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if( is_empty##_domain( D_ bigmap() ) )
       myerr(@n@,"is_empty()","BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ nilmap ) )
       myerr(@n@,"is_in()","@X@,[]");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"is_in()","@X@,[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @Y@, D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"is_in()","@Y@,[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ bigmap() ) )
       myerr(@n@,"is_in()","@X@,BIGMAP");
@) DD EE }

   void p_@N@()
   { if(  is_in##_domain( E_ @Y@, D_ bigmap() ) )
       myerr(@n@,"is_in()","@Y@,BIGMAP");
   DD EE }

/*================================================================================================*/

   void p_@N@()
   { if(! is_submap##_domain( D_ nilmap, D_ nilmap ) )
       myerr(@n@,"is_submap()","[],[]");
   DD }

   void p_@N@()
   {
@(   if( is_submap##_domain( D_ onemap(@X@,@Y@), D_ nilmap ) )
       myerr(@n@,"is_submap()","[@X@:->@Y@],[]");
@) DD }

   void p_@N@()
   { if( is_submap##_domain( D_ bigmap(), D_ nilmap ) )
       myerr(@n@,"is_submap()","BIGMAP,[]");
   DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ nilmap, D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"is_submap()","[],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if( is_submap##_domain( D_ onemap(@X@,@Y@), D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"is_submap()","[@X@:->@Y@],[@Y@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if( is_submap##_domain( D_ onemap(@X@,@Y@), D_ onemap(@X@,@Z@) ) )
       myerr(@n@,"is_submap()","[@X@:->@Y@],[@X@:->@Z@]");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@X@,@Y@), D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"is_submap()","[@X@:->@Y@],[@X@:->@Y@]");
@) DD }

   void p_@N@()
   {
@(   if( is_submap##_domain( D_ bigmap(), D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"is_submap()","BIGMAP,[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ nilmap, D_ bigmap() ) )
       myerr(@n@,"is_submap()","[],BIGMAP");
   DD }

   void p_@N@()
   {
@(   if( is_submap##_domain( D_ onemap(@Y@,@Z@), D_ bigmap() ) )
       myerr(@n@,"is_submap()","[@Y@:->@Z@],BIGMAP");
@) DD }

   void p_@N@()
   {
@(   if( is_submap##_domain( D_ onemap(@X@,@Z@), D_ bigmap() ) )
       myerr(@n@,"is_submap()","[@X@:->@Z@],BIGMAP");
@) DD }

   void p_@N@()
   {
@(   if(! is_submap##_domain( D_ onemap(@X@,@Y@), D_ bigmap() ) )
       myerr(@n@,"is_submap()","[@X@:->@Y@],BIGMAP");
@) DD }

   void p_@N@()
   { if(! is_submap##_domain( D_ bigmap(), D_ bigmap() ) )
       myerr(@n@,"is_submap()","BIGMAP,BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   { Elem elem2;
@(   if( is_in_dom##_domain( E_ @X@, D_ nilmap, &elem2 ) )
       myerr(@n@,"is_in_dom()","@X@,[]");
@) DD EE }

   void p_@N@()
   { Elem elem2;
@(   if( is_in_dom##_domain( E_ @X@, D_ onemap(@Y@,@Z@), &elem2 ) )
       myerr(@n@,"is_in_dom()","@X@,[@Y@:->@Z@]");
@) DD EE }

   void p_@N@()
   { Elem elem2;
@(   if(! is_in_dom##_domain( E_ @X@, D_ onemap(@X@,@Y@), &elem2 ) )   
       myerr(@n@,"is_in_dom() /1","@X@,[@X@:->@Y@]");
     else
       if(! is_eq##_elem( elem2, E_ @Y@ ) )  
         myerr(@n@,"is_in_dom() /2","@X@,[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   { Elem elem2;
     if( is_in_dom##_domain( E_ @Y@, D_ bigmap(), &elem2 ) )
       myerr(@n@,"is_in_dom()","@Y@,BIGMAP");
   DD EE }

   void p_@N@()
   { Elem elem2;
@(   if(! is_in_dom##_domain( E_ @X@, D_ bigmap(), &elem2 ) )
       myerr(@n@,"is_in_dom() /1","@X@,BIGMAP");
     else
       if(! is_eq##_elem( elem2, sel##_domain( D_ bigmap(), E_ @X@ ) ) )
         myerr(@n@,"is_in_dom() /2","@X@,BIGMAP");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { Elem elem1;
     if( is_in_rng##_domain( E_ @Y@, D_ nilmap, &elem1 ) )
       myerr(@n@,"is_in_rng()","@Y@,[]");
   DD EE }

   void p_@N@()
   { Elem elem1;
     if( is_in_rng##_domain( E_ @X@, D_ onemap(@Y@,@Z@), &elem1 ) )
       myerr(@n@,"is_in_rng()","@X@,[@Y@:->@Z@]");
   DD EE }

   void p_@N@()
   { Elem elem1;
@(   if(! is_in_rng##_domain( E_ @Y@, D_ onemap(@X@,@Y@), &elem1 ) )
       myerr(@n@,"is_in_rng() /1","@Y@,[@X@:->@Y@]");
     else
       if(! is_eq##_elem( elem1, E_ @X@ ) )
         myerr(@n@,"is_in_rng() /2","@Y@,[@X@:->@Y@]");
@) DD EE }

   void p_@N@()
   { Elem elem1;
@(   if( is_in_rng##_domain( E_ @X@, D_ bigmap(), &elem1 ) )
       myerr(@n@,"is_in_rng()","@X@,BIGMAP");
@) DD EE }

   void p_@N@()
   { Elem elem1;
@(   if(! is_in_rng##_domain( E_ @Y@, D_ bigmap(), &elem1 ) )
       myerr(@n@,"is_in_rng() /1","@Y@,BIGMAP");
     else
       if(! is_eq##_elem( sel##_domain( D_ bigmap(), elem1 ), E_ @Y@ ) )
         myerr(@n@,"is_in_rng() /2","@Y@,BIGMAP");
@) DD EE }

/*================================================================================================*/

#ifdef ISORDERED
      void p_@N@()
      { Elem elem1;
   @(   if( is_in_min##_domain( E_ @X@, D_ nilmap, &elem1 ) )
          myerr(@n@,"is_in_min()","@X@,[]");
   @) DD EE }
  
      void p_@N@()
      { Elem elem1;
        if( is_in_min##_domain( E_ @Z@, D_ onemap(@Y@,@Z@), &elem1 ) )
          myerr(@n@,"is_in_min()","@Z@,[@Y@:->@Z@]");
      DD EE }
  
      void p_@N@()
      { Elem elem1;
        if(! is_in_min##_domain( E_ @Y@, D_ onemap(@Z@,@Y@), &elem1 ) )
          myerr(@n@,"is_in_min() /1","@Y@,[@Z@:->@Y@]");
        else
          if(! is_eq##_elem( elem1, E_ @Z@ ) )
            myerr(@n@,"is_in_min() /2","@Y@,[@Z@:->@Y@]");
      DD EE }
  
      void p_@N@()
      { Elem elem1;
   @(   if(! is_in_min##_domain( E_ @X@, D_ bigmap(), &elem1 ) )
          myerr(@n@,"is_in_min() /1","@X@,BIGMAP");
        else
          if(! is_ge##_elem( elem1, E_ @X@ ) )
            myerr(@n@,"is_in_min() /2","@X@,BIGMAP");
   @) DD EE }
   
      void p_@N@()
      { Elem elem1;
   @(   if( is_in_max##_domain( E_ @X@, D_ nilmap, &elem1 ) )
          myerr(@n@,"is_in_max()","@X@,[]");
   @) DD EE }
  
      void p_@N@()
      { Elem elem1;
        if( is_in_max##_domain( E_ @Y@, D_ onemap(@Z@,@Y@), &elem1 ) )
          myerr(@n@,"is_in_max()","@Y@,[@Z@:->@Y@]");
      DD EE }
  
      void p_@N@()
      { Elem elem1;
        if(! is_in_max##_domain( E_ @Z@, D_ onemap(@Y@,@Z@), &elem1 ) )
          myerr(@n@,"is_in_max() /1","@Z@,[@Y@:->@Z@]");
        else
          if(! is_eq##_elem( elem1, E_ @Y@ ) )
            myerr(@n@,"is_in_max() /2","@Z@,[@Y@:->@Z@]");
      DD EE }
  
      void p_@N@()
      { Elem elem1;
   @(   if(! is_in_max##_domain( E_ @X@, D_ bigmap(), &elem1 ) )
          myerr(@n@,"is_in_max() /1","@X@,BIGMAP");
        else
          if( is_gr##_elem( elem1, E_ @X@ ) )
            myerr(@n@,"is_in_max() /2","@X@,BIGMAP");
   @) DD EE }
   
#endif
/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ nilmap, for_test );
     if( glob != 0)
       myerr(@n@,"forall()","[]");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forall##_domain( D_ onemap( @X@, @Y@), for_test );
     if( glob != 1 )
       myerr(@n@,"forall() /1","[@X@:->@Y@]");
     if(! is_eq##_domain( glob_map, D_ onemap(@X@,@Y@) ) )
       myerr(@n@,"forall() /2","[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ bigmap(), for_test );
       if( glob != bignum() )
         myerr(@n@,"forall() /1","BIGMAP");
       if(! is_eq##_domain( glob_map, D_ bigmap() ) )
         myerr(@n@,"forall() /2","BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ nilmap, forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","[]");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forsome##_domain( D_ onemap( @X@, @Y@), forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ onemap( @Y@, @Z@), forsome_test, for_test );
     if( glob != 1 )
       myerr(@n@,"forsome() /1","[@Y@:->@Z@]");
     if(! is_eq##_domain( glob_map, D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"forsome() /2","[@Y@:->@Z@]");
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ bigmap(), forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","BIGMAP");
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ union1d##_domain( bigmap(), @Y@, @Z@ ), forsome_test, for_test );
     if( glob != 1 )
       myerr(@n@,"forsome() /1","BIGMAP");
     if(! is_eq##_domain( glob_map, D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"forsome() /2","BIGMAP");
   DD }

/*================================================================================================*/

#ifdef ISORDERED
      void p_@N@()
      { clear_glob();
        forrange##_domain( D_ nilmap, for_test, E_ @Y@, E_ @Z@ );
        if( glob != 0 )
          myerr(@n@,"forrange()","[],@Y@,@Z@");
      DD EE }
  
      void p_@N@()
      { clear_glob();
        forrange##_domain( D_ onemap( @Y@, @Z@), for_test, E_ @Z@, E_ @Z@ );
        if( glob != 0 )
          myerr(@n@,"forrange()","[@Y@:->@Z@],@Z@,@Z@");
      DD EE }
  
      void p_@N@()
      { clear_glob();
        forrange##_domain( D_ onemap( @Y@, @Z@), for_test, E_ @Y@, E_ @Y@ );
        if( glob != 1 )
          myerr(@n@,"forrange() /1","[@Y@:->@Z@],@Y@,@Y@");
        if(! is_eq##_domain( glob_map, D_ onemap(@Y@,@Z@) ) )
          myerr(@n@,"forrange() /2","[@Y@:->@Z@],@Y@,@Y@");
      DD EE }
  
      void p_@N@()
      { clear_glob();
        forrange##_domain( D_ bigmap(), for_test, E_ @Y@, E_ @Y@ );
        if( glob != 0 )
          myerr(@n@,"forrange()","BIGMAP,@Y@,@Y@");
      DD EE }

      void p_@N@()
      { Elem first,last;
        int i=1;
   @(    if( i == 1 )
          first=E_ @X@;
        if( i == bignum() )
          last=E_ @X@;
        ++i;
   @)   clear_glob();
        forrange##_domain( D_ bigmap(), for_test, first, last );
        if( glob != bignum() )
          myerr(@n@,"forrange() /1","BIGMAP,first,last");
        if(! is_eq##_domain( glob_map, D_ bigmap() ) )
          myerr(@n@,"forrange() /2","BIGMAP,first,last");
      DD EE }
  
#endif
/*================================================================================================*/

   void p_@N@()
   { if( bf##_domain( TRUE, D_ nilmap ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","[]");
   DD }

   void p_@N@()
   {
@(   if( bf##_domain( TRUE, D_ onemap( @X@, @Y@) ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","[@X@:->@Y@]");
@) DD }

   void p_@N@()
   { if( bf##_domain( TRUE, D_ bigmap() ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","BIGMAP");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( ff##_domain( D_ nilmap, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","[],@X@,aaa,@Y@,bbb,@Z@,ccc");
     if( ff1##_domain( D_ nilmap,TRUE, fcvf##_elem##_elem, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"fold-Funktional ff1()","[],@X@,aaa,@Y@,bbb,@Z@,ccc");
@) DD EE }

/*----------------------------------------------------------------
  removed by HMH, produces error for <map linklist tupl array>
  (attempt to select eleent not in the domain of the map)

   void p_@N@()
   {
@( if( ff##_domain( D_ onemap( @X@, @Y@), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE )
       != TRUE )
       myerr(@n@,"fold-Funktional ff()","[@X@:->@Y@],@Z@,ccc,@Y@,bbb,@X@,aaa");
@) DD EE }

   void p_@N@()
   {
@(   if( ff##_domain( D_ bigmap(), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","BIGMAP,@Z@,ccc,@Y@,bbb,@X@,aaa");
@) DD EE }

-------------------------------------------------------------------*/
/*================================================================================================*/

#ifdef ISSTR2
   void p_@N@()
   { char dname[] = "TEST_DIR";
     Elem dname_str = mkc##_elem(dname);
     if( mkdir(dname,0755) )
       myerr(@n@,"mkdir()",dname);
     if(! fwrite##_domain( D_ nilmap, dname_str ) )
       myerr(@n@,"fwrite()","[]");
     if(! is_empty##_domain( fread##_domain( dname_str ) ) )
       myerr(@n@,"fread()","[]");
     if( unlink(strcat(dname,"/*")) )
       myerr(@n@,"unlink()",dname));
     if( rmdir(dname) )
       myerr(@n@,"rmdir()",dname);
   DD }
  
   void p_@N@()
   { char dname[] = "TEST_DIR";
     Elem dname_str = mkc##_elem(dname);
     if( mkdir(dname,0755) )
       myerr(@n@,"mkdir()",dname);
     if(! fwrite##_domain( D_ onemap(@Y@,@Z@), dname_str ) )
       myerr(@n@,"fwrite()","[@Y@,@Z@]");
     if(! is_eq##_domain( fread##_domain( dname_str ), D_ onemap(@Y@,@Z@) ) )
       myerr(@n@,"fread()","[@Y@,@Z@]");
     if( unlink(strcat(dname,"/*")) )
       myerr(@n@,"unlink()",dname));
     if( rmdir(dname) )
       myerr(@n@,"rmdir()",dname);
   DD }
  
   void p_@N@()
   { char dname[] = "TEST_DIR";
     Elem dname_str = mkc##_elem(dname);
     if( mkdir(dname,0755) )
       myerr(@n@,"mkdir()",dname);
     if(! fwrite##_domain( D_ bigmap(), dname_str ) )
       myerr(@n@,"fwrite()","BIGMAP");
     if(! is_eq##_domain( fread##_domain( dname_str ), D_ bigmap() ) )
       myerr(@n@,"fread()","BIGMAP");
     if( unlink(strcat(dname,"/*")) )
       myerr(@n@,"unlink()",dname));
     if( rmdir(dname) )
       myerr(@n@,"rmdir()",dname);
   DD }
  
#endif

/*================================================================================================*/

#define ARG nilmap
#define TEXT []
#include <aux/com/cvtotupl/bbc2>

#define ARG onemap(@X@,@Y@)
#define TEXT [@X@:->@Y@]
#define REPEAT
#include <aux/com/cvtotupl/bbc2>

#define ARG bigmap()
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG nilmap
#define TEXT []
#include <aux/com/hash/bbc2>

#define ARG onemap(@X@,@Y@)
#define TEXT [@X@:->@Y@]
#define REPEAT
#include <aux/com/hash/bbc2>

#define ARG bigmap()
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG nilmap
#include <aux/com/del1/bbc2>

#define ARG onemap(@X@,@Y@)
#define REPEAT
#include <aux/com/del1/bbc2>

#define ARG bigmap()
#include <aux/com/del1/bbc2>

#define ARG nilmap
#include <aux/com/del/bbc2>

#define ARG onemap(@X@,@Y@)
#define REPEAT
#include <aux/com/del/bbc2>

#define ARG bigmap()
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG nilmap
#include <aux/com/print/bbc2>

#define ARG onemap(@X@,@Y@)
#define REPEAT
#include <aux/com/print/bbc2>

#define ARG bigmap()
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG nilmap
#include <aux/com/pr/bbc2>

#define ARG onemap(@X@,@Y@)
#define REPEAT
#include <aux/com/pr/bbc2>

#define ARG bigmap()
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG nilmap
#include <aux/com/fpr/bbc2>

#define ARG onemap(@X@,@Y@)
#define REPEAT
#include <aux/com/fpr/bbc2>

#define ARG bigmap()
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/map/com/basic/bbd1 <<'-----'
@X@=
mk_empty##_elem()
mk1##_elem(xxx,xxx)
mk1##_elem(yyy,zzz)
mk1##_elem(zzz,yyy)
ovwrt1d##_elem(ovwrt1d##_elem(mk1##_elem(xxx,xxx),yyy,zzz),zzz,yyy)

@Y@=
mk1##_elem(ppp,xxx)

@Z@=
mk1##_elem(qqq,xxx)
-----
cat >$OUT_DIR/map/com/basic/docu <<'-----'
Syntax:

  Map = Dom -m-> Rng

ISO Syntax ( -N option ):

  Map = map Dom to Rng

Description:

  '-m->' (ISO: map <type> to <type> )

  defines the domain of all finite maps from Dom into Rng.

Example :
  Let a file system consists of a set of uniquely named files; and let
  each file consists of a set of uniquely keyed records, i.e. the file
  may  have its records randomly accessed by key. Let file names, keys
  and records presently be further unspecified. Then:

      File = Key -m-> Rec

  or the equivalent ISO syntax

      File = map Key to Rec

  is an abstract syntax rule whose left-hand side is  an  'identifier'
  and  whose  right-hand  side  is a 'domain expression'. The equation
  gives the name 'File' to a domain, and this domain  is  defined,  by
  Key  -m->  Rec  to  be the domain of finite domain maps from keys to
  records.

-----
[ -d $OUT_DIR/map/com/binary ] || mkdir $OUT_DIR/map/com/binary
cat >$OUT_DIR/map/com/binary/ccod <<'-----'
#include <aux/com/binary/ccod>
-----
cat >$OUT_DIR/map/com/binary/docu <<'-----'
#define map
#include <aux/com/binary/docu>
-----
cat >$OUT_DIR/map/com/binary/param <<'-----'
DELETE
FCTNAME
FOLDEXT
FOLDFCT
NOFOLDENR
NOSIGNATURE
RESULT
-----
cat >$OUT_DIR/map/com/binary/vdm <<'-----'
#include <aux/com/binary/vdm>
-----
[ -d $OUT_DIR/map/com/card ] || mkdir $OUT_DIR/map/com/card
cat >$OUT_DIR/map/com/card/docu <<'-----'
  Common implementation of 'card' built upon 'fold'.
-----
cat >$OUT_DIR/map/com/card/gtyp <<'-----'
_DEFINE const1##_ELEM1##_ELEM2(x1,x2) 1
-----
cat >$OUT_DIR/map/com/card/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
  DOMAIN	= + fold.card	("RESULT"	 = "Nat0"
				,"NULLFCT" = "null"
				,"FOLDFCT" = "plus"
				,"CVFCT"   = "const1"
				,"NOSIGNATURE"
				)
  
  Nat0		= + null + plus
#endif
-----
[ -d $OUT_DIR/map/com/copy ] || mkdir $OUT_DIR/map/com/copy
cat >$OUT_DIR/map/com/copy/ccod <<'-----'
#if SIMPLEELEMS
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN) {return copy1##_DOMAIN(x1);}
#else
#define fct copy
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define ty2 ELEM2
#define incr r1 = MERGE(union1,_DOMAIN)(r1,MERGE(copy,_ELEM1)(y1),MERGE(copy,_ELEM2)(y2));
#include <aux/com/for/ccod>
#endif
-----
cat >$OUT_DIR/map/com/copy/docu <<'-----'
  general implementation of copy by constructing a new map
  with copies of all subvalues
  copy(x1) = [copy(i) :-> copy(x1(i)) | i e dom x1 ]

  time complexity : O(n) * max(O(copy##_ELEM1), + O(copy##_ELEM2))
-----
cat >$OUT_DIR/map/com/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if SIMPLEELEMS
   DOMAIN   =  + copy1
#else
   DOMAIN   =  + forall + mk_empty + union1
   ELEM1    =  + copy
   ELEM2    =  + copy
#endif
-----
[ -d $OUT_DIR/map/com/copy1 ] || mkdir $OUT_DIR/map/com/copy1
cat >$OUT_DIR/map/com/copy1/ccod <<'-----'
#define fct copy1
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define ty2 ELEM2
#define incr r1 = MERGE(union1,_DOMAIN)(r1,y1,y2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/copy1/docu <<'-----'
  general implementation of copy1 by constructing a new map
  copy1(x1) = [i :-> x1(i) | i e dom x1 ]

  time complexity : O(n) * O(union1)
-----
cat >$OUT_DIR/map/com/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall + mk_empty + union1
-----
[ -d $OUT_DIR/map/com/cvfromtup1 ] || mkdir $OUT_DIR/map/com/cvfromtup1
cat >$OUT_DIR/map/com/cvfromtup1/ccod <<'-----'
#define __ADDELEM union1
#include <aux/com/cvfromtup1/ccod>
-----
cat >$OUT_DIR/map/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/map/com/cvfromtup1/vdm <<'-----'
#define __ADDELEM union1
#include <aux/com/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/map/com/cvlines ] || mkdir $OUT_DIR/map/com/cvlines
cat >$OUT_DIR/map/com/cvlines/ccod <<'-----'
#ifdef GEN_ISO
#define stup " |-> "
#else
#define stup " :-> "
#endif
  Cvtext_vdmlib cvlines3##_DOMAIN##_ELEM1##_ELEM2 _FPH2(ELEM1,ELEM2)
    { Cvtext_vdmlib lx1;
      Cvtext_vdmlib lx2;
      
      lx1 = cvlines##_ELEM1(x1);
      lx2 = cvlines##_ELEM2(x2);
      if (  len_cvtext_vdmlib(lx1) == 1
         && len_cvtext_vdmlib(lx2) == 1
         && len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
                <= curr_linelen_vdmlib - 5
         )
         { Str lx3;
           
           lx3 = conc_str( hd_cvtext_vdmlib(lx1)
                         , conc_str(mkc_str(stup),hd_cvtext_vdmlib(lx2))
                         );
           del1_cvtext_vdmlib(lx1);
           del1_cvtext_vdmlib(lx2);
           return mk1_cvtext_vdmlib(lx3);
         }
      else
         { return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(stup)));}
    }

#undef stup

#define IS_EMPTY(x1) MERGE(is_empty,_DOMAIN)(x1)
#ifdef GEN_ISO
#define START_STR "{"
#define END_STR "}"
#else
#define START_STR "["
#define END_STR "]"
#endif

#include <aux/com/cvlines/ccod>
#undef IS_EMPTY
#undef START_STR
#undef END_STR
-----
cat >$OUT_DIR/map/com/cvlines/docu <<'-----'
#include <aux/com/cvlines/docu>
-----
cat >$OUT_DIR/map/com/cvlines/gtyp <<'-----'
#ifdef GEN_C
  extern Cvtext_vdmlib cvlines3##_DOMAIN##_ELEM1##_ELEM2 P_OP ELEM1 x1, ELEM2 x2 P_CL ;
#endif
-----
cat >$OUT_DIR/map/com/cvlines/param <<'-----'
SUPRESS
-----
cat >$OUT_DIR/map/com/cvlines/vdm <<'-----'
DOMAINS  
IMPLEMENTATIONS
  Str            =  + mkc
  DOMAIN         =  + is_empty
                    + fold.cvlines1( "NULLFCT" = "mk_empty"
                                   , "CVFCT"   = "cvlines3"#_DOMAIN
                                   , "FOLDFCT" = "cvlines2"
                                   , "RESULT"  = "Cvtext_vdmlib")
  ELEM1          =  + cvlines
  ELEM2          =  + cvlines
  Vdmlib         =  + cvtext + header("STRING")
-----
[ -d $OUT_DIR/map/com/cvtotup1 ] || mkdir $OUT_DIR/map/com/cvtotup1
cat >$OUT_DIR/map/com/cvtotup1/ccod <<'-----'

TUPLDOMAIN cvtotuppair##_DOMAIN _FPH3(TUPLDOMAIN,ELEM1,ELEM2)
  { return cvtotup1##_ELEM2(cvtotup1##_ELEM1(x1,x2),x3); }

#define __NOELEMS card
#include <aux/com/cvtotup1/ccod>
-----
cat >$OUT_DIR/map/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/map/com/cvtotup1/vdm <<'-----'
#define __NOELEMS card
#include <aux/com/cvtotup1/vdm>
-----
[ -d $OUT_DIR/map/com/default ] || mkdir $OUT_DIR/map/com/default
cat >$OUT_DIR/map/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the map datatype the following set of operations is
  added

#include <map/com/default/vdm>
-----
cat >$OUT_DIR/map/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + mk1
                                       ! constructors !
             + is_empty
             + is_in + is_in_dom
                                       ! predicates !
             + card + sel
                                       ! attributes !
             + union1 + ovwrt1 + sub1
                                       ! combinators with elements !
             + union + ovwrt
                                       ! combinators with maps !
             + iterator
                                       ! iterator functions !
             + copy1 + del1
                                       ! duplicate and destroy values !
-----
[ -d $OUT_DIR/map/com/del ] || mkdir $OUT_DIR/map/com/del
cat >$OUT_DIR/map/com/del/ccod <<'-----'
#include <aux/com/del/ccod>
-----
cat >$OUT_DIR/map/com/del/docu <<'-----'
  general implementation of del via forall and del1

  time complexity : O(n) * max(O(del1##_ELEM1) + O(del1##_ELEM2))
-----
cat >$OUT_DIR/map/com/del/vdm <<'-----'
#include <aux/com/del/vdm>
-----
[ -d $OUT_DIR/map/com/dom ] || mkdir $OUT_DIR/map/com/dom
cat >$OUT_DIR/map/com/dom/defs <<'-----'
#ifndef GEN_DOCU
#ifndef RESULT
#error DOMAIN: Parameter 'RESULT' must be defined for operation 'dom'!
#endif
#endif
-----
cat >$OUT_DIR/map/com/dom/docu <<'-----'
  General implementation of the domain operator.

  Parameters:

   'RESULT':
             Supplies the name of the resulting set domain.
             This parameter must be supplied.

#ifndef BASEIMPL
   'COPY':
             if this parameter is given, a complete copy
             of all elements in the domain of the map
             is performed during the computation
             such that the result and the argument do not share
             any data
#endif

-----
cat >$OUT_DIR/map/com/dom/param <<'-----'
RESULT
COPY
-----
cat >$OUT_DIR/map/com/dom/vdm <<'-----'
#include <map/com/dom/defs>

 DOMAINS
   DOMAIN -> RESULT
 IMPLEMENTATIONS
   RESULT = + mk_empty
            + mk_one
#ifdef COPY
   RESULT = + uniond
   ELEM1  = + copy
#else
            + union
#endif
   DOMAIN = + fold.dom("RESULT"=#RESULT
		      ,"NULLFCT" = mk_empty
#ifdef COPY
                      ,"FOLDFCT" = uniond
#else
		      ,"FOLDFCT" = union
#endif
		      ,"CVFCT"   = dom##_DOMAIN
		      ,"NOSIGNATURE")
-----
[ -d $OUT_DIR/map/com/domresby ] || mkdir $OUT_DIR/map/com/domresby
cat >$OUT_DIR/map/com/domresby/defs <<'-----'
#ifndef DOMAINSET
#ifdef GEN_DOCU
#define DOMAINSET DomainSet
#else
#error DOMAIN: Parameter 'DOMAINSET' must be defined for operation 'domresby'!
#endif
#endif
-----
cat >$OUT_DIR/map/com/domresby/docu <<'-----'
#include <map/com/domresto/docu>
-----
cat >$OUT_DIR/map/com/domresby/param <<'-----'
DOMAINSET
-----
cat >$OUT_DIR/map/com/domresby/vdm <<'-----'
#include <map/com/domresby/defs>
#define _OPNAME domresby1
#define _ADDPAR DOMAINSET
#include <map/com/domresto/aux>
-----
[ -d $OUT_DIR/map/com/domresto ] || mkdir $OUT_DIR/map/com/domresto
cat >$OUT_DIR/map/com/domresto/aux <<'-----'
 DOMAINS
   DOMAIN -> _ADDPAR
 IMPLEMENTATIONS
   DOMAIN = + mk_empty + union + mk_one
   _ADDPAR = + is_in
   ELEM1  = + copy
   ELEM2  = + copy
   DOMAIN = + fold._OPNAME(RESULT=DOMAIN
		      ,NULLFCT = mk_empty
		      ,FOLDFCT = union
		      ,CVFCT   = _OPNAME##_DOMAIN
		      ,X       = _ADDPAR
		      ,NOSIGNATURE)
#undef _OPNAME
#undef _ADDPAR
-----
cat >$OUT_DIR/map/com/domresto/defs <<'-----'
#ifndef DOMAINSET
#ifdef GEN_DOCU
#define DOMAINSET DomainSet
#else
#error DOMAIN: Parameter 'DOMAINSET' must be defined for operation 'domresto'!
#endif
#endif
-----
cat >$OUT_DIR/map/com/domresto/docu <<'-----'
 General implementation using the 'fold' operation.

 Parameters:
   'DOMAINSET':
                Name of a domain of type ELEM1 -set containing the
                set to which the restriction shall be performed.
                This parameter must be supplied.
-----
cat >$OUT_DIR/map/com/domresto/param <<'-----'
DOMAINSET
-----
cat >$OUT_DIR/map/com/domresto/vdm <<'-----'
#include <map/com/domresto/defs>
#define _OPNAME domresto1
#define _ADDPAR DOMAINSET
#include <map/com/domresto/aux>
-----
[ -d $OUT_DIR/map/com/exist ] || mkdir $OUT_DIR/map/com/exist
cat >$OUT_DIR/map/com/exist/docu <<'-----'
#include <aux/com/exist/docu>
-----
cat >$OUT_DIR/map/com/exist/vdm <<'-----'
#include <aux/com/exist/vdm>
-----
[ -d $OUT_DIR/map/com/exist1 ] || mkdir $OUT_DIR/map/com/exist1
cat >$OUT_DIR/map/com/exist1/docu <<'-----'
#include <aux/com/exist1/docu>
-----
cat >$OUT_DIR/map/com/exist1/gcod <<'-----'
#include <aux/com/exist1/gcod>
-----
cat >$OUT_DIR/map/com/exist1/gtyp <<'-----'
#include <aux/com/exist1/gtyp>
-----
cat >$OUT_DIR/map/com/exist1/vdm <<'-----'
#include <aux/com/exist1/vdm>
-----
[ -d $OUT_DIR/map/com/fold ] || mkdir $OUT_DIR/map/com/fold
cat >$OUT_DIR/map/com/fold/ccod <<'-----'
#include <aux/com/fold/ccod>
-----
cat >$OUT_DIR/map/com/fold/docu <<'-----'
#define Map map
  Implementation of the 'fold' functional using the 'forall' routine
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/map/com/fold/param <<'-----'
ABORTVAL
RESULT
CVFCTRES
FCTNAME
NULLFCT
NULLPARAM
CVFCT
CVFCTVAR
FOLDFCT
NOSIGNATURE
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/map/com/fold/vdm <<'-----'
#include <aux/com/fold/vdm>
-----
[ -d $OUT_DIR/map/com/forrange ] || mkdir $OUT_DIR/map/com/forrange
cat >$OUT_DIR/map/com/forrange/ccod <<'-----'
#define fct forrange
#define tx2 MERGE(T2_forrange,_DOMAIN)
#define tx3 ELEM1
#define tx4 ELEM1
#define ty2 ELEM2
#define incr if (MERGE(is_ge,_ELEM1)(y1,t3) && MERGE(is_ge,_ELEM1)(t4,y1)) (*t2)(y1,y2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/forrange/docu <<'-----'
  general implementation of forrange by forall

  time complexity : as forall
-----
cat >$OUT_DIR/map/com/forrange/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
   ELEM1    = + is_ge
-----
[ -d $OUT_DIR/map/com/forsome ] || mkdir $OUT_DIR/map/com/forsome
cat >$OUT_DIR/map/com/forsome/ccod <<'-----'
#define fct forsome
#define tx2 MERGE(T2_forsome,_DOMAIN)
#define tx3 MERGE(T3_forsome,_DOMAIN)
#define ty2 ELEM2
#define incr if ((*t2)(y1)) (*t3)(y1,y2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/forsome/docu <<'-----'
  general implementation of forsome by forall
  time complexity : as forall
-----
cat >$OUT_DIR/map/com/forsome/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
-----
[ -d $OUT_DIR/map/com/fread ] || mkdir $OUT_DIR/map/com/fread
cat >$OUT_DIR/map/com/fread/ccod <<'-----'
#ifndef MAXPATHLEN
#define MAXFNLEN 256
#else
#define MAXFNLEN MAXPATHLEN
#endif

#undef __BSD42__
_IF defined(__BSD42__)
_DEFINE dirent direct
_ENDIF

DOMAIN fread##_DOMAIN _FPH1(Str)
   {char path[MAXFNLEN];
    DIR * dp;
    DOMAIN m1;
    cpc_str(x1,path);
    m1 = mk_empty##_DOMAIN();
    if (dp = opendir(path))
      {struct dirent * dep;
       while (dep = readdir(dp))
        {if (dep->d_name[0] != '.') /* filter hidden files */
         {ELEM1 d1;
          d1 = mkc##_ELEM1(dep->d_name);
          {ELEM2 r1;
           Str fn;
           fn = conc_path_str(copy_str(x1),mkc_str(dep->d_name));
           r1 = fread##_ELEM2(fn);
           del_str(fn);
           m1 = ovwrt1##_DOMAIN(m1,d1,r1);
        }}}
       closedir(dp);
      }
    return m1;
   }
   
_UNDEF dirent

#undef MAXFNLEN
-----
cat >$OUT_DIR/map/com/fread/docu <<'-----'
  general implementation of fread
  fread constructs the empty map and extends it with ovwrt1

  time complexity : n * O(ovwrt1)
-----
cat >$OUT_DIR/map/com/fread/param <<'-----'
MAXPATHLEN
NOREADELEM2
-----
cat >$OUT_DIR/map/com/fread/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + mk_empty + ovwrt1
   ELEM1    =  + mkc
#ifndef NOREADELEM2
   ELEM2    =  + fread
#endif
   Vdmlib   =  + header("TYPES","DIRENT")
   Str      =  + mkc + cpc + conc + appr + del + copy + conc_path
-----
[ -d $OUT_DIR/map/com/fwrite ] || mkdir $OUT_DIR/map/com/fwrite
cat >$OUT_DIR/map/com/fwrite/ccod <<'-----'
#ifndef MAXPATHLEN
#define MAXFNLEN 256
#else
#define MAXFNLEN MAXPATHLEN
#endif

Bool fwrite##_DOMAIN _FPH2(DOMAIN,Str)
   {char path[MAXFNLEN];
    cpc_str(x2,path);
    mkdir(path,-1);
    return fwrite1##_DOMAIN(x1,x2);
   }

Bool fwrite2##_ELEM1##_ELEM2 _FPH3(ELEM1,ELEM2,Str)
   {Str y1;
    Bool r1;
    {Nat1 i = 1; /* conversion from ELEM1 to Str */
     Nat0 l = len##_ELEM1(x1);
     y1 = mk_empty_str();
     while (i <= l) {y1 = appr_str(y1,sel##_ELEM1(x1,i));i++;}
    }
    y1 = conc_path_str(copy_str(x3),y1);
    r1 = fwrite##_ELEM2(x2,y1);
    del_str(y1);
    return r1;
   }
#undef MAXFNLEN
-----
cat >$OUT_DIR/map/com/fwrite/docu <<'-----'
  general implementation of fwrite
-----
cat >$OUT_DIR/map/com/fwrite/param <<'-----'
MAXPATHLEN
NOWRITEELEM2
-----
cat >$OUT_DIR/map/com/fwrite/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + fold.fwrite1("RESULT"=Bool,
                              "NULLFCT"=true,
                              "FOLDFCT"=and,
                              "CVFCT"=fwrite2,
                              "X"=Str)
   ELEM1    =  + len + sel
#ifndef NOWRITEELEM2
   ELEM2    =  + fwrite
#endif
   Str      =  + copy + del + conc_path + appr + mk_empty + cpc
   Bool     =  + true + and
   Vdmlib   =  + header("DIRENT","STAT","TYPES")
-----
[ -d $OUT_DIR/map/com/hash ] || mkdir $OUT_DIR/map/com/hash
cat >$OUT_DIR/map/com/hash/ccod <<'-----'
#define fct hash
#define result Nat0
#define ty2 ELEM2
#define inires 0
#define incr r1 += MERGE(hash,_ELEM1)(y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/hash/docu <<'-----'
  general implementation of hash for maps
  as hashvalue the sum of the hashvalues of the domain elements is taken

  time complexity : O(n) * O(hash(ELEM1))
-----
cat >$OUT_DIR/map/com/hash/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall
   ELEM1    =  + hash
-----
[ -d $OUT_DIR/map/com/inters ] || mkdir $OUT_DIR/map/com/inters
cat >$OUT_DIR/map/com/inters/ccod <<'-----'
#define fct inters
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 DOMAIN
#define ty2 ELEM2
#define incr {ELEM2 z2; if (MERGE(is_in_dom,_DOMAIN)(y1,t2,&z2) && MERGE(is_eq,_ELEM2)(y2,z2)) r1 = MERGE(union1,_DOMAIN)(r1,y1,y2);}
#define resfin MERGE(del1,_DOMAIN)(x1);MERGE(del1,_DOMAIN)(x2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/inters/docu <<'-----'
  general implementation of inters with is_in_dom and union1

  time complexity : O(n) * max{ O(is_in_dom), O(union1) }
-----
cat >$OUT_DIR/map/com/inters/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + is_in_dom + union1 + forall + del1
-----
[ -d $OUT_DIR/map/com/intersd ] || mkdir $OUT_DIR/map/com/intersd
cat >$OUT_DIR/map/com/intersd/ccod <<'-----'
#define fct intersd
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 DOMAIN
#define ty2 ELEM2
#define incr {ELEM2 z2; if (MERGE(is_in_dom,_DOMAIN)(y1,t2,&z2) && MERGE(is_eq,_ELEM2)(y2,z2)) r1 = MERGE(union1,_DOMAIN)(r1,y1,y2);else {MERGE(del,_ELEM1)(y1);MERGE(del,_ELEM2)(y2);}}
#define resfin MERGE(del1,_DOMAIN)(x1);MERGE(del,_DOMAIN)(x2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/intersd/docu <<'-----'
  general implementation of intersd with is_in_dom and union1

  time complexity : O(n) * max{ O(is_in_dom), O(union1) }
-----
cat >$OUT_DIR/map/com/intersd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + is_in_dom + union1 + forall + del1 + del
   ELEM1    = + del
   ELEM2    = + del
-----
[ -d $OUT_DIR/map/com/is_empty ] || mkdir $OUT_DIR/map/com/is_empty
cat >$OUT_DIR/map/com/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) { return card##_DOMAIN(x1) == 0; }
-----
cat >$OUT_DIR/map/com/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (card##_DOMAIN(x1) == 0)
-----
cat >$OUT_DIR/map/com/is_empty/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/com/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (card##_DOMAIN(x1) = 0)
-----
cat >$OUT_DIR/map/com/is_empty/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN  = + card
-----
[ -d $OUT_DIR/map/com/is_eq ] || mkdir $OUT_DIR/map/com/is_eq
cat >$OUT_DIR/map/com/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return (card##_DOMAIN(x1) == card##_DOMAIN(x2))   
           && is_submap##_DOMAIN(x1,x2);
   }        
-----
cat >$OUT_DIR/map/com/is_eq/docu <<'-----'
  general implementation of is_eq:

  is_eq(x1,x2) =
      (card x1 = card x2)
      & is_submap(x1,x2)

  time complexity : max(O(card),O(is_subset))
-----
cat >$OUT_DIR/map/com/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + card + is_submap
-----
[ -d $OUT_DIR/map/com/is_ge ] || mkdir $OUT_DIR/map/com/is_ge
cat >$OUT_DIR/map/com/is_ge/ccod <<'-----'
#include <com/aux/is_ge/ccod>
-----
cat >$OUT_DIR/map/com/is_ge/docu <<'-----'
#include <com/aux/is_ge/docu>
-----
cat >$OUT_DIR/map/com/is_ge/vdm <<'-----'
#include <com/aux/is_ge/vdm>
-----
[ -d $OUT_DIR/map/com/is_in ] || mkdir $OUT_DIR/map/com/is_in
cat >$OUT_DIR/map/com/is_in/ccod <<'-----'
  Bool is_in##_DOMAIN _FPH2(ELEM1,DOMAIN)
    { ELEM2 lx1; return is_in_dom##_DOMAIN(x1,x2,&lx1); }
-----
cat >$OUT_DIR/map/com/is_in/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN  = + is_in_dom
    Vdmlib  = + err_smap
-----
[ -d $OUT_DIR/map/com/is_in_max ] || mkdir $OUT_DIR/map/com/is_in_max
cat >$OUT_DIR/map/com/is_in_max/ccod <<'-----'

#define fct is_in_max
#define result Bool
#define tx1 ELEM1
#define tx2 DOMAIN
#define tx3 ELEM1 *
#define ty2 ELEM2
#define tl1 ELEM1
#define incr {if (MERGE(is_ge,_ELEM1)(t1,y1) && ((! r1) || MERGE(is_ge,_ELEM1)(y1,l1) )) {r1=1;l1=y1;}}
#define inires 0
#define resfin if (r1) *x3=l1;
#define forx x2
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/is_in_max/docu <<'-----'
  general implementation of is_in_max with is_ge##_ELEM1 and forall

  time complexity : O(n) * O(is_ge##_ELEM1)
-----
cat >$OUT_DIR/map/com/is_in_max/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
   ELEM1    = + is_ge
-----
[ -d $OUT_DIR/map/com/is_in_min ] || mkdir $OUT_DIR/map/com/is_in_min
cat >$OUT_DIR/map/com/is_in_min/ccod <<'-----'

#define fct is_in_min
#define result Bool
#define tx1 ELEM1
#define tx2 DOMAIN
#define tx3 ELEM1 *
#define ty2 ELEM2
#define tl1 ELEM1
#define incr {if (MERGE(is_ge,_ELEM1)(y1,t1) && ((! r1) || MERGE(is_ge,_ELEM1)(l1,y1) )) {r1=1;l1=y1;}}
#define inires 0
#define resfin if (r1) *x3=l1;
#define forx x2
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/is_in_min/docu <<'-----'
  general implementation of is_in_min with is_ge##_ELEM1 and forall

  time complexity : O(n) * O(is_ge##_ELEM1)
-----
cat >$OUT_DIR/map/com/is_in_min/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
   ELEM1    = + is_ge
-----
[ -d $OUT_DIR/map/com/is_in_rng ] || mkdir $OUT_DIR/map/com/is_in_rng
cat >$OUT_DIR/map/com/is_in_rng/ccod <<'-----'

#define _NAME(x) MERGE(MERGE(MERGE(_,x),_tmp_is_in_rng),_DOMAIN)

static Bool  _NAME(t1);
static ELEM1 _NAME(t2);
static ELEM2 _NAME(t3);

static void _NAME(p1) _FPH2(ELEM1,ELEM2)
  { if (is_eq##_ELEM2(x2,_NAME(t3))) { _NAME(t1) = 1; _NAME(t2) = x1; } }

  Bool is_in_rng##_DOMAIN _FPH3(ELEM2,DOMAIN,ELEM1*)
    { _NAME(t1) = 0;
      _NAME(t3) = x1;
      forall##_DOMAIN(x2,_NAME(p1));
      *x3 = _NAME(t2);
      return _NAME(t1);
    }
#undef _NAME
-----
cat >$OUT_DIR/map/com/is_in_rng/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN  = + forall
    ELEM2   = + is_eq
-----
[ -d $OUT_DIR/map/com/is_submap ] || mkdir $OUT_DIR/map/com/is_submap
cat >$OUT_DIR/map/com/is_submap/ccod <<'-----'

#define fct is_submap
#define result Bool
#define tx1 DOMAIN
#define tx2 DOMAIN
#define ty2 ELEM2
#define incr {ELEM2 z2; r1 = r1 && MERGE(is_in_dom,_DOMAIN)(y1,t2,&z2) && MERGE(is_eq,_ELEM2)(y2,z2);}
#define inires (MERGE(card,_DOMAIN)(t1) <= MERGE(card,_DOMAIN)(t2))
#define forloop if (r1) MERGE(forall,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/is_submap/docu <<'-----'
  general implementation of is_submap :

  is_submap(x1,x2) =
    (card x1  <= card x2)
    & (All i e x1)(i e x2 & x1(i) = x2(i))

  time complexity : O(n) * max(O(is_in_dom),O(is_eq##_ELEM2))
-----
cat >$OUT_DIR/map/com/is_submap/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_in_dom + card + forall
   ELEM2    = + is_eq
-----
[ -d $OUT_DIR/map/com/iterator ] || mkdir $OUT_DIR/map/com/iterator
cat >$OUT_DIR/map/com/iterator/ccod <<'-----'
COMMENT_( DOMAIN: iterator operations not available for this implementation )
-----
cat >$OUT_DIR/map/com/iterator/docu <<'-----'
#define MAP
#include <aux/com/iterator/docu>
-----
cat >$OUT_DIR/map/com/iterator/param <<'-----'
INTERNALFCT
-----
[ -d $OUT_DIR/map/com/max_dom ] || mkdir $OUT_DIR/map/com/max_dom
cat >$OUT_DIR/map/com/max_dom/ccod <<'-----'

#define fct max_dom
#define ty2 ELEM2
#define result ELEM1
#define tx1 DOMAIN
#define tl1 Bool 
#define incr {if ((! l1) || MERGE(is_ge,_ELEM1)(y1,r1) ) {l1=1;r1=y1;}}
#define inil1 0
#define resfin if (! l1) {err_emap_vdmlib(MKSTRING(DOMAIN));}

#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/max_dom/docu <<'-----'
  general implementation of max_dom using is_ge##_ELEM1 and forall

  time complexity : O(n) * O(is_ge##_ELEM1)
-----
cat >$OUT_DIR/map/com/max_dom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
   Vdmlib   = + err_emap
   ELEM1    = + is_ge
-----
[ -d $OUT_DIR/map/com/mfolddom ] || mkdir $OUT_DIR/map/com/mfolddom
cat >$OUT_DIR/map/com/mfolddom/ccod <<'-----'
#include <aux/com/mfolddom/ccod>
-----
cat >$OUT_DIR/map/com/mfolddom/gtyp <<'-----'
#include <aux/com/mfolddom/gtyp>
-----
cat >$OUT_DIR/map/com/mfolddom/param <<'-----'
FCTNAME
NEXTDOM
CALLDOM
XN
-----
[ -d $OUT_DIR/map/com/min_dom ] || mkdir $OUT_DIR/map/com/min_dom
cat >$OUT_DIR/map/com/min_dom/ccod <<'-----'
#define fct min_dom
#define ty2 ELEM2
#define result ELEM1
#define tx1 DOMAIN
#define tl1 Bool 
#define incr {if ((! l1) || MERGE(is_ge,_ELEM1)(r1,y1) ) {l1=1;r1=y1;}}
#define inil1 0
#define resfin if (! l1) {err_emap_vdmlib(MKSTRING(DOMAIN));}

#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/min_dom/docu <<'-----'
  general implementation of min_dom using is_ge##_ELEM1 and forall

  time complexity : O(n) * O(is_ge##_ELEM1)
-----
cat >$OUT_DIR/map/com/min_dom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
   Vdmlib   = + err_emap
   ELEM1    = + is_ge
-----
[ -d $OUT_DIR/map/com/mk1 ] || mkdir $OUT_DIR/map/com/mk1
cat >$OUT_DIR/map/com/mk1/ccod <<'-----'
  DOMAIN mk1##_DOMAIN _FPH2(ELEM1,ELEM2)
    { return union1##_DOMAIN(mk_empty##_DOMAIN(),x1,x2); }
-----
cat >$OUT_DIR/map/com/mk1/cmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1,x2) union1##_DOMAIN(mk_empty##_DOMAIN(),x1,x2)
-----
cat >$OUT_DIR/map/com/mk1/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/com/mk1/pmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1,x2) union1##_DOMAIN(mk_empty##_DOMAIN,x1,x2)
-----
cat >$OUT_DIR/map/com/mk1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN  = + union1 + mk_empty

#define CONSTRNAME mk1
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/com/ovwrt ] || mkdir $OUT_DIR/map/com/ovwrt
cat >$OUT_DIR/map/com/ovwrt/docu <<'-----'
  general implementation of ovwrt with ovwrt1

  time complexity : O(n) * O(ovwrt1)
-----
cat >$OUT_DIR/map/com/ovwrt/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.ovwrt("FOLDFCT"="ovwrt1",DELETE,NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/map/com/ovwrtd ] || mkdir $OUT_DIR/map/com/ovwrtd
cat >$OUT_DIR/map/com/ovwrtd/docu <<'-----'
  general implementation of ovwrtd with ovwrt1d

  time complexity : O(n) * O(ovwrt1d)
-----
cat >$OUT_DIR/map/com/ovwrtd/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.ovwrtd("FOLDFCT"="ovwrt1d",DELETE,NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/map/com/parse ] || mkdir $OUT_DIR/map/com/parse
cat >$OUT_DIR/map/com/parse/ccod <<'-----'
#define START_SYM '['
#define STOP_SYM ']'
#define ADD_TO union1d
#include <aux/com/parsem/ccod>
-----
cat >$OUT_DIR/map/com/parse/docu <<'-----'

#ifdef GEN_ISO
  Syntax:  '[' [<ELEM1> |-> <ELEM2> (',' <ELEM1> |-> <ELEM2>)* ] ']'
#else
  Syntax:  '[' [<ELEM1> :-> <ELEM2> (',' <ELEM1> :-> <ELEM2>)* ] ']'
#endif

-----
cat >$OUT_DIR/map/com/parse/vdm <<'-----'
#define ADD_TO union1d
#include <aux/com/parsem/vdm>
-----
[ -d $OUT_DIR/map/com/print ] || mkdir $OUT_DIR/map/com/print
cat >$OUT_DIR/map/com/print/ccod <<'-----'
#define step ","
#ifdef GEN_ISO
#define stup " |-> "
#define start "{"
#define stop "}"
#else
#define stup " :-> "
#define start "["
#define stop "]"
#endif
#include <aux/com/print/ccod>
-----
cat >$OUT_DIR/map/com/print/docu <<'-----'
#ifdef GEN_ISO
  prints a map in the format "[d1|->r1,...,dn|->rn]"
#else
  prints a map in the format "[d1:->r1,...,dn:->rn]"
#endif
-----
cat >$OUT_DIR/map/com/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall + is_empty
   ELEM1    = + print
   ELEM2    = + print
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/map/com/ran ] || mkdir $OUT_DIR/map/com/ran
cat >$OUT_DIR/map/com/ran/docu <<'-----'
  General implementation of the range operator.

  Parameters:

   'RESULT':
             Supplies the name of the resulting set domain.
             This parameter must be supplied.

#ifndef BASEIMPL
   'COPY':
             if this parameter is given, a complete copy
             of the elements in the range of the map
             is performed during the computation
             such that the result and the argument do not share
             any data
#endif


-----
cat >$OUT_DIR/map/com/ran/param <<'-----'
RESULT
COPY
-----
cat >$OUT_DIR/map/com/ran/vdm <<'-----'
#include <map/com/dom/defs>

 DOMAINS
   DOMAIN -> RESULT
 IMPLEMENTATIONS
   RESULT = + mk_empty
            + mk_one
#ifdef COPY
   RESULT = + uniond
   ELEM2  = + copy
#else
            + union
#endif
   DOMAIN = + fold.ran("RESULT"=#RESULT
		      ,"NULLFCT" = mk_empty
#ifdef COPY
                      ,"FOLDFCT" = uniond
#else
		      ,"FOLDFCT" = union
#endif
		      ,"CVFCT"   = ran##_DOMAIN
		      ,"NOSIGNATURE")
-----
[ -d $OUT_DIR/map/com/ranresby ] || mkdir $OUT_DIR/map/com/ranresby
cat >$OUT_DIR/map/com/ranresby/defs <<'-----'
#ifndef RANGESET
#error DOMAIN: Parameter 'RANGESET' must be defined for operation 'ranresby'!
#endif
-----
cat >$OUT_DIR/map/com/ranresby/docu <<'-----'
#include <map/com/ranresto/docu>
-----
cat >$OUT_DIR/map/com/ranresby/param <<'-----'
RANGESET
-----
cat >$OUT_DIR/map/com/ranresby/vdm <<'-----'
#include <map/com/ranresby/defs>
#define _OPNAME ranresby
#define _ADDPAR RANGESET
#include <map/com/domresto/aux>
-----
[ -d $OUT_DIR/map/com/ranresto ] || mkdir $OUT_DIR/map/com/ranresto
cat >$OUT_DIR/map/com/ranresto/defs <<'-----'
#ifndef RANGESET
#error DOMAIN: Parameter 'RANGESET' must be defined for operation 'ranresto'!
#endif

-----
cat >$OUT_DIR/map/com/ranresto/docu <<'-----'
 General implementation using the 'fold' operation.

 Parameters:
   'RANGESET':	Name of a domain of type ELEM2 -set containing the
		set to which the restriction shall be performed.
		This parameter must be supplied.
-----
cat >$OUT_DIR/map/com/ranresto/param <<'-----'
RANGESET
-----
cat >$OUT_DIR/map/com/ranresto/vdm <<'-----'
#include <map/com/ranresto/defs>
#define _OPNAME ranresto
#define _ADDPAR RANGESET
#include <map/com/domresto/aux>
-----
[ -d $OUT_DIR/map/com/sel ] || mkdir $OUT_DIR/map/com/sel
cat >$OUT_DIR/map/com/sel/ccod <<'-----'
  ELEM2 sel##_DOMAIN _FPH2(DOMAIN,ELEM1)
    { ELEM2 lx1;
      if (! is_in_dom##_DOMAIN(x2,x1,&lx1))
         err_smap_vdmlib(MKSTRING(DOMAIN));
      return lx1;
    }
-----
cat >$OUT_DIR/map/com/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_in_dom
   Vdmlib   = + err_smap
-----
[ -d $OUT_DIR/map/com/sel_dom ] || mkdir $OUT_DIR/map/com/sel_dom
cat >$OUT_DIR/map/com/sel_dom/ccod <<'-----'
#define fct sel_dom
#define result ELEM1
#define tx1 DOMAIN
#define ty1 ELEM1
#define ty2 ELEM2
#define tl1 Bool
#define inil1 0
#define forloop if (MERGE(is_empty,_DOMAIN)(x1)) err_emap_vdmlib(MKSTRING(DOMAIN)); MERGE(forall,_DOMAIN)
#define incr if (! l1) {l1=1;r1=y1;}
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/sel_dom/docu <<'-----'
  General implementation of 'sel_dom' implementing by iterating over
  the whole map (using 'forall') and collecting one arbitrary element.

  Time characteristics: O(forall)
-----
cat >$OUT_DIR/map/com/sel_dom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_empty + forall
   Vdmlib   = + err_emap
-----
[ -d $OUT_DIR/map/com/sub ] || mkdir $OUT_DIR/map/com/sub
cat >$OUT_DIR/map/com/sub/ccod <<'-----'
#define fct sub
#define result DOMAIN
#define inires x1
#define tx2 DOMAIN
#define ty1 ELEM1
#define ty2 ELEM2
#define incr r1 = MERGE(sub1,_DOMAIN)(r1,y1);
#define forx x2
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/sub/docu <<'-----'
  general implementation of sub with sub1

  time complexity : O(n) * O(sub1)
-----
cat >$OUT_DIR/map/com/sub/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + sub1 + forall
-----
[ -d $OUT_DIR/map/com/subd ] || mkdir $OUT_DIR/map/com/subd
cat >$OUT_DIR/map/com/subd/ccod <<'-----'
#define fct subd
#define result DOMAIN
#define inires x1
#define tx2 DOMAIN
#define ty1 ELEM1
#define ty2 ELEM2
#define incr r1 = MERGE(sub1d,_DOMAIN)(r1,y1);
#define forx x2
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/map/com/subd/docu <<'-----'
  general implementation of subd with sub1d

  time complexity : O(n) * O(sub1d)
-----
cat >$OUT_DIR/map/com/subd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + sub1d + forall
-----
[ -d $OUT_DIR/map/com/union ] || mkdir $OUT_DIR/map/com/union
cat >$OUT_DIR/map/com/union/docu <<'-----'
  general implementation of union with union1

  time complexity : O(n) * O(union1)
-----
cat >$OUT_DIR/map/com/union/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.union("FOLDFCT"="union1",DELETE,NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/map/com/uniond ] || mkdir $OUT_DIR/map/com/uniond
cat >$OUT_DIR/map/com/uniond/docu <<'-----'
  general implementation of uniond with union1d

  time complexity : O(n) * O(union1d)
-----
cat >$OUT_DIR/map/com/uniond/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.uniond("FOLDFCT"="union1d",DELETE,NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/map/dir ] || mkdir $OUT_DIR/map/dir
[ -d $OUT_DIR/map/dir/basic ] || mkdir $OUT_DIR/map/dir/basic
cat >$OUT_DIR/map/dir/basic/ccod <<'-----'
#include <map/dir/basic/def>
  /* just remembers the pathname of the file to be read */
R2##_DOMAIN fread_r2##_DOMAIN _FPH1(Str) {return mk_ud(copy_str(x1));}   

  /* assures that the file is read */
ELEM2 checkread##_DOMAIN _FPH1(R2##_DOMAIN)
   {if (is_ud(x1))
      {Str x2;
       x2 = s_ud(x1);
       x1 = ovwrt_rd(x1,fread##_ELEM2(x2));
       del_str(x2);
      }
    return s_rd(x1);
   }
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/basic/def <<'-----'
#ifdef SELSUFFIX
#define mk_ud MERGE(MERGE(MERGE(mk_u,_DOMAIN),_r2),_DOMAIN)
#define s_ud MERGE(MERGE(MERGE(s_u,_DOMAIN),_r2),_DOMAIN)
#define is_ud MERGE(MERGE(MERGE(is_u,_DOMAIN),_r2),_DOMAIN)
#define mk_rd MERGE(MERGE(MERGE(mk_r,_DOMAIN),_r2),_DOMAIN)
#define s_rd MERGE(MERGE(MERGE(s_r,_DOMAIN),_r2),_DOMAIN)
#define is_rd MERGE(MERGE(MERGE(is_r,_DOMAIN),_r2),_DOMAIN)
#define ovwrt_rd MERGE(MERGE(MERGE(ovwrt_r,_DOMAIN),_r2),_DOMAIN)
#else
#define mk_ud MERGE(mk_u,_DOMAIN)
#define s_ud MERGE(s_u,_DOMAIN)
#define is_ud MERGE(is_u,_DOMAIN)
#define mk_rd MERGE(mk_r,_DOMAIN)
#define s_rd MERGE(s_r,_DOMAIN)
#define is_rd MERGE(is_r,_DOMAIN)
#define ovwrt_rd MERGE(ovwrt_r,_DOMAIN)
#endif
-----
cat >$OUT_DIR/map/dir/basic/defp <<'-----'
#ifndef MAPIMP
#define MAPIMP linklist("INTERNALDOMAIN")
#endif
-----
cat >$OUT_DIR/map/dir/basic/docu <<'-----'
  Implementation of

     DOMAIN  =  ELEM1 -m-> ELEM2

  as a directory of a filesystem.


  ELEM1 must be a domain of type Char * (usually Str)
  ELEM2 must be a domain for that fread and fwrite functions
  exist for reading a subcomponent of a directory, a plain file
  modelled as tuple domain or a subdirectory modelled as a map.
  The reading of the subcomponents is done in a "lasy" way, that means
  the file is read when accessing a ELEM2 value the first time.

  The implementation is useful when working on directories,
  where only some parts of the directory are realy needed.

  Parameter:

  'MAPIMP' :
              gives the implementation name of the underlying map
              implementation in main memory that corresponds to the
              directory value in the file system.
              Default is linklist.

  Examples:
   
    DOMAINS
      DOMAIN  =  Str -m-> Str

    IMPLEMENTATIONS
      DOMAIN  =  dir(MAPIMP="linklist")
       
-----
cat >$OUT_DIR/map/dir/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/dir/basic/gtyp <<'-----'
  TYPE_DEF(DOMAIN,R1##_DOMAIN)

#ifdef GEN_C
  FUNCDEC(MERGE(checkread,_DOMAIN),PL_1(MERGE(R2,_DOMAIN)),ELEM2)
  FUNCDEC(MERGE(fread_r2,_DOMAIN),PL_1(Str),MERGE(R2,_DOMAIN))
_DEFINE profile##_DOMAIN() profile_r1##_DOMAIN()
#endif
-----
cat >$OUT_DIR/map/dir/basic/param <<'-----'
AUTOMEM
INTERNALDOMAIN
MACROS
MAPIMP
PROFILE
-----
cat >$OUT_DIR/map/dir/basic/undef <<'-----'
#undef mk_ud
#undef s_ud
#undef is_ud
#undef mk_rd
#undef s_rd
#undef is_rd
#undef ovwrt_rd
-----
cat >$OUT_DIR/map/dir/basic/vdm <<'-----'
#include <map/dir/basic/defp>
  DOMAINS
   R1##_DOMAIN     =  ELEM1 -m-> R2##_DOMAIN
   R2##_DOMAIN     =  s_u##_DOMAIN : Str
                   |  s_r##_DOMAIN : ELEM2

   DOMAIN         -> R1##_DOMAIN

  IMPLEMENTATIONS
   R1##_DOMAIN     =  MAPIMP ! ("MACROS") !
   R2##_DOMAIN     =  ptunion("INTERNALDOMAIN")
                             ! ("MACROS") ! + mk + s + is + ovwrt
   ELEM2           =  + fread
   Str             =  + del + copy + mk_empty
   Vdmlib          =  + header("SPRINTF")
#undef MAPIMP

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/dir/card ] || mkdir $OUT_DIR/map/dir/card
cat >$OUT_DIR/map/dir/card/ccod <<'-----'
Nat0 card##_DOMAIN _FPH1(DOMAIN) {return card_r1##_DOMAIN(x1);}
-----
cat >$OUT_DIR/map/dir/card/cmcr <<'-----'
_DEFINE card##_DOMAIN(x1) card_r1##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/dir/card/pmcr <<'-----'
_DEFINE card##_DOMAIN(x1) card_r1##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/dir/card/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  R1##_DOMAIN   = + card
-----
[ -d $OUT_DIR/map/dir/copy1 ] || mkdir $OUT_DIR/map/dir/copy1
cat >$OUT_DIR/map/dir/copy1/ccod <<'-----'
static DOMAIN _r1_copy##_DOMAIN;
static void copy11_r1##_DOMAIN _FPH2(ELEM1,R2##_DOMAIN)
   {_r1_copy##_DOMAIN = ovwrt1_r1##_DOMAIN(_r1_copy##_DOMAIN,x1,copy1_r2##_DOMAIN(x2));}

DOMAIN copy1##_DOMAIN _FPH1(DOMAIN)
   {_r1_copy##_DOMAIN = mk_empty_r1##_DOMAIN();
    forall_r1##_DOMAIN(x1,copy11_r1##_DOMAIN);
    return _r1_copy##_DOMAIN;
   }
-----
cat >$OUT_DIR/map/dir/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  R1##_DOMAIN = + ovwrt1 + mk_empty + forall 
  R2##_DOMAIN = + copy1
-----
[ -d $OUT_DIR/map/dir/del ] || mkdir $OUT_DIR/map/dir/del
cat >$OUT_DIR/map/dir/del/ccod <<'-----'
void del##_DOMAIN _FPH1(DOMAIN)
   { del_r1##_DOMAIN(x1); }
-----
cat >$OUT_DIR/map/dir/del/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  R1##_DOMAIN  = + del
-----
[ -d $OUT_DIR/map/dir/del1 ] || mkdir $OUT_DIR/map/dir/del1
cat >$OUT_DIR/map/dir/del1/ccod <<'-----'
static void del11_r1##_DOMAIN _FPH2(ELEM1,R2##_DOMAIN)
   {del1_r2##_DOMAIN(x2);}

void del1##_DOMAIN _FPH1(DOMAIN)
   {
    forall_r1##_DOMAIN(x1,del11_r1##_DOMAIN);
    del1_r1##_DOMAIN(x1);
   }
-----
cat >$OUT_DIR/map/dir/del1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  R1##_DOMAIN  = + del1 + forall
  R2##_DOMAIN  = + del1
-----
[ -d $OUT_DIR/map/dir/forall ] || mkdir $OUT_DIR/map/dir/forall
cat >$OUT_DIR/map/dir/forall/ccod <<'-----'
static T2_forall##_DOMAIN tmp_forall##_DOMAIN;
static void help_forall##_DOMAIN _FPH2(ELEM1,R2##_DOMAIN)
   { (*tmp_forall##_DOMAIN)(x1,checkread##_DOMAIN(x2)); }

void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
    { T2_forall##_DOMAIN lx1 = tmp_forall##_DOMAIN;
      tmp_forall##_DOMAIN = x2;
      forall_r1##_DOMAIN(x1,help_forall##_DOMAIN);
      tmp_forall##_DOMAIN = lx1;
    }
-----
cat >$OUT_DIR/map/dir/forall/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  R1##_DOMAIN  = + forall
  R2##_DOMAIN  = + s
-----
[ -d $OUT_DIR/map/dir/fread ] || mkdir $OUT_DIR/map/dir/fread
cat >$OUT_DIR/map/dir/fread/ccod <<'-----'
DOMAIN fread##_DOMAIN _FPH1(Str) {return fread_r1##_DOMAIN(x1);}
-----
cat >$OUT_DIR/map/dir/fread/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  R1##_DOMAIN   = + fread("NOREADELEM2") ! hinders transitive includes of fread !
                                      ! for ELEM2 of R1_DOMAIN               !
-----
[ -d $OUT_DIR/map/dir/fwrite ] || mkdir $OUT_DIR/map/dir/fwrite
cat >$OUT_DIR/map/dir/fwrite/ccod <<'-----'
#include <map/dir/basic/def>
#ifndef MAXPATHLEN
#define MAXFNLEN 256
#else
#define MAXFNLEN MAXPATHLEN
#endif

Bool fwrite_r2##_DOMAIN _FPH2(R2##_DOMAIN,Str)
   {
    return (is_ud(x1) && is_eq_str(s_ud(x1),x2))
           ? 0
           : fwrite##_ELEM2(checkread##_DOMAIN(x1),x2);
   } 

Bool fwrite##_DOMAIN _FPH2(DOMAIN,Str)
   { return fwrite_r1##_DOMAIN(x1,x2); }

#undef MAXFNLEN
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/fwrite/gtyp <<'-----'
#ifdef GEN_C
extern Bool fwrite_r2##_DOMAIN P_OP R2##_DOMAIN x1, Str x2 P_CL ;
#endif
-----
cat >$OUT_DIR/map/dir/fwrite/param <<'-----'
MAXPATHLEN
-----
cat >$OUT_DIR/map/dir/fwrite/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  ELEM2        = + fwrite
  R1##_DOMAIN   = + fwrite("NOWRITEELEM2") ! hinders transitive includes of fwrite !
                                        ! for ELEM2 of R1_DOMAIN                !
  R2##_DOMAIN   = + is + s
  Str          = + is_eq
-----
[ -d $OUT_DIR/map/dir/is_in_dom ] || mkdir $OUT_DIR/map/dir/is_in_dom
cat >$OUT_DIR/map/dir/is_in_dom/ccod <<'-----'
Bool is_in_dom##_DOMAIN _FPH3(ELEM1,DOMAIN,ELEM2 *)
   {R2##_DOMAIN x4; 
    Bool r;
    if ((r = is_in_dom_r1##_DOMAIN(x1,x2,&x4)))
       {*x3 = checkread##_DOMAIN(x4);}
    return r;
   }
-----
cat >$OUT_DIR/map/dir/is_in_dom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   R1##_DOMAIN  = + is_in_dom
-----
[ -d $OUT_DIR/map/dir/iterator ] || mkdir $OUT_DIR/map/dir/iterator
cat >$OUT_DIR/map/dir/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/map/dir/iterator/vdm <<'-----'
#define IMPL dir
#include <aux/com/iterator/vdm>

DOMAINS
IMPLEMENTATIONS
  R1##_DOMAIN = + iterator("INTERNALFCT")
-----
[ -d $OUT_DIR/map/dir/mk_empty ] || mkdir $OUT_DIR/map/dir/mk_empty
cat >$OUT_DIR/map/dir/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() {return mk_empty_r1##_DOMAIN();}
-----
cat >$OUT_DIR/map/dir/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() mk_empty_r1##_DOMAIN()
-----
cat >$OUT_DIR/map/dir/mk_empty/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/dir/mk_empty/pmcr <<'-----'
_DEFINE mk_empty##_DOMAIN mk_empty_r1##_DOMAIN
-----
cat >$OUT_DIR/map/dir/mk_empty/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   R1##_DOMAIN  = + mk_empty

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/dir/ovwrt1 ] || mkdir $OUT_DIR/map/dir/ovwrt1
cat >$OUT_DIR/map/dir/ovwrt1/ccod <<'-----'
#include <map/dir/basic/def>
DOMAIN ovwrt1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
   {R2##_DOMAIN x4;
    if (is_in_dom_r1##_DOMAIN(x2,x1,&x4))
      {if (is_ud(x4)) {del_str(s_ud(x4));}
       del1_r2##_DOMAIN(x4);
      }
    return ovwrt1_r1##_DOMAIN(x1,x2,mk_rd(x3));
   }
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/ovwrt1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   R1##_DOMAIN     = + is_in_dom + ovwrt1 
   R2##_DOMAIN     = + is + s + mk + del1
   Str            = + del
-----
[ -d $OUT_DIR/map/dir/ovwrt1d ] || mkdir $OUT_DIR/map/dir/ovwrt1d
cat >$OUT_DIR/map/dir/ovwrt1d/ccod <<'-----'
#include <map/dir/basic/def>
DOMAIN ovwrt1d##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
    {return ovwrt1d_r1##_DOMAIN(x1,x2,mk_rd(x3));}
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/ovwrt1d/cmcr <<'-----'
#include <map/dir/basic/def>
_DEFINE ovwrt1d##_DOMAIN(x1,x2,x3) ovwrt1d_r1##_DOMAIN(x1,x2,mk_rd(x3))
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/ovwrt1d/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/dir/ovwrt1d/pmcr <<'-----'
#include <map/dir/basic/def>
_DEFINE ovwrt1d##_DOMAIN(x1,x2,x3) ovwrt1d_r1##_DOMAIN(x1,x2,mk_rd(x3))
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   R1##_DOMAIN     = + ovwrt1d
   R2##_DOMAIN     = + mk
-----
[ -d $OUT_DIR/map/dir/sub1 ] || mkdir $OUT_DIR/map/dir/sub1
cat >$OUT_DIR/map/dir/sub1/ccod <<'-----'
#include <map/dir/basic/defp>
#include <map/dir/basic/def>

DOMAIN sub1##_DOMAIN _FPH2(DOMAIN,ELEM1)
   {R2##_DOMAIN x4;
    if (is_in_dom_r1##_DOMAIN(x2,x1,&x4))
      {if (is_ud(x4)) {del_str(s_ud(x4));}
       del1_r2##_DOMAIN(x4);
      }
    return sub1_r1##_DOMAIN(x1,x2);
   }
#undef MAPIMP
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/sub1/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/dir/sub1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   R1##_DOMAIN     = + is_in_dom + sub1
   R2##_DOMAIN     = + is + s + del1
   Str            = + del
-----
[ -d $OUT_DIR/map/dir/sub1d ] || mkdir $OUT_DIR/map/dir/sub1d
cat >$OUT_DIR/map/dir/sub1d/ccod <<'-----'
DOMAIN sub1d##_DOMAIN _FPH2(DOMAIN,ELEM1)
   {return sub1d_r1##_DOMAIN(x1,x2);}
-----
cat >$OUT_DIR/map/dir/sub1d/cmcr <<'-----'
_DEFINE sub1d##_DOMAIN(x1,x2) sub1d_r1##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/map/dir/sub1d/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/dir/sub1d/pmcr <<'-----'
_DEFINE sub1d##_DOMAIN(x1,x2) sub1d_r1##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/map/dir/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   R1##_DOMAIN  = + sub1d
-----
[ -d $OUT_DIR/map/dir/union1 ] || mkdir $OUT_DIR/map/dir/union1
cat >$OUT_DIR/map/dir/union1/ccod <<'-----'
#include <map/dir/basic/def>
DOMAIN union1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
   {ELEM2 x4;
    if (is_in_dom##_DOMAIN(x2,x1,&x4))
      {if (! is_eq##_ELEM2(x3,x4))
         {err_umap_vdmlib(MKSTRING(DOMAIN));}
       return x1;
      }
    return ovwrt1_r1##_DOMAIN(x1,x2,mk_rd(x3));
   }
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/union1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN      =  + is_in_dom
   R1##_DOMAIN  =  + ovwrt1
   R2##_DOMAIN  =  + mk
   ELEM2       =  + is_eq
   Vdmlib      =  + err_umap
-----
[ -d $OUT_DIR/map/dir/union1d ] || mkdir $OUT_DIR/map/dir/union1d
cat >$OUT_DIR/map/dir/union1d/ccod <<'-----'
#include <map/dir/basic/def>
DOMAIN union1d##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
   {ELEM2 x4;
    if (is_in_dom##_DOMAIN(x2,x1,&x4))
      {if (! is_eq##_ELEM2(x3,x4))
         {err_umap_vdmlib(MKSTRING(DOMAIN));}
      }
    return ovwrt1d_r1##_DOMAIN(x1,x2,mk_rd(x3));
   }
#include <map/dir/basic/undef>
-----
cat >$OUT_DIR/map/dir/union1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN      =  + is_in_dom
   R1##_DOMAIN  =  + ovwrt1
   R2##_DOMAIN  =  + mk
   ELEM2       =  + is_eq
   Vdmlib      =  + err_umap
-----
[ -d $OUT_DIR/map/extern ] || mkdir $OUT_DIR/map/extern
[ -d $OUT_DIR/map/extern/basic ] || mkdir $OUT_DIR/map/extern/basic
cat >$OUT_DIR/map/extern/basic/ccod <<'-----'
-----
cat >$OUT_DIR/map/extern/basic/docu <<'-----'
  Implementation of a Map as an external data structure

  There is no code in the library for the basic
  operations. This code must be supplied by the
  application.

  But the interface information is generated as for
  an ordinary map datatype.

  This allows to model datatypes in the environment
  of the application with the usual operations

  Example:

  A file system can be seen as a map of filenames to
  file contents

     Filesystem  = Filename -m-> Content

  for the operations, e.g.

     'is_in' :  existence of a file
       'sel' :  reading a file
     'ovwrt' :  writing a file

  the interface can be generated, but the implementation
  must be done in the application
 
  all "available" operations in this implementation are
  dummys, to tell the class library generator program
  not to search for a common implementation
-----
cat >$OUT_DIR/map/extern/basic/gptr <<'-----'
#if GEN_C
#ifdef CSTRUCT
#define LCSTRUCT CSTRUCT
#else
#define LCSTRUCT struct {}
#endif
TYPE_DEF(DOMAIN,LCSTRUCT)
#undef LCSTRUCT
#endif
-----
cat >$OUT_DIR/map/extern/basic/param <<'-----'
CSTRUCT
INTERNALDOMAIN
NOIMPLEMENTATIONS
NO_AUTOMEM
-----
cat >$OUT_DIR/map/extern/basic/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = extern("NOIMPLEMENTATIONS")

#if 0
#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
#endif
-----
[ -d $OUT_DIR/map/extern/copy1 ] || mkdir $OUT_DIR/map/extern/copy1
cat >$OUT_DIR/map/extern/copy1/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/default ] || mkdir $OUT_DIR/map/extern/default
cat >$OUT_DIR/map/extern/default/docu <<'-----'
#include <aux/com/default/docunoop>
-----
cat >$OUT_DIR/map/extern/default/vdm <<'-----'
-----
[ -d $OUT_DIR/map/extern/del1 ] || mkdir $OUT_DIR/map/extern/del1
cat >$OUT_DIR/map/extern/del1/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/ext ] || mkdir $OUT_DIR/map/extern/ext
cat >$OUT_DIR/map/extern/ext/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/forall ] || mkdir $OUT_DIR/map/extern/forall
cat >$OUT_DIR/map/extern/forall/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/fpr ] || mkdir $OUT_DIR/map/extern/fpr
cat >$OUT_DIR/map/extern/fpr/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/fread ] || mkdir $OUT_DIR/map/extern/fread
cat >$OUT_DIR/map/extern/fread/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/fwrite ] || mkdir $OUT_DIR/map/extern/fwrite
cat >$OUT_DIR/map/extern/fwrite/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/hash ] || mkdir $OUT_DIR/map/extern/hash
cat >$OUT_DIR/map/extern/hash/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/is_empty ] || mkdir $OUT_DIR/map/extern/is_empty
cat >$OUT_DIR/map/extern/is_empty/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/is_eq ] || mkdir $OUT_DIR/map/extern/is_eq
cat >$OUT_DIR/map/extern/is_eq/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/is_ge ] || mkdir $OUT_DIR/map/extern/is_ge
cat >$OUT_DIR/map/extern/is_ge/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/is_gr ] || mkdir $OUT_DIR/map/extern/is_gr
cat >$OUT_DIR/map/extern/is_gr/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/is_in ] || mkdir $OUT_DIR/map/extern/is_in
cat >$OUT_DIR/map/extern/is_in/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/mk1 ] || mkdir $OUT_DIR/map/extern/mk1
cat >$OUT_DIR/map/extern/mk1/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/mk_empty ] || mkdir $OUT_DIR/map/extern/mk_empty
cat >$OUT_DIR/map/extern/mk_empty/ccod <<'-----'
-----
cat >$OUT_DIR/map/extern/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/extern/ovwrt1 ] || mkdir $OUT_DIR/map/extern/ovwrt1
cat >$OUT_DIR/map/extern/ovwrt1/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/pr ] || mkdir $OUT_DIR/map/extern/pr
cat >$OUT_DIR/map/extern/pr/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/sel ] || mkdir $OUT_DIR/map/extern/sel
cat >$OUT_DIR/map/extern/sel/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/sel_dom ] || mkdir $OUT_DIR/map/extern/sel_dom
cat >$OUT_DIR/map/extern/sel_dom/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/sub1 ] || mkdir $OUT_DIR/map/extern/sub1
cat >$OUT_DIR/map/extern/sub1/ccod <<'-----'
-----
[ -d $OUT_DIR/map/extern/union1 ] || mkdir $OUT_DIR/map/extern/union1
cat >$OUT_DIR/map/extern/union1/ccod <<'-----'
-----
[ -d $OUT_DIR/map/genbt ] || mkdir $OUT_DIR/map/genbt
[ -d $OUT_DIR/map/genbt/basic ] || mkdir $OUT_DIR/map/genbt/basic
cat >$OUT_DIR/map/genbt/basic/ccod <<'-----'
/* dummy routine for genbt perform routine */
static void donothing##_DOMAIN _FPH1(Genptr) {}

/* routine for comparing two elements e.g. for search */
/* 0 indicates success                                */
/* 1 indicates search in right subree                 */
/* -1 indicates search in left subree                 */
/* -2 indicates on success possible                   */

static int eqelem1##_DOMAIN _FPH2(Genptr,Genptr)
  {return is_eq##_ELEM1(((H1##_DOMAIN)x1)->f_info,
                       ((H1##_DOMAIN)x2)->f_info)
          ? 0 :
          is_ge##_ELEM1(((H1##_DOMAIN)x1)->f_info,
                       ((H1##_DOMAIN)x2)->f_info)
          ? -1 : 1;
  }
-----
cat >$OUT_DIR/map/genbt/basic/defp <<'-----'
#ifdef AVLTREE
#define GENBT Genericavltree
#define _GENBT _genericavltree
#define GENBTIMP AVL
#endif
#ifndef GENBT
#define GENBT Genericbinarytree
#define _GENBT _genericbinarytree
#define GENBTIMP NORMAL
#endif
-----
cat >$OUT_DIR/map/genbt/basic/docu <<'-----'
#include <map/genbt/basic/defp>
  Implementation of

     DOMAIN  =  ELEM1 -m-> ELEM2

  with a generic binary tree. The code for the generic
  binary tree will be shared by all map implementations
  (and others) based on the generic binary tree.
  time and space characteristics are in the same order
  of magnitute as normal binary tree implementations,
  but the generic code requires extra routine calls
  for domain specific operations (e.g. for searching
  inserting, deleting and copying values)

  Implementation Parameters

  'AVLTREE' :
              if set the underlying binary tree implementation
              uses a balanced AVL tree, insert and remove
              operations then become more expensive
              but search is always efficient
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/genbt/basic/gtyp <<'-----'
#include <map/genbt/basic/defp>
#ifdef GEN_C
/* converstion type between Genptr and pairs of map elements */

  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_info,ELEM1);
                      RECFIELD(f_attr,ELEM2);
  END_RECORD_TYP(Struct##_DOMAIN) 

  TYPE_DEF(H1##_DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
#endif

   TYPE_DEF(DOMAIN,GENBT)
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/basic/param <<'-----'
AUTOMEM
AVLTREE
GENBT
INTERNALDOMAIN
MACROS
-----
cat >$OUT_DIR/map/genbt/basic/undefp <<'-----'
#undef GENBT
#undef _GENBT
#undef GENBTIMP
-----
cat >$OUT_DIR/map/genbt/basic/vdm <<'-----'
#include <map/genbt/basic/defp>
  DOMAINS
   GENBT          =  () -genbt
   DOMAIN         -> GENBT

  IMPLEMENTATIONS
   GENBT          =  bintree("INTERNALDOMAIN",GENBTIMP)
   ELEM1          =  + is_eq + is_ge

   ! generic pointers are required in ptr section, not in type section!
   Vdmlib         =  + genptr(GTYPEDEF)

#undef GENBT
#undef GENBTIMP
#undef _GENBT

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/genbt/card ] || mkdir $OUT_DIR/map/genbt/card
cat >$OUT_DIR/map/genbt/card/ccod <<'-----'
#include <map/genbt/basic/defp>
  Nat0 card##_DOMAIN _FPH1(DOMAIN)
     {  return card##_GENBT((GENBT)x1); }
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/card/docu <<'-----'
  time complexity : o(n) 
-----
cat >$OUT_DIR/map/genbt/card/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
  GENBT        = + card
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/copy ] || mkdir $OUT_DIR/map/genbt/copy
cat >$OUT_DIR/map/genbt/copy/ccod <<'-----'
#include <map/genbt/basic/defp>

static void copyelems##_DOMAIN _FPH1(Genptr)
  {H1##_DOMAIN lx1 = (H1##_DOMAIN)x1;
   lx1->f_info = copy##_ELEM1(lx1->f_info);
   lx1->f_attr = copy##_ELEM2(lx1->f_attr);
  }

DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
{ return
    (DOMAIN)(copy1##_GENBT((GENBT)x1,
                          sizeof(struct Struct##_DOMAIN),
                          copyelems##_DOMAIN));
}
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/copy/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
  GENBT        = + copy1
  ELEM1        = + copy
  ELEM2        = + copy
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/copy1 ] || mkdir $OUT_DIR/map/genbt/copy1
cat >$OUT_DIR/map/genbt/copy1/ccod <<'-----'
#include <map/genbt/basic/defp>
DOMAIN copy1##_DOMAIN _FPH1(DOMAIN)
{return
   (DOMAIN)(copy1##_GENBT((GENBT)x1,
                         sizeof(struct Struct##_DOMAIN),
                         donothing##_DOMAIN));
}
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/copy1/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
  GENBT        = + copy1
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/del ] || mkdir $OUT_DIR/map/genbt/del
cat >$OUT_DIR/map/genbt/del/ccod <<'-----'
#include <map/genbt/basic/defp>

static void delelems##_DOMAIN _FPH1(Genptr)
  {del##_ELEM1(((H1##_DOMAIN)x1)->f_info);
   del##_ELEM2(((H1##_DOMAIN)x1)->f_attr);
  }

void del##_DOMAIN _FPH1(DOMAIN)
  {del1##_GENBT((GENBT)x1,
               sizeof(struct Struct##_DOMAIN),
               delelems##_DOMAIN);
  }
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/del/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT    = + del1
   ELEM1    = + del
   ELEM2    = + del
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/del1 ] || mkdir $OUT_DIR/map/genbt/del1
cat >$OUT_DIR/map/genbt/del1/ccod <<'-----'
#include <map/genbt/basic/defp> 

void del1##_DOMAIN _FPH1(DOMAIN)
  { /* zurueckfuehren auf del1##_GENBT */
    del1##_GENBT( (GENBT)x1,sizeof(struct Struct##_DOMAIN),donothing##_DOMAIN);
  }
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/del1/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
  GENBT        = + del1
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/forall ] || mkdir $OUT_DIR/map/genbt/forall
cat >$OUT_DIR/map/genbt/forall/ccod <<'-----'
#include <map/genbt/basic/defp>

static T2_forall##_DOMAIN tmp_forall##_DOMAIN;

static void help_forall##_DOMAIN _FPH1(Genptr)
  { (*tmp_forall##_DOMAIN)(((H1##_DOMAIN)x1)->f_info,
                          ((H1##_DOMAIN)x1)->f_attr); } 

void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
  { T2_forall##_DOMAIN lx1 = tmp_forall##_DOMAIN;
    tmp_forall##_DOMAIN = x2;
    forall##_GENBT((GENBT)x1,help_forall##_DOMAIN);
    tmp_forall##_DOMAIN = lx1;
  }
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/forall/vdm <<'-----'
#include <map/genbt/basic/defp>

DOMAINS
IMPLEMENTATIONS
  GENBT         = + forall
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/is_eq ] || mkdir $OUT_DIR/map/genbt/is_eq
cat >$OUT_DIR/map/genbt/is_eq/ccod <<'-----'
#include <map/genbt/basic/defp>

static int eqelem12##_DOMAIN _FPH2(Genptr,Genptr)
  {return is_eq##_ELEM1(((H1##_DOMAIN)x1)->f_info,
                       ((H1##_DOMAIN)x2)->f_info)
          ? ( is_eq##_ELEM2(((H1##_DOMAIN)x1)->f_attr,
                           ((H1##_DOMAIN)x2)->f_attr)
              ? 0 : -2 )
          : ( is_ge##_ELEM1(((H1##_DOMAIN)x1)->f_info,
                           ((H1##_DOMAIN)x2)->f_info)
              ? -1 : 1 );
  }

Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
  { return is_eq##_GENBT((GENBT)x1,(GENBT)x2,eqelem12##_DOMAIN);}
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/is_eq/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT         = +is_eq
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/is_ge ] || mkdir $OUT_DIR/map/genbt/is_ge
cat >$OUT_DIR/map/genbt/is_ge/ccod <<'-----'
#include <map/genbt/basic/defp>

static int geelem12##_DOMAIN _FPH2(Genptr,Genptr)
  {return is_eq##_ELEM1(((H1##_DOMAIN)x1)->f_info,
                       ((H1##_DOMAIN)x2)->f_info)
          ? ( is_eq##_ELEM2(((H1##_DOMAIN)x1)->f_attr,
                           ((H1##_DOMAIN)x2)->f_attr)
              ? 0 : -2 )
          : ( is_ge##_ELEM1(((H1##_DOMAIN)x1)->f_info,
                           ((H1##_DOMAIN)x2)->f_info)
              ? -1 : 1 );
  }

Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN)
  { return is_ge##_GENBT((GENBT)x1,(GENBT)x2,geelem12##_DOMAIN);}
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/is_ge/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT         = +is_ge
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/is_in_dom ] || mkdir $OUT_DIR/map/genbt/is_in_dom
cat >$OUT_DIR/map/genbt/is_in_dom/ccod <<'-----'
#include <map/genbt/basic/defp>
Bool is_in_dom##_DOMAIN _FPH3(ELEM1,DOMAIN,ELEM2 *)
  { struct Struct##_DOMAIN lx1;
    H1##_DOMAIN lx2;
    lx1.f_info = x1;
    lx2 = (H1##_DOMAIN)find##_GENBT((GENBT)x2,
                                  (Genptr)(&lx1),
                                  eqelem1##_DOMAIN);
    if (lx2) {*x3 = lx2->f_attr; return 1;}
    return 0;  
  }
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/is_in_dom/docu <<'-----'
#include <map/genbt/basic/defp>
  time complexity : o( log n )
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/is_in_dom/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT         = + find
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/iterator ] || mkdir $OUT_DIR/map/genbt/iterator
cat >$OUT_DIR/map/genbt/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/map/genbt/iterator/vdm <<'-----'
#ifdef AVLTREE
#define PARAM11 "AVLTREE"
#else
#define PARAM11 "NORMAL"
#endif
#define PARAM PARAM11 , "INTERNALFCT"
#define IMPL genbt
#include <aux/com/iterator/vdm>
#undef PARAM11

#include <map/genbt/basic/defp>
  DOMAINS
  IMPLEMENTATIONS
   GENBT    = + iterator("INTERNALFCT")
#undef GENBT
#undef _GENBT
#undef GENBTIMP
-----
[ -d $OUT_DIR/map/genbt/mk_empty ] || mkdir $OUT_DIR/map/genbt/mk_empty
cat >$OUT_DIR/map/genbt/mk_empty/ccod <<'-----'
#include <map/genbt/basic/defp>
DOMAIN mk_empty##_DOMAIN _FPH0() 
  { return (DOMAIN)mk_empty##_GENBT();}
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/mk_empty/vdm <<'-----'
#include <map/genbt/basic/defp>

DOMAINS
IMPLEMENTATIONS
   GENBT         = + mk_empty
#undef GENBT
#undef GENBTIMP
#undef _GENBT

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/genbt/ovwrt1 ] || mkdir $OUT_DIR/map/genbt/ovwrt1
cat >$OUT_DIR/map/genbt/ovwrt1/ccod <<'-----'
#define errormess lx2->f_attr = x3;
#define deleteelems
#define fctname ovwrt1
#include <map/genbt/union1/ccod>
-----
cat >$OUT_DIR/map/genbt/ovwrt1/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT         = + find 
                   + insert1
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/ovwrt1d ] || mkdir $OUT_DIR/map/genbt/ovwrt1d
cat >$OUT_DIR/map/genbt/ovwrt1d/ccod <<'-----'
#define errormess MERGE(del,_ELEM2)(lx2->f_attr);
#define deleteelems lx2->f_attr = x3;
#define fctname ovwrt1d
#include <map/genbt/union1/ccod>
-----
cat >$OUT_DIR/map/genbt/ovwrt1d/vdm <<'-----'
#include <map/genbt/ovwrt1/vdm>
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT         = + find 
                   + insert1
   ELEM1         = + del
   ELEM2         = + del
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/sub1 ] || mkdir $OUT_DIR/map/genbt/sub1
cat >$OUT_DIR/map/genbt/sub1/ccod <<'-----'
#include <map/genbt/basic/defp>

#ifndef fct
#define fct sub1
#endif

#ifndef perf
#define perf MERGE(donothing,_DOMAIN)
#endif

DOMAIN fct##_DOMAIN _FPH2(DOMAIN,ELEM1)
{ 
   struct Struct##_DOMAIN lx1;
   lx1.f_info = x2; 
   return
      (DOMAIN)remove1##_GENBT( (GENBT)x1
                            , sizeof(lx1)
                            , (Genptr)(&lx1)
                            , eqelem1##_DOMAIN
                            , perf
                            ); 
}
#undef perf
#undef fct
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/sub1/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT         = + remove1
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/sub1d ] || mkdir $OUT_DIR/map/genbt/sub1d
cat >$OUT_DIR/map/genbt/sub1d/ccod <<'-----'
static void delsubelems##_DOMAIN _FPH1(Genptr)
  {del##_ELEM1(((H1##_DOMAIN)x1)->f_info);
   del##_ELEM2(((H1##_DOMAIN)x1)->f_attr);
  }

#define fct sub1d
#define perf MERGE(delsubelems,_DOMAIN)
#include <map/genbt/sub1/ccod>
-----
cat >$OUT_DIR/map/genbt/sub1d/vdm <<'-----'
#include <map/genbt/sub1/vdm>
DOMAINS
IMPLEMENTATIONS
   ELEM1         = + del
   ELEM2         = + del
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/union1 ] || mkdir $OUT_DIR/map/genbt/union1
cat >$OUT_DIR/map/genbt/union1/ccod <<'-----'
#include <map/genbt/basic/defp>

#ifndef fctname
#define fctname union1
#endif

#ifndef errormess
#define errormess if (! MERGE(is_eq,_ELEM2)(lx2->f_attr,x3)) { err_umap_vdmlib(MKSTRING(DOMAIN)); }
#endif

#ifndef deleteelems
#define deleteelems
#endif

DOMAIN fctname##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)    
{
   struct Struct##_DOMAIN lx1;
   H1##_DOMAIN lx2;
   lx1.f_info = x2;
   lx2 = (H1##_DOMAIN)find##_GENBT(x1,(Genptr)(&lx1),eqelem1##_DOMAIN);
   if (lx2) {
      errormess
      deleteelems
      return x1;
   }
   lx1.f_attr = x3;
   return
      (DOMAIN)insert1##_GENBT( (Genptr)(&lx1)
                            , sizeof(lx1)
                            , (GENBT)x1
                            , eqelem1##_DOMAIN
                            );
}
#undef deleteelems
#undef errormess
#undef fctname
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
cat >$OUT_DIR/map/genbt/union1/vdm <<'-----'
#include <map/genbt/basic/defp>
DOMAINS
IMPLEMENTATIONS
   GENBT         = + find 
                   + insert1
   ELEM2         = + is_eq
   Vdmlib        = + err_umap
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/genbt/union1d ] || mkdir $OUT_DIR/map/genbt/union1d
cat >$OUT_DIR/map/genbt/union1d/ccod <<'-----'
#define deleteelems MERGE(del,_ELEM1)(x2);MERGE(del,_ELEM2)(x3);
#define fctname union1d
#include <map/genbt/union1/ccod>
-----
cat >$OUT_DIR/map/genbt/union1d/vdm <<'-----'
#include <map/genbt/union1/vdm>
DOMAINS
IMPLEMENTATIONS
   ELEM1    = + del
   ELEM2    = + del
#undef GENBT
#undef GENBTIMP
#undef _GENBT
-----
[ -d $OUT_DIR/map/hashlist ] || mkdir $OUT_DIR/map/hashlist
[ -d $OUT_DIR/map/hashlist/basic ] || mkdir $OUT_DIR/map/hashlist/basic
cat >$OUT_DIR/map/hashlist/basic/docu <<'-----'
  Implementation of a map as a hashtable with fixed length. It is
  implemented as

    DOMAIN      = Help *
    Help        = ELEM1 -m-> ELEM2

  Parameter:

  'TUPLIMPL' :
              Changes the implementation of the tuple domain. This
              must allow fast random access, construction or
              combination do not appear. Thus the default value
              'array' should do allmost allways.

  'MAPIMPL' :
              Changes the implementation for the map domain 'Help'.
              Default value is 'linklist' with freelist storage
              allocation:
                  
              linklist(ALLOC="freelist(MAXLEN=20)")

  'LISTLOG' :
              This parameter defines the size of the hashtable.
              The length of the hashlist will be 2^LISTLOG.
              (default for LISTLOG: 8 --> hashtable with 265 entries)

  Operations are mapped to the appropriate operation for the 'Help'
  domain. To reduce overhead, no special error checking will be done.
  Therefore eventual error messages will contain the name of one of
  the auxiliary domains instead of 'DOMAIN'. If this should become
  a problem, use another implementation during program development.

  Creation of an empty map is rather expensive since a tuple of empty
  maps with length 2^LISTLOG will be created. Thus use this 
  implementation only, if map creation will occur infrequently.
  Iteration over weakly filled hashlist will cause a lot of overhead
  also.

  NOTE: The Pascal/Modula interface for this implementation will work
        only with MACROS on!

-----
cat >$OUT_DIR/map/hashlist/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/hashlist/basic/gptr <<'-----'
#include <aux/hashlist/basic/gptr>
-----
cat >$OUT_DIR/map/hashlist/basic/gtyp <<'-----'
#include <aux/hashlist/basic/gtyp>
-----
cat >$OUT_DIR/map/hashlist/basic/param <<'-----'
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
LISTLOG
MACROS
MAPIMPL
TUPLIMPL
-----
cat >$OUT_DIR/map/hashlist/basic/vdm <<'-----'
#include <aux/hashlist/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/hashlist/copy ] || mkdir $OUT_DIR/map/hashlist/copy
cat >$OUT_DIR/map/hashlist/copy/gcod <<'-----'
_ALIAS_DD(copy,tupl##_DOMAIN)
-----
cat >$OUT_DIR/map/hashlist/copy/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,copy)
-----
[ -d $OUT_DIR/map/hashlist/copy1 ] || mkdir $OUT_DIR/map/hashlist/copy1
cat >$OUT_DIR/map/hashlist/copy1/gcod <<'-----'
_FDEC1(copy1,DOMAIN,DOMAIN,_RET(copy2_tupl##_DOMAIN(x1)))
-----
cat >$OUT_DIR/map/hashlist/copy1/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,copy2)
-----
[ -d $OUT_DIR/map/hashlist/del ] || mkdir $OUT_DIR/map/hashlist/del
cat >$OUT_DIR/map/hashlist/del/gcod <<'-----'
_ALIAS_VD(del,tupl##_DOMAIN)
-----
cat >$OUT_DIR/map/hashlist/del/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,del)
-----
[ -d $OUT_DIR/map/hashlist/del1 ] || mkdir $OUT_DIR/map/hashlist/del1
cat >$OUT_DIR/map/hashlist/del1/gcod <<'-----'
_FDEC1(del1,void,DOMAIN,del2_tupl##_DOMAIN(x1))
-----
cat >$OUT_DIR/map/hashlist/del1/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,del2)
-----
[ -d $OUT_DIR/map/hashlist/forall ] || mkdir $OUT_DIR/map/hashlist/forall
cat >$OUT_DIR/map/hashlist/forall/ccod <<'-----'
#include <aux/hashlist/forall/ccod>
-----
cat >$OUT_DIR/map/hashlist/forall/vdm <<'-----'
#include <aux/hashlist/forall/vdm>
-----
[ -d $OUT_DIR/map/hashlist/is_in ] || mkdir $OUT_DIR/map/hashlist/is_in
cat >$OUT_DIR/map/hashlist/is_in/gcod <<'-----'
#include <aux/hashlist/basic/setup>
_FDEC2(is_in,Bool,ELEM1,DOMAIN,_RET(is_in_aux##_DOMAIN(x1,_HGET(x2,x1))))
#undef LISTLEN
#undef _HGET
#undef _HIND
-----
cat >$OUT_DIR/map/hashlist/is_in/vdm <<'-----'
_ADD_OP(Aux##_DOMAIN,is_in)
-----
[ -d $OUT_DIR/map/hashlist/is_in_dom ] || mkdir $OUT_DIR/map/hashlist/is_in_dom
cat >$OUT_DIR/map/hashlist/is_in_dom/gcod <<'-----'
#include <aux/hashlist/basic/setup>
_FDEC3(is_in_dom,Bool,ELEM1,DOMAIN,ELEM2 *,_RET(is_in_dom_aux##_DOMAIN(x1,_HGET(x2,x1),x3)))
#undef LISTLEN
#undef _HGET
#undef _HIND
-----
cat >$OUT_DIR/map/hashlist/is_in_dom/vdm <<'-----'
_ADD_OP(Aux##_DOMAIN,is_in_dom)
-----
[ -d $OUT_DIR/map/hashlist/iterator ] || mkdir $OUT_DIR/map/hashlist/iterator
cat >$OUT_DIR/map/hashlist/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/map/hashlist/iterator/vdm <<'-----'
#include <aux/hashlist/iterator/vdm>
-----
[ -d $OUT_DIR/map/hashlist/mk_empty ] || mkdir $OUT_DIR/map/hashlist/mk_empty
cat >$OUT_DIR/map/hashlist/mk_empty/ccod <<'-----'
#ifndef MAPIMPL
#define SIMPLE_AUX
#endif
#include <aux/hashlist/mk_empty/ccod>
-----
cat >$OUT_DIR/map/hashlist/mk_empty/vdm <<'-----'
#ifndef MAPIMPL
#define SIMPLE_AUX
#endif
#include <aux/hashlist/mk_empty/vdm>

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/hashlist/ovwrt1 ] || mkdir $OUT_DIR/map/hashlist/ovwrt1
cat >$OUT_DIR/map/hashlist/ovwrt1/ccod <<'-----'
#include <aux/hashlist/combine/ccod>
-----
cat >$OUT_DIR/map/hashlist/ovwrt1/vdm <<'-----'
#include <aux/hashlist/combine/vdm>
-----
[ -d $OUT_DIR/map/hashlist/ovwrt1d ] || mkdir $OUT_DIR/map/hashlist/ovwrt1d
cat >$OUT_DIR/map/hashlist/ovwrt1d/ccod <<'-----'
#define OPER ovwrt1d
#include <aux/hashlist/combine/ccod>
-----
cat >$OUT_DIR/map/hashlist/ovwrt1d/vdm <<'-----'
#define OPER ovwrt1d
#include <aux/hashlist/combine/vdm>
-----
[ -d $OUT_DIR/map/hashlist/sel ] || mkdir $OUT_DIR/map/hashlist/sel
cat >$OUT_DIR/map/hashlist/sel/gcod <<'-----'
#include <aux/hashlist/basic/setup>
_FDEC2(sel,ELEM2,DOMAIN,ELEM1,_RET(sel_aux##_DOMAIN(_HGET(x1,x2),x2)))
#undef LISTLEN
#undef _HGET
#undef _HIND
-----
cat >$OUT_DIR/map/hashlist/sel/vdm <<'-----'
_ADD_OP(Aux##_DOMAIN,sel)
-----
[ -d $OUT_DIR/map/hashlist/sub1 ] || mkdir $OUT_DIR/map/hashlist/sub1
cat >$OUT_DIR/map/hashlist/sub1/ccod <<'-----'
#include <aux/hashlist/combine1/ccod>
-----
cat >$OUT_DIR/map/hashlist/sub1/vdm <<'-----'
#include <aux/hashlist/combine1/vdm>
-----
[ -d $OUT_DIR/map/hashlist/sub1d ] || mkdir $OUT_DIR/map/hashlist/sub1d
cat >$OUT_DIR/map/hashlist/sub1d/ccod <<'-----'
#define OPER sub1d
#include <aux/hashlist/combine1/ccod>
-----
cat >$OUT_DIR/map/hashlist/sub1d/vdm <<'-----'
#define OPER sub1d
#include <aux/hashlist/combine1/vdm>
-----
[ -d $OUT_DIR/map/hashlist/union1 ] || mkdir $OUT_DIR/map/hashlist/union1
cat >$OUT_DIR/map/hashlist/union1/ccod <<'-----'
#define OPER union1
#include <aux/hashlist/combine/ccod>
-----
cat >$OUT_DIR/map/hashlist/union1/vdm <<'-----'
#define OPER union1
#include <aux/hashlist/combine/vdm>
-----
[ -d $OUT_DIR/map/hashlist/union1d ] || mkdir $OUT_DIR/map/hashlist/union1d
cat >$OUT_DIR/map/hashlist/union1d/ccod <<'-----'
#define OPER union1d
#include <aux/hashlist/combine/ccod>
-----
cat >$OUT_DIR/map/hashlist/union1d/vdm <<'-----'
#define OPER union1d
#include <aux/hashlist/combine/vdm>
-----
[ -d $OUT_DIR/map/hashtab ] || mkdir $OUT_DIR/map/hashtab
[ -d $OUT_DIR/map/hashtab/basic ] || mkdir $OUT_DIR/map/hashtab/basic
cat >$OUT_DIR/map/hashtab/basic/ccod <<'-----'
#include <map/hashtab/basic/defp>

struct Struct1##_DOMAIN _tmp_free##_DOMAIN;

static DOMAIN _init##_DOMAIN _FPH1(Nat0)
{
   DOMAIN lx1;
   H1##_DOMAIN lx2; /* Laufvariable fuer MAP-Eintraege */
   Nat0 size;
   Nat0 i;        /* Laufvariable FOR-Schleife */

   size = sizeof(*lx1) + x1 * sizeof(struct Struct1##_DOMAIN);
   lx1 = alloc##_DOMAIN(size);
   lx1->f_space  = size;
   lx1->f_len    = x1;
#if MAX
   lx1->f_extend = (x1 * MAX + 99) / 100;
#endif
#if MIN
   lx1->f_shrink = (x1 * MIN + 99) / 100;
#endif
   lx1->f_card   = 0;
   lx2=(H1##_DOMAIN)(lx1+1);
   for (i=0; i < x1; i++, lx2++)
      lx2->f_next = & _tmp_free##_DOMAIN;
   return lx1;
} 
       
static void _ins_entry##_DOMAIN _FPH3(H1##_DOMAIN,ELEM1,ELEM2)
{
    if (x1->f_next == & _tmp_free##_DOMAIN)
    {
        x1->f_next = 0;
        x1->f_info = x2;
        x1->f_attr = x3;
    }
    else
    {
        H1##_DOMAIN t;
        t = alloc_h1##_DOMAIN();
        t->f_next = x1->f_next;
        t->f_info = x2;
        t->f_attr = x3;
        x1->f_next = t;
    }
}

static void _rem_entry##_DOMAIN _FPH2(H1##_DOMAIN,H1##_DOMAIN)
{
   if (x2 == 0)
   {
      /* entry found in table */
      if (x1->f_next == 0)
      {
         /* overflow list empty */
         /* mark table entry to be free */
         x1->f_next = & _tmp_free##_DOMAIN;
      }
      else
      {
         /* overflow list not empty */
         /* copy first oflw elem into table */
         x2 = x1->f_next;
         *x1 = *x2;
         free_h1##_DOMAIN(x2);
      }
   }
   else
   {
      /* entry found in overflow list */
      /* remove elem from oflw list */
      x2->f_next = x1->f_next;
      free_h1##_DOMAIN(x1); 
   }
}

#if DYNAMIC

static DOMAIN _ttx2##_DOMAIN;

static void _move_elem##_DOMAIN _FPH2(ELEM1,ELEM2)
{
   H1##_DOMAIN lx3;
   lx3=((H1##_DOMAIN)(_ttx2##_DOMAIN+1))
       + (hash##_ELEM1(x1) % _ttx2##_DOMAIN->f_len);
   _ins_entry##_DOMAIN(lx3,x1,x2);
}

static DOMAIN _tabfill##_DOMAIN _FPH2(DOMAIN,DOMAIN)
{
    DOMAIN lx2;
    lx2 = _ttx2##_DOMAIN;
    _ttx2##_DOMAIN = x2;
    x2->f_card = x1->f_card;
    forall##_DOMAIN(x1,_move_elem##_DOMAIN);
    del1##_DOMAIN(x1);
    _ttx2##_DOMAIN = lx2;
    return x2;
}

#endif

#if MAX

static DOMAIN _extend##_DOMAIN _FPH1(DOMAIN)
{
   return _tabfill##_DOMAIN(x1,_init##_DOMAIN((x1->f_len)*2));
}

#endif

#if MIN

static DOMAIN _shrink##_DOMAIN _FPH1(DOMAIN)
{
   return _tabfill##_DOMAIN(x1,_init##_DOMAIN((x1->f_len)/2));
}

#endif       

/* search of an ELEM1 in the hash table
   if not found *x3 contains the hashtable entry
   if found *x3 contains the pointer to the H1##_DOMAIN entry
   and *x4 contains 0 if the entry is in the hashtable
   otherwise *x4 contains the pointer to the previous H1##_DOMAIN entry
*/

Bool _search##_DOMAIN _FPH4(ELEM1,DOMAIN,H1##_DOMAIN*,H1##_DOMAIN*)
{
   H1##_DOMAIN lx3;

   lx3=((H1##_DOMAIN)(x2+1)) + (hash##_ELEM1(x1) % x2->f_len);
   if (lx3->f_next != & _tmp_free##_DOMAIN)
   {
       H1##_DOMAIN lx4,lx5;
       lx4 = lx3;
       lx5 = 0;
       while (lx4 != 0)
       {
          if (is_eq##_ELEM1(lx4->f_info,x1)) 
          {
             *x3 = lx4;
             *x4 = lx5;
             return 1;
          }
          lx5 = lx4;
          lx4 = lx4->f_next;
       }
   }
   *x3 = lx3;
   return 0;   
}

static DOMAIN _incr_card##_DOMAIN _FPH1(DOMAIN)
{
   (x1->f_card)++;
#if MAX
   if (x1->f_card > x1->f_extend)
      x1 = _extend##_DOMAIN(x1);
#endif
   return x1;
}

static DOMAIN _decr_card##_DOMAIN _FPH1(DOMAIN)
{
   (x1->f_card)--;
#if MIN
   if ( x1->f_card < x1->f_shrink && x1->f_len/2 >= LENGTH)
      x1 = _shrink##_DOMAIN(x1);
#endif
   return x1;
}

#undef ALLOC
#undef ALLOC1
#undef DYNAMIC
#undef MAX
#undef MIN
-----
cat >$OUT_DIR/map/hashtab/basic/defp <<'-----'
#ifndef LENGTH
#define LENGTH 64
#endif
#if LENGTH < 1
#undef LENGTH
#define LENGTH 1
#endif

#ifndef MIN
#define MIN 0
#endif

#ifndef MAX
#define MAX 0
#endif

#if MAX || MIN
#define DYNAMIC 1
#endif

#ifndef ALLOC
#define ALLOC osalloc("INTERNALDOMAIN")
#endif

#ifndef ALLOC1
#define ALLOC1 malloc("INTERNALDOMAIN")
#endif
-----
cat >$OUT_DIR/map/hashtab/basic/docu <<'-----'
#include <map/hashtab/basic/defp>
  Implementation of Maps as Hashtables 

  The Map pairs are stored in a hashtable,
  the hash function on ELEM1 is used for indexing
  overflow elements are stored for every index in
  a linked list of overflow elements.
  The hash table can be organized as a fixed length table
  or as a dynamically growing and/or shrinking table
  (see implementation parameters 'MAX' and 'MIN').

  space characteristics
  =====================

  sizeof(DOMAIN) = sizeof(struct Struct##_DOMAIN *)

  sizeof(struct Struct##_DOMAIN) =
        5 * sizeof(Nat0) +
        (n + m) * (sizeof(pointer) + sizeof(ELEM1) + sizeof(ELEM2))

  where n is the length of the hashtable
  and   m is the number of overflow elements

  time characteristics
  ====================
  
  If the cardinality of the map is less than the length of the
  table, insertion, deletion and lookup is constant in time
  (if the hash function works properly).
  
  If the overflow lists become long, the behaviour changes
  to that of a linked list (e.g. if implementation parameter 
  'LENGTH' is set to 1 and 'MAX' is not given, the
  implementation is a linked list).

  For dynamically organized hash tables time for the
  reorganization of the table when extending of shrinking it
  must be taken into account. This time grows linear to
  the cardinality of the map.
  
  Implementation parameters
  =========================

  'LENGTH' :
            Gives the default length of the hash table,
            default value is LENGTH.

  'MAX' :
            If this parameter is set to a given positive
            value (e.g. 100), the hash table is growing
            dynamically, that means if the table is filled
            more than 'MAX' percent, the table length is
            doubled and the table is reorganized.

  'MIN' :
            If this parameter is set to a given positive
            value (e.g. 50), the hash table is shrinking
            dynamically when deleting entries from the table,
            that means if the table is filled less than 'MIN'
            percent the table length is divided by 2 and the
            table is reorganized.
            The table is not reorganized if the length
            of the table would become less than 'LENGH'.

  'ALLOC1' :
            Allocation strategie for overflow elements
            default is ALLOC1.
            If another strategie (e.g. by a freelist)
            is prefered, this parameter
            must be defined with another implementation
            for the heap ADT for fixed length elements
            (e.g. freelist).

#undef ALLOC
#undef ALLOC1
#undef DYNAMIC
#undef MAX
#undef MIN
-----
cat >$OUT_DIR/map/hashtab/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/hashtab/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
  TYPE_DEF(H1##_DOMAIN,POINTER_TO_STRUCT(Struct1##_DOMAIN))
-----
cat >$OUT_DIR/map/hashtab/basic/gtyp <<'-----'
  START_RECORD_TYP(Struct1##_DOMAIN)
             RECFIELD(f_next,H1##_DOMAIN);
             RECFIELD(f_info,ELEM1);
             RECFIELD(f_attr,ELEM2);
  END_RECORD_TYP(Struct1##_DOMAIN)

  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_space,Nat0);
                      RECFIELD(f_card,Nat0);
                      RECFIELD(f_len,Nat0);  
#if MAX
                      RECFIELD(f_extend,Nat0);
#endif
#if MIN
                      RECFIELD(f_shrink,Nat0);
#endif
                      COMMENT_(RECFIELD(f_elems[LENGTH],Struct1##_DOMAIN);)
  END_RECORD_TYP(Struct##_DOMAIN) 
extern struct Struct1##_DOMAIN _tmp_free##_DOMAIN;

-----
cat >$OUT_DIR/map/hashtab/basic/param <<'-----'
ALLOC
ALLOC1
AUTOMEM
DYNAMIC
FORWARD_ALLOWED
INTERNALDOMAIN
LENGTH
MACROS
MAX
MIN
-----
cat >$OUT_DIR/map/hashtab/basic/vdm <<'-----'
#include <map/hashtab/basic/defp>

DOMAINS
   H1##_DOMAIN    = PREDEF
   Heap##_DOMAIN  = DOMAIN     -heap
   Heap1##_DOMAIN = H1##_DOMAIN -heap

   Heap1##_DOMAIN -> DOMAIN	! Since H1##_DOMAIN is defined there !
   DOMAIN         -> Heap1##_DOMAIN
   DOMAIN         -> Heap##_DOMAIN

IMPLEMENTATIONS
   ! the hash function and the equality test for     !
   ! ELEM1 is always required                        !

   ELEM1         = + hash + is_eq   

   ! allocation strategy for the hashtable           !
   ! at the moment only basic OS allocation possible !
   ! may be extended by e.g. buddy allocation        !

   Heap##_DOMAIN  = ALLOC + memalloc

   ! allocation strategy for overflow elements       !
   ! can be modified e.g. as freelist allocation or  !
   ! any other strategy available for linked lists   !

   Heap1##_DOMAIN = ALLOC1 
                   + alloc("STRUCT"= "struct Struct1" #_DOMAIN)
   
   ! if dynamic hashtables are used some operations  !
   ! required for reorganizing the hashtable         !

#if DYNAMIC
   DOMAIN        = + forall + union1 + del1
#endif
#undef ALLOC
#undef ALLOC1
#undef DYNAMIC
#undef MAX
#undef MIN

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/hashtab/card ] || mkdir $OUT_DIR/map/hashtab/card
cat >$OUT_DIR/map/hashtab/card/ccod <<'-----'
Nat0 card##_DOMAIN _FPH1(DOMAIN)
{
   return x1->f_card;
}
-----
[ -d $OUT_DIR/map/hashtab/copy1 ] || mkdir $OUT_DIR/map/hashtab/copy1
cat >$OUT_DIR/map/hashtab/copy1/ccod <<'-----'
DOMAIN copy1##_DOMAIN _FPH1(DOMAIN)
{
   DOMAIN ln1;
   H1##_DOMAIN la3, ln3;
   Nat0 i;

   ln1 = alloc##_DOMAIN(x1->f_space);
   ln1->f_space  = x1->f_space;
   ln1->f_len    = x1->f_len;
#if MAX
   ln1->f_extend = x1->f_extend;
#endif
#if MIN
   ln1->f_shrink = x1->f_shrink;
#endif
   ln1->f_card   = x1->f_card;
   la3=(H1##_DOMAIN)(x1+1);
   ln3=(H1##_DOMAIN)(ln1+1);
   for ( i=0; i < x1->f_len; la3++, ln3++,i++)
   {
      ln3->f_next = la3->f_next;
      if (la3->f_next != & _tmp_free##_DOMAIN)
      {
         ln3->f_info = la3->f_info;
         ln3->f_attr = la3->f_attr;
         { H1##_DOMAIN ln4, la4;
           la4 = la3->f_next;
           ln4 = ln3;
           while (la4 != 0)
           { H1##_DOMAIN ln2;
             ln2 = alloc_h1##_DOMAIN();
            *ln2 = *la4;
             ln4->f_next = ln2;
             ln4 = ln2;
             la4 = la4->f_next;
           }
         }
      }
   }
   return ln1;
}
-----
[ -d $OUT_DIR/map/hashtab/del1 ] || mkdir $OUT_DIR/map/hashtab/del1
cat >$OUT_DIR/map/hashtab/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN)
  {
   H1##_DOMAIN lx2,lxe;

   for (lx2=(H1##_DOMAIN)(x1+1),lxe=lx2+x1->f_len;
        lx2 < lxe;
        lx2++)
   {
      if (lx2->f_next != & _tmp_free##_DOMAIN)
      { H1##_DOMAIN lx1;
        lx1 = lx2->f_next;
        while (lx1 != 0)
        {
          { H1##_DOMAIN t;
            t = lx1;
            lx1 = lx1->f_next;
            free_h1##_DOMAIN(t);
          }
        }
      }
   }
   free##_DOMAIN(x1,x1->f_space);
}
-----
[ -d $OUT_DIR/map/hashtab/forall ] || mkdir $OUT_DIR/map/hashtab/forall
cat >$OUT_DIR/map/hashtab/forall/ccod <<'-----'
void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
{
   H1##_DOMAIN lx3,lxe;

   for ( lx3=(H1##_DOMAIN)(x1+1), lxe=lx3+x1->f_len;
         lx3 < lxe;
         lx3++)
   {
      if ( lx3->f_next != & _tmp_free##_DOMAIN)
      {
         H1##_DOMAIN   lx4;
         lx4 = lx3;
         while ( lx4 != 0)
         { 
            (*x2)(lx4->f_info,lx4->f_attr);
            lx4=lx4->f_next;
         }
      }
   }
}
-----
[ -d $OUT_DIR/map/hashtab/is_empty ] || mkdir $OUT_DIR/map/hashtab/is_empty
cat >$OUT_DIR/map/hashtab/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN)
  {
    return (x1->f_card == 0 );
  }
-----
[ -d $OUT_DIR/map/hashtab/is_in ] || mkdir $OUT_DIR/map/hashtab/is_in
cat >$OUT_DIR/map/hashtab/is_in/ccod <<'-----'
Bool is_in##_DOMAIN _FPH2(ELEM1,DOMAIN)
{
   H1##_DOMAIN lx1,lx2;
   return _search##_DOMAIN(x1,x2,&lx1,&lx2);
}
-----
[ -d $OUT_DIR/map/hashtab/is_in_dom ] || mkdir $OUT_DIR/map/hashtab/is_in_dom
cat >$OUT_DIR/map/hashtab/is_in_dom/ccod <<'-----'
Bool is_in_dom##_DOMAIN _FPH3(ELEM1,DOMAIN,ELEM2*)
{
   H1##_DOMAIN lx1,lx2;
   Bool r;
   if ((r = _search##_DOMAIN(x1,x2,&lx1,&lx2)))
      *x3 = lx1->f_attr; 
   return r;
}
-----
[ -d $OUT_DIR/map/hashtab/iterator ] || mkdir $OUT_DIR/map/hashtab/iterator
cat >$OUT_DIR/map/hashtab/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/map/hashtab/iterator/vdm <<'-----'
#define IMPL hashtab
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/map/hashtab/mk_empty ] || mkdir $OUT_DIR/map/hashtab/mk_empty
cat >$OUT_DIR/map/hashtab/mk_empty/ccod <<'-----'
DOMAIN mk_empty##_DOMAIN _FPH0()
{
   return _init##_DOMAIN((Nat0)(LENGTH));
}
-----
cat >$OUT_DIR/map/hashtab/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/hashtab/ovwrt1 ] || mkdir $OUT_DIR/map/hashtab/ovwrt1
cat >$OUT_DIR/map/hashtab/ovwrt1/ccod <<'-----'
DOMAIN ovwrt1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
{
   H1##_DOMAIN lx1,lx2;
   if (_search##_DOMAIN(x2,x1,&lx1,&lx2))
   {
      lx1->f_attr = x3;
      return x1;
   }
   {
      _ins_entry##_DOMAIN(lx1,x2,x3);
      return _incr_card##_DOMAIN(x1);
   }
}
-----
[ -d $OUT_DIR/map/hashtab/ovwrt1d ] || mkdir $OUT_DIR/map/hashtab/ovwrt1d
cat >$OUT_DIR/map/hashtab/ovwrt1d/ccod <<'-----'
DOMAIN ovwrt1d##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
{
   H1##_DOMAIN lx1,lx2;
   if (_search##_DOMAIN(x2,x1,&lx1,&lx2))
   {
      del##_ELEM1(lx1->f_info);
      del##_ELEM2(lx1->f_attr);
      lx1->f_info = x2;
      lx1->f_attr = x3;
      return x1;
   }
   {
      _ins_entry##_DOMAIN(lx1,x2,x3);
      return _incr_card##_DOMAIN(x1);
   }
}
-----
cat >$OUT_DIR/map/hashtab/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1    = + del
   ELEM2    = + del
-----
[ -d $OUT_DIR/map/hashtab/sub1 ] || mkdir $OUT_DIR/map/hashtab/sub1
cat >$OUT_DIR/map/hashtab/sub1/ccod <<'-----'
DOMAIN sub1##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
   H1##_DOMAIN lx1,lx2;
   if (_search##_DOMAIN(x2,x1,&lx1,&lx2))
   {
      _rem_entry##_DOMAIN(lx1,lx2);
      x1 = _decr_card##_DOMAIN(x1);
   }
   return x1;
}
-----
[ -d $OUT_DIR/map/hashtab/sub1d ] || mkdir $OUT_DIR/map/hashtab/sub1d
cat >$OUT_DIR/map/hashtab/sub1d/ccod <<'-----'

DOMAIN sub1d##_DOMAIN _FPH2(DOMAIN,ELEM1)
{
   H1##_DOMAIN lx1,lx2;
   if (_search##_DOMAIN(x2,x1,&lx1,&lx2))
   {
      del##_ELEM1(lx1->f_info);
      del##_ELEM2(lx1->f_attr);
      _rem_entry##_DOMAIN(lx1,lx2);
      x1 = _decr_card##_DOMAIN(x1);
   }
   return x1;
}
-----
cat >$OUT_DIR/map/hashtab/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + del
   ELEM2  = + del
-----
[ -d $OUT_DIR/map/hashtab/union1 ] || mkdir $OUT_DIR/map/hashtab/union1
cat >$OUT_DIR/map/hashtab/union1/ccod <<'-----'
 DOMAIN union1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
{
   H1##_DOMAIN lx1,lx2;
   if (_search##_DOMAIN(x2,x1,&lx1,&lx2))
   {
      if (! is_eq##_ELEM2(lx1->f_attr,x3))
         err_umap_vdmlib(MKSTRING(DOMAIN));
      return x1;
   }
   {
      _ins_entry##_DOMAIN(lx1,x2,x3);
      return _incr_card##_DOMAIN(x1);
   }
}

-----
cat >$OUT_DIR/map/hashtab/union1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM2    = + is_eq 
   Vdmlib   = + err_umap
-----
[ -d $OUT_DIR/map/hashtab/union1d ] || mkdir $OUT_DIR/map/hashtab/union1d
cat >$OUT_DIR/map/hashtab/union1d/ccod <<'-----'
  DOMAIN union1d##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
{
   H1##_DOMAIN lx1,lx2;
   if (_search##_DOMAIN(x2,x1,&lx1,&lx2))
   {
      if (! is_eq##_ELEM2(lx1->f_attr,x3))
         err_umap_vdmlib(MKSTRING(DOMAIN));
      del##_ELEM1(x2);
      del##_ELEM2(x3);
      return x1;
   }
   {
      _ins_entry##_DOMAIN(lx1,x2,x3);
      return _incr_card##_DOMAIN(x1);
   }
}

-----
cat >$OUT_DIR/map/hashtab/union1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1    = + del
   ELEM2    = + is_eq + del
   Vdmlib   = + err_umap
-----
[ -d $OUT_DIR/map/heap ] || mkdir $OUT_DIR/map/heap
[ -d $OUT_DIR/map/heap/basic ] || mkdir $OUT_DIR/map/heap/basic
cat >$OUT_DIR/map/heap/basic/docu <<'-----'
  Implementation  of

     Token -m-> ELEM

  using pointers to ELEM as implementation of Token.
  The implementation is done in a heap store.
  Only a few operations are available for this
  implementation:

     mk_empty, ovwrt1, union1, sel, sub1 and ext

  Features:

  For the Token domain the pointer to the element is taken.
  Therefore,  the  map  application  ('sel_') becomes  a simple
  pointer dereferencing operation.
  Since no collection of the domain elements is held,
  all operations using the domain set (e.g.  for all, union,...)
  cannot be implemented (these functions are available
  but produce an error message at runtime).
  Since some of the implemented operations cannot perform the usual tests,
  it is recommended not to use this implementation during developement,
  but extensions of this implementation (e.g. the 'heapdom' implementation)
  storing extra informations about the domain set.
-----
cat >$OUT_DIR/map/heap/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/heap/basic/gtyp <<'-----'
  TYPE_DEF(DOMAIN,Nat0)
-----
cat >$OUT_DIR/map/heap/basic/param <<'-----'
ALLOC
INTERNALDOMAIN
MACROS
NO_AUTOMEM
-----
cat >$OUT_DIR/map/heap/basic/vdm <<'-----'
#ifndef ALLOC
#define ALLOC malloc("INTERNALDOMAIN")
#endif

DOMAINS
   Heap##_DOMAIN  = ELEM1 -heap

   DOMAIN         -> Heap##_DOMAIN

IMPLEMENTATIONS
   Heap##_DOMAIN  = ALLOC
                 + alloc("STRUCT"= #ELEM2)
                 + cont("MACROS","RESULT"= #ELEM2)
#undef ALLOC

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/heap/card ] || mkdir $OUT_DIR/map/heap/card
cat >$OUT_DIR/map/heap/card/ccod <<'-----'
#define FCT card
#define RES Nat0
#include <aux/heap/undef/ccod>
-----
cat >$OUT_DIR/map/heap/card/vdm <<'-----'
#include <aux/heap/undef/vdm>
-----
[ -d $OUT_DIR/map/heap/copy ] || mkdir $OUT_DIR/map/heap/copy
cat >$OUT_DIR/map/heap/copy/ccod <<'-----'
#define FCT copy
#include <aux/heap/undef/ccod>
-----
cat >$OUT_DIR/map/heap/copy/vdm <<'-----'
#include <aux/heap/undef/vdm>
-----
[ -d $OUT_DIR/map/heap/copy1 ] || mkdir $OUT_DIR/map/heap/copy1
cat >$OUT_DIR/map/heap/copy1/ccod <<'-----'
#include <com/com/copy1/ccod>
-----
cat >$OUT_DIR/map/heap/copy1/cmcr <<'-----'
#include <com/com/copy1/cmcr>
-----
[ -d $OUT_DIR/map/heap/cvlines ] || mkdir $OUT_DIR/map/heap/cvlines
cat >$OUT_DIR/map/heap/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   {return mk1_cvtext_vdmlib(mkc_str(MKSTRING([<DOMAIN : map cannot be printed>])));}
-----
cat >$OUT_DIR/map/heap/cvlines/vdm <<'-----'
DOMAINS  
IMPLEMENTATIONS
  Str            =  + mkc
  Vdmlib         =  + cvtext
-----
[ -d $OUT_DIR/map/heap/default ] || mkdir $OUT_DIR/map/heap/default
cat >$OUT_DIR/map/heap/default/docu <<'-----'
#include <aux/com/default/docu>

  For this special purpose implementation of maps
  only a few operations are added by default
  because not all operations are supported by this implementation
-----
cat >$OUT_DIR/map/heap/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty
                                       ! constructor !
                                       ! no predicates !
             + sel
                                       ! attributes !
             + union1 + ovwrt1 
                                       ! combinators with elements !
             + ext
                                       ! map extension !
-----
[ -d $OUT_DIR/map/heap/ext ] || mkdir $OUT_DIR/map/heap/ext
cat >$OUT_DIR/map/heap/ext/ccod <<'-----'
  ELEM1 ext##_DOMAIN _FPH2(DOMAIN,ELEM2)
   {ELEM1 y1;
    y1 = (ELEM1)alloc##_ELEM1();
    store##_ELEM1(y1,x2);
    return y1;
   } 
-----
[ -d $OUT_DIR/map/heap/forall ] || mkdir $OUT_DIR/map/heap/forall
cat >$OUT_DIR/map/heap/forall/ccod <<'-----'
#define FCT forall
#define RES void
#define X2 MERGE(T2_forall,_DOMAIN)
#include <aux/heap/undef/ccod>
-----
cat >$OUT_DIR/map/heap/forall/vdm <<'-----'
#include <aux/heap/undef/vdm>
-----
[ -d $OUT_DIR/map/heap/is_empty ] || mkdir $OUT_DIR/map/heap/is_empty
cat >$OUT_DIR/map/heap/is_empty/ccod <<'-----'
#define FCT is_empty
#define RES Bool
#include <aux/heap/undef/ccod>
-----
cat >$OUT_DIR/map/heap/is_empty/vdm <<'-----'
#include <aux/heap/undef/vdm>
-----
[ -d $OUT_DIR/map/heap/is_in ] || mkdir $OUT_DIR/map/heap/is_in
cat >$OUT_DIR/map/heap/is_in/ccod <<'-----'
#define FCT is_in
#define RES Bool
#define X1 ELEM1
#define X2 DOMAIN
#include <aux/heap/undef/ccod>
-----
cat >$OUT_DIR/map/heap/is_in/vdm <<'-----'
#include <aux/heap/undef/vdm>
-----
[ -d $OUT_DIR/map/heap/is_in_dom ] || mkdir $OUT_DIR/map/heap/is_in_dom
cat >$OUT_DIR/map/heap/is_in_dom/ccod <<'-----'
#define FCT is_in_dom
#define RES Bool
#define X1 ELEM1
#define X2 DOMAIN
#define X3 ELEM2 *
#include <aux/heap/undef/ccod>
-----
cat >$OUT_DIR/map/heap/is_in_dom/vdm <<'-----'
#include <aux/heap/undef/vdm>
-----
[ -d $OUT_DIR/map/heap/mk_empty ] || mkdir $OUT_DIR/map/heap/mk_empty
cat >$OUT_DIR/map/heap/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() {return 0;}
-----
cat >$OUT_DIR/map/heap/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() 0
-----
cat >$OUT_DIR/map/heap/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/heap/ovwrt1 ] || mkdir $OUT_DIR/map/heap/ovwrt1
cat >$OUT_DIR/map/heap/ovwrt1/ccod <<'-----'
   DOMAIN ovwrt1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
      {store##_ELEM1(x2,x3); return 0; } 
-----
cat >$OUT_DIR/map/heap/ovwrt1/cmcr <<'-----'
_DEFINE ovwrt1##_DOMAIN(x1,x2,x3) (store##_ELEM1(x2,x3),0)
-----
[ -d $OUT_DIR/map/heap/ovwrt1d ] || mkdir $OUT_DIR/map/heap/ovwrt1d
cat >$OUT_DIR/map/heap/ovwrt1d/ccod <<'-----'
   DOMAIN ovwrt1d##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
      {del##_ELEM2(cont##_ELEM1(x2));
       store##_ELEM1(x2,x3);
       return 0;
      } 
-----
cat >$OUT_DIR/map/heap/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM2    = + del
-----
[ -d $OUT_DIR/map/heap/print ] || mkdir $OUT_DIR/map/heap/print
cat >$OUT_DIR/map/heap/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
   { cerr << MKSTRING([<DOMAIN : map cannot be printed>]);}
_ELSE
   {fprintf(stderr,MKSTRING([<DOMAIN : map cannot be printed>]));}
_ENDIF
-----
cat >$OUT_DIR/map/heap/print/docu <<'-----'
  maps of this implementation cannot be printed
  because the elements cannot be enumerated
-----
cat >$OUT_DIR/map/heap/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/map/heap/sel ] || mkdir $OUT_DIR/map/heap/sel
cat >$OUT_DIR/map/heap/sel/ccod <<'-----'

  ELEM2 sel##_DOMAIN(x1,x2) _FPH2(DOMAIN,ELEM1) {return cont##_ELEM1(x2);}
-----
cat >$OUT_DIR/map/heap/sel/cmcr <<'-----'
_DEFINE sel##_DOMAIN(x1,x2) cont##_ELEM1(x2)
-----
cat >$OUT_DIR/map/heap/sel/docu <<'-----'
  time complexity : constant
-----
[ -d $OUT_DIR/map/heap/sub1 ] || mkdir $OUT_DIR/map/heap/sub1
cat >$OUT_DIR/map/heap/sub1/ccod <<'-----'
#include <aux/heap/sub1/ccod>
-----
cat >$OUT_DIR/map/heap/sub1/cmcr <<'-----'
_DEFINE sub1##_DOMAIN(x1,x2) (free##_ELEM1(x2),0)
-----
[ -d $OUT_DIR/map/heap/sub1d ] || mkdir $OUT_DIR/map/heap/sub1d
cat >$OUT_DIR/map/heap/sub1d/ccod <<'-----'
#define fct sub1d
#define delelem MERGE(del,_ELEM2)(MERGE(cont,_ELEM1)(x2));
#include <aux/heap/sub1/ccod>
-----
cat >$OUT_DIR/map/heap/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM2  = + del
-----
[ -d $OUT_DIR/map/heap/union1 ] || mkdir $OUT_DIR/map/heap/union1
cat >$OUT_DIR/map/heap/union1/ccod <<'-----'
   DOMAIN union1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
      {store##_ELEM1(x2,x3); return 0; } 
-----
cat >$OUT_DIR/map/heap/union1/cmcr <<'-----'
_DEFINE union1##_DOMAIN(x1,x2,x3) (store##_ELEM1(x2,x3),0)
-----
[ -d $OUT_DIR/map/heapmap ] || mkdir $OUT_DIR/map/heapmap
[ -d $OUT_DIR/map/heapmap/basic ] || mkdir $OUT_DIR/map/heapmap/basic
cat >$OUT_DIR/map/heapmap/basic/docu <<'-----'
  Implementation of

      DOMAIN = ELEM1 -m-> ELEM2

  as

      Token -m-> Value

  For ELEM1 the "ptr" implementation is taken,
  Pointers represent the key values of type #ELEM1,
  the values stored at these pointer are
  the attribute values of type #ELEM2.
  The implementation is directly done in the heap store.
  The keys of a map value are stored in a set of pointers.
  So this implementation is as efficient as the heap implementation,
  but also most of the operations are available.

  Features:

  For the Token domain the pointer to the element is taken.
  Therefore,  the  map  application  ('sel') becomes  a simple
  pointer dereferencing operation. If the parameter SAVE is set
  an 'is_in' test is done before accessing the attribute value.

  Warning: 

  all Token values should always be part of one unique map value
  otherwise errors in the storage management will occour.
  map subraction must be used carefully because the 'sub1' operation
  frees the storage for the attribute value associated with the token.
  So moving a map element from one map to another is not possible.

  Parameters:

  'MACROS' :
               operations as macros if available
  'SAVE' :
               checks on legal accesses are generated

  'ALLOC' :
               allocation stategie for the heap
               default: malloc

  'DOMIMPL' :
               implementation for the auxiliary set 
               for the domain values
               default: linklist

  Example:

    DOMAINS
      Domain  = Pointer -m-> Value
      Pointer = TOKEN
      Value   = ...

    IMPLEMENTATIONS
      Domain  = heapmap + ...
      Pointer = ptr + ...
      Value   = ...
-----
cat >$OUT_DIR/map/heapmap/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/heapmap/basic/gtyp <<'-----'
  TYPE_DEF(DOMAIN,H1##_DOMAIN)
-----
cat >$OUT_DIR/map/heapmap/basic/param <<'-----'
ALLOC
INTERNALDOMAIN
MACROS
SAVE
SETIMPL
-----
cat >$OUT_DIR/map/heapmap/basic/vdm <<'-----'
#ifndef ALLOC
#define ALLOC malloc("INTERNALDOMAIN")
#endif

#ifndef DOMIMPL
#define DOMIMPL linklist("INTERNALDOMAIN")
#endif

DOMAINS
   Heap##_DOMAIN  = ELEM1 -heap
   H1##_DOMAIN    = ELEM1 -set

   DOMAIN         -> Heap##_DOMAIN
   DOMAIN         -> H1##_DOMAIN
   ELEM1          -> ELEM2

IMPLEMENTATIONS
   ELEM1          = ptr("ELEM"=ELEM2)

   Heap##_DOMAIN  = ALLOC
                 + alloc("STRUCT"=ELEM2)
#ifdef MACROS
                 + cont("RESULT"=ELEM2)
#else
                 + cont("MACROS","RESULT"=ELEM2)
#endif
   H1##_DOMAIN    = DOMIMPL
#undef ALLOC
#undef DOMIMPL

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/heapmap/card ] || mkdir $OUT_DIR/map/heapmap/card
cat >$OUT_DIR/map/heapmap/card/ccod <<'-----'
   Nat0 card##_DOMAIN _FPH1(DOMAIN) {return card_##h1##_DOMAIN(x1);}
-----
cat >$OUT_DIR/map/heapmap/card/cmcr <<'-----'
_DEFINE card##_DOMAIN(x1) card_##h1##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/heapmap/card/vdm <<'-----'
#define fct card
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/copy1 ] || mkdir $OUT_DIR/map/heapmap/copy1
cat >$OUT_DIR/map/heapmap/copy1/ccod <<'-----'
  H1##_DOMAIN copy10##_DOMAIN##_ELEM1 _FPH1(ELEM1)
   {ELEM1 y1;
    y1 = (ELEM1)alloc##_ELEM1();
    store##_ELEM1(y1,*x1);
    return mk1_##h1##_DOMAIN(y1);
   } 

   DOMAIN copy1##_DOMAIN _FPH1(DOMAIN)
   { return copy_##h1##_DOMAIN(x1); }
-----
cat >$OUT_DIR/map/heapmap/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   H1##_DOMAIN  = + mk_empty + union + mk1
                 + fold.copy("RESULT"=H1##_DOMAIN,
                             "NULLFCT"=mk_empty,
                             "FOLDFCT"=union,
                             "CVFCT"=copy10##_DOMAIN)
-----
[ -d $OUT_DIR/map/heapmap/del1 ] || mkdir $OUT_DIR/map/heapmap/del1
cat >$OUT_DIR/map/heapmap/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN)
   {
    forall_##h1##_DOMAIN(x1,free##_ELEM1);
    del1_##h1##_DOMAIN(x1);
   }
-----
cat >$OUT_DIR/map/heapmap/del1/vdm <<'-----'
#define fct del1 + forall
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/ext ] || mkdir $OUT_DIR/map/heapmap/ext
cat >$OUT_DIR/map/heapmap/ext/ccod <<'-----'
  ELEM1 ext##_DOMAIN _FPH2(DOMAIN *,ELEM2)
   {ELEM1 y1;
    y1 = (ELEM1)alloc##_ELEM1();
    (* x1) = union1_##h1##_DOMAIN((* x1),y1);
    store##_ELEM1(y1,x2);
    return y1;
   } 
-----
cat >$OUT_DIR/map/heapmap/ext/vdm <<'-----'
#define fct union1
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/forall ] || mkdir $OUT_DIR/map/heapmap/forall
cat >$OUT_DIR/map/heapmap/forall/ccod <<'-----'
  static T2_forall##_DOMAIN _xx2_forall##_DOMAIN;

  static void _ff1_forall##_DOMAIN _FPH1(ELEM1)
   {(*_xx2_forall##_DOMAIN)(x1,cont##_ELEM1(x1));}

  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
   {T2_forall##_DOMAIN y1 = _xx2_forall##_DOMAIN;
    _xx2_forall##_DOMAIN = x2;
    forall_##h1##_DOMAIN(x1,_ff1_forall##_DOMAIN);
    _xx2_forall##_DOMAIN = y1;
   }
-----
cat >$OUT_DIR/map/heapmap/forall/vdm <<'-----'
#define fct forall
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/is_empty ] || mkdir $OUT_DIR/map/heapmap/is_empty
cat >$OUT_DIR/map/heapmap/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) {return is_empty_##h1##_DOMAIN(x1);}
-----
cat >$OUT_DIR/map/heapmap/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) is_empty_##h1##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/heapmap/is_empty/vdm <<'-----'
#define fct is_empty
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/is_in ] || mkdir $OUT_DIR/map/heapmap/is_in
cat >$OUT_DIR/map/heapmap/is_in/ccod <<'-----'
  Bool is_in##_DOMAIN _FPH2(ELEM1,DOMAIN) {return is_in_##h1##_DOMAIN(x1,x2);}
-----
cat >$OUT_DIR/map/heapmap/is_in/cmcr <<'-----'
_DEFINE is_in##_DOMAIN(x1,x2) is_in_##h1##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/map/heapmap/is_in/vdm <<'-----'
#define fct is_in
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/is_in_dom ] || mkdir $OUT_DIR/map/heapmap/is_in_dom
cat >$OUT_DIR/map/heapmap/is_in_dom/ccod <<'-----'
  Bool is_in_dom##_DOMAIN _FPH3(ELEM1,DOMAIN,ELEM2 *)
   {if (is_in_##h1##_DOMAIN(x1,x2))
       {*x3 = cont##_ELEM1(x1);
        return 1;}
    return 0;}
-----
cat >$OUT_DIR/map/heapmap/is_in_dom/vdm <<'-----'
#define fct is_in
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/iterator ] || mkdir $OUT_DIR/map/heapmap/iterator
cat >$OUT_DIR/map/heapmap/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/map/heapmap/iterator/vdm <<'-----'

#define PARAM "INTERNALFCT"
#define IMPL heapmap
#include <aux/com/iterator/vdm>

DOMAINS
IMPLEMENTATIONS
  H1##_DOMAIN = + iterator("INTERNALFCT")
-----
[ -d $OUT_DIR/map/heapmap/mk_empty ] || mkdir $OUT_DIR/map/heapmap/mk_empty
cat >$OUT_DIR/map/heapmap/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() {return mk_empty_##h1##_DOMAIN();}
-----
cat >$OUT_DIR/map/heapmap/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() mk_empty_##h1##_DOMAIN()
-----
cat >$OUT_DIR/map/heapmap/mk_empty/vdm <<'-----'
#define fct mk_empty
#include <aux/heapmap/basic/vdm>

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/heapmap/ovwrt1 ] || mkdir $OUT_DIR/map/heapmap/ovwrt1
cat >$OUT_DIR/map/heapmap/ovwrt1/ccod <<'-----'
#include <aux/heapmap/ovwrt1/ccod>
-----
cat >$OUT_DIR/map/heapmap/ovwrt1/vdm <<'-----'
#define fct union1
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/ovwrt1d ] || mkdir $OUT_DIR/map/heapmap/ovwrt1d
cat >$OUT_DIR/map/heapmap/ovwrt1d/ccod <<'-----'
#define fct ovwrt1d
#define delelem MERGE(del,_ELEM2)(MERGE(cont,_ELEM1)(x2));
#include <aux/heapmap/ovwrt1/ccod>
-----
cat >$OUT_DIR/map/heapmap/ovwrt1d/vdm <<'-----'
#define fct del
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/sel ] || mkdir $OUT_DIR/map/heapmap/sel
cat >$OUT_DIR/map/heapmap/sel/ccod <<'-----'

  ELEM2 sel##_DOMAIN _FPH2(DOMAIN,ELEM1)
   {
#ifdef SAVE
    if (! is_in_##h1##_DOMAIN(x2,x1)) err_smap_vdmlib(MKSTRING(DOMAIN));
#endif
    return cont##_ELEM1(x2);
   }
-----
cat >$OUT_DIR/map/heapmap/sel/cmcr <<'-----'
_DEFINE sel##_DOMAIN(x1,x2) cont##_ELEM1(x2)
-----
cat >$OUT_DIR/map/heapmap/sel/docu <<'-----'
  time complexity :
    if parameter SAVE is set :  O(is_in) for the domain set
    else                     :  constant
-----
cat >$OUT_DIR/map/heapmap/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifndef MACROS
#ifdef SAVE
   H1##_DOMAIN = + is_in
   Vdmlib     = + err_smap
#endif
#endif
-----
[ -d $OUT_DIR/map/heapmap/sub1 ] || mkdir $OUT_DIR/map/heapmap/sub1
cat >$OUT_DIR/map/heapmap/sub1/ccod <<'-----'
#include <aux/heapmap/sub1/ccod>
-----
cat >$OUT_DIR/map/heapmap/sub1/vdm <<'-----'
#define fct sub1
#include <aux/heapmap/basic/vdm>
-----
[ -d $OUT_DIR/map/heapmap/sub1d ] || mkdir $OUT_DIR/map/heapmap/sub1d
cat >$OUT_DIR/map/heapmap/sub1d/ccod <<'-----'
#define fct sub1d
#define delelem MERGE(del,_ELEM2)(MERGE(cont,_ELEM1)(x2));
#include <aux/heapmap/sub1/ccod>
-----
cat >$OUT_DIR/map/heapmap/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   H1##_DOMAIN = + sub1
   ELEM2      = + del
-----
[ -d $OUT_DIR/map/heapmap/union1 ] || mkdir $OUT_DIR/map/heapmap/union1
cat >$OUT_DIR/map/heapmap/union1/ccod <<'-----'
   DOMAIN union1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
      {if (is_in_##h1##_DOMAIN(x2,x1))
         {if (! is_eq##_ELEM2(cont##_ELEM1(x2),x3)) err_umap_vdmlib(MKSTRING(DOMAIN));}
       else
         {x1 = union1_##h1##_DOMAIN(x1,x2);store##_ELEM1(x2,x3);}
       return x1;
      } 
-----
cat >$OUT_DIR/map/heapmap/union1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   H1##_DOMAIN = + is_in + union1
   ELEM2      = + is_eq
   Vdmlib     = + err_umap
-----
[ -d $OUT_DIR/map/linklist ] || mkdir $OUT_DIR/map/linklist
[ -d $OUT_DIR/map/linklist/basic ] || mkdir $OUT_DIR/map/linklist/basic
cat >$OUT_DIR/map/linklist/basic/docu <<'-----'
  Implementation of Maps as linked lists

  space : O(n) * (sizeof(pointer) + sizeof(ELEM1) + sizeof(ELEM2))
-----
cat >$OUT_DIR/map/linklist/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/linklist/basic/gptr <<'-----'
#include <aux/linklist/basic/gptr>
-----
cat >$OUT_DIR/map/linklist/basic/gtyp <<'-----'
#include <aux/linklist/basic/gtyp>
-----
cat >$OUT_DIR/map/linklist/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
SAVE
-----
cat >$OUT_DIR/map/linklist/basic/vdm <<'-----'
#include <aux/com/heap/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/linklist/card ] || mkdir $OUT_DIR/map/linklist/card
cat >$OUT_DIR/map/linklist/card/ccod <<'-----'
#define fct card
#include <aux/linklist/len/ccod>
-----
cat >$OUT_DIR/map/linklist/card/docu <<'-----'
  time complexity : O(n)
-----
[ -d $OUT_DIR/map/linklist/copy ] || mkdir $OUT_DIR/map/linklist/copy
cat >$OUT_DIR/map/linklist/copy/ccod <<'-----'
#include <aux/linklist/copy/ccod>
-----
cat >$OUT_DIR/map/linklist/copy/vdm <<'-----'
#include <aux/linklist/copy/vdm>
-----
[ -d $OUT_DIR/map/linklist/copy1 ] || mkdir $OUT_DIR/map/linklist/copy1
cat >$OUT_DIR/map/linklist/copy1/ccod <<'-----'
#include <aux/linklist/copy1/ccod>
-----
[ -d $OUT_DIR/map/linklist/del1 ] || mkdir $OUT_DIR/map/linklist/del1
cat >$OUT_DIR/map/linklist/del1/ccod <<'-----'
#include <aux/linklist/del1/ccod>
-----
cat >$OUT_DIR/map/linklist/del1/cmcr <<'-----'
#include <aux/linklist/del1/cmcr>
-----
[ -d $OUT_DIR/map/linklist/fold ] || mkdir $OUT_DIR/map/linklist/fold
cat >$OUT_DIR/map/linklist/fold/ccod <<'-----'
#include <aux/linklist/fold/ccod>
-----
cat >$OUT_DIR/map/linklist/fold/docu <<'-----'
#define Abortval
#define Map map
  Special linklist implementation for 'fold'
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/map/linklist/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/map/linklist/fold/vdm <<'-----'
#include <aux/linklist/fold/vdm>
-----
[ -d $OUT_DIR/map/linklist/forall ] || mkdir $OUT_DIR/map/linklist/forall
cat >$OUT_DIR/map/linklist/forall/ccod <<'-----'
#include <aux/linklist/forall/ccod>
-----
cat >$OUT_DIR/map/linklist/forall/cmcr <<'-----'
#include <aux/linklist/forall/cmcr>
-----
[ -d $OUT_DIR/map/linklist/is_empty ] || mkdir $OUT_DIR/map/linklist/is_empty
cat >$OUT_DIR/map/linklist/is_empty/ccod <<'-----'
#include <aux/linklist/is_empty/ccod>
-----
cat >$OUT_DIR/map/linklist/is_empty/cmcr <<'-----'
#include <aux/linklist/is_empty/cmcr>
-----
cat >$OUT_DIR/map/linklist/is_empty/docu <<'-----'
  time complexity : constant (1 pointer test)
-----
cat >$OUT_DIR/map/linklist/is_empty/pmcr <<'-----'
#include <aux/linklist/is_empty/pmcr>
-----
[ -d $OUT_DIR/map/linklist/is_in ] || mkdir $OUT_DIR/map/linklist/is_in
cat >$OUT_DIR/map/linklist/is_in/ccod <<'-----'

#define fct is_in
#define params _FP(x1,ELEM1), _FP(x2,DOMAIN)
#define paramdec _EP(x1,ELEM1) _EP(x2,DOMAIN)
#define search if (MERGE(is_eq,_ELEM1)(MERGE(ref,_DOMAIN)(x2)->f_info,x1)) return 1;
#include <aux/linklist/is_in/ccod>
-----
cat >$OUT_DIR/map/linklist/is_in/docu <<'-----'
  time complexity : O(n)
-----
cat >$OUT_DIR/map/linklist/is_in/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq
-----
[ -d $OUT_DIR/map/linklist/is_in_dom ] || mkdir $OUT_DIR/map/linklist/is_in_dom
cat >$OUT_DIR/map/linklist/is_in_dom/ccod <<'-----'

#define fct is_in_dom
#define params _FP(x1,ELEM1), _FP(x2,DOMAIN), _FP(x3,ELEM2 *)
#define paramdec _EP(x1,ELEM1) _EP(x2,DOMAIN) _EP(x3,ELEM2 *)
#define search if (MERGE(is_eq,_ELEM1)(MERGE(ref,_DOMAIN)(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
#include <aux/linklist/is_in/ccod>
-----
cat >$OUT_DIR/map/linklist/is_in_dom/docu <<'-----'
  time complexity : O(n)
-----
cat >$OUT_DIR/map/linklist/is_in_dom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq
-----
[ -d $OUT_DIR/map/linklist/is_in_rng ] || mkdir $OUT_DIR/map/linklist/is_in_rng
cat >$OUT_DIR/map/linklist/is_in_rng/ccod <<'-----'

#define fct is_in_rng
#define params _FP(x1,ELEM2), _FP(x2,DOMAIN), _FP(x3,ELEM1 *)
#define paramdec _EP(x1,ELEM2) _EP(x2,DOMAIN) _EP(x3,ELEM1 *)
#define search if (MERGE(is_eq,_ELEM2)(MERGE(ref,_DOMAIN)(x2)->f_attr,x1)) {*x3 = x2->f_info; return 1;}
#include <aux/linklist/is_in/ccod>
-----
cat >$OUT_DIR/map/linklist/is_in_rng/docu <<'-----'
  time complexity : O(n)
-----
cat >$OUT_DIR/map/linklist/is_in_rng/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM2  = + is_eq
-----
[ -d $OUT_DIR/map/linklist/iterator ] || mkdir $OUT_DIR/map/linklist/iterator
cat >$OUT_DIR/map/linklist/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/map/linklist/iterator/vdm <<'-----'
#define IMPL linklist
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/map/linklist/mk1 ] || mkdir $OUT_DIR/map/linklist/mk1
cat >$OUT_DIR/map/linklist/mk1/ccod <<'-----'
#include <aux/linklist/mk1/ccod>
-----
cat >$OUT_DIR/map/linklist/mk1/vdm <<'-----'

#define CONSTRNAME mk1
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/linklist/mk_empty ] || mkdir $OUT_DIR/map/linklist/mk_empty
cat >$OUT_DIR/map/linklist/mk_empty/ccod <<'-----'
#include <aux/linklist/mk_empty/ccod>
-----
cat >$OUT_DIR/map/linklist/mk_empty/cmcr <<'-----'
#include <aux/linklist/mk_empty/cmcr>
-----
cat >$OUT_DIR/map/linklist/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/linklist/ovwrt1 ] || mkdir $OUT_DIR/map/linklist/ovwrt1
cat >$OUT_DIR/map/linklist/ovwrt1/ccod <<'-----'

#define fct ovwrt1
#define params _FP(x1,DOMAIN), _FP(x2,ELEM1), _FP(x3,ELEM2)
#define paramdec _EP(x1,DOMAIN) _EP(x2,ELEM1) _EP(x3,ELEM2)
#define retst {MERGE(ref,_DOMAIN)(lx1)->f_attr=x3; return x1;}
#define notfound lx1 = MERGE(mk1,_DOMAIN)(x2,x3);
#include <aux/linklist/union1/ccod>
-----
cat >$OUT_DIR/map/linklist/ovwrt1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk1
   ELEM1    = + is_eq
-----
[ -d $OUT_DIR/map/linklist/ovwrt1d ] || mkdir $OUT_DIR/map/linklist/ovwrt1d
cat >$OUT_DIR/map/linklist/ovwrt1d/ccod <<'-----'

#define fct ovwrt1d
#define params _FP(x1,DOMAIN), _FP(x2,ELEM1), _FP(x3,ELEM2)
#define paramdec _EP(x1,DOMAIN) _EP(x2,ELEM1) _EP(x3,ELEM2)
#define retst {MERGE(del,_ELEM1)(x2);MERGE(del,_ELEM2)(lx1->f_attr);lx1->f_attr=x3;return x1;}
#define notfound lx1 = MERGE(mk1,_DOMAIN)(x2,x3);
#include <aux/linklist/union1/ccod>
-----
cat >$OUT_DIR/map/linklist/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk1
   ELEM1    = + is_eq + del
   ELEM2    = + del
-----
[ -d $OUT_DIR/map/linklist/sel ] || mkdir $OUT_DIR/map/linklist/sel
cat >$OUT_DIR/map/linklist/sel/ccod <<'-----'
  ELEM2 sel##_DOMAIN _FPH2(DOMAIN,ELEM1)
   {while (x1)
    {if (is_eq##_ELEM1(ref##_DOMAIN(x1)->f_info,x2)) return x1->f_attr;
     x1 = x1->f_next;
    } 
    err_smap_vdmlib(MKSTRING(DOMAIN));
    return x1->f_attr; /* dummy to prevent silly compiler warnings */
   }
-----
cat >$OUT_DIR/map/linklist/sel/docu <<'-----'
  time complexity : constant
-----
cat >$OUT_DIR/map/linklist/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1    = + is_eq
   Vdmlib   = + err_smap
-----
[ -d $OUT_DIR/map/linklist/sel_dom ] || mkdir $OUT_DIR/map/linklist/sel_dom
cat >$OUT_DIR/map/linklist/sel_dom/docu <<'-----'
  Special implementation of 'sel_dom' for linked lists.
  If 'MACROS' is set, no test for empty map will be done.

  Time characteristics: Constant
-----
cat >$OUT_DIR/map/linklist/sel_dom/gcod <<'-----'
#ifdef CROUTINES
  ELEM1 sel_dom##_DOMAIN _FPH1(DOMAIN)
   {if (x1) 
       return ref##_DOMAIN(x1)->f_info;
    err_emap_vdmlib(MKSTRING(DOMAIN));
    return x1->f_info; /* prevent compiler warnings */
   }
#else
_FDEC1(sel_dom,ELEM1,DOMAIN,_RET(_ICOMPSEL(ref##_DOMAIN(x1),f_info)))
#endif
-----
cat >$OUT_DIR/map/linklist/sel_dom/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/linklist/sel_dom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifndef MACROS
   Vdmlib   = + err_emap
#endif
-----
[ -d $OUT_DIR/map/linklist/sub1 ] || mkdir $OUT_DIR/map/linklist/sub1
cat >$OUT_DIR/map/linklist/sub1/ccod <<'-----'
#include <aux/linklist/sub1/ccod>
-----
cat >$OUT_DIR/map/linklist/sub1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq
-----
[ -d $OUT_DIR/map/linklist/sub1d ] || mkdir $OUT_DIR/map/linklist/sub1d
cat >$OUT_DIR/map/linklist/sub1d/ccod <<'-----'

#define fct sub1d
#define delelem MERGE(del,_ELEM1)(lx2->f_info); MERGE(del,_ELEM2)(lx2->f_attr);
#include <aux/linklist/sub1/ccod>
-----
cat >$OUT_DIR/map/linklist/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq + del
-----
[ -d $OUT_DIR/map/linklist/union1 ] || mkdir $OUT_DIR/map/linklist/union1
cat >$OUT_DIR/map/linklist/union1/ccod <<'-----'

#define params _FP(x1,DOMAIN), _FP(x2,ELEM1), _FP(x3,ELEM2)
#define paramdec _EP(x1,DOMAIN) _EP(x2,ELEM1) _EP(x3,ELEM2)
#define retst {if (! MERGE(is_eq,_ELEM2)(MERGE(ref,_DOMAIN)(lx1)->f_attr,x3)) err_umap_vdmlib(MKSTRING(DOMAIN)); return x1;}
#define notfound lx1 = MERGE(mk1,_DOMAIN)(x2,x3);
#include <aux/linklist/union1/ccod>
-----
cat >$OUT_DIR/map/linklist/union1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk1
   ELEM1    = + is_eq
   ELEM2    = + is_eq
   Vdmlib   = + err_umap
-----
[ -d $OUT_DIR/map/linklist/union1d ] || mkdir $OUT_DIR/map/linklist/union1d
cat >$OUT_DIR/map/linklist/union1d/ccod <<'-----'

#define fct union1d
#define params _FP(x1,DOMAIN), _FP(x2,ELEM1), _FP(x3,ELEM2)
#define paramdec _EP(x1,DOMAIN) _EP(x2,ELEM1) _EP(x3,ELEM2)
#define retst {if (! MERGE(is_eq,_ELEM2)(MERGE(ref,_DOMAIN)(lx1)->f_attr,x3)) err_umap_vdmlib(MKSTRING(DOMAIN)); MERGE(del,_ELEM1)(x2);MERGE(del,_ELEM2)(x3);return x1;}
#define notfound lx1 = MERGE(mk1,_DOMAIN)(x2,x3);
#include <aux/linklist/union1/ccod>
-----
cat >$OUT_DIR/map/linklist/union1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk1
   ELEM1    = + is_eq + del
   ELEM2    = + is_eq + del
   Vdmlib   = + err_umap
-----
[ -d $OUT_DIR/map/scaldom ] || mkdir $OUT_DIR/map/scaldom
[ -d $OUT_DIR/map/scaldom/basic ] || mkdir $OUT_DIR/map/scaldom/basic
cat >$OUT_DIR/map/scaldom/basic/defp <<'-----'
#ifndef TUPLIMP
#define TUPLIMP1 array("INTERNALDOMAIN")
#else
#define TUPLIMP1 TUPLIMP
#endif

#ifndef LOWB
#define LOWB1 MERGE(lb,_ELEM1)
#else
#define LOWB1 LOWB
#endif

#ifndef OPTIMP
#define OPTIMP1 elemonil("INTERNALDOMAIN",NILVAL="-1")
#else
#define OPTIMP1 OPTIMP
#endif

#define INDEX(x1) ((Nat0)x1 - LOWB1 + 1)
#define DOMELEM(i) (ELEM1)(i - 1 + LOWB1)
-----
cat >$OUT_DIR/map/scaldom/basic/docu <<'-----'
  Implementation of

     DOMAIN  =  ELEM1 -m-> ELEM2

  as

     DOMAIN  = [ ELEM2 ] *

  DOMAIN is implemented as a tuple of optional values of ELEM2.
  This implementation is applicable if ELEM1 is a scalar type with a
  fixed lower bound (e.g. Nat0 Nat1 ). ELEM1 is used for indexing into
  the tuple. The NIL value is used for indicating that the associated
  ELEM1 value is not in domain of a map value.
  This implementation is usefull if the domain of values constructed
  is contained in a small intervall the ELEM1.

  The tuple implementation should be an array implementation to use
  indexing for the access of the elements. In this case 
  the time complexity for is_in, sel, union1, ovwrt1 becomes constant.
  The space needed for a map value x1 is then proportional to the maximum
  element in the domain of x1.

  Parameter:

  "TUPLIMP" :
              gives the implementation name of the underlying tupl
              implementation. Default value is 'array'. This gives 
              random access to the map elements.
  "OPTIMP" :
              implementation of the optional domain. Default is
              'elemonil("-1")'
  "LOWB" :
              gives the lower bound of the scalar type. Default value 
              is the constant lb##_ELEM1, that is always defined for
              unsigned an scalar types

  Examples:
   
  a)
    DOMAINS
      DOMAIN  =  Nat0 -m-> Nat1

    IMPEMENTATIONS
      DOMAIN  =  scaldom(OPTIMP="elemonil(NILVAL=0)", LOWB=0)
       
  Here the optional domain [Nat1] is implemented as Nat1 | 0,
  that means 0 is used to indicate the NIL case

  b)
    DOMAINS
      DOMAIN  =  Char -m-> Nat0

    IMPEMENTATIONS
      DOMAIN  =  scaldom
       
  In this case the optional domain [Nat0] is implemented as Nat0 | -1
  -1 represents the NIL case
-----
cat >$OUT_DIR/map/scaldom/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/scaldom/basic/gtyp <<'-----'
   TYPE_DEF(DOMAIN,Tupl##_DOMAIN)
-----
cat >$OUT_DIR/map/scaldom/basic/param <<'-----'
AUTOMEM
INTERNALDOMAIN
LOWB
MACROS
OPTIMP
TUPLIMP
-----
cat >$OUT_DIR/map/scaldom/basic/undefp <<'-----'
#undef DOMELEM
#undef INDEX
#undef LOWB1
#undef OPTIMP1
#undef TUPLIMP1
-----
cat >$OUT_DIR/map/scaldom/basic/vdm <<'-----'
#include <map/scaldom/basic/defp>

  DOMAINS
   Opti##_DOMAIN   =  [ELEM2]
   Tupl##_DOMAIN   =  Opti##_DOMAIN*

   DOMAIN         -> Tupl##_DOMAIN

  IMPLEMENTATIONS
   Opti##_DOMAIN   =  OPTIMP1
   Tupl##_DOMAIN   =  TUPLIMP1

#include <map/scaldom/basic/undefp>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/scaldom/card ] || mkdir $OUT_DIR/map/scaldom/card
cat >$OUT_DIR/map/scaldom/card/ccod <<'-----'
  Nat0 card##_DOMAIN _FPH1(DOMAIN)
     { register Nat0 y1 = 0;
       register Nat1 y2;
       
       for (y2 = len_tupl##_DOMAIN(x1); y2 >= 1; y2--)
           { if (! is_nil_opti##_DOMAIN(sel_tupl##_DOMAIN(x1,y2))) y1++; }
       return y1;
     }
-----
cat >$OUT_DIR/map/scaldom/card/docu <<'-----'
  time complexity : o(n) * o(sel)
-----
cat >$OUT_DIR/map/scaldom/card/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN = + len + sel
  Opti##_DOMAIN = + is_nil
-----
[ -d $OUT_DIR/map/scaldom/copy ] || mkdir $OUT_DIR/map/scaldom/copy
cat >$OUT_DIR/map/scaldom/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN) { return copy_tupl##_DOMAIN(x1); }
-----
cat >$OUT_DIR/map/scaldom/copy/cmcr <<'-----'
_DEFINE copy##_DOMAIN(x1) copy_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/copy/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/scaldom/copy/pmcr <<'-----'
_DEFINE copy##_DOMAIN(x1) copy_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN = + copy
-----
[ -d $OUT_DIR/map/scaldom/copy1 ] || mkdir $OUT_DIR/map/scaldom/copy1
cat >$OUT_DIR/map/scaldom/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN) { return copy2_tupl##_DOMAIN(x1); }
-----
cat >$OUT_DIR/map/scaldom/copy1/cmcr <<'-----'
_DEFINE copy1##_DOMAIN(x1) copy2_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/copy1/pmcr <<'-----'
_DEFINE copy1##_DOMAIN(x1) copy2_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN = + copy2
-----
[ -d $OUT_DIR/map/scaldom/del ] || mkdir $OUT_DIR/map/scaldom/del
cat >$OUT_DIR/map/scaldom/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN) { del_tupl##_DOMAIN(x1); }
-----
cat >$OUT_DIR/map/scaldom/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1) del_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/del/pmcr <<'-----'
_DEFINE del##_DOMAIN(x1) del_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/del/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN = + del
-----
[ -d $OUT_DIR/map/scaldom/del1 ] || mkdir $OUT_DIR/map/scaldom/del1
cat >$OUT_DIR/map/scaldom/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) { del2_tupl##_DOMAIN(x1); }
-----
cat >$OUT_DIR/map/scaldom/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) del2_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/del1/pmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) del2_tupl##_DOMAIN(x1)
-----
cat >$OUT_DIR/map/scaldom/del1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN = + del2
-----
[ -d $OUT_DIR/map/scaldom/forall ] || mkdir $OUT_DIR/map/scaldom/forall
cat >$OUT_DIR/map/scaldom/forall/ccod <<'-----'
#include <map/scaldom/basic/defp>

static T2_forall##_DOMAIN tmp_forall##_DOMAIN;

static void help_forall##_DOMAIN _FPH2(Opti##_DOMAIN,Nat1)
  { ELEM2 lx1;
  
    if (is_opt_opti##_DOMAIN(x1,&lx1))
       {(*tmp_forall##_DOMAIN)(DOMELEM(x2),lx1);}
  }

  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
    
    { T2_forall##_DOMAIN lx1 = tmp_forall##_DOMAIN;
      tmp_forall##_DOMAIN = x2;
      forindex_tupl##_DOMAIN(x1,help_forall##_DOMAIN);
      tmp_forall##_DOMAIN = lx1;
    }

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/forall/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN  = + forindex
  Opti##_DOMAIN  = + is_opt
-----
[ -d $OUT_DIR/map/scaldom/is_in_dom ] || mkdir $OUT_DIR/map/scaldom/is_in_dom
cat >$OUT_DIR/map/scaldom/is_in_dom/ccod <<'-----'
#include <map/scaldom/basic/defp>

  Bool is_in_dom##_DOMAIN _FPH3(ELEM1,DOMAIN,ELEM2 *)
    { return (INDEX(x1) > len_tupl##_DOMAIN(x2))
             ? 0
             : is_opt_opti##_DOMAIN(sel_tupl##_DOMAIN(x2,INDEX(x1)),x3); }

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/is_in_dom/docu <<'-----'
  time complexity : o(sel_tupl)
-----
cat >$OUT_DIR/map/scaldom/is_in_dom/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Tupl##_DOMAIN  = + sel + len
   Opti##_DOMAIN  = + is_opt
-----
[ -d $OUT_DIR/map/scaldom/iterator ] || mkdir $OUT_DIR/map/scaldom/iterator
cat >$OUT_DIR/map/scaldom/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/map/scaldom/iterator/vdm <<'-----'
#include <map/scaldom/basic/defp>

#define PARAM "INTERNALFCT","LOWB"=MKSTRING(LOWB1)
#define IMPL scaldom
#include <aux/com/iterator/vdm>

DOMAINS
IMPLEMENTATIONS
  Tupl##_DOMAIN = + iterator("INTERNALFCT")

#include <map/scaldom/basic/undefp>
-----
[ -d $OUT_DIR/map/scaldom/mk_empty ] || mkdir $OUT_DIR/map/scaldom/mk_empty
cat >$OUT_DIR/map/scaldom/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() {return mk_empty_tupl##_DOMAIN();}
-----
cat >$OUT_DIR/map/scaldom/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() mk_empty_tupl##_DOMAIN()
-----
cat >$OUT_DIR/map/scaldom/mk_empty/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/scaldom/mk_empty/pmcr <<'-----'
_DEFINE mk_empty##_DOMAIN mk_empty_tupl##_DOMAIN
-----
cat >$OUT_DIR/map/scaldom/mk_empty/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Tupl##_DOMAIN  = + mk_empty

#define CONSTRNAME mk_empty
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/scaldom/ovwrt1 ] || mkdir $OUT_DIR/map/scaldom/ovwrt1
cat >$OUT_DIR/map/scaldom/ovwrt1/ccod <<'-----'
#include <map/scaldom/basic/defp>

  DOMAIN ovwrt1##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
    { return ( (INDEX(x2) > len_tupl##_DOMAIN(x1))
               ? union1##_DOMAIN(x1,x2,x3)
               : ovwrt1_tupl##_DOMAIN(x1,INDEX(x2),mk_opt_opti##_DOMAIN(x3)));
    }

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/ovwrt1/cmcr.err <<'-----'
/* error see ovwrt1d */
#include <map/scaldom/basic/defp>

_DEFINE ovwrt1##_DOMAIN(x1,x2,x3) ovwrt1_tupl##_DOMAIN(x1,INDEX(x2),mk_opt_opti##_DOMAIN(x3))

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/ovwrt1/pmcr.err <<'-----'
/* error see ovwrt1d */
#include <map/scaldom/basic/defp>

_DEFINE ovwrt1##_DOMAIN(x1,x2,x3) ovwrt1_tupl##_DOMAIN(x1,INDEX(x2),mk_opt_opti##_DOMAIN(x3))

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/ovwrt1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN         = + union1
   Tupl##_DOMAIN   = + ovwrt1 + len
   Opti##_DOMAIN   = + mk_opt
-----
[ -d $OUT_DIR/map/scaldom/ovwrt1d ] || mkdir $OUT_DIR/map/scaldom/ovwrt1d
cat >$OUT_DIR/map/scaldom/ovwrt1d/ccod <<'-----'
#include <map/scaldom/basic/defp>

  DOMAIN ovwrt1d##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
    { return ( (INDEX(x2) > len_tupl##_DOMAIN(x1))
               ? union1##_DOMAIN(x1,x2,x3)
               : ovwrt1d_tupl##_DOMAIN(x1,INDEX(x2),mk_opt_opti##_DOMAIN(x3)));
    }

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/ovwrt1d/cmcr.err <<'-----'
/* extra case required for extending the map */
#include <map/scaldom/basic/defp>

_DEFINE ovwrt1d##_DOMAIN(x1,x2,x3) ovwrt1d_tupl##_DOMAIN(x1,INDEX(x2),mk_opt_opti##_DOMAIN(x3))

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/ovwrt1d/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/scaldom/ovwrt1d/pmcr.err <<'-----'
#include <map/scaldom/basic/defp>

_DEFINE ovwrt1d##_DOMAIN(x1,x2,x3) ovwrt1d_tupl##_DOMAIN(x1,INDEX(x2),mk_opt_opti##_DOMAIN(x3))

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN         = + union1
   Tupl##_DOMAIN   = + ovwrt1d + len
   Opti##_DOMAIN   = + mk_opt
-----
[ -d $OUT_DIR/map/scaldom/sub1 ] || mkdir $OUT_DIR/map/scaldom/sub1
cat >$OUT_DIR/map/scaldom/sub1/ccod <<'-----'
#include <map/scaldom/basic/defp>

#ifndef OVWRT1
#define OVWRT1 ovwrt1
#define FCT sub1
#endif

  DOMAIN FCT##_DOMAIN _FPH2(DOMAIN,ELEM1)
    { return (INDEX(x2) > len_tupl##_DOMAIN(x1))
	     ? x1
	     : OVWRT1##_tupl##_DOMAIN(x1,INDEX(x2),mk_nil_opti##_DOMAIN());
    }

#undef OVWRT1
#undef FCT
#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/sub1/cmcr <<'-----'
#include <map/scaldom/basic/defp>

#ifndef OVWRT1
#define OVWRT1 ovwrt1
#define FCT sub1
#endif


_DEFINE FCT##_DOMAIN(x1,x2) ((INDEX(x2) > len_tupl##_DOMAIN(x1)) ? x1 : OVWRT1##_tupl##_DOMAIN(x1,INDEX(x2),mk_nil_opti##_DOMAIN()))

#undef OVWRT1
#undef FCT
#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/sub1/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/scaldom/sub1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Tupl##_DOMAIN  = + ovwrt1
   Opti##_DOMAIN  = + mk_nil
-----
[ -d $OUT_DIR/map/scaldom/sub1d ] || mkdir $OUT_DIR/map/scaldom/sub1d
cat >$OUT_DIR/map/scaldom/sub1d/ccod <<'-----'
#define OVWRT1 ovwrt1d
#define FCT sub1d
#include <map/scaldom/sub1/ccod>
-----
cat >$OUT_DIR/map/scaldom/sub1d/cmcr <<'-----'
#include <map/scaldom/basic/defp>

_DEFINE sub1d##_DOMAIN(x1,x2) ovwrt1d_tupl##_DOMAIN(x1,INDEX(x2),mk_nil_opti##_DOMAIN())

#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/sub1d/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/scaldom/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Tupl##_DOMAIN  = + ovwrt1d
   Opti##_DOMAIN  = + mk_nil
-----
[ -d $OUT_DIR/map/scaldom/union1 ] || mkdir $OUT_DIR/map/scaldom/union1
cat >$OUT_DIR/map/scaldom/union1/auxccod <<'-----'
#include <map/scaldom/basic/defp>

  DOMAIN FCTNAME##_DOMAIN _FPH3(DOMAIN,ELEM1,ELEM2)
    {
      { Nat0   lx1 = INDEX(x2);
        Nat0   lx2 = len_tupl##_DOMAIN(x1);
        while (lx1 > lx2++) { x1 = appr_tupl##_DOMAIN(x1,mk_nil_opti##_DOMAIN()); }
      }
         
      { ELEM2  lx3;
        if (  is_opt_opti##_DOMAIN(sel_tupl##_DOMAIN(x1,INDEX(x2)),&lx3)
           && ! is_eq##_ELEM2(lx3,x3)
           ) {err_umap_vdmlib(MKSTRING(DOMAIN));}
      }
      
      return OVWRT1##_tupl##_DOMAIN(x1,INDEX(x2),mk_opt_opti##_DOMAIN(x3));
    }

#undef OVWRT1
#undef FCTNAME
#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/union1/auxvdm <<'-----'
#include <map/scaldom/basic/defp>

DOMAINS
IMPLEMENTATIONS
   Tupl##_DOMAIN  = + len + appr + sel + OVWRT1
   Opti##_DOMAIN  = + mk_nil + is_nil + mk_opt + is_opt
   ELEM2          = + is_eq
   Vdmlib         = + err_umap

#undef OVWRT1
#include <map/scaldom/basic/undefp>
-----
cat >$OUT_DIR/map/scaldom/union1/ccod <<'-----'
#define OVWRT1 ovwrt1
#define FCTNAME union1
#include <map/scaldom/union1/auxccod>
-----
cat >$OUT_DIR/map/scaldom/union1/vdm <<'-----'
#define OVWRT1 ovwrt1
#include <map/scaldom/union1/auxvdm>
-----
[ -d $OUT_DIR/map/scaldom/union1d ] || mkdir $OUT_DIR/map/scaldom/union1d
cat >$OUT_DIR/map/scaldom/union1d/ccod <<'-----'
#define OVWRT1 ovwrt1d
#define FCTNAME union1d
#include <map/scaldom/union1/auxccod>
-----
cat >$OUT_DIR/map/scaldom/union1d/vdm <<'-----'
#define OVWRT1 ovwrt1d
#include <map/scaldom/union1/auxvdm>
-----
[ -d $OUT_DIR/map/scanfile ] || mkdir $OUT_DIR/map/scanfile
[ -d $OUT_DIR/map/scanfile/basic ] || mkdir $OUT_DIR/map/scanfile/basic
cat >$OUT_DIR/map/scanfile/basic/docu <<'-----'
#include <aux/scanfile/basic/docu>
-----
cat >$OUT_DIR/map/scanfile/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/map/scanfile/basic/gtyp <<'-----'
#include <aux/scanfile/basic/gtyp>
-----
cat >$OUT_DIR/map/scanfile/basic/param <<'-----'
INTERNALDOMAIN
MACROS
TUPLDOMAIN
-----
cat >$OUT_DIR/map/scanfile/basic/vdm <<'-----'

#define CONSTRNAME mk_basic
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/map/scanfile/card ] || mkdir $OUT_DIR/map/scanfile/card
cat >$OUT_DIR/map/scanfile/card/ccod <<'-----'
#define fct card
#include <aux/scanfile/len/ccod>
-----
cat >$OUT_DIR/map/scanfile/card/cmcr <<'-----'
#include <map/scanfile/card/ccod>
-----
cat >$OUT_DIR/map/scanfile/card/param <<'-----'
MACROS
-----
[ -d $OUT_DIR/map/scanfile/cvfromtupl ] || mkdir $OUT_DIR/map/scanfile/cvfromtupl
cat >$OUT_DIR/map/scanfile/cvfromtupl/ccod <<'-----'
#include <aux/scanfile/cvfromtupl/ccod>
-----
cat >$OUT_DIR/map/scanfile/cvfromtupl/vdm <<'-----'
#include <aux/scanfile/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/map/scanfile/default ] || mkdir $OUT_DIR/map/scanfile/default
cat >$OUT_DIR/map/scanfile/default/docu <<'-----'
#include <aux/com/default/docunoop>
-----
cat >$OUT_DIR/map/scanfile/default/vdm <<'-----'
-----
[ -d $OUT_DIR/map/scanfile/del1 ] || mkdir $OUT_DIR/map/scanfile/del1
cat >$OUT_DIR/map/scanfile/del1/ccod <<'-----'
#include <aux/scanfile/del1/ccod>
-----
cat >$OUT_DIR/map/scanfile/del1/cmcr <<'-----'
#include <aux/scanfile/del1/ccod>
-----
cat >$OUT_DIR/map/scanfile/del1/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/scanfile/del1/pmcr <<'-----'
#include <aux/scanfile/del1/ccod>
-----
[ -d $OUT_DIR/map/scanfile/fold ] || mkdir $OUT_DIR/map/scanfile/fold
cat >$OUT_DIR/map/scanfile/fold/ccod <<'-----'
#include <aux/scanfile/fold/ccod>
-----
cat >$OUT_DIR/map/scanfile/fold/docu <<'-----'
#define Map map
#define Abortval
  Special 'scanfile' implementation for 'fold'
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/map/scanfile/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/map/scanfile/fold/vdm <<'-----'
#include <aux/scanfile/fold/vdm>
-----
[ -d $OUT_DIR/map/scanfile/forall ] || mkdir $OUT_DIR/map/scanfile/forall
cat >$OUT_DIR/map/scanfile/forall/ccod <<'-----'
#include <aux/scanfile/forall/ccod>
-----
cat >$OUT_DIR/map/scanfile/forall/cmcr <<'-----'
#include <aux/scanfile/forall/cmcr>
-----
cat >$OUT_DIR/map/scanfile/forall/param <<'-----'
MACROS
-----
cat >$OUT_DIR/map/scanfile/forall/vdm <<'-----'
#include <aux/scanfile/forall/vdm>
-----
[ -d $OUT_DIR/map/sign ] || mkdir $OUT_DIR/map/sign
[ -d $OUT_DIR/map/sign/all ] || mkdir $OUT_DIR/map/sign/all
cat >$OUT_DIR/map/sign/all/vsig <<'-----'
#include <aux/sign/all/vsig>
-----
[ -d $OUT_DIR/map/sign/basic ] || mkdir $OUT_DIR/map/sign/basic
cat >$OUT_DIR/map/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
public:
  DOMAIN data;
  /* 
     === the macro BASEIMPL is defined only if the actual domain ===
     === is realised by an automem implementation                === 
     */
#ifdef BASEIMPL
  Cpp_DOMAIN()
  {
    data = 0;
    CA == non valid handle CE
  }

  ~Cpp_DOMAIN() { del##_DOMAIN(data); }

  Cpp_DOMAIN(const Cpp_DOMAIN & x1)
  {
    check_handle##_DOMAIN(x1.data);
    data = x1.data;
    data->f_rc++;
  }

  Cpp_DOMAIN(const DOMAIN &x1)
  {
    check_handle##_DOMAIN(x1);
    data = x1;
    data->f_rc++;
  }

  Cpp_DOMAIN & operator = (const Cpp_DOMAIN & x1)
  { 
    check_handle##_DOMAIN(x1.data);
    if (data != x1.data)
      {
	if (data!=0) del##_DOMAIN(data);
	data = x1.data;
	data->f_rc++;
      }
    return *this;
  }

  /* for moving a C++ object into a C data structure, e.g. a union */
  /* conversion back to C++ is done implicitly by Constuctor Cpp_DOMAIN(const DOMAIN & x1) */
  /* use count is incremented to prevent deletion by destructors */

  DOMAIN cv##_DOMAIN() const
  {
    check_handle##_DOMAIN(data);
    data->f_rc++;
    return data;
  }
        
#else

  Cpp_DOMAIN() {}
  Cpp_DOMAIN(const DOMAIN &x1) { data = x1;}
  Cpp_DOMAIN & operator = (const Cpp_DOMAIN & x1)
  {
    data = x1.data;
    return *this;
  }

  /* access function for data field for conversion between C++ and C */
  DOMAIN       cv##_DOMAIN() const              { return data;                  }

#endif
#else
  /* auxiliary domain for a pair of ELEM1 and ELEM2 
     to support operators += and |= for map extension with a single pair
     */
class PAIR_##Cpp_DOMAIN {
  friend class Cpp_DOMAIN;
  Cpp_ELEM1 lx1;
  Cpp_ELEM2 lx2;
public:
  PAIR_##Cpp_DOMAIN(const Cpp_ELEM1 & x1, const Cpp_ELEM2 & x2)
    : lx1(x1),lx2(x2)
  { }
};

#endif
-----
cat >$OUT_DIR/map/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
class PAIR_##Cpp_DOMAIN;
-----
[ -d $OUT_DIR/map/sign/binary ] || mkdir $OUT_DIR/map/sign/binary
cat >$OUT_DIR/map/sign/binary/gsig <<'-----'
#include <aux/sign/binary/gsig>
-----
cat >$OUT_DIR/map/sign/binary/vsig <<'-----'
  binary(x1) =
   let fct(y1,y2) = if y2 = []
                    then y1
                    else let [d :-> r] e y2 in
                      fct(x1(y1,d,r),y2 - [d :-> r])
   in fct
  TYPE : (Result  ELEM1  ELEM2  -->  Result)
         -->
         (Result  DOMAIN  -->  Result)

  __EM(binary) is a functional (a function returning another function as result).
  With help of this functional functions on Result, ELEM1 and ELEM2 can be
  generalized to functions of DOMAIN to Result.

  An important case is Result = DOMAIN. This leads to the examples
  described below. The general case is usefull for inventing conversions.

  binary is evaluated at module generation time.

  Example : Map union

  given the function :

     union1(y1,y2,y3) = y1 U [y2 :-> y3]
     TYPE : DOMAIN  ELEM1 ELEM2  -->  DOMAIN

  the map union operation 'union' can be constructed by:

     union(x1,x2) = binary(union1)(x1,x2)
     TYPE : DOMAIN  DOMAIN  -->  DOMAIN

-----
[ -d $OUT_DIR/map/sign/card ] || mkdir $OUT_DIR/map/sign/card
cat >$OUT_DIR/map/sign/card/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(card,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,card,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/map/sign/card/gsig <<'-----'
  FUNCDEC(card##_DOMAIN,PL_1(DOMAIN),Nat0)
-----
cat >$OUT_DIR/map/sign/card/vsig <<'-----'
  card(x1) = card dom x1
  TYPE : DOMAIN  -->  Nat0

  cardinality of dom of map x1
-----
[ -d $OUT_DIR/map/sign/dom ] || mkdir $OUT_DIR/map/sign/dom
cat >$OUT_DIR/map/sign/dom/cpp <<'-----'
#include <map/com/dom/defs>
InlineFriendConstFct(dom,FPAR1(const Cpp_DOMAIN &),Cpp_RESULT)
RUMPF(BODY1(Cpp_RESULT,dom,FPARLIST1))

-----
cat >$OUT_DIR/map/sign/dom/gsig <<'-----'
#include <map/com/dom/defs>

#ifndef GEN_DOCU
#ifdef COPY
  _DEFINE dom##_DOMAIN##_ELEM1##_ELEM2(x1,x2) mk_one##_RESULT(copy##_ELEM1(x1))
#else
  _DEFINE dom##_DOMAIN##_ELEM1##_ELEM2(x1,x2) mk_one##_RESULT(x1)
#endif
#endif

  FUNCDEC(dom##_DOMAIN,PL_1(DOMAIN),RESULT)

-----
cat >$OUT_DIR/map/sign/dom/vsig <<'-----'
  dom(x1) = dom x1
  TYPE : DOMAIN  -->  RESULT

  The domain of the map x1 (the set of keys in x1) is computed.
-----
[ -d $OUT_DIR/map/sign/domresby ] || mkdir $OUT_DIR/map/sign/domresby
cat >$OUT_DIR/map/sign/domresby/cpp <<'-----'
#include <map/com/domresby/defs>
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(domresby,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,domresby,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/map/sign/domresby/gsig <<'-----'
#include <map/com/domresby/defs>
  FUNCDEC(domresby1##_DOMAIN,PL_2(DOMAIN,DOMAINSET),DOMAIN)
  _DEFINE domresby1##_DOMAIN##_ELEM1##_ELEM2(x1,x2,x3) ( (!is_in##_DOMAINSET(x1,x3)) ? mk_one##_DOMAIN(copy##_ELEM1(x1),copy##_ELEM2(x2)) : mk_empty##_DOMAIN())
  _DEFINE domresby##_DOMAIN(x1,x2) domresby1##_DOMAIN(x2,x1)
-----
cat >$OUT_DIR/map/sign/domresby/vsig <<'-----'
#define _OPNAME domresby
#define _NOT NOT
#include <map/sign/domresto/vsig>
-----
[ -d $OUT_DIR/map/sign/domresto ] || mkdir $OUT_DIR/map/sign/domresto
cat >$OUT_DIR/map/sign/domresto/cpp <<'-----'
#include <map/com/domresto/defs>
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(domresto,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,domresto,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/map/sign/domresto/gsig <<'-----'
#include <map/com/domresto/defs>
  FUNCDEC(domresto1##_DOMAIN,PL_2(DOMAIN,DOMAINSET),DOMAIN)
  _DEFINE domresto1##_DOMAIN##_ELEM1##_ELEM2(x1,x2,x3) ( (is_in##_DOMAINSET(x1,x3)) ? mk_one##_DOMAIN(copy##_ELEM1(x1),copy##_ELEM2(x2)) : mk_empty##_DOMAIN())
  _DEFINE domresto##_DOMAIN(x1,x2) domresto1##_DOMAIN(x2,x1)
-----
cat >$OUT_DIR/map/sign/domresto/vsig <<'-----'
#ifndef _OPNAME
#define _OPNAME domresto
#define _NOT 
#endif

  _OPNAME(x1,x2) =  x1 <| x2 = [ a |-> b | a _NOT IN x1 & [ a |-> b ] IN x2 ]
  TYPE : DOMAINSET DOMAIN  -->  DOMAIN

  _OPNAME(x1,x2) computes the domain restriction of the
  map x2 to a subset x1 of the domain of x2. This is a new
  map consisting of all those pairs [ a |-> b ] e x2 where 
  a is _NOT contained in x1.
  The elements are copied when added to the result, i.e. the
  map x2 is not destroied.

  See also:
    __SA(ranresto), __SA(ranresby), __SA(domresto), __SA(domresby)
#undef _OPNAME
#undef _NOT
-----
[ -d $OUT_DIR/map/sign/exist ] || mkdir $OUT_DIR/map/sign/exist
cat >$OUT_DIR/map/sign/exist/vsig <<'-----'
#include <aux/sign/exist/vsig>
-----
[ -d $OUT_DIR/map/sign/exist1 ] || mkdir $OUT_DIR/map/sign/exist1
cat >$OUT_DIR/map/sign/exist1/gsig <<'-----'
#include <aux/sign/exist1/gsig>
-----
cat >$OUT_DIR/map/sign/exist1/vsig <<'-----'
#include <aux/sign/exist1/vsig>
-----
[ -d $OUT_DIR/map/sign/ext ] || mkdir $OUT_DIR/map/sign/ext
cat >$OUT_DIR/map/sign/ext/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 Cpp_DOMAIN &
#define T2 const Cpp_ELEM2 &
InlineFriendFct(ext,FPAR2(T1,T2),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,ext,(&(DATA), x2.data)))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/ext/gsig <<'-----'
  FUNCDEC(ext##_DOMAIN,PL_RV(DOMAIN,ELEM2),ELEM1)
-----
cat >$OUT_DIR/map/sign/ext/vsig <<'-----'
  ext(x1,x2) =  let p be.s.t. p ~ in dom x1 in
                (p,x1 U [p :-> x2])
  TYPE : DOMAIN  ELEM2  -->  ( ELEM1  DOMAIN )

  extension of a map x1 with a new pair, where an arbitrary ELEM1 value
  is selected that is not in the domain of the map x1.
  This generated value and the extended map x1 are returned.
  The map return value is implemented via a reference parameter for x1
-----
[ -d $OUT_DIR/map/sign/fold ] || mkdir $OUT_DIR/map/sign/fold
cat >$OUT_DIR/map/sign/fold/gsig <<'-----'
#include <aux/sign/fold/gsig>
-----
cat >$OUT_DIR/map/sign/fold/vsig <<'-----'
  fold(x1,x2,x3)(y1,a1,...,an) =
   let fct(z1) = if z1 = []
                 then x2
                 else let i e dom z1 in
                      x3(x1 (i,z1(i),a1,...,ak)
                        ,fct(z1 - {i})
                        ,al,...,an
                        )
   in fct(y1)
  TYPE : (ELEM1 ELEM2   T1 ... Tk --> RESULT)
         (                        --> RESULT)
         (RESULT RESULT Tl ... Tn --> RESULT)
         -->
         (DOMAIN        T1 ... Tn --> RESULT)

  __EM(fold) is a functional (a function returning another function as result).
  With help of this functional functions on the type DOMAIN can be defined
  by means of functions defined on the element type ELEM1.
  Fold returns a function from DOMAIN to RESULT.

  Usually, fold is partly evaluated at module generation time.
  The parameters a1 .. an are usefull to pass global information
  into the fold- or conversion functions. They are optional and
  can be generated in any combination.

  Example : construction of the inverse map

  Given the domains

     Map    =  Elem1 -m-> Elem2
     Imap   =  Elem2 -m-> Elem1

  and the function

     swap(x1,x2) = [x2 :-> x1]
     TYPE :  Elem1  Elem2  --> Imap

     mk_empty()
     TYPE :  -->  Imap

     union(x1,x2) = x1 U x2
     TYPE :  Imap  Imap  --> Imap

  the inverse function
  defined as

     inverse(x1) = [x1(i) :-> i | i e dom x1]
     TYPE : Map  -->  Imap
     PRE  : card dom x1 = card rng x1

  can be constructed by:

     inverse(x1) = fold(swap,mk_empty,union)(x1)
     TYPE : Map  -->  Imap

-----
[ -d $OUT_DIR/map/sign/forall ] || mkdir $OUT_DIR/map/sign/forall
cat >$OUT_DIR/map/sign/forall/cpp.old <<'-----'
#ifndef DECL
class cv_forall##_DOMAIN {
  void (*data1) (Cpp_ELEM1,Cpp_ELEM2);
  static void (*ptr1) (Cpp_ELEM1, Cpp_ELEM2);
public:
  cv_forall##_DOMAIN(void (*x1) (Cpp_ELEM1,Cpp_ELEM2))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1, ELEM2 x2)
   { (*ptr1) (x1, x2);}
};
void (*cv_forall##_DOMAIN::ptr1) (Cpp_ELEM1, Cpp_ELEM2) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1, Cpp_ELEM2)
InlineFriendFct(forall,PPAR2(T1,X2),void)
RUMPF(
{ cv_forall##_DOMAIN tmp(x2);
  forall##_DOMAIN(DATA, cv_forall##_DOMAIN::cv_1);
  tmp.reset();})
#undef T1
#undef X2
-----
cat >$OUT_DIR/map/sign/forall/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forall##_DOMAIN) P_OP ELEM1 y1, ELEM2 y2 P_CL ;
  extern void forall##_DOMAIN P_OP DOMAIN x1, T2_forall##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/map/sign/forall/vsig <<'-----'
  forall(x1,x2) = for i in dom x1 do x2(i,x1(i))
  TYPE : DOMAIN  ( ELEM1  ELEM2  -->  )  --> 

  for all elements in map x1 procedure x2 is executed
  if the map is ordered the elements are processed in this order
-----
[ -d $OUT_DIR/map/sign/forrange ] || mkdir $OUT_DIR/map/sign/forrange
cat >$OUT_DIR/map/sign/forrange/cpp.old <<'-----'
#ifndef DECL
class cv_forrange##_DOMAIN {
  void (*data1) (Cpp_ELEM1,Cpp_ELEM2);
  static void (*ptr1) (Cpp_ELEM1,Cpp_ELEM2);
public:
  cv_forrange##_DOMAIN(void (*x1) (Cpp_ELEM1,Cpp_ELEM2))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1, ELEM2 x2)
   { (*ptr1) (x1,x2);}
};
void (*cv_forrange##_DOMAIN::ptr1) (Cpp_ELEM1,Cpp_ELEM2) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1,Cpp_ELEM2)
#define T3 const Cpp_ELEM1 &
#define T4 const Cpp_ELEM1 &
InlineFriendFct(forrange,PPAR4(T1,X2,T3,T4),void)
RUMPF(
{ cv_forrange##_DOMAIN tmp(x2);
  forrange##_DOMAIN(DATA, cv_forrange##_DOMAIN::cv_1,x3.data, x4.data);
  tmp.reset();})
#undef T1
#undef X2
#undef T3
#undef T4
-----
cat >$OUT_DIR/map/sign/forrange/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forrange##_DOMAIN) P_OP ELEM1 y1, ELEM2 y2 P_CL ;
  extern void forrange##_DOMAIN P_OP DOMAIN x1, T2_forrange##_DOMAIN x2, ELEM1 x3, ELEM1 x4 P_CL ;
#endif
-----
cat >$OUT_DIR/map/sign/forrange/vsig <<'-----'
  forrange(x1,x2,x3,x4) = let y1 = [ i :-> x1(i) | i e dom x1 & x3 <= i <= x4 ]
                          in forall(y1,x2)
  TYPE : DOMAIN  ( ELEM1  ELEM2  -->  )  ELEM1  ELEM1 -->

  for those elements [d1 :-> r1] of map x1 for which d1 lies in the interval
  x3..x4 routine x2 is performed

  here it is assumed that an ordering function <= is defined on ELEM1
-----
[ -d $OUT_DIR/map/sign/forsome ] || mkdir $OUT_DIR/map/sign/forsome
cat >$OUT_DIR/map/sign/forsome/cpp.old <<'-----'
#ifndef DECL
class cv_forsome##_DOMAIN {
  void (*data1) (Cpp_ELEM1,Cpp_ELEM2);
  Cpp_BOOL (*data2) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1,Cpp_ELEM2);
  static Cpp_BOOL (*ptr2) (Cpp_ELEM1);
public:
  cv_forsome##_DOMAIN(void (*x1) (Cpp_ELEM1,Cpp_ELEM2), Cpp_BOOL (*x2) (Cpp_ELEM1))
   { data1 = ptr1; data2 = ptr2; ptr1 = x1; ptr2 = x2; }
  void reset()
   { ptr1 = data1; ptr2 = data2;}
  static void cv_1(ELEM1 x1,ELEM2 x2)
   { (*ptr1) (x1,x2);}
  static Bool cv_2(ELEM1 x1)
   { return ((*ptr2) (x1)).data;}
};
void (*cv_forsome##_DOMAIN::ptr1) (Cpp_ELEM1,Cpp_ELEM2) = 0;
Cpp_BOOL (*cv_forsome##_DOMAIN::ptr2) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 Cpp_BOOL (*x2) (Cpp_ELEM1)
#define X3 void (*x3) (Cpp_ELEM1,Cpp_ELEM2)
InlineFriendFct(forsome,PPAR3(T1,X2,X3),void)
RUMPF(
{ cv_forsome##_DOMAIN tmp(x3,x2);
  forsome##_DOMAIN(DATA,cv_forsome##_DOMAIN::cv_2, cv_forsome##_DOMAIN::cv_1);
  tmp.reset();})
#undef T1
#undef X2
#undef X3
-----
cat >$OUT_DIR/map/sign/forsome/gsig <<'-----'
#ifdef GEN_C
  typedef Bool (* T2_forsome##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  typedef void (* T3_forsome##_DOMAIN) P_OP ELEM1 y1, ELEM2 y2 P_CL ;
  extern void forsome##_DOMAIN P_OP DOMAIN x1, T2_forsome##_DOMAIN x2, T3_forsome##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/map/sign/forsome/vsig <<'-----'
  forsome(x1,x2,x3) = let y1 = [ i :-> x1(i) | i e dom x1 & x2(i) ]
                      in forall(y1,x3)
  TYPE : DOMAIN  ( ELEM1 --> Bool )  ( ELEM1  ELEM2 -->  )  -->

  for those elements [d1 :-> r1] in map x1
  for which the predicate x2 holds for d1
  procedure x3 is executed
-----
[ -d $OUT_DIR/map/sign/fread ] || mkdir $OUT_DIR/map/sign/fread
cat >$OUT_DIR/map/sign/fread/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#if 0
#define T1 const Cpp_FREAD &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(fread,(x1.data)))
#undef T1 
#endif

InlineNoFriendFct(fread,KPAR1(const Cpp_STR &),Cpp_DOMAIN &)
RUMPF(BODY2d(fread,(x1.data)))
#endif
-----
cat >$OUT_DIR/map/sign/fread/gsig <<'-----'
  FUNCDEC(fread##_DOMAIN,PL_1(Str),DOMAIN)
-----
cat >$OUT_DIR/map/sign/fread/vsig <<'-----'
  fread(x1) =
  TYPE : Str  -->  DOMAIN

  reads a map from a directory, the directory path name is given by x1
  the whole directory is read and a map is constructed
  it is assumed that the range elements of the directory can be read
  with a fread function defined for the range domain
  the string x1 is a read only parameter
  if an error occours in reading, the empty map is returned
-----
[ -d $OUT_DIR/map/sign/fwrite ] || mkdir $OUT_DIR/map/sign/fwrite
cat >$OUT_DIR/map/sign/fwrite/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_STR &
InlineFriendConstFct(fwrite,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,fwrite,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/fwrite/gsig <<'-----'
  FUNCDEC(fwrite##_DOMAIN,PL_2(DOMAIN,Str),Bool)
-----
cat >$OUT_DIR/map/sign/fwrite/vsig <<'-----'
  fwrite(x1,x2) =
  TYPE : DOMAIN  Str  ==>  Bool

  writes a map x1 to a directory, the directory name is given by x2
  it is assumed that the domain of the map value consists of string
  values giving the file names, and that for the range values there
  is a fwrite function to be called for writing the file content
  both arguments x1 and x2 are read only

  if an error occours in the file operations false is returned
  else true is returned
-----
[ -d $OUT_DIR/map/sign/inters ] || mkdir $OUT_DIR/map/sign/inters
cat >$OUT_DIR/map/sign/inters/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN & 
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(inters,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

#ifdef OPERATOR

#if defined(BASEIMPL)

InlineFriendFct(operator &=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

InlineFriendConstFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(inters))

#else

InlineFriendFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

#endif
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/map/sign/inters/gsig <<'-----'
  FUNCDEC(inters##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/inters/vsig <<'-----'
  inters(x1,x2) = [ i :-> j | i e (dom x1 n dom x2) & x1(i) = x2(i)] 
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  combinator function for intersection of map DOMAIN
  x1 and x2 are destroied, but no substructures are deleted
-----
[ -d $OUT_DIR/map/sign/intersd ] || mkdir $OUT_DIR/map/sign/intersd
cat >$OUT_DIR/map/sign/intersd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'intersd' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(intersd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(intersd,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/intersd/gsig <<'-----'
  FUNCDEC(intersd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/intersd/vsig <<'-----'
  intersd(x1,x2) = [ i :-> j | i e (dom x1 n dom x2) & x1(i) = x2(i)] 
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  combinator function for intersection of map DOMAIN
  x1 and x2 are destroied, all substructures not contained in the result
  are deleted with implicit calls of del for ELEM1 and ELEM2
-----
[ -d $OUT_DIR/map/sign/is_empty ] || mkdir $OUT_DIR/map/sign/is_empty
cat >$OUT_DIR/map/sign/is_empty/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(is_empty,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_empty,FPARLIST1))

#ifdef OPERATOR
InlineFriendConstFct(operator !,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,! is_empty,FPARLIST1))
#endif

#undef T1
#endif
-----
cat >$OUT_DIR/map/sign/is_empty/gsig <<'-----'
  FUNCDEC(is_empty##_DOMAIN,PL_1(DOMAIN),Bool)
-----
cat >$OUT_DIR/map/sign/is_empty/vsig <<'-----'
  is_empty(x1) = ( x1 = [] )
  TYPE : DOMAIN  -->  Bool

  test on empty map
-----
[ -d $OUT_DIR/map/sign/is_in ] || mkdir $OUT_DIR/map/sign/is_in
cat >$OUT_DIR/map/sign/is_in/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(is_in,SPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in,SPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/is_in/gsig <<'-----'
  FUNCDEC(is_in##_DOMAIN,PL_2(ELEM1,DOMAIN),Bool)
-----
cat >$OUT_DIR/map/sign/is_in/vsig <<'-----'
  is_in(x1,x2) = ( x1 e dom x2 )
  TYPE : ELEM1  DOMAIN  -->  Bool

  test whether element x1 is in the domain of map x2
-----
[ -d $OUT_DIR/map/sign/is_in_dom ] || mkdir $OUT_DIR/map/sign/is_in_dom
cat >$OUT_DIR/map/sign/is_in_dom/cpp <<'-----'

#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_DOMAIN &
#define T3 Cpp_ELEM2 &
InlineFriendConstFct(is_in_dom,SPAR3(T1,T2,T3),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in_dom,(x1.data,DATA,&(x3.data))))
#undef T1
#undef T2
#undef T3

-----
cat >$OUT_DIR/map/sign/is_in_dom/gsig <<'-----'
  FUNCDEC(is_in_dom##_DOMAIN,PL_VVR(ELEM1,DOMAIN,ELEM2),Bool)
-----
cat >$OUT_DIR/map/sign/is_in_dom/vsig <<'-----'
  is_in_dom(x1,x2) = if x1 e dom x2
                     then (TRUE ,x2(x1))
                     else (FALSE,NIL)
  TYPE : ELEM1  DOMAIN  -->  ( Bool  [ELEM2] )

  test whether x1 is in the domain of map x2,
  if x1 IN dom x2,  x2(x1) is returned via x3 else x3 is not defined                      
  [ELEM2] is implemented as an extra reference parameter x3.

  with this function combinations of __SA(is_in) and __SA(sel) functions like

    if is_in(x1,x2) then r := sel(x2,x1) ... r ... else ...

  can be shortened to

    if is_in_dom(x1,x2,r) then ... r ... else ....
-----
[ -d $OUT_DIR/map/sign/is_in_max ] || mkdir $OUT_DIR/map/sign/is_in_max
cat >$OUT_DIR/map/sign/is_in_max/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_DOMAIN &
#define T3 Cpp_ELEM1 &
InlineFriendConstFct(is_in_max,SPAR3(T1,T2,T3),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in_max,(x1.data,DATA,&(x3.data))))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/map/sign/is_in_max/gsig <<'-----'
  FUNCDEC(is_in_max##_DOMAIN,PL_VVR(ELEM1,DOMAIN,ELEM1),Bool)
-----
cat >$OUT_DIR/map/sign/is_in_max/vsig <<'-----'
  is_in_max(x1,x2) =
    let s = { d | d in dom x2 & d <= x1 }
    in if s = {}
       then (FALSE,NIL   )
       else (TRUE , max s)
  TYPE : ELEM1  DOMAIN  -->  ( Bool  [ELEM1] )

  looks for the largest element in dom x2 that is not greater than x1
  [ELEM1] is implemented as an extra reference parameter x3.
-----
[ -d $OUT_DIR/map/sign/is_in_min ] || mkdir $OUT_DIR/map/sign/is_in_min
cat >$OUT_DIR/map/sign/is_in_min/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_DOMAIN &
#define T3 Cpp_ELEM1 &
InlineFriendConstFct(is_in_min,SPAR3(T1,T2,T3),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in_min,(x1.data,DATA,&(x3.data))))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/map/sign/is_in_min/gsig <<'-----'
  FUNCDEC(is_in_min##_DOMAIN,PL_VVR(ELEM1,DOMAIN,ELEM1),Bool)
-----
cat >$OUT_DIR/map/sign/is_in_min/vsig <<'-----'
  is_in_min(x1,x2) =
    let s = { d | d in dom x2 & d >= x1 }
    in if s = {}
       then (FALSE,NIL  )
       else (TRUE ,min s)
  TYPE : ELEM1  DOMAIN  -->  ( Bool  [ELEM1] )

  looks for the smallest element in dom x2 that is greater than
  or equal to x1
  [ELEM1] is implemented as an extra reference parameter x3.
-----
[ -d $OUT_DIR/map/sign/is_in_rng ] || mkdir $OUT_DIR/map/sign/is_in_rng
cat >$OUT_DIR/map/sign/is_in_rng/cpp <<'-----'
#define T1 const Cpp_ELEM2 &
#define T2 const Cpp_DOMAIN &
#define T3 Cpp_ELEM1 &
InlineFriendConstFct(is_in_rng,SPAR3(T1,T2,T3),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in_rng,(x1.data,DATA,&(x3.data))))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/map/sign/is_in_rng/gsig <<'-----'
  FUNCDEC(is_in_rng##_DOMAIN,PL_VVR(ELEM2,DOMAIN,ELEM1),Bool)
-----
cat >$OUT_DIR/map/sign/is_in_rng/vsig <<'-----'
  is_in_rng(x1,x2) = if x1 in rng x2 
                      then (TRUE, let i in dom x2 be s.th. x2(i) = x1 in i)
                      else (FALSE, NIL)
  TYPE : ELEM2  DOMAIN  -->  ( Bool  [ELEM1] ) 

  test whether x1 is in the range of map x2                   
  if x1 e rng x2, an arbitray x3 is choosen with                 
  x2(x3) = x1 else x3 is undefined                       
  [ELEM2] is implemented as an extra reference parameter x3.
-----
[ -d $OUT_DIR/map/sign/is_submap ] || mkdir $OUT_DIR/map/sign/is_submap
cat >$OUT_DIR/map/sign/is_submap/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(is_submap,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_submap,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/is_submap/gsig <<'-----'
  FUNCDEC(is_submap##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/map/sign/is_submap/vsig <<'-----'
  is_submap(x1,x2) = (All i e x1)(i e dom x2 & x1(i) = x2(i))
  TYPE : ELEM1  DOMAIN  -->  Bool

  test whether map x1 is contained in map x2
-----
[ -d $OUT_DIR/map/sign/iterator ] || mkdir $OUT_DIR/map/sign/iterator
cat >$OUT_DIR/map/sign/iterator/cpp <<'-----'
#include <aux/sign/iterator/docu>
-----
[ -d $OUT_DIR/map/sign/max_dom ] || mkdir $OUT_DIR/map/sign/max_dom
cat >$OUT_DIR/map/sign/max_dom/cpp <<'-----'
InlineFriendConstFct(max_dom,FPAR1(const Cpp_DOMAIN &),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,max_dom,FPARLIST1))

-----
cat >$OUT_DIR/map/sign/max_dom/gsig <<'-----'
  FUNCDEC(max_dom##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/map/sign/max_dom/vsig <<'-----'
  max_dom(x1) =
    max { d | d in dom x1 }
  TYPE : DOMAIN  --> ELEM1

  looks for the largest element in dom x1. If the map is empty
  an error occurs
-----
[ -d $OUT_DIR/map/sign/min_dom ] || mkdir $OUT_DIR/map/sign/min_dom
cat >$OUT_DIR/map/sign/min_dom/cpp <<'-----'
InlineFriendConstFct(min_dom,FPAR1(const Cpp_DOMAIN &),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,min_dom,FPARLIST1))

-----
cat >$OUT_DIR/map/sign/min_dom/gsig <<'-----'
  FUNCDEC(min_dom##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/map/sign/min_dom/vsig <<'-----'
  min_dom(x1) =
    min { d | d in dom x1 }
  TYPE : DOMAIN  --> ELEM1

  looks for the smallest element in dom x1. If the map is empty
  an error occurs
-----
[ -d $OUT_DIR/map/sign/mk1 ] || mkdir $OUT_DIR/map/sign/mk1
cat >$OUT_DIR/map/sign/mk1/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_ELEM2 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR2(T1,T2),)
RUMPF(BODY4(mk1,KPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/mk1/gsig <<'-----'
  FUNCDEC(mk1##_DOMAIN,PL_2(ELEM1,ELEM2),DOMAIN)
-----
cat >$OUT_DIR/map/sign/mk1/vsig <<'-----'
  mk1(x1,x2) = [x1 :-> x2]
  TYPE : ELEM1  ELEM2  -->  DOMAIN

  construction of a map with one element [x1 :-> x2]
-----
[ -d $OUT_DIR/map/sign/mk_empty ] || mkdir $OUT_DIR/map/sign/mk_empty
cat >$OUT_DIR/map/sign/mk_empty/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_EMPTY &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk_empty,KPARLIST0))
#undef T1 
#endif
-----
cat >$OUT_DIR/map/sign/mk_empty/gsig <<'-----'
  FUNCDEC(mk_empty##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/map/sign/mk_empty/vsig <<'-----'
  mk_empty() = []
  TYPE :  -->  DOMAIN

  construction of the empty set

#include <aux/com/mk_empty/docu>

-----
[ -d $OUT_DIR/map/sign/ovwrt ] || mkdir $OUT_DIR/map/sign/ovwrt
cat >$OUT_DIR/map/sign/ovwrt/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN &
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(ovwrt,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator +=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt,FPARLIST2))

#if defined(BASEIMPL)
InlineFriendConstFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(ovwrt))
#else
InlineFriendFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt,FPARLIST2))
#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/map/sign/ovwrt/gsig <<'-----'
  FUNCDEC(ovwrt##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/ovwrt/vsig <<'-----'
  ovwrt(x1,x2) = x1 + x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  map ovwrt of x1 with x2
  x1 and x2 are destroyed
-----
[ -d $OUT_DIR/map/sign/ovwrt1 ] || mkdir $OUT_DIR/map/sign/ovwrt1
cat >$OUT_DIR/map/sign/ovwrt1/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
#define T3 const Cpp_ELEM2 &
InlineFriendFct(ovwrt1,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt1,FPARLIST3))

#ifdef OPERATOR
InlineFriendFct(operator +=,FPAR2(T1,const PAIR_##Cpp_DOMAIN &),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt1,FPARLIST3a))
#endif

#undef T1
#undef T2
#undef T3
#endif
-----
cat >$OUT_DIR/map/sign/ovwrt1/gsig <<'-----'
  FUNCDEC(ovwrt1##_DOMAIN,PL_3(DOMAIN,ELEM1,ELEM2),DOMAIN)
-----
cat >$OUT_DIR/map/sign/ovwrt1/vsig <<'-----'
  ovwrt1(x1,x2,x3) = x1 + [x2 :-> x3]
  TYPE : DOMAIN  ELEM1  ELEM2  -->  DOMAIN

  x1 is overwritten at x2 with x3
  x1 is destroyed
-----
[ -d $OUT_DIR/map/sign/ovwrt1d ] || mkdir $OUT_DIR/map/sign/ovwrt1d
cat >$OUT_DIR/map/sign/ovwrt1d/cpp <<'-----'
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
#define T3 const Cpp_ELEM2 &
InlineFriendFct(ovwrt1d,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt1d,FPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/map/sign/ovwrt1d/gsig <<'-----'
  FUNCDEC(ovwrt1d##_DOMAIN,PL_3(DOMAIN,ELEM1,ELEM2),DOMAIN)
-----
cat >$OUT_DIR/map/sign/ovwrt1d/vsig <<'-----'
  ovwrt1d(x1,x2,x3) = x1 + [x2 :-> x3]
  TYPE : DOMAIN  ELEM1  ELEM2  -->  DOMAIN

  if x2 is already in x1
  implicit calls of del are performed to delete unused values
  x1 is destroyed
-----
[ -d $OUT_DIR/map/sign/ovwrtd ] || mkdir $OUT_DIR/map/sign/ovwrtd
cat >$OUT_DIR/map/sign/ovwrtd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'ovwrtd' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(ovwrtd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrtd,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/ovwrtd/gsig <<'-----'
  FUNCDEC(ovwrtd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/ovwrtd/vsig <<'-----'
  ovwrtd(x1,x2) = x1 + x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  map overwrite of x1 and x2
  for elements not longer used in the result
  implicit calls of del are performed
  x1 and x2 are destroyed
-----
[ -d $OUT_DIR/map/sign/ran ] || mkdir $OUT_DIR/map/sign/ran
cat >$OUT_DIR/map/sign/ran/cpp <<'-----'
#include <map/com/dom/defs>
InlineFriendConstFct(ran,FPAR1(const Cpp_DOMAIN &),Cpp_RESULT)
RUMPF(BODY1(Cpp_RESULT,ran,FPARLIST1))

-----
cat >$OUT_DIR/map/sign/ran/gsig <<'-----'
#include <map/com/dom/defs>

#ifndef GEN_DOCU
#ifdef COPY
  _DEFINE ran##_DOMAIN##_ELEM1##_ELEM2(x1,x2) mk_one##_RESULT(copy##_ELEM2(x2))
#else
  _DEFINE ran##_DOMAIN##_ELEM1##_ELEM2(x1,x2) mk_one##_RESULT(x2)
#endif
#endif

  FUNCDEC(ran##_DOMAIN,PL_1(DOMAIN),RESULT)
-----
cat >$OUT_DIR/map/sign/ran/vsig <<'-----'
  ran(x1) = ran x1
  TYPE : DOMAIN  -->  RESULT

  The range of the map x1 (the set of attribute values in x1) is computed,
  duplicates are eliminated.
-----
[ -d $OUT_DIR/map/sign/ranresby ] || mkdir $OUT_DIR/map/sign/ranresby
cat >$OUT_DIR/map/sign/ranresby/cpp <<'-----'
#include <map/com/ranresby/defs>
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(ranresby,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,ranresby,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/map/sign/ranresby/gsig <<'-----'
#include <map/com/ranresby/defs>
  FUNCDEC(ranresby##_DOMAIN,PL_2(DOMAIN,RANGESET),DOMAIN)
  _DEFINE ranresby##_DOMAIN##_ELEM1##_ELEM2(x1,x2,x3) ( (!is_in##_RANGESET(x2,x3)) ? mk_one##_DOMAIN(copy##_ELEM1(x1),copy##_ELEM2(x2)) : mk_empty##_DOMAIN())
-----
cat >$OUT_DIR/map/sign/ranresby/vsig <<'-----'
#define _OPNAME ranresby
#define _NOT NOT
#include <map/sign/ranresto/vsig>
-----
[ -d $OUT_DIR/map/sign/ranresto ] || mkdir $OUT_DIR/map/sign/ranresto
cat >$OUT_DIR/map/sign/ranresto/cpp <<'-----'
#include <map/com/ranresto/defs>
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(ranresto,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,ranresto,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/map/sign/ranresto/gsig <<'-----'
#include <map/com/ranresto/defs>
  FUNCDEC(ranresto##_DOMAIN,PL_2(DOMAIN,RANGESET),DOMAIN)
  _DEFINE ranresto##_DOMAIN##_ELEM1##_ELEM2(x1,x2,x3) ( (is_in##_RANGESET(x2,x3)) ? mk_one##_DOMAIN(copy##_ELEM1(x1),copy##_ELEM2(x2)) : mk_empty##_DOMAIN())
-----
cat >$OUT_DIR/map/sign/ranresto/vsig <<'-----'
#ifndef _OPNAME
#define _OPNAME ranresto
#define _NOT 
#endif

  _OPNAME(x1,x2) =  x1 |> x2 = [ a |-> b | b _NOT IN x2 & [ a |-> b ] IN x1 ]
  TYPE : DOMAIN RANGESET  -->  DOMAIN

  _OPNAME(x1,x2) computes the range restriction of the
  map x1 to a subset x2 of the domain of x1. This is a new
  map consisting of all those pairs [ a |-> b ] IN x1 where 
  b is _NOT contained in x2.
  The elements are copied when added to the result, i.e. the
  map x1 is not destroied.

  See also:
    __SA(ranresto), __SA(ranresby), __SA(domresto), __SA(domresby).
#undef _NOT
#undef _OPNAME
-----
[ -d $OUT_DIR/map/sign/sel ] || mkdir $OUT_DIR/map/sign/sel
cat >$OUT_DIR/map/sign/sel/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)

#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_ELEM1 &
InlineFriendConstFct(sel,FPAR2(T1,T2),Cpp_ELEM2)
RUMPF(BODY1(Cpp_ELEM2,sel,FPARLIST2))

#ifdef OPERATOR
InlineMemberConstFct(operator [],(T2 x2),Cpp_ELEM2)
RUMPF(BODY1(Cpp_ELEM2,sel,(data,x2.data)))
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/sel/gsig <<'-----'
  FUNCDEC(sel##_DOMAIN,PL_2(DOMAIN,ELEM1),ELEM2)
-----
cat >$OUT_DIR/map/sign/sel/vsig <<'-----'
  sel(x1,x2) = x1(x2)
  TYPE : DOMAIN ELEM1 --> ELEM2
  PRE  : x2 e dom x1

  selects from map x1 the value associated with x2
  if the precondition is violated an error routine is called
-----
[ -d $OUT_DIR/map/sign/sel_dom ] || mkdir $OUT_DIR/map/sign/sel_dom
cat >$OUT_DIR/map/sign/sel_dom/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(sel_dom,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,sel_dom,FPARLIST1))
#undef T1
#endif
-----
cat >$OUT_DIR/map/sign/sel_dom/gsig <<'-----'
  FUNCDEC(sel_dom##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/map/sign/sel_dom/vsig <<'-----'
  sel_dom(x1) = 
    let i in dom x1
     in i
  TYPE : DOMAIN  -->  ELEM1
  PRE  : ~ (x1 = [])

  select an arbitrary element from dom x1
  if the precondition is violated an error routine is called
-----
[ -d $OUT_DIR/map/sign/sub ] || mkdir $OUT_DIR/map/sign/sub
cat >$OUT_DIR/map/sign/sub/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN &
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(sub,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator -=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub,FPARLIST2))

#if defined(BASEIMPL)
InlineFriendConstFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(sub))
#else
InlineFriendFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub,FPARLIST2))
#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/map/sign/sub/gsig <<'-----'
  FUNCDEC(sub##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/sub/vsig <<'-----'
  sub(x1,x2) = x1 - dom x2
             = [ i :-> x1(i) | i e (dom x1 - dom x2) ]
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  map subraction of x1 with x2
  x1 is destroyed, x2 remains unchanged
-----
[ -d $OUT_DIR/map/sign/sub1 ] || mkdir $OUT_DIR/map/sign/sub1
cat >$OUT_DIR/map/sign/sub1/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &

InlineFriendFct(sub1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator -=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))

#if defined(BASEIMPL)
InlineFriendConstFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(sub1))
#else
InlineFriendFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))
#endif

#endif
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/sub1/gsig <<'-----'
  FUNCDEC(sub1##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/map/sign/sub1/vsig <<'-----'
  sub1(x1,x2) = x1 - {x2}
  TYPE : DOMAIN ELEM1 --> DOMAIN

  x2 is removed from the domain of x1
  x1 is destroyed
-----
[ -d $OUT_DIR/map/sign/sub1d ] || mkdir $OUT_DIR/map/sign/sub1d
cat >$OUT_DIR/map/sign/sub1d/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'sub1d' not supported for automem)
#else

#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1d,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/sub1d/gsig <<'-----'
  FUNCDEC(sub1d##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/map/sign/sub1d/vsig <<'-----'
  sub1d(x1,x2) = x1 - {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is removed from x1

  if a value y1 equal to x2 is x1 y1 and its picture y2 = x1(y1) will
  be deleted through implicit call of del##_ELEM1(y1) and del##_ELEM2(y2).
  x1 is destroyed
-----
[ -d $OUT_DIR/map/sign/subd ] || mkdir $OUT_DIR/map/sign/subd
cat >$OUT_DIR/map/sign/subd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'subd' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(subd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(subd,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/subd/gsig <<'-----'
  FUNCDEC(subd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/subd/vsig <<'-----'
  subd(x1,x2) = x1 - dom x2
             = [ i :-> x1(i) | i e (dom x1 - dom x2) ]
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  map subraction of x1 with x2
  x1 and all unused substructures are destroyed, x2 remains unchanged
-----
[ -d $OUT_DIR/map/sign/union ] || mkdir $OUT_DIR/map/sign/union
cat >$OUT_DIR/map/sign/union/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN &
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(plus,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator |=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

#if defined(BASEIMPL)
InlineFriendConstFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(union))
#else
InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))
#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/map/sign/union/gsig <<'-----'
  FUNCDEC(union##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/union/vsig <<'-----'
  union(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
  PRE  : (All i & dom x1 n dom x2)(x1(i) = x2(i))

  map union of x1 and x2
  x1 and x2 are destroyed
  if the precondition is violated an error routine is called

#ifdef GEN_CPP
  In C++ union is called plus to avoid conflicts
  with C keyword union
#endif
-----
[ -d $OUT_DIR/map/sign/union1 ] || mkdir $OUT_DIR/map/sign/union1
cat >$OUT_DIR/map/sign/union1/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
#define T3 const Cpp_ELEM2 &
InlineFriendFct(plus1,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST3))

#ifdef OPERATOR
InlineFriendFct(operator |=,FPAR2(T1,const PAIR_##Cpp_DOMAIN &),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST3a))
#endif

#undef T1
#undef T2
#undef T3
#endif
-----
cat >$OUT_DIR/map/sign/union1/gsig <<'-----'
  FUNCDEC(union1##_DOMAIN,PL_3(DOMAIN,ELEM1,ELEM2),DOMAIN)
-----
cat >$OUT_DIR/map/sign/union1/vsig <<'-----'
  union1(x1,x2,x3) = x1 u [x2 :-> x3]
  TYPE : DOMAIN  ELEM1  ELEM2  -->  DOMAIN
  PRE  : x2 ~ e dom x1

  [x2 :-> x3] is added to x1
  x1 is destroyed
  if the precondition is violated an error routine is called

#ifdef GEN_CPP
  In C++ union1 is called plus to avoid conflicts
  with C keyword union (see operation union)
#endif
-----
[ -d $OUT_DIR/map/sign/union1d ] || mkdir $OUT_DIR/map/sign/union1d
cat >$OUT_DIR/map/sign/union1d/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'union1d' not supported for automem)
#else

#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
#define T3 const Cpp_ELEM2 &
InlineFriendFct(plus1d,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(union1d,FPARLIST3))
#undef T1
#undef T2
#undef T3
#endif
-----
cat >$OUT_DIR/map/sign/union1d/gsig <<'-----'
  FUNCDEC(union1d##_DOMAIN,PL_3(DOMAIN,ELEM1,ELEM2),DOMAIN)
-----
cat >$OUT_DIR/map/sign/union1d/vsig <<'-----'
  union1d(x1,x2,x3) = x1 u [x2 :-> x3]
  TYPE : DOMAIN  ELEM1  ELEM2  -->  DOMAIN
  PRE  : x2 ~ e dom x1

  [x2 :-> x3] is added to x1
  if x2 is already in x1 an implicit call of del(x2) and del(x3) is performed
  x1 is destroyed
  if the precondition is violated an error routine is called

#ifdef GEN_CPP
  In C++ union1d is called plus to avoid conflicts
  with C keyword union (see operation union)
#endif
-----
[ -d $OUT_DIR/map/sign/uniond ] || mkdir $OUT_DIR/map/sign/uniond
cat >$OUT_DIR/map/sign/uniond/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'uniond' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(plusd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(uniond,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/map/sign/uniond/gsig <<'-----'
  FUNCDEC(uniond##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/map/sign/uniond/vsig <<'-----'
  uniond(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
  PRE  : (All i & dom x1 n dom x2)(x1(i) = x2(i))

  map union of x1 and x2
  for elements contained in both sets implicit calls of del are preformed
  x1 and x2 are destroyed
  if the precondition is violated an error routine is called

#ifdef GEN_CPP
  In C++ uniond is called plus to avoid conflicts
  with C keyword union (see operation union)
#endif
-----
[ -d $OUT_DIR/mimelib ] || mkdir $OUT_DIR/mimelib
[ -d $OUT_DIR/mimelib/aux ] || mkdir $OUT_DIR/mimelib/aux
[ -d $OUT_DIR/mimelib/aux/help ] || mkdir $OUT_DIR/mimelib/aux/help
cat >$OUT_DIR/mimelib/aux/help/common <<'-----'
__HYPERBIG(Common Help on the VDM Help and Info System)


__HYPERLINK(Creating hyper links,raw:mimelib.aux.help.usage) in the VDM database
needs some knowledge about the internal structure of the database. This
information is only necessary for maintaining the database not for using it.



-----
cat >$OUT_DIR/mimelib/aux/help/usage <<'-----'
__HTMLON

__H3(Welcome To The VDM Class Library Hypertext System)

__B(This Document gives a short overview over the implemented hypertext features:)

__OL
__LI
  A hyper link with the current selected language (C, C++, C++ automem)
  for documentation about the __HYPERLINK(is_empty,set.linklist.is_empty)
  function.
__P

__LI
  A hyper link with changing the selected language, in this case to pure C,
  again for __HYPERLINK(is_empty,c.set.linklist.is_empty).
__P

__LI
  Pictures may be included in the help text, here e.g. the VDM Class Library logo.__P
  __IMAGELINK(picture,mime:mimelib.aux.pics.vdmlogo)

__LI
  Active pictures can be included in the hypertext:
__P
  __HYPERLINK(__IMAGELINK(picture,mime:mimelib.aux.pics.vdmicon) the VDM logo,map.linklist.is_in)
  leads to documentation about operation is_in for maps implemented as linked lists.__P

__LI
  Thumbnails can be included as a reference to descriptions __P

  A click on this green ball is enough to see the VDM logo on a single page __P

  __HYPERLINK(__IMAGELINK(ball,mime:mimelib.aux.pics.ball),mime:mimelib.aux.pics.vdmlogo)__P

__LI
  Animated pictures may also be included,__P

  VDM Power Tools __P

  __IMAGELINK(c,mimelib.aux.pics.hammer)__P

  This Hammer schould move, when the browser supports the feature.__P

__LI
  As usual, symbols can be made transparent. The VDM Database Manager is prepared to
  generate such pictures, a white background can be made transparent.
__P

  __H3(__IMAGELINKALIGN(c,mime:mimelib.aux.pics.c,middle) is an old fashoned language.)
  __H3(__IMAGELINKALIGN(cpp,mime:mimelib.aux.pics.cpp,middle) is a complex language.)
  __H3(__IMAGELINKALIGN(app,mime:mimelib.aux.pics.app,middle) is more comfortable.)

__P
  Thanks to Marko Temme for implementing all these nice features
OL__

__HTMLOFF






-----
[ -d $OUT_DIR/mimelib/aux/pics ] || mkdir $OUT_DIR/mimelib/aux/pics
cat >$OUT_DIR/mimelib/aux/pics/app <<'-----'
text/html
R0lGODlhQgA5AOYAAL+/v94YGN4hGN4pGOcpGOcpEN4pEOcxEOc5EOdCEOdKEOdSEOdaEO9j
EOdjEO9rEO9zEO9zCO97CO97AO+ECPeUCO+MCO+MAO+UCPecCPecAPelCPelAPetCPe1CPe9
CPe9AP/OAPfGAP/WAPfOAP/eAP/nAP/vAP/3AP//9///7///5///3v//1v//zv//xv//vf//
tf//rf//pf//nP//lP//jP//hP//e///c///a///Y///Wv//Uv//Sv//Qv//Of//Mf//Kf//
If//GP//EP//CP//ANYAId4AGNYAGN4IGN4QGAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAABCADkAAAf/gACCg4SFhoeIiYqLjI2O
j5CRkpOUlZaXmJmam5ydnp+goaKjpKWmjDM5R6usq0GnjkOts7M1sIdFtLq6KbeCu8C0PrA+
wcazpjDHy6ykzM+rN6LQ0KDU1Eaf19RCndvXnECzKExLS9+sJhsjqzmbtAhIS0gdwUhIwRVK
Ds2atPf3CNjDB8zDEgWt/M0yx5CgLgIOdZlAEiBhJlpLkshLkgTYgo66UJwgkWRJggFJlGTS
MesBkgUkAFJodSIDBAJMAN5j1VCjxiVMMvGYhUSJiSMY5kUcIe+eRiQlWTGA4KHEPIuXZjWY
5wECA447WxlZheQosIxYLeVilVNpyZIRllst+RBMY9pKQVpBdQs2Lk8Mwa72u0RD7jlWKOQt
EaALyYBqmFi04jhrgbkkJGgtmPlMIVJzZo+4zcgOnQyFHOcl8bDqLcckgL/teCeaSQACDuii
28VJ2W5mnn4bGxZcOLAXoIQY1zVt+V1tznWYWt4N1m5fglIU3oa9EDMX3RG9GKuLSI5e4dOr
X8++vfv38OPLn+8oEAA7
-----
cat >$OUT_DIR/mimelib/aux/pics/ball <<'-----'
image/gif
R0lGODlhDgAOANUAALH/pY//izH/RSH/Pw//Lw//Mwf/KAD9HQD9IQDuIwDmHgDeHr+/vwjW
JwDWHGLNcGLNdELOVBDOKADOH7zFv3rFg3rFhgDGGQC8GAC8GwC0GgCsGUqcVQCcFgCUFjCL
PhCEHgCEEQ9yGwByDgBqDQBiDwBaCABaDQBKCABKDQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAADgAOAAUG
a0CGcEgsGo9ES0QiiViOEMfhgEhcIMXK5EAQGBSXToUYORgCgIID4wERJQiDYNDAdEKn90Kx
mGjuJXkUQhEYGBkbdyYoIoNCFR4dHiEjJSkoHEUPJCQnKJ8fRYMVIicnIhyOokOOqkSqrQxB
ACH/C01BQ0dDb24gBAMQMAAAAAFXcml0dGVuIGJ5IEdJRkNvbnZlcnRlciAyLjMuMiBvZiBN
YXIgNiwgMTk5MwA7
-----
cat >$OUT_DIR/mimelib/aux/pics/c <<'-----'
text/html
R0lGODlhQgA5AMQAAL+/v///AP3vAvrfBPjQBfbAB/OwCfGgC++QDOyBDupyEOhiEeZSE+NC
FeEyF98jGNwTGtoDHAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
ACH5BAEAAAAALAAAAABCADkAAAXfICCOZGmeaKqubOu+cCzPdG3feK7vfO//wKBwSCwaW4Gk
UnmELZ/LZgpKrUpH1SxUqu1ui95wdCguJ8nmMjDN/rHTvnd7l1ZE7hFFoNHw8sp4gYFhdGGC
hxGEOmEQg0sOeIo4XgWBAlCRfpNejlADdxCaN4aZVAcJkjakd3Jjo5ylrTmria1ns12dsrha
gQZZv6KvWg+BCKasXYuwsUm6VIXMeHzP0H/SiLVacWENh3rC0WEIDAyoYmu220HqVmjtTGDw
AVy2VyK791jo+ijh/QADChxIsKDBgwgTKlQRAgA7
-----
cat >$OUT_DIR/mimelib/aux/pics/cpp <<'-----'
text/html
R0lGODlhQgA5AOYAAL+/v94YGN4hGOchGN4pGOcpGOcpEOcxGN4pEOcxEOc5EOdCEOdKEOdS
EO9aEOdaEO9jEOdjEO9rEO9zEO9zCO97EO97CO+ECPeUCO+MCO+UCPecCPelCPetCPe1CPe9
CPe9APfGCP/OAPfGAP/WAPfOAP/eAP/nAP/vAP/3AP//9///7///5///3v//1v//zv//xv//
vf//tf//rf//pf//nP//lP//jP//hP//e///c///a///Y///Wv//Uv//Sv//Qv//Of//Mf//
Kf//If//GP//EP//CP//ANYAId4AGNYAGN4IGN4QGAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAABCADkAAAf/gACCg4SFhoeIiYqLjI2O
j5CRkpOUlZaXmJmam5ydnp+goaKjpKWmjkipqkZDLKeOLTKqs7Q7r4gwtLq7qbeDRbzBs0Ey
ry/CyLSnycyqpM3QqS+i0dGgRNXRRJ/Z1S2dM93VnCzi1baatCgSBxAfIk0Z4igms5uzAUlK
Svr5BOJLkszSkQ6JPiZMkjwQEGAfEwG6kjBJISxJEorOMqXatw+FKn5JlkS8WJFkxks8Ukjc
p4uBvpEeg71EgoKDh0wxAiRUEmIXwpEnUgVNRcDiPn0WkyzQiJRJMiYcLUK1OHRCUoQCJmQA
ESLTkYBQn3JUAhVkiVQhQphI4XKCPUxCn/jxS9akyYEFBJQ0qMcLghIGby/VSJqkA7QNSiAG
68CkSWBLMMomUayrgq4PZIWJCPnYEpKpFiMqsTzrRGhoNAqWVaJBlQkBEs2pKnIPiQakR8n+
lN1rUy4kIRIi1DeXd29OtIYaP4l8Oa8eoJzvoiad+ScV1ZGYkv6qnLkfvgDEMBee0I1mQnKU
N9QiCLIb6+PLn0+/vv37+PPr3/8oEAA7
-----
cat >$OUT_DIR/mimelib/aux/pics/hammer <<'-----'
image/gif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-----
cat >$OUT_DIR/mimelib/aux/pics/java <<'-----'
text/html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-----
cat >$OUT_DIR/mimelib/aux/pics/vdmicon <<'-----'
image/gif
R0lGODlhPAAoAPAAAAAAAP7+/iH5BAEAAAEALAAAAAA8ACgAAAL9jI+py+0Po5y02ouz3rxX
cIDeKBriOabqOgEu5KLtm5RmjOCOHtBRbFsAcz4Gj/cYNoDBo+KIXCqF01uw5mPCqkQuN1Rk
XrFf8TUKtuG+aW0bjbZ2reOemMwupsltqpuep2fXFAb3MjUUZ0gIcujlmLUmCAj2JFiVKEkT
N3iy2IPXN9jZODm6xwfa5bl5J2cUedZaouT2d+onx2gCqlUaW1h3QxfyusqLqcep24raN9to
LG1ZOuzsKlrMiwvLqYN4nGT61t0ptbk9t5OJt2wuLuxM7f6uSr0lfNtNWw5/LsHGHr10VGAQ
E1IsnjYjAOstnMYiR8SJTyhavMihAAA7
-----
cat >$OUT_DIR/mimelib/aux/pics/vdmlogo <<'-----'
image/gif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-----
[ -d $OUT_DIR/niletc ] || mkdir $OUT_DIR/niletc
[ -d $OUT_DIR/niletc/com ] || mkdir $OUT_DIR/niletc/com
[ -d $OUT_DIR/niletc/com/basic ] || mkdir $OUT_DIR/niletc/com/basic
cat >$OUT_DIR/niletc/com/basic/adttype <<'-----'
AUXILIARY
-----
[ -d $OUT_DIR/niletc/sign ] || mkdir $OUT_DIR/niletc/sign
[ -d $OUT_DIR/niletc/sign/basic ] || mkdir $OUT_DIR/niletc/sign/basic
cat >$OUT_DIR/niletc/sign/basic/ccod <<'-----'
_IF __cplusplus
Cpp_DOMAIN empty, nil, new_val;
_ENDIF
-----
cat >$OUT_DIR/niletc/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
#else
extern Cpp_DOMAIN empty, nil, new_val;
typedef Cpp_DOMAIN * mklc;
#endif
-----
cat >$OUT_DIR/niletc/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/niletc/sign/consts ] || mkdir $OUT_DIR/niletc/sign/consts
cat >$OUT_DIR/niletc/sign/consts/cpp <<'-----'
#ifdef DECL
extern Cpp_DOMAIN empty, nil, new_val;
typedef Cpp_DOMAIN * mklc;
#endif
-----
[ -d $OUT_DIR/numeric ] || mkdir $OUT_DIR/numeric
[ -d $OUT_DIR/numeric/aux ] || mkdir $OUT_DIR/numeric/aux
[ -d $OUT_DIR/numeric/aux/hash ] || mkdir $OUT_DIR/numeric/aux/hash
cat >$OUT_DIR/numeric/aux/hash/ccod <<'-----'
#include <numeric/aux/hash/defp>
  Nat0 hash##_DOMAIN _FPH1(DOMAIN) {return (((Nat0)x1) HASHSHIFT1);}
#undef HASHSHIFT1
#undef HASHSHIFT
-----
cat >$OUT_DIR/numeric/aux/hash/cmcr <<'-----'
#include <numeric/aux/hash/defp>
_DEFINE hash##_DOMAIN(x1) (((Nat0)(x1)) HASHSHIFT1)
#undef HASHSHIFT1
#undef HASHSHIFT
-----
cat >$OUT_DIR/numeric/aux/hash/defp <<'-----'
#ifndef HASHSHIFT
#define HASHSHIFT 0
#endif
#if HASHSHIFT == 0
#define HASHSHIFT1
#else
#define HASHSHIFT1 >> HASHSHIFT
#endif
-----
cat >$OUT_DIR/numeric/aux/hash/pmcr <<'-----'
_DEFINE hash##_DOMAIN(x1) (Nat0(x1))
-----
[ -d $OUT_DIR/numeric/com ] || mkdir $OUT_DIR/numeric/com
[ -d $OUT_DIR/numeric/com/basic ] || mkdir $OUT_DIR/numeric/com/basic
cat >$OUT_DIR/numeric/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/numeric/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = () -numeric

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + null
   + one

   + copy1
   + copy
   + plus

   + is_eq
   + is_gr
   + is_ge

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

-----
cat >$OUT_DIR/numeric/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

DOMAINEQ2

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + null
   + one

   + is_eq
   + is_gr
   + is_ge

-----
cat >$OUT_DIR/numeric/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbid1>

/*================================================================================================*/

   void p_@N@()
   { if(! is_eq##_domain( D_ null##_domain(), 0 ) )
       myerr(@n@,"null()","");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_eq##_domain( D_ one##_domain(), 1 ) )
       myerr(@n@,"one()","");
   DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/copy1/bbc2>

#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ plus##_domain( D_ null##_domain(), D_ @X@ ), D_ @X@ ) )
       myerr(@n@,"plus(),null()","@X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ plus##_domain( D_ @Y@, D_ @X@ ), D_ plus##_domain( D_ @X@, D_ @Y@ ) ) )
       myerr(@n@,"plus()","@Y@,@X@");
@) DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG2 @Y@
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if( is_gr##_domain( D_ @X@, D_ @X@ ) )
       myerr(@n@,"is_gr()","@X@,@X@");
@) DD }

   void p_@N@()
   { if( is_gr##_domain( D_ @Y@, D_ @Z@ ) )
       myerr(@n@,"is_gr()","@Y@,@Z@");
   DD }

   void p_@N@()
   { if(! is_gr##_domain( D_ @Z@, D_ @Y@ ) )
       myerr(@n@,"is_gr()","@Z@,@Y@");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(  if(! is_ge##_domain( D_ @X@, D_ @X@ ) )
       myerr(@n@,"is_ge()","@X@,@X@");
@) DD }

   void p_@N@()
   { if( is_ge##_domain( D_ @Y@, D_ @Z@ ) )
       myerr(@n@,"is_ge()","@Y@,@Z@");
   DD }

   void p_@N@()
   { if(! is_ge##_domain( D_ @Z@, D_ @Y@ ) )
       myerr(@n@,"is_ge()","@Z@,@Y@");
   DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define REPEAT
#include <aux/com/del1/bbc2>

#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define REPEAT
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define REPEAT
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/numeric/com/basic/bbd1 <<'-----'
#ifdef isChar
@X@=
'\001'
'\n'
'*'
'A'
'Z'

@Y@=
'y'

@Z@=
'z'

#elif isIntg
@X@=
null##_elem()
one##_elem()
-33
453
-9787

@Y@=
-888

@Z@=
-887

#elif isNat1
@X@=
one##_elem()
3
4
6787

@Y@=
12345

@Z@=
12346

#else
@X@=
null##_elem()
one##_elem()
2
999
9999

@Y@=
599

@Z@=
600

#endif
-----
cat >$OUT_DIR/numeric/com/basic/bbd2 <<'-----'
#if isChar
'\013'
'\001'
'_'
'1'
'Z'

@Y@=
'a'

@Z@=
'b'

#elif isIntg
@X@=
null##_domain()
one##_domain()
-3
43
-787

@Y@=
ppp

@Z@=
qqq

#elif isNat1
@X@=
one##_domain()
3
43
787

@Y@=
ppp

@Z@=
qqq

#else
@X@=
null##_domain()
one##_domain()
2
42
777

@Y@=
ppp

@Z@=
qqq

#endif
-----
cat >$OUT_DIR/numeric/com/basic/docu <<'-----'
  Syntax:

    Elem = () -numeric

  Description:

  'numeric' describes an elementary ADT containing numeric valued
  objects like integers and reals.
  elementary numeric operations are supplied for them.

  The predefined types 'Nat0', 'Nat1', 'Intg' and 'Char'
  are defined as 'numeric'.
  These are implemeted as scalar or unsigned builtin types.

  real data types can be generated with the 'real' implemetation

  Examples:

    DOMAIN
      Nat0 = () -numeric 
      Real = () -numeric

    IMPLEMENTATION
      Nat0 = unsigned + ...
      REAL = real + ...

-----
[ -d $OUT_DIR/numeric/com/cvfromtup1 ] || mkdir $OUT_DIR/numeric/com/cvfromtup1
cat >$OUT_DIR/numeric/com/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { register unsigned long lx1;
    register unsigned long int lx2 = 0;
      
    lx1 = hd##_TUPLDOMAIN(*x1); *x1 = tld##_TUPLDOMAIN(*x1);
    if (sizeof(DOMAIN) == 1 || lx1 < 128)
       { return (DOMAIN)lx1; }
    else if ((unsigned char)lx1 == 192)
       { lx2 = ((unsigned long)hd##_TUPLDOMAIN(*x1) & 255);
	 *x1 = tld##_TUPLDOMAIN(*x1);
         lx2 |= ((unsigned long)hd##_TUPLDOMAIN(*x1) & 255) << 8;
	 *x1 = tld##_TUPLDOMAIN(*x1);
	 return (DOMAIN)lx2;
       }
    else
       { for (lx1 = 0; lx1 < sizeof(DOMAIN); lx1++)
           { lx2 |= (((unsigned long)hd##_TUPLDOMAIN(*x1)) & 255) << (lx1*8);
	     *x1  = tld##_TUPLDOMAIN(*x1);
           }
         return (DOMAIN)lx2;
       }
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/numeric/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/numeric/com/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + hd + tld
#undef TUPLDOMAIN

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/numeric/com/cvtotup1 ] || mkdir $OUT_DIR/numeric/com/cvtotup1
cat >$OUT_DIR/numeric/com/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
{
    if ( sizeof(x2) == 1 || (unsigned long)x2 < 128 )
	{
	    return appr##_TUPLDOMAIN(x1, (unsigned char)x2);
	}

    if ( (unsigned long)x2 < 32768 )
	{
	    x1 = appr##_TUPLDOMAIN(x1,192);
	    x1 = appr##_TUPLDOMAIN(x1,((unsigned int)x2) & 255);
	    x1 = appr##_TUPLDOMAIN(x1,(((unsigned int)x2) >> 8) & 255);
	    return x1;
	}

    /* else */
    {
	register Nat0 i;
	x1 = appr##_TUPLDOMAIN(x1,128);
	for (i = 1; i <= (Nat0)sizeof(DOMAIN); i++)
	    {
		x1 = appr##_TUPLDOMAIN(x1,(((unsigned int) x2) & 255));
		x2 = (DOMAIN)(((unsigned int) x2) >> 8);
	    }
	return x1;
    }
}

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/numeric/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/numeric/com/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + appr

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/numeric/com/default ] || mkdir $OUT_DIR/numeric/com/default
cat >$OUT_DIR/numeric/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For numeric datatypes the following set of operations is
  added

#include <numeric/com/default/vdm>
-----
cat >$OUT_DIR/numeric/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + plus + minus + succ + pred
             + times + div + mod
             + is_eq + is_ge + is_gr + is_le + is_lt
-----
[ -d $OUT_DIR/numeric/com/div ] || mkdir $OUT_DIR/numeric/com/div
cat >$OUT_DIR/numeric/com/div/gcod <<'-----'
  _FDEC2(div,DOMAIN,DOMAIN,DOMAIN,_RET((x1)/(x2)))
-----
[ -d $OUT_DIR/numeric/com/gcd ] || mkdir $OUT_DIR/numeric/com/gcd
cat >$OUT_DIR/numeric/com/gcd/ccod <<'-----'

-----
[ -d $OUT_DIR/numeric/com/is_gr ] || mkdir $OUT_DIR/numeric/com/is_gr
cat >$OUT_DIR/numeric/com/is_gr/ccod <<'-----'
  Bool is_gr##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return (x1>x2);}   
-----
cat >$OUT_DIR/numeric/com/is_gr/cmcr <<'-----'
_DEFINE is_gr##_DOMAIN(x1,x2) ((x1) > (x2))
-----
cat >$OUT_DIR/numeric/com/is_gr/pmcr <<'-----'
_DEFINE is_gr##_DOMAIN(x1,x2) ((x1) > (x2))
-----
[ -d $OUT_DIR/numeric/com/max ] || mkdir $OUT_DIR/numeric/com/max
cat >$OUT_DIR/numeric/com/max/ccod <<'-----'
  DOMAIN max##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return is_ge##_DOMAIN(x1,x2) ? x1 : x2;}
-----
cat >$OUT_DIR/numeric/com/max/cmcr <<'-----'
_DEFINE max##_DOMAIN(x1,x2) ( is_ge##_DOMAIN((x1),(x2)) ? (x1) : (x2) )
-----
cat >$OUT_DIR/numeric/com/max/docu <<'-----'
  max function on elementary types :
-----
cat >$OUT_DIR/numeric/com/max/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + is_ge
-----
[ -d $OUT_DIR/numeric/com/min ] || mkdir $OUT_DIR/numeric/com/min
cat >$OUT_DIR/numeric/com/min/ccod <<'-----'
  DOMAIN min##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return is_ge##_DOMAIN(x2,x1) ? x1 : x2;}
-----
cat >$OUT_DIR/numeric/com/min/cmcr <<'-----'
_DEFINE min##_DOMAIN(x1,x2) ( is_ge##_DOMAIN((x2),(x1)) ? (x1) : (x2) )
-----
cat >$OUT_DIR/numeric/com/min/docu <<'-----'
  min function on elementary types :
-----
cat >$OUT_DIR/numeric/com/min/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + is_ge
-----
[ -d $OUT_DIR/numeric/com/minus ] || mkdir $OUT_DIR/numeric/com/minus
cat >$OUT_DIR/numeric/com/minus/gcod <<'-----'
  _FDEC2(minus,DOMAIN,DOMAIN,DOMAIN,_RET((x1)-(x2)))
-----
[ -d $OUT_DIR/numeric/com/mod ] || mkdir $OUT_DIR/numeric/com/mod
cat >$OUT_DIR/numeric/com/mod/gcod <<'-----'
#if defined(ISUNSIGNED) || defined(ISSCALAR)
  _FDEC2(mod,DOMAIN,DOMAIN,DOMAIN,_RET((x1)%(x2)))
#endif
-----
[ -d $OUT_DIR/numeric/com/null ] || mkdir $OUT_DIR/numeric/com/null
cat >$OUT_DIR/numeric/com/null/ccod <<'-----'
  DOMAIN null##_DOMAIN _FPH0() {return (DOMAIN)0;}
-----
cat >$OUT_DIR/numeric/com/null/cmcr <<'-----'
_DEFINE null##_DOMAIN() ((DOMAIN)0)
-----
[ -d $OUT_DIR/numeric/com/one ] || mkdir $OUT_DIR/numeric/com/one
cat >$OUT_DIR/numeric/com/one/ccod <<'-----'
  DOMAIN one##_DOMAIN _FPH0() {return (DOMAIN)1;}
-----
cat >$OUT_DIR/numeric/com/one/cmcr <<'-----'
_DEFINE one##_DOMAIN() ((DOMAIN)1)
-----
[ -d $OUT_DIR/numeric/com/parse ] || mkdir $OUT_DIR/numeric/com/parse
cat >$OUT_DIR/numeric/com/parse/ccod <<'-----'
  DOMAIN parse##_DOMAIN _FPH0()
    { long lx1 = readint_vdmlib(#DOMAIN);

      if (lx1 < lb##_DOMAIN || lx1 > ub##_DOMAIN)
	 { out_of_range_vdmlib(#DOMAIN,lx1); }
      return (DOMAIN)lx1;
    }
-----
cat >$OUT_DIR/numeric/com/parse/docu <<'-----'

  Syntax:  ['+'|'-']<digit>+

-----
cat >$OUT_DIR/numeric/com/parse/vdm <<'-----'
#include <aux/com/parse/vdm>
-----
[ -d $OUT_DIR/numeric/com/plus ] || mkdir $OUT_DIR/numeric/com/plus
cat >$OUT_DIR/numeric/com/plus/ccod <<'-----'
  DOMAIN plus##_DOMAIN _FPH2(DOMAIN,DOMAIN) {return x1 + x2;}
-----
cat >$OUT_DIR/numeric/com/plus/cmcr <<'-----'
_DEFINE plus##_DOMAIN(x1,x2) ((x1) + (x2))
-----
cat >$OUT_DIR/numeric/com/plus/docu <<'-----'
  plus function on elementary types :
  the values are added
-----
[ -d $OUT_DIR/numeric/com/pred ] || mkdir $OUT_DIR/numeric/com/pred
cat >$OUT_DIR/numeric/com/pred/gcod <<'-----'
  _FDEC1(pred,DOMAIN,DOMAIN,_RET((x1) - 1))
-----
[ -d $OUT_DIR/numeric/com/set_parse_format ] || mkdir $OUT_DIR/numeric/com/set_parse_format
cat >$OUT_DIR/numeric/com/set_parse_format/ccod <<'-----'
char * parseformat##_DOMAIN = #PARSEFORMAT;

void set_parse_format##_DOMAIN _FPH1(char *)
  { parseformat##_DOMAIN = (x1) ? x1 : #PARSEFORMAT; }
-----
cat >$OUT_DIR/numeric/com/set_parse_format/docu <<'-----'

  parsing for this implementation is not done with
  scanf, so setting a format has no effect for
  this implementation

-----
[ -d $OUT_DIR/numeric/com/set_print_format ] || mkdir $OUT_DIR/numeric/com/set_print_format
cat >$OUT_DIR/numeric/com/set_print_format/ccod <<'-----'
char * printformat##_DOMAIN = #PRINTFORMAT;

void set_print_format##_DOMAIN _FPH1(char *)
  { printformat##_DOMAIN = (x1) ? x1 : #PRINTFORMAT; }
-----
[ -d $OUT_DIR/numeric/com/succ ] || mkdir $OUT_DIR/numeric/com/succ
cat >$OUT_DIR/numeric/com/succ/gcod <<'-----'
  _FDEC1(succ,DOMAIN,DOMAIN,_RET((x1) + 1))
-----
[ -d $OUT_DIR/numeric/com/times ] || mkdir $OUT_DIR/numeric/com/times
cat >$OUT_DIR/numeric/com/times/gcod <<'-----'
  _FDEC2(times,DOMAIN,DOMAIN,DOMAIN,_RET((x1)*(x2)))
-----
[ -d $OUT_DIR/numeric/real ] || mkdir $OUT_DIR/numeric/real
[ -d $OUT_DIR/numeric/real/basic ] || mkdir $OUT_DIR/numeric/real/basic
cat >$OUT_DIR/numeric/real/basic/docu <<'-----'
  implementation of numeric data with floating point numbers

  Parameters:

    'ASDOUBLE' :
               the double precision datatype ( C double ) is used
               this is the default

    'ASFLOAT' :
               single precision reals ( C float ) is used

    'PRINTFORMAT' :
               format string for conversion into string representations
               in pr, fpr, cvstr and cvlines
               default is "%lg"

               see also : __SA(set_print_format)

    'PARSEFORMAT' :
               format for parsing reals with scanf in function parse
               default is "%lg" 

               see also : __SA(set_parse_format)

-----
cat >$OUT_DIR/numeric/real/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/numeric/real/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,STRUCT)
-----
cat >$OUT_DIR/numeric/real/basic/param <<'-----'
ASFLOAT
ASDOUBLE
PRINTFORMAT
PARSEFORMAT
ISFLOAT
MACROS
STRUCT
-----
cat >$OUT_DIR/numeric/real/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Vdmlib

IMPLEMENTATIONS
  Vdmlib = + header("FLOAT")

#ifndef STRUCT
#ifdef ASFLOAT
#define STRUCT float
#else
#define STRUCT double
#endif

#ifndef PRINTFORMAT
#define PRINTFORMAT %lg
#endif

#ifndef PARSEFORMAT
#define PARSEFORMAT %lg
#endif

  DOMAIN = real("STRUCT"=MKSTRING(STRUCT),
                "ISFLOAT",
                "PRINTFORMAT"=MKSTRING(PRINTFORMAT),
                "PARSEFORMAT"=MKSTRING(PARSEFORMAT))

#undef STRUCT
#undef PRINTFORMAT
#endif

#define CONSTRNAME mk_basic
#define ADTNAME ADT_NUMERIC,IMPL_REAL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/numeric/real/cvfromtup1 ] || mkdir $OUT_DIR/numeric/real/cvfromtup1
cat >$OUT_DIR/numeric/real/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { DOMAIN lx1;
    unsigned char * px1;
    unsigned i;

    px1 = (unsigned char *)(&lx1);

    for ( i = 0; i < sizeof(lx1); i++ ) {
      *px1 = hd##_TUPLDOMAIN(*x1);
      px1++;
      *x1 = tld##_TUPLDOMAIN(*x1);
    }
    return lx1;
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/numeric/real/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/numeric/real/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + hd + tld
#undef TUPLDOMAIN

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/numeric/real/cvlines ] || mkdir $OUT_DIR/numeric/real/cvlines
cat >$OUT_DIR/numeric/real/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   { char  lx1[50];

     sprintf(lx1,printformat##_DOMAIN,(double)x1);
     return mk1_cvtext_vdmlib(mkc_str(lx1));
   }
-----
cat >$OUT_DIR/numeric/real/cvlines/docu <<'-----'
  the decimal value of x1 is returned with minimal number of characters
-----
cat >$OUT_DIR/numeric/real/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  DOMAIN          = + set_print_format
  Cvtext_vdmlib   = + mk1
  Vdmlib          = + cvtext + header("SPRINTF")
  Str             = + mkc
-----
[ -d $OUT_DIR/numeric/real/cvstr ] || mkdir $OUT_DIR/numeric/real/cvstr
cat >$OUT_DIR/numeric/real/cvstr/ccod <<'-----'
#include <aux/com/cvstr/defp>

  RST FCTN##_DOMAIN _FPH1(DOMAIN)
   {char lx1[50];
    sprintf(lx1,printformat##_DOMAIN,(double)x1);
    return MKC(lx1);
   }

#include <aux/com/cvstr/undef>
-----
cat >$OUT_DIR/numeric/real/cvstr/docu <<'-----'
  x1 is converted into its decimal string representation
-----
cat >$OUT_DIR/numeric/real/cvstr/param <<'-----'
AUTOMEMRESULT
-----
cat >$OUT_DIR/numeric/real/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + set_print_format
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)

   Vdmlib   = + header("SPRINTF")
-----
[ -d $OUT_DIR/numeric/real/cvtotup1 ] || mkdir $OUT_DIR/numeric/real/cvtotup1
cat >$OUT_DIR/numeric/real/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
  { unsigned char * cvp;
    unsigned i;

    cvp = (unsigned char *)(&x2);

    for (i = 0; i < sizeof(x2); i++) {
      x1 = appr##_TUPLDOMAIN(x1,*cvp);
      cvp++;
    }

    return x1;  
  }
#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/numeric/real/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/numeric/real/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  TUPLDOMAIN	= + appr

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/numeric/real/hash ] || mkdir $OUT_DIR/numeric/real/hash
cat >$OUT_DIR/numeric/real/hash/ccod <<'-----'
#include <numeric/aux/hash/defp>
  Nat0 hash##_DOMAIN _FPH1(DOMAIN) {return ((*((Nat0*)(&x1))) HASHSHIFT1);}
#undef HASHSHIFT1
#undef HASHSHIFT
-----
cat >$OUT_DIR/numeric/real/hash/docu <<'-----'
  hash function on real types : 

  the real value is converted to an unsigned value.
  Optionally an extra rigth shift can be performed by a constant.
  This constant can be defined via the parameter "HASHSHIFT",
  the default value is 0. 
-----
cat >$OUT_DIR/numeric/real/hash/param <<'-----'
HASHSHIFT
-----
cat >$OUT_DIR/numeric/real/hash/pmcr <<'-----'
#include <numeric/aux/hash/cmcr>
-----
[ -d $OUT_DIR/numeric/real/parse ] || mkdir $OUT_DIR/numeric/real/parse
cat >$OUT_DIR/numeric/real/parse/ccod <<'-----'
  DOMAIN parse##_DOMAIN _FPH0()
    { 
      return (DOMAIN)readdouble_vdmlib(#DOMAIN,parseformat##_DOMAIN);
    }
-----
cat >$OUT_DIR/numeric/real/parse/docu <<'-----'

  Syntax: like C floating point format

  see implementation parameter "PARSEFORMAT"

-----
cat >$OUT_DIR/numeric/real/parse/vdm <<'-----'
IMPLEMENTATIONS
  DOMAIN          = + set_parse_format

#define params FLOATSUPPORT
#include <aux/com/parse/vdm>
-----
[ -d $OUT_DIR/numeric/real/print ] || mkdir $OUT_DIR/numeric/real/print
cat >$OUT_DIR/numeric/real/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
    { print_FD_vdmlib << x1;}
_ELSE
    {fprintf(print_FD_vdmlib,printformat##_DOMAIN,(double)x1);}
_ENDIF
-----
cat >$OUT_DIR/numeric/real/print/docu <<'-----'
  the decimal value of x1 is printed with minimal characters
-----
cat >$OUT_DIR/numeric/real/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + set_print_format
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/numeric/real/set_parse_format ] || mkdir $OUT_DIR/numeric/real/set_parse_format
cat >$OUT_DIR/numeric/real/set_parse_format/ccod <<'-----'
#include <numeric/com/set_parse_format/ccod>
-----
cat >$OUT_DIR/numeric/real/set_parse_format/docu <<'-----'

  default for reals is "%lg"

  Example:

    DOMAINS
      Myfloat = () -numeric

    IMPLEMENTATIONS
      Myfloat = real(ASFLOAT,PARSEFORMAT="%lf")

  defines a datatype "Myfloat" implemeted as C float with "%lf"

  The format can be changed during execution, by assigning
  a new value to the internal format char pointer

  Example
 
    set_parse_format_myfloat("%lg");
                     ---> from now input will be read with "%lg"

    set_print_format_myfloat((char *)0);
                     ---> reset to default format ( in this case "%lf" )

-----
[ -d $OUT_DIR/numeric/real/set_print_format ] || mkdir $OUT_DIR/numeric/real/set_print_format
cat >$OUT_DIR/numeric/real/set_print_format/ccod <<'-----'
#include <numeric/com/set_print_format/ccod>
-----
cat >$OUT_DIR/numeric/real/set_print_format/docu <<'-----'

  default for reals is "%lg"

  Example:

    DOMAINS
      Myfloat = () -numeric

    IMPLEMENTATIONS
      Myfloat = real(ASFLOAT,PRINTFORMAT="%lf")

  defines a datatype "Myfloat" implemeted as C float with "%lf"

  The format can be changed during execution, by assigning
  a new value to the internal format char pointer

  Example
 
    set_print_format_myfloat("%12.5lf");
                     ---> from now on output will be formated with "12.5lf"

    set_print_format_myfloat((char *)0);
                     ---> reset to default format

-----
[ -d $OUT_DIR/numeric/scalar ] || mkdir $OUT_DIR/numeric/scalar
[ -d $OUT_DIR/numeric/scalar/basic ] || mkdir $OUT_DIR/numeric/scalar/basic
cat >$OUT_DIR/numeric/scalar/basic/docu <<'-----'
  implementation of elementary data as signed integers

  Parameters:

    'LB' :
               lower bound of scalar range
    'UB' :
               upper bound of scalar range

               the minimal signed data type which covers the range 'LB'..'UB'
               is selected (char, short or long)

               'LB' and 'UB' are available as macros
               lb##_DOMAIN and ub##_DOMAIN

               it is assumed that
                    char is a  8 bit unit
               short int is a 16 bit unit
                long int is a 32 bit unit

    'PRINTFORMAT' :
               format string for conversion into string representations
               in pr, fpr, cvstr and cvlines
               default is "%ld"

               see also : _SA(set_print_format)

-----
cat >$OUT_DIR/numeric/scalar/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/numeric/scalar/basic/gptr <<'-----'
#ifndef LB
#define LB MININT
#endif

#ifndef UB
#define UB MAXINT
#endif

#ifndef STRUCT
#if GEN_C

_DEFINE lb##_DOMAIN LB

_DEFINE ub##_DOMAIN UB

#if (UB < 128) && (LB >= -128)
#define STRUCT char
#else
#if (UB < 32768) && (LB >= -32768)
#define STRUCT short int
#else
#define STRUCT long int
#endif
#endif

#else
#define STRUCT SUB_RANGE(LB,UB)
#endif
#endif

#ifdef STRUCT
  TYPE_DEF(DOMAIN,STRUCT)
#endif
#undef LB
#undef STRUCT
#undef UB
-----
cat >$OUT_DIR/numeric/scalar/basic/param <<'-----'
CSTRUCT
FORWARD_ALLOWED
INTERNALDOMAIN
ISINTGTYPE
ISSCALAR
LB
MACROS
PRINTFORMAT
PARSEFORMAT
STRUCT
UB
-----
cat >$OUT_DIR/numeric/scalar/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Bool

IMPLEMENTATIONS
  DOMAIN = scalar("ISSCALAR"

#ifndef PRINTFORMAT
                 ,"PRINTFORMAT"="%ld"
#endif

#ifndef PARSEFORMAT
                 ,"PARSEFORMAT"="%ld"
#endif
                 )


#define CONSTRNAME mk_basic
#define ADTNAME ADT_NUMERIC,IMPL_SCALAR
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/numeric/scalar/cvlines ] || mkdir $OUT_DIR/numeric/scalar/cvlines
cat >$OUT_DIR/numeric/scalar/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   { char  lx1[50];

     sprintf(lx1,printformat##_DOMAIN,(long)x1);
     return mk1_cvtext_vdmlib(mkc_str(lx1));
   }
-----
cat >$OUT_DIR/numeric/scalar/cvlines/docu <<'-----'
  the decimal value of x1 is returned as signed unit with minimal characters
-----
cat >$OUT_DIR/numeric/scalar/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  DOMAIN          = + set_print_format
  Cvtext_vdmlib   = + mk1
  Vdmlib          = + cvtext
  Str             = + mkc
-----
[ -d $OUT_DIR/numeric/scalar/cvstr ] || mkdir $OUT_DIR/numeric/scalar/cvstr
cat >$OUT_DIR/numeric/scalar/cvstr/ccod <<'-----'
#include <aux/com/cvstr/defp>

  RST FCTN##_DOMAIN _FPH1(DOMAIN)
   {char lx1[50];
    sprintf(lx1,printformat##_DOMAIN,(long)x1);
    return MKC(lx1);
   }

#include <aux/com/cvstr/undef>
-----
cat >$OUT_DIR/numeric/scalar/cvstr/docu <<'-----'
  x1 is converted into its decimal string representation
-----
cat >$OUT_DIR/numeric/scalar/cvstr/param <<'-----'
AUTOMEMRESULT
-----
cat >$OUT_DIR/numeric/scalar/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + set_print_format
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)

   Vdmlib   = + header("SPRINTF")
-----
[ -d $OUT_DIR/numeric/scalar/gcd ] || mkdir $OUT_DIR/numeric/scalar/gcd
cat >$OUT_DIR/numeric/scalar/gcd/ccod <<'-----'
  DOMAIN gcd##_DOMAIN _FPH2(DOMAIN,DOMAIN) {
    return 
      (DOMAIN)
      gcd_nat0(x1 >= 0 ? (Nat0)x1 : (Nat0)(-x1)
              ,x2 >= 0 ? (Nat0)x2 : (Nat0)(-x2)
              );
  }
-----
cat >$OUT_DIR/numeric/scalar/gcd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Nat0 = + gcd
-----
[ -d $OUT_DIR/numeric/scalar/hash ] || mkdir $OUT_DIR/numeric/scalar/hash
cat >$OUT_DIR/numeric/scalar/hash/ccod <<'-----'
#include <numeric/aux/hash/ccod>
-----
cat >$OUT_DIR/numeric/scalar/hash/docu <<'-----'
  hash function on scalar types : 

  the scalar value is converted to an unsigned value.
  Optionally an extra rigth shift can be performed by a constant.
  This constant can be defined via the parameter "HASHSHIFT",
  the default value is 0. 
-----
cat >$OUT_DIR/numeric/scalar/hash/param <<'-----'
HASHSHIFT
-----
cat >$OUT_DIR/numeric/scalar/hash/pmcr <<'-----'
#include <numeric/aux/hash/cmcr>
-----
[ -d $OUT_DIR/numeric/scalar/print ] || mkdir $OUT_DIR/numeric/scalar/print
cat >$OUT_DIR/numeric/scalar/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
    { print_FD_vdmlib << x1;}
_ELSE
    {fprintf(print_FD_vdmlib,printformat##_DOMAIN,(long)x1);}
_ENDIF
-----
cat >$OUT_DIR/numeric/scalar/print/docu <<'-----'
  the decimal value of x1 is printed as signed unit with minimal characters
-----
cat >$OUT_DIR/numeric/scalar/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + set_print_format
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/numeric/sign ] || mkdir $OUT_DIR/numeric/sign
[ -d $OUT_DIR/numeric/sign/basic ] || mkdir $OUT_DIR/numeric/sign/basic
cat >$OUT_DIR/numeric/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
public:
  DOMAIN data;
  Cpp_DOMAIN            ()                      {}
  Cpp_DOMAIN            (DOMAIN x1)             { data = x1;                    }
  Cpp_DOMAIN & operator=(DOMAIN x1)             { data = x1;      return *this; }
  Cpp_DOMAIN            (const Cpp_DOMAIN & x1) { data = x1.data;               }
  Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1) { data = x1.data; return *this; }


  /* access function for data field for conversion between unsigned types */
  /* and signed types via the C builtin conversion */

  DOMAIN       cv##_DOMAIN() const              { return data; }

#if defined(ISUNSIGNED) && ! defined(ISNAT0TYPE)
  /* all unsigned values can be constructed from NAT0s */
  /* all unsigned datatypes can be converted to NAT0 */
  /* conversion to buitin C types can be done by accessing field "data" directly */

  Cpp_DOMAIN            (const Cpp_NAT0   & x1);

  operator Cpp_NAT0 () const;
#endif

#if defined(ISSCALAR) && ! defined(ISINTGTYPE)
  Cpp_DOMAIN            (const Cpp_INTG   & x1);

  operator Cpp_INTG () const;
#endif

  /* a NAT0 can be constructed by an INTG */
#if defined(ISUNSIGNED) && defined(ISNAT0TYPE)
  Cpp_DOMAIN            (const Cpp_INTG   & x1);
#endif

  /* an INTG can be constructed by a NAT0 */
#if defined(ISSCALAR) && defined(ISINTGTYPE)
  Cpp_DOMAIN            (const Cpp_NAT0   & x1);
#endif

#else

#if defined(ISUNSIGNED) && ! defined(ISNAT0TYPE)
  inline
  Cpp_DOMAIN :: Cpp_DOMAIN (const Cpp_NAT0 & x1)
  {
    data = DOMAIN(x1.data);
  }
  inline
  Cpp_DOMAIN :: operator Cpp_NAT0 () const 
  {
    return Cpp_NAT0(Nat0(data)); 
  }
#endif

#if defined(ISSCALAR) && ! defined(ISINTGTYPE)
  inline
  Cpp_DOMAIN :: Cpp_DOMAIN (const Cpp_INTG & x1)
  {
    data = DOMAIN(x1.data);
  }
  inline
  Cpp_DOMAIN :: operator Cpp_INTG () const
  {
    return Cpp_INTG(Intg(data));
  }
#endif

#if defined(ISUNSIGNED) && defined(ISNAT0TYPE)
  inline
  Cpp_DOMAIN :: Cpp_DOMAIN (const Cpp_INTG & x1)
  {
    data = DOMAIN(x1.data); 
  }
#endif

#if defined(ISSCALAR) && defined(ISINTGTYPE)
  inline Cpp_DOMAIN :: Cpp_DOMAIN (const Cpp_NAT0 & x1)
  {
    data = DOMAIN(x1.data);
  }
#endif

#endif

-----
cat >$OUT_DIR/numeric/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/numeric/sign/div ] || mkdir $OUT_DIR/numeric/sign/div
cat >$OUT_DIR/numeric/sign/div/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(div,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,div,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator /=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(div,FPARLIST2))

InlineFriendConstFct(operator /,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,div,FPARLIST2))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/numeric/sign/div/gsig <<'-----'
  FUNCDEC(div##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/div/vsig <<'-----'
  div(x1,x2) =  x1 / x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  for integer types integer division,
  for real types real division
-----
[ -d $OUT_DIR/numeric/sign/gcd ] || mkdir $OUT_DIR/numeric/sign/gcd
cat >$OUT_DIR/numeric/sign/gcd/cpp <<'-----'
#if defined(ISUNSIGNED) || defined(ISSCALAR) || defined(GEN_DOCU)

InlineFriendConstFct(gcd,FPAR2(const Cpp_DOMAIN &,const Cpp_DOMAIN &),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,gcd,FPARLIST2))

#endif
-----
cat >$OUT_DIR/numeric/sign/gcd/gsig <<'-----'
#if defined(ISUNSIGNED) || defined(ISSCALAR) || defined(GEN_DOCU)

  FUNCDEC(gcd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)

#endif
-----
cat >$OUT_DIR/numeric/sign/gcd/vsig <<'-----'
  gcd(x1,x2) =  x1 gcd x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  greatest common divisor ( only for integral numbers )
-----
[ -d $OUT_DIR/numeric/sign/is_eq ] || mkdir $OUT_DIR/numeric/sign/is_eq
cat >$OUT_DIR/numeric/sign/is_eq/cpp <<'-----'
#if defined(DECL) || ! defined(NOIMPLEMENTATIONS)
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_eq,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_eq,FPARLIST2))

#ifdef OPERATOR
InlineFriendConstFct(operator ==,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_eq,FPARLIST2))

InlineFriendConstFct(operator !=,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,(Bool)! is_eq,FPARLIST2))

InlineFriendConstFct(operator !,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,(Bool)! is_eq,(DATA,((DOMAIN)0))))
#endif

#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/numeric/sign/is_eq/gsig <<'-----'
  FUNCDEC(is_eq##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/numeric/sign/is_eq/vsig <<'-----'
  is_eq(x1,x2) = ( x1 = x2 )
  TYPE : DOMAIN  DOMAIN  -->  Bool

  equality test for numeric values

#ifdef GEN_CPP  
  the "operator !" performs a test against 0 (x1 != 0)
#endif
-----
[ -d $OUT_DIR/numeric/sign/max ] || mkdir $OUT_DIR/numeric/sign/max
cat >$OUT_DIR/numeric/sign/max/cpp <<'-----'
InlineFriendConstFct(max,FPAR2(const Cpp_DOMAIN &,const Cpp_DOMAIN &),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,max,FPARLIST2))

-----
cat >$OUT_DIR/numeric/sign/max/gsig <<'-----'
  FUNCDEC(max##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/max/vsig <<'-----'
  max(x1,x2) =  max {x1,x2}
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/numeric/sign/min ] || mkdir $OUT_DIR/numeric/sign/min
cat >$OUT_DIR/numeric/sign/min/cpp <<'-----'
InlineFriendConstFct(min,FPAR2(const Cpp_DOMAIN &,const Cpp_DOMAIN &),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,min,FPARLIST2))

-----
cat >$OUT_DIR/numeric/sign/min/gsig <<'-----'
  FUNCDEC(min##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/min/vsig <<'-----'
  min(x1,x2) =  min {x1,x2}
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/numeric/sign/minus ] || mkdir $OUT_DIR/numeric/sign/minus
cat >$OUT_DIR/numeric/sign/minus/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(minus,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,minus,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator -=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(minus,FPARLIST2))

InlineFriendConstFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,minus,FPARLIST2))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/numeric/sign/minus/gsig <<'-----'
  FUNCDEC(minus##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/minus/vsig <<'-----'
  minus(x1,x2) =  x1 - x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/numeric/sign/mod ] || mkdir $OUT_DIR/numeric/sign/mod
cat >$OUT_DIR/numeric/sign/mod/cpp <<'-----'
#if defined(ISUNSIGNED) || defined(ISSCALAR) || defined(GEN_DOCU)

#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(mod,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,mod,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator %=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(mod,FPARLIST2))

InlineFriendConstFct(operator %,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,mod,FPARLIST2))
#endif

#undef T1
#undef T2

#endif
-----
cat >$OUT_DIR/numeric/sign/mod/gsig <<'-----'
#if defined(ISUNSIGNED) || defined(ISSCALAR) || defined(GEN_DOCU)

  FUNCDEC(mod##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)

#endif
-----
cat >$OUT_DIR/numeric/sign/mod/vsig <<'-----'
  mod(x1,x2) =  x1 mod x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  modulo operator (C syntax: x1 % x2) (only for integral numbers)
-----
[ -d $OUT_DIR/numeric/sign/null ] || mkdir $OUT_DIR/numeric/sign/null
cat >$OUT_DIR/numeric/sign/null/gsig <<'-----'
  FUNCDEC(null##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/null/vsig <<'-----'
  null() =  0
  TYPE :  -->  DOMAIN

  the value zero (unit for plus operation) is returned
  this function can be used as __EM(NULLFCT) in the
  __SA(fold) functional
-----
[ -d $OUT_DIR/numeric/sign/one ] || mkdir $OUT_DIR/numeric/sign/one
cat >$OUT_DIR/numeric/sign/one/gsig <<'-----'
  FUNCDEC(one##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/one/vsig <<'-----'
  one() =  1
  TYPE :  -->  DOMAIN

  the value one (unit for mult operation) is returned
  this function can be used as __EM(NULLFCT) in the
  __SA(fold) functional
-----
[ -d $OUT_DIR/numeric/sign/plus ] || mkdir $OUT_DIR/numeric/sign/plus
cat >$OUT_DIR/numeric/sign/plus/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(plus,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,plus,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator +=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(plus,FPARLIST2))

InlineFriendConstFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,plus,FPARLIST2))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/numeric/sign/plus/gsig <<'-----'
  FUNCDEC(plus##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/plus/vsig <<'-----'
  plus(x1,x2) =  x1 + x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  two elements of DOMAIN are added
-----
[ -d $OUT_DIR/numeric/sign/pred ] || mkdir $OUT_DIR/numeric/sign/pred
cat >$OUT_DIR/numeric/sign/pred/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendFct(pred,FPAR1(T1),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,pred,FPARLIST1))

#ifdef OPERATOR
InlineNoFriendFct(operator --,FPAR1(Cpp_DOMAIN &),Cpp_DOMAIN &)
RUMPF(BODY2(pred,FPARLIST1))

InlineNoFriendFct(operator --,FPAR2a(Cpp_DOMAIN &,int),Cpp_DOMAIN)
RUMPF(BODY7(pred,FPARLIST1))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/numeric/sign/pred/gsig <<'-----'
  FUNCDEC(pred##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/pred/vsig <<'-----'
  pred(x1) =  x1 - 1
  TYPE : DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/numeric/sign/set_parse_format ] || mkdir $OUT_DIR/numeric/sign/set_parse_format
cat >$OUT_DIR/numeric/sign/set_parse_format/cpp <<'-----'
InlineNoFriendConstFct(set_parse_format,KPAR1(char *),void)
RUMPF(BODY3(set_parse_format,(x1)))

InlineNoFriendConstFct(set_parse_format,KPAR0(),void)
RUMPF(BODY3(set_parse_format,((char *)0)))
-----
cat >$OUT_DIR/numeric/sign/set_parse_format/gsig <<'-----'
  extern char * parseformat##_DOMAIN;

  PROCDEC(set_parse_format##_DOMAIN,PL_1(char *))
-----
cat >$OUT_DIR/numeric/sign/set_parse_format/vsig <<'-----'
  set_parse_format(x1)
  TAPE : char *  -->

  sets the format string for parsing a value
  this format string must be a C character pointer (char *)
  This string is used during conversion from strings in
  functions __SA(parse), __SA(input), ...

  The default format string can be specified at generation time
  with implementation parameter __EM(PARSEFORMAT)

  see also:
    implementation features, __SA(parse), __SA(input
-----
[ -d $OUT_DIR/numeric/sign/set_print_format ] || mkdir $OUT_DIR/numeric/sign/set_print_format
cat >$OUT_DIR/numeric/sign/set_print_format/cpp <<'-----'
InlineNoFriendConstFct(set_print_format,KPAR1(char *),void)
RUMPF(BODY3(set_print_format,(x1)))

InlineNoFriendConstFct(set_print_format,KPAR0(),void)
RUMPF(BODY3(set_print_format,((char *)0)))
-----
cat >$OUT_DIR/numeric/sign/set_print_format/gsig <<'-----'
  extern char * printformat##_DOMAIN;

  PROCDEC(set_print_format##_DOMAIN,PL_1(char *))
-----
cat >$OUT_DIR/numeric/sign/set_print_format/vsig <<'-----'
  set_print_format(x1)
  TAPE : char *  -->

  sets the format string for printing a value
  this format string must be a C character pointer (char *)
  This string is used during conversion into strings in
  functions __SA(pr), __SA(fpr), __SA(cvstr) and __SA(cvlines).

  The default format string can be specified at generation time
  with implementation parameter __SA(PRINTFORMAT)

  see alse:
    implementation features,
    __SA(pr), __SA(fpr), __SA(cvstr), __SA(cvlines)
-----
[ -d $OUT_DIR/numeric/sign/succ ] || mkdir $OUT_DIR/numeric/sign/succ
cat >$OUT_DIR/numeric/sign/succ/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendFct(succ,FPAR1(T1),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,succ,FPARLIST1))

#ifdef OPERATOR
InlineFriendFct(operator ++,FPAR1(Cpp_DOMAIN &),Cpp_DOMAIN &)
RUMPF(BODY2(succ,FPARLIST1))

InlineFriendFct(operator ++,FPAR2a(Cpp_DOMAIN &,int),Cpp_DOMAIN)
RUMPF(BODY7(succ,FPARLIST1))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/numeric/sign/succ/gsig <<'-----'
  FUNCDEC(succ##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/succ/vsig <<'-----'
  succ(x1) =
    x1 + 1
  TYPE : DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/numeric/sign/times ] || mkdir $OUT_DIR/numeric/sign/times
cat >$OUT_DIR/numeric/sign/times/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(times,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,times,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator *=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(times,FPARLIST2))

InlineFriendConstFct(operator *,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,times,FPARLIST2))
#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/numeric/sign/times/gsig <<'-----'
  FUNCDEC(times##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/numeric/sign/times/vsig <<'-----'
  times(x1,x2) =
    x1 * x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN
-----
[ -d $OUT_DIR/numeric/unsigned ] || mkdir $OUT_DIR/numeric/unsigned
[ -d $OUT_DIR/numeric/unsigned/basic ] || mkdir $OUT_DIR/numeric/unsigned/basic
cat >$OUT_DIR/numeric/unsigned/basic/docu <<'-----'
  implementation of elementary data as unsigned integers

  Parameters:

    'LB' :
               lower bound of the unsigned range (must be >= 0, default = 0)
    'UB' :
               upper bound of the unsigned range (default maximum value)

               the minimal unsigned data type which covers the range 'LB'..'UB'
               is selected (unsigned char, unsigned short, unsigned long)

    'PRINTFORMAT' :
               format string for conversion into string representations
               in pr, fpr, cvstr and cvlines
               default is "%lu"

               see also : _SA(set_print_format)
-----
cat >$OUT_DIR/numeric/unsigned/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/numeric/unsigned/basic/gptr <<'-----'
#ifdef CSTRUCT
#if ! defined(STRUCT) || defined(GEN_C)
#undef STRUCT
#define STRUCT CSTRUCT
#endif
#endif

#ifdef STRUCT
#if defined(GEN_PASCAL) && defined(ISPREDEFINEDPASCALTYPE)
#else
   TYPE_DEF(DOMAIN,STRUCT)
#endif
#ifdef ISCHARTYPE
_DEFINE lb##_DOMAIN 0

_DEFINE ub##_DOMAIN 255
#endif
#else

#ifndef LB
#define LB 0
#endif

#ifndef UB
#define UB MAXINT
#endif

#ifndef STDDEF
#ifdef GEN_C

_DEFINE lb##_DOMAIN LB

_DEFINE ub##_DOMAIN UB

#if UB < 256
#define CSTRUCT unsigned char
#else
#if UB < 65536
#define CSTRUCT unsigned short
#else
#define CSTRUCT unsigned long
#endif
#endif
   TYPE_DEF(DOMAIN,CSTRUCT)
#undef CSTRUCT

#else
  TYPE_DEF(DOMAIN,SUB_RANGE(LB,UB))
#endif
#endif

#endif

#undef LB
#undef UB
-----
cat >$OUT_DIR/numeric/unsigned/basic/param <<'-----'
CSTRUCT
FORWARD_ALLOWED
INTERNALDOMAIN
ISCHARTYPE
ISNAT0TYPE
ISPREDEFINEDPASCALTYPE
ISUNSIGNED
LB
MACROS
PRINTFORMAT
PARSEFORMAT
STDDEF
STRUCT
UB
-----
cat >$OUT_DIR/numeric/unsigned/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Bool

IMPLEMENTATIONS
  DOMAIN = unsigned("ISUNSIGNED"

#ifndef PRINTFORMAT
                   ,"PRINTFORMAT"="%lu"
#endif

#ifndef PARSEFORMAT
                   ,"PARSEFORMAT"="%lu"
#endif
                   )

#define CONSTRNAME mk_basic
#define ADTNAME ADT_NUMERIC,IMPL_UNSIGNED
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/numeric/unsigned/cvlines ] || mkdir $OUT_DIR/numeric/unsigned/cvlines
cat >$OUT_DIR/numeric/unsigned/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   { char  lx1[50];

     sprintf(lx1,printformat##_DOMAIN,(unsigned long)x1);
     return mk1_cvtext_vdmlib(mkc_str(lx1));
   }
-----
cat >$OUT_DIR/numeric/unsigned/cvlines/docu <<'-----'
  the decimal value of x1 is returned with minimal number of characters
-----
cat >$OUT_DIR/numeric/unsigned/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  DOMAIN          = + set_print_format
  Cvtext_vdmlib   = + mk1
  Vdmlib          = + cvtext
  Str             = + mkc
-----
[ -d $OUT_DIR/numeric/unsigned/cvstr ] || mkdir $OUT_DIR/numeric/unsigned/cvstr
cat >$OUT_DIR/numeric/unsigned/cvstr/ccod <<'-----'
#include <aux/com/cvstr/defp>

  RST FCTN##_DOMAIN _FPH1(DOMAIN)
   {char ft[20];
    sprintf(ft,printformat##_DOMAIN,(unsigned long)x1);
    return MKC(ft);
   }

#include <aux/com/cvstr/undef>
-----
cat >$OUT_DIR/numeric/unsigned/cvstr/docu <<'-----'
  x1 is converted into its decimal string representation
-----
cat >$OUT_DIR/numeric/unsigned/cvstr/param <<'-----'
AUTOMEMRESULT
-----
cat >$OUT_DIR/numeric/unsigned/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + set_print_format
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)

   Vdmlib   = + header("STDIO")
-----
[ -d $OUT_DIR/numeric/unsigned/gcd ] || mkdir $OUT_DIR/numeric/unsigned/gcd
cat >$OUT_DIR/numeric/unsigned/gcd/ccod <<'-----'
  DOMAIN gcd##_DOMAIN _FPH2(DOMAIN,DOMAIN) {
    if ( x1 == 0 || x2 == 0 ) err_div0_vdmlib(#DOMAIN);

    while ( x1 != 0 ) {
      if ( x2 > x1 ){
        DOMAIN t;
        t = x1; x1 = x2; x2 = t;
      }
      x1 %= x2;
    }
    return x2;
  }
-----
cat >$OUT_DIR/numeric/unsigned/gcd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Vdmlib = + err_div0
-----
[ -d $OUT_DIR/numeric/unsigned/hash ] || mkdir $OUT_DIR/numeric/unsigned/hash
cat >$OUT_DIR/numeric/unsigned/hash/ccod <<'-----'
#include <numeric/aux/hash/ccod>
-----
cat >$OUT_DIR/numeric/unsigned/hash/cmcr <<'-----'
#include <numeric/aux/hash/cmcr>
-----
cat >$OUT_DIR/numeric/unsigned/hash/docu <<'-----'
  hash function on unsigned types : 

  the unsigned value is converted to a Nat0 value.
  Optionally an extra rigth shift can be performed by a constant.
  This constant can be defined via the parameter "HASHSHIFT",
  the default value is 0.
-----
cat >$OUT_DIR/numeric/unsigned/hash/param <<'-----'
HASHSHIFT
-----
cat >$OUT_DIR/numeric/unsigned/hash/pmcr <<'-----'
#include <numeric/aux/hash/cmcr>
-----
[ -d $OUT_DIR/numeric/unsigned/print ] || mkdir $OUT_DIR/numeric/unsigned/print
cat >$OUT_DIR/numeric/unsigned/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
    { print_FD_vdmlib << x1;}
_ELSE
    {fprintf(print_FD_vdmlib,printformat##_DOMAIN,(unsigned long)x1);}
_ENDIF
-----
cat >$OUT_DIR/numeric/unsigned/print/docu <<'-----'
  the decimal value of x1 is printed with minimal characters
-----
cat >$OUT_DIR/numeric/unsigned/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + set_print_format
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/opti ] || mkdir $OUT_DIR/opti
[ -d $OUT_DIR/opti/automem ] || mkdir $OUT_DIR/opti/automem
[ -d $OUT_DIR/opti/automem/basic ] || mkdir $OUT_DIR/opti/automem/basic
cat >$OUT_DIR/opti/automem/basic/ccod <<'-----'
#include <aux/automem/basic/ccod>
-----
cat >$OUT_DIR/opti/automem/basic/docu <<'-----'
#define TYPGEN optional
#define OPTI
#include <aux/automem/basic/docu>
-----
cat >$OUT_DIR/opti/automem/basic/gimp <<'-----'
#include <aux/automem/basic/gimp>
-----
cat >$OUT_DIR/opti/automem/basic/gptr <<'-----'
#include <aux/automem/basic/gptr>
-----
cat >$OUT_DIR/opti/automem/basic/gtyp <<'-----'
#include <aux/automem/basic/gtyp>
-----
cat >$OUT_DIR/opti/automem/basic/param <<'-----'
BASEIMPL
INTERNALDOMAIN
MACROS
NOCHECK
-----
cat >$OUT_DIR/opti/automem/basic/vdm <<'-----'
#define REP_DOMAIN  [ ELEM1 ]
#include <aux/automem/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/automem/copy ] || mkdir $OUT_DIR/opti/automem/copy
cat >$OUT_DIR/opti/automem/copy/ccod <<'-----'
#include <aux/automem/copy/ccod>
-----
[ -d $OUT_DIR/opti/automem/copy1 ] || mkdir $OUT_DIR/opti/automem/copy1
cat >$OUT_DIR/opti/automem/copy1/vdm <<'-----'
! === automem: Operation opti/copy1 not supported === !
-----
[ -d $OUT_DIR/opti/automem/cvfromtup1 ] || mkdir $OUT_DIR/opti/automem/cvfromtup1
cat >$OUT_DIR/opti/automem/cvfromtup1/ccod <<'-----'
#include <aux/automem/cvfromtup1/ccod>
-----
cat >$OUT_DIR/opti/automem/cvfromtup1/param <<'-----'
#include <aux/automem/cvfromtup1/param>
-----
cat >$OUT_DIR/opti/automem/cvfromtup1/vdm <<'-----'
#include <aux/automem/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/opti/automem/cvfromtupl ] || mkdir $OUT_DIR/opti/automem/cvfromtupl
cat >$OUT_DIR/opti/automem/cvfromtupl/ccod <<'-----'
#include <aux/automem/cvfromtupl/ccod>
-----
cat >$OUT_DIR/opti/automem/cvfromtupl/param <<'-----'
#include <aux/automem/cvfromtupl/param>
-----
cat >$OUT_DIR/opti/automem/cvfromtupl/vdm <<'-----'
#include <aux/automem/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/opti/automem/cvlines ] || mkdir $OUT_DIR/opti/automem/cvlines
cat >$OUT_DIR/opti/automem/cvlines/ccod <<'-----'
#define NAME cvlines
#define RESULT Cvtext_vdmlib
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/opti/automem/cvlines/cmcr <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/opti/automem/cvlines/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
! Mit Hilfe des Parameters LDOMNAME wird der 'richtige' Domain-Name an die  !
! Routine cvlines der BASEIMPL uebergeben. Dies ist notwendig, da sonst      !
! mk_rep##_DOMAIN anstelle des gewuenschten mk##_DOMAIN im Ausgabetext auf-  !
! tritt                                                                      !
   Rep##_DOMAIN = + cvlines("LDOMNAME" = #_DOMAIN)
-----
[ -d $OUT_DIR/opti/automem/cvtotup1 ] || mkdir $OUT_DIR/opti/automem/cvtotup1
cat >$OUT_DIR/opti/automem/cvtotup1/ccod <<'-----'
#include <aux/automem/cvtotup1/ccod>
-----
cat >$OUT_DIR/opti/automem/cvtotup1/param <<'-----'
#include <aux/automem/cvtotup1/param>
-----
cat >$OUT_DIR/opti/automem/cvtotup1/vdm <<'-----'
#include <aux/automem/cvtotup1/vdm>
-----
[ -d $OUT_DIR/opti/automem/cvtotupl ] || mkdir $OUT_DIR/opti/automem/cvtotupl
cat >$OUT_DIR/opti/automem/cvtotupl/ccod <<'-----'
#include <aux/automem/cvtotupl/ccod>
-----
cat >$OUT_DIR/opti/automem/cvtotupl/param <<'-----'
#include <aux/automem/cvtotupl/param>
-----
cat >$OUT_DIR/opti/automem/cvtotupl/vdm <<'-----'
#include <aux/automem/cvtotupl/vdm>
-----
[ -d $OUT_DIR/opti/automem/del ] || mkdir $OUT_DIR/opti/automem/del
cat >$OUT_DIR/opti/automem/del/ccod <<'-----'
#include <aux/automem/del/ccod>
-----
cat >$OUT_DIR/opti/automem/del/vdm <<'-----'
#include <aux/automem/del/vdm>
-----
[ -d $OUT_DIR/opti/automem/del1 ] || mkdir $OUT_DIR/opti/automem/del1
cat >$OUT_DIR/opti/automem/del1/vdm <<'-----'
! === automem: Operation opti/del1 not required === !
-----
[ -d $OUT_DIR/opti/automem/gcinfo ] || mkdir $OUT_DIR/opti/automem/gcinfo
cat >$OUT_DIR/opti/automem/gcinfo/ccod <<'-----'
#define Handle Nat0

/* get_gc_info1##_DOMAIN returns 0, if DOMAIN is no automem implementation */

Handle get_gc_info1##_DOMAIN(DOMAIN x1, Adts * x2)
{
   if (!is_in_adts((Handle)x1, *x2))
   {
      Adt     my_adt;
      Handle  my_handle;
      Handles my_handles = mk_empty_handles();
     
      if (is##_ELEM1##_DOMAIN(x1))
      {
         /* do not call "s" for domain, otherwise rc will be incremented ! */
         my_handle = get_gc_info1##_ELEM1(s##_ELEM1##_rep##_DOMAIN(x1),x2);
         if (my_handle!=0) my_handles = union1_handles(my_handles,my_handle);
      }

      /* We have to manipulate the reference counter of my_handles and my_adt
         manually because the called operations were designed to be called
         from the C++ interface and not from C ! */
_IFDEF AUTOMEM_handles
      my_handles->f_rc = 0;
_ENDIF
      my_adt = mk_adt(x1->f_rc,my_handles);
_IFDEF AUTOMEM_adt
     my_adt->f_rc = 0;
_ENDIF
      *x2    = union1_adts(*x2, (Handle) x1, my_adt);
   }
   return (Handle) x1;      
}

Adts get_gc_info##_DOMAIN(DOMAIN x1)
{
   check_handle##_DOMAIN(x1);
   Adts lx1 = mk_empty_adts();
   (void) get_gc_info1##_DOMAIN(x1, &lx1);
   return lx1;
}

#undef Handle
-----
cat >$OUT_DIR/opti/automem/gcinfo/docu <<'-----'
#include <aux/automem/gcinfo/docu>
-----
cat >$OUT_DIR/opti/automem/gcinfo/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN = + is + s
   ELEM1  = + gcinfo
-----
[ -d $OUT_DIR/opti/automem/hash ] || mkdir $OUT_DIR/opti/automem/hash
cat >$OUT_DIR/opti/automem/hash/ccod <<'-----'
#define NAME hash
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/opti/automem/hash/cmcr <<'-----'
#define NAME hash
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/opti/automem/hash/vdm <<'-----'
#define NAME hash
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/opti/automem/input ] || mkdir $OUT_DIR/opti/automem/input
cat >$OUT_DIR/opti/automem/input/vdm <<'-----'
! === automem: Operation opti/input not supported === !
-----
[ -d $OUT_DIR/opti/automem/is ] || mkdir $OUT_DIR/opti/automem/is
cat >$OUT_DIR/opti/automem/is/ccod <<'-----'
#define NAME MERGE(is, _ELEM1)
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/opti/automem/is/cmcr <<'-----'
#define NAME MERGE(is, _ELEM1)
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/opti/automem/is/vdm <<'-----'
#define NAME is
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/opti/automem/is_eq ] || mkdir $OUT_DIR/opti/automem/is_eq
cat >$OUT_DIR/opti/automem/is_eq/ccod <<'-----'
#define NAME is_eq
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/opti/automem/is_eq/cmcr <<'-----'
#define NAME is_eq
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/opti/automem/is_eq/vdm <<'-----'
#define NAME is_eq
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/opti/automem/is_ge ] || mkdir $OUT_DIR/opti/automem/is_ge
cat >$OUT_DIR/opti/automem/is_ge/ccod <<'-----'
#define NAME is_ge
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/opti/automem/is_ge/cmcr <<'-----'
#define NAME is_ge
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/opti/automem/is_ge/vdm <<'-----'
#define NAME is_ge
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/opti/automem/is_gr ] || mkdir $OUT_DIR/opti/automem/is_gr
cat >$OUT_DIR/opti/automem/is_gr/ccod <<'-----'
#define NAME is_gr
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/opti/automem/is_gr/cmcr <<'-----'
#define NAME is_gr
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/opti/automem/is_gr/vdm <<'-----'
#define NAME is_gr
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/opti/automem/is_nil ] || mkdir $OUT_DIR/opti/automem/is_nil
cat >$OUT_DIR/opti/automem/is_nil/ccod <<'-----'
#define NAME is_nil
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/opti/automem/is_nil/cmcr <<'-----'
#define NAME is_nil
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/opti/automem/is_nil/vdm <<'-----'
#define NAME is_nil
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/opti/automem/mk ] || mkdir $OUT_DIR/opti/automem/mk
cat >$OUT_DIR/opti/automem/mk/vdm <<'-----'
! === automem: Operation opti/mk not supported === !
-----
[ -d $OUT_DIR/opti/automem/mk_nil ] || mkdir $OUT_DIR/opti/automem/mk_nil
cat >$OUT_DIR/opti/automem/mk_nil/ccod <<'-----'
#define NAME mk_nil
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/opti/automem/mk_nil/vdm <<'-----'
#define  NAME mk_nil
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk_nil
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/automem/mk_opt ] || mkdir $OUT_DIR/opti/automem/mk_opt
cat >$OUT_DIR/opti/automem/mk_opt/ccod <<'-----'
#define NAME mk_opt
#define P1_INSERTED
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/opti/automem/mk_opt/vdm <<'-----'
#define NAME mk_opt
#define P1_INSERTED
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk_opt
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/automem/parse ] || mkdir $OUT_DIR/opti/automem/parse
cat >$OUT_DIR/opti/automem/parse/ccod <<'-----'
#include <aux/automem/parse/ccod> 
-----
cat >$OUT_DIR/opti/automem/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
! Mit Hilfe der Parameter LDOMNAME wird der 'richtige' Domainname an die   !
! Routine parse der BASEIMPL uebergeben. Dies ist notwendig, da bei der    !
! Eingabe sonst mk_rep##_DOMAIN anstelle von mk##_DOMAIN erwartet wuerde.  !
   Rep##_DOMAIN = + parse("LDOMNAME"= #_DOMAIN)
-----
[ -d $OUT_DIR/opti/automem/pr ] || mkdir $OUT_DIR/opti/automem/pr
cat >$OUT_DIR/opti/automem/pr/vdm <<'-----'
! === automem: Operation opti/pr not supported === !
-----
[ -d $OUT_DIR/opti/automem/s ] || mkdir $OUT_DIR/opti/automem/s
cat >$OUT_DIR/opti/automem/s/ccod <<'-----'
#define NAME MERGE(s, _ELEM1)
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/opti/automem/s/cmcr <<'-----'
#define NAME MERGE(s, _ELEM1)
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/opti/automem/s/vdm <<'-----'
#define NAME s
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/opti/com ] || mkdir $OUT_DIR/opti/com
[ -d $OUT_DIR/opti/com/basic ] || mkdir $OUT_DIR/opti/com/basic
cat >$OUT_DIR/opti/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/opti/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = [ Elem ]

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + mk_nil
   + mk_opt
   + mk

   + copy1
   + copy
   + s

   + is_eq
   + is_nil
   + is_opt
   + is
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

-----
cat >$OUT_DIR/opti/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

B_opti = [ BASIC ]

IMPLEMENTATIONS

B_opti = IMPLEMENTATION2

   + mk_nil
   + mk_opt

   + is_eq
   + is_gr
   + is_ge

-----
cat >$OUT_DIR/opti/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbdele>

#define nilopt MERGE(mk_nil,_domain)()
#define oneopt(elem) MERGE(mk_opt,_domain)(elem)

#include <aux/com/basic/bbid2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_nil##_domain( D_ nilopt ) )
       myerr(@n@,"mk_nil()","");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s##_elem##_domain ( D_ oneopt(@X@) ), E_ @X@ ) )
       myerr(@n@,"mk_opt()","@X@");
@) DD EE }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ mk##_elem##_domain(@X@), D_ oneopt(@X@) ) )
       myerr(@n@,"mk_ELEM(),mk_opt()","@X@");
@) DD EE }

/*================================================================================================*/

#define ARG nilopt
#define TEXT NIL
#include <aux/com/copy1/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG nilopt
#define TEXT NIL
#include <aux/com/copy/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s##_elem##_domain ( D_ oneopt(@X@) ), E_ @X@ ) )
       myerr(@n@,"s_ELEM()","@X@");
@) DD EE }

/*================================================================================================*/

#define ARG nilopt
#define TEXT NIL,NIL
#include <aux/com/is_eq/bbc2>

#define ARG nilopt
#define ARG2 oneopt(@X@)
#define TEXT NIL,@X@
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG oneopt(@X@)
#define ARG2 nilopt
#define TEXT @X@,NIL
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG oneopt(@X@)
#define ARG2 oneopt(@Y@)
#define TEXT @X@,@Y@
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG oneopt(@X@)
#define TEXT @X@,@X@
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_nil##_domain( D_ nilopt ) )
       myerr(@n@,"is_nil()","NIL");
   DD }

   void p_@N@()
   {
@(   if( is_nil##_domain( D_ oneopt(@X@) ) )
       myerr(@n@,"is_nil()","@X@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   { Elem elem;     
     if( is_opt##_domain( D_ nilopt, &elem ) )
       myerr(@n@,"is_opt()","NIL");
   DD }

   void p_@N@()
   { Elem elem;     
@(   if(! ( is_opt##_domain( D_ oneopt(@X@), &elem ) &&
            is_eq##_elem( elem, @X@ ) ) )
       myerr(@n@,"is_opt()","@X@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   { if( is##_elem##_domain( D_ nilopt ) )
       myerr(@n@,"is_ELEM()","NIL");
   DD }

   void p_@N@()
   {
@(   if(! is##_elem##_domain( D_ oneopt(@X@) ) )
       myerr(@n@,"is_ELEM()","@X@");
@) DD }

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain( D_ oneopt(@Y@), D_ oneopt(@Y@) ) )
       myerr(@n@,"is_gr()","@Y@,@Y@");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ oneopt(@Z@), D_ oneopt(@Z@) ) )
       myerr(@n@,"is_gr()","@Z@,@Z@");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ oneopt(@Y@), D_ oneopt(@Z@) ) )
       myerr(@n@,"is_gr()","@Y@,@Z@");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ oneopt(@Z@), D_ oneopt(@Y@) ) )
       myerr(@n@,"is_gr()","@Z@,@Y@");
   DD }
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain( D_ oneopt(@Y@), D_ oneopt(@Y@) ) )
       myerr(@n@,"is_ge()","@Y@,@Y@");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ oneopt(@Z@), D_ oneopt(@Z@) ) )
       myerr(@n@,"is_ge()","@Z@,@Z@");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ oneopt(@Y@), D_ oneopt(@Z@) ) )
       myerr(@n@,"is_ge()","@Y@,@Z@");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ oneopt(@Z@), D_ oneopt(@Y@) ) )
       myerr(@n@,"is_ge()","@Z@,@Y@");
   DD }
  
#endif
/*================================================================================================*/

#define ARG nilopt
#define TEXT NIL
#include <aux/com/cvtotupl/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG nilopt
#define TEXT NIL
#include <aux/com/hash/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG nilopt
#include <aux/com/del1/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/del1/bbc2>


#define ARG nilopt
#include <aux/com/del/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG nilopt
#include <aux/com/print/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG nilopt
#include <aux/com/pr/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG nilopt
#include <aux/com/fpr/bbc2>

#define ARG oneopt(@X@)
#define REPEAT
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/opti/com/basic/bbd1 <<'-----'
@X@=
mk_nil_b_opti()
mk_opt_b_opti(xxx)
mk_opt_b_opti(yyy)
mk_opt_b_opti(zzz)

@Y@=
mk_opt_b_opti(ppp)

@Z@=
mk_opt_b_opti(qqq)

-----
cat >$OUT_DIR/opti/com/basic/docu <<'-----'
Syntax:

  Dd = [ Aa ]

Description:

  Options  are  unions of a domain and the special value NIL, so for
  options the same comments and examples are valid as for unions.

-----
[ -d $OUT_DIR/opti/com/copy ] || mkdir $OUT_DIR/opti/com/copy
cat >$OUT_DIR/opti/com/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
   {ELEM1 x2;
    if (is_opt##_DOMAIN(x1,&x2)) return mk_opt##_DOMAIN(copy##_ELEM1(x2));
    else return mk_nil##_DOMAIN();
   } 
-----
cat >$OUT_DIR/opti/com/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_opt + mk_nil + mk_opt
   ELEM1    = + copy
-----
[ -d $OUT_DIR/opti/com/cvfromtup1 ] || mkdir $OUT_DIR/opti/com/cvfromtup1
cat >$OUT_DIR/opti/com/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { if (cvfromtup1_bool(x1))
       { return mk_opt##_DOMAIN(cvfromtup1##_ELEM1(x1)); }
    else
       { return mk_nil##_DOMAIN(); }
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/opti/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/opti/com/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Bool		= + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
  DOMAIN	= + mk_nil + mk_opt
  ELEM1		= + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/opti/com/cvlines ] || mkdir $OUT_DIR/opti/com/cvlines
cat >$OUT_DIR/opti/com/cvlines/ccod <<'-----'
/* LDOMNAME will be used to pass the 'real' domain name to the 'cvlines'
   function of the representation in automem implementations !  */

  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
    { ELEM1 x2;
      if (is_opt##_DOMAIN(x1,&x2))
#ifdef GEN_ISO
         { return cvlines##_ELEM1(x2); }
#else
#if defined(LDOMNAME)
         { return close_struct_vdmlib(ident_lines_vdmlib( cvlines##_ELEM1(x2)
                                     ,mkc_str("mk"###LDOMNAME##"("))
				     ,mkc_str(")")
				     ,strlen("mk"###LDOMNAME##"("));
	 }
#else
         { return close_struct_vdmlib(ident_lines_vdmlib( cvlines##_ELEM1(x2)
                                     ,mkc_str("mk"###_DOMAIN##"("))
				     ,mkc_str(")")
				     ,strlen("mk"###_DOMAIN##"("));
	 }
#endif
#endif
#ifdef GEN_ISO
      return mk1_cvtext_vdmlib(mkc_str("nil"));
#else
      return mk1_cvtext_vdmlib(mkc_str("NIL"));
#endif
    }
#undef LDOMNAME
-----
cat >$OUT_DIR/opti/com/cvlines/param <<'-----'
LDOMNAME
-----
cat >$OUT_DIR/opti/com/cvlines/vdm <<'-----'
DOMAINS  
IMPLEMENTATIONS
  Str            =  + mkc
  DOMAIN         =  + is_opt
  Vdmlib         =  + cvtext
  ELEM1		 =  + cvlines
-----
[ -d $OUT_DIR/opti/com/cvtotup1 ] || mkdir $OUT_DIR/opti/com/cvtotup1
cat >$OUT_DIR/opti/com/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
  { x1 = cvtotup1_bool(x1,is##_ELEM1##_DOMAIN(x2));
    if (is##_ELEM1##_DOMAIN(x2))
       { x1 = cvtotup1##_ELEM1(x1,s##_ELEM1##_DOMAIN(x2)); }
    return x1;
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/opti/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/opti/com/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Bool		= + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
  DOMAIN	= + is + s
  ELEM1		= + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/opti/com/default ] || mkdir $OUT_DIR/opti/com/default
cat >$OUT_DIR/opti/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the optional datatype the following set of operations is
  added

#include <opti/com/default/vdm>
-----
cat >$OUT_DIR/opti/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_nil + mk_opt
                                       ! constructors !
             + is_nil + is  + is_opt
                                       ! predicates !
             + s
                                       ! selection !
             + copy1 + del1
                                       ! duplicate and destroy values !
-----
[ -d $OUT_DIR/opti/com/del ] || mkdir $OUT_DIR/opti/com/del
cat >$OUT_DIR/opti/com/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN)
   {ELEM1 x2;
    if (is_opt##_DOMAIN(x1,&x2)) del##_ELEM1(x2);
    del1##_DOMAIN(x1);
   } 
-----
cat >$OUT_DIR/opti/com/del/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_opt + del1
   ELEM1    = + del
-----
[ -d $OUT_DIR/opti/com/hash ] || mkdir $OUT_DIR/opti/com/hash
cat >$OUT_DIR/opti/com/hash/ccod <<'-----'
  Nat0 hash##_DOMAIN _FPH1(DOMAIN)
   {return is_nil##_DOMAIN(x1)
           ? 0
           : hash##_ELEM1(s##_ELEM1##_DOMAIN(x1));
   }
-----
cat >$OUT_DIR/opti/com/hash/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s + is_nil
   ELEM1    = + hash
-----
[ -d $OUT_DIR/opti/com/is ] || mkdir $OUT_DIR/opti/com/is
cat >$OUT_DIR/opti/com/is/ccod <<'-----'
  Bool is##_ELEM1##_DOMAIN _FPH1(DOMAIN) {return ! is_nil##_DOMAIN(x1);}
-----
cat >$OUT_DIR/opti/com/is/cmcr <<'-----'
_DEFINE is##_ELEM1##_DOMAIN(x1) (! is_nil##_DOMAIN(x1))
-----
cat >$OUT_DIR/opti/com/is/pmcr <<'-----'
_DEFINE is##_ELEM1##_DOMAIN(x1) (NOT is_nil##_DOMAIN(x1))
-----
cat >$OUT_DIR/opti/com/is/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_nil
-----
[ -d $OUT_DIR/opti/com/is_eq ] || mkdir $OUT_DIR/opti/com/is_eq
cat >$OUT_DIR/opti/com/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return is_nil##_DOMAIN(x1)
           ? is_nil##_DOMAIN(x2)
           : (! is_nil##_DOMAIN(x2)
              && is_eq##_ELEM1(s##_ELEM1##_DOMAIN(x1),s##_ELEM1##_DOMAIN(x2))
             );
   }
-----
cat >$OUT_DIR/opti/com/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s + is_nil
   ELEM1    = + is_eq
-----
[ -d $OUT_DIR/opti/com/is_ge ] || mkdir $OUT_DIR/opti/com/is_ge
cat >$OUT_DIR/opti/com/is_ge/ccod <<'-----'
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return is_nil##_DOMAIN(x1)
           ? is_nil##_DOMAIN(x2)
           : (! is_nil##_DOMAIN(x1)
              && (is_nil##_DOMAIN(x2) || is_ge##_ELEM1(s##_ELEM1##_DOMAIN(x1),s##_ELEM1##_DOMAIN(x2)))
             );
   }
-----
cat >$OUT_DIR/opti/com/is_ge/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s + is_nil
   ELEM1    = + is_ge
-----
[ -d $OUT_DIR/opti/com/is_gr ] || mkdir $OUT_DIR/opti/com/is_gr
cat >$OUT_DIR/opti/com/is_gr/ccod <<'-----'
  Bool is_gr##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return is_nil##_DOMAIN(x1)
           ? 0
           : (! is_nil##_DOMAIN(x1)
              && (is_nil##_DOMAIN(x2) || is_gr##_ELEM1(s##_ELEM1##_DOMAIN(x1),s##_ELEM1##_DOMAIN(x2)))
             );
   }
-----
cat >$OUT_DIR/opti/com/is_gr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s + is_nil
   ELEM1    = + is_gr
-----
[ -d $OUT_DIR/opti/com/is_opt ] || mkdir $OUT_DIR/opti/com/is_opt
cat >$OUT_DIR/opti/com/is_opt/ccod <<'-----'
  Bool is_opt##_DOMAIN _FPH2(DOMAIN,ELEM1 *)
   {if ( ! is_nil##_DOMAIN(x1) ) {*x2 = s##_ELEM1##_DOMAIN(x1); return 1;}
    return 0;
   }
-----
cat >$OUT_DIR/opti/com/is_opt/docu <<'-----'
  general implementation using "is_nil" and "s" (selector function)
-----
cat >$OUT_DIR/opti/com/is_opt/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + is_nil + s  
-----
[ -d $OUT_DIR/opti/com/mk ] || mkdir $OUT_DIR/opti/com/mk
cat >$OUT_DIR/opti/com/mk/ccod <<'-----'
  DOMAIN mk##_ELEM1##_DOMAIN _FPH1(DOMAIN) {return mk_opt##_DOMAIN(x1);}
-----
cat >$OUT_DIR/opti/com/mk/cmcr <<'-----'
_DEFINE mk##_ELEM1##_DOMAIN(x1) mk_opt##_DOMAIN(x1)
-----
cat >$OUT_DIR/opti/com/mk/pmcr <<'-----'
_DEFINE mk##_ELEM1##_DOMAIN(x1) mk_opt##_DOMAIN(x1)
-----
cat >$OUT_DIR/opti/com/mk/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_opt
-----
[ -d $OUT_DIR/opti/com/parse ] || mkdir $OUT_DIR/opti/com/parse
cat >$OUT_DIR/opti/com/parse/ccod <<'-----'
/* LDOMNAME will be used to pass the 'real' domain name to the 'parse'
   function of the representation in automem implementations !  */

DOMAIN parse##_DOMAIN _FPH0()
#ifdef GEN_ISO
  { if (check_char_vdmlib('n'))
       { char *lx1 = readtoken_vdmlib(#DOMAIN);
	 if (strcmp(lx1,"nil") == 0)
	    { return mk_nil##_DOMAIN(); }
	 else
	    { unputtoken_vdmlib(lx1); }
       }
    return mk_opt##_DOMAIN(parse##_ELEM1()); 
  }
#else
  { char *lx1 = readtoken_vdmlib(#DOMAIN);
    char lx2[300];

    /* dynamic construction of "mk##_DOMAIN" */
#if defined(LDOMNAME)
    strcpy(lx2,"mk"); strcat(lx2,#LDOMNAME);   
#else
    strcpy(lx2,"mk"); strcat(lx2,#_DOMAIN);
#endif

    if (strcmp(lx1,"NIL") == 0) { return mk_nil##_DOMAIN(); }
    if (strcmp(lx1,lx2) != 0)
       { strcat(lx2," or NIL"); expected_vdmlib(#DOMAIN,lx2,lx1); }
    expect_vdmlib("(",#DOMAIN);
    { ELEM1 lx3 = parse##_ELEM1();
      expect_vdmlib(")",#DOMAIN);
      return mk_opt##_DOMAIN(lx3);
    }
  }
#endif

#undef LDOMNAME
-----
cat >$OUT_DIR/opti/com/parse/docu <<'-----'

  Syntax:  'NIL' | 'mk_'<DOMAIN>'('<ELEM1')'

-----
cat >$OUT_DIR/opti/com/parse/param <<'-----'
DOMNAME
LDOMNAME
-----
cat >$OUT_DIR/opti/com/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
 DOMAIN	= + mk_nil + mk_opt
 ELEM1	= + parse
 Vdmlib	= + parsesup
-----
[ -d $OUT_DIR/opti/com/print ] || mkdir $OUT_DIR/opti/com/print
cat >$OUT_DIR/opti/com/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
   {ELEM1 x2;
    if (is_opt##_DOMAIN(x1,&x2))
       {
_IFDEF __cplusplus
#ifndef GEN_ISO
       print_FD_vdmlib << "mk"###_DOMAIN##"(";
#endif
       print##_ELEM1(x2);
#ifndef GEN_ISO
         print_FD_vdmlib << ")";
#endif
       }
    else
#ifdef GEN_ISO
      { print_FD_vdmlib << "nil"; }
#else
      { print_FD_vdmlib << "NIL"; }
#endif

_ELSE

#ifndef GEN_ISO
       fprintf(print_FD_vdmlib,"mk"###_DOMAIN##"(");
#endif
       print##_ELEM1(x2);
#ifndef GEN_ISO
         fprintf(print_FD_vdmlib,")");
#endif
       }
    else
#ifdef GEN_ISO
      { fprintf(print_FD_vdmlib,"nil"); }
#else
      { fprintf(print_FD_vdmlib,"NIL"); }
#endif
_ENDIF
   }
-----
cat >$OUT_DIR/opti/com/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_opt
   ELEM1    = + print
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/opti/elemonil ] || mkdir $OUT_DIR/opti/elemonil
[ -d $OUT_DIR/opti/elemonil/basic ] || mkdir $OUT_DIR/opti/elemonil/basic
cat >$OUT_DIR/opti/elemonil/basic/docu <<'-----'
  
  Implementation of

     DOMAIN  =  [ ELEM1 ]

  NIL is represented by a special user-defined
  value that does not represent a legal value of the ELEM1 domain.
  For example [ Nat1 ] can be implemented by 'elemonil(NILVAL=0)'
  since 0 is no value of Nat1 but can be represented anyway.
  This implementation can also be used when the 'ptrelem' implementation
  does not work, because the NIL pointer is a legal pointer value
  (representing the empty structure).
  Here you can implement [ ELEM1 ] as 'elemonil(NILVAL=-1)'
  assuming that -1 is not a a legal pointer.

  Parameters:

   "NILVAL" :
              gives the value of the special NIL element. This parameter 
              must be given.
   "MACROS" :
              macro implementation of functions if possible
   "NOCHECK" :
              no check is made in select functions that the union value
              is not NIL, MACROS implies NOCHECK
-----
cat >$OUT_DIR/opti/elemonil/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/opti/elemonil/basic/gtyp <<'-----'
  TYPE_DEF(DOMAIN,ELEM1)

#ifndef NILVAL
  DOMAIN: the implementation parameter NILVAL must be specified
#endif
-----
cat >$OUT_DIR/opti/elemonil/basic/param <<'-----'
AUTOMEM
AUTOMEM_SEL
INTERNALDOMAIN
MACROS
NILVAL
NOCHECK
-----
cat >$OUT_DIR/opti/elemonil/basic/vdm <<'-----'
#if defined(AUTOMEM_SEL)
DOMAINS
IMPLEMENTATIONS
   DOMAIN = + mk_nil + del + copy
#endif

#define CONSTRNAME mk_basic
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/elemonil/is_nil ] || mkdir $OUT_DIR/opti/elemonil/is_nil
cat >$OUT_DIR/opti/elemonil/is_nil/ccod <<'-----'
  Bool is_nil##_DOMAIN _FPH1(DOMAIN) {return (x1 == (DOMAIN)(NILVAL)) ;}
-----
cat >$OUT_DIR/opti/elemonil/is_nil/cmcr <<'-----'
_DEFINE is_nil##_DOMAIN(x1) ((x1) == (DOMAIN)(NILVAL))
-----
cat >$OUT_DIR/opti/elemonil/is_nil/pmcr <<'-----'
_DEFINE is_nil##_DOMAIN(x1) ((x1) == (DOMAIN)(NILVAL)))
-----
[ -d $OUT_DIR/opti/elemonil/is_opt ] || mkdir $OUT_DIR/opti/elemonil/is_opt
cat >$OUT_DIR/opti/elemonil/is_opt/ccod <<'-----'
  Bool is_opt##_DOMAIN _FPH2(DOMAIN,ELEM1 *)
   {if ((x1) != (DOMAIN)(NILVAL)) {*x2 = x1; return 1;}
    return 0;
   }
-----
[ -d $OUT_DIR/opti/elemonil/mk_nil ] || mkdir $OUT_DIR/opti/elemonil/mk_nil
cat >$OUT_DIR/opti/elemonil/mk_nil/ccod <<'-----'
  DOMAIN mk_nil##_DOMAIN _FPH0() {return (DOMAIN)(NILVAL);}
-----
cat >$OUT_DIR/opti/elemonil/mk_nil/cmcr <<'-----'
_DEFINE mk_nil##_DOMAIN() ((DOMAIN)(NILVAL))
-----
cat >$OUT_DIR/opti/elemonil/mk_nil/pmcr <<'-----'
_DEFINE mk_nil##_DOMAIN DOMAIN((NILVAL))
-----
cat >$OUT_DIR/opti/elemonil/mk_nil/vdm <<'-----'

#define CONSTRNAME mk_nil
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/elemonil/mk_opt ] || mkdir $OUT_DIR/opti/elemonil/mk_opt
cat >$OUT_DIR/opti/elemonil/mk_opt/ccod <<'-----'
  DOMAIN mk_opt##_DOMAIN _FPH1(DOMAIN) {return x1;}
-----
cat >$OUT_DIR/opti/elemonil/mk_opt/cmcr <<'-----'
_DEFINE mk_opt##_DOMAIN(x1) x1
-----
cat >$OUT_DIR/opti/elemonil/mk_opt/pmcr <<'-----'
_DEFINE mk_opt##_DOMAIN(x1) x1
-----
cat >$OUT_DIR/opti/elemonil/mk_opt/vdm <<'-----'

#define CONSTRNAME mk_opt
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/elemonil/s ] || mkdir $OUT_DIR/opti/elemonil/s
cat >$OUT_DIR/opti/elemonil/s/ccod <<'-----'
  ELEM1 s##_ELEM1##_DOMAIN _FPH1(DOMAIN)
   {
#ifndef NOCHECK
    if ((x1) == (DOMAIN)(NILVAL)) err_opt_vdmlib(MKSTRING(DOMAIN));
#endif
    return x1;
   }
-----
cat >$OUT_DIR/opti/elemonil/s/cmcr <<'-----'
_DEFINE s##_ELEM1##_DOMAIN(x1) x1
-----
cat >$OUT_DIR/opti/elemonil/s/pmcr <<'-----'
_DEFINE s##_ELEM1##_DOMAIN(x1) x1
-----
cat >$OUT_DIR/opti/elemonil/s/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! MACROS && ! NOCHECK
   Vdmlib   = + err_opt
#endif
-----
[ -d $OUT_DIR/opti/ptelem ] || mkdir $OUT_DIR/opti/ptelem
[ -d $OUT_DIR/opti/ptelem/basic ] || mkdir $OUT_DIR/opti/ptelem/basic
cat >$OUT_DIR/opti/ptelem/basic/docu <<'-----'
  
  Implementation of

     DOMAIN  =  [ ELEM1 ]

  as pointer or NIL. NIL is represented by the NULL pointer
  (Pascal : NIL, C (ELEM1)0 ). ELEM1 must be implemented as a pointer.
  It is important for this implementation, that the NIL pointer does not
  represent any legal ELEM1 value, since 0 is used to encode the NIL case.
  This for example does hold for the 'ptstruct' implementation
  of trees or the 'ptrunion' implementation for unions,
  but not for the linked list implementations of maps, sets and tuples.
  Here NIL represents the empyt map, set or tuple.

  Parameters:

   "MACROS" :
              macro implementation of functions if possible
   "NOCHECK" :
              no check is made in select functions that the union value
              is not NIL, MACROS implies NOCHECK
-----
cat >$OUT_DIR/opti/ptelem/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/opti/ptelem/basic/gtyp <<'-----'
  TYPE_DEF(DOMAIN,ELEM1)
-----
cat >$OUT_DIR/opti/ptelem/basic/param <<'-----'
INTERNALDOMAIN
MACROS
NOCHECK
NO_AUTOMEM
-----
cat >$OUT_DIR/opti/ptelem/basic/vdm <<'-----'
#if defined(AUTOMEM)
DOMAINS
IMPLEMENTATIONS
   DOMAIN = + copy + del + mk_nil
#endif

#define CONSTRNAME mk_basic
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/ptelem/is_nil ] || mkdir $OUT_DIR/opti/ptelem/is_nil
cat >$OUT_DIR/opti/ptelem/is_nil/ccod <<'-----'
  Bool is_nil##_DOMAIN _FPH1(DOMAIN) {return ! x1;}
-----
cat >$OUT_DIR/opti/ptelem/is_nil/cmcr <<'-----'
_DEFINE is_nil##_DOMAIN(x1) (! (x1))
-----
cat >$OUT_DIR/opti/ptelem/is_nil/pmcr <<'-----'
_DEFINE is_nil##_DOMAIN(x1) ((x1) = NIL)
-----
[ -d $OUT_DIR/opti/ptelem/is_opt ] || mkdir $OUT_DIR/opti/ptelem/is_opt
cat >$OUT_DIR/opti/ptelem/is_opt/ccod <<'-----'
  Bool is_opt##_DOMAIN _FPH2(DOMAIN,ELEM1 *)
   {if (x1) {*x2 = x1; return 1;}
    return 0;
   }
-----
[ -d $OUT_DIR/opti/ptelem/mk_nil ] || mkdir $OUT_DIR/opti/ptelem/mk_nil
cat >$OUT_DIR/opti/ptelem/mk_nil/ccod <<'-----'
  DOMAIN mk_nil##_DOMAIN _FPH0() {return (DOMAIN)0;}
-----
cat >$OUT_DIR/opti/ptelem/mk_nil/cmcr <<'-----'
_DEFINE mk_nil##_DOMAIN() ((DOMAIN)0)
-----
cat >$OUT_DIR/opti/ptelem/mk_nil/pmcr <<'-----'
_DEFINE mk_nil##_DOMAIN NIL
-----
cat >$OUT_DIR/opti/ptelem/mk_nil/vdm <<'-----'

#define CONSTRNAME mk_nil
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/ptelem/mk_opt ] || mkdir $OUT_DIR/opti/ptelem/mk_opt
cat >$OUT_DIR/opti/ptelem/mk_opt/ccod <<'-----'
  DOMAIN mk_opt##_DOMAIN _FPH1(DOMAIN) {return x1;}
-----
cat >$OUT_DIR/opti/ptelem/mk_opt/cmcr <<'-----'
_DEFINE mk_opt##_DOMAIN(x1) (x1)
-----
cat >$OUT_DIR/opti/ptelem/mk_opt/pmcr <<'-----'
_DEFINE mk_opt##_DOMAIN(x1) (x1)
-----
cat >$OUT_DIR/opti/ptelem/mk_opt/vdm <<'-----'

#define CONSTRNAME mk_opt
#define ADTNAME ADT_OPTI
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/opti/ptelem/s ] || mkdir $OUT_DIR/opti/ptelem/s
cat >$OUT_DIR/opti/ptelem/s/ccod <<'-----'
  ELEM1 s##_ELEM1##_DOMAIN _FPH1(DOMAIN)
   {
#ifndef NOCHECK
    if (! x1) err_opt_vdmlib(MKSTRING(DOMAIN));
#endif
    return x1;
   }
-----
cat >$OUT_DIR/opti/ptelem/s/cmcr <<'-----'
_DEFINE s##_ELEM1##_DOMAIN(x1) (x1)
-----
cat >$OUT_DIR/opti/ptelem/s/pmcr <<'-----'
_DEFINE s##_ELEM1##_DOMAIN(x1) (x1)
-----
cat >$OUT_DIR/opti/ptelem/s/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! MACROS && ! NOCHECK
   Vdmlib   = + err_opt
#endif
-----
[ -d $OUT_DIR/opti/sign ] || mkdir $OUT_DIR/opti/sign
[ -d $OUT_DIR/opti/sign/basic ] || mkdir $OUT_DIR/opti/sign/basic
cat >$OUT_DIR/opti/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
public:
  DOMAIN data;
  /* 
     === the macro BASEIMPL is defined only if the automatic memory management 
     === is selected explicitly as "automem(BASEIMPL= ... )" and not by selecting
     === the command line parameter "-M" ! This will create an inefficient
     === implementation for optionals, which is only available for testing
     ===        *** MAY NOT BE SUPPORTED IN FURTHER VERSIONS ***
     */
#if defined(BASEIMPL)
  Cpp_DOMAIN()
  {
    data = 0;
    CA == non valid handle CE
  }
  ~Cpp_DOMAIN() { del##_DOMAIN(data); }

  Cpp_DOMAIN(const Cpp_DOMAIN & x1)
  {
    check_handle##_DOMAIN(x1.data);
    data = x1.data;
    data->f_rc++;
  }

  Cpp_DOMAIN(const DOMAIN &x1)
  {
    check_handle##_DOMAIN(x1);
    data = x1;
    data->f_rc++;
  }

  Cpp_DOMAIN & operator = (const Cpp_DOMAIN & x1)
  { 
    check_handle##_DOMAIN(x1.data);
    if (data != x1.data)
      {
	if (data!=0) del##_DOMAIN(data);
	data = x1.data;
	data->f_rc++;
      }
    return *this;
  }

  /* for moving a C++ object into a C data structure, e.g. a union */
  /* conversion back to C++ is done implicitly by Constuctor Cpp_DOMAIN(const DOMAIN & x1) */
  /* use count is incremented to prevent deletion by destructors */

  DOMAIN cv##_DOMAIN() const
  {
    check_handle##_DOMAIN(data);
    data->f_rc++;
    return data;
  }

#elif defined(AUTOMEM_SEL)
  Cpp_DOMAIN()
  {
    data = mk_nil##_DOMAIN();
  }
  ~Cpp_DOMAIN()
  {
    del##_DOMAIN(data);
  }
  Cpp_DOMAIN(const DOMAIN &x1)
  {
    data = copy##_DOMAIN(x1);
  }
  Cpp_DOMAIN(const Cpp_DOMAIN & x1)
  {
    data = copy##_DOMAIN(x1.data);
  }
  Cpp_DOMAIN & operator = (const Cpp_DOMAIN & x1)
  { 
    if (data != x1.data)
      {
	del##_DOMAIN(data);
	data = copy##_DOMAIN(x1.data);
      }
    return *this;
  }

  /* access function for data field for conversion between C++ and C */
  DOMAIN       cv##_DOMAIN() const              { return data;                  }

#else
  Cpp_DOMAIN() {}
  Cpp_DOMAIN(const DOMAIN &x1) { data = x1;}
  Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1)
  {
    data = x1.data;
    return *this;
  }

  /* access function for data field for conversion between C++ and C */
  DOMAIN       cv##_DOMAIN() const              { return data;                  }

#endif
#endif
-----
cat >$OUT_DIR/opti/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/opti/sign/is ] || mkdir $OUT_DIR/opti/sign/is
cat >$OUT_DIR/opti/sign/is/cpp <<'-----'
#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(is##_ELEM1,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is##_ELEM1,FPARLIST1))

#ifdef OPERATOR
InlineFriendConstFct(operator !,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is##_ELEM1,FPARLIST1))
#endif

#undef T1
-----
cat >$OUT_DIR/opti/sign/is/gsig <<'-----'
  FUNCDEC(is##_ELEM1##_DOMAIN,PL_1(DOMAIN),Bool)
-----
cat >$OUT_DIR/opti/sign/is/vsig <<'-----'
  is##_ELEM1(x1) = ~ is_nil(x1)
  TYPE : DOMAIN  -->  Bool

  test whether the optional value x1 is not the NIL value
-----
[ -d $OUT_DIR/opti/sign/is_nil ] || mkdir $OUT_DIR/opti/sign/is_nil
cat >$OUT_DIR/opti/sign/is_nil/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(is_nil,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_nil,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/opti/sign/is_nil/gsig <<'-----'
  FUNCDEC(is_nil##_DOMAIN,PL_1(DOMAIN),Bool)  
-----
cat >$OUT_DIR/opti/sign/is_nil/vsig <<'-----'
  is_nil(x1) = ( x1 = NIL )
  TYPE : DOMAIN --> Bool

  test whether the optional value x1 is the NIL value
-----
[ -d $OUT_DIR/opti/sign/is_opt ] || mkdir $OUT_DIR/opti/sign/is_opt
cat >$OUT_DIR/opti/sign/is_opt/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 Cpp_ELEM1 &
InlineFriendConstFct(is_opt,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_opt,(DATA,&(x2.data))))
#undef T1
#undef T2
-----
cat >$OUT_DIR/opti/sign/is_opt/gsig <<'-----'
  FUNCDEC(is_opt##_DOMAIN,PL_VR(DOMAIN,ELEM1),Bool)
-----
cat >$OUT_DIR/opti/sign/is_opt/vsig <<'-----'
  is_opt(x1) =
    if x1 = NIL
    then
      (FALSE, )
    else
      (TRUE,x1)
  TYPE :  DOMAIN  --> ( Bool   ELEM1 )

  predicate for testing whether a value is NIL and for returning
  the non NIL value in the false case. The return value is implemented
  as extra reference parameter x2.

  With the use of this function the select functions can be eliminated
  and code can be more compact and readable.

  Example:

    the following C code can be substituted by a shorter sequence using
    the is_opt predicate

    old: test and select separated

    if (! is_nil##_DOMAIN(x1)) {
       ELEM1 x2 = s##_ELEM1##_DOMAIN(x1);
         ...x2...
       }

    shorter: test and select combined

    { ELEM1 x2;
      if ( is_opt##_DOMAIN(x1,&x2) ) {
        ...x2...;
      }
    }
-----
[ -d $OUT_DIR/opti/sign/mk ] || mkdir $OUT_DIR/opti/sign/mk
cat >$OUT_DIR/opti/sign/mk/gsig <<'-----'
  FUNCDEC(mk##_ELEM1##_DOMAIN,PL_1(ELEM1),DOMAIN)
-----
cat >$OUT_DIR/opti/sign/mk/vsig <<'-----'
  mk##_ELEM1(x1) = mk_opt(x1)
  TYPE : ELEM1 --> DOMAIN

  synonym for __SA(mk_opt) for compatibility reasons
-----
[ -d $OUT_DIR/opti/sign/mk_nil ] || mkdir $OUT_DIR/opti/sign/mk_nil
cat >$OUT_DIR/opti/sign/mk_nil/cpp <<'-----'
#define T1 const Cpp_NIL &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk_nil,KPARLIST0))
#undef T1 
-----
cat >$OUT_DIR/opti/sign/mk_nil/gsig <<'-----'
  FUNCDEC(mk_nil##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/opti/sign/mk_nil/vsig <<'-----'
  mk_nil() = NIL
  TYPE : --> DOMAIN

  constructing the NIL value of an optional domain

#ifdef GEN_CPP
  In C++ __EM(mk_nil) becomes a constructor with one argument
  of an auxiliary class NILETC

  In C++ initialization with the NIL value is done
  in the form

    DOMAIN v = nil;

  or

    DOMAIN v(nil);

  __EM(nil) is a special predefined object of the auxiliary class __EM(NILETC)

#endif

-----
[ -d $OUT_DIR/opti/sign/mk_opt ] || mkdir $OUT_DIR/opti/sign/mk_opt
cat >$OUT_DIR/opti/sign/mk_opt/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk_opt,KPARLIST1))
#undef T1
-----
cat >$OUT_DIR/opti/sign/mk_opt/gsig <<'-----'
  FUNCDEC(mk_opt##_DOMAIN,PL_1(ELEM1),DOMAIN)
-----
cat >$OUT_DIR/opti/sign/mk_opt/vsig <<'-----'
  mk_opt(x1) = x1
  TYPE : ELEM1  -->  DOMAIN

  constructing a non NIL value of an optional domain 
  by a conversion from ELEM1 to DOMAIN
  this must be done explicitly (in pure VDM it is done implicitly)
  for storing the extra information that the value x1 is not NIL

#ifdef GEN_CPP

  In C++ 'mk_opt' becomes a constructor with one argument
  of class ELEMENT1, so implizit construction becomes possible
  in C++ as long as the constructor call can be unambiguously
  computed by the C++ type checker

#endif
-----
[ -d $OUT_DIR/opti/sign/s ] || mkdir $OUT_DIR/opti/sign/s
cat >$OUT_DIR/opti/sign/s/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(s,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,s##_ELEM1,FPARLIST1))
#undef T1

-----
cat >$OUT_DIR/opti/sign/s/gsig <<'-----'
  FUNCDEC(s##_ELEM1##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/opti/sign/s/vsig <<'-----'
  s##_ELEM1(x1) = x1
  TYPE : DOMAIN  -->  ELEM1
  PRE  : x1 ~ = NIL

  function for removing the extra information neccesary for
  distinguishing between NIL and the other values.
  in pure VDM this is conversion is done implicitly.
-----
[ -d $OUT_DIR/rel ] || mkdir $OUT_DIR/rel
[ -d $OUT_DIR/rel/aux ] || mkdir $OUT_DIR/rel/aux
[ -d $OUT_DIR/rel/aux/defs ] || mkdir $OUT_DIR/rel/aux/defs
cat >$OUT_DIR/rel/aux/defs/domran <<'-----'
#include <rel/aux/defs/ranset>
#include <rel/aux/defs/domset>
-----
cat >$OUT_DIR/rel/aux/defs/domset <<'-----'
#ifndef DOMAINSET
#error DOMAIN: The parameter 'DOMAINSET' must be set either for the
#error  whole implementation or for the suitable operation.
#endif
#ifdef ELEM3
#error DOMAIN: operation allowed for binary relations only
#endif
-----
cat >$OUT_DIR/rel/aux/defs/ranset <<'-----'
#ifndef RANGESET
#error DOMAIN: The parameter 'RANGESET' must be set either for the
#error  whole implementation or for the suitable operation.
#endif
#ifdef ELEM3
#error DOMAIN: operation allowed for binary relations only
#endif
-----
[ -d $OUT_DIR/rel/aux/docu ] || mkdir $OUT_DIR/rel/aux/docu
cat >$OUT_DIR/rel/aux/docu/domset <<'-----'
    "DOMAINSET"	: Parameter specifying the name of a set
		  domain of type ELEM1 -set. If not supplied
		  with the implementation description, it must
		  be supplied with the individual operation.
-----
cat >$OUT_DIR/rel/aux/docu/ranset <<'-----'
    "RANGESET"	: Parameter specifying the name of a set
		  domain of type ELEM2 -set. If not supplied
		  with the implementation description, it must
		  be supplied with the individual operation.
-----
[ -d $OUT_DIR/rel/aux/macro1 ] || mkdir $OUT_DIR/rel/aux/macro1
cat >$OUT_DIR/rel/aux/macro1/ccod <<'-----'
#ifndef MACRO0
#define MACRO0 ,
#endif

#ifndef MACRO1
#define MACRO1(e,n) e x##n
#endif

  MACRO1(ELEM1,1)
#ifdef ELEM2
  MACRO0 MACRO1(ELEM2,2)
#endif
#ifdef ELEM3
  MACRO0 MACRO1(ELEM3,3)
#endif
#ifdef ELEM3
  MACRO0 MACRO1(ELEM3,3)
#endif
#ifdef ELEM4
  MACRO0 MACRO1(ELEM4,4)
#endif
#ifdef ELEM5
  MACRO0 MACRO1(ELEM5,5)
#endif
#ifdef ELEM6
  MACRO0 MACRO1(ELEM6,6)
#endif
#ifdef ELEM7
  MACRO0 MACRO1(ELEM7,7)
#endif
#ifdef ELEM8
  MACRO0 MACRO1(ELEM8,8)
#endif
#ifdef ELEM9
  MACRO0 MACRO1(ELEM9,9)
#endif
#ifdef ELEM10
#error DOMAIN: maximum of 9 components are allowed for relations
#endif

#undef MACRO0
#undef MACRO1
-----
[ -d $OUT_DIR/rel/aux/sigone ] || mkdir $OUT_DIR/rel/aux/sigone
cat >$OUT_DIR/rel/aux/sigone/fhdr <<'-----'
#ifndef _DOMPAR
#define _DOMPAR _FP(x0,DOMAIN),
#define _DOMPAR1 _EP(x0,DOMAIN)
#endif
#ifndef _RES
#define _RES DOMAIN
#endif
  _RES MERGE(_OPNAME,_DOMAIN) (_DOMPAR
#define MACRO0 ,
#define MACRO1(e,n) _FP(x##n,e)
#include <rel/aux/macro1/ccod>
  ) _DOMPAR1
#define MACRO0 
#define MACRO1(e,n) _EP(x##n,e)
#include <rel/aux/macro1/ccod>

#undef _OPNAME
#undef _DOMPAR
#undef _DOMPAR1
#undef _RES
-----
cat >$OUT_DIR/rel/aux/sigone/gsig <<'-----'
#ifndef _DOMPAR
#define _DOMPAR DOMAIN x0,
#endif
#ifndef _RES
#define _RES DOMAIN
#endif
  _RES MERGE(_OPNAME,_DOMAIN) P_OP _DOMPAR
#define MACRO0 ,
#define MACRO1(e,n) e x##n
#include <rel/aux/macro1/ccod>
  P_CL;

#undef _OPNAME
#undef _DOMPAR
#undef _RES
-----
[ -d $OUT_DIR/rel/com ] || mkdir $OUT_DIR/rel/com
[ -d $OUT_DIR/rel/com/all ] || mkdir $OUT_DIR/rel/com/all
cat >$OUT_DIR/rel/com/all/docu <<'-----'
#include <aux/com/all/docu>
-----
cat >$OUT_DIR/rel/com/all/vdm <<'-----'
#include <aux/com/all/vdm>
-----
[ -d $OUT_DIR/rel/com/basic ] || mkdir $OUT_DIR/rel/com/basic
cat >$OUT_DIR/rel/com/basic/adttype <<'-----'
REAL
-----
[ -d $OUT_DIR/rel/com/cvlines ] || mkdir $OUT_DIR/rel/com/cvlines
cat >$OUT_DIR/rel/com/cvlines/gcod <<'-----'
  _FDEC1(cvlines,Cvtext_vdmlib,DOMAIN,_RET(cvlines_set##_DOMAIN(x1)))
-----
cat >$OUT_DIR/rel/com/cvlines/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,cvlines)
-----
[ -d $OUT_DIR/rel/com/dom ] || mkdir $OUT_DIR/rel/com/dom
cat >$OUT_DIR/rel/com/dom/docu <<'-----'
  General implementation using 'fold'.

  Parameters:
#include <rel/aux/docu/domset>
-----
cat >$OUT_DIR/rel/com/dom/gtyp <<'-----'
_DEFINE dom##_DOMAIN##_ELEM1##_ELEM2(x1,x2) mk1##_DOMAINSET(x1)
-----
cat >$OUT_DIR/rel/com/dom/param <<'-----'
DOMAINSET
-----
cat >$OUT_DIR/rel/com/dom/vdm <<'-----'
#include <rel/aux/defs/domset>
  DOMAINS
  IMPLEMENTATIONS
   DOMAIN = + fold.dom(RESULT	= DOMAINSET
	   	      ,NULLFCT	= mk_empty
	   	      ,FOLDFCT	= union
	   	      ,CVFCT	= dom##_DOMAIN
	   	      ,NOSIGNATURE)
   DOMAINSET = + mk_empty + union + mk1
-----
[ -d $OUT_DIR/rel/com/domresby ] || mkdir $OUT_DIR/rel/com/domresby
cat >$OUT_DIR/rel/com/domresby/docu <<'-----'
  General implementation using 'fold'.

  Parameters:
#include <rel/aux/docu/domset>
-----
cat >$OUT_DIR/rel/com/domresby/gtyp <<'-----'
#ifndef _NOT
#define _NOT !
#endif
#ifndef _OPERATION
#define _OPERATION domresby1
#endif
_DEFINE MERGE(MERGE(_OPERATION,_DOMAIN),MERGE(_ELEM1,_ELEM2))(x1,x2,x3) ( (_NOT is_in##_DOMAINSET(x1,x3)) ? mk1##_DOMAIN(x1,x2) : mk_empty##_DOMAIN())
#undef _NOT
#undef _OPERATION
-----
cat >$OUT_DIR/rel/com/domresby/param <<'-----'
DOMAINSET
-----
cat >$OUT_DIR/rel/com/domresby/vdm <<'-----'
#include <rel/com/domresby/vdmaux>
-----
cat >$OUT_DIR/rel/com/domresby/vdmaux <<'-----'
#ifndef _OPERATION
#define _OPERATION domresby1
#endif
#ifndef _ARGSET
#define _ARGSET DOMAINSET
#endif
  DOMAINS
  IMPLEMENTATIONS
   DOMAIN = + fold._OPERATION(RESULT	= DOMAIN
	   	      ,NULLFCT	= mk_empty
	   	      ,FOLDFCT	= union
	   	      ,CVFCT	= _OPERATION##_DOMAIN
		      ,X	= _ARGSET
	   	      ,NOSIGNATURE)
   	    + mk_empty + union + mk1
   _ARGSET = + is_in
#undef _OPERATION
#undef _ARGSET
-----
[ -d $OUT_DIR/rel/com/domresto ] || mkdir $OUT_DIR/rel/com/domresto
cat >$OUT_DIR/rel/com/domresto/docu <<'-----'
  General implementation using 'fold'.

  Parameters:
#include <rel/aux/docu/domset>
-----
cat >$OUT_DIR/rel/com/domresto/gtyp <<'-----'
#define _OPERATION domresto1
#define _NOT
#include <rel/com/domresby/gtyp>
-----
cat >$OUT_DIR/rel/com/domresto/param <<'-----'
DOMAINSET
-----
cat >$OUT_DIR/rel/com/domresto/vdm <<'-----'
#define _OPERATION domresto1
#include <rel/com/domresby/vdmaux>
-----
[ -d $OUT_DIR/rel/com/fold ] || mkdir $OUT_DIR/rel/com/fold
cat >$OUT_DIR/rel/com/fold/ccod <<'-----'
#include <aux/com/fold/ccod>
-----
cat >$OUT_DIR/rel/com/fold/docu <<'-----'
#define Rel

  General implementation for 'fold' based on 'forall'

#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/rel/com/fold/param <<'-----'
ABORTVAL
RESULT
CVFCTRES
FCTNAME
NULLFCT
NULLPARAM
CVFCT
CVFCTVAR
FOLDFCT
NOSIGNATURE
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/rel/com/fold/vdm <<'-----'
#include <aux/com/fold/vdm>
-----
[ -d $OUT_DIR/rel/com/parse ] || mkdir $OUT_DIR/rel/com/parse
cat >$OUT_DIR/rel/com/parse/gcod <<'-----'
_ALIAS_DV(parse,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/com/parse/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,parse)
-----
[ -d $OUT_DIR/rel/com/print ] || mkdir $OUT_DIR/rel/com/print
cat >$OUT_DIR/rel/com/print/gcod <<'-----'
_ALIAS_VD(print,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/com/print/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,print)
-----
[ -d $OUT_DIR/rel/com/ran ] || mkdir $OUT_DIR/rel/com/ran
cat >$OUT_DIR/rel/com/ran/docu <<'-----'
  General implementation using 'fold'.

  Parameters:
#include <rel/aux/docu/ranset>
-----
cat >$OUT_DIR/rel/com/ran/gtyp <<'-----'
_DEFINE ran##_DOMAIN##_ELEM1##_ELEM2(x1,x2) mk1##_RANGESET(x2)
-----
cat >$OUT_DIR/rel/com/ran/param <<'-----'
RANGESET
-----
cat >$OUT_DIR/rel/com/ran/vdm <<'-----'
#include <rel/aux/defs/ranset>
  DOMAINS
  IMPLEMENTATIONS
   DOMAIN = + fold.ran(RESULT	= RANGESET
	   	      ,NULLFCT	= mk_empty
	   	      ,FOLDFCT	= union
	   	      ,CVFCT	= ran##_DOMAIN
	   	      ,NOSIGNATURE)
   RANGESET = + mk_empty + union + mk1
-----
[ -d $OUT_DIR/rel/com/ranresby ] || mkdir $OUT_DIR/rel/com/ranresby
cat >$OUT_DIR/rel/com/ranresby/docu <<'-----'
  General implementation using 'fold'.

  Parameters:
#include <rel/aux/docu/ranset>
-----
cat >$OUT_DIR/rel/com/ranresby/gtyp <<'-----'
#ifndef _NOT
#define _NOT !
#endif
#ifndef _OPERATION
#define _OPERATION ranresby
#endif
_DEFINE MERGE(MERGE(_OPERATION,_DOMAIN),MERGE(_ELEM1,_ELEM2))(x1,x2,x3) ( (_NOT is_in##_RANGESET(x2,x3)) ? mk1##_DOMAIN(x1,x2) : mk_empty##_DOMAIN())
#undef _NOT
#undef _OPERATION
-----
cat >$OUT_DIR/rel/com/ranresby/param <<'-----'
RANGESET
-----
cat >$OUT_DIR/rel/com/ranresby/vdm <<'-----'
#define _OPERATION ranresby
#define _ARGSET RANGESET
#include <rel/com/domresby/vdmaux>
-----
[ -d $OUT_DIR/rel/com/ranresto ] || mkdir $OUT_DIR/rel/com/ranresto
cat >$OUT_DIR/rel/com/ranresto/docu <<'-----'
  General implementation using 'fold'.

  Parameters:
#include <rel/aux/docu/ranset>
-----
cat >$OUT_DIR/rel/com/ranresto/gtyp <<'-----'
#define _OPERATION ranresto
#define _NOT
#include <rel/com/ranresby/gtyp>
-----
cat >$OUT_DIR/rel/com/ranresto/param <<'-----'
RANGESET
-----
cat >$OUT_DIR/rel/com/ranresto/vdm <<'-----'
#define _OPERATION ranresto
#define _ARGSET RANGESET
#include <rel/com/domresby/vdmaux>
-----
[ -d $OUT_DIR/rel/com/sel ] || mkdir $OUT_DIR/rel/com/sel
cat >$OUT_DIR/rel/com/sel/docu <<'-----'
  General implementation using 'fold'.

  Parameters:
#include <rel/aux/docu/domset>
#include <rel/aux/docu/ranset>
-----
cat >$OUT_DIR/rel/com/sel/gtyp <<'-----'
_DEFINE sel##_DOMAIN##_ELEM1##_ELEM2(x1,x2,x3) ( (is_in##_DOMAINSET(x1,x3)) ? mk1##_RANGESET(x2) : mk_empty##_RANGESET() )
-----
cat >$OUT_DIR/rel/com/sel/param <<'-----'
DOMAINSET
RANGESET
-----
cat >$OUT_DIR/rel/com/sel/vdm <<'-----'
#include <rel/aux/defs/domran>
  DOMAINS
  IMPLEMENTATIONS
   DOMAIN = + fold.sel(RESULT	= RANGESET
	   	      ,NULLFCT	= mk_empty
	   	      ,FOLDFCT	= union
	   	      ,CVFCT	= sel##_DOMAIN
	   	      ,X		= DOMAINSET
	   	      ,NOSIGNATURE)
   RANGESET = + mk_empty + union + mk1
   DOMAINSET = + is_in
-----
[ -d $OUT_DIR/rel/mapdom ] || mkdir $OUT_DIR/rel/mapdom
[ -d $OUT_DIR/rel/mapdom/basic ] || mkdir $OUT_DIR/rel/mapdom/basic
cat >$OUT_DIR/rel/mapdom/basic/defdef <<'-----'
#define __SEL(i)	MERGE(s_,MERGE(i,_DOMAIN))
-----
cat >$OUT_DIR/rel/mapdom/basic/defimpl <<'-----'
#ifndef SETIMPL
#define SETIMPL linklist
#endif
#ifndef TREEIMPL
#define TREEIMPL struct
#endif
-----
cat >$OUT_DIR/rel/mapdom/basic/defp <<'-----'
#ifndef SETIMPL
#define SETIMPL linklist
#endif
#ifndef TREEIMPL
#define TREEIMPL struct
#endif
-----
cat >$OUT_DIR/rel/mapdom/basic/docu <<'-----'
#include <rel/mapdom/basic/defimpl>

  Implementation of a relation as a set of tree elements:
    
    Tree##_DOMAIN :: ELEM1 ELEM2 ELEM3
    DOMAIN	  =  Tree##_DOMAIN -set
  
Parameters:

  "SETIMPL" 	: Implementation name for the set domain. This
		  parameter is optional. Default value is #SETIMPL.
  "TREEIMPL"	: Implementation name for the tree domain. This 
		  parameter is optional. Default value is #TREEIMPL.
		  NOTE: Do not change this implementation into 
		        one using dynamic storage allocation (i.e. ptstruct)
		        since there might be storage left unreleased!
  "DOMAINSET"	: This parameter is used for binary relations only.
		  It supplies the name of a set domain of type
		  ELEM1 -set. It is needed (like "RANGESET") for
		  operations having this domain either as parameter
		  or as result (like 'dom', 'domresby',...). It
		  can be specified here globally for the whole 
		  implementation or, if ommitted here, when 
		  selecting each operation individually.
  "RANGESET"	: Similar to "DOMAINSET", this parameter applies for
		  binart relations only. It is used to specify the
		  name of a set domain of type ELEM2 -set, which
		  may occur in several operations like 'ran',
		  'rangeresto',....
-----
cat >$OUT_DIR/rel/mapdom/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/rel/mapdom/basic/gtyp <<'-----'
TYPE_DEF(DOMAIN,Set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/basic/param <<'-----'
MAPIMPL
TREEIMPL
DOMAINSET
RANGESET
MACROS
-----
cat >$OUT_DIR/rel/mapdom/basic/undef <<'-----'
#undef __SEL
-----
cat >$OUT_DIR/rel/mapdom/basic/vdm <<'-----'
#include <rel/mapdom/basic/defimpl>
#include <rel/mapdom/basic/defdef>
DOMAINS
  Tree##_DOMAIN ::
#define MACRO0
#define MACRO1(e,n) __SEL(n) : e
#include <rel/aux/macro1/ccod>
  Set##_DOMAIN = Tree##_DOMAIN -set

  DOMAIN       -> Set##_DOMAIN

IMPLEMENTATIONS
  Tree##_DOMAIN = TREEIMPL(SUPPRESS_CONSTR) ! output as pure tuples !
  Set##_DOMAIN = SETIMPL
#undef SETIMPL
#undef TREEIMPL
#include <rel/mapdom/basic/undef>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_REL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/rel/mapdom/card ] || mkdir $OUT_DIR/rel/mapdom/card
cat >$OUT_DIR/rel/mapdom/card/gcod <<'-----'
_ALIAS_ND(card,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/card/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,card)
-----
[ -d $OUT_DIR/rel/mapdom/copy ] || mkdir $OUT_DIR/rel/mapdom/copy
cat >$OUT_DIR/rel/mapdom/copy/gcod <<'-----'
_ALIAS_DD(copy,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/copy/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,copy)
-----
[ -d $OUT_DIR/rel/mapdom/copy1 ] || mkdir $OUT_DIR/rel/mapdom/copy1
cat >$OUT_DIR/rel/mapdom/copy1/gcod <<'-----'
_ALIAS_DD(copy1,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/copy1/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,copy1)
-----
[ -d $OUT_DIR/rel/mapdom/del ] || mkdir $OUT_DIR/rel/mapdom/del
cat >$OUT_DIR/rel/mapdom/del/gcod <<'-----'
_ALIAS_VD(del,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/del/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,del)
-----
[ -d $OUT_DIR/rel/mapdom/del1 ] || mkdir $OUT_DIR/rel/mapdom/del1
cat >$OUT_DIR/rel/mapdom/del1/gcod <<'-----'
_ALIAS_VD(del1,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/del1/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,del1)
-----
[ -d $OUT_DIR/rel/mapdom/forall ] || mkdir $OUT_DIR/rel/mapdom/forall
cat >$OUT_DIR/rel/mapdom/forall/ccod <<'-----'
#include <rel/mapdom/basic/defdef>

#define _tp MERGE(tp_forall,_DOMAIN)
#define _pp MERGE(pp_forall,_DOMAIN)

static T2_forall##_DOMAIN _tp;
static void _pp _FPH1(Tree##_DOMAIN)
  { (*_tp)(
#define MACRO0 ,
#define MACRO1(e,n) __SEL(n)(x1)
#include <rel/aux/macro1/ccod>
        );
  }

void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
  { T2_forall##_DOMAIN lx1 = _tp; _tp = x2;
    forall_set##_DOMAIN(x1,_pp);
    _tp = lx1;
  }

#undef _tp
#undef _pp
#include <rel/mapdom/basic/undef>
-----
cat >$OUT_DIR/rel/mapdom/forall/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Set##_DOMAIN = + forall
  Tree##_DOMAIN = + s
-----
[ -d $OUT_DIR/rel/mapdom/hash ] || mkdir $OUT_DIR/rel/mapdom/hash
cat >$OUT_DIR/rel/mapdom/hash/gcod <<'-----'
  _ALIAS_ND(hash,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/hash/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,hash)
-----
[ -d $OUT_DIR/rel/mapdom/is_empty ] || mkdir $OUT_DIR/rel/mapdom/is_empty
cat >$OUT_DIR/rel/mapdom/is_empty/gcod <<'-----'
  _ALIAS_BD(is_empty,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/is_empty/vdm <<'-----'
  _ADD_OP(Set##_DOMAIN,is_empty)
-----
[ -d $OUT_DIR/rel/mapdom/is_eq ] || mkdir $OUT_DIR/rel/mapdom/is_eq
cat >$OUT_DIR/rel/mapdom/is_eq/gcod <<'-----'
  _ALIAS_BDD(is_eq,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/is_eq/vdm <<'-----'
  _ADD_OP(Set##_DOMAIN,is_eq)
-----
[ -d $OUT_DIR/rel/mapdom/is_ge ] || mkdir $OUT_DIR/rel/mapdom/is_ge
cat >$OUT_DIR/rel/mapdom/is_ge/gcod <<'-----'
  _ALIAS_BDD(is_ge,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/is_ge/vdm <<'-----'
  _ADD_OP(Set##_DOMAIN,is_ge)
-----
[ -d $OUT_DIR/rel/mapdom/is_in ] || mkdir $OUT_DIR/rel/mapdom/is_in
cat >$OUT_DIR/rel/mapdom/is_in/ccod <<'-----'
  Bool is_in##_DOMAIN (
#define MACRO0 ,
#define MACRO1(e,n) _FP(x##n,e)
#include <rel/aux/macro1/ccod>
  , _FP(x0,DOMAIN)
  )
#define MACRO0 
#define MACRO1(e,n) _EP(x##n,e)
#include <rel/aux/macro1/ccod>
   _EP(x0,DOMAIN)
   { return is_in_##set##_DOMAIN(mk_tree##_DOMAIN(
#define MACRO1(e,n) MERGE(x,n)
#include <rel/aux/macro1/ccod>
      )
     , x0);
   }
-----
cat >$OUT_DIR/rel/mapdom/is_in/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Set##_DOMAIN = + is_in 
  Tree##_DOMAIN = + mk
-----
[ -d $OUT_DIR/rel/mapdom/is_subrel ] || mkdir $OUT_DIR/rel/mapdom/is_subrel
cat >$OUT_DIR/rel/mapdom/is_subrel/gcod <<'-----'
_ALIAS_BDD(is_subset,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/is_subrel/vdm <<'-----'
_ADD_OP(Set##_DOMAIN,is_subset)
-----
[ -d $OUT_DIR/rel/mapdom/mk1 ] || mkdir $OUT_DIR/rel/mapdom/mk1
cat >$OUT_DIR/rel/mapdom/mk1/ccod <<'-----'
#define _OPNAME mk1
#define _DOMPAR
#define _DOMPAR1
#include <rel/aux/sigone/fhdr>
    { return mk1_set##_DOMAIN(mk_tree##_DOMAIN(
#define MACRO1(e,n) MERGE(x,n)
#include <rel/aux/macro1/ccod>
	));
    }
-----
cat >$OUT_DIR/rel/mapdom/mk1/vdm <<'-----'
DOMAINS IMPLEMENTATIONS
  Set##_DOMAIN = + mk1
  Tree##_DOMAIN = + mk

#define CONSTRNAME mk1
#define ADTNAME ADT_MAP
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/rel/mapdom/mk_empty ] || mkdir $OUT_DIR/rel/mapdom/mk_empty
cat >$OUT_DIR/rel/mapdom/mk_empty/gcod <<'-----'
  _ALIAS_DV(mk_empty,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/mk_empty/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,mk_empty)

#define CONSTRNAME mk_empty
#define ADTNAME ADT_REL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/rel/mapdom/sub1 ] || mkdir $OUT_DIR/rel/mapdom/sub1
cat >$OUT_DIR/rel/mapdom/sub1/gcod <<'-----'
#define _OPNAME sub1
#include <rel/aux/sigone/fhdr>
  { return sub1_set##_DOMAIN(x0,mk_tree##_DOMAIN(
#define MACRO1(e,n) MERGE(x,n)
#include <rel/aux/macro1/ccod>
    ));
  }
-----
cat >$OUT_DIR/rel/mapdom/sub1/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,sub1)
 _ADD_OP(Tree##_DOMAIN,mk)
-----
[ -d $OUT_DIR/rel/mapdom/sub1d ] || mkdir $OUT_DIR/rel/mapdom/sub1d
cat >$OUT_DIR/rel/mapdom/sub1d/gcod <<'-----'
#define _OPNAME sub1d
#include <rel/aux/sigone/fhdr>
  { return sub1d_set##_DOMAIN(x0,mk_tree##_DOMAIN(
#define MACRO1(e,n) MERGE(x,n)
#include <rel/aux/macro1/ccod>
    ));
  }
-----
cat >$OUT_DIR/rel/mapdom/sub1d/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,sub1d)
 _ADD_OP(Tree##_DOMAIN,mk)
-----
[ -d $OUT_DIR/rel/mapdom/union ] || mkdir $OUT_DIR/rel/mapdom/union
cat >$OUT_DIR/rel/mapdom/union/gcod <<'-----'
  _ALIAS_DDD(union,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/union/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,union)
-----
[ -d $OUT_DIR/rel/mapdom/union1 ] || mkdir $OUT_DIR/rel/mapdom/union1
cat >$OUT_DIR/rel/mapdom/union1/gcod <<'-----'
#define _OPNAME union1
#include <rel/aux/sigone/fhdr>
  { return union1_set##_DOMAIN(x0,mk_tree##_DOMAIN(
#define MACRO1(e,n) MERGE(x,n)
#include <rel/aux/macro1/ccod>
    ));
  }
-----
cat >$OUT_DIR/rel/mapdom/union1/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,union1)
 _ADD_OP(Tree##_DOMAIN,mk)
-----
[ -d $OUT_DIR/rel/mapdom/union1d ] || mkdir $OUT_DIR/rel/mapdom/union1d
cat >$OUT_DIR/rel/mapdom/union1d/ccod <<'-----'
#define _OPNAME union1d
#include <rel/aux/sigone/fhdr>
  { return union1d_set##_DOMAIN(x0,mk_tree##_DOMAIN(
#define MACRO1(e,n) MERGE(x,n)
#include <rel/aux/macro1/ccod>
    ));
  }
-----
cat >$OUT_DIR/rel/mapdom/union1d/gcod <<'-----'
#define _OPNAME union1d
#include <rel/aux/sigone/fhdr>
  { return union1d_set##_DOMAIN(x0,mk_tree##_DOMAIN(
#define MACRO1(e,n) MERGE(x,n)
#include <rel/aux/macro1/ccod>
    ));
  }
-----
cat >$OUT_DIR/rel/mapdom/union1d/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,union1d)
 _ADD_OP(Tree##_DOMAIN,mk)
-----
[ -d $OUT_DIR/rel/mapdom/uniond ] || mkdir $OUT_DIR/rel/mapdom/uniond
cat >$OUT_DIR/rel/mapdom/uniond/gcod <<'-----'
  _ALIAS_DDD(uniond,set##_DOMAIN)
-----
cat >$OUT_DIR/rel/mapdom/uniond/vdm <<'-----'
 _ADD_OP(Set##_DOMAIN,uniond)
-----
[ -d $OUT_DIR/rel/sign ] || mkdir $OUT_DIR/rel/sign
[ -d $OUT_DIR/rel/sign/all ] || mkdir $OUT_DIR/rel/sign/all
cat >$OUT_DIR/rel/sign/all/vsig <<'-----'
#include <aux/sign/all/vsig>
-----
[ -d $OUT_DIR/rel/sign/binary ] || mkdir $OUT_DIR/rel/sign/binary
cat >$OUT_DIR/rel/sign/binary/gsig <<'-----'
#include <aux/sign/binary/gsig>
-----
cat >$OUT_DIR/rel/sign/binary/vsig <<'-----'
  binary(x1) =
   let fct(y1,y2) = if y2 = {}
                    then y1
                    else let elem e y2 in
                      fct(x1(y1,e1,e2,...),y2 - {(e1,e2,...)})
   in fct
  TYPE : (Result  ELEM1 ELEM2 ... --> Result)
         -->
         (Result  DOMAIN --> Result)

  __EM(binary) is a functional (a function returning another function as result).
  With help of this functional functions on Result and ELEM1 ELEM2 ... can be
  generalized to functions of DOMAIN to Result.

  An important case is Result = DOMAIN. This leads to the examples
  described below. The general case is usefull for inventing conversions.

  binary is evaluated at module generation time.

  Example : Union of two binary relations.

  given the function :

     union1(y1,e1,e2) = y1 u {(e1,e2)}
     TYPE : DOMAIN ELEM1 ELEM2  -->  DOMAIN

  The union function can be constructed by:

     union(x1,x2) = binary(union1)(x1,x2)
     TYPE : DOMAIN  DOMAIN -->  DOMAIN

-----
[ -d $OUT_DIR/rel/sign/card ] || mkdir $OUT_DIR/rel/sign/card
cat >$OUT_DIR/rel/sign/card/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(card,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,card,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/card/gsig <<'-----'
  FUNCDEC(card##_DOMAIN,PL_1(DOMAIN),Nat0)
-----
cat >$OUT_DIR/rel/sign/card/vsig <<'-----'
  card(x1) = card x1
  TYPE : DOMAIN --> Nat0

  cardinality of the relation x1
-----
[ -d $OUT_DIR/rel/sign/dom ] || mkdir $OUT_DIR/rel/sign/dom
cat >$OUT_DIR/rel/sign/dom/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(dom,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,dom,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/dom/gsig <<'-----'
  FUNCDEC(dom##_DOMAIN,PL_1(DOMAIN),DOMAINSET)
-----
cat >$OUT_DIR/rel/sign/dom/vsig <<'-----'
  dom(x1) = {x | (x,y) IN x1}
  TYPE : DOMAIN  -->  DOMAINSET

  Compute the domain of a binary relation. The relation
  x1 is left unchanged.
  This applies for binary relations only.

  See also:
    __SA(ran).
-----
[ -d $OUT_DIR/rel/sign/domresby ] || mkdir $OUT_DIR/rel/sign/domresby
cat >$OUT_DIR/rel/sign/domresby/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(domresby,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,domresby,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/domresby/gsig <<'-----'
  FUNCDEC(domresby1##_DOMAIN,PL_2(DOMAIN,DOMAINSET),DOMAIN)
  _DEFINE domresby##_DOMAIN(x1,x2) domresby1##_DOMAIN(x2,x1)
-----
cat >$OUT_DIR/rel/sign/domresby/vsig <<'-----'
#ifndef _OPNAME
#define _OPNAME domresby
#define _NOT NOT
#endif

  _OPNAME(x1,x2) =  x1 <| x2 = {(a,b) IN x2 | a _NOT IN x1 }
  TYPE : DOMAINSET DOMAIN  -->  DOMAIN

  _OPNAME(x1,x2) computes the domain restriction of the
  binary relation x2 to a subset x1 of the domain of x2. This is a new
  relation consisting of all those pairs (a,b) IN x2 where 
  a is _NOT contained in x1.
  The elements are copied when added to the result, i.e. the
  relation x2 is not destroied.

  This operation apples for binary relations only!

  See also:
    __SA(ranresto), __SA(ranresby), __SA(domresto), __SA(domresby)
#undef _OPNAME
#undef _NOT
-----
[ -d $OUT_DIR/rel/sign/domresto ] || mkdir $OUT_DIR/rel/sign/domresto
cat >$OUT_DIR/rel/sign/domresto/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(domresto,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,domresto,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/domresto/gsig <<'-----'
  FUNCDEC(domresto1##_DOMAIN,PL_2(DOMAIN,DOMAINSET),DOMAIN)
  _DEFINE domresto##_DOMAIN(x1,x2) domresto1##_DOMAIN(x2,x1)
-----
cat >$OUT_DIR/rel/sign/domresto/vsig <<'-----'
#define _OPNAME domresto
#define _NOT
#include <rel/sign/domresby/vsig>
-----
[ -d $OUT_DIR/rel/sign/exist ] || mkdir $OUT_DIR/rel/sign/exist
cat >$OUT_DIR/rel/sign/exist/vsig <<'-----'
#include <aux/sign/exist/vsig>
-----
[ -d $OUT_DIR/rel/sign/exist1 ] || mkdir $OUT_DIR/rel/sign/exist1
cat >$OUT_DIR/rel/sign/exist1/gsig <<'-----'
#include <aux/sign/exist1/gsig>
-----
cat >$OUT_DIR/rel/sign/exist1/vsig <<'-----'
#include <aux/sign/exist1/vsig>
-----
[ -d $OUT_DIR/rel/sign/fold ] || mkdir $OUT_DIR/rel/sign/fold
cat >$OUT_DIR/rel/sign/fold/gsig <<'-----'
#include <aux/sign/fold/gsig>
-----
cat >$OUT_DIR/rel/sign/fold/vsig <<'-----'
  fold(x1,x2,x3)(y1,a1,...,an) =
   let fct(z1) = if z1 = {}
                 then x2
                 else let (e1,e2,..) e z1 in
                      x3(x1 (e1,e2,..,a1,..,ak)
                        ,fct(z1 - {(e1,e2,...)})
                        ,al,...,an
                        )
   in fct(y1)
  TYPE : (ELEM1 ELEM2 ... T1 ... Tk --> RESULT)
         (                          --> RESULT)
         (RESULT RESULT   Tl ... Tn --> RESULT)
         -->
         (DOMAIN          T1 ... Tn --> RESULT)

  __EM(fold) is a functional (a function returning another function as result).
  With help of this functional functions on the type DOMAIN can be defined
  by means of functions defined on the element type ELEM1 ELEM2 ...
  Fold returns a function from DOMAIN to RESULT.

  Usually, fold is partly evaluated at module generation time.
  The parameters a1 .. an are usefull to pass global information
  into the fold- or conversion functions. They are optional and
  can be generated in any combination.

  Example : Computation of the cardinality of a binary relation 

  Given the functions :

     one(e1,e2) = 1
     TYPE : ELEM1 ELEM2  -->  Nat0
     zero()  = 0
     TYPE :  --> Nat0
     plus(y1,y2) = y1 + y2
     TYPE : Nat0  Nat0  -->  Nat0

  the card function can be constructed by:

     card(x1) = fold(one,zero,plus)(x1)
     TYPE : DOMAIN  -->  Nat0

-----
[ -d $OUT_DIR/rel/sign/forall ] || mkdir $OUT_DIR/rel/sign/forall
cat >$OUT_DIR/rel/sign/forall/cpp.old <<'-----'
#ifndef DECL
class cv_forall##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
public:
  cv_forall##_DOMAIN(void (*x1) (Cpp_ELEM1))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
};
void (*cv_forall##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1)
InlineFriendFct(forall,PPAR2(T1,X2),void)
#ifndef DECL
{ cv_forall##_DOMAIN tmp(x2);
  forall##_DOMAIN(DATA, cv_forall##_DOMAIN::cv_1);
  tmp.reset();}
#else
;
#endif
#undef T1
#undef X2
-----
cat >$OUT_DIR/rel/sign/forall/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forall##_DOMAIN) P_OP
#include <rel/aux/macro1/ccod>
  P_CL ;
  extern void forall##_DOMAIN P_OP DOMAIN x1, T2_forall##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/rel/sign/forall/vsig <<'-----'
  forall(x1,x2) = for (e1,e2,...) in x1 do x2(e1,e2,...)
  TYPE : DOMAIN  (ELEM1 ELEM2 ...  -->  )  --> 

  For all elements in rel x1 procedure x2 is executed.
-----
[ -d $OUT_DIR/rel/sign/is_empty ] || mkdir $OUT_DIR/rel/sign/is_empty
cat >$OUT_DIR/rel/sign/is_empty/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(is_empty,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_empty,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/is_empty/gsig <<'-----'
  FUNCDEC(is_empty##_DOMAIN,PL_1(DOMAIN),Bool)
-----
cat >$OUT_DIR/rel/sign/is_empty/vsig <<'-----'
  is_empty(x1) = ( x1 = {} )
  TYPE : DOMAIN  -->  Bool

  Test on empty relation.
-----
[ -d $OUT_DIR/rel/sign/is_in ] || mkdir $OUT_DIR/rel/sign/is_in
cat >$OUT_DIR/rel/sign/is_in/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(is_in,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/is_in/gsig <<'-----'
#ifdef GEN_C
  extern Bool is_in##_DOMAIN P_OP
#include <rel/aux/macro1/ccod>
  , DOMAIN x0
  P_CL;
#endif
-----
cat >$OUT_DIR/rel/sign/is_in/vsig <<'-----'
  is_in(x1,x2,...,x0) = ( (x1,x2,...) IN x0 )
  TYPE : ELEM1 ELEM2 ... DOMAIN  -->  Bool

  Test if the tuple (x1,x2,...) is contained in the relation x0.
-----
[ -d $OUT_DIR/rel/sign/mk1 ] || mkdir $OUT_DIR/rel/sign/mk1
cat >$OUT_DIR/rel/sign/mk1/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk1,KPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/mk1/gsig <<'-----'
#define _OPNAME mk1
#define _DOMPAR
#include <rel/aux/sigone/gsig>
-----
cat >$OUT_DIR/rel/sign/mk1/vsig <<'-----'
  mk1(x1,x2,...) = {(x1,x2,...)}
  TYPE : ELEM1 ELEM2 ...  -->  DOMAIN

  Construction of a relation containing one tuple (x1,x2,...).
-----
[ -d $OUT_DIR/rel/sign/mk_empty ] || mkdir $OUT_DIR/rel/sign/mk_empty
cat >$OUT_DIR/rel/sign/mk_empty/cpp <<'-----'
#define T1 const Cpp_EMPTY &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk_empty,KPARLIST0))
#undef T1 
-----
cat >$OUT_DIR/rel/sign/mk_empty/gsig <<'-----'
  FUNCDEC(mk_empty##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/rel/sign/mk_empty/vsig <<'-----'
  mk_empty() = {}
  TYPE :  -->  DOMAIN

  Construction of the empty relation.
-----
[ -d $OUT_DIR/rel/sign/mk_product ] || mkdir $OUT_DIR/rel/sign/mk_product
cat >$OUT_DIR/rel/sign/mk_product/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(mk_product,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,mk_product,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/mk_product/gsig <<'-----'
  FUNCDEC(mk_product##_DOMAIN,PL_2(DOMAINSET,RANGESET),DOMAIN)
-----
cat >$OUT_DIR/rel/sign/mk_product/vsig <<'-----'
  mk_product(x1,x2) = x1 X x2 = {(x,y) | x IN x1 & y IN x2}
  TYPE: DOMAINSET RANGESET  --> DOMAIN

  Computation of the cartesian product of x1 and x2.
  x1 and x2 will be left undestroyed.

  This operation apples for binary operations only!
-----
[ -d $OUT_DIR/rel/sign/ran ] || mkdir $OUT_DIR/rel/sign/ran
cat >$OUT_DIR/rel/sign/ran/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(ran,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,ran,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/ran/gsig <<'-----'
  FUNCDEC(ran##_DOMAIN,PL_1(DOMAIN),RANGESET)
-----
cat >$OUT_DIR/rel/sign/ran/vsig <<'-----'
  ran(x1) = {y | (x,y) IN x1}
  TYPE : DOMAIN  -->  RANGESET

  Compute the range of a binary relation. The relation
  x1 is left unchanged.
  This applies for binary relations only.

  See also:
    __SA(dom).
-----
[ -d $OUT_DIR/rel/sign/ranresby ] || mkdir $OUT_DIR/rel/sign/ranresby
cat >$OUT_DIR/rel/sign/ranresby/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(ranresby,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,ranresby,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/ranresby/gsig <<'-----'
  FUNCDEC(ranresby##_DOMAIN,PL_2(DOMAIN,RANGESET),DOMAIN)
-----
cat >$OUT_DIR/rel/sign/ranresby/vsig <<'-----'
#ifndef _OPNAME
#define _OPNAME ranresby
#define _NOT NOT
#endif

  _OPNAME(x1,x2) =  x1 |> x2 = {(a,b) IN x1 | a _NOT IN x2 }
  TYPE : DOMAIN RANGESET  -->  DOMAIN

  _OPNAME(x1,x2) computes the range restriction of the
  binary relation x1 to a subset x1 of the domain of x2. This is a new
  relation consisting of all those pairs (a,b) IN x1 where 
  a is _NOT contained in x2.
  The elements are copied when added to the result, i.e. the
  relation x1 is not destroied.

  This operation apples for binary relations only!

  See also:
    __SA(ranresto), __SA(ranresby), __SA(domresto), __SA(domresby)
#undef _OPNAME
#undef _NOT
-----
[ -d $OUT_DIR/rel/sign/ranresto ] || mkdir $OUT_DIR/rel/sign/ranresto
cat >$OUT_DIR/rel/sign/ranresto/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(ranresto,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,ranresto,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/ranresto/gsig <<'-----'
  FUNCDEC(ranresto##_DOMAIN,PL_2(DOMAIN,RANGESET),DOMAIN)
-----
cat >$OUT_DIR/rel/sign/ranresto/vsig <<'-----'
#define _OPNAME ranresto
#define _NOT
#include <rel/sign/ranresby/vsig>
-----
[ -d $OUT_DIR/rel/sign/sel ] || mkdir $OUT_DIR/rel/sign/sel
cat >$OUT_DIR/rel/sign/sel/cpp <<'-----'
!!!
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(sel,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,sel,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/rel/sign/sel/gsig <<'-----'
  FUNCDEC(sel##_DOMAIN,PL_2(DOMAIN,DOMAINSET),RANGESET)
-----
cat >$OUT_DIR/rel/sign/sel/vsig <<'-----'
  sel(x1,x2) = {y IN RANGESET | (x,y) IN x1 & x IN x2}
  TYPE : DOMAINSET  -->  RANGESET

  The operation __EM(sel) computes the relational image
  of the set x1 under the relation x2.
  This applies for binary relations only.
-----
[ -d $OUT_DIR/rel/sign/sub1 ] || mkdir $OUT_DIR/rel/sign/sub1
cat >$OUT_DIR/rel/sign/sub1/cpp <<'-----'
!!!
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))
#ifdef OPERATOR
InlineFriendFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))
#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/rel/sign/sub1/gsig <<'-----'
#define _OPNAME sub1
#include <rel/aux/sigone/gsig>
-----
cat >$OUT_DIR/rel/sign/sub1/vsig <<'-----'
  sub1(x1,x2,x3,...) = x1 - {(x2,x3,...)}
  TYPE : DOMAIN ELEM1 ELEM2 ...  -->  DOMAIN

  The tuple (x2,x3,...) is removed from x1.
  x1 is destroyed.

  See also:
    __SA(sub1d), __SA(sub), __SA(subd).
-----
[ -d $OUT_DIR/rel/sign/sub1d ] || mkdir $OUT_DIR/rel/sign/sub1d
cat >$OUT_DIR/rel/sign/sub1d/cpp <<'-----'
!!!
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1d,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/rel/sign/sub1d/gsig <<'-----'
#define _OPNAME sub1d
#include <rel/aux/sigone/gsig>
-----
cat >$OUT_DIR/rel/sign/sub1d/vsig <<'-----'
  sub1(x1,x2,x3,...) = x1 - {(x2,x3,...)}
  TYPE : DOMAIN ELEM1 ELEM2 ...  -->  DOMAIN

  The tuple (x2,x3,...) is removed from x1. If removed, the
  tuple elements will be deleted by an implicit call of 'del'.
  x1 is destroyed.

  See also:
    __SA(sub1), __SA(sub), __SA(subd).
-----
[ -d $OUT_DIR/rel/sign/union ] || mkdir $OUT_DIR/rel/sign/union
cat >$OUT_DIR/rel/sign/union/cpp <<'-----'
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(plus,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))
#ifdef OPERATOR
InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))
#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/rel/sign/union/gsig <<'-----'
  FUNCDEC(union##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/rel/sign/union/vsig <<'-----'
  union(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  Union of x1 and x2.
  x1 and x2 are destroyed.
-----
[ -d $OUT_DIR/rel/sign/union1 ] || mkdir $OUT_DIR/rel/sign/union1
cat >$OUT_DIR/rel/sign/union1/cpp <<'-----'
!!!
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
InlineFriendFct(plus1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST2))
#ifdef OPERATOR
InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST2))
#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/rel/sign/union1/gsig <<'-----'
#define _OPNAME union1
#include <rel/aux/sigone/gsig>
-----
cat >$OUT_DIR/rel/sign/union1/vsig <<'-----'
  union1(x1,x2,x3...) = x1 u {(x2,x3,...)}
  TYPE : DOMAIN  ELEM1 ELEM2 ...  -->  DOMAIN

  The tuple (x2,x3,...) is inserted in x1.
  x1 is destroyed.

  See also:
    __SA(union1d), __SA(union).
-----
[ -d $OUT_DIR/rel/sign/union1d ] || mkdir $OUT_DIR/rel/sign/union1d
cat >$OUT_DIR/rel/sign/union1d/cpp <<'-----'
!!!
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
InlineFriendFct(plus1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1d,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/rel/sign/union1d/gsig <<'-----'
#define _OPNAME union1d
#include <rel/aux/sigone/gsig>
-----
cat >$OUT_DIR/rel/sign/union1d/vsig <<'-----'
  union1(x1,x2,x3...) = x1 u {(x2,x3,...)}
  TYPE : DOMAIN  ELEM1 ELEM2 ...  -->  DOMAIN

  The tuple (x2,x3,...) is inserted in x1.
  If (x2,x3,...) is not needed in x1 an implicit call of 
  del(x2), sel(x3),... is performed
  x1 is destroyed.

  See also:
    __SA(union1), __SA(union).
-----
[ -d $OUT_DIR/rel/sign/uniond ] || mkdir $OUT_DIR/rel/sign/uniond
cat >$OUT_DIR/rel/sign/uniond/cpp <<'-----'
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(plusd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(uniond,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/rel/sign/uniond/gsig <<'-----'
  FUNCDEC(uniond##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/rel/sign/uniond/vsig <<'-----'
  uniond(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  Union of x1 and x2
  For tuples contained in both relations and if they are not
  needed implicit calls of del are performed.
  x1 and x2 are destroyed.
-----
[ -d $OUT_DIR/set ] || mkdir $OUT_DIR/set
[ -d $OUT_DIR/set/automem ] || mkdir $OUT_DIR/set/automem
[ -d $OUT_DIR/set/automem/all ] || mkdir $OUT_DIR/set/automem/all
cat >$OUT_DIR/set/automem/all/vdm <<'-----'
! === automem: Operation set/all not supported === !
-----
[ -d $OUT_DIR/set/automem/basic ] || mkdir $OUT_DIR/set/automem/basic
cat >$OUT_DIR/set/automem/basic/ccod <<'-----'
#include <aux/automem/basic/ccod>
-----
cat >$OUT_DIR/set/automem/basic/docu <<'-----'
#define TYPGEN set
#include <aux/automem/basic/docu>
-----
cat >$OUT_DIR/set/automem/basic/gptr <<'-----'
#include <aux/automem/basic/gptr>
-----
cat >$OUT_DIR/set/automem/basic/gtyp <<'-----'
#include <aux/automem/basic/gtyp>
-----
cat >$OUT_DIR/set/automem/basic/param <<'-----'
BASEIMPL
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
NOCHECK
-----
cat >$OUT_DIR/set/automem/basic/vdm <<'-----'
#define REP_DOMAIN  ELEM1 -set
#include <aux/automem/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/automem/card ] || mkdir $OUT_DIR/set/automem/card
cat >$OUT_DIR/set/automem/card/ccod <<'-----'
#define NAME   card
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/card/cmcr <<'-----'
#define NAME  card
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/card/vdm <<'-----'
#define NAME card
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/copy ] || mkdir $OUT_DIR/set/automem/copy
cat >$OUT_DIR/set/automem/copy/ccod <<'-----'
#include <aux/automem/copy/ccod>
-----
[ -d $OUT_DIR/set/automem/copy1 ] || mkdir $OUT_DIR/set/automem/copy1
cat >$OUT_DIR/set/automem/copy1/vdm <<'-----'
! === automem: Operation set/copy1 not supported === !
-----
[ -d $OUT_DIR/set/automem/cvfromtup1 ] || mkdir $OUT_DIR/set/automem/cvfromtup1
cat >$OUT_DIR/set/automem/cvfromtup1/ccod <<'-----'
#include <aux/automem/cvfromtup1/ccod>
-----
cat >$OUT_DIR/set/automem/cvfromtup1/param <<'-----'
#include <aux/automem/cvfromtup1/param>
-----
cat >$OUT_DIR/set/automem/cvfromtup1/vdm <<'-----'
#include <aux/automem/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/set/automem/cvfromtupl ] || mkdir $OUT_DIR/set/automem/cvfromtupl
cat >$OUT_DIR/set/automem/cvfromtupl/ccod <<'-----'
#include <aux/automem/cvfromtupl/ccod>
-----
cat >$OUT_DIR/set/automem/cvfromtupl/param <<'-----'
#include <aux/automem/cvfromtupl/param>
-----
cat >$OUT_DIR/set/automem/cvfromtupl/vdm <<'-----'
#include <aux/automem/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/set/automem/cvlines ] || mkdir $OUT_DIR/set/automem/cvlines
cat >$OUT_DIR/set/automem/cvlines/ccod <<'-----'
#define NAME cvlines
#define RESULT Cvtext_vdmlib
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/cvlines/cmcr <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/cvlines/vdm <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/cvtotup1 ] || mkdir $OUT_DIR/set/automem/cvtotup1
cat >$OUT_DIR/set/automem/cvtotup1/ccod <<'-----'
#include <aux/automem/cvtotup1/ccod>
-----
cat >$OUT_DIR/set/automem/cvtotup1/param <<'-----'
#include <aux/automem/cvtotup1/param>
-----
cat >$OUT_DIR/set/automem/cvtotup1/vdm <<'-----'
#include <aux/automem/cvtotup1/vdm>
-----
[ -d $OUT_DIR/set/automem/cvtotupl ] || mkdir $OUT_DIR/set/automem/cvtotupl
cat >$OUT_DIR/set/automem/cvtotupl/ccod <<'-----'
#include <aux/automem/cvtotupl/ccod>
-----
cat >$OUT_DIR/set/automem/cvtotupl/param <<'-----'
#include <aux/automem/cvtotupl/param>
-----
cat >$OUT_DIR/set/automem/cvtotupl/vdm <<'-----'
#include <aux/automem/cvtotupl/vdm>
-----
[ -d $OUT_DIR/set/automem/del ] || mkdir $OUT_DIR/set/automem/del
cat >$OUT_DIR/set/automem/del/ccod <<'-----'
#include <aux/automem/del/ccod>
-----
cat >$OUT_DIR/set/automem/del/vdm <<'-----'
#include <aux/automem/del/vdm>
-----
[ -d $OUT_DIR/set/automem/del1 ] || mkdir $OUT_DIR/set/automem/del1
cat >$OUT_DIR/set/automem/del1/vdm <<'-----'
! === automem: Operation set/del1 not required === !
-----
[ -d $OUT_DIR/set/automem/diff ] || mkdir $OUT_DIR/set/automem/diff
cat >$OUT_DIR/set/automem/diff/ccod <<'-----'
#define NAME diff
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/set/automem/diff/vdm <<'-----'
#define NAME diff
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/set/automem/diffd ] || mkdir $OUT_DIR/set/automem/diffd
cat >$OUT_DIR/set/automem/diffd/vdm <<'-----'
! === automem: Operation set/diffd not supported === !
-----
[ -d $OUT_DIR/set/automem/exist ] || mkdir $OUT_DIR/set/automem/exist
cat >$OUT_DIR/set/automem/exist/vdm <<'-----'
! === automem: Operation set/exist not supported === !
-----
[ -d $OUT_DIR/set/automem/exist1 ] || mkdir $OUT_DIR/set/automem/exist1
cat >$OUT_DIR/set/automem/exist1/vdm <<'-----'
! === automem: Operation set/exist1 not supported === !
-----
[ -d $OUT_DIR/set/automem/fold ] || mkdir $OUT_DIR/set/automem/fold
cat >$OUT_DIR/set/automem/fold/vdm <<'-----'
! === automem: Operation set/fold not supported === !
-----
[ -d $OUT_DIR/set/automem/forall ] || mkdir $OUT_DIR/set/automem/forall
cat >$OUT_DIR/set/automem/forall/ccod <<'-----'
#include <aux/automem/forall/ccod>
-----
cat >$OUT_DIR/set/automem/forall/cmcr <<'-----'
#include <aux/automem/forall/cmcr>
-----
cat >$OUT_DIR/set/automem/forall/vdm <<'-----'
#include <aux/automem/forall/vdm>
-----
[ -d $OUT_DIR/set/automem/forsome ] || mkdir $OUT_DIR/set/automem/forsome
cat >$OUT_DIR/set/automem/forsome/vdm <<'-----'
! === automem: Operation set/forsome not supported === !
-----
[ -d $OUT_DIR/set/automem/gcinfo ] || mkdir $OUT_DIR/set/automem/gcinfo
cat >$OUT_DIR/set/automem/gcinfo/ccod <<'-----'
#include <aux/automem/gcinfo/ccod>
-----
cat >$OUT_DIR/set/automem/gcinfo/docu <<'-----'
#include <aux/automem/gcinfo/docu>
-----
cat >$OUT_DIR/set/automem/gcinfo/vdm <<'-----'
#include <aux/automem/gcinfo/vdm>
-----
[ -d $OUT_DIR/set/automem/hash ] || mkdir $OUT_DIR/set/automem/hash
cat >$OUT_DIR/set/automem/hash/ccod <<'-----'
#define NAME hash
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/hash/cmcr <<'-----'
#define NAME hash
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/hash/vdm <<'-----'
#define NAME hash
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/input ] || mkdir $OUT_DIR/set/automem/input
cat >$OUT_DIR/set/automem/input/vdm <<'-----'
! === automem: Operation set/input not supported === !
-----
[ -d $OUT_DIR/set/automem/inters ] || mkdir $OUT_DIR/set/automem/inters
cat >$OUT_DIR/set/automem/inters/ccod <<'-----'
#define NAME inters
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/set/automem/inters/vdm <<'-----'
#define NAME inters
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/set/automem/intersd ] || mkdir $OUT_DIR/set/automem/intersd
cat >$OUT_DIR/set/automem/intersd/vdm <<'-----'
! === automem: Operation set/intersd not supported === !
-----
[ -d $OUT_DIR/set/automem/is_empty ] || mkdir $OUT_DIR/set/automem/is_empty
cat >$OUT_DIR/set/automem/is_empty/ccod <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/is_empty/cmcr <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/is_empty/vdm <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/is_eq ] || mkdir $OUT_DIR/set/automem/is_eq
cat >$OUT_DIR/set/automem/is_eq/ccod <<'-----'
#define NAME is_eq
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/is_eq/cmcr <<'-----'
#define NAME is_eq
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/is_eq/vdm <<'-----'
#define NAME is_eq
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/is_ge ] || mkdir $OUT_DIR/set/automem/is_ge
cat >$OUT_DIR/set/automem/is_ge/vdm <<'-----'
! === automem: Operation set/is_ge not supported === !
-----
[ -d $OUT_DIR/set/automem/is_gr ] || mkdir $OUT_DIR/set/automem/is_gr
cat >$OUT_DIR/set/automem/is_gr/vdm <<'-----'
! === automem: Operation set/is_gr not supported === !
-----
[ -d $OUT_DIR/set/automem/is_in ] || mkdir $OUT_DIR/set/automem/is_in
cat >$OUT_DIR/set/automem/is_in/ccod <<'-----'
#define NAME is_in
#define PTYPE1 ELEM1
#define P1_IS_ELEM
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/is_in/cmcr <<'-----'
#define NAME is_in
#define TWO_PARAM
#define P1_IS_ELEM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/is_in/vdm <<'-----'
#define NAME is_in
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/is_subset ] || mkdir $OUT_DIR/set/automem/is_subset
cat >$OUT_DIR/set/automem/is_subset/ccod <<'-----'
#define NAME is_subset
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/is_subset/cmcr <<'-----'
#define NAME is_subset
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/is_subset/vdm <<'-----'
#define NAME is_subset
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/iterator ] || mkdir $OUT_DIR/set/automem/iterator
cat >$OUT_DIR/set/automem/iterator/vdm <<'-----'
#include <aux/automem/iterator/vdm>
DOMAINS
IMPLEMENTATIONS
  Rep##_DOMAIN = + iterator("INTERNALFCT")
-----
[ -d $OUT_DIR/set/automem/max ] || mkdir $OUT_DIR/set/automem/max
cat >$OUT_DIR/set/automem/max/ccod <<'-----'
#define NAME   max
#define RESULT ELEM1
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/max/cmcr <<'-----'
#define NAME  max
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/max/vdm <<'-----'
#define NAME max
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/min ] || mkdir $OUT_DIR/set/automem/min
cat >$OUT_DIR/set/automem/min/ccod <<'-----'
#define NAME   min
#define RESULT ELEM1
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/set/automem/min/cmcr <<'-----'
#define NAME  min
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/set/automem/min/vdm <<'-----'
#define NAME min
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/set/automem/mk1 ] || mkdir $OUT_DIR/set/automem/mk1
cat >$OUT_DIR/set/automem/mk1/ccod <<'-----'
#define NAME mk1
#define P1_INSERTED
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/set/automem/mk1/vdm <<'-----'
#define NAME mk1
#define P1_INSERTED
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk1
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/automem/mk_empty ] || mkdir $OUT_DIR/set/automem/mk_empty
cat >$OUT_DIR/set/automem/mk_empty/ccod <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/set/automem/mk_empty/vdm <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk_empty
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/automem/parse ] || mkdir $OUT_DIR/set/automem/parse
cat >$OUT_DIR/set/automem/parse/ccod <<'-----'
#include <aux/automem/parse/ccod>
-----
cat >$OUT_DIR/set/automem/parse/vdm <<'-----'
#include <aux/automem/parse/vdm>
-----
[ -d $OUT_DIR/set/automem/pr ] || mkdir $OUT_DIR/set/automem/pr
cat >$OUT_DIR/set/automem/pr/vdm <<'-----'
! === automem: Operation set/pr not supported === !
-----
[ -d $OUT_DIR/set/automem/sel ] || mkdir $OUT_DIR/set/automem/sel
cat >$OUT_DIR/set/automem/sel/ccod <<'-----'
#define NAME sel
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/set/automem/sel/cmcr <<'-----'
#define NAME sel
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/set/automem/sel/vdm <<'-----'
#define NAME sel
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/set/automem/sort ] || mkdir $OUT_DIR/set/automem/sort
cat >$OUT_DIR/set/automem/sort/ccod <<'-----'
#include <aux/automem/sort/ccod>
-----
cat >$OUT_DIR/set/automem/sort/param <<'-----'
#include <aux/automem/sort/param>
-----
cat >$OUT_DIR/set/automem/sort/vdm <<'-----'
#include <aux/automem/sort/vdm>
-----
[ -d $OUT_DIR/set/automem/sub1 ] || mkdir $OUT_DIR/set/automem/sub1
cat >$OUT_DIR/set/automem/sub1/ccod <<'-----'
#define NAME sub1
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/set/automem/sub1/vdm <<'-----'
#define NAME sub1
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/set/automem/sub1d ] || mkdir $OUT_DIR/set/automem/sub1d
cat >$OUT_DIR/set/automem/sub1d/vdm <<'-----'
! === automem: Operation set/sub1d not supported === !
-----
[ -d $OUT_DIR/set/automem/union ] || mkdir $OUT_DIR/set/automem/union
cat >$OUT_DIR/set/automem/union/ccod <<'-----'
#define NAME union
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>
-----
cat >$OUT_DIR/set/automem/union/vdm <<'-----'
#define NAME union
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/set/automem/union1 ] || mkdir $OUT_DIR/set/automem/union1
cat >$OUT_DIR/set/automem/union1/ccod <<'-----'
#define NAME union1
#define P2_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/set/automem/union1/vdm <<'-----'
#define NAME union1
#define P2_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/set/automem/union1d ] || mkdir $OUT_DIR/set/automem/union1d
cat >$OUT_DIR/set/automem/union1d/vdm <<'-----'
! === automem: Operation set/union1d not supported === !
-----
[ -d $OUT_DIR/set/automem/uniond ] || mkdir $OUT_DIR/set/automem/uniond
cat >$OUT_DIR/set/automem/uniond/vdm <<'-----'
! === automem: Operation set/uniond not supported === !
-----
[ -d $OUT_DIR/set/bitmap ] || mkdir $OUT_DIR/set/bitmap
[ -d $OUT_DIR/set/bitmap/basic ] || mkdir $OUT_DIR/set/bitmap/basic
cat >$OUT_DIR/set/bitmap/basic/defp <<'-----'
#undef LB1
#ifdef LB 
#define LB1 LB
#else
#define LB1 0
#endif

#undef NOELEMS1
#ifdef NOELEMS
#define NOELEMS1 NOELEMS
#else
  DOMAIN: the implementation parameter NOELEMS must be specified
#endif

#undef BASESIZE1
#ifdef BASESIZE
#define BASESIZE1 BASESIZE
#else
#define BASESIZE1 4
#endif

#undef BASETYPE
#if (BASESIZE1 == 1)
#define BASETYPE CHARACTER
#else
#if (BASESIZE1 == 4)
#define BASETYPE long int
#endif
#endif

#undef NFDBITS
#define NFDBITS (8 * BASESIZE1)
#undef UB 
#define UB ((NFDBITS * NOELEMS1) + LB1 - 1)

#undef BYTEINDEX 
#define BYTEINDEX(n) (((n) - LB1) / NFDBITS)
#undef BITINDEX
#define BITINDEX(n) (((n) - LB1) % NFDBITS)

#undef RANGE_ASSERT
#define RANGE_ASSERT(x) if (((x) < LB1) || ((x) > UB)) err_maxlen_vdmlib(MKSTRING(DOMAIN));


-----
cat >$OUT_DIR/set/bitmap/basic/docu <<'-----'
 Implementation of ELEM1 -set where ELEM1 is a scalar type and the
 sets only cover a relatively small range. It is implemented as a
 pointer to an array of integers with bits set/cleared for each
 scalar value.
 Most of the set operation work in constant time.
 The size of the sets is fixed at generation time.
 
 Parameters:
 ===========
   "LB"
                fist set element (default value = 0)
   "NOELEMS"
                \# of array elements
   "BASESIZE"
                size of array elements (1,4 default: 4)

 Space requirements: "NOELEMS" * "BASESIZE" Bytes
-----
cat >$OUT_DIR/set/bitmap/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/set/bitmap/basic/gptr <<'-----'
   TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/set/bitmap/basic/gtyp <<'-----'
#include <set/bitmap/basic/defp>

   START_RECORD_TYP(Struct##_DOMAIN)
#ifdef GEN_C
     BASETYPE f_bits[NOELEMS1];
#else
     RECFIELD(f_bits,ARRAY[0 .. NOELEMS1] OF BASETYPE);
#endif
   END_RECORD_TYP(Struct##_DOMAIN)

#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
cat >$OUT_DIR/set/bitmap/basic/param <<'-----'
ALLOC
AUTOMEM
BASESIZE
FORWARD_ALLOWED
INTERNALDOMAIN
LB
MACROS
NOELEMS
-----
cat >$OUT_DIR/set/bitmap/basic/vdm <<'-----'
#include <aux/com/heap/vdm>
  DOMAINS
  IMPLEMENTATIONS
    Vdmlib = + err_maxlen
#undef ALLOC

#define CONSTRNAME mk_basic
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/bitmap/copy ] || mkdir $OUT_DIR/set/bitmap/copy
cat >$OUT_DIR/set/bitmap/copy/ccod <<'-----'
#include <set/bitmap/basic/defp>

#ifndef fct
#define fct copy
#endif

  DOMAIN fct##_DOMAIN _FPH1(DOMAIN)
    { DOMAIN lx1 = alloc##_DOMAIN();
      Nat0 lx2;
      for (lx2 = 0; lx2 < NOELEMS1; lx2++) {lx1 -> f_bits[lx2] = ref##_DOMAIN(x1) -> f_bits[lx2];}
      return lx1;
    }

#undef fct
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB

-----
cat >$OUT_DIR/set/bitmap/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib = + header("MEMORY")
-----
[ -d $OUT_DIR/set/bitmap/copy1 ] || mkdir $OUT_DIR/set/bitmap/copy1
cat >$OUT_DIR/set/bitmap/copy1/ccod <<'-----'
#define fct copy1
#include <set/bitmap/copy/ccod>
-----
cat >$OUT_DIR/set/bitmap/copy1/vdm <<'-----'
#include <set/bitmap/copy/vdm>
-----
[ -d $OUT_DIR/set/bitmap/del ] || mkdir $OUT_DIR/set/bitmap/del
cat >$OUT_DIR/set/bitmap/del/ccod <<'-----'
   void del##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(x1);}
-----
cat >$OUT_DIR/set/bitmap/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1) free##_DOMAIN(x1)
-----
cat >$OUT_DIR/set/bitmap/del/pmcr <<'-----'
_DEFINE del##_DOMAIN(x1) free##_DOMAIN(x1)
-----
[ -d $OUT_DIR/set/bitmap/del1 ] || mkdir $OUT_DIR/set/bitmap/del1
cat >$OUT_DIR/set/bitmap/del1/ccod <<'-----'
   void del1##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(x1);}
-----
cat >$OUT_DIR/set/bitmap/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) free##_DOMAIN(x1)
-----
cat >$OUT_DIR/set/bitmap/del1/pmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) free##_DOMAIN(x1)
-----
[ -d $OUT_DIR/set/bitmap/forall ] || mkdir $OUT_DIR/set/bitmap/forall
cat >$OUT_DIR/set/bitmap/forall/ccod <<'-----'
#include <set/bitmap/basic/defp>
  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
    { ELEM1 lx1;
      for (lx1 = LB1; lx1 <= UB; lx1++)
	{ if (is_in##_DOMAIN(lx1,x1)) (*x2)(lx1); }
    }
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
cat >$OUT_DIR/set/bitmap/forall/cmcr <<'-----'
#include <set/bitmap/basic/defp>
_DEFINE forall##_DOMAIN(x1,x2) { DOMAIN lx0 = x1; ELEM1 lx1; for (lx1 = LB1; lx1 <= UB; lx1++){ if is_in##_DOMAIN(lx1,lx0) x2(lx1); }}
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
cat >$OUT_DIR/set/bitmap/forall/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + is_in
-----
[ -d $OUT_DIR/set/bitmap/is_empty ] || mkdir $OUT_DIR/set/bitmap/is_empty
cat >$OUT_DIR/set/bitmap/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN)
    { Nat0 lx1;
      for (lx1 = 0; lx1 < NOELEMS1; lx1++)
	{ if (ref##_DOMAIN(x1) -> f_bits[lx1]) return 0; }
      return 1;
    }
-----
[ -d $OUT_DIR/set/bitmap/is_in ] || mkdir $OUT_DIR/set/bitmap/is_in
cat >$OUT_DIR/set/bitmap/is_in/ccod <<'-----'
#include <set/bitmap/basic/defp>
  Bool is_in##_DOMAIN _FPH2(ELEM1,DOMAIN)
    { RANGE_ASSERT(x1)
      return (((ref##_DOMAIN(x2)) -> f_bits[BYTEINDEX(x1)] & (1 << BITINDEX(x1))) != 0);
    }
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
cat >$OUT_DIR/set/bitmap/is_in/cmcr <<'-----'
#include <set/bitmap/basic/defp>
_DEFINE is_in##_DOMAIN(x1,x2) (((ref##_DOMAIN(x2)) -> f_bits[BYTEINDEX(x1)] & (1 << BITINDEX(x1))) != 0)
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
[ -d $OUT_DIR/set/bitmap/iterator ] || mkdir $OUT_DIR/set/bitmap/iterator
cat >$OUT_DIR/set/bitmap/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/set/bitmap/iterator/vdm <<'-----'
#include <set/bitmap/basic/defp>
#define PARAM "LB"=LB1,"NOELEMS"=NOELEMS1,"BASESIZE"=BASESIZE1
#define IMPL bitmap
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/set/bitmap/mk_empty ] || mkdir $OUT_DIR/set/bitmap/mk_empty
cat >$OUT_DIR/set/bitmap/mk_empty/ccod <<'-----'
#include <set/bitmap/basic/defp>
  DOMAIN mk_empty##_DOMAIN _FPH0()
    { DOMAIN lx1 = alloc##_DOMAIN();
      Nat0 lx2;
      for (lx2 = 0; lx2 < NOELEMS1; lx2++)
	  { lx1 -> f_bits[lx2] = (BASETYPE)0; }
      return lx1;
    }
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
cat >$OUT_DIR/set/bitmap/mk_empty/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Vdmlib = + header("MEMORY")

#define CONSTRNAME mk_empty
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/bitmap/sel ] || mkdir $OUT_DIR/set/bitmap/sel
cat >$OUT_DIR/set/bitmap/sel/ccod <<'-----'
#include <set/bitmap/basic/defp>
  ELEM1 sel##_DOMAIN _FPH1(DOMAIN)
   { ELEM1 lx1;
     for (lx1 = LB1; lx1 <= UB; lx1++)
	 { if (is_in##_DOMAIN(lx1,x1)) return lx1;}
    err_elem_vdmlib(MKSTRING(DOMAIN));
   }
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
cat >$OUT_DIR/set/bitmap/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_in
   Vdmlib   = + err_elem
-----
[ -d $OUT_DIR/set/bitmap/sub1 ] || mkdir $OUT_DIR/set/bitmap/sub1
cat >$OUT_DIR/set/bitmap/sub1/ccod <<'-----'
#include <set/bitmap/basic/defp>
  DOMAIN sub1##_DOMAIN _FPH2(DOMAIN,ELEM1)
    { RANGE_ASSERT(x2)
      ref##_DOMAIN(x1) -> f_bits[BYTEINDEX(x2)] &= ~(1 << BITINDEX(x2));
      return x1;
    }
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
[ -d $OUT_DIR/set/bitmap/sub1d ] || mkdir $OUT_DIR/set/bitmap/sub1d
cat >$OUT_DIR/set/bitmap/sub1d/ccod <<'-----'
  DOMAIN sub1d##_DOMAIN _FPH2(DOMAIN,ELEM1)
    {return sub1##_DOMAIN(x1,x2);}
-----
cat >$OUT_DIR/set/bitmap/sub1d/cmcr <<'-----'
_DEFINE sub1d##_DOMAIN(x1,x2) sub1##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/set/bitmap/sub1d/pmcr <<'-----'
_DEFINE sub1d##_DOMAIN(x1,x2) sub1##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/set/bitmap/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN = + sub1
-----
[ -d $OUT_DIR/set/bitmap/union1 ] || mkdir $OUT_DIR/set/bitmap/union1
cat >$OUT_DIR/set/bitmap/union1/ccod <<'-----'
#include <set/bitmap/basic/defp>
  DOMAIN union1##_DOMAIN _FPH2(DOMAIN,ELEM1)
    { RANGE_ASSERT(x2)
      ref##_DOMAIN(x1) -> f_bits[BYTEINDEX(x2)] |= (1 << BITINDEX(x2));
      return x1;
    }
#undef BASESIZE1
#undef BASETYPE
#undef BITINDEX
#undef BYTEINDEX
#undef LB1
#undef NFDBITS
#undef RANGE_ASSERT
#undef UB
-----
[ -d $OUT_DIR/set/bitmap/union1d ] || mkdir $OUT_DIR/set/bitmap/union1d
cat >$OUT_DIR/set/bitmap/union1d/ccod <<'-----'
  DOMAIN union1d##_DOMAIN _FPH2(DOMAIN,ELEM1)
    {return union1##_DOMAIN(x1,x2);}
-----
cat >$OUT_DIR/set/bitmap/union1d/cmcr <<'-----'
_DEFINE union1d##_DOMAIN(x1,x2) union1##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/set/bitmap/union1d/pmcr <<'-----'
_DEFINE union1d##_DOMAIN(x1,x2) union1##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/set/bitmap/union1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + union1
-----
[ -d $OUT_DIR/set/com ] || mkdir $OUT_DIR/set/com
[ -d $OUT_DIR/set/com/all ] || mkdir $OUT_DIR/set/com/all
cat >$OUT_DIR/set/com/all/docu <<'-----'
#include <aux/com/all/docu>
-----
cat >$OUT_DIR/set/com/all/vdm <<'-----'
#include <aux/com/all/vdm>
-----
[ -d $OUT_DIR/set/com/basic ] || mkdir $OUT_DIR/set/com/basic
cat >$OUT_DIR/set/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/set/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = Elem -set

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + mk_empty
   + mk1

   + card

   + copy1
   + copy
   + union1
   + union1d
   + sub1
   + sub1d
   + union
   + uniond
   + diff
   + diffd
   + inters
   + intersd
   + sel

   + is_eq
   + is_empty
   + is_in
   + is_subset

   + forall
   + forsome

   + binary.bf(RESULT=Bool,FOLDFCT="bfoldf",NOFOLDENR)
   + fold.ff(RESULT=Bool,NULLFCT="fnullf",CVFCT="fcvf",FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)
   + fold.ff1(RESULT=Bool,NULLPARAM,CVFCTVAR,FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput
   + all + exist + exist1

-----
cat >$OUT_DIR/set/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Elem = BASIC -set

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + mk_empty
   + mk1

   + union1d

   + is_eq

-----
cat >$OUT_DIR/set/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbdele>

#define nilset MERGE(mk_empty,_domain)()

#define oneset(elem) MERGE(mk1,_domain)(elem)

Domain bigset()
{ return
   @( union1d##_domain( 
   @)  nilset 
   @( ,@X@) 
   @)
  ;
}

/*------------------------------------------------------------------------------------------------*/

int bignum()

{  Domain bighelp = bigset();
   int i = 0;
@( if( is_in##_domain( E_ @X@, bighelp ) )
   { ++i;
     bighelp = sub1d##_domain( bighelp, E_ @X@ );
   }
@) /* HMH EE */
   del##_domain(bighelp);
   return( i );
}

/*================================================================================================*/

int glob = -1;
Domain glob_set;

/*------------------------------------------------------------------------------------------------*/

void clear_glob ()

{ if (glob != -1) del1##_domain(glob_set);
  glob = 0;
  glob_set = nilset;
}

/*------------------------------------------------------------------------------------------------*/

void for_test _FPH1(Elem)
{ ++glob;
  glob_set = union1##_domain( glob_set, x1 );
}

/*------------------------------------------------------------------------------------------------*/

Bool forsome_test _FPH1(Elem)
{ Elem e_array[1];
  int Ei = 0;
  Bool r = is_eq##_elem( x1, E_ @Y@ );
  EE
  return r;
}

/*================================================================================================*/

Bool bfoldf##_domain _FPH2(Bool,Elem)
{ Domain bighelp;
  Bool r;
  bighelp = bigset();
  r = x1 && is_in##_domain( x2, bighelp );
  del##_domain(bighelp);
  return r;
}

/*================================================================================================*/

Bool fnullf_bool ()

{ return TRUE;
}

/*------------------------------------------------------------------------------------------------*/

Bool fcvf##_elem ( elem, vx, vxx, vxxx, vy, vyy, vyyy )

  Elem elem;
  Elem vx,vy; BASIC vxx,vyy; Bool vxxx,vyyy;

{ 
  Domain d_array[9];
  int Di = 0;
  Elem e_array[9];
  int Ei = 0;
  Bool r = is_in##_domain( elem, D_ bigset() ) &&
           is_eq##_elem( vx, E_ @Z@ ) &&
           vxx == ccc &&
           vxxx &&
           is_eq##_elem( vy, E_ @Y@ ) &&
           vyy == bbb &&
           ! vyyy ;
/*- HMH  DD EE */
  return r;
}

/*------------------------------------------------------------------------------------------------*/

Bool ffoldf_bool ( result1, result2, vy, vyy, vyyy, vz, vzz, vzzz )

  Bool result1, result2;
  Elem vy,vz; BASIC vyy,vzz; Bool vyyy,vzzz;

{ 
  Domain d_array[9];
  int Di = 0;
  Elem e_array[9];
  int Ei = 0;
  Bool r = result1 && 
           result2 && 
           is_in##_domain( vz, D_ bigset() ) &&
           vzz == aaa  &&
           vzzz &&
           is_eq##_elem( vy, E_ @Y@ ) &&
           vyy == bbb && 
           !vyyy;
/*- HMH  DD EE */
  return r;
}

#include <aux/com/basic/bbid2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ nilset ) )
       myerr(@n@,"mk_empty()","");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ oneset(@X@) ), E_ @X@ ) )
       myerr(@n@,"mk1()","@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if( card##_domain( D_ nilset ) != 0 )
       myerr(@n@,"card()","{}");
   DD }

   void p_@N@()
   {
@(   if( card##_domain( D_ oneset(@X@) ) != 1 )
       myerr(@n@,"card()","{@X@}");
@) DD }

   void p_@N@()
   { if( card##_domain( D_ bigset() ) != bignum() )
       myerr(@n@,"card()","BIGSET");
   DD }

/*================================================================================================*/

#define ARG nilset
#define TEXT {}
#include <aux/com/copy1/bbc2>

#define ARG oneset(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG bigset()
#include <aux/com/copy1/bbc2>

#define ARG nilset
#define TEXT {}
#include <aux/com/copy/bbc2>

#define ARG oneset(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/copy/bbc2>

#define ARG bigset()
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1##_domain( nilset, @X@ ), D_ oneset(@X@) ) )
       myerr(@n@,"union1()","{},@X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ union1##_domain( oneset(@Y@), @X@ ) ) )
       myerr(@n@,"union1() /1","{@Y@},@X@");
     if(! is_in##_domain( E_ @Y@, D_ union1##_domain( oneset(@Y@), @X@ ) ) )
       myerr(@n@,"union1() /2","{@Y@},@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1##_domain( oneset(@X@), @X@ ), D_ oneset(@X@) ) )
       myerr(@n@,"union1()","{@X@},@X@");
@) DD }

   void p_@N@()
   { if(! is_in##_domain( E_ @Y@, D_ union1##_domain( bigset(), @Y@ ) ) )
       myerr(@n@,"union1() /1","BIGSET,@Y@");
     if(! is_subset##_domain( D_ bigset(), D_ union1##_domain( bigset(), @Y@ ) ) )
       myerr(@n@,"union1() /2","BIGSET,@Y@");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1##_domain( bigset(), @X@ ), D_ bigset() ) )
       myerr(@n@,"union1()","BIGSET,@X@");
@) DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1d##_domain( nilset, @X@ ), D_ oneset(@X@) ) )
       myerr(@n@,"union1d()","{},@X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ union1d##_domain( oneset(@Y@), @X@ ) ) )
       myerr(@n@,"union1d() /1","{@Y@},@X@");
     if(! is_in##_domain( E_ @Y@, D_ union1d##_domain( oneset(@Y@), @X@ ) ) )
       myerr(@n@,"union1d() /2","{@Y@},@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1d##_domain( oneset(@X@), @X@ ), D_ oneset(@X@) ) )
       myerr(@n@,"union1d()","{@X@},@X@");
@) DD }

   void p_@N@()
   { if(! is_in##_domain( E_ @Y@, D_ union1d##_domain( bigset(), @Y@ ) ) )
       myerr(@n@,"union1d() /1","BIGSET,@Y@");
     if(! is_subset##_domain( D_ bigset(), D_ union1d##_domain( bigset(), @Y@ ) ) )
       myerr(@n@,"union1d() /2","BIGSET,@Y@");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union1d##_domain( bigset(), @X@ ), D_ bigset() ) )
       myerr(@n@,"union1d()","BIGSET,@X@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1##_domain( nilset, E_ @X@ ) ) )
       myerr(@n@,"sub1()","{},@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub1##_domain( oneset(@Y@), E_ @X@ ), D_ oneset(@Y@) ) )
       myerr(@n@,"sub1()","{@Y@},@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1##_domain( oneset(@X@), E_ @X@ ) ) )
       myerr(@n@,"sub1()","{@X@},@X@");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub1##_domain( bigset(), E_ @Y@ ), D_ bigset() ) )
       myerr(@n@,"sub1()","BIGSET,@Y@");
   DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ sub1##_domain( bigset(), E_ @X@ ) ) )
       myerr(@n@,"sub1()","BIGSET,@X@");
@) DD EE }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1d##_domain( nilset, E_ @X@ ) ) )
       myerr(@n@,"sub1d()","{},@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub1d##_domain( oneset(@Y@), E_ @X@ ), D_ oneset(@Y@) ) )
       myerr(@n@,"sub1d()","{@Y@},@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub1d##_domain( oneset(@X@), E_ @X@ ) ) )
       myerr(@n@,"sub1d()","{@X@},@X@");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub1d##_domain( bigset(), E_ @Y@ ), D_ bigset() ) )
       myerr(@n@,"sub1d()","BIGSET,@Y@");
   DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ sub1d##_domain( bigset(), E_ @X@ ) ) )
       myerr(@n@,"sub1d()","BIGSET,@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ union##_domain( nilset, nilset ) ) )
       myerr(@n@,"union()","{},{}");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( nilset, oneset(@X@) ), D_ oneset(@X@) ) )
       myerr(@n@,"union()","{},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ union##_domain( nilset, bigset() ), D_ bigset() ) )
       myerr(@n@,"union()","{},BIGSET");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( oneset(@X@), nilset ), D_ oneset(@X@) ) )
       myerr(@n@,"union()","{@X@},{}");
@) DD }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @Y@, D_ union##_domain( oneset(@Y@), oneset(@X@) ) ) )
       myerr(@n@,"union() /1","{@Y@},{@X@}");
     if(! is_in##_domain( E_ @X@, D_ union##_domain( oneset(@Y@), oneset(@X@) ) ) )
       myerr(@n@,"union() /2","{@Y@},{@X@}");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( oneset(@X@), oneset(@X@) ),
                          D_ oneset(@X@) ) )
       myerr(@n@,"union()","{@X@},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_in##_domain( E_ @Y@, D_ union##_domain( oneset(@Y@), bigset() ) ) )
       myerr(@n@,"union() /1","{@Y@},BIGSET");
     if(! is_subset##_domain( D_ bigset(), D_ union##_domain( oneset(@Y@), bigset() ) ) )
       myerr(@n@,"union() /2","{@Y@},BIGSET");
   DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( oneset(@X@), bigset() ), D_ bigset() ) )
       myerr(@n@,"union()","{@X@},BIGSET");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ union##_domain( bigset(), nilset ), D_ bigset() ) )
       myerr(@n@,"union()","BIGSET,{}");
   DD }

   void p_@N@()
   { if(! is_subset##_domain( D_ bigset(), D_ union##_domain( bigset(), oneset(@Y@) ) ) )
       myerr(@n@,"union() /1","BIGSET,{@Y@}");
     if(! is_in##_domain( E_ @Y@, D_ union##_domain( bigset(), oneset(@Y@) ) ) )
       myerr(@n@,"union() /2","BIGSET,{@Y@}");
   DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ union##_domain( bigset(), oneset(@X@) ), D_ bigset() ) )
       myerr(@n@,"union()","BIGSET,{@X@}");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ union##_domain( bigset(), bigset() ), D_ bigset() ) )
       myerr(@n@,"union()","BIGSET,BIGSET");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_empty##_domain( D_ uniond##_domain( nilset, nilset ) ) )
       myerr(@n@,"uniond()","{},{}");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( nilset, oneset(@X@) ), D_ oneset(@X@) ) )
       myerr(@n@,"uniond()","{},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ uniond##_domain( nilset, bigset() ), D_ bigset() ) )
       myerr(@n@,"uniond()","{},BIGSET");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( oneset(@X@), nilset ), D_ oneset(@X@) ) )
       myerr(@n@,"uniond()","{@X@},{}");
@) DD }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @Y@, D_ uniond##_domain( oneset(@Y@), oneset(@X@) ) ) )
       myerr(@n@,"uniond() /1","{@Y@},{@X@}");
     if(! is_in##_domain( E_ @X@, D_ uniond##_domain( oneset(@Y@), oneset(@X@) ) ) )
       myerr(@n@,"uniond() /2","{@Y@},{@X@}");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( oneset(@X@), oneset(@X@) ),
                          D_ oneset(@X@) ) )
       myerr(@n@,"uniond()","{@X@},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_in##_domain( E_ @Y@, D_ uniond##_domain( oneset(@Y@), bigset() ) ) )
       myerr(@n@,"uniond() /1","{@Y@},BIGSET");
     if(! is_subset##_domain( D_ bigset(), D_ uniond##_domain( oneset(@Y@), bigset() ) ) )
       myerr(@n@,"uniond() /2","{@Y@},BIGSET");
   DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( oneset(@X@), bigset() ), D_ bigset() ) )
       myerr(@n@,"uniond()","{@X@},BIGSET");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ uniond##_domain( bigset(), nilset ), D_ bigset() ) )
       myerr(@n@,"uniond()","BIGSET,{}");
   DD }

   void p_@N@()
   { if(! is_subset##_domain( D_ bigset(), D_ uniond##_domain( bigset(), oneset(@Y@) ) ) )
       myerr(@n@,"uniond() /1","BIGSET,{@Y@}");
     if(! is_in##_domain( E_ @Y@, D_ uniond##_domain( bigset(), oneset(@Y@) ) ) )
       myerr(@n@,"uniond() /2","BIGSET,{@Y@}");
   DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ uniond##_domain( bigset(), oneset(@X@) ), D_ bigset() ) )
       myerr(@n@,"uniond()","BIGSET,{@X@}");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ uniond##_domain( bigset(), bigset() ), D_ bigset() ) )
       myerr(@n@,"uniond()","BIGSET,BIGSET");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ diff##_domain( nilset, D_ nilset ) ) )
       myerr(@n@,"diff()","{},{}");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ diff##_domain( nilset, D_ oneset(@X@) ) ) )
       myerr(@n@,"diff()","{},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ diff##_domain( nilset, D_ bigset() ) ) )
       myerr(@n@,"diff()","{},BIGSET");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ diff##_domain( oneset(@X@), D_ nilset ), D_ oneset(@X@) ) )
       myerr(@n@,"diff()","{@X@},{}");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ diff##_domain( oneset(@Y@), D_ oneset(@X@) ),
                          D_ oneset(@Y@) ) )
       myerr(@n@,"diff()","{@Y@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ diff##_domain( oneset(E_ @X@), D_ oneset(@X@) ) ) )
       myerr(@n@,"diff()","{@X@},{@X@}");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ diff##_domain( oneset(E_ @X@), D_ bigset() ) ) )
       myerr(@n@,"diff()","{@X@},BIGSET");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ diff##_domain( bigset(), D_ nilset ), D_ bigset() ) )
       myerr(@n@,"diff()","BIGSET,{}");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ diff##_domain( bigset(), D_ oneset(@Y@) ), D_ bigset() ) )
       myerr(@n@,"diff()","BIGSET,{@Y@}");
   DD }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ diff##_domain( bigset(), D_ oneset(@X@) ) ) )
       myerr(@n@,"diff()","BIGSET,{@X@}");
@) DD EE }

   void p_@N@()
   { if(! is_empty##_domain( D_ diff##_domain( bigset(), D_ bigset() ) ) )
       myerr(@n@,"diff()","BIGSET,BIGSET");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_empty##_domain( D_ diffd##_domain( nilset, D_ nilset ) ) )
       myerr(@n@,"diffd()","{},{}");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ diffd##_domain( nilset, D_ oneset(@X@) ) ) )
       myerr(@n@,"diffd()","{},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ diffd##_domain( nilset, D_ bigset() ) ) )
       myerr(@n@,"diffd()","{},BIGSET");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ diffd##_domain( oneset(@X@), D_ nilset ), D_ oneset(@X@) ) )
       myerr(@n@,"diffd()","{@X@},{}");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ diffd##_domain( oneset(@Y@), D_ oneset(@X@) ),
                          D_ oneset(@Y@) ) )
       myerr(@n@,"diffd()","{@Y@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ diffd##_domain( oneset(@X@), D_ oneset(@X@) ) ) )
       myerr(@n@,"diffd()","{@X@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ diffd##_domain( oneset(@X@), D_ bigset() ) ) )
       myerr(@n@,"diffd()","{@X@},BIGSET");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ diffd##_domain( bigset(), D_ nilset ), D_ bigset() ) )
       myerr(@n@,"diffd()","BIGSET,{}");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ diffd##_domain( bigset(), D_ oneset(@Y@) ), D_ bigset() ) )
       myerr(@n@,"diffd()","BIGSET,{@Y@}");
   DD }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ diffd##_domain( bigset(), D_ oneset(@X@) ) ) )
       myerr(@n@,"diffd()","BIGSET,{@X@}");
@) DD EE }

   void p_@N@()
   { if(! is_empty##_domain( D_ diffd##_domain( bigset(), D_ bigset() ) ) )
       myerr(@n@,"diffd()","BIGSET,BIGSET");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( nilset, nilset ) ) )
       myerr(@n@,"inters()","{},{}");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( nilset, oneset(E_ @X@) ) ) )
       myerr(@n@,"inters()","{},{@X@}");
@) DD EE }

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( nilset, bigset() ) ) )
       myerr(@n@,"inters()","{},BIGSET");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( oneset(E_ @X@), nilset ) ) )
       myerr(@n@,"inters()","{@X@},{}");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ inters##_domain( oneset(E_ @Y@), oneset(E_ @X@) ) ) )
       myerr(@n@,"inters()","{@Y@},{@X@}");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ inters##_domain( oneset(@X@), oneset(@X@) ),
                          D_ oneset(@X@) ) )
       myerr(@n@,"inters()","{@X@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ inters##_domain( oneset(@X@), bigset() ), D_ oneset(@X@) ) )
       myerr(@n@,"inters()","{@X@},BIGSET");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( bigset(), nilset ) ) )
       myerr(@n@,"inters()","BIGSET,{}");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ inters##_domain( bigset(), oneset(E_ @Y@) ) ) )
       myerr(@n@,"inters()","BIGSET,{@X@}");
   DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ inters##_domain( bigset(), oneset(@X@) ), D_ oneset(@X@) ) )
       myerr(@n@,"inters()","BIGSET,{@X@}");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ inters##_domain( bigset(), bigset() ), D_ bigset() ) )
       myerr(@n@,"inters()","BIGSET,BIGSET");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( nilset, nilset ) ) )
       myerr(@n@,"intersd()","{},{}");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( nilset, oneset(@X@) ) ) )
       myerr(@n@,"intersd()","{},{@X@}");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( nilset, bigset() ) ) )
       myerr(@n@,"intersd()","{},BIGSET");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( oneset(@X@), nilset ) ) )
       myerr(@n@,"intersd()","{@X@},{}");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ intersd##_domain( oneset(@Y@), oneset(@X@) ) ) )
       myerr(@n@,"intersd()","{@Y@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ intersd##_domain( oneset(@X@), oneset(@X@) ),
                          D_ oneset(@X@) ) )
       myerr(@n@,"intersd()","{@X@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ intersd##_domain( oneset(@X@), bigset() ), D_ oneset(@X@) ) )
       myerr(@n@,"intersd()","{@X@},BIGSET");
@) DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( bigset(), nilset ) ) )
       myerr(@n@,"intersd()","BIGSET,{}");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ intersd##_domain( bigset(), oneset(@Y@) ) ) )
       myerr(@n@,"intersd()","BIGSET,{@X@}");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ intersd##_domain( bigset(), oneset(@X@) ), D_ oneset(@X@) ) )
       myerr(@n@,"intersd()","BIGSET,{@X@}");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ intersd##_domain( bigset(), bigset() ), D_ bigset() ) )
       myerr(@n@,"intersd()","BIGSET,BIGSET");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ oneset(@X@) ), E_ @X@ ) )
       myerr(@n@,"sel()","{@X@}");
@) DD EE }

   void p_@N@()
   { Domain bighelp = bigset();
     Elem elem;
     int i = bignum();
     while(i--)
     { if(! is_in##_domain( ( elem = sel##_domain( bighelp ) ), bighelp ) )
         myerr(@n@,"sel() /1","BIGSET");
       bighelp = sub1d##_domain( bighelp, elem );
     }
     if(! is_empty##_domain( bighelp ) )
       myerr(@n@,"sel() /2","BIGSET");
     del##_domain(bighelp);
   }

/*================================================================================================*/

#define ARG nilset
#define TEXT {},{}
#include <aux/com/is_eq/bbc2>

#define ARG nilset
#define ARG2 oneset(@X@)
#define TEXT {},{@X@}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG nilset
#define ARG2 bigset()
#define NEG
#define TEXT {},ARG2
#include <aux/com/is_eq/bbc2>

#define ARG oneset(@X@)
#define ARG2 nilset
#define TEXT {@X@},{}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG oneset(@Y@)
#define ARG2 oneset(@X@)
#define TEXT {@Y@},{@X@}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG oneset(@X@)
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG oneset(@X@)
#define ARG2 bigset()
#define TEXT {@X@},ARG2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigset()
#define ARG2 nilset
#define TEXT ARG,{}
#define NEG
#include <aux/com/is_eq/bbc2>

#define ARG bigset()
#define ARG2 oneset(@X@)
#define TEXT ARG,{@X@}
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigset()
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ nilset ) )
       myerr(@n@,"is_empty()","{}");
   DD }

   void p_@N@()
   {
@(   if( is_empty##_domain( D_ oneset(@X@) ) )
       myerr(@n@,"is_empty()","{@X@}");
@) DD }

   void p_@N@()
   { if( is_empty##_domain( D_ bigset() ) )
       myerr(@n@,"is_empty()","BIGSET");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ nilset ) )
       myerr(@n@,"is_in()","@X@,{}");
@( DD EE }

   void p_@N@()
   {
@(   if( is_in##_domain( E_ @X@, D_ oneset(@Y@) ) )
       myerr(@n@,"is_in()","@X@,{@Y@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ oneset(@X@) ) )
       myerr(@n@,"is_in()","@X@,{@X@}");
@) DD EE }

   void p_@N@()
   { if( is_in##_domain( E_ @Y@, D_ bigset() ) )
       myerr(@n@,"is_in()","@Y@,BIGSET");
   DD EE }

   void p_@N@()
   {
@(   if(! is_in##_domain( E_ @X@, D_ bigset() ) )
       myerr(@n@,"is_in()","@X@,BIGSET");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if(! is_subset##_domain( D_ nilset, D_ nilset ) )
       myerr(@n@,"is_subset()","{},{}");
   DD }

   void p_@N@()
   {
@(   if( is_subset##_domain( D_ oneset(@X@), D_ nilset ) )
       myerr(@n@,"is_subset()","{@X@},{}");
@) DD }

   void p_@N@()
   { if( is_subset##_domain( D_ bigset(), D_ nilset ) )
       myerr(@n@,"is_subset()","BIGSET,{}");
   DD }

   void p_@N@()
   {
@(   if(! is_subset##_domain( D_ nilset, D_ oneset(@X@) ) )
       myerr(@n@,"is_subset()","{},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if( is_subset##_domain( D_ oneset(@X@), D_ oneset(@Y@) ) )
       myerr(@n@,"is_subset()","{@X@},{@Y@}");
@) DD }

   void p_@N@()
   {
@(   if(! is_subset##_domain( D_ oneset(@X@), D_ oneset(@X@) ) )
       myerr(@n@,"is_subset()","{@X@},{@X@}");
@) DD }

   void p_@N@()
   {
@(   if( is_subset##_domain( D_ bigset(), D_ oneset(@X@) ) )
       myerr(@n@,"is_subset()","BIGSET,{@X@}");
@) DD }

   void p_@N@()
   { if(! is_subset##_domain( D_ nilset, D_ bigset() ) )
       myerr(@n@,"is_subset()","{},BIGSET");
   DD }

   void p_@N@()
   { if( is_subset##_domain( D_ oneset(@Y@), D_ bigset() ) )
       myerr(@n@,"is_subset()","{@Y@},BIGSET");
   DD }

   void p_@N@()
   {
@(   if(! is_subset##_domain( D_ oneset(@X@), D_ bigset() ) )
       myerr(@n@,"is_subset()","{@X@},BIGSET");
@) DD }

   void p_@N@()
   { if(! is_subset##_domain( D_ bigset(), D_ bigset() ) )
       myerr(@n@,"is_subset()","BIGSET,BIGSET");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ nilset, for_test );
     if( glob != 0 )
       myerr(@n@,"forall()","{}");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forall##_domain( D_ oneset(@X@), for_test );
     if( glob != 1 ) 
       myerr(@n@,"forall() /1","{@X@}");
     if(! is_eq##_domain( glob_set, D_ oneset(@X@) ) )
       myerr(@n@,"forall() /2","{@X@}");
@) DD }

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ bigset(), for_test );
       if( glob != bignum() )
         myerr(@n@,"forall() /1","BIGSET");
       if(! is_eq##_domain( glob_set, D_ bigset() ) )
         myerr(@n@,"forall() /2","BIGSET");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ nilset, forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","{}");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forsome##_domain( D_ oneset(@X@), forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","{@X@}");
@) DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ oneset(@Y@), forsome_test, for_test );
     if( glob != 1 )
       myerr(@n@,"forsome() /1","{@Y@}");
     if(! is_eq##_domain( glob_set, D_ oneset(@Y@) ) )
       myerr(@n@,"forsome() /2","{@Y@}");
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ bigset(), forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","BIGSET");
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ union1d##_domain( bigset(), @Y@ ), forsome_test, for_test );
     if( glob != 1 )
       myerr(@n@,"forsome() /1","BIGSET+@Y@");
     if(! is_eq##_domain( glob_set, D_ oneset(@Y@) ) )
       myerr(@n@,"forsome() /2","BIGSET+@Y@");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if( bf##_domain( TRUE, D_ nilset ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","{}");
   DD }

   void p_@N@()
   {
@(   if( bf##_domain( TRUE, D_ oneset( @X@) ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","{@X@}");
@) DD }

   void p_@N@()
   { if( bf##_domain( TRUE, D_ bigset() ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","BIGSET");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( ff##_domain( D_ nilset, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","{},@X@,aaa,@Y@,bbb,@Z@,ccc");
     if( ff1##_domain( D_ nilset,TRUE,fcvf##_elem, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"fold-Funktional ff1()","{},@X@,aaa,@Y@,bbb,@Z@,ccc");
@) DD EE }

   void p_@N@()
   {
@(   if( ff##_domain( D_ oneset(@X@), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE )
         != TRUE )
       myerr(@n@,"fold-Funktional ff()","{@X@},@Z@,ccc,@Y@,bbb,@X@,aaa");
     if( ff1##_domain( D_ oneset(@X@),TRUE,fcvf##_elem, E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE )
         != TRUE )
       myerr(@n@,"fold-Funktional ff1()","{@X@},@Z@,ccc,@Y@,bbb,@X@,aaa");
@) DD EE }

   void p_@N@()
   {
@(   if( ff##_domain( D_ bigset(), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","BIGSET,@Z@,ccc,@Y@,bbb,@X@,aaa");
     if( ff1##_domain( D_ bigset(),TRUE,fcvf##_elem, E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"fold-Funktional ff1()","BIGSET,@Z@,ccc,@Y@,bbb,@X@,aaa");
@) DD EE }

/*================================================================================================*/

#define ARG nilset
#define TEXT {}
#include <aux/com/cvtotupl/bbc2>

#define ARG oneset(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/cvtotupl/bbc2>

#define ARG bigset()
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG nilset
#define TEXT {}
#include <aux/com/hash/bbc2>

#define ARG oneset(@X@)
#define TEXT {@X@}
#define REPEAT
#include <aux/com/hash/bbc2>

#define ARG bigset()
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG nilset
#include <aux/com/del1/bbc2>

#define ARG oneset(@X@)
#define REPEAT
#include <aux/com/del1/bbc2>

#define ARG bigset()
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG nilset
#include <aux/com/del/bbc2>

#define ARG oneset(@X@)
#define REPEAT
#include <aux/com/del/bbc2>

#define ARG bigset()
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG nilset
#include <aux/com/print/bbc2>

#define ARG oneset(@X@)
#define REPEAT
#include <aux/com/print/bbc2>

#define ARG bigset()
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG nilset
#include <aux/com/pr/bbc2>

#define ARG oneset(@X@)
#define REPEAT
#include <aux/com/pr/bbc2>

#define ARG bigset()
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG nilset
#include <aux/com/fpr/bbc2>

#define ARG oneset(@X@)
#define REPEAT
#include <aux/com/fpr/bbc2>

#define ARG bigset()
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/set/com/basic/bbd1 <<'-----'
@X@=
mk_empty##_elem()
mk1##_elem(xxx)
mk1##_elem(yyy)
mk1##_elem(zzz)
union1d##_elem(union1d##_elem(mk1##_elem(xxx),yyy),zzz)

@Y@=
mk1##_elem(ppp)

@Z@=
mk1##_elem(qqq)
-----
cat >$OUT_DIR/set/com/basic/docu <<'-----'
Syntax:

   Aset = Element -set

ISO Syntax ( -N option ):

   Aset = set of Element

Description:

  '-set' (ISO: set of <type> )
  defines the domain of all finite subsets of a given type

Example :

  A  set  of  classes  is  given,  each  class  consiting  of a set of
  students.  Let students be abstracted by their  school  registration
  code. Let  the domain of all such codes be Student. Then :

      Class = Student -set

  or in equivalent ISO syntax

      Class = set of Student

  is  an  abstract syntax rule whose left-hand side is an 'identifier'
  and whose right-hand side is a 'domain expression'. It  describes  a
  class  as being a set of (distinct) students. The equation gives the
  name 'Class' to a domain, and this domain is  defined  by 
  'Student- set', to be the domain of finite subsets of 'Student'.


-----
[ -d $OUT_DIR/set/com/binary ] || mkdir $OUT_DIR/set/com/binary
cat >$OUT_DIR/set/com/binary/ccod <<'-----'
#include <aux/com/binary/ccod>
-----
cat >$OUT_DIR/set/com/binary/docu <<'-----'
#define set
#include <aux/com/binary/docu>
-----
cat >$OUT_DIR/set/com/binary/param <<'-----'
DELETE
FCTNAME
FOLDEXT
FOLDFCT
NOFOLDENR
NOSIGNATURE
RESULT
-----
cat >$OUT_DIR/set/com/binary/vdm <<'-----'
#include <aux/com/binary/vdm>
-----
[ -d $OUT_DIR/set/com/card ] || mkdir $OUT_DIR/set/com/card
cat >$OUT_DIR/set/com/card/docu <<'-----'
  Common implementation of 'card' built upon 'fold'.
-----
cat >$OUT_DIR/set/com/card/gtyp <<'-----'
_DEFINE const1##_ELEM1(x1) 1
-----
cat >$OUT_DIR/set/com/card/vdm <<'-----'
#ifndef GEN_CPLUS
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + fold.card( "RESULT" = Nat0
			, "NULLFCT" = null
			, "CVFCT" = const1
			, "FOLDFCT" = plus
			, "NOSIGNATURE"
			)
    Nat0   = + null + plus
#endif
-----
[ -d $OUT_DIR/set/com/copy ] || mkdir $OUT_DIR/set/com/copy
cat >$OUT_DIR/set/com/copy/ccod <<'-----'
#if SIMPLEELEMS
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
   {return copy1##_DOMAIN(x1);}
#else
#define fct copy
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define incr r1 = MERGE(union1,_DOMAIN)(r1,MERGE(copy,_ELEM1)(y1));
#include <aux/com/for/ccod>
#endif
-----
cat >$OUT_DIR/set/com/copy/docu <<'-----'
  general implementation of copy

  copy(x1) = {copy(i) | i e x1>

  time complexity : O(n) * O(copy(ELEM1))
-----
cat >$OUT_DIR/set/com/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if SIMPLEELEMS
   DOMAIN   =  + copy1
#else
   DOMAIN   =  + forall + mk_empty
   ELEM1    =  + copy
#endif
-----
[ -d $OUT_DIR/set/com/copy1 ] || mkdir $OUT_DIR/set/com/copy1
cat >$OUT_DIR/set/com/copy1/ccod <<'-----'
#define fct copy1
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define incr r1 = MERGE(union1,_DOMAIN)(r1,y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/set/com/copy1/docu <<'-----'
  general implementation of copy1 by constructing a new set

  copy1(x1) = { i | i e x1 }

  time complexity : O(n) * O(union1)
-----
cat >$OUT_DIR/set/com/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall + mk_empty + union1
-----
[ -d $OUT_DIR/set/com/cvfromtup1 ] || mkdir $OUT_DIR/set/com/cvfromtup1
cat >$OUT_DIR/set/com/cvfromtup1/ccod <<'-----'
#define __ADDELEM union1
#include <aux/com/cvfromtup1/ccod>
-----
cat >$OUT_DIR/set/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/set/com/cvfromtup1/vdm <<'-----'
#define __ADDELEM union1
#include <aux/com/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/set/com/cvlines ] || mkdir $OUT_DIR/set/com/cvlines
cat >$OUT_DIR/set/com/cvlines/ccod <<'-----'
#define IS_EMPTY(x1) MERGE(is_empty,_DOMAIN)(x1)
#define START_STR "{"
#define END_STR "}"
#include <aux/com/cvlines/ccod>
#undef IS_EMPTY
#undef START_STR
#undef END_STR
-----
cat >$OUT_DIR/set/com/cvlines/docu <<'-----'
#include <aux/com/cvlines/docu>
-----
cat >$OUT_DIR/set/com/cvlines/gtyp <<'-----'
#ifdef GEN_C
_DEFINE cvlines2##_DOMAIN(x1,x2) cvlines2_vdmlib(x1,x2)
#endif
-----
cat >$OUT_DIR/set/com/cvlines/param <<'-----'
SUPRESS
-----
cat >$OUT_DIR/set/com/cvlines/vdm <<'-----'
DOMAINS  
IMPLEMENTATIONS
  Str            =  + mkc
  DOMAIN         =  + is_empty
                    + fold.cvlines1( "NULLFCT" = "mk_empty"
                                   , "CVFCT"   = "cvlines"
                                   , "FOLDFCT" = "cvlines2"
                                   , "RESULT"  = "Cvtext_vdmlib")
  ELEM1          =  + cvlines
  Vdmlib         =  + cvtext + header("STRING")
-----
[ -d $OUT_DIR/set/com/cvtotup1 ] || mkdir $OUT_DIR/set/com/cvtotup1
cat >$OUT_DIR/set/com/cvtotup1/ccod <<'-----'
#define __NOELEMS card
#include <aux/com/cvtotup1/ccod>
-----
cat >$OUT_DIR/set/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/set/com/cvtotup1/vdm <<'-----'
#define __NOELEMS card
#include <aux/com/cvtotup1/vdm>
-----
[ -d $OUT_DIR/set/com/default ] || mkdir $OUT_DIR/set/com/default
cat >$OUT_DIR/set/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the set datatype the following set of operations is
  added

#include <set/com/default/vdm>
-----
cat >$OUT_DIR/set/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + mk1
                                       ! constructors !
             + is_empty + is_in
                                       ! predicates !
             + card
                                       ! attributes !
             + union1 + sub1
                                       ! combinators with elements !
             + union + diff + inters 
                                       ! combinators with sets !
             + iterator
                                       ! iterator functions !
             + copy1 + del1
                                       ! duplicate and destroy values !
-----
[ -d $OUT_DIR/set/com/del ] || mkdir $OUT_DIR/set/com/del
cat >$OUT_DIR/set/com/del/ccod <<'-----'
#include <aux/com/del/ccod>
-----
cat >$OUT_DIR/set/com/del/docu <<'-----'
  general implementation of del via forall and del1

  time complexity : O(n) * O(del1(ELEM1))
-----
cat >$OUT_DIR/set/com/del/vdm <<'-----'
#include <aux/com/del/vdm>
-----
[ -d $OUT_DIR/set/com/diff ] || mkdir $OUT_DIR/set/com/diff
cat >$OUT_DIR/set/com/diff/docu <<'-----'
  general implementation of diff with sub1

  time complexity : O(n) * O(sub1)
-----
cat >$OUT_DIR/set/com/diff/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.diff("FOLDFCT"="sub1",NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/set/com/diffd ] || mkdir $OUT_DIR/set/com/diffd
cat >$OUT_DIR/set/com/diffd/docu <<'-----'
  general implementation of diffd with sub1d

  time complexity : O(n) * O(sub1d)
-----
cat >$OUT_DIR/set/com/diffd/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.diffd("FOLDFCT"="sub1d",NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/set/com/exist ] || mkdir $OUT_DIR/set/com/exist
cat >$OUT_DIR/set/com/exist/docu <<'-----'
#include <aux/com/exist/docu>
-----
cat >$OUT_DIR/set/com/exist/vdm <<'-----'
#include <aux/com/exist/vdm>
-----
[ -d $OUT_DIR/set/com/exist1 ] || mkdir $OUT_DIR/set/com/exist1
cat >$OUT_DIR/set/com/exist1/docu <<'-----'
#include <aux/com/exist1/docu>
-----
cat >$OUT_DIR/set/com/exist1/gcod <<'-----'
#include <aux/com/exist1/gcod>
-----
cat >$OUT_DIR/set/com/exist1/gtyp <<'-----'
#include <aux/com/exist1/gtyp>
-----
cat >$OUT_DIR/set/com/exist1/vdm <<'-----'
#include <aux/com/exist1/vdm>
-----
[ -d $OUT_DIR/set/com/fold ] || mkdir $OUT_DIR/set/com/fold
cat >$OUT_DIR/set/com/fold/ccod <<'-----'
#include <aux/com/fold/ccod>
-----
cat >$OUT_DIR/set/com/fold/docu <<'-----'
#define Set set
  Implementation of the 'fold' functional using the 'forall' routine
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/set/com/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/set/com/fold/vdm <<'-----'
#include <aux/com/fold/vdm>
-----
[ -d $OUT_DIR/set/com/forsome ] || mkdir $OUT_DIR/set/com/forsome
cat >$OUT_DIR/set/com/forsome/ccod <<'-----'
#define fct forsome
#define tx2 MERGE(T2_forsome,_DOMAIN)
#define tx3 MERGE(T3_forsome,_DOMAIN)
#define incr if ((*t2)(y1)) (*t3)(y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/set/com/forsome/docu <<'-----'
  general implementation of forsome by forall

  time complexity : O(forall) + O(filter predicate)
-----
cat >$OUT_DIR/set/com/forsome/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
-----
[ -d $OUT_DIR/set/com/hash ] || mkdir $OUT_DIR/set/com/hash
cat >$OUT_DIR/set/com/hash/ccod <<'-----'
#define fct hash
#define result Nat0
#define inires 0
#define incr r1 += MERGE(hash,_ELEM1)(y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/set/com/hash/docu <<'-----'
  general implementation of hash for sets
  as hash the sum of the hashvalues of the elements is taken

  time complexity : O(n) * O(hash(ELEM1))
-----
cat >$OUT_DIR/set/com/hash/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall
   ELEM1    =  + hash
-----
[ -d $OUT_DIR/set/com/inters ] || mkdir $OUT_DIR/set/com/inters
cat >$OUT_DIR/set/com/inters/ccod <<'-----'
#define fct inters
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 DOMAIN
#define incr if (MERGE(is_in,_DOMAIN)(y1,t2)) r1 = MERGE(union1,_DOMAIN)(r1,y1);
#define resfin MERGE(del1,_DOMAIN)(x1);MERGE(del1,_DOMAIN)(x2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/set/com/inters/docu <<'-----'
  general implementation of inters with is_in and union1

  time complexity : O(n) * max{ O(is_in), O(union1) }
-----
cat >$OUT_DIR/set/com/inters/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + is_in + union1 + forall + del1
-----
[ -d $OUT_DIR/set/com/intersd ] || mkdir $OUT_DIR/set/com/intersd
cat >$OUT_DIR/set/com/intersd/ccod <<'-----'
#define fct intersd
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 DOMAIN
#define incr if (MERGE(is_in,_DOMAIN)(y1,t2)) r1 = MERGE(union1,_DOMAIN)(r1,y1); else MERGE(del,_ELEM1)(y1);
#define resfin MERGE(del1,_DOMAIN)(x1);MERGE(del,_DOMAIN)(x2);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/set/com/intersd/docu <<'-----'
  general implementation of intersd with is_in and union1

  time complexity : O(n) * max{ O(is_in), O(union1) }
-----
cat >$OUT_DIR/set/com/intersd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + is_in + union1 + forall + del1 + del
   ELEM1    = + del
-----
[ -d $OUT_DIR/set/com/is_empty ] || mkdir $OUT_DIR/set/com/is_empty
cat >$OUT_DIR/set/com/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) { return card##_DOMAIN(x1) == 0; }
-----
cat >$OUT_DIR/set/com/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (card##_DOMAIN(x1) == 0)
-----
cat >$OUT_DIR/set/com/is_empty/param <<'-----'
MACROS
-----
cat >$OUT_DIR/set/com/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (card##_DOMAIN(x1) = 0)
-----
cat >$OUT_DIR/set/com/is_empty/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN  = + card
-----
[ -d $OUT_DIR/set/com/is_eq ] || mkdir $OUT_DIR/set/com/is_eq
cat >$OUT_DIR/set/com/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return (card##_DOMAIN(x1) == card##_DOMAIN(x2))   
           && is_subset##_DOMAIN(x1,x2);
   }        
-----
cat >$OUT_DIR/set/com/is_eq/docu <<'-----'

  general implementation of is_eq:

  is_eq(x1,x2) =
      (card x1 = card x2)
      & is_subset(x1,x2)

  time complexity : max(O(card),O(is_subset))
-----
cat >$OUT_DIR/set/com/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + card + is_subset
-----
[ -d $OUT_DIR/set/com/is_ge ] || mkdir $OUT_DIR/set/com/is_ge
cat >$OUT_DIR/set/com/is_ge/ccod <<'-----'
#include <com/aux/is_ge/ccod>
-----
cat >$OUT_DIR/set/com/is_ge/docu <<'-----'
#include <com/aux/is_ge/docu>
-----
cat >$OUT_DIR/set/com/is_ge/vdm <<'-----'
#include <com/aux/is_ge/vdm>
-----
[ -d $OUT_DIR/set/com/is_subset ] || mkdir $OUT_DIR/set/com/is_subset
cat >$OUT_DIR/set/com/is_subset/ccod <<'-----'

#define fct is_subset
#define result Bool
#define tx1 DOMAIN
#define tx2 DOMAIN
#define incr r1 = r1 && MERGE(is_in,_DOMAIN)(y1,t2);
#define inires (MERGE(card,_DOMAIN)(t1) <= MERGE(card,_DOMAIN)(t2))
#define forloop if (r1) MERGE(forall,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/set/com/is_subset/docu <<'-----'
  general implementation of is_subset :

  is_subset(x1,x2) =
    (card x1  <= card x2)
    & (All i e x1)(i e x2)

  time complexity : O(n) * O(is_in)
-----
cat >$OUT_DIR/set/com/is_subset/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + is_in + card + forall
-----
[ -d $OUT_DIR/set/com/iterator ] || mkdir $OUT_DIR/set/com/iterator
cat >$OUT_DIR/set/com/iterator/docu <<'-----'
#define SET
#include <aux/com/iterator/docu>
-----
[ -d $OUT_DIR/set/com/max ] || mkdir $OUT_DIR/set/com/max
cat >$OUT_DIR/set/com/max/ccod <<'-----'
#define _OPNAME max
#define _COMPARE is_lt
#include <set/com/min/ccod>
-----
cat >$OUT_DIR/set/com/max/vdm <<'-----'
#include <set/com/min/vdm>
-----
[ -d $OUT_DIR/set/com/mfolddom ] || mkdir $OUT_DIR/set/com/mfolddom
cat >$OUT_DIR/set/com/mfolddom/ccod <<'-----'
#include <aux/com/mfolddom/ccod>
-----
cat >$OUT_DIR/set/com/mfolddom/gtyp <<'-----'
#include <aux/com/mfolddom/gtyp>
-----
cat >$OUT_DIR/set/com/mfolddom/param <<'-----'
FCTNAME
NEXTDOM
CALLDOM
XN
-----
cat >$OUT_DIR/set/com/mfolddom/vdm <<'-----'
#include <aux/com/mfolddom/vdm>
-----
[ -d $OUT_DIR/set/com/min ] || mkdir $OUT_DIR/set/com/min
cat >$OUT_DIR/set/com/min/ccod <<'-----'
#ifndef _OPNAME
#define _OPNAME min
#define _COMPARE is_gr
#endif

#define _TMPF MERGE(MERGE(_ff_,_OPNAME),_DOMAIN)
#define _TMPR MERGE(MERGE(_rr_,_OPNAME),_DOMAIN)
#define _TMPP MERGE(MERGE(_pp_,_OPNAME),_DOMAIN)

static ELEM1 _TMPR;
static Bool  _TMPF;

static void _TMPP _FPH1(ELEM1)
  { if (_TMPF == FALSE || _COMPARE##_ELEM1(_TMPR,x1))
       { _TMPR = x1; _TMPF = TRUE; }
  }

ELEM1 _OPNAME##_DOMAIN _FPH1(DOMAIN)
  { _TMPF = FALSE;
    forall##_DOMAIN(x1,_TMPP);
    if (_TMPF == FALSE) { err_elem_vdmlib(MKSTRING(DOMAIN)); }
    return _TMPR;
  }

#undef _OPNAME
#undef _COMPARE
#undef _TMPF
#undef _TMPR
#undef _TMPP
-----
cat >$OUT_DIR/set/com/min/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + forall
    ELEM1  = + is_gr + is_lt
    Vdmlib = + err_elem
-----
[ -d $OUT_DIR/set/com/mk1 ] || mkdir $OUT_DIR/set/com/mk1
cat >$OUT_DIR/set/com/mk1/ccod <<'-----'
  DOMAIN mk1##_DOMAIN _FPH1(ELEM1)
    { return union1##_DOMAIN(mk_empty##_DOMAIN(),x1); }
-----
cat >$OUT_DIR/set/com/mk1/cmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) union1##_DOMAIN(mk_empty##_DOMAIN(),(x1))
-----
cat >$OUT_DIR/set/com/mk1/pmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) union1##_DOMAIN(mk_empty##_DOMAIN(),(x1))
-----
cat >$OUT_DIR/set/com/mk1/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + union1

#define CONSTRNAME mk1
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/com/parse ] || mkdir $OUT_DIR/set/com/parse
cat >$OUT_DIR/set/com/parse/ccod <<'-----'
#define START_SYM '{'
#define STOP_SYM '}'
#define ADD_TO union1d
#include <aux/com/parsem/ccod>
-----
cat >$OUT_DIR/set/com/parse/docu <<'-----'

  Syntax:  '{' [<ELEM1> (',' <ELEM1>)* ] '}'

-----
cat >$OUT_DIR/set/com/parse/vdm <<'-----'
#define ADD_TO union1d
#include <aux/com/parsem/vdm>
-----
[ -d $OUT_DIR/set/com/print ] || mkdir $OUT_DIR/set/com/print
cat >$OUT_DIR/set/com/print/ccod <<'-----'
#define start "{"
#define stop "}"
#define step ","
#include <aux/com/print/ccod>
-----
cat >$OUT_DIR/set/com/print/docu <<'-----'
  prints a set in the format "{e1,...,en}"
-----
cat >$OUT_DIR/set/com/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall + is_empty
   ELEM1    = + print
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/set/com/sort ] || mkdir $OUT_DIR/set/com/sort
cat >$OUT_DIR/set/com/sort/ccod <<'-----'
#include <aux/com/sort/ccod>
-----
cat >$OUT_DIR/set/com/sort/defs <<'-----'
#include <aux/com/sort/defs>
-----
cat >$OUT_DIR/set/com/sort/docu <<'-----'
#define COLL set
#include <aux/com/sort/docu>
-----
cat >$OUT_DIR/set/com/sort/param <<'-----'
#include <aux/com/sort/param>
-----
cat >$OUT_DIR/set/com/sort/vdm <<'-----'
#include <aux/com/sort/vdm>
-----
[ -d $OUT_DIR/set/com/union ] || mkdir $OUT_DIR/set/com/union
cat >$OUT_DIR/set/com/union/docu <<'-----'
  general implementation of union with union1

  time complexity : O(n) * O(union1)
-----
cat >$OUT_DIR/set/com/union/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.union("FOLDFCT"="union1",DELETE,NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/set/com/uniond ] || mkdir $OUT_DIR/set/com/uniond
cat >$OUT_DIR/set/com/uniond/docu <<'-----'
  general implementation of uniond with union1d

  time complexity : O(n) * O(union1d)
-----
cat >$OUT_DIR/set/com/uniond/vdm <<'-----'
#ifndef GEN_CPLUS
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + binary.uniond("FOLDFCT"="union1d",DELETE,NOSIGNATURE)
#endif
-----
[ -d $OUT_DIR/set/com/upto ] || mkdir $OUT_DIR/set/com/upto
cat >$OUT_DIR/set/com/upto/ccod <<'-----'
  DOMAIN upto##_DOMAIN _FPH2(ELEM1,ELEM1)
    { DOMAIN lx1; lx1 = mk_empty##_DOMAIN();
      while (is_le##_ELEM1(x1,x2))
	 { lx1 = union1##_DOMAIN(lx1,x1); x1 = succ##_ELEM1(x1); }
      return lx1;
    }
-----
cat >$OUT_DIR/set/com/upto/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + union1
    ELEM1  = + succ + is_le
-----
[ -d $OUT_DIR/set/hashlist ] || mkdir $OUT_DIR/set/hashlist
[ -d $OUT_DIR/set/hashlist/basic ] || mkdir $OUT_DIR/set/hashlist/basic
cat >$OUT_DIR/set/hashlist/basic/docu <<'-----'
  Implementation of set a hashtable with fixed length.
  It is implemented as

    DOMAIN = Help*
    Help = ELEM1 -set


  Parameter:

    TUPLIMPL:
           Changes the implementation of the tuple domain. This
           must allow fast random access, construction or
           combination do not appear. Thus the default value
           'array' should do allmost allways.

    SETIMPL:
           Changes the implementation for the set domain 'Help'.
           Default value is 'linklist' with freelist storage
           allocation:
  
              linklist(ALLOC="freelist(MAXLEN=20)")

   LISTLOG:
           This parameter defines the size of the hashtable.
           The length of the hashlist will be 2^LISTLOG.
           (default for LISTLOG: 8 --> hashtable of size 265)

  Operations are mapped to the appropriate operation for the 'Help'
  domain. To reduce overhead, no special error checking will be done.
  Therefore eventual error messages will contain the name of one of
  the auxiliary domains instead of 'DOMAIN'. If this should become
  a problem, use another implementation during program development.

  Creation of an empty set is rather expensive since a tuple of empty
  sets with length 2^LISTLOG will be created. Thus use this 
  implementation only, if set creation will occur infrequently.
  Iteration over weakly filled hashlist will cause a lot of overhead
  also.

  NOTE: The Pascal/Modula interface for this implementation will work
        only with MACROS on!

-----
cat >$OUT_DIR/set/hashlist/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/set/hashlist/basic/gptr <<'-----'
#include <aux/hashlist/basic/gptr>
-----
cat >$OUT_DIR/set/hashlist/basic/gtyp <<'-----'
#include <aux/hashlist/basic/gtyp>
-----
cat >$OUT_DIR/set/hashlist/basic/param <<'-----'
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
LISTLOG
MACROS
SETIMPL
TUPLIMPL
-----
cat >$OUT_DIR/set/hashlist/basic/vdm <<'-----'
#include <aux/hashlist/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/hashlist/copy ] || mkdir $OUT_DIR/set/hashlist/copy
cat >$OUT_DIR/set/hashlist/copy/gcod <<'-----'
_ALIAS_DD(copy,tupl##_DOMAIN)
-----
cat >$OUT_DIR/set/hashlist/copy/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,copy)
-----
[ -d $OUT_DIR/set/hashlist/copy1 ] || mkdir $OUT_DIR/set/hashlist/copy1
cat >$OUT_DIR/set/hashlist/copy1/ccod <<'-----'
_FDEC1(copy1,DOMAIN,DOMAIN,_RET(copy2_tupl##_DOMAIN(x1)))
-----
cat >$OUT_DIR/set/hashlist/copy1/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,copy2)
-----
[ -d $OUT_DIR/set/hashlist/del ] || mkdir $OUT_DIR/set/hashlist/del
cat >$OUT_DIR/set/hashlist/del/gcod <<'-----'
_ALIAS_VD(del,tupl##_DOMAIN)
-----
cat >$OUT_DIR/set/hashlist/del/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,del)
-----
[ -d $OUT_DIR/set/hashlist/del1 ] || mkdir $OUT_DIR/set/hashlist/del1
cat >$OUT_DIR/set/hashlist/del1/gcod <<'-----'
_FDEC1(del1,void,DOMAIN,del2_tupl##_DOMAIN(x1))
-----
cat >$OUT_DIR/set/hashlist/del1/vdm <<'-----'
_ADD_OP(Tupl##_DOMAIN,del2)
-----
[ -d $OUT_DIR/set/hashlist/forall ] || mkdir $OUT_DIR/set/hashlist/forall
cat >$OUT_DIR/set/hashlist/forall/ccod <<'-----'
#include <aux/hashlist/forall/ccod>
-----
cat >$OUT_DIR/set/hashlist/forall/vdm <<'-----'
#include <aux/hashlist/forall/vdm>
-----
[ -d $OUT_DIR/set/hashlist/is_in ] || mkdir $OUT_DIR/set/hashlist/is_in
cat >$OUT_DIR/set/hashlist/is_in/gcod <<'-----'
#include <aux/hashlist/basic/setup>
_FDEC2(is_in,Bool,ELEM1,DOMAIN,_RET(is_in_aux##_DOMAIN(x1,_HGET(x2,x1))))
#undef LISTLEN
#undef _HGET
#undef _HIND
-----
cat >$OUT_DIR/set/hashlist/is_in/vdm <<'-----'
_ADD_OP(Aux##_DOMAIN,is_in)
-----
[ -d $OUT_DIR/set/hashlist/iterator ] || mkdir $OUT_DIR/set/hashlist/iterator
cat >$OUT_DIR/set/hashlist/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/set/hashlist/iterator/vdm <<'-----'
#include <aux/hashlist/iterator/vdm>
-----
[ -d $OUT_DIR/set/hashlist/mk_empty ] || mkdir $OUT_DIR/set/hashlist/mk_empty
cat >$OUT_DIR/set/hashlist/mk_empty/ccod <<'-----'
#ifndef SETIMPL
#define SIMPLE_AUX
#endif
#include <aux/hashlist/mk_empty/ccod>
-----
cat >$OUT_DIR/set/hashlist/mk_empty/vdm <<'-----'
#ifndef SETIMPL
#define SIMPLE_AUX
#endif
#include <aux/hashlist/mk_empty/vdm>

#define CONSTRNAME mk_empty
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/hashlist/sel ] || mkdir $OUT_DIR/set/hashlist/sel
cat >$OUT_DIR/set/hashlist/sel/ccod <<'-----'
  ELEM1 sel##_DOMAIN _FPH1(DOMAIN)
   { Nat0 lx1 = len_tupl##_DOMAIN(x1);
     
     while (lx1 > 0)
       { Aux##_DOMAIN lx2 = sel_tupl##_DOMAIN(x1,lx1--);
	 
	 if (!is_empty_aux##_DOMAIN(lx2))
	    { return sel_aux##_DOMAIN(lx2); }
       }
     err_elem_vdmlib(MKSTRING(DOMAIN));
   }
-----
cat >$OUT_DIR/set/hashlist/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib	= + err_elem
   Aux##_DOMAIN	= + sel + is_empty
   Tupl##_DOMAIN	= + len
-----
[ -d $OUT_DIR/set/hashlist/sub1 ] || mkdir $OUT_DIR/set/hashlist/sub1
cat >$OUT_DIR/set/hashlist/sub1/ccod <<'-----'
#include <aux/hashlist/combine1/ccod>
-----
cat >$OUT_DIR/set/hashlist/sub1/vdm <<'-----'
#include <aux/hashlist/combine1/vdm>
-----
[ -d $OUT_DIR/set/hashlist/sub1d ] || mkdir $OUT_DIR/set/hashlist/sub1d
cat >$OUT_DIR/set/hashlist/sub1d/ccod <<'-----'
#define OPER sub1d
#include <aux/hashlist/combine1/ccod>
-----
cat >$OUT_DIR/set/hashlist/sub1d/vdm <<'-----'
#define OPER sub1d
#include <aux/hashlist/combine1/vdm>
-----
[ -d $OUT_DIR/set/hashlist/union1 ] || mkdir $OUT_DIR/set/hashlist/union1
cat >$OUT_DIR/set/hashlist/union1/ccod <<'-----'
#define OPER union1
#include <aux/hashlist/combine1/ccod>
-----
cat >$OUT_DIR/set/hashlist/union1/vdm <<'-----'
#define OPER union1
#include <aux/hashlist/combine1/vdm>
-----
[ -d $OUT_DIR/set/hashlist/union1d ] || mkdir $OUT_DIR/set/hashlist/union1d
cat >$OUT_DIR/set/hashlist/union1d/ccod <<'-----'
#define OPER union1d
#include <aux/hashlist/combine1/ccod>
-----
cat >$OUT_DIR/set/hashlist/union1d/vdm <<'-----'
#define OPER union1d
#include <aux/hashlist/combine1/vdm>
-----
[ -d $OUT_DIR/set/linklist ] || mkdir $OUT_DIR/set/linklist
[ -d $OUT_DIR/set/linklist/basic ] || mkdir $OUT_DIR/set/linklist/basic
cat >$OUT_DIR/set/linklist/basic/docu <<'-----'
  Implementation of Sets as linked lists

  space : O(n) * (sizeof(pointer) + sizeof(ELEM1))
-----
cat >$OUT_DIR/set/linklist/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/set/linklist/basic/gptr <<'-----'
#include <aux/linklist/basic/gptr>
-----
cat >$OUT_DIR/set/linklist/basic/gtyp <<'-----'
#include <aux/linklist/basic/gtyp>
-----
cat >$OUT_DIR/set/linklist/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
SAVE
-----
cat >$OUT_DIR/set/linklist/basic/vdm <<'-----'
#include <aux/com/heap/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/linklist/card ] || mkdir $OUT_DIR/set/linklist/card
cat >$OUT_DIR/set/linklist/card/ccod <<'-----'
#define fct card
#include <aux/linklist/len/ccod>
-----
cat >$OUT_DIR/set/linklist/card/docu <<'-----'
  time complexity : O(n)
-----
[ -d $OUT_DIR/set/linklist/copy ] || mkdir $OUT_DIR/set/linklist/copy
cat >$OUT_DIR/set/linklist/copy/ccod <<'-----'
#include <aux/linklist/copy/ccod>
-----
cat >$OUT_DIR/set/linklist/copy/vdm <<'-----'
#include <aux/linklist/copy/vdm>
-----
[ -d $OUT_DIR/set/linklist/copy1 ] || mkdir $OUT_DIR/set/linklist/copy1
cat >$OUT_DIR/set/linklist/copy1/ccod <<'-----'
#include <aux/linklist/copy1/ccod>
-----
[ -d $OUT_DIR/set/linklist/del1 ] || mkdir $OUT_DIR/set/linklist/del1
cat >$OUT_DIR/set/linklist/del1/ccod <<'-----'
#include <aux/linklist/del1/ccod>
-----
cat >$OUT_DIR/set/linklist/del1/cmcr <<'-----'
#include <aux/linklist/del1/cmcr>
-----
[ -d $OUT_DIR/set/linklist/fold ] || mkdir $OUT_DIR/set/linklist/fold
cat >$OUT_DIR/set/linklist/fold/ccod <<'-----'
#include <aux/linklist/fold/ccod>
-----
cat >$OUT_DIR/set/linklist/fold/docu <<'-----'
#define Abortval
#define Set set
  Special linklist implementation for 'fold'
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/set/linklist/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/set/linklist/fold/vdm <<'-----'
#include <aux/linklist/fold/vdm>
-----
[ -d $OUT_DIR/set/linklist/forall ] || mkdir $OUT_DIR/set/linklist/forall
cat >$OUT_DIR/set/linklist/forall/ccod <<'-----'
#include <aux/linklist/forall/ccod>
-----
cat >$OUT_DIR/set/linklist/forall/cmcr <<'-----'
#include <aux/linklist/forall/cmcr>
-----
[ -d $OUT_DIR/set/linklist/is_empty ] || mkdir $OUT_DIR/set/linklist/is_empty
cat >$OUT_DIR/set/linklist/is_empty/ccod <<'-----'
#include <aux/linklist/is_empty/ccod>
-----
cat >$OUT_DIR/set/linklist/is_empty/cmcr <<'-----'
#include <aux/linklist/is_empty/cmcr>
-----
cat >$OUT_DIR/set/linklist/is_empty/docu <<'-----'
  time complexity : constant (1 pointer test)
-----
cat >$OUT_DIR/set/linklist/is_empty/pmcr <<'-----'
#include <aux/linklist/is_empty/pmcr>
-----
[ -d $OUT_DIR/set/linklist/is_in ] || mkdir $OUT_DIR/set/linklist/is_in
cat >$OUT_DIR/set/linklist/is_in/ccod <<'-----'

#define fct is_in
#define params _FP(x1,ELEM1), _FP(x2,DOMAIN)
#define paramdec _EP(x1,ELEM1) _EP(x2,DOMAIN)
#define search if (MERGE(is_eq,_ELEM1)(MERGE(ref,_DOMAIN)(x2)->f_info,x1)) return 1;
#include <aux/linklist/is_in/ccod>
-----
cat >$OUT_DIR/set/linklist/is_in/docu <<'-----'
  time complexity : O(n)
-----
cat >$OUT_DIR/set/linklist/is_in/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq
-----
[ -d $OUT_DIR/set/linklist/iterator ] || mkdir $OUT_DIR/set/linklist/iterator
cat >$OUT_DIR/set/linklist/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/set/linklist/iterator/vdm <<'-----'
#define IMPL linklist
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/set/linklist/mk1 ] || mkdir $OUT_DIR/set/linklist/mk1
cat >$OUT_DIR/set/linklist/mk1/ccod <<'-----'
#include <aux/linklist/mk1/ccod>
-----
cat >$OUT_DIR/set/linklist/mk1/vdm <<'-----'

#define CONSTRNAME mk1
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/linklist/mk_empty ] || mkdir $OUT_DIR/set/linklist/mk_empty
cat >$OUT_DIR/set/linklist/mk_empty/ccod <<'-----'
#include <aux/linklist/mk_empty/ccod>
-----
cat >$OUT_DIR/set/linklist/mk_empty/cmcr <<'-----'
#include <aux/linklist/mk_empty/cmcr>
-----
cat >$OUT_DIR/set/linklist/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_SET
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/set/linklist/sel ] || mkdir $OUT_DIR/set/linklist/sel
cat >$OUT_DIR/set/linklist/sel/ccod <<'-----'
  ELEM1 sel##_DOMAIN _FPH1(DOMAIN)
   {if ( !x1 )
       err_elem_vdmlib(MKSTRING(DOMAIN));
    return ref##_DOMAIN(x1)->f_info;
   }
-----
cat >$OUT_DIR/set/linklist/sel/docu <<'-----'
  time complexity : constant
-----
cat >$OUT_DIR/set/linklist/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_elem
-----
[ -d $OUT_DIR/set/linklist/sub1 ] || mkdir $OUT_DIR/set/linklist/sub1
cat >$OUT_DIR/set/linklist/sub1/ccod <<'-----'
#include <aux/linklist/sub1/ccod>
-----
cat >$OUT_DIR/set/linklist/sub1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq
-----
[ -d $OUT_DIR/set/linklist/sub1d ] || mkdir $OUT_DIR/set/linklist/sub1d
cat >$OUT_DIR/set/linklist/sub1d/ccod <<'-----'

#define fct sub1d
#define delelem MERGE(del,_ELEM1)(lx2->f_info);
#include <aux/linklist/sub1/ccod>
-----
cat >$OUT_DIR/set/linklist/sub1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1  = + is_eq + del
-----
[ -d $OUT_DIR/set/linklist/union1 ] || mkdir $OUT_DIR/set/linklist/union1
cat >$OUT_DIR/set/linklist/union1/ccod <<'-----'
#include <aux/linklist/union1/ccod>
-----
cat >$OUT_DIR/set/linklist/union1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk1
   ELEM1    = + is_eq
-----
[ -d $OUT_DIR/set/linklist/union1d ] || mkdir $OUT_DIR/set/linklist/union1d
cat >$OUT_DIR/set/linklist/union1d/ccod <<'-----'

#define fct union1d
#define retst {MERGE(del,_ELEM1)(x2);return x1;}
#include <aux/linklist/union1/ccod>
-----
cat >$OUT_DIR/set/linklist/union1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk1
   ELEM1    = + is_eq + del
-----
[ -d $OUT_DIR/set/sign ] || mkdir $OUT_DIR/set/sign
[ -d $OUT_DIR/set/sign/all ] || mkdir $OUT_DIR/set/sign/all
cat >$OUT_DIR/set/sign/all/vsig <<'-----'
#include <aux/sign/all/vsig>
-----
[ -d $OUT_DIR/set/sign/binary ] || mkdir $OUT_DIR/set/sign/binary
cat >$OUT_DIR/set/sign/binary/gsig <<'-----'
#include <aux/sign/binary/gsig>
-----
cat >$OUT_DIR/set/sign/binary/vsig <<'-----'
  binary(x1) =
   let fct(y1,y2) = if y2 = {}
                    then y1
                    else let elem e y2 in
                      fct(x1(y1,elem),y2 - {elem})
   in fct
  TYPE : (Result  ELEM1 --> Result)
         -->
         (Result  DOMAIN --> Result)

  __EM(binary) is a functional (a function returning another function as result).
  With help of this functional binary functions on Result and ELEM1 can be
  generalized to functions of DOMAIN to Result. 
  An important case is Result = DOMAIN. This leads to the examples
  described below. The general case is usefull for inventing conversions.

  __EM(binary) is evaluated at module generation time.

  Example : union of 2 sets

  given the function :

     union1(y1,y2) = y1 u {y2}
     TYPE : DOMAIN ELEM1  -->  DOMAIN

  the union function can be constructed by:

     union(x1,x2) = binary(union1)(x1,x2)
     TYPE : DOMAIN  DOMAIN -->  DOMAIN

-----
[ -d $OUT_DIR/set/sign/card ] || mkdir $OUT_DIR/set/sign/card
cat >$OUT_DIR/set/sign/card/cpp <<'-----'

#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(card,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,card,FPARLIST1))
#undef T1

-----
cat >$OUT_DIR/set/sign/card/gsig <<'-----'
  FUNCDEC(card##_DOMAIN,PL_1(DOMAIN),Nat0)
-----
cat >$OUT_DIR/set/sign/card/vsig <<'-----'
  card(x1) = card x1
  TYPE : DOMAIN --> Nat0

  cardinality of set x1
-----
[ -d $OUT_DIR/set/sign/diff ] || mkdir $OUT_DIR/set/sign/diff
cat >$OUT_DIR/set/sign/diff/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN & 
#define T1 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
#endif

InlineFriendFct(diff,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diff,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator -=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diff,FPARLIST2))

#if defined(BASEIMPL)

InlineFriendConstFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(diff))

#else

InlineFriendFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diff,FPARLIST2))

#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/diff/gsig <<'-----'
  FUNCDEC(diff##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/set/sign/diff/vsig <<'-----'
  diff(x1,x2) = x1 - x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  set difference of x1 and x2
  only x1 is destroyed
-----
[ -d $OUT_DIR/set/sign/diffd ] || mkdir $OUT_DIR/set/sign/diffd
cat >$OUT_DIR/set/sign/diffd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'diffd' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(diffd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(diffd,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/set/sign/diffd/gsig <<'-----'
  FUNCDEC(diffd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/set/sign/diffd/vsig <<'-----'
  diffd(x1,x2) = x1 - x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  set difference of x1 and x2
  for elements of x1 not contained x2 implicit calls of __EM(del) are performed
  only x1 are destroyed
-----
[ -d $OUT_DIR/set/sign/exist ] || mkdir $OUT_DIR/set/sign/exist
cat >$OUT_DIR/set/sign/exist/vsig <<'-----'
#include <aux/sign/exist/vsig>
-----
[ -d $OUT_DIR/set/sign/exist1 ] || mkdir $OUT_DIR/set/sign/exist1
cat >$OUT_DIR/set/sign/exist1/gsig <<'-----'
#include <aux/sign/exist1/gsig>
-----
cat >$OUT_DIR/set/sign/exist1/vsig <<'-----'
#include <aux/sign/exist1/vsig>
-----
[ -d $OUT_DIR/set/sign/fold ] || mkdir $OUT_DIR/set/sign/fold
cat >$OUT_DIR/set/sign/fold/gsig <<'-----'
#include <aux/sign/fold/gsig>
-----
cat >$OUT_DIR/set/sign/fold/vsig <<'-----'
  fold(x1,x2,x3)(y1,a1,...,an) =
   let fct(z1) = if z1 = {}
                 then x2
                 else let i e z1 in
                      x3(x1 (i,a1,..,ak)
                        ,fct(z1 - {i})
                        ,al,...,an
                        )
   in fct(y1)
  TYPE : (ELEM1         T1 ... Tk --> RESULT)
         (                        --> RESULT)
         (RESULT RESULT Tl ... Tn --> RESULT)
         -->
         (DOMAIN        T1 ... Tn --> RESULT)

  __EM(fold) is a functional (a function returning another function as result).
  With help of this functional functions on the type DOMAIN can be defined
  by means of functions defined on the element type ELEM1.
  Fold returns a function from DOMAIN to RESULT.

  Usually, fold is partly evaluated at module generation time.
  The parameters a1 .. an are usefull to pass global information
  into the fold- or conversion functions. They are optional and
  can be generated in any combination.

  Example : computation of the cardinality of a set

  Given the functions :

     one(y1) = 1
     TYPE : ELEM1  -->  Nat0

     zero()  = 0
     TYPE :  --> Nat0

     plus(y1,y2) = y1 + y2
     TYPE : Nat0  Nat0  -->  Nat0

  the card function can be constructed by:

     card(x1) = fold(one,zero,plus)(x1)
     TYPE : DOMAIN  -->  Nat0

-----
[ -d $OUT_DIR/set/sign/forall ] || mkdir $OUT_DIR/set/sign/forall
cat >$OUT_DIR/set/sign/forall/cpp.old <<'-----'
#ifndef DECL
class cv_forall##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
public:
  cv_forall##_DOMAIN(void (*x1) (Cpp_ELEM1))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
};
void (*cv_forall##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1)
InlineFriendFct(forall,PPAR2(T1,X2),void)
RUMPF(
{ cv_forall##_DOMAIN tmp(x2);
  forall##_DOMAIN(DATA, cv_forall##_DOMAIN::cv_1);
  tmp.reset();})
#undef T1
#undef X2
-----
cat >$OUT_DIR/set/sign/forall/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forall##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern void forall##_DOMAIN P_OP DOMAIN x1, T2_forall##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/set/sign/forall/vsig <<'-----'
  forall(x1,x2) = for i in x1 do x2(i)
  TYPE : DOMAIN  (ELEM1  -->  )  --> 

  for all elements in set x1 procedure x2 is executed
  if the set is ordered the elements are processed in this order
-----
[ -d $OUT_DIR/set/sign/forsome ] || mkdir $OUT_DIR/set/sign/forsome
cat >$OUT_DIR/set/sign/forsome/cpp.old <<'-----'
#ifndef DECL
class cv_forsome##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  Cpp_BOOL (*data2) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
  static Cpp_BOOL (*ptr2) (Cpp_ELEM1);
public:
  cv_forsome##_DOMAIN(void (*x1) (Cpp_ELEM1), Cpp_BOOL (*x2) (Cpp_ELEM1))
   { data1 = ptr1; data2 = ptr2; ptr1 = x1; ptr2 = x2; }
  void reset()
   { ptr1 = data1; ptr2 = data2;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
  static Bool cv_2(ELEM1 x1)
   { return ((*ptr2) (x1)).data;}
};
void (*cv_forsome##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
Cpp_BOOL (*cv_forsome##_DOMAIN::ptr2) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 Cpp_BOOL (*x2) (Cpp_ELEM1)
#define X3 void (*x3) (Cpp_ELEM1)
InlineFriendFct(forsome,PPAR3(T1,X2,X3),void)
RUMPF(
{ cv_forsome##_DOMAIN tmp(x3,x2);
  forsome##_DOMAIN(DATA,cv_forsome##_DOMAIN::cv_2, cv_forsome##_DOMAIN::cv_1);
  tmp.reset();})
#undef T1
#undef X2
#undef X3
-----
cat >$OUT_DIR/set/sign/forsome/gsig <<'-----'
#ifdef GEN_C
  typedef Bool (* T2_forsome##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  typedef void (* T3_forsome##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern void forsome##_DOMAIN P_OP DOMAIN x1, T2_forsome##_DOMAIN x2, T3_forsome##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/set/sign/forsome/vsig <<'-----'
  forsome(x1,x2,x3) = let y1 = <x1(i) | i e ind x1 & x2(x1(i))>
                      in forall(y1,x3)
  TYPE : DOMAIN  ( ELEM1  -->  Bool )  ( ELEM1  -->  )  -->

  for those elements in set x1
  for which the predicate x2 holds 
  procedure x3 is executed
-----
[ -d $OUT_DIR/set/sign/inters ] || mkdir $OUT_DIR/set/sign/inters
cat >$OUT_DIR/set/sign/inters/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN &
#define T1 const Cpp_DOMAIN &

InlineFriendFct(inters,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator &=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))
 
InlineFriendConstFct(operator &, FPAR2(Cpp_DOMAIN,T2), Cpp_DOMAIN)
RUMPF(BODY6(inters))
#endif

#else
#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &

InlineFriendFct(inters,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator &=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))

InlineFriendFct(operator &,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(inters,FPARLIST2))
#endif

#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/inters/gsig <<'-----'
  FUNCDEC(inters##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/set/sign/inters/vsig <<'-----'
  inters(x1,x2) = x1 n x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  intersect of x1 and x2
  x1 and x2 are destroyed
-----
[ -d $OUT_DIR/set/sign/intersd ] || mkdir $OUT_DIR/set/sign/intersd
cat >$OUT_DIR/set/sign/intersd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'intersd' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(intersd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(intersd,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/set/sign/intersd/gsig <<'-----'
  FUNCDEC(intersd##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/set/sign/intersd/vsig <<'-----'
  intersd(x1,x2) = x1 n x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  intersection of x1 and x2
  for elements not contained in the result set implicit calls of del
  are preformed
  x1 and x2 are destroyed
-----
[ -d $OUT_DIR/set/sign/is_empty ] || mkdir $OUT_DIR/set/sign/is_empty
cat >$OUT_DIR/set/sign/is_empty/cpp <<'-----'
#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(is_empty,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_empty,FPARLIST1))

#ifdef OPERATOR
InlineFriendConstFct(operator !,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,! is_empty,FPARLIST1))
#endif

#undef T1
-----
cat >$OUT_DIR/set/sign/is_empty/gsig <<'-----'
  FUNCDEC(is_empty##_DOMAIN,PL_1(DOMAIN),Bool)
-----
cat >$OUT_DIR/set/sign/is_empty/vsig <<'-----'
  is_empty(x1) = ( x1 = {} )
  TYPE : DOMAIN  -->  Bool

  test on empty set
-----
[ -d $OUT_DIR/set/sign/is_in ] || mkdir $OUT_DIR/set/sign/is_in
cat >$OUT_DIR/set/sign/is_in/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(is_in,SPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_in,SPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/is_in/gsig <<'-----'
  FUNCDEC(is_in##_DOMAIN,PL_2(ELEM1,DOMAIN),Bool)
-----
cat >$OUT_DIR/set/sign/is_in/vsig <<'-----'
  is_in(x1,x2) = ( x1 e x2 )
  TYPE : ELEM1  DOMAIN  -->  Bool

  test whether element x1 is in set x2
-----
[ -d $OUT_DIR/set/sign/is_subset ] || mkdir $OUT_DIR/set/sign/is_subset
cat >$OUT_DIR/set/sign/is_subset/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &
InlineFriendConstFct(is_subset,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_subset,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/is_subset/gsig <<'-----'
  FUNCDEC(is_subset##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/set/sign/is_subset/vsig <<'-----'
  is_subset(x1,x2) = ( x1 <= x2 )
  TYPE : ELEM1  DOMAIN  -->  Bool

  test whether set x1 is contained in set x2
-----
[ -d $OUT_DIR/set/sign/iterator ] || mkdir $OUT_DIR/set/sign/iterator
cat >$OUT_DIR/set/sign/iterator/cpp <<'-----'
#include <aux/sign/iterator/docu>
-----
[ -d $OUT_DIR/set/sign/max ] || mkdir $OUT_DIR/set/sign/max
cat >$OUT_DIR/set/sign/max/cpp <<'-----'
#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(max,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,max,FPARLIST1))

#undef T1
-----
cat >$OUT_DIR/set/sign/max/gsig <<'-----'
  FUNCDEC(max##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/set/sign/max/vsig <<'-----'
  max(x1) = {x e x1 | A y e x1: y <= x}
  TYPE : DOMAIN  -->  ELEM1

  Select the maximum element from the set x1.
-----
[ -d $OUT_DIR/set/sign/min ] || mkdir $OUT_DIR/set/sign/min
cat >$OUT_DIR/set/sign/min/cpp <<'-----'
#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(min,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,min,FPARLIST1))

#undef T1
-----
cat >$OUT_DIR/set/sign/min/gsig <<'-----'
  FUNCDEC(min##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/set/sign/min/vsig <<'-----'
  min(x1) = {x e x1 | A y e x1: y >= x}
  TYPE : DOMAIN  -->  ELEM1

  Select the minimum from the set x1.
-----
[ -d $OUT_DIR/set/sign/mk1 ] || mkdir $OUT_DIR/set/sign/mk1
cat >$OUT_DIR/set/sign/mk1/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk1,KPARLIST1))
#undef T1
-----
cat >$OUT_DIR/set/sign/mk1/gsig <<'-----'
  FUNCDEC(mk1##_DOMAIN,PL_1(ELEM1),DOMAIN)
-----
cat >$OUT_DIR/set/sign/mk1/vsig <<'-----'
  mk1(x1) = {x1}
  TYPE : ELEM1  -->  DOMAIN

  construction of a set with one element x1
-----
[ -d $OUT_DIR/set/sign/mk_empty ] || mkdir $OUT_DIR/set/sign/mk_empty
cat >$OUT_DIR/set/sign/mk_empty/cpp <<'-----'
#define T1 const Cpp_EMPTY &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk_empty,KPARLIST0))
#undef T1 
-----
cat >$OUT_DIR/set/sign/mk_empty/gsig <<'-----'
  FUNCDEC(mk_empty##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/set/sign/mk_empty/vsig <<'-----'
  mk_empty() = {}
  TYPE :  -->  DOMAIN

  construction of the empty set

#include <aux/com/mk_empty/docu>
-----
[ -d $OUT_DIR/set/sign/sel ] || mkdir $OUT_DIR/set/sign/sel
cat >$OUT_DIR/set/sign/sel/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(sel,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,sel,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/set/sign/sel/gsig <<'-----'
  FUNCDEC(sel##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/set/sign/sel/vsig <<'-----'
  sel(x1) = let y1 e x1 in y1
  TYPE : DOMAIN  -->  ELEM1
  PRE  : ~ (x1 = {})

  selects an arbitrary element of set x1
  x1 must be non empty
-----
[ -d $OUT_DIR/set/sign/sort ] || mkdir $OUT_DIR/set/sign/sort
cat >$OUT_DIR/set/sign/sort/cpp <<'-----'
#include <aux/sign/sort/cpp>

-----
cat >$OUT_DIR/set/sign/sort/gsig <<'-----'
#include <aux/sign/sort/gsig>
-----
cat >$OUT_DIR/set/sign/sort/vsig <<'-----'
#define COLL set
#include <aux/sign/sort/vsig>
-----
[ -d $OUT_DIR/set/sign/sub1 ] || mkdir $OUT_DIR/set/sign/sub1
cat >$OUT_DIR/set/sign/sub1/cpp <<'-----'
#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &

InlineFriendFct(sub1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator -=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))

#if defined(BASEIMPL)
InlineFriendConstFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(sub1))
#else
InlineFriendFct(operator -,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1,FPARLIST2))
#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/sub1/gsig <<'-----'
  FUNCDEC(sub1##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/set/sign/sub1/vsig <<'-----'
  sub1(x1,x2) = x1 - {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is removed from x1
  x1 is destroyed
-----
[ -d $OUT_DIR/set/sign/sub1d ] || mkdir $OUT_DIR/set/sign/sub1d
cat >$OUT_DIR/set/sign/sub1d/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'sub1d' not supported for automem)
#else

#define T2 const Cpp_ELEM1 &
#define T1 Cpp_DOMAIN &
InlineFriendFct(sub1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(sub1d,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/set/sign/sub1d/gsig <<'-----'
  FUNCDEC(sub1d##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/set/sign/sub1d/vsig <<'-----'
  sub1d(x1,x2) = x1 - {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is removed from x1
  if a value y1 equal to x2 is x1 an implicit call of del(y1) is performed
  x1 is destroyed
-----
[ -d $OUT_DIR/set/sign/union ] || mkdir $OUT_DIR/set/sign/union
cat >$OUT_DIR/set/sign/union/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN & 
#define T1 const Cpp_DOMAIN &

InlineFriendFct(plus,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator |=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

InlineFriendConstFct(operator |,FPAR2(T1,T2), Cpp_DOMAIN)
RUMPF(BODY6(union))
#endif

#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &

InlineFriendFct(plus,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator |=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))

InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union,FPARLIST2))
#endif

#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/union/gsig <<'-----'
  FUNCDEC(union##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/set/sign/union/vsig <<'-----'
  union(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  union of x1 and x2
  x1 and x2 are destroyed

#ifdef GEN_CPP
  In C++ union is called plus to avoid conflicts
  with C keyword union
#endif

-----
[ -d $OUT_DIR/set/sign/union1 ] || mkdir $OUT_DIR/set/sign/union1
cat >$OUT_DIR/set/sign/union1/cpp <<'-----'
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &

InlineFriendFct(plus1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST2))

#ifdef OPERATOR
InlineFriendFct(operator |=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST2))

#if defined(BASEIMPL)
InlineFriendConstFct(operator |, FPAR2(T1,T2), Cpp_DOMAIN)
RUMPF(BODY6(union1))
#else
InlineFriendFct(operator |,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1,FPARLIST2))
#endif

#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/union1/gsig <<'-----'
  FUNCDEC(union1##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/set/sign/union1/vsig <<'-----'
  union1(x1,x2) = x1 u {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is inserted in x1
  x1 is destroyed

#ifdef GEN_CPP
  In C++ union1 is called plus to avoid conflicts
  with C keyword union (see operation union)
#endif
-----
[ -d $OUT_DIR/set/sign/union1d ] || mkdir $OUT_DIR/set/sign/union1d
cat >$OUT_DIR/set/sign/union1d/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'union1d' not supported for automem)
#else

#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_ELEM1 &
InlineFriendFct(plus1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(union1d,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/set/sign/union1d/gsig <<'-----'
  FUNCDEC(union1d##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/set/sign/union1d/vsig <<'-----'
  union1d(x1,x2) = x1 u {x2}
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is inserted in x1
  if x2 is already in x1 an implicit call of del(x2) is performed
  x1 is destroyed

#ifdef GEN_CPP
  In C++ union1d is called plus to avoid conflicts
  with C keyword union (see operation union)
#endif
-----
[ -d $OUT_DIR/set/sign/uniond ] || mkdir $OUT_DIR/set/sign/uniond
cat >$OUT_DIR/set/sign/uniond/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'uniond' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(plusd,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(uniond,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/set/sign/uniond/gsig <<'-----'
  FUNCDEC(uniond##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/set/sign/uniond/vsig <<'-----'
  uniond(x1,x2) = x1 u x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  union of x1 and x2
  for elements contained in both sets implicit calls of del are preformed
  x1 and x2 are destroyed

#ifdef GEN_CPP
  In C++ uniond is called plus to avoid conflicts
  with C keyword union (see operation union)
#endif
-----
[ -d $OUT_DIR/set/sign/upto ] || mkdir $OUT_DIR/set/sign/upto
cat >$OUT_DIR/set/sign/upto/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_ELEM1 &

InlineNoFriendFct(Cpp_DOMAIN,KPAR2(T1,T2),)
RUMPF(BODY4(upto,KPARLIST2))

#undef T1
#undef T2
-----
cat >$OUT_DIR/set/sign/upto/gsig <<'-----'
  FUNCDEC(upto##_DOMAIN,PL_2(ELEM1,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/set/sign/upto/vsig <<'-----'
  upto(x1,x2) = {x1 .. x2}
  TYPE : ELEM1 ELEM1  -->  DOMAIN

  Construction of a set containing the intervall x1 .. x2.
  This operation is valid only if ELEM1 supplies a successor 
  function __SA(succ).

#ifdef GEN_CPP
  In C++ __SA(upto) becomes a constructor with two arguments
  of class ELEMENT1
#endif
-----
[ -d $OUT_DIR/stdlib ] || mkdir $OUT_DIR/stdlib
[ -d $OUT_DIR/stdlib/aux ] || mkdir $OUT_DIR/stdlib/aux
[ -d $OUT_DIR/stdlib/aux/setup ] || mkdir $OUT_DIR/stdlib/aux/setup
cat >$OUT_DIR/stdlib/aux/setup/com <<'-----'
/* preprocessor command generation */

#define _IF \#if
#define _IFDEF \#ifdef
#define _IFNDEF \#ifndef
#define _ELSE \#else
#define _ENDIF \#endif
#define _DEFINE \#define
#define _UNDEF \#undef
#define _INCLUDE \#include
#define MERGE(SSS,TTT)SSS##TTT
#define MKSTRING(x)#x
#define CA /##*
#define CE */
#define COMMENT_(CC) CA CC CE
/* Tree selector name definition */
/* TSNAME_REP is used for automem implementations TT,23/10/93 */
#ifdef GEN_ISO
#define TSNAME(SS,_SS) SS
#define TSNAME_REP(SS,_SS) MERGE(s_rep_##SS##_rep,_DOMAIN)
#define UCNAME_REP(op,_SS) MERGE(op,MERGE(_s,MERGE(_SS,MERGE(_rep,_DOMAIN))))
#define UCNAME_REP_s(_SS) MERGE(s,MERGE(_SS,MERGE(_rep,_DOMAIN)))
#else
#define TSNAME(SS,_SS) s##_SS
#define TSNAME_REP(SS,_SS) MERGE(s_rep_##SS##_rep,_DOMAIN)
#define UCNAME_REP(op,_SS) MERGE(op,MERGE(_SS,MERGE(_rep,_DOMAIN)))
#define UCNAME_REP_s(_SS) MERGE(s,MERGE(_SS,MERGE(_rep,_DOMAIN)))
#endif
-----
[ -d $OUT_DIR/stdlib/com ] || mkdir $OUT_DIR/stdlib/com
[ -d $OUT_DIR/stdlib/com/basic ] || mkdir $OUT_DIR/stdlib/com/basic
cat >$OUT_DIR/stdlib/com/basic/HISTLOG <<'-----'

$Id: vdmdb-c.f,v 1.101 1996/09/19 09:25:46 vdm Exp $

$Log: vdmdb-c.f,v $
Revision 1.101  1996/09/19 09:25:46  vdm
Bool example

Revision 1.100  1996/09/18 13:13:42  vdm
new constructors for all is-a's
DOMAIN(const BASEDOMAIN &)
and assignments
DOMAIN operator = (const BASEDOMAIN &)

Revision 1.98  1996/09/06 10:51:57  vdm
docu edited

Revision 1.97  1996/09/05 20:26:35  vdm
docu format edited

Revision 1.96  1996/09/05 15:11:43  vdm
in extern for maps impl. param changed

Revision 1.95  1996/09/05 12:53:06  vdm
VDM Logo

Revision 1.94  1996/09/05 11:45:36  vdm
HTML tags added

Revision 1.93  1996/09/05 06:09:17  vdm
Marko Temmes extensions

Revision 1.92  1996/07/11 08:57:59  vdm
Hans-Martins nderungen: alias Mackros

Revision 1.91  1996/06/13 08:04:53  vdm
array bound check did not work for A++: c implementations
"array", "bitset" and "larray" used macros and did not check bounds
Macro generation changed: -SNOCHECK must be explicitliy set to prevent
array bound check in sel operation,
implementation is a bit tricky: if macros are generated flag NOCHECK
is tested, if not set a dummy op sel_save is used, this only includes
the ccode of sel

Revision 1.89  1996/05/01 19:08:28  vdm
the last (!!!) minor errors in test cases removed

Revision 1.88  1996/05/01 10:47:27  vdm
minor changes
errors for non macro copy for elementary types
const attributes for numeric functions in C++

Revision 1.87  1996/04/30 20:25:40  vdm
extensions for implementing alias as inheritance in C++
solution: a new constructor -isa with external syntax
Subtype is-a Basetype
Semantics for C like "=", but for C++ class SUBTYPE
becomes a subclass of class BASETYPE
Problem: constructors are not inherited, so the
constructors are passed from Basetype to Subtype
in the generator, therefore a special operation
constructor.mk??? introduced, wich is copied in the generator
to the Subtype domain.
The generation order computation did not work save,
therefore an explicit dependency graph is constructed, with this
graph the generation order is computed, old code still there
function "old_gen_order"

Revision 1.86  1996/02/15 14:13:04  vdm
sort algorithm for tuples from Hans-Martin
quicksort algorithm
ISO print and cvlines for tuples and unions

Revision 1.85  1996/02/01 12:22:43  vdm
new operation for token/extern removed from default ops

Revision 1.84  1996/01/31 11:32:32  vdm
header files edited, math.h added

Revision 1.83  1996/01/30 22:47:43  vdm
new conversion function cv_DOMAIN for
all C++ Classes, to convert to C, e.g. for use in a union

c Revision 1.81  1995/12/03  19:33:36  vdm
c VDM Version in header files
c

-----
cat >$OUT_DIR/stdlib/com/basic/TODO <<'-----'
diese Operationen muessen fr c++ und fr automem noch bearbeitet werden
map/sign/domresby/cpp
map/sign/domresto/cpp
map/sign/ranresby/cpp
map/sign/ranresto/cpp
rel/sign/card/cpp
rel/sign/dom/cpp
rel/sign/domresby/cpp
rel/sign/domresto/cpp
rel/sign/is_empty/cpp
rel/sign/is_in/cpp
rel/sign/mk1/cpp
rel/sign/mk_empty/cpp
rel/sign/mk_product/cpp
rel/sign/ran/cpp
rel/sign/ranresby/cpp
rel/sign/ranresto/cpp
rel/sign/sel/cpp
rel/sign/sub1/cpp
rel/sign/sub1d/cpp
rel/sign/union/cpp
rel/sign/union1/cpp
rel/sign/union1d/cpp
rel/sign/uniond/cpp
set/sign/max/cpp         !! schon gendert aber noch nicht getestet
set/sign/min/cpp         !! schon gendert aber noch nicht getestet
tupl/sign/extract/cpp    !! schon gendert aber noch nicht getestet
tupl/sign/filter/cpp     !! schon gendert aber noch nicht getestet
tupl/sign/foldix/cpp     !! fr c++ gelscht
tupl/sign/front/cpp      !! umbenannt in frontd, neue operation front ( analog zu tl,tld )
tupl/sign/is_postfix/cpp !! implementierung mit schleife, kein mk_sub_tup mehr
			 !! noch keine automem impl. (--> schlechte performence)
tupl/sign/is_prefix/cpp  !! implementierung mit schleife, kein mk_sub_tup mehr
			 !! noch keine automem impl. (--> schlechte performence)
tupl/sign/is_subtup/cpp  !! impl. mit 'index_list' keine schleife mehr
tupl/sign/reverse/cpp    !! noch keine automem impl. (--> schlechte performence)
tupl/sign/sub_tupls/cpp
-----
cat >$OUT_DIR/stdlib/com/basic/adttype <<'-----'
AUXILIARY
-----
cat >$OUT_DIR/stdlib/com/basic/param <<'-----'
INTERNALDOMAIN
MACROS
NOSTD
-----
cat >$OUT_DIR/stdlib/com/basic/vdm <<'-----'
  --------------------------------------------------------------------
  --
  --      VDM database $Revision: 1.101 $ from $Date: 1996/09/19 09:25:46 $
  --
  --      predefined domains
  --
  --------------------------------------------------------------------

#if NOSTD
DOMAINS

  Bool       =  PREDEF
  Char       =  PREDEF
  Intg       =  PREDEF
  Nat0       =  PREDEF
  Nat1       =  PREDEF
  Str        =  PREDEF
  Vdmlib     =  PREDEF
  Niletc     =  PREDEF
  Cvtext_vdmlib = PREDEF

  Adts       = PREDEF       -- for debugging automatic memory managing
  Adt        = PREDEF       -- for debugging automatic memory managing
  Handles    = PREDEF       -- for debugging automatic memory managing

IMPLEMENTATIONS

  -- no implementations needed for predefined types

#else

DOMAINS

  Bool    =  ()-bool       
                                -- = TRUE | FALSE ( C++ : true, false )
  Char    =  ()-numeric   
				
  Intg    =  ()-numeric    
                                -- = { minint .. maxint } 
  Nat0    =  ()-numeric    
                                -- = { 0 .. maxunsigned }   
  Nat1    =  ()-numeric    
                                -- = { 1 .. maxunsigned } 
  Str     =  Char *       

  Vdmlib  =  ()-vdmlib     
                                -- internal ADT containing auxiliary routines 
                                -- for error reporting, program terminating,
                                -- operating system interface (.h files), ...

IMPLEMENTATIONS

#if defined(AUTOMEM_SEL)
#define DEFAULTS + default
#else
#define DEFAULTS
#endif

  Bool    = bool("ISBOOLTYPE") DEFAULTS

  Char    = unsigned("STRUCT"="CHARACTER1",
                 "ISPREDEFINEDPASCALTYPE","ISCHARTYPE") DEFAULTS

  Intg    = scalar("ISINTGTYPE") DEFAULTS

  Nat0    = unsigned("ISNAT0TYPE") DEFAULTS

  Nat1    = unsigned("LB"="1") DEFAULTS

#if defined(AUTOMEM_SEL)
  Str     = automem("BASEIMPL"="array(\"INTERNALDOMAIN\",\"SIMPLEELEMS\",\"ISCHAR\")","ISSTRING")
              + mkc + cpc
#else 
  Str     = array("SIMPLEELEMS","ISCHAR")
              + mkc + cpc
#endif
#undef DEFAULTS

  Vdmlib  = common


#ifndef GEN_DOCU
DOMAINS

  Niletc  =  ()-niletc         --  for C++ empty set, tuple, ... 

  Nat0    -> Bool              -- all types need Bool
  Nat1    -> Bool
  Intg    -> Bool
  Char    -> Bool
  Str     -> Niletc
  Bool    -> Vdmlib

IMPLEMENTATIONS

  Niletc  = sign

#endif

#endif
-----
cat >$OUT_DIR/stdlib/com/basic/version <<'-----'
$Revision: 1.101 $
$Date: 1996/09/19 09:25:46 $
-----
[ -d $OUT_DIR/stdlib/com/setup ] || mkdir $OUT_DIR/stdlib/com/setup
cat >$OUT_DIR/stdlib/com/setup/bb <<'-----'
#include <stdlib/aux/setup/com>

#ifndef __SETUPBB
#define __SETUPBB 1

/* define implementations */

#ifndef ADT1predef
#define IMPLEMENTATION1 IMPL1(IMPLPAR1)
#else
#define IMPLEMENTATION1
#endif

#ifndef ADT2predef
#define DOMAINEQ2 Elem = ADT2
#define IMPLEMENTATION2 IMPL2(IMPLPAR2)
#else
#define DOMAINEQ2
#define IMPLEMENTATION2
#endif

/* define predefined basic domain and basic test values */
#if isNat0

#define BASIC Nat0
#define _BASIC _nat0
#define aaa 411
#define bbb 42
#define ccc 6500
#define xxx 1
#define yyy 0
#define zzz 1000
#define ppp 10000
#define qqq 10001

#elif isNat1

#define BASIC Nat1
#define _BASIC _nat1
#define aaa 241
#define bbb 4442
#define ccc 3
#define xxx 1
#define yyy 2
#define zzz 777
#define ppp 7
#define qqq 77

#elif isIntg

#define BASIC Intg
#define _BASIC _intg
#define aaa 41
#define bbb -42
#define ccc 65000
#define xxx -5
#define yyy 0
#define zzz 777
#define ppp -7
#define qqq 77

#elif isChar

#define BASIC Char
#define _BASIC _char
#define aaa ' ' 
#define bbb '^'
#define ccc 'A'
#define xxx 'a'
#define yyy '1'
#define zzz '-'
#define ppp 'y'
#define qqq 'z'

#elif isStr

#define BASIC Str
#define _BASIC _str
#define aaa mkc_str("a")
#define bbb mkc_str("aa")
#define ccc mkc_str("1234567889")
#define xxx mkc_str("")
#define yyy mkc_str("1")
#define zzz mkc_str("Emil")
#define ppp mkc_str("aaaab")
#define qqq mkc_str("aaaaba")

#else

#define BASIC Nat0
#define _BASIC _nat0
#define aaa 255
#define bbb 256
#define ccc 257
#define xxx 0
#define yyy 1
#define zzz 777
#define ppp 7
#define qqq 77
#endif

#endif

-----
cat >$OUT_DIR/stdlib/com/setup/ccod <<'-----'

#include <stdlib/aux/setup/com>
#include <stdlib/com/setup/gcod>

CA
module generated from VDM Class Library 
#include <stdlib/com/basic/version>
CE

/*--- K&R vs. ANSI function definitions ---*/
#if GEN_ANSIC

#define _FP(N,T) T N
#define _EP(N,T) 
#define _FPH0() (void)
/*-- copied from 'gsig' ---*/
#define P_OP (
#define P_CL )

#else

#define _FP(N,T) N
#define _EP(N,T) T N;
#define _FPH0() ()
/*-- copied from 'gsig' ---*/
#define P_OP (CA
#define P_CL CE)

#endif

#define _FPH1(T1) (_FP(x1,T1)) _EP(x1,T1)
#define _FPH2(T1,T2) (_FP(x1,T1),_FP(x2,T2)) _EP(x1,T1) _EP(x2,T2)
#define _FPH3(T1,T2,T3) (_FP(x1,T1),_FP(x2,T2),_FP(x3,T3)) _EP(x1,T1) _EP(x2,T2) _EP(x3,T3)
#define _FPH4(T1,T2,T3,T4) (_FP(x1,T1),_FP(x2,T2),_FP(x3,T3),_FP(x4,T4)) _EP(x1,T1) _EP(x2,T2) _EP(x3,T3) _EP(x4,T4)
#define _FPH5(T1,T2,T3,T4,T5) (_FP(x1,T1),_FP(x2,T2),_FP(x3,T3),_FP(x4,T4),_FP(x5,T5)) _EP(x1,T1) _EP(x2,T2) _EP(x3,T3) _EP(x4,T4) _EP(x5,T5)
#define _FPH6(T1,T2,T3,T4,T5,T6) (_FP(x1,T1),_FP(x2,T2),_FP(x3,T3),_FP(x4,T4),_FP(x5,T5),_FP(x6,T6)) _EP(x1,T1) _EP(x2,T2) _EP(x3,T3) _EP(x4,T4) _EP(x5,T5) _EP(x6,T6)
#define _FPH7(T1,T2,T3,T4,T5,T6,T7) (_FP(x1,T1),_FP(x2,T2),_FP(x3,T3),_FP(x4,T4),_FP(x5,T5),_FP(x6,T6),_FP(x7,T7)) _EP(x1,T1) _EP(x2,T2) _EP(x3,T3) _EP(x4,T4) _EP(x5,T5) _EP(x6,T6) _EP(x7,T7)
-----
cat >$OUT_DIR/stdlib/com/setup/cmcr <<'-----'
#include <stdlib/com/setup/gcod>
-----
cat >$OUT_DIR/stdlib/com/setup/com <<'-----'
#include <stdlib/aux/setup/com>

/* -------------------------------------------------------*/

#if defined(GEN_MODULA) || defined(GEN_IMPORT)
#define IDF_(I) &_ I _&
#undef COMMENT_
#define COMMENT_(CC) (* CC *)
#define SUB_RANGE(L,U) [L .. U]
#define POINTER_TO(T) POINTER TO T
#define POINTER_TO_STRUCT(T) POINTER_TO(T)
#define TYPE_DEF(N,T)    IDF_(N) = IDF_(T);
#define START_ENUM_TYP(N) IDF_(N) = (
#define END_ENUM_TYP(N) );

#define CHARACTER CHAR
#define CHARACTER1 CHAR
#define BOOLTYPE BOOLEAN

#define MININT -2147483647
#define MAXINT 2147483647
#endif

/* -------------------------------------------------------*/

#ifdef GEN_PASCAL
#define IDF_(I) I
#undef COMMENT_
#define COMMENT_(CC) { CC }
#define SUB_RANGE(L,U) L .. U
#define POINTER_TO(T) ^T
#define POINTER_TO_STRUCT(T) POINTER_TO(T)
#define TYPE_DEF(N,T)    IDF_(N) = IDF_(T);
#define START_ENUM_TYP(N) IDF_(N) = (
#define END_ENUM_TYP(N) );

#define CHARACTER char
#define CHARACTER1 char
#define BOOLTYPE boolean

#define MININT -2147483647
#define MAXINT 2147483647
#endif

/* -------------------------------------------------------*/

#ifdef GEN_C
#define IDF_(I) I
#define SUB_RANGE(L,U)   DOMAIN: internal error: subrange [L .. U] not possible for C !
#define POINTER_TO(T) T *
#define POINTER_TO_STRUCT(T) struct T *
#define TYPE_DEF(N,T)    typedef IDF_(T) IDF_(N);
#define START_ENUM_TYP(N) enum IDF_(MERGE(_ENUM_,N)) {
#define END_ENUM_TYP(N) }; typedef enum IDF_(MERGE(_ENUM_,N)) IDF_(N);

#define CHARACTER unsigned char
#define CHARACTER1 char
#define BOOLTYPE unsigned char

#define MININT -2147483647
#define MAXINT 2147483647

#endif

/* -------------------------------------------------------*/

#ifdef GEN_IMPORT
#define IMP_SEP ,
#endif

/* signature macros --------------------------------------*/

#ifdef GEN_MODULA
#define FUNCDEC(FN,PL,RT) PROCEDURE IDF_(FN) EXTERNAL FN PL : IDF_(RT);
#define PROCDEC(FN,PL) PROCEDURE IDF_(FN) EXTERNAL FN PL;
#define PARAM(PN,PT) PN:IDF_(PT) 
#define REF_PARAM(PN,PT) VAR PN:IDF_(PT)

#define P_OP (
#define P_CL )
#define P_SEP ;
#endif

/* --------------------------------------------------------*/

#ifdef GEN_PASCAL

#ifdef GEN_SUNPASC
#define EXTERNAL_ external c
#else 
#define EXTERNAL_ EXTERN
#endif

#define FUNCDEC(FN,PL,RT) FUNCTION IDF_(FN) PL : IDF_(RT); EXTERNAL_;
#define PROCDEC(FN,PL) PROCEDURE IDF_(FN) PL; EXTERNAL_;
#define PARAM(PN,PT) PN:IDF_(PT) 
#define REF_PARAM(PN,PT) VAR PN:IDF_(PT)

#define P_OP (
#define P_CL )
#define P_SEP ;
#endif

/* --------------------------------------------------------*/

#ifdef GEN_C

/*--- always generating ANSI prototypes, commented out for non-ANSI ---*/

#define FUNCDEC(FN,PL,RT)    extern IDF_(RT) IDF_(FN) PL;
#define PROCDEC(FN,PL)    extern void IDF_(FN) PL;
#define PARAM(PN,PT) IDF_(PT) PN
#define REF_PARAM(PN,PT) IDF_(PT) *PN

#ifdef GEN_ANSIC
#define P_OP (
#define P_CL )
#else
#define P_OP (CA
#define P_CL CE)
#endif

#define P_SEP ,
#endif

/* --------------------------------------------------------*/

#ifdef GEN_IMPORT

#define FUNCDEC(FN,PL,RT)    IDF_(FN) IMP_SEP
#define PROCDEC(FN,PL)    IDF_(FN) IMP_SEP
#define PARAM(PN,PT) 
#define REF_PARAM(PN,PT)

#define P_OP 
#define P_CL
#define P_SEP 
#endif

/* --------------------------------------------------------*/

#ifdef GEN_PASCAL
#define PL_0()
#else
#if (defined(GEN_C) && defined(GEN_ANSIC))
#define PL_0() P_OP void P_CL
#else
#define PL_0() P_OP P_CL
#endif
#endif

#define PL_1(PT1) P_OP PARAM(x1,PT1) P_CL
#define PL_2(PT1,PT2) P_OP PARAM(x1,PT1) P_SEP PARAM(x2,PT2) P_CL
#define PL_3(PT1,PT2,PT3) P_OP PARAM(x1,PT1) P_SEP PARAM(x2,PT2) P_SEP PARAM(x3,PT3) P_CL
#define PL_4(PT1,PT2,PT3,PT4) P_OP PARAM(x1,PT1) P_SEP PARAM(x2,PT2) P_SEP PARAM(x3,PT3) P_SEP PARAM(x4,PT4) P_CL
#define PL_5(PT1,PT2,PT3,PT4,PT5) P_OP PARAM(x1,PT1) P_SEP PARAM(x2,PT2) P_SEP PARAM(x3,PT3) P_SEP PARAM(x4,PT4) P_SEP PARAM(x5,PT5) P_CL
#define PL_6(PT1,PT2,PT3,PT4,PT5,PT6) P_OP PARAM(x1,PT1) P_SEP PARAM(x2,PT2) P_SEP PARAM(x3,PT3) P_SEP PARAM(x4,PT4) P_SEP PARAM(x5,PT5) P_SEP PARAM(x6,PT6) P_CL

#define PL_R(PT1) P_OP REF_PARAM(x1,PT1) P_CL
#define PL_RV(PT1,PT2) P_OP REF_PARAM(x1,PT1) P_SEP PARAM(x2,PT2) P_CL
#define PL_VR(PT1,PT2) P_OP PARAM(x1,PT1) P_SEP REF_PARAM(x2,PT2) P_CL
#define PL_VVR(PT1,PT2,PT3) P_OP PARAM(x1,PT1) P_SEP PARAM(x2,PT2) P_SEP REF_PARAM(x3,PT3) P_CL
-----
cat >$OUT_DIR/stdlib/com/setup/gcod <<'-----'
#include <stdlib/com/setup/com>

#ifdef CROUTINES

/* function definitions */
#define _FDEC0(name,rt,body)	rt MERGE(name,_DOMAIN) _FPH0() { body; }
#define _FDEC1(name,rt,t1,body)	rt MERGE(name,_DOMAIN) _FPH1(t1) { body; }
#define _FDEC2(name,rt,t1,t2,body)	rt MERGE(name,_DOMAIN) _FPH2(t1,t2) { body; }
#define _FDEC3(name,rt,t1,t2,t3,body)	rt MERGE(name,_DOMAIN) _FPH3(t1,t2,t3) { body; }
#define _FDEC4(name,rt,t1,t2,t3,t4,body)	rt MERGE(name,_DOMAIN) _FPH4(t1,t2,t3,t4) { body; }
#define _FDEC5(name,rt,t1,t2,t3,t4,t5,body)	rt MERGE(name,_DOMAIN) _FPH5(t1,t2,t3,t4,t5) { body; }
#define _FDEC6(name,rt,t1,t2,t3,t4,t5,t6,body)	rt MERGE(name,_DOMAIN) _FPH6(t1,t2,t3,t4,t5,t6) { body; }
/* statements & expressions */
#define _RET(e)		return e
#define _SEQ(s1,s2)	s1;s2
#define _ICOMPSEL(r,c)	(r)->c
#define _DCOMPSEL(r,c)	(r).c

#else

/* macro definitions */
#define _FDEC0(name,rt,body)	_DEFINE MERGE(name,_DOMAIN)() (body)
#define _FDEC1(name,rt,t1,body)	_DEFINE MERGE(name,_DOMAIN)(x1) (body)
#define _FDEC2(name,rt,t1,t2,body)	_DEFINE MERGE(name,_DOMAIN)(x1,x2) (body)
#define _FDEC3(name,rt,t1,t2,t3,body)	_DEFINE MERGE(name,_DOMAIN)(x1,x2,x3) (body)
#define _FDEC4(name,rt,t1,t2,t3,t4,body)	_DEFINE MERGE(name,_DOMAIN)(x1,x2,x3,x4) (body)
#define _FDEC5(name,rt,t1,t2,t3,t4,t5,body)	_DEFINE MERGE(name,_DOMAIN)(x1,x2,x3,x4,x5) (body)
#define _FDEC6(name,rt,t1,t2,t3,t4,t5,t6,body)	_DEFINE MERGE(name,_DOMAIN)(x1,x2,x3,x4,x5,x6) (body)

/* statements & expressions */
#define _RET(e)		e
#define _SEQ(s1,s2)	s1;s2

#ifdef CMACROS

#define _ICOMPSEL(r,c)	(r)->c
#define _DCOMPSEL(r,c)	(r).c

#else

#define _ICOMPSEL(r,c)	^r.c
#define _DCOMPSEL(r,c)	r.c

#endif

#endif


#define _ALIAS_DV(name,ad)	_FDEC0(name,DOMAIN,_RET(MERGE(MERGE(name,_),ad)()))
#define _ALIAS_DD(name,ad)	_FDEC1(name,DOMAIN,DOMAIN,_RET(MERGE(MERGE(name,_),ad)(x1)))
#define _ALIAS_DDD(name,ad)	_FDEC2(name,DOMAIN,DOMAIN,DOMAIN,_RET(MERGE(MERGE(name,_),ad)(x1,x2)))
#define _ALIAS_VD(name,ad)	_FDEC1(name,void,DOMAIN,MERGE(MERGE(name,_),ad)(x1))
#define _ALIAS_ND(name,ad)	_FDEC1(name,Nat0,DOMAIN,MERGE(MERGE(name,_),ad)(x1))
#define _ALIAS_BD(name,ad)	_FDEC1(name,Bool,DOMAIN,MERGE(MERGE(name,_),ad)(x1))
#define _ALIAS_BDD(name,ad)	_FDEC2(name,Bool,DOMAIN,DOMAIN,MERGE(MERGE(name,_),ad)(x1))

-----
cat >$OUT_DIR/stdlib/com/setup/gcst <<'-----'
#include <stdlib/com/setup/com>

#if define(GEN_PASCAL) || defined(GEN_MODULA) || defined(GEN_IMPORT)
(*
module generated from VDM Class Library 
#include <stdlib/com/basic/version>
*)
#endif

#if defined(GEN_C)
CA
module generated from VDM Class Library 
#include <stdlib/com/basic/version>
CE
#endif

-----
cat >$OUT_DIR/stdlib/com/setup/gimp <<'-----'
#include <stdlib/com/setup/com>
-----
cat >$OUT_DIR/stdlib/com/setup/gptr <<'-----'
#include <stdlib/com/setup/com>

#if defined(GEN_C)
CA
module generated from VDM Class Library 
#include <stdlib/com/basic/version>
CE
#endif
-----
cat >$OUT_DIR/stdlib/com/setup/gtyp <<'-----'
#include <stdlib/com/setup/com>
#ifdef GEN_MODULA
#define FIELDSEP |
#define START_RECORD_TYP(N) IDF_(N) = RECORD
#define END_RECORD_TYP(N) END;
#define RECFIELD(N,T) IDF_(N) : IDF_(T)
#endif

#ifdef GEN_PASCAL
#define FIELDSEP ;
#define START_RECORD_TYP(N) IDF_(N) = RECORD
#define END_RECORD_TYP(N) END;
#define RECFIELD(N,T) IDF_(N) : IDF_(T)
#endif

#ifdef GEN_C
#define FIELDSEP ;
#define START_RECORD_TYP(N) struct IDF_(N) {
#define END_RECORD_TYP(N) };
#define RECFIELD(N,T) IDF_(T)	IDF_(N)

/*--- K&R vs. ANSI function definitions ---*/
#if GEN_ANSIC

#define _FP(N,T) T N
#define _EP(N,T) 
/*-- copied from 'gsig' ---*/
#define P_OP (
#define P_CL )

#else

#define _FP(N,T) N
#define _EP(N,T) T N;
/*-- copied from 'gsig' ---*/
#define P_OP (CA
#define P_CL CE)

#endif

#endif

-----
cat >$OUT_DIR/stdlib/com/setup/mmcr <<'-----'
#include <stdlib/com/setup/gcod>
-----
cat >$OUT_DIR/stdlib/com/setup/param <<'-----'
DUMMY_DEFINE
DUMMY_DEFINE_
GEN_ANSIC
GEN_C
GEN_CPLUS
GEN_IMPORT
GEN_MODULA
GEN_PASCAL
GEN_SUNPASC
-----
cat >$OUT_DIR/stdlib/com/setup/pmcr <<'-----'
#include <stdlib/com/setup/gcod>
-----
cat >$OUT_DIR/stdlib/com/setup/vdm <<'-----'

#include <stdlib/aux/setup/com>
#define _ADD_OP(dom,op)	DOMAINS IMPLEMENTATIONS dom = + op
-----
[ -d $OUT_DIR/stdlib/sign ] || mkdir $OUT_DIR/stdlib/sign
[ -d $OUT_DIR/stdlib/sign/basic ] || mkdir $OUT_DIR/stdlib/sign/basic
cat >$OUT_DIR/stdlib/sign/basic/cpp <<'-----'
#include <stdlib/aux/setup/com>
#ifdef DECL
_IFNDEF STDLIB_CL 
_DEFINE STDLIB_CL
class Cpp_DOMAIN {
#endif

-----
cat >$OUT_DIR/stdlib/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/stdlib/sign/post ] || mkdir $OUT_DIR/stdlib/sign/post
cat >$OUT_DIR/stdlib/sign/post/cpp <<'-----'
#ifdef DECL
};
_ENDIF
#endif
-----
[ -d $OUT_DIR/stdlib/sign/setup ] || mkdir $OUT_DIR/stdlib/sign/setup
cat >$OUT_DIR/stdlib/sign/setup/cpp <<'-----'
#include <stdlib/aux/setup/com>
#ifdef UPPER
#define Cpp_NAT0 NAT0 
#define Cpp_NAT1 NAT1
#define Cpp_BOOL BOOL
#define Cpp_INTG INTG
#define Cpp_STR STR
#define Cpp_CHAR CHAR
#define Cpp_DUMMY NILETC
#define Cpp_FREAD READF
#else
#define Cpp_NAT0 nat0
#define Cpp_NAT1 nat1
#define Cpp_BOOL bool
#define Cpp_INTG intg
#define Cpp_STR str
#define Cpp_CHAR chr
#ifdef ISCHARTYPE
#undef Cpp_DOMAIN
#define Cpp_DOMAIN Cpp_CHAR
#endif
#define Cpp_DUMMY niletc
#define Cpp_FREAD readf
#endif
#define Cpp_FWRITE writef
#define Cpp_EMPTY Cpp_DUMMY 
#define Cpp_NEW Cpp_DUMMY
#define Cpp_NIL Cpp_DUMMY
#define Cpp_MKLC Cpp_DUMMY
#define KPAR0() ()
#define KPAR1(t1) (t1 x1)
#define KPAR2(t1,t2) (t1 x1, t2 x2)
#define KPAR3(t1,t2,t3) (t1 x1, t2 x2, t3 x3)
#define KPARLIST0 ()
#define KPARLIST1 (x1.data)
#define KPARLIST2 (x1.data, x2.data)
#define KPARLIST3 (x1.data, x2.data, x3.data)
#define ALLWAYSCONST const
#ifdef MEMBERS    
#define FRIEND
#define CONSTFCT ALLWAYSCONST
#define FPAR1(t1)  ()
#define PPAR2(t1,x2) (x2)
#define PPAR3(t1,x2,x3) (x2, x3)
#define FPAR2(t1,t2) (t2 x2)
#define FPAR2a(t1,t2) (t2)
#define FPAR3(t1,t2,t3) (t2 x2, t3 x3)
#define SPAR2(t1,t2) (t1 x1)
#define SPAR3(t1,t2,t3) (t1 x1, t3 x3)
#define PPAR4(t1,x2,t3,t4) (x2, t3 x3, t4 x4)
#define DATA data
#define THIS *this
#define SCOPEOP(x) x
#else            
#define FRIEND friend
#define CONSTFCT
#define FPAR1(t1)  (t1 xx)
#define FPAR2(t1,t2) (t1 xx, t2 x2)
#define FPAR2a(t1,t2) (t1 xx, t2)
#define FPAR3(t1,t2,t3) (t1 xx, t2 x2, t3 x3)
#define SPAR2(t1,t2) (t1 x1, t2 xx)
#define SPAR3(t1,t2,t3) (t1 x1, t2 xx, t3 x3)
#define PPAR2(t1,x2) (t1 xx, x2)
#define PPAR3(t1,x2,x3) (t1 xx, x2, x3)
#define PPAR4(t1,x2,t3,t4) (t1 xx, x2, t3 x3, t4 x4)
#define DATA xx.data
#define THIS xx
#define SCOPEOP(x)
#endif
#define FPARLIST1 (DATA)
#define FPARLIST1a (&(DATA))
#define FPARLIST2 (DATA, x2.data)
#define FPARLIST3 (DATA, x2.data, x3.data)
#define FPARLIST3a (DATA, x2.lx1.data, x2.lx2.data)
#define RPARLIST2 (x2.data, DATA)
#define SPARLIST2 (x1.data, DATA)
#define SPARLIST21 (x1, DATA)
#define SPARLIST3 (x1.data, DATA, x3.data)

#define FUNCDEF0(Inline,Friend,Scope,Name,Params,Result,Const) Inline Friend Result Scope Name Params Const

#define FUNCDEF(Inline,Friend,Scope,Name,Params,Result) FUNCDEF0(Inline,Friend,Scope,Name,Params,Result,)
#define CFUNCDEF(Inline,Friend,Scope,Name,Params,Result) FUNCDEF0(Inline,Friend,Scope,Name,Params,Result,CONSTFCT)
#define CMFUNCDEF(Inline,Friend,Scope,Name,Params,Result) FUNCDEF0(Inline,Friend,Scope,Name,Params,Result,ALLWAYSCONST)

#if 0
#define IFUNCDEF(Friend,Scope,Name,Params,Result) FUNCDEF(INLINE,Friend,Scope,Name,Params,Result)
#define ICFUNCDEF(Friend,Scope,Name,Params,Result) CFUNCDEF(INLINE,Friend,Scope,Name,Params,Result)
#else
#define IFUNCDEF(Friend,Scope,Name,Params,Result) FUNCDEF(inline,Friend,Scope,Name,Params,Result)
#define ICFUNCDEF(Friend,Scope,Name,Params,Result) CFUNCDEF(inline,Friend,Scope,Name,Params,Result)
#endif


#define InlineNoFriendFct(Name,Params,Result) IFUNCDEF(NOFRIEND,SCOPE,Name,Params,Result)
#define InlineFriendFct(Name,Params,Result) IFUNCDEF(FRIENDFCT(FRIEND),SCOPEOP(SCOPE),Name,Params,Result)
#define InlineAllwaysFriendFct(Name,Params,Result) IFUNCDEF(FRIENDFCT(friend),,Name,Params,Result)

#define InlineNoFriendConstFct(Name,Params,Result) ICFUNCDEF(NOFRIEND,SCOPE,Name,Params,Result)
#define InlineFriendConstFct(Name,Params,Result) ICFUNCDEF(FRIENDFCT(FRIEND),SCOPEOP(SCOPE),Name,Params,Result)
#define InlineMemberConstFct(Name,Params,Result) CMFUNCDEF(INLINE,NOFRIEND,SCOPE,Name,Params,Result)

#ifdef DECL
#define FRIENDFCT(x) x
#define SCOPE
#ifndef RUMPF
#ifndef GEN_DOCU
#define RUMPF(x) ;
#else
#define RUMPF(x)
#endif
#endif
#define INLINE
#else
#define FRIENDFCT(x) 
#define SCOPE Cpp_DOMAIN ::
#define RUMPF(x) x
#define INLINE inline
#endif
#define NOFRIEND

#define BODY1a(Result,Name,Params) { return Result(Name Params);}
#define BODY2a(Name,Params) { DATA = Name Params; return THIS;}
#define BODY3a(Name,Params) { Name Params;}
#define BODY4a(Name,Params) { data = Name Params;}
#define BODY5a(Name,Params) { x1.data = Name Params; return x1;}

#define BODY1(Result,Name,Params)BODY1a(Result,MERGE(Name,_DOMAIN),Params)
#define BODY2(Name,Params)BODY2a(MERGE(Name,_DOMAIN),Params)
#define BODY3(Name,Params)BODY3a(MERGE(Name,_DOMAIN),Params)
#define BODY4(Name,Params)BODY4a(MERGE(Name,_DOMAIN),Params)
#define BODY5(Name,Params)BODY5a(MERGE(Name,_DOMAIN),Params)
#define BODY6(Name) { Cpp_DOMAIN tmp=THIS; tmp.data=MERGE(Name,_DOMAIN)(tmp.data,x2.data); return tmp; }
#define BODY7(Name,Params){ Cpp_DOMAIN tmp=THIS; BODY4a(MERGE(Name,_DOMAIN),Params); return tmp; }

#ifndef BASEIMPL
#define BODY2d(Name,Params)BODY2(Name,Params)
#else
#define BODY2d(Name,Params){MERGE(del,_DOMAIN)(data);BODY2(Name,Params)}
#endif
-----
cat >$OUT_DIR/stdlib/sign/setup/cppclass <<'-----'
#include <stdlib/aux/setup/com>

CA
module generated from VDM Class Library 
#include <stdlib/com/basic/version>
CE
-----
cat >$OUT_DIR/stdlib/sign/setup/defcpp <<'-----'
#undef DOMAIN
#undef RESULT
#undef DOMAINSET
#undef RANGESET
#undef INDEXSET
#undef ELEMSET
#undef COMP1
#undef COMP2

#define Cpp_DOMAIN DOMAIN
#define Cpp_ELEM ELEMENT
#define Cpp_ELEM1 ELEMENT1
#define Cpp_ELEM2 ELEMENT2
#define Cpp_ELEMN ELEMENTn
#define Cpp_VAR1 ELEMENT1
#define Cpp_VAR2 ELEMENT2
#define Cpp_COMP1 COMP1
#define Cpp_COMP2 COMP2
#define Cpp_RESULT RESULT
#define Cpp_SEL1 sel1
#define Cpp_SEL2 sel2
#define _Cpp_SEL1 _sel1
#define _Cpp_SEL2 _sel2
#define Cpp_COMP1 COMP1
#define Cpp_COMP2 COMP2
#define _Cpp_COMP1 _comp1
#define _Cpp_COMP2 _comp2
#define Cpp_FCTNAME fct
#define Cpp_DOMAINSET DOMAINSET
#define Cpp_RANGESET RANGESET
#define Cpp_INDEXSET INDEXSET
#define Cpp_ELEMSET ELEMSET
-----
cat >$OUT_DIR/stdlib/sign/setup/defp <<'-----'
#define DOMAIN Domain
#define _DOMAIN _domain
#define ELEM Element
#define _ELEM _element
#define ELEM1 Element1
#define _ELEM1 _element1
#define ELEM2 Element2
#define _ELEM2 _element2
#define ELEMN Elementn
#define _ELEMN _elementn
#define _SEL1 _sel1
#define _SEL2 _sel2
#define SEL1 sel1
#define SEL2 sel2
#define VAR1 Element1
#define _VAR1 _element1
#define VAR2 Element2
#define _VAR2 _element2
#define COMP1 Comp1
#define COMP2 Comp2
#define RESULT Result
#define _RESULT _result
#define FCTNAME fct
#define NULLFCT nullvalue
#define DOMAINSET Domainset
#define _DOMAINSET _domainset
#define RANGESET Rangeset
#define _RANGESET _rangeset
#define INDEXSET Indexset
#define _INDEXSET _indexset
#define ELEMSET Elemset
#define _ELEMSET _elemset
-----
cat >$OUT_DIR/stdlib/sign/setup/docu <<'-----'
#include <stdlib/sign/setup/gsig>

#define OPERATOR
#define MEMBERS
#define UPPER

#include <stdlib/sign/setup/cpp>

#undef RUMPF
#undef inline
#define inline  
#define RUMPF(x) 

#include <stdlib/sign/setup/defp>

#include <stdlib/sign/setup/hyper>
-----
cat >$OUT_DIR/stdlib/sign/setup/gsig <<'-----'
#include <stdlib/com/setup/com>
-----
cat >$OUT_DIR/stdlib/sign/setup/hyper <<'-----'
#ifdef GEN_HYPER

#define __HYPERLINK(l,w) <A VDMREF=MKSTRING(w)>l</A>
#define __IMAGELINK(alttxt,imgref) <IMG SRC=MKSTRING(imgref) ALT=MKSTRING(alttxt)>
#define __IMAGELINKALIGN(alttxt,imgref,align) <IMG SRC=MKSTRING(imgref) ALT=MKSTRING(alttxt) ALIGN=align>
#define __HYPERBIG(txt) <H3>txt</H3>
#define __HYPEREXAMPLE(l,r,e) <A EXAMPLE r=MKSTRING(e)>l</A>

#define __H(x) <x>
#define __Z(x) </x>

#define __TAG(tag,txt)<tag>txt</tag>
#define __EM(txt)__TAG(EM,txt)

/* all docu is currently written in <PRE> ... </PRE>, to generate normal HTML */
/* switch PRE of, at the end switch PRE on */

#define __HTMLON </PRE>
#define __HTMLOFF <PRE>

#else 

#define __HYPERLINK(l,w) l 
#define __IMAGELINK(alttxt,imgref) imagine MKSTRING(alttxt) here
#define __IMAGELINKALIGN(alttxt,imgref,align) imagine MKSTRING(alttxt) here
#define __HYPERBIG(txt) txt
#define __HYPEREXAMPLE(l,r,e) l

#define __H(x)
#define __Z(x)

#define __TAG(tag,txt)txt
#define __EM(txt)MKSTRING(txt)

#define __HTMLON
#define __HTMLOFF

#endif

#define __A(l,w)__HYPERLINK(l,w)
#define __SA(n)__A(MKSTRING(n),n)

#define __H1(txt)__TAG(H3,txt)
#define __H2(txt)__TAG(H3,txt)
#define __H3(txt)__TAG(H3,txt)
#define __H4(txt)__TAG(H3,txt)
#define __H5(txt)__TAG(H3,txt)
#define __H6(txt)__TAG(H3,txt)

#define __B(txt)__TAG(B,txt)
#define __VAR(txt)__TAG(VAR,txt)
#define __STRONG(txt)__TAG(STRONG,txt)
#define __CODE(txt)__TAG(CODE,txt)
#define __TT(txt)__TAG(TT,txt)

#define __BR __H(BR)
#define __P __H(P)
#define __HR __H(HR)

#define __PRE __H(PRE)
#define PRE__ __Z(PRE)

#define __UL __H(UL)
#define UL__ __Z(UL)

#define __OL __H(OL)
#define OL__ __Z(OL)

#define __DL __H(DL)
#define DL__ __Z(DL)

#define __LI __H(LI)
#define __DD __H(DD)
#define __DT __H(DT)

-----
[ -d $OUT_DIR/token ] || mkdir $OUT_DIR/token
[ -d $OUT_DIR/token/aux ] || mkdir $OUT_DIR/token/aux
[ -d $OUT_DIR/token/aux/basic ] || mkdir $OUT_DIR/token/aux/basic
cat >$OUT_DIR/token/aux/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Vdmlib
IMPLEMENTATIONS

-----
[ -d $OUT_DIR/token/aux/cvlines ] || mkdir $OUT_DIR/token/aux/cvlines
cat >$OUT_DIR/token/aux/cvlines/ccod <<'-----'
#ifndef format
#define format "%lu"
#endif

  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   { char  lx1[20];

     sprintf(lx1,format,(unsigned long)x1);
     return mk1_cvtext_vdmlib(mkc_str(lx1));
   }
#undef format
-----
cat >$OUT_DIR/token/aux/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  Vdmlib          = + cvtext + header("STDIO")
  Cvtext_vdmlib   = + mk1
  Str             = + mkc
-----
[ -d $OUT_DIR/token/aux/cvstr ] || mkdir $OUT_DIR/token/aux/cvstr
cat >$OUT_DIR/token/aux/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)

   Vdmlib   = + header("STDIO")
-----
[ -d $OUT_DIR/token/com ] || mkdir $OUT_DIR/token/com
[ -d $OUT_DIR/token/com/basic ] || mkdir $OUT_DIR/token/com/basic
cat >$OUT_DIR/token/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/token/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = TOKEN

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + new

   + copy1
   + copy

   + is_eq
   + is_gr
   + is_ge

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

-----
cat >$OUT_DIR/token/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Elem = TOKEN

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

-----
cat >$OUT_DIR/token/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>

#include <aux/com/basic/bbid1>

/*================================================================================================*/

   void p_@N@()
   { Domain newtest[99];
     int i,j;
     for(i=0; i<99; ++i)
       newtest[i]=D_ new##_domain();
     for(i=0; i<99; ++i)
       for(j=i+1; j<99; ++j)
         if(i != j)
           if( is_eq##_domain( newtest[i], newtest[j] ) )
             myerr(@n@,"new()","");
   DD }

/*================================================================================================*/

   void p_@N@()
   { Domain newvalue;
@(   newvalue = D_ @X@;
     if(! is_eq##_domain( D_ copy1##_domain(newvalue), newvalue ) )
       myerr(@n@,"copy1()","@X@");
@) DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { Domain newvalue;
@(   newvalue = D_ @X@;
     if(! is_eq##_domain( D_ copy##_domain(newvalue), newvalue ) )
       myerr(@n@,"copy()","@X@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   { Domain newvalue;
@(   newvalue = D_ @X@;
     if(! is_eq##_domain( newvalue, newvalue ) )
       myerr(@n@,"is_eq()","@X@,@X@");
@) DD }

#define ARG2 @Y@
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   { Domain newvalue;
@(   newvalue = D_ @X@;
     if( is_gr##_domain( newvalue, newvalue ) )
       myerr(@n@,"is_gr()","@X@,@X@");
@) DD }

   void p_@N@()
   { Domain newval1, newval2;
     newval1 = D_ @Y@;
     newval2 = D_ @Z@;
     if( is_gr##_domain( newval1,newval2 )
       && is_gr##_domain( newval2,newval1))
       myerr(@n@,"is_gr()","@Y@,@Z@");
   DD }

   void p_@N@()
   { Domain newval1, newval2;
     newval1 = D_ @Y@;
     newval2 = D_ @Z@;
     if( ! is_gr##_domain( newval1,newval2 )
       && ! is_gr##_domain( newval2,newval1))
       myerr(@n@,"is_gr()","@Y@,@Z@");
   DD }

/*================================================================================================*/

   void p_@N@()
   { Domain newvalue;
     Domain newvalue1;
     Str    tmp;
@(   newvalue = D_ @X@;
     tmp = cvtotupl##_domain(newvalue);
     newvalue1 = D_ cvfromtupl##_domain(tmp);
     if(! is_eq##_domain( newvalue1 , newvalue ) )
       myerr(@n@,"cvfromtupl(),cvtotupl()","@X@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   { Domain newvalue;
@(   newvalue = D_ @X@;
     if( ! is_eq_nat0(hash##_domain( newvalue ), hash##_domain( newvalue ) ))
       myerr(@n@,"hash()","@X@");
@) DD }

/*================================================================================================*/

#define REPEAT
#include <aux/com/del1/bbc2>

#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define REPEAT
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define REPEAT
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/token/com/basic/bbd1 <<'-----'
@X@=
new##_elem()
new##_elem()

@Y@=
new##_elem()

@Z@=
new##_elem()
-----
cat >$OUT_DIR/token/com/basic/bbd2 <<'-----'
@X@=
new##_domain()
new##_domain()

@Y@=
new##_domain()

@Z@=
new##_domain()
-----
cat >$OUT_DIR/token/com/basic/docu <<'-----'
Syntax:
  
  Token = TOKEN

Description:

  The 'token' constructor supplies a set of anonymous objects
  (tokens) for which only generation- and compare operations
  are defined. In contrast to the 'enum' constructor these elements
  are generated by a generator function and cannot be named
  explicitely.
  Tokens are usually represented by numbers or by addresses or pointers

Example:

  Record keys within a database systems can be implementd as tokens:

  Key = TOKEN

-----
[ -d $OUT_DIR/token/com/cvfromtup1 ] || mkdir $OUT_DIR/token/com/cvfromtup1
cat >$OUT_DIR/token/com/cvfromtup1/ccod <<'-----'
#include <aux/com/elemfromtup1/ccod>
-----
cat >$OUT_DIR/token/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/token/com/cvfromtup1/vdm <<'-----'
#include <aux/com/elemfromtup1/vdm>
-----
[ -d $OUT_DIR/token/com/cvtotup1 ] || mkdir $OUT_DIR/token/com/cvtotup1
cat >$OUT_DIR/token/com/cvtotup1/ccod <<'-----'
#include <aux/com/elemtotup1/ccod>
-----
cat >$OUT_DIR/token/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/token/com/cvtotup1/vdm <<'-----'
#include <aux/com/elemtotup1/vdm>
-----
[ -d $OUT_DIR/token/com/default ] || mkdir $OUT_DIR/token/com/default
cat >$OUT_DIR/token/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the token datatype the following set of operations is
  added

#include <token/com/default/vdm>
-----
cat >$OUT_DIR/token/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + new
-----
[ -d $OUT_DIR/token/com/is_gr ] || mkdir $OUT_DIR/token/com/is_gr
cat >$OUT_DIR/token/com/is_gr/ccod <<'-----'
#include <numeric/com/is_gr/ccod>
-----
cat >$OUT_DIR/token/com/is_gr/cmcr <<'-----'
#include <numeric/com/is_gr/cmcr>
-----
cat >$OUT_DIR/token/com/is_gr/pmcr <<'-----'
#include <numeric/com/is_gr/pmcr>
-----
[ -d $OUT_DIR/token/extern ] || mkdir $OUT_DIR/token/extern
[ -d $OUT_DIR/token/extern/basic ] || mkdir $OUT_DIR/token/extern/basic
cat >$OUT_DIR/token/extern/basic/ccod <<'-----'
-----
cat >$OUT_DIR/token/extern/basic/docu <<'-----'
  "Implementation" of an unspecified data type

  there is no code in the library for the basic
  operations. This code must be supplied by the
  application.

  But the interface information is generated as for
  an ordinary token data type.

  Interfaces can be generated for all token operations
  and all common operation (is_eq, copy, del, ...)

  This allows to model data types in the environment
  of the application with the Class Library interface

  all "available" operations in this "implementation" are
  dummys, to tell the class library generator program
  not to search for an implementation

  The structure of the data type can be defined by the
  parameter "CSTRUCT"

  Example:

  DOMAINS
    Stringptr = TOKEN

  IMPLEMENTATIONS
    Stringptr = extern(CSTRUCT="MyCharPtr")
              + is_eq + copy + del + new

  'Stringptr' is defined as a user supported type "MyCharPtr".

  To include own datatypes, see ADT __A("vdmlib",vdmlib.com.basic) and implementation
  parameter 'MYHEADER'

  If type 'MyCharPtr' is defined in a header file "myheader.h"
  include this header by the directive

  IMPLEMENTATIONS
    Vdmlib = common(MYHEADER="myheader.h")
-----
cat >$OUT_DIR/token/extern/basic/gptr <<'-----'
#if GEN_C
#ifdef CSTRUCT
#define LCSTRUCT CSTRUCT
#else
#define LCSTRUCT struct {}
#endif
TYPE_DEF(DOMAIN,LCSTRUCT)
#undef LCSTRUCT
#endif
-----
cat >$OUT_DIR/token/extern/basic/param <<'-----'
CSTRUCT
INTERNALDOMAIN
NOIMPLEMENTATIONS
NO_AUTOMEM
-----
cat >$OUT_DIR/token/extern/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Vdmlib
IMPLEMENTATIONS
  DOMAIN = extern("NOIMPLEMENTATIONS")
#include <token/aux/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TOKEN,IMPL_EXTERN
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/token/extern/copy ] || mkdir $OUT_DIR/token/extern/copy
cat >$OUT_DIR/token/extern/copy/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/copy1 ] || mkdir $OUT_DIR/token/extern/copy1
cat >$OUT_DIR/token/extern/copy1/* <<'-----'
-----
[ -d $OUT_DIR/token/extern/cvlines ] || mkdir $OUT_DIR/token/extern/cvlines
cat >$OUT_DIR/token/extern/cvlines/ccod <<'-----'
-----
cat >$OUT_DIR/token/extern/cvlines/docu <<'-----'
  the conversion function must be supported by the application
  with a similar functionality as the cvlines routines for numeric
  or string datatypes
-----
cat >$OUT_DIR/token/extern/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  Vdmlib          = + cvtext + header("STDIO")
  Cvtext_vdmlib   = + mk1
  Str             = + mkc
-----
[ -d $OUT_DIR/token/extern/default ] || mkdir $OUT_DIR/token/extern/default
cat >$OUT_DIR/token/extern/default/docu <<'-----'
#include <aux/com/default/docu>

  For the extern implementation of the token datatype no operation
  is added by default, even the new operation is not included,
  because values are constructed elsewhere and the token type
  only acts as a container type for storing arbitrary types
-----
cat >$OUT_DIR/token/extern/default/vdm <<'-----'
  -- nothing included by default
  -- even new is not included, because values are constructed
  -- elsewere, and not in the VDM code
  DOMAINS
  IMPLEMENTATIONS
-----
[ -d $OUT_DIR/token/extern/del ] || mkdir $OUT_DIR/token/extern/del
cat >$OUT_DIR/token/extern/del/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/del1 ] || mkdir $OUT_DIR/token/extern/del1
cat >$OUT_DIR/token/extern/del1/* <<'-----'
-----
[ -d $OUT_DIR/token/extern/fpr ] || mkdir $OUT_DIR/token/extern/fpr
cat >$OUT_DIR/token/extern/fpr/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/fread ] || mkdir $OUT_DIR/token/extern/fread
cat >$OUT_DIR/token/extern/fread/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/fwrite ] || mkdir $OUT_DIR/token/extern/fwrite
cat >$OUT_DIR/token/extern/fwrite/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/hash ] || mkdir $OUT_DIR/token/extern/hash
cat >$OUT_DIR/token/extern/hash/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/is_eq ] || mkdir $OUT_DIR/token/extern/is_eq
cat >$OUT_DIR/token/extern/is_eq/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/is_ge ] || mkdir $OUT_DIR/token/extern/is_ge
cat >$OUT_DIR/token/extern/is_ge/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/is_gr ] || mkdir $OUT_DIR/token/extern/is_gr
cat >$OUT_DIR/token/extern/is_gr/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/new ] || mkdir $OUT_DIR/token/extern/new
cat >$OUT_DIR/token/extern/new/ccod <<'-----'
-----
[ -d $OUT_DIR/token/extern/pr ] || mkdir $OUT_DIR/token/extern/pr
cat >$OUT_DIR/token/extern/pr/ccod <<'-----'
-----
[ -d $OUT_DIR/token/nat0 ] || mkdir $OUT_DIR/token/nat0
[ -d $OUT_DIR/token/nat0/basic ] || mkdir $OUT_DIR/token/nat0/basic
cat >$OUT_DIR/token/nat0/basic/docu <<'-----'
Implementation of TOKEN domain with natural numbers

a TOKEN value is represented as a natural number

  Parameters:
    'MACROS' : implementation of operations as macros
-----
cat >$OUT_DIR/token/nat0/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/token/nat0/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,Nat0)
-----
cat >$OUT_DIR/token/nat0/basic/param <<'-----'
INTERNALDOMAIN
MACROS
-----
cat >$OUT_DIR/token/nat0/basic/vdm <<'-----'
DOMAINS
  DOMAIN -> Nat0
IMPLEMENTATIONS

#include <token/aux/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TOKEN,IMPL_NAT0
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/token/nat0/cvlines ] || mkdir $OUT_DIR/token/nat0/cvlines
cat >$OUT_DIR/token/nat0/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   { char  lx1[50];

     sprintf(lx1,"%lu",(unsigned long)x1);
     return mk1_cvtext_vdmlib(mkc_str(lx1));
   }
-----
cat >$OUT_DIR/token/nat0/cvlines/docu <<'-----'
  the natural number in decimal representation is returned
-----
cat >$OUT_DIR/token/nat0/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  Vdmlib          = + cvtext + header("STDIO")
  Cvtext_vdmlib   = + mk1
  Str             = + mkc
-----
[ -d $OUT_DIR/token/nat0/cvstr ] || mkdir $OUT_DIR/token/nat0/cvstr
cat >$OUT_DIR/token/nat0/cvstr/ccod <<'-----'
#include <aux/com/cvstr/defp>

  RST FCTN##_DOMAIN _FPH1(DOMAIN)
   {char tf[10];
    sprintf(tf,"%lu",(unsigned long)x1);
    return MKC(tf);
   }

#include <aux/com/cvstr/undef>
-----
cat >$OUT_DIR/token/nat0/cvstr/docu <<'-----'
  the decimal representation of the natural number is returned
  in a string
-----
cat >$OUT_DIR/token/nat0/cvstr/param <<'-----'
AUTOMEMRESULT
-----
cat >$OUT_DIR/token/nat0/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)

   Vdmlib   = + header("STDIO")
-----
[ -d $OUT_DIR/token/nat0/hash ] || mkdir $OUT_DIR/token/nat0/hash
cat >$OUT_DIR/token/nat0/hash/ccod <<'-----'
  Nat0 hash##_DOMAIN _FPH1(DOMAIN) {return ((Nat0)x1);}
-----
cat >$OUT_DIR/token/nat0/hash/cmcr <<'-----'
_DEFINE hash##_DOMAIN(x1) ((Nat0)(x1)) 
-----
cat >$OUT_DIR/token/nat0/hash/docu <<'-----'
  hash function for TOKEN values represented as natural numbers
  the value itself is taken
-----
[ -d $OUT_DIR/token/nat0/new ] || mkdir $OUT_DIR/token/nat0/new
cat >$OUT_DIR/token/nat0/new/ccod <<'-----'
  DOMAIN new##_DOMAIN _FPH0()
   {static DOMAIN cnt = 0;
    return cnt++;
   }
-----
[ -d $OUT_DIR/token/nat0/parse ] || mkdir $OUT_DIR/token/nat0/parse
cat >$OUT_DIR/token/nat0/parse/ccod <<'-----'
#include <token/nat0/parse/gcod>
-----
cat >$OUT_DIR/token/nat0/parse/cmcr <<'-----'
#include <token/nat0/parse/gcod>
-----
cat >$OUT_DIR/token/nat0/parse/docu <<'-----'

  Syntax:  <number>

-----
cat >$OUT_DIR/token/nat0/parse/gcod <<'-----'
_FDEC0(parse,DOMAIN,_RET(parse_nat0()))
-----
cat >$OUT_DIR/token/nat0/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Nat0 = + parse
-----
[ -d $OUT_DIR/token/nat0/print ] || mkdir $OUT_DIR/token/nat0/print
cat >$OUT_DIR/token/nat0/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
   { print_FD_vdmlib << x1;}
_ELSE
   {fprintf(print_FD_vdmlib,"%lu",(unsigned long)x1);}
_ENDIF
-----
cat >$OUT_DIR/token/nat0/print/docu <<'-----'
  the decimal representation of the value is printed
-----
cat >$OUT_DIR/token/nat0/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/token/ptr ] || mkdir $OUT_DIR/token/ptr
[ -d $OUT_DIR/token/ptr/basic ] || mkdir $OUT_DIR/token/ptr/basic
cat >$OUT_DIR/token/ptr/basic/defp <<'-----'
#ifdef ELEM
#ifndef STRUCT
#define STRUCT POINTER_TO(ELEM)
#endif
#ifndef CSTRUCT
#define CSTRUCT POINTER_TO(ELEM)
#endif
#endif

#ifndef STRUCT
#define STRUCT POINTER_TO(CHARACTER1)
#endif
#ifndef CSTRUCT
#define CSTRUCT POINTER_TO(CHARACTER1)
#endif
-----
cat >$OUT_DIR/token/ptr/basic/docu <<'-----'
  Implementation of TOKEN as pointer.

  a TOKEN value is represented as an address

  Parameters:

  "ELEM": Optional parameter to change the base type of the pointer
	  type. Default value: 'char'

  If this implemetation is used in combination with maps
  and the heapmap implementation, "ELEM" must be defined with 
  the attribute name of the map domain. 
-----
cat >$OUT_DIR/token/ptr/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/token/ptr/basic/gptr <<'-----'
#ifdef GTYPEDEF
#include <token/ptr/basic/defp>

#ifdef GEN_C
  TYPE_DEF(DOMAIN,CSTRUCT)
#else
  TYPE_DEF(DOMAIN,STRUCT)
#endif
#undef CSTRUCT
#undef STRUCT
#endif
-----
cat >$OUT_DIR/token/ptr/basic/gtyp <<'-----'
#ifndef GTYPEDEF
#include <token/ptr/basic/defp>

#ifdef GEN_C
  TYPE_DEF(DOMAIN,CSTRUCT)
#else
  TYPE_DEF(DOMAIN,STRUCT)
#endif
#undef CSTRUCT
#undef STRUCT
#endif
-----
cat >$OUT_DIR/token/ptr/basic/param <<'-----'
CSTRUCT
ELEM
INTERNALDOMAIN
MACROS
NO_AUTOMEM
STRUCT
GTYPEDEF
-----
cat >$OUT_DIR/token/ptr/basic/vdm <<'-----'
#include <token/aux/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TOKEN,IMPL_PTR
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/token/ptr/cvlines ] || mkdir $OUT_DIR/token/ptr/cvlines
cat >$OUT_DIR/token/ptr/cvlines/ccod <<'-----'
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
   { char  lx1[50];

     sprintf(lx1,"%8lx",(unsigned long)x1);
     return mk1_cvtext_vdmlib(mkc_str(lx1));
   }
-----
cat >$OUT_DIR/token/ptr/cvlines/docu <<'-----'
  the hexadecimal representation of the internal address is returned
-----
cat >$OUT_DIR/token/ptr/cvlines/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   = PREDEF
IMPLEMENTATIONS
  Vdmlib          = + cvtext + header("STDIO")
  Cvtext_vdmlib   = + mk1
  Str             = + mkc
-----
[ -d $OUT_DIR/token/ptr/cvstr ] || mkdir $OUT_DIR/token/ptr/cvstr
cat >$OUT_DIR/token/ptr/cvstr/ccod <<'-----'
#include <aux/com/cvstr/defp>

  RST FCTN##_DOMAIN _FPH1(DOMAIN)
   {char tf[10];
    sprintf(tf,"%8lx",(unsigned long)x1);
    return MKC(tf);
   }

#include <aux/com/cvstr/undef>
-----
cat >$OUT_DIR/token/ptr/cvstr/docu <<'-----'
  the hexadecimal representation of the internal address is converted
  into a string
-----
cat >$OUT_DIR/token/ptr/cvstr/param <<'-----'
AUTOMEMRESULT
-----
cat >$OUT_DIR/token/ptr/cvstr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Str      = + mkc
              + automemresult.cvstr##_DOMAIN("ARGUMENT"=DOMAIN,"OPERATION"=cvstr)

   Vdmlib   = + header("STDIO")
-----
[ -d $OUT_DIR/token/ptr/del ] || mkdir $OUT_DIR/token/ptr/del
cat >$OUT_DIR/token/ptr/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN)
   { if (x1) FREEMEM_vdmlib(x1,sizeof(*x1)); }
-----
[ -d $OUT_DIR/token/ptr/del1 ] || mkdir $OUT_DIR/token/ptr/del1
cat >$OUT_DIR/token/ptr/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN)
   { if (x1) FREEMEM_vdmlib(x1,sizeof(*x1)); }
-----
[ -d $OUT_DIR/token/ptr/hash ] || mkdir $OUT_DIR/token/ptr/hash
cat >$OUT_DIR/token/ptr/hash/ccod <<'-----'
  Nat0 hash##_DOMAIN _FPH1(DOMAIN) {return ((Nat0)x1 >> 2);}
-----
cat >$OUT_DIR/token/ptr/hash/cmcr <<'-----'
_DEFINE hash##_DOMAIN(x1) (((Nat0)(x1)) >> 2) 
-----
cat >$OUT_DIR/token/ptr/hash/docu <<'-----'
  hash function for pointer types:

  the pointer is converted to an unsigned integer
  and shifted 2 bits to the rigth (pointers are usually aligned on
  4 byte boundaries).
-----
[ -d $OUT_DIR/token/ptr/new ] || mkdir $OUT_DIR/token/ptr/new
cat >$OUT_DIR/token/ptr/new/ccod <<'-----'
  DOMAIN new##_DOMAIN _FPH0()
   {
    return (DOMAIN)ALLOCMEM_vdmlib(sizeof(DOMAIN*));
   }
-----
[ -d $OUT_DIR/token/ptr/parse ] || mkdir $OUT_DIR/token/ptr/parse
cat >$OUT_DIR/token/ptr/parse/ccod <<'-----'
DOMAIN parse##_DOMAIN _FPH0()
  { err_uop_vdmlib("parse",#DOMAIN); }
-----
cat >$OUT_DIR/token/ptr/parse/docu <<'-----'

  input operation is not defined for pointer implementation.

-----
cat >$OUT_DIR/token/ptr/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
 Vdmlib = + err_uop
-----
[ -d $OUT_DIR/token/ptr/print ] || mkdir $OUT_DIR/token/ptr/print
cat >$OUT_DIR/token/ptr/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
   { print_FD_vdmlib << x1;}
_ELSE
   {fprintf(print_FD_vdmlib,"%8lx",(unsigned long)x1);}
_ENDIF
-----
cat >$OUT_DIR/token/ptr/print/docu <<'-----'
  the hexadecimal representation of the internal address is printed
-----
cat >$OUT_DIR/token/ptr/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/token/sign ] || mkdir $OUT_DIR/token/sign
[ -d $OUT_DIR/token/sign/basic ] || mkdir $OUT_DIR/token/sign/basic
cat >$OUT_DIR/token/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN { public:
    DOMAIN data;
    Cpp_DOMAIN            ()                      {}
    Cpp_DOMAIN            (DOMAIN x1)             { data = x1;                    }
    Cpp_DOMAIN & operator=(DOMAIN x1)             { data = x1;      return *this; }
    Cpp_DOMAIN            (const Cpp_DOMAIN & x1) { data = x1.data;               }
    Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1) { data = x1.data; return *this; }
                 operator DOMAIN() const          {                  return data; }

  /* access function for data field for conversion between C++ and C */
  /* for consistency reasons, operator DOMAIN would be sufficient */
  DOMAIN       cv##_DOMAIN() const              { return data;                  }
#endif

-----
cat >$OUT_DIR/token/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/token/sign/new ] || mkdir $OUT_DIR/token/sign/new
cat >$OUT_DIR/token/sign/new/cpp <<'-----'
#define T1 const Cpp_NEW &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(new,KPARLIST0))
#undef T1
-----
cat >$OUT_DIR/token/sign/new/gsig <<'-----'
  FUNCDEC(new##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/token/sign/new/vsig <<'-----'
  DCL elems := {} TYPE DOMAIN -set

  new() =
   let e1 be s.t. e1 ~ e C elems IN
    (elems := C elems U {e};
     return e
    ) 
  TYPE :   ==>  DOMAIN

  creation of a new value of DOMAIN that is never used before

#ifdef GEN_CPP
  In C++ this operation becomes a constructor with one parameter
  of auxiliary class NILETC

  Initialization with a new value is done
  in the form

    DOMAIN v = new_val;

  or

    DOMAIN v(new_val);

  __EM(new_val) is a special predefined object of the auxiliary class __EM(NILETC)
#endif
-----
[ -d $OUT_DIR/tree ] || mkdir $OUT_DIR/tree
[ -d $OUT_DIR/tree/automem ] || mkdir $OUT_DIR/tree/automem
[ -d $OUT_DIR/tree/automem/basic ] || mkdir $OUT_DIR/tree/automem/basic
cat >$OUT_DIR/tree/automem/basic/ccod <<'-----'
#include <aux/automem/basic/ccod>
-----
cat >$OUT_DIR/tree/automem/basic/docu <<'-----'
#define TYPGEN tree
#include <aux/automem/basic/docu>
-----
cat >$OUT_DIR/tree/automem/basic/gimp <<'-----'
#include <aux/automem/basic/gimp>
-----
cat >$OUT_DIR/tree/automem/basic/gptr <<'-----'
#include <aux/automem/basic/gptr>
-----
cat >$OUT_DIR/tree/automem/basic/gtyp <<'-----'
#include <aux/automem/basic/gtyp>
-----
cat >$OUT_DIR/tree/automem/basic/param <<'-----'
BASEIMPL
INTERNALDOMAIN
MACROS
NOCHECK
-----
cat >$OUT_DIR/tree/automem/basic/vdm <<'-----'
#ifndef BASEIMPL
#error *** Parameter 'BASEIMPL' is missing ***
#endif

#define MACRO1(C,C_,S,_S)  MERGE(s_rep,_S) : C

DOMAINS

  Rep##_DOMAIN  ::
#include <aux/com/macro1/ccod>

  Heap##_DOMAIN	= DOMAIN -heap
  DOMAIN -> Heap##_DOMAIN
  DOMAIN -> Rep##_DOMAIN
	
IMPLEMENTATIONS

  Rep##_DOMAIN  = BASEIMPL 
                + copy ! allways needed by function cond_clone() !
  Heap##_DOMAIN = freelist("INTERNALDOMAIN"
                          ,"MAXLEN"="100"
                          ,"PROFILE")
		+ alloc("STRUCT"="struct Handle" #_DOMAIN)
  DOMAIN        = + del ! always needed for destructor !
#ifndef NOCHECK
  Vdmlib        = + err_nv_hdl
#endif
  
#undef BASEIMPL
#undef NOCHECK

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/automem/cfold ] || mkdir $OUT_DIR/tree/automem/cfold
cat >$OUT_DIR/tree/automem/cfold/vdm <<'-----'
! === automem: Operation tree/cfold not supported === !
-----
[ -d $OUT_DIR/tree/automem/chg ] || mkdir $OUT_DIR/tree/automem/chg
cat >$OUT_DIR/tree/automem/chg/ccod <<'-----'
#ifdef GEN_ISO
#define _CCC(_S) MERGE(chg_s_rep,MERGE(_S,MERGE(_rep,_DOMAIN)))
#else
#define _CCC(_S) MERGE(chg_rep,MERGE(_S,MERGE(_rep,_DOMAIN)))
#endif
#define MACRO1(C,_C,S,_S)  DOMAIN MERGE(chg,_S)(_FP(x1,DOMAIN),_FP(x2,C))\
                           {\
                              MERGE(check_handle,_DOMAIN)(x1);\
                              MERGE(cond_clone,_DOMAIN)(&x1);\
                              x2 = MERGE(copy,_C)(x2);\
                              MERGE(del,_C)(TSNAME_REP(S,_S)(x1->f_rep));\
                              x1->f_rep = _CCC(_S) (x1->f_rep,x2);\
                              return x1;\
                            }
#include <aux/com/macro1/ccod>
#undef _CCC
-----
cat >$OUT_DIR/tree/automem/chg/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + chg

#define MACRO1(C,_C,S,_S)  C = + copy + del
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/automem/copy ] || mkdir $OUT_DIR/tree/automem/copy
cat >$OUT_DIR/tree/automem/copy/ccod <<'-----'
#include <aux/automem/copy/ccod>
-----
[ -d $OUT_DIR/tree/automem/copy1 ] || mkdir $OUT_DIR/tree/automem/copy1
cat >$OUT_DIR/tree/automem/copy1/vdm <<'-----'
! === automem: Operation tree/copy1 not supported === !
-----
[ -d $OUT_DIR/tree/automem/cvfromtup1 ] || mkdir $OUT_DIR/tree/automem/cvfromtup1
cat >$OUT_DIR/tree/automem/cvfromtup1/ccod <<'-----'
#include <aux/automem/cvfromtup1/ccod>
-----
cat >$OUT_DIR/tree/automem/cvfromtup1/param <<'-----'
#include <aux/automem/cvfromtup1/param>
-----
cat >$OUT_DIR/tree/automem/cvfromtup1/vdm <<'-----'
#include <aux/automem/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/tree/automem/cvfromtupl ] || mkdir $OUT_DIR/tree/automem/cvfromtupl
cat >$OUT_DIR/tree/automem/cvfromtupl/ccod <<'-----'
#include <aux/automem/cvfromtupl/ccod>
-----
cat >$OUT_DIR/tree/automem/cvfromtupl/param <<'-----'
#include <aux/automem/cvfromtupl/param>
-----
cat >$OUT_DIR/tree/automem/cvfromtupl/vdm <<'-----'
#include <aux/automem/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/tree/automem/cvlines ] || mkdir $OUT_DIR/tree/automem/cvlines
cat >$OUT_DIR/tree/automem/cvlines/ccod <<'-----'
#define NAME cvlines
#define RESULT Cvtext_vdmlib
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tree/automem/cvlines/cmcr <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tree/automem/cvlines/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
! Mit Hilfe des Parameters START_TXT wird der 'richtige' Domain-Name an die  !
! Routine cvlines der BASEIMPL uebergeben. Dies ist notwendig, da sonst      !
! mk_rep##_DOMAIN anstelle des gewuenschten mk##_DOMAIN im Ausgabetext auf-  !
! tritt                                                                      !
#ifdef GEN_ISO
#define START_STR MKSTRING(MERGE(mk_,DOMAIN))"("
#else
#define START_STR MKSTRING(MERGE(mk,_DOMAIN))"("
#endif
   Rep##_DOMAIN = + cvlines(START_TXT=START_STR)
-----
[ -d $OUT_DIR/tree/automem/cvtotup1 ] || mkdir $OUT_DIR/tree/automem/cvtotup1
cat >$OUT_DIR/tree/automem/cvtotup1/ccod <<'-----'
#include <aux/automem/cvtotup1/ccod>
-----
cat >$OUT_DIR/tree/automem/cvtotup1/param <<'-----'
#include <aux/automem/cvtotup1/param>
-----
cat >$OUT_DIR/tree/automem/cvtotup1/vdm <<'-----'
#include <aux/automem/cvtotup1/vdm>
-----
[ -d $OUT_DIR/tree/automem/cvtotupl ] || mkdir $OUT_DIR/tree/automem/cvtotupl
cat >$OUT_DIR/tree/automem/cvtotupl/ccod <<'-----'
#include <aux/automem/cvtotupl/ccod>
-----
cat >$OUT_DIR/tree/automem/cvtotupl/param <<'-----'
#include <aux/automem/cvtotupl/param>
-----
cat >$OUT_DIR/tree/automem/cvtotupl/vdm <<'-----'
#include <aux/automem/cvtotupl/vdm>
-----
[ -d $OUT_DIR/tree/automem/del ] || mkdir $OUT_DIR/tree/automem/del
cat >$OUT_DIR/tree/automem/del/ccod <<'-----'
#include <aux/automem/del/ccod>
-----
cat >$OUT_DIR/tree/automem/del/vdm <<'-----'
#include <aux/automem/del/vdm>
-----
[ -d $OUT_DIR/tree/automem/del1 ] || mkdir $OUT_DIR/tree/automem/del1
cat >$OUT_DIR/tree/automem/del1/vdm <<'-----'
! === automem: Operation tree/del1 not required === !
-----
[ -d $OUT_DIR/tree/automem/gcinfo ] || mkdir $OUT_DIR/tree/automem/gcinfo
cat >$OUT_DIR/tree/automem/gcinfo/ccod <<'-----'
#define Handle Nat0

/* get_gc_info1##_DOMAIN returns 0, if DOMAIN is no automem implementation */

#define MACRO1(C,_C,S,_S) my_hdl = MERGE(get_gc_info1,_C)(TSNAME_REP(S,_S)(x1->f_rep),x2);\
                          if (my_hdl!=0) my_handles = union1_handles(my_handles,my_hdl);

Handle get_gc_info1##_DOMAIN(DOMAIN x1, Adts * x2)
{
   if (!is_in_adts((Handle)x1, *x2))
   {
      Adt     my_adt;
      Handle  my_hdl;
      Handles my_handles = mk_empty_handles();

#include <aux/com/macro1/ccod>

      /* We have to manipulate the reference counter of my_handles and my_adt
         manually because the called operations were designed to be called
         from C++ and not C ! */
_IFDEF AUTOMEM_handles
      my_handles->f_rc = 0;
_ENDIF
      my_adt = mk_adt(x1->f_rc,my_handles);
_IFDEF AUTOMEM_adt
     my_adt->f_rc = 0;
_ENDIF
      *x2    = union1_adts(*x2, (Handle) x1, my_adt);
   }
   return (Handle) x1;      
}

Adts get_gc_info##_DOMAIN(DOMAIN x1)
{
   check_handle##_DOMAIN(x1);
   Adts lx1 = mk_empty_adts();
   (void) get_gc_info1##_DOMAIN(x1, &lx1);
   return lx1;
}

#undef Handle
-----
cat >$OUT_DIR/tree/automem/gcinfo/docu <<'-----'
#include <aux/automem/gcinfo/docu>
-----
cat >$OUT_DIR/tree/automem/gcinfo/vdm <<'-----'
#define MACRO1(C,_C,S,_S) C = + gcinfo

DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + s
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/automem/hash ] || mkdir $OUT_DIR/tree/automem/hash
cat >$OUT_DIR/tree/automem/hash/ccod <<'-----'
#define NAME hash
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tree/automem/hash/cmcr <<'-----'
#define NAME hash
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tree/automem/hash/vdm <<'-----'
#define NAME hash
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tree/automem/input ] || mkdir $OUT_DIR/tree/automem/input
cat >$OUT_DIR/tree/automem/input/vdm <<'-----'
! === automem: Operation tree/input not supported === !
-----
[ -d $OUT_DIR/tree/automem/is_eq ] || mkdir $OUT_DIR/tree/automem/is_eq
cat >$OUT_DIR/tree/automem/is_eq/ccod <<'-----'
#define NAME is_eq
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tree/automem/is_eq/cmcr <<'-----'
#define NAME is_eq
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tree/automem/is_eq/vdm <<'-----'
#define NAME is_eq
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tree/automem/is_ge ] || mkdir $OUT_DIR/tree/automem/is_ge
cat >$OUT_DIR/tree/automem/is_ge/ccod <<'-----'
#define NAME is_ge
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tree/automem/is_ge/cmcr <<'-----'
#define NAME is_ge
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tree/automem/is_ge/vdm <<'-----'
#define NAME is_ge
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tree/automem/is_gr ] || mkdir $OUT_DIR/tree/automem/is_gr
cat >$OUT_DIR/tree/automem/is_gr/ccod <<'-----'
#define NAME is_gr
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tree/automem/is_gr/cmcr <<'-----'
#define NAME is_gr
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tree/automem/is_gr/vdm <<'-----'
#define NAME is_gr
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tree/automem/mk ] || mkdir $OUT_DIR/tree/automem/mk
cat >$OUT_DIR/tree/automem/mk/ccod <<'-----'
#define MACRO1(C,_C,S,_S)  _FP(MERGE(x,_S),C)
#define MACRO0 ,

DOMAIN mk##_DOMAIN(
#include <aux/com/macro1/ccod>
)
{
   DOMAIN l = alloc##_DOMAIN();
   l->f_rc  = 1;
#define MACRO1(C,_C,S,_S)  MERGE(x,_S) = MERGE(copy,_C)( MERGE(x,_S) );
#include <aux/com/macro1/ccod>
#define MACRO1(C,_C,S,_S) MERGE(x,_S)
#define MACRO0 ,
   l->f_rep = mk_rep##_DOMAIN(
#include <aux/com/macro1/ccod>
);
   return l;
}
-----
cat >$OUT_DIR/tree/automem/mk/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + mk
#define MACRO1(C,_C,S,_S)   C = + copy
#include <aux/com/macro1/ccod>

#define CONSTRNAME mk
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/automem/parse ] || mkdir $OUT_DIR/tree/automem/parse
cat >$OUT_DIR/tree/automem/parse/ccod <<'-----'
#include <aux/automem/parse/ccod>
-----
cat >$OUT_DIR/tree/automem/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
! Mit Hilfe der Parameter (L)DOMNAME wird der 'richtige' Domainname an die !
! Routine parse der BASEIMPL uebergeben. Dies ist notwendig, da bei der    !
! Eingabe sonst mk_rep##_DOMAIN anstelle von mk##_DOMAIN erwartet wuerde.  !
   Rep##_DOMAIN = + parse("DOMNAME"=#DOMAIN, "LDOMNAME"=#_DOMAIN)
-----
[ -d $OUT_DIR/tree/automem/pr ] || mkdir $OUT_DIR/tree/automem/pr
cat >$OUT_DIR/tree/automem/pr/vdm <<'-----'
! === automem: Operation tree/pr not supported === !
-----
[ -d $OUT_DIR/tree/automem/s ] || mkdir $OUT_DIR/tree/automem/s
cat >$OUT_DIR/tree/automem/s/ccod <<'-----'
#define MACRO1(C,_C,S,_S)  C TSNAME(S,_S)(_FP(x1,DOMAIN))\
			   {\
			      MERGE(check_handle,_DOMAIN)(x1);\
                              return MERGE(copy,_C)(TSNAME_REP(S,_S)(x1->f_rep));\
			   }
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/automem/s/cmcr <<'-----'
#define MACRO1(C,_C,S,_S)  _DEFINE TSNAME(S,_S)(x1) \
                              MERGE(copy,_C)(TSNAME_REP(S,_S)(x1->f_rep))
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/automem/s/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + s
#define MACRO1(C,_C,S,_S)  C = + copy
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/automem/sfold ] || mkdir $OUT_DIR/tree/automem/sfold
cat >$OUT_DIR/tree/automem/sfold/vdm <<'-----'
! === automem: Operation tree/sfold not supported === !
-----
[ -d $OUT_DIR/tree/automem/smk ] || mkdir $OUT_DIR/tree/automem/smk
cat >$OUT_DIR/tree/automem/smk/ccod <<'-----'
void smk##_DOMAIN(_FP(x1,DOMAIN),
#define MACRO1(C,_C,S,_S)    _FP(MERGE(x1,_S),C *)
#define MACRO0  ,
#include <aux/com/macro1/ccod>
)
{
   check_handle##_DOMAIN(x1);        
#define MACRO1(C,_C,S,_S)    MERGE(del,_C)(MERGE(*x1,_S));\
                             (* MERGE(x1,_S)) = MERGE(copy,_C)(TSNAME_REP(S,_S)(x1->f_rep));
#include <aux/com/macro1/ccod>
}
-----
cat >$OUT_DIR/tree/automem/smk/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + s
#define MACRO1(C,_C,S,_S)  C = + copy + del
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/automem/subst ] || mkdir $OUT_DIR/tree/automem/subst
cat >$OUT_DIR/tree/automem/subst/README <<'-----'
The operation 'subst' is implemented as C++ member function by using 'chg' !
Please refer to  tree/sign/subst/cpp for more information.
-----
cat >$OUT_DIR/tree/automem/subst/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN = + chg
-----
[ -d $OUT_DIR/tree/aux ] || mkdir $OUT_DIR/tree/aux
[ -d $OUT_DIR/tree/aux/basic ] || mkdir $OUT_DIR/tree/aux/basic
cat >$OUT_DIR/tree/aux/basic/vdm <<'-----'

DOMAINS
  DOMAIN -> Vdmlib	! Needed if tree is empty !
IMPLEMENTATIONS
-----
[ -d $OUT_DIR/tree/aux/fold ] || mkdir $OUT_DIR/tree/aux/fold
cat >$OUT_DIR/tree/aux/fold/ccod <<'-----'
#ifndef RESULT
  DOMAIN: the implementation parameter RESULT must be specified
#endif
#include <aux/com/folda/ccod>
#include <aux/com/folda/gtyp>

  RESULT FCTNAME##_DOMAIN(_FP(x1,DOMAIN) PX PY PZ)
      _EP(x1,DOMAIN) tPX tPY tPZ
   {RESULT lr1 = NULLFCT##_RESULT();
   
#define MACRO1(C,_C,S,_S)    lr1 = MERGE(FOLDFCT,_RESULT)(lr1,CONF(_C,S,_S) lPY lPZ);
#include <aux/com/macro1/ccod>

    return lr1;
   }
#undef CONF
#include <aux/com/folde/ccod>
-----
cat >$OUT_DIR/tree/aux/fold/docu <<'-----'

  parameters :
   "RESULT"   :
                the domain of the result type (must be given!)
   "NULLFCT"  :
                the name of a constant function
                which determines the value of an empty tree
   "FOLDFCT"  :
                the name of a binary function defined on the domain RESULT
   "CVFCT"    :
                the name of a conversion function from ELEMi to RESULT
                (optional)
                'cfold' and 'sfold' differ in the naming convention for these 
                functions.
                  cfold:
                   for each tree component the name is expanded with the name of 
                   the element domain
                  sfold:
                   for each tree component the name is expanded with the name of 
                   the appropriate selector function
                default is the identity function (this assumes RESULT =
                ELEM1 = .. = ELEMn)


   examples :
      See fold functions for __A(maps,map.com.fold), __A(tuples,tupl.com.fold) or __A(sets,set.com.fold).
-----
cat >$OUT_DIR/tree/aux/fold/gsig <<'-----'
#ifndef RESULT
  DOMAIN: the implementation parameter RESULT must be specified
#endif
#include <aux/sign/fold/gsig>
-----
cat >$OUT_DIR/tree/aux/fold/vdm <<'-----'
#include <aux/com/folda/ccod>
DOMAINS
   DOMAIN   -> RESULT
IMPLEMENTATIONS
  DOMAIN = + s
#include <aux/com/folde/ccod>
-----
cat >$OUT_DIR/tree/aux/fold/vsig <<'-----'
  fold(x11,x12,...,x1n,x2,x3)(y1) =
     x3( x2
       , x3( x11(s_e1(y1))
           , x3( x12(s_e2(y1))
               , x3( ...
                   , x1n(s_en(y1)) ... ))))
  TYPE : (Elem1         --> RESULT)
         (Elem2         --> RESULT)
           ... 
         (Elemn         --> RESULT)
         (              --> RESULT)
         (RESULT RESULT --> RESULT)
         -->
         (DOMAIN  --> RESULT)

  __EM(fold) is a functional (a function returning another function as result) analog
  to the fold functions for sets, maps and tuples.
  With help of this functional functions on the tuple DOMAIN can be defined
  with the help of functions defined on the element type Elem1, ..., Elemn.
  fold returns a function from DOMAIN to RESULT.
  fold is evaluated at module generation time.

  __EM(fold) comes in two flavours, called __SA(cfold) and __SA(ffold). They differ in the
  naming conventions for the conversion functions x11 .. x1n.

  Example : No simple and expressive example found yet. The main use lies
            in the handling of trees from function generated automatically,
            i.e. as part of other implementations.

-----
[ -d $OUT_DIR/tree/com ] || mkdir $OUT_DIR/tree/com
[ -d $OUT_DIR/tree/com/basic ] || mkdir $OUT_DIR/tree/com/basic
cat >$OUT_DIR/tree/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/tree/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain1 ::
   s_t1_1: Elem

Domain2 ::
   s_t2_1: Elem
   s_t2_2: BASIC

Domain5 ::
   s_t5_1: Elem
   s_t5_2: BASIC
   s_t5_3: Elem
   s_t5_4: BASIC
   s_t5_5: Elem

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain1 = IMPLEMENTATION1

   + mk

   + copy1
   + copy
   + chg
   + subst
   + s
   + smk

   + is_eq
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + cfold.cf(RESULT=Bool,NULLFCT="cnullf",CVFCT="ccvf",FOLDFCT="cfoldf",
              X=Elem,XX=BASIC,XXX=Bool)
   + sfold.sf(RESULT=Bool,NULLFCT="snullf",CVFCT="scvf",FOLDFCT="sfoldf",
              X=Elem,XX=BASIC,XXX=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

Domain2 = IMPLEMENTATION1

   + mk

   + copy1
   + copy
   + chg
   + subst
   + s
   + smk

   + is_eq
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + cfold.cf(RESULT=Bool,NULLFCT="cnullf",CVFCT="ccvf",FOLDFCT="cfoldf",
              X=Elem,XX=BASIC,XXX=Bool)
   + sfold.sf(RESULT=Bool,NULLFCT="snullf",CVFCT="scvf",FOLDFCT="sfoldf",
              X=Elem,XX=BASIC,XXX=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

Domain5 = IMPLEMENTATION1

   + mk

   + copy1
   + copy
   + chg
   + subst
   + s
   + smk

   + is_eq
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + cfold.cf(RESULT=Bool,NULLFCT="cnullf",CVFCT="ccvf",FOLDFCT="cfoldf",
              X=Elem,XX=BASIC,XXX=Bool)
   + sfold.sf(RESULT=Bool,NULLFCT="snullf",CVFCT="scvf",FOLDFCT="sfoldf",
              X=Elem,XX=BASIC,XXX=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

-----
cat >$OUT_DIR/tree/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Elem ::
   s_t_1: BASIC
   s_t_2: BASIC

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + mk

   + is_eq
   + is_gr
   + is_ge

-----
cat >$OUT_DIR/tree/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#if 0
/*vorlaeufig noch nicht vollstaendig */
Btree d_array[99];
int Di = 0;

#define D_ d_array[Di++]=
#define DD while(Di){ --Di; del_btree(d_array[Di]); }

Btree e_array[99];
int Ei = 0;

#define E_ e_array[Ei++]=
#define EE while(Ei){ --Ei; del_btree(e_array[Ei]); }
#else
#define D_
#define DD
#define E_
#define EE
#endif

/*================================================================================================*/

#define tree1(elem)        MERGE(mk,_domain1)(elem)
#define tree2(elem1,elem2) MERGE(mk,_domain2)(elem1,elem2)
#define tree5(elem1,elem2) MERGE(mk,_domain5)(elem1,elem2,elem1,elem2,elem1)

/*================================================================================================*/

Bool cnullf_bool ()

{ return(TRUE); }

/*------------------------------------------------------------------------------------------------*/

Bool ccvf##_elem ( elem, vx, vxx, vxxx )

  Elem elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return is_eq##_elem( elem, vx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ccvf##_BASIC ( elem, vx, vxx, vxxx )

  BASIC elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return ( elem == vxx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool cfoldf_bool ( result1, result2 )

  Bool result1, result2;

{ return ( result1 == TRUE ) && ( result2 == TRUE ); }

/*================================================================================================*/

Bool snullf_bool ()

{ return(TRUE); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t1_1 ( elem, vx, vxx, vxxx )

  Elem elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return is_eq##_elem( elem ,vx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t2_1 ( elem, vx, vxx, vxxx )

  Elem elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return is_eq##_elem( elem ,vx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t2_2 ( elem, vx, vxx, vxxx )

  BASIC elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return ( elem == vxx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t5_1 ( elem, vx, vxx, vxxx )

  Elem elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return is_eq##_elem( elem ,vx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t5_2 ( elem, vx, vxx, vxxx )

  BASIC elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return ( elem == vxx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t5_3 ( elem, vx, vxx, vxxx )

  Elem elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return is_eq##_elem( elem ,vx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t5_4 ( elem, vx, vxx, vxxx )

  BASIC elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return ( elem == vxx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool scvf_t5_5 ( elem, vx, vxx, vxxx )

  Elem elem;
  Elem vx; BASIC vxx; Bool vxxx;

{ return is_eq##_elem( elem ,vx ) && ( vxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool sfoldf_bool ( result1, result2 )

  Bool result1, result2;

{ return ( result1 == TRUE ) && ( result2 == TRUE ); }

#include <aux/com/basic/bbid2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! ( is_eq##_elem( s_t1_1( D_ tree1(@X@) ), E_ @X@ ) ) )
       myerr(@n@,"mk()","@X@");
@) DD EE }

/*================================================================================================*/

#define ARG tree1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG tree1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain1( chg_t1_1( D_ tree1(@Y@), E_ @X@ ), D_ tree1(@X@) ) )
       myerr(@n@,"chg_t1_1()","@Y@, @X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain1( subst_t1_1( D_ tree1(@Y@), @X@ ), D_ tree1(@X@) ) )
       myerr(@n@,"subst_t1_1()","@Y@, @X@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_t1_1( D_ tree1(@X@) ), E_ @X@ ) )
       myerr(@n@,"s_t1_1()","@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { Elem elem;
@(   smk##_domain1( D_ tree1(@X@), &elem );
     if(! is_eq##_elem( elem, E_ @X@ ) )
       myerr(@n@,"smk()","@X@");
@) DD EE }

/*================================================================================================*/

#define ARG tree1(@X@)
#define REPEAT
#define NO 1
#include <aux/com/is_eq/bbc2>

#define ARG tree1(@X@)
#define ARG2 tree1(@Y@)
#define NO 1
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain1( D_ tree1(@Y@), D_ tree1(@Y@) ) )
       myerr(@n@,"is_gr()","@Y@, @Y@");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain1( D_ tree1(@Y@), D_ tree1(@Z@) ) )
       myerr(@n@,"is_gr()","@Y@, @Z@");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain1( D_ tree1(@Z@), D_ tree1(@Y@) ) )
       myerr(@n@,"is_gr()","@Z@, @Y@");
   DD }
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain1( D_ tree1(@Y@), D_ tree1(@Y@) ) )
       myerr(@n@,"is_ge()","@Y@, @Y@");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain1( D_ tree1(@Y@), D_ tree1(@Z@) ) )
       myerr(@n@,"is_ge()","@Y@, @Z@");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain1( D_ tree1(@Z@), D_ tree1(@Y@) ) )
       myerr(@n@,"is_ge()","@Z@, @Y@");
   DD }
  
#endif
/*================================================================================================*/

   void p_@N@()
   {
@(   if( cf##_domain1( D_ tree1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cfold-Funktional cf()","@X@");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( sf##_domain1( D_ tree1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sfold-Funktional sf()","@X@");
@) DD }

/*================================================================================================*/

#define ARG tree1(@X@)
#define NO 1
#define REPEAT
#define DOMAIN_ Domain1
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG tree1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG tree1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG tree1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG tree1(@X@)
#define REPEAT
#define NO 1
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG tree1(@X@)
#define REPEAT
#define NO 1
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG tree1(@X@)
#define REPEAT
#define NO 1
#include <aux/com/fpr/bbc2>

/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"\n<the end> of TREE1\n");
   }

/*================================================================================================*/
/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"<start> of TREE2\n\n");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_t2_1( D_ tree2(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"mk() /1","@X@,aaa");
     if( s_t2_2( D_ tree2(@X@,aaa) ) != aaa )
       myerr(@n@,"mk() /2","@X@,aaa");
@) DD EE }

/*================================================================================================*/

#define ARG tree2(@X@,aaa)
#define NO 2
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG tree2(@X@,aaa)
#define NO 2
#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain2( chg_t2_1( D_ tree2(@Y@,aaa), E_ @X@ ), D_ tree2(@X@,aaa) ) )
       myerr(@n@,"chg_t2_1()","@Y@,aaa, @X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain2( chg_t2_2( D_ tree2(@X@,aaa), bbb ), D_ tree2(@X@,bbb) ) )
       myerr(@n@,"chg_t2_2()","@X@,aaa, bbb");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain2( D_ subst_t2_1( tree2(@Y@,aaa), @X@ ), D_ tree2(@X@,aaa) ) )
       myerr(@n@,"subst_t2_1()","@Y@,aaa, @X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain2( subst_t2_2( D_ tree2(@X@,aaa), bbb ), D_ tree2(@X@,bbb) ) )
       myerr(@n@,"subst_t2_2()","@X@,aaa, bbb");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_t2_1( D_ tree2(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"s_t2_1()","@X@,aaa");
     if( s_t2_2( D_ tree2(@X@,aaa) ) != aaa )
       myerr(@n@,"s_t2_2()","@X@,aaa");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { Elem elem1;
     BASIC elem2;
@(   smk##_domain2( D_ tree2(@X@,aaa), &elem1, &elem2 );
     if(! is_eq##_elem( elem1, E_ @X@ ) )
       myerr(@n@,"smk() /1","@X@");
     if( elem2 != aaa )
       myerr(@n@,"smk() /2","aaa");
@) DD EE }

/*================================================================================================*/

#define ARG tree2(@X@,aaa)
#define REPEAT
#define NO 2
#include <aux/com/is_eq/bbc2>

#define ARG tree2(@X@,aaa)
#define ARG2 tree2(@Y@,aaa)
#define NO 2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG tree2(@X@,aaa)
#define ARG2 tree2(@X@,bbb)
#define NO 2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG tree2(@X@,aaa)
#define ARG2 tree2(@Y@,bbb)
#define NO 2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain2( D_ tree2(@Y@,aaa), D_ tree2(@Y@,aaa) ) )
       myerr(@n@,"is_gr()","@Y@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain2( D_ tree2(@Y@,aaa), D_ tree2(@Z@,aaa) ) )
       myerr(@n@,"is_gr()","@Y@,aaa, @Z@,aaa");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain2( D_ tree2(@Z@,aaa), D_ tree2(@Y@,aaa) ) )
       myerr(@n@,"is_gr()","@Z@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain2( D_ tree2(@Y@,aaa), D_ tree2(@Y@,bbb) ) )
       myerr(@n@,"is_gr()","@Y@,aaa, @Y@,bbb");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain2( D_ tree2(@Y@,bbb), D_ tree2(@Y@,aaa) ) )
       myerr(@n@,"is_gr()","@Y@,bbb, @Y@,aaa");
   DD }
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain2( D_ tree2(@Y@,aaa), D_ tree2(@Y@,aaa) ) )
       myerr(@n@,"is_ge()","@Y@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain2( D_ tree2(@Y@,aaa), D_ tree2(@Z@,aaa) ) )
       myerr(@n@,"is_ge()","@Y@,aaa, @Z@,aaa");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain2( D_ tree2(@Z@,aaa), D_ tree2(@Y@,aaa) ) )
       myerr(@n@,"is_ge()","@Z@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain2( D_ tree2(@Y@,aaa), D_ tree2(@Y@,bbb) ) )
       myerr(@n@,"is_ge()","@Y@,aaa, @Y@,bbb");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain2( D_ tree2(@Y@,bbb), D_ tree2(@Y@,aaa) ) )
       myerr(@n@,"is_ge()","@Y@,bbb, @Y@,aaa");
   DD }
  
#endif
/*================================================================================================*/

/*-------------------------------------------------------------
   deleted by HMH, elementary functions are nonsens

   void p_@N@()
   {
@(   if( cf##_domain2( D_ tree2(@X@,aaa), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cfold-Funktional cf()","@X@,aaa");
@) DD }

---------------------------------------------------------------*/

/*================================================================================================*/

   void p_@N@()
   {
@(   if( sf##_domain2( D_ tree2(@X@,aaa), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sfold-Funktional sf()","@X@,aaa");
@) DD }

/*================================================================================================*/

#define ARG tree2(@X@,aaa)
#define NO 2
#define REPEAT
#define DOMAIN_ Domain2
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG tree2(@X@,aaa)
#define NO 2
#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG tree2(@X@,aaa)
#define NO 2
#define REPEAT
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG tree2(@X@,aaa)
#define NO 2
#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG tree2(@X@,aaa)
#define NO 2
#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG tree2(@X@,aaa)
#define REPEAT
#define NO 2
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG tree2(@X@,aaa)
#define REPEAT
#define NO 2
#include <aux/com/fpr/bbc2>

/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"\n<the end> of TREE2\n");
   }

/*================================================================================================*/
/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"<start> of TREE5\n\n");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_t5_1( D_ tree5(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"mk() /1","@X@,aaa");
     if( s_t5_2( D_ tree5(@X@,aaa) ) != aaa )
       myerr(@n@,"mk() /2","@X@,aaa");
     if(! is_eq##_elem( s_t5_3( D_ tree5(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"mk() /3","@X@,aaa");
     if( s_t5_4( D_ tree5(@X@,aaa) ) != aaa )
       myerr(@n@,"mk() /4","@X@,aaa");
     if(! is_eq##_elem( s_t5_5( D_ tree5(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"mk() /5","@X@,aaa");
@) DD EE }

/*================================================================================================*/

#define ARG tree5(@X@,aaa)
#define NO 5
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG tree5(@X@,aaa)
#define NO 5
#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain5( chg_t5_1( chg_t5_3( chg_t5_5( D_ tree5(@Y@,aaa), @X@ ), @X@ ), @X@ ),
                            D_ tree5(@X@,aaa) ) )
       myerr(@n@,"chg_t5_1,3,5()","@Y@,aaa, @X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain5( chg_t5_2( chg_t5_4( D_ tree5(@X@,aaa), bbb ), bbb ), D_ tree5(@X@,bbb) ) )
       myerr(@n@,"chg_t5_2,4()","@X@,aaa, bbb");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain5( subst_t5_1( subst_t5_3( subst_t5_5( D_ tree5(@Y@,aaa), @X@ ), @X@ ), @X@ ),
                            D_ tree5(@X@,aaa) ) )
       myerr(@n@,"subst_t5_1,3,5()","@Y@,aaa, @X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain5( subst_t5_2( subst_t5_4( D_ tree5(@X@,aaa), bbb ), bbb ), D_ tree5(@X@,bbb) ) )
       myerr(@n@,"subst_t5_2,4()","@X@,aaa, bbb");
@) DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_t5_1( D_ tree5(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"s_t5_1()","@X@,aaa");
     if( s_t5_2( D_ tree5(@X@,aaa) ) != aaa )
       myerr(@n@,"s_t5_2()","@X@,aaa");
     if(! is_eq##_elem( s_t5_3( D_ tree5(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"s_t5_3()","@X@,aaa");
     if( s_t5_4( D_ tree5(@X@,aaa) ) != aaa )
       myerr(@n@,"s_t5_4()","@X@,aaa");
     if(! is_eq##_elem( s_t5_5( D_ tree5(@X@,aaa) ), E_ @X@ ) )
       myerr(@n@,"s_t5_5()","@X@,aaa");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { Elem elem1,elem3,elem5;
     BASIC elem2,elem4;
@(   smk##_domain5( D_ tree5(@X@,aaa), &elem1, &elem2, &elem3, &elem4, &elem5 );
     if(! is_eq##_elem( elem1, E_ @X@ ) )
       myerr(@n@,"smk() /1","@X@");
     if( elem2 != aaa )
       myerr(@n@,"smk() /2","aaa");
     if(! is_eq##_elem( elem3, E_ @X@ ) )
       myerr(@n@,"smk() /3","@X@");
     if( elem4 != aaa )
       myerr(@n@,"smk() /4","aaa");
     if(! is_eq##_elem( elem5, E_ @X@ ) )
       myerr(@n@,"smk() /5","@X@");
@) DD EE }

/*================================================================================================*/

#define ARG tree5(@X@,aaa)
#define REPEAT
#define NO 5
#include <aux/com/is_eq/bbc2>

#define ARG tree5(@X@,aaa)
#define ARG2 tree5(@Y@,aaa)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG tree5(@X@,aaa)
#define ARG2 tree5(@X@,bbb)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG tree5(@X@,aaa)
#define ARG2 tree5(@Y@,bbb)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain5( D_ tree5(@Y@,aaa), D_ tree5(@Y@,aaa) ) )
       myerr(@n@,"is_gr()","@Y@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain5( D_ tree5(@Y@,aaa), D_ tree5(@Z@,aaa) ) )
       myerr(@n@,"is_gr()","@Y@,aaa, @Z@,aaa");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain5( D_ tree5(@Z@,aaa), D_ tree5(@Y@,aaa) ) )
       myerr(@n@,"is_gr()","@Z@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain5( D_ tree5(@Y@,aaa), D_ tree5(@Y@,bbb) ) )
       myerr(@n@,"is_gr()","@Y@,aaa, @Y@,bbb");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain5( D_ tree5(@Y@,bbb), D_ tree5(@Y@,aaa) ) )
       myerr(@n@,"is_gr()","@Y@,bbb, @Y@,aaa");
   DD }
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain5( D_ tree5(@Y@,aaa), D_ tree5(@Y@,aaa) ) )
       myerr(@n@,"is_ge()","@Y@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain5( D_ tree5(@Y@,aaa), D_ tree5(@Z@,aaa) ) )
       myerr(@n@,"is_ge()","@Y@,aaa, @Z@,aaa");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain5( D_ tree5(@Z@,aaa), D_ tree5(@Y@,aaa) ) )
       myerr(@n@,"is_ge()","@Z@,aaa, @Y@,aaa");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain5( D_ tree5(@Y@,aaa), D_ tree5(@Y@,bbb) ) )
       myerr(@n@,"is_ge()","@Y@,aaa, @Y@,bbb");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain5( D_ tree5(@Y@,bbb), D_ tree5(@Y@,aaa) ) )
       myerr(@n@,"is_ge()","@Y@,bbb, @Y@,aaa");
   DD }
  
#endif
/*================================================================================================*/

/*-------------------------------------------------------------
   deleted by HMH, elementary functions are nonsens

   void p_@N@()
   {
@(   if( cf##_domain5( D_ tree5(@X@,aaa), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cfold-Funktional cf()","@X@,aaa");
@) DD }

---------------------------------------------------------------*/

/*================================================================================================*/

   void p_@N@()
   {
@(   if( sf##_domain5( D_ tree5(@X@,aaa), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sfold-Funktional sf()","@X@,aaa");
@) DD }

/*================================================================================================*/

#define ARG tree5(@X@,aaa)
#define NO 5
#define REPEAT
#define DOMAIN_ Domain5
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG tree5(@X@,aaa)
#define NO 5
#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG tree5(@X@,aaa)
#define NO 5
#define REPEAT
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG tree5(@X@,aaa)
#define NO 5
#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG tree5(@X@,aaa)
#define NO 5
#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG tree5(@X@,aaa)
#define REPEAT
#define NO 5
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG tree5(@X@,aaa)
#define REPEAT
#define NO 5
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/tree/com/basic/bbd1 <<'-----'
@X@=
mk##_elem(xxx,yyy)
mk##_elem(xxx,zzz)
mk##_elem(yyy,xxx)
mk##_elem(yyy,zzz)
mk##_elem(zzz,xxx)
mk##_elem(zzz,yyy)

@Y@=
mk##_elem(xxx,ppp)

@Z@=
mk##_elem(xxx,qqq)
-----
cat >$OUT_DIR/tree/com/basic/docu <<'-----'
Syntax:

  Tr :: s_s1 : Comp1
        s_s2 : Comp2
        ...
        s_sn : Compn

ISO Syntax ( -N option ):

  Tr = compose Tr of
          s1 : Comp1
          s2 : Comp2
          ...
          sn : Compn
       end

Description:
  
  The tree constructor '::' ( ISO compose construct ) describes the
  cartesian product of the components.
  The definition above describes the set of values
   
        Tr = Comp1 x Comp2 x ... x Compn

  This can be compared to structures or records in conventional
  programming languages.

Example:
  
  The following definition describes the data associated to a person:

     Person :: s_name	: Str
               s_firstname : Str
               s_birthday : Date

  the equivalent type in ISO syntax 

     Person = compose Person of
                      name : Str
                 firstname : Str
                  birthday : Date
              end
                 
  The information consists of the persons name an birthday.
	       

-----
[ -d $OUT_DIR/tree/com/cfold ] || mkdir $OUT_DIR/tree/com/cfold
cat >$OUT_DIR/tree/com/cfold/ccod <<'-----'
#include <aux/com/folda/ccod>

#ifdef CVFCT
#define CONF(_C,S,_S) MERGE(CVFCT,_C)(TSNAME(S,_S)(x1) lPX lPY)

#define MACRO1(C,_C,S,_S)_IFNDEF MERGE(CVFCT,_C)
#define MACRO2(C,_C,S,_S)   extern RESULT MERGE(CVFCT,_C) P_OP C x1 pPX pPY P_CL;
#define MACRO3(C,_C,S,_S)_ENDIF
#include <aux/com/mecro1/ccod>

#else
#define CONF(_C,S,_S) TSNAME(S,_S)(x1)
#endif
#include <tree/aux/fold/ccod>
-----
cat >$OUT_DIR/tree/com/cfold/docu <<'-----'
#include <tree/aux/fold/docu>
-----
cat >$OUT_DIR/tree/com/cfold/param <<'-----'
CVFCT
FCTNAME
FOLDFCT
NULLFCT
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/tree/com/cfold/vdm <<'-----'
#include <tree/aux/fold/vdm>
-----
[ -d $OUT_DIR/tree/com/cvfromtup1 ] || mkdir $OUT_DIR/tree/com/cvfromtup1
cat >$OUT_DIR/tree/com/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  {
#define MACRO1(C,_C,S,_S)     C MERGE(lx,_S);
#include <aux/com/macro1/ccod>      
#define MACRO1(C,_C,S,_S)     MERGE(lx,_S) = MERGE(cvfromtup1,_C)(x1);
#include <aux/com/macro1/ccod>      
    return mk##_DOMAIN(
#define MACRO1(C,_C,S,_S)    MERGE(lx,_S)
#define MACRO0     ,
#include <aux/com/macro1/ccod>      
                     );
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tree/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tree/com/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  DOMAIN	= + mk
#define MACRO1(C,_C,S,_S)   C  = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#include <aux/com/macro1/ccod>

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/tree/com/cvlines ] || mkdir $OUT_DIR/tree/com/cvlines
cat >$OUT_DIR/tree/com/cvlines/ccod <<'-----'
#ifndef COMP1
#define IS_EMPTY(x1) 1
#else
#define IS_EMPTY(x1) 0
#endif

#ifdef SUPPRESS_CONSTR
#define START_STR "("
#else
#ifdef START_TXT
/* Parameter START_TXT will be used by the automem implementation of trees
   to pass the correct domain name to the underlying implementation ! */
#define START_STR MKSTRING(START_TXT)
#else
#ifdef GEN_ISO
#define START_STR MKSTRING(MERGE(mk_,DOMAIN))"("
#else
#define START_STR MKSTRING(MERGE(mk,_DOMAIN))"("
#endif
#endif
#endif

#define END_STR ")"

#include <aux/com/cvlines/ccod>

#undef IS_EMPTY
#undef START_STR
#undef END_STR
#undef START_TXT

-----
cat >$OUT_DIR/tree/com/cvlines/docu <<'-----'
#include <aux/com/cvlines/docu>
-----
cat >$OUT_DIR/tree/com/cvlines/gtyp <<'-----'
#ifdef GEN_C
_DEFINE cvlines2##_DOMAIN(x1,x2) cvlines2_vdmlib(x1,x2)
#endif
-----
cat >$OUT_DIR/tree/com/cvlines/param <<'-----'
START_TXT
SUPRESS
-----
cat >$OUT_DIR/tree/com/cvlines/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Str            =  + mkc
  DOMAIN         =  + cfold.cvlines1( "NULLFCT" = "mk_empty"
                                    , "CVFCT"   = "cvlines"
                                    , "FOLDFCT" = "cvlines2"
                                    , "RESULT"  = "Cvtext_vdmlib")
#define MACRO1(C,_C,S,_S)    C  = + cvlines
#include <aux/com/macro1/ccod>
  Vdmlib         =  + cvtext + header("STRING")
-----
[ -d $OUT_DIR/tree/com/cvtotup1 ] || mkdir $OUT_DIR/tree/com/cvtotup1
cat >$OUT_DIR/tree/com/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
  {
#define MACRO1(C,_C,S,_S)    x1 = MERGE(cvtotup1,_C)(x1,TSNAME(S,_S)(x2));
#include <aux/com/macro1/ccod>      
    return x1;
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tree/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tree/com/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  DOMAIN	= + s
#define MACRO1(C,_C,S,_S)   C  = + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
#include <aux/com/macro1/ccod>

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/tree/com/default ] || mkdir $OUT_DIR/tree/com/default
cat >$OUT_DIR/tree/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the tree datatype the following set of operations is
  added

#include <tree/com/default/vdm>
-----
cat >$OUT_DIR/tree/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk
                                       ! the constructor !
             + s
                                       ! field selection !
             + chg
                                       ! field update    !
             + copy1 + del1
                                       ! duplicate and destroy values !
-----
[ -d $OUT_DIR/tree/com/del ] || mkdir $OUT_DIR/tree/com/del
cat >$OUT_DIR/tree/com/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN)
   {
#define MACRO1(C,_C,S,_S)   MERGE(del,_C)(TSNAME(S,_S)(x1));
#include <aux/com/macro1/ccod>
    del1##_DOMAIN(x1);
   }
-----
cat >$OUT_DIR/tree/com/del/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + del1 + s
#define MACRO1(C,_C,S,_S)   C = + del
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/com/hash ] || mkdir $OUT_DIR/tree/com/hash
cat >$OUT_DIR/tree/com/hash/ccod <<'-----'
  Nat0 hash##_DOMAIN _FPH1(DOMAIN)
   {return 0
#define MACRO1(C,_C,S,_S)           + MERGE(hash,_C)(TSNAME(S,_S)(x1))
#include <aux/com/macro1/ccod>
   ;}
-----
cat >$OUT_DIR/tree/com/hash/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s
#define MACRO1(C,_C,S,_S)   C = + hash
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/com/is_eq ] || mkdir $OUT_DIR/tree/com/is_eq
cat >$OUT_DIR/tree/com/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return 1 
#define MACRO1(C,_C,S,_S)   && MERGE(is_eq,_C)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2))
#include <aux/com/macro1/ccod>
   ;}
-----
cat >$OUT_DIR/tree/com/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s
#define MACRO1(C,_C,S,_S)   C = + is_eq
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/com/is_ge ] || mkdir $OUT_DIR/tree/com/is_ge
cat >$OUT_DIR/tree/com/is_ge/ccod <<'-----'
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN)
  {return
#ifdef COMP1
#define MACRO1(C,_C,S,_S)   MERGE(is_ge,_C)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2))
#define MACRO2(C,_C,S,_S)   MERGE(is_gr,_C)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2)) || (MERGE(is_eq,_C)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2)) &&
#define MACRO3 )
#include <aux/com/micro1/ccod>
#else
    1
#endif
   ;}
-----
cat >$OUT_DIR/tree/com/is_ge/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s
#define MACRO1(C,_C,S,_S)   C = + is_ge + is_gr + is_eq
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/com/is_gr ] || mkdir $OUT_DIR/tree/com/is_gr
cat >$OUT_DIR/tree/com/is_gr/ccod <<'-----'
  Bool is_gr##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return
#ifdef COMP1
#define MACRO1(C,_C,S,_S)   MERGE(is_gr,_C)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2))
#define MACRO2(C,_C,S,_S)   MERGE(is_gr,_C)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2)) || (MERGE(is_eq,_C)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2)) &&
#define MACRO3 )
#include <aux/com/micro1/ccod>
#else
    0
#endif
   ;}
-----
cat >$OUT_DIR/tree/com/is_gr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s
#define MACRO1(C,_C,S,_S)   C =  + is_gr + is_eq
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/com/parse ] || mkdir $OUT_DIR/tree/com/parse
cat >$OUT_DIR/tree/com/parse/ccod <<'-----'
/* if this functiom is called from an automem function the parameters
   DOMNAME/LDOMNAME will be defined and used as expected string.
   Otherwise mk_rep##_DOMAIN would be expected instead of the 
   desired mk_##DOMAIN ! */

DOMAIN parse##_DOMAIN _FPH0()
  { char *lx1 = readtoken_vdmlib(#DOMAIN);
    char lx2[300];

    /* dynamic construction of "mk##_DOMAIN" */
#ifdef GEN_ISO
#if defined(DOMNAME)
    strcpy(lx2,"mk_"); strcat(lx2,#DOMNAME);
#else
    strcpy(lx2,"mk_"); strcat(lx2,#DOMAIN);
#endif
#else
#if defined(LDOMNAME)
    strcpy(lx2,"mk"); strcat(lx2,#LDOMNAME);
#else
    strcpy(lx2,"mk"); strcat(lx2,#_DOMAIN);
#endif
#endif

    if (strcmp(lx1,lx2) != 0) { expected_vdmlib(#DOMAIN,lx2,lx1); }
    expect_vdmlib("(",#DOMAIN);
    {
#define MACRO0 ;
#define MACRO1(C,_C,S,_S) C lx##_S
#include <aux/com/macro1/ccod>
;
#define MACRO0 expect_vdmlib(",",MKSTRING(DOMAIN));
#define MACRO1(C,_C,S,_S) lx##_S = parse##_C();
#include <aux/com/macro1/ccod>
      expect_vdmlib(")",#DOMAIN);
      return mk##_DOMAIN(
#define MACRO0 ,
#define MACRO1(C,_C,S,_S) lx##_S
#include <aux/com/macro1/ccod>
			);
    }
  }
#undef DOMNAME
#undef LDOMNAME
-----
cat >$OUT_DIR/tree/com/parse/docu <<'-----'

  Syntax:  'mk_'<DOMAIN>'('<ELEM1>','<ELEM2>',' ... ')'

  If the optional implementation parameter 'SUPPRESS_CONSTR'
  is set, the leading prefix will be ommited.

-----
cat >$OUT_DIR/tree/com/parse/param <<'-----'
DOMNAME
LDOMNAME
SUPRESS_CONSTR
-----
cat >$OUT_DIR/tree/com/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
 DOMAIN	= + mk
 Vdmlib	= + parsesup + header("STRING")
#define MACRO1(C,_C,S,_S) C = + parse
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/com/print ] || mkdir $OUT_DIR/tree/com/print
cat >$OUT_DIR/tree/com/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
_IFDEF __cplusplus
   { print_FD_vdmlib <<
_ELSE
   { fprintf( print_FD_vdmlib,
_ENDIF
#ifdef SUPPRESS_CONSTR
         "("
#else
#ifdef GEN_ISO
         MKSTRING(MERGE(mk_,DOMAIN))"("
#else
         MKSTRING(MERGE(mk,_DOMAIN))"("
#endif
#endif
_IFDEF __cplusplus
   ;
_ELSE
   );
_ENDIF

_IFDEF __cplusplus
#define MACRO1(C,_C,S,_S)   MERGE(print,_C)(TSNAME(S,_S)(x1));
#define MACRO0   print_FD_vdmlib << ",";
#include <aux/com/macro1/ccod>
    print_FD_vdmlib << ")";
_ELSE
#define MACRO1(C,_C,S,_S)   MERGE(print,_C)(TSNAME(S,_S)(x1));
#define MACRO0   fprintf(print_FD_vdmlib,",");
#include <aux/com/macro1/ccod>
    fprintf(print_FD_vdmlib,")");
_ENDIF

   }
-----
cat >$OUT_DIR/tree/com/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s
   Vdmlib   = + header("STDIO")
#define MACRO1(C,_C,S,_S)   C = + print
#include <aux/com/macro1/ccod>
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/tree/com/sfold ] || mkdir $OUT_DIR/tree/com/sfold
cat >$OUT_DIR/tree/com/sfold/ccod <<'-----'
#include <aux/com/folda/ccod>

#ifdef CVFCT
#define CONF(_C,S,_S) MERGE(CVFCT,_S)(TSNAME(S,_S)(x1) lPX lPY)

#define MACRO1(C,_C,S,_S)_IFNDEF MERGE(CVFCT,_S)
#define MACRO2(C,_C,S,_S)   extern RESULT MERGE(CVFCT,_S) P_OP C x1 pPX pPY P_CL;
#define MACRO3(C,_C,S,_S)_ENDIF
#include <aux/com/mecro1/ccod>

#else
#define CONF(_C,S,_S) TSNAME(S,_S)(x1)
#endif
#include <tree/aux/fold/ccod>
-----
cat >$OUT_DIR/tree/com/sfold/docu <<'-----'
#include <tree/aux/fold/docu>
-----
cat >$OUT_DIR/tree/com/sfold/param <<'-----'
CVFCT
FCTNAME
FOLDFCT
NULLFCT
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/tree/com/sfold/vdm <<'-----'
#include <tree/aux/fold/vdm>
-----
[ -d $OUT_DIR/tree/com/smk ] || mkdir $OUT_DIR/tree/com/smk
cat >$OUT_DIR/tree/com/smk/ccod <<'-----'
  void smk##_DOMAIN(
     _FP(x1,DOMAIN),
#define MACRO1(C,_C,S,_S)    _FP(MERGE(x1,_S),C *)
#define MACRO0  ,
#include <aux/com/macro1/ccod>
  )
    _EP(x1,DOMAIN)
#define MACRO1(C,_C,S,_S)   _EP(MERGE(x1,_S),C *)
#include <aux/com/macro1/ccod>
   {
#define MACRO1(C,_C,S,_S)    (* MERGE(x1,_S)) = TSNAME(S,_S)(x1);
#include <aux/com/macro1/ccod>
   }
-----
cat >$OUT_DIR/tree/com/smk/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + s
-----
[ -d $OUT_DIR/tree/com/subst ] || mkdir $OUT_DIR/tree/com/subst
cat >$OUT_DIR/tree/com/subst/ccod <<'-----'
#define MACRO1(C,_C,S,_S)  DOMAIN MERGE(subst,_S)(_FP(x1,DOMAIN),_FP(MERGE(x2,_S),C)) _EP(x1,DOMAIN) _EP(MERGE(x2,_S),C) {return MERGE(chg,_S)(MERGE(copy1,_DOMAIN)(x1),MERGE(x2,_S));}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/com/subst/cmcr <<'-----'
#define MACRO1(C,_C,S,_S)_DEFINE MERGE(subst,_S)(z1,z2) MERGE(chg,_S)(MERGE(copy1,_DOMAIN)(z1),z2)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/com/subst/pmcr <<'-----'
#include <tree/com/subst/cmcr>
-----
cat >$OUT_DIR/tree/com/subst/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + chg + copy1
-----
[ -d $OUT_DIR/tree/ptstruct ] || mkdir $OUT_DIR/tree/ptstruct
[ -d $OUT_DIR/tree/ptstruct/basic ] || mkdir $OUT_DIR/tree/ptstruct/basic
cat >$OUT_DIR/tree/ptstruct/basic/docu <<'-----'
  Implementation of trees with pointers to records (or structs)

  Dynamic data allocation on a heap is required for this
  implementation, but assignments and copy operations
  only move pointers, so values can be shared by various
  variables.

  This implementation is required expecially for cyclic data
  structurs, where the 'struct' implementation does not always
  work, it is also neccessay for implementing optionals, when
  the nil value shal be represented by a nil pointer.

#ifndef BASEIMPL
  This implementation requires stoage cleanup operations
  by the user with functions 'del' and 'del1'.
#else
  For automatic memmory management with C++ classes
  this implementation becomes less important, because
  automem allocation itself works with pointers and
  introduces a level of indirection, so the 'struct'
  implementation is a more suitable one.

#endif

  Parameters:

  'MACROS' :
                Implementation of short operations as macros,
                this can improve preformance especially for the
                tree ADTs

  'ALLOC' :
                The allocation strategie for the heap can be
                set by this parameter

                Default is 'malloc' (the builtin C or C++ heap
                operations 'malloc' and 'free' of 'new' and 'delete')

                If a freelist is a better method, define ALLOC as

                Example:

                IMPLEMENTATION
                  DOMAIN = ptstruct(ALLOC="freelist")

                If the freelist shall be limited in length (e.g.
                maximum = 20), add this information to the freelist
                
                IMPLEMENTATION
                  DOMAIN = ptstruct(ALLOC="freelist(MAXLEN=20)")
-----
cat >$OUT_DIR/tree/ptstruct/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tree/ptstruct/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/tree/ptstruct/basic/gtyp <<'-----'
  START_RECORD_TYP(Struct##_DOMAIN)
#ifdef COMP1
#define MACRO1(C,_C,S,_S)      RECFIELD(MERGE(f,_S),C);
#include <aux/com/macro1/ccod>
#else
                     RECFIELD(f_dummy,Nat0);
#endif
  END_RECORD_TYP(Struct##_DOMAIN) 
-----
cat >$OUT_DIR/tree/ptstruct/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
-----
cat >$OUT_DIR/tree/ptstruct/basic/vdm <<'-----'
#include <aux/com/heap/vdm>
#include <tree/aux/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/ptstruct/chg ] || mkdir $OUT_DIR/tree/ptstruct/chg
cat >$OUT_DIR/tree/ptstruct/chg/ccod <<'-----'
#define MACRO1(C,_C,S,_S)  DOMAIN MERGE(chg,_S)(_FP(x1,DOMAIN),_FP(MERGE(x2,_S),C)) _EP(x1,DOMAIN) _EP(MERGE(x2,_S),C) {MERGE(ref,_DOMAIN)(x1)->MERGE(f,_S) = MERGE(x2,_S); return x1;}
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/ptstruct/copy ] || mkdir $OUT_DIR/tree/ptstruct/copy
cat >$OUT_DIR/tree/ptstruct/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
   {x1 = copy1##_DOMAIN(x1);
#define MACRO1(C,_C,S,_S)    x1->MERGE(f,_S) = MERGE(copy,_C)(MERGE(ref,_DOMAIN)(x1)->MERGE(f,_S));
#include <aux/com/macro1/ccod>
    return x1;
   }
-----
cat >$OUT_DIR/tree/ptstruct/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + copy1
#define MACRO1(C,_C,S,_S)   C = + copy
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/ptstruct/copy1 ] || mkdir $OUT_DIR/tree/ptstruct/copy1
cat >$OUT_DIR/tree/ptstruct/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN)
   {DOMAIN x2 = alloc##_DOMAIN(); *x2 = *x1; return x2; }
-----
[ -d $OUT_DIR/tree/ptstruct/del1 ] || mkdir $OUT_DIR/tree/ptstruct/del1
cat >$OUT_DIR/tree/ptstruct/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(x1);}
-----
cat >$OUT_DIR/tree/ptstruct/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(z1) free##_DOMAIN(z1)
-----
cat >$OUT_DIR/tree/ptstruct/del1/pmcr <<'-----'
#include <tree/ptstruct/del1/cmcr>
-----
[ -d $OUT_DIR/tree/ptstruct/mk ] || mkdir $OUT_DIR/tree/ptstruct/mk
cat >$OUT_DIR/tree/ptstruct/mk/ccod <<'-----'
  DOMAIN mk##_DOMAIN(
#define MACRO1(C,_C,S,_S)    _FP(MERGE(x1,_S),C)
#define MACRO0  ,
#include <aux/com/macro1/ccod>
  )
#define MACRO1(C,_C,S,_S)   _EP(MERGE(x1,_S),C)
#include <aux/com/macro1/ccod>
   {DOMAIN lx1 = alloc##_DOMAIN();
#define MACRO1(C,_C,S,_S)    lx1->MERGE(f,_S) = MERGE(x1,_S);
#include <aux/com/macro1/ccod>
    return lx1;
   }
-----
cat >$OUT_DIR/tree/ptstruct/mk/vdm <<'-----'

#define CONSTRNAME mk
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/ptstruct/s ] || mkdir $OUT_DIR/tree/ptstruct/s
cat >$OUT_DIR/tree/ptstruct/s/ccod <<'-----'
#define MACRO1(C,_C,S,_S)   C TSNAME(S,_S) _FPH1(DOMAIN) {return  MERGE(ref,_DOMAIN)(x1)->MERGE(f,_S);}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/ptstruct/s/cmcr <<'-----'
#define MACRO1(C,_C,S,_S)_DEFINE TSNAME(S,_S)(x) (MERGE(ref,_DOMAIN)(x)->MERGE(f,_S))
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/ptstruct/s/pmcr <<'-----'
#define MACRO1(C,_C,S,_S)_DEFINE TSNAME(S,_S)(x) (x^.MERGE(f,_S))
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/sign ] || mkdir $OUT_DIR/tree/sign
[ -d $OUT_DIR/tree/sign/cfold ] || mkdir $OUT_DIR/tree/sign/cfold
cat >$OUT_DIR/tree/sign/cfold/gsig <<'-----'
#include <tree/aux/fold/gsig>
-----
cat >$OUT_DIR/tree/sign/cfold/vsig <<'-----'
#include <tree/aux/fold/vsig>
-----
[ -d $OUT_DIR/tree/sign/chg ] || mkdir $OUT_DIR/tree/sign/chg
cat >$OUT_DIR/tree/sign/chg/cpp <<'-----'
#define T1 Cpp_DOMAIN &
#define MACRO1(C,_C,S,_S,SS) InlineFriendFct(MERGE(chg_,S),FPAR2(T1,const C &),Cpp_DOMAIN &)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY2a(MERGE(chg,_S),FPARLIST2))
#define MACRO3(C,_C,S,_S,SS) 
#include <aux/sign/mecro1/cpp>
#undef T1
-----
cat >$OUT_DIR/tree/sign/chg/gsig <<'-----'
#define MACRO1(C,_C,S,_S)  FUNCDEC(MERGE(chg,_S),PL_2(DOMAIN,C),DOMAIN)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/sign/chg/vsig <<'-----'
#define MACRO1(C,_C,S,_S)  MERGE(chg,_S)(x1,x2) = MERGE(mk,_DOMAIN)(x1.s_*,...,x2,...,x1.s_*)
#include <aux/com/macro1/ccod>
#define MACRO1(C,_C,S,_S)  TYPE : DOMAIN  C  -->  DOMAIN
#include <aux/com/macro1/ccod>
    changing of one tree component, the tree is destroyed 
    the value overwritten is not deleted               
-----
[ -d $OUT_DIR/tree/sign/mk ] || mkdir $OUT_DIR/tree/sign/mk
cat >$OUT_DIR/tree/sign/mk/cpp <<'-----'
InlineNoFriendFct(Cpp_DOMAIN,,)
(
#ifdef Cpp_COMP1
#define MACRO0 ,
#define MACRO1(C,_C,S,_S) const C & MERGE(x,_S)
#include <aux/sign/macro1/cpp>
#else
const Cpp_DUMMY &
#endif
)
#ifdef DECL
;
#else
{ data =  mk##_DOMAIN (
#define MACRO1(C,_C,S,_S) MERGE(x,_S).data
#define MACRO0 ,
#include <aux/sign/macro1/cpp>
);}
#endif
-----
cat >$OUT_DIR/tree/sign/mk/gsig <<'-----'
#ifdef GEN_MODULA
   PROCEDURE mkDOMAIN EXTERNAL mk##_DOMAIN 
#else
#if defined(GEN_C)
   extern DOMAIN mk##_DOMAIN
#else
#if defined(GEN_PASCAL)
   FUNCTION mk##_DOMAIN
#else
  DOMAIN: this function is only supported for MODULA, C and PASCAL !!!
#endif
#endif
#endif

#ifdef COMP1
  P_OP
#define MACRO0   P_SEP
#define MACRO1(C,_C,S,_S)    PARAM(MERGE(x1,_S),C)
#include <aux/com/macro1/ccod>
  P_CL
#else
  PL_0()
#endif

#ifdef GEN_MODULA
   : DOMAIN;
#else
#if defined(GEN_C)
   ;
#else
#if defined(GEN_PASCAL)
   : DOMAIN; EXTERNAL_;
#else
  DOMAIN: this function is only supported for MODULA, C and PASCAL !!!
#endif
#endif
#endif
-----
cat >$OUT_DIR/tree/sign/mk/vsig <<'-----'
  mk##_DOMAIN(x1,...,xn)
  TYPE : ELEM1 .... ELEMN  -->  DOMAIN

  constructor functions
-----
[ -d $OUT_DIR/tree/sign/s ] || mkdir $OUT_DIR/tree/sign/s
cat >$OUT_DIR/tree/sign/s/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define MACRO1(C,_C,S,_S,SS) InlineFriendConstFct(S,FPAR1(T1),C)
/* #define MACRO2(C,_C,S,_S) RUMPF(BODY1a(C,MERGE(s,_S),FPARLIST1)) */
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY1a(C,TSNAME(SS,_S),FPARLIST1))
#define MACRO3(C,_C,S,_S,SS)
#include <aux/sign/mecro1/cpp>
#undef T1
-----
cat >$OUT_DIR/tree/sign/s/gsig <<'-----'
#define MACRO1(C,_C,S,_S)  FUNCDEC(TSNAME(S,_S),PL_1(DOMAIN),C)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/sign/s/vsig <<'-----'
#define MACRO1(C,_C,S,_S)  TSNAME(S,_S)(x1) = x1.TSNAME(S,_S)
#include <aux/com/macro1/ccod>
#define MACRO1(C,_C,S,_S)  TYPE : DOMAIN  -->  C
#include <aux/com/macro1/ccod>
  selector functions
-----
[ -d $OUT_DIR/tree/sign/sfold ] || mkdir $OUT_DIR/tree/sign/sfold
cat >$OUT_DIR/tree/sign/sfold/gsig <<'-----'
#include <tree/aux/fold/gsig>
-----
cat >$OUT_DIR/tree/sign/sfold/vsig <<'-----'
#include <tree/aux/fold/vsig>
-----
[ -d $OUT_DIR/tree/sign/smk ] || mkdir $OUT_DIR/tree/sign/smk
cat >$OUT_DIR/tree/sign/smk/cpp <<'-----'
InlineFriendFct(smk,,void)
(
#ifndef MEMBERS
const Cpp_DOMAIN & xx
#endif
#define MACRO1(C,_C,S,_S) C & MERGE(x2,_S)
#define MACRO0 ,
#include <aux/sign/macro1/cpp>
)
#ifdef DECL
;
#else
{ smk##_DOMAIN (DATA,
#define MACRO1(C,_C,S,_S) & MERGE(x2,_S).data
#define MACRO0 ,
#include <aux/sign/macro1/cpp>
); }
#endif
-----
cat >$OUT_DIR/tree/sign/smk/gsig <<'-----'
#ifdef GEN_MODULA
   PROCEDURE smkDOMAIN EXTERNAL smk##_DOMAIN 
#elif defined(GEN_C)
   extern void smk##_DOMAIN
#elif defined(GEN_PASCAL)
   PROCEDURE smk##_DOMAIN
#else
  DOMAIN: this function is only supported for MODULA, C and PASCAL !!!
#endif

  P_OP
   PARAM(x1,DOMAIN),
#define MACRO0   P_SEP
#define MACRO1(C,_C,S,_S)    REF_PARAM(MERGE(x1,_S),C)
#include <aux/com/macro1/ccod>
  P_CL

#ifdef GEN_MODULA
   ;
#elif defined(GEN_C)
   ;
#elif defined(GEN_PASCAL)
   : DOMAIN; EXTERNAL_
#else
  DOMAIN: this function is only supported for MODULA, C and PASCAL !!!
#endif
-----
cat >$OUT_DIR/tree/sign/smk/vsig <<'-----'
  smk##_DOMAIN(x1)
    LET mk##_DOMAIN(y1,...,yn) = x1
     IN (y1,...,yn)
  TYPE : DOMAIN  -->  (ELEM1 .... ELEMN)

  Splits a tree into its components to implement the impicit 
  select operations.
-----
[ -d $OUT_DIR/tree/sign/subst ] || mkdir $OUT_DIR/tree/sign/subst
cat >$OUT_DIR/tree/sign/subst/cpp <<'-----'
#define T1 Cpp_DOMAIN &
#if !defined(BASEIMPL)

#define MACRO1(C,_C,S,_S,SS) InlineFriendConstFct(MERGE(subst_,S),FPAR2(T1,const C &),Cpp_DOMAIN)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY1a(Cpp_DOMAIN,MERGE(subst,_S),FPARLIST2))
#define MACRO3(C,_C,S,_S,SS)
#include <aux/sign/mecro1/cpp>

#else

#define MACRO1(C,_C,S,_S,SS) InlineFriendConstFct(MERGE(subst_,S),FPAR2(T1,const C &),Cpp_DOMAIN)
#define MACRO2(C,_C,S,_S,SS) RUMPF({Cpp_DOMAIN tmp=THIS; tmp.MERGE(chg_,S)(x2); return tmp;})
#define MACRO3(C,_C,S,_S,SS)
#include <aux/sign/mecro1/cpp>

#endif 
#undef T1
-----
cat >$OUT_DIR/tree/sign/subst/gsig <<'-----'
#define MACRO1(C,_C,S,_S)  FUNCDEC(MERGE(subst,_S),PL_2(DOMAIN,C),DOMAIN)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/sign/subst/vsig <<'-----'
#define MACRO1(C,_C,S,_S)  MERGE(subst,_S)(x1,x2) = MERGE(mk,_DOMAIN)(x1.s_*,...,x2,...,x1.s_*) 
#include <aux/com/macro1/ccod>
#define MACRO1(C,_C,S,_S)  TYPE : DOMAIN  C  -->  DOMAIN
#include <aux/com/macro1/ccod>
   copies the tree value x1 and replaces one tree component
-----
[ -d $OUT_DIR/tree/small ] || mkdir $OUT_DIR/tree/small
[ -d $OUT_DIR/tree/small/basic ] || mkdir $OUT_DIR/tree/small/basic
cat >$OUT_DIR/tree/small/basic/docu <<'-----'
  Implementation of trees with one component (as maximum). The
  tree is identified with its component to avoid overhead for 
  constructor- and selector functions which now can ALL be implemented
  as macros. For languages with support type checking some 
  safety may be lost since DOMAIN and COMP1 now are identical.
  (Use another implementation for program developement if 
  necessary.)

  Parameters:

    "DUMMYTYPE" :
                Since C does not support any kind of empty type
                an empty tree must be implemented by adding a
                dummy component. This will be 'Nat0' by default
                but if another type fits better (due to space-
                or allignment requirements) it can be specified
                here. The type used MUST be assignment compatible
                to 'Nat0' (i.e. 'Char').

   "SUPPRESS_CONSTR" :
                If defined, the I/O routines will not
                require/generate tree values to be 
                preceeded by the corresponding constructor
                name. These values will simply be 
               
-----
cat >$OUT_DIR/tree/small/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tree/small/basic/gtyp <<'-----'
#ifndef DUMMYTYPE
#define DUMMYTYPE Nat0
#endif

#ifdef COMP1
  TYPE_DEF(DOMAIN,COMP1)
#else
  TYPE_DEF(DOMAIN,DUMMYTYPE) COMMENT_(C does not support empty records)
#endif

#ifdef COMP2
  DOMAIN: This implementation allows only of one component !
#endif

#undef DUMMYTYPE
-----
cat >$OUT_DIR/tree/small/basic/param <<'-----'
AUTOMEM
INTERNALDOMAIN
MACROS
DUMMYTYPE
SUPPRESS_CONSTR
-----
cat >$OUT_DIR/tree/small/basic/vdm <<'-----'
#include <tree/aux/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/small/chg ] || mkdir $OUT_DIR/tree/small/chg
cat >$OUT_DIR/tree/small/chg/ccod <<'-----'
#ifdef COMP1
  DOMAIN chg##_SEL1 _FPH2(DOMAIN,COMP1) { return x2; }
#endif
-----
cat >$OUT_DIR/tree/small/chg/cmcr <<'-----'
#ifdef COMP1
_DEFINE chg##_SEL1 (x1,x2) (x2)
#endif
-----
cat >$OUT_DIR/tree/small/chg/pmcr <<'-----'
#include <tree/small/chg/cmcr>
-----
[ -d $OUT_DIR/tree/small/copy ] || mkdir $OUT_DIR/tree/small/copy
cat >$OUT_DIR/tree/small/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
#ifdef COMP1
    { return copy##_COMP1(x1); }
#else
    { return x1; }
#endif
-----
cat >$OUT_DIR/tree/small/copy/cmcr <<'-----'
#ifdef COMP1
_DEFINE copy##_DOMAIN(x1) copy##_COMP1(x1)
#else
_DEFINE copy##_DOMAIN(x1) (x1)
#endif
-----
cat >$OUT_DIR/tree/small/copy/pmcr <<'-----'
#include <tree/small/copy/pmcr>
-----
cat >$OUT_DIR/tree/small/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifdef COMP1
  COMP1 = + copy
#endif
-----
[ -d $OUT_DIR/tree/small/cvfromtup1 ] || mkdir $OUT_DIR/tree/small/cvfromtup1
cat >$OUT_DIR/tree/small/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
#ifdef COMP1
    { return mk##_DOMAIN(cvfromtup1##_COMP1(x1)); }
#else
    { return mk##_DOMAIN(); }
#endif

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tree/small/cvfromtup1/cmcr <<'-----'
#include <aux/com/cvtotupl/defp>

#ifdef COMP1
_DEFINE cvfromtup1##_DOMAIN(x1) mk##_DOMAIN(cvfromtup1##_COMP1(x1))
#else
_DEFINE cvfromtup1##_DOMAIN(x1) mk##_DOMAIN()
#endif

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tree/small/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tree/small/cvfromtup1/pmcr <<'-----'
#include <tree/small/cvfromtup1/cmcr>
-----
cat >$OUT_DIR/tree/small/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  DOMAIN	= + mk
#define MACRO1(C,_C,S,_S)   C  = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#include <aux/com/macro1/ccod>

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/tree/small/cvtotup1 ] || mkdir $OUT_DIR/tree/small/cvtotup1
cat >$OUT_DIR/tree/small/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
    {
#ifdef COMP1
      return cvtotup1##_COMP1(x1,s##_SEL1(x2));
#else
      return x1;
#endif
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tree/small/cvtotup1/cmcr <<'-----'
#include <aux/com/cvtotupl/defp>

#ifdef COMP1
_DEFINE cvtotup1##_DOMAIN(x1,x2) cvtotup1##_COMP1(x1,s##_SEL1(x2))
#else
_DEFINE cvtotup1##_DOMAIN(x1,x2) (x1)
#endif

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tree/small/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tree/small/cvtotup1/pmcr <<'-----'
#include <tree/small/cvtotup1/cmcr>
-----
cat >$OUT_DIR/tree/small/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  DOMAIN	= + s
#define MACRO1(C,_C,S,_S)   C  = + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
#include <aux/com/macro1/ccod>

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/tree/small/mk ] || mkdir $OUT_DIR/tree/small/mk
cat >$OUT_DIR/tree/small/mk/ccod <<'-----'
#ifdef COMP1
  DOMAIN mk##_DOMAIN _FPH1(COMP1) { return x1; }
#else
  DOMAIN mk##_DOMAIN _FPH0() { return 0; }
#endif
-----
cat >$OUT_DIR/tree/small/mk/cmcr <<'-----'
#ifdef COMP1
_DEFINE mk##_DOMAIN(x1) (x1)
#else
_DEFINE mk##_DOMAIN() 0
#endif
-----
cat >$OUT_DIR/tree/small/mk/pmcr <<'-----'
#include <tree/small/mk/cmcr>
-----
cat >$OUT_DIR/tree/small/mk/vdm <<'-----'

#define CONSTRNAME mk
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/small/s ] || mkdir $OUT_DIR/tree/small/s
cat >$OUT_DIR/tree/small/s/ccod <<'-----'
#ifdef COMP1
#ifdef GEN_ISO
  COMP1 SEL1 _FPH1(DOMAIN) { return x1; }
#else
  COMP1 s##_SEL1 _FPH1(DOMAIN) { return x1; }
#endif
#endif
-----
cat >$OUT_DIR/tree/small/s/cmcr <<'-----'
#ifdef COMP1
#ifdef GEN_ISO
_DEFINE SEL1(x1) (x1)
#else
_DEFINE s##_SEL1(x1) (x1)
#endif
#endif
-----
cat >$OUT_DIR/tree/small/s/pmcr <<'-----'
#include <tree/small/s/cmcr>
-----
[ -d $OUT_DIR/tree/struct ] || mkdir $OUT_DIR/tree/struct
[ -d $OUT_DIR/tree/struct/basic ] || mkdir $OUT_DIR/tree/struct/basic
cat >$OUT_DIR/tree/struct/basic/docu <<'-----'
  Implementation of trees as records (Pascal) or structures (C)

  No dynamic data allocation on a heap is required, but
  assignments  require  copying  of the whole structure.

  Parameters:

  'MACROS' :
                Implementation of short operations as macros,
                this can improve preformance especially for the
                tree ADTs


  'SUPPRESS_CONSTR' :
                If defined, the I/O routines will not
                require/generate tree values to be 
                preceeded by the corresponding constructor
                name. These values will simply be 
                surrounded by brackets.
-----
cat >$OUT_DIR/tree/struct/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tree/struct/basic/gtyp <<'-----'
  START_RECORD_TYP(Struct##_DOMAIN)
#ifdef COMP1
#define MACRO1(C,_C,S,_S)     RECFIELD(MERGE(f,_S),C);
#include <aux/com/macro1/ccod>
#else
            RECFIELD(f_dummy,Nat0);
#endif
  END_RECORD_TYP(Struct##_DOMAIN) 

#ifdef GEN_C
  typedef struct Struct##_DOMAIN DOMAIN;
#else
  TYPE_DEF(DOMAIN,Struct##_DOMAIN)
#endif

-----
cat >$OUT_DIR/tree/struct/basic/param <<'-----'
AUTOMEM
INTERNALDOMAIN
MACROS
SUPPRESS_CONSTR
-----
cat >$OUT_DIR/tree/struct/basic/vdm <<'-----'
#include <tree/aux/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/struct/chg ] || mkdir $OUT_DIR/tree/struct/chg
cat >$OUT_DIR/tree/struct/chg/ccod <<'-----'
#define MACRO1(C,_C,S,_S)  DOMAIN MERGE(chg,_S)(_FP(x1,DOMAIN),_FP(MERGE(x2,_S),C)) _EP(x1,DOMAIN) _EP(MERGE(x2,_S),C) {x1.MERGE(f,_S) = MERGE(x2,_S);return x1;}
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/struct/copy ] || mkdir $OUT_DIR/tree/struct/copy
cat >$OUT_DIR/tree/struct/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
   {
#define MACRO1(C,_C,S,_S)    x1.MERGE(f,_S) = MERGE(copy,_C)(x1.MERGE(f,_S));
#include <aux/com/macro1/ccod>
    return x1;
   }
-----
cat >$OUT_DIR/tree/struct/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#define MACRO1(C,_C,S,_S)   C = + copy
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/tree/struct/mk ] || mkdir $OUT_DIR/tree/struct/mk
cat >$OUT_DIR/tree/struct/mk/ccod <<'-----'
  DOMAIN mk##_DOMAIN(
#define MACRO1(C,_C,S,_S)   _FP(MERGE(x1,_S),C)
#define MACRO0  ,
#include <aux/com/macro1/ccod>
  )
#define MACRO1(C,_C,S,_S)   _EP(MERGE(x1,_S),C)
#include <aux/com/macro1/ccod>
   {DOMAIN lx1;
#define MACRO1(C,_C,S,_S)     lx1.MERGE(f,_S) = MERGE(x1,_S);
#include <aux/com/macro1/ccod>
    return lx1;
   }
-----
cat >$OUT_DIR/tree/struct/mk/vdm <<'-----'

#define CONSTRNAME mk
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tree/struct/s ] || mkdir $OUT_DIR/tree/struct/s
cat >$OUT_DIR/tree/struct/s/ccod <<'-----'
#define MACRO1(C,_C,S,_S)  C TSNAME(S,_S) _FPH1(DOMAIN) {return x1.MERGE(f,_S);}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/struct/s/cmcr <<'-----'
#define MACRO1(C,_C,S,_S)_DEFINE TSNAME(S,_S)(x) (x).MERGE(f,_S) 
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/tree/struct/s/pmcr <<'-----'
#include <tree/struct/s/cmcr>
-----
[ -d $OUT_DIR/tupl ] || mkdir $OUT_DIR/tupl
[ -d $OUT_DIR/tupl/array ] || mkdir $OUT_DIR/tupl/array
[ -d $OUT_DIR/tupl/array/appr ] || mkdir $OUT_DIR/tupl/array/appr
cat >$OUT_DIR/tupl/array/appr/ccod <<'-----'
  DOMAIN appr##_DOMAIN _FPH2(DOMAIN,ELEM1)
    { Nat0 lx1 = ref##_DOMAIN(x1)->f_len;

      if (lx1 < x1->f_max)
	 { *( ((ELEM1 *)(x1 + 1)) + lx1) = x2;
	   x1->f_len++;
	   return x1;
	 }
      else
	 { return conc##_DOMAIN(x1,mk1##_DOMAIN(x2)); }
    }
-----
cat >$OUT_DIR/tupl/array/appr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + mk1 + conc
-----
[ -d $OUT_DIR/tupl/array/basic ] || mkdir $OUT_DIR/tupl/array/basic
cat >$OUT_DIR/tupl/array/basic/docu <<'-----'
  Implementation of Tuples as variable length arrays

  space : 2 * sizeof(unsigned long) +  n * sizeof(ELEM1)
  the space is allocated in units of powers of 2

  parameters :
   SIMPLEELEMS :
                 if the element domain is implemented without
                 the use of dynamically allocated data (like for Char),
                 this flag improves the efficiency of the "del" function
   ISCHAR      :
                 elements of the tuple are characters
   NOCHECK     :
                 no check is done in select functions whether index is
                 not greater than length of tuple
   ALLOC       :
                 allocation strategie (default : vmalloc)
                 allocation is done in powers of 2 with C malloc and free
-----
cat >$OUT_DIR/tupl/array/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tupl/array/basic/gptr <<'-----'
#include <aux/array/basic/gptr>
-----
cat >$OUT_DIR/tupl/array/basic/gtyp <<'-----'
#include <aux/array/basic/gtyp>
-----
cat >$OUT_DIR/tupl/array/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
ISCHAR
MACROS
NOCHECK
SIMPLEELEMS
-----
cat >$OUT_DIR/tupl/array/basic/vdm <<'-----'
#include <aux/com/vheap/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/array/conc ] || mkdir $OUT_DIR/tupl/array/conc
cat >$OUT_DIR/tupl/array/conc/ccod <<'-----'
#include <aux/array/conc/ccod>
-----
cat >$OUT_DIR/tupl/array/conc/docu <<'-----'
  time complexity : O(n) (proportional to the number of elements)
-----
cat >$OUT_DIR/tupl/array/conc/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + del1
-----
[ -d $OUT_DIR/tupl/array/concc ] || mkdir $OUT_DIR/tupl/array/concc
cat >$OUT_DIR/tupl/array/concc/ccod <<'-----'
#define fct concc
#define del
#include <aux/array/conc/ccod>
-----
[ -d $OUT_DIR/tupl/array/copy ] || mkdir $OUT_DIR/tupl/array/copy
cat >$OUT_DIR/tupl/array/copy/ccod <<'-----'
#define fct copy
#if SIMPLEELEMS
#define copyelem(z1) z1
#else
#define copyelem(z1) MERGE(copy,_ELEM1)(z1)
#endif
#include <aux/array/copy1/ccod>
-----
cat >$OUT_DIR/tupl/array/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! SIMPLEELEMS
   ELEM1 = + copy
#endif
-----
[ -d $OUT_DIR/tupl/array/copy1 ] || mkdir $OUT_DIR/tupl/array/copy1
cat >$OUT_DIR/tupl/array/copy1/ccod <<'-----'
#include <aux/array/copy1/ccod>
-----
[ -d $OUT_DIR/tupl/array/cpc ] || mkdir $OUT_DIR/tupl/array/cpc
cat >$OUT_DIR/tupl/array/cpc/ccod <<'-----'
  void cpc##_DOMAIN _FPH2(DOMAIN,ELEM1 *)
   {register Nat0    li  = ref##_DOMAIN(x1)->f_len;
    register ELEM1 * px1 = (ELEM1 *)(x1 + 1);
    register ELEM1 * px2 = (ELEM1 *)x2;
    while (li--) *(px2++) = *(px1++);
    *(px2) = 0;
   }
-----
[ -d $OUT_DIR/tupl/array/cvfromtup1 ] || mkdir $OUT_DIR/tupl/array/cvfromtup1
cat >$OUT_DIR/tupl/array/cvfromtup1/ccod <<'-----'
#ifdef ISCHAR
#include <aux/com/cvtotupl/defp>
  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { register Nat0 lx1 = cvfromtup1_nat0(x1);
    register DOMAIN lx2;

    lx2 = mkn_empty##_DOMAIN(lx1);
    for (; lx1 >= 1; lx1--) {
          *( ((ELEM1 *)(lx2 + 1)) + lx2->f_len++) = hd##_TUPLDOMAIN(*x1);
	  *x1  = tld##_TUPLDOMAIN(*x1);
    }
    return lx2;
  }

#include <aux/com/cvtotupl/undefp>
#else
#define __ADDELEM appr
#define MK_EMPTY(x1) MERGE(mkn_empty,_DOMAIN)(x1)
#include <aux/com/cvfromtup1/ccod>
#endif
-----
cat >$OUT_DIR/tupl/array/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tupl/array/cvfromtup1/vdm <<'-----'
#define __ADDELEM appr
#define MK_EMPTY(x1) MERGE(mkn_empty,_DOMAIN)(x1)
#include <aux/com/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/tupl/array/del1 ] || mkdir $OUT_DIR/tupl/array/del1
cat >$OUT_DIR/tupl/array/del1/ccod <<'-----'
#include <aux/array/del1/ccod>
-----
[ -d $OUT_DIR/tupl/array/fapp ] || mkdir $OUT_DIR/tupl/array/fapp
cat >$OUT_DIR/tupl/array/fapp/ccod <<'-----'
#define FCT fapp
#define ACC "a"
#define WLOOP \
  if (fwrite((char *)(x1+1),sizeof(ELEM1),x1->f_len,fd) != x1->f_len) return 0;
#include <tupl/aux/fwrite/ccod>
-----
cat >$OUT_DIR/tupl/array/fapp/docu <<'-----'
  array implementation of fapp

  time complexity : O(n)
-----
cat >$OUT_DIR/tupl/array/fapp/vdm <<'-----'
#include <tupl/aux/fwrite/vdm>
-----
[ -d $OUT_DIR/tupl/array/forall ] || mkdir $OUT_DIR/tupl/array/forall
cat >$OUT_DIR/tupl/array/forall/ccod <<'-----'
#include <aux/array/forall/ccod>
-----
[ -d $OUT_DIR/tupl/array/fread ] || mkdir $OUT_DIR/tupl/array/fread
cat >$OUT_DIR/tupl/array/fread/ccod <<'-----'
/* reading into an array is done by trying to read as much as
   space is available, if the whole array is filled by fread
   a new array is allocated with the max size doubled and incremented
   the increment is neccessay in the case where the empty tuple
   has allocated a maximum number of elements = 0
*/

#define ALLOCmcr MERGE(alloc,_DOMAIN)
#define DEL1mcr MERGE(del1,_DOMAIN)

#define RLOOP \
 {int space;\
  int cnt;\
  while (space = (int)(t1->f_max - t1->f_len),\
         (cnt = fread((char *)(((ELEM *)(t1 + 1)) + t1->f_len),\
                      sizeof(ELEM1),\
                      (size_t)space,fd)) == space)\
   {DOMAIN t2;\
    t2 = ALLOCmcr((Nat0)((t1->f_max)*2 + 1));\
    t2->f_len = t1->f_max;\
    {register Nat0 i = t1->f_max;\
     register ELEM1 * px3 = (ELEM1 *)(t2 + 1);\
     register ELEM1 * px1 = (ELEM1 *)(t1 + 1);\
     while (i--) *(px3++) = *(px1++);\
    }\
    DEL1mcr(t1);\
    t1 = t2;\
   }\
  t1->f_len += cnt;\
 }

#include <tupl/aux/fread/ccod>
#undef ALLOCmcr
#undef DEL1mcr
-----
cat >$OUT_DIR/tupl/array/fread/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + del1
-----
[ -d $OUT_DIR/tupl/array/fwrite ] || mkdir $OUT_DIR/tupl/array/fwrite
cat >$OUT_DIR/tupl/array/fwrite/ccod <<'-----'
#define WLOOP \
  if (fwrite((char *)(x1+1) \
            ,sizeof(ELEM1) \
            ,(size_t)(x1->f_len) \
            ,fd \
            ) != x1->f_len) return 0;
#include <tupl/aux/fwrite/ccod>
-----
cat >$OUT_DIR/tupl/array/fwrite/docu <<'-----'
  array implementation of fwrite

  time complexity : O(n)
-----
cat >$OUT_DIR/tupl/array/fwrite/vdm <<'-----'
#include <tupl/aux/fwrite/vdm>
-----
[ -d $OUT_DIR/tupl/array/is_empty ] || mkdir $OUT_DIR/tupl/array/is_empty
cat >$OUT_DIR/tupl/array/is_empty/ccod <<'-----'
#include <aux/array/is_empty/ccod>
-----
cat >$OUT_DIR/tupl/array/is_empty/cmcr <<'-----'
#include <aux/array/is_empty/cmcr>
-----
cat >$OUT_DIR/tupl/array/is_empty/docu <<'-----'
  time complexity : constant
-----
cat >$OUT_DIR/tupl/array/is_empty/pmcr <<'-----'
#include <aux/array/is_empty/pmcr>
-----
[ -d $OUT_DIR/tupl/array/is_eq ] || mkdir $OUT_DIR/tupl/array/is_eq
cat >$OUT_DIR/tupl/array/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {register Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    if (lx1 != ref##_DOMAIN(x2)->f_len) return 0;
    {Nat0 i = 0;
     register ELEM1 * px1 = (ELEM1 *)(x1+1);
     register ELEM1 * px2 = (ELEM1 *)(x2+1);
     while (i != lx1)
     {if (! is_eq##_ELEM1(*(px1++),*(px2++))) return 0;
      i++;
     } 
     return 1;
    }
   }
-----
cat >$OUT_DIR/tupl/array/is_eq/docu <<'-----'
  array implementation of is_eq for tuples

  time complexity : O(n) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/array/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1     =  + is_eq
-----
[ -d $OUT_DIR/tupl/array/is_ge ] || mkdir $OUT_DIR/tupl/array/is_ge
cat >$OUT_DIR/tupl/array/is_ge/ccod <<'-----'
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    Nat0 lx2 = ref##_DOMAIN(x2)->f_len;
    Nat0 i = 0;
    ELEM1 * px1 = (ELEM1 *)(x1+1);
    ELEM1 * px2 = (ELEM1 *)(x2+1);
    while (1)
    {if (i == lx2) return 1;
     if (i == lx1) return 0;
     {ELEM1 le1 = * (px1++);
      ELEM1 le2 = * (px2++);
      if (is_eq##_ELEM1(le1,le2)) i++;
      else return is_ge##_ELEM1(le1,le2);
     }
    }
   }
-----
cat >$OUT_DIR/tupl/array/is_ge/docu <<'-----'
  array implementation of is_ge for tuples
  is_ge is the lexicografical ordering functions
  an ordering functions on the element domain must be available

  time complexity : O(n) * O(is_ge(ELEM1))
-----
cat >$OUT_DIR/tupl/array/is_ge/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1     =  + is_ge + is_eq
-----
[ -d $OUT_DIR/tupl/array/is_gr ] || mkdir $OUT_DIR/tupl/array/is_gr
cat >$OUT_DIR/tupl/array/is_gr/ccod <<'-----'
  Bool is_gr##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    Nat0 lx2 = ref##_DOMAIN(x2)->f_len;
    register Nat0 i = 0;
    register ELEM1 * px1 = (ELEM1 *)(x1+1);
    register ELEM1 * px2 = (ELEM1 *)(x2+1);
    while (1)
    {if (i == lx1) return 0;
     if (i == lx2) return 1;
     {ELEM1 le1 = * (px1++);
      ELEM1 le2 = * (px2++);
      if (is_eq##_ELEM1(le1,le2)) i++;
      else return is_ge##_ELEM1(le1,le2);
     }
    }
   }
-----
cat >$OUT_DIR/tupl/array/is_gr/docu <<'-----'
  array implementation of is_gr for tuples
  is_gr is the lexicografical ordering functions
  an ordering functions on the element domain must be available

  time complexity : O(n) * O(is_ge(ELEM1))
-----
cat >$OUT_DIR/tupl/array/is_gr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1     =  + is_ge + is_eq
-----
[ -d $OUT_DIR/tupl/array/iterator ] || mkdir $OUT_DIR/tupl/array/iterator
cat >$OUT_DIR/tupl/array/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/tupl/array/iterator/vdm <<'-----'
#define IMPL array
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/tupl/array/len ] || mkdir $OUT_DIR/tupl/array/len
cat >$OUT_DIR/tupl/array/len/ccod <<'-----'
#define fct len
#include <aux/array/len/ccod>
-----
cat >$OUT_DIR/tupl/array/len/cmcr <<'-----'
#include <aux/array/len/cmcr>
-----
cat >$OUT_DIR/tupl/array/len/docu <<'-----'
  time complexity : constant
-----
cat >$OUT_DIR/tupl/array/len/pmcr <<'-----'
#include <aux/array/len/pmcr>
-----
[ -d $OUT_DIR/tupl/array/mk1 ] || mkdir $OUT_DIR/tupl/array/mk1
cat >$OUT_DIR/tupl/array/mk1/ccod <<'-----'
#include <aux/array/mk1/ccod>
-----
cat >$OUT_DIR/tupl/array/mk1/vdm <<'-----'

#define CONSTRNAME mk1
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/array/mk_empty ] || mkdir $OUT_DIR/tupl/array/mk_empty
cat >$OUT_DIR/tupl/array/mk_empty/ccod <<'-----'
#include <aux/array/mk_empty/ccod>
-----
cat >$OUT_DIR/tupl/array/mk_empty/cmcr <<'-----'
#include <aux/array/mk_empty/cmcr>
-----
cat >$OUT_DIR/tupl/array/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/array/mk_sub_tup ] || mkdir $OUT_DIR/tupl/array/mk_sub_tup
cat >$OUT_DIR/tupl/array/mk_sub_tup/ccod <<'-----'
#if ! SIMPLEELEMS
#define copyelem(x)MERGE(copy,_ELEM1)(x)
#else
#define copyelem(x)x
#endif

  DOMAIN mk_sub_tup##_DOMAIN _FPH3(DOMAIN,Nat1,Nat0)
  { DOMAIN lx1;
    Nat0   len1;
    if (x3 > ref##_DOMAIN(x1)->f_len) { x3 = x1->f_len; }
    if (x2 > x3) { x2 = x3 + 1; }
    len1 = x3 - x2 + 1;
    lx1  = alloc##_DOMAIN(len1);
    lx1->f_len = len1;
    { register ELEM1 * plx1  = (ELEM1 *)(lx1+1);
      register ELEM1 * px1   =((ELEM1 *)( x1+1)) + (x2 - 1);
      register ELEM1 * pend  = plx1 + len1;
      while (plx1 != pend) { *(plx1++) = copyelem(*(px1++)); }
    }
    return lx1;
  }

#undef copyelem
-----
[ -d $OUT_DIR/tupl/array/mkc ] || mkdir $OUT_DIR/tupl/array/mkc
cat >$OUT_DIR/tupl/array/mkc/ccod <<'-----'
  DOMAIN mkc##_DOMAIN _FPH1(ELEM1 *)
   {register Nat0    li  = 0;   
    register ELEM1 * lx1 = (ELEM1 *)x1;
    while (*(lx1++)) li++;
    {DOMAIN          x2  = alloc##_DOMAIN(li);
     register ELEM1 * lx2 = (ELEM1 *)(x2 + 1);
     lx1 = (ELEM1 *)x1;
     while (li--) *(lx2++) = *(lx1++);
     return x2;
    }
   }
-----
cat >$OUT_DIR/tupl/array/mkc/vdm <<'-----'

#define CONSTRNAME mkc
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/array/mklc ] || mkdir $OUT_DIR/tupl/array/mklc
cat >$OUT_DIR/tupl/array/mklc/ccod <<'-----'
  DOMAIN mklc##_DOMAIN _FPH1( char *)
   {register Nat0    li  = 0;   
    register ELEM1 * lx1 = (ELEM1 *)x1;
    while (*(lx1++)) li++;
    {DOMAIN          x2  = alloc##_DOMAIN(li);
     register ELEM1 * lx2 = (ELEM1 *)(x2 + 1);
     lx1 = (ELEM1 *)x1;
     while (li--) {register ELEM1 c = *(lx1++);
                   *(lx2++) = (isupper(c))?tolower(c):c;
                  }
     return x2;
    }
   }
-----
cat >$OUT_DIR/tupl/array/mklc/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
Vdmlib  = + header("CTYPE")
-----
[ -d $OUT_DIR/tupl/array/mkn ] || mkdir $OUT_DIR/tupl/array/mkn
cat >$OUT_DIR/tupl/array/mkn/ccod <<'-----'
#ifndef COPY
#define COPY(x) x
#endif

#ifndef FCT
#define FCT mkn
#endif

  DOMAIN FCT##_DOMAIN _FPH2(ELEM1,Nat0)
  { DOMAIN y1 = alloc##_DOMAIN(x2);
    ELEM1* y2 = ((ELEM1 *)(y1 + 1));

    while(x2--) { *(y2++) = COPY(x1); }
    return y1;
  }

#undef FCT
#undef COPY
#undef FCT
-----
cat >$OUT_DIR/tupl/array/mkn/docu <<'-----'
  time complexity : O(n)
-----
[ -d $OUT_DIR/tupl/array/mkn_empty ] || mkdir $OUT_DIR/tupl/array/mkn_empty
cat >$OUT_DIR/tupl/array/mkn_empty/ccod <<'-----'
#include <aux/array/mkn_empty/ccod>
-----
cat >$OUT_DIR/tupl/array/mkn_empty/param <<'-----'
MACROS
-----
[ -d $OUT_DIR/tupl/array/mknc ] || mkdir $OUT_DIR/tupl/array/mknc
cat >$OUT_DIR/tupl/array/mknc/ccod <<'-----'
#define COPY(x1) MERGE(copy,_ELEM1)(x1)
#define FCT	 mknc
#include <tupl/array/mkn/ccod>
-----
cat >$OUT_DIR/tupl/array/mknc/docu <<'-----'
  time complexity : O(n) * O(copy##_ELEM1)
-----
cat >$OUT_DIR/tupl/array/mknc/vdm <<'-----'
_ADD_OP(ELEM1,copy)
-----
[ -d $OUT_DIR/tupl/array/ovwrt1 ] || mkdir $OUT_DIR/tupl/array/ovwrt1
cat >$OUT_DIR/tupl/array/ovwrt1/ccod <<'-----'

#ifndef fct
#define fct ovwrt1
#endif
#ifndef delelem
#define delelem(z1)
#endif

  DOMAIN fct##_DOMAIN _FPH3(DOMAIN,Nat1,ELEM1)
   {
#if ! NOCHECK
    if (x2 > ref##_DOMAIN(x1)->f_len)
       err_sel_vdmlib(x2,(Nat0)(x1->f_len),MKSTRING(DOMAIN));
#endif
    delelem(*( ((ELEM1 *)(x1 + 1)) + x2 -1));
    *( ((ELEM1 *)(x1 + 1)) + x2 -1) = x3;
    return x1;
   }

#undef fct
#undef delelem
-----
cat >$OUT_DIR/tupl/array/ovwrt1/docu <<'-----'
  time complexity : constant !
-----
cat >$OUT_DIR/tupl/array/ovwrt1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
Vdmlib   = + err_sel
#endif
-----
[ -d $OUT_DIR/tupl/array/ovwrt1d ] || mkdir $OUT_DIR/tupl/array/ovwrt1d
cat >$OUT_DIR/tupl/array/ovwrt1d/ccod <<'-----'
#define fct ovwrt1d
#if ! SIMPLEELEMS
#define delelem(z1) MERGE(del,_ELEM1)(z1)
#endif
#include <tupl/array/ovwrt1/ccod>
-----
cat >$OUT_DIR/tupl/array/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   Vdmlib   = + err_sel
#endif
   ELEM1    = + del
#if ! SIMPLEELEMS

#endif
-----
[ -d $OUT_DIR/tupl/array/print ] || mkdir $OUT_DIR/tupl/array/print
cat >$OUT_DIR/tupl/array/print/ccod <<'-----'
#ifdef ISCHAR
  void print##_DOMAIN _FPH1(DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;   
_IFDEF __cplusplus
    print_FD_vdmlib << "\"";
_ELSE
    fprintf(print_FD_vdmlib,"\"");
_ENDIF
    if (lx1)
     {ELEM1 * px1 = ((ELEM1 *)(x1 + 1)) + lx1 -1;
      static ELEM1 lx1[] = " ";
      lx1[0] = * px1;
      * px1 = 0;
_IFDEF __cplusplus
      print_FD_vdmlib << (ELEM1 *)(x1 + 1) << lx1;
_ELSE
      fprintf(print_FD_vdmlib,"%s%s",(ELEM1 *)(x1 + 1),lx1);
_ENDIF
      * px1 = lx1[0];
     }
_IFDEF __cplusplus
    print_FD_vdmlib << "\"";
_ELSE
    fprintf(print_FD_vdmlib,"\"");
_ENDIF
   }
#else
#include <tupl/com/print/ccod>
#endif
-----
cat >$OUT_DIR/tupl/array/print/docu <<'-----'
  for strings the tupl is printed a a quoted character sequence
  else the standard print routine is taken
-----
cat >$OUT_DIR/tupl/array/print/vdm <<'-----'
#if ! ISCHAR
#include <tupl/com/print/vdm>
#else
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + printsup
#endif   
-----
[ -d $OUT_DIR/tupl/array/puts ] || mkdir $OUT_DIR/tupl/array/puts
cat >$OUT_DIR/tupl/array/puts/ccod <<'-----'
_IFDEF __cplusplus
  void puts##_DOMAIN _FPH2(DOMAIN,ostream &)
_ELSE
  void puts##_DOMAIN _FPH2(DOMAIN,FILE *)
_ENDIF
   {Nat0    li = x1->f_len;
    ELEM1 * lx1 = (ELEM1 *)(x1 + 1);
    while (li--)
_IFDEF __cplusplus
      x2 << (char)(*(lx1++));
_ELSE
      fputc((char)(*(lx1++)),x2);
_ENDIF
   }
-----
cat >$OUT_DIR/tupl/array/puts/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + header("STDIO")
-----
[ -d $OUT_DIR/tupl/array/read ] || mkdir $OUT_DIR/tupl/array/read
cat >$OUT_DIR/tupl/array/read/ccod <<'-----'
DOMAIN read##_DOMAIN _FPH2(Intg,Nat0)
  { DOMAIN lx1 = alloc##_DOMAIN(x2);
    Intg   lx2 = read(x1,(char *)(lx1 + 1),x2 * sizeof(ELEM1));

    lx1->f_len = (lx2 < 0) ? 0 : lx2 / sizeof(ELEM1);
    return lx1;
  }

-----
cat >$OUT_DIR/tupl/array/read/docu <<'-----'
  Special implementation of 'read' for arrays. The tuple is read
  by calling the Unix read system call once.
-----
[ -d $OUT_DIR/tupl/array/sel ] || mkdir $OUT_DIR/tupl/array/sel
cat >$OUT_DIR/tupl/array/sel/ccod <<'-----'
ELEM1 sel##_DOMAIN _FPH2(DOMAIN,Nat1)
{

#if ! NOCHECK
    if (x2 > ref##_DOMAIN(x1)->f_len)
	err_sel_vdmlib(x2,(Nat0)(x1->f_len),MKSTRING(DOMAIN));
#endif
    return *( ((ELEM1 *)(x1 + 1)) + x2 -1);
}
-----
cat >$OUT_DIR/tupl/array/sel/cmcr <<'-----'
#if NOCHECK
_DEFINE sel##_DOMAIN(x1,x2) (*( ((ELEM1 *)((x1) + 1)) + x2 -1))
#else
#include <tupl/sign/sel/gsig>
#endif
-----
cat >$OUT_DIR/tupl/array/sel/docu <<'-----'
  time complexity : constant !
-----
cat >$OUT_DIR/tupl/array/sel/pmcr <<'-----'
_DEFINE sel##_DOMAIN(x1,x2) x1^.f_str[x2]
-----
cat >$OUT_DIR/tupl/array/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS

#if ! NOCHECK
   Vdmlib   = + err_sel
#endif

#if MACROS && ! NOCHECK
   DOMAIN   = + sel_save
#endif
-----
[ -d $OUT_DIR/tupl/array/sel_save ] || mkdir $OUT_DIR/tupl/array/sel_save
cat >$OUT_DIR/tupl/array/sel_save/ccod <<'-----'
#include <tupl/array/sel/ccod>
-----
[ -d $OUT_DIR/tupl/array/sub_tup ] || mkdir $OUT_DIR/tupl/array/sub_tup
cat >$OUT_DIR/tupl/array/sub_tup/ccod <<'-----'
#ifndef fct
#define fct sub_tup
#endif

#ifndef delelem
#define delelem
#endif

DOMAIN fct##_DOMAIN _FPH3(DOMAIN,Nat1,Nat0)
  { if (x3 > ref##_DOMAIN(x1)->f_len) { x3 = x1->f_len; }
    if (x2 > x3) { x2 = x3 + 1; }
    delelem
    { x1->f_len = x3 - x2 + 1;
      CA testing and optimizing the case of a truncation CE
      if (x2 != 1)
         { register ELEM1 * px1  = (ELEM1 *)(x1+1);
                    CA start of array CE
           register ELEM1 * px2  = px1 + (x2 - 1);
                    CA start of substring CE
           register ELEM1 * pend = px1 + x1->f_len;
                    CA points behind the end of the new string CE
           while (px1 != pend) { *(px1++) = *(px2++); }
                    CA move all elements to the front of the array CE
         }
    }
    return x1;
  }

#undef fct
#undef delelem
-----
cat >$OUT_DIR/tupl/array/sub_tup/docu <<'-----'
  Special implementation of 'sub_tup' by moving the
  substring to the beginning of the array.
-----
[ -d $OUT_DIR/tupl/array/sub_tupd ] || mkdir $OUT_DIR/tupl/array/sub_tupd
cat >$OUT_DIR/tupl/array/sub_tupd/ccod <<'-----'
#define fct sub_tupd

#if ! SIMPLEELEMS
#define delelem  delelem1 delelem2
#define delelem0(i) MERGE(del,_ELEM1)( ((ELEM1 *)(x1+1))[(i)-1] );
#define delelem1 { register Nat0 i=1;  while (i != x2       ) delelem0(i++) }
#define delelem2 { register Nat0 i=x3; while (i != x1->f_len) delelem0(++i) }
#endif

#include <tupl/array/sub_tup/ccod>

#undef delelem0
#undef delelem1
#undef delelem2
-----
cat >$OUT_DIR/tupl/array/sub_tupd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! SIMPLEELEMS
   ELEM1    = + del
#endif
-----
[ -d $OUT_DIR/tupl/array/tl ] || mkdir $OUT_DIR/tupl/array/tl
cat >$OUT_DIR/tupl/array/tl/ccod <<'-----'
#ifndef FCT
#define FCT tl
#endif

#ifndef SUBTUP
#define SUBTUP sub_tup
#endif

DOMAIN FCT##_DOMAIN _FPH1(DOMAIN)
  { 
#if !NOCHECK
    if (ref##_DOMAIN(x1)->f_len == 0) { err_tl_vdmlib(MKSTRING(DOMAIN)); }
#endif
    return SUBTUP##_DOMAIN(x1,(Nat1)2,x1->f_len);
  }

#undef FCT
#undef SUBTUP
-----
cat >$OUT_DIR/tupl/array/tl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifndef NOCHECK
  Vdmlib	= + err_tl
#endif
  DOMAIN        = + sub_tup
-----
[ -d $OUT_DIR/tupl/array/tld ] || mkdir $OUT_DIR/tupl/array/tld
cat >$OUT_DIR/tupl/array/tld/ccod <<'-----'
#define FCT tld
#define SUBTUP sub_tupd
#include <tupl/array/tl/ccod>
-----
cat >$OUT_DIR/tupl/array/tld/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifndef NOCHECK
  Vdmlib	= + err_tl
#endif
  DOMAIN        = + sub_tupd
-----
[ -d $OUT_DIR/tupl/array/write ] || mkdir $OUT_DIR/tupl/array/write
cat >$OUT_DIR/tupl/array/write/ccod <<'-----'
Intg write##_DOMAIN _FPH2(Intg,DOMAIN)
  { Intg lx1 = write(x1,(char *)(x2 + 1),(x2->f_len) * sizeof(ELEM1));
    return  (lx1 < 0) ? lx1 : lx1 / sizeof(ELEM1);
  }
-----
cat >$OUT_DIR/tupl/array/write/docu <<'-----'
  Array implementation of write. The whole tuple is written with one
  system call.
-----
[ -d $OUT_DIR/tupl/automem ] || mkdir $OUT_DIR/tupl/automem
[ -d $OUT_DIR/tupl/automem/all ] || mkdir $OUT_DIR/tupl/automem/all
cat >$OUT_DIR/tupl/automem/all/vdm <<'-----'
! === automem: Operation tupl/all not supported === !
-----
[ -d $OUT_DIR/tupl/automem/appl ] || mkdir $OUT_DIR/tupl/automem/appl
cat >$OUT_DIR/tupl/automem/appl/ccod <<'-----'
DOMAIN appl##_DOMAIN _FPH2(ELEM1, DOMAIN)
{
   check_handle##_DOMAIN(x2);
   cond_clone##_DOMAIN(&x2);
   x1 = copy##_ELEM1(x1);
   x2->f_rep = appl_rep##_DOMAIN(x1,x2->f_rep);
   return x2;
}
-----
cat >$OUT_DIR/tupl/automem/appl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + appl
   ELEM1        = + copy
-----
[ -d $OUT_DIR/tupl/automem/appr ] || mkdir $OUT_DIR/tupl/automem/appr
cat >$OUT_DIR/tupl/automem/appr/ccod <<'-----'
#define NAME appr
#define REP_NAME appr
#define P2_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/tupl/automem/appr/vdm <<'-----'
#define NAME appr
#define REP_NAME appr
#define P2_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/tupl/automem/automemresult ] || mkdir $OUT_DIR/tupl/automem/automemresult
cat >$OUT_DIR/tupl/automem/automemresult/param <<'-----'
FCTNAME
ARGUMENT
OPERATION
-----
cat >$OUT_DIR/tupl/automem/automemresult/vdm <<'-----'
/* this directive passes back to the OPERATION of the
   ARGUMENT domain, whether the result (usually domain Str) is
   implemented as automem
*/
DOMAINS
IMPLEMENTATIONS
  ARGUMENT = + OPERATION("AUTOMEMRESULT")
-----
[ -d $OUT_DIR/tupl/automem/basic ] || mkdir $OUT_DIR/tupl/automem/basic
cat >$OUT_DIR/tupl/automem/basic/ccod <<'-----'
#include <aux/automem/basic/ccod>
-----
cat >$OUT_DIR/tupl/automem/basic/docu <<'-----'
#define TYPGEN tuple
#include <aux/automem/basic/docu>
-----
cat >$OUT_DIR/tupl/automem/basic/gptr <<'-----'
#include <aux/automem/basic/gptr>
-----
cat >$OUT_DIR/tupl/automem/basic/gtyp <<'-----'
#include <aux/automem/basic/gtyp>
-----
cat >$OUT_DIR/tupl/automem/basic/param <<'-----'
BASEIMPL
FORWARD_ALLOWED
INTERNALDOMAIN
ISSTRING
MACROS
NOCHECK
-----
cat >$OUT_DIR/tupl/automem/basic/vdm <<'-----'
#define REP_DOMAIN  ELEM1 *
#include <aux/automem/basic/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/automem/binary ] || mkdir $OUT_DIR/tupl/automem/binary
cat >$OUT_DIR/tupl/automem/binary/vdm <<'-----'
! === automem: Operation tupl/binary not supported === !
-----
[ -d $OUT_DIR/tupl/automem/conc ] || mkdir $OUT_DIR/tupl/automem/conc
cat >$OUT_DIR/tupl/automem/conc/ccod <<'-----'
#if !defined(ISSTRING)

#define NAME conc
#define REP_NAME conc
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>

#else
/*
   This version of the conc function for Str will be called from the C++
   interface if automatic memory management is selected. The second  
   parameter will remain unchanged.
   It is called conc_auto so that it will not be called
   from internal operations in the database.
*/
#define NAME conc_auto
#define REP_NAME conc
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>

/* 
   This version of the conc function (for Str only) will be used by internal 
   operations of the database; the operations expect that the second parameter
   will be destroyed by the conc function, therefore we'll do it manually 
   here. Otherwise the second parameter would never be deleted.
*/ 
DOMAIN conc##_DOMAIN _FPH2(DOMAIN,DOMAIN)
{
   check_handle##_DOMAIN(x1);
   check_handle##_DOMAIN(x1);
   cond_clone##_DOMAIN(&x1);
   x1->f_rep = conc_rep##_DOMAIN(x1->f_rep,x2->f_rep);
   free_str(x2);
   return x1;  
}

#endif
-----
cat >$OUT_DIR/tupl/automem/conc/vdm <<'-----'
#define REP_NAME conc
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/tupl/automem/conc3 ] || mkdir $OUT_DIR/tupl/automem/conc3
cat >$OUT_DIR/tupl/automem/conc3/vdm <<'-----'
! === automem: Operation tupl/conc3 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/conc4 ] || mkdir $OUT_DIR/tupl/automem/conc4
cat >$OUT_DIR/tupl/automem/conc4/vdm <<'-----'
! === automem: Operation tupl/conc4 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/conc5 ] || mkdir $OUT_DIR/tupl/automem/conc5
cat >$OUT_DIR/tupl/automem/conc5/vdm <<'-----'
! === automem: Operation tupl/conc5 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/conc6 ] || mkdir $OUT_DIR/tupl/automem/conc6
cat >$OUT_DIR/tupl/automem/conc6/vdm <<'-----'
! === automem: Operation tupl/conc6 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/conc_path ] || mkdir $OUT_DIR/tupl/automem/conc_path
cat >$OUT_DIR/tupl/automem/conc_path/ccod <<'-----'
#if !defined(ISSTRING)

#define NAME conc_path
#define REP_NAME conc_path
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>

#else
/*
   This version of the conc_path function for Str will be called from the C++
   interface if automatic memory management is selected. The second  
   parameter will be saved. It is called conc_path_auto so that it will not 
   be called from internal operations in the database.
*/
#define NAME conc_path_auto
#define REP_NAME conc_path
#define P2_DESTROYED
#include <aux/automem/update_DD/ccod>

/* 
   This version of the conc_path function (for Str only) will be used by 
   internal operations of the database; the operations expect that the second 
   parameter will be destroyed by the conc function, therefore we'll do it 
   manually here. Otherwise this string would never be deleted !
*/ 
DOMAIN conc_path##_DOMAIN _FPH2(DOMAIN,DOMAIN)
{
   check_handle##_DOMAIN(x1);
   check_handle##_DOMAIN(x1);
   cond_clone##_DOMAIN(&x1);
   x1->f_rep = conc_path_rep##_DOMAIN(x1->f_rep,x2->f_rep);
   free_str(x2);
   return x1;  
}

#endif
-----
cat >$OUT_DIR/tupl/automem/conc_path/vdm <<'-----'
#define REP_NAME conc_path
#define P2_DESTROYED
#include <aux/automem/update_DD/vdm>
-----
[ -d $OUT_DIR/tupl/automem/concc ] || mkdir $OUT_DIR/tupl/automem/concc
cat >$OUT_DIR/tupl/automem/concc/vdm <<'-----'
! === automem: tupl/concc not supported  === !
-----
[ -d $OUT_DIR/tupl/automem/copy ] || mkdir $OUT_DIR/tupl/automem/copy
cat >$OUT_DIR/tupl/automem/copy/ccod <<'-----'
#include <aux/automem/copy/ccod>
-----
cat >$OUT_DIR/tupl/automem/copy/vdm <<'-----'
#include <aux/automem/copy/vdm>
-----
[ -d $OUT_DIR/tupl/automem/copy1 ] || mkdir $OUT_DIR/tupl/automem/copy1
cat >$OUT_DIR/tupl/automem/copy1/vdm <<'-----'
! === automem: Operation tupl/copy1 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/copy2 ] || mkdir $OUT_DIR/tupl/automem/copy2
cat >$OUT_DIR/tupl/automem/copy2/vdm <<'-----'
! === automem: Operation tupl/copy2 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/cpc ] || mkdir $OUT_DIR/tupl/automem/cpc
cat >$OUT_DIR/tupl/automem/cpc/ccod <<'-----'
/* only 'char *' allowed as second parameter because target language is
   allways C++ */
void cpc##_DOMAIN _FPH2(DOMAIN, char *)
{
   check_handle##_DOMAIN(x1);
   cpc_rep##_DOMAIN(x1->f_rep, x2);
}
-----
cat >$OUT_DIR/tupl/automem/cpc/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + cpc
-----
[ -d $OUT_DIR/tupl/automem/cvfromtup1 ] || mkdir $OUT_DIR/tupl/automem/cvfromtup1
cat >$OUT_DIR/tupl/automem/cvfromtup1/ccod <<'-----'
#include <aux/automem/cvfromtup1/ccod>
-----
cat >$OUT_DIR/tupl/automem/cvfromtup1/param <<'-----'
#include <aux/automem/cvfromtup1/param>
-----
cat >$OUT_DIR/tupl/automem/cvfromtup1/vdm <<'-----'
#include <aux/automem/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/tupl/automem/cvfromtupl ] || mkdir $OUT_DIR/tupl/automem/cvfromtupl
cat >$OUT_DIR/tupl/automem/cvfromtupl/ccod <<'-----'
#include <aux/automem/cvfromtupl/ccod>
-----
cat >$OUT_DIR/tupl/automem/cvfromtupl/param <<'-----'
#include <aux/automem/cvfromtupl/param>
-----
cat >$OUT_DIR/tupl/automem/cvfromtupl/vdm <<'-----'
#include <aux/automem/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/tupl/automem/cvlines ] || mkdir $OUT_DIR/tupl/automem/cvlines
cat >$OUT_DIR/tupl/automem/cvlines/ccod <<'-----'
#define NAME cvlines
#define RESULT Cvtext_vdmlib
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/cvlines/cmcr <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/cvlines/vdm <<'-----'
#define NAME cvlines
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/cvtotup1 ] || mkdir $OUT_DIR/tupl/automem/cvtotup1
cat >$OUT_DIR/tupl/automem/cvtotup1/ccod <<'-----'
#include <aux/automem/cvtotup1/ccod>
-----
cat >$OUT_DIR/tupl/automem/cvtotup1/param <<'-----'
#include <aux/automem/cvtotup1/param>
-----
cat >$OUT_DIR/tupl/automem/cvtotup1/vdm <<'-----'
#include <aux/automem/cvtotup1/vdm>
-----
[ -d $OUT_DIR/tupl/automem/cvtotupl ] || mkdir $OUT_DIR/tupl/automem/cvtotupl
cat >$OUT_DIR/tupl/automem/cvtotupl/ccod <<'-----'
#include <aux/automem/cvtotupl/ccod>
-----
cat >$OUT_DIR/tupl/automem/cvtotupl/param <<'-----'
#include <aux/automem/cvtotupl/param>
-----
cat >$OUT_DIR/tupl/automem/cvtotupl/vdm <<'-----'
#include <aux/automem/cvtotupl/vdm>
-----
[ -d $OUT_DIR/tupl/automem/del ] || mkdir $OUT_DIR/tupl/automem/del
cat >$OUT_DIR/tupl/automem/del/ccod <<'-----'
#include <aux/automem/del/ccod>
-----
cat >$OUT_DIR/tupl/automem/del/vdm <<'-----'
#include <aux/automem/del/vdm>
-----
[ -d $OUT_DIR/tupl/automem/del1 ] || mkdir $OUT_DIR/tupl/automem/del1
cat >$OUT_DIR/tupl/automem/del1/vdm <<'-----'
! === automem: Operation tupl/del1 not required === !
-----
[ -d $OUT_DIR/tupl/automem/del2 ] || mkdir $OUT_DIR/tupl/automem/del2
cat >$OUT_DIR/tupl/automem/del2/vdm <<'-----'
! === automem: tupl/del2 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/elems ] || mkdir $OUT_DIR/tupl/automem/elems
cat >$OUT_DIR/tupl/automem/elems/ccod <<'-----'
#define NAME elems
#include <aux/automem/structselector/ccod>
-----
cat >$OUT_DIR/tupl/automem/elems/param <<'-----'
RESULT
COPY
-----
cat >$OUT_DIR/tupl/automem/elems/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + elems("RESULT"=Rep##_RESULT,"COPY")
-----
[ -d $OUT_DIR/tupl/automem/exist ] || mkdir $OUT_DIR/tupl/automem/exist
cat >$OUT_DIR/tupl/automem/exist/vdm <<'-----'
! === automem: Operation tupl/exist not supported === !
-----
[ -d $OUT_DIR/tupl/automem/exist1 ] || mkdir $OUT_DIR/tupl/automem/exist1
cat >$OUT_DIR/tupl/automem/exist1/vdm <<'-----'
! === automem: Operation tupl/exist1 not supported === !
-----
[ -d $OUT_DIR/tupl/automem/extract ] || mkdir $OUT_DIR/tupl/automem/extract
cat >$OUT_DIR/tupl/automem/extract/ccod <<'-----'
#define NAME extract
#define RESULT DOMAIN
#define _RESULT _DOMAIN
#define PAR2 INDEXSET
#define _PAR2 _INDEXSET
#include <aux/automem/structselector/ccod>
-----
cat >$OUT_DIR/tupl/automem/extract/param <<'-----'
INDEXSET
-----
cat >$OUT_DIR/tupl/automem/extract/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + extract("INDEXSET"=Rep##_INDEXSET)
-----
[ -d $OUT_DIR/tupl/automem/fapp ] || mkdir $OUT_DIR/tupl/automem/fapp
cat >$OUT_DIR/tupl/automem/fapp/ccod <<'-----'
#define NAME   fapp
#define PTYPE1 DOMAIN
#define PTYPE2 Str
#define P2_IS_ELEM
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/fapp/vdm <<'-----'
#define NAME fapp
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/filter ] || mkdir $OUT_DIR/tupl/automem/filter
cat >$OUT_DIR/tupl/automem/filter/ccod <<'-----'
#define NAME filter
#define RESULT DOMAIN
#define _RESULT _DOMAIN
#define PAR2 ELEMSET
#define _PAR2 _ELEMSET
#include <aux/automem/structselector/ccod>
-----
cat >$OUT_DIR/tupl/automem/filter/param <<'-----'
ELEMSET
-----
cat >$OUT_DIR/tupl/automem/filter/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + filter("ELEMSET"=Rep##_ELEMSET,"COPY")
-----
[ -d $OUT_DIR/tupl/automem/fold ] || mkdir $OUT_DIR/tupl/automem/fold
cat >$OUT_DIR/tupl/automem/fold/vdm <<'-----'
! === automem: tupl/fold not supported === !
-----
[ -d $OUT_DIR/tupl/automem/foldix ] || mkdir $OUT_DIR/tupl/automem/foldix
cat >$OUT_DIR/tupl/automem/foldix/vdm <<'-----'
! === automem: tupl/foldix not supported === !
-----
[ -d $OUT_DIR/tupl/automem/forall ] || mkdir $OUT_DIR/tupl/automem/forall
cat >$OUT_DIR/tupl/automem/forall/ccod <<'-----'
#include <aux/automem/forall/ccod>
-----
cat >$OUT_DIR/tupl/automem/forall/cmcr <<'-----'
#include <aux/automem/forall/cmcr>
-----
cat >$OUT_DIR/tupl/automem/forall/vdm <<'-----'
#include <aux/automem/forall/vdm>
-----
[ -d $OUT_DIR/tupl/automem/forindex ] || mkdir $OUT_DIR/tupl/automem/forindex
cat >$OUT_DIR/tupl/automem/forindex/vdm <<'-----'
! === automem: tupl/forindex not supported === !
-----
[ -d $OUT_DIR/tupl/automem/forrange ] || mkdir $OUT_DIR/tupl/automem/forrange
cat >$OUT_DIR/tupl/automem/forrange/vdm <<'-----'
! === automem: tupl/forrange not supported === !
-----
[ -d $OUT_DIR/tupl/automem/fread ] || mkdir $OUT_DIR/tupl/automem/fread
cat >$OUT_DIR/tupl/automem/fread/ccod <<'-----'
#define NAME   fread
#define PTYPE1 Str
#include <aux/automem/mk_special/ccod>
-----
cat >$OUT_DIR/tupl/automem/fread/vdm <<'-----'
#define REP_NAME fread
#include <aux/automem/mk_special/vdm>
-----
[ -d $OUT_DIR/tupl/automem/front ] || mkdir $OUT_DIR/tupl/automem/front
cat >$OUT_DIR/tupl/automem/front/ccod <<'-----'
DOMAIN front##_DOMAIN _FPH1(DOMAIN)
{
   check_handle##_DOMAIN(x1);
   cond_clone##_DOMAIN(&x1);
   x1->f_rep = frontd_rep##_DOMAIN(x1->f_rep);
   return x1;
}
-----
cat >$OUT_DIR/tupl/automem/front/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + frontd
-----
[ -d $OUT_DIR/tupl/automem/fwrite ] || mkdir $OUT_DIR/tupl/automem/fwrite
cat >$OUT_DIR/tupl/automem/fwrite/ccod <<'-----'
#define NAME   fwrite
#define PTYPE1 DOMAIN
#define PTYPE2 Str
#define P2_IS_ELEM
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/fwrite/vdm <<'-----'
#define NAME fwrite
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/gcinfo ] || mkdir $OUT_DIR/tupl/automem/gcinfo
cat >$OUT_DIR/tupl/automem/gcinfo/ccod <<'-----'
#include <aux/automem/gcinfo/ccod>
-----
cat >$OUT_DIR/tupl/automem/gcinfo/docu <<'-----'
#include <aux/automem/gcinfo/docu>
-----
cat >$OUT_DIR/tupl/automem/gcinfo/vdm <<'-----'
#include <aux/automem/gcinfo/vdm>
-----
[ -d $OUT_DIR/tupl/automem/hash ] || mkdir $OUT_DIR/tupl/automem/hash
cat >$OUT_DIR/tupl/automem/hash/ccod <<'-----'
#define NAME hash
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/hash/cmcr <<'-----'
#define NAME hash
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/hash/vdm <<'-----'
#define NAME hash
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/hd ] || mkdir $OUT_DIR/tupl/automem/hd
cat >$OUT_DIR/tupl/automem/hd/ccod <<'-----'
#define NAME hd
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/tupl/automem/hd/cmcr <<'-----'
#define NAME hd
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/tupl/automem/hd/vdm <<'-----'
#define NAME hd
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/tupl/automem/index ] || mkdir $OUT_DIR/tupl/automem/index
cat >$OUT_DIR/tupl/automem/index/ccod <<'-----'
#define NAME index
#define PTYPE2 ELEM1
#define P2_IS_ELEM
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/index/cmcr <<'-----'
#define NAME index
#define TWO_PARAM
#define P2_IS_ELEM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/index/vdm <<'-----'
#define NAME index
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/index_list ] || mkdir $OUT_DIR/tupl/automem/index_list
cat >$OUT_DIR/tupl/automem/index_list/ccod <<'-----'
#define NAME index_list
#define PTYPE2 DOMAIN
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/index_list/cmcr <<'-----'
#define NAME index_list
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/index_list/vdm <<'-----'
#define NAME index_list
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/index_list_from ] || mkdir $OUT_DIR/tupl/automem/index_list_from
cat >$OUT_DIR/tupl/automem/index_list_from/ccod <<'-----'
#define NAME index_list_from
#define PTYPE2 DOMAIN
#define PTYPE3 Nat1
#define P3_IS_ELEM
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/index_list_from/cmcr <<'-----'
#define NAME index_list_from
#define THREE_PARAM
#define P3_IS_ELEM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/index_list_from/vdm <<'-----'
#define NAME index_list_from
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/inds ] || mkdir $OUT_DIR/tupl/automem/inds
cat >$OUT_DIR/tupl/automem/inds/ccod <<'-----'
#include <tupl/com/inds/defs>
#define NAME inds
#include <aux/automem/structselector/ccod>
-----
cat >$OUT_DIR/tupl/automem/inds/param <<'-----'
RESULT
-----
cat >$OUT_DIR/tupl/automem/inds/vdm <<'-----'
#include <tupl/com/inds/defs>
#define NAME inds("RESULT"=RESULT)
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/input ] || mkdir $OUT_DIR/tupl/automem/input
cat >$OUT_DIR/tupl/automem/input/vdm <<'-----'
! === automem: tupl/input not supported === !
-----
[ -d $OUT_DIR/tupl/automem/insert ] || mkdir $OUT_DIR/tupl/automem/insert
cat >$OUT_DIR/tupl/automem/insert/ccod <<'-----'
#define NAME insert
#define REP_NAME insert
#define PTYPE2  Nat1
#define _PTYPE2 nat1
#define PTYPE3  ELEM1
#define _PTYPE3 _ELEM1
#define P3_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/tupl/automem/insert/vdm <<'-----'
#define NAME insert
#define REP_NAME insert
#define PTYPE2 Nat1
#define PTYPE3 ELEM1
#define P3_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/tupl/automem/is_empty ] || mkdir $OUT_DIR/tupl/automem/is_empty
cat >$OUT_DIR/tupl/automem/is_empty/ccod <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/is_empty/cmcr <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/is_empty/vdm <<'-----'
#define NAME is_empty
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/is_eq ] || mkdir $OUT_DIR/tupl/automem/is_eq
cat >$OUT_DIR/tupl/automem/is_eq/ccod <<'-----'
#define NAME is_eq
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/is_eq/cmcr <<'-----'
#define NAME is_eq
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/is_eq/vdm <<'-----'
#define NAME is_eq
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/is_ge ] || mkdir $OUT_DIR/tupl/automem/is_ge
cat >$OUT_DIR/tupl/automem/is_ge/ccod <<'-----'
#define NAME is_ge
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/is_ge/cmcr <<'-----'
#define NAME is_ge
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/is_ge/vdm <<'-----'
#define NAME is_ge
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/is_gr ] || mkdir $OUT_DIR/tupl/automem/is_gr
cat >$OUT_DIR/tupl/automem/is_gr/ccod <<'-----'
#define NAME is_gr
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/is_gr/cmcr <<'-----'
#define NAME is_gr
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/is_gr/vdm <<'-----'
#define NAME is_gr
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/is_postfix ] || mkdir $OUT_DIR/tupl/automem/is_postfix
cat >$OUT_DIR/tupl/automem/is_postfix/ccod <<'-----'
#define NAME is_postfix
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/is_postfix/cmcr <<'-----'
#define NAME is_postfix
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/is_postfix/vdm <<'-----'
#define NAME is_postfix
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/is_prefix ] || mkdir $OUT_DIR/tupl/automem/is_prefix
cat >$OUT_DIR/tupl/automem/is_prefix/ccod <<'-----'
#define NAME is_prefix
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/is_prefix/cmcr <<'-----'
#define NAME is_prefix
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/is_prefix/vdm <<'-----'
#define NAME is_prefix
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/is_subtup ] || mkdir $OUT_DIR/tupl/automem/is_subtup
cat >$OUT_DIR/tupl/automem/is_subtup/ccod <<'-----'
#define NAME is_subtup
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/is_subtup/cmcr <<'-----'
#define NAME is_subtup
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/is_subtup/vdm <<'-----'
#define NAME is_subtup
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/iterator ] || mkdir $OUT_DIR/tupl/automem/iterator
cat >$OUT_DIR/tupl/automem/iterator/vdm <<'-----'
#include <aux/automem/iterator/vdm>
DOMAINS
IMPLEMENTATIONS
  Rep##_DOMAIN = + iterator("INTERNALFCT")
-----
[ -d $OUT_DIR/tupl/automem/last ] || mkdir $OUT_DIR/tupl/automem/last
cat >$OUT_DIR/tupl/automem/last/ccod <<'-----'
#define NAME last
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/tupl/automem/last/cmcr <<'-----'
#define NAME last
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/tupl/automem/last/vdm <<'-----'
#define NAME last
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/tupl/automem/len ] || mkdir $OUT_DIR/tupl/automem/len
cat >$OUT_DIR/tupl/automem/len/ccod <<'-----'
#define NAME len
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/len/cmcr <<'-----'
#define NAME len
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/tupl/automem/len/vdm <<'-----'
#define NAME len
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mk1 ] || mkdir $OUT_DIR/tupl/automem/mk1
cat >$OUT_DIR/tupl/automem/mk1/ccod <<'-----'
#define NAME mk1
#define P1_INSERTED
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/tupl/automem/mk1/vdm <<'-----'
#define NAME mk1
#define P1_INSERTED
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk1
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mk2 ] || mkdir $OUT_DIR/tupl/automem/mk2
cat >$OUT_DIR/tupl/automem/mk2/ccod <<'-----'
#define NAME mk2
#define P1_INSERTED
#define P2_INSERTED
#define PTYPE2  ELEM1
#define _PTYPE2 _ELEM1
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/tupl/automem/mk2/vdm <<'-----'
#define NAME mk2
#define P1_INSERTED
#define P2_INSERTED
#define PTYPE2 ELEM1
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk2
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mk3 ] || mkdir $OUT_DIR/tupl/automem/mk3
cat >$OUT_DIR/tupl/automem/mk3/ccod <<'-----'
#define NAME mk3
#define P1_INSERTED
#define P2_INSERTED
#define P3_INSERTED
#define PTYPE2 ELEM1
#define PTYPE3 ELEM1
#define _PTYPE2 _ELEM1
#define _PTYPE3 _ELEM1
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/tupl/automem/mk3/vdm <<'-----'
#define NAME mk3
#define P1_INSERTED
#define P2_INSERTED
#define P3_INSERTED
#define PTYPE2 ELEM1
#define PTYPE3 ELEM1
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk3
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mk_empty ] || mkdir $OUT_DIR/tupl/automem/mk_empty
cat >$OUT_DIR/tupl/automem/mk_empty/ccod <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/ccod>
-----
cat >$OUT_DIR/tupl/automem/mk_empty/vdm <<'-----'
#define NAME mk_empty
#include <aux/automem/mk/vdm>

#define CONSTRNAME mk_empty
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mk_sub_tup ] || mkdir $OUT_DIR/tupl/automem/mk_sub_tup
cat >$OUT_DIR/tupl/automem/mk_sub_tup/ccod <<'-----'
DOMAIN mk_sub_tup##_DOMAIN _FPH3(DOMAIN, Nat1, Nat0)
{
   check_handle##_DOMAIN(x1);
   DOMAIN lx = alloc##_DOMAIN();
   lx->f_rc  = 1;
   lx->f_rep = mk_sub_tup_rep##_DOMAIN(x1->f_rep,x2,x3);
   return lx;
}
-----
cat >$OUT_DIR/tupl/automem/mk_sub_tup/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Rep##_DOMAIN = + mk_sub_tup
-----
[ -d $OUT_DIR/tupl/automem/mkarray ] || mkdir $OUT_DIR/tupl/automem/mkarray
cat >$OUT_DIR/tupl/automem/mkarray/vdm <<'-----'
! === automem: tupl/mkarray not supported === !
-----
[ -d $OUT_DIR/tupl/automem/mkc ] || mkdir $OUT_DIR/tupl/automem/mkc
cat >$OUT_DIR/tupl/automem/mkc/ccod <<'-----'
/* only 'char *' allowed as parameter because target language is allways C++ */
#define NAME   mkc
#define PTYPE1 char *
#include <aux/automem/mk_special/ccod>
-----
cat >$OUT_DIR/tupl/automem/mkc/vdm <<'-----'
#define REP_NAME mkc
#include <aux/automem/mk_special/vdm>

#define CONSTRNAME mkc
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mklc ] || mkdir $OUT_DIR/tupl/automem/mklc
cat >$OUT_DIR/tupl/automem/mklc/ccod <<'-----'
/* only 'char *' allowed as parameter because target language is allways C++ */
#define NAME   mklc
#define PTYPE1 char *
#include <aux/automem/mk_special/ccod>
-----
cat >$OUT_DIR/tupl/automem/mklc/vdm <<'-----'
#define REP_NAME mklc
#include <aux/automem/mk_special/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mkn ] || mkdir $OUT_DIR/tupl/automem/mkn
cat >$OUT_DIR/tupl/automem/mkn/ccod <<'-----'
#define NAME     mkn
#define REP_NAME mknc
#define PTYPE1   ELEM1
#define PTYPE2   Nat0
#include <aux/automem/mk_special/ccod>
-----
cat >$OUT_DIR/tupl/automem/mkn/vdm <<'-----'
#define REP_NAME mknc
#include <aux/automem/mk_special/vdm>
-----
[ -d $OUT_DIR/tupl/automem/mknc ] || mkdir $OUT_DIR/tupl/automem/mknc
cat >$OUT_DIR/tupl/automem/mknc/vdm <<'-----'
! === automem: tupl/mknc not supported === !
-----
[ -d $OUT_DIR/tupl/automem/ovwrt1 ] || mkdir $OUT_DIR/tupl/automem/ovwrt1
cat >$OUT_DIR/tupl/automem/ovwrt1/ccod <<'-----'
#define NAME ovwrt1
#define PTYPE2  Nat1
#define _PTYPE2 nat1
#define PTYPE3  ELEM1
#define _PTYPE3 _ELEM1
#define P3_INSERTED
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/tupl/automem/ovwrt1/vdm <<'-----'
#define NAME ovwrt1
#define PTYPE2 Nat1
#define PTYPE3 ELEM1
#define P3_INSERTED
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/tupl/automem/ovwrt1d ] || mkdir $OUT_DIR/tupl/automem/ovwrt1d
cat >$OUT_DIR/tupl/automem/ovwrt1d/vdm <<'-----'
! === automem: tupl/ovwrt1d not supported === !
-----
[ -d $OUT_DIR/tupl/automem/parse ] || mkdir $OUT_DIR/tupl/automem/parse
cat >$OUT_DIR/tupl/automem/parse/ccod <<'-----'
#include <aux/automem/parse/ccod>
-----
cat >$OUT_DIR/tupl/automem/parse/vdm <<'-----'
#include <aux/automem/parse/vdm>
-----
[ -d $OUT_DIR/tupl/automem/pr ] || mkdir $OUT_DIR/tupl/automem/pr
cat >$OUT_DIR/tupl/automem/pr/vdm <<'-----'
! === automem: tupl/pr not supported === !
-----
[ -d $OUT_DIR/tupl/automem/print ] || mkdir $OUT_DIR/tupl/automem/print
cat >$OUT_DIR/tupl/automem/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
    { check_handle##_DOMAIN(x1); print_rep##_DOMAIN(x1->f_rep); }
-----
cat >$OUT_DIR/tupl/automem/print/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    Rep##_DOMAIN = + print
-----
[ -d $OUT_DIR/tupl/automem/puts ] || mkdir $OUT_DIR/tupl/automem/puts
cat >$OUT_DIR/tupl/automem/puts/ccod <<'-----'
_IFDEF __cplusplus
  void puts##_DOMAIN _FPH2(DOMAIN,ostream &)
_ELSE
  void puts##_DOMAIN _FPH2(DOMAIN, FILE *)
_ENDIF
{
   check_handle##_DOMAIN(x1);
   puts_rep##_DOMAIN(x1->f_rep, x2);
}
-----
cat >$OUT_DIR/tupl/automem/puts/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + puts
-----
[ -d $OUT_DIR/tupl/automem/read ] || mkdir $OUT_DIR/tupl/automem/read
cat >$OUT_DIR/tupl/automem/read/vdm <<'-----'
! === automem: tupl/read not supported === !
-----
[ -d $OUT_DIR/tupl/automem/rindex ] || mkdir $OUT_DIR/tupl/automem/rindex
cat >$OUT_DIR/tupl/automem/rindex/ccod <<'-----'
#define NAME rindex
#define PTYPE2 ELEM1
#define P2_IS_ELEM
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/tupl/automem/rindex/vdm <<'-----'
#define NAME rindex
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/tupl/automem/rmv1 ] || mkdir $OUT_DIR/tupl/automem/rmv1
cat >$OUT_DIR/tupl/automem/rmv1/ccod <<'-----'
#define NAME rmv1
#define PTYPE2  Nat1
#define _PTYPE2 nat1
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/tupl/automem/rmv1/vdm <<'-----'
#define NAME rmv1
#define PTYPE2 Nat0
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/tupl/automem/rmv1d ] || mkdir $OUT_DIR/tupl/automem/rmv1d
cat >$OUT_DIR/tupl/automem/rmv1d/vdm <<'-----'
! === automem: tupl/rmv1d not supported === !
-----
[ -d $OUT_DIR/tupl/automem/search ] || mkdir $OUT_DIR/tupl/automem/search
cat >$OUT_DIR/tupl/automem/search/vdm <<'-----'
! === automem: tupl/search not supported === !
-----
[ -d $OUT_DIR/tupl/automem/sel ] || mkdir $OUT_DIR/tupl/automem/sel
cat >$OUT_DIR/tupl/automem/sel/ccod <<'-----'
#define NAME sel
#define P2_TYPE Nat0
#include <aux/automem/selector/ccod>
-----
cat >$OUT_DIR/tupl/automem/sel/cmcr <<'-----'
#define NAME sel
#define P2_TYPE Nat0
#define RESULT ELEM1
#define _RESULT _ELEM1
#include <aux/automem/selector/cmcr>
-----
cat >$OUT_DIR/tupl/automem/sel/vdm <<'-----'
#define NAME sel
#include <aux/automem/selector/vdm>
-----
[ -d $OUT_DIR/tupl/automem/sort ] || mkdir $OUT_DIR/tupl/automem/sort
cat >$OUT_DIR/tupl/automem/sort/ccod <<'-----'
DOMAIN sort##_DOMAIN _FPH1(DOMAIN)
{
   check_handle##_DOMAIN(x1);
   cond_clone##_DOMAIN(&x1);
   x1->f_rep = sort_rep##_DOMAIN(x1->f_rep);
   return x1;
}
-----
cat >$OUT_DIR/tupl/automem/sort/param <<'-----'
QUICKSORT
-----
cat >$OUT_DIR/tupl/automem/sort/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + sort
-----
[ -d $OUT_DIR/tupl/automem/sub_tup ] || mkdir $OUT_DIR/tupl/automem/sub_tup
cat >$OUT_DIR/tupl/automem/sub_tup/ccod <<'-----'
#define NAME sub_tup
#define PTYPE2   Nat1
#define PTYPE3   Nat0
#define _PTYPE2  nat1
#define _PTYPE3  nat0
#include <aux/automem/update_D/ccod>
-----
cat >$OUT_DIR/tupl/automem/sub_tup/vdm <<'-----'
#define NAME   sub_tup
#define PTYPE2 Nat1
#define PTYPE3 Nat0
#include <aux/automem/update_D/vdm>
-----
[ -d $OUT_DIR/tupl/automem/sub_tupd ] || mkdir $OUT_DIR/tupl/automem/sub_tupd
cat >$OUT_DIR/tupl/automem/sub_tupd/vdm <<'-----'
! === automem: tupl/sub_tupd not supported === !
-----
[ -d $OUT_DIR/tupl/automem/tl ] || mkdir $OUT_DIR/tupl/automem/tl
cat >$OUT_DIR/tupl/automem/tl/ccod <<'-----'
DOMAIN tl##_DOMAIN _FPH1(DOMAIN)
{
   check_handle##_DOMAIN(x1);
   cond_clone##_DOMAIN(&x1);
   x1->f_rep = tld_rep##_DOMAIN(x1->f_rep);
   return x1;
}
-----
cat >$OUT_DIR/tupl/automem/tl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + tld
-----
[ -d $OUT_DIR/tupl/automem/tld ] || mkdir $OUT_DIR/tupl/automem/tld
cat >$OUT_DIR/tupl/automem/tld/README <<'-----'
============================================================================

Die Operation 'tupl/automem/tld' wird NUR fuer interne Zwecke (Realisierung
der cvfromtupl-Operationen) zur Verfuegung gestellt. Es finden keine Sicher-
heitsabfragen statt, da diese schon in der aufrufenden Routine durchgefuehrt
wurden.

============================================================================
-----
cat >$OUT_DIR/tupl/automem/tld/ccod <<'-----'
DOMAIN tld##_DOMAIN _FPH1(DOMAIN)
{
   x1->f_rep = tld_rep##_DOMAIN(x1->f_rep);
   return x1;
}
-----
cat >$OUT_DIR/tupl/automem/tld/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + tld
-----
[ -d $OUT_DIR/tupl/automem/write ] || mkdir $OUT_DIR/tupl/automem/write
cat >$OUT_DIR/tupl/automem/write/vdm <<'-----'
! === automem: tupl/write not supported === !
-----
[ -d $OUT_DIR/tupl/aux ] || mkdir $OUT_DIR/tupl/aux
[ -d $OUT_DIR/tupl/aux/foldix ] || mkdir $OUT_DIR/tupl/aux/foldix
cat >$OUT_DIR/tupl/aux/foldix/ccod <<'-----'
#define _FORALL forindex
#define ii , _FP(yi,Nat0)
#define tii _EP(yi,Nat0)
#define pii ,Nat0 yi
#define iipp ,yi++
#define iinp ,yi
#define vii Nat0 yi = 1;

#ifndef CVFCT
  DOMAIN: the implementation parameter CVFCT must be specified
#endif
-----
cat >$OUT_DIR/tupl/aux/foldix/docu <<'-----'
#define Tupl tupl
#include <aux/com/fold/docu>

   The functional 'foldix' has the same parameters as 'fold', but
   the parameter CVFCT for the conversion function must always be
   given since the conversion function has the index of the element
   to be processed as extra parameter.

   Example:
   
   The above example for the distributed concatenation could be modified
   to concatenate only every second element in the tuple
   
      DOMAIN  = .... + foldix.concat_even( NULLFCT="mk_empty"
                                         , FOLDFCT="conc"
                                         , CVFCT  ="sel_even")
   
   Here it is assumed that a conversion function 'sel_even' exists:
   
      DOMAIN sel_even_ELEM1(e,i)
         ELEM1  e;
         Nat1   i;
       { return (i % 2 == 0) ? mk1##_DOMAIN(e)
                             : mk_empty##_DOMAIN(); }
-----
[ -d $OUT_DIR/tupl/aux/fread ] || mkdir $OUT_DIR/tupl/aux/fread
cat >$OUT_DIR/tupl/aux/fread/ccod <<'-----'
#ifndef MAXFNLEN
#define MAXFNLEN 256
#endif

#ifndef RLOOP
#define RLOOP \
 {ELEM1 e1;\
  while ( (fread((char *)(&e1),sizeof(e1),1,fd)) != 0 )\
    t1 = MERGE(appr,_DOMAIN)(t1,e1);\
 }
#endif

DOMAIN fread##_DOMAIN _FPH1(Str)
   {char path[MAXFNLEN];
    FILE * fd;
    cpc_str(x1,path);
    if ( (fd = fopen(path,"r")) != 0)
      {DOMAIN t1;
       t1 = mk_empty##_DOMAIN();
         RLOOP
       fclose(fd);
       return t1;
      }
    else return mk_empty##_DOMAIN();
   }
   
#undef RLOOP
#undef MAXFNLEN
-----
cat >$OUT_DIR/tupl/aux/fread/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + mk_empty
   Str      =  + cpc
   Vdmlib   =  + header("STDIO")
-----
[ -d $OUT_DIR/tupl/aux/fwrite ] || mkdir $OUT_DIR/tupl/aux/fwrite
cat >$OUT_DIR/tupl/aux/fwrite/ccod <<'-----'
#ifndef FCT
#define FCT fwrite
#endif

#ifndef ACC
#define ACC "w"
#endif

#ifndef MAXFNLEN
#define MAXFNLEN 256
#endif

#ifndef WLOOP
#define WLOOP \
Nat1 i; Nat0 l;\
i = 1;\
l = MERGE(len,_DOMAIN)(x1);\
while (i <= l)\
 {ELEM1 e1;\
  e1 = MERGE(sel,_DOMAIN)(x1,i);\
  if (fwrite((char *)(&e1),sizeof(e1),1,fd) == 0) return 0;\
  i++;\
 }
#endif

Bool FCT##_DOMAIN _FPH2(DOMAIN,Str)
   {char path[MAXFNLEN];
    FILE * fd;
    cpc_str(x2,path);
    if ((fd = fopen(path,ACC)))
      {WLOOP
       fclose(fd);
       return 1;
      }
    else return 0;
   }
   

#undef FCT
#undef ACC
#undef WLOOP
#undef MAXFNLEN
-----
cat >$OUT_DIR/tupl/aux/fwrite/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Str      =  + cpc
   Vdmlib   =  + header("STDIO")
-----
[ -d $OUT_DIR/tupl/bitset ] || mkdir $OUT_DIR/tupl/bitset
[ -d $OUT_DIR/tupl/bitset/appl ] || mkdir $OUT_DIR/tupl/bitset/appl
cat >$OUT_DIR/tupl/bitset/appl/ccod <<'-----'
  DOMAIN appl##_DOMAIN _FPH2(ELEM1,DOMAIN)
   {
#if ! NOCHECK
      if (len##_DOMAIN(x2) == MAXLEN##_DOMAIN) err_maxlen_vdmlib(MKSTRING(DOMAIN));
#endif
    return (Nat0)((x2 << 1) | x1);
   }
-----
cat >$OUT_DIR/tupl/bitset/appl/cmcr <<'-----'
_DEFINE appl##_DOMAIN(x1,x2) ((Nat0)(((x2) << 1) | x1))
-----
cat >$OUT_DIR/tupl/bitset/appl/param <<'-----'
NOCHECK
MACROS
-----
cat >$OUT_DIR/tupl/bitset/appl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   DOMAIN   = + len
   Vdmlib   = + err_maxlen
#endif
-----
[ -d $OUT_DIR/tupl/bitset/appr ] || mkdir $OUT_DIR/tupl/bitset/appr
cat >$OUT_DIR/tupl/bitset/appr/ccod <<'-----'
  DOMAIN appr##_DOMAIN _FPH2(DOMAIN,ELEM1)
   { register Nat0 lx1 = len##_DOMAIN(x1);
#if ! NOCHECK
      if (lx1 == MAXLEN##_DOMAIN) err_maxlen_vdmlib(MKSTRING(DOMAIN));
#endif
    return (Nat0)(x1 & ((1 << lx1) - 1) | ((x2 | 2) << lx1));
   }
-----
cat >$OUT_DIR/tupl/bitset/appr/param <<'-----'
NOCHECK
-----
cat >$OUT_DIR/tupl/bitset/appr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + len
#if ! NOCHECK
   Vdmlib   = + err_maxlen
#endif
-----
[ -d $OUT_DIR/tupl/bitset/basic ] || mkdir $OUT_DIR/tupl/bitset/basic
cat >$OUT_DIR/tupl/bitset/basic/docu <<'-----'
  Implementation of

     DOMAIN = ELEM1 *

  where ELEM1 is a scalar type with at most two elements
  and the tuples will be shorter than 

     8 * sizeof(Nat0) - 1.

  The tuple will be implemented as Nat0 where every bit represents
  a tuple element. The first element of the tuple will be represented 
  by the least significant bit, the tuple is terminated by a 
  bit set to 1. Thus the operations 'appl', 'sel', 'hd' and 'tail'
  can be implemented very efficiently by shifting and masking.

  Parameters:

    "NOCHECK": supresses all checks about valid operations
    "MACROS" : generate Macro operations instead of functions where
	       possible. The macro semantics will be the same as
	       if 'NOCHECK' set.

  Example: 
    
    Having the domains

      Leftright	= LEFT | RIGHT
      Path	= Leftright*

    we can choose the implementations

      Leftright	= enum
      Path	= bitset

    and get a very efficient and compact implementation for 'Path'
    fitting into one word.

-----
cat >$OUT_DIR/tupl/bitset/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tupl/bitset/basic/gtyp <<'-----'
   TYPE_DEF(DOMAIN,Nat0)
#if GEN_C
_DEFINE MAXLEN##_DOMAIN ((sizeof(DOMAIN)*8) - 1)
#endif
-----
cat >$OUT_DIR/tupl/bitset/basic/param <<'-----'
AUTOMEM
INTERNALDOMAIN
MACROS
NOCHECK
-----
cat >$OUT_DIR/tupl/bitset/basic/vdm <<'-----'

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/bitset/copy ] || mkdir $OUT_DIR/tupl/bitset/copy
cat >$OUT_DIR/tupl/bitset/copy/ccod <<'-----'
#include <com/com/copy/ccod>
-----
cat >$OUT_DIR/tupl/bitset/copy/cmcr <<'-----'
#include <com/com/copy/cmcr>
-----
cat >$OUT_DIR/tupl/bitset/copy/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/bitset/copy/pmcr <<'-----'
#include <com/com/copy/pmcr>
-----
[ -d $OUT_DIR/tupl/bitset/copy1 ] || mkdir $OUT_DIR/tupl/bitset/copy1
cat >$OUT_DIR/tupl/bitset/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN) { return x1;}
-----
cat >$OUT_DIR/tupl/bitset/copy1/cmcr <<'-----'
_DEFINE copy1##_DOMAIN(x1) x1
-----
cat >$OUT_DIR/tupl/bitset/copy1/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/bitset/copy1/pmcr <<'-----'
_DEFINE copy1##_DOMAIN(x1) x1
-----
[ -d $OUT_DIR/tupl/bitset/cvfromtup1 ] || mkdir $OUT_DIR/tupl/bitset/cvfromtup1
cat >$OUT_DIR/tupl/bitset/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *) { return cvfromtup1_nat0(x1); }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tupl/bitset/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tupl/bitset/cvfromtup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Nat0	= + cvfromtup1
-----
[ -d $OUT_DIR/tupl/bitset/cvtotup1 ] || mkdir $OUT_DIR/tupl/bitset/cvtotup1
cat >$OUT_DIR/tupl/bitset/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
     { return cvtotup1_nat0(x1,x2); }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/tupl/bitset/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tupl/bitset/cvtotup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Nat0	= + cvtotup1
-----
[ -d $OUT_DIR/tupl/bitset/forall ] || mkdir $OUT_DIR/tupl/bitset/forall
cat >$OUT_DIR/tupl/bitset/forall/ccod <<'-----'
  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
    { while (x1 != 1) { (*x2)(x1 & (Nat0)1); x1 = x1 >> 1; } }
-----
[ -d $OUT_DIR/tupl/bitset/hd ] || mkdir $OUT_DIR/tupl/bitset/hd
cat >$OUT_DIR/tupl/bitset/hd/ccod <<'-----'
  ELEM1 hd##_DOMAIN _FPH1(DOMAIN)
   {
#if ! NOCHECK
      if (is_empty##_DOMAIN(x1))
         err_hd_vdmlib(MKSTRING(DOMAIN));
#endif
    return (Nat0)(x1 & 1);
   }
-----
cat >$OUT_DIR/tupl/bitset/hd/cmcr <<'-----'
_DEFINE hd##_DOMAIN(x1) ((Nat0)((x1) & 1))
-----
cat >$OUT_DIR/tupl/bitset/hd/param <<'-----'
NOCHECK
MACROS
-----
cat >$OUT_DIR/tupl/bitset/hd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   DOMAIN   = + is_empty
   Vdmlib   = + err_hd
#endif
-----
[ -d $OUT_DIR/tupl/bitset/is_empty ] || mkdir $OUT_DIR/tupl/bitset/is_empty
cat >$OUT_DIR/tupl/bitset/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) { return (x1 == (Nat0)1); }
-----
cat >$OUT_DIR/tupl/bitset/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((x1) == (Nat0)1)
-----
cat >$OUT_DIR/tupl/bitset/is_empty/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/bitset/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) ((x1) = 1)
-----
[ -d $OUT_DIR/tupl/bitset/is_eq ] || mkdir $OUT_DIR/tupl/bitset/is_eq
cat >$OUT_DIR/tupl/bitset/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN) { return (x1 == x2); }
-----
cat >$OUT_DIR/tupl/bitset/is_eq/cmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) ((x1) == (x2))
-----
cat >$OUT_DIR/tupl/bitset/is_eq/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/bitset/is_eq/pmcr <<'-----'
_DEFINE is_eq##_DOMAIN(x1,x2) ((x1) = (x2))
-----
[ -d $OUT_DIR/tupl/bitset/iterator ] || mkdir $OUT_DIR/tupl/bitset/iterator
cat >$OUT_DIR/tupl/bitset/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/tupl/bitset/iterator/vdm <<'-----'
#define IMPL bitset
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/tupl/bitset/len ] || mkdir $OUT_DIR/tupl/bitset/len
cat >$OUT_DIR/tupl/bitset/len/ccod <<'-----'
  Nat0 len##_DOMAIN _FPH1(DOMAIN)
    { register Nat0 lx1 = 0;
      while (x1 != (Nat0)1) { x1 = x1 >> 1; lx1++; }
      return lx1;
    }
-----
[ -d $OUT_DIR/tupl/bitset/mk1 ] || mkdir $OUT_DIR/tupl/bitset/mk1
cat >$OUT_DIR/tupl/bitset/mk1/ccod <<'-----'
  DOMAIN mk1##_DOMAIN _FPH1(ELEM1) { return (Nat0)(2 | x1); }
-----
cat >$OUT_DIR/tupl/bitset/mk1/cmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) ((Nat0)(2 | x1))
-----
cat >$OUT_DIR/tupl/bitset/mk1/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/bitset/mk1/pmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) (2 + x1)
-----
cat >$OUT_DIR/tupl/bitset/mk1/vdm <<'-----'

#define CONSTRNAME mk1
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/bitset/mk_empty ] || mkdir $OUT_DIR/tupl/bitset/mk_empty
cat >$OUT_DIR/tupl/bitset/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() { return (Nat0)1; }
-----
cat >$OUT_DIR/tupl/bitset/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() (Nat0)1
-----
cat >$OUT_DIR/tupl/bitset/mk_empty/param <<'-----'
NOCHECK
MACROS
-----
cat >$OUT_DIR/tupl/bitset/mk_empty/pmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() 1
-----
cat >$OUT_DIR/tupl/bitset/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/bitset/sel ] || mkdir $OUT_DIR/tupl/bitset/sel
cat >$OUT_DIR/tupl/bitset/sel/ccod <<'-----'
ELEM1 sel##_DOMAIN _FPH2(DOMAIN,Nat1)
{

#if ! NOCHECK
    {
	register Nat0 lx1 = len##_DOMAIN(x1);
	if (x2 > lx1)
	    err_sel_vdmlib(x2,lx1,MKSTRING(DOMAIN));
    }
#endif

    return (Nat0)(x1 >> (x2 - 1)) & 1;
}
-----
cat >$OUT_DIR/tupl/bitset/sel/cmcr <<'-----'
#if NOCHECK
_DEFINE sel##_DOMAIN(x1,x2) ((Nat0)((x1) >> ((x2) - 1)) & 1)
#else
#include <tupl/sign/sel/gsig>
#endif
-----
cat >$OUT_DIR/tupl/bitset/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS

#if ! NOCHECK
   Vdmlib   = + err_sel
   DOMAIN   = + len
#endif

#if MACROS && ! NOCHECK
   DOMAIN   = + sel_save
#endif
-----
[ -d $OUT_DIR/tupl/bitset/sel_save ] || mkdir $OUT_DIR/tupl/bitset/sel_save
cat >$OUT_DIR/tupl/bitset/sel_save/ccod <<'-----'
#include <tupl/bitset/sel/ccod>
-----
[ -d $OUT_DIR/tupl/bitset/tl ] || mkdir $OUT_DIR/tupl/bitset/tl
cat >$OUT_DIR/tupl/bitset/tl/ccod <<'-----'
#ifndef _FCT 
#define _FCT tl
#endif

  DOMAIN _FCT##_DOMAIN _FPH1(DOMAIN)
   {
#if ! NOCHECK
      if (is_empty##_DOMAIN(x1))
         err_tl_vdmlib(MKSTRING(DOMAIN));
#endif
    return (Nat0)(x1 >> 1);
   }
#undef _FCT
-----
cat >$OUT_DIR/tupl/bitset/tl/cmcr <<'-----'
_DEFINE tl##_DOMAIN(x1) ((Nat0)((x1) >> 1))
-----
cat >$OUT_DIR/tupl/bitset/tl/param <<'-----'
NOCHECK
MACROS
-----
cat >$OUT_DIR/tupl/bitset/tl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   DOMAIN   = + is_empty
   Vdmlib   = + err_tl
#endif
-----
[ -d $OUT_DIR/tupl/bitset/tld ] || mkdir $OUT_DIR/tupl/bitset/tld
cat >$OUT_DIR/tupl/bitset/tld/ccod <<'-----'
#define _FCT tld
#include <tupl/bitset/tl/ccod>
-----
cat >$OUT_DIR/tupl/bitset/tld/cmcr <<'-----'
_DEFINE tld##_DOMAIN(x1) ((Nat0)((x1) >> 1))
-----
cat >$OUT_DIR/tupl/bitset/tld/param <<'-----'
NOCHECK
MACROS
-----
cat >$OUT_DIR/tupl/bitset/tld/vdm <<'-----'
#include <tupl/bitset/tl/vdm>
-----
[ -d $OUT_DIR/tupl/com ] || mkdir $OUT_DIR/tupl/com
[ -d $OUT_DIR/tupl/com/all ] || mkdir $OUT_DIR/tupl/com/all
cat >$OUT_DIR/tupl/com/all/docu <<'-----'
#include <aux/com/all/docu>
-----
cat >$OUT_DIR/tupl/com/all/vdm <<'-----'
#include <aux/com/all/vdm>
-----
[ -d $OUT_DIR/tupl/com/appl ] || mkdir $OUT_DIR/tupl/com/appl
cat >$OUT_DIR/tupl/com/appl/ccod <<'-----'
  DOMAIN appl##_DOMAIN _FPH2(ELEM1,DOMAIN)
    {return conc##_DOMAIN(mk1##_DOMAIN(x1),x2);}   
-----
cat >$OUT_DIR/tupl/com/appl/cmcr <<'-----'
_DEFINE appl##_DOMAIN(x1,x2) conc##_DOMAIN(mk1##_DOMAIN(x1),x2)
-----
cat >$OUT_DIR/tupl/com/appl/docu <<'-----'
  general implementation of appl

  appl(x1,x2) = conc(mk1(x1),x2)

  time complexity : O(mk1) * O(conc)
-----
cat >$OUT_DIR/tupl/com/appl/pmcr <<'-----'
_DEFINE appl##_DOMAIN(x1,x2) conc##_DOMAIN(mk1##_DOMAIN(x1),x2)
-----
cat >$OUT_DIR/tupl/com/appl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + mk1 + conc
-----
[ -d $OUT_DIR/tupl/com/appr ] || mkdir $OUT_DIR/tupl/com/appr
cat >$OUT_DIR/tupl/com/appr/ccod <<'-----'
  DOMAIN appr##_DOMAIN _FPH2(DOMAIN,ELEM1)
    {return conc##_DOMAIN(x1,mk1##_DOMAIN(x2));}   
-----
cat >$OUT_DIR/tupl/com/appr/cmcr <<'-----'
_DEFINE appr##_DOMAIN(x1,x2) conc##_DOMAIN(x1,mk1##_DOMAIN(x2))
-----
cat >$OUT_DIR/tupl/com/appr/docu <<'-----'
  general implementation of appr

  appr(x1,x2) = conc(x1,mk1(x1))

  time complexity : O(mk1) * O(conc)
-----
cat >$OUT_DIR/tupl/com/appr/pmcr <<'-----'
_DEFINE appr##_DOMAIN(x1,x2) conc##_DOMAIN(x1,mk1##_DOMAIN(x2))
-----
cat >$OUT_DIR/tupl/com/appr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + mk1 + conc
-----
[ -d $OUT_DIR/tupl/com/basic ] || mkdir $OUT_DIR/tupl/com/basic
cat >$OUT_DIR/tupl/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/tupl/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain = Elem *

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain = IMPLEMENTATION1

   + mk_empty
   + mk1
   + mk2
   + mk3
   + mkn
   + mknc
   + mkarray
#ifdef ISSTR1
   + cpc
   + mkc
   + mklc
#endif

   + len

   + copy1
   + copy2
   + copy
   + appl
   + insert
   + appr
   + conc
#ifdef ISSTR1
   + conc_path
#endif
   + ovwrt1
   + ovwrt1d
   + rmv1
   + rmv1d
   + hd
   + last + front + frontd + reverse
   + tl
   + tld
   + sel
   + sub_tup
   + index + rindex
   + search

   + is_prefix + is_postfix + is_subtup
   + is_eq
   + is_empty
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + forall
   + forsome
   + forrange
   + forindex

   + binary.bf(RESULT=Bool,FOLDFCT="bfoldf",NOFOLDENR)
   + fold.ff(RESULT=Bool,NULLFCT="fnullf",CVFCT="fcvf",FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)
   + fold.ff1(RESULT=Bool,NULLPARAM,CVFCTVAR,FOLDFCT="ffoldf",
             X=Elem,XX=BASIC,XXX=Bool,
             Y=Elem,YY=BASIC,YYY=Bool,
             Z=Elem,ZZ=BASIC,ZZZ=Bool)
   + foldix.fixf(RESULT=Bool,NULLFCT="fnullf",CVFCT="fixcvf",FOLDFCT="ffoldf",
                 X=Elem,XX=BASIC,XXX=Bool,
                 Y=Elem,YY=BASIC,YYY=Bool,
                 Z=Elem,ZZ=BASIC,ZZZ=Bool)

#ifdef ISSTR1
   + fread
   + fwrite
   + fapp
#endif

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del2
   + del

   + print + fprint
   + pr
   + fpr
   + finput
   + all + exist + exist1
   + conc3 + conc4 + conc5 + conc6


-----
cat >$OUT_DIR/tupl/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

#ifndef ADT2predef
Elem = BASIC *
#endif

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + mk_empty
   + mk1
   + mk2
   + mk3
   + mkn

#ifdef ISSTR2
   + mkc
#endif

   + is_eq
   + is_gr
   + is_ge

-----
cat >$OUT_DIR/tupl/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>
#include <aux/com/basic/bbdeld>
#include <aux/com/basic/bbdele>

#define niltupl MERGE(mk_empty,_domain)()

#define onetupl(elem) MERGE(mk1,_domain)(elem)

Domain mk_big##_domain()
{ return
   @( appr##_domain( 
   @)  niltupl 
   @( ,@X@) 
   @)
  ;
}

#define bigtupl MERGE(mk_big,_domain)()

#define bignum (0 @( + 1 @) ) 

/*================================================================================================*/

Bool search_test _FPH1(Elem)
{ Bool r = is_eq##_elem( x1, E_ @Y@ ) ;
  EE
  return r;
}

/*================================================================================================*/

int glob = -1;
Domain glob_tupl;

/*------------------------------------------------------------------------------------------------*/

void clear_glob()

{ if (glob != -1) del1##_domain(glob_tupl);
  glob = 0;
  glob_tupl = niltupl;
}

/*------------------------------------------------------------------------------------------------*/

Bool forsome_test _FPH1(Elem)
{ Bool r = is_eq##_elem( x1, E_ @Y@ );
  EE 
  return r;
}

/*------------------------------------------------------------------------------------------------*/

void for_test _FPH1(Elem)
{ ++glob;
  glob_tupl = appr##_domain( glob_tupl, x1 );
}

/*------------------------------------------------------------------------------------------------*/

void forindex_test _FPH2(Elem,Nat1)
{ 
  ++glob;
  if( ( (x2==1) && ( index##_domain( D_ bigtupl, x1 ) != 0 ) ) ||
      is_eq##_elem( x1, sel##_domain( D_ bigtupl, x2 ) ) )
    glob_tupl = appr##_domain( glob_tupl, x1 );
}

/*================================================================================================*/

Bool bfoldf##_domain ( result, elem )

  Bool result;
  Elem elem;

{ Domain bighelp;
  Bool r;
  bighelp = bigtupl;
  r = result && index##_domain( bigtupl, elem ); 
  del##_domain(bighelp);
  return r;
}

/*================================================================================================*/

Bool fnullf_bool ()

{ return(TRUE);
}

/*------------------------------------------------------------------------------------------------*/

Bool fcvf##_elem ( elem, vx, vxx, vxxx, vy, vyy, vyyy )

  Elem elem;
  Elem vx,vy; BASIC vxx,vyy; Bool vxxx,vyyy;

{ 
  Domain d_array[9];
  int Di = 0;
  Elem e_array[9];
  int Ei = 0;
  Bool r = ( ( index##_domain( D_ bigtupl, elem ) != 0 ) &&
            is_eq##_elem( vx, E_ @Z@ ) && ( vxx == ccc ) &&  vxxx &&
            is_eq##_elem( vy, E_ @Y@ ) && ( vyy == bbb ) && !vyyy    );
/* HMH  DD EE  */
  return r;
}

/*------------------------------------------------------------------------------------------------*/

Bool fixcvf##_elem ( elem, pos, vx, vxx, vxxx, vy, vyy, vyyy )

  Elem elem;
  Nat0 pos;
  Elem vx,vy; BASIC vxx,vyy; Bool vxxx,vyyy;

{ 
  Domain d_array[9];
  int Di = 0;
  Elem e_array[9];
  int Ei = 0;
  Bool r = ( ( index##_domain( D_ bigtupl, elem ) != 0 ) &&
            is_eq##_elem( vx, E_ @Z@ ) && ( vxx == ccc ) &&  vxxx &&
            is_eq##_elem( vy, E_ @Y@ ) && ( vyy == bbb ) && !vyyy    );
/* HMH  DD EE */
  return r;
}

/*------------------------------------------------------------------------------------------------*/

Bool ffoldf_bool ( result1, result2, vy, vyy, vyyy, vz, vzz, vzzz )

  Bool result1, result2;
  Elem vy,vz; BASIC vyy,vzz; Bool vyyy,vzzz;

{ 
  Domain d_array[9];
  int Di = 0;
  Elem e_array[9];
  int Ei = 0;
  Bool r =  result1 &&
            result2 && 
            index##_domain( D_ bigtupl, vz ) && 
            vzz == aaa &&
            vzzz &&
            is_eq##_elem( vy, E_ @Y@ ) &&
            vyy == bbb &&
            ! vyyy;
/* HMH  DD EE */
  return r;
}

#include <aux/com/basic/bbid2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ niltupl ) )
       myerr(@n@,"mk_empty()","");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem(sel##_domain( D_ onetupl(@X@), 1 ), E_ @X@ ) )
       myerr(@n@,"mk1()","@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ mk2##_domain( @Y@, @X@ ), 1 ), E_ @Y@ ) )
       myerr(@n@,"mk2() /1","@Y@,@X@");
   DD EE
     if(! is_eq##_elem( sel##_domain( D_ mk2##_domain( @Y@, @X@ ), 2 ), E_ @X@ ) )
       myerr(@n@,"mk2() /2","@Y@,@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ mk3##_domain( @Y@, @X@, @Z@ ), 1 ), E_ @Y@ ) )
       myerr(@n@,"mk3() /1","@Y@,@X@,@Z@");
   DD EE
     if(! is_eq##_elem( sel##_domain( D_ mk3##_domain( @Y@, @X@, @Z@ ), 2 ), E_ @X@ ) )
       myerr(@n@,"mk3() /2","@Y@,@X@,@Z@");
   DD EE
     if(! is_eq##_elem( sel##_domain( D_ mk3##_domain( @Y@, @X@, @Z@ ), 3 ), E_ @Z@ ) )
       myerr(@n@,"mk3() /3","@Y@,@X@,@Z@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { int i;
@(   for(i=1; i <= 5; ++i)
     {  if(! is_eq##_elem( sel##_domain( /* D_ HMH */ mkn##_domain( @X@, 5), i ), E_ @X@ ) )
         myerr(@n@,"mkn()","@X@");
     DD EE }
@) }

/*================================================================================================*/

   void p_@N@()
   { int i;
@(   for(i=1; i <= 5; ++i)
     { if(! is_eq##_elem( sel##_domain( D_ mknc##_domain( @X@, 5 ), i ), E_ @X@ ) )
         myerr(@n@,"mknc()","@X@");
     DD EE }
@) }

/*================================================================================================*/

   void p_@N@()
   { Elem *test_array;
     if(! is_empty##_domain( D_ mkarray##_domain( test_array, 0 ) ) )
       myerr(@n@,"mkarray()","<>");
   DD }

   void p_@N@()
   { Elem test_array[1];
@(   test_array[0]= @X@;
     if(! is_eq##_domain( D_ mkarray##_domain( test_array, 1 ), D_ onetupl(@X@) ) )
       myerr(@n@,"mkarray()","<@X@>");
@) DD }

   void p_@N@()
   { Elem test_array[bignum];
     int i=0;
@(   test_array[i++]= @X@;
@)   if(! is_eq##_domain( D_ mkarray##_domain( test_array, bignum ), D_ bigtupl ) )
       myerr(@n@,"mkarray()","@X@");
@) DD }

/*================================================================================================*/

#ifdef ISSTR1
      void p_@N@()
      { char cstring[1];
        cpc##_domain( D_ niltupl, cstring );
        if(! is_empty##_domain( D_ mkc##_domain( cstring ) ) )
          myerr(@n@,"cpc(),mkc()","<>");
      DD }
   
      void p_@N@()
      { char cstring[2];
   @(   cpc##_domain( D_ onetupl(@X@), cstring );
        if(! is_eq##_domain( D_ mkc##_domain( cstring ), D_ onetupl(@X@) ) )
          myerr(@n@,"cpc(),mkc()","<@X@>");
   @) DD }
   
      void p_@N@()
      { char cstring[bignum+1];
        cpc##_domain( D_ bigtupl, cstring );
        if(! is_eq##_domain( D_ mkc##_domain( cstring ), D_ bigtupl ) )
          myerr(@n@,"cpc(),mkc()","BIGTUPL");
      DD }
   
/*------------------------------------------------------------------------------------------------*/

      void p_@N@()
      { char cstring[1];
        cpc##_domain( D_ niltupl, cstring );
        if(! is_empty##_domain( D_ mklc##_domain( cstring ) ) )
          myerr(@n@,"cpc(),mklc()","<>");
      DD }
   
      void p_@N@()
      { char cstring[2];
        Domain lowtupl;
   @(   cpc##_domain( D_ onetupl(@X@), cstring );
        lowtupl = D_ mklc##_domain( cstring );
        cstring[0] = tolower(cstring[0]);
        if(! is_eq##_domain( lowtupl, D_ mkc##_domain( cstring ) ) )
          myerr(@n@,"cpc(),mklc(),mkc()","<@X@>");
   @) DD }
   
      void p_@N@()
      { char cstring[bignum+1];
        Domain lowtupl;
        int i;
        cpc##_domain( D_ bigtupl, cstring );
        lowtupl = D_ mklc##_domain( cstring );
        for( i = 0; i < bignum; ++i )
          cstring[i] = tolower(cstring[i]);
        if(! is_eq##_domain( lowtupl, D_ mkc##_domain( cstring ) ) )
          myerr(@n@,"cpc(),mklc(),mkc()","BIGTUPL");
      DD }
   
#endif
/*================================================================================================*/

   void p_@N@()
   { if( len##_domain( D_ niltupl ) != 0 )
       myerr(@n@,"len()","<>");
   DD }
   void p_@N@()
   {
@(   if( len##_domain( D_ onetupl(@X@) ) != 1 )
       myerr(@n@,"len()","<@X@>");
@) DD }
   void p_@N@()
   { if( len##_domain( D_ bigtupl ) != bignum )
       myerr(@n@,"len()","BIGTUPL");
   DD }

/*================================================================================================*/

#define ARG niltupl
#define TEXT <>
#include <aux/com/copy1/bbc2>

#define ARG onetupl(@X@)
#define TEXT <@X@>
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG bigtupl
#include <aux/com/copy1/bbc2>

#define ARG niltupl
#define TEXT <>
#include <aux/com/copy/bbc2>

#define ARG onetupl(@X@)
#define TEXT <@X@>
#define REPEAT
#include <aux/com/copy/bbc2>

#define ARG bigtupl
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_eq##_domain( D_ copy2##_domain( D_ niltupl ), D_ niltupl ) )
       myerr(@n@,"copy2()","<>");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ copy2##_domain( D_ onetupl(@X@) ), D_ onetupl(@X@) ) )
       myerr(@n@,"copy2()","<@X@>");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ copy2##_domain( D_ bigtupl ), D_ bigtupl ) )
       myerr(@n@,"copy2()","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ appl##_domain( @X@, niltupl ), D_ onetupl(@X@) ) )
       myerr(@n@,"appl()","@X@,<>");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_elem(sel##_domain( D_ appl##_domain( @X@, onetupl(@Y@) ), 1 ),
                       E_ @X@ ) )
       myerr(@n@,"appl() /1","@X@,<@Y@>");
     if(! is_eq##_elem(sel##_domain( D_ appl##_domain( @X@, onetupl(@Y@) ), 2 ),
                       E_ @Y@ ) )
       myerr(@n@,"appl() /2","@X@,<@Y@>");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ appl##_domain( @X@, bigtupl ), 1 ), E_ @X@ ) )
       myerr(@n@,"appl() /1","@X@,BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( appl##_domain( E_ @X@, bigtupl ), 2, bignum+1 ),
                           D_ bigtupl ) )
       myerr(@n@,"appl() /2","@X@,BIGTUPL");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ insert##_domain( niltupl, 1, @X@ ), D_ onetupl(@X@) ) )
       myerr(@n@,"insert()","<>,@X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_elem(sel##_domain( D_ insert##_domain( onetupl(@Y@), 1, @X@ ), 1 ),
                       E_ @X@ ) )
       myerr(@n@,"insert() /1","<@Y@>,@X@");
     if(! is_eq##_elem(sel##_domain( D_ insert##_domain( onetupl(@Y@), 1,@X@ ), 2 ),
                       E_ @Y@ ) )
       myerr(@n@,"insert() /2","<@Y@>,@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_elem(sel##_domain( D_ insert##_domain( onetupl(@Y@), 2, @X@ ), 1 ),
                       E_ @Y@ ) )
       myerr(@n@,"insert() /1","<@Y@>,@X@");
     if(! is_eq##_elem( sel##_domain( D_ insert##_domain( onetupl(@Y@), 2, @X@ ), 2 ),
                       E_ @X@ ) )
       myerr(@n@,"insert() /2","<@Y@>,@X@");
@) DD EE }

   void p_@N@()
   { int i;
     for( i = 1; i <= bignum+1; ++i )
     {
@(     if(! is_eq##_domain( D_ sub_tup##_domain( insert##_domain( bigtupl, i, E_ @X@ ), 1, i-1 ),
                             D_ sub_tup##_domain( bigtupl, 1, i-1 ) ) )
         myerr(@n@,"insert() /1","BIGTUPL,@X@");
       if(! is_eq##_elem( sel##_domain( D_ insert##_domain( bigtupl, i, @X@ ), i ),
                         E_ @X@ ) )
         myerr(@n@,"insert() /2","BIGTUPL,@X@");
       if(! is_eq##_domain( D_ sub_tup##_domain( insert##_domain( bigtupl, i, @X@ ),
                             i+1, bignum+1 ), D_ sub_tup##_domain( bigtupl, i, bignum ) ) )
         myerr(@n@,"insert() /3","BIGTUPL,@X@");
@)   DD EE }
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ appr##_domain( niltupl, @X@ ), D_ onetupl(@X@) ) )
       myerr(@n@,"appr()","<>,@X@");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ appr##_domain( onetupl(@Y@), @X@ ), 1 ),
                       E_ @Y@ ) )
       myerr(@n@,"appr() /1","<@Y@>,@X@");
     if(! is_eq##_elem( sel##_domain( D_ appr##_domain( onetupl(@Y@), @X@ ), 2 ),
                       E_ @X@ ) )
       myerr(@n@,"appr() /2","<@Y@>,@X@");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub_tup##_domain( appr##_domain( bigtupl, E_ @X@ ), 1, bignum ),
                           D_ bigtupl ) )
       myerr(@n@,"appr() /1","BIGTUPL,@X@");
     if(! is_eq##_elem( sel##_domain( D_ appr##_domain( bigtupl, @X@ ), bignum+1 ),
                       E_ @X@ ) )
       myerr(@n@,"appr() /2","BIGTUPL,@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ conc##_domain( niltupl, niltupl ) ) )
       myerr(@n@,"conc()","<>,<>");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ conc##_domain( niltupl, onetupl(@X@) ), D_ onetupl(@X@) ) )
       myerr(@n@,"conc()","<>,<@X@>");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ conc##_domain( niltupl, bigtupl ), D_ bigtupl ) )
       myerr(@n@,"conc()","<>,BIGTUPL");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ conc##_domain( onetupl(@X@), niltupl ), D_ onetupl(@X@) ) )
       myerr(@n@,"conc()","<@X@>,<>");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ conc##_domain( onetupl(@X@), onetupl(@Y@) ), 1 ),
                       E_ @X@ ) )
       myerr(@n@,"conc() /1","<@X@>,<@Y@>");
     if(! is_eq##_elem( sel##_domain( D_ conc##_domain( onetupl(@X@), onetupl(@Y@) ), 2 ),
                       E_ @Y@ ) )
       myerr(@n@,"conc() /2","<@X@>,<@Y@>");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ conc##_domain( onetupl(@X@), bigtupl ), 1 ),
                       E_ @X@ ) )
       myerr(@n@,"conc() /1","<@X@>,BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( conc##_domain( onetupl(E_ @X@), bigtupl ),
                           2, bignum+1 ), D_ bigtupl ) )
       myerr(@n@,"conc() /2","<@X@>,BIGTUPL");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ conc##_domain( bigtupl, niltupl ), D_ bigtupl ) )
       myerr(@n@,"conc()","BIGTUPL,<>");
   DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub_tup##_domain( conc##_domain( bigtupl, onetupl(E_ @X@) ),
                           1, bignum ), D_ bigtupl ) )
       myerr(@n@,"conc() /1","BIGTUPL,<@X@>");
     if(! is_eq##_elem( sel##_domain( D_ conc##_domain( bigtupl, onetupl(@X@) ), bignum+1 ),
                       E_ @X@ ) )
       myerr(@n@,"conc() /2","BIGTUPL,<@X@>");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub_tup##_domain( conc##_domain( bigtupl, bigtupl ), 1, bignum ),
                           D_ bigtupl ) )
       myerr(@n@,"conc() /1","BIGTUPL,BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( conc##_domain( bigtupl, bigtupl ),
                           bignum+1, bignum+bignum ), D_ bigtupl ) )
       myerr(@n@,"conc() /2","BIGTUPL,BIGTUPL");
   DD }

/*================================================================================================*/

#ifdef ISSTR1
      void p_@N@()
      { if(! is_eq##_domain( D_ conc_path##_domain( niltupl, niltupl ), D_ onetupl('/') ) )
          myerr(@n@,"conc_path()","<>,<>");
      DD }
   
      void p_@N@()
      {
   @(   if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( niltupl, onetupl(@X@) ), 1 ),
                          '/' ) )
          myerr(@n@,"conc_path() /1","<>,<@X@>");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( niltupl, onetupl(@X@) ), 2 ),
                          E_ @X@ ) )
          myerr(@n@,"conc_path() /2","<>,<@X@>");
   @) DD EE }
   
      void p_@N@()
      { if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( niltupl, bigtupl ), 1 ), '/' ) )
          myerr(@n@,"conc_path() /1","<>,BIGTUPL");
        if(! is_eq##_domain( D_ sub_tup##_domain( conc_path##_domain( niltupl, bigtupl ),
                              2, bignum+1 ), D_ bigtupl ) )
          myerr(@n@,"conc_path() /2","<>,BIGTUPL");
      DD EE }
   
      void p_@N@()
      {
   @(   if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( onetupl(@X@), niltupl ), 1 ),
                          E_ @X@ ) )
          myerr(@n@,"conc_path() /1","<@X@>,<>");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( onetupl(@X@), niltupl ), 2 ),
                          '/' ) )  
          myerr(@n@,"conc_path() /2","<@X@>,<>");
   @) DD EE }
   
      void p_@N@()
      {
   @(   if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( onetupl(@X@),
                          onetupl(@Y@) ), 1 ), E_ @X@ ) )
          myerr(@n@,"conc_path() /1","<@X@>,<@Y@>");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( onetupl(@X@),
                          onetupl(@Y@) ), 2 ), '/' ) )
          myerr(@n@,"conc_path() /2","<@X@>,<@Y@>");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( onetupl(@X@),
                          onetupl(@Y@) ), 3 ), E_ @Y@ ) )
          myerr(@n@,"conc_path() /3","<@X@>,<@Y@>");
   @) DD EE }
   
      void p_@N@()
      {
   @(   if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( onetupl(@X@), bigtupl ), 1 ),
                          E_ @X@ ) )
          myerr(@n@,"conc_path() /1","<@X@>,BIGTUPL");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( onetupl(@X@), bigtupl ), 2 ),
                          '/' ) )
          myerr(@n@,"conc_path() /2","<@X@>,BIGTUPL");
        if(! is_eq##_domain( D_ sub_tup##_domain( conc_path##_domain( onetupl(@X@), bigtupl ),
                              3, bignum+2 ), D_ bigtupl ) )
          myerr(@n@,"conc_path() /3","<@X@>,BIGTUPL");
   @) DD EE }
   
      void p_@N@()
      { if(! is_eq##_domain( D_ sub_tup##_domain( conc_path##_domain( bigtupl, niltupl ),
                              1, bignum ), D_ bigtupl ) )
          myerr(@n@,"conc_path() /1","BIGTUPL,<>");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( bigtupl, niltupl ), bignum+1 ),
                          '/' ) )
          myerr(@n@,"conc_path() /2","BIGTUPL,<>");
      DD EE }
   
      void p_@N@()
      {
   @(   if(! is_eq##_domain( D_ sub_tup##_domain( conc_path##_domain( bigtupl, onetupl(@X@) ),
                              1, bignum ), D_ bigtupl ) )
          myerr(@n@,"conc_path() /1","BIGTUPL,<@X@>");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( bigtupl, onetupl(@X@) ),
                          bignum+1 ), '/' ) )
          myerr(@n@,"conc_path() /2","BIGTUPL,<@X@>");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( bigtupl, onetupl(@X@) ),
                          bignum+2 ), E_ @X@ ) )
          myerr(@n@,"conc_path() /3","BIGTUPL,<@X@>");
   @) DD EE }
   
      void p_@N@()
      { if(! is_eq##_domain( D_ sub_tup##_domain( conc_path##_domain( bigtupl, bigtupl ),
                              1, bignum ), D_ bigtupl ) )
          myerr(@n@,"conc_path() /1","BIGTUPL,BIGTUPL");
        if(! is_eq##_elem( sel##_domain( D_ conc_path##_domain( bigtupl, bigtupl ), bignum+1 ),
                          '/' ) )
          myerr(@n@,"conc_path() /2","BIGTUPL,BIGTUPL");
        if(! is_eq##_domain( D_ sub_tup##_domain( conc_path##_domain( bigtupl, bigtupl ),
                              bignum+2, bignum+bignum+1 ), D_ bigtupl ) )
          myerr(@n@,"conc_path() /3","BIGTUPL,BIGTUPL");
      DD EE }
  
#endif
/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1##_domain( onetupl(E_ @Y@), 1, @X@ ),
                           D_ onetupl(@X@) ) )
       myerr(@n@,"ovwrt1()","<@Y@>,@X@");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_elem( sel##_domain( D_ ovwrt1##_domain( bigtupl, 1, @Y@ ), 1 ), E_ @Y@ ) )
       myerr(@n@,"ovwrt1() /1","BIGTUPL,@Y@");
     if(! is_eq##_domain( D_ sub_tup##_domain( ovwrt1##_domain( bigtupl, 1, @Y@ ),
                           2, bignum ), D_ sub_tup##_domain( bigtupl, 2, bignum ) ) )
       myerr(@n@,"ovwrt1() /2","BIGTUPL,@Y@");
   DD EE }

   void p_@N@()
   { if(! is_eq##_elem( sel##_domain( D_ ovwrt1##_domain( bigtupl, 2, @Y@ ), 1 ),
                       sel##_domain( D_ bigtupl, 1 ) ) )
       myerr(@n@,"ovwrt1() /1","BIGTUPL,@Y@");
     if(! is_eq##_elem( sel##_domain( D_ ovwrt1##_domain( bigtupl, 2, @Y@ ), 2 ), E_ @Y@ ) )
       myerr(@n@,"ovwrt1() /2","BIGTUPL,@Y@");
     if(! is_eq##_domain( D_ sub_tup##_domain( ovwrt1##_domain( bigtupl, 2, @Y@ ),
                           3, bignum ), D_ sub_tup##_domain( bigtupl, 3, bignum ) ) )
       myerr(@n@,"ovwrt1() /3","BIGTUPL,@Y@");
   DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub_tup##_domain( ovwrt1##_domain( bigtupl, bignum, @Y@ ),
                           1, bignum-1 ), D_ sub_tup##_domain( bigtupl, 1, bignum-1 ) ) )
       myerr(@n@,"ovwrt1() /1","BIGTUPL,@Y@");
     if(! is_eq##_elem( sel##_domain( D_ ovwrt1##_domain( bigtupl, bignum, @Y@ ), bignum ),
                       E_ @Y@ ) ) 
       myerr(@n@,"ovwrt1() /2","BIGTUPL,@Y@");
   DD EE }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ ovwrt1d##_domain( onetupl(@Y@), 1, @X@ ),
                           D_ onetupl(@X@) ) )
       myerr(@n@,"ovwrt1d()","<@Y@>,@X@");
@) DD }

   void p_@N@()
   { if(! is_eq##_elem( sel##_domain( D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ), 1 ), E_ @Y@ ) )
       myerr(@n@,"ovwrt1d() /1","BIGTUPL,@Y@");
     if(! is_eq##_domain( D_ sub_tup##_domain( ovwrt1d##_domain( bigtupl, 1, @Y@ ),
                           2, bignum ), D_ sub_tup##_domain( bigtupl, 2, bignum ) ) )
       myerr(@n@,"ovwrt1d() /2","BIGTUPL,@Y@");
   DD EE }

   void p_@N@()
   { if(! is_eq##_elem( sel##_domain( D_ ovwrt1d##_domain( bigtupl, 2, @Y@ ), 1 ),
                       sel##_domain( D_ bigtupl, 1 ) ) )
       myerr(@n@,"ovwrt1d() /1","BIGTUPL,@Y@");
     if(! is_eq##_elem( sel##_domain( D_ ovwrt1d##_domain( bigtupl, 2, @Y@ ), 2 ), E_ @Y@ ) )
       myerr(@n@,"ovwrt1d() /2","BIGTUPL,@Y@");
     if(! is_eq##_domain( D_ sub_tup##_domain( ovwrt1d##_domain( bigtupl, 2, @Y@ ),
                           3, bignum ), D_ sub_tup##_domain( bigtupl, 3, bignum ) ) )
       myerr(@n@,"ovwrt1d() /3","BIGTUPL,@Y@");
   DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub_tup##_domain( ovwrt1d##_domain( bigtupl, bignum, @Y@ ),
                           1, bignum-1 ), D_ sub_tup##_domain( bigtupl, 1, bignum-1 ) ) )
       myerr(@n@,"ovwrt1d() /1","BIGTUPL,@Y@");
     if(! is_eq##_elem( sel##_domain( D_ ovwrt1d##_domain( bigtupl, bignum, @Y@ ), bignum ),
                       E_ @Y@ ) ) 
       myerr(@n@,"ovwrt1d() /2","BIGTUPL,@Y@");
   DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ rmv1##_domain( onetupl(E_ @Y@), 1 ) ) )
       myerr(@n@,"rmv1()","<@X@>");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_domain( D_ rmv1##_domain( bigtupl, 1 ),
                           D_ sub_tup##_domain( bigtupl, 2, bignum ) ) )
       myerr(@n@,"rmv1()","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_eq##_elem( sel##_domain( D_ rmv1##_domain( bigtupl, 2 ), 1 ),
                       sel##_domain( D_ bigtupl, 1 ) ) )
       myerr(@n@,"rmv1() /1","BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( rmv1##_domain( bigtupl, 2 ), 2, bignum-1 ),
                           D_ sub_tup##_domain( bigtupl, 3, bignum ) ) )
       myerr(@n@,"rmv1() /2","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ rmv1##_domain( bigtupl, bignum ),
                           D_ sub_tup##_domain( bigtupl, 1, bignum-1 ) ) )
       myerr(@n@,"rmv1()","BIGTUPL");
   DD }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ rmv1d##_domain( onetupl(@Y@), 1 ) ) )
       myerr(@n@,"rmv1d()","<@X@>");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ rmv1d##_domain( bigtupl, 1 ),
                           D_ sub_tup##_domain( bigtupl, 2, bignum ) ) )
       myerr(@n@,"rmv1d()","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_eq##_elem( sel##_domain( D_ rmv1d##_domain( bigtupl, 2 ), 1 ),
                       sel##_domain( D_ bigtupl, 1 ) ) )
       myerr(@n@,"rmv1d() /1","BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( rmv1d##_domain( bigtupl, 2 ), 2, bignum-1 ),
                           D_ sub_tup##_domain( bigtupl, 3, bignum ) ) )
       myerr(@n@,"rmv1d() /2","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ rmv1d##_domain( bigtupl, bignum ),
                           D_ sub_tup##_domain( bigtupl, 1, bignum-1 ) ) )
       myerr(@n@,"rmv1d()","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( hd##_domain( D_ onetupl(@X@) ), E_ @X@) )
       myerr(@n@,"hd()","<@X@>");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_elem( hd##_domain( D_ bigtupl ), sel##_domain( D_ bigtupl, 1 ) ) )
       myerr(@n@,"hd()","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( last##_domain( D_ onetupl(@X@) ), E_ @X@) )
       myerr(@n@,"last()","<@X@>");
@) DD EE }

   void p_@N@()
   { if(! is_eq##_elem( last##_domain( D_ bigtupl ), sel##_domain( D_ bigtupl, bignum ) ) )
       myerr(@n@,"last()","BIGTUPL");
   DD }

/*================================================================================================*/

/*---- HMH

   void p_@N@()
   { if(! is_eq##_domain( D_ tl##_domain( niltupl ), D_ niltupl ) )
       myerr(@n@,"tl()","<@X@>");
   DD }

------*/

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ tl##_domain( onetupl(@X@) ), D_ niltupl ) )
       myerr(@n@,"tl()","<@X@>");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ tl##_domain( bigtupl ), D_ rmv1d##_domain( bigtupl, 1 ) ) )
       myerr(@n@,"tl()","BIGTUPL");
   DD }

/*------------------------------------------------------------------------------------------------*/

/*---- HMH
   void p_@N@()
   { if(! is_eq##_domain( D_ tld##_domain( niltupl ), D_ niltupl ) )
       myerr(@n@,"tld()","<@X@>");
   DD }

----- */

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ tld##_domain( onetupl(@X@) ), D_ niltupl ) )
       myerr(@n@,"tld()","<@X@>");
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ tld##_domain( bigtupl ), D_ rmv1d##_domain( bigtupl, 1 ) ) )
       myerr(@n@,"tld()","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( sel##_domain( D_ onetupl(@X@), 1 ), E_ @X@) )
       myerr(@n@,"sel()","<@X@>");
@) DD EE }

   void p_@N@()
   { int i=1;
@(   if(! is_eq##_elem( sel##_domain( D_ bigtupl, i++ ), E_ @X@) )
       myerr(@n@,"sel()","BIGTUPL");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( niltupl, 1, 0 ) ) )
       myerr(@n@,"sub_tup()","<>");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( niltupl, 1, 1 ) ) )
       myerr(@n@,"sub_tup()","<>");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( niltupl, 1, 2 ) ) )
       myerr(@n@,"sub_tup()","<>");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( niltupl, 2, 0 ) ) )
       myerr(@n@,"sub_tup()","<>");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( niltupl, 2, 1 ) ) )
       myerr(@n@,"sub_tup()","<>");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( niltupl, 2, 2 ) ) )
       myerr(@n@,"sub_tup()","<>");
   DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub_tup##_domain( onetupl(E_ @X@), 1, 0 ) ) )
       myerr(@n@,"sub_tup()","<@X@>");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub_tup##_domain( onetupl(@X@), 1, 1 ), D_ onetupl(@X@) ) )
       myerr(@n@,"sub_tup()","<@X@>");
@) DD }

   void p_@N@()
   {
@(   if(! is_eq##_domain( D_ sub_tup##_domain( onetupl(@X@), 1, 2 ), D_ onetupl(@X@) ) )
       myerr(@n@,"sub_tup()","<@X@>");
@) DD }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub_tup##_domain( onetupl(E_ @X@), 2, 0 ) ) )
       myerr(@n@,"sub_tup()","<@X@>");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub_tup##_domain( onetupl(E_ @X@), 2, 1 ) ) )
       myerr(@n@,"sub_tup()","<@X@>");
@) DD EE }

   void p_@N@()
   {
@(   if(! is_empty##_domain( D_ sub_tup##_domain( onetupl(E_ @X@), 2, 2 ) ) )
       myerr(@n@,"sub_tup()","<@X@>");
@) DD EE }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( bigtupl, 1, 0 ) ) )
       myerr(@n@,"sub_tup()","BIGTUPL");
   DD }

   void p_@N@()
   { int i=1;
@(   if(! is_eq##_domain( D_ sub_tup##_domain( bigtupl, i, i ), D_ onetupl(@X@) ) )
       myerr(@n@,"sub_tup()","BIGTUPL,@X@");
     ++i;
@) DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub_tup##_domain( bigtupl, 1, bignum ), D_ bigtupl ) )
       myerr(@n@,"sub_tup()","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub_tup##_domain( bigtupl, 1, bignum+1 ), D_ bigtupl ) )
       myerr(@n@,"sub_tup()","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( bigtupl, bignum, 0 ) ) )
       myerr(@n@,"sub_tup()","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_eq##_domain( D_ sub_tup##_domain( bigtupl, bignum, bignum+1 ),
                           D_ sub_tup##_domain( bigtupl, bignum, bignum ) ) )
       myerr(@n@,"sub_tup()","BIGTUPL");
   DD }

   void p_@N@()
   { if(! is_empty##_domain( D_ sub_tup##_domain( bigtupl, bignum+1, bignum+1 ) ) )
       myerr(@n@,"sub_tup()","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( rindex##_domain( D_ niltupl, E_ @X@ ) != 0 )
       myerr(@n@,"rindex()","<>,@X@");
@) DD EE }

   void p_@N@()
   {
@(   if( rindex##_domain( D_ onetupl(@Y@), E_ @X@ ) != 0 )
       myerr(@n@,"rindex()","<@Y@>,@X@");
@) DD EE }

   void p_@N@()
   {
@(   if( rindex##_domain( D_ onetupl(@X@), E_ @X@ ) != 1 )
       myerr(@n@,"rindex()","<@X@>,@X@");
@) DD EE }

   void p_@N@()
   { if( rindex##_domain( D_ bigtupl, E_ @Y@ ) != 0 )
       myerr(@n@,"rindex()","BIGTUPL,@Y@");
   DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( index##_domain( D_ niltupl, E_ @X@ ) != 0 )
       myerr(@n@,"index()","<>,@X@");
@) DD EE }

   void p_@N@()
   {
@(   if( index##_domain( D_ onetupl(@Y@), E_ @X@ ) != 0 )
       myerr(@n@,"index()","<@Y@>,@X@");
@) DD EE }

   void p_@N@()
   {
@(   if( index##_domain( D_ onetupl(@X@), E_ @X@ ) != 1 )
       myerr(@n@,"index()","<@X@>,@X@");
@) DD EE }

   void p_@N@()
   { if( index##_domain( D_ bigtupl, E_ @Y@ ) != 0 )
       myerr(@n@,"index()","BIGTUPL,@Y@");
   DD EE }

   void p_@N@()
   { int i = 1;
@(   if( index##_domain( D_ bigtupl, E_ @X@ ) != i++ )
       myerr(@n@,"index()","BIGTUPL,@X@");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   { if( search##_domain( D_ niltupl, search_test ) != 0 )
       myerr(@n@,"search()","<>,@Y@");
   DD }

   void p_@N@()
   {
@(   if( search##_domain( D_ onetupl(@X@), search_test ) != 0 )
       myerr(@n@,"search()","<@X@>,@Y@");
@) DD }

   void p_@N@()
   { if( search##_domain( D_ onetupl(@Y@), search_test ) != 1 )
       myerr(@n@,"search()","<@Y@>,@Y@");
   DD }

   void p_@N@()
   { if( search##_domain( D_ bigtupl, search_test ) != 0 )
       myerr(@n@,"search()","BIGTUPL,@Y@");
   DD }

   void p_@N@()
   { int i;
     for( i = 1; i <= bignum; ++i )
       if( search##_domain( D_ ovwrt1d##_domain( bigtupl, i, @Y@ ), search_test ) != i )
         myerr(@n@,"search()","BIGTUPL,@Y@");
   DD }

/*================================================================================================*/

#define ARG niltupl
#define TEXT <>,<>
#include <aux/com/is_eq/bbc2>

#define ARG niltupl
#define ARG2 onetupl(@X@)
#define TEXT <>,<@X@>
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG niltupl
#define ARG2 bigtupl
#define NEG
#define TEXT <>,ARG2
#include <aux/com/is_eq/bbc2>

#define ARG onetupl(@X@)
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onetupl(@X@)
#define ARG2 niltupl
#define TEXT <@X@>,<>
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onetupl(@Y@)
#define ARG2 onetupl(@X@)
#define TEXT <@Y@>,<@X@>
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG onetupl(@X@)
#define ARG2 bigtupl
#define TEXT <@X@>,ARG2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigtupl
#define ARG2 niltupl
#define TEXT ARG,<>
#define NEG
#include <aux/com/is_eq/bbc2>

#define ARG bigtupl
#define ARG2 onetupl(@X@)
#define TEXT ARG,<@X@>
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG bigtupl
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   { if(! is_empty##_domain( D_ niltupl ) )
       myerr(@n@,"is_empty()","<>");
   DD }

   void p_@N@()
   {
@(   if( is_empty##_domain( D_ onetupl(@X@) ) )
       myerr(@n@,"is_empty()","<@X@>");
@) DD }

   void p_@N@()
   { if( is_empty##_domain( D_ bigtupl ) )
       myerr(@n@,"is_empty()","BIGTUPL");
   DD }

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain( D_ niltupl, D_ niltupl ) )
       myerr(@n@,"is_gr()","<>,<>");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ niltupl, D_ onetupl(@Y@) ) )
       myerr(@n@,"is_gr()","<>,<@Y@>");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ niltupl, D_ bigtupl ) )
       myerr(@n@,"is_gr()","<>,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ onetupl(@Y@), D_ niltupl ) )
       myerr(@n@,"is_gr()","<@Y@>,<>");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ onetupl(@Y@), D_ onetupl(@Y@) ) )
       myerr(@n@,"is_gr()","<@Y@>,<@Y@>");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ onetupl(@Y@), D_ onetupl(@Z@) ) )
       myerr(@n@,"is_gr()","<@Y@>,<@Z@>");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ onetupl(@Z@), D_ onetupl(@Y@) ) )
       myerr(@n@,"is_gr()","<@Z@>,<@Y@>");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ onetupl(@Y@), D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ) ) )
       myerr(@n@,"is_gr()","<@Y@>,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ bigtupl, D_ niltupl ) )
       myerr(@n@,"is_gr()","BIGTUPL,<>");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ), D_ onetupl(@Y@) ) )
       myerr(@n@,"is_gr()","BIGTUPL,<@Y@>");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ bigtupl, D_ bigtupl ) )
       myerr(@n@,"is_gr()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ),
                          D_ ovwrt1d##_domain( bigtupl, 1, @Z@ ) ) )
       myerr(@n@,"is_gr()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ ovwrt1d##_domain( bigtupl, 1, @Z@ ),
                           D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ) ) )
       myerr(@n@,"is_gr()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ ovwrt1d##_domain( bigtupl, 2, @Y@ ),
                          D_ ovwrt1d##_domain( bigtupl, 2, @Z@ ) ) )
       myerr(@n@,"is_gr()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ ovwrt1d##_domain( bigtupl, 2, @Z@ ),
                           D_ ovwrt1d##_domain( bigtupl, 2, @Y@ ) ) )
       myerr(@n@,"is_gr()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if( is_gr##_domain( D_ ovwrt1d##_domain( bigtupl, bignum, @Y@ ),
                          D_ ovwrt1d##_domain( bigtupl, bignum, @Z@ ) ) )
       myerr(@n@,"is_gr()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_gr##_domain( D_ ovwrt1d##_domain( bigtupl, bignum, @Z@ ),
                           D_ ovwrt1d##_domain( bigtupl, bignum, @Y@ ) ) )
       myerr(@n@,"is_gr()","BIGTUPL,BIGTUPL");
   DD }
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain( D_ niltupl, D_ niltupl ) )
       myerr(@n@,"is_ge()","<>,<>");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ niltupl, D_ onetupl(@Y@) ) )
       myerr(@n@,"is_ge()","<>,<@Y@>");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ niltupl, D_ bigtupl ) )
       myerr(@n@,"is_ge()","<>,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ onetupl(@Y@), D_ niltupl ) )
       myerr(@n@,"is_ge()","<@Y@>,<>");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ onetupl(@Y@), D_ onetupl(@Y@) ) )
       myerr(@n@,"is_ge()","<@Y@>,<@Y@>");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ onetupl(@Y@), D_ onetupl(@Z@) ) )
       myerr(@n@,"is_ge()","<@Y@>,<@Z@>");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ onetupl(@Z@), D_ onetupl(@Y@) ) )
       myerr(@n@,"is_ge()","<@Z@>,<@Y@>");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ onetupl(@Y@), D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ) ) )
       myerr(@n@,"is_ge()","<@Y@>,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ bigtupl, D_ niltupl ) )
       myerr(@n@,"is_ge()","BIGTUPL,<>");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ), D_ onetupl(@Y@) ) )
       myerr(@n@,"is_ge()","BIGTUPL,<@Y@>");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ bigtupl, D_ bigtupl ) )
       myerr(@n@,"is_ge()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ),
                          D_ ovwrt1d##_domain( bigtupl, 1, @Z@ ) ) )
       myerr(@n@,"is_ge()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ ovwrt1d##_domain( bigtupl, 1, @Z@ ),
                           D_ ovwrt1d##_domain( bigtupl, 1, @Y@ ) ) )
       myerr(@n@,"is_ge()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ ovwrt1d##_domain( bigtupl, 2, @Y@ ),
                          D_ ovwrt1d##_domain( bigtupl, 2, @Z@ ) ) )
       myerr(@n@,"is_ge()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ ovwrt1d##_domain( bigtupl, 2, @Z@ ),
                           D_ ovwrt1d##_domain( bigtupl, 2, @Y@ ) ) )
       myerr(@n@,"is_ge()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if( is_ge##_domain( D_ ovwrt1d##_domain( bigtupl, bignum, @Y@ ),
                          D_ ovwrt1d##_domain( bigtupl, bignum, @Z@ ) ) )
       myerr(@n@,"is_ge()","BIGTUPL,BIGTUPL");
   DD }
  
   void p_@N@()
   { if(! is_ge##_domain( D_ ovwrt1d##_domain( bigtupl, bignum, @Z@ ),
                           D_ ovwrt1d##_domain( bigtupl, bignum, @Y@ ) ) )
       myerr(@n@,"is_ge()","BIGTUPL,BIGTUPL");
   DD }
  
#endif
/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ niltupl, for_test );
     if( glob != 0 )
       myerr(@n@,"forall()","<>");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forall##_domain( D_ onetupl(@X@), for_test );
     if( glob != 1 )
       myerr(@n@,"forall() /1","<@X@>");
     if(! is_eq##_domain( glob_tupl, D_ onetupl(@X@) ) )
       myerr(@n@,"forall() /2","<@X@>");
@) DD }

   void p_@N@()
   { clear_glob();
     forall##_domain( D_ bigtupl, for_test );
     if( glob != bignum )
       myerr(@n@,"forall() /1","BIGTUPL");
     if(! is_eq##_domain( glob_tupl, D_ bigtupl ) )
       myerr(@n@,"forall() /2","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ niltupl, forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","<>");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forsome##_domain( D_ onetupl(@X@), forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","<@X@>");
@) DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ onetupl(@Y@), forsome_test, for_test );
     if( glob != 1 )
       myerr(@n@,"forsome() /1","<@Y@>");
     if(! is_eq##_domain( glob_tupl, D_ onetupl(@Y@) ) )
       myerr(@n@,"forsome() /2","<@Y@>");
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( D_ bigtupl, forsome_test, for_test );
     if( glob != 0 )
       myerr(@n@,"forsome()","BIGTUPL");
   DD }

   void p_@N@()
   { int i;
     for( i = 1; i <= bignum; ++i )
     { clear_glob();
       forsome##_domain( D_ ovwrt1d##_domain( bigtupl, i, @Y@ ), forsome_test, for_test );
       if( glob != 1 )
         myerr(@n@,"forsome() /1","BIGTUPL,@Y@");
       if(! is_eq##_domain( glob_tupl, D_ onetupl(@Y@) ) )
         myerr(@n@,"forsome() /2","BIGTUPL,@Y@");
     }
   DD }

   void p_@N@()
   { clear_glob();
     forsome##_domain( /* D_ HMH */ mkn##_domain( @Y@, bignum ), forsome_test, for_test );
     if( glob != bignum )
       myerr(@n@,"forsome() /1","mkn(@Y@)");
     if(! is_eq##_domain( glob_tupl, /* D_ HMH */ mkn##_domain( @Y@, bignum ) ) )
       myerr(@n@,"forsome() /2","mkn(@Y@)");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forrange##_domain( /* D_ HMH */ niltupl, for_test, 1, 1 );
     if( glob != 0 )
       myerr(@n@,"forrange()","<>");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forrange##_domain( D_ onetupl(@X@), for_test, 1, 1 );
     if( glob != 1 )
       myerr(@n@,"forrange() /1","<@X@>");
     if(! is_eq##_domain( glob_tupl, D_ onetupl(@X@) ) )
       myerr(@n@,"forrange() /2","<@X@>");
@) DD }

   void p_@N@()
   { int i=1;
@(   clear_glob();
     forrange##_domain( D_ bigtupl, for_test, i, i );
     if( glob != 1 )
       myerr(@n@,"forrange() /1","BIGTUPL");
     if(! is_eq##_domain( glob_tupl, D_ sub_tup##_domain( bigtupl, i, i ) ) )
       myerr(@n@,"forrange() /2","BIGTUPL");
     ++i;
@) DD }

   void p_@N@()
   { clear_glob();
     forrange##_domain( D_ bigtupl, for_test, 1, bignum );
     if( glob != bignum )
       myerr(@n@,"forrange() /1","BIGTUPL");
     if(! is_eq##_domain( glob_tupl, D_ bigtupl ) )
       myerr(@n@,"forrange() /2","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   { clear_glob();
     forindex##_domain( D_ niltupl, forindex_test );
     if( glob != 0 )
       myerr(@n@,"forindex()","<>");
   DD }

   void p_@N@()
   { 
@(   clear_glob();
     forindex##_domain( D_ onetupl(@X@), forindex_test );
     if( glob != 1 )
       myerr(@n@,"forindex() /1","<@X@>");
     if(! is_eq##_domain( glob_tupl, D_ onetupl(@X@) ) )
       myerr(@n@,"forindex() /2","<@X@>");
@) DD }

   void p_@N@()
   { clear_glob();
     forindex##_domain( D_ bigtupl, forindex_test );
     if( glob != bignum )
       myerr(@n@,"forindex() /1","BIGTUPL");
     if(! is_eq##_domain( glob_tupl, D_ bigtupl ) )
       myerr(@n@,"forindex() /2","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   { if( bf##_domain( TRUE, D_ niltupl ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","<>");
   DD }

   void p_@N@()
   {
@(   if( bf##_domain( TRUE, D_ onetupl(@X@) ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","<@X@>");
@) DD }

   void p_@N@()
   { if( bf##_domain( TRUE, D_ bigtupl ) != TRUE )
       myerr(@n@,"binary-Funktional bf()","BIGTUPL");
   DD }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( ff##_domain( D_ niltupl, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","<>");
@) DD EE }

   void p_@N@()
   {
@(   if( ff##_domain( D_ onetupl(@X@), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE )
         != TRUE )
       myerr(@n@,"fold-Funktional ff()","<@X@>");
@) DD EE }

   void p_@N@()
   {
@(   if( ff##_domain( D_ bigtupl, E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"fold-Funktional ff()","BIGTUPL");
     if( ff1##_domain( D_ bigtupl, TRUE, fcvf##_elem, E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"fold-Funktional ff1()","BIGTUPL");
@) DD EE }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( fixf##_domain( D_ niltupl, E_ @X@,aaa,FALSE, E_ @Y@,bbb,TRUE, E_ @Z@,ccc,FALSE ) != TRUE )
       myerr(@n@,"foldix-Funktional fixf()","<>");
@) DD EE }

   void p_@N@()
   {
@(   if( fixf##_domain( D_ onetupl(@X@), E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE )
         != TRUE )
       myerr(@n@,"foldix-Funktional fixf()","<@X@>");
@) DD EE }

   void p_@N@()
   {
@(   if( fixf##_domain( D_ bigtupl, E_ @Z@,ccc,TRUE, E_ @Y@,bbb,FALSE, E_ @X@,aaa,TRUE ) != TRUE )
       myerr(@n@,"foldix-Funktional fixf()","BIGTUPL");
@) DD EE }

/*================================================================================================*/

#ifdef ISSTR1
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ niltupl, fname_str ) )
       myerr(@n@,"fwrite()","<>");
     if(! is_empty##_domain( D_ fread##_domain( fname_str ) ) )
       myerr(@n@,"fread()","<>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ onetupl(@Y@), fname_str ) )
       myerr(@n@,"fwrite()","<@Y@>");
     if(! is_eq##_domain( D_ fread##_domain( fname_str ), D_ onetupl(@Y@) ) )
       myerr(@n@,"fread()","<@Y@>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ bigtupl, fname_str ) )
       myerr(@n@,"fwrite()","BIGTUPL");
     if(! is_eq##_domain( D_ fread##_domain( fname_str ), D_ bigtupl ) )
       myerr(@n@,"fread()","BIGTUPL");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
/*================================================================================================*/

   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ niltupl, fname_str ) )
       myerr(@n@,"fwrite()","<>");
     if(! fapp##_domain( D_ niltupl, fname_str ) )
       myerr(@n@,"fapp()","<>");
     if(! is_empty##_domain( D_ fread##_domain( fname_str ) ) )
       myerr(@n@,"fread()","<>,<>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ niltupl, fname_str ) )
       myerr(@n@,"fwrite()","<>");
     if(! fapp##_domain( D_ onetupl(@Y@), fname_str ) )
       myerr(@n@,"fapp()","<@Y@>");
     if(! is_eq##_domain( D_ fread##_domain( fname_str ), D_ onetupl(@Y@) ) )
       myerr(@n@,"fread()","<>,<@Y@>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ niltupl, fname_str ) )
       myerr(@n@,"fwrite()","<>");
     if(! fapp##_domain( D_ bigtupl, fname_str ) )
       myerr(@n@,"fapp()","BIGTUPL");
     if(! is_eq##_domain( D_ fread##_domain( fname_str ), D_ bigtupl ) )
       myerr(@n@,"fread()","<>,BIGTUPL");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ onetupl(@Y@), fname_str ) )
       myerr(@n@,"fwrite()","<@Y@>");
     if(! fapp##_domain( D_ niltupl, fname_str ) )
       myerr(@n@,"fapp()","<>");
     if(! is_eq##_domain( D_ fread##_domain( fname_str ), D_ onetupl(@Y@) ) )
       myerr(@n@,"fread()","<@Y@>,<>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ onetupl(@Y@), fname_str ) )
       myerr(@n@,"fwrite()","<@Y@>");
     if(! fapp##_domain( D_ onetupl(@Z@), fname_str ) )
       myerr(@n@,"fapp()","<@Z@>");
     if(! is_eq##_elem( sel##_domain( D_ fread##_domain( fname_str ), 1 ), E_ @Y@ ) )
       myerr(@n@,"fread() /1","<@Y@>,<@Z@>");
     if(! is_eq##_elem( sel##_domain( D_ fread##_domain( fname_str ), 2 ), E_ @Z@ ) )
       myerr(@n@,"fread() /2","<@Y@>,<@Z@>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ onetupl(@Y@), fname_str ) )
       myerr(@n@,"fwrite()","<@Y@>");
     if(! fapp##_domain( D_ bigtupl, fname_str ) )
       myerr(@n@,"fapp()","BIGTUPL");
     if(! is_eq##_elem( sel##_domain( D_ fread##_domain( fname_str ), 1 ), E_ @Y@ ) )
       myerr(@n@,"fread() /1","<@Y@>,BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( fread##_domain( fname_str ), 2, bignum+1 ),
                           D_ bigtupl ) )
       myerr(@n@,"fread() /2","<@Y@>,BIGTUPL");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD EE }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ bigtupl, fname_str ) )
       myerr(@n@,"fwrite()","BIGTUPL");
     if(! fapp##_domain( D_ niltupl, fname_str ) )
       myerr(@n@,"fapp()","<>");
     if(! is_eq##_domain( D_ fread##_domain( fname_str ), D_ bigtupl ) )
       myerr(@n@,"fread()","BIGTUPL,<>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ bigtupl, fname_str ) )
       myerr(@n@,"fwrite()","BIGTUPL");
     if(! fapp##_domain( D_ onetupl(@Y@), fname_str ) )
       myerr(@n@,"fapp()","<@Y@>");
     if(! is_eq##_domain( D_ sub_tup##_domain( fread##_domain( fname_str ), 1, bignum ),
                           D_ bigtupl ) )
       myerr(@n@,"fread() /1","BIGTUPL,<@Y@>");
     if(! is_eq##_elem( sel##_domain( D_ fread##_domain( fname_str ), bignum+1 ), E_ @Y@ ) )
       myerr(@n@,"fread() /2","BIGTUPL,<@Y@>");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD EE }
  
   void p_@N@()
   { char * fname = "TEST_FILE";
     Domain fname_str = D_ mkc##_domain( fname ); 
     if(! fwrite##_domain( D_ bigtupl, fname_str ) )
       myerr(@n@,"fwrite()","BIGTUPL");
     if(! fapp##_domain( D_ bigtupl, fname_str ) )
       myerr(@n@,"fapp()","BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( fread##_domain( fname_str ), 1, bignum ),
                           D_ bigtupl ) )
       myerr(@n@,"fread() /1","BIGTUPL,BIGTUPL");
     if(! is_eq##_domain( D_ sub_tup##_domain( fread##_domain( fname_str ),
                           bignum+1, bignum+bignum ), D_ bigtupl ) )
       myerr(@n@,"fread() /2","BIGTUPL,BIGTUPL");
     if( unlink(fname) )
       myerr(@n@,"unlink()",fname);
   DD }
  
#endif
/*================================================================================================*/

#define ARG niltupl
#define TEXT <>
#include <aux/com/cvtotupl/bbc2>

#define ARG onetupl(@X@)
#define TEXT <@X@>
#define REPEAT
#include <aux/com/cvtotupl/bbc2>

#define ARG bigtupl
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG niltupl
#define TEXT <>
#include <aux/com/hash/bbc2>

#define ARG onetupl(@X@)
#define TEXT <@X@>
#define REPEAT
#include <aux/com/hash/bbc2>

#define ARG bigtupl
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG niltupl
#include <aux/com/del1/bbc2>

#define ARG onetupl(@X@)
#define REPEAT
#include <aux/com/del1/bbc2>

#define ARG bigtupl
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   { del2##_domain( niltupl );
   }

   void p_@N@()
   {
@(   del2##_domain( onetupl(@X@) );
@) }

   void p_@N@()
   { del2##_domain( bigtupl );
   }

/*------------------------------------------------------------------------------------------------*/

#define ARG niltupl
#include <aux/com/del/bbc2>

#define ARG onetupl(@X@)
#define REPEAT
#include <aux/com/del/bbc2>

#define ARG bigtupl
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG niltupl
#include <aux/com/print/bbc2>

#define ARG onetupl(@X@)
#define REPEAT
#include <aux/com/print/bbc2>

#define ARG bigtupl
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG niltupl
#include <aux/com/pr/bbc2>

#define ARG onetupl(@X@)
#define REPEAT
#include <aux/com/pr/bbc2>

#define ARG bigtupl
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG niltupl
#include <aux/com/fpr/bbc2>

#define ARG onetupl(@X@)
#define REPEAT
#include <aux/com/fpr/bbc2>

#define ARG bigtupl
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/tupl/com/basic/bbd1 <<'-----'
@X@=
mk_empty##_elem()
mk1##_elem(xxx)
mk1##_elem(yyy)
mk1##_elem(zzz)
mk2##_elem(zzz,yyy)
mk3##_elem(zzz,yyy,xxx)
mkn##_elem(zzz,30)

@Y@=
mk3##_elem(xxx,yyy,ppp)

@Z@=
mk3##_elem(xxx,yyy,qqq)
-----
cat >$OUT_DIR/tupl/com/basic/docu <<'-----'
Syntax:

  Tu = El *

ISO Syntax ( -N option ):

  Tu = seq of El

Description:

  '*' ( ISO: seq of <type> )

  defines all finite tuples whose elements are from the given element type.
  El * denotes the infinite domain of finite length tuples all of whose
  elements are in El. The 0-length tuple is in El * for any El.

Example:

  Let El denote a class of objects, i.e. a  domain ,  abstracting  the
  fields  of  a record, with records consisting now of a finite number
  of such ordered fields. Then :

      Tu = El *

  or the equivalent ISO syntax

      Tu = seq of El

  is an abstract syntax rule whose left-hand side is an  'identifier',
  and  whose  right-hand side is a 'domain expression'. It describes a
  record as being a tuple of fields. The equation gives the name Tu to
  a  domain, and  this domain is defined, by El *, to be the domain of
  finite length tuples of El.

-----
[ -d $OUT_DIR/tupl/com/binary ] || mkdir $OUT_DIR/tupl/com/binary
cat >$OUT_DIR/tupl/com/binary/ccod <<'-----'
#include <aux/com/binary/ccod>
-----
cat >$OUT_DIR/tupl/com/binary/docu <<'-----'
#define tupl
#include <aux/com/binary/docu>
-----
cat >$OUT_DIR/tupl/com/binary/param <<'-----'
DELETE
FCTNAME
FOLDEXT
FOLDFCT
NOFOLDENR
NOSIGNATURE
RESULT
-----
cat >$OUT_DIR/tupl/com/binary/vdm <<'-----'
#include <aux/com/binary/vdm>
-----
[ -d $OUT_DIR/tupl/com/conc ] || mkdir $OUT_DIR/tupl/com/conc
cat >$OUT_DIR/tupl/com/conc/ccod <<'-----'
#define fct conc
#define result DOMAIN
#define inires x1
#define tx2 DOMAIN
#define incr r1 = MERGE(appr,_DOMAIN)(r1,y1);
#define forx x2
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/conc/docu <<'-----'
  general implementation of conc for tuples via forall and appr

  time complexity : O(n) * O(appr)
-----
cat >$OUT_DIR/tupl/com/conc/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall + appr
-----
[ -d $OUT_DIR/tupl/com/conc3 ] || mkdir $OUT_DIR/tupl/com/conc3
cat >$OUT_DIR/tupl/com/conc3/ccod <<'-----'
#include <tupl/com/conc3/gcod>
-----
cat >$OUT_DIR/tupl/com/conc3/cmcr <<'-----'
#include <tupl/com/conc3/gcod>
-----
cat >$OUT_DIR/tupl/com/conc3/gcod <<'-----'
_FDEC3(conc3,DOMAIN,DOMAIN,DOMAIN,DOMAIN,_RET(conc##_DOMAIN(conc##_DOMAIN(x1,x2),x3)))
-----
cat >$OUT_DIR/tupl/com/conc3/pmcr <<'-----'
#include <tupl/com/conc3/gcod>
-----
cat >$OUT_DIR/tupl/com/conc3/vdm <<'-----'
DOMAINS IMPLEMENTATIONS DOMAIN   = + conc
-----
[ -d $OUT_DIR/tupl/com/conc4 ] || mkdir $OUT_DIR/tupl/com/conc4
cat >$OUT_DIR/tupl/com/conc4/ccod <<'-----'
#include <tupl/com/conc4/gcod>
-----
cat >$OUT_DIR/tupl/com/conc4/cmcr <<'-----'
#include <tupl/com/conc4/gcod>
-----
cat >$OUT_DIR/tupl/com/conc4/gcod <<'-----'
_FDEC4(conc4,DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN,
       _RET(conc##_DOMAIN(conc##_DOMAIN(conc##_DOMAIN(x1,x2),x3),x4)))
-----
cat >$OUT_DIR/tupl/com/conc4/pmcr <<'-----'
#include <tupl/com/conc4/gcod>
-----
cat >$OUT_DIR/tupl/com/conc4/vdm <<'-----'
DOMAINS IMPLEMENTATIONS DOMAIN   = + conc
-----
[ -d $OUT_DIR/tupl/com/conc5 ] || mkdir $OUT_DIR/tupl/com/conc5
cat >$OUT_DIR/tupl/com/conc5/ccod <<'-----'
#include <tupl/com/conc5/gcod>
-----
cat >$OUT_DIR/tupl/com/conc5/cmcr <<'-----'
#include <tupl/com/conc5/gcod>
-----
cat >$OUT_DIR/tupl/com/conc5/gcod <<'-----'
_FDEC5(conc5,DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN,
       _RET(conc##_DOMAIN(conc4##_DOMAIN(x1,x2,x3,x4),x5)))
-----
cat >$OUT_DIR/tupl/com/conc5/pmcr <<'-----'
#include <tupl/com/conc5/gcod>
-----
cat >$OUT_DIR/tupl/com/conc5/vdm <<'-----'
DOMAINS IMPLEMENTATIONS DOMAIN   = + conc + conc4
-----
[ -d $OUT_DIR/tupl/com/conc6 ] || mkdir $OUT_DIR/tupl/com/conc6
cat >$OUT_DIR/tupl/com/conc6/ccod <<'-----'
#include <tupl/com/conc6/gcod>
-----
cat >$OUT_DIR/tupl/com/conc6/cmcr <<'-----'
#include <tupl/com/conc6/gcod>
-----
cat >$OUT_DIR/tupl/com/conc6/gcod <<'-----'
_FDEC6(conc6,DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN,
       _RET(conc##_DOMAIN(conc##_DOMAIN(conc4##_DOMAIN(x1,x2,x3,x4),x5),x6)))
-----
cat >$OUT_DIR/tupl/com/conc6/pmcr <<'-----'
#include <tupl/com/conc6/gcod>
-----
cat >$OUT_DIR/tupl/com/conc6/vdm <<'-----'
DOMAINS IMPLEMENTATIONS DOMAIN   = + conc + conc4
-----
[ -d $OUT_DIR/tupl/com/conc_path ] || mkdir $OUT_DIR/tupl/com/conc_path
cat >$OUT_DIR/tupl/com/conc_path/ccod <<'-----'
#undef __DOS__
_IF defined(__DOS__)
_DEFINE VDMpathdel '\\'
_ELSE
_DEFINE VDMpathdel '/'
_ENDIF

  DOMAIN conc_path##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {return conc##_DOMAIN(appr##_DOMAIN(x1,VDMpathdel),x2);}

_UNDEF VDMpathdel
-----
cat >$OUT_DIR/tupl/com/conc_path/docu <<'-----'
  general implementation of constructing a tuple with 2 elements
  implemented with mk1 and appr
-----
cat >$OUT_DIR/tupl/com/conc_path/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + conc + appr
-----
[ -d $OUT_DIR/tupl/com/concc ] || mkdir $OUT_DIR/tupl/com/concc
cat >$OUT_DIR/tupl/com/concc/ccod <<'-----'
#include <tupl/com/concc/gcod>
-----
cat >$OUT_DIR/tupl/com/concc/cmcr <<'-----'
#include <tupl/com/concc/gcod>
-----
cat >$OUT_DIR/tupl/com/concc/docu <<'-----'
  general implementation of concc for tuples via copy and conc

  time complexity : O(copy) + O(conc)
-----
cat >$OUT_DIR/tupl/com/concc/gcod <<'-----'
_FDEC2(concc,DOMAIN,DOMAIN,DOMAIN,_RET(conc##_DOMAIN(x1,copy##_DOMAIN(x2))))
-----
cat >$OUT_DIR/tupl/com/concc/pmcr <<'-----'
#include <tupl/com/concc/gcod>
-----
cat >$OUT_DIR/tupl/com/concc/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + copy + conc
-----
[ -d $OUT_DIR/tupl/com/copy ] || mkdir $OUT_DIR/tupl/com/copy
cat >$OUT_DIR/tupl/com/copy/ccod <<'-----'
#if SIMPLEELEMS
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN) {return copy1##_DOMAIN(x1);}
#else
#define fct copy
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define incr r1 = MERGE(appr,_DOMAIN)(r1,MERGE(copy,_ELEM1)(y1));
#include <aux/com/for/ccod>
#endif
-----
cat >$OUT_DIR/tupl/com/copy/docu <<'-----'
  general implementation of copy
  copy(x1) = <copy(x1(i)) | i e ind x1>

  time complexity : O(n) * O(copy(ELEM1))
-----
cat >$OUT_DIR/tupl/com/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if SIMPLEELEMS
   DOMAIN   =  + copy1
#else
   DOMAIN   =  + forall + mk_empty + appr
   ELEM1    =  + copy
#endif
-----
[ -d $OUT_DIR/tupl/com/copy1 ] || mkdir $OUT_DIR/tupl/com/copy1
cat >$OUT_DIR/tupl/com/copy1/ccod <<'-----'
#define fct copy1
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define incr r1 = MERGE(appr,_DOMAIN)(r1,y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/copy1/docu <<'-----'
  general implementation of copy1 by constructing a new tuple
  copy1(x1) = <x1(i) | i e ind x1>

  time complexity : O(n)
-----
cat >$OUT_DIR/tupl/com/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall + mk_empty + appr
-----
[ -d $OUT_DIR/tupl/com/copy2 ] || mkdir $OUT_DIR/tupl/com/copy2
cat >$OUT_DIR/tupl/com/copy2/docu <<'-----'
  general implementation of copy2
  copy2(x1) = <copy1(x1(i)) | i e ind x1>

  time complexity : O(n) * O(copy2(ELEM1))
-----
cat >$OUT_DIR/tupl/com/copy2/gtyp <<'-----'
_DEFINE copyelem1##_ELEM1(x1) mk1##_DOMAIN(copy1##_ELEM1(x1))
-----
cat >$OUT_DIR/tupl/com/copy2/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN	= + fold.copy2	("RESULT"	= DOMAIN
				,"NULLFCT"= "mk_empty"
				,"FOLDFCT"= "conc"
				,"CVFCT"	= "copyelem1"
				,"NOSIGNATURE"
				)
  DOMAIN	= + mk_empty + conc + mk1
  ELEM1		= + copy1
-----
[ -d $OUT_DIR/tupl/com/cvfromtup1 ] || mkdir $OUT_DIR/tupl/com/cvfromtup1
cat >$OUT_DIR/tupl/com/cvfromtup1/ccod <<'-----'
#define __ADDELEM appr
#define MK_EMPTY(x1) MERGE(mkn_empty,_DOMAIN)(x1)
#include <aux/com/cvfromtup1/ccod>
-----
cat >$OUT_DIR/tupl/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tupl/com/cvfromtup1/vdm <<'-----'
#define __ADDELEM appr
#define MK_EMPTY(x1) MERGE(mkn_empty,_DOMAIN)(x1)
#include <aux/com/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/tupl/com/cvlines ] || mkdir $OUT_DIR/tupl/com/cvlines
cat >$OUT_DIR/tupl/com/cvlines/ccod <<'-----'
#if ISCHAR
  Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
    { return mk1_cvtext_vdmlib( conc_str( mkc_str("\"")
                                           , conc_str( cvstr##_DOMAIN(x1)
                                                     , mkc_str("\"")
                                 )         )         );
    }
#else

#define IS_EMPTY(x1) MERGE(is_empty,_DOMAIN)(x1)

#ifdef GEN_ISO
#define START_STR "["
#define END_STR "]"
#else
#define START_STR "<"
#define END_STR ">"
#endif

#include <aux/com/cvlines/ccod>
#undef IS_EMPTY
#undef START_STR
#undef END_STR

#endif
-----
cat >$OUT_DIR/tupl/com/cvlines/docu <<'-----'
#include <aux/com/cvlines/docu>
-----
cat >$OUT_DIR/tupl/com/cvlines/gtyp <<'-----'
#ifdef GEN_C
_DEFINE cvlines2##_DOMAIN(x1,x2) cvlines2_vdmlib(x1,x2)

#if ISCHAR
_DEFINE mk1_str_char(x1) mk1_str(x1)
#endif

#endif
-----
cat >$OUT_DIR/tupl/com/cvlines/param <<'-----'
SUPRESS
-----
cat >$OUT_DIR/tupl/com/cvlines/vdm <<'-----'
DOMAINS  
IMPLEMENTATIONS
  Str            =  + mkc
#if ISCHAR
  DOMAIN	 =  + fold.cvstr( "RESULT"  = "Str"
				, "NULLFCT" = "mk_empty"
				, "CVFCT"   = "mk1_str"
				, "FOLDFCT" = "conc"
				)
  Str		 =  + mk_empty + mk1 + conc
#else
  DOMAIN         =  + is_empty
                    + fold.cvlines1( "NULLFCT" = "mk_empty"
                                   , "CVFCT"   = "cvlines"
                                   , "FOLDFCT" = "cvlines2"
                                   , "RESULT"  = "Cvtext_vdmlib")
  ELEM1          =  + cvlines
#endif
  Vdmlib         =  + cvtext + header("STRING")
-----
[ -d $OUT_DIR/tupl/com/cvtotup1 ] || mkdir $OUT_DIR/tupl/com/cvtotup1
cat >$OUT_DIR/tupl/com/cvtotup1/ccod <<'-----'
#define __NOELEMS len
#include <aux/com/cvtotup1/ccod>
-----
cat >$OUT_DIR/tupl/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/tupl/com/cvtotup1/vdm <<'-----'
#define __NOELEMS len
#include <aux/com/cvtotup1/vdm>
-----
[ -d $OUT_DIR/tupl/com/default ] || mkdir $OUT_DIR/tupl/com/default
cat >$OUT_DIR/tupl/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the tuple datatype the following set of operations is
  added

#include <tupl/com/default/vdm>
-----
cat >$OUT_DIR/tupl/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty + mk1
                                       ! constructors !
             + is_empty 
                                       ! predicates !
             + len
                                       ! attributes !
             + hd + sel
                                       ! element selection !
             + appl + appr
                                       ! combinators with elements !
             + conc + tl
                                       ! combinators with tuples !
             + iterator
                                       ! iterator functions !
             + copy1 + del1
                                       ! duplicate and destroy values !
-----
[ -d $OUT_DIR/tupl/com/del ] || mkdir $OUT_DIR/tupl/com/del
cat >$OUT_DIR/tupl/com/del/ccod <<'-----'
#include <aux/com/del/ccod>
-----
cat >$OUT_DIR/tupl/com/del/docu <<'-----'
  general implementation of del via forall and del1

  time complexity : O(n) * O(del1(ELEM1))
-----
cat >$OUT_DIR/tupl/com/del/vdm <<'-----'
#include <aux/com/del/vdm>
-----
[ -d $OUT_DIR/tupl/com/del2 ] || mkdir $OUT_DIR/tupl/com/del2
cat >$OUT_DIR/tupl/com/del2/ccod <<'-----'
  static void _tmp_del2##_DOMAIN _FPH1(ELEM1) { del1##_ELEM1(x1); }

  void del2##_DOMAIN _FPH1(DOMAIN)
    { forall##_DOMAIN(x1,_tmp_del2##_DOMAIN);
      del1##_DOMAIN(x1);
    }
-----
cat >$OUT_DIR/tupl/com/del2/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS

    DOMAIN = + del1 + forall
    ELEM1  = + del1
-----
[ -d $OUT_DIR/tupl/com/elems ] || mkdir $OUT_DIR/tupl/com/elems
cat >$OUT_DIR/tupl/com/elems/defs <<'-----'
#ifndef GEN_DOCU
#ifndef RESULT
#error DOMAIN: Parameter 'RESULT' must be defined for operation 'elems'!
#endif
#endif

-----
cat >$OUT_DIR/tupl/com/elems/docu <<'-----'
  General implementation of the tuple element set operator.

  Parameters:

   'RESULT':
             Supplies the name of the resulting set domain.
             This parameter must be supplied.

   'COPY':
             if this parameter is given, a complete copy
             of all elements is performed during the computation
             such that the result and the argument do not share
             any data
             
-----
cat >$OUT_DIR/tupl/com/elems/param <<'-----'
RESULT
COPY
-----
cat >$OUT_DIR/tupl/com/elems/vdm <<'-----'
#include <tupl/com/elems/defs>

 DOMAINS
   DOMAIN -> RESULT
 IMPLEMENTATIONS
   RESULT = + mk_empty
            + mk_one
#ifdef COPY
   RESULT = + uniond
   ELEM1  = + copy
#else
   RESULT = + union
#endif
   DOMAIN = + fold.elems("RESULT"	= RESULT
			,"NOSIGNATURE"
			,"CVFCT"   = elems##_DOMAIN
#ifdef COPY
			,"FOLDFCT" = uniond
#else
			,"FOLDFCT" = union
#endif
			,"NULLFCT" = mk_empty)
-----
[ -d $OUT_DIR/tupl/com/exist ] || mkdir $OUT_DIR/tupl/com/exist
cat >$OUT_DIR/tupl/com/exist/docu <<'-----'
#include <aux/com/exist/docu>
-----
cat >$OUT_DIR/tupl/com/exist/vdm <<'-----'
#include <aux/com/exist/vdm>
-----
[ -d $OUT_DIR/tupl/com/exist1 ] || mkdir $OUT_DIR/tupl/com/exist1
cat >$OUT_DIR/tupl/com/exist1/docu <<'-----'
#include <aux/com/exist1/docu>
-----
cat >$OUT_DIR/tupl/com/exist1/gcod <<'-----'
#include <aux/com/exist1/gcod>
-----
cat >$OUT_DIR/tupl/com/exist1/gtyp <<'-----'
#include <aux/com/exist1/gtyp>
-----
cat >$OUT_DIR/tupl/com/exist1/vdm <<'-----'
#include <aux/com/exist1/vdm>
-----
[ -d $OUT_DIR/tupl/com/extract ] || mkdir $OUT_DIR/tupl/com/extract
cat >$OUT_DIR/tupl/com/extract/defs <<'-----'
#ifndef INDEXSET
#error DOMAIN: Parameter 'INDEXSET' must be defined for operation 'extract'!
#endif
-----
cat >$OUT_DIR/tupl/com/extract/docu <<'-----'
  General implementation of the extract set operator.

  Parameters:

   'INDEXSET':
                Supplies the name of the index subset to be extracted
                from the tuple.
                This parameter must be supplied.
                It must denote a domain identifier for a Nat1-set
-----
cat >$OUT_DIR/tupl/com/extract/param <<'-----'
INDEXSET
-----
cat >$OUT_DIR/tupl/com/extract/vdm <<'-----'
#include <tupl/com/extract/defs>
 DOMAINS
   DOMAIN -> INDEXSET
 IMPLEMENTATIONS
   INDEXSET = + is_in
   ELEM1    = + copy
   DOMAIN   = + mk_empty + mk_one
	      + foldix.extract(RESULT  = DOMAIN
			    ,CVFCT   = extract1##_DOMAIN
			    ,FOLDFCT = conc
			    ,NOSIGNATURE
			    ,NULLFCT = mk_empty
			    ,X       = INDEXSET)
-----
[ -d $OUT_DIR/tupl/com/fapp ] || mkdir $OUT_DIR/tupl/com/fapp
cat >$OUT_DIR/tupl/com/fapp/ccod <<'-----'
#define FCT fapp
#define ACC "a"
#include <tupl/aux/fwrite/ccod>
-----
cat >$OUT_DIR/tupl/com/fapp/docu <<'-----'
  general implementation of fapp with sel

  time complexity : n * O(sel)
-----
cat >$OUT_DIR/tupl/com/fapp/vdm <<'-----'
#include <tupl/aux/fwrite/vdm>
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + sel + len
-----
[ -d $OUT_DIR/tupl/com/filter ] || mkdir $OUT_DIR/tupl/com/filter
cat >$OUT_DIR/tupl/com/filter/defs <<'-----'
#ifndef ELEMSET
#error DOMAIN: Parameter 'ELEMSET' must be defined for operation 'filter'!
#endif
-----
cat >$OUT_DIR/tupl/com/filter/docu <<'-----'
  General implementation of the filter operator.

  Parameters:
   'ELEMSET':
                Supplies the name of the element subset to be filtered
                from the tuple.
                This parameter must be supplied.
                It must denote a domain identifier of an ELEM1-set 

-----
cat >$OUT_DIR/tupl/com/filter/param <<'-----'
ELEMSET
-----
cat >$OUT_DIR/tupl/com/filter/vdm <<'-----'
#include <tupl/com/filter/defs>
 DOMAINS
   DOMAIN -> ELEMSET
 IMPLEMENTATIONS
   ELEMSET = + is_in
   ELEM1   = + copy
   DOMAIN  = + mk_empty + mk_one
	      + fold.filter(RESULT  = DOMAIN
			   ,CVFCT   = filter1##_DOMAIN
			   ,FOLDFCT = conc
			   ,NOSIGNATURE
			   ,NULLFCT = mk_empty
			   ,X       = ELEMSET)
-----
[ -d $OUT_DIR/tupl/com/fold ] || mkdir $OUT_DIR/tupl/com/fold
cat >$OUT_DIR/tupl/com/fold/ccod <<'-----'
#include <aux/com/fold/ccod>
-----
cat >$OUT_DIR/tupl/com/fold/docu <<'-----'
#define Tupl tupl
  Implementation of the 'fold' functional using the 'forall' routine
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/tupl/com/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/tupl/com/fold/vdm <<'-----'
#include <aux/com/fold/vdm>
-----
[ -d $OUT_DIR/tupl/com/foldix ] || mkdir $OUT_DIR/tupl/com/foldix
cat >$OUT_DIR/tupl/com/foldix/ccod <<'-----'
#include <tupl/aux/foldix/ccod>
#include <aux/com/fold/ccod>
-----
cat >$OUT_DIR/tupl/com/foldix/docu <<'-----'
   Implementation of the 'foldix' functional using the 'forall' iterator
#include <tupl/aux/foldix/docu>
-----
cat >$OUT_DIR/tupl/com/foldix/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/tupl/com/foldix/vdm <<'-----'
#include <tupl/aux/foldix/ccod>
#include <aux/com/fold/vdm>
-----
[ -d $OUT_DIR/tupl/com/forindex ] || mkdir $OUT_DIR/tupl/com/forindex
cat >$OUT_DIR/tupl/com/forindex/ccod <<'-----'
#define fct forindex
#define tx2 MERGE(T2_forindex,_DOMAIN)
#define tl1 Nat1
#define inil1 1
#define incr (*t2)(y1,l1++);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/forindex/docu <<'-----'
  general implementation of forindex by forall

  time complexity : as forall
-----
cat >$OUT_DIR/tupl/com/forindex/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
-----
[ -d $OUT_DIR/tupl/com/forrange ] || mkdir $OUT_DIR/tupl/com/forrange
cat >$OUT_DIR/tupl/com/forrange/ccod <<'-----'
#define fct forrange
#define tx2 MERGE(T2_forrange,_DOMAIN)
#define tx3 Nat1
#define tx4 Nat0
#define ty2 Nat1
#define incr if ((y2 >= t3) && (y2 <= t4)) (*t2)(y1);
#define forloop MERGE(forindex,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/forrange/docu <<'-----'
  general implementation of forrange by forall

  time complexity : as forall
-----
cat >$OUT_DIR/tupl/com/forrange/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
-----
[ -d $OUT_DIR/tupl/com/forsome ] || mkdir $OUT_DIR/tupl/com/forsome
cat >$OUT_DIR/tupl/com/forsome/ccod <<'-----'
#define fct forsome
#define tx2 MERGE(T2_forsome,_DOMAIN)
#define tx3 MERGE(T3_forsome,_DOMAIN)
#define incr if ((*t2)(y1)) (*t3)(y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/forsome/docu <<'-----'
  general implementation of forsome by forall

  time complexity : as forall
-----
cat >$OUT_DIR/tupl/com/forsome/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall
-----
[ -d $OUT_DIR/tupl/com/fread ] || mkdir $OUT_DIR/tupl/com/fread
cat >$OUT_DIR/tupl/com/fread/ccod <<'-----'
#include <tupl/aux/fread/ccod>
-----
cat >$OUT_DIR/tupl/com/fread/docu <<'-----'
  general implementation of fread
  fread constructs the empty tuple and uses appr
  for extending the tuple as long as there are elements on the file

  time complexity : n * O(appr)
-----
cat >$OUT_DIR/tupl/com/fread/vdm <<'-----'
#include <tupl/aux/fread/vdm>
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + appr
-----
[ -d $OUT_DIR/tupl/com/front ] || mkdir $OUT_DIR/tupl/com/front
cat >$OUT_DIR/tupl/com/front/docu <<'-----'
  General implementation of the front operator based on the
  rmv1 operation.
 
   front(t) = rmv1(t,len(t))
-----
cat >$OUT_DIR/tupl/com/front/gcod <<'-----'
 _FDEC1(front,DOMAIN,DOMAIN,_RET(rmv1##_DOMAIN(x1,len##_DOMAIN(x1))))
-----
cat >$OUT_DIR/tupl/com/front/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/com/front/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
   DOMAIN = + len + rmv1
-----
[ -d $OUT_DIR/tupl/com/frontd ] || mkdir $OUT_DIR/tupl/com/frontd
cat >$OUT_DIR/tupl/com/frontd/docu <<'-----'
  General implementation of the frontd operator based on the
  sub_tupd operation.
 
   frontd(t) = sub_tupd(t,1,len(t) -1)
-----
cat >$OUT_DIR/tupl/com/frontd/gcod <<'-----'
 _FDEC1(frontd,DOMAIN,DOMAIN,_RET(sub_tupd##_DOMAIN(x1,1,len##_DOMAIN(x1) - 1)))
-----
cat >$OUT_DIR/tupl/com/frontd/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/com/frontd/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
   DOMAIN = + len + sub_tupd
-----
[ -d $OUT_DIR/tupl/com/fwrite ] || mkdir $OUT_DIR/tupl/com/fwrite
cat >$OUT_DIR/tupl/com/fwrite/ccod <<'-----'
#include <tupl/aux/fwrite/ccod>
-----
cat >$OUT_DIR/tupl/com/fwrite/docu <<'-----'
  general implementation of fwrite with sel

  time complexity : n * O(sel)
-----
cat >$OUT_DIR/tupl/com/fwrite/vdm <<'-----'
#include <tupl/aux/fwrite/vdm>
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + sel + len
-----
[ -d $OUT_DIR/tupl/com/hash ] || mkdir $OUT_DIR/tupl/com/hash
cat >$OUT_DIR/tupl/com/hash/ccod <<'-----'
#define fct hash
#define result Nat0
#define inires 0
#define incr r1 += MERGE(hash,_ELEM1)(y1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/hash/docu <<'-----'
  general implementation of hash for tuples
  as hash the sum of the hashvalues of the components is taken

  time complexity : O(n) * O(hash(ELEM1))
-----
cat >$OUT_DIR/tupl/com/hash/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall
   ELEM1    =  + hash
-----
[ -d $OUT_DIR/tupl/com/hd ] || mkdir $OUT_DIR/tupl/com/hd
cat >$OUT_DIR/tupl/com/hd/ccod <<'-----'
  ELEM1 hd##_DOMAIN _FPH1(DOMAIN) {return sel##_DOMAIN(x1,(Nat1)1);}    
-----
cat >$OUT_DIR/tupl/com/hd/cmcr <<'-----'
_DEFINE hd##_DOMAIN(x1) sel##_DOMAIN(x1,(Nat1)1)
-----
cat >$OUT_DIR/tupl/com/hd/docu <<'-----'
  general implementation of hd

  hd(x1) = sel(x1,1)

  time complexity : O(sel(ELEM1))
-----
cat >$OUT_DIR/tupl/com/hd/pmcr <<'-----'
_DEFINE hd##_DOMAIN(x1) sel##_DOMAIN(x1,1)
-----
cat >$OUT_DIR/tupl/com/hd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + sel
-----
[ -d $OUT_DIR/tupl/com/index ] || mkdir $OUT_DIR/tupl/com/index
cat >$OUT_DIR/tupl/com/index/ccod <<'-----'
#define fct index
#define result Nat0
#define inires 0
#define tx2 ELEM1
#define ty2 Nat1
#define incr if ((r1 == 0) && MERGE(is_eq,_ELEM1)(y1,t2)) r1 = y2;
#define forloop MERGE(forindex,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/index/docu <<'-----'
  general implementation of index with forindex

  time complexity : O(n) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/com/index/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forindex
   ELEM1    = + is_eq
-----
[ -d $OUT_DIR/tupl/com/index_list ] || mkdir $OUT_DIR/tupl/com/index_list
cat >$OUT_DIR/tupl/com/index_list/ccod <<'-----'

  Nat0 index_list##_DOMAIN _FPH2(DOMAIN,DOMAIN)
  {
  Nat0 ix = 0;
  Nat0 lenx1 = len##_DOMAIN(x1);
  Nat0 lenx2 = len##_DOMAIN(x2);
  
  if ( lenx1 >= lenx2 ) {
    Nat0 diff = lenx1 - lenx2;
    while ( ix <= diff ) {
      Nat0 j = 1;
      while ( j <= lenx2 && is_eq##_ELEM1(sel##_DOMAIN(x2,j),sel##_DOMAIN(x1,j+ix)) )
        j++;
      ix++;
      if ( j > lenx2 )
        return ix; 
    }
  }
  return 0;  
  }
-----
cat >$OUT_DIR/tupl/com/index_list/docu <<'-----'
  general implementation of index_list

  time complexity : O(len x1 * len x2) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/com/index_list/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forindex + sel
   ELEM1    = + is_eq
-----
[ -d $OUT_DIR/tupl/com/index_list_from ] || mkdir $OUT_DIR/tupl/com/index_list_from
cat >$OUT_DIR/tupl/com/index_list_from/ccod <<'-----'

  Nat0 index_list_from##_DOMAIN _FPH3(DOMAIN,DOMAIN,Nat1)
  {
  Nat0 ix = x3-1;
  Nat0 lenx1 = len##_DOMAIN(x1);
  Nat0 lenx2 = len##_DOMAIN(x2);
  
  if ( lenx1 >= lenx2 + ix ) {
    Nat0 diff = lenx1 - lenx2;
    while ( ix <= diff ) {
      Nat0 j = 1;
      while ( j <= lenx2 && is_eq##_ELEM1(sel##_DOMAIN(x2,j),sel##_DOMAIN(x1,j+ix)) )
        j++;
      ix++;
      if ( j > lenx2 )
        return ix; 
    }
  }
  return 0;  
  }
-----
cat >$OUT_DIR/tupl/com/index_list_from/docu <<'-----'
  general implementation of index_list_from

  time complexity : O(len x1 * len x2) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/com/index_list_from/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forindex + sel
   ELEM1    = + is_eq
-----
[ -d $OUT_DIR/tupl/com/inds ] || mkdir $OUT_DIR/tupl/com/inds
cat >$OUT_DIR/tupl/com/inds/ccod <<'-----'
#include <tupl/com/inds/defs>
  RESULT inds##_DOMAIN _FPH1(DOMAIN)
    { register Nat0 lx1;
      RESULT        lx2; lx2 = mk_empty##_RESULT();
      for (lx1 = 1; lx1 <= len##_DOMAIN(x1); lx1++)
	  { lx2 = union1##_RESULT(lx2,lx1); }
      return lx2;
    }
-----
cat >$OUT_DIR/tupl/com/inds/defs <<'-----'
#ifndef GEN_DOCU
#ifndef RESULT
#error DOMAIN: Parameter 'RESULT' must be defined for operation 'inds'!
#endif
#endif
-----
cat >$OUT_DIR/tupl/com/inds/docu <<'-----'
  General implementation of the index set operator.

  Parameters:

   'RESULT':
              Supplies the name of the resulting set domain.
              This parameter must be supplied,
              it must be a 'Nat0 -set'

-----
cat >$OUT_DIR/tupl/com/inds/param <<'-----'
RESULT
-----
cat >$OUT_DIR/tupl/com/inds/vdm <<'-----'
#include <tupl/com/inds/defs>

 DOMAINS
   DOMAIN -> RESULT
 IMPLEMENTATIONS
   RESULT = + mk_empty + union1
   DOMAIN = + len
-----
[ -d $OUT_DIR/tupl/com/insert ] || mkdir $OUT_DIR/tupl/com/insert
cat >$OUT_DIR/tupl/com/insert/ccod <<'-----'
  DOMAIN insert##_DOMAIN _FPH3(DOMAIN,Nat1,ELEM1)
   { Nat0 lx1 = len##_DOMAIN(x1);
     DOMAIN lx2 = copy1##_DOMAIN(x1);

     if (x2 > lx1 + 1) err_sel_vdmlib(x2,lx1,MKSTRING(DOMAIN));
     return conc##_DOMAIN(appr##_DOMAIN(sub_tup##_DOMAIN(lx2,1,x2-1)
				     ,x3)
			,sub_tup##_DOMAIN(x1,x2,lx1));
   }
-----
cat >$OUT_DIR/tupl/com/insert/docu <<'-----'
  general implementation using 'conc' and 'sub_tup' working with
  'conc', 'sub_tup' and 'copy1'.
-----
cat >$OUT_DIR/tupl/com/insert/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + conc + appr + copy1 + sub_tup + len
   Vdmlib   = + err_sel
-----
[ -d $OUT_DIR/tupl/com/is_empty ] || mkdir $OUT_DIR/tupl/com/is_empty
cat >$OUT_DIR/tupl/com/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN) {return (len##_DOMAIN(x1) == 0);}    
-----
cat >$OUT_DIR/tupl/com/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (len##_DOMAIN(x1) == 0)
-----
cat >$OUT_DIR/tupl/com/is_empty/docu <<'-----'
  general implementation of is_empty

  is_empty(x1) = (len(x1) = 0)

  time complexity : O(len(DOMAIN))
-----
cat >$OUT_DIR/tupl/com/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (len##_DOMAIN(x1) = 0)
-----
cat >$OUT_DIR/tupl/com/is_empty/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + len
-----
[ -d $OUT_DIR/tupl/com/is_eq ] || mkdir $OUT_DIR/tupl/com/is_eq
cat >$OUT_DIR/tupl/com/is_eq/ccod <<'-----'
#define fct is_eq
#define result Bool
#define inires (Bool)(MERGE(len,_DOMAIN)(x1) == MERGE(len,_DOMAIN)(x2))
#define tx2 DOMAIN
#define tl1 Nat1
#define inil1 1
#define forloop if (r1) MERGE(forall,_DOMAIN)
#define incr if (r1) r1 = MERGE(is_eq,_ELEM1)(y1,MERGE(sel,_DOMAIN)(t2,(Nat1)(l1++)));
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/is_eq/docu <<'-----'
  general implementation of is_eq for tuples via forall

  time complexity : O(n) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/com/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall + len + sel
   ELEM1    =  + is_eq
-----
[ -d $OUT_DIR/tupl/com/is_ge ] || mkdir $OUT_DIR/tupl/com/is_ge
cat >$OUT_DIR/tupl/com/is_ge/ccod <<'-----'
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {Nat0 lx1 = len##_DOMAIN(x1);
    Nat0 lx2 = len##_DOMAIN(x2);
    Nat0 i = 0;
    while (1)
    {if (i == lx1) return (i == lx2);
     if (i == lx2) return 1;
     i++;
     {ELEM1 le1 = sel##_DOMAIN(x1,(Nat1)i);
      ELEM1 le2 = sel##_DOMAIN(x2,(Nat1)i);
      if (! (is_eq##_ELEM1(le1,le2))) return is_ge##_ELEM1(le1,le2);
     }
    }
   }
-----
cat >$OUT_DIR/tupl/com/is_ge/docu <<'-----'
  general implementation of is_ge for tuples
  is_ge is the lexicografical ordering functions
  an ordering functions on the element domain must be available

  time complexity : O(n) * O(is_ge(ELEM1))
-----
cat >$OUT_DIR/tupl/com/is_ge/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + len + sel
   ELEM1    =  + is_ge + is_eq
-----
[ -d $OUT_DIR/tupl/com/is_postfix ] || mkdir $OUT_DIR/tupl/com/is_postfix
cat >$OUT_DIR/tupl/com/is_postfix/ccod <<'-----'
  Bool is_postfix##_DOMAIN _FPH2(DOMAIN,DOMAIN)
#if 0
    { DOMAIN lx1 = mk_sub_tup##_DOMAIN(x2,len##_DOMAIN(x2) - len##_DOMAIN(x1) + 1,len##_DOMAIN(x2));
      Bool   lx2 = is_eq##_DOMAIN(x1,lx1);
      del1##_DOMAIN(lx1); return lx2;
    }
#else
    { Nat0 l1 = len##_DOMAIN(x1);
      Nat0 l2 = len##_DOMAIN(x2);
      while ( 0 < l1 && 0 < l2 && is_eq##_ELEM1(sel##_DOMAIN(x1,l1),sel##_DOMAIN(x2,l2)) )
        l1--,l2--;
      return ( l1 == 0);
     }
#endif      
-----
cat >$OUT_DIR/tupl/com/is_postfix/docu <<'-----'
 General implementation of the is_postfix predicate
 by comparison of elements.
 Element access is done with indexing operation 'sel'.
-----
cat >$OUT_DIR/tupl/com/is_postfix/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
#if 0
   ! mk_sub_tup eleiminated !
   DOMAIN  = + del1 + mk_sub_tup + len + is_eq
#else
   DOMAIN  = + len + sel
   ELEM1   = + is_eq
#endif
-----
[ -d $OUT_DIR/tupl/com/is_prefix ] || mkdir $OUT_DIR/tupl/com/is_prefix
cat >$OUT_DIR/tupl/com/is_prefix/ccod <<'-----'
  Bool is_prefix##_DOMAIN _FPH2(DOMAIN,DOMAIN)
#if 0
    /* mk_sub_tup eliminated: semantic of mk_sub_tup changed to make a deep copy (c++) */
    { DOMAIN lx1 = mk_sub_tup##_DOMAIN(x2,1,len##_DOMAIN(x1));
      Bool   lx2 = is_eq##_DOMAIN(x1,lx1);
      del##_DOMAIN(lx1); return lx2;
    }
#else
    { Nat0 l1 = len##_DOMAIN(x1);
      Nat0 l2 = len##_DOMAIN(x2);
      Nat0 i = 1;
      while ( i <= l1 && i <= l2 && is_eq##_ELEM1(sel##_DOMAIN(x1,i),sel##_DOMAIN(x2,i)) )
        i++;
      return ( i > l1 );
     }
#endif       
-----
cat >$OUT_DIR/tupl/com/is_prefix/docu <<'-----'
 General implementation of the is_prefix predicate
 by comparison of elements.
 Element access is done with indexing operation 'sel'.

-----
cat >$OUT_DIR/tupl/com/is_prefix/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
#if 0
   ! mk_sub_tup eleiminated !
   DOMAIN  = + del1 + mk_sub_tup + len + is_eq
#else
   DOMAIN  = + len + sel
   ELEM1   = + is_eq
#endif
-----
[ -d $OUT_DIR/tupl/com/is_subtup ] || mkdir $OUT_DIR/tupl/com/is_subtup
cat >$OUT_DIR/tupl/com/is_subtup/ccod <<'-----'
  Bool is_subtup##_DOMAIN _FPH2(DOMAIN,DOMAIN)
#if 0
    { Nat0 lx1,lx2;

      for (lx1 = 1; lx1 <= len##_DOMAIN(x2); lx1++)
	  { for (lx2 = lx1; lx2 <= len##_DOMAIN(x2); lx2++)
		{ DOMAIN lx3 = mk_sub_tup##_DOMAIN(x2,lx1,lx2);
		  Bool lx4 = is_eq##_DOMAIN(x1,lx3);
		  del1##_DOMAIN(lx3);
		  if (lx4 == TRUE) { return TRUE; }
		}
	  }
      return FALSE;
    }
#else
    { return ( index_list##_DOMAIN(x2,x1) != 0 ); }
#endif
-----
cat >$OUT_DIR/tupl/com/is_subtup/docu <<'-----'
 General implementation of the is_subtup predicate
 using 'index_list'.
-----
cat >$OUT_DIR/tupl/com/is_subtup/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
#if 0
   DOMAIN  = + del1 + mk_sub_tup + len + is_eq
#else
   DOMAIN  = + index_list
#endif
-----
[ -d $OUT_DIR/tupl/com/iterator ] || mkdir $OUT_DIR/tupl/com/iterator
cat >$OUT_DIR/tupl/com/iterator/docu <<'-----'
#define TUPL
#include <aux/com/iterator/docu>
-----
cat >$OUT_DIR/tupl/com/iterator/gtyp <<'-----'
! iterator operations not available for the selected implementation !
-----
cat >$OUT_DIR/tupl/com/iterator/param <<'-----'
INTERNALFCT
-----
[ -d $OUT_DIR/tupl/com/last ] || mkdir $OUT_DIR/tupl/com/last
cat >$OUT_DIR/tupl/com/last/ccod <<'-----'
  ELEM1 last##_DOMAIN _FPH1(DOMAIN)
    {return sel##_DOMAIN(x1,(Nat1)(len##_DOMAIN(x1)));}    
-----
cat >$OUT_DIR/tupl/com/last/cmcr <<'-----'
_DEFINE last##_DOMAIN(x1) sel##_DOMAIN(x1,(Nat1)(len##_DOMAIN(x1)))
-----
cat >$OUT_DIR/tupl/com/last/docu <<'-----'
  general implementation of last

  last(x1) = sel(x1,len x1)

  time complexity : O(sel(ELEM1))
-----
cat >$OUT_DIR/tupl/com/last/pmcr <<'-----'
_DEFINE last##_DOMAIN(x1) sel##_DOMAIN(x1,len##_DOMAIN(x1))
-----
cat >$OUT_DIR/tupl/com/last/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + sel + len
-----
[ -d $OUT_DIR/tupl/com/len ] || mkdir $OUT_DIR/tupl/com/len
cat >$OUT_DIR/tupl/com/len/ccod <<'-----'
#define fct len
#define result Nat0
#define inires 0
#define incr r1++;
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/len/docu <<'-----'
  general implementation of len via counting elements with forall

  time complexity : O(n)
-----
cat >$OUT_DIR/tupl/com/len/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + forall
-----
[ -d $OUT_DIR/tupl/com/mfolddom ] || mkdir $OUT_DIR/tupl/com/mfolddom
cat >$OUT_DIR/tupl/com/mfolddom/ccod <<'-----'
#define _Tupl
#include <aux/com/mfolddom/ccod>
#undef _Tupl
-----
cat >$OUT_DIR/tupl/com/mfolddom/gtyp <<'-----'
#define _Tupl
#include <aux/com/mfolddom/gtyp>
#undef _Tupl
-----
cat >$OUT_DIR/tupl/com/mfolddom/param <<'-----'
FCTNAME
NEXTDOM
CALLDOM
XN
-----
cat >$OUT_DIR/tupl/com/mfolddom/vdm <<'-----'
#define _Tupl
#include <aux/com/mfolddom/vdm>
#undef _Tupl
-----
[ -d $OUT_DIR/tupl/com/mk1 ] || mkdir $OUT_DIR/tupl/com/mk1
cat >$OUT_DIR/tupl/com/mk1/ccod <<'-----'
  DOMAIN mk1##_DOMAIN _FPH1(ELEM1)
    {return appr##_DOMAIN(mk_empty##_DOMAIN(),x1);}    
-----
cat >$OUT_DIR/tupl/com/mk1/cmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) appr##_DOMAIN(mk_empty##_DOMAIN(),x1)
-----
cat >$OUT_DIR/tupl/com/mk1/docu <<'-----'
  general implementation of mk1

  mk1(x1) = appr(mk_empty(),x1)

  time complexity : constant
-----
cat >$OUT_DIR/tupl/com/mk1/pmcr <<'-----'
_DEFINE mk1##_DOMAIN(x1) appr##_DOMAIN(mk_empty##_DOMAIN,x1)
-----
cat >$OUT_DIR/tupl/com/mk1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + appr + mk_empty

#define CONSTRNAME mk1
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/com/mk2 ] || mkdir $OUT_DIR/tupl/com/mk2
cat >$OUT_DIR/tupl/com/mk2/ccod <<'-----'
  DOMAIN mk2##_DOMAIN _FPH2(ELEM1,ELEM1)
   {return appr##_DOMAIN(mk1##_DOMAIN(x1),x2);}
-----
cat >$OUT_DIR/tupl/com/mk2/cmcr <<'-----'
_DEFINE mk2##_DOMAIN(x1,x2) appr##_DOMAIN(mk1##_DOMAIN(x1),x2)
-----
cat >$OUT_DIR/tupl/com/mk2/docu <<'-----'
  general implementation of constructing a tuple with 2 elements
  implemented with mk1 and appr
-----
cat >$OUT_DIR/tupl/com/mk2/pmcr <<'-----'
_DEFINE mk2##_DOMAIN(x1,x2) appr##_DOMAIN(mk1##_DOMAIN(x1),x2)
-----
cat >$OUT_DIR/tupl/com/mk2/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + mk1 + appr

#define CONSTRNAME mk2
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/com/mk3 ] || mkdir $OUT_DIR/tupl/com/mk3
cat >$OUT_DIR/tupl/com/mk3/ccod <<'-----'
  DOMAIN mk3##_DOMAIN _FPH3(ELEM1,ELEM1,ELEM1)
   {return appr##_DOMAIN(appr##_DOMAIN(mk1##_DOMAIN(x1),x2),x3);}
-----
cat >$OUT_DIR/tupl/com/mk3/cmcr <<'-----'
_DEFINE mk3##_DOMAIN(x1,x2,x3) appr##_DOMAIN(appr##_DOMAIN(mk1##_DOMAIN(x1),x2),x3)
-----
cat >$OUT_DIR/tupl/com/mk3/docu <<'-----'
  general implementation of constructing a tuple with 3 elements
  implemented with mk1 and appr
-----
cat >$OUT_DIR/tupl/com/mk3/pmcr <<'-----'
_DEFINE mk3##_DOMAIN(x1,x2,x3) appr##_DOMAIN(appr##_DOMAIN(mk1##_DOMAIN(x1),x2),x3)
-----
cat >$OUT_DIR/tupl/com/mk3/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + mk1 + appr

#define CONSTRNAME mk2
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/com/mk_sub_tup ] || mkdir $OUT_DIR/tupl/com/mk_sub_tup
cat >$OUT_DIR/tupl/com/mk_sub_tup/ccod <<'-----'
  DOMAIN mk_sub_tup##_DOMAIN _FPH3(DOMAIN,Nat1,Nat0)
   { return sub_tupd##_DOMAIN(copy##_DOMAIN(x1),x2,x3); }
-----
cat >$OUT_DIR/tupl/com/mk_sub_tup/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + copy + sub_tupd
-----
[ -d $OUT_DIR/tupl/com/mkarray ] || mkdir $OUT_DIR/tupl/com/mkarray
cat >$OUT_DIR/tupl/com/mkarray/ccod <<'-----'
  DOMAIN mkarray##_DOMAIN _FPH2(ELEM1 *,Nat0)
   {register ELEM1 * lx1 = (ELEM1 *)x1;
    DOMAIN           lx2 = mk_empty##_DOMAIN();

    while (x2--) lx2 = appr##_DOMAIN(lx2,*(lx1++));
    return lx2;
   }
-----
cat >$OUT_DIR/tupl/com/mkarray/docu <<'-----'
   General implementation of 'mkarray' using 'mk_empty' and 'appr'
-----
cat >$OUT_DIR/tupl/com/mkarray/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
   DOMAIN = + mk_empty + appr
-----
[ -d $OUT_DIR/tupl/com/mkn ] || mkdir $OUT_DIR/tupl/com/mkn
cat >$OUT_DIR/tupl/com/mkn/ccod <<'-----'
#ifndef COPY
#define COPY(x) x
#endif

#ifndef FCT
#define FCT mkn
#endif

  DOMAIN FCT##_DOMAIN _FPH2(ELEM1,Nat0)
  { DOMAIN y1;
    Nat0   y2;

    y1 = mk_empty##_DOMAIN();
    for(y2 = 1; y2 <= x2; y2++) y1 = appr##_DOMAIN(y1,COPY(x1));
    return y1;
  }

#undef FCT
#undef COPY
#undef FCT
-----
cat >$OUT_DIR/tupl/com/mkn/docu <<'-----'
  general implementation of mkn

  time complexity : O(n) * O(appr)
-----
cat >$OUT_DIR/tupl/com/mkn/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + appr + mk_empty
-----
[ -d $OUT_DIR/tupl/com/mkn_empty ] || mkdir $OUT_DIR/tupl/com/mkn_empty
cat >$OUT_DIR/tupl/com/mkn_empty/gcod <<'-----'
#include <aux/com/mkn_empty/gcod>
-----
cat >$OUT_DIR/tupl/com/mkn_empty/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/com/mkn_empty/vdm <<'-----'
#include <aux/com/mkn_empty/vdm>
-----
[ -d $OUT_DIR/tupl/com/mknc ] || mkdir $OUT_DIR/tupl/com/mknc
cat >$OUT_DIR/tupl/com/mknc/ccod <<'-----'
#define COPY(x1) MERGE(copy,_ELEM1)(x1)
#define FCT	 mknc
#include <tupl/com/mkn/ccod>
-----
cat >$OUT_DIR/tupl/com/mknc/docu <<'-----'
  general implementation of mknc

  time complexity : O(n) * O(appr) * O(copy##_ELEM1)
-----
cat >$OUT_DIR/tupl/com/mknc/vdm <<'-----'
_ADD_OP(ELEM1,copy)
#include <tupl/com/mkn/vdm>
-----
[ -d $OUT_DIR/tupl/com/ovwrt1 ] || mkdir $OUT_DIR/tupl/com/ovwrt1
cat >$OUT_DIR/tupl/com/ovwrt1/ccod <<'-----'
#define fct ovwrt1
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 Nat1
#define tx3 ELEM1
#define ty2 Nat1
#define incr r1 = MERGE(appr,_DOMAIN)(r1,(t2 == y2) ? t3 : y1);
#define forloop MERGE(forindex,_DOMAIN)
#define resfin MERGE(del1,_DOMAIN)(x1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/ovwrt1/docu <<'-----'
  general implementation of ovwrt1 with forindex and appr

  time complexity : O(n) * O(appr)
-----
cat >$OUT_DIR/tupl/com/ovwrt1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + del1 + forindex + appr
-----
[ -d $OUT_DIR/tupl/com/ovwrt1d ] || mkdir $OUT_DIR/tupl/com/ovwrt1d
cat >$OUT_DIR/tupl/com/ovwrt1d/ccod <<'-----'
#define fct ovwrt1d
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 Nat1
#define tx3 ELEM1
#define ty2 Nat1
#define incr if (t2 == y2) { MERGE(del,_ELEM1)(y1); r1 = MERGE(appr,_DOMAIN)(r1,t3); } else { r1 = MERGE(appr,_DOMAIN)(r1,y1); }
#define forloop MERGE(forindex,_DOMAIN)
#define resfin MERGE(del1,_DOMAIN)(x1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/ovwrt1d/docu <<'-----'
  general implementation of ovwrt1d with forindex and appr

  time complexity : O(n) * O(appr)
-----
cat >$OUT_DIR/tupl/com/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + del1 + forindex + appr
   ELEM1    = + del
-----
[ -d $OUT_DIR/tupl/com/parse ] || mkdir $OUT_DIR/tupl/com/parse
cat >$OUT_DIR/tupl/com/parse/ccod <<'-----'
#ifdef ISCHAR
  DOMAIN parse##_DOMAIN _FPH0()
   { DOMAIN lx1 = mk_empty##_DOMAIN();
     char   lx2;

     expect_vdmlib("\"",#DOMAIN);
     while ((lx2 = getchar_vdmlib()) != '\"')
       { lx1 = appr##_DOMAIN(lx1,lx2); }
     return lx1;
   }
#else

#ifdef GEN_ISO
#define START_SYM '['
#define STOP_SYM ']'
#else
#define START_SYM '<'
#define STOP_SYM '>'
#endif

#define ADD_TO appr
#include <aux/com/parsem/ccod>
#endif
-----
cat >$OUT_DIR/tupl/com/parse/docu <<'-----'

  Syntax:  '<' [<ELEM1> (',' <ELEM1>)* ] '>'

-----
cat >$OUT_DIR/tupl/com/parse/vdm <<'-----'
#ifdef ISCHAR
DOMAINS
IMPLEMENTATIONS
  Vdmlib = + parsesup
  DOMAIN = + mk_empty + appr
#else
#define ADD_TO appr
#include <aux/com/parsem/vdm>
#endif
-----
[ -d $OUT_DIR/tupl/com/print ] || mkdir $OUT_DIR/tupl/com/print
cat >$OUT_DIR/tupl/com/print/ccod <<'-----'

#ifdef GEN_ISO
#define start "["
#define stop "]"
#else
#define start "<"
#define stop ">"
#endif
#define step ","

#include <aux/com/print/ccod>
-----
cat >$OUT_DIR/tupl/com/print/docu <<'-----'
  prints a tuple in the format "<e1,...,en>"
-----
cat >$OUT_DIR/tupl/com/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forall + is_empty
   ELEM1    = + print
   Vdmlib   = + header("STDIO")
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/tupl/com/read ] || mkdir $OUT_DIR/tupl/com/read
cat >$OUT_DIR/tupl/com/read/ccod <<'-----'
DOMAIN read##_DOMAIN _FPH2(Intg,Nat0)
  { DOMAIN lx1 = mk_empty##_DOMAIN();
    Nat0   lx2;

    for (lx2 = 0; lx2 < x2; lx2++)
      { ELEM1 llx1;
	Intg  llx2 = read(x1,(char *) &llx1,sizeof(ELEM1));

	if (llx2 == sizeof(ELEM1))
	   { lx1 = appr##_DOMAIN(lx1,llx1); }
	else 
	   { return lx1; }
      }
    
    return lx1;
  }

-----
cat >$OUT_DIR/tupl/com/read/docu <<'-----'
  General implementation of 'read'. Each element is read seperately
  and appended to the tuple.
-----
cat >$OUT_DIR/tupl/com/read/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + appr + mk_empty
-----
[ -d $OUT_DIR/tupl/com/reverse ] || mkdir $OUT_DIR/tupl/com/reverse
cat >$OUT_DIR/tupl/com/reverse/docu <<'-----'
 General implementation of the reverse operator.
-----
cat >$OUT_DIR/tupl/com/reverse/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
   ELEM1  = + copy
   DOMAIN = + mk_empty + mk_one + appl
	    + fold.reverse(RESULT	= DOMAIN
			  ,NULLFCT	= mk_empty
			  ,CVFCT	= copy
			  ,CVFCTRES	= ELEM1
			  ,FOLDFCT	= appl1)
-----
[ -d $OUT_DIR/tupl/com/rindex ] || mkdir $OUT_DIR/tupl/com/rindex
cat >$OUT_DIR/tupl/com/rindex/ccod <<'-----'
 Nat0 rindex##_DOMAIN _FPH2(DOMAIN,ELEM1)
   { Nat0 lx1;
     
     for (lx1 = len##_DOMAIN(x1); lx1 > 0; lx1--)
       { if (is_eq##_ELEM1(x2,sel##_DOMAIN(x1,lx1))) { return lx1; }}
    return 0;
   }
-----
cat >$OUT_DIR/tupl/com/rindex/docu <<'-----'
  General implementation of rindex using element selection.

  Time complexity : O(n) * O(sel(DOMAIN)) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/com/rindex/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + sel + len
   ELEM1    = + is_eq
-----
[ -d $OUT_DIR/tupl/com/rmv1 ] || mkdir $OUT_DIR/tupl/com/rmv1
cat >$OUT_DIR/tupl/com/rmv1/ccod <<'-----'
#define fct rmv1
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 Nat1
#define incr if (y2 != t2) r1 = MERGE(appr,_DOMAIN)(r1,y1);
#define ty2 Nat1
#define forloop MERGE(forindex,_DOMAIN)
#define resfin MERGE(del1,_DOMAIN)(x1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/rmv1/docu <<'-----'
  general implementation of rmv1 with forindex and appr

  time complexity : O(n) * O(appr(DOMAIN))
-----
cat >$OUT_DIR/tupl/com/rmv1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forindex + appr + del1 + mk_empty
-----
[ -d $OUT_DIR/tupl/com/rmv1d ] || mkdir $OUT_DIR/tupl/com/rmv1d
cat >$OUT_DIR/tupl/com/rmv1d/ccod <<'-----'
#define fct rmv1d
#define result DOMAIN
#define inires MERGE(mk_empty,_DOMAIN)()
#define tx2 Nat1
#define incr if (y2 == t2) MERGE(del,_ELEM1)(y1); else r1 = MERGE(appr,_DOMAIN)(r1,y1);
#define ty2 Nat1
#define forloop MERGE(forindex,_DOMAIN)
#define resfin MERGE(del1,_DOMAIN)(x1);
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/rmv1d/docu <<'-----'
  general implementation of rmv1d with forindex and appr

  time complexity : O(n) * O(appr(DOMAIN))
-----
cat >$OUT_DIR/tupl/com/rmv1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forindex + appr + del1 + mk_empty
   ELEM1    = + del
-----
[ -d $OUT_DIR/tupl/com/search ] || mkdir $OUT_DIR/tupl/com/search
cat >$OUT_DIR/tupl/com/search/ccod <<'-----'
#define fct search
#define result Nat0
#define inires 0
#define tx2 MERGE(T2_search,_DOMAIN)
#define ty2 Nat1
#define incr if ((r1 == 0) && (*t2)(y1)) r1 = y2;
#define forloop MERGE(forindex,_DOMAIN)
#include <aux/com/for/ccod>
-----
cat >$OUT_DIR/tupl/com/search/docu <<'-----'
  general implementation of search with forindex

  time complexity : O(n) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/com/search/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forindex
-----
[ -d $OUT_DIR/tupl/com/sel ] || mkdir $OUT_DIR/tupl/com/sel
cat >$OUT_DIR/tupl/com/sel/ccod <<'-----'
#define _NAME(z1) MERGE(MERGE(MERGE(_,z1),_sel),_DOMAIN)
#define tt1 _NAME(t1)
#define tt2 _NAME(t2)
#define tt3 _NAME(t3)

static Nat0 tt1;
static ELEM1 tt2;
void tt3(_FP(y1,ELEM1),_FP(y2,Nat1)) _EP(y1,ELEM1) _EP(y2,Nat1) {if (y2 == tt1) {tt1=0; tt2=y1;}}
   
ELEM1 sel##_DOMAIN _FPH2(DOMAIN,Nat1)
{
    tt1 = (Nat0)(x2);
    forindex##_DOMAIN(x1,tt3);
    if (tt1)
	err_sel_vdmlib(x2,len##_DOMAIN(x1),MKSTRING(DOMAIN));

    return tt2;
}
#undef _NAME
#undef tt1
#undef tt2
#undef tt3
-----
cat >$OUT_DIR/tupl/com/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + forindex + len
   Vdmlib   = + err_sel
-----
[ -d $OUT_DIR/tupl/com/sort ] || mkdir $OUT_DIR/tupl/com/sort
cat >$OUT_DIR/tupl/com/sort/ccod <<'-----'

#ifdef QSORT

/* T.Ottmann, P.Widmayer: Algorithmen und Datenstrukturen, BI, Seite 86 ff */

static DOMAIN sort1##_DOMAIN _FPH3(DOMAIN,Nat0,Nat0)
{
    Nat0 i,j;
    ELEM1 v;

    if (x3 > x2)
	{
	    i = x2 - 1;
	    j = x3;
	    v = sel##_DOMAIN(x1,(x2 + x3) / 2); /* middle element */

	    while (1) {
		do
		    ++i;
		while ( is_gr##_ELEM1(v, sel##_DOMAIN(x1, i)) );
		do
		    --j;
		while ( is_gr##_ELEM1(sel##_DOMAIN(x1, j), v) );

		if ( i >= j )
		    break;

		{
		    /* swap elements */
		    ELEM1 t = sel##_DOMAIN(x1, i);
		    x1 = ovwrt1##_DOMAIN(x1, i, sel##_DOMAIN(x1, j));
		    x1 = ovwrt1##_DOMAIN(x1, j, t);
		}
	    }

	    {
		/* swap elements */
		ELEM1 t = sel##_DOMAIN(x1, i);
		x1 = ovwrt1##_DOMAIN(x1, i, sel##_DOMAIN(x1, j));
		x1 = ovwrt1##_DOMAIN(x1, j, t);
	    }

	    x1 = sort1##_DOMAIN(x1, x2, i-1);
	    x1 = sort1##_DOMAIN(x1, i+1, x3);
	}

    return x1;
}

DOMAIN sort##_DOMAIN _FPH1(DOMAIN)
{
    return sort1##_DOMAIN(x1,1,len##_DOMAIN(x1));
}

#else

DOMAIN sort##_DOMAIN _FPH1(DOMAIN)
{
    Nat0 lx1,lx2;

    if (len##_DOMAIN(x1) == 0)
	{
	    return x1;
	}

    for (lx1 = len##_DOMAIN(x1) - 1;
	 lx1 >= 1;
	 --lx1)
	{
	    for (lx2 = 1;
		 lx2 <= lx1;
		 ++lx2)
                {
		    if (is_gr##_ELEM1(sel##_DOMAIN(x1,lx2),sel##_DOMAIN(x1,lx2 + 1)))
			{
			    ELEM1 lx3 = sel##_DOMAIN(x1,lx2);
			    x1 = ovwrt1##_DOMAIN(x1,lx2,sel##_DOMAIN(x1,lx2 + 1));
			    x1 = ovwrt1##_DOMAIN(x1,lx2 + 1,lx3);
			}
                }
	}
    return x1;
}
#endif
-----
cat >$OUT_DIR/tupl/com/sort/docu <<'-----'
  General implementation of sort for tuples.

  Default implementation is the 'bubblesort' algorithm.
  This algorithm makes heavy use of the 'sel' and 'ovwrt' operations
  for reading from and writing into the tuple, so these operations
  should be fairly efficient (or the tuples must be very short).

  time complexity : O(n*n) * O(sel)

  A second sorting algorithm 'quicksort' is also available. It can be
  selected with implementation parameter 'QUICKSORT'

  Example:

     Types
       Namelist = Str *

     Implementations
       Namelist = array + sort(QUICKSORT)

  ==> "quicksort' is used for Namelist


-----
cat >$OUT_DIR/tupl/com/sort/param <<'-----'
QUICKSORT
-----
cat >$OUT_DIR/tupl/com/sort/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + len + sel + ovwrt1
   ELEM1    =  + is_gr

-----
[ -d $OUT_DIR/tupl/com/sub_tup ] || mkdir $OUT_DIR/tupl/com/sub_tup
cat >$OUT_DIR/tupl/com/sub_tup/ccod <<'-----'
#ifndef fct
#define fct sub_tup
#endif

#ifndef delelem
#define delelem
#endif

  DOMAIN fct##_DOMAIN _FPH3(DOMAIN,Nat1,Nat0)
   {DOMAIN lx1 = mk_empty##_DOMAIN();
    Nat0   lx2 = len##_DOMAIN(x1);
    Nat0   lx3 = x2;
    if (lx2 < x3)
       x3 = lx2;
    while (lx3 <= x3)
       lx1 = appr##_DOMAIN(lx1,sel##_DOMAIN(x1,lx3++));
    delelem
    del1##_DOMAIN(x1);
    return lx1;
   }

#undef fct
#undef delelem
-----
cat >$OUT_DIR/tupl/com/sub_tup/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + appr + del1 + sel + len
-----
[ -d $OUT_DIR/tupl/com/sub_tupd ] || mkdir $OUT_DIR/tupl/com/sub_tupd
cat >$OUT_DIR/tupl/com/sub_tupd/ccod <<'-----'
#define fct sub_tupd

#if ! SIMPLEELEMS
#define delelem  delelem1 delelem2
#define delelem0(i) MERGE(del,_ELEM1)(MERGE(sel,_DOMAIN)(x1,(i)))
#define delelem1 { Nat0 i=1;  while (i != x2 ) delelem0(i++); }
#define delelem2 { Nat0 i=x3; while (i != lx2) delelem0(++i); }
#endif

#include <tupl/com/sub_tup/ccod>

#undef delelem0
#undef delelem1
#undef delelem2
-----
cat >$OUT_DIR/tupl/com/sub_tupd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + mk_empty + appr + del1 + sel + len
   ELEM1    = + del
-----
[ -d $OUT_DIR/tupl/com/sub_tupls ] || mkdir $OUT_DIR/tupl/com/sub_tupls
cat >$OUT_DIR/tupl/com/sub_tupls/ccod <<'-----'
  RESULT sub_tupls##_DOMAIN _FPH1(DOMAIN)
    { Nat0 lx1,lx2;
      RESULT lx3; lx3 = mk_empty##_RESULT();

      for (lx1 = 1; lx1 <= len##_DOMAIN(x1); lx1++)
	  { for (lx2 = lx1; lx2 <= len##_DOMAIN(x1); lx2++)
		{ lx3 = union1##_RESULT(lx3,sub_tupd##_DOMAIN(copy##_DOMAIN(x1),lx1,lx2)); }
	  }
      return lx3;
    }
-----
cat >$OUT_DIR/tupl/com/sub_tupls/defs <<'-----'
#ifndef RESULT
#error DOMAIN: Parameter 'RESULT' must be defined for operation 'sub_tupls'!
#endif
-----
cat >$OUT_DIR/tupl/com/sub_tupls/docu <<'-----'
 General implementation of the sub_tupls operator.

 Parameters:

   'RESULT':	Supplies the name of the result set domain, which
		must be DOMAIN -set.
		This parameter must be supplied.
-----
cat >$OUT_DIR/tupl/com/sub_tupls/param <<'-----'
RESULT
-----
cat >$OUT_DIR/tupl/com/sub_tupls/vdm <<'-----'
#include <tupl/com/sub_tupls/defs>
 DOMAINS
   DOMAIN -> RESULT
 IMPLEMENTATIONS
   RESULT = + mk_empty + union1
   DOMAIN  = + copy + sub_tupd + len
-----
[ -d $OUT_DIR/tupl/com/tl ] || mkdir $OUT_DIR/tupl/com/tl
cat >$OUT_DIR/tupl/com/tl/ccod <<'-----'
  DOMAIN tl##_DOMAIN _FPH1(DOMAIN) {return rmv1##_DOMAIN(x1,1);}
-----
cat >$OUT_DIR/tupl/com/tl/cmcr <<'-----'
_DEFINE tl##_DOMAIN(x1) rmv1##_DOMAIN(x1,1)
-----
cat >$OUT_DIR/tupl/com/tl/docu <<'-----'
  general implementation of tl via rmv1

  tl(x1) = rmv1(x1,1)

  time complexity : O(rmv1)
-----
cat >$OUT_DIR/tupl/com/tl/pmcr <<'-----'
_DEFINE tl##_DOMAIN(x1) rmv1##_DOMAIN(x1,1)
-----
cat >$OUT_DIR/tupl/com/tl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + rmv1
-----
[ -d $OUT_DIR/tupl/com/tld ] || mkdir $OUT_DIR/tupl/com/tld
cat >$OUT_DIR/tupl/com/tld/ccod <<'-----'
  DOMAIN tld##_DOMAIN _FPH1(DOMAIN) {return rmv1d##_DOMAIN(x1,1);}
-----
cat >$OUT_DIR/tupl/com/tld/cmcr <<'-----'
_DEFINE tld##_DOMAIN(x1) rmv1d##_DOMAIN(x1,1)
-----
cat >$OUT_DIR/tupl/com/tld/docu <<'-----'
  general implementation of tld via rmv1d

  tld(x1) = rmv1d(x1,1)

  time complexity : O(rmv1d)
-----
cat >$OUT_DIR/tupl/com/tld/pmcr <<'-----'
_DEFINE tld##_DOMAIN(x1) rmv1d##_DOMAIN(x1,1)
-----
cat >$OUT_DIR/tupl/com/tld/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + rmv1d
-----
[ -d $OUT_DIR/tupl/com/write ] || mkdir $OUT_DIR/tupl/com/write
cat >$OUT_DIR/tupl/com/write/ccod <<'-----'
Intg write##_DOMAIN _FPH2(Intg,DOMAIN)
  { Nat0  lx1 = 1;
    Nat0  lx2 = len##_DOMAIN(x2);

    while (lx1 <= lx2)
      { Intg llx1;
	ELEM1 llx2;

	llx2 = sel##_DOMAIN(x2,lx1);
        llx1 = write(x1,&llx2,sizeof(ELEM1));
	if (llx1 != sizeof(ELEM1)) break;
	lx1++;
      }

    return lx1 -1;
  }
-----
cat >$OUT_DIR/tupl/com/write/docu <<'-----'
  General inmplementation of read. Each element is selected and 
  written seperately.
-----
cat >$OUT_DIR/tupl/com/write/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + sel
-----
[ -d $OUT_DIR/tupl/larray ] || mkdir $OUT_DIR/tupl/larray
[ -d $OUT_DIR/tupl/larray/appl ] || mkdir $OUT_DIR/tupl/larray/appl
cat >$OUT_DIR/tupl/larray/appl/ccod <<'-----'
#include <tupl/larray/basic/aux>

DOMAIN appl##_DOMAIN _FPH2(ELEM1,DOMAIN)
  { if (ref##_DOMAIN(x2)->f_offs > 0)
       { x2->f_offs--; x2->f_len++;
	 *FIRSTELEM(x2) = x1;
	 return x2;
       }
    else
       { return conc##_DOMAIN(mk1##_DOMAIN(x1),x2); }
  }

#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/appl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN  = + conc + mk1
-----
[ -d $OUT_DIR/tupl/larray/appr ] || mkdir $OUT_DIR/tupl/larray/appr
cat >$OUT_DIR/tupl/larray/appr/ccod <<'-----'
#include <tupl/larray/basic/aux>

DOMAIN appr##_DOMAIN _FPH2(DOMAIN,ELEM1)
  { if (ref##_DOMAIN(x1)->f_len + x1->f_offs < x1->f_max)
       { *(FIRSTELEM(x1) + (x1->f_len++)) = x2;
	 return x1;
       }
    else
       { return conc##_DOMAIN(x1,mk1##_DOMAIN(x2)); }
  }

#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/appr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  DOMAIN  = + conc + mk1
-----
[ -d $OUT_DIR/tupl/larray/basic ] || mkdir $OUT_DIR/tupl/larray/basic
cat >$OUT_DIR/tupl/larray/basic/aux <<'-----'
#ifdef PHASE1
#undef PHASE1
#undef FIRSTELEM
#else
#define PHASE1
#define FIRSTELEM(x1) (((ELEM1*)(x1 + 1)) + x1->f_offs)
#endif
-----
cat >$OUT_DIR/tupl/larray/basic/ccod <<'-----'
/* needed for macro sel_DOMAIN */
/* else c++ complains about undefined referencen when using MACROS and NOCHECK */

DOMAIN sel##_DOMAIN##_tmp_var;
-----
cat >$OUT_DIR/tupl/larray/basic/docu <<'-----'
  Implementation of Tuples as variable length arrays.
  The elements are not necessarily stored starting at the beginning
  of the allocated space. Upon creation elements are stored using 
  a fixed offset that can be selected by the parameter 'OFFSET'.
  Using 'tl', 'appl' or even 'conc' will manipulate this offset 
  if possible to avoid copying tuples as long as possible.
  Thus 'tl' and often 'appl' will be very fast.

  Space : 3 * sizeof(unsigned) +  (n + offs) * sizeof(ELEM1)
    where 'n' is # of elements and 'offs' the offset of the elemts.
    Space is allocated in units of powers of 2.

  Parameters :
   SIMPLEELEMS :
                 if the element domain is implemented without
                 the use of dynamically allocated data (like for Char),
                 this flag improves the efficiency of the "del" function
   ISCHAR      :
                 says that elements of the tuple are characters
		 (affects output functions)
   NOCHECK     :
                 if defined, no check is done in select functions 
		 whether an index is not greater than length of tuple
   ALLOC       :
                 Used to change allocation strategie (default : vomalloc
                 where allocation is done in powers of 2 with C malloc 
		 and free)
   OFFSET      :
                 Used to change the default offset taken when creating
		 new tuple objects. Default value is 0. If 'appl' is
		 used frequently without previous use of 'tl' consider
		 to increase this value.
   MACROS      :
                 Implement operations as macros if possible. For those
		 operations implemented as macros this implies NOCHECK
-----
cat >$OUT_DIR/tupl/larray/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tupl/larray/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/tupl/larray/basic/gtyp <<'-----'
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_max,Nat0);
                      RECFIELD(f_len,Nat0);
                      RECFIELD(f_offs,Nat0);
#ifndef GEN_C
                      RECFIELD(f_str,ARRAY[1..10000]OF ELEM1);
#endif
  END_RECORD_TYP(Struct##_DOMAIN) 
-----
cat >$OUT_DIR/tupl/larray/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
ISCHAR
MACROS
NOCHECK
OFFSET
SIMPLEELEMS
-----
cat >$OUT_DIR/tupl/larray/basic/vdm <<'-----'
#ifndef ALLOC
#define ALLOC vomalloc
#endif

#ifndef OFFSET
#define TMPOFFSET 0
#else
#define TMPOFFSET OFFSET
#endif

DOMAINS
   Heap##_DOMAIN  = ( DOMAIN ELEM1 ) -heap
   DOMAIN	  -> Heap##_DOMAIN

IMPLEMENTATIONS
   Heap##_DOMAIN  = ALLOC("INTERNALDOMAIN"
                         ,"OFFSET"=TMPOFFSET)
		    + valloc("STRUCT"="struct Struct" #_DOMAIN)
#undef ALLOC
#undef TMPOFFSET

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/larray/conc ] || mkdir $OUT_DIR/tupl/larray/conc
cat >$OUT_DIR/tupl/larray/conc/ccod <<'-----'
#include <tupl/larray/basic/aux>

  DOMAIN conc##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {Nat0 ll1 = ref##_DOMAIN(x1)->f_len;
    Nat0 ll2 = ref##_DOMAIN(x2)->f_len;

    if (  (x1->f_offs + ll1 + ll2 <= x1->f_max)
#ifdef SHORTEST
       && ( (ll2 < ll1) || (ll1 > x2->f_offs) ) /* select shortest to copy */
#endif
       )
       { register Nat0 li = ll2;
	 register ELEM1 * px1 = FIRSTELEM(x1) + ll1;
	 register ELEM1 * px2 = FIRSTELEM(x2);
         while (li--) { *(px1++) = *(px2++); }
	 x1->f_len += ll2;
	 del1##_DOMAIN(x2);
	 return x1;
       }

    if (ll1 <= x2->f_offs)
       { register Nat0 li;
	 register ELEM1 * px1;
	 register ELEM1 * px2;

	 x2->f_offs -= ll1;
	 x2->f_len += ll1;
         li = ll1;
	 px1 = FIRSTELEM(x1);
	 px2 = FIRSTELEM(x2);
         while (li--) { *(px2++) = *(px1++); }
	 del1##_DOMAIN(x1);
	 return x2;
       }

    { DOMAIN lx3 = alloc##_DOMAIN(ll1 + ll2);
      register ELEM1 * pxs = FIRSTELEM(x1);
      register ELEM1 * pxd = FIRSTELEM(lx3);
      register Nat0 li = ll1;

      while (li--) { *(pxd++) = *(pxs++); }
      li = ll2; pxs = FIRSTELEM(x2);
      while (li--) { *(pxd++) = *(pxs++); }
      del1##_DOMAIN(x1);
      del1##_DOMAIN(x2);
      return lx3;
    }
  }

#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/conc/docu <<'-----'
  Special array implementation of conc. It is optimized to reduce
  copying by combining both tuples into one of the operands as long
  as possible.
  
  If the parameter 'SHORTEST' is set, it will be tried to copy the shorter 
  tuple into the other one first. This will eventually reduce copying 
  further at the expense of up to two compare (and branch) operations.
  Without this it first will be tried to copy the second tuple at the end 
  of the first one.
-----
cat >$OUT_DIR/tupl/larray/conc/param <<'-----'
SHORTEST
-----
cat >$OUT_DIR/tupl/larray/conc/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + del1
-----
[ -d $OUT_DIR/tupl/larray/copy ] || mkdir $OUT_DIR/tupl/larray/copy
cat >$OUT_DIR/tupl/larray/copy/ccod <<'-----'
#define fct copy
#if SIMPLEELEMS
#define copyelem(z1) z1
#else
#define copyelem(z1) MERGE(copy,_ELEM1)(z1)
#endif
#include <tupl/larray/copy1/ccod>
-----
cat >$OUT_DIR/tupl/larray/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! SIMPLEELEMS
   ELEM1 = + copy
#endif
-----
[ -d $OUT_DIR/tupl/larray/copy1 ] || mkdir $OUT_DIR/tupl/larray/copy1
cat >$OUT_DIR/tupl/larray/copy1/ccod <<'-----'
#ifndef fct
#define fct copy1
#endif

#ifndef copyelem
#define copyelem(z1) z1
#endif

#include <tupl/larray/basic/aux>

  DOMAIN fct##_DOMAIN _FPH1(DOMAIN)
  { DOMAIN  x2 = alloc##_DOMAIN(ref##_DOMAIN(x1)->f_len);
    register ELEM1 * px1 = FIRSTELEM(x1);
    register ELEM1 * px2 = FIRSTELEM(x2);
    register Nat0 i = x1->f_len;
    while (i--) *(px2++) = copyelem(*(px1++));
    return x2;
   }

#include <tupl/larray/basic/aux>

#undef copy
#undef fct
#undef copyelem
-----
[ -d $OUT_DIR/tupl/larray/cpc ] || mkdir $OUT_DIR/tupl/larray/cpc
cat >$OUT_DIR/tupl/larray/cpc/ccod <<'-----'
#include <tupl/larray/basic/aux>
  void cpc##_DOMAIN _FPH2(DOMAIN,ELEM1 *)
   {register Nat0    li  = ref##_DOMAIN(x1)->f_len;
    register ELEM1 * px1 = FIRSTELEM(x1);
    register ELEM1 * px2 = (ELEM1 *)x2;
    while (li--) *(px2++) = *(px1++);
    *(px2) = 0;
   }
#include <tupl/larray/basic/aux>
-----
[ -d $OUT_DIR/tupl/larray/del1 ] || mkdir $OUT_DIR/tupl/larray/del1
cat >$OUT_DIR/tupl/larray/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(x1);}
-----
cat >$OUT_DIR/tupl/larray/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(z1) free##_DOMAIN(z1)
-----
[ -d $OUT_DIR/tupl/larray/fapp ] || mkdir $OUT_DIR/tupl/larray/fapp
cat >$OUT_DIR/tupl/larray/fapp/ccod <<'-----'
#include <tupl/larray/basic/aux>
#define FCT fapp
#define ACC "a"
#define WLOOP \
  if (fwrite((char *)(FIRSTELEM(x1)),sizeof(ELEM1),x1->f_len,fd) != x1->f_len) return 0;
#include <tupl/aux/fwrite/ccod>
#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/fapp/vdm <<'-----'
#include <tupl/aux/fwrite/vdm>
-----
[ -d $OUT_DIR/tupl/larray/forall ] || mkdir $OUT_DIR/tupl/larray/forall
cat >$OUT_DIR/tupl/larray/forall/ccod <<'-----'
#include <tupl/larray/basic/aux>

  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    ELEM1 * px1 = FIRSTELEM(x1);
    while (lx1--) (*x2)(*(px1++));
   } 

#include <tupl/larray/basic/aux>
-----
[ -d $OUT_DIR/tupl/larray/insert ] || mkdir $OUT_DIR/tupl/larray/insert
cat >$OUT_DIR/tupl/larray/insert/ccod <<'-----'
#include <tupl/larray/basic/aux>

  DOMAIN insert##_DOMAIN _FPH3(DOMAIN,Nat1,ELEM1)
   { Nat0 lx1 = ref##_DOMAIN(x1)->f_len;

     if (x2 == 1 && x1->f_offs > 0)
	{ x1->f_offs--; x1->f_len++; *FIRSTELEM(x1) = x3; return x1; }

#ifndef NOCHECK
       if (x2 > lx1 + 1) err_sel_vdmlib(x2,lx1,MKSTRING(DOMAIN));
#endif

     if (lx1 + x1->f_offs < x1->f_max)
	{ register Nat0		lx2 = lx1 - x2 + 1;
	  register ELEM1*	lx3 = FIRSTELEM(x1) + lx1;

	  while (lx2--) { *lx3 = *(lx3 - 1); lx3--; }
	  *(FIRSTELEM(x1) + x2 - 1) = x3;
	  x1->f_len++;
	  return x1;
	}

     { DOMAIN lx2 = copy1##_DOMAIN(x1);

       return conc##_DOMAIN(appr##_DOMAIN(sub_tup##_DOMAIN(lx2,1,x2-1)
				       ,x3)
			  ,sub_tup##_DOMAIN(x1,x2,lx1));
     }
   }

#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/insert/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + conc + appr + copy1 + sub_tup
#ifndef NOCHECK
   Vdmlib   = + err_sel
#endif
-----
[ -d $OUT_DIR/tupl/larray/is_empty ] || mkdir $OUT_DIR/tupl/larray/is_empty
cat >$OUT_DIR/tupl/larray/is_empty/ccod <<'-----'
  Bool is_empty##_DOMAIN _FPH1(DOMAIN)
   {return (ref##_DOMAIN(x1)->f_len == 0);}
-----
cat >$OUT_DIR/tupl/larray/is_empty/cmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (! (ref##_DOMAIN((x1))->f_len) )
-----
cat >$OUT_DIR/tupl/larray/is_empty/pmcr <<'-----'
_DEFINE is_empty##_DOMAIN(x1) (x1^.f_len = 0)
-----
[ -d $OUT_DIR/tupl/larray/is_eq ] || mkdir $OUT_DIR/tupl/larray/is_eq
cat >$OUT_DIR/tupl/larray/is_eq/ccod <<'-----'
#include <tupl/larray/basic/aux>
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {register Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    if (lx1 != ref##_DOMAIN(x2)->f_len) return 0;
    {register Nat0 i = lx1;
     register ELEM1 * px1 = FIRSTELEM(x1);
     register ELEM1 * px2 = FIRSTELEM(x2);
     while (i--) { if (! is_eq##_ELEM1(*(px1++),*(px2++))) return 0; } 
     return 1;
    }
   }
#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/is_eq/docu <<'-----'
  array implementation of is_eq for tuples

  time complexity : O(n) * O(is_eq(ELEM1))
-----
cat >$OUT_DIR/tupl/larray/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1     =  + is_eq
-----
[ -d $OUT_DIR/tupl/larray/is_ge ] || mkdir $OUT_DIR/tupl/larray/is_ge
cat >$OUT_DIR/tupl/larray/is_ge/ccod <<'-----'
#include <tupl/larray/basic/aux>
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    Nat0 lx2 = ref##_DOMAIN(x2)->f_len;
    Nat0 i = 0;
    ELEM1 * px1 = FIRSTELEM(x1);
    ELEM1 * px2 = FIRSTELEM(x2);
    while (1)
    {if (i == lx2) return 1;
     if (i == lx1) return 0;
     {ELEM1 le1 = * (px1++);
      ELEM1 le2 = * (px2++);
      if (is_eq##_ELEM1(le1,le2)) i++;
      else return is_ge##_ELEM1(le1,le2);
     }
    }
   }
#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/is_ge/docu <<'-----'
  array implementation of is_ge for tuples
  is_ge is the lexicografical ordering functions
  an ordering functions on the element domain must be available

  time complexity : O(n) * O(is_ge(ELEM1))
-----
cat >$OUT_DIR/tupl/larray/is_ge/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1     =  + is_ge + is_eq
-----
[ -d $OUT_DIR/tupl/larray/is_gr ] || mkdir $OUT_DIR/tupl/larray/is_gr
cat >$OUT_DIR/tupl/larray/is_gr/ccod <<'-----'
#include <tupl/larray/basic/aux>
  Bool is_gr##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;
    Nat0 lx2 = ref##_DOMAIN(x2)->f_len;
    register Nat0 i = 0;
    register ELEM1 * px1 = FIRSTELEM(x1);
    register ELEM1 * px2 = FIRSTELEM(x2);
    while (1)
    {if (i == lx1) return 0;
     if (i == lx2) return 1;
     {ELEM1 le1 = * (px1++);
      ELEM1 le2 = * (px2++);
      if (is_eq##_ELEM1(le1,le2)) i++;
      else return is_ge##_ELEM1(le1,le2);
     }
    }
   }
#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/is_gr/docu <<'-----'
  array implementation of is_gr for tuples
  is_gr is the lexicografical ordering functions
  an ordering functions on the element domain must be available

  time complexity : O(n) * O(is_ge(ELEM1))
-----
cat >$OUT_DIR/tupl/larray/is_gr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   ELEM1     =  + is_ge + is_eq
-----
[ -d $OUT_DIR/tupl/larray/iterator ] || mkdir $OUT_DIR/tupl/larray/iterator
cat >$OUT_DIR/tupl/larray/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/tupl/larray/iterator/vdm <<'-----'
#define IMPL larray
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/tupl/larray/len ] || mkdir $OUT_DIR/tupl/larray/len
cat >$OUT_DIR/tupl/larray/len/ccod <<'-----'
  Nat0 len##_DOMAIN _FPH1(DOMAIN) {return (ref##_DOMAIN(x1)->f_len);}
-----
cat >$OUT_DIR/tupl/larray/len/cmcr <<'-----'
_DEFINE len##_DOMAIN(x1) (ref##_DOMAIN((x1))->f_len)
-----
cat >$OUT_DIR/tupl/larray/len/pmcr <<'-----'
_DEFINE len##_DOMAIN(x1) x1^.f_len
-----
[ -d $OUT_DIR/tupl/larray/mk1 ] || mkdir $OUT_DIR/tupl/larray/mk1
cat >$OUT_DIR/tupl/larray/mk1/ccod <<'-----'
#include <tupl/larray/basic/aux>

  DOMAIN mk1##_DOMAIN _FPH1(ELEM1)
  {DOMAIN lx1 = alloc##_DOMAIN((Nat0)1);
   *FIRSTELEM(lx1) = x1;
   return lx1;
  } 

#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/mk1/vdm <<'-----'

#define CONSTRNAME mk1
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/larray/mk_empty ] || mkdir $OUT_DIR/tupl/larray/mk_empty
cat >$OUT_DIR/tupl/larray/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0()
  {return alloc##_DOMAIN((Nat0)0);}
-----
cat >$OUT_DIR/tupl/larray/mk_empty/cmcr <<'-----'
_DEFINE mk_empty##_DOMAIN() alloc##_DOMAIN((Nat0)0)
-----
cat >$OUT_DIR/tupl/larray/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/larray/mkarray ] || mkdir $OUT_DIR/tupl/larray/mkarray
cat >$OUT_DIR/tupl/larray/mkarray/ccod <<'-----'
#define FCT mkarray
#define FHEADER _FPH2(ELEM1 *,Nat0)
#define INITLEN     li = x2;
#include <tupl/larray/mkc/ccod>
-----
[ -d $OUT_DIR/tupl/larray/mkc ] || mkdir $OUT_DIR/tupl/larray/mkc
cat >$OUT_DIR/tupl/larray/mkc/ccod <<'-----'
#include <tupl/larray/basic/aux>

#ifndef FCT
#define FCT mkc
#endif

#ifndef ASSIGN
#define ASSIGN { *(lx2++) = *(lx1++); }
#endif

#ifndef FHEADER
#define FHEADER _FPH1(ELEM1 *)
#endif

#ifndef INITLEN
#define INITLEN      while (*(lx1++)) li++;
#endif

  DOMAIN FCT##_DOMAIN FHEADER
   {register Nat0    li  = 0;   
    register ELEM1 * lx1 = (ELEM1 *)x1;
    INITLEN
    {DOMAIN          xr  = alloc##_DOMAIN(li);
     register ELEM1 * lx2 = FIRSTELEM(xr);
     lx1 = (ELEM1 *)x1;
     while (li--) ASSIGN
     return xr;
    }
   }
#include <tupl/larray/basic/aux>

#undef ASSIGN
#undef FCT
#undef INITLEN
#undef FHEADER
-----
cat >$OUT_DIR/tupl/larray/mkc/vdm <<'-----'

#define CONSTRNAME mkc
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/larray/mklc ] || mkdir $OUT_DIR/tupl/larray/mklc
cat >$OUT_DIR/tupl/larray/mklc/ccod <<'-----'
#define FCT mklc
#define ASSIGN { register ELEM1 c = *(lx1++); *(lx2++) = (isupper(c))?tolower(c):c; }
#include <tupl/larray/mkc/ccod>
-----
cat >$OUT_DIR/tupl/larray/mklc/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
Vdmlib  = + header("CTYPE")
-----
[ -d $OUT_DIR/tupl/larray/mkn_empty ] || mkdir $OUT_DIR/tupl/larray/mkn_empty
cat >$OUT_DIR/tupl/larray/mkn_empty/ccod <<'-----'
#include <aux/array/mkn_empty/ccod>
-----
cat >$OUT_DIR/tupl/larray/mkn_empty/param <<'-----'
MACROS
-----
[ -d $OUT_DIR/tupl/larray/ovwrt1 ] || mkdir $OUT_DIR/tupl/larray/ovwrt1
cat >$OUT_DIR/tupl/larray/ovwrt1/ccod <<'-----'

#ifndef fct
#define fct ovwrt1
#endif
#ifndef delelem
#define delelem(z1)
#endif
#include <tupl/larray/basic/aux>

  DOMAIN fct##_DOMAIN _FPH3(DOMAIN,Nat1,ELEM1)
   { ELEM1* lx3 = FIRSTELEM(x1) + x2 - 1;
#if ! NOCHECK
    if (x2 > ref##_DOMAIN(x1)->f_len)
       err_sel_vdmlib(x2,(Nat0)(x1->f_len),MKSTRING(DOMAIN));
#endif
    delelem(*lx3); *lx3 = x3;
    return x1;
   }

#include <tupl/larray/basic/aux>
#undef fct
#undef delelem
-----
cat >$OUT_DIR/tupl/larray/ovwrt1/docu <<'-----'
  time complexity : constant !
-----
cat >$OUT_DIR/tupl/larray/ovwrt1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
Vdmlib   = + err_sel
#endif
-----
[ -d $OUT_DIR/tupl/larray/ovwrt1d ] || mkdir $OUT_DIR/tupl/larray/ovwrt1d
cat >$OUT_DIR/tupl/larray/ovwrt1d/ccod <<'-----'
#define fct ovwrt1d
#if ! SIMPLEELEMS
#define delelem(z1) MERGE(del,_ELEM1)(z1)
#endif
#include <tupl/larray/ovwrt1/ccod>
-----
cat >$OUT_DIR/tupl/larray/ovwrt1d/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   Vdmlib   = + err_sel
#endif
   ELEM1    = + del
#if ! SIMPLEELEMS

#endif
-----
[ -d $OUT_DIR/tupl/larray/print ] || mkdir $OUT_DIR/tupl/larray/print
cat >$OUT_DIR/tupl/larray/print/ccod <<'-----'
#if ISCHAR
#include <tupl/larray/basic/aux>
  void print##_DOMAIN _FPH1(DOMAIN)
   {Nat0 lx1 = ref##_DOMAIN(x1)->f_len;   
_IFDEF __cplusplus
    print_FD_vdmlib << "\"";
_ELSE
    fprintf(print_FD_vdmlib,"\"");
_ENDIF
    if (lx1)
     {ELEM1 * px1 = FIRSTELEM(x1) + lx1 -1;
      static ELEM1 lx1[] = " ";
      lx1[0] = * px1;
      * px1 = 0;
_IFDEF __cplusplus
      print_FD_vdmlib << FIRSTELEM(x1) << lx1;
_ELSE
      fprintf(print_FD_vdmlib,"%s%s",FIRSTELEM(x1),lx1);
_ENDIF
      * px1 = lx1[0];
     }
_IFDEF __cplusplus
    print_FD_vdmlib << "\"";
_ELSE
    fprintf(print_FD_vdmlib,"\"");
_ENDIF
   }
#include <tupl/larray/basic/aux>
#else
#include <tupl/com/print/ccod>
#endif
-----
cat >$OUT_DIR/tupl/larray/print/docu <<'-----'
  for strings the tupl is printed a a quoted character sequence
  else the standard print routine is taken
-----
cat >$OUT_DIR/tupl/larray/print/vdm <<'-----'
#if ! ISCHAR
#include <tupl/com/print/vdm>
#else
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + printsup
#endif   
-----
[ -d $OUT_DIR/tupl/larray/puts ] || mkdir $OUT_DIR/tupl/larray/puts
cat >$OUT_DIR/tupl/larray/puts/ccod <<'-----'
#include <tupl/larray/basic/aux>
  void puts##_DOMAIN _FPH2(DOMAIN,FILE *)
   {Nat0    li = x1->f_len;
    ELEM1 * lx1 = FIRSTELEM(x1);
    while (li--) fputc((char)(*(lx1++)),x2);
   }
#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/puts/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + header("STDIO")
-----
[ -d $OUT_DIR/tupl/larray/read ] || mkdir $OUT_DIR/tupl/larray/read
cat >$OUT_DIR/tupl/larray/read/ccod <<'-----'
#include <tupl/larray/basic/aux>
DOMAIN read##_DOMAIN _FPH2(Intg,Nat0)
  { DOMAIN lx1 = alloc##_DOMAIN(x2);
    Intg   lx2 = read(x1,(char *)FIRSTELEM(lx1),x2 * sizeof(ELEM1));

    lx1->f_len = (lx2 < 0) ? 0 : lx2 / sizeof(ELEM1);
    return lx1;
  }

#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/read/docu <<'-----'
  Special implementation of 'read' for arrays. The tuple is read
  by calling the Unix read system call once.
-----
[ -d $OUT_DIR/tupl/larray/sel ] || mkdir $OUT_DIR/tupl/larray/sel
cat >$OUT_DIR/tupl/larray/sel/ccod <<'-----'
#include <tupl/larray/basic/aux>

ELEM1 sel##_DOMAIN _FPH2(DOMAIN,Nat1)
{

#if ! NOCHECK
    if (x2 > ref##_DOMAIN(x1)->f_len)
	err_sel_vdmlib(x2,(Nat0)(x1->f_len),MKSTRING(DOMAIN));
#endif

    return *( FIRSTELEM(x1) + x2 - 1);
}

#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/sel/cmcr <<'-----'
#if NOCHECK
#include <tupl/larray/basic/aux>
extern DOMAIN sel##_DOMAIN##_tmp_var;
_DEFINE sel##_DOMAIN(x1,x2) (sel##_DOMAIN##_tmp_var = (x1),(*( FIRSTELEM(sel##_DOMAIN##_tmp_var) + x2 - 1)))
#include <tupl/larray/basic/aux>
#else
#include <tupl/sign/sel/gsig>
#endif
-----
cat >$OUT_DIR/tupl/larray/sel/docu <<'-----'
  time complexity : constant !
-----
cat >$OUT_DIR/tupl/larray/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS

#if ! NOCHECK
   Vdmlib   = + err_sel
#endif

#if MACROS && ! NOCHECK
   DOMAIN   = + sel_save
#endif
-----
[ -d $OUT_DIR/tupl/larray/sel_save ] || mkdir $OUT_DIR/tupl/larray/sel_save
cat >$OUT_DIR/tupl/larray/sel_save/ccod <<'-----'
#include <tupl/larray/sel/ccod>
-----
[ -d $OUT_DIR/tupl/larray/sub_tup ] || mkdir $OUT_DIR/tupl/larray/sub_tup
cat >$OUT_DIR/tupl/larray/sub_tup/ccod <<'-----'
#ifndef fct
#define fct sub_tup
#endif

#ifndef delelem
#define delelem
#endif

DOMAIN fct##_DOMAIN _FPH3(DOMAIN,Nat1,Nat0)
  { if (x3 > ref##_DOMAIN(x1)->f_len) { x3 = x1->f_len; }
    if (x2 > x3) { x2 = x3 + 1; }
    delelem /* manipulate length after deleting, since 'sel' is used here */
    if (x2 > x3)
       { x1->f_len = 0; }
    else
       { x1->f_len = x3 - x2 + 1; x1->f_offs += x2 - 1; }
    return x1;
  }

#undef fct
#undef delelem
-----
cat >$OUT_DIR/tupl/larray/sub_tup/docu <<'-----'
  Special implementation of 'sub_tup' working in constant time
  by manipulating pointers.
-----
[ -d $OUT_DIR/tupl/larray/sub_tupd ] || mkdir $OUT_DIR/tupl/larray/sub_tupd
cat >$OUT_DIR/tupl/larray/sub_tupd/ccod <<'-----'
#define fct sub_tupd
#if ! SIMPLEELEMS
#define delelem delelem1 delelem2
#define delelem1 { Nat0 i=1;  while (i != x2 )       MERGE(del,_ELEM1)(MERGE(sel,_DOMAIN)(x1,i++)); }
#define delelem2 { Nat0 i=x3; while (i != x1->f_len) MERGE(del,_ELEM1)(MERGE(sel,_DOMAIN)(x1,++i)); }
#endif
#include <tupl/larray/sub_tup/ccod>
#undef delelem1
#undef delelem2
#undef delelem
#undef fct
-----
cat >$OUT_DIR/tupl/larray/sub_tupd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! SIMPLEELEMS
   DOMAIN   = + sel
   ELEM1    = + del
#endif
-----
[ -d $OUT_DIR/tupl/larray/tl ] || mkdir $OUT_DIR/tupl/larray/tl
cat >$OUT_DIR/tupl/larray/tl/ccod <<'-----'
#ifndef FCT
#define FCT tl
#endif

#ifndef DELELEM
#define DELELEM(z1)
#endif

#include <tupl/larray/basic/aux>

DOMAIN FCT##_DOMAIN _FPH1(DOMAIN)
  { 
#if !NOCHECK
    if (ref##_DOMAIN(x1)->f_len == 0) { err_tl_vdmlib(MKSTRING(DOMAIN)); }
#endif
    DELELEM(*FIRSTELEM(x1))
    x1->f_len--; x1->f_offs++; return x1;
  }

#include <tupl/larray/basic/aux>

#undef DELELEM
#undef FCT
-----
cat >$OUT_DIR/tupl/larray/tl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifndef NOCHECK
  Vdmlib	= + err_tl
#endif
-----
[ -d $OUT_DIR/tupl/larray/tld ] || mkdir $OUT_DIR/tupl/larray/tld
cat >$OUT_DIR/tupl/larray/tld/ccod <<'-----'
#define FCT tld
#define DELELEM(z1) MERGE(del,_ELEM1)(z1);
#include <tupl/larray/tl/ccod>
-----
cat >$OUT_DIR/tupl/larray/tld/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifndef NOCHECK
 Vdmlib	= + err_tl
#endif
 ELEM1	= + del
-----
[ -d $OUT_DIR/tupl/larray/write ] || mkdir $OUT_DIR/tupl/larray/write
cat >$OUT_DIR/tupl/larray/write/ccod <<'-----'
#include <tupl/larray/basic/aux>
Intg write##_DOMAIN _FPH2(Intg,DOMAIN)
  { Intg lx1 = write(x1,(char *)FIRSTELEM(x2),(x2->f_len) * sizeof(ELEM1));
    return  (lx1 < 0) ? lx1 : lx1 / sizeof(ELEM1);
  }
#include <tupl/larray/basic/aux>
-----
cat >$OUT_DIR/tupl/larray/write/docu <<'-----'
  Array implementation of write. The whole tuple is written with one
  system call.
-----
[ -d $OUT_DIR/tupl/linklist ] || mkdir $OUT_DIR/tupl/linklist
[ -d $OUT_DIR/tupl/linklist/basic ] || mkdir $OUT_DIR/tupl/linklist/basic
cat >$OUT_DIR/tupl/linklist/basic/docu <<'-----'
  Implementation of Tuples as linked lists

  space : n * (sizeof(pointer) + sizeof(ELEM1))
-----
cat >$OUT_DIR/tupl/linklist/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tupl/linklist/basic/gptr <<'-----'
#include <aux/linklist/basic/gptr>
-----
cat >$OUT_DIR/tupl/linklist/basic/gtyp <<'-----'
#define info ELEM1
#include <aux/linklist/basic/gtyp>
-----
cat >$OUT_DIR/tupl/linklist/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
NOCHECK
SAVE
-----
cat >$OUT_DIR/tupl/linklist/basic/vdm <<'-----'
#include <aux/com/heap/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/linklist/conc ] || mkdir $OUT_DIR/tupl/linklist/conc
cat >$OUT_DIR/tupl/linklist/conc/ccod <<'-----'
#include <aux/linklist/conc/ccod>
-----
cat >$OUT_DIR/tupl/linklist/conc/docu <<'-----'
  time complexity : O(n)  ( proportional to the len x1 )
-----
[ -d $OUT_DIR/tupl/linklist/copy ] || mkdir $OUT_DIR/tupl/linklist/copy
cat >$OUT_DIR/tupl/linklist/copy/ccod <<'-----'
#include <aux/linklist/copy/ccod>
-----
cat >$OUT_DIR/tupl/linklist/copy/vdm <<'-----'
#include <aux/linklist/copy/vdm>
-----
[ -d $OUT_DIR/tupl/linklist/copy1 ] || mkdir $OUT_DIR/tupl/linklist/copy1
cat >$OUT_DIR/tupl/linklist/copy1/ccod <<'-----'
#include <aux/linklist/copy1/ccod>
-----
[ -d $OUT_DIR/tupl/linklist/del1 ] || mkdir $OUT_DIR/tupl/linklist/del1
cat >$OUT_DIR/tupl/linklist/del1/ccod <<'-----'
#include <aux/linklist/del1/ccod>
-----
cat >$OUT_DIR/tupl/linklist/del1/cmcr <<'-----'
#include <aux/linklist/del1/cmcr>
-----
[ -d $OUT_DIR/tupl/linklist/fold ] || mkdir $OUT_DIR/tupl/linklist/fold
cat >$OUT_DIR/tupl/linklist/fold/ccod <<'-----'
#include <aux/linklist/fold/ccod>
-----
cat >$OUT_DIR/tupl/linklist/fold/docu <<'-----'
#define Abortval
#define Tupl tupl
  Implementation of the 'fold' functional using the 'forall' routine
#include <aux/com/fold/docu>
-----
cat >$OUT_DIR/tupl/linklist/fold/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
cat >$OUT_DIR/tupl/linklist/fold/vdm <<'-----'
#include <aux/linklist/fold/vdm>
-----
[ -d $OUT_DIR/tupl/linklist/foldix ] || mkdir $OUT_DIR/tupl/linklist/foldix
cat >$OUT_DIR/tupl/linklist/foldix/ccod <<'-----'
#include <tupl/aux/foldix/ccod>
#include <aux/linklist/fold/ccod>
-----
cat >$OUT_DIR/tupl/linklist/foldix/docu <<'-----'
#define Abortval
   Special linklist implementation of the 'foldix' functional
#include <tupl/aux/foldix/docu>
-----
cat >$OUT_DIR/tupl/linklist/foldix/param <<'-----'
ABORTVAL
CVFCT
CVFCTRES
CVFCTVAR
FCTNAME
FOLDFCT
NOSIGNATURE
NULLFCT
NULLPARAM
RESULT
X
XX
XXX
XXXX
XXXXX
Y
YY
YYY
Z
ZZ
ZZZ
-----
[ -d $OUT_DIR/tupl/linklist/forall ] || mkdir $OUT_DIR/tupl/linklist/forall
cat >$OUT_DIR/tupl/linklist/forall/ccod <<'-----'
#include <aux/linklist/forall/ccod>
-----
cat >$OUT_DIR/tupl/linklist/forall/cmcr <<'-----'
#include <aux/linklist/forall/cmcr>
-----
[ -d $OUT_DIR/tupl/linklist/is_empty ] || mkdir $OUT_DIR/tupl/linklist/is_empty
cat >$OUT_DIR/tupl/linklist/is_empty/ccod <<'-----'
#include <aux/linklist/is_empty/ccod>
-----
cat >$OUT_DIR/tupl/linklist/is_empty/cmcr <<'-----'
#include <aux/linklist/is_empty/cmcr>
-----
cat >$OUT_DIR/tupl/linklist/is_empty/docu <<'-----'
  time complexity : constant (1 pointer test)
-----
cat >$OUT_DIR/tupl/linklist/is_empty/pmcr <<'-----'
#include <aux/linklist/is_empty/pmcr>
-----
[ -d $OUT_DIR/tupl/linklist/iterator ] || mkdir $OUT_DIR/tupl/linklist/iterator
cat >$OUT_DIR/tupl/linklist/iterator/param <<'-----'
INTERNALFCT
-----
cat >$OUT_DIR/tupl/linklist/iterator/vdm <<'-----'
#define IMPL linklist
#include <aux/com/iterator/vdm>
-----
[ -d $OUT_DIR/tupl/linklist/len ] || mkdir $OUT_DIR/tupl/linklist/len
cat >$OUT_DIR/tupl/linklist/len/ccod <<'-----'
#define fct len
#include <aux/linklist/len/ccod>
-----
cat >$OUT_DIR/tupl/linklist/len/docu <<'-----'
  time complexity : O(n)
-----
[ -d $OUT_DIR/tupl/linklist/mk1 ] || mkdir $OUT_DIR/tupl/linklist/mk1
cat >$OUT_DIR/tupl/linklist/mk1/ccod <<'-----'
#include <aux/linklist/mk1/ccod>
-----
cat >$OUT_DIR/tupl/linklist/mk1/vdm <<'-----'

#define CONSTRNAME mk1
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/linklist/mk_empty ] || mkdir $OUT_DIR/tupl/linklist/mk_empty
cat >$OUT_DIR/tupl/linklist/mk_empty/ccod <<'-----'
#include <aux/linklist/mk_empty/ccod>
-----
cat >$OUT_DIR/tupl/linklist/mk_empty/cmcr <<'-----'
#include <aux/linklist/mk_empty/cmcr>
-----
cat >$OUT_DIR/tupl/linklist/mk_empty/vdm <<'-----'

#define CONSTRNAME mk_empty
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/linklist/sel ] || mkdir $OUT_DIR/tupl/linklist/sel
cat >$OUT_DIR/tupl/linklist/sel/ccod <<'-----'
ELEM1 sel##_DOMAIN _FPH2(DOMAIN,Nat1)
{
    Nat0 len = 0;

    while (x1)
	{
	    if (++len == x2)
		return ref##_DOMAIN(x1)->f_info;

	    x1=x1->f_next;
	}

    err_sel_vdmlib(x2,len,MKSTRING(DOMAIN));

    return x1->f_info; /* prevent compiler warnings */
}
-----
cat >$OUT_DIR/tupl/linklist/sel/docu <<'-----'
  time complexity : O(n) ( x2 pointer references )
-----
cat >$OUT_DIR/tupl/linklist/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_sel
-----
[ -d $OUT_DIR/tupl/readfile ] || mkdir $OUT_DIR/tupl/readfile
[ -d $OUT_DIR/tupl/readfile/appl ] || mkdir $OUT_DIR/tupl/readfile/appl
cat >$OUT_DIR/tupl/readfile/appl/ccod <<'-----'
  DOMAIN appl##_DOMAIN _FPH2(ELEM1,DOMAIN)
   { err_uop_vdmlib(MKSTRING(DOMAIN),"appl"); }
-----
cat >$OUT_DIR/tupl/readfile/appl/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/readfile/appl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/readfile/appr ] || mkdir $OUT_DIR/tupl/readfile/appr
cat >$OUT_DIR/tupl/readfile/appr/ccod <<'-----'
  DOMAIN appr##_DOMAIN _FPH2(DOMAIN,ELEM1)
   { err_uop_vdmlib(MKSTRING(DOMAIN),"appl"); }
-----
cat >$OUT_DIR/tupl/readfile/appr/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/readfile/appr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/readfile/basic ] || mkdir $OUT_DIR/tupl/readfile/basic
cat >$OUT_DIR/tupl/readfile/basic/ccod <<'-----'
#include <tupl/readfile/basic/defp>

DOMAIN read_buffer##_DOMAIN _FPH1(DOMAIN)
{
    Nat0 lx1;
    Nat0 lx2;
    Intg lx3;

    lx1 = (x1->f_elfile > BUFFSIZE) ? BUFFSIZE : x1->f_elfile;
    lx2 = lx1 * sizeof(ELEM1);
    lx3 = read((int)(x1->f_fdes),
	       (char *)(x1->f_buff),
	       lx2);

    if (lx3 != (Intg)lx2)
	{
#ifdef NOTIFYIOERR
	    notify_ioerr##_DOMAIN();
#endif
	    err_tl_vdmlib(MKSTRING(DOMAIN));
	}

    x1->f_currelem = &x1->f_buff[0];
    x1->f_buffelems = lx1;
    x1->f_elfile -= lx1;

    return x1;
}  
#undef BUFFSIZE
-----
cat >$OUT_DIR/tupl/readfile/basic/defp <<'-----'
#ifndef BUFFSIZE
#define BUFFSIZE 4096
#endif
-----
cat >$OUT_DIR/tupl/readfile/basic/docu <<'-----'
  'readfile' is an implementation of

     DOMAIN = ELEM1 *

  where ELEM1 is a simple type (i.e. not containing any pointers).
  The tuple is mapped to a file.

  Only the operations

    'fread', 'hd', 'tl', 'tld', 'len', 'is_empty', 'del' and 'del1'

  are available for objects of this type.

  This allows modelling sequential input of simple objects from
  a file using tuple operations.

  Parameters:

    "BUFFSIZE":
               Change size of output buffer. Optional
               parameter, default value is 4096.

    "NOTIFYIOERR":
               Since the file will not be read in one piece,
               I/O errors can occur during tuple operations.
               This parameter selects, how the user will be
               informed about these errors. See description
               of __SA(tl) for details.
    "MACROS":
               generate Macro operations instead of functions
               where possible.


  See also:
    __A("writefile",tupl.writefile.basic) (tuple implementation), __SA(cvfromtupl) (operation)

-----
cat >$OUT_DIR/tupl/readfile/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tupl/readfile/basic/gptr <<'-----'
   TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/tupl/readfile/basic/gtyp <<'-----'
#include <tupl/readfile/basic/defp>
  START_RECORD_TYP(Struct##_DOMAIN)
#ifdef GEN_C
			/* otherwise warnings are given : conversion between int and Intg */
                      RECFIELD(f_fdes,int);
#else
                      RECFIELD(f_fdes,Intg);
#endif
		      RECFIELD(f_elfile,Nat0); COMMENT_( #elems left in file )
		      RECFIELD(f_currelem,POINTER_TO(ELEM1));
                      RECFIELD(f_buffelems,Nat0);
#ifdef GEN_C
		      ELEM1	f_buff[BUFFSIZE];
#else
                      RECFIELD(f_buff,ARRAY[1..BUFFSIZE] OF ELEM1);
#endif
  END_RECORD_TYP(Struct##_DOMAIN) 

#ifdef GEN_C

  FUNCDEC(read_buffer##_DOMAIN,PL_1(DOMAIN),DOMAIN)

#ifdef NOTIFYIOERR
_IFNDEF notify_ioerr##_DOMAIN
  FUNCDEC(notify_ioerr##_DOMAIN,PL_0(),void)
  extern void notify_ioerr##_DOMAIN();
_ENDIF
#endif

#endif
#undef BUFFSIZE
-----
cat >$OUT_DIR/tupl/readfile/basic/param <<'-----'
BUFFSIZE
INTERNALDOMAIN
MACROS
NOCHECK
NOTIFYIOERR
-----
cat >$OUT_DIR/tupl/readfile/basic/vdm <<'-----'
#include <aux/com/heap/vdm>
DOMAINS
IMPLEMENTATIONS
  Vdmlib        = + header("ERRNO","FCNTL","UNISTD") + err_tl
#undef ALLOC

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/readfile/copy1 ] || mkdir $OUT_DIR/tupl/readfile/copy1
cat >$OUT_DIR/tupl/readfile/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN) { err_uop_vdmlib(MKSTRING(DOMAIN),"copy1"); }
-----
cat >$OUT_DIR/tupl/readfile/copy1/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/readfile/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/readfile/default ] || mkdir $OUT_DIR/tupl/readfile/default
cat >$OUT_DIR/tupl/readfile/default/docu <<'-----'
#include <aux/com/default/docu>

  For this special purpose implementation of the tuple datatype
  only the following set of operations is
  added

#include <tupl/readfile/default/vdm>
-----
cat >$OUT_DIR/tupl/readfile/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + fread
                                       ! the only constructor !
             + is_empty 
             + hd 
             + tl
             + del1
-----
[ -d $OUT_DIR/tupl/readfile/del ] || mkdir $OUT_DIR/tupl/readfile/del
cat >$OUT_DIR/tupl/readfile/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN)
    { if (ref##_DOMAIN(x1)->f_fdes != -1) { close((int)(x1->f_fdes)); }
      free##_DOMAIN(ref##_DOMAIN(x1));
    }
-----
cat >$OUT_DIR/tupl/readfile/del/docu <<'-----'
  The file will be closed and the buffer will be deleted.
-----
[ -d $OUT_DIR/tupl/readfile/del1 ] || mkdir $OUT_DIR/tupl/readfile/del1
cat >$OUT_DIR/tupl/readfile/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) 
    { if (ref##_DOMAIN(x1)->f_fdes != -1) { close((int)(x1->f_fdes)); }
      free##_DOMAIN(ref##_DOMAIN(x1));
    }
-----
cat >$OUT_DIR/tupl/readfile/del1/docu <<'-----'
  The file will be closed and the buffer will be deleted.
-----
[ -d $OUT_DIR/tupl/readfile/forall ] || mkdir $OUT_DIR/tupl/readfile/forall
cat >$OUT_DIR/tupl/readfile/forall/ccod <<'-----'
  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
   { err_uop_vdmlib(MKSTRING(DOMAIN),"forall"); }
-----
cat >$OUT_DIR/tupl/readfile/forall/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/readfile/forall/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/readfile/fread ] || mkdir $OUT_DIR/tupl/readfile/fread
cat >$OUT_DIR/tupl/readfile/fread/ccod <<'-----'
#include <tupl/readfile/basic/defp>

  DOMAIN fread##_DOMAIN _FPH1(Str)
    { DOMAIN lx1 = alloc##_DOMAIN();

      lx1->f_elfile = 0;
      lx1->f_buffelems = 0;

      { char *lx2 = (char *)ALLOCMEM_vdmlib(len_str(x1) + 5);

	cpc_str(x1,lx2);
	lx1->f_fdes = open(lx2,O_RDONLY);
        FREEMEM_vdmlib(lx2,len_str(x1) + 5);
      }

      if (lx1->f_fdes == -1) { return lx1; }

      { struct stat lx2;

	if (fstat((int)(lx1->f_fdes),&lx2) == -1) { return lx1; }

	lx1->f_elfile = lx2.st_size / sizeof(ELEM1);
      }

      lx1 = read_buffer##_DOMAIN(lx1);
      return lx1;
    }
#undef BUFFSIZE
-----
cat >$OUT_DIR/tupl/readfile/fread/docu <<'-----'
  The file given as parameter is opened and the first buffer is filled.
  If an error occurs, an empty tuple will be returned. In this case
  consult 'errno' for details. 

  Since the empty tuple stands for I/O error, an attempt to read an
  empty tuple will result in an error:
  'attempt to get tl of an empty tuple'.
-----
cat >$OUT_DIR/tupl/readfile/fread/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Str	= + cpc + len
  Vdmlib = + header("TYPES","STAT")
-----
[ -d $OUT_DIR/tupl/readfile/hd ] || mkdir $OUT_DIR/tupl/readfile/hd
cat >$OUT_DIR/tupl/readfile/hd/ccod <<'-----'
  ELEM1 hd##_DOMAIN _FPH1(DOMAIN) 
    { if (is_empty##_DOMAIN(x1)) err_hd_vdmlib(MKSTRING(DOMAIN));
      return *x1->f_currelem;
    }
-----
cat >$OUT_DIR/tupl/readfile/hd/cmcr <<'-----'
_DEFINE hd##_DOMAIN(x1) *ref##_DOMAIN(x1)->f_currelem
-----
cat >$OUT_DIR/tupl/readfile/hd/docu <<'-----'
  The macro version does not check for empty tuple!
-----
cat >$OUT_DIR/tupl/readfile/hd/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/readfile/hd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN	= + is_empty
   Vdmlib	= + err_hd
-----
[ -d $OUT_DIR/tupl/readfile/len ] || mkdir $OUT_DIR/tupl/readfile/len
cat >$OUT_DIR/tupl/readfile/len/ccod <<'-----'
  Nat0 len##_DOMAIN _FPH1(DOMAIN)
    { return ref##_DOMAIN(x1)->f_buffelems + ref##_DOMAIN(x1)->f_elfile; }
-----
cat >$OUT_DIR/tupl/readfile/len/params <<'-----'
MACROS
-----
[ -d $OUT_DIR/tupl/readfile/mk_empty ] || mkdir $OUT_DIR/tupl/readfile/mk_empty
cat >$OUT_DIR/tupl/readfile/mk_empty/ccod <<'-----'
  DOMAIN mk_empty##_DOMAIN _FPH0() { err_uop_vdmlib(MKSTRING(DOMAIN),"mk_empty"); }
-----
cat >$OUT_DIR/tupl/readfile/mk_empty/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/readfile/mk_empty/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop

#define CONSTRNAME mk_empty
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/readfile/sel ] || mkdir $OUT_DIR/tupl/readfile/sel
cat >$OUT_DIR/tupl/readfile/sel/ccod <<'-----'
ELEM1 sel##_DOMAIN _FPH2(DOMAIN,Nat1) { err_uop_vdmlib(MKSTRING(DOMAIN),"sel"); }
-----
cat >$OUT_DIR/tupl/readfile/sel/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/readfile/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/readfile/tl ] || mkdir $OUT_DIR/tupl/readfile/tl
cat >$OUT_DIR/tupl/readfile/tl/ccod <<'-----'
#ifndef OP
#define OP tl
#endif

  DOMAIN OP##_DOMAIN _FPH1(DOMAIN)
    { if (is_empty##_DOMAIN(x1)) err_tl_vdmlib(MKSTRING(DOMAIN));
      return (ref##_DOMAIN(x1)->f_currelem++, (--(x1->f_buffelems) == 0) ? read_buffer##_DOMAIN(x1) : x1); }

#undef OP
-----
cat >$OUT_DIR/tupl/readfile/tl/cmcr <<'-----'
#ifndef OP
#define OP tl
#endif

_DEFINE OP##_DOMAIN(x1) (ref##_DOMAIN(x1)->f_currelem++, (--((x1)->f_buffelems) == 0) ? read_buffer##_DOMAIN(x1) : x1)

#undef OP
-----
cat >$OUT_DIR/tupl/readfile/tl/docu <<'-----'
  If an I/O error occurs upon reading the next buffer, an error
  ('apply "tl" upon empty typle') occurs. If the parameter NOTIFYIOERR
  is set for the implentation, the (user defined) routine notify_ioerr##_DOMAIN()
  will be called before to allow user defined handling of I/O errors.

  The macro version does not check for empty tuple!
-----
cat >$OUT_DIR/tupl/readfile/tl/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/readfile/tl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN	= + is_empty
   Vdmlib	= + err_tl
-----
[ -d $OUT_DIR/tupl/readfile/tld ] || mkdir $OUT_DIR/tupl/readfile/tld
cat >$OUT_DIR/tupl/readfile/tld/ccod <<'-----'
#define OP tld
#include <tupl/readfile/tl/ccod>
-----
cat >$OUT_DIR/tupl/readfile/tld/cmcr <<'-----'
#define OP tld
#include <tupl/readfile/tl/cmcr>
-----
cat >$OUT_DIR/tupl/readfile/tld/docu <<'-----'
  If an I/O error occurs upon reading the next buffer, an error
  ('apply "tld" upon empty typle') occurs. If the parameter NOTIFYIOERR
  is set, the (user defined) routine notify_ioerr##_DOMAIN() will
  be called before to allow user defined handling of I/O errors.
   
  The macro version does not check for empty tuple!
-----
cat >$OUT_DIR/tupl/readfile/tld/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/readfile/tld/vdm <<'-----'
#include <tupl/readfile/tl/vdm>
-----
[ -d $OUT_DIR/tupl/sign ] || mkdir $OUT_DIR/tupl/sign
[ -d $OUT_DIR/tupl/sign/all ] || mkdir $OUT_DIR/tupl/sign/all
cat >$OUT_DIR/tupl/sign/all/vsig <<'-----'
#include <aux/sign/all/vsig>
-----
[ -d $OUT_DIR/tupl/sign/appl ] || mkdir $OUT_DIR/tupl/sign/appl
cat >$OUT_DIR/tupl/sign/appl/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 Cpp_DOMAIN &
InlineFriendFct(appl,SPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(appl,SPARLIST2))
#ifdef OPERATOR
#if defined(BASEIMPL)
InlineAllwaysFriendFct(operator +,KPAR2(T1,T2),Cpp_DOMAIN )
RUMPF({Cpp_DOMAIN tmp = x2; tmp.data = appl##_DOMAIN(x1.data, tmp.data); return tmp;})
#else
InlineAllwaysFriendFct(operator +,KPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF({ x2.data = appl##_DOMAIN KPARLIST2; return x2;})
#endif
#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/appl/gsig <<'-----'
  FUNCDEC(appl##_DOMAIN,PL_2(ELEM1,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/appl/vsig <<'-----'
  appl(x1,x2) = <x1> & x2
  TYPE : ELEM1  DOMAIN  -->  DOMAIN

  x1 is inserted at the head of x2
  x2 is destroyed
-----
[ -d $OUT_DIR/tupl/sign/appr ] || mkdir $OUT_DIR/tupl/sign/appr
cat >$OUT_DIR/tupl/sign/appr/cpp <<'-----'
#define T1 Cpp_DOMAIN &
#define T2 const Cpp_ELEM1 &

InlineFriendFct(appr,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(appr,FPARLIST2))

#ifdef OPERATOR

#if defined(BASEIMPL)

InlineFriendFct(operator +=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(appr,FPARLIST2))

InlineFriendConstFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN )
RUMPF(BODY6(appr))

#else

InlineFriendFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(appr,FPARLIST2))

InlineFriendFct(operator +=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(appr,FPARLIST2))
#endif

#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/appr/gsig <<'-----'
  FUNCDEC(appr##_DOMAIN,PL_2(DOMAIN,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/appr/vsig <<'-----'
  appr(x1,x2) = x1 & <x2>
  TYPE : DOMAIN  ELEM1  -->  DOMAIN

  x2 is appended at the end of x1
  x1 is destroyed
-----
[ -d $OUT_DIR/tupl/sign/basic ] || mkdir $OUT_DIR/tupl/sign/basic
cat >$OUT_DIR/tupl/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN {
public:
  DOMAIN data;
  /* 
     === the macro BASEIMPL is defined only if automatic memory management is ===
     === selected and the tuple implementation is not readfile or writefile   === 
     */
#if defined(BASEIMPL)
  Cpp_DOMAIN()
  {
    data = 0;
    CA == non valid handle CE
  }

  ~Cpp_DOMAIN() { del##_DOMAIN(data); }

  Cpp_DOMAIN(const Cpp_DOMAIN & x1)
  {
    check_handle##_DOMAIN(x1.data);
    data = x1.data;
    data->f_rc++;
  }

  Cpp_DOMAIN(const DOMAIN &x1)
  {
    check_handle##_DOMAIN(x1);
    data = x1;
    /* die folgende Zeile ist falsch
       das incrementieren muss in der C funktion gemacht werde
       wird es auch fast immer, nur nicht bei Iteratoren
       bleibt diese Zeile drin, wird nicht alles freigegeben,
       es laeuft aber erst einmal
       */
    /* data->f_rc++; iteratoren geaendert */
  }

  Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1)
  { 
    check_handle##_DOMAIN(x1.data);
    (x1.data)->f_rc++;
    if (data!=0) del##_DOMAIN(data);
    data = x1.data;
    return *this;
  }

  /* for moving a C++ object into a C data structure, e.g. a union */
  /* conversion back to C++ is done implicitly by Constuctor Cpp_DOMAIN(const DOMAIN & x1) */
  /* use count is incremented to prevent deletion by destructors */

  DOMAIN cv##_DOMAIN() const
  {
    check_handle##_DOMAIN(data);
    data->f_rc++;
    return data;
  }

#elif defined(RW_FILE_AUTO)
  /* === the macro RW_FILE_AUTO will only be defined if automatic memory ===
     === management is selected and the tuple implementation is readfile ===
     === or writefile === 
     */

private:
  Cpp_DOMAIN & operator = (const Cpp_DOMAIN & x1) {} 
  Cpp_DOMAIN(const Cpp_DOMAIN & x1);

public:
  Cpp_DOMAIN(const DOMAIN &x1) { data = x1;}
  ~Cpp_DOMAIN()
  { 
    /* data will be 0, if tuple has already been deleted by an
       cvfromtupl-Operation ! */
    if (data!=0) del##_DOMAIN(data);
  }

#else
  Cpp_DOMAIN            ()                      {                               }
  Cpp_DOMAIN            (const     DOMAIN & x1) { data = x1;                    }
  Cpp_DOMAIN            (const Cpp_DOMAIN & x1) { data = x1.data;               }
  Cpp_DOMAIN & operator=(const Cpp_DOMAIN & x1) { data = x1.data; return *this; }

  /* access function for data field for conversion between C++ and C */
  DOMAIN       cv##_DOMAIN() const              { return data;                  }
#endif
#endif
-----
cat >$OUT_DIR/tupl/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
[ -d $OUT_DIR/tupl/sign/binary ] || mkdir $OUT_DIR/tupl/sign/binary
cat >$OUT_DIR/tupl/sign/binary/gsig <<'-----'
#include <aux/sign/binary/gsig>
-----
cat >$OUT_DIR/tupl/sign/binary/vsig <<'-----'
  binary(x1) =
   let fct(y1,y2) = if y2 = <>
                    then y1
                    else let elem = hd y2 in
                      fct(x1(y1,elem),tl y2)
   in fct
  TYPE : (Result  ELEM1   -->  Result)
         -->
         (Result  DOMAIN  -->  Result)

  __EM(binary) is a functional (a function returning another function as result).
  With help of this functional binary functions on Result and ELEM1 can be
  generalized to functions of DOMAIN to Result.
  An important case is Result = DOMAIN. This leads to the examples
  described below. The general case is usefull for inventing conversions.

  __EM(binary) is evaluated at module generation time.

  Example : concatenation of 2 tuples

  given the function :

     appr(y1,y2) = y1 & <y2>
     TYPE : DOMAIN  ELEM1  -->  DOMAIN

  the concatenation function conc can be constructed by:

     conc(x1,x2) = binary(appr)(x1,x2)
     TYPE : DOMAIN  DOMAIN  -->  DOMAIN

-----
[ -d $OUT_DIR/tupl/sign/conc ] || mkdir $OUT_DIR/tupl/sign/conc
cat >$OUT_DIR/tupl/sign/conc/cpp <<'-----'
#if defined(BASEIMPL)
#define T2 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN &
#endif
 
#define T1 Cpp_DOMAIN &

InlineFriendFct(conc,FPAR2(T1,T2),Cpp_DOMAIN &)
#if !defined(ISSTRING)
RUMPF(BODY2(conc,FPARLIST2))
#else
RUMPF(BODY2(conc_auto,FPARLIST2))
#endif

#ifdef OPERATOR

#if defined(BASEIMPL)

InlineFriendFct(operator +=,FPAR2(T1,T2),Cpp_DOMAIN &)
#if !defined(ISSTRING)
RUMPF(BODY2(conc,FPARLIST2))
#else
RUMPF(BODY2(conc_auto,FPARLIST2))
#endif

InlineFriendConstFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN )
#if !defined(ISSTRING)
RUMPF(BODY6(conc))
#else
RUMPF(BODY6(conc_auto))
#endif

#else

InlineFriendFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(conc,FPARLIST2))

InlineFriendFct(operator +=,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(conc,FPARLIST2))

#endif

#endif

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/conc/gsig <<'-----'
  FUNCDEC(conc##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
#if defined(BASEIMPL) && defined(ISSTRING) 
  FUNCDEC(conc_auto##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
#endif 
-----
cat >$OUT_DIR/tupl/sign/conc/vsig <<'-----'
  conc(x1,x2) = x1 & x2
  TYPE : DOMAIN DOMAIN  -->  DOMAIN

  Concatenation of x1,x2. The parameters are destroyed.

  See also:
    __SA(concc), __SA(conc3), __SA(conc4), __SA(conc5), __SA(conc6).
-----
[ -d $OUT_DIR/tupl/sign/conc3 ] || mkdir $OUT_DIR/tupl/sign/conc3
cat >$OUT_DIR/tupl/sign/conc3/gsig <<'-----'
  FUNCDEC(conc3##_DOMAIN,PL_3(DOMAIN,DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/conc3/vsig <<'-----'
  conc3(x1,x2,x3) = x1 & x2 & x3
  TYPE : DOMAIN DOMAIN  DOMAIN  -->  DOMAIN

  Concatenation of three tuples. The parameters are destroyed.

  See also:
    __SA(conc), __SA(concc), __SA(conc4), __SA(conc5), __SA(conc6).
-----
[ -d $OUT_DIR/tupl/sign/conc4 ] || mkdir $OUT_DIR/tupl/sign/conc4
cat >$OUT_DIR/tupl/sign/conc4/gsig <<'-----'
  FUNCDEC(conc4##_DOMAIN,PL_4(DOMAIN,DOMAIN,DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/conc4/vsig <<'-----'
  conc4(x1,x2,x3,x4) = x1 & x2 & x3 & x4
  TYPE : DOMAIN DOMAIN DOMAIN DOMAIN  -->  DOMAIN

  Concatenation of four tuples. The parameters are destroyed.

  See also:
    __SA(conc), __SA(concc), __SA(conc3), __SA(conc5), __SA(conc6).
-----
[ -d $OUT_DIR/tupl/sign/conc5 ] || mkdir $OUT_DIR/tupl/sign/conc5
cat >$OUT_DIR/tupl/sign/conc5/gsig <<'-----'
  FUNCDEC(conc5##_DOMAIN,PL_5(DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/conc5/vsig <<'-----'
  conc5(x1,x2,x3,x4,x5) = x1 & x2 & x3 & x4 & x5
  TYPE : DOMAIN DOMAIN DOMAIN DOMAIN DOMAIN  -->  DOMAIN

  Concatenation of five tuples. The parameters are destroyed.

  See also:
    __SA(conc), __SA(concc), __SA(conc3), __SA(conc4), __SA(conc6).
-----
[ -d $OUT_DIR/tupl/sign/conc6 ] || mkdir $OUT_DIR/tupl/sign/conc6
cat >$OUT_DIR/tupl/sign/conc6/gsig <<'-----'
  FUNCDEC(conc6##_DOMAIN,PL_6(DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/conc6/vsig <<'-----'
  conc6(x1,x2,x3,x4,x5,x6) = x1 & x2 & x3 & x4 & x5 & x6
  TYPE : DOMAIN DOMAIN DOMAIN DOMAIN DOMAIN DOMAIN  -->  DOMAIN

  Concatenation of six tuples. The parameters are destroyed.

  See also:
    __SA(conc), __SA(concc), __SA(conc3), __SA(conc4), __SA(conc5).
-----
[ -d $OUT_DIR/tupl/sign/conc_path ] || mkdir $OUT_DIR/tupl/sign/conc_path
cat >$OUT_DIR/tupl/sign/conc_path/cpp <<'-----'

#define T1 Cpp_DOMAIN & 

#ifdef BASEIMPL
#define T2 const Cpp_DOMAIN &
#else
#define T2 Cpp_DOMAIN &
#endif

InlineFriendFct(conc_path,FPAR2(T1,T2),Cpp_DOMAIN &)

#if !defined(ISSTRING)
RUMPF(BODY2(conc_path,FPARLIST2))
#else
RUMPF(BODY2(conc_path_auto,FPARLIST2))
#endif 

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/conc_path/gsig <<'-----'
  FUNCDEC(conc_path##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
#if defined(BASEIMPL) && defined(ISSTRING)
  FUNCDEC(conc_path_auto##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
#endif
-----
cat >$OUT_DIR/tupl/sign/conc_path/vsig <<'-----'
  conc_path(x1,x2) = x1 & <path_delimiter> & x2
  TYPE : DOMAIN  DOMAIN  -->  DOMAIN

  construction of a path name used for file system access
  default path delimiter is / for DOS \
  x1 and x2 are destroied like in a normal conc operation
-----
[ -d $OUT_DIR/tupl/sign/concc ] || mkdir $OUT_DIR/tupl/sign/concc
cat >$OUT_DIR/tupl/sign/concc/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'concc' not supported for automem)
#else

#define T2 Cpp_DOMAIN & 
#define T1 Cpp_DOMAIN &
InlineFriendFct(conc,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(concc,FPARLIST2))
#ifdef OPERATOR
InlineFriendFct(operator +,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(concc,FPARLIST2))
#endif
#undef T1
#undef T2

#endif
-----
cat >$OUT_DIR/tupl/sign/concc/gsig <<'-----'
  FUNCDEC(concc##_DOMAIN,PL_2(DOMAIN,DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/concc/vsig <<'-----'
  concc(x1,x2) = x1 & x2
  TYPE : DOMAIN DOMAIN  -->  DOMAIN

  Concatenation of x1,x2.
  The parameter x1 is destroyed.
  The parameter x2 is not changed

  See also:
    __SA(conc), __SA(conc3), __SA(conc4), __SA(conc5), __SA(conc6).
-----
[ -d $OUT_DIR/tupl/sign/cpc ] || mkdir $OUT_DIR/tupl/sign/cpc
cat >$OUT_DIR/tupl/sign/cpc/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 char *
InlineFriendConstFct(cpc,FPAR2(T1,T2),void)
RUMPF(BODY3(cpc,(DATA,x2)))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/cpc/gsig <<'-----'
  PROCDEC(cpc##_DOMAIN,PL_VR(DOMAIN,ELEM1))
-----
cat >$OUT_DIR/tupl/sign/cpc/vsig <<'-----'
  cpc(x1,x2) = 
  TYPE : DOMAIN  ptr to ELEM1  -->

  Conversion to C strings
  __EM(cpc) moves the elements of the tuple value x1 into the area pointed at
  by x2. A 0 element is appended at the end of x2.
-----
[ -d $OUT_DIR/tupl/sign/elems ] || mkdir $OUT_DIR/tupl/sign/elems
cat >$OUT_DIR/tupl/sign/elems/cpp <<'-----'
#include <tupl/com/elems/defs>
InlineFriendConstFct(elems,FPAR1(const Cpp_DOMAIN &),Cpp_RESULT)
RUMPF(BODY1(Cpp_RESULT,elems,FPARLIST1))

-----
cat >$OUT_DIR/tupl/sign/elems/gsig <<'-----'
#include <tupl/com/elems/defs>

#ifndef GEN_DOCU
#ifdef COPY
  _DEFINE elems##_DOMAIN##_ELEM1(x1) mk_one##_RESULT(copy##_ELEM1(x1))
#else
  _DEFINE elems##_DOMAIN##_ELEM1(x1) mk_one##_RESULT(x1)
#endif
#endif

  FUNCDEC(elems##_DOMAIN,PL_1(DOMAIN),RESULT)

  _DEFINE ran##_DOMAIN elems##_DOMAIN
-----
cat >$OUT_DIR/tupl/sign/elems/vsig <<'-----'
  elems(x1) = elems x1
  TYPE : DOMAIN  -->  RESULT

  The elements occuring in the tuple x1 are collected in a set,

  Supposed ELEM1 is the element domain,
  then RESULT must be an ELEM1 -set.
 
  As a synonym, the operation may be called under the name
  __SA(ran) instead.
-----
[ -d $OUT_DIR/tupl/sign/exist ] || mkdir $OUT_DIR/tupl/sign/exist
cat >$OUT_DIR/tupl/sign/exist/vsig <<'-----'
#include <aux/sign/exist/vsig>
-----
[ -d $OUT_DIR/tupl/sign/exist1 ] || mkdir $OUT_DIR/tupl/sign/exist1
cat >$OUT_DIR/tupl/sign/exist1/gsig <<'-----'
#include <aux/sign/exist1/gsig>
-----
cat >$OUT_DIR/tupl/sign/exist1/vsig <<'-----'
#include <aux/sign/exist1/vsig>
-----
[ -d $OUT_DIR/tupl/sign/extract ] || mkdir $OUT_DIR/tupl/sign/extract
cat >$OUT_DIR/tupl/sign/extract/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_INDEXSET &

InlineFriendConstFct(extract,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,extract,FPARLIST2))

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/extract/gsig <<'-----'
#include <tupl/com/extract/defs>
#ifndef GEN_DOCU
  _DEFINE extract1##_DOMAIN##_ELEM1(x1,x2,x3) ((is_in##_INDEXSET(x2,x3)) ? mk_one##_DOMAIN(copy##_ELEM1(x1)) : mk_empty##_DOMAIN())
#endif

  FUNCDEC(extract##_DOMAIN,PL_2(DOMAIN,INDEXSET),DOMAIN)
  _DEFINE extractr##_DOMAIN(x1,x2) extract##_DOMAIN(x1,x2)
-----
cat >$OUT_DIR/tupl/sign/extract/vsig <<'-----'
  extract(x1,x2) = <x1(i) | i e x2>
  TYPE : DOMAIN Nat1-set  -->  DOMAIN

  Extract those elements from a given tuple x1 which are contained
  in the index-subset x2. The elements are copied when extracted
  from the tuple, therefore x1 will be left unchanged.
  A synonym is defined under the name __SA(extractr) with the parameter
  list beeing swapped:

    extractr(x1,x2) = extract(x1,x2)
    
-----
[ -d $OUT_DIR/tupl/sign/fapp ] || mkdir $OUT_DIR/tupl/sign/fapp
cat >$OUT_DIR/tupl/sign/fapp/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_STR &
InlineFriendFct(fapp,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,fapp,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/fapp/gsig <<'-----'
  FUNCDEC(fapp##_DOMAIN,PL_2(DOMAIN,Str),Bool)
-----
cat >$OUT_DIR/tupl/sign/fapp/vsig <<'-----'
  fapp(x1,x2) =
  TYPE : DOMAIN  Str  ==>  Bool

  appends a tuple x1 to a file, the file name is given by x2
  it is assumed that the elements of the tuple domain are
  simple unstructured values (no pointers)

  the string x1 is a read only parameter
  the file is writen with the fopen, fwrite and fclose C library calls

  if an error occours in the file operations false is returned
  else true is returned
-----
[ -d $OUT_DIR/tupl/sign/filter ] || mkdir $OUT_DIR/tupl/sign/filter
cat >$OUT_DIR/tupl/sign/filter/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_ELEMSET &

InlineFriendConstFct(filter,FPAR2(T1,T2),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,filter,FPARLIST2))

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/filter/gsig <<'-----'
#include <tupl/com/filter/defs>

#ifndef GEN_DOCU
  _DEFINE filter1##_DOMAIN##_ELEM1(x1,x2) (is_in##_ELEMSET(x1,x2)) ? mk_one##_DOMAIN(copy##_ELEM1(x1)) : mk_empty##_DOMAIN()
#endif

  FUNCDEC(filter##_DOMAIN,PL_2(DOMAIN,ELEMSET),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/filter/vsig <<'-----'
  filter(x1,x2) = <x1(i) | x1(i) e x2>
  TYPE : DOMAIN ELEM1-set  -->  DOMAIN

  Extract those elements from a given tuple x1 which are
  in the element set x2. The elements will be copied when 
  extracted from the tuple, therefore x1 will be left unchanged.
-----
[ -d $OUT_DIR/tupl/sign/fold ] || mkdir $OUT_DIR/tupl/sign/fold
cat >$OUT_DIR/tupl/sign/fold/gsig <<'-----'
#include <aux/sign/fold/gsig>
-----
cat >$OUT_DIR/tupl/sign/fold/vsig <<'-----'
  fold(x1,x2,x3)(y1,a1,...,an) =
   let fct(z1) = if z1 = <>
                 then x2
                 else let first & <last> = z1 in
                      x3(fct(first)
                        ,x1 (last,a1,...,ak)
                        ,al,...,an
                        )
   in fct(y1)
  TYPE : (ELEM1         T1 ... Tk  -->  RESULT)
         (                         -->  RESULT)
         (RESULT RESULT Tl ... Tn  -->  RESULT)
         -->
         (DOMAIN        T1 ... Tn  -->  RESULT)

  __EM(fold) is a functional (a function returning another function as result).
  With help of this functional functions on the type DOMAIN can be defined
  by means of functions defined on the element type ELEM1.
  Fold returns a function from DOMAIN to RESULT.

  Usually, fold is partly evaluated at module generation time.
  The parameters a1 .. an are usefull to pass global information
  into the fold- or conversion functions. They are optional and
  can be generated in any combination.

  Example : computation of the length of a tuple

  Given the functions :

     one(y1) = 1
     TYPE : ELEM1  -->  Nat0

     zero()  = 0
     TYPE :  --> Nat0

     plus(y1,y2) = y1 + y2
     TYPE : Nat0  Nat0  -->  Nat0

  the len function can be constructed by:

     len(x1) = fold(one,zero,plus)(x1)
     TYPE : DOMAIN  -->  Nat0
-----
[ -d $OUT_DIR/tupl/sign/foldix ] || mkdir $OUT_DIR/tupl/sign/foldix
cat >$OUT_DIR/tupl/sign/foldix/gsig <<'-----'
#include <tupl/aux/foldix/ccod>
#include <aux/sign/fold/gsig>
-----
cat >$OUT_DIR/tupl/sign/foldix/vsig <<'-----'
  foldix(x1,x2,x3)(y1,a1,...,an) =
   let fct(z1,i) =
       if z1 = <>
          then x2
          else let first & <last> = z1
                in x3( fct(first,i + 1)
                     , x1 (last,i,a1,...,ak)
                     ,al,...,an
                     )
   in fct(y1,1)
  TYPE : (ELEM1 Nat0    T1 ... Tk  -->  RESULT)
         (                         -->  RESULT)
         (RESULT RESULT Tl ... Tn  -->  RESULT)
         -->
         (DOMAIN        T1 ... Tn  -->  RESULT)

  __EM(foldix) is a functional (a function returning another function as result).
  The semantics is similar to the __SA(fold) functional. The only difference is
  that the conversion function (x1 above) gets the element index as second
  parameter. It therefore has the type (ELEM1  Nat0  -->  RESULT) instead of
  (ELEM1  -->  RESULT). This allows operations depending on the element index
  (i.e. process every second element only, etc.).
-----
[ -d $OUT_DIR/tupl/sign/forall ] || mkdir $OUT_DIR/tupl/sign/forall
cat >$OUT_DIR/tupl/sign/forall/cpp.old <<'-----'
#ifndef DECL
class cv_forall##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
public:
  cv_forall##_DOMAIN(void (*x1) (Cpp_ELEM1))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
};
void (*cv_forall##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1)
InlineFriendConstFct(forall,PPAR2(T1,X2),void)
RUMPF(
{ cv_forall##_DOMAIN tmp(x2);
  forall##_DOMAIN(DATA, cv_forall##_DOMAIN::cv_1);
  tmp.reset();})
#undef T1
#undef X2
-----
cat >$OUT_DIR/tupl/sign/forall/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forall##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern void forall##_DOMAIN P_OP DOMAIN x1, T2_forall##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/tupl/sign/forall/vsig <<'-----'
  forall(x1,x2) = for i in x1 do x2(i)
  TYPE : DOMAIN  ( ELEM1  -->  )  --> 

  in sequential order for all elements in tuple x1 procedure x2 is executed
-----
[ -d $OUT_DIR/tupl/sign/forindex ] || mkdir $OUT_DIR/tupl/sign/forindex
cat >$OUT_DIR/tupl/sign/forindex/cpp.old <<'-----'
#ifndef DECL
class cv_forindex##_DOMAIN {
  void (*data1) (Cpp_ELEM1,Cpp_NAT1);
  static void (*ptr1) (Cpp_ELEM1,Cpp_NAT1);
public:
  cv_forindex##_DOMAIN(void (*x1) (Cpp_ELEM1,Cpp_NAT1))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1,Nat1 x2)
   { (*ptr1) (x1,x2);}
};
void (*cv_forindex##_DOMAIN::ptr1) (Cpp_ELEM1,Cpp_NAT1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1,Cpp_NAT1)
InlineFriendConstFct(forindex,PPAR2(T1,X2),void)
RUMPF({ cv_forindex##_DOMAIN tmp(x2);
  forindex##_DOMAIN(DATA, cv_forindex##_DOMAIN::cv_1);
  tmp.reset();})
#undef T1
#undef X2
-----
cat >$OUT_DIR/tupl/sign/forindex/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forindex##_DOMAIN) P_OP ELEM1 y1, Nat1 y2 P_CL ;
  extern void forindex##_DOMAIN P_OP DOMAIN x1, T2_forindex##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/tupl/sign/forindex/vsig <<'-----'
  forindex(x1,x2) = for i e ind x1 do x2(x1(i),i)
  TYPE : DOMAIN  ( ELEM1  Nat1  -->  )  --> 

  for all elements in tuple x1
  procedure x2 is executed,
  x2 has as extra parameter y2 the index of y1
-----
[ -d $OUT_DIR/tupl/sign/forrange ] || mkdir $OUT_DIR/tupl/sign/forrange
cat >$OUT_DIR/tupl/sign/forrange/cpp.old <<'-----'
#ifndef DECL
class cv_forrange##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
public:
  cv_forrange##_DOMAIN(void (*x1) (Cpp_ELEM1))
   { data1 = ptr1; ptr1 = x1; }
  void reset()
   { ptr1 = data1;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
};
void (*cv_forrange##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 void (*x2) (Cpp_ELEM1)
#define T3 const Cpp_NAT1 &
#define T4 const Cpp_NAT0 &
InlineFriendConstFct(forrange,PPAR4(T1,X2,T3,T4),void)
RUMPF({ cv_forrange##_DOMAIN tmp(x2);
  forrange##_DOMAIN(DATA, cv_forrange##_DOMAIN::cv_1,x3.data, x4.data);
  tmp.reset();})
#undef T1
#undef X2
#undef T3
#undef T4
-----
cat >$OUT_DIR/tupl/sign/forrange/gsig <<'-----'
#ifdef GEN_C
  typedef void (* T2_forrange##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern void forrange##_DOMAIN P_OP DOMAIN x1, T2_forrange##_DOMAIN x2, Nat1 x3, Nat0 x4 P_CL ;
#endif
-----
cat >$OUT_DIR/tupl/sign/forrange/vsig <<'-----'
  forrange(x1,x2,x3,x4) = for i e (ind x1 n {x3..x4}) do x2(x1(i))
  TYPE : DOMAIN  ( ELEM1  -->  )  Nat1  Nat0  -->

  for all elements in tuple x1 in the range x3 to x4
  procedure x2 is executed
-----
[ -d $OUT_DIR/tupl/sign/forsome ] || mkdir $OUT_DIR/tupl/sign/forsome
cat >$OUT_DIR/tupl/sign/forsome/cpp.old <<'-----'
#ifndef DECL
class cv_forsome##_DOMAIN {
  void (*data1) (Cpp_ELEM1);
  Cpp_BOOL (*data2) (Cpp_ELEM1);
  static void (*ptr1) (Cpp_ELEM1);
  static Cpp_BOOL (*ptr2) (Cpp_ELEM1);
public:
  cv_forsome##_DOMAIN(void (*x1) (Cpp_ELEM1), Cpp_BOOL (*x2) (Cpp_ELEM1))
   { data1 = ptr1; data2 = ptr2; ptr1 = x1; ptr2 = x2; }
  void reset()
   { ptr1 = data1; ptr2 = data2;}
  static void cv_1(ELEM1 x1)
   { (*ptr1) (x1);}
  static Bool cv_2(ELEM1 x1)
   { return ((*ptr2) (x1)).data;}
};
void (*cv_forsome##_DOMAIN::ptr1) (Cpp_ELEM1) = 0;
Cpp_BOOL (*cv_forsome##_DOMAIN::ptr2) (Cpp_ELEM1) = 0;
#endif
#define T1 const Cpp_DOMAIN &
#define X2 Cpp_BOOL (*x2) (Cpp_ELEM1)
#define X3 void (*x3) (Cpp_ELEM1)
InlineFriendConstFct(forsome,PPAR3(T1,X2,X3),void)
RUMPF({ cv_forsome##_DOMAIN tmp(x3,x2);
  forsome##_DOMAIN(DATA,cv_forsome##_DOMAIN::cv_2, cv_forsome##_DOMAIN::cv_1);
  tmp.reset();})
#undef T1
#undef X2
#undef X3
-----
cat >$OUT_DIR/tupl/sign/forsome/gsig <<'-----'
#ifdef GEN_C
  typedef Bool (* T2_forsome##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  typedef void (* T3_forsome##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern void forsome##_DOMAIN P_OP DOMAIN x1, T2_forsome##_DOMAIN x2, T3_forsome##_DOMAIN x3 P_CL ;
#endif
-----
cat >$OUT_DIR/tupl/sign/forsome/vsig <<'-----'
  forsome(x1,x2,x3) = for i e ind x1 do 
                       if x2(x1(i))
                       then x3(x1(i))
                       else
  TYPE : DOMAIN  ( ELEM1  -->  Bool ) ( ELEM1  -->  )  -->

  for those elements in tuple x1
  for which the predicate x2 holds 
  procedure x3 is executed
-----
[ -d $OUT_DIR/tupl/sign/fread ] || mkdir $OUT_DIR/tupl/sign/fread
cat >$OUT_DIR/tupl/sign/fread/cpp <<'-----'
#if 0
#define T1 const Cpp_FREAD &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(fread,(x1.data)))
#undef T1 
#endif

InlineNoFriendFct(fread,KPAR1(const Cpp_STR &),Cpp_DOMAIN &)
#if !defined(BASEIMPL)
RUMPF(BODY2(fread,(x1.data)))
#else
RUMPF({MERGE(del,_DOMAIN)(data);
       BODY2(fread,(x1.data))
      }
     )
#endif
-----
cat >$OUT_DIR/tupl/sign/fread/gsig <<'-----'
  FUNCDEC(fread##_DOMAIN,PL_1(Str),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/fread/vsig <<'-----'
  fread(x1) =
  TYPE : Str  -->  DOMAIN

  reads a tuple from a file, the file name is given by x1
  the whole file is read and a tuple is constructed
  it is assumed that the elements of the tuple domain are
  simple unstructured values (no pointers)

  the string x1 is a read only parameter
  the file is read with the fopen, fread and fclose C library calls
  if an error occours in the file operations the empty tuple is returned
-----
[ -d $OUT_DIR/tupl/sign/front ] || mkdir $OUT_DIR/tupl/sign/front
cat >$OUT_DIR/tupl/sign/front/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendFct(front,FPAR1(T1),Cpp_DOMAIN &)
RUMPF(BODY2(front,FPARLIST1))
#undef T1

-----
cat >$OUT_DIR/tupl/sign/front/gsig <<'-----'
  FUNCDEC(front##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/front/vsig <<'-----'
  front(x1) = <x1(i) | 1 <= i < len(x1) >
  TYPE : DOMAIN  -->  DOMAIN
  PRE  : ~ (x1 = <>)

  The last element from the tuple is removed
  but its is not implicitly deleted (as with __SA(frontd))
-----
[ -d $OUT_DIR/tupl/sign/frontd ] || mkdir $OUT_DIR/tupl/sign/frontd
cat >$OUT_DIR/tupl/sign/frontd/cpp <<'-----'
#if !defined(BASEIMPL)

#define T1 const Cpp_DOMAIN &
InlineFriendFct(frontd,FPAR1(T1),Cpp_DOMAIN &)
RUMPF(BODY2(frontd,FPARLIST1))
#undef T1

#else
   CA === tupl/tld not supported for automem implementation === CE
#endif

-----
cat >$OUT_DIR/tupl/sign/frontd/gsig <<'-----'
  FUNCDEC(frontd##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/frontd/vsig <<'-----'
  frontd(x1) = <x1(i) | 1 <= i < len(x1) >
  TYPE : DOMAIN  -->  DOMAIN
  PRE  : ~ (x1 = <>)


  The last element from the tuple is removed and will be deleted.

  for C++ automem implementation this function is
  not required, __SA(front) does all the storage management.
-----
[ -d $OUT_DIR/tupl/sign/fwrite ] || mkdir $OUT_DIR/tupl/sign/fwrite
cat >$OUT_DIR/tupl/sign/fwrite/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_STR &
InlineFriendConstFct(fwrite,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,fwrite,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/fwrite/gsig <<'-----'
  FUNCDEC(fwrite##_DOMAIN,PL_2(DOMAIN,Str),Bool)
-----
cat >$OUT_DIR/tupl/sign/fwrite/vsig <<'-----'
  fwrite(x1,x2) =
  TYPE : DOMAIN  Str  ==>  Bool

  writes a tuple x1 to a file, the file name is given by x2
  it is assumed that the elements of the tuple domain are
  simple unstructured values (no pointers)

  the string x1 is a read only parameter
  the file is writen with the fopen, fwrite and fclose C library calls
  if an error occours in the file operations false is returned
  else true is returned
-----
[ -d $OUT_DIR/tupl/sign/hd ] || mkdir $OUT_DIR/tupl/sign/hd
cat >$OUT_DIR/tupl/sign/hd/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(hd,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,hd,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/tupl/sign/hd/gsig <<'-----'
  FUNCDEC(hd##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/tupl/sign/hd/vsig <<'-----'
  hd(x1) = hd x1
  TYPE : DOMAIN  -->  ELEM1

  selects first element of tuple x1
-----
[ -d $OUT_DIR/tupl/sign/index ] || mkdir $OUT_DIR/tupl/sign/index
cat >$OUT_DIR/tupl/sign/index/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_ELEM1 &
InlineFriendConstFct(index,FPAR2(T1,T2),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,index,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/index/gsig <<'-----'
  FUNCDEC(index##_DOMAIN,PL_2(DOMAIN,ELEM1),Nat0)
-----
cat >$OUT_DIR/tupl/sign/index/vsig <<'-----'
  index(x1,x2) = let is = {i | i e ind x1 & x1(i) = x2}
                 in if is = {}
                    then 0
                    else min is
  TYPE : DOMAIN  ELEM1  -->  Nat0

  search of x2 in x1, if x2 is found the position is returned,
  else 0 is returned indicating that x2 is not found 

  See also:
    __SA(rindex), __SA(search).
-----
[ -d $OUT_DIR/tupl/sign/index_list ] || mkdir $OUT_DIR/tupl/sign/index_list
cat >$OUT_DIR/tupl/sign/index_list/cpp <<'-----'
InlineFriendConstFct(index,FPAR2(const Cpp_DOMAIN &,const Cpp_DOMAIN &),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,index_list,FPARLIST2))

-----
cat >$OUT_DIR/tupl/sign/index_list/gsig <<'-----'
  FUNCDEC(index_list##_DOMAIN,PL_2(DOMAIN,DOMAIN),Nat0)
-----
cat >$OUT_DIR/tupl/sign/index_list/vsig <<'-----'
  index_list(x1,x2) =
    let prefixes = {s | s e DOMAIN 
                      : E z e Domain : x1 = s ^ x2 ^ z
                   }
    in if prefixes = {}
       then 0
       else 1 + MIN { len s | s e prefixes }
  TYPE : DOMAIN  DOMAIN  -->  Nat0

  search of the tuple x2 in x1,
  if x2 is found the starting position of the 1.
  occourence of x2 is returned,
  else 0 is returned indicating that x2 does not
  occur in x1 as a subtuple

  See also:
    __SA(index), __SA(rindex), __SA(search).
-----
[ -d $OUT_DIR/tupl/sign/index_list_from ] || mkdir $OUT_DIR/tupl/sign/index_list_from
cat >$OUT_DIR/tupl/sign/index_list_from/cpp <<'-----'
InlineFriendConstFct(index,FPAR3(const Cpp_DOMAIN &,const Cpp_DOMAIN &,const Cpp_NAT1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,index_list_from,FPARLIST3))

-----
cat >$OUT_DIR/tupl/sign/index_list_from/gsig <<'-----'
  FUNCDEC(index_list_from##_DOMAIN,PL_3(DOMAIN,DOMAIN,Nat1),Nat0)
-----
cat >$OUT_DIR/tupl/sign/index_list_from/vsig <<'-----'
  index_list_from(x1,x2,x3) =
    let prefixes = {s | s e DOMAIN 
                      : E z e Domain : x1 = s ^ x2 ^ z
                        && len s >= x3
                   }
    in if prefixes = {}
       then 0
       else 1 + MIN { len s | s e prefixes }
  TYPE : DOMAIN  DOMAIN  Nat1 -->  Nat0

  search of the tuple x2 in x1 from position x3,
  if x2 is found the starting position of the 1.
  occourence of x2 is returned,
  else 0 is returned indicating that x2 does not
  occur in x1 as a subtuple

  See also:
    __SA(index), __SA(rindex), __SA(search), __SA(index_list).
-----
[ -d $OUT_DIR/tupl/sign/inds ] || mkdir $OUT_DIR/tupl/sign/inds
cat >$OUT_DIR/tupl/sign/inds/cpp <<'-----'
#include <tupl/com/inds/defs>

InlineFriendConstFct(inds,FPAR1(const Cpp_DOMAIN &),Cpp_RESULT)
RUMPF(BODY1(Cpp_RESULT,inds,FPARLIST1))

-----
cat >$OUT_DIR/tupl/sign/inds/gsig <<'-----'
#include <tupl/com/inds/defs>
  FUNCDEC(inds##_DOMAIN,PL_1(DOMAIN),RESULT)
  _DEFINE dom##_DOMAIN inds##_DOMAIN
-----
cat >$OUT_DIR/tupl/sign/inds/vsig <<'-----'
  inds(x1) = inds x1
  TYPE : DOMAIN  -->  RESULT

  The index set of the sequence DOMAIN is computed.
  As a synonym, the operation may be called under the
  name __SA(dom) instead.
-----
[ -d $OUT_DIR/tupl/sign/insert ] || mkdir $OUT_DIR/tupl/sign/insert
cat >$OUT_DIR/tupl/sign/insert/cpp <<'-----'
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_NAT1 &
#define T3 const Cpp_ELEM1 &
InlineFriendFct(insert,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(insert,FPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/tupl/sign/insert/gsig <<'-----'
  FUNCDEC(insert##_DOMAIN,PL_3(DOMAIN,Nat1,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/insert/vsig <<'-----'
  insert(x1,x2,x3) = 
    < x1[i] | 0 < i < x2 > 
    ^ < x3 >
    ^ < x1[i] | x2 <= i <= len x1 >
  TYPE : DOMAIN  Nat1  ELEM1  -->  DOMAIN
  PRE : 1 <= x2 <= len x1 + 1

  insert element x3 into tuple x1 before position x2. The tuple will become
  one element longer.
  x1 is destroyed

  See also:
    __SA(ovwrt1), __SA(ovwrt1d).
-----
[ -d $OUT_DIR/tupl/sign/is_empty ] || mkdir $OUT_DIR/tupl/sign/is_empty
cat >$OUT_DIR/tupl/sign/is_empty/cpp <<'-----'
#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(is_empty,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_empty,FPARLIST1))

#ifdef OPERATOR
InlineFriendConstFct(operator !,FPAR1(T1),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,! is_empty,FPARLIST1))
#endif

#undef T1
-----
cat >$OUT_DIR/tupl/sign/is_empty/gsig <<'-----'
  FUNCDEC(is_empty##_DOMAIN,PL_1(DOMAIN),Bool)
-----
cat >$OUT_DIR/tupl/sign/is_empty/vsig <<'-----'
  is_empty(x1) = ( x1 = <> )
  TYPE : DOMAIN  -->  Bool

  test on empty tuple
-----
[ -d $OUT_DIR/tupl/sign/is_postfix ] || mkdir $OUT_DIR/tupl/sign/is_postfix
cat >$OUT_DIR/tupl/sign/is_postfix/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_postfix,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_postfix,FPARLIST2))

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/is_postfix/gsig <<'-----'
  FUNCDEC(is_postfix##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/tupl/sign/is_postfix/vsig <<'-----'
  is_postfix(x1,x2) = E r: DOMAIN: x1 ^ r = x2
  TYPE : DOMAIN DOMAIN  -->  Bool

  Check, if the tuple x1 is a prefix of x2
-----
[ -d $OUT_DIR/tupl/sign/is_prefix ] || mkdir $OUT_DIR/tupl/sign/is_prefix
cat >$OUT_DIR/tupl/sign/is_prefix/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_prefix,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_prefix,FPARLIST2))

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/is_prefix/gsig <<'-----'
  FUNCDEC(is_prefix##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/tupl/sign/is_prefix/vsig <<'-----'
  is_prefix(x1,x2) = E r: DOMAIN: x1 ^ r = x2
  TYPE : DOMAIN DOMAIN  -->  Bool

  Check, if the tuple x1 is a prefix of x2
-----
[ -d $OUT_DIR/tupl/sign/is_subtup ] || mkdir $OUT_DIR/tupl/sign/is_subtup
cat >$OUT_DIR/tupl/sign/is_subtup/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_DOMAIN &

InlineFriendConstFct(is_subtup,FPAR2(T1,T2),Cpp_BOOL)
RUMPF(BODY1(Cpp_BOOL,is_subtup,FPARLIST2))

#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/is_subtup/gsig <<'-----'
  FUNCDEC(is_subtup##_DOMAIN,PL_2(DOMAIN,DOMAIN),Bool)
-----
cat >$OUT_DIR/tupl/sign/is_subtup/vsig <<'-----'
  is_subtup(x1,x2) = E l,r: DOMAIN: l ^ x1 ^ r = x2
  TYPE : DOMAIN DOMAIN  -->  Bool

  Check, if the tuple x1 is contained as subtuple somewhere within x2.
-----
[ -d $OUT_DIR/tupl/sign/iterator ] || mkdir $OUT_DIR/tupl/sign/iterator
cat >$OUT_DIR/tupl/sign/iterator/cpp <<'-----'
#include <aux/sign/iterator/docu>
-----
[ -d $OUT_DIR/tupl/sign/last ] || mkdir $OUT_DIR/tupl/sign/last
cat >$OUT_DIR/tupl/sign/last/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(last,FPAR1(T1),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,last,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/tupl/sign/last/gsig <<'-----'
  FUNCDEC(last##_DOMAIN,PL_1(DOMAIN),ELEM1)
-----
cat >$OUT_DIR/tupl/sign/last/vsig <<'-----'
  last(x1) = x1(len x1)
  TYPE : DOMAIN  -->  ELEM1
  PRE  : ~ (x1 = <>)

  selects last element of tuple x1
-----
[ -d $OUT_DIR/tupl/sign/len ] || mkdir $OUT_DIR/tupl/sign/len
cat >$OUT_DIR/tupl/sign/len/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(len,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,len,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/tupl/sign/len/gsig <<'-----'
  FUNCDEC(len##_DOMAIN,PL_1(DOMAIN),Nat0)
-----
cat >$OUT_DIR/tupl/sign/len/vsig <<'-----'
  len(x1) = len x1
  TYPE : DOMAIN  -->  Nat0

  length of tuple x1
-----
[ -d $OUT_DIR/tupl/sign/mk1 ] || mkdir $OUT_DIR/tupl/sign/mk1
cat >$OUT_DIR/tupl/sign/mk1/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk1,KPARLIST1))

#undef T1
-----
cat >$OUT_DIR/tupl/sign/mk1/gsig <<'-----'
  FUNCDEC(mk1##_DOMAIN,PL_1(ELEM1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mk1/vsig <<'-----'
  mk1(x1) = <x1>
  TYPE : ELEM1  -->  DOMAIN

  construction of a tuple with one element x1
-----
[ -d $OUT_DIR/tupl/sign/mk2 ] || mkdir $OUT_DIR/tupl/sign/mk2
cat >$OUT_DIR/tupl/sign/mk2/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_ELEM1 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR2(T1,T2),)
RUMPF(BODY4(mk2,KPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/mk2/gsig <<'-----'
  FUNCDEC(mk2##_DOMAIN,PL_2(ELEM1,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mk2/vsig <<'-----'
  mk2(x1,x2) = <x1,x2> = appr(mk1(x1),x2)
  TYPE : ELEM1  ELEM1  -->  DOMAIN

  construction of a tuple with two elements
-----
[ -d $OUT_DIR/tupl/sign/mk3 ] || mkdir $OUT_DIR/tupl/sign/mk3
cat >$OUT_DIR/tupl/sign/mk3/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_ELEM1 &
#define T3 const Cpp_ELEM1 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR3(T1,T2,T3),)
RUMPF(BODY4(mk3,KPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/tupl/sign/mk3/gsig <<'-----'
  FUNCDEC(mk3##_DOMAIN,PL_3(ELEM1,ELEM1,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mk3/vsig <<'-----'
  mk3(x1,x2,x3) = <x1,x2,x3> = appr(appr(mk1(x1),x2),x3)
  TYPE : ELEM1  ELEM1  ELEM1  -->  DOMAIN

  construction of a tuple with three elements
-----
[ -d $OUT_DIR/tupl/sign/mk_empty ] || mkdir $OUT_DIR/tupl/sign/mk_empty
cat >$OUT_DIR/tupl/sign/mk_empty/cpp <<'-----'
#define T1 const Cpp_EMPTY &
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mk_empty,KPARLIST0))
#undef T1 
-----
cat >$OUT_DIR/tupl/sign/mk_empty/gsig <<'-----'
  FUNCDEC(mk_empty##_DOMAIN,PL_0(),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mk_empty/vsig <<'-----'
  mk_empty() = <>
  TYPE :  -->  DOMAIN

  construction of the empty tuple

#include <aux/com/mk_empty/docu>

-----
[ -d $OUT_DIR/tupl/sign/mk_sub_tup ] || mkdir $OUT_DIR/tupl/sign/mk_sub_tup
cat >$OUT_DIR/tupl/sign/mk_sub_tup/cpp <<'-----'
#define T1 const Cpp_DOMAIN & 
#define T2 const Cpp_NAT1 &
#define T3 const Cpp_NAT0 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR3(T1,T2,T3),)
RUMPF(BODY4(mk_sub_tup,KPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/tupl/sign/mk_sub_tup/gsig <<'-----'
  FUNCDEC(mk_sub_tup##_DOMAIN,PL_3(DOMAIN,Nat1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mk_sub_tup/vsig <<'-----'
  mk_sub_tup(x1,x2,x3) = <x1(i) | i e (ind x1 n {x2..x3})>
  TYPE : DOMAIN  Nat1  Nat0  -->  DOMAIN

  constructs a subtuple x1[x2 .. x3] from x1
  x1 remains unchanged
  a complete new value is constructed,
  elements are processed with __SA(copy)

  See also:
    __SA(sub_tup),__SA(sub_tupd)
-----
[ -d $OUT_DIR/tupl/sign/mkarray ] || mkdir $OUT_DIR/tupl/sign/mkarray
cat >$OUT_DIR/tupl/sign/mkarray/gsig <<'-----'
  FUNCDEC(mkarray##_DOMAIN,PL_RV(ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mkarray/vsig <<'-----'
  mkarray(x1,x2) = <x1[i] | 1 <= i <= x2>
  TYPE : ptr to ELEM1  Nat0  -->  DOMAIN

  construction of a tuple from an array of ELEM1. x1 points to the
  beginning of the array, x2 gives its length.
-----
[ -d $OUT_DIR/tupl/sign/mkc ] || mkdir $OUT_DIR/tupl/sign/mkc
cat >$OUT_DIR/tupl/sign/mkc/cpp <<'-----'
#define T1 char * 
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mkc,(x1)))
#undef T1
-----
cat >$OUT_DIR/tupl/sign/mkc/gsig <<'-----'
  FUNCDEC(mkc##_DOMAIN,P_OP REF_PARAM(x1,ELEM1) P_CL,DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mkc/vsig <<'-----'
  mkc(x1) = <x1[i] | 1 <= i <= n & x1[n] = 0>
  TYPE : ptr to ELEM1  -->  DOMAIN

  construction of a tuple from a C string, x1 is a pointer to
  the C string which is terminated by an 0 element
-----
[ -d $OUT_DIR/tupl/sign/mklc ] || mkdir $OUT_DIR/tupl/sign/mklc
cat >$OUT_DIR/tupl/sign/mklc/cpp <<'-----'
#define T1 Cpp_MKLC *
InlineNoFriendFct(Cpp_DOMAIN,KPAR1(T1),)
RUMPF(BODY4(mklc,((char *)x1))) 
#undef T1
-----
cat >$OUT_DIR/tupl/sign/mklc/gsig <<'-----'
  FUNCDEC(mklc##_DOMAIN,P_OP REF_PARAM(x1,char) P_CL,DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mklc/vsig <<'-----'
  mklc(x1) = <tolower(x1[i]) | 1 <= i <= n & x1[n] = 0>
  TYPE : ptr to ELEM1  -->  DOMAIN

  construction of a tuple from a C string, x1 is a pointer to
  the C string which is terminated by an 0 element
  the string is converted to lowecase

  This function applies for Char * only!
-----
[ -d $OUT_DIR/tupl/sign/mkn ] || mkdir $OUT_DIR/tupl/sign/mkn
cat >$OUT_DIR/tupl/sign/mkn/cpp <<'-----'
#define T1 const Cpp_ELEM1 &
#define T2 const Cpp_NAT0 &
InlineNoFriendFct(Cpp_DOMAIN,KPAR2(T1,T2),)
RUMPF(BODY4(mkn,KPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/mkn/gsig <<'-----'
  FUNCDEC(mkn##_DOMAIN,PL_2(ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mkn/vsig <<'-----'
  mkn(x1,x2) = <x1 | 1 <= i <= x2>
  TYPE : ELEM1  Nat0 -->  DOMAIN

  construction of a tuple with x2 identical elements x1. The elements
  are not copied upon insertion into the tuple.

  See also:
    __SA(mknc)
-----
[ -d $OUT_DIR/tupl/sign/mkn_empty ] || mkdir $OUT_DIR/tupl/sign/mkn_empty
cat >$OUT_DIR/tupl/sign/mkn_empty/gsig <<'-----'
  FUNCDEC(mkn_empty##_DOMAIN,PL_1(Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mkn_empty/vsig <<'-----'
  mkn_empty() = <>
  TYPE : Nat0  -->  DOMAIN

  Construction of the empty tupl, identical to function __SA(mk_empty).
  The parameter x1 may be used to allocate space for x1
  elements directly to save storage allocation upon later union.
-----
[ -d $OUT_DIR/tupl/sign/mknc ] || mkdir $OUT_DIR/tupl/sign/mknc
cat >$OUT_DIR/tupl/sign/mknc/gsig <<'-----'
  FUNCDEC(mknc##_DOMAIN,PL_2(ELEM1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/mknc/vsig <<'-----'
  mknc(x1,x2) = <x1 | 1 <= i <= x2>
  TYPE : ELEM1  Nat0 -->  DOMAIN

  construction of a tuple with x2 equal elements x1. x1 is copied
  upon insertion into the tuple.

  See also:
    __SA(mkn)
-----
[ -d $OUT_DIR/tupl/sign/ovwrt1 ] || mkdir $OUT_DIR/tupl/sign/ovwrt1
cat >$OUT_DIR/tupl/sign/ovwrt1/cpp <<'-----'
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_NAT1 &
#define T3 const Cpp_ELEM1 &
InlineFriendFct(ovwrt1,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt1,FPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/tupl/sign/ovwrt1/gsig <<'-----'
  FUNCDEC(ovwrt1##_DOMAIN,PL_3(DOMAIN,Nat1,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/ovwrt1/vsig <<'-----'
  ovwrt1(x1,x2,x3) = <if i = x2 then x3 else x1(i) | 1 <= i <= len x1>
  TYPE : DOMAIN  Nat1  ELEM1  -->  DOMAIN
  PRE  : len x1 >= x2

  the element at position x2 in tuple x1 is overwritten with x3
  x1 is destroyed

  See also:
    __SA(insert).
-----
[ -d $OUT_DIR/tupl/sign/ovwrt1d ] || mkdir $OUT_DIR/tupl/sign/ovwrt1d
cat >$OUT_DIR/tupl/sign/ovwrt1d/cpp <<'-----'
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_NAT1 &
#define T3 const Cpp_ELEM1 &
InlineFriendFct(ovwrt1d,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(ovwrt1d,FPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/tupl/sign/ovwrt1d/gsig <<'-----'
  FUNCDEC(ovwrt1d##_DOMAIN,PL_3(DOMAIN,Nat1,ELEM1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/ovwrt1d/vsig <<'-----'
  ovwrt1d(x1,x2,x3) = <if i=x2 then x3 else x1(i) | 1<=i<=len x1>
  TYPE : DOMAIN  Nat1  ELEM1  -->  DOMAIN
  PRE  : len x1 >= x2

  the element at position x2 in tuple x1 is overwritten with x3
  x1 is destroyed
  an implicit call of __SA(del)(x1(x2)) is performed

  See also:
    __SA(insert).
-----
[ -d $OUT_DIR/tupl/sign/puts ] || mkdir $OUT_DIR/tupl/sign/puts
cat >$OUT_DIR/tupl/sign/puts/cpp <<'-----'
InlineFriendConstFct(puts,FPAR2(const Cpp_DOMAIN &,ostream &),void)
RUMPF(BODY3(puts,(DATA, x2)))

-----
cat >$OUT_DIR/tupl/sign/puts/gsig <<'-----'
_IFDEF __cplusplus
  PROCDEC(puts##_DOMAIN,PL_2(DOMAIN,ostream &))
_ELSE
  PROCDEC(puts##_DOMAIN,PL_VR(DOMAIN,FILE))
_ENDIF
-----
cat >$OUT_DIR/tupl/sign/puts/vsig <<'-----'
  puts(x1,x2) = "writes tuple to a char file"
  TYPE : DOMAIN  FILE *  -->

  writes a tuple x1 to a C FILE with file pointer x2 with
  C library call fputc. x1 remains unchanged.

  for C++ the 2. Parameter is of type __EM(ostream &) and
  the Elements of the tuple are printed as chars onto that stream
-----
[ -d $OUT_DIR/tupl/sign/read ] || mkdir $OUT_DIR/tupl/sign/read
cat >$OUT_DIR/tupl/sign/read/gsig <<'-----'
  FUNCDEC(read##_DOMAIN,PL_2(Intg,Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/read/vsig <<'-----'
  read(x1,x2) =
  TYPE : Intg Nat0  -->  DOMAIN

  Emulates the UNIX system call __EM(read) for tuples. Tries to read 
  x2 elements of the type ELEM1 from the file x1 and builds a tuple
  from them. The file is represented by the filedescriptor x1
  created using the __EM(open) system call. 

  The tuple returned contains as much elements as where sucessfully
  read. If the __EM(read) system call returns -1 an empty tuple will
  be returned. The C library variable __EM(errno) can be used as usual.

  The tuple elements are assumed to be simple unstructured values
  (containing no pointers).

  See also:
    __EM(write)
-----
[ -d $OUT_DIR/tupl/sign/reverse ] || mkdir $OUT_DIR/tupl/sign/reverse
cat >$OUT_DIR/tupl/sign/reverse/cpp <<'-----'
#define T1 const Cpp_DOMAIN &

InlineFriendConstFct(reverse,FPAR1(T1),Cpp_DOMAIN)
RUMPF(BODY1(Cpp_DOMAIN,reverse,FPARLIST1))

#undef T1
-----
cat >$OUT_DIR/tupl/sign/reverse/gsig <<'-----'
  FUNCDEC(reverse##_DOMAIN,PL_1(DOMAIN),DOMAIN)

#ifndef GEN_DOCU
  _DEFINE appl1##_DOMAIN(x1,x2) appl##_DOMAIN(copy##_ELEM1(x2),x1)
#endif
-----
cat >$OUT_DIR/tupl/sign/reverse/vsig <<'-----'
  reverse(x1) = <x1(len(x1) - i + 1) | 1 <= i <= len(x1) >
  TYPE : DOMAIN  -->  DOMAIN

  A new sequence is built from x1 containing the elements in reverse
  order. x1 is left unchanged. Elements are copied.
-----
[ -d $OUT_DIR/tupl/sign/rindex ] || mkdir $OUT_DIR/tupl/sign/rindex
cat >$OUT_DIR/tupl/sign/rindex/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_ELEM1 &
InlineFriendConstFct(rindex,FPAR2(T1,T2),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,rindex,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/rindex/gsig <<'-----'
  FUNCDEC(rindex##_DOMAIN,PL_2(DOMAIN,ELEM1),Nat0)
-----
cat >$OUT_DIR/tupl/sign/rindex/vsig <<'-----'
  rindex(x1,x2) = let is = {i | i e ind x1 & x1(i) = x2}
                 in if is = {}
                    then 0
                    else max is
  TYPE : DOMAIN  ELEM1  -->  Nat0

  Search for the LAST occurence of x2 within the tuple x1.
  If the element is found, the index is returned, 0 otherwise.

  See also:
    __SA(index).
-----
[ -d $OUT_DIR/tupl/sign/rmv1 ] || mkdir $OUT_DIR/tupl/sign/rmv1
cat >$OUT_DIR/tupl/sign/rmv1/cpp <<'-----'
#define T1 Cpp_DOMAIN &
#define T2 const Cpp_NAT1 &
InlineFriendFct(rmv1,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(rmv1,FPARLIST2))
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/rmv1/gsig <<'-----'
  FUNCDEC(rmv1##_DOMAIN,PL_2(DOMAIN,Nat1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/rmv1/vsig <<'-----'
  rmv1(x1,x2) = < x1(i) | 1 <= i < x2 > & < x1(i) | x2 < i <=len x1 >
  TYPE : DOMAIN  Nat1  -->  DOMAIN
  PRE  : x2 <= len x1

  removes the element at position x2 in tuple x1, x1 is destroyed 
  no sub structures are destroyed or deleted              
-----
[ -d $OUT_DIR/tupl/sign/rmv1d ] || mkdir $OUT_DIR/tupl/sign/rmv1d
cat >$OUT_DIR/tupl/sign/rmv1d/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'rmv1d' not supported for automem)
#else

#define T1 Cpp_DOMAIN &
#define T2 const Cpp_NAT1 &
InlineFriendFct(rmv1d,FPAR2(T1,T2),Cpp_DOMAIN &)
RUMPF(BODY2(rmv1d,FPARLIST2))
#undef T1
#undef T2
#endif
-----
cat >$OUT_DIR/tupl/sign/rmv1d/gsig <<'-----'
  FUNCDEC(rmv1d##_DOMAIN,PL_2(DOMAIN,Nat1),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/rmv1d/vsig <<'-----'
  rmv1d(x1,x2) = < x1(i) | 1 <= i < x2 > & < x1(i) | x2 < i <=len x1 >
  TYPE : DOMAIN  Nat1  -->  DOMAIN
  PRE  : x2 <= len x1

  removes the element at position x2 in tuple x1, x1 is destroyed 
  an implicit call of del(x1(x2)) is performed
-----
[ -d $OUT_DIR/tupl/sign/search ] || mkdir $OUT_DIR/tupl/sign/search
cat >$OUT_DIR/tupl/sign/search/gsig <<'-----'
#ifdef GEN_C
  typedef Bool (* T2_search##_DOMAIN) P_OP ELEM1 y1 P_CL ;
  extern Nat0 search##_DOMAIN P_OP DOMAIN x1, T2_search##_DOMAIN x2 P_CL ;
#endif
-----
cat >$OUT_DIR/tupl/sign/search/vsig <<'-----'
  search(x1,x2) = let is = {i | i e ind x1 & x2(x1(i))}
                  in if is ={}
                     then 0
                     else min is
  TYPE : DOMAIN  ( ELEM1  -->  Bool )  -->  Nat0

  search of an element y1 in x1 which meets the predicate x2 
  if found, the index of the first element is returned
  else 0 is returned               
-----
[ -d $OUT_DIR/tupl/sign/sel ] || mkdir $OUT_DIR/tupl/sign/sel
cat >$OUT_DIR/tupl/sign/sel/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define T2 const Cpp_NAT1 &
InlineFriendConstFct(sel,FPAR2(T1,T2),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,sel,FPARLIST2))
#ifdef OPERATOR
InlineMemberConstFct(operator [],(T2 x2),Cpp_ELEM1)
RUMPF(BODY1(Cpp_ELEM1,sel,(data,x2.data)))
#endif
#undef T1
#undef T2
-----
cat >$OUT_DIR/tupl/sign/sel/gsig <<'-----'
  FUNCDEC(sel##_DOMAIN,PL_2(DOMAIN,Nat1),ELEM1)
-----
cat >$OUT_DIR/tupl/sign/sel/vsig <<'-----'
  sel(x1,x2) = x1(x2)
  TYPE : DOMAIN  Nat1  -->  ELEM1
  PRE  : len x1 >= x2

  selects element x2 of tuple x1
-----
[ -d $OUT_DIR/tupl/sign/sort ] || mkdir $OUT_DIR/tupl/sign/sort
cat >$OUT_DIR/tupl/sign/sort/cpp <<'-----'
 
InlineFriendFct(sort,FPAR1(Cpp_DOMAIN &),Cpp_DOMAIN &)
RUMPF(BODY2(sort,FPARLIST1))

-----
cat >$OUT_DIR/tupl/sign/sort/gsig <<'-----'
  FUNCDEC(sort##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/sort/vsig <<'-----'
  sort(x1) = < x1(i) | i < len(x1) ==> x1(i) <= x1(i + 1) >
  TYPE : DOMAIN  -->  DOMAIN

  Sort x1 in increasing order according to the predicate __SA(is_gr) defined
  for ELEM1. The input parameter x1 will be destroied.

  See also:
    __SA(reverse)
-----
[ -d $OUT_DIR/tupl/sign/sub_tup ] || mkdir $OUT_DIR/tupl/sign/sub_tup
cat >$OUT_DIR/tupl/sign/sub_tup/cpp <<'-----'
#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_NAT1 &
#define T3 const Cpp_NAT0 &
InlineFriendFct(sub_tup,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(sub_tup,FPARLIST3))
#undef T1
#undef T2
#undef T3
-----
cat >$OUT_DIR/tupl/sign/sub_tup/gsig <<'-----'
  FUNCDEC(sub_tup##_DOMAIN,PL_3(DOMAIN,Nat1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/sub_tup/vsig <<'-----'
  sub_tup(x1,x2,x3) = <x1(i) | i e (ind x1 n {x2..x3})>
  TYPE : DOMAIN  Nat1  Nat0  -->  DOMAIN

  select a subtuple x1[x2 .. x3] from x1
  x1 is destroied

  See also:
    __SA(sub_tupd), __SA(mk_sub_tup)
-----
[ -d $OUT_DIR/tupl/sign/sub_tupd ] || mkdir $OUT_DIR/tupl/sign/sub_tupd
cat >$OUT_DIR/tupl/sign/sub_tupd/cpp <<'-----'
#if defined(BASEIMPL)
COMMENT_(member function 'sub_tupd' not supported for automem)
#else

#define T1 Cpp_DOMAIN & 
#define T2 const Cpp_NAT1 &
#define T3 const Cpp_NAT0 &
InlineFriendFct(sub_tupd,FPAR3(T1,T2,T3),Cpp_DOMAIN &)
RUMPF(BODY2(sub_tupd,FPARLIST3))
#undef T1
#undef T2
#undef T3
#endif
-----
cat >$OUT_DIR/tupl/sign/sub_tupd/gsig <<'-----'
  FUNCDEC(sub_tupd##_DOMAIN,PL_3(DOMAIN,Nat1,Nat0),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/sub_tupd/vsig <<'-----'
  sub_tupd(x1,x2,x3) = <x1(i) | i e (ind x1 n {x2..x3})>
  TYPE : DOMAIN  Nat1  Nat0  -->  DOMAIN

  select a subtuple x1[x2 .. x3] from x1

  x1 is destroied
  and for all elements in the ranges
  1 <= i < x2 and x3 < i < len x1
  a call of del is performed

  See also:
    __SA(sub_tup), __SA(mk_sub_tup)
-----
[ -d $OUT_DIR/tupl/sign/sub_tupls ] || mkdir $OUT_DIR/tupl/sign/sub_tupls
cat >$OUT_DIR/tupl/sign/sub_tupls/cpp <<'-----'
#include <tupl/com/sub_tupls/defs>
#define T1 const Cpp_DOMAIN &
InlineFriendConstFct(sub_tupls,FPAR1(T1),Cpp_NAT0)
RUMPF(BODY1(Cpp_NAT0,sub_tupls,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/tupl/sign/sub_tupls/gsig <<'-----'
#include <tupl/com/sub_tupls/defs>
  FUNCDEC(sub_tupls##_DOMAIN,PL_1(DOMAIN),RESULT)
-----
cat >$OUT_DIR/tupl/sign/sub_tupls/vsig <<'-----'
  sub_tupls(x1) = { <x(k) | i <= k <= j> | i,j IN inds x1 }
  TYPE : DOMAIN -->  DOMAIN -set

  Compute the set of all subtuples of x1. x1 is left undestroyed.
-----
[ -d $OUT_DIR/tupl/sign/tl ] || mkdir $OUT_DIR/tupl/sign/tl
cat >$OUT_DIR/tupl/sign/tl/cpp <<'-----'
#define T1 Cpp_DOMAIN &
InlineFriendFct(tl,FPAR1(T1),Cpp_DOMAIN &)
RUMPF(BODY2(tl,FPARLIST1))
#undef T1
-----
cat >$OUT_DIR/tupl/sign/tl/gsig <<'-----'
  FUNCDEC(tl##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/tl/vsig <<'-----'
  tl(x1) = tl x1
  TYPE : DOMAIN  -->  DOMAIN
  PRE  : ~ (x1 = <>)

  removes first element of tuple x1
  x1 is destroyed
-----
[ -d $OUT_DIR/tupl/sign/tld ] || mkdir $OUT_DIR/tupl/sign/tld
cat >$OUT_DIR/tupl/sign/tld/cpp <<'-----'
#if !defined(BASEIMPL)

#define T1 Cpp_DOMAIN &
InlineFriendFct(tld,FPAR1(T1),Cpp_DOMAIN &)
RUMPF(BODY2(tld,FPARLIST1))
#undef T1

#else
   CA === tupl/tld only for internal use === CE
#endif
-----
cat >$OUT_DIR/tupl/sign/tld/gsig <<'-----'
  FUNCDEC(tld##_DOMAIN,PL_1(DOMAIN),DOMAIN)
-----
cat >$OUT_DIR/tupl/sign/tld/vsig <<'-----'
  tld(x1) = tl x1
  TYPE : DOMAIN  -->  DOMAIN
  PRE  : ~ (x1 = <>)

  removes first element of tuple x1 (like tl x1)
  but an implicit call of del(hd x1) is performed
  x1 is destroyed

  for C++ automem implementation this function is
  not required, __SA(tl) does all the storage management
-----
[ -d $OUT_DIR/tupl/sign/write ] || mkdir $OUT_DIR/tupl/sign/write
cat >$OUT_DIR/tupl/sign/write/gsig <<'-----'
  FUNCDEC(write##_DOMAIN,PL_2(Intg,DOMAIN),Intg)
-----
cat >$OUT_DIR/tupl/sign/write/vsig <<'-----'
  write(x1,x2) =
  TYPE : Intg DOMAIN  ==>  Intg

  Emulates the __EM(write) Unix system call for tuples. The tuple x2 is
  written to the file x1 identified by a file pointer created using
  the __EM(open) system call. The value returned will be either the number
  of elements successfully written or -1 in case of an error.
  The variable __EM(errno) can be used as usual.

  The tuple elements are assumed to be simple unstructured values
  (not containing pointers).

  See also:
    __SA(read).

-----
[ -d $OUT_DIR/tupl/writefile ] || mkdir $OUT_DIR/tupl/writefile
[ -d $OUT_DIR/tupl/writefile/appl ] || mkdir $OUT_DIR/tupl/writefile/appl
cat >$OUT_DIR/tupl/writefile/appl/ccod <<'-----'
  DOMAIN appl##_DOMAIN _FPH2(ELEM1,DOMAIN)
   { err_uop_vdmlib(MKSTRING(DOMAIN),"appl"); }
-----
cat >$OUT_DIR/tupl/writefile/appl/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/writefile/appl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/writefile/appr ] || mkdir $OUT_DIR/tupl/writefile/appr
cat >$OUT_DIR/tupl/writefile/appr/ccod <<'-----'
#include <tupl/writefile/basic/defp>
  DOMAIN appr##_DOMAIN _FPH2(DOMAIN,ELEM1)
   { return (ref##_DOMAIN(x1)->f_buff[ref##_DOMAIN(x1)->f_buffelems] = x2, (++(x1->f_buffelems) == BUFFSIZE) ? write_buffer##_DOMAIN(x1) : x1);
   }
#undef BUFFSIZE
#undef CREATEMASK
#undef DEFAULTFN
#undef MAXDEFFN
-----
cat >$OUT_DIR/tupl/writefile/appr/cmcr <<'-----'
#include <tupl/writefile/basic/defp>
_DEFINE appr##_DOMAIN(x1,x2) (ref##_DOMAIN(x1)->f_buff[ref##_DOMAIN(x1)->f_buffelems] = x2, (++(x1->f_buffelems) == BUFFSIZE) ? write_buffer##_DOMAIN(x1) : x1)
#undef BUFFSIZE
#undef CREATEMASK
#undef DEFAULTFN
#undef MAXDEFFN
-----
cat >$OUT_DIR/tupl/writefile/appr/param <<'-----'
MACROS
-----
[ -d $OUT_DIR/tupl/writefile/basic ] || mkdir $OUT_DIR/tupl/writefile/basic
cat >$OUT_DIR/tupl/writefile/basic/ccod <<'-----'
#include <tupl/writefile/basic/defp>

DOMAIN write_buffer##_DOMAIN _FPH1(DOMAIN)
{ 
    if (x1->f_ioerr == 0)
	{ Intg lx1 = write((int)(x1->f_fdes),
			   (char *)(x1->f_buff),
			   (x1->f_buffelems) * sizeof(ELEM1));

	if (lx1 != (Intg)(x1->f_buffelems * sizeof(ELEM1)))
	    {
		x1->f_ioerr = 1;
		x1->f_errno = errno;
#ifdef NOTIFYIOERR
                notify_ioerr##_DOMAIN();
#endif
	    }
	}
      
    x1->f_buffelems = 0;
    return x1;
}
#undef BUFFSIZE
#undef CREATEMASK
#undef DEFAULTFN
#undef MAXDEFFN
-----
cat >$OUT_DIR/tupl/writefile/basic/defp <<'-----'
#ifndef BUFFSIZE
#define BUFFSIZE 4096
#endif

#ifndef MAXDEFFN
#define MAXDEFFN 128
#endif

#ifndef DEFAULTFN
#define DEFAULTFN MKSTRING(tmp_%MERGE(lu,_DOMAIN)!)
#endif

#ifndef CREATEMASK
#define CREATEMASK 0x01A4
#endif
-----
cat >$OUT_DIR/tupl/writefile/basic/docu <<'-----'
  'writefile' is an implementation of

     DOMAIN = ELEM1 *

  where ELEM1 is a simple type (i.e. not containing any pointers).
  The tuple is associated to a file.

  Only the operations

     'mk_empty', 'appr', 'fwrite', 'del' and 'del1'

  are available for objects of this type.

  This allows modelling sequential output of simple objects to
  a file using tuple operations.

  Parameters:

    "BUFFSIZE":
               Change size of output buffer. Optional
               parameter, default value is 4096.

    "CREATEMASK":
               File access mode when creating a new 
               file. Optional, default value is 0x01A4.

    "MAXDEFFN":
               Maximum length of filename used for the
               default filename (see __SA(mk_empty) for 
               details). Optional, current value is 128.

    "NOTIFYIOERR":
               During tupl creation (i.e. 'mk_empty', 'appr'),
               several file I/O operations will take place. 
               If one of these fails, the user normally will
               become aware of this when the 'fwrite'
               operation fails at the end. If "NOTIFYIOERR"
               is set, an external routine named

                       notify_ioerr##_DOMAIN
                        
               (supplied by the user) will be called each
               time an I/O error occurs.

    "DEFAULTFN":
               Temporary name of the output file used by
               'mk_empty', if "NODEFFN" is not set. 
               Optional parameter, default is 'tmp_%lu_domain!'.

    "NODEFFN":   
               If defined, 'mk_empty' does not generate a
               temporary filename itself but calls a
               routine 

                 extern void get_deffn##_DOMAIN(char *, Nat0);
                        
               instead. Here the user can supply a filename
               of his own. The second parameter contains the
               number of calls to 'mk_empty' to allow creation
               of unique filenames.
    "MACROS":    
               generate Macro operations instead of functions
               where possible.

  Example: 
    
    One application of this implementation is in connection with
    the 'cvtotupl' -operation. Using 'writefile' as implementation
    for the result tuple domain, output of structured values
    becomes straight forward:

    given the '.vdm' file:
      
      DOMAINS

        Somedomain   = ...
        Outtupl      = Byte*

      IMPLEMENTATIONS
        
        Somedomain   = ... + cvtotupl(TUPLDOMAIN="Outtupl")
        Outtupl      = writefile(BUFFSIZE=1028
                                ,DEFAULTFN="dummy_%u")
                       + fwrite + del1


     the following statements can be used to write a structured
     valuea 's' of type 'Somedomain' to a file 'outfile':

       if (fwrite_outtupl(cvtotupl_somedomain(s), outfile))
          { ...OK }
       else
          { ...FAILED, consult 'errno' for details ... }
     
     (This sequence will work independent of the implementation
     of 'Outtupl' but for other implementations the complete
     tuple value will be built up in memory before written to
     the file.)
     

  See also:
    __A("readfile",tupl.readfile.basic) (tuple implementation), __SA(cvtotupl) (operation)

-----
cat >$OUT_DIR/tupl/writefile/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/tupl/writefile/basic/gptr <<'-----'
   TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/tupl/writefile/basic/gtyp <<'-----'
#include <tupl/writefile/basic/defp>
  START_RECORD_TYP(Struct##_DOMAIN)
                      RECFIELD(f_fdes,Intg);
#ifdef GEN_C
		      char	f_deffn[MAXDEFFN];
#else
                      RECFIELD(f_deffn,ARRAY[1..MAXDEFFN] OF char);
#endif
                      RECFIELD(f_ioerr,char);
                      RECFIELD(f_errno,Intg);
                      RECFIELD(f_buffelems,Nat0);
#ifdef GEN_C
		      ELEM1	f_buff[BUFFSIZE];
#else
                      RECFIELD(f_buff,ARRAY[1..BUFFSIZE] OF ELEM1);
#endif
  END_RECORD_TYP(Struct##_DOMAIN) 

#ifdef GEN_C
  FUNCDEC(write_buffer##_DOMAIN,PL_1(DOMAIN),DOMAIN)

#ifdef NOTIFYIOERR
_IFNDEF notify_ioerr##_DOMAIN
  FUNCDEC(notify_ioerr##_DOMAIN,PL_0(),void)
_ENDIF
#endif
#endif
#undef BUFFSIZE
#undef CREATEMASK
#undef DEFAULTFN
#undef MAXDEFFN
-----
cat >$OUT_DIR/tupl/writefile/basic/param <<'-----'
AUTOMEM_SEL
BUFFSIZE
CREATEMASK
DEFAULTFN
INTERNALDOMAIN
MACROS
MAXDEFFN
NOCHECK
NODEFFN
NOTIFYIOERR
RW_FILE_AUTO
-----
cat >$OUT_DIR/tupl/writefile/basic/vdm <<'-----'
#include <aux/com/heap/vdm>
DOMAINS
IMPLEMENTATIONS
  Vdmlib        = + header("ERRNO","FCNTL","UNISTD")
#undef ALLOC

#define CONSTRNAME mk_basic
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/writefile/copy1 ] || mkdir $OUT_DIR/tupl/writefile/copy1
cat >$OUT_DIR/tupl/writefile/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN) { err_uop_vdmlib(MKSTRING(DOMAIN),"copy1"); }
-----
cat >$OUT_DIR/tupl/writefile/copy1/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/writefile/copy1/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/writefile/default ] || mkdir $OUT_DIR/tupl/writefile/default
cat >$OUT_DIR/tupl/writefile/default/docu <<'-----'
#include <aux/com/default/docu>

  For this special purpose implementation of the tuple datatype
  only the following set of operations is
  added

#include <tupl/writefile/default/vdm>
-----
cat >$OUT_DIR/tupl/writefile/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk_empty 
                                       ! the only constructor !
             + appr
             + fwrite
             + del1
-----
[ -d $OUT_DIR/tupl/writefile/del ] || mkdir $OUT_DIR/tupl/writefile/del
cat >$OUT_DIR/tupl/writefile/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(ref##_DOMAIN(x1));}
-----
cat >$OUT_DIR/tupl/writefile/del/cmcr <<'-----'
_DEFINE del##_DOMAIN(x1) free##_DOMAIN(ref##_DOMAIN(x1))
-----
cat >$OUT_DIR/tupl/writefile/del/docu <<'-----'
  Only the buffer will be deleted, the file will remain. Note that
  'fwrite' must be used before 'del'. Otherwise the file remains
  incomplete and will not be closed.
-----
cat >$OUT_DIR/tupl/writefile/del/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/writefile/del/pmcr <<'-----'
_DEFINE del##_DOMAIN(x1) free##_DOMAIN(ref##_DOMAIN(x1))
-----
[ -d $OUT_DIR/tupl/writefile/del1 ] || mkdir $OUT_DIR/tupl/writefile/del1
cat >$OUT_DIR/tupl/writefile/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(ref##_DOMAIN(x1));}
-----
cat >$OUT_DIR/tupl/writefile/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) free##_DOMAIN(ref##_DOMAIN(x1))
-----
cat >$OUT_DIR/tupl/writefile/del1/docu <<'-----'
  Only the buffer will be deleted, the file will remain. Note that
  'fwrite' must be used before 'del1'. Otherwise the file will remain
  incomplete and will not be closed.
-----
cat >$OUT_DIR/tupl/writefile/del1/param <<'-----'
MACROS
-----
cat >$OUT_DIR/tupl/writefile/del1/pmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) free##_DOMAIN(ref##_DOMAIN(x1))
-----
[ -d $OUT_DIR/tupl/writefile/forall ] || mkdir $OUT_DIR/tupl/writefile/forall
cat >$OUT_DIR/tupl/writefile/forall/ccod <<'-----'
  void forall##_DOMAIN _FPH2(DOMAIN,T2_forall##_DOMAIN)
   { err_uop_vdmlib(MKSTRING(DOMAIN),"forall"); }
-----
cat >$OUT_DIR/tupl/writefile/forall/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/writefile/forall/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/writefile/fwrite ] || mkdir $OUT_DIR/tupl/writefile/fwrite
cat >$OUT_DIR/tupl/writefile/fwrite/ccod <<'-----'
#include <tupl/writefile/basic/defp>

  Bool fwrite##_DOMAIN _FPH2(DOMAIN,Str)
    { Intg lx1;
      
      x1 = write_buffer##_DOMAIN(ref##_DOMAIN(x1));
      lx1 = close((int)(x1->f_fdes));

      if (x1->f_ioerr) { errno = (int)(x1->f_errno); return 0; }
      if (lx1 == -1)   
	 {
#ifdef NOTIFYIOERR
           notify_ioerr##_DOMAIN();
#endif
           return 0;
	 }

      { char lx2[MAXDEFFN];

	cpc_str(x2,lx2);
        if (strcmp(x1->f_deffn,lx2)) 
	   { if (unlink(lx2) && errno != ENOENT) { return 0; }
	     if (link(x1->f_deffn,lx2)) { return 0; }
	     if (unlink(x1->f_deffn))   { return 0; }
	   }
      }
	
      return 1;
    }
#undef BUFFSIZE
#undef CREATEMASK
#undef DEFAULTFN
#undef MAXDEFFN
-----
cat >$OUT_DIR/tupl/writefile/fwrite/docu <<'-----'
   Writes the buffer to the file and closes it. If the filename given
   and the preliminary filename differ, the file will be renamed
   afterwards.

   After 'fwrite', the tuple no longer can be written and should
   be deleted.
-----
cat >$OUT_DIR/tupl/writefile/fwrite/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Str	= + cpc
-----
[ -d $OUT_DIR/tupl/writefile/hd ] || mkdir $OUT_DIR/tupl/writefile/hd
cat >$OUT_DIR/tupl/writefile/hd/ccod <<'-----'
  ELEM1 hd##_DOMAIN _FPH1(DOMAIN) { err_uop_vdmlib(MKSTRING(DOMAIN),"forall"); }
-----
cat >$OUT_DIR/tupl/writefile/hd/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/writefile/hd/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/writefile/len ] || mkdir $OUT_DIR/tupl/writefile/len
cat >$OUT_DIR/tupl/writefile/len/ccod <<'-----'
  Nat0 len##_DOMAIN _FPH1(DOMAIN) { err_uop_vdmlib(MKSTRING(DOMAIN),"forall"); }
-----
cat >$OUT_DIR/tupl/writefile/len/docu <<'-----'
  This operation is not defined for this implementation!!
-----
cat >$OUT_DIR/tupl/writefile/len/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/writefile/mk_empty ] || mkdir $OUT_DIR/tupl/writefile/mk_empty
cat >$OUT_DIR/tupl/writefile/mk_empty/ccod <<'-----'
#include <tupl/writefile/basic/defp>

#ifdef NODEFFN
  extern void get_deffn##_DOMAIN(CA char *, Nat0 CE);
#else
  static void get_deffn##_DOMAIN _FPH2(char *,Nat0) { sprintf(x1,DEFAULTFN,x2); }
#endif


  DOMAIN mk_empty##_DOMAIN _FPH0() 
    { static Nat0 f_opencnt = 0;
      DOMAIN lx1 = alloc##_DOMAIN();

      get_deffn##_DOMAIN(lx1->f_deffn,f_opencnt++);
      lx1->f_fdes = open(lx1->f_deffn,O_WRONLY | O_CREAT,CREATEMASK);
     
      if (lx1->f_fdes == -1)
	 { lx1->f_ioerr = 1; lx1->f_errno = errno; 
#ifdef NOTIFYIOERR
           notify_ioerr##_DOMAIN();
#endif
	 }
      else
	 { lx1->f_ioerr = 0; lx1->f_errno = 0; }

      lx1->f_buffelems = 0;
      return lx1;
    }
#undef BUFFSIZE
#undef CREATEMASK
#undef DEFAULTFN
#undef MAXDEFFN
-----
cat >$OUT_DIR/tupl/writefile/mk_empty/docu <<'-----'
  Special implementation of 'mk_empty'. A buffer is allocated and the
  output file is created and opened. Since the output filename usually
  will be given with the 'fwrite' operation, a preliminary filename
  will be used. The file will be renamed in the 'fwrite' operation.

  The preliminary filename can be changed in two ways:

  1.) define the parameter 'DEFAULTFN' with another string

  2.) set the flag 'NODEFFN' and supply a routine

           extern void get_deffn##_DOMAIN(char *, Nat0);
     
      which will define the first parameter with an appropriate 
      filename. This must not be longer than 'MAXDEFFN' characters. 
      The second parameter is a counter that can be used to generate
      unique filenames for multiple calls of 'mk_empty'.
-----
cat >$OUT_DIR/tupl/writefile/mk_empty/param <<'-----'
NODEFFN
DEFAULTFN
CREATEMASK
MACROS
-----
cat >$OUT_DIR/tupl/writefile/mk_empty/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
Vdmlib	= + header("FCNTL")

#define CONSTRNAME mk_empty
#define ADTNAME ADT_TUPL
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/tupl/writefile/sel ] || mkdir $OUT_DIR/tupl/writefile/sel
cat >$OUT_DIR/tupl/writefile/sel/ccod <<'-----'
ELEM1 sel##_DOMAIN _FPH2(DOMAIN,Nat1) { err_uop_vdmlib(MKSTRING(DOMAIN),"sel"); }
-----
cat >$OUT_DIR/tupl/writefile/sel/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/tupl/writefile/tl ] || mkdir $OUT_DIR/tupl/writefile/tl
cat >$OUT_DIR/tupl/writefile/tl/ccod <<'-----'
  DOMAIN sel##_DOMAIN _FPH1(DOMAIN) { err_uop_vdmlib(MKSTRING(DOMAIN),"tl"); }
-----
cat >$OUT_DIR/tupl/writefile/tl/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/unio ] || mkdir $OUT_DIR/unio
[ -d $OUT_DIR/unio/automem ] || mkdir $OUT_DIR/unio/automem
[ -d $OUT_DIR/unio/automem/basic ] || mkdir $OUT_DIR/unio/automem/basic
cat >$OUT_DIR/unio/automem/basic/ccod <<'-----'
#include <aux/automem/basic/ccod>
-----
cat >$OUT_DIR/unio/automem/basic/docu <<'-----'
#define TYPGEN union
#include <aux/automem/basic/docu>
-----
cat >$OUT_DIR/unio/automem/basic/gimp <<'-----'
#include <aux/automem/basic/gimp>
-----
cat >$OUT_DIR/unio/automem/basic/gptr <<'-----'
#include <aux/automem/basic/gptr>
-----
cat >$OUT_DIR/unio/automem/basic/gtyp <<'-----'
typedef enum {
#define MACRO1(V,_V,S,_S) MERGE(d,_S)
#define MACRO0            ,
#include <aux/com/macro1/ccod>
} discriminant##_DOMAIN;

#include <aux/automem/basic/gtyp>
-----
cat >$OUT_DIR/unio/automem/basic/param <<'-----'
BASEIMPL
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
NOCHECK
-----
cat >$OUT_DIR/unio/automem/basic/vdm <<'-----'
#ifndef BASEIMPL
#error *** Parameter 'BASEIMPL' is missing ***
#endif

#define MACRO1(V,V_,S,_S) MERGE(s,_S) : V
#define MACRO0 |

DOMAINS

  Rep##_DOMAIN  =
#include <aux/com/macro1/ccod>

  Heap##_DOMAIN	= DOMAIN -heap
  DOMAIN -> Heap##_DOMAIN
  DOMAIN -> Rep##_DOMAIN
	
IMPLEMENTATIONS

  Rep##_DOMAIN  = BASEIMPL 
                + copy ! allways needed by function cond_clone() !
  Heap##_DOMAIN = freelist ("INTERNALDOMAIN"
                           ,"MAXLEN"="100"
                           ,"PROFILE")
		+ alloc("STRUCT"="struct Handle" #_DOMAIN)
  DOMAIN        = + del ! always needed for destructor !
#ifndef NOCHECK
  Vdmlib        = + err_nv_hdl
#endif
  
#undef BASEIMPL
#undef NOCHECK

#define CONSTRNAME mk_basic
#define ADTNAME ADT_UNIO
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/automem/chg ] || mkdir $OUT_DIR/unio/automem/chg
cat >$OUT_DIR/unio/automem/chg/ccod <<'-----'
#define MACRO1(V,_V,S,_S)  DOMAIN MERGE(chg,_S) (_FP(x1,DOMAIN), _FP(x2,V))\
{\
   MERGE(check_handle,_DOMAIN)(x1);\
   MERGE(cond_clone,_DOMAIN)(&x1);\
   MERGE(del,_V)(UCNAME_REP_s(_S) (x1->f_rep) );\
   x1->f_rep = UCNAME_REP(chg,_S) (x1->f_rep, MERGE(copy,_V)(x2));\
   return x1;\
}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/chg/ccod.old <<'-----'
#define MACRO1(V,_V,S,_S)  DOMAIN MERGE(chg,_S) (_FP(x1,DOMAIN),_FP(x2,V))\
{\
   MERGE(check_handle,_DOMAIN)(x1);\
   MERGE(cond_clone,_DOMAIN)(&x1);\
   MERGE(del,_V)(MERGE(s,MERGE(_V,MERGE(_rep,_DOMAIN)))(x1->f_rep));\
   x1->f_rep = MERGE(chg,MERGE(_V,MERGE(_rep,_DOMAIN)))(x1->f_rep,MERGE(copy,_V)(x2));\
   return x1;\
}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/chg/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + chg + s

#define MACRO1(V,_V,S,_S)  V = + copy + del
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/automem/copy ] || mkdir $OUT_DIR/unio/automem/copy
cat >$OUT_DIR/unio/automem/copy/ccod <<'-----'
#include <aux/automem/copy/ccod>
-----
[ -d $OUT_DIR/unio/automem/copy1 ] || mkdir $OUT_DIR/unio/automem/copy1
cat >$OUT_DIR/unio/automem/copy1/vdm <<'-----'
! === automem: Operation union/copy1 not supported === !
-----
[ -d $OUT_DIR/unio/automem/cswitch ] || mkdir $OUT_DIR/unio/automem/cswitch
cat >$OUT_DIR/unio/automem/cswitch/vdm <<'-----'
! === automem: Operation union/cswitch not supported === !
-----
[ -d $OUT_DIR/unio/automem/cvfromtup1 ] || mkdir $OUT_DIR/unio/automem/cvfromtup1
cat >$OUT_DIR/unio/automem/cvfromtup1/ccod <<'-----'
#include <aux/automem/cvfromtup1/ccod>
-----
cat >$OUT_DIR/unio/automem/cvfromtup1/param <<'-----'
#include <aux/automem/cvfromtup1/param>
-----
cat >$OUT_DIR/unio/automem/cvfromtup1/vdm <<'-----'
#include <aux/automem/cvfromtup1/vdm>
-----
[ -d $OUT_DIR/unio/automem/cvfromtupl ] || mkdir $OUT_DIR/unio/automem/cvfromtupl
cat >$OUT_DIR/unio/automem/cvfromtupl/ccod <<'-----'
#include <aux/automem/cvfromtupl/ccod>
-----
cat >$OUT_DIR/unio/automem/cvfromtupl/param <<'-----'
#include <aux/automem/cvfromtupl/param>
-----
cat >$OUT_DIR/unio/automem/cvfromtupl/vdm <<'-----'
#include <aux/automem/cvfromtupl/vdm>
-----
[ -d $OUT_DIR/unio/automem/cvlines ] || mkdir $OUT_DIR/unio/automem/cvlines
cat >$OUT_DIR/unio/automem/cvlines/ccod <<'-----'
#include <unio/com/cvlines/ccod>

Cvtext_vdmlib cvlines##_DOMAIN _FPH1(DOMAIN)
{
   check_handle##_DOMAIN(x1);
   switch (discr##_DOMAIN(x1)) 
   {
#define MACRO1(C,_C,S,_S) case MERGE(d,_S) :\
			     return MERGE(cvlines,_S)(MERGE(s,MERGE(_S,MERGE(_rep,_DOMAIN)))(x1->f_rep));
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN));
             /* prevent waning: control reaches end of non-void function */
             return mk_empty_cvtext_vdmlib();
   }
}
-----
cat >$OUT_DIR/unio/automem/cvlines/docu <<'-----'
#include <unio/com/cvlines/docu>
-----
cat >$OUT_DIR/unio/automem/cvlines/param <<'-----'
NOTAGS
-----
cat >$OUT_DIR/unio/automem/cvlines/vdm <<'-----'
DOMAINS 
IMPLEMENTATIONS
    DOMAIN = + discr
    Rep##_DOMAIN = + s
#define MACRO1(C,_C,S,_S)    C  = + cvlines
#include <aux/com/macro1/ccod> 
-----
[ -d $OUT_DIR/unio/automem/cvtotup1 ] || mkdir $OUT_DIR/unio/automem/cvtotup1
cat >$OUT_DIR/unio/automem/cvtotup1/ccod <<'-----'
#include <aux/automem/cvtotup1/ccod>
-----
cat >$OUT_DIR/unio/automem/cvtotup1/param <<'-----'
#include <aux/automem/cvtotup1/param>
-----
cat >$OUT_DIR/unio/automem/cvtotup1/vdm <<'-----'
#include <aux/automem/cvtotup1/vdm>
-----
[ -d $OUT_DIR/unio/automem/cvtotupl ] || mkdir $OUT_DIR/unio/automem/cvtotupl
cat >$OUT_DIR/unio/automem/cvtotupl/ccod <<'-----'
#include <aux/automem/cvtotupl/ccod>
-----
cat >$OUT_DIR/unio/automem/cvtotupl/param <<'-----'
#include <aux/automem/cvtotupl/param>
-----
cat >$OUT_DIR/unio/automem/cvtotupl/vdm <<'-----'
#include <aux/automem/cvtotupl/vdm>
-----
[ -d $OUT_DIR/unio/automem/del ] || mkdir $OUT_DIR/unio/automem/del
cat >$OUT_DIR/unio/automem/del/ccod <<'-----'
#include <aux/automem/del/ccod>
-----
cat >$OUT_DIR/unio/automem/del/vdm <<'-----'
#include <aux/automem/del/vdm>
-----
[ -d $OUT_DIR/unio/automem/del1 ] || mkdir $OUT_DIR/unio/automem/del1
cat >$OUT_DIR/unio/automem/del1/vdm <<'-----'
! === automem: Operation union/del1 not required === !
-----
[ -d $OUT_DIR/unio/automem/discr ] || mkdir $OUT_DIR/unio/automem/discr
cat >$OUT_DIR/unio/automem/discr/ccod <<'-----'
discriminant##_DOMAIN discr##_DOMAIN _FPH1(DOMAIN)
{
   check_handle##_DOMAIN(x1);
   return (discriminant##_DOMAIN) discr_rep##_DOMAIN(x1->f_rep);
}
-----
cat >$OUT_DIR/unio/automem/discr/cmcr <<'-----'
_DEFINE discr##_DOMAIN(x)  (discriminant##_DOMAIN) discr_rep##_DOMAIN((x)->f_rep)
-----
cat >$OUT_DIR/unio/automem/discr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + discr
-----
[ -d $OUT_DIR/unio/automem/gcinfo ] || mkdir $OUT_DIR/unio/automem/gcinfo
cat >$OUT_DIR/unio/automem/gcinfo/ccod <<'-----'
#define Handle Nat0

/* get_gc_info1##_DOMAIN returns 0, if DOMAIN is no automem implementation */

#define MACRO1(V,_V,S,_S)  case MERGE(d,_S) : \
                               my_handle = MERGE(get_gc_info1,_V)(MERGE(s,MERGE(_V,MERGE(_rep,_DOMAIN)))(x1->f_rep),x2);\
                               break;

Handle get_gc_info1##_DOMAIN(DOMAIN x1, Adts * x2)
{
   if (!is_in_adts((Handle)x1, *x2))
   {
      Adt     my_adt;
      Handle  my_handle;
      Handles my_handles = mk_empty_handles();

      switch(discr##_DOMAIN(x1))
      {
#include <aux/com/macro1/ccod>
      }
      if (my_handle!=0) my_handles = union1_handles(my_handles,my_handle);
      /* We have to manipulate the reference counter of my_handles and my_adt
         manually because the called operations were designed to be called
         from C++ and not C ! */
_IFDEF AUTOMEM_handles
      my_handles->f_rc = 0;
_ENDIF
      my_adt = mk_adt(x1->f_rc,my_handles);
_IFDEF AUTOMEM_adt
     my_adt->f_rc = 0;
_ENDIF
      *x2    = union1_adts(*x2, (Handle) x1, my_adt);
   }
   return (Handle) x1;      
}

Adts get_gc_info##_DOMAIN(DOMAIN x1)
{
   check_handle##_DOMAIN(x1);
   Adts lx1 = mk_empty_adts();
   (void) get_gc_info1##_DOMAIN(x1, &lx1);
   return lx1;
}

#undef Handle
-----
cat >$OUT_DIR/unio/automem/gcinfo/docu <<'-----'
#include <aux/automem/gcinfo/docu>
-----
cat >$OUT_DIR/unio/automem/gcinfo/vdm <<'-----'

#define MACRO1(V,_V,S,_S) V = + gcinfo

DOMAINS
IMPLEMENTATIONS
   DOMAIN = + discr 
   Rep##_DOMAIN = + s
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/automem/hash ] || mkdir $OUT_DIR/unio/automem/hash
cat >$OUT_DIR/unio/automem/hash/ccod <<'-----'
#define NAME hash
#define RESULT Nat0
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/unio/automem/hash/cmcr <<'-----'
#define NAME hash
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/unio/automem/hash/vdm <<'-----'
#define NAME hash
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/unio/automem/input ] || mkdir $OUT_DIR/unio/automem/input
cat >$OUT_DIR/unio/automem/input/vdm <<'-----'
! === automem: Operation union/input not supported === !
-----
[ -d $OUT_DIR/unio/automem/is ] || mkdir $OUT_DIR/unio/automem/is
cat >$OUT_DIR/unio/automem/is/ccod <<'-----'
#define MACRO1(V,_V,S,_S)  Bool MERGE(is,_S) _FPH1(DOMAIN)\
                           {\
                              MERGE(check_handle,_DOMAIN)(x1);\
                              return UCNAME_REP(is,_S)(x1->f_rep);\
                           }
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/is/cmcr <<'-----'
#define MACRO1(V,_V,S,_S)  _DEFINE MERGE(is,_S)(x) UCNAME_REP(is,_S)((x)->f_rep)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/is/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + is
-----
[ -d $OUT_DIR/unio/automem/is_eq ] || mkdir $OUT_DIR/unio/automem/is_eq
cat >$OUT_DIR/unio/automem/is_eq/ccod <<'-----'
#define NAME is_eq
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/unio/automem/is_eq/cmcr <<'-----'
#define NAME is_eq
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/unio/automem/is_eq/vdm <<'-----'
#define NAME is_eq
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/unio/automem/is_ge ] || mkdir $OUT_DIR/unio/automem/is_ge
cat >$OUT_DIR/unio/automem/is_ge/ccod <<'-----'
#define NAME is_ge
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/unio/automem/is_ge/cmcr <<'-----'
#define NAME is_ge
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/unio/automem/is_ge/vdm <<'-----'
#define NAME is_ge
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/unio/automem/is_gr ] || mkdir $OUT_DIR/unio/automem/is_gr
cat >$OUT_DIR/unio/automem/is_gr/ccod <<'-----'
#define NAME is_gr
#define PTYPE1 DOMAIN
#define PTYPE2 DOMAIN
#include <aux/automem/attribute/ccod>
-----
cat >$OUT_DIR/unio/automem/is_gr/cmcr <<'-----'
#define NAME is_gr
#define TWO_PARAM
#include <aux/automem/attribute/cmcr>
-----
cat >$OUT_DIR/unio/automem/is_gr/vdm <<'-----'
#define NAME is_gr
#include <aux/automem/attribute/vdm>
-----
[ -d $OUT_DIR/unio/automem/mk ] || mkdir $OUT_DIR/unio/automem/mk
cat >$OUT_DIR/unio/automem/mk/ccod <<'-----'
#define MACRO1(V,_V,S,_S)  DOMAIN MERGE(mk,_S) _FPH1(V)\
{\
   DOMAIN lx = MERGE(alloc,_DOMAIN)();\
   lx->f_rc  = 1;\
   lx->f_rep = UCNAME_REP(mk,_S)(MERGE(copy,_V)(x1));\
   return lx;\
}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/mk/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + mk
#define MACRO1(V,_V,S,_S)  V = + copy
#include <aux/com/macro1/ccod>

#define CONSTRNAME mk
#define ADTNAME ADT_UNIO
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/automem/ovwrt ] || mkdir $OUT_DIR/unio/automem/ovwrt
cat >$OUT_DIR/unio/automem/ovwrt/ccod <<'-----'
/* In dieser Operation wird der ganze Rep##_DOMAIN anstelle nur des 
   eigentlichen Elementes geloescht. Dies ist vorteilhaft, da dann nicht in
   jeder erzeugten ovwrt-Funktion ein switch-Statement zur Bestimmung des 
   aktuellen Typs des Unions notwendig ist ! Nachteil: etwas hoeherer Overhead */

#define MACRO1(V,_V,S,_S)  DOMAIN MERGE(ovwrt,_S) _FPH2(DOMAIN,V)\
{\
   MERGE(check_handle,_DOMAIN)(x1);\
   MERGE(cond_clone,_DOMAIN)(&x1);\
   MERGE(del_rep,_DOMAIN)(x1->f_rep);\
   x1->f_rep = UCNAME_REP(mk,_S)(MERGE(copy,_V)(x2));\
   return x1;\
}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/ovwrt/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + ovwrt
#define MACRO1(V,_V,S,_S)  V = + copy 
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/automem/parse ] || mkdir $OUT_DIR/unio/automem/parse
cat >$OUT_DIR/unio/automem/parse/ccod <<'-----'

DOMAIN parse##_DOMAIN _FPH0()
{   
   char *lx1  = readtoken_vdmlib(#DOMAIN);
   char *lx2  = lx1 + 2;	/* points to optional name */
   DOMAIN lx3 = alloc##_DOMAIN();
   lx3->f_rc   = 1;

   if (strncmp(lx1,"mk",2) != 0) { expected_vdmlib(#DOMAIN,"mk",lx1); }
   expect_vdmlib("(",#DOMAIN);
#define MACRO0
#define MACRO1(C,_C,S,_S) if (strcmp(lx2,#_S) == 0)\
                          {\
                             lx3->f_rep = UCNAME_REP(mk,_S)(parse##_C());\
                             goto OK;\
                          } 
#include <aux/com/macro1/ccod>
     expected_vdmlib(#DOMAIN,"legal variant constructor",lx1);
 OK: expect_vdmlib(")",#DOMAIN);
     return lx3;
}
-----
cat >$OUT_DIR/unio/automem/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + mk
   Vdmlib       = + parsesup + header("STRING")
#define MACRO1(C,_C,S,_S) C = + parse
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/automem/pr ] || mkdir $OUT_DIR/unio/automem/pr
cat >$OUT_DIR/unio/automem/pr/vdm <<'-----'
! === automem: Operation union/pr not supported === !
-----
[ -d $OUT_DIR/unio/automem/s ] || mkdir $OUT_DIR/unio/automem/s
cat >$OUT_DIR/unio/automem/s/ccod <<'-----'
#define MACRO1(V,_V,S,_S)  V  TSNAME(S,_S) _FPH1(DOMAIN)\
                           {\
                              MERGE(check_handle,_DOMAIN)(x1);\
                              return MERGE(copy,_V)(UCNAME_REP_s(_S)(x1->f_rep));\
                           }
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/s/cmcr <<'-----'
#define MACRO1(V,_V,S,_S) _DEFINE TSNAME(S,_S)(x1) \
                              MERGE(copy,_V)(UCNAME_REP(s,_S)(x1->f_rep))

#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/automem/s/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Rep##_DOMAIN = + s
#define MACRO1(V,_V,S,_S) V = + copy
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/automem/subst ] || mkdir $OUT_DIR/unio/automem/subst
cat >$OUT_DIR/unio/automem/subst/README <<'-----'
The operation 'subst' is implemented as C++ member function by using 'chg' !
Please refer to unio/sign/subst/cpp for more information.
-----
cat >$OUT_DIR/unio/automem/subst/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN = + chg
-----
[ -d $OUT_DIR/unio/automem/switchcpp ] || mkdir $OUT_DIR/unio/automem/switchcpp
cat >$OUT_DIR/unio/automem/switchcpp/vdm <<'-----'
! === automem: Operation union/switch not supported === !
-----
[ -d $OUT_DIR/unio/aux ] || mkdir $OUT_DIR/unio/aux
[ -d $OUT_DIR/unio/aux/basic ] || mkdir $OUT_DIR/unio/aux/basic
cat >$OUT_DIR/unio/aux/basic/docu <<'-----'
    "SMALLTYPE":
                 The generation of union types implies the 
		 generation of an enumeration type called
                 discriminant##_DOMAIN containing the names
		 of the different discriminants derived from 
		 the selector given in the domain equations.

		 An enumeration in C is represented
		 by an unsigned integer type with additional
		 constant definitions. In languages like Pascal
		 or Modula2 usually subrange types of the form
		 (0 .. #elements) are used to implement enume-
		 rations. These normally only occupy as less
		 storage as possible (i.e. one byte for less
		 than 256 elements,...). If "SMALLTYPE" is 
                 set this allocation strategy will be followed
		 up. By default normal C enumerations are
		 generated. Check which strategy will be the
		 one needed for you when using these C implemen-
		 tations from Pascal, Modula, etc. This option
                 therefore should be used when using C implementaions
		 from Modula-2 or Pascal programs.
-----
cat >$OUT_DIR/unio/aux/basic/gtyp <<'-----'
#ifdef GEN_C

  enum Enum##_DOMAIN {
#define MACRO1(V,_V,S,_S)                MERGE(d,_S)
#define MACRO0                ,
#include <aux/com/macro1/ccod>

#ifdef SMALLTYPE
                    };

/* determine the actual type fitting to the number of elems   */
#ifdef ELEM65536
  typedef unsigned long discriminant##_DOMAIN;
#else
#ifdef ELEM256
  typedef unsigned short discriminant##_DOMAIN;
#else
  typedef unsigned char discriminant##_DOMAIN;
#endif
#endif

#else
	    }; typedef enum Enum##_DOMAIN discriminant##_DOMAIN;
#endif

#else

  START_ENUM_TYP(discriminant##_DOMAIN)
#define MACRO1(V,_V,S,_S)     IDF_(MERGE(d,_S))
#define MACRO0     ,
#include <aux/com/macro1/ccod>
                         END_ENUM_TYP(discriminant##_DOMAIN)

#endif
-----
[ -d $OUT_DIR/unio/com ] || mkdir $OUT_DIR/unio/com
[ -d $OUT_DIR/unio/com/basic ] || mkdir $OUT_DIR/unio/com/basic
cat >$OUT_DIR/unio/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/unio/com/basic/bb1 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Domain1 =
   s_u1_1: Elem

Domain2 =
   s_u2_1: Elem |
   s_u2_2: BASIC

Domain5 =
   s_u5_1: Elem |
   s_u5_2: BASIC   |
   s_u5_3: Elem |
   s_u5_4: BASIC   |
   s_u5_5: Elem

IMPLEMENTATIONS

Nat0   = + is_eq

Vdmlib = + abort(VDMERROR="vdmerr(x1)")

Domain1 = IMPLEMENTATION1

   + mk

   + copy1
   + copy
   + chg
   + subst
   + ovwrt
   + s

   + is_eq
   + is
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + discr

   + cswitch.csw(RESULT=Bool, XX=Elem,XXX=BASIC,XXXX=Bool)
   + sswitch.ssw(RESULT=Bool, XX=Elem,XXX=BASIC,XXXX=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

Domain2 = IMPLEMENTATION1

   + mk

   + copy1
   + copy
   + chg
   + subst
   + ovwrt
   + s

   + is_eq
   + is
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + discr

   + cswitch.csw(RESULT=Bool, XX=Elem,XXX=BASIC,XXXX=Bool)
   + sswitch.ssw(RESULT=Bool, XX=Elem,XXX=BASIC,XXXX=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

Domain5 = IMPLEMENTATION1

   + mk

   + copy1
   + copy
   + chg
   + subst
   + ovwrt
   + s

   + is_eq
   + is
#ifdef ISORDERED
   + is_gr
   + is_ge
#endif

   + discr

   + cswitch.csw(RESULT=Bool, XX=Elem,XXX=BASIC,XXXX=Bool)
   + sswitch.ssw(RESULT=Bool, XX=Elem,XXX=BASIC,XXXX=Bool)

   + cvfromtupl
   + cvtotupl

   + hash
   + del1
   + del

   + print + fprint
   + pr
   + fpr
   + finput

-----
cat >$OUT_DIR/unio/com/basic/bb2 <<'-----'
#include <stdlib/com/setup/bb>

DOMAINS

Elem =
   s_u_1: BASIC |
   s_u_2: BASIC

IMPLEMENTATIONS

Elem = IMPLEMENTATION2

   + mk

   + is_eq
   + is_gr
   + is_ge

-----
cat >$OUT_DIR/unio/com/basic/bbc <<'-----'
#include <aux/com/basic/bbc1>

#define DD
#define D_
#define EE
#define E_

Bool csw##_elem ( elem, vxx, vxxx, vxxxx )

  Elem elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return is_eq##_elem( elem, vxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool csw##_BASIC ( elem, vxx, vxxx, vxxxx )

  BASIC elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return ( elem == vxxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u1_1 ( elem, vxx, vxxx, vxxxx )

  Elem elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return is_eq##_elem( elem, vxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u2_1 ( elem, vxx, vxxx, vxxxx )

  Elem elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return is_eq##_elem( elem, vxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u2_2 ( elem, vxx, vxxx, vxxxx )

  BASIC elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return ( elem == vxxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u5_1 ( elem, vxx, vxxx, vxxxx )

  Elem elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return is_eq##_elem( elem, vxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u5_2 ( elem, vxx, vxxx, vxxxx )

  BASIC elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return ( elem == vxxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u5_3 ( elem, vxx, vxxx, vxxxx )

  Elem elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return is_eq##_elem( elem, vxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u5_4 ( elem, vxx, vxxx, vxxxx )

  BASIC elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return ( elem == vxxx ) && ( vxxxx == TRUE ); }

/*------------------------------------------------------------------------------------------------*/

Bool ssw_u5_5 ( elem, vxx, vxxx, vxxxx )

  Elem elem;
  Elem vxx; BASIC vxxx; Bool vxxxx;

{ return is_eq##_elem( elem, vxx ) && ( vxxxx == TRUE ); }

#include <aux/com/basic/bbid2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_u1_1( mk_u1_1(@X@) ), @X@ ) )
       myerr(@n@,"mk_u1_1()","@X@");
@) }

/*================================================================================================*/

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain1( chg_u1_1( mk_u1_1(@Y@), @X@ ), mk_u1_1(@X@) ) )
       myerr(@n@,"chg_u1_1()","u1_1(@Y@),@X@");
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain1( subst_u1_1( mk_u1_1(@Y@), @X@ ), mk_u1_1(@X@) ) )
       myerr(@n@,"subst_u1_1()","u1_1(@Y@),@X@");
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain1( ovwrt_u1_1( mk_u1_1(@Y@), @X@ ), mk_u1_1(@X@) ) )
       myerr(@n@,"ovwrt_u1_1()","u1_1(@Y@),@X@");
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_u1_1( mk_u1_1(@X@) ), @X@ ) )
       myerr(@n@,"s_u1_1()","u1_1(@X@)");
@) }

/*================================================================================================*/

#define ARG mk_u1_1(@X@)
#define REPEAT
#define NO 1
#include <aux/com/is_eq/bbc2>

#define ARG mk_u1_1(@X@)
#define ARG2 mk_u1_1(@Y@)
#define NO 1
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_u1_1( mk_u1_1(@X@) ) )
       myerr(@n@,"is_u1_1()","u1_1(@X@)");
@) }

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain1( mk_u1_1(@Y@), mk_u1_1(@Y@) ) )
       myerr(@n@,"is_gr()","u1_1(@Y@),u1_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain1( mk_u1_1(@Y@), mk_u1_1(@Z@) ) )
       myerr(@n@,"is_gr()","u1_1(@Y@),u1_1(@Z@)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain1( mk_u1_1(@Z@), mk_u1_1(@Y@) ) )
       myerr(@n@,"is_gr()","u1_1(@Z@),u1_1(@Y@)");
   }
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain1( mk_u1_1(@Y@), mk_u1_1(@Y@) ) )
       myerr(@n@,"is_ge()","u1_1(@Y@),u1_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_ge##_domain1( mk_u1_1(@Y@), mk_u1_1(@Z@) ) )
       myerr(@n@,"is_ge()","u1_1(@Y@),u1_1(@Z@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain1( mk_u1_1(@Z@), mk_u1_1(@Y@) ) )
       myerr(@n@,"is_ge()","u1_1(@Z@),u1_1(@Y@)");
   }
  
#endif
/*================================================================================================*/

   void p_@N@()
   {
@(   switch( discr##_domain1( mk_u1_1(@X@) ) )
     { case d_u1_1: /* ok */
                    break;
       default:     myerr(@n@,"discr()","u1_1(@X@)");
     }
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( csw##_domain1( mk_u1_1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u1_1(@X@),@X@,aaa");
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( ssw##_domain1( mk_u1_1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u1_1(@X@),@X@,aaa");
@) }

/*================================================================================================*/

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#define DOMAIN_ Domain1
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG mk_u1_1(@X@)
#define NO 1
#define REPEAT
#include <aux/com/fpr/bbc2>

/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"\n<the end> of UNIO1\n");
   }

/*================================================================================================*/
/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"<start> of UNIO2\n\n");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_u2_1( mk_u2_1(@X@) ), @X@ ) )
       myerr(@n@,"mk_u2_1()","@X@");
@) }

   void p_@N@()
   { if(! ( s_u2_2( mk_u2_2(aaa) ) == aaa ) )
       myerr(@n@,"mk_u2_2()","aaa");
   }

/*================================================================================================*/

#define ARG mk_u2_1(@X@)
#define NO 2
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/copy1/bbc2>

#define ARG mk_u2_1(@X@)
#define NO 2
#define REPEAT
#include <aux/com/copy/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain2( chg_u2_1( mk_u2_1(@Y@), @X@ ), mk_u2_1(@X@) ) )
       myerr(@n@,"chg_u2_1()","u2_1(@Y@),@X@");
@) }

   void p_@N@()
   { if(! is_eq##_domain2( chg_u2_2( mk_u2_2(aaa), bbb ), mk_u2_2(bbb) ) )
       myerr(@n@,"chg_u2_2()","u2_2(aaa),bbb");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain2( subst_u2_1( mk_u2_1(@Y@), @X@ ), mk_u2_1(@X@) ) )
       myerr(@n@,"subst_u2_1()","u2_1(@Y@),@X@");
@) }

   void p_@N@()
   { if(! is_eq##_domain2( subst_u2_2( mk_u2_2(aaa), bbb ), mk_u2_2(bbb) ) )
       myerr(@n@,"subst_u2_2()","u2_2(aaa),bbb");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain2( ovwrt_u2_1( mk_u2_1(@Y@), @X@ ), mk_u2_1(@X@) ) )
       myerr(@n@,"ovwrt_u2_1()","u2_1(@Y@),@X@");
@) }

   void p_@N@()
   { if(! is_eq##_domain2( ovwrt_u2_2( mk_u2_2(aaa), bbb ), mk_u2_2(bbb) ) )
       myerr(@n@,"ovwrt_u2_2()","u2_2(aaa),bbb");
   }

   void p_@N@()
   {
@(   if(! is_eq##_domain2( ovwrt_u2_1( mk_u2_2(aaa), @X@ ), mk_u2_1(@X@) ) )
       myerr(@n@,"ovwrt_u2_1()","u2_2(aaa),@X@");
@) }

   void p_@N@()
   {
@(   if(! is_eq##_domain2( ovwrt_u2_2( mk_u2_1(@X@), aaa ), mk_u2_2(aaa) ) )
       myerr(@n@,"ovwrt_u2_2()","u2_1(@X@),aaa");
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_u2_1( mk_u2_1(@X@) ), @X@ ) )
       myerr(@n@,"s_u2_1()","u2_1(@X@)");
@) }

   void p_@N@()
   { if( s_u2_2( mk_u2_2(aaa) ) != aaa )
       myerr(@n@,"s_u2_2()","u2_2(aaa)");
   }

/*================================================================================================*/

#define ARG mk_u2_1(@X@)
#define REPEAT
#define NO 2
#include <aux/com/is_eq/bbc2>

#define ARG mk_u2_1(@X@)
#define ARG2 mk_u2_1(@Y@)
#define NO 2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u2_1(@X@)
#define ARG2 mk_u2_2(aaa)
#define NO 2
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/is_eq/bbc2>

#define ARG mk_u2_2(aaa)
#define ARG2 mk_u2_1(@X@)
#define NEG
#define NO 2
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_u2_1( mk_u2_1(@X@) ) )
       myerr(@n@,"is_u2_1()","u2_1(@X@)");
@) }

   void p_@N@()
   { if( is_u2_1( mk_u2_2(aaa) ) )
       myerr(@n@,"is_u2_1()","u2_2(aaa)");
   }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if( is_u2_2( mk_u2_1(@X@) ) )
       myerr(@n@,"is_u2_2()","u2_1(@X@)");
@) }

   void p_@N@()
   { if(! is_u2_2( mk_u2_2(aaa) ) )
       myerr(@n@,"is_u2_2()","u2_2(aaa)");
   }

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain2( mk_u2_1(@Y@), mk_u2_1(@Y@) ) )
       myerr(@n@,"is_gr()","u2_1(@Y@),u2_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain2( mk_u2_1(@Y@), mk_u2_1(@Z@) ) )
       myerr(@n@,"is_gr()","u2_1(@Y@),u2_1(@Z@)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain2( mk_u2_1(@Z@), mk_u2_1(@Y@) ) )
       myerr(@n@,"is_gr()","u2_1(@Z@),u2_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain2( mk_u2_2(aaa), mk_u2_2(aaa) ) )
       myerr(@n@,"is_gr()","u2_2(aaa),u2_2(aaa)");
   }
  
  /* ---------------------------------------------------------
  removed by HMH, since there is no order on aaa,bbb,ccc,...

   void p_@N@()
   { if( is_gr##_domain2( mk_u2_2(aaa), mk_u2_2(bbb) ) )
       myerr(@n@,"is_gr()","u2_2(aaa),u2_2(bbb)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain2( mk_u2_2(bbb), mk_u2_2(aaa) ) )
       myerr(@n@,"is_gr()","u2_2(bbb),u2_2(aaa)");
   }

  ------------------------------------------------------------*/
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain2( mk_u2_1(@Y@), mk_u2_1(@Y@) ) )
       myerr(@n@,"is_ge()","u2_1(@Y@),u2_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_ge##_domain2( mk_u2_1(@Y@), mk_u2_1(@Z@) ) )
       myerr(@n@,"is_ge()","u2_1(@Y@),u2_1(@Z@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain2( mk_u2_1(@Z@), mk_u2_1(@Y@) ) )
       myerr(@n@,"is_ge()","u2_1(@Z@),u2_1(@Y@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain2( mk_u2_2(aaa), mk_u2_2(aaa) ) )
       myerr(@n@,"is_ge()","u2_2(aaa),u2_2(aaa)");
   }
  
  /* ---------------------------------------------------------
  removed by HMH, since there is no order on aaa,bbb,ccc,...

   void p_@N@()
   { if( is_ge##_domain2( mk_u2_2(aaa), mk_u2_2(bbb) ) )
       myerr(@n@,"is_ge()","u2_2(aaa),u2_2(bbb)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain2( mk_u2_2(bbb), mk_u2_2(aaa) ) )
       myerr(@n@,"is_ge()","u2_2(bbb),u2_2(aaa)");
   }
  ------------------------------------------------------------*/ 
#endif
/*================================================================================================*/

   void p_@N@()
   {
@(   switch( discr##_domain2( mk_u2_1(@X@) ) )
     { case d_u2_1: /* ok */
                    break;
       case d_u2_2: myerr(@n@,"discr() /1","u2_1(@X@)");
                    break;
       default:     myerr(@n@,"discr() /2","u2_1(@X@)");
     }
@) }

   void p_@N@()
   { switch( discr##_domain2( mk_u2_2(aaa) ) )
     { case d_u2_2: /* ok */
                    break;
       case d_u2_1: myerr(@n@,"discr() /1","u2_2(aaa)");
                    break;
       default:     myerr(@n@,"discr() /2","u2_2(aaa)");
     }
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( csw##_domain2( mk_u2_1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u2_1(@X@),@X@,aaa");
@) }

   void p_@N@()
   { if( csw##_domain2( mk_u2_2(aaa), aaa, @Y@, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u2_2(aaa),@Y@,aaa");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( ssw##_domain2( mk_u2_1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u2_1(@X@),@X@,aaa");
@) }

   void p_@N@()
   { if( ssw##_domain2( mk_u2_2(aaa), @Y@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u2_2(aaa),@Y@,aaa");
   }

/*================================================================================================*/

#define ARG mk_u2_1(@X@)
#define NO 2
#define REPEAT
#define DOMAIN_ Domain2
#include <aux/com/cvtotupl/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#define DOMAIN_ Domain2
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/

#define ARG mk_u2_1(@X@)
#define NO 2
#define REPEAT
#include <aux/com/hash/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/hash/bbc2>

/*================================================================================================*/

#define ARG mk_u2_1(@X@)
#define NO 2
#define REPEAT
#include <aux/com/del1/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG mk_u2_1(@X@)
#define NO 2
#define REPEAT
#include <aux/com/del/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG mk_u2_1(@X@)
#define NO 2
#define REPEAT
#include <aux/com/print/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG mk_u2_1(@X@)
#define REPEAT
#define NO 2
#include <aux/com/pr/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG mk_u2_1(@X@)
#define REPEAT
#define NO 2
#include <aux/com/fpr/bbc2>

#define ARG mk_u2_2(aaa)
#define NO 2
#include <aux/com/fpr/bbc2>

/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"\n<the end> of UNIO2\n");
   }

/*================================================================================================*/
/*================================================================================================*/

   void p_@N@()
   { fprintf(stderr,"<start> of UNIO5\n\n");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_u5_1( mk_u5_1(@X@) ), @X@ ) )
       myerr(@n@,"mk_u5_1()","@X@");
     if(! is_eq##_elem( s_u5_3( mk_u5_3(@X@) ), @X@ ) )
       myerr(@n@,"mk_u5_3()","@X@");
     if(! is_eq##_elem( s_u5_5( mk_u5_5(@X@) ), @X@ ) )
       myerr(@n@,"mk_u5_5()","@X@");
@) }

   void p_@N@()
   { if(! ( s_u5_2( mk_u5_2(aaa) ) == aaa ) )
       myerr(@n@,"mk_u5_2()","aaa");
     if(! ( s_u5_4( mk_u5_4(aaa) ) == aaa ) )
       myerr(@n@,"mk_u5_4()","aaa");
   }

/*================================================================================================*/

#define ARG mk_u5_1(@X@)
#define NO 5
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/copy1/bbc2>

#define ARG mk_u5_3(@X@)
#define NO 5
#define REPEAT
#include <aux/com/copy1/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/copy1/bbc2>

#define ARG mk_u5_5(@X@)
#define NO 5
#define REPEAT
#include <aux/com/copy1/bbc2>


#define ARG mk_u5_1(@X@)
#define NO 5
#define REPEAT
#include <aux/com/copy/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/copy/bbc2>

#define ARG mk_u5_3(@X@)
#define NO 5
#define REPEAT
#include <aux/com/copy/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/copy/bbc2>

#define ARG mk_u5_5(@X@)
#define NO 5
#define REPEAT
#include <aux/com/copy/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain5( chg_u5_1( mk_u5_1(@Y@), @X@ ), mk_u5_1(@X@) ) )
       myerr(@n@,"chg_u5_1()","u5_1(@Y@),@X@");
     if(! is_eq##_domain5( chg_u5_3( mk_u5_3(@Y@), @X@ ), mk_u5_3(@X@) ) )
       myerr(@n@,"chg_u5_3()","u5_3(@Y@),@X@");
     if(! is_eq##_domain5( chg_u5_5( mk_u5_5(@Y@), @X@ ), mk_u5_5(@X@) ) )
       myerr(@n@,"chg_u5_5()","u5_5(@Y@),@X@");
@) }

   void p_@N@()
   { if(! is_eq##_domain5( chg_u5_2( mk_u5_2(aaa), bbb ), mk_u5_2(bbb) ) )
       myerr(@n@,"chg_u5_2()","u5_2(aaa),bbb");
     if(! is_eq##_domain5( chg_u5_4( mk_u5_4(aaa), bbb ), mk_u5_4(bbb) ) )
       myerr(@n@,"chg_u5_4()","u5_4(aaa),bbb");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain5( subst_u5_1( mk_u5_1(@Y@), @X@ ), mk_u5_1(@X@) ) )
       myerr(@n@,"subst_u5_1()","u5_1(@Y@),@X@");
     if(! is_eq##_domain5( subst_u5_3( mk_u5_3(@Y@), @X@ ), mk_u5_3(@X@) ) )
       myerr(@n@,"subst_u5_3()","u5_3(@Y@),@X@");
     if(! is_eq##_domain5( subst_u5_5( mk_u5_5(@Y@), @X@ ), mk_u5_5(@X@) ) )
       myerr(@n@,"subst_u5_5()","u5_5(@Y@),@X@");
@) }

   void p_@N@()
   { if(! is_eq##_domain5( subst_u5_2( mk_u5_2(aaa), bbb ), mk_u5_2(bbb) ) )
       myerr(@n@,"subst_u5_2()","u5_2(aaa),bbb");
     if(! is_eq##_domain5( subst_u5_4( mk_u5_4(aaa), bbb ), mk_u5_4(bbb) ) )
       myerr(@n@,"subst_u5_4()","u5_4(aaa),bbb");
   }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_domain5( ovwrt_u5_1( mk_u5_1(@Y@), @X@ ), mk_u5_1(@X@) ) )
       myerr(@n@,"ovwrt_u5_1()","u5_1(@Y@),@X@");
     if(! is_eq##_domain5( ovwrt_u5_3( mk_u5_3(@Y@), @X@ ), mk_u5_3(@X@) ) )
       myerr(@n@,"ovwrt_u5_3()","u5_3(@Y@),@X@");
     if(! is_eq##_domain5( ovwrt_u5_5( mk_u5_5(@Y@), @X@ ), mk_u5_5(@X@) ) )
       myerr(@n@,"ovwrt_u5_5()","u5_5(@Y@),@X@");
@) }

   void p_@N@()
   { if(! is_eq##_domain5( ovwrt_u5_2( mk_u5_2(aaa), bbb ), mk_u5_2(bbb) ) )
       myerr(@n@,"ovwrt_u5_2()","u5_2(aaa),bbb");
     if(! is_eq##_domain5( ovwrt_u5_4( mk_u5_4(aaa), bbb ), mk_u5_4(bbb) ) )
       myerr(@n@,"ovwrt_u5_4()","u5_4(aaa),bbb");
   }

   void p_@N@()
   {
@(   if(! is_eq##_domain5( ovwrt_u5_1( mk_u5_2(aaa), @X@ ), mk_u5_1(@X@) ) )
       myerr(@n@,"ovwrt_u5_1()","u5_2(@Y@),@X@");
     if(! is_eq##_domain5( ovwrt_u5_3( mk_u5_2(aaa), @X@ ), mk_u5_3(@X@) ) )
       myerr(@n@,"ovwrt_u5_3()","u5_2(@Y@),@X@");
     if(! is_eq##_domain5( ovwrt_u5_5( mk_u5_2(aaa), @X@ ), mk_u5_5(@X@) ) )
       myerr(@n@,"ovwrt_u5_5()","u5_2(@Y@),@X@");
@) }

   void p_@N@()
   {
@(   if(! is_eq##_domain5( ovwrt_u5_2( mk_u5_1(@X@), aaa ), mk_u5_2(aaa) ) )
       myerr(@n@,"ovwrt_u5_2()","u5_1(aaa),aaa");
     if(! is_eq##_domain5( ovwrt_u5_4( mk_u5_1(@X@), aaa ), mk_u5_4(aaa) ) )
       myerr(@n@,"ovwrt_u5_4()","u5_1(aaa),aaa");
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_eq##_elem( s_u5_1( mk_u5_1(@X@) ), @X@ ) )
       myerr(@n@,"s_u5_1()","u5_1(@X@)");
     if(! is_eq##_elem( s_u5_3( mk_u5_3(@X@) ), @X@ ) )
       myerr(@n@,"s_u5_3()","u5_3(@X@)");
     if(! is_eq##_elem( s_u5_5( mk_u5_5(@X@) ), @X@ ) )
       myerr(@n@,"s_u5_5()","u5_5(@X@)");
@) }

   void p_@N@()
   { if( s_u5_2( mk_u5_2(aaa) ) != aaa )
       myerr(@n@,"s_u5_2()","u5_2(aaa)");
     if( s_u5_4( mk_u5_4(aaa) ) != aaa )
       myerr(@n@,"s_u5_4()","u5_4(aaa)");
   }

/*================================================================================================*/

#define ARG mk_u5_1(@X@)
#define REPEAT
#define NO 5
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_1(@X@)
#define ARG2 mk_u5_1(@Y@)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_1(@X@)
#define ARG2 mk_u5_2(aaa)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_2(aaa)
#define ARG2 mk_u5_2(bbb)
#define NO 5
#define NEG
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_2(aaa)
#define ARG2 mk_u5_1(@X@)
#define NEG
#define NO 5
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_3(@X@)
#define REPEAT
#define NO 5
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_3(@X@)
#define ARG2 mk_u5_3(@Y@)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_3(@X@)
#define ARG2 mk_u5_2(aaa)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_4(aaa)
#define ARG2 mk_u5_4(bbb)
#define NO 5
#define NEG
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_4(aaa)
#define ARG2 mk_u5_1(@X@)
#define NEG
#define NO 5
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_5(@X@)
#define REPEAT
#define NO 5
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_5(@X@)
#define ARG2 mk_u5_5(@Y@)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

#define ARG mk_u5_5(@X@)
#define ARG2 mk_u5_2(aaa)
#define NO 5
#define NEG
#define REPEAT
#include <aux/com/is_eq/bbc2>

/*================================================================================================*/

   void p_@N@()
   {
@(   if(! is_u5_1( mk_u5_1(@X@) ) )
       myerr(@n@,"is_u5_1()","u5_1(@X@)");
@) }

   void p_@N@()
   { if( is_u5_1( mk_u5_2(aaa) ) )
       myerr(@n@,"is_u5_1()","u5_2(aaa)");
   }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if( is_u5_2( mk_u5_1(@X@) ) )
       myerr(@n@,"is_u5_2()","u5_1(@X@)");
@) }

   void p_@N@()
   { if(! is_u5_2( mk_u5_2(aaa) ) )
       myerr(@n@,"is_u5_2()","u5_2(aaa)");
   }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_u5_3( mk_u5_3(@X@) ) )
       myerr(@n@,"is_u5_3()","u5_3(@X@)");
@) }

   void p_@N@()
   { if( is_u5_3( mk_u5_2(aaa) ) )
       myerr(@n@,"is_u5_3()","u5_2(aaa)");
   }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if( is_u5_4( mk_u5_1(@X@) ) )
       myerr(@n@,"is_u5_4()","u5_1(@X@)");
@) }

   void p_@N@()
   { if(! is_u5_4( mk_u5_4(aaa) ) )
       myerr(@n@,"is_u5_4()","u5_4(aaa)");
   }

/*------------------------------------------------------------------------------------------------*/

   void p_@N@()
   {
@(   if(! is_u5_5( mk_u5_5(@X@) ) )
       myerr(@n@,"is_u5_5()","u5_5(@X@)");
@) }

   void p_@N@()
   { if( is_u5_5( mk_u5_2(aaa) ) )
       myerr(@n@,"is_u5_5()","u5_2(aaa)");
   }

/*================================================================================================*/

#ifdef ISORDERED
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_1(@Y@), mk_u5_1(@Y@) ) )
       myerr(@n@,"is_gr()","u5_1(@Y@),u5_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_1(@Y@), mk_u5_1(@Z@) ) )
       myerr(@n@,"is_gr()","u5_1(@Y@),u5_1(@Z@)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain5( mk_u5_1(@Z@), mk_u5_1(@Y@) ) )
       myerr(@n@,"is_gr()","u5_1(@Z@),u5_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_2(aaa), mk_u5_2(aaa) ) )
       myerr(@n@,"is_gr()","u5_2(aaa),u5_2(aaa)");
   }
  
   /*---------------------------------------------------------
   removed by HMH, since aaa,bbb,... is not ordered

   void p_@N@()
   { if( is_gr##_domain5( mk_u5_2(aaa), mk_u5_2(bbb) ) )
       myerr(@n@,"is_gr()","u5_2(aaa),u5_2(bbb)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain5( mk_u5_2(bbb), mk_u5_2(aaa) ) )
       myerr(@n@,"is_gr()","u5_2(bbb),u5_2(aaa)");
   }
  
   --------------------------------------------------------------*/
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_3(@Y@), mk_u5_3(@Y@) ) )
       myerr(@n@,"is_gr()","u5_3(@Y@),u5_3(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_3(@Y@), mk_u5_3(@Z@) ) )
       myerr(@n@,"is_gr()","u5_3(@Y@),u5_3(@Z@)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain5( mk_u5_3(@Z@), mk_u5_3(@Y@) ) )
       myerr(@n@,"is_gr()","u5_3(@Z@),u5_3(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_4(aaa), mk_u5_4(aaa) ) )
       myerr(@n@,"is_gr()","u5_4(aaa),u5_4(aaa)");
   }
  
   /*---------------------------------------------------------
   removed by HMH, since aaa,bbb,... is not ordered

   void p_@N@()
   { if( is_gr##_domain5( mk_u5_4(aaa), mk_u5_4(bbb) ) )
       myerr(@n@,"is_gr()","u5_4(aaa),u5_4(bbb)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain5( mk_u5_4(bbb), mk_u5_4(aaa) ) )
       myerr(@n@,"is_gr()","u5_4(bbb),u5_4(aaa)");
   }

   -------------------------------------------------------------*/
  
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_5(@Y@), mk_u5_5(@Y@) ) )
       myerr(@n@,"is_gr()","u5_5(@Y@),u5_5(@Y@)");
   }
  
   void p_@N@()
   { if( is_gr##_domain5( mk_u5_5(@Y@), mk_u5_5(@Z@) ) )
       myerr(@n@,"is_gr()","u5_5(@Y@),u5_5(@Z@)");
   }
  
   void p_@N@()
   { if(! is_gr##_domain5( mk_u5_5(@Z@), mk_u5_5(@Y@) ) )
       myerr(@n@,"is_gr()","u5_5(@Z@),u5_5(@Y@)");
   }
  
/*================================================================================================*/

   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_1(@Y@), mk_u5_1(@Y@) ) )
       myerr(@n@,"is_ge()","u5_1(@Y@),u5_1(@Y@)");
   }
  
   void p_@N@()
   { if( is_ge##_domain5( mk_u5_1(@Y@), mk_u5_1(@Z@) ) )
       myerr(@n@,"is_ge()","u5_1(@Y@),u5_1(@Z@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_1(@Z@), mk_u5_1(@Y@) ) )
       myerr(@n@,"is_ge()","u5_1(@Z@),u5_1(@Y@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_2(aaa), mk_u5_2(aaa) ) )
       myerr(@n@,"is_ge()","u5_2(aaa),u5_2(aaa)");
   }
  
   /*---------------------------------------------------------
   removed by HMH, since aaa,bbb,... is not ordered

   void p_@N@()
   { if( is_ge##_domain5( mk_u5_2(aaa), mk_u5_2(bbb) ) )
       myerr(@n@,"is_ge()","u5_2(aaa),u5_2(bbb)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_2(bbb), mk_u5_2(aaa) ) )
       myerr(@n@,"is_ge()","u5_2(bbb),u5_2(aaa)");
   }

   -------------------------------------------------------------*/
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_3(@Y@), mk_u5_3(@Y@) ) )
       myerr(@n@,"is_ge()","u5_3(@Y@),u5_3(@Y@)");
   }
  
   void p_@N@()
   { if( is_ge##_domain5( mk_u5_3(@Y@), mk_u5_3(@Z@) ) )
       myerr(@n@,"is_ge()","u5_3(@Y@),u5_3(@Z@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_3(@Z@), mk_u5_3(@Y@) ) )
       myerr(@n@,"is_ge()","u5_3(@Z@),u5_3(@Y@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_4(aaa), mk_u5_4(aaa) ) )
       myerr(@n@,"is_ge()","u5_4(aaa),u5_4(aaa)");
   }

   /*---------------------------------------------------------
   removed by HMH, since aaa,bbb,... is not ordered
  
   void p_@N@()
   { if( is_ge##_domain5( mk_u5_4(aaa), mk_u5_4(bbb) ) )
       myerr(@n@,"is_ge()","u5_4(aaa),u5_4(bbb)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_4(bbb), mk_u5_4(aaa) ) )
       myerr(@n@,"is_ge()","u5_4(bbb),u5_4(aaa)");
   }

   -------------------------------------------------------------*/
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_5(@Y@), mk_u5_5(@Y@) ) )
       myerr(@n@,"is_ge()","u5_5(@Y@),u5_5(@Y@)");
   }
  
   void p_@N@()
   { if( is_ge##_domain5( mk_u5_5(@Y@), mk_u5_5(@Z@) ) )
       myerr(@n@,"is_ge()","u5_1(@Y@),u5_1(@Z@)");
   }
  
   void p_@N@()
   { if(! is_ge##_domain5( mk_u5_5(@Z@), mk_u5_5(@Y@) ) )
       myerr(@n@,"is_ge()","u5_1(@Z@),u5_1(@Y@)");
   }
  
#endif
/*================================================================================================*/

   void p_@N@()
   {
@(   switch( discr##_domain5( mk_u5_1(@X@) ) )
     { case d_u5_1: /* ok */
                    break;
       case d_u5_2:
       case d_u5_3:
       case d_u5_4:
       case d_u5_5: myerr(@n@,"discr() /1","u5_1(@X@)");
                    break;
       default:     myerr(@n@,"discr() /2","u5_1(@X@)");
     }
@) }

   void p_@N@()
   {
     switch( discr##_domain5( mk_u5_2(aaa) ) )
     { case d_u5_2: /* ok */
                    break;
       case d_u5_1:
       case d_u5_3:
       case d_u5_4:
       case d_u5_5: myerr(@n@,"discr() /1","u5_2(aaa)");
                    break;
       default:     myerr(@n@,"discr() /2","u5_2(aaa)");
     }
   }

   void p_@N@()
   {
@(   switch( discr##_domain5( mk_u5_3(@X@) ) )
     { case d_u5_3: /* ok */
                    break;
       case d_u5_1:
       case d_u5_2:
       case d_u5_4:
       case d_u5_5: myerr(@n@,"discr() /1","u5_3(@X@)");
                    break;
       default:     myerr(@n@,"discr() /2","u5_3(@X@)");
     }
@) }

   void p_@N@()
   {
     switch( discr##_domain5( mk_u5_4(aaa) ) )
     { case d_u5_4: /* ok */
                    break;
       case d_u5_1:
       case d_u5_2:
       case d_u5_3:
       case d_u5_5: myerr(@n@,"discr() /1","u5_4(aaa)");
                    break;
       default:     myerr(@n@,"discr() /2","u5_4(aaa)");
     }
   }

   void p_@N@()
   {
@(   switch( discr##_domain5( mk_u5_5(@X@) ) )
     { case d_u5_5: /* ok */
                    break;
       case d_u5_1:
       case d_u5_2:
       case d_u5_3:
       case d_u5_4: myerr(@n@,"discr() /1","u5_5(@X@)");
                    break;
       default:     myerr(@n@,"discr() /2","u5_5(@X@)");
     }
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( csw##_domain5( mk_u5_1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u5_1(@X@),@X@,aaa");
@) }

   void p_@N@()
   { if( csw##_domain5( mk_u5_2(aaa), aaa, @Y@, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u5_2(aaa),@Y@,aaa");
   }

   void p_@N@()
   {
@(   if( csw##_domain5( mk_u5_3(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u5_3(@X@),@X@,aaa");
@) }

   void p_@N@()
   { if( csw##_domain5( mk_u5_4(aaa), aaa, @Y@, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u5_4(aaa),@Y@,aaa");
   }

   void p_@N@()
   {
@(   if( csw##_domain5( mk_u5_5(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"cswitch-Funktional csw()","u5_5(@X@),@X@,aaa");
@) }

/*================================================================================================*/

   void p_@N@()
   {
@(   if( ssw##_domain5( mk_u5_1(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u5_1(@X@),@X@,aaa");
@) }

   void p_@N@()
   { if( ssw##_domain5( mk_u5_2(aaa), @Y@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u5_2(aaa),@Y@,aaa");
   }

   void p_@N@()
   {
@(   if( ssw##_domain5( mk_u5_3(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u5_3(@X@),@X@,aaa");
@) }

   void p_@N@()
   { if( ssw##_domain5( mk_u5_4(aaa), @Y@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u5_4(aaa),@Y@,aaa");
   }

   void p_@N@()
   {
@(   if( ssw##_domain5( mk_u5_5(@X@), @X@, aaa, TRUE ) != TRUE )
       myerr(@n@,"sswitch-Funktional ssw()","u5_5(@X@),@X@,aaa");
@) }

/*================================================================================================*/


#define ARG mk_u5_1(@X@)
#define NO 5
#define REPEAT
#define DOMAIN_ Domain5
#include <aux/com/cvtotupl/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#define DOMAIN_ Domain5
#include <aux/com/cvtotupl/bbc2>

#define ARG mk_u5_3(@X@)
#define NO 5
#define REPEAT
#define DOMAIN_ Domain5
#include <aux/com/cvtotupl/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#define DOMAIN_ Domain5
#include <aux/com/cvtotupl/bbc2>

#define ARG mk_u5_5(@X@)
#define NO 5
#define REPEAT
#define DOMAIN_ Domain5
#include <aux/com/cvtotupl/bbc2>

/*================================================================================================*/


#define ARG mk_u5_1(@X@)
#define NO 5
#define REPEAT
#include <aux/com/hash/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/hash/bbc2>

#define ARG mk_u5_3(@X@)
#define NO 5
#define REPEAT
#include <aux/com/hash/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/hash/bbc2>

#define ARG mk_u5_5(@X@)
#define NO 5
#define REPEAT
#include <aux/com/hash/bbc2>

/*================================================================================================*/


#define ARG mk_u5_1(@X@)
#define NO 5
#define REPEAT
#include <aux/com/del1/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/del1/bbc2>

#define ARG mk_u5_3(@X@)
#define NO 5
#define REPEAT
#include <aux/com/del1/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/del1/bbc2>

#define ARG mk_u5_5(@X@)
#define NO 5
#define REPEAT
#include <aux/com/del1/bbc2>

/*------------------------------------------------------------------------------------------------*/

#define ARG mk_u5_1(@X@)
#define NO 5
#define REPEAT
#include <aux/com/del/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/del/bbc2>

#define ARG mk_u5_3(@X@)
#define NO 5
#define REPEAT
#include <aux/com/del/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/del/bbc2>

#define ARG mk_u5_5(@X@)
#define NO 5
#define REPEAT
#include <aux/com/del/bbc2>

/*================================================================================================*/

#include <aux/com/print/bbc1>

#define ARG mk_u5_1(@X@)
#define NO 5
#define REPEAT
#include <aux/com/print/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/print/bbc2>

#define ARG mk_u5_3(@X@)
#define NO 5
#define REPEAT
#include <aux/com/print/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/print/bbc2>

#define ARG mk_u5_5(@X@)
#define NO 5
#define REPEAT
#include <aux/com/print/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/pr/bbc1>

#define ARG mk_u5_1(@X@)
#define REPEAT
#define NO 5
#include <aux/com/pr/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/pr/bbc2>

#define ARG mk_u5_3(@X@)
#define REPEAT
#define NO 5
#include <aux/com/pr/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/pr/bbc2>

#define ARG mk_u5_5(@X@)
#define REPEAT
#define NO 5
#include <aux/com/pr/bbc2>

/*------------------------------------------------------------------------------------------------*/

#include <aux/com/fpr/bbc1>

#define ARG mk_u5_1(@X@)
#define REPEAT
#define NO 5
#include <aux/com/fpr/bbc2>

#define ARG mk_u5_2(aaa)
#define NO 5
#include <aux/com/fpr/bbc2>

#define ARG mk_u5_3(@X@)
#define REPEAT
#define NO 5
#include <aux/com/fpr/bbc2>

#define ARG mk_u5_4(aaa)
#define NO 5
#include <aux/com/fpr/bbc2>

#define ARG mk_u5_5(@X@)
#define REPEAT
#define NO 5
#include <aux/com/fpr/bbc2>

#include <aux/com/basic/bbc2>

-----
cat >$OUT_DIR/unio/com/basic/bbd1 <<'-----'
@X@=
mk_u_1(xxx)
mk_u_2(xxx)
mk_u_1(yyy)
mk_u_2(yyy)
mk_u_1(zzz)
mk_u_2(zzz)

@Y@=
mk_u_1(ppp)

@Z@=
mk_u_1(qqq)

-----
cat >$OUT_DIR/unio/com/basic/docu <<'-----'
Syntax:

  Uniontype = Variant1 | Variant2 | ... | Variantn

Description:

   '|' denotes the dicrimiated union operation :

   A | B = { (A,a) | a in A } u { (B,b) | b in B}

   The union operator can be compared to unions or variant records
   within conventional programming languages.

Example:

  Let   'Scalar',  'Ptr',  'Boolean',  'Tok',  'Enum'  are  elementary
  datatypes. Then

      Elem = Scalar
           | Ptr
           | Boolean
           | Tok
           | Enum

  is an abstract syntax rule whose left-hand side is  an  'identifier'
  and  whose  right-hand  side  is a 'domain expression'. It describes
  Elem as being a union  of  'Scalar',  'Ptr',  'Boolean',  'Tok'  and
  'Enum'. The equation gives the name Elem to a domain and this domain
  is defined by 'Scalar | Ptr | Boolean | Tok | Enum' to be the domain
  of discriminated union of Scalar, Ptr, Boolean, Tok, Enum.

  in C or Pascal Variants have to be accessed by a selector function
  the selector function name is derived from the type name. In the
  example 's_scalar', 's_ptr', 's_boolean', 's_tok' and 's_enum'
  would be the names used. In C++ implicit conversion functions are
  supported. As an extension it is possible to explicitly specify
  selector name, e.g for the example

      Elem = s_v1 : Scalar       
           | s_v2 : Ptr       
           | s_v3 : Boolean       
           | s_v4 : Tok       
           | s_v5 : Enum 

  would define an equivalent type, but with selector functions 's_v1' to 
  's_v5'.      

-----
[ -d $OUT_DIR/unio/com/copy ] || mkdir $OUT_DIR/unio/com/copy
cat >$OUT_DIR/unio/com/copy/ccod <<'-----'
  DOMAIN copy##_DOMAIN _FPH1(DOMAIN)
   {x1 = copy1##_DOMAIN(x1);
    switch (discr##_DOMAIN(x1))
    {
#define MACRO1(V,_V,S,_S) case MERGE(d,_S) : x1 = MERGE(chg,_S)(x1,MERGE(copy,_V)(TSNAME(S,_S)(x1)));break;
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN));
    }
    return x1;
   }
-----
cat >$OUT_DIR/unio/com/copy/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + copy1 + chg + s + discr
   Vdmlib   = + err_uuni
#define MACRO1(V,_V,S,_S)  V = + copy   
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/com/cswitch ] || mkdir $OUT_DIR/unio/com/cswitch
cat >$OUT_DIR/unio/com/cswitch/ccod <<'-----'
#include <aux/com/switch/ccod>

#define MACRO1(C,_C,S,_S)_IFNDEF MERGE(FCTNAME,_C)
#define MACRO2(C,_C,S,_S)   extern RESULT MERGE(FCTNAME,_C) P_OP C x1 xxfpars P_CL;
#define MACRO3(C,_C,S,_S)_ENDIF
#include <aux/com/mecro1/ccod>

  RESULT FCTNAME##_DOMAIN(_FP(x1,DOMAIN) xxl) _EP(x1,DOMAIN) xxpars
   {switch (discr##_DOMAIN(x1)) {
#define MACRO1(C,_C,S,_S)    case MERGE(d,_S) : return MERGE(FCTNAME,_C)(TSNAME(S,_S)(x1) xxpl);
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN));
           /* return added to satisfy C compiler. This will not be reached */
           return MERGE(FCTNAME,_COMP1)(TSNAME(SEL1,_SEL1)(x1) xxpl);
   }}

#include <aux/com/switche/ccod>
-----
cat >$OUT_DIR/unio/com/cswitch/docu <<'-----'
#include <aux/com/switch/docu>
-----
cat >$OUT_DIR/unio/com/cswitch/param <<'-----'
XX
XXX
XXXX
RESULT
FCTNAME
NOSIGNATURE
-----
cat >$OUT_DIR/unio/com/cswitch/vdm <<'-----'
#include <aux/com/switch/vdm>
-----
[ -d $OUT_DIR/unio/com/cvfromtup1 ] || mkdir $OUT_DIR/unio/com/cvfromtup1
cat >$OUT_DIR/unio/com/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
  { discriminant##_DOMAIN lx1 = (discriminant##_DOMAIN)cvfromtup1_nat0(x1);
   switch (lx1)
    {
#define MACRO1(C,_C,S,_S)    case MERGE(d,_S) : return MERGE(mk,_S)(MERGE(cvfromtup1,_C)(x1));
#include <aux/com/macro1/ccod>
    /* dummy return to avoid compiler warnings about missing return value */
    default: err_uuni_vdmlib(MKSTRING(DOMAIN)); return MERGE(mk,_SEL1)(MERGE(cvfromtup1,_COMP1)(x1));

    }
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/unio/com/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/unio/com/cvfromtup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>

DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Nat0		= + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
  DOMAIN	= + mk
  Vdmlib	= + err_uuni
#define MACRO1(C,_C,S,_S)   C  = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#include <aux/com/macro1/ccod>

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/unio/com/cvlines ] || mkdir $OUT_DIR/unio/com/cvlines
cat >$OUT_DIR/unio/com/cvlines/ccod <<'-----'

#ifndef NOTAGS

#define MACRO1(C,_C,S,_S) Cvtext_vdmlib MERGE(cvlines,_S) _FPH1(C)\
{ Nat0 lx1 = curr_linelen_vdmlib; \
  Cvtext_vdmlib lx2; \
  adj_linelen_vdmlib((Nat0)strlen(MKSTRING(MERGE(mk,_S))"("));\
  lx2 = close_struct_vdmlib(ident_lines_vdmlib(MERGE(cvlines,_C)(x1),mkc_str(MKSTRING(MERGE(mk,_S))"(")) \
      ,mkc_str(")") \
      ,(Nat0)strlen(MKSTRING(MERGE(mk,_S))"("));\
  curr_linelen_vdmlib = lx1; return lx2;\
}

#else

#ifdef GEN_ISO

#define MACRO1(C,_C,S,_S) Cvtext_vdmlib MERGE(cvlines,_S) _FPH1(C)\
{ Nat0 lx1 = curr_linelen_vdmlib; \
  Cvtext_vdmlib lx2; \
  adj_linelen_vdmlib((Nat0)strlen(MKSTRING(MERGE(mk,_S))"("));\
  lx2 = close_struct_vdmlib(ident_lines_vdmlib(MERGE(cvlines,_C)(x1),mkc_str(MKSTRING(MERGE(mk,_S))"(")) \
      ,mkc_str(")") \
      ,(Nat0)strlen(MKSTRING(MERGE(mk,_S))"("));\
  curr_linelen_vdmlib = lx1; return lx2;\
}

#else

#define MACRO1(C,_C,S,_S) Cvtext_vdmlib MERGE(cvlines,_S) _FPH1(C)\
{ Nat0 lx1 = curr_linelen_vdmlib; \
  Cvtext_vdmlib lx2; \
  adj_linelen_vdmlib((Nat0)0);\
  lx2 = close_struct_vdmlib(ident_lines_vdmlib(MERGE(cvlines,_C)(x1),mkc_str("")) \
      ,mkc_str("") \
      ,(Nat0)0);\
  curr_linelen_vdmlib = lx1; return lx2;\
}

#endif

#endif
#include <aux/com/macro1/ccod>

-----
cat >$OUT_DIR/unio/com/cvlines/docu <<'-----'

  Parameters :

    'NOTAGS' :
                for union domains the value is usually tagged with
                the variant name, to distinguish between different
                variants. If this is not needed or not wanted
                the tag can be omitted with the implementation parameter
                'NOTAGS'. Remind that if 'NOTAGS' is given, parsing the output
                with the 'parse' operation is not longer possible
-----
cat >$OUT_DIR/unio/com/cvlines/gtyp <<'-----'
#ifdef emil

#ifdef GEN_C

/* auxilary macros for cvlines##_DOMAIN */
#define MACRO1(C,_C,S,_S)extern Cvtext_vdmlib MERGE(cvlines,_S) P_OP C x1 P_CL ;
#include <aux/com/macro1/ccod>

#define MACRO1(C,_C,S,_S)_DEFINE MERGE(cvlines,_S)(x1) \
  close_struct_vdmlib(ident_lines_vdmlib(MERGE(cvlines_C)(x1),mkc_str(MKSTRING(MERGE(mk,_S))"(")) \
   ,mkc_str(")") \
   ,(Nat0)strlen(MKSTRING(MERGE(mk,_S))"("))
#include <aux/com/macro1/ccod>

#endif

#endif
-----
cat >$OUT_DIR/unio/com/cvlines/param <<'-----'
NOTAGS
-----
cat >$OUT_DIR/unio/com/cvlines/vdm <<'-----'
DOMAINS  
IMPLEMENTATIONS
  Str            =  + mkc
  DOMAIN         =  + sswitch.cvlines("RESULT"="Cvtext_vdmlib","NOSIGNATURE")
#define MACRO1(C,_C,S,_S)    C  = + cvlines
#include <aux/com/macro1/ccod>
  Vdmlib         =  + cvtext + header("STRING")
-----
[ -d $OUT_DIR/unio/com/cvtotup1 ] || mkdir $OUT_DIR/unio/com/cvtotup1
cat >$OUT_DIR/unio/com/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
  { x1 = cvtotup1_nat0(x1,(Nat0)discr##_DOMAIN(x2));
   switch (discr##_DOMAIN(x2)) 
    {
#define MACRO1(C,_C,S,_S)    case MERGE(d,_S) : return MERGE(cvtotup1,_C)(x1,TSNAME(S,_S)(x2));
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN)); return x1; /* avoid compiler warning */
    }
  }

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/unio/com/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/unio/com/cvtotup1/vdm <<'-----'
#include <aux/com/cvtotupl/defp>
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
  Nat0		= + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
  DOMAIN	= + discr
  Vdmlib	= + err_uuni
#define MACRO1(C,_C,S,_S)   C  = + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
#include <aux/com/macro1/ccod>

#include <aux/com/cvtotupl/undefp>
-----
[ -d $OUT_DIR/unio/com/default ] || mkdir $OUT_DIR/unio/com/default
cat >$OUT_DIR/unio/com/default/docu <<'-----'
#include <aux/com/default/docu>

  For the union datatype the following set of operations is
  added

#include <unio/com/default/vdm>
-----
cat >$OUT_DIR/unio/com/default/vdm <<'-----'
  DOMAINS
  IMPLEMENTATIONS
    DOMAIN = + mk
                                       ! constructors !
             + is
                                       ! predicates !
             + discr
                                       ! discriminant for switches !
             + s
                                       ! selection !
             + copy1 + del1
                                       ! duplicate and destroy values !
-----
[ -d $OUT_DIR/unio/com/del ] || mkdir $OUT_DIR/unio/com/del
cat >$OUT_DIR/unio/com/del/ccod <<'-----'
  void del##_DOMAIN _FPH1(DOMAIN)
   {
    switch (discr##_DOMAIN(x1))
    {
#define MACRO1(V,_V,S,_S)      case MERGE(d,_S) : MERGE(del,_V)(TSNAME(S,_S)(x1));break;
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN));
    }
    del1##_DOMAIN(x1);
   }
-----
cat >$OUT_DIR/unio/com/del/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + del1 + s + discr
   Vdmlib   = + err_uuni
#define MACRO1(V,_V,S,_S)  V = + del   
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/com/hash ] || mkdir $OUT_DIR/unio/com/hash
cat >$OUT_DIR/unio/com/hash/ccod <<'-----'
  Nat0 hash##_DOMAIN _FPH1(DOMAIN)
   {switch (discr##_DOMAIN(x1))
    {
#define MACRO1(V,_V,S,_S)     case MERGE(d,_S) : return MERGE(discr,_DOMAIN)(x1) + MERGE(hash,_V)(TSNAME(S,_S)(x1));
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN));
             return 0;
    }
   }
-----
cat >$OUT_DIR/unio/com/hash/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + discr + s
   Vdmlib   = + err_uuni
#define MACRO1(V,_V,S,_S)  V  = + hash
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/com/is_eq ] || mkdir $OUT_DIR/unio/com/is_eq
cat >$OUT_DIR/unio/com/is_eq/ccod <<'-----'
  Bool is_eq##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {if (discr##_DOMAIN(x1) != discr##_DOMAIN(x2)) return 0;
    switch (discr##_DOMAIN(x1))
    {
#define MACRO1(V,_V,S,_S)     case MERGE(d,_S) : return MERGE(is_eq,_V)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2));
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN)); return FALSE;
    }
   }
-----
cat >$OUT_DIR/unio/com/is_eq/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + discr + s
   Vdmlib   = + err_uuni
#define MACRO1(V,_V,S,_S)  V  = + is_eq
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/com/is_ge ] || mkdir $OUT_DIR/unio/com/is_ge
cat >$OUT_DIR/unio/com/is_ge/ccod <<'-----'
  Bool is_ge##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {if (discr##_DOMAIN(x1) != discr##_DOMAIN(x2))
       return (discr##_DOMAIN(x1) >= discr##_DOMAIN(x2));
    switch (discr##_DOMAIN(x1))
    {
#define MACRO1(V,_V,S,_S)     case MERGE(d,_S) : return MERGE(is_ge,_V)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2));
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN)); return FALSE;
    }
   }
-----
cat >$OUT_DIR/unio/com/is_ge/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + discr + s
   Vdmlib   = + err_uuni
#define MACRO1(V,_V,S,_S)  V  = + is_ge
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/com/is_gr ] || mkdir $OUT_DIR/unio/com/is_gr
cat >$OUT_DIR/unio/com/is_gr/ccod <<'-----'
  Bool is_gr##_DOMAIN _FPH2(DOMAIN,DOMAIN)
   {if (discr##_DOMAIN(x1) != discr##_DOMAIN(x2))
       return (discr##_DOMAIN(x1) >= discr##_DOMAIN(x2));
    switch (discr##_DOMAIN(x1))
    {
#define MACRO1(V,_V,S,_S)     case MERGE(d,_S) : return MERGE(is_gr,_V)(TSNAME(S,_S)(x1),TSNAME(S,_S)(x2));
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN)); return FALSE;
    }
   }
-----
cat >$OUT_DIR/unio/com/is_gr/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + discr + s
   Vdmlib   = + err_uuni
#define MACRO1(V,_V,S,_S)  V  = + is_gr
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/com/ovwrt ] || mkdir $OUT_DIR/unio/com/ovwrt
cat >$OUT_DIR/unio/com/ovwrt/ccod <<'-----'
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(ovwrt,_S) _FPH2(DOMAIN,V) {err_uop_vdmlib(MKSTRING(MERGE(ovwrt,_S) ),MKSTRING(DOMAIN ));}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/com/ovwrt/docu <<'-----'
  this operation is not generally applicable, only for those
  implementations using a level of indirection for representing
  the union values (e.g. ptunion)
-----
cat >$OUT_DIR/unio/com/ovwrt/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + err_uop
-----
[ -d $OUT_DIR/unio/com/parse ] || mkdir $OUT_DIR/unio/com/parse
cat >$OUT_DIR/unio/com/parse/ccod <<'-----'
DOMAIN parse##_DOMAIN _FPH0()
  { char *lx1 = readtoken_vdmlib(#DOMAIN);
    char *lx2 = lx1 + 2;	/* points to optional name */
    DOMAIN lx3;

    if (strncmp(lx1,"mk",2) != 0) { expected_vdmlib(#DOMAIN,"mk",lx1); }
    expect_vdmlib("(",#DOMAIN);
#define MACRO0
#define MACRO1(C,_C,S,_S) if (strcmp(lx2,#_S) == 0) {lx3 = mk##_S(parse##_C()); goto OK; }
#include <aux/com/macro1/ccod>
      expected_vdmlib(#DOMAIN,"optional constructor",lx1);
      /* lx3 defined to satisfy the compiler (warnings). It will not be executed */
      lx3 = mk##_SEL1(parse##_COMP1());
  OK: expect_vdmlib(")",#DOMAIN);
      return lx3;
  }
-----
cat >$OUT_DIR/unio/com/parse/docu <<'-----'

  Syntax:  'mk_'<ELEM1>'('<ELEM1>')'

-----
cat >$OUT_DIR/unio/com/parse/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
 DOMAIN	= + mk
 Vdmlib	= + parsesup + header("STRING")
#define MACRO1(C,_C,S,_S) C = + parse
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/com/print ] || mkdir $OUT_DIR/unio/com/print
cat >$OUT_DIR/unio/com/print/ccod <<'-----'
  void print##_DOMAIN _FPH1(DOMAIN)
   {   
    switch (discr##_DOMAIN(x1))
    {
_IFDEF __cplusplus

#ifdef NOTAGS
#define MACRO1(V,_V,S,_S)      case MERGE(d,_S) : MERGE(print,_V)(TSNAME(S,_S)(x1)); break;
#else
#ifdef GEN_ISO
#define MACRO1(V,_V,S,_S)      case MERGE(d,_S) : print_FD_vdmlib << MKSTRING(MERGE(mk,_S))"(";MERGE(print,_V)(TSNAME(S,_S)(x1)); print_FD_vdmlib << ")";break;
#else
#define MACRO1(V,_V,S,_S)      case MERGE(d,_S) : print_FD_vdmlib << MKSTRING(MERGE(mk,_S))"(";MERGE(print,_V)(TSNAME(S,_S)(x1)); print_FD_vdmlib << ")";break;
#endif
#endif
#include <aux/com/macro1/ccod>

_ELSE

#ifdef NOTAGS
#define MACRO1(V,_V,S,_S)      case MERGE(d,_S) : MERGE(print,_V)(TSNAME(S,_S)(x1));break;
#else
#ifdef GEN_ISO
#define MACRO1(V,_V,S,_S)      case MERGE(d,_S) : fprintf(print_FD_vdmlib,MKSTRING(MERGE(mk,_S))"(");MERGE(print,_V)(TSNAME(S,_S)(x1));fprintf(print_FD_vdmlib,")");break;
#else
#define MACRO1(V,_V,S,_S)      case MERGE(d,_S) : fprintf(print_FD_vdmlib,MKSTRING(MERGE(mk,_S))"(");MERGE(print,_V)(TSNAME(S,_S)(x1));fprintf(print_FD_vdmlib,")");break;
#endif
#endif
#include <aux/com/macro1/ccod>

_ENDIF
    default: err_uuni_vdmlib(MKSTRING(DOMAIN));
    }
   }
-----
cat >$OUT_DIR/unio/com/print/docu <<'-----'
#include <unio/com/cvlines/docu>
-----
cat >$OUT_DIR/unio/com/print/param <<'-----'
NOTAGS
-----
cat >$OUT_DIR/unio/com/print/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   = + s + discr
   Vdmlib   = + header("STDIO")
   Vdmlib   = + err_uuni
#define MACRO1(V,_V,S,_S)   V = + print
#include <aux/com/macro1/ccod>
   Vdmlib   = + printsup
-----
[ -d $OUT_DIR/unio/com/signature ] || mkdir $OUT_DIR/unio/com/signature
cat >$OUT_DIR/unio/com/signature/ccod <<'-----'
#define CPPIMPL

_IFDEF __cplusplus
#include <aux/sign/signature/cppdef>

Cpp_RESULT FCTNAME1 (Cpp_ParamS) Cpp_Const Cpp_Body

{
  switch ( discr() ) {

#if MANIPULATOR

#define MACRO1(C,_C,S,_S,SS) case MERGE(d,_S) : { C lx = S();
#define MACRO2(C,_C,S,_S,SS)   lx.FCTNAME(Cpp_AaramS); MERGE(chg_,S)(lx); }
#define MACRO3(C,_C,S,_S,SS) break;

#else

#ifdef NOTCONST

#define MACRO1(C,_C,S,_S,SS) case MERGE(d,_S) : { C lx = S();
#define MACRO2(C,_C,S,_S,SS)   Cpp_RESULT r = lx.FCTNAME(Cpp_AaramS); MERGE(chg_,S)(lx);
#define MACRO3(C,_C,S,_S,SS)   return r; }

#else

#define MACRO1(C,_C,S,_S,SS) case MERGE(d,_S) :
#define MACRO2(C,_C,S,_S,SS)   return S().FCTNAME(Cpp_AaramS);
#define MACRO3(C,_C,S,_S,SS) 

#endif
#endif

#include <aux/sign/mecro1/cpp>

    default : err_tag_vdmlib(MKSTRING(DOMAIN));
  }

#if MANIPULATOR
  return *this;
#endif
}

#include <aux/sign/signature/cppdef>

_ENDIF

#undef CPPIMPL

-----
cat >$OUT_DIR/unio/com/signature/param <<'-----'
#include <com/com/signature/param>
-----
cat >$OUT_DIR/unio/com/signature/vdm <<'-----'
/* declaration of a union function implies a generation
   of a switch function
*/

#include <aux/com/switch/vparam>
DOMAINS
IMPLEMENTATIONS
  DOMAIN = + discr + chg + s
  Vdmlib   = + err_uuni

  --  DOMAIN = + switchcpp.FCTNAME("NOSIGNATURE"=1,PARAMS)

#include <aux/com/switch/vparam>
-----
[ -d $OUT_DIR/unio/com/sswitch ] || mkdir $OUT_DIR/unio/com/sswitch
cat >$OUT_DIR/unio/com/sswitch/ccod <<'-----'
#include <aux/com/switch/ccod>

#define MACRO1(C,_C,S,_S)_IFNDEF MERGE(FCTNAME,_S)
#define MACRO2(C,_C,S,_S)   extern RESULT MERGE(FCTNAME,_S) P_OP C x1 xxfpars P_CL;
#define MACRO3(C,_C,S,_S)_ENDIF
#include <aux/com/mecro1/ccod>

  RESULT FCTNAME##_DOMAIN(_FP(x1,DOMAIN) xxl) _EP(x1,DOMAIN) xxpars
   {switch (discr##_DOMAIN(x1)) {
#define MACRO1(C,_C,S,_S)    case MERGE(d,_S) : return MERGE(FCTNAME,_S)(TSNAME(S,_S)(x1) xxpl);
#include <aux/com/macro1/ccod>
    default: err_uuni_vdmlib(MKSTRING(DOMAIN));
             /* return statement to satisfy the compiler. It will not be executed */
             return MERGE(FCTNAME,_SEL1)(TSNAME(SEL1,_SEL1)(x1) xxpl);
   }}

#include <aux/com/switche/ccod>
-----
cat >$OUT_DIR/unio/com/sswitch/docu <<'-----'
#include <aux/com/switch/docu>
-----
cat >$OUT_DIR/unio/com/sswitch/param <<'-----'
FCTNAME
NOSIGNATURE
RESULT
XX
XXX
XXXX
-----
cat >$OUT_DIR/unio/com/sswitch/vdm <<'-----'
#include <aux/com/switch/vdm>
-----
[ -d $OUT_DIR/unio/com/subst ] || mkdir $OUT_DIR/unio/com/subst
cat >$OUT_DIR/unio/com/subst/ccod <<'-----'
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(subst,_S) _FPH2(DOMAIN,V) {return MERGE(chg,_S)(MERGE(copy1,_DOMAIN)(x1),x2);}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/com/subst/cmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE MERGE(subst,_S)(x1,x2) MERGE(chg,_S)(MERGE(copy1,_DOMAIN)(x1),x2)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/com/subst/pmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE MERGE(subst,_S)(x1,x2) MERGE(chg,_S)(MERGE(copy1,_DOMAIN)(x1),x2)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/com/subst/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   DOMAIN   =  + chg + copy1
-----
[ -d $OUT_DIR/unio/ptunion ] || mkdir $OUT_DIR/unio/ptunion
[ -d $OUT_DIR/unio/ptunion/basic ] || mkdir $OUT_DIR/unio/ptunion/basic
cat >$OUT_DIR/unio/ptunion/basic/docu <<'-----'
    Implementation of union as pointer to a union with tagfield

    Each  access requires one level of indirection but
    assignment can be done by pointer assignment.

    Parameters:
      NOCHECK  :
                 optional, if defined no check on the
                 legality of accessing variants is done
      MACROS   :
                 functions a macros if possible       
                 MACROS implies NOCHECK
#include <unio/aux/basic/docu>
-----
cat >$OUT_DIR/unio/ptunion/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/unio/ptunion/basic/gptr <<'-----'
  TYPE_DEF(DOMAIN,POINTER_TO_STRUCT(Struct##_DOMAIN))
-----
cat >$OUT_DIR/unio/ptunion/basic/gtyp <<'-----'
#include <unio/aux/basic/gtyp>

  START_RECORD_TYP(Struct##_DOMAIN)
                    RECFIELD(tag##_DOMAIN,discriminant##_DOMAIN);

#ifdef GEN_MODULA
                    var##_DOMAIN :
                    RECORD
                     CASE :discriminant##_DOMAIN OF
#define MACRO1(V,_V,S,_S)                     IDF_(MERGE(d,_S))  : RECFIELD(MERGE(f,_S),V)
#define MACRO0                     |
#include <aux/com/macro1/ccod>
                    END;
#else
#ifdef GEN_C
                         union {
#define MACRO1(V,_V,S,_S)                                 V MERGE(f,_S) ;
#include <aux/com/macro1/ccod>
                               }             var##_DOMAIN;
#else
#ifdef GEN_PASCAL
                    var##_DOMAIN :
                    RECORD
                     CASE discriminant##_DOMAIN OF
#define MACRO1(V,_V,S,_S)                     MERGE(d,_S)  : (MERGE(f,_S) : V)
#define MACRO0                     ;
#include <aux/com/macro1/ccod>
                    END;
#else
   !!! fill in for not Modula, C or Pascal !!!
#endif
#endif
#endif

  END_RECORD_TYP(Struct##_DOMAIN) 
-----
cat >$OUT_DIR/unio/ptunion/basic/param <<'-----'
ALLOC
AUTOMEM
FORWARD_ALLOWED
INTERNALDOMAIN
MACROS
NOCHECK
SMALLTYPE
-----
cat >$OUT_DIR/unio/ptunion/basic/vdm <<'-----'
#include <aux/com/heap/vdm>

#define CONSTRNAME mk_basic
#define ADTNAME ADT_UNIO
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/ptunion/chg ] || mkdir $OUT_DIR/unio/ptunion/chg
cat >$OUT_DIR/unio/ptunion/chg/ccod <<'-----'
#if NOCHECK
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(chg,_S) _FPH2(DOMAIN,V) {(MERGE(ref,_DOMAIN)(x1)->MERGE(var,_DOMAIN)).MERGE(f,_S) = x2; return x1;}
#else
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(chg,_S) _FPH2(DOMAIN,V) {if (MERGE(ref,_DOMAIN)(x1)->MERGE(tag,_DOMAIN) != MERGE(d,_S)) err_tag_vdmlib(MKSTRING(DOMAIN)); (x1->MERGE(var,_DOMAIN)).MERGE(f,_S) = x2; return x1;}
#endif
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/ptunion/chg/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   Vdmlib   = + err_tag
#endif
-----
[ -d $OUT_DIR/unio/ptunion/copy1 ] || mkdir $OUT_DIR/unio/ptunion/copy1
cat >$OUT_DIR/unio/ptunion/copy1/ccod <<'-----'
  DOMAIN copy1##_DOMAIN _FPH1(DOMAIN)
   {DOMAIN lx1 = alloc##_DOMAIN();
    *lx1 = *x1;
    return lx1;
   }
-----
[ -d $OUT_DIR/unio/ptunion/del1 ] || mkdir $OUT_DIR/unio/ptunion/del1
cat >$OUT_DIR/unio/ptunion/del1/ccod <<'-----'
  void del1##_DOMAIN _FPH1(DOMAIN) {free##_DOMAIN(x1);}
-----
cat >$OUT_DIR/unio/ptunion/del1/cmcr <<'-----'
_DEFINE del1##_DOMAIN(x1) free##_DOMAIN(x1)
-----
[ -d $OUT_DIR/unio/ptunion/discr ] || mkdir $OUT_DIR/unio/ptunion/discr
cat >$OUT_DIR/unio/ptunion/discr/ccod <<'-----'
  discriminant##_DOMAIN discr##_DOMAIN _FPH1(DOMAIN)
   {return ref##_DOMAIN(x1)->tag##_DOMAIN;}
-----
cat >$OUT_DIR/unio/ptunion/discr/cmcr <<'-----'
_DEFINE discr##_DOMAIN(D) (ref##_DOMAIN(D)->tag##_DOMAIN)
-----
cat >$OUT_DIR/unio/ptunion/discr/pmcr <<'-----'
_DEFINE discr##_DOMAIN(D) discriminant##_DOMAIN(D^.tag##_DOMAIN)
-----
[ -d $OUT_DIR/unio/ptunion/is ] || mkdir $OUT_DIR/unio/ptunion/is
cat >$OUT_DIR/unio/ptunion/is/ccod <<'-----'
#define MACRO1(V,_V,S,_S) Bool MERGE(is,_S) _FPH1(DOMAIN) {return MERGE(ref,_DOMAIN)(x1)->MERGE(tag,_DOMAIN) == MERGE(d,_S);}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/ptunion/is/cmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE MERGE(is,_S)(D) (MERGE(ref,_DOMAIN)(D)->MERGE(tag,_DOMAIN) == MERGE(d,_S))
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/ptunion/is/pmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE MERGE(is,_S)(D) (D^.MERGE(tag,_DOMAIN) = ord(MERGE(d,_S)))
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/ptunion/mk ] || mkdir $OUT_DIR/unio/ptunion/mk
cat >$OUT_DIR/unio/ptunion/mk/ccod <<'-----'
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(mk,_S) _FPH1(V) {DOMAIN lx1 = MERGE(alloc,_DOMAIN)(); lx1->MERGE(tag,_DOMAIN) = MERGE(d,_S); (lx1->MERGE(var,_DOMAIN)).MERGE(f,_S) = x1; return lx1;}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/ptunion/mk/vdm <<'-----'

#define CONSTRNAME mk
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/ptunion/ovwrt ] || mkdir $OUT_DIR/unio/ptunion/ovwrt
cat >$OUT_DIR/unio/ptunion/ovwrt/ccod <<'-----'
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(ovwrt,_S) _FPH2(DOMAIN,V) {MERGE(ref,_DOMAIN)(x1)->MERGE(tag,_DOMAIN) = MERGE(d,_S);(x1)->MERGE(var,_DOMAIN).MERGE(f,_S) = x2; return x1;}
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/ptunion/s ] || mkdir $OUT_DIR/unio/ptunion/s
cat >$OUT_DIR/unio/ptunion/s/ccod <<'-----'
#if NOCHECK
#define MACRO1(V,_V,S,_S) V TSNAME(S,_S) _FPH1(DOMAIN) {return (MERGE(ref,_DOMAIN)(x1)->MERGE(var,_DOMAIN)).MERGE(f,_S);}
#else
#define MACRO1(V,_V,S,_S) V TSNAME(S,_S) _FPH1(DOMAIN) {if (MERGE(ref,_DOMAIN)(x1)->MERGE(tag,_DOMAIN) != MERGE(d,_S)) err_tag_vdmlib(MKSTRING(DOMAIN)); return (x1->MERGE(var,_DOMAIN)).MERGE(f,_S);}
#endif
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/ptunion/s/cmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE TSNAME(S,_S)(D) (MERGE(ref,_DOMAIN)(D)->MERGE(var,_DOMAIN)).MERGE(f,_S)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/ptunion/s/pmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE TSNAME(S,_S)(D) D^.MERGE(var,_DOMAIN).MERGE(f,_S)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/ptunion/s/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! MACROS && ! NOCHECK
   Vdmlib   = + err_tag
#endif
-----
[ -d $OUT_DIR/unio/scalbin ] || mkdir $OUT_DIR/unio/scalbin
[ -d $OUT_DIR/unio/scalbin/basic ] || mkdir $OUT_DIR/unio/scalbin/basic
cat >$OUT_DIR/unio/scalbin/basic/docu <<'-----'
  Implementation of 

    DOMAIN  = s_o1 : Domain1  |  s_o2 : Domain2
  
  where 'Domain1' and 'Domain2' are implemented based on unsigned
  scalar values. The distinction between the two variants is made
  by storing the second variant as negative value. This means that
  0 must not be a legal value for at least the second domain!

    Example:
     
      Path   = s_virtpath : Nat0
	     | s_physpath : Nat0

    where both values are not becoming larger than 2^31 - 1

    Parameters:
      NOCHECK  : optional, if defined no check on the
                 legality of accessing variants is done
      MACROS   : functions a macros if possible       
                 MACROS implies NOCHECK
      BASETYPE : Gives the optional possibility to change the singed
		 representation of the union domain. Default will be
		 'Intg'.
#include <unio/aux/basic/docu>
-----
cat >$OUT_DIR/unio/scalbin/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/unio/scalbin/basic/gtyp <<'-----'
#include <unio/aux/basic/gtyp>

#ifdef BASETYPE
  TYPE_DEF(DOMAIN,BASETYPE)
#else
  TYPE_DEF(DOMAIN,Intg)
#endif

#ifdef SEL3
  DOMAIN: only two variants are possible for this implementation !
#endif
-----
cat >$OUT_DIR/unio/scalbin/basic/param <<'-----'
BASETYPE
INTERNALDOMAIN
MACROS
NOCHECKS
SMALLTYPE
-----
cat >$OUT_DIR/unio/scalbin/basic/vdm <<'-----'

#define CONSTRNAME mk_basic
#define ADTNAME ADT_UNIO
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/scalbin/chg ] || mkdir $OUT_DIR/unio/scalbin/chg
cat >$OUT_DIR/unio/scalbin/chg/ccod <<'-----'
#if NOCHECK
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(chg,_S) _FPH2(DOMAIN,V) {return MERGE(mk,_S)(x2);}
#else
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(chg,_S) _FPH2(DOMAIN,V) {if (MERGE(discr,_DOMAIN)(x1) != MERGE(d,_S)) err_tag_vdmlib(MKSTRING(DOMAIN)); return MERGE(mk,_S)(x2);}
#endif
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/scalbin/chg/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   Vdmlib   = + err_tag
#endif
-----
[ -d $OUT_DIR/unio/scalbin/copy ] || mkdir $OUT_DIR/unio/scalbin/copy
cat >$OUT_DIR/unio/scalbin/copy/ccod <<'-----'
#include <com/com/copy/ccod>
-----
cat >$OUT_DIR/unio/scalbin/copy/cmcr <<'-----'
#include <com/com/copy/cmcr>
-----
cat >$OUT_DIR/unio/scalbin/copy/param <<'-----'
MACROS
-----
cat >$OUT_DIR/unio/scalbin/copy/pmcr <<'-----'
#include <com/com/copy/pmcr>
-----
[ -d $OUT_DIR/unio/scalbin/cvfromtup1 ] || mkdir $OUT_DIR/unio/scalbin/cvfromtup1
cat >$OUT_DIR/unio/scalbin/cvfromtup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  DOMAIN cvfromtup1##_DOMAIN _FPH1(TUPLDOMAIN *)
#ifdef BASETYPE
  { return cvfromtup1##_BASETYPE(x1); }
#else
  { return cvfromtup1_intg(x1); }
#endif

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/unio/scalbin/cvfromtup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/unio/scalbin/cvfromtup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
#ifdef BASETYPE
  BASETYPE = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#else
  Intg	   = + cvfromtup1("TUPLDOMAIN"=TUPLDOMAIN)
#endif 
-----
[ -d $OUT_DIR/unio/scalbin/cvtotup1 ] || mkdir $OUT_DIR/unio/scalbin/cvtotup1
cat >$OUT_DIR/unio/scalbin/cvtotup1/ccod <<'-----'
#include <aux/com/cvtotupl/defp>

  TUPLDOMAIN cvtotup1##_DOMAIN _FPH2(TUPLDOMAIN,DOMAIN)
#ifdef BASETYPE
  { return cvtotup1##_BASETYPE(x1,x2); }
#else
  { return cvtotup1_intg(x1,x2); }
#endif

#include <aux/com/cvtotupl/undefp>
-----
cat >$OUT_DIR/unio/scalbin/cvtotup1/param <<'-----'
TUPLDOMAIN
-----
cat >$OUT_DIR/unio/scalbin/cvtotup1/vdm <<'-----'
DOMAINS
  DOMAIN	-> TUPLDOMAIN
IMPLEMENTATIONS
#ifdef BASETYPE
  BASETYPE = + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
#else
  Intg	   = + cvtotup1("TUPLDOMAIN"=TUPLDOMAIN)
#endif 
-----
[ -d $OUT_DIR/unio/scalbin/del ] || mkdir $OUT_DIR/unio/scalbin/del
cat >$OUT_DIR/unio/scalbin/del/ccod <<'-----'
#include <com/com/del/ccod>
-----
cat >$OUT_DIR/unio/scalbin/del/cmcr <<'-----'
#include <com/com/del/cmcr>
-----
cat >$OUT_DIR/unio/scalbin/del/param <<'-----'
MACROS
-----
cat >$OUT_DIR/unio/scalbin/del/pmcr <<'-----'
#include <com/com/del/pmcr>
-----
[ -d $OUT_DIR/unio/scalbin/discr ] || mkdir $OUT_DIR/unio/scalbin/discr
cat >$OUT_DIR/unio/scalbin/discr/ccod <<'-----'
  discriminant##_DOMAIN discr##_DOMAIN _FPH1(DOMAIN)
   {return (x1 < 0) ? d##_SEL2 : d##_SEL1;}
-----
cat >$OUT_DIR/unio/scalbin/discr/cmcr <<'-----'
_DEFINE discr##_DOMAIN(D) (((D) < 0) ? d##_SEL2 : d##_SEL1)
-----
cat >$OUT_DIR/unio/scalbin/discr/param <<'-----'
MACROS
-----
[ -d $OUT_DIR/unio/scalbin/is ] || mkdir $OUT_DIR/unio/scalbin/is
cat >$OUT_DIR/unio/scalbin/is/ccod <<'-----'
Bool is##_SEL1 _FPH1(DOMAIN) {return (x1 >= 0);}
Bool is##_SEL2 _FPH1(DOMAIN) {return (x1 < 0);}
-----
cat >$OUT_DIR/unio/scalbin/is/cmcr <<'-----'
_DEFINE is##_SEL1(x1) (x1 >= 0)
_DEFINE is##_SEL2(x1) (x1 < 0)
-----
cat >$OUT_DIR/unio/scalbin/is/param <<'-----'
MACROS
-----
cat >$OUT_DIR/unio/scalbin/is/pmcr <<'-----'
_DEFINE is##_SEL1(x1) (x1 >= 0)
_DEFINE is##_SEL2(x1) (x1 < 0)
-----
[ -d $OUT_DIR/unio/scalbin/mk ] || mkdir $OUT_DIR/unio/scalbin/mk
cat >$OUT_DIR/unio/scalbin/mk/ccod <<'-----'
  DOMAIN mk##_SEL1 _FPH1(COMP1) { return (DOMAIN) x1; }
  DOMAIN mk##_SEL2 _FPH1(COMP2) { return (DOMAIN)(-x1); }
-----
cat >$OUT_DIR/unio/scalbin/mk/cmcr <<'-----'
_DEFINE mk##_SEL1(x1) ((DOMAIN) (x1))
_DEFINE mk##_SEL2(x1) ((DOMAIN) (-x1))
-----
cat >$OUT_DIR/unio/scalbin/mk/param <<'-----'
MACROS
-----
cat >$OUT_DIR/unio/scalbin/mk/pmcr <<'-----'
_DEFINE mk##_SEL1(x1) (x1)
_DEFINE mk##_SEL2(x1) (-x1)
-----
cat >$OUT_DIR/unio/scalbin/mk/vdm <<'-----'

#define CONSTRNAME mk
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/scalbin/s ] || mkdir $OUT_DIR/unio/scalbin/s
cat >$OUT_DIR/unio/scalbin/s/ccod <<'-----'
  COMP1 s##_SEL1 _FPH1(DOMAIN)
   {
#if ! NOCHECK
    if (! is##_SEL1(x1)) err_tag_vdmlib(MKSTRING(DOMAIN));
#endif
    return (COMP1)(x1);
  }

  COMP2 s##_SEL2(x1)
      DOMAIN x1;
   {
#if ! NOCHECK
    if (! is##_SEL2(x1)) err_tag_vdmlib(MKSTRING(DOMAIN));
#endif
    return (COMP2)(-x1);
  }
-----
cat >$OUT_DIR/unio/scalbin/s/cmcr <<'-----'
_DEFINE s##_SEL1(x1)  ((COMP1)(x1))
_DEFINE s##_SEL2(x1)  ((COMP2)(-(x1)))
-----
cat >$OUT_DIR/unio/scalbin/s/param <<'-----'
MACROS
-----
cat >$OUT_DIR/unio/scalbin/s/pmcr <<'-----'
_DEFINE s##_SEL1(x1)  (x1)
_DEFINE s##_SEL2(x1)  (-(x1))
-----
cat >$OUT_DIR/unio/scalbin/s/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! MACROS && ! NOCHECK
   Vdmlib   = + err_tag
   DOMAIN   = + is
#endif
-----
[ -d $OUT_DIR/unio/sign ] || mkdir $OUT_DIR/unio/sign
[ -d $OUT_DIR/unio/sign/chg ] || mkdir $OUT_DIR/unio/sign/chg
cat >$OUT_DIR/unio/sign/chg/cpp <<'-----'
#define T1 Cpp_DOMAIN &
#define MACRO1(C,_C,S,_S,SS) InlineFriendFct(MERGE(chg_,S),FPAR2(T1,const C &),Cpp_DOMAIN &)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY2a(MERGE(chg,_S),FPARLIST2))
#define MACRO3(C,_C,S,_S,SS) 
#include <aux/sign/mecro1/cpp>
#undef T1
-----
cat >$OUT_DIR/unio/sign/chg/gsig <<'-----'
#define MACRO1(V,_V,S,_S)  FUNCDEC(MERGE(chg,_S),PL_2(DOMAIN,V),DOMAIN)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/sign/chg/vsig <<'-----'
#define MACRO1(V,_V,S,_S)  MERGE(chg,_S)(x1,x2)
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S)  TYPE : DOMAIN  V  -->  DOMAIN
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S)  PRE MERGE(chg,_S) : MERGE(is,_S)(x1)
#include <aux/com/macro1/ccod>
   changing a variant of a union value without copying the value
-----
[ -d $OUT_DIR/unio/sign/cswitch ] || mkdir $OUT_DIR/unio/sign/cswitch
cat >$OUT_DIR/unio/sign/cswitch/gsig <<'-----'
#include <aux/sign/switch/gsig>
-----
cat >$OUT_DIR/unio/sign/cswitch/vsig <<'-----'
#include <aux/sign/switch/vsig>
-----
[ -d $OUT_DIR/unio/sign/discr ] || mkdir $OUT_DIR/unio/sign/discr
cat >$OUT_DIR/unio/sign/discr/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define _RES MERGE(discriminant,_DOMAIN)
InlineFriendConstFct(discr,FPAR1(T1),_RES)
RUMPF(BODY1(_RES,discr,FPARLIST1))
#undef T1
#undef _RES
-----
cat >$OUT_DIR/unio/sign/discr/gsig <<'-----'
  FUNCDEC(discr##_DOMAIN,PL_1(DOMAIN),discriminant##_DOMAIN)
-----
cat >$OUT_DIR/unio/sign/discr/vsig <<'-----'
  discr##_DOMAIN(x1)
  TYPE : DOMAIN  -->  discriminant_DOMAIN

  selecting the discriminant of the union value x1
  for using case/switch statements                       
  the values of the discriminants are named __EM(d_*)
  for selector __EM(s_*)

  Example:
   Let Uni a union domain and u a value of that domain

     Uni   = s_u1 : Nat0 | s_u2 : Str

   a C switch statement can then be unsed in the following way

   switch (discr_uni(u))
     {case d_u1 : .....;break;
      case d_u2 : .....;break;
     }
-----
[ -d $OUT_DIR/unio/sign/is ] || mkdir $OUT_DIR/unio/sign/is
cat >$OUT_DIR/unio/sign/is/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define MACRO1(C,_C,S,_S,SS) InlineFriendConstFct(MERGE(is_,S),FPAR1(T1),Cpp_BOOL)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY1a(Cpp_BOOL,MERGE(is,_S),FPARLIST1))
#define MACRO3(C,_C,S,_S,SS)
#include <aux/sign/mecro1/cpp>
#undef T1
-----
cat >$OUT_DIR/unio/sign/is/gsig <<'-----'
#define MACRO1(V,_V,S,_S)  FUNCDEC(MERGE(is,_S),PL_1(DOMAIN),Bool)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/sign/is/vsig <<'-----'
#define MACRO1(V,_V,S,_S)  MERGE(is,_S)(x1)
#include <aux/com/macro1/ccod>
  TYPE : DOMAIN  -->  Bool

  test of type of x1

  if no explicit selectors are supported, see general info about unions,
  the variant names in lowercase are taken as names and prefixed with __SA(is)
-----
[ -d $OUT_DIR/unio/sign/mk ] || mkdir $OUT_DIR/unio/sign/mk
cat >$OUT_DIR/unio/sign/mk/cpp <<'-----'
#define MACRO1(C,_C,S,_S,SS) InlineNoFriendFct(Cpp_DOMAIN,KPAR1(const C &),)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY4a(MERGE(mk,_S),KPARLIST1))
#define MACRO3(C,_C,S,_S,SS)
#include <aux/sign/mecro1/cpp>
-----
cat >$OUT_DIR/unio/sign/mk/gsig <<'-----'
#define MACRO1(V,_V,S,_S)  FUNCDEC(MERGE(mk,_S),PL_1(V),DOMAIN)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/sign/mk/vsig <<'-----'
#define MACRO1(V,_V,S,_S) MERGE(mk,_S)(x1)
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S) TYPE : V  -->  DOMAIN
#include <aux/com/macro1/ccod>
  constructor functions for unions

  in C and Pascal unions must be explicitly constructed, because the variant
  type information has to be part of the value. This is a deviation from pure VDM.

  in C++ this is done by calling a constructor and these calls can mostly be
  inserted implicitly by the C++ compiler, so C++ code would correspond in this
  case much more to a VDM specification than C or Pascal code. 
-----
[ -d $OUT_DIR/unio/sign/ovwrt ] || mkdir $OUT_DIR/unio/sign/ovwrt
cat >$OUT_DIR/unio/sign/ovwrt/cpp <<'-----'
#define T1 Cpp_DOMAIN &
#define MACRO1(C,_C,S,_S,SS) InlineFriendFct(MERGE(ovwrt_,S),FPAR2(T1,const C &),Cpp_DOMAIN &)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY2a(MERGE(ovwrt,_S),FPARLIST2))
#define MACRO3(C,_C,S,_S,SS) 
#include <aux/sign/mecro1/cpp>
#undef T1
-----
cat >$OUT_DIR/unio/sign/ovwrt/gsig <<'-----'
#define MACRO1(V,_V,S,_S)  FUNCDEC(MERGE(ovwrt,_S),PL_2(DOMAIN,V),DOMAIN)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/sign/ovwrt/vsig <<'-----'
#define MACRO1(V,_V,S,_S)  MERGE(ovwrt,_S)(x1,x2)
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S)  TYPE : DOMAIN  V  -->  DOMAIN
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S)  PRE MERGE(ovwrt,_S) : MERGE(is,_S)(x1)
#include <aux/com/macro1/ccod>
   changing a union value inclusive the discriminant without
   copying the value
-----
[ -d $OUT_DIR/unio/sign/s ] || mkdir $OUT_DIR/unio/sign/s
cat >$OUT_DIR/unio/sign/s/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#define MACRO1(C,_C,S,_S,SS) InlineFriendConstFct(S,FPAR1(T1),C)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY1a(C,TSNAME(SS,_S),FPARLIST1))
#define MACRO3(C,_C,S,_S,SS)
#include <aux/sign/mecro1/cpp>
#undef T1

#ifdef OPERATOR
#define MACRO1(C,_C,S,_S,SS) InlineNoFriendConstFct(operator C,(),)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY1a(C,TSNAME(SS,_S),FPARLIST1))
#define MACRO3(C,_C,S,_S,SS)
#include <aux/sign/mecro1/cpp>
#endif
-----
cat >$OUT_DIR/unio/sign/s/gsig <<'-----'
#define MACRO1(V,_V,S,_S)  FUNCDEC(TSNAME(S,_S),PL_1(DOMAIN),V)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/sign/s/vsig <<'-----'
#define MACRO1(V,_V,S,_S)  TSNAME(S,_S)(x1)
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S)  TYPE :  DOMAIN  -->  V
#include <aux/com/macro1/ccod>
  selector functions for variants of unions
  if the selected variant is not valid an error routine is called

  if no explicit selectors are supported, see general info about unions,
  the variant names in lowercase are taken as names and prefixed with 'is_'

  these functions are not neccesary in pure VDM
  here conversion between union values and variants is done implicitly

  but in a programming language extra data is needed
  for storing the type information
  removing this data is done in C and Pascal by calling the selector functions
  in C++ the selectors are implemented as conversion function, so the
  explicit call is avoided

-----
[ -d $OUT_DIR/unio/sign/signature ] || mkdir $OUT_DIR/unio/sign/signature
cat >$OUT_DIR/unio/sign/signature/cpp <<'-----'
#ifdef DECL

#include <com/sign/signature/cpp>

#endif
-----
[ -d $OUT_DIR/unio/sign/sswitch ] || mkdir $OUT_DIR/unio/sign/sswitch
cat >$OUT_DIR/unio/sign/sswitch/gsig <<'-----'
#include <aux/sign/switch/gsig>
-----
cat >$OUT_DIR/unio/sign/sswitch/vsig <<'-----'
#include <aux/sign/switch/vsig>
-----
[ -d $OUT_DIR/unio/sign/subst ] || mkdir $OUT_DIR/unio/sign/subst
cat >$OUT_DIR/unio/sign/subst/cpp <<'-----'
#define T1 const Cpp_DOMAIN &
#if defined(BASEIMPL)

#define MACRO1(C,_C,S,_S,SS) InlineFriendConstFct(MERGE(subst_,S),FPAR2(T1,const C &),Cpp_DOMAIN)
#define MACRO2(C,_C,S,_S,SS) RUMPF({Cpp_DOMAIN tmp=THIS; tmp.MERGE(chg_,S)(x2); return tmp;})
#define MACRO3(C,_C,S,_S,SS)

#else

#define MACRO1(C,_C,S,_S,SS) InlineFriendConstFct(MERGE(subst_,S),FPAR2(T1,const C &),Cpp_DOMAIN)
#define MACRO2(C,_C,S,_S,SS) RUMPF(BODY1a(Cpp_DOMAIN,MERGE(subst,_S),FPARLIST2))
#define MACRO3(C,_C,S,_S,SS)

#endif
#include <aux/sign/mecro1/cpp>
#undef T1
-----
cat >$OUT_DIR/unio/sign/subst/gsig <<'-----'
#define MACRO1(V,_V,S,_S)  FUNCDEC(MERGE(subst,_S),PL_2(DOMAIN,V),DOMAIN)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/sign/subst/vsig <<'-----'
#define MACRO1(V,_V,S,_S)  MERGE(subst,_S)(x1,x2) = MERGE(chg,_S)(copy1(x1),x2)
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S)  TYPE : DOMAIN  V  -->  DOMAIN
#include <aux/com/macro1/ccod>
#define MACRO1(V,_V,S,_S)  PRE MERGE(subst,_S) : MERGE(is,_S)(x1)
#include <aux/com/macro1/ccod>
   copying of union value and changing the component
-----
[ -d $OUT_DIR/unio/union ] || mkdir $OUT_DIR/unio/union
[ -d $OUT_DIR/unio/union/basic ] || mkdir $OUT_DIR/unio/union/basic
cat >$OUT_DIR/unio/union/basic/docu <<'-----'
    Implementation of union as a union with tagfield

    Parameters:

      NOCHECK  :
                 optional, if defined no check on the
                 legality of accessing variants is done
      MACROS   :
                 functions a macros if possible       
                 MACROS implies NOCHECK
#include <unio/aux/basic/docu>
-----
cat >$OUT_DIR/unio/union/basic/gimp <<'-----'
#include <aux/com/basic/gimp>
-----
cat >$OUT_DIR/unio/union/basic/gtyp <<'-----'
#include <unio/aux/basic/gtyp>


#ifdef GEN_C
#define TMP1 MERGE(Struct,_DOMAIN)
#else 
#define TMP1 DOMAIN
#endif

  START_RECORD_TYP(TMP1)
                    RECFIELD(tag##_DOMAIN,discriminant##_DOMAIN);

#ifdef GEN_MODULA
                    var##_DOMAIN :
                    RECORD
                     CASE :discriminant##_DOMAIN OF
#define MACRO1(V,_V,S,_S)                     IDF_(MERGE(d,_S))  : RECFIELD(MERGE(f,_S),V)
#define MACRO0                     |
#include <aux/com/macro1/ccod>
                    END;
#else
#ifdef GEN_PASCAL
            var##_DOMAIN :
             RECORD
               CASE discriminant##_DOMAIN OF
#define MACRO1(V,_V,S,_S)   MERGE(d,_S)  : (MERGE(f,_S) : V)
#define MACRO0        ;
#include <aux/com/macro1/ccod>
               END;
#else
#ifdef GEN_C
                         union {
#define MACRO1(V,_V,S,_S)             V MERGE(f,_S) ;
#include <aux/com/macro1/ccod>
                               } var##_DOMAIN;
#else
   !!! fill in for other languages !!!
#endif
#endif
#endif

  END_RECORD_TYP(TMP1) 

#ifdef GEN_C
  typedef struct Struct##_DOMAIN DOMAIN;
#endif

#undef TMP1

-----
cat >$OUT_DIR/unio/union/basic/param <<'-----'
AUTOMEM
INTERNALDOMAIN
MACROS
NOCHECKS
SMALLTYPE
-----
cat >$OUT_DIR/unio/union/basic/vdm <<'-----'

#define CONSTRNAME mk_basic
#define ADTNAME ADT_UNIO
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/union/chg ] || mkdir $OUT_DIR/unio/union/chg
cat >$OUT_DIR/unio/union/chg/ccod <<'-----'
#if NOCHECK
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(chg,_S) _FPH2(DOMAIN,V) {x1.MERGE(var,_DOMAIN).MERGE(f,_S) = x2; return x1;}
#else
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(chg,_S) _FPH2(DOMAIN,V) {if (x1.MERGE(tag,_DOMAIN) != MERGE(d,_S)) err_tag_vdmlib(MKSTRING(DOMAIN)); x1.MERGE(var,_DOMAIN).MERGE(f,_S) = x2; return x1;}
#endif
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/union/chg/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! NOCHECK
   Vdmlib   = + err_tag
#endif
-----
[ -d $OUT_DIR/unio/union/discr ] || mkdir $OUT_DIR/unio/union/discr
cat >$OUT_DIR/unio/union/discr/ccod <<'-----'
  discriminant##_DOMAIN discr##_DOMAIN _FPH1(DOMAIN) {return x1.tag##_DOMAIN;}
-----
cat >$OUT_DIR/unio/union/discr/cmcr <<'-----'
_DEFINE discr##_DOMAIN(D) ((D).tag##_DOMAIN)
-----
cat >$OUT_DIR/unio/union/discr/pmcr <<'-----'
_DEFINE discr##_DOMAIN(D) discriminant##_DOMAIN(D.tag##_DOMAIN)
-----
[ -d $OUT_DIR/unio/union/is ] || mkdir $OUT_DIR/unio/union/is
cat >$OUT_DIR/unio/union/is/ccod <<'-----'
#define MACRO1(V,_V,S,_S) Bool MERGE(is,_S) _FPH1(DOMAIN) {return x1.MERGE(tag,_DOMAIN) == MERGE(d,_S);}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/union/is/cmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE MERGE(is,_S)(D) ((D).MERGE(tag,_DOMAIN) == MERGE(d,_S))
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/union/is/pmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE MERGE(is,_S)(D) (D.MERGE(tag,_DOMAIN) = ord(MERGE(d,_S)))
#include <aux/com/macro1/ccod>
-----
[ -d $OUT_DIR/unio/union/mk ] || mkdir $OUT_DIR/unio/union/mk
cat >$OUT_DIR/unio/union/mk/ccod <<'-----'
#define MACRO1(V,_V,S,_S) DOMAIN MERGE(mk,_S) _FPH1(V) {DOMAIN lx1; lx1.MERGE(tag,_DOMAIN) = MERGE(d,_S); lx1.MERGE(var,_DOMAIN).MERGE(f,_S) = x1; return lx1;}
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/union/mk/vdm <<'-----'

#define CONSTRNAME mk
#define ADTNAME ADT_TREE
#include <aux/com/constructor/vdm>
-----
[ -d $OUT_DIR/unio/union/s ] || mkdir $OUT_DIR/unio/union/s
cat >$OUT_DIR/unio/union/s/ccod <<'-----'
#if NOCHECK
#define MACRO1(V,_V,S,_S) V TSNAME(S,_S) _FPH1(DOMAIN) {return (x1.MERGE(var,_DOMAIN)).MERGE(f,_S);}
#else
#define MACRO1(V,_V,S,_S) V TSNAME(S,_S) _FPH1(DOMAIN) {if (x1.MERGE(tag,_DOMAIN) != MERGE(d,_S)) err_tag_vdmlib(MKSTRING(DOMAIN)); return (x1.MERGE(var,_DOMAIN)).MERGE(f,_S);}
#endif

#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/union/s/cmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE TSNAME(S,_S)(D) ((D).MERGE(var,_DOMAIN)).MERGE(f,_S)

#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/union/s/pmcr <<'-----'
#define MACRO1(V,_V,S,_S)_DEFINE TSNAME(S,_S)(D) D.MERGE(var,_DOMAIN).MERGE(f,_S)
#include <aux/com/macro1/ccod>
-----
cat >$OUT_DIR/unio/union/s/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#if ! MACROS && ! NOCHECK
   Vdmlib   = + err_tag
#endif
-----
[ -d $OUT_DIR/vdmlib ] || mkdir $OUT_DIR/vdmlib
[ -d $OUT_DIR/vdmlib/aux ] || mkdir $OUT_DIR/vdmlib/aux
[ -d $OUT_DIR/vdmlib/aux/vdm_error ] || mkdir $OUT_DIR/vdmlib/aux/vdm_error
cat >$OUT_DIR/vdmlib/aux/vdm_error/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
   Vdmlib   = + abort
#ifndef NOMESSAGES
              + header("IOSTREAM") 
#endif
-----
[ -d $OUT_DIR/vdmlib/com ] || mkdir $OUT_DIR/vdmlib/com
[ -d $OUT_DIR/vdmlib/com/abort ] || mkdir $OUT_DIR/vdmlib/com/abort
cat >$OUT_DIR/vdmlib/com/abort/ccod <<'-----'
#ifndef VDMERROR
#define VDMERROR exit(1)
#endif

  void abort##_DOMAIN _FPH1(Nat0)
   {
    VDMERROR;
   } 
#undef VDMERROR
-----
cat >$OUT_DIR/vdmlib/com/abort/docu <<'-----'
  The error routine can be changed using the optional parameter
  "VDMERROR".
  Default value for "VDMERROR" is exit(1).
  When changing this, prototypes eventually
  needed must be supplied explicitely (for instance by using
  the 'header(...)' enrichment of the vdmlib.

  The exit-call can be redefined generating error numbers by simply
  using the parameter 'x1' containing the error code.

  Example:

     Vdmlib = + abort(VDMERROR="exit(100 + x1)") + header(STDLIB)

  or
     
     Vdmlib = + abort(VDMERROR="own_error(x1)")

  This enrichment also adds the symbolic error number values used by
  the error routines to the generated headerfile.
-----
cat >$OUT_DIR/vdmlib/com/abort/gtyp <<'-----'
#ifdef GEN_C
/*- error numbers used by the error routines when calling abort ---*/

_DEFINE VDM_ERR_EMPTYSET	1	/* attempt to select element of an empty set */
_DEFINE VDM_ERR_EMPTYMAP	2	/* attempt to select an element from an empty map */
_DEFINE VDM_ERR_EMPTYHD	3	/* attempt to take 'hd' of an empty tuple */
_DEFINE VDM_ERR_ERRMAXLEN	4	/* length of structure exeedes maximum length */
_DEFINE VDM_ERR_NILPTR	5	/* pointer with NIL value */
_DEFINE VDM_ERR_NILOPT	6	/* attempt to access the component of an option with value NIL */
_DEFINE VDM_ERR_ILLPTR	7	/* dangling pointer reference */
_DEFINE VDM_ERR_SELECT	8	/* tuple index exeeds length of tuple */
_DEFINE VDM_ERR_SELMAP	9	/* attempt to select an element that is not in the domain of a map */
_DEFINE VDM_ERR_UNIO	10	/* attempt to access a non existing component of a union */
_DEFINE VDM_ERR_EMPTYTL	11	/* attempt to take 'tl' of an empty tuple */
_DEFINE VDM_ERR_UNION	12	/* attempt to union elements [d :-> r1] and [d :->r2] of a map */
_DEFINE VDM_ERR_NOTIMPL	13	/* operation %s not available for the selected implementation */
_DEFINE VDM_ERR_HEAPOFL	15	/* no more heap space available */
_DEFINE VDM_ERR_CVLINES	16	/* error in 'cvlines' */
_DEFINE VDM_ERR_NV_HDL  17      /* attempt to use an non valid handle */
_DEFINE VDM_ERR_EMPTYIT 18      /* attempt to select elements after the end of an iterater loop */
_DEFINE VDM_ERR_DIV0    19      /* attempt to divide by 0 */

#endif
-----
cat >$OUT_DIR/vdmlib/com/abort/param <<'-----'
VDMERROR
-----
cat >$OUT_DIR/vdmlib/com/abort/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
#ifndef VDMERROR
  Vdmlib  = + header("STDLIB")
#endif
-----
[ -d $OUT_DIR/vdmlib/com/basic ] || mkdir $OUT_DIR/vdmlib/com/basic
cat >$OUT_DIR/vdmlib/com/basic/adttype <<'-----'
REAL
-----
cat >$OUT_DIR/vdmlib/com/basic/ccod <<'-----'
#ifndef NOMESSAGES
_IFDEF __cplusplus
_DEFINE outerrstr##_DOMAIN(x1) cerr << x1
_DEFINE outerrint##_DOMAIN(x1) cerr << x1
_DEFINE outerrme1##_DOMAIN(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << " "
_DEFINE outerrmes##_DOMAIN(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << "\n"
_ELSE
_DEFINE outerrstr##_DOMAIN(x1) fprintf(stderr,"%s",x1)
_DEFINE outerrint##_DOMAIN(x1) fprintf(stderr,"%ld",x1)
_DEFINE outerrme1##_DOMAIN(x1,x2) fprintf(stderr,"\n\n%s : %s ",x2,x1)
_DEFINE outerrmes##_DOMAIN(x1,x2) fprintf(stderr,"\n\n%s : %s\n",x2,x1)
_ENDIF
#endif
-----
cat >$OUT_DIR/vdmlib/com/basic/docu <<'-----'
  The 'vdmlib' datatype contains a collection of auxiliary functions
  and several routines mainly for error reporting and interfaces to the
  operating system.

  This ADT is not a generic one. It will be generated
  by default together with the elementary data types (Nat0,...) to
  enshure the existence of all library routines needed
  (see predefined domains).


  Valid parameters for the elementary routines are:
 
  "VDMERROR": 
              allows changing the error exit routine; see docu for
              __SA(abort) for details.

  "MYHEADER": 
              defines an optional header that will be included at 
              the beginning of the generated C header file.

              For example including a line like

                 Vdmlib = common(MYHEADER="\"mytypes.h\"")

              in the implementation part of a ".vdm" file
              will result in an 'include' directive for "mytypes.h"
              at the beginning of the generated header file
              (the inner ""s need a \ as escape char !!!).

              The same can be done by a command line directive
              at generation time

                 vdm -SMYHEADER='"mytypes.h"' ...

              (again the ""s need to be quoted !!!).


  "MYSIGHEADER":
              Similar to "MYHEADER", defining an optional 
              header to be included at the beginning of the 
              procedure declaration (signature) section. This
              allows the definition of own functions as well
              as own auxiliary types like procedure pointers
              needed as parameters for fold-functions,...

  "NOMESSAGES":
              Usually an error occuring within an ADT operation 
              will be reported upon 'stderr' using the 'fprintf'
              facility (C++ :  cerr stream).
              If this parameter is defined, this error 
              message will be ommitted and the program termination
              routine 'abort' will be called directly. This is useful
              in programs running without operating system support
              (like i.e. embedded systems or operating systems
              themselves). 'abort' can be parameterized to terminate
              the program with an error code instead. See __SA(abort)
              operation of the 'vdmlib' operator for details.
-----
cat >$OUT_DIR/vdmlib/com/basic/gptr <<'-----'
#ifdef GEN_C

/* parameterisation of the VDM database with system parameters      */

/* optional private header file                                     */
#ifdef MYHEADER
_INCLUDE MYHEADER
#endif

/* system identification */
/* ndix                  */

/* sun 3 bsd4.2         */

#undef sun
_IF defined(sun) && ! defined(sparc)
_DEFINE __BSD42__
_ENDIF

/* sco xenix 2.3        */

#undef M_XENIX
_IFDEF M_XENIX
_DEFINE __XENIX__
_DEFINE __SYSV__
_ENDIF

/* Turbo C              */

#undef __TURBOC__
_IFDEF __TURBOC__
_DEFINE __DOS__
_ENDIF

/* void pointer definition */

#undef __TURBOC__
#undef __ANSIC__
#undef __STDC__
_IF defined(__TURBOC__) || defined(__ANSIC__) || defined(__STDC__)
   typedef void * VOIDptr;
_ELSE
   typedef char * VOIDptr;
_ENDIF

#endif
-----
cat >$OUT_DIR/vdmlib/com/basic/param <<'-----'
VDMERROR
MYHEADER
MYSIGHEADER
NOMESSAGES
FORWARD_ALLOWED
-----
[ -d $OUT_DIR/vdmlib/com/cvtext ] || mkdir $OUT_DIR/vdmlib/com/cvtext
cat >$OUT_DIR/vdmlib/com/cvtext/ccod <<'-----'

  Bool supress_cvlines##_DOMAIN  = TRUE;
  Nat0 curr_linelen##_DOMAIN;
  char *start_structure##_DOMAIN;
  char *end_structure##_DOMAIN;

  /* auxilary functions for conversion of domains into text */
  
  void adj_linelen_vdmlib _FPH1(Nat0)
     { curr_linelen_vdmlib = (curr_linelen_vdmlib > x1) ? (curr_linelen_vdmlib - x1) : 0;}

  Str ident_prefix##_DOMAIN _FPH2(Str,Nat0)
    { return conc_str(mkn_str(' ',x2 - len_str(x1)), x1); }

  Cvtext##_DOMAIN ident_lines##_DOMAIN _FPH2(Cvtext##_DOMAIN,Str)
    { Str lx1;Nat1 lx2;

      lx1 = mkn_str(' ',len_str(x2));
      x1  = ovwrt1_cvtext##_DOMAIN( x1
                                 , (Nat1)1
                                 , conc_str(x2,sel_cvtext##_DOMAIN(x1,(Nat1)1)));
      for(lx2 = 2;lx2 <= len_cvtext##_DOMAIN(x1); lx2++)
         x1 = ovwrt1_cvtext##_DOMAIN( x1
                                   , lx2
                                   , conc_str( copy_str(lx1)
                                             , sel_cvtext##_DOMAIN(x1,lx2)));
      del_str(lx1);
      return x1;
    }

  Cvtext##_DOMAIN close_struct##_DOMAIN _FPH3(Cvtext##_DOMAIN,Str,Nat0)
    { Nat0 lx1 = len_cvtext##_DOMAIN(x1);
      Str  lx2 = sel_cvtext##_DOMAIN(x1,(Nat1)lx1);
      Nat0 lx3 = 1;

      if (lx1 <= 2)
         return ovwrt1_cvtext##_DOMAIN(x1,(Nat1)lx1,conc_str(lx2,x2));

      while(sel_str(lx2,lx3) == ' ') lx3++;
      if (  len_str(x2) == 1  /* should allways be true */
	 && sel_str(lx2,lx3) == hd_str(x2)
	 )
	 { return ovwrt1_cvtext##_DOMAIN(x1
				       ,(Nat1)lx1
				       ,ovwrt1_str(lx2,x3,hd_str(x2)));
	 }


      return appr_cvtext##_DOMAIN(x1,ident_prefix##_DOMAIN(x2,x3));
    }

  Cvtext##_DOMAIN append_lastline##_DOMAIN _FPH2(Cvtext##_DOMAIN,Cvtext##_DOMAIN)
    { if (len_cvtext##_DOMAIN(x2) != 1)
         { 
#ifndef NOMESSAGES
           outerrstr##_DOMAIN("error in 2nd parameter of 'append_lastline'");
#endif
           abort##_DOMAIN(VDM_ERR_CVLINES);
         }
      { Nat0 lx1 = len_cvtext##_DOMAIN(x1);
      
        x1 = ovwrt1_cvtext##_DOMAIN( x1
                                  , (Nat1)lx1
                                  , conc_str( sel_cvtext##_DOMAIN(x1,(Nat1)lx1)
                                            , conc_str( mkc_str(",")
                                                      , hd_cvtext##_DOMAIN(x2))));
        del1_cvtext##_DOMAIN(x2);
        return x1;
      }
    }

  static Bool last_was_simple##_DOMAIN _FPH2(Cvtext##_DOMAIN,Nat0)
    { return (  len_cvtext##_DOMAIN(x1) == 1
             || index_str(last_cvtext##_DOMAIN(x1),',') == x2
             );
    }

  Cvtext##_DOMAIN cvlines2_cvtext##_DOMAIN _FPH2(Cvtext##_DOMAIN,Cvtext##_DOMAIN)
    { if (is_empty_cvtext##_DOMAIN(x1))
         return ident_lines##_DOMAIN(x2,mkc_str(start_structure##_DOMAIN));
      else
         { if (  len_cvtext##_DOMAIN(x2) == 1
              && len_str(hd_cvtext##_DOMAIN(x2))
                 + len_str(last_cvtext##_DOMAIN(x1))
                   < curr_linelen##_DOMAIN
              && last_was_simple##_DOMAIN(x1,(Nat0)strlen(start_structure##_DOMAIN))
              )
              return append_lastline##_DOMAIN(x1,x2);
           else   
              return conc_cvtext##_DOMAIN
                      (x1,ident_lines##_DOMAIN
                           (x2,ident_prefix##_DOMAIN( mkc_str(",")
                                                  , (Nat0)strlen(start_structure##_DOMAIN))));
         }
    }

_IFDEF __cplusplus
  void fprint_lines##_DOMAIN _FPH2(ostream &,Cvtext##_DOMAIN)
_ELSE
  void fprint_lines##_DOMAIN _FPH2(FILE *,Cvtext##_DOMAIN)
_ENDIF
    { Nat1          lx1;
    
      for (lx1 = 1;lx1 <= len_cvtext##_DOMAIN(x2); lx1++)
          { Nat1 lx3;
            Str  lx4;
          
            lx4 = sel_cvtext##_DOMAIN(x2,lx1);
            for (lx3 = 1; lx3 <= len_str(lx4); lx3++)
_IFDEF __cplusplus
                {x1 << (char)(sel_str(lx4,lx3));}
            x1 << "\n";
_ELSE
                {fprintf(x1,"%c",sel_str(lx4,lx3));}
            fprintf(x1,"\n");
_ENDIF
          }
    }
-----
cat >$OUT_DIR/vdmlib/com/cvtext/gtyp <<'-----'
#ifdef GEN_C

  /* global parameter for conversion of Domains into text */
  extern Bool supress_cvlines##_DOMAIN;
  extern Nat0 curr_linelen##_DOMAIN;
  extern char *start_structure##_DOMAIN;
  extern char *end_structure##_DOMAIN;

  /* auxiliary functions for conversion of domain into text lines */
  extern void           adj_linelen_vdmlib P_OP Nat0 x1 P_CL ;
  extern Str            ident_prefix##_DOMAIN P_OP Str x1, Nat0 x2 P_CL ;
  extern Cvtext##_DOMAIN ident_lines##_DOMAIN P_OP Cvtext##_DOMAIN x1, Str x2 P_CL ;
  extern Cvtext##_DOMAIN close_struct##_DOMAIN P_OP Cvtext##_DOMAIN x1,Str x2, Nat0 x3 P_CL ;
  extern Cvtext##_DOMAIN append_lastline##_DOMAIN P_OP Cvtext##_DOMAIN x1,Cvtext##_DOMAIN x2 P_CL ;
  extern Cvtext##_DOMAIN cvlines2_cvtext_vdmlib P_OP Cvtext##_DOMAIN x1,Cvtext##_DOMAIN x2 P_CL ;
_IFDEF __cplusplus
  extern void           fprint_lines##_DOMAIN P_OP ostream & x1,Cvtext##_DOMAIN x2 P_CL ;
_ELSE
  extern void           fprint_lines##_DOMAIN P_OP FILE *x1,Cvtext##_DOMAIN x2 P_CL ;
_ENDIF

#endif
-----
cat >$OUT_DIR/vdmlib/com/cvtext/vdm <<'-----'
DOMAINS
  Cvtext_vdmlib   =  Str*
IMPLEMENTATIONS
  Cvtext_vdmlib   =  array("INTERNALDOMAIN") 
                     + ovwrt1 + sel + appr + len + hd + last + conc
                     + is_empty + del + mk_empty

  Str             =  + len + conc + mkn + copy + del + mkc + index
		     + hd + ovwrt1 + sel

  Vdmlib          =  + header("IOSTREAM","SPRINTF") + abort
-----
[ -d $OUT_DIR/vdmlib/com/err_div0 ] || mkdir $OUT_DIR/vdmlib/com/err_div0
cat >$OUT_DIR/vdmlib/com/err_div0/ccod <<'-----'
  void err_div0##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to divide by 0",x1);
#endif
    abort##_DOMAIN(VDM_ERR_DIV0);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_div0/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_elem ] || mkdir $OUT_DIR/vdmlib/com/err_elem
cat >$OUT_DIR/vdmlib/com/err_elem/ccod <<'-----'
  void err_elem##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to select an element from an empty set",x1);
#endif
    abort##_DOMAIN(VDM_ERR_EMPTYSET);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_elem/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_emap ] || mkdir $OUT_DIR/vdmlib/com/err_emap
cat >$OUT_DIR/vdmlib/com/err_emap/ccod <<'-----'
  void err_emap##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to select an element from an empty map",x1);
#endif
    abort##_DOMAIN(VDM_ERR_EMPTYMAP);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_emap/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_empty_iterator ] || mkdir $OUT_DIR/vdmlib/com/err_empty_iterator
cat >$OUT_DIR/vdmlib/com/err_empty_iterator/ccod <<'-----'
  void err_empty_iterator##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("no more elements to process by an iterator",x1);
#endif
    abort##_DOMAIN(VDM_ERR_EMPTYIT);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_empty_iterator/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_hd ] || mkdir $OUT_DIR/vdmlib/com/err_hd
cat >$OUT_DIR/vdmlib/com/err_hd/ccod <<'-----'
  void err_hd##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to take 'hd' of an empty tuple",x1);
#endif
    abort##_DOMAIN(VDM_ERR_EMPTYHD);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_hd/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_maxlen ] || mkdir $OUT_DIR/vdmlib/com/err_maxlen
cat >$OUT_DIR/vdmlib/com/err_maxlen/ccod <<'-----'
  void err_maxlen##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("length of structure exeedes maximum length",x1);
#endif
    abort##_DOMAIN(VDM_ERR_ERRMAXLEN);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_maxlen/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_nil ] || mkdir $OUT_DIR/vdmlib/com/err_nil
cat >$OUT_DIR/vdmlib/com/err_nil/ccod <<'-----'
  void err_nil##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("pointer with NIL value",x1);
#endif
    abort##_DOMAIN(VDM_ERR_NILPTR);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_nil/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_nv_hdl ] || mkdir $OUT_DIR/vdmlib/com/err_nv_hdl
cat >$OUT_DIR/vdmlib/com/err_nv_hdl/ccod <<'-----'
  void err_nv_hdl##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("accessed object contains no valid data",x1);
#endif
    abort##_DOMAIN(VDM_ERR_NV_HDL);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_nv_hdl/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_opt ] || mkdir $OUT_DIR/vdmlib/com/err_opt
cat >$OUT_DIR/vdmlib/com/err_opt/ccod <<'-----'
  void err_opt##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to access the component of an option with value NIL",x1);
#endif
    abort##_DOMAIN(VDM_ERR_NILOPT);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_opt/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_ref ] || mkdir $OUT_DIR/vdmlib/com/err_ref
cat >$OUT_DIR/vdmlib/com/err_ref/ccod <<'-----'
  void err_ref##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("dangling pointer reference",x1);
#endif
    abort##_DOMAIN(VDM_ERR_ILLPTR);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_ref/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_sel ] || mkdir $OUT_DIR/vdmlib/com/err_sel
cat >$OUT_DIR/vdmlib/com/err_sel/ccod <<'-----'
  void err_sel##_DOMAIN _FPH3(Nat1,Nat0,char *)
   { 
#ifndef NOMESSAGES
    outerrme1##_DOMAIN("attempt to select element",x3);
    outerrint##_DOMAIN((long)x1);
    outerrstr##_DOMAIN(" of tuple with length ");
    outerrint##_DOMAIN((long)x2);
    outerrstr##_DOMAIN("\n");
#endif
    abort##_DOMAIN(VDM_ERR_SELECT);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_sel/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_smap ] || mkdir $OUT_DIR/vdmlib/com/err_smap
cat >$OUT_DIR/vdmlib/com/err_smap/ccod <<'-----'
  void err_smap##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to select an element that is not in the domain of a map",x1);
#endif
    abort##_DOMAIN(VDM_ERR_SELMAP);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_smap/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_tag ] || mkdir $OUT_DIR/vdmlib/com/err_tag
cat >$OUT_DIR/vdmlib/com/err_tag/ccod <<'-----'
  void err_tag##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to access a non existing component of a union",x1);
#endif
    abort##_DOMAIN(VDM_ERR_UNIO);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_tag/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_tl ] || mkdir $OUT_DIR/vdmlib/com/err_tl
cat >$OUT_DIR/vdmlib/com/err_tl/ccod <<'-----'
  void err_tl##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to take 'tl' of an empty tuple",x1);
#endif
    abort##_DOMAIN(VDM_ERR_EMPTYTL);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_tl/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_umap ] || mkdir $OUT_DIR/vdmlib/com/err_umap
cat >$OUT_DIR/vdmlib/com/err_umap/ccod <<'-----'
  void err_umap##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to union elements [d :-> r1] and [d :->r2] of a map",x1);
#endif
    abort##_DOMAIN(VDM_ERR_UNION);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_umap/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_uop ] || mkdir $OUT_DIR/vdmlib/com/err_uop
cat >$OUT_DIR/vdmlib/com/err_uop/ccod <<'-----'
  void err_uop##_DOMAIN _FPH2(char *,char *)
   { 
#ifndef NOMESSAGES
    outerrme1##_DOMAIN("operation",x1);
    outerrstr##_DOMAIN(x1);
    outerrstr##_DOMAIN(" not available for the selected implementation\n");
#endif
    abort##_DOMAIN(VDM_ERR_NOTIMPL);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_uop/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/err_uuni ] || mkdir $OUT_DIR/vdmlib/com/err_uuni
cat >$OUT_DIR/vdmlib/com/err_uuni/ccod <<'-----'
  void err_uuni##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("attempt to select an unknown component of a union value",x1);
#endif
    abort##_DOMAIN(VDM_ERR_UNIO);
   } 
-----
cat >$OUT_DIR/vdmlib/com/err_uuni/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/genptr ] || mkdir $OUT_DIR/vdmlib/com/genptr
cat >$OUT_DIR/vdmlib/com/genptr/param <<'-----'
GTYPEDEF
-----
cat >$OUT_DIR/vdmlib/com/genptr/vdm <<'-----'
DOMAINS
   Genptr        = TOKEN

IMPLEMENTATIONS
   Genptr        = ptr( "STRUCT"="POINTER_TO(Genptr)",
                       "CSTRUCT"="POINTER_TO(void)"
#ifdef GTYPEDEF
                      ,"GTYPEDEF"
#endif
                      )
-----
[ -d $OUT_DIR/vdmlib/com/header ] || mkdir $OUT_DIR/vdmlib/com/header
cat >$OUT_DIR/vdmlib/com/header/docu <<'-----'
  enrichment file for including C header files

  a header file may be included by the Implementation directive

     Vdmlib   =  + header(NAME)

  where NAME determines <name.h> as the header file to be included
  system dependent renaming (e.g. <strings.h> in <string.h>) is done in this
  module. header files needed by other header files are included automatically.

  header files currently supported : NAME =

  "CTYPE" 
            <ctype.h>

  "DIRENT" 
            <sys/dirent.h> default
            <dirent.h>  for __POSIX (__linux__, _AIX, sun sparc) and __XENIX__
            <sys/dir.h> for __BSD42__

  "ERRNO"
            <errno.h>

  "FCNTL"
            <fcntl.h>

  "FLOAT"
            <float.h>

  "IOSTREAM"
            <iostream.h> for __cplusplus only

  "MATH"
            <math.h>

  "MEMORY"
            <memory.h> default
            <string.h> for __STDC__

  "SPRINTF" 
            <stdio.h> for __cplusplus only
  "STAT"
            <sys/stat.h>

  "STRING" 
            <string.h> default
            <strings.h> for __BSD42__

  "STDIO" 
            <stdio.h>

  "STDLIB" 
            <stdlib.h> for __STDC__ and __cplusplus only

  "TYPES" 
            <sys/types.h>

  "UNISTD" 
            <unistd.h> for __POSIX
            <sys/unistd.h> else
-----
cat >$OUT_DIR/vdmlib/com/header/gptr <<'-----'
#ifdef GEN_C

#undef __STDC__
#undef __XENIX__
#undef __BSD42__
#undef apollo
#undef __cplusplus
#undef _AIX
#undef __STDC__
#undef __linux__
#undef __POSIX

/* dirent.h needs stat.h */
#ifdef DIRENT
#ifndef STAT
#define STAT
#endif
#endif

/* stat.h needs types.h */
#ifdef STAT
#ifndef TYPES
#define TYPES
#endif
#endif

_IF defined(__linux__) || defined(_AIX) || defined(MIPSEL) || (defined(sun) && defined(sparc))
_IFNDEF __POSIX
_DEFINE __POSIX
_ENDIF
_ENDIF

/* stdlib--------------------------------- */

#ifdef STDLIB
_IFDEF  __cplusplus
_INCLUDE <stdlib.h>
_ELSE
_IF defined(__STDC__) || defined(__POSIX)
_IFNDEF apollo
_INCLUDE <stdlib.h>
_ENDIF
_ENDIF
_ENDIF
#undef STDLIB
#endif

/* memory--------------------------------- */

#ifdef MEMORY
_IF defined(__STDC__) || defined(__cplusplus) || defined(__POSIX)
_INCLUDE <string.h>
_ELSE
_INCLUDE <memory.h>
_ENDIF
#undef MEMORY
#endif 

/* ctypes--------------------------------- */

#ifdef CTYPE
_INCLUDE <ctype.h>
#undef CTYPE
#endif

/* sprintf-------------------------------- */

#ifdef SPRINTF
_IFDEF __cplusplus
_INCLUDE <stdio.h>
_ENDIF
#undef SPRINTF
#endif

/* stdio --------------------------------- */

#ifdef IOSTREAM
_IFDEF __cplusplus
_INCLUDE <iostream.h>
_ELSE
_INCLUDE <stdio.h>
_ENDIF
#undef IOSTREAM
#endif

#ifdef STDIO
_INCLUDE <stdio.h>
#undef STDIO
#endif

/* float --------------------------------- */

#ifdef FLOAT
_INCLUDE <float.h>
#undef FLOAT
#endif

/* fcntl --------------------------------- */

#ifdef FCNTL
_INCLUDE <fcntl.h>
#undef FCNTL
#endif

/* errno --------------------------------- */

#ifdef ERRNO
_INCLUDE <errno.h>
#undef ERRNO
#endif

/* math functions ------------------------ */

#ifdef MATH
_INCLUDE <math.h>
#undef MATH
#endif

/* types ---------------------------------- */

#ifdef TYPES
_INCLUDE <sys/types.h>
#undef TYPES
#endif

/* string--------------------------------- */

#ifdef STRING
_IFDEF __BSD42__
_INCLUDE <strings.h>
_ELSE
_INCLUDE <string.h>
_ENDIF
#undef STRING
#endif

/* stat----------------------------------- */

#ifdef STAT
_INCLUDE <sys/stat.h>
#undef STAT
#endif

/* dirent--------------------------------- */

#ifdef DIRENT
_IFDEF __BSD42__
_INCLUDE <sys/dir.h>
_ELSE
_IF defined(__POSIX) || defined(__XENIX__)
_INCLUDE <dirent.h>
_ELSE
_INCLUDE <sys/dirent.h>
_ENDIF
_ENDIF
#undef DIRENT
#endif

/* unistd---------------------------------- */

#ifdef UNISTD
_IFDEF __POSIX
_INCLUDE <unistd.h>
_ELSE
_INCLUDE <sys/unistd.h>
_ENDIF
#undef UNISTD
#endif
#endif
-----
cat >$OUT_DIR/vdmlib/com/header/param <<'-----'
CTYPE
DIRENT
ERRNO
FCNTL
FLOAT
IOSTREAM
MATH
MEMORY
SPRINTF
STAT
STDIO
STDLIB
STRING
TYPES
UNISTD
-----
[ -d $OUT_DIR/vdmlib/com/heap_oflw ] || mkdir $OUT_DIR/vdmlib/com/heap_oflw
cat >$OUT_DIR/vdmlib/com/heap_oflw/ccod <<'-----'
  void heap_oflw##_DOMAIN _FPH1(char *)
   { 
#ifndef NOMESSAGES
    outerrmes##_DOMAIN("no more heap space available",x1);
#endif
    abort##_DOMAIN(VDM_ERR_HEAPOFL);
   } 
-----
cat >$OUT_DIR/vdmlib/com/heap_oflw/vdm <<'-----'
#include <vdmlib/aux/vdm_error/vdm>
-----
[ -d $OUT_DIR/vdmlib/com/mallfree ] || mkdir $OUT_DIR/vdmlib/com/mallfree
cat >$OUT_DIR/vdmlib/com/mallfree/docu <<'-----'
  Generates basic "allocmem" functions using C malloc/free

  Parameters:

  "NOMALLOC":
              supresses generation of alloc functions at all
	      assuming external implementation. In this case 
	      either external- or macro definition must be 
	      supplied by the user.
-----
cat >$OUT_DIR/vdmlib/com/mallfree/gtyp <<'-----'
#ifdef GEN_C

#ifndef NOMALLOC
#undef __cplusplus
#undef __STDC__
_IFDEF __cplusplus
  inline VOIDptr ALLOCMEM##_DOMAIN(unsigned long int x1)
     { return (VOIDptr)(new char[x1]); }
  inline void FREEMEM##_DOMAIN(VOIDptr x1,unsigned long int)
     { delete (char *)(x1); }
_ELSE
_IF ! defined(__STDC__) && ! defined(_AIX) && ! defined(__NOMALLOC__)
  extern VOIDptr malloc P_OP unsigned long x1 P_CL ;
  extern void free P_OP VOIDptr x1 P_CL ;
_ENDIF
_DEFINE ALLOCMEM##_DOMAIN(x1) malloc(x1)
_DEFINE FREEMEM##_DOMAIN(x1,x2) free(x1)
_ENDIF
#endif

#endif
-----
cat >$OUT_DIR/vdmlib/com/mallfree/param <<'-----'
NOMALLOC
-----
cat >$OUT_DIR/vdmlib/com/mallfree/vdm <<'-----'
#ifndef NOMALLOC
  DOMAINS
  IMPLEMENTATIONS
    Vdmlib = + header("STDLIB")
#endif
-----
[ -d $OUT_DIR/vdmlib/com/parseio ] || mkdir $OUT_DIR/vdmlib/com/parseio
cat >$OUT_DIR/vdmlib/com/parseio/ccod <<'-----'
_IFDEF __cplusplus

static  int lastchar##_DOMAIN = -1;
istream * parseinput##_DOMAIN = &cin;

char getchar##_DOMAIN _FPH0()
{
   if (lastchar##_DOMAIN == -1)
   {   
      char c;
      (*parseinput##_DOMAIN).get(c);
      return c;
   }
   else
   {
      char lx1 = lastchar##_DOMAIN; 
      lastchar##_DOMAIN = -1; 
      return lx1; 
   }
}

void unputchar##_DOMAIN _FPH1(char)
{ 
   (*parseinput##_DOMAIN).putback(x1); 
}

void parseerror##_DOMAIN _FPH3(char *, char *, char *)
{ 
   fprintf(stderr,"%s: %s%s\n",x2,x1,x3);
   abort_vdmlib(33);
}

_ELSE

static int lastchar##_DOMAIN = -1;
FILE *parseinput##_DOMAIN = stdin;

char getchar##_DOMAIN _FPH0()
  { if (lastchar##_DOMAIN == -1)
       { return getc(parseinput##_DOMAIN); }
    else
       { char lx1 = lastchar##_DOMAIN; lastchar##_DOMAIN = -1; return lx1; }
  }

void unputchar##_DOMAIN _FPH1(char)
  { ungetc(x1,parseinput##_DOMAIN); }

void parseerror##_DOMAIN _FPH3(char *, char *, char *)
  { fprintf(stderr,"%s: %s%s\n",x2,x1,x3);
    abort_vdmlib(33);
  }

_ENDIF

-----
cat >$OUT_DIR/vdmlib/com/parseio/vdm <<'-----'
 DOMAINS
 IMPLEMENTATIONS
   Vdmlib = + header("STDIO") + abort
-----
[ -d $OUT_DIR/vdmlib/com/parsesup ] || mkdir $OUT_DIR/vdmlib/com/parsesup
cat >$OUT_DIR/vdmlib/com/parsesup/ccod <<'-----'

/*- error routines ------------------------------------------*/

void expected##_DOMAIN _FPH3(char*, char*, char*)
  { char lx1[200];
    sprintf(lx1," expected, read: %s",x3);
    parseerror##_DOMAIN(x2,x1,lx1);
  }
void out_of_range##_DOMAIN _FPH2(char *,long)
  { char lx1[20];
    sprintf(lx1,"%ld",x2);
    parseerror##_DOMAIN(lx1,x1,": value out of range");
  }

/*- scanner routines ----------------------------------------*/

char *char2str##_DOMAIN _FPH1(char)
  { static char lx1[8]; static int i = 0;
    if (i > 4) { i = 0; }
    lx1[i++] = x1; lx1[i++] = 0; return &lx1[i-2];
  }

void skip_blanks##_DOMAIN _FPH0()
  { char lx1;
    
    do { lx1 = getchar##_DOMAIN(); }
    while ( lx1 == ' ' || lx1 == '\n' || lx1 == '\t');
    unputchar##_DOMAIN(lx1);
  }

char next_char##_DOMAIN _FPH0()
  { skip_blanks##_DOMAIN(); return getchar##_DOMAIN(); }

Bool check_char##_DOMAIN _FPH1(char)
  { char lx1 = next_char##_DOMAIN();
    unputchar##_DOMAIN(lx1);
    return lx1 == x1;
  }

void expect##_DOMAIN _FPH2(char*, char*)
  { /* Check if the string 'x1' is the next token within input stream */
    char *x11 = x1;
    char x12[300];
    int i = 0;

    skip_blanks##_DOMAIN();
    while (*x11)
      { char c = x12[i++] = getchar##_DOMAIN();
	if (c != *(x11++))
	   { x12[i] = 0; unputchar##_DOMAIN(c); expected##_DOMAIN(x2,x1,x12); }
      }
  }

long readint##_DOMAIN _FPH1(char *)
  { char lx1;
    int  neg;
    long lx2 = 0;

    skip_blanks##_DOMAIN();

    lx1 = getchar##_DOMAIN();
    neg = (lx1 == '-') ? 1 : 0;

    if (lx1 == '-' || lx1 == '+') { lx1 = getchar##_DOMAIN(); }
    if (!isdigit(lx1))
       { unputchar##_DOMAIN(lx1);
	 expected##_DOMAIN(x1,"Digit",char2str##_DOMAIN(lx1)); 
	 return lx2;
       }
    
    do
       { lx2 = 10*lx2 + (lx1 - '0'); lx1 = getchar##_DOMAIN(); }
    while (isdigit(lx1));
    unputchar##_DOMAIN(lx1);
    return (neg) ? -lx2 : lx2;
  }

#ifdef FLOATSUPPORT
double readdouble##_DOMAIN _FPH2(char *,char *)
  { char   lx1[510]; /* char buffer for sscanf */
                     /* ANSI requires 509 chars as maximum */
    char * lx2;
    register char c;

    skip_blanks##_DOMAIN();

    lx2 = lx1;
    c = getchar##_DOMAIN();
    if ( c == '-' || c == '+' ) { *(lx2++) = c; c = getchar##_DOMAIN(); }
    while ( isdigit(c) ) {
      *(lx2++) = c; c = getchar##_DOMAIN();
    }
    if ( c == '.' ) { *(lx2++) = c; c = getchar##_DOMAIN(); }
    while ( isdigit(c) ) {
      *(lx2++) = c; c = getchar##_DOMAIN();
    }
    if ( c == 'e' || c == 'E' ) {
      *(lx2++) = c; c = getchar##_DOMAIN();
      if ( c == '-' || c == '+' ) { *(lx2++) = c; c = getchar##_DOMAIN(); }
      while ( isdigit(c) ) {
        *(lx2++) = c; c = getchar##_DOMAIN();
      }
    }
    *lx2 = 0; /* string termination */
    unputchar##_DOMAIN(c); /* put back last char not containing to number */

    { double lx3;

      lx3 = 0.0;
      if ( sscanf(lx1,x2, &lx3) != 1 ) {
        parseerror##_DOMAIN(lx1,x1,": error in floating point conversion");
      }
      
      return lx3;
    }
  }
#endif

char *readtoken##_DOMAIN _FPH1(char*)
  { static char lx1[500]; /* result, must be used up before next call */
    register int lx2 = 0;
    register char lx3;

    skip_blanks##_DOMAIN();
    if (!isalpha(lx3 = getchar##_DOMAIN()))
       { unputchar##_DOMAIN(lx3);
	 expected##_DOMAIN(x1,"Character",char2str##_DOMAIN(lx3));
	 return "";
       }

    do 
       { lx1[lx2] = lx3; lx3 = getchar##_DOMAIN(); if (lx2 < 500) { lx2++; } }
    while (isalnum(lx3) || lx3 == '_');
    unputchar##_DOMAIN(lx3); lx1[lx2] = 0;

    return lx1;
  }

void unputtoken##_DOMAIN _FPH1(char *)
  { int i;
    for (i = strlen(x1) - 1; i >= 0; i--)
	{ unputchar##_DOMAIN(x1[i]); }
  }

-----
cat >$OUT_DIR/vdmlib/com/parsesup/param <<'-----'
FLOATSUPPORT
-----
cat >$OUT_DIR/vdmlib/com/parsesup/vdm <<'-----'
DOMAINS
IMPLEMENTATIONS
  Vdmlib = + header("CTYPE","SPRINTF")
-----
[ -d $OUT_DIR/vdmlib/com/printsup ] || mkdir $OUT_DIR/vdmlib/com/printsup
cat >$OUT_DIR/vdmlib/com/printsup/ccod <<'-----'
_IFDEF __cplusplus
  ostream * ptr_print_FD##_DOMAIN = & cerr;
_ELSE
  FILE * print_FD##_DOMAIN = stderr;
_ENDIF
-----
cat >$OUT_DIR/vdmlib/com/printsup/gtyp <<'-----'
#ifdef GEN_C
_IFDEF __cplusplus
  extern ostream * ptr_print_FD##_DOMAIN;
_DEFINE print_FD##_DOMAIN (*ptr_print_FD##_DOMAIN)
  COMMENT_(default: 'cerr')
_ELSE
  extern FILE *print_FD##_DOMAIN;
  COMMENT_(default: 'stderr')
_ENDIF
#endif
-----
[ -d $OUT_DIR/vdmlib/common ] || mkdir $OUT_DIR/vdmlib/common
[ -d $OUT_DIR/vdmlib/common/basic ] || mkdir $OUT_DIR/vdmlib/common/basic
cat >$OUT_DIR/vdmlib/common/basic/ccod <<'-----'
#ifndef NOMESSAGES
_IFDEF __cplusplus
_DEFINE outerrstr##_DOMAIN(x1) cerr << x1
_DEFINE outerrint##_DOMAIN(x1) cerr << x1
_DEFINE outerrme1##_DOMAIN(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << " "
_DEFINE outerrmes##_DOMAIN(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << "\n"
_ELSE
_DEFINE outerrstr##_DOMAIN(x1) fprintf(stderr,"%s",x1)
_DEFINE outerrint##_DOMAIN(x1) fprintf(stderr,"%ld",x1)
_DEFINE outerrme1##_DOMAIN(x1,x2) fprintf(stderr,"\n\n%s : %s ",x2,x1)
_DEFINE outerrmes##_DOMAIN(x1,x2) fprintf(stderr,"\n\n%s : %s\n",x2,x1)
_ENDIF
#endif
-----
cat >$OUT_DIR/vdmlib/common/basic/docu <<'-----'
  The single implementation of the 'vdmlib' datatype
-----
cat >$OUT_DIR/vdmlib/common/basic/gptr <<'-----'
#ifdef GEN_C

/* parameterisation of the VDM database with system parameters      */

/* optional private header file                                     */
#ifdef MYHEADER
_INCLUDE MYHEADER
#endif

/* system identification */
/* ndix                  */

/* sun 3 bsd4.2         */

#undef sun
_IF defined(sun) && ! defined(sparc)
_DEFINE __BSD42__
_ENDIF

/* sco xenix 2.3        */

#undef M_XENIX
_IFDEF M_XENIX
_DEFINE __XENIX__
_DEFINE __SYSV__
_ENDIF

/* Turbo C              */

#undef __TURBOC__
_IFDEF __TURBOC__
_DEFINE __DOS__
_ENDIF

/* void pointer definition */

#undef __TURBOC__
#undef __ANSIC__
#undef __STDC__
_IF defined(__TURBOC__) || defined(__ANSIC__) || defined(__STDC__)
   typedef void * VOIDptr;
_ELSE
   typedef char * VOIDptr;
_ENDIF

#endif
-----
cat >$OUT_DIR/vdmlib/common/basic/param <<'-----'
INTERNALDOMAIN
MYHEADER
MYSIGHEADER
NOMESSAGES
VDMERROR
-----
[ -d $OUT_DIR/vdmlib/sign ] || mkdir $OUT_DIR/vdmlib/sign
[ -d $OUT_DIR/vdmlib/sign/abort ] || mkdir $OUT_DIR/vdmlib/sign/abort
cat >$OUT_DIR/vdmlib/sign/abort/gsig <<'-----'
  PROCDEC(abort##_DOMAIN,PL_1(Nat0))
-----
cat >$OUT_DIR/vdmlib/sign/abort/vsig <<'-----'
  abort(x1) = exit program
  Type :  Nat0  ==>

  aborts the execution of a program. It takes an error number as 
  argument which can be used to generate an exitcode of the program.
  __EM(abort) is called from all error routines in the VDM Class Library.

  If an error routine is called from a routine, the
  error position can be detected by setting a breakpoint at the
  abort routine (in the class library __EM(abort) is named __EM(abort_vdmlib) to
  avoid name conflicts with other libraries)
-----
[ -d $OUT_DIR/vdmlib/sign/basic ] || mkdir $OUT_DIR/vdmlib/sign/basic
cat >$OUT_DIR/vdmlib/sign/basic/cpp <<'-----'
#ifdef DECL
class Cpp_DOMAIN { 
#endif
-----
cat >$OUT_DIR/vdmlib/sign/basic/cppclass <<'-----'
class Cpp_DOMAIN;
-----
cat >$OUT_DIR/vdmlib/sign/basic/gsig <<'-----'
#ifdef GEN_C

/* optional private signature header file */
#ifdef MYSIGHEADER
_INCLUDE MYSIGHEADER
#endif


#endif
-----
[ -d $OUT_DIR/vdmlib/sign/err_div0 ] || mkdir $OUT_DIR/vdmlib/sign/err_div0
cat >$OUT_DIR/vdmlib/sign/err_div0/gsig <<'-----'
  PROCDEC(err_div0##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_div0/vsig <<'-----'
  err_div0(x1) =
  TYPE :  Str  -->

  Error routine for numeric values:
  attempt to divide by 0
-----
[ -d $OUT_DIR/vdmlib/sign/err_elem ] || mkdir $OUT_DIR/vdmlib/sign/err_elem
cat >$OUT_DIR/vdmlib/sign/err_elem/gsig <<'-----'
  PROCDEC(err_elem##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_elem/vsig <<'-----'
  err_elem(x1) =
  TYPE :  Str  -->

  error routine for sets
  an attempt is made to select an element from an empty set
-----
[ -d $OUT_DIR/vdmlib/sign/err_emap ] || mkdir $OUT_DIR/vdmlib/sign/err_emap
cat >$OUT_DIR/vdmlib/sign/err_emap/gsig <<'-----'
  PROCDEC(err_emap##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_emap/vsig <<'-----'
  err_emap(x1) =
  TYPE :  Str  -->

  error routine for maps
  an attempt is made to select an element from an empty map
-----
[ -d $OUT_DIR/vdmlib/sign/err_empty_iterator ] || mkdir $OUT_DIR/vdmlib/sign/err_empty_iterator
cat >$OUT_DIR/vdmlib/sign/err_empty_iterator/gsig <<'-----'
  PROCDEC(err_empty_iterator##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_empty_iterator/vsig <<'-----'
  err_empty_iterator(x1) =
  TYPE :  Str  -->

  error routine for iterator functions
  an attempt is made to move the iterator curser
  beyond the last element of a collection
-----
[ -d $OUT_DIR/vdmlib/sign/err_hd ] || mkdir $OUT_DIR/vdmlib/sign/err_hd
cat >$OUT_DIR/vdmlib/sign/err_hd/gsig <<'-----'
  PROCDEC(err_hd##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_hd/vsig <<'-----'
  err_hd(x1) =
  TYPE :  Str  -->

  Error routine for tuples:
  __SA(hd) was applied to an empty tuple
-----
[ -d $OUT_DIR/vdmlib/sign/err_maxlen ] || mkdir $OUT_DIR/vdmlib/sign/err_maxlen
cat >$OUT_DIR/vdmlib/sign/err_maxlen/gsig <<'-----'
  PROCDEC(err_maxlen##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_maxlen/vsig <<'-----'
  err_maxlen(x1) =
  TYPE :  Str  -->

  Generl error routine:
  Some static space restriction has been violated
-----
[ -d $OUT_DIR/vdmlib/sign/err_nil ] || mkdir $OUT_DIR/vdmlib/sign/err_nil
cat >$OUT_DIR/vdmlib/sign/err_nil/gsig <<'-----'
  PROCDEC(err_nil##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_nil/vsig <<'-----'
  err_nil(x1) =
  TYPE :  Str  -->

  error routine for dynamically allocated variables
  an attempt is made to access a pointer with NIL value
-----
[ -d $OUT_DIR/vdmlib/sign/err_nv_hdl ] || mkdir $OUT_DIR/vdmlib/sign/err_nv_hdl
cat >$OUT_DIR/vdmlib/sign/err_nv_hdl/gsig <<'-----'
  PROCDEC(err_nv_hdl##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_nv_hdl/vsig <<'-----'
  err_nv_handle(x1) =
  TYPE :  Str  -->

  Error routine for automatic memory management in C++:

  An object, which was created by the default constructor __EM(DOMAIN::DOMAIN())
  and therefore contains no valid data, has been accessed.
     
  You have to initialise such an object as lvalue in an assigment or as
  reference parameter in a function call before any other usage.

  If you want to create a __EM(real empty) object (e.g. an empty set) use the
  constructor __EM(DOMAIN::DOMAIN(NILETC)) instead e.g.:

    ASET aset = empty;
 
  will initialize the variable __EM(aset) with the empty set.
-----
[ -d $OUT_DIR/vdmlib/sign/err_opt ] || mkdir $OUT_DIR/vdmlib/sign/err_opt
cat >$OUT_DIR/vdmlib/sign/err_opt/gsig <<'-----'
  PROCDEC(err_opt##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_opt/vsig <<'-----'
  err_opt(x1) =
  TYPE :  Str  -->

  error routine for optional domains
  an attempt is made to access the component of a option with value NIL
-----
[ -d $OUT_DIR/vdmlib/sign/err_ref ] || mkdir $OUT_DIR/vdmlib/sign/err_ref
cat >$OUT_DIR/vdmlib/sign/err_ref/gsig <<'-----'
  PROCDEC(err_ref##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_ref/vsig <<'-----'
  err_ref(x1) =
  TYPE :  Str  -->

  error routine for dynamically allocated variables
  an attempt is made to access an undefined variable of domain x1
  in many cases this error occours during an access to a dangling pointer
  reference, where the variable is already destroied
-----
[ -d $OUT_DIR/vdmlib/sign/err_sel ] || mkdir $OUT_DIR/vdmlib/sign/err_sel
cat >$OUT_DIR/vdmlib/sign/err_sel/gsig <<'-----'
  PROCDEC(err_sel##_DOMAIN,PL_VVR(Nat1,Nat0,CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_sel/vsig <<'-----'
  err_sel(x1,x2,x3) =
  TYPE :  Nat1  Nat0  Str  -->

  error routine for tuples
  an attempt is made to access element x1 of a tuple with length x2
-----
[ -d $OUT_DIR/vdmlib/sign/err_smap ] || mkdir $OUT_DIR/vdmlib/sign/err_smap
cat >$OUT_DIR/vdmlib/sign/err_smap/gsig <<'-----'
  PROCDEC(err_smap##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_smap/vsig <<'-----'
  err_smap(x1) =
  TYPE :  Str  -->

  error routine for maps
  an attempt is made to select an element that is not in the domain
  of a map
-----
[ -d $OUT_DIR/vdmlib/sign/err_tag ] || mkdir $OUT_DIR/vdmlib/sign/err_tag
cat >$OUT_DIR/vdmlib/sign/err_tag/gsig <<'-----'
  PROCDEC(err_tag##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_tag/vsig <<'-----'
  err_tag(x1) =
  TYPE :  Str  -->

  error routine for unions
  an attempt is made to access a non existing component of a union
-----
[ -d $OUT_DIR/vdmlib/sign/err_tl ] || mkdir $OUT_DIR/vdmlib/sign/err_tl
cat >$OUT_DIR/vdmlib/sign/err_tl/gsig <<'-----'
  PROCDEC(err_tl##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_tl/vsig <<'-----'
  err_tl(x1) =
  TYPE :  Str  -->

  Error routine for tuples:
  __SA(tl) was applied to an empty tuple
-----
[ -d $OUT_DIR/vdmlib/sign/err_umap ] || mkdir $OUT_DIR/vdmlib/sign/err_umap
cat >$OUT_DIR/vdmlib/sign/err_umap/gsig <<'-----'
  PROCDEC(err_umap##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_umap/vsig <<'-----'
  err_umap(x1) =
  TYPE :  Str  -->

  error routine for maps
  an attempt is made to perform a union operation of elements [d1 :-> r1]
  and [d1 :-> r2] where r1 is not equal to r2
-----
[ -d $OUT_DIR/vdmlib/sign/err_uop ] || mkdir $OUT_DIR/vdmlib/sign/err_uop
cat >$OUT_DIR/vdmlib/sign/err_uop/gsig <<'-----'
  PROCDEC(err_uop##_DOMAIN,P_OP REF_PARAM(x1,CHARACTER1) P_SEP REF_PARAM(x2,CHARACTER1) P_CL)
-----
cat >$OUT_DIR/vdmlib/sign/err_uop/vsig <<'-----'
  err_uop(x1,x2) =
  TYPE :  Str  Str  -->

  common error routine
  for unimplemented operations of an implementation
  some implementations, e.g. the heap implementation for maps,
  do not support all operations. x1 is the operation name x2 the domain name
-----
[ -d $OUT_DIR/vdmlib/sign/err_uuni ] || mkdir $OUT_DIR/vdmlib/sign/err_uuni
cat >$OUT_DIR/vdmlib/sign/err_uuni/gsig <<'-----'
  PROCDEC(err_uuni##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/err_uuni/vsig <<'-----'
  err_uuni(x1) =
  TYPE :  Str  -->

  error routine for unions
  an attempt is made to select an unknown component of a union value
-----
[ -d $OUT_DIR/vdmlib/sign/heap_oflw ] || mkdir $OUT_DIR/vdmlib/sign/heap_oflw
cat >$OUT_DIR/vdmlib/sign/heap_oflw/gsig <<'-----'
  PROCDEC(heap_oflw##_DOMAIN,PL_R(CHARACTER1))
-----
cat >$OUT_DIR/vdmlib/sign/heap_oflw/vsig <<'-----'
  heap_oflw(x1) =
  TYPE :  Str  -->

  error routine for domains implemented by using data allocation on the heap
  no more space available
-----
[ -d $OUT_DIR/vdmlib/sign/parseio ] || mkdir $OUT_DIR/vdmlib/sign/parseio
cat >$OUT_DIR/vdmlib/sign/parseio/gsig <<'-----'
#ifdef GEN_C
_IFDEF __cplusplus
extern istream * parseinput##_DOMAIN;
_ELSE
extern FILE *parseinput##_DOMAIN;
_ENDIF
#endif

-----
[ -d $OUT_DIR/vdmlib/sign/parsesup ] || mkdir $OUT_DIR/vdmlib/sign/parsesup
cat >$OUT_DIR/vdmlib/sign/parsesup/gsig <<'-----'
  PROCDEC(expected##_DOMAIN,PL_3(char *, char *, char *))
  PROCDEC(out_of_range##_DOMAIN,PL_2(char *,long))

  FUNCDEC(char2str##_DOMAIN,PL_1(char), char*)
  PROCDEC(skip_blanks##_DOMAIN,PL_0())
  FUNCDEC(next_char##_DOMAIN,PL_0(),char)
  FUNCDEC(check_char##_DOMAIN,PL_1(char),Bool)
  PROCDEC(expect##_DOMAIN,PL_2(char *, char *))
  FUNCDEC(readint##_DOMAIN,PL_1(char *),long)
  FUNCDEC(readtoken##_DOMAIN,PL_1(char *), char *)
  FUNCDEC(unputtoken##_DOMAIN,PL_1(char *), void)

_IFNDEF getchar##_DOMAIN
 extern char getchar##_DOMAIN PL_0();
_ENDIF
_IFNDEF unputchar##_DOMAIN
 extern void unputchar##_DOMAIN PL_1(char);
_ENDIF
_IFNDEF uparseerror##_DOMAIN
 extern void parseerror##_DOMAIN PL_3(char *,char *, char *);
_ENDIF

-----
